Lua_ButtonList = class("Lua_ButtonList", Lua_DisplayObject);
function Lua_ButtonList:ctor(p, btnNames, distance, owner, callBack,
	tabSkinNor, tabSkinPress, tabSize, tabPressSize,
	tabTxtColor, tabTxtPressColor, txtSize, sortType, uiatlasName,
	txtPos, txtPressPos, normalEffColor, selectEffColor, txtSpacingY, tabSkinGray, tabTxtGrayColor)

	self.btnNames = btnNames;
	self.distance = distance;
	self.pageArr = Array();
	self.callBackOwner = owner;
	self.callBack = callBack;
	self.tabSize = tabSize == nil and Vector4(0, 0, 145, 55) or tabSize;
	self.tabPressSize = tabPressSize == nil and Vector4(0, 0, 145, 55) or tabPressSize;
	self.tabSkinNor = tabSkinNor == nil and "tab3_souchong_normal" or tabSkinNor;
	self.tabSkinPress = tabSkinPress == nil and "tab3_souchong_select" or tabSkinPress;
	self.tabTxtColor = tabTxtColor == nil and Lua_ColorDefine.BLACK or tabTxtColor;
	self.tabTxtPressColor = tabTxtPressColor == nil and Lua_ColorDefine.BROWN or tabTxtPressColor;
	self.txtSize = txtSize == nil and Vector4(24, 24, 100, 30) or txtSize;
	self.sortType = sortType == nil and 1 or sortType;
	self.atlasName = uiatlasName == nil and "iconantlas1" or uiatlasName;
	self.txtPos = txtPos == nil and Vector3(0, 3, 0) or txtPos;
	self.txtPressPos = txtPressPos == nil and Vector3(0, 3, 0) or txtPressPos;
	self.normalEffColor = normalEffColor;
	self.selectEffColor = selectEffColor;
	self.txtSpacingY = txtSpacingY == nil and 0 or txtSpacingY;
	self.tabSkinGray = tabSkinGray;
	self.tabTxtGrayColor = tabTxtGrayColor;

	self:superCall("ctor", p);
end

function Lua_ButtonList:buildShowItem()
	self:superCall("buildShowItem");

	local item;
	local len = self.btnNames:getSize();
	for i = 1, len do
		if type(self.btnNames[i]) == "string" then
			item = Lua_TabItem.new(self.content, i, self.btnNames[i], self, self.onPageClick,
				self.tabSkinNor, self.tabSkinPress, self.tabSize, self.tabPressSize,
				self.tabTxtColor, self.tabTxtPressColor, self.txtSize, self.sortType, self.atlasName,
				nil, self.txtPos, self.txtPressPos, self.normalEffColor, self.selectEffColor, self.txtSpacingY, self.tabSkinGray, self.tabTxtGrayColor);
		else
			item = Lua_TabItem.new(self.content, i, self.btnNames[i].name, self, self.onPageClick,
				self.tabSkinNor, self.tabSkinPress, self.tabSize, self.tabPressSize,
				self.tabTxtColor, self.tabTxtPressColor, self.txtSize, self.sortType, self.atlasName,
				self.btnNames[i].eventIds, self.txtPos, self.txtPressPos, self.normalEffColor, self.selectEffColor, self.txtSpacingY, self.tabSkinGray, self.tabTxtGrayColor);
			item.clickRemoveEvent = self.btnNames[i].clickRemoveEvent;
			item.openId = self.btnNames[i].openId;
			
			if self.btnNames[i].showGray == true then
				item.showGray = true;
			else
				item.showGray = false;
			end
		end

		if self.sortType == 1 then
			item:setLocation(0, -1 *(i - 1) * self.distance);
		else
			item:setLocation((i - 1) * self.distance, 0);
		end
		self.pageArr:add(item);
	end
end

function Lua_ButtonList:setBtnTextByIdx(str, idx)
	if str ~= nil and self.pageArr ~= nil and self.pageArr[idx] ~= nil then
		self.pageArr[idx]:setText(str);
	end
end

function Lua_ButtonList:onPageClick(index)
	self:setSelected(index, true);
end

function Lua_ButtonList:setBtnGray(value, idx, isShowIcon)
	local _isShowIcon = true
	if isShowIcon ~= nil then
		_isShowIcon = isShowIcon
	end

	if value ~= nil and self.pageArr ~= nil and self.pageArr[idx] ~= nil then
		self.pageArr[idx]:setBtnGray(value, _isShowIcon);
	end
end

function Lua_ButtonList:setSelected(val, dispatchEvent)
	local len = self.pageArr:getSize();
	for i = 1, len do
		self.pageArr[i].selected = self.pageArr[i].index == val;
	end

	if dispatchEvent == true and self.callBack ~= nil and self.callBackOwner ~= nil then
		self.callBack(self.callBackOwner, val);
	end
end

function Lua_ButtonList:setDepth(val)
	self:superCall("setDepth", val);

	local len = self.pageArr:getSize();
	for i = 1, len do
		self.pageArr[i]:setDepth(val);
	end
end

function Lua_ButtonList:setRedDotPos(posx, posy)
	local len = self.pageArr:getSize();
	for i = 1, len do
		self.pageArr[i]:setRedDotPos(posx, posy);
	end
end

function Lua_ButtonList:setRedDotStateByIndex(idx, bShow)
	if idx == nil or idx < 1 or idx > self.pageArr:getSize() then
		return;
	end
	self.pageArr[idx]:setRedDotState(bShow);
end

function Lua_ButtonList:dispose()
	if self.pageArr ~= nil then
		self.pageArr:dispose();
		self.pageArr:clear();
	end
	self.callBackOwner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TabItem = class("Lua_TabItem", Lua_DisplayObject);
function Lua_TabItem:ctor(p, index, name, owner, callBack,
	tabSkinNor, tabSkinPress, tabSize, tabPressSize,
	tabTxtColor, tabTxtPressColor, txtSize, sortType, uiatlasName,
	redEventIds, txtPos, txtPressPos, normalEffColor, selectEffColor, txtSpacingY, tabSkinGray, tabTxtGrayColor)

	self.index = index;
	self.name = name
	self.owner = owner;
	self.callBack = callBack;
	self.tabSkinNor = tabSkinNor == nil and "tab3_souchong_normal" or tabSkinNor;
	self.tabSkinPress = tabSkinPress == nil and "tab3_souchong_select" or tabSkinPress;
	self.tabSize = tabSize == nil and Vector4(0, 0, 145, 55) or tabSize;
	self.tabPressSize = tabPressSize == nil and Vector4(0, 0, 145, 55) or tabPressSize;
	self.tabTxtColor = tabTxtColor == nil and Lua_ColorDefine.BLACK or tabTxtColor;
	self.tabTxtPressColor = tabTxtPressColor == nil and Lua_ColorDefine.BROWN or tabTxtPressColor;
	self.txtSize = txtSize == nil and Vector4(24, 24, 100, 30) or txtSize;
	self.sortType = sortType == nil and 1 or sortType;
	self.atlasName = uiatlasName == nil and "iconantlas1" or uiatlasName;
	self.clientRedState = false;
	self.txtPos = txtPos;
	self.txtPressPos = txtPressPos;
	self.normalEffColor = normalEffColor;
	self.selectEffColor = selectEffColor;
	self.txtSpacingY = txtSpacingY;
	self.tabSkinGray = tabSkinGray;
	self.tabTxtGrayColor = tabTxtGrayColor == nil and Lua_ColorDefine.WHITE or tabTxtGrayColor;

	self:superCall("ctor", p);
	self.content.name = "Lua_TabItem" .. tostring(index);
	self.eventIds = redEventIds;
end

function Lua_TabItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, self.atlasName, self.tabSkinNor, 0, 0, 0, 0);
	self.bg:SetDimensions(self.tabSize.z, self.tabSize.w);
	self.bg:addClickFuntion(self, self.onBgClick);

	self.txt = UICreate.createLabel(self.content, self.name, 0, 0, self.txtSize.z, self.txtSize.w, self.txtSize.x);
	self.txt.pivot = UIWidget.Pivot.Center;
	self.txt.colorStr = self.tabTxtColor;
	self.txt.spacingY = self.txtSpacingY;
	if self.normalEffColor ~= nil then
		self.txt.effectStyle = 3;
		self.txt.effectColorStr = Lua_ColorDefine.transColor(self.normalEffColor);
		self.txt:setEffectDistance(1, 1);
	else
		self.txt.effectStyle = 0;
	end
	self.txt:setLocation(self.txtPos.x, self.txtPos.y, self.txtPos.z);

	self.selected = false;
	self:setDepth(self.depth);
end

function Lua_TabItem:onBgClick(go)
	if self.owner ~= nil then
		self.callBack(self.owner, self.index);
	end

	if self.clickRemoveEvent ~= nil then
		for i, v in ipairs(self.clickRemoveEvent) do
			DataCenter.redDotData:updateRedDotVoState(v, false);
			Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = v, val = 0, bShow = false });
		end
		self.clickRemoveEvent = nil;
	end
end

function Lua_TabItem:setText(name)
	self.name = name;
	if self.txt ~= nil then
		self.txt.text = name;
	end
end

function Lua_TabItem.Set:selected(val)
	self._selected = val;
	if self.openId == 10157 and DataCenter.runeData.isOpenCompound == false then -- 灵纹合成特殊处理
		self:setBtnGray(true);
		return;
	else
		self:setBtnGray(false);
	end

	if self.openId ~= nil and DataCenter.funcOpenData:isOpened(self.openId) == false then
		self:setBtnGray(true);
		return;
	else
		self:setBtnGray(false);
	end
	self.bg:setAltas(self.atlasName, val == true and self.tabSkinPress or self.tabSkinNor);

	if val == true then
		self.bg:SetDimensions(self.tabPressSize.z, self.tabPressSize.w);
		self.bg:setLocation(self.tabPressSize.x, self.tabPressSize.y);

		self.txt.fontSize = self.txtSize.y;
		self.txt.colorStr = self.tabTxtPressColor;
		if self.selectEffColor ~= nil then
			self.txt.effectStyle = 3;
			self.txt:setEffectDistance(1, 1);
			self.txt.effectColorStr = Lua_ColorDefine.transColor(self.selectEffColor);
		else
			self.txt.effectStyle = 0;
		end
		self.txt:setLocation(self.txtPressPos.x, self.txtPressPos.y, self.txtPressPos.z);
	else
		self.bg:SetDimensions(self.tabSize.z, self.tabSize.w);
		self.bg:setLocation(self.tabSize.x, self.tabSize.y);

		self.txt.fontSize = self.txtSize.x;
		self.txt.colorStr = self.tabTxtColor;
		if self.normalEffColor ~= nil then
			self.txt.effectStyle = 3;
			self.txt:setEffectDistance(1, 1);
			self.txt.effectColorStr = Lua_ColorDefine.transColor(self.normalEffColor);
		else
			self.txt.effectStyle = 0;
		end
		self.txt:setLocation(self.txtPos.x, self.txtPos.y, self.txtPos.z);
	end
	self.txt.spacingY = self.txtSpacingY;

	if self.showGray == true then
		self:setBtnGray(true);
	else
		self:setBtnGray(false);
	end

	if self._selected == true and self.clickRemoveEvent ~= nil then
		for i, v in ipairs(self.clickRemoveEvent) do
			DataCenter.redDotData:updateRedDotVoState(v, false);
			Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = v, val = 0, bShow = false });
		end
		self.clickRemoveEvent = nil;
	end
end

function Lua_TabItem.Get:selected()
	return self._selected;
end

function Lua_TabItem:setDepth(val)
	self:superCall("setDepth", val);

	self.bg.depth = val;
	self.txt.depth = val + 1;
	if self.redDotIcon ~= nil then
		self.redDotIcon:setDepth(val + 2);
	end
end

function Lua_TabItem:setBtnGray(value, isShowIcon)
	if self.tabSkinGray ~= nil and value then
		self.bg:setAltas(self.atlasName, self.tabSkinGray);
		self.bg:setGray(false);

		self.txt.colorStr = self.tabTxtGrayColor;
	else
		self.bg:setGray(value);
	end

	if isShowIcon ~= nil then
		self.bg:setEnable(isShowIcon);

		self.txt:setEnable(isShowIcon);
	end
end

function Lua_TabItem.Set:eventIds(val)
	if val == nil or #val <= 0 then
		self._eventIds = nil;
		return;
	end

	local len = #val;
	local eventId;
	local needRed = false;
	self._eventIds = {};
	for i = 1, len do
		eventId = val[i];
		if DataCenter.redDotData:getRedDotVoByEventId(eventId) ~= nil then
			self._eventIds[tostring(eventId)] = eventId;
			needRed = true;
		end
	end

	if needRed == true and self.redDotIcon == nil then
		local posx = -55;
		local posy = 0;
		if self.redPos ~= nil then
			posx = self.redPos.x;
			posy = self.redPos.y;
		end
		self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", posx, posy, 0, 0);
		self.redDotIcon:setDepth(self.depth + 2);
		self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.refreshRedDot);
		-- 图标红点更新
		self:refreshRedDot();
	end
end

function Lua_TabItem:setRedDotPos(posx, posy)
	if self.redDotIcon ~= nil then
		self.redDotIcon:setLocation(posx, posy, 0);
	else
		self.redPos = {x = posx, y = posy};
	end
end

function Lua_TabItem:refreshRedDot(obj)
	if self.redDotIcon == nil then
		return;
	end

	if self.clientRedState == true then
		self.redDotIcon:setEnable(true);
		return;
	end

	if self.openId ~= nil and DataCenter.funcOpenData:isOpened(self.openId) == false then
		self.redDotIcon:setEnable(false);
			return;
	end

	if self._eventIds ~= nil then
		if obj == nil or (obj ~= nil and self._eventIds[tostring(obj.evenId)] ~= nil) then
			for k, v in pairs(self._eventIds) do
				if DataCenter.redDotData:getRedDotStateByEventId(v) == true then
					self.redDotIcon:setEnable(true);
					return;
				end
			end
			self.redDotIcon:setEnable(false);
		end
	else
		self.redDotIcon:setEnable(false);
	end
end

function Lua_TabItem:setRedDotState(val)
	val = val == nil and false or val;
	self.clientRedState = val;
	if val == true then
		if self.redDotIcon == nil then
			local posx = -55;
			local posy = 0;
			if self.redPos ~= nil then
				posx = self.redPos.x;
				posy = self.redPos.y;
			end
			self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", posx, posy, 0, 0);
			self.redDotIcon:setDepth(self.depth + 2);
		end
		self.redDotIcon:setEnable(true);
	else
		self:refreshRedDot();
	end
end

function Lua_TabItem:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.txt ~= nil then
		self.txt:dispose();
		self.txt = nil;
	end
	self.owner = nil;
	self.callBack = nil;
	
	self:superCall("dispose");
end