-- 玩法比武购买次数界面
Lua_BuyTimesWindow = class("Lua_BuyTimesWindow", Lua_ThirdSizeWindow)
function Lua_BuyTimesWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(120926));

	self.windowName = "Lua_BuyTimesWindow";
	self.skinName = "BuyTimesWindow_skin";
	self.w = 609;
	self.h = 359;
	self.titleBgOffsetY = -5;
	self.titleTxtOffsetY = -5;
	self.btnCloseOffsetY = -7;
	self.isClickClose = true;
end

function Lua_BuyTimesWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.curNum = 1;

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.maxBtn:addClickFuntion(self, self.onMaxBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);

	self:addLuaEvent("BuyTimesInfoUpdate", self, self.onBuyTimesInfoUpdate); -- 剩余购买次数更新
	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
end

-- 传递参数栗子如下
-- local info = {};
-- info.owner = self;
-- info.configSign = ""; -- 通过vip配置对应字段获取每日次数购买上限(暂时没有)
-- info.residueTimes = DataCenter.gamePlayData.curCanBuyTimes; -- 剩余购买次数
-- info.eachCost = getConfig({"arena_plus_info", "buy_cost_money", "value"}); -- 每次消耗
-- info.costType = Lua_MoneyData.GOLD; -- 货币类型
-- info.callback = self.onBuyTimes;	-- 购买回调
function Lua_BuyTimesWindow:showWin(param)
	self:superCall("showWin", param);
	if self.showData ~= nil then
		self.owner = self.showData.owner;
		self.configSign = self.showData.configSign;
		self.curCanBuyTimes = self.showData.residueTimes;
		self.eachCostNum = self.showData.eachCost;
		self.costList = self.showData.costList;
		self.costType = self.showData.costType;
		self.callback = self.showData.callback;
		self.useGold = self.showData.useGold;

		self:updateResidueBuyTimes();
		self:updateVipInfo();
		self:updateCostMoney();
		self:updateCostImg();
	else
		self:hide();
	end
end

function Lua_BuyTimesWindow:updateCostImg()
	if self.costType ~= nil then
		self.moneySp:setAltas("icon_atlas_3", Lua_MoneyData.getIconSpByMoneyType(self.costType));
	end
end

function Lua_BuyTimesWindow:updateVipInfo()
	self.vipLv_left = Lua_NumberImage.new(self.content);
	self.vipLv_left.prefix = "ui_daily_vip_";
	self.vipLv_left:setDepth(5);
	self.vipLv_left:setLocation(-117.5, 98, 0);

	self.vipLv_right = Lua_NumberImage.new(self.content);
	self.vipLv_right.prefix = "ui_daily_vip_";
	self.vipLv_right:setDepth(5);
	self.vipLv_right:setLocation(162.5, 98, 0);

	local ownVipType = DataCenter.roleData.vipType;
	local curNum = getConfig({"vip_level", ownVipType, self.configSign});
	if curNum == nil then
		curNum = 0;
	end
	self.maxBuyNum = curNum;
	local maxVipLv = getConfig({"vip_const", "max_vip_lv", "value"});

	local nextVip = -1;
	for i = ownVipType + 1, maxVipLv do
		local num = getConfig({"vip_level", i, self.configSign});
		if num == nil then
			num = 0;
		end
		if num > curNum then
			nextVip = i;
			break;
		end
	end

	if nextVip == -1 then
		for i=1, ownVipType - 1 do
			local index = ownVipType - i;
			local num = getConfig({"vip_level", index, self.configSign});
			if num == nil then
				num = 0;
			end
			if num < curNum then
				nextVip = index;
				break;
			end
		end
	end

	if nextVip == -1 then
		nextVip = maxVipLv;
	end

	if nextVip >= ownVipType then
		self.times_left.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(curNum).."[-]");
		self.vipLv_left.num = ownVipType;

		local nextNum = getConfig({"vip_level", nextVip, self.configSign});
		if nextNum == nil then
			nextNum = 0;
		end
		self.vipLv_right.num = nextVip;
		self.times_right.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(nextNum).."[-]");
	else
		local nextNum = getConfig({"vip_level", ownVipType, self.configSign});
		if nextNum == nil then
			nextNum = 0;
		end
		
		if ownVipType == 100 then
			-- self.vipLv_left:setAddIcon("+");
		else
			self.vipLv_left.num = ownVipType;
		end
		self.times_left.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(nextNum).."[-]");
		
		self.vip_bg_left:setLocation(0, 100, 0);
		self.vip_left:setLocation(-24, 98, 0);
		self.times_left:setLocation(-1, 56, 0);
		self.vipLv_left:setLocation(22.5, 98, 0);

		self.arrow:setEnable(false);
		self.vip_right:setEnable(false);
		self.vip_bg_right:setEnable(false);
		self.times_right:setEnable(false);
		self.vipLv_right:setEnable(false);
	end
end

function Lua_BuyTimesWindow:updateResidueBuyTimes()
	local str = "";
	local num = self.curCanBuyTimes;
	if num < 0 then
		num = 0;
	end
	if num > 0 then
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(num).."[-]";
	else
		str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(num).."[-]";
	end
	self.residueBuyTimesTxt.text = LanUtil.formateStr(LanUtil.getValue(120927), str);
end

function Lua_BuyTimesWindow:updateCostMoney()
	local num = self.curCanBuyTimes;
	if num <= 0 then
		self.curNum = 1;
	else
		if self.curNum > num then
			self.curNum = num;
		elseif self.curNum <= 0 then
			self.curNum = 1;
		end
	end
	self.buyTimesTxt.text = tostring(self.curNum);

	self:updateCost();
end

function Lua_BuyTimesWindow:updateCost()
	local num = 0;
	if self.costList ~= nil then
		local len = self.costList:getSize();
		local startNum = self.maxBuyNum - self.curCanBuyTimes + 1;
		local endNum = startNum + self.curNum - 1;
		for i = startNum, endNum do
			if i > len then
				num = num + self.costList[len];
			else
				num = num + self.costList[i];
			end
		end
	elseif self.eachCostNum ~= nil then
		num = self.eachCostNum * self.curNum;
	end

	self.costMoneyNum = num;
	local str = "";
	local ct = self.costType;
	if self.useGold == 1 and self.costType == Lua_MoneyData.BIND_GOLD then
		ct = Lua_MoneyData.GOLD_AND_BINDGOLD;
	end
	if num <= DataCenter.moneyData:getMoney(ct) then
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(num).."[-]";
	else
		str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(num).."[-]";
	end
	self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(120928), str);
	self.moneySp:setLocation(self.costTxt.mainContent.transform.localPosition.x + self.costTxt.width + 25, -66, 0);
end

function Lua_BuyTimesWindow:onSubBtnClick(go)
	self.curNum = self.curNum - 1;
	self:updateCostMoney();
end

function Lua_BuyTimesWindow:onAddBtnClick(go)
	self.curNum = self.curNum + 1;
	self:updateCostMoney();
end

function Lua_BuyTimesWindow:onMaxBtnClick(go)
	self.curNum = self.curCanBuyTimes;
	self:updateCostMoney();
end

function Lua_BuyTimesWindow:onBuyBtnClick(go)
	if self.curCanBuyTimes <= 0 then
		OperateAlert.show(LanUtil.getValue(120930));
		return;
	end

	local ct = self.costType;
	if self.useGold == 1 and self.costType == Lua_MoneyData.BIND_GOLD then
		ct = Lua_MoneyData.GOLD_AND_BINDGOLD;
	end

	if self.costMoneyNum ~= nil 
		and DataCenter.moneyData:isMoneyEnough(ct, self.costMoneyNum, true, true) == false then
		return;
	end

	if self.owner ~= nil and self.callback ~= nil then
		self.callback(self.owner, self.curNum);
	end
	self:hide();
end

-- 剩余购买次数更新
-- residueTimes;
function Lua_BuyTimesWindow:onBuyTimesInfoUpdate(residueTimes)
	self.curCanBuyTimes = residueTimes;
	self:updateResidueBuyTimes();
	self:updateCostMoney();
end

-- 货币变化
function Lua_BuyTimesWindow:onMoneyUpdate(o)
	self:updateCost();
end

function Lua_BuyTimesWindow:dispose()
	self.owner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end