-- 字体类型
Lua_MyUISettings = {};
Lua_MyUISettings.defaultFontName = "heiti_font";         -- 默认黑体

Lua_ColorDefine = { };
function Lua_ColorDefine.initColor()
    Lua_ColorDefine.maxAlpha = tonumber("FF000000", 16);

    Lua_ColorDefine.WHITE_STR = "FFFFFF";
    Lua_ColorDefine.WHITE = Lua_ColorDefine.transColor("FFFFFF");

    Lua_ColorDefine.GREEN_STR = "00e125";
    Lua_ColorDefine.GREEN = Lua_ColorDefine.transColor("00e125");
    Lua_ColorDefine.GREEN_STR2 = "00a10f";
    Lua_ColorDefine.GREEN2 = Lua_ColorDefine.transColor("00a10f");

    Lua_ColorDefine.BLUE_STR = "00c0ff";
    Lua_ColorDefine.BLUE = Lua_ColorDefine.transColor("00c0ff");
    Lua_ColorDefine.BLUE_STR2 = "00629b";
    Lua_ColorDefine.BLUE2 = Lua_ColorDefine.transColor("00629b");
    
    Lua_ColorDefine.PURPLE_STR = "bc3bff";
    Lua_ColorDefine.PURPLE = Lua_ColorDefine.transColor("bc3bff");

    Lua_ColorDefine.YELLOW_STR = "ffdf05";
    Lua_ColorDefine.YELLOW = Lua_ColorDefine.transColor("ffdf05");

    Lua_ColorDefine.RED_STR = "ff1616";
    Lua_ColorDefine.RED = Lua_ColorDefine.transColor("ff1616");

    Lua_ColorDefine.GOLD_STR = "ffb319";
    Lua_ColorDefine.GOLD = Lua_ColorDefine.transColor("ffb319");

    Lua_ColorDefine.BLACK_STR = "000000";
    Lua_ColorDefine.BLACK = Lua_ColorDefine.transColor("000000");

    Lua_ColorDefine.BROWN_STR = "742C00";
    Lua_ColorDefine.BROWN = Lua_ColorDefine.transColor("742C00");

    Lua_ColorDefine.GRAY_STR = "808080";
    Lua_ColorDefine.GRAY = Lua_ColorDefine.transColor("808080");
    Lua_ColorDefine.GRAY_STR2 = "b6b6b6";
    Lua_ColorDefine.GRAY2 = Lua_ColorDefine.transColor("b6b6b6");

    Lua_ColorDefine.PINK = Lua_ColorDefine.transColor("ff57e9"); 
    Lua_ColorDefine.PINK_STR = "ff57e9";
    Lua_ColorDefine.PINK2 = Lua_ColorDefine.transColor("ff4c9c");
    Lua_ColorDefine.PINK_STR2 = "ff4c9c";
end
function Lua_ColorDefine.transColor(color, alpha)
    local alphaVal = math.ceil(Lua_ColorDefine.maxAlpha *(alpha == nil and 1 or alpha));
    local colorVal = tonumber(color, 16)
    return alphaVal + colorVal;
end
function Lua_ColorDefine.transColorStr(color, alpha)
    return tostring(Lua_ColorDefine.transColor(color, alpha));
end
function Lua_ColorDefine.colorStr(str, color)
    return "[" .. color .. "]" .. str .. "[-]";
end
function Lua_ColorDefine.getItemColor(c, dark)
    if c == 0 then
        return Lua_ColorDefine.WHITE;
    elseif c == 1 then
        if dark == true then
            return Lua_ColorDefine.GREEN2;
        else
            return Lua_ColorDefine.GREEN;
        end
    elseif c == 2 then
        if dark == true then
            return Lua_ColorDefine.BLUE2;
        else
            return Lua_ColorDefine.BLUE;
        end
    elseif c == 3 then
        return Lua_ColorDefine.PURPLE;
    elseif c == 4 then
        return Lua_ColorDefine.YELLOW;
    elseif c == 5 then
        return Lua_ColorDefine.RED;
    elseif c == 6 then
        if dark == true then
            return Lua_ColorDefine.PINK2;
        else
            return Lua_ColorDefine.PINK;
        end
    else
        return Lua_ColorDefine.GOLD;
    end
end
function Lua_ColorDefine.getItemColorStr(c, dark, darkBlue)
    if darkBlue == nil then
        darkBlue = false
    else
        darkBlue = true;
    end

    if c == 0 then
        return Lua_ColorDefine.WHITE_STR;
    elseif c == 1 then
        if dark == true then
            return Lua_ColorDefine.GREEN_STR2;
        else
            return Lua_ColorDefine.GREEN_STR;
        end
    elseif c == 2 then
        if darkBlue == true then
            return "37a8f7";
        end
        if dark == true then
            return Lua_ColorDefine.BLUE_STR2;
        else
            return Lua_ColorDefine.BLUE_STR;
        end
    elseif c == 3 then
        return Lua_ColorDefine.PURPLE_STR;
    elseif c == 4 then
        return Lua_ColorDefine.YELLOW_STR;
    elseif c == 5 then
        return Lua_ColorDefine.RED_STR;
    elseif c == 6 then
        if dark == true then
            return Lua_ColorDefine.PINK_STR2;
        else
            return Lua_ColorDefine.PINK_STR;
        end
    else
        return Lua_ColorDefine.GOLD_STR;
    end
end