-- 【321开始】动画表现
Lua_CountDownAnimation = class("Lua_CountDownAnimation", Lua_DisplayObject);
function Lua_CountDownAnimation:ctor(p, owner, callback, showType, numPrefix)
	self.owner = owner;
	self.callback = callback;
	self.showType = showType == nil and 1 or showType; -- 1开始 2结束 3退出场景 4进入下层
	self.numPrefix = numPrefix == nil and "ui_fuben_" or numPrefix;
	self.isLoadImgBg = false;
	self.bPlay = false;
	self:superCall("ctor", p);
end

function Lua_CountDownAnimation:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_CountDownAnimation";

	self.showBg = UICreate.createUIAtlasImage(self.content, "copy_atlas_2", "ui_fuben_title_01", 0, 0, 0, 0);
	self.showBg.name = "showBg";

	local spName = "";
	if self.showType == 1 then -- xx秒后开始战斗
		spName = "ui_fuben_z_zd";
	elseif self.showType == 2 then -- xx秒后自动退出副本
		spName = "ui_fuben_z_tc";
	elseif self.showType == 3 then -- xx秒后自动退出场景
		spName = "ui_zhujiemian_z_dccj";
	elseif self.showType == 4 then -- 进入xx层
		spName = "ui_zhujiemian_z_jr";
	elseif self.showType == 5 then -- 距离下波怪物攻城刷新还有xx秒
		spName = "ui_zhujiemian_z_gwsx";
	elseif self.showType == 6 then -- 距离下波宝珠刷新还有xx秒
		spName = "ui_zhujiemian_z_zbsx";
	end
	self.bgImg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.bgImg.name = "bgImg";
	self.bgImg:addLoadCompleteFun(self, self.onLoadCompleteImg);
	self.bgImg:setAltas("copy_atlas_2", spName);

	if self.showType == 4 then
		if self.imgNextNum == nil then
			self.imgNextNum = Lua_NumberImage.new(self.content);
			self.imgNextNum.pivot = 2;
			self.imgNextNum.numWidth = 22;
			self.imgNextNum.prefix = self.numPrefix;
			self.imgNextNum.num = 0;
			self.imgNextNum:setLocation(43, 0, 0);
		end
	elseif self.showType == 5 then
		if self.imgNext == nil then
			self.imgNext = Lua_NumberImage.new(self.content);
			self.imgNext.pivot = 2;
			self.imgNext.numWidth = 22;
			self.imgNext.prefix = self.numPrefix;
			self.imgNext.num = 0;
			self.imgNext:setLocation(194, 0, 0);
		end
	elseif self.showType == 6 then
		if self.imgSixNum == nil then
			self.imgSixNum = Lua_NumberImage.new(self.content);
			self.imgSixNum.pivot = 2;
			self.imgSixNum.numWidth = 22;
			self.imgSixNum.prefix = self.numPrefix;
			self.imgSixNum.num = 0;
			self.imgSixNum:setLocation(190, 0, 0);
		end
	else
		if self.imgNum == nil then
			self.imgNum = Lua_NumberImage.new(self.content);
			self.imgNum.numWidth = 22;
			self.imgNum.prefix = self.numPrefix;
			self.imgNum.num = 0;
		end
	end
end

function Lua_CountDownAnimation:onLoadCompleteImg(go)
	self.isLoadImgBg = true;
end

function Lua_CountDownAnimation:playCountDown(countNum, intervalTime)
	if intervalTime == nil or intervalTime <= 0 or countNum <= 0 then
		self:clearTimer();
		return;
	end

	-- print("countNum", countNum);
	if self.showType == 4 then
		self.imgNextNum.num = countNum;
		self.countNum = DataCenter.godWarUtil.nextSceneTime;
	elseif self.showType == 5 then
		self.countNum = math.ceil(countNum);
	else
		self.countNum = math.ceil(countNum);
	end

	self:setShowImg();
	if self.bPlay == false then
		self.bPlay = true;
		Lua_CommonUtil.addTimer("Lua_CountDownAnimation", intervalTime, self, self.updateCountDownAniTime);
	end
end

function Lua_CountDownAnimation:updateCountDownAniTime()
	self.countNum = self.countNum - 1;
	self:setShowImg();
	if self.countNum <= 0 then
		self:clearTimer();
		return;
	end
end

function Lua_CountDownAnimation:setShowImg()
	if self.imgNum ~= nil then
		if self.countNum > 0 and self.isLoadImgBg == true then
			self.imgNum.num = self.countNum;

			local showWidth = self.imgNum.width + self.bgImg.width;
			self.imgNum:setLocation((-showWidth / 2), 0, 0);
			self.bgImg:setLocation((-showWidth / 2 + self.imgNum.width + self.bgImg.width / 2), 0, 0);
		end
		self.imgNum:setEnable(self.countNum > 0 and self.isLoadImgBg);
	end

	if self.imgNext ~= nil then
		if self.countNum > 0 and self.isLoadImgBg == true then
			self.imgNext.num = self.countNum;
		end
		self.imgNext:setEnable(self.countNum > 0 and self.isLoadImgBg);
	end

	if self.imgSixNum ~= nil then
		if self.countNum > 0 and self.isLoadImgBg == true then
			self.imgSixNum.num = self.countNum;
		end
		self.imgSixNum:setEnable(self.countNum > 0 and self.isLoadImgBg);
	end

	self.showBg:setEnable(self.countNum > 0 and self.isLoadImgBg);
	self.bgImg:setEnable(self.countNum > 0 and self.isLoadImgBg);
end

function Lua_CountDownAnimation:clearTimer()
	if self.bPlay == true then
		self.bPlay = false;
		Lua_CommonUtil.removeTimer(self, self.updateCountDownAniTime);
	end

	if self.owner ~= nil and self.callback ~= nil then
		self.callback(self.owner);
	end
end

function Lua_CountDownAnimation:setDepth(val)
	self:superCall("setDepth", val);

	self.showBg:setDepth(val);
	self.bgImg:setDepth(val + 1);
	if self.imgNextNum ~= nil then
		self.imgNextNum:setDepth(val + 1);
	end
	if self.imgNext ~= nil then
		self.imgNext:setDepth(val + 1);
	end
	if self.imgSixNum ~= nil then
		self.imgSixNum:setDepth(val + 1);
	end
	if self.imgNum ~= nil then
		self.imgNum:setDepth(val + 1);
	end
end

function Lua_CountDownAnimation:dispose()
	if self.bgImg ~= nil then
		self.bgImg:dispose();
		self.bgImg = nil;
	end
	if self.imgNextNum ~= nil then
		self.imgNextNum:dispose();
		self.imgNextNum = nil;
	end
	if self.imgNext ~= nil then
		self.imgNext:dispose();
		self.imgNext = nil;
	end
	if self.imgSixNum ~= nil then
		self.imgSixNum:dispose();
		self.imgSixNum = nil;
	end
	if self.imgNum ~= nil then
		self.imgNum:dispose();
		self.imgNum = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.updateCountDownAniTime);
	self.owner = nil;
	self.callback = nil;

	self:superCall("dispose");
end