Lua_DragButtonMain = class("Lua_DragButtonMain", Lua_DragContainerItem);
function Lua_DragButtonMain:ctor(p, mainSize, atlas, skinNor, skinPress, txtNorColor, txtPressColor, fontSize, mainOffset)
	self.btnType = 1;
	self.sizeX = mainSize ~= nil and mainSize.x or nil;
	self.sizeY = mainSize ~= nil and mainSize.y or nil;
	self.atlas = atlas == nil and "common_atlas_1" or atlas;
	self.skinNor = skinNor == nil and "ui_common_btn_01" or skinNor;
	self.skinPress = skinPress == nil and "ui_common_btn_02" or skinPress;
	self.txtNorColor = txtNorColor == nil and Lua_ColorDefine.transColor("D5DADE") or Lua_ColorDefine.transColor(txtNorColor);
	self.txtPressColor = txtPressColor == nil and Lua_ColorDefine.transColor("FFEDDD") or Lua_ColorDefine.transColor(txtPressColor);
	self.fontSize = fontSize == nil and 28 or fontSize;
	self.mainOffset = mainOffset == nil and Vector2(0, 0) or mainOffset;

	self:superCall("ctor", p, "DragButtonMain_skin", false);
end

function Lua_DragButtonMain:buildShowItem()
	self:superCall("buildShowItem");

	self.btnLabel.fontSize = self.fontSize;
	if self.sizeX == nil or self.sizeY == nil then

	else
		self.btnBg:SetDimensions(self.sizeX, self.sizeY);
	end

	self.btnBg:addClickFuntion(self, self.onMouseDown);
	self.btnBg:addMouseUpFuntion(self, self.onMouseUp);
end

function Lua_DragButtonMain.Get:data()
	return self._data;
end

function Lua_DragButtonMain:setData(data, owner, ownerCallBack)
	self._data = data;

	self.btnLabel.text = data.name;
	self.btnIndex = data.btnIndex;
	self.owner = owner;
	self.ownerCallBack = ownerCallBack;
	self:checkSelected();
end

function Lua_DragButtonMain:checkSelected()
	if self._data.specialNum == nil then
		if self._data.selected == true then
			self.btnLabel.colorStr = self.txtPressColor;
			self.btnBg:setAltas(self.atlas, self.skinPress);
		else
			self.btnLabel.colorStr = self.txtNorColor;
			self.btnBg:setAltas(self.atlas, self.skinNor);
		end
	elseif self._data.specialNum == 1 then -- 披风
		local config =  getConfig({"cloakClass", self.btnIndex});
		if self._data.selected == true then
			self.btnLabel.colorStr = Lua_ColorDefine.WHITE;
			self.btnBg:setAltas("cloakAtlas", config.select_yes);
			else
			self.btnLabel.colorStr = Lua_ColorDefine.WHITE;
			self.btnBg:setAltas("cloakAtlas", config.select_no);
		end
	end
end

function Lua_DragButtonMain:onMouseDown()
	self.startX = UnityEngine.Input.mousePosition.x;
	self.startY = UnityEngine.Input.mousePosition.y;
	if self.owner ~= nil then
		self.owner:startDrag();
	end
end

function Lua_DragButtonMain:onMouseUp(go)
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if lx + ly < 4 then
		if self.owner ~= nil and self.ownerCallBack ~= nil then
			self.ownerCallBack(self.owner, self.btnIndex, nil);
		end
	end

	if self.owner ~= nil then
		self.owner:stopDrag();
	end
end

function Lua_DragButtonMain:setRedDot(val)
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.btnBg.mainContent, "common_atlas_1", "ui_common_hongdian", 103, 5, 0, 0);
			if self.sizeX == nil or self.sizeY == nil then

			else
				self._redDotIcon:setLocation(self.sizeX / 2 - 10, self.sizeY / 2 - 10);
			end
		end
		self._redDotIcon:setDepth(4);
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_DragButtonMain:getHeight()
	return self.btnBg.height + 10;
end

function Lua_DragButtonMain:getOffsetX()
	return self.mainOffset.x;
end

function Lua_DragButtonMain:getOffsetY()
	return self.mainOffset.y;
end