Lua_DragButtonSub = class("Lua_DragButtonSub", Lua_DragContainerItem);
function Lua_DragButtonSub:ctor(p, subSize, atlas, skinNor, skinPress, txtNorColor, txtPressColor, fontSize, subOffset)
	self.btnType = 2;
	self.sizeX = subSize ~= nil and subSize.x or nil;
	self.sizeY = subSize ~= nil and subSize.y or nil;
	self.atlas = atlas == nil and "common_atlas_1" or atlas;
	self.skinNor = skinNor == nil and "ui_common_btn_p4" or skinNor;
	self.skinPress = skinPress == nil and "ui_common_btn_p3" or skinPress;
	self.txtNorColor = txtNorColor == nil and Lua_ColorDefine.transColor("FFFFFF") or Lua_ColorDefine.transColor(txtNorColor);
	self.txtPressColor = txtPressColor == nil and Lua_ColorDefine.transColor("FFFCB7") or Lua_ColorDefine.transColor(txtPressColor);
	self.fontSize = fontSize == nil and 26 or fontSize;
	self.subOffset = subOffset == nil and Vector2(0, 0) or subOffset;

	self:superCall("ctor", p, "DragButtonSub_skin", false);
end

function Lua_DragButtonSub:buildShowItem()
	self:superCall("buildShowItem");

	self.btnLabel.fontSize = self.fontSize;

	if self.sizeX == nil or self.sizeY == nil then

	else
		self.btnBg:SetDimensions(self.sizeX, self.sizeY);
	end
	self.btnLabel1.uiwidget.gameObject:SetActive(false);
	self.btnBg:addClickFuntion(self, self.onMouseDown);
	self.btnBg:addMouseUpFuntion(self, self.onMouseUp);
end

function Lua_DragButtonSub.Get:data()
	return self._data;
end

function Lua_DragButtonSub:setData(data, owner, ownerCallBack)
	self._data = data;
	self.btnLabel.text = data.name;

	if data.specialNum == 1 then -- 披风
		self.btnLabel.fontSize = 22;
		self.btnLabel1.fontSize = 20;
		self.btnLabel:setLocation(0,12)
		self.btnLabel1:setLocation(0,-13)
		self.btnLabel1.uiwidget.gameObject:SetActive(true); 
		self.btnLabel1.text = data.decName;
	end

	self.btnIndex = data.btnIndex;
	self.owner = owner;
	self.ownerCallBack = ownerCallBack;
	if self._data.selected == true then
		self.btnBg:setAltas(self.atlas, self.skinPress);
	else
		self.btnBg:setAltas(self.atlas, self.skinNor);
	end

	if self._data.isShowLock ~= nil and self._data.isShowLock == true then
		self.lock:setEnable(true);
	else
		self.lock:setEnable(false);
	end
end

function Lua_DragButtonSub:checkSelected()
	if self._data.specialNum == nil then
		if self._data.selected == true then
			self.btnLabel.colorStr = self.txtPressColor;
			self.btnBg:setAltas(self.atlas, self.skinPress);
		else
			self.btnLabel.colorStr = self.txtNorColor;
			self.btnBg:setAltas(self.atlas, self.skinNor);
		end
	elseif self._data.specialNum == 1 then -- 披风
		if self._data.selected == true then
			self.btnLabel.colorStr = Lua_ColorDefine.transColor("3f6180", 1);
			self.btnBg:setAltas("cloakAtlas", "select_yes");
		else
			self.btnLabel.colorStr = Lua_ColorDefine.transColor("192e41", 1);
			self.btnBg:setAltas("cloakAtlas", "select_no");
		end
	end
end

function Lua_DragButtonSub:setBtnGray(val)
	if val == true then
		self.btnBg:setGray(false)
	else
		self.btnBg:setGray(true)
	end
end

function Lua_DragButtonSub:onMouseDown()
	self.startX = UnityEngine.Input.mousePosition.x;
	self.startY = UnityEngine.Input.mousePosition.y;
	if self.owner ~= nil then
		self.owner:startDrag();
	end
end

function Lua_DragButtonSub:setRedDot(val)
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.btnBg.mainContent, "common_atlas_1", "ui_common_hongdian", 92, 0, 0, 0);
			if self.sizeX == nil or self.sizeY == nil then

			else
				self._redDotIcon:setLocation(self.sizeX / 2 - 10, self.sizeY / 2 - 10);
			end
		end
		self._redDotIcon:setDepth(4);
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_DragButtonSub:onMouseUp(go)
	local lx = math.abs(UnityEngine.Input.mousePosition.x - self.startX);
	local ly = math.abs(UnityEngine.Input.mousePosition.y - self.startY);
	if lx + ly < 4 then
		if self.owner ~= nil and self.ownerCallBack ~= nil then
			self.ownerCallBack(self.owner, self._data);
		end
	end

	if self.owner ~= nil then
		self.owner:stopDrag();
	end
end

function Lua_DragButtonSub:getHeight()
	if self.data.isEnd then
		if self:getOffsetY() > 0 then
			return self.btnBg.height + self:getOffsetY() - 10;
		else
			return self.btnBg.height + 20;
		end
	else
		return self.btnBg.height + 10;
	end
end

function Lua_DragButtonSub:getOffsetX()
	return self.subOffset.x;
end

function Lua_DragButtonSub:getOffsetY()
	return self.subOffset.y;
end