Lua_DragCellData = class("Lua_DragCellData");
function Lua_DragCellData:ctor(posX, posY, width, height, data, ownerList)
	self.itemX = posX;
	self.itemY = posY;
	self.minX = posX - width / 2;
	self.minY = posY - height / 2;
	self.maxX = posX + width / 2;
	self.maxY = posY + height / 2;
	self.showRect = Lua_Rectangle.new(minX, minY, width, height);
	self.data = data;
	self.ownerList = ownerList;
	self.cell = nil;
end
function Lua_DragCellData:init(posX, posY, width, height, data)
	self.itemX = posX;
	self.itemY = posY;
	self.minX = posX - width / 2;
	self.minY = posY - height / 2;
	self.maxX = posX + width / 2;
	self.maxY = posY + height / 2;
	self.showRect = Lua_Rectangle.new(minX, minY, width, height);
	self.data = data;

	if self.cell ~= nil then
		self.cell:setData(self.data);
		if self.cell.onSelectionChange ~= nil  and self.ownerList.curSelectedIdx == self.index then
			self.cell:onSelectionChange(true);
		else
			self.cell:onSelectionChange(false);
		end
	end
end
function Lua_DragCellData:checkInBound(p_pos, viewRect, ox, oy)
	self.showRect.x = self.minX + p_pos.x;
	self.showRect.y = self.minY + p_pos.y;
	if self.showRect:intersects(viewRect) then
		return true;
	else
		return false;
	end
end
function Lua_DragCellData:returnCellToPool()
	if self.cell ~= nil then		
		self.ownerList:returnCell(self.cell);		
		self.cell = nil;
		self.ownerList = nil;		
	end
end
function Lua_DragCellData:getCellFromPool(ownerList)
	self.ownerList = ownerList;
	if self.cell == nil then
		self.cell = self.ownerList:createCellItem();
		self.cell:setBoxSize(self.cellWidth, self.cellHeight);
		self.cell:setLocation(self.itemX, self.itemY);
		self.cell:setData(self.data);
        self.cell.cellSeqIndex = self.index;
        self.cell:setCellSeqIndex(self.index);
	end
	if self.cell.onSelectionChange ~= nil and self.ownerList.curSelectedIdx == self.index then
		self.cell:onSelectionChange(true);
	else
		self.cell:onSelectionChange(false);
	end
end
function Lua_DragCellData:checkScale(p_pos, mpos, ox, oy, minScale, maxScale, distance)
	local left_x = self.maxX + p_pos.x - ox;
	local top_y = self.maxY + p_pos.y + oy;
	local d = math.abs(left_x - mpos.x);
	return d;
	
end
function Lua_DragCellData:clean()
	self:returnCellToPool();
	self.data = nil;
end