-- 自定义BtnList
checkRequire("Lua_DragCustomBtnListCell");
Lua_DragCustomBtnList = class("Lua_DragCustomBtnList", Lua_DragContainer);
Lua_DragCustomBtnList.MAIN_BTN = 1;
Lua_DragCustomBtnList.SUB_BTN = 2;
function Lua_DragCustomBtnList:ctor(p, ltype, vsize)
	self.btnShowList = {};
	self.btnShowList[Lua_DragCustomBtnList.MAIN_BTN] = Array();
	self.btnShowList[Lua_DragCustomBtnList.SUB_BTN] = Array();
	self.btnHideList = {};
	self.btnHideList[Lua_DragCustomBtnList.MAIN_BTN] = Array();
	self.btnHideList[Lua_DragCustomBtnList.SUB_BTN] = Array();
    
    self:superCall("ctor", p, ltype, vsize);
    self.checkSizeDrag = true;
    self.clickDrawBack = false;
end

function Lua_DragCustomBtnList:dispose()
    self.owner = nil;
    self.clickCallBack = nil;

    local cell = nil;
    local list = self.btnShowList;
    if list ~= nil then
    	for k,arr in pairs(list) do
            if arr ~= nil then
                local len = arr:getSize();
                for i=1,len do
        			cell = arr[len - i + 1];
                    if cell ~= nil then
                        cell:dispose();
                    end
                    arr:remove(len);
        		end
                arr:clear();
            end
            list[k] = nil;
    	end
    end
    self.btnShowList = nil;

    local _cell = nil;
    local _list = self.btnHideList;
    if _list ~= nil then
        for k,arr in pairs(_list) do
            if arr ~= nil then
                local len = arr:getSize();
                for i=1,len do
                    _cell = arr[len - i + 1];
                    if _cell ~= nil then
                        _cell:dispose();
                    end
                    arr:remove(len);
                end
                arr:clear();
            end
            _list[k] = nil;
        end
    end
    self.btnHideList = nil;

    self:superCall("dispose");
end

function Lua_DragCustomBtnList:setMainBtnCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.mainBtnCell = cell;
    self.mainBtnCellWidth = cellWidth;
    self.mainBtnCellHeight = cellHeight;
    self.mainBtnCellOffsetX = offsetX;
    self.mainBtnCellOffsetY = offsetY;
end

function Lua_DragCustomBtnList:setSubBtnCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.subBtnCell = cell;
    self.subBtnCellWidth = cellWidth;
    self.subBtnCellHeight = cellHeight;
    self.subBtnCellOffsetX = offsetX;
    self.subBtnCellOffsetY = offsetY;
end

function Lua_DragCustomBtnList:createButton(btnType)
    local len = self.btnHideList[btnType]:getSize();
    local cell = nil;
    if len > 0 then
        cell = self.btnHideList[btnType][1];
        self.btnHideList[btnType]:remove(1);
        cell:setEnable(true);
    end
    if cell == nil then
        if btnType == Lua_DragCustomBtnList.MAIN_BTN then
            cell = self.mainBtnCell.new(self.sub, btnType, self.mainBtnCellWidth, self.mainBtnCellHeight, self.mainBtnCellOffsetX, self.mainBtnCellOffsetY);
            cell.btnType = Lua_DragCustomBtnList.MAIN_BTN; 
        else
            cell = self.subBtnCell.new(self.sub, btnType, self.subBtnCellWidth, self.subBtnCellHeight, self.subBtnCellOffsetX, self.subBtnCellOffsetY);
            cell.btnType = Lua_DragCustomBtnList.SUB_BTN;
        end
    end
    self.btnShowList[btnType]:add(cell);
    return cell;
end

function Lua_DragCustomBtnList:returntButton(btnType, btn)
    local len = self.btnShowList[btnType]:getSize();
    for i = 1, len do
    	local cell = self.btnShowList[btnType][i];
        if cell == btn then
            cell:setEnable(false);
            self.btnShowList[btnType]:remove(i);
            break;
        end
    end
    self.btnHideList[btnType]:add(btn);
end

function Lua_DragCustomBtnList:setData(data, owner, clickCallBack)
    self.data = data;
    self.owner = owner;
    self.clickCallBack = clickCallBack;
    self.lastMainSelected = -1;

    local len = self.childrenList:getSize();
    for i = 1, len do
        self:returntButton(self.childrenList[i].btnType, self.childrenList[i]);
    end
    self.childrenList:clear();

    len = data:getSize();
    for i = 1, len do
        local cell = self:createButton(Lua_DragCustomBtnList.MAIN_BTN);
        data[i].mainIndex = i;
        data[i].subIndex = nil;
        cell:setData(data[i], self, self.onSubBtnClick);
        self:addSubContainer(cell, false);
    end

    self:updateChildPos();
end

function Lua_DragCustomBtnList:onSubBtnClick(data)
    self:setMainSlected(data.mainIndex, data.subIndex);
end

function Lua_DragCustomBtnList:setMainSlected(mainIndex, subIndex)
    local len = 0;
    local cell = nil;
    
    if self.lastMainSelected ~= mainIndex then
        self.lastMainSelected = mainIndex;
        self.subSelected = -1;

        local numIndex = 0;
        len = self.childrenList:getSize();
        for i = 1, len do
            numIndex = numIndex + 1;
            if self.childrenList[numIndex] ~= nil then
                if self.childrenList[numIndex].btnType == Lua_DragCustomBtnList.SUB_BTN then
                    cell = self.childrenList[numIndex];
                    self:returntButton(Lua_DragCustomBtnList.SUB_BTN, cell);
                    self.childrenList:remove(numIndex);
                    numIndex = numIndex - 1;
                else
                    cell = self.childrenList[numIndex];
                    cell.selected = (cell.data.mainIndex == mainIndex);
                end
            end
        end

        len = self.childrenList:getSize();
        for i = 1, len do
            if self.childrenList[i].data.mainIndex == mainIndex then
                local arr = self.childrenList[i].data.sub;
                if arr == nil or arr:getSize() == 0 then
                    -- if self.childrenList[i].selected == true and self.owner ~= nil and self.clickCallBack ~= nil then
                    --     self.clickCallBack(self.owner, self.childrenList[i].data);
                    -- end
                else
                    for j = 1, arr:getSize() do
                        cell = self:createButton(Lua_DragCustomBtnList.SUB_BTN);
                        arr[j].mainIndex = self.childrenList[i].data.mainIndex;
                        arr[j].subIndex = j;
                        cell:setData(arr[j], self, self.onSubBtnClick);
                        self.childrenList:add(cell, i + j);
                    end
                end
                break;
            end
        end

        self:updateChildPos();
    elseif self.clickDrawBack == true then
        local numIndex = 0;
        len = self.childrenList:getSize();
        for i = 1, len do
            numIndex = numIndex + 1;
            if self.childrenList[numIndex] ~= nil then
                if self.childrenList[numIndex].btnType == Lua_DragCustomBtnList.SUB_BTN then
                    cell = self.childrenList[numIndex];
                    self:returntButton(Lua_DragCustomBtnList.SUB_BTN, cell);
                    self.childrenList:remove(numIndex);
                    numIndex = numIndex - 1;
                else
                    cell = self.childrenList[numIndex];
                    cell.selected = (cell.data.mainIndex == mainIndex);
                end
            end
        end

        self:updateChildPos();
        self.lastMainSelected = -1;
    end

    if self.lastMainSelected ~= -1 then
        subIndex = subIndex == nil and 1 or subIndex;
        if subIndex ~= nil and subIndex ~= self.subSelected then
            self.subSelected = subIndex;
            len = self.childrenList:getSize();
            for i = 1, len do
                if self.childrenList[i].btnType == Lua_DragCustomBtnList.SUB_BTN then
                    cell = self.childrenList[i];
                    cell.selected = (cell.data.subIndex == self.subSelected);
                    if cell.selected == true and self.owner ~= nil and self.clickCallBack ~= nil then
                        self.clickCallBack(self.owner, cell.data);
                    end
                end
            end
        end
    end
end

function Lua_DragCustomBtnList:updateChildPos()
    local len = self.childrenList:getSize();
    self.maxSize = 0;
    for i = 1, len do
        local ox = 0;
        local oy = 0;
        if self.childrenList[i].getOffsetX ~= nil then
            ox = self.childrenList[i]:getOffsetX();
        end
        if self.childrenList[i].getOffsetY ~= nil then
            oy = self.childrenList[i]:getOffsetY();
        end

        if self.ltype == 1 then
            self.maxSize = self.maxSize - self.childrenList[i]:getHeight() / 2;
            self.childrenList[i]:setLocation(self.offsetY + ox, self.maxSize + self.offsetX + oy, 0);
            self.maxSize = self.maxSize - self.childrenList[i]:getHeight() / 2;
        end
    end
    
    if self.ltype == 1 then
        self.cminY = 0;
        self.cmaxY = -(self.maxSize + self.vsize.w + self.addNum);
    end
end

function Lua_DragCustomBtnList:onPress(go, state)
    if state == true then
        if self.ltype == 1 then
            if self.checkSizeDrag == true and self.cminY > self.cmaxY then
                return;
            end
        end

        if self.startMouse == -1 then
            if self.ltype == 1 then
                self.startMouse = UnityEngine.Input.mousePosition.y;
                self.startContainer = self.sub.transform.localPosition.y;
            else
                self.startMouse = UnityEngine.Input.mousePosition.x;
                self.startContainer = self.sub.transform.localPosition.x;
            end
        end
        if self._isClick == false then
            self._isClick = true;
            Lua_CommonUtil.addTimer("onEnterFrame", 0.01, self, self.onEnterFrame);
        end
        Lua_CommonUtil.removeTimer(self, self.onBackPostion);
    else
        if self.ltype == 1 then
            local endPos = self.sub.transform.localPosition.y;
            local co = endPos - self.startContainer;
            if co < 2 and co > -2 then
                local screenpos = UICamera.mainCamera:ScreenToWorldPoint(UnityEngine.Input.mousePosition);
                local winPos = self.sub.transform:InverseTransformPoint(screenpos);
                local len = self.childrenList:getSize();
                for i = 1, len do
                    local ty = self.childrenList[i].y + self.childrenList[i]:getHeight() / 2;
                    local dy = self.childrenList[i].y - self.childrenList[i]:getHeight() / 2; 
                    if ty >= winPos.y 
                        and dy <= winPos.y then
                        self.childrenList[i]:onPlayerSoundClick();
                        break;
                    end
                end
            end
        end
        self.startMouse = -1;
        self.startContainer = -1;
        if self._isClick == true then
            self._isClick = false;
            Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
        end
        self:checkPosFix();
    end
end