-- 二级自定义list
checkRequire("Lua_DragSecBtnListCell");
checkRequire("Lua_DragContainer");
Lua_DragSecButtonList = class("Lua_DragSecButtonList", Lua_DragContainer);
Lua_DragSecButtonList.MAIN_BTN = 1;
Lua_DragSecButtonList.SEC_BTN = 2;
function Lua_DragSecButtonList:ctor(p, vsize)
    self.btnShowList = {};
    self.btnShowList[Lua_DragSecButtonList.MAIN_BTN] = Array();
    self.btnShowList[Lua_DragSecButtonList.SEC_BTN] = Array();
    self.btnHideList = {};
    self.btnHideList[Lua_DragSecButtonList.MAIN_BTN] = Array();
    self.btnHideList[Lua_DragSecButtonList.SEC_BTN] = Array();

    self:superCall("ctor", p, 1, vsize);
    self.checkSizeDrag = true;
    self.content.name = "Lua_DragSecButtonList";
end

function Lua_DragSecButtonList:setMainBtnCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.mainBtnCell = cell;
    self.mainBtnCellWidth = cellWidth;
    self.mainBtnCellHeight = cellHeight;
    self.mainBtnCellOffsetX = offsetX;
    self.mainBtnCellOffsetY = offsetY;
end

function Lua_DragSecButtonList:setSecBtnCell(cell, cellWidth, cellHeight, offsetX, offsetY)
    self.secBtnCell = cell;
    self.secBtnCellWidth = cellWidth;
    self.secBtnCellHeight = cellHeight;
    self.secBtnCellOffsetX = offsetX;
    self.secBtnCellOffsetY = offsetY;
end

function Lua_DragSecButtonList:createButton(btnType)
    local len = self.btnHideList[btnType]:getSize();
    local cell = nil;
    if len > 0 then
        cell = self.btnHideList[btnType][1];
        self.btnHideList[btnType]:remove(1);
        cell:setEnable(true);
    end

    if cell == nil then
        if btnType == Lua_DragSecButtonList.MAIN_BTN then
            cell = self.mainBtnCell.new(self.sub, btnType, self.mainBtnCellWidth, self.mainBtnCellHeight, self.mainBtnCellOffsetX, self.mainBtnCellOffsetY);
        elseif btnType == Lua_DragSecButtonList.SEC_BTN then
            cell = self.secBtnCell.new(self.sub, btnType, self.secBtnCellWidth, self.secBtnCellHeight, self.secBtnCellOffsetX, self.secBtnCellOffsetY);
        end
    end
    self.btnShowList[btnType]:add(cell);
    return cell;
end

function Lua_DragSecButtonList:setBtnGray(dbtnType, valList)
    local num = 1;
    local len = self.childrenList:getSize();
    for i = 1, len do
        if self.childrenList[i].dragBtnType == dbtnType then
            self.childrenList[i]:setBtnGray(valList[num]);
            num = num + 1;
        end
    end
end

function Lua_DragSecButtonList:returntButton(btnType, btn)
    local len = self.btnShowList[btnType]:getSize();
    for i = 1, len do
    	local cell = self.btnShowList[btnType][i];
        if cell == btn then
        	cell.selected = false;
            cell:setEnable(false);
            self.btnShowList[btnType]:remove(i);
            break;
        end
    end
    self.btnHideList[btnType]:add(btn);
end

function Lua_DragSecButtonList:setData(data, selectMainIdx, subIdx)
    self.data = data;

    local len = self.childrenList:getSize();
    for i = 1, len do
        self:returntButton(self.childrenList[i].btnType, self.childrenList[i]);
    end
    self.childrenList:clear();

    local bRefreshSubData = false;
    len = data:getSize();
    for i = 1, len do
        local cell = self:createButton(Lua_DragSecButtonList.MAIN_BTN);
        cell.mainIndex = i;
        cell:setData(data[i], self, self.setMainBtnSlected);
        self:addSubContainer(cell, false);

        if self.unFoldDic ~= nil and self.unFoldDic[i] == true then
            bRefreshSubData = true;
        end
    end

    if selectMainIdx ~= nil then
        self.subSelectSecIdx = subIdx;
        self.subSelectMainIdx = selectMainIdx;
    -- 	self:setMainBtnSlected(selectMainIdx, nil, true);
    -- elseif self.lastMainSelected ~= nil then
    --     self:setMainBtnSlected(self.lastMainSelected, nil, true);
    -- else
	   --  self:updateChildPos();
    end
    self:setMainBtnSlected(selectMainIdx, nil, true, bRefreshSubData);
end

function Lua_DragSecButtonList:setMainBtnSlected(mainIdx, secIdx, bUnfold, bRefreshSubData)
	local len = 0;
    local cell = nil;

    if self.unFoldDic == nil then
        self.unFoldDic = {};
    end
    local startIdx = 1;
    local mainLen = self.data:getSize();
    if mainIdx ~= nil and mainIdx > 0 and mainIdx <= mainLen then
        self.unFoldDic[mainIdx] = bUnfold;
    end

    if bRefreshSubData == true then -- 必要刷新
        startIdx = 0;
        for i = 1, mainLen do
            startIdx = startIdx + 1;
            if self.unFoldDic[i] == true then
                self.childrenList[startIdx].selected = true;
                local arr = self.data[i].sub;
                if arr ~= nil and arr:getSize() > 0 then
                    len = arr:getSize();
                    for j = 1, len do
                        startIdx = startIdx + 1;
                        cell = self:createButton(Lua_DragSecButtonList.SEC_BTN);
                        cell.mainIndex = i;
                        cell.secIndex = j;
                        cell:setData(arr[j], self, self.onSubBtnClick);
                        self.childrenList:add(cell, startIdx);
                        if i == self.subSelectMainIdx and j == self.subSelectSecIdx then
                            cell.bRefreshData = true;
                            cell.selected = true;
                        else
                            cell.selected = false;
                        end
                    end
                end
            else
                self.childrenList[startIdx].selected = false;
            end
        end
        self:updateChildPos();
    else
        if mainIdx ~= nil and mainIdx > 0 and mainIdx <= mainLen then
            startIdx = 1;
            for i = 1, mainIdx - 1 do
                if self.unFoldDic[i] == true and self.data[i].sub ~= nil and self.data[i].sub:getSize() > 0 then
                    startIdx = startIdx + self.data[i].sub:getSize() + 1;
                else
                    startIdx = startIdx + 1;
                end
            end

            self.childrenList[startIdx].selected = bUnfold;
            local arr = self.data[mainIdx].sub;
            if arr ~= nil and arr:getSize() > 0 then
                len = arr:getSize();
                for i = 1, len do
                    if bUnfold == true then -- 展开
                        cell = self:createButton(Lua_DragSecButtonList.SEC_BTN);
                        cell.mainIndex = mainIdx;
                        cell.secIndex = i;
                        cell:setData(arr[i], self, self.onSubBtnClick);
                        self.childrenList:add(cell, i + startIdx);
                        if mainIdx == self.subSelectMainIdx and i == self.subSelectSecIdx then
                            cell.bRefreshData = true;
                            cell.selected = true;
                        else
                            cell.selected = false;
                        end
                    else
                        cell = self.childrenList[startIdx + 1];
                        self:returntButton(Lua_DragSecButtonList.SEC_BTN, cell);
                        self.childrenList:remove(startIdx + 1);
                    end
                end 
            end

            self:updateChildPos();
        end
    end
end

function Lua_DragSecButtonList:onSubBtnClick(mainIdx, secIdx, bUnfold)
	self.subSelectMainIdx = mainIdx;
	self.subSelectSecIdx = secIdx;
	local len = self.childrenList:getSize();
    for i = 1, len do
        local cell = self.childrenList[i];
        if cell ~= nil and cell.btnType == Lua_DragSecButtonList.SEC_BTN then
            if cell.secIndex == secIdx and cell.mainIndex == mainIdx then
            	cell.selected = true;
            else
            	cell.selected = false;
            end
        end
    end
end

function Lua_DragSecButtonList:dispose()
    local cell = nil;
    local dic = self.btnShowList;
    if dic ~= nil then
	    for k, arr in pairs(dic) do
	    	if arr ~= nil then
	    		local len = arr:getSize();
	    		for i = 1, len do
	    			cell = arr[len - i + 1];
                    if cell ~= nil then
    	    			cell:dispose();
                    end
	    			arr:remove(len);
	    		end
	    		arr:clear();
	    	end
	    	dic[k] = nil;
	    end 
	end
    self.btnShowList = nil;

    local cell = nil;
    local dic = self.btnHideList;
    if dic ~= nil then
	    for k, arr in pairs(dic) do
	    	if arr ~= nil then
	    		local len = arr:getSize();
	    		for i = 1, len do
                    cell = arr[len - i + 1];
                    if cell ~= nil then
    	    			cell:dispose();
                    end
	    			arr:remove(len);
	    		end
	    		arr:clear();
	    	end
	    	dic[k] = nil;
	    end 
	end
    self.btnHideList = nil;
    cell = nil;
	dic = nil;

    self:superCall("dispose");
end

function Lua_DragSecButtonList:updateChildPos()
    local len = self.childrenList:getSize();
    self.maxSize = 0;
    for i = 1, len do
        local ox = 0;
        local oy = 0;
        if self.childrenList[i].getOffsetX ~= nil then
            ox = self.childrenList[i]:getOffsetX();
        end
        if self.childrenList[i].getOffsetY ~= nil then
            oy = self.childrenList[i]:getOffsetY();
        end

    	local curH = self.childrenList[i]:getHeight();
        self.maxSize = self.maxSize - curH / 2;
        self.childrenList[i]:setLocation(self.offsetY + ox, self.maxSize + self.offsetX + oy, 0);
        self.maxSize = self.maxSize - curH / 2;
        self.showRect = Lua_Rectangle.new(-1*ox + self.vsize.x - self.vsize.z / 2,
         -oy + self.vsize.y - self.vsize.w / 2, self.vsize.z, self.vsize.w);

        if self.childrenList[i].checkOutBound ~= nil then
            self.childrenList[i]:checkOutBound(self.showRect);
        end
    end
    
    self.cminY = 0;
    self.cmaxY = -(self.maxSize + self.vsize.w + self.addNum);
end

function Lua_DragSecButtonList:onPress(go, state)
    if state == true then
        if self.ltype == 2 then
            if self.checkSizeDrag == true and self.cminX < self.cmaxX then
                return;
            end
        else
            if self.checkSizeDrag == true and self.cminY > self.cmaxY then
                return;
            end
        end
        if self.startMouse == -1 then
            if self.ltype == 1 then
                self.startMouse = UnityEngine.Input.mousePosition.y;
                self.startContainer = self.sub.transform.localPosition.y;
            else
                self.startMouse = UnityEngine.Input.mousePosition.x;
                self.startContainer = self.sub.transform.localPosition.x;
            end
        end
        if self._isClick == false then
            self._isClick = true;
            Lua_CommonUtil.addTimer("onEnterFrame", 0.01, self, self.onEnterFrame);
        end
        Lua_CommonUtil.removeTimer(self, self.onBackPostion);
    else
        if self.ltype == 1 then
            local endPos = 0;
            endPos = self.sub.transform.localPosition.y;
            local co = endPos - self.startContainer;
            if co < 2 and co > -2 then
                local screenpos = UICamera.mainCamera:ScreenToWorldPoint(UnityEngine.Input.mousePosition);
                local winPos = self.sub.transform:InverseTransformPoint(screenpos);
                local len = self.childrenList:getSize();
                for i = 1, len do
                    local ty = self.childrenList[i].y + self.childrenList[i]:getHeight() / 2;
                    local dy = self.childrenList[i].y - self.childrenList[i]:getHeight() / 2; 
                    if ty >= winPos.y 
                        and dy <= winPos.y then
                        self.childrenList[i]:onPlayerSoundClick();
                        break;
                    end
                end
            end
        end
        self.startMouse = -1;
        self.startContainer = -1;
        if self._isClick == true then
            self._isClick = false;
            Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
        end
        self:checkPosFix();
    end
end