-- local sub1 = Array();
-- sub1:add({name="sub2_1", data=1});

-- local sub2 = Array();
-- sub2:add({name="sub3_1", data=2});
-- sub2:add({name="sub3_2", data=3});

-- local sub3 = Array();
-- sub3:add({name="sub1_1", data=4});
-- sub3:add({name="sub1_2", data=5});
-- sub3:add({name="sub1_3", data=6});

-- local arr = Array();
-- arr:add({name="name1", sub=sub1});
-- arr:add({name="name2", sub=sub2});
-- arr:add({name="name3", sub=sub3});

-- self.btnList = Lua_DragSubButtonList.new(self.content, 1, Vector4(0, -237, 184, 548));
-- self.btnList:setData(arr, self, self.onSubClick);
-- self.btnList:setLocation(-407, 211, 0);
-- self.btnList:setMainSlected(1, 1);

checkRequire("Lua_DragButtonMain");
checkRequire("Lua_DragButtonSub");
checkRequire("Lua_DragContainer");
Lua_DragSubButtonList = class("Lua_DragSubButtonList", Lua_DragContainer);
function Lua_DragSubButtonList:ctor(p, ltype, vsize, mainSize, subSize, mainOffset, subOffset)
	self:superCall("ctor", p, ltype, vsize);
	self.content.name = "Lua_DragSubButtonList";

	self.mainSize = mainSize == nil and nil or mainSize;
	self.subSize = subSize == nil and nil or subSize;
	self.mainOffset = mainOffset == nil and Vector2(0, 0) or mainOffset;
	self.subOffset = subOffset == nil and Vector2(0, 0) or subOffset;

	self.btnShowList = Array();
	self.btnShowList:add(Array());
	self.btnShowList:add(Array());
	self.btnHideList = Array();
	self.btnHideList:add(Array());
	self.btnHideList:add(Array());
	self.checkSizeDrag = true;
	self.clickDrawBack = false;
	self.showSubBtn = true;
end

function Lua_DragSubButtonList:startDrag()
	self:onPress(go, true);
end

function Lua_DragSubButtonList:stopDrag()
	self:onPress(go, false);
end

function Lua_DragSubButtonList:createButton(t)
	local len = self.btnHideList[t]:getSize();
	local cell = nil;
	if len > 0 then
		cell = self.btnHideList[t][1];
		self.btnHideList[t]:remove(1);
		cell:setEnable(true);
	end
    
	if cell == nil then
		if t == 1 then
			cell = Lua_DragButtonMain.new(self.sub, self.mainSize, self.mainAtlas, self.mainSkinNor, self.mainSkinPress, 
			self.maintxtNorColor, self.maintxtPressColor, self.mainFontSize, self.mainOffset);
			cell.dragBtnType = 1; 
		else
			cell = Lua_DragButtonSub.new(self.sub, self.subSize, self.subAtlas, self.subSkinNor, self.subSkinPress, 
			self.subtxtNorColor, self.subtxtPressColor, self.subFontSize, self.subOffset);
			cell.dragBtnType = 2;
		end
	end
	self.btnShowList[t]:add(cell);
	return cell;
end

function Lua_DragSubButtonList:setMainBtnStyle(atlas, skinNor, skinPress, txtNorColor, txtPressColor, fontSize)
	self.mainAtlas = atlas;
	self.mainSkinNor = skinNor;
	self.mainSkinPress = skinPress;
	self.maintxtNorColor = txtNorColor;
	self.maintxtPressColor = txtPressColor;
	self.mainFontSize = fontSize;
end

function Lua_DragSubButtonList:setSubBtnStyle(atlas, skinNor, skinPress, txtNorColor, txtPressColor, fontSize)
	self.subAtlas = atlas;
	self.subSkinNor = skinNor;
	self.subSkinPress = skinPress;
	self.subtxtNorColor = txtNorColor;
	self.subtxtPressColor = txtPressColor;
	self.subFontSize = fontSize;
end

function Lua_DragSubButtonList:setRedDot(dbtnType, valList)
	local num = 1;
	for i=1,self.childrenList:getSize() do
		if self.childrenList[i].dragBtnType == dbtnType then
			self.childrenList[i]:setRedDot(valList[num]);
			num = num + 1;
		end
	end
end

function Lua_DragSubButtonList:setBtnGray(dbtnType,valList)
	local num = 1;
	for i=1,self.childrenList:getSize() do
		if self.childrenList[i].dragBtnType == dbtnType then
			self.childrenList[i]:setBtnGray(valList[num]);
			num = num + 1;
		end
	end
end

function Lua_DragSubButtonList:returntButton(t, btn)
	local len = self.btnShowList[t]:getSize();
	for i = 1, len do
		if self.btnShowList[t][i] == btn then
			self.btnShowList[t][i]:setEnable(false);
			self.btnShowList[t]:remove(i);
			break;
		end
	end
	self.btnHideList[t]:add(btn);
end

function Lua_DragSubButtonList:setBtnLabel(t, index, val) -- 设置子类 lab
	-- t = 1 --Lua_DragButtonMain 类
	-- t = 2 --Lua_DragButtonSub 类
	local arr = self.btnShowList[t];
	if arr ~= nil and arr[index] ~= nil and arr[index].btnLabel ~= nil then
		arr[index].btnLabel.text = val;
	end
end

function Lua_DragSubButtonList:setData(data, owner, clickCallBack, offsetY, offsetX)
	self.data = data;
	self.owner = owner;
	self.clickCallBack = clickCallBack;
	self.offsetX = offsetX == nil and 0 or offsetX;
	self.offsetY = offsetY == nil and 0 or offsetY;

	local len = self.childrenList:getSize();
	for i = 1, len do
		self:returntButton(self.childrenList[i].btnType, self.childrenList[i]);
	end
	self.childrenList:clear();

	len = data:getSize();
	local cell;
	for i = 1, len do
		data[i].btnIndex = i;
		cell = self:createButton(1);
		cell:setData(data[i], self, self.setMainSlected);
		self:addSubContainer(cell, false);
	end
	self:updateChildPos();
end

function Lua_DragSubButtonList:setMainSlected(index, subIndex, isMain)
	local len = 0;
	local cell = nil;
	local isMianChange = false;
	local isCheckSelect = false;
	if isMain == nil or isMain then
		local numIndex = 0;
		len = self.childrenList:getSize();
		for i = 1, len do
			numIndex = numIndex + 1;
			if self.childrenList[numIndex] ~= nil then
				if self.childrenList[numIndex].btnType == 2 then
					cell = self.childrenList[numIndex];
					self:returntButton(2, cell);
					self.childrenList:remove(numIndex);
					numIndex = numIndex - 1;
				else
					cell = self.childrenList[numIndex];
					cell.data.selected = cell.data.btnIndex == index;
					cell:checkSelected();
				end
			end
		end

		if self.lastMainSelected == index then
			if self.showSubBtn then
				self.showSubBtn = false;
				self:updateChildPos();
				return;
			end
		else
			self.showSubBtn = true;
			isMianChange = true;
		end

		if self.showSubBtn then
			self.lastMainSelected = index;
			self.subSelected = -1;
		else
			self.showSubBtn = true;
			isCheckSelect = true;
			subIndex = self.subSelected;
		end

		len = self.childrenList:getSize();
		for i = 1, len do
			if self.childrenList[i].data.btnIndex == index then
				local sub = self.childrenList[i].data.sub;
				if sub == nil or sub:getSize() == 0 then
					if self.childrenList[i].data.selected == true and self.owner ~= nil and self.clickCallBack ~= nil then
						self.clickCallBack(self.owner, self.childrenList[i].data);
					end
				else
					for j = 1, sub:getSize() do
						cell = self:createButton(2);
						sub[j].mainIndex = self.childrenList[i].data.btnIndex;
						sub[j].btnIndex = j;
						sub[j].isEnd = j == sub:getSize();
						cell:setData(sub[j], self, self.onSubBtnClick);
						self.childrenList:add(cell, i + j);
					end
				end
				break;
			end
		end
		self:updateChildPos();
	elseif self.clickDrawBack == true and isMain ~= false then
		local numIndex = 0;
		len = self.childrenList:getSize();
		for i = 1, len do
			numIndex = numIndex + 1;
			if self.childrenList[numIndex] ~= nil then
				if self.childrenList[numIndex].btnType == 2 then
					cell = self.childrenList[numIndex];
					self:returntButton(2, cell);
					self.childrenList:remove(numIndex);
					numIndex = numIndex - 1;
				else
					cell = self.childrenList[numIndex];
					cell.data.selected = cell.data.btnIndex == index;
					cell:checkSelected();
				end
			end
		end
		self:updateChildPos();
		self.lastMainSelected = -1;
	end

	if isCheckSelect then
		len = self.childrenList:getSize();
		for i = 1, len do
			if self.childrenList[i].btnType == 2 then
				cell = self.childrenList[i];
				cell.data.selected = cell.data.btnIndex == self.subSelected;
				cell:checkSelected();
			end
		end
		return;
	end

	if self.lastMainSelected ~= -1 then
		if subIndex == nil then
			len = self.childrenList:getSize();
			for i = 1, len do
				if self.childrenList[i].btnType == 2 and self.childrenList[i].data.career == DataCenter.roleData.career then
					subIndex = self.childrenList[i].data.btnIndex;
					break;
				end
			end
		end

		subIndex = subIndex == nil and 1 or subIndex;
		if subIndex ~= nil and subIndex ~= self.subSelected then
			self.subSelected = subIndex;
			len = self.childrenList:getSize();
			for i = 1, len do
				if self.childrenList[i].btnType == 2 then
					cell = self.childrenList[i];
					cell.data.selected = cell.data.btnIndex == self.subSelected;
					cell:checkSelected();
					if cell.data.selected == true and self.owner ~= nil and self.clickCallBack ~= nil then
						self.clickCallBack(self.owner, cell.data);
					end
				end
			end
		end
	end

	if isMianChange then
		self:moveToChildIndex(index, true, true);
	end
end

function Lua_DragSubButtonList:updateChildPos()
	local ox;
	local oy;
	local len = self.childrenList:getSize();
	self.maxSize = 0;
	local recordState = false;
	for i = 1, len do
		ox = 0;
		oy = 0;
		if self.childrenList[i].getOffsetX ~= nil then
			ox = self.childrenList[i]:getOffsetX();
		end

		if self.childrenList[i].getOffsetY ~= nil then
			oy = self.childrenList[i]:getOffsetY();
		end

		if self.ltype == 2 then -- 水平
			self.childrenList[i]:setLocation(self.maxSize + self.offsetY + ox, self.offsetX + oy, 0);
			self.maxSize = self.maxSize + self.childrenList[i]:getWidth();
		else -- 垂直
			self.childrenList[i]:setLocation(self.offsetY + ox, self.maxSize + self.offsetX + oy, 0);
			self.maxSize = self.maxSize - self.childrenList[i]:getHeight();
		end
	end

	if self.ltype == 2 then
		self.cminX = self.vsize.z - self.maxSize;
		self.cmaxX = 0;
	else
		self.cminY = 0;
		self.cmaxY = -(self.maxSize + self.vsize.w + self.addNum);
	end
end

function Lua_DragSubButtonList:onSubBtnClick(data)
	self:setMainSlected(data.mainIndex, data.btnIndex, false);
end

function Lua_DragSubButtonList:dispose()
	self.owner = nil;
	self.clickCallBack = nil;

	self:superCall("dispose");
end