Lua_DragTitleItem = class("Lua_DragTitleItem", Lua_DisplayObject);
function Lua_DragTitleItem:ctor(p)
	self:superCall("ctor", p, "DragTitleItem_skin");
end
function Lua_DragTitleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.sanjiaoSp:setRot(0, 0, 90);
	self.bg:addClickFuntion(self,self.onBgClick);
end

function Lua_DragTitleItem:setData(data, owner, callback)
	self._data = data;
	self.titleTxt.text = data.name;
	self.numTxt.text = data.text;
	self.owner = owner;
	self.callback = callback;
end

function Lua_DragTitleItem:onBgClick(go)
	if self.owner ~= nil and self.callback ~= nil then
		self.callback(self.owner, self._data.btnIndex);
	end
end

function Lua_DragTitleItem:setDepth(val)
	self:superCall("setDepth", val);
	self.bg:setDepth(val);
	self.sanjiaoSp:setDepth(val + 1);
	self.titleTxt:setDepth(val + 2);
	self.numTxt:setDepth(val + 2);
end

function Lua_DragTitleItem:setSelected(val)
	self.bg:setAltas("mailboxwindow_atlas", val and "ui_friend_widget_01" or "ui_friend_widget_02");
	self.sanjiaoSp:setRot(0, 0, val and 0 or 90);
end

function Lua_DragTitleItem:dispose()
	self.owner = nil;
	self.callback = nil;
	self:superCall("dispose");
end

function Lua_DragTitleItem:setRedDotPos(posx, posy)
	if self.redDotIcon ~= nil then
		self.redDotIcon:setLocation(posx, posy, 0);
	else
		self.redPos = {x = posx, y = posy};
	end
end

function Lua_DragTitleItem:setRedDotState(val)
	val = (val == nil) and false or val;
	if val then
		if self.redDotIcon == nil then
			local posx = 0;
			local posy = 0;
			if self.redPos ~= nil then
				posx = self.redPos.x;
				posy = self.redPos.y;
			end
			self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", posx, posy, 0, 0);
			self.redDotIcon:setDepth(self.depth + 2);
		end
		self.redDotIcon:setEnable(true);
	else
		if self.redDotIcon ~= nil then
			self.redDotIcon:setEnable(false);
		end
	end
end