checkRequire("Lua_DragTitleItem");
Lua_DragTitleList = class("Lua_DragTitleList", Lua_DisplayObject);
function Lua_DragTitleList:ctor(p, width, height, cell, perWidth, perHeight)
	self.width = width;
	self.height = height;
	self.perWidth = perWidth;
	self.perHeight = perHeight;
	self.cell = cell;
	self:superCall("ctor", p);
end
--[[
local data = Array();

local arr = Array();
local sub1 = Array();
sub1:add({name="sub1_1", data=1});
sub1:add({name="sub1_2", data=2});
sub1:add({name="sub1_3", data=3});
arr:add({name="name1", sub=sub1});

local sub2 = Array();
sub2:add({name="sub2_1", data=4});
arr:add({name="name2", sub=sub2});

local sub3 = Array();
sub3:add({name="sub3_1", data=7});
sub3:add({name="sub3_2", data=8});
arr:add({name="name3", sub=sub3});

]]
function Lua_DragTitleList:setData(data,setDefault)
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.titleList ~= nil then
		local len = self.titleList:getSize();
		for i=1,len do
			self.titleList[i]:dispose();
		end
		self.titleList:clear();
	end
	self.titleList = Array();
	self._data = data;
	local len = data:getSize();
	for i=1,len do
		local titleItem = Lua_DragTitleItem.new(self.content);
		titleItem:setLocation(0, -50 * (i - 1), 0);
		titleItem:setDepth(self.depth);
		data[i].btnIndex = i;
		titleItem:setData(data[i], self, self.onTitleClick);
		self.titleList:add(titleItem);
	end
	self.dragHeight = self.height - 50 * len - 65;
	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, self.perWidth, self.dragHeight));
	self.dragList:setLocation(0, 0, 0);
	self.dragList:setDepth(2510);
	self.dragList:setListCell(self.cell, self.perHeight, self.perWidth, 1);
    if setDefault==nil or setDefault==true then
	   self:setSelected(1);
	   self.dragList:setEnable(true);
	else
		self.dragList:setEnable(false);
	end
end
function Lua_DragTitleList:onTitleClick(val)
	self:setSelected(val);
end
function Lua_DragTitleList:setSelected(val,isShow)
	if self.selectedVal == val and (isShow==nil or isShow==false) then
		self.selectedVal = -1;
		self.dragList:setEnable(false);
		local len = self.titleList:getSize();
		for i=1,len do
			self.titleList[i]:setSelected(false);
			self.titleList[i]:setLocation(0, -50 * (i - 1), 0);
		end
	else
		self.selectedVal = val;
		local sub = self._data[val].sub;
		self.dragList:setEnable(true);
		self.dragList:setLuaArrayData(sub, false);
		self.dragList:setLocation(0, -50 * (val - 1) - self.dragHeight / 2 - 25, 0);
		local len = self.titleList:getSize();
		for i=1,len do
			self.titleList[i]:setSelected(i == val);
			if i <= val then
				self.titleList[i]:setLocation(0, -50 * (i - 1), 0);
			else
				self.titleList[i]:setLocation(0, - self.height + 60 + 50 * (len - i + 1), 0);
			end
		end
	end
end
function Lua_DragTitleList:setDepth(val)
	self:superCall("setDepth", val);
	local len = self.titleList:getSize();
	for i=1,len do
		self.titleList[i]:setDepth(val);
	end
end
function Lua_DragTitleList:setRedDotPos(posx, posy)
	local len = self.titleList:getSize();
	for i=1,len do
		self.titleList[i]:setRedDotPos(posx, posy);
	end
end
function Lua_DragTitleList:setRedDotStateByIndex(idx, bShow)
	if idx == nil or idx < 1 or idx > self.titleList:getSize() then
		return;
	end
	self.titleList[idx]:setRedDotState(bShow);
end
function Lua_DragTitleList:setRedDotData(data)
	self._data = data;
end