checkRequire("class");
checkRequire("Lua_MsgUtil");
Lua_EventOwner = class("Lua_EventOwner");
function Lua_EventOwner:ctor()
	self.lua_eventList = Array();
	self.lua_ceventList = Array();
	self.lua_timeList = Array();
end

function Lua_EventOwner:dispose()
	self.isDispose_2 = true;
	for k,v in pairs(self) do
		if type(v) == "table" and v.dispose ~= nil and v.isDispose_2 ~= true and type(v.dispose) == "function" then
			v:dispose();
		end
	end

	local len = 0;
	if self.lua_eventList ~= nil then
		len = self.lua_eventList:getSize();
		for i = 1, len do
			Lua_MsgUtil.removeEventListener(self.lua_eventList[i].str, self.lua_eventList[i].tb, self.lua_eventList[i].fun);
		end
	end

	if self.lua_ceventList ~= nil then
		len = self.lua_ceventList:getSize();
		for i = 1, len do
			MsgUtil.removeEventListener(self.lua_ceventList[i].str, self.lua_ceventList[i].key);
		end
	end

	if self.lua_timeList ~= nil then
		len = self.lua_timeList:getSize();
		for i = 1, len do
			Lua_CommonUtil.removeTimer(self.lua_timeList[i].tb, self.lua_timeList[i].fun);
		end
	end
end

function Lua_EventOwner:addLuaEvent(str, tb, fun)
	local value = Lua_MsgUtil.addEventListener(str, tb, fun);
	if value then
		self.lua_eventList:add({str = str, tb = tb, fun = fun});
	end
end

function Lua_EventOwner:addCSharpEvent(str, tb, fun)
	local s = MsgUtil.addEventListener(str, tb, fun);
	self.lua_ceventList:add({str = str, key = s});
end

function Lua_EventOwner:addTimer(funName, interval, tb, fun)
	Lua_CommonUtil.addTimer(funName, interval, tb, fun, nil, -1)
	self.lua_timeList:add({funName = funName, tb = tb, fun = fun});
end