-- 奖励
Lua_FightResultRewardsItem = class("Lua_FightResultRewardsItem", Lua_DisplayObject);
function Lua_FightResultRewardsItem:ctor(p, str, _dep, dragPosy, isShowLabel, dragWidth)
	self.titleStr = str == nil and "" or str;
	self.dep = _dep == nil and 1 or _dep;
	self.dragPosy = dragPosy == nil and -56 or dragPosy
	self.isShowLable = isShowLabel == nil and true or isShowLabel
	self.dragWidth = dragWidth == nil and 380 or dragWidth;
	self:superCall("ctor", p, nil);
end

function Lua_FightResultRewardsItem:buildShowItem()
	self:superCall("buildShowItem");

	if self.isShowLable then
		self.leftPoint = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_title_3", -150, 0, 158, 22);
		self.leftPoint:setSacle(1, 1, 1);
		self.leftPoint:setDepth(self.dep);

		self.rightPoint = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_title_3", 150, 0, 158, 22);
		self.rightPoint:setSacle(-1, 1, 1);
		self.rightPoint:setDepth(self.dep);

		self.titleTxt = UICreate.createLabel(self.content, self.titleStr, 0, 0, 300, 30, 28);
		self.titleTxt.pivot = UIWidget.Pivot.Center;
		self.titleTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.titleTxt:setDepth(self.dep);
	end
end

function Lua_FightResultRewardsItem:setShowRewardArr(arr)
	if arr == nil then
		if self.dragList ~= nil then
			self.dragList:setLuaArrayData(Array(), false);
		end
		return;
	end

	if self.dragList == nil then
		self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, self.dragWidth, 66));
		self.dragList:setListCell(Lua_FightResultRewardListItem, 66, 76, 1000);
		self.dragList:setDepth(self.dep);
	end
	self.dragList:setLuaArrayData(arr, false);

	local len = arr:getSize();
	local posX = len * 76 > self.dragWidth and 0 or (self.dragWidth - len * 76) / 2 + 5;
	self.dragList:setLocation(posX, self.dragPosy, 0);
end

function Lua_FightResultRewardsItem:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_FightResultRewardListItem = class("Lua_FightResultRewardListItem", Lua_ListCell);
function Lua_FightResultRewardListItem:ctor(p)
	self:superCall("ctor", p, nil);
end

function Lua_FightResultRewardListItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(1);
	self.item:setScale(0.8, 0.8);
	self.item:setCanClick(false);
end

function Lua_FightResultRewardListItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.item.data = data
end

function Lua_FightResultRewardListItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data, false);
	end
end

function Lua_FightResultRewardListItem:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end