-- 战斗结算基础类
Lua_FightingResultBaseWindow = class("Lua_FightingResultBaseWindow", Lua_FullSizeWindow);
function Lua_FightingResultBaseWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightingResultBaseWindow";
	self.skinName = "FightResultBaseWindow_skin";
	self.showClose = false;
	self.showTitle = false;
	self.showMoney = false;

	-- 修改结算面板UI显示
	self.winWinBgUrl = "/images/mainWindow/ui_zhujiemian_bg_11.png"; -- 胜利
	self.tieWinBgUrl = "/images/mainWindow/ui_zhujiemian_bg_25.png"; -- 平局
	self.failWinBgUrl = "/images/mainWindow/ui_zhujiemian_bg_09.png"; -- 失败

	self.winShowBgUrl = "/images/mainWindow/ui_zhujiemian_bg_20.png"; -- 胜利
	self.tieShowBgUrl = "/images/mainWindow/ui_zhujiemian_bg_20.png"; -- 平局
	self.failShowBgUrl = "/images/mainWindow/ui_zhujiemian_bg_22.png"; -- 失败

	self.winTitleBgUrl = "/images/mainWindow/ui_zhujiemian_bg_19.png"; -- 胜利
	self.tieTitleBgUrl = "/images/mainWindow/ui_zhujiemian_bg_23.png"; -- 平局
	self.failTitleBgUrl = "/images/mainWindow/ui_zhujiemian_bg_21.png"; -- 失败

	self.winTitleAtlas = "ui_zhujiemian_z_zysl"; -- 胜利
	self.tieTitleAtlas = "ui_zhujiemian_z_zypj"; -- 平局
	self.failTitleAtlas = "ui_zhujiemian_z_zysb"; -- 失败

	self.winTipsBgUrl = "/images/mainWindow/ui_zhujiemian_bg_12.png"; -- 胜利
	self.tieTipsBgUrl = "/images/mainWindow/ui_zhujiemian_bg_24.png"; -- 平局
	self.failTipsBgUrl = "/images/mainWindow/ui_zhujiemian_bg_10.png"; -- 失败
	self.bShowStar = false;
	self.needBackBtn = true;
	self.needNextBtn = true;
	self.needBackTime = true;
	self.backTimeLang = 120935;
end

function Lua_FightingResultBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 显示星级
	if self.bShowStar then
		self.starArr = Array();
		local leftStar = UICreate.createUIAtlasImage(self.content, "copy_atlas_2", "ui_fuben_nanduxing", -79, 240, 93, 97.5);
		leftStar:setDepth(3);
		self.starArr:add(leftStar);

		local midStar = UICreate.createUIAtlasImage(self.content, "copy_atlas_2", "ui_fuben_nanduxing", 0, 269, 105, 112);
		midStar:setDepth(3);
		self.starArr:add(midStar);

		local rightStar = UICreate.createUIAtlasImage(self.content, "copy_atlas_2", "ui_fuben_nanduxing", 79, 240, 93, 97.5);
		rightStar:setDepth(3);
		self.starArr:add(rightStar);
	end
	self.backBtn:setEnable(self.needBackBtn);
	self.nextBtn:setEnable(self.needNextBtn);
	self.backTimeTxt:setEnable(self.needBackTime);
	self:showUI(self.bShowStar);

	self.titleIcon:addLoadCompleteFun(self, self.onLoadCompleteImg);
	self.backBtn:addClickFuntion(self, self.onBackBtnClick);
	self.nextBtn:addClickFuntion(self, self.onNextBtnClick);
end

function Lua_FightingResultBaseWindow:showUI(showState)
	if showState then
		self.titleBg:setLocation(-11, 91, 0);
		self.titleIcon:setLocation(0, 157, 0);
		self.tipsBg:setEnable(false);
	else
		self.titleBg:setLocation(-11, 202, 0);
		self.titleIcon:setLocation(0, 254, 0);
		self.tipsBg:setEnable(true);
	end
end

function Lua_FightingResultBaseWindow:onLoadCompleteImg()
	self.titleIcon:resetSize();
end

function Lua_FightingResultBaseWindow:onBackBtnClick(go)
	self:hide();
end

function Lua_FightingResultBaseWindow:onNextBtnClick(go)
end

-- 结算信息
function Lua_FightingResultBaseWindow:setShowInfo(resultState, backTime, starNum, showNextBtn)
	if resultState == 1 then -- 赢
		self.winBg:setUrl(self.winWinBgUrl);
		self.showBg:setUrl(self.winShowBgUrl);
		self.titleBg:setUrl(self.winTitleBgUrl);
		self.titleIcon:setAltas("fight_atlas", self.winTitleAtlas);
		self.tipsBg:setUrl(self.winTipsBgUrl);
	elseif resultState == -1 then -- 输
		self.winBg:setUrl(self.failWinBgUrl);
		self.showBg:setUrl(self.failShowBgUrl);
		self.titleBg:setUrl(self.failTitleBgUrl);
		self.titleIcon:setAltas("fight_atlas", self.failTitleAtlas);
		self.tipsBg:setUrl(self.failTipsBgUrl);
	else -- 平
		self.winBg:setUrl(self.tieWinBgUrl);
		self.showBg:setUrl(self.tieShowBgUrl);
		self.titleBg:setUrl(self.tieTitleBgUrl);
		self.titleIcon:setAltas("fight_atlas", self.tieTitleAtlas);
		self.tipsBg:setUrl(self.tieTipsBgUrl);
	end

	-- 倒计时退出
	if self.needBackTime then
		if backTime <= 0 then
			self.backTimeTxt.text = "";
			self:clearTimer();	
		else
			self.backTime = backTime;
			self.backTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(120935), tostring(self.backTime));
			if self.bRegistTimer ~= true then
				self.bRegistTimer = true;
				Lua_CommonUtil.addTimer("Lua_FightingResultBaseWindow", 1, self, self.updateFightingResultBackTime);
			end
		end
	end

	-- 星级
	if self.bShowStar and self.starArr ~= nil then
		starNum = starNum == nil and 0 or starNum;
		for i = 1, self.starArr:getSize() do
			-- self.starArr[i]:setGray(i > starNum);
			if i > starNum then
				self.starArr[i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing_s");
			else
				self.starArr[i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing");
			end
		end
	end

	-- 再来一次按钮
	if self.needNextBtn == true then
		showNextBtn = showNextBtn == nil and false or showNextBtn;
		if showNextBtn == true then
			self.nextBtn:setEnable(true);
			self.backBtn:setLocation(-155, -153, 0);
			self.nextBtn:setLocation(155, -153, 0);
		else
			self.nextBtn:setEnable(false);
			self.backBtn:setLocation(0, -153, 0);
		end
	end
end

function Lua_FightingResultBaseWindow:clearTimer()
	if self.bRegistTimer == true then
		self.bRegistTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateFightingResultBackTime);
	end
end

function Lua_FightingResultBaseWindow:updateFightingResultBackTime()
	self.backTime = self.backTime - 1;
	if self.backTime <= 0 then
		self:clearTimer();
		self.backTimeTxt.text = "";
		self:onCountDownEnd();
		return;
	end
	self.backTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(self.backTimeLang), tostring(self.backTime));
end

function Lua_FightingResultBaseWindow:onCountDownEnd()
	self:onBackBtnClick();
end

function Lua_FightingResultBaseWindow:hideStar()
	if self.starArr == nil then
		return;
	end
	local len = self.starArr:getSize();
	for i = 1, len do
		self.starArr[i]:setEnable(false);
	end
end

function Lua_FightingResultBaseWindow:dispose()
	self:clearTimer();
	self:superCall("dispose");
end