Lua_FullSizeTabBaseWindow = class("Lua_FullSizeTabBaseWindow", Lua_FullSizeWindow);
--全屏标签页面板基类，主要用来处理标签页切换时的子面板显示、隐藏操作
function Lua_FullSizeTabBaseWindow:ctor(tabList)
	local arr = Array();
	for i = 1, tabList:getSize() do
		tabList[i].pindex = i;
		if tabList[i].openId == nil or DataCenter.funcOpenData:isOpened(tabList[i].openId) == true then
			arr:add(tabList[i]);
		else
			local s = getConfig({"func_open", tabList[i].openId, "advance_function"});
			if s ~= 0 then
				tabList[i].showGray = true;
				arr:add(tabList[i]);
			end
		end
	end
	self.tabList = arr;
	
	self.tabNames = Array();
	for i = 1, arr:getSize() do
		self.tabNames:add({name = self.tabList[i].name, eventIds = self.tabList[i].eventIds, showGray=self.tabList[i].showGray, openId=self.tabList[i].openId, clickRemoveEvent=self.tabList[i].clickRemoveEvent});
	end

	self.btnList = nil;
	self.curPanel = nil;
	self:superCall("ctor");
	self.panelIndex = -1;
end

function Lua_FullSizeTabBaseWindow:setShowData(o)
	self:superCall("setShowData", o);

	if self.isSetIndex ~= true then
		self.btnList:setSelected(1, true);
	end
end

function Lua_FullSizeTabBaseWindow:showWin(param)
	self.selectDefaultData = nil;
	self.toindex = nil;
	if type(param) == "table" and param.openIdx ~= nil then
		self.toindex = param.openIdx;
		self.selectDefaultData = param.data;
	elseif type(param) == "number" then
		self.toindex = param;
	end
	
	self.defaultSelectIdx = nil;
	if self.toindex ~= nil then
		for i=1,self.tabList:getSize() do
			if self.tabList[i].pindex == self.toindex then
				if self.tabList[i].openId == nil or DataCenter.funcOpenData:isOpened(self.tabList[i].openId) == true then
					self.defaultSelectIdx = self.toindex;
					self.isSetIndex = true;
					self.btnList:setSelected(i, true);
				end
				break;
			end
		end
	end

	if self.defaultSelectIdx == nil then
		self.selectDefaultData = nil;
	end
end

function Lua_FullSizeTabBaseWindow:setSelected(val)
	if self.panelIndex == val or self.tabList[val] == nil then
		return;
	end
	
	local objClass = self.tabList[val].panel;
	if self.tabList[val].openId ~= nil and DataCenter.funcOpenData:isOpened(self.tabList[val].openId) == false then
		local s = getConfig({"func_open", self.tabList[val].openId, "advance_message"});
		if s ~= nil then
			OperateAlert.show(s);
		end
		self.btnList:setSelected(self.panelIndex, false);
		return;
	end

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.panelIndex = val;
	
	self.curPanel = objClass.new(self.content);
	if self.showTitle then
		if self.tabList[val].titleAltas ~= nil and self.tabList[val].titleSprite ~= nil then
			self.titleSp:setAltas(self.tabList[val].titleAltas, self.tabList[val].titleSprite);
			self.titleSp:setEnable(true);
		else
			self.titleSp:setEnable(false);
		end
	end
	if self.updateBgImg ~= nil then
		self:updateBgImg(val);
	end
	if self.defaultSelectIdx ~= nil and self.defaultSelectIdx == val and self.selectDefaultData ~= nil then
		if self.curPanel.showDefaultData ~= nil then
			self.curPanel:showDefaultData(self.selectDefaultData);
		end
		self.selectDefaultData = nil;
		self.defaultSelectIdx = nil;
	end
end

function Lua_FullSizeTabBaseWindow:onBtnClick(val, bb)
	self:setSelected(val);
end

function Lua_FullSizeTabBaseWindow:setBlackMaskFun(val)
	self:superCall("setBlackMaskFun", val);
	if self.curPanel ~= nil and self.curPanel.setBlackMaskFun ~= nil then
		self.curPanel:setBlackMaskFun(val);
	end
end

function Lua_FullSizeTabBaseWindow:setRedDotStateByIndex(idx, bShow)
	for i = 1, self.tabList:getSize() do
		if self.tabList[i].pindex == idx then
			if self.tabList[i].openId == nil or DataCenter.funcOpenData:isOpened(self.tabList[i].openId) == true then
				self.btnList:setRedDotStateByIndex(i, bShow);
			end
			return;
		end
	end
end