checkRequire("Lua_MoneyItem");
Lua_FullSizeWindow = class("Lua_FullSizeWindow", Lua_Window);
function Lua_FullSizeWindow:ctor(showimgBg, isModel, layer, showClose, showTitle, showMoney, bgPath, isSpecial)
    self:superCall("ctor");

    self.layer = layer == nil and 3500 or layer;
    self.isModel = isModel == nil and true or isModel;
    self.showClose = showClose == nil and true or showClose;
    self.showBg = false;
    self.bgPath = bgPath == nil and "/images/common/ui_common_bg.jpg" or bgPath;
    self.showimgBg = showimgBg == nil and true or showimgBg;
    self.showTitle = showTitle == nil and true or showTitle;
    self.w = MainWinDefine.V_width;
    self.h = MainWinDefine.V_height;
    self.blackAlpha = 1;
    self.showMoney = showMoney == nil and true or showMoney;
    self.showMoney2 = false;
    self.isSpecial = isSpecial == nil and false or isSpecial;
end

function Lua_FullSizeWindow:buildShowItem()
    self:superCall("buildShowItem");

    if self.btnClose ~= nil then
        self.btnClose:setAltas("common_atlas_1", "ui_common_btn_05");
        self.btnClose:resetSize();
        self.btnClose:setLocation(MainWinDefine.bgWidth / 2 - 1229, MainWinDefine.bgHeight / 2 - 31, 0);
        self.btnClose:setDepth(3);
    end

    if self.showimgBg == true then
        self.imgBg = UICreate.createImage(self.content, self.bgPath, 0, 0, 0, 0);
        self.imgBg.name = "imgBg";
        self.imgBg:setUrl(self.bgPath);
        self.imgBg:setDepth(-1);
        self.imgBg:SetDimensions(MainWinDefine.bgWidth, MainWinDefine.bgHeight);
    end

    if self.showTitle == true then
        self.winTitleBg = UICreate.createImage(self.content, "/images/common/ui_common_btd_01.png", 0, MainWinDefine.bgHeight / 2 - 31, MainWinDefine.bgWidth, 64);
        self.winTitleBg.name = "winTitleBg";
        self.winTitleBg:setDepth(2);

        self.titleLine = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_btd_zs", MainWinDefine.bgWidth / 2 - 1185, MainWinDefine.bgHeight / 2 - 31, 0, 0);
        self.titleLine.name = "titleLine";
        self.titleLine:setDepth(3);

        self.titleSp = UICreate.createUIAtlasImage(self.content, "", "", MainWinDefine.bgWidth / 2 - 1169, MainWinDefine.bgHeight / 2 - 31, 0, 0);
        self.titleSp.name = "titleSp";
        self.titleSp.pivot = UIWidget.Pivot.Left;
        self.titleSp:setDepth(3);
        self.titleSp:addLoadCompleteFun(self, self.onLoadCompleteImg);
    end

    self:showMoney1(false, nil);
    self:addCSharpEvent("SCREEN_RESIZE", self, self.onScreenResize);
    self:onScreenResize();
end

function Lua_FullSizeWindow:onLoadCompleteImg()
    self.titleSp:resetSize();
end

function Lua_FullSizeWindow:onScreenResize()
    if self.showimgBg == false then
        return;
    end

    local bgW = MainWinDefine.V_width > 1440 and MainWinDefine.V_width or 1440;
    local bgH = MainWinDefine.V_height > 720 and MainWinDefine.V_height or 720;
    self.imgBg:SetDimensions(bgW, bgH);
end

function Lua_FullSizeWindow:setShowTitle(atlasName, spriteName)
    if self.showTitle then
        self.titleSp:setAltas(atlasName, spriteName);
    end
end

function Lua_FullSizeWindow:showMoney1(value, money_type)
    self.showMoney2 = value;

    if self.showMoney == true and self.showMoney2 == false then
        if self.moneyItem1 == nil then
            self.moneyItem1 = Lua_MoneyItem.new(self.content);
            self.moneyItem1.name = "moneyItem1";
            self.moneyItem1:setMoneyType(Lua_MoneyData.GOLD);
            self.moneyItem1:setDepth(4);
            self.moneyItem1:replaceSpecialBgAtlas(self.isSpecial)

            self.moneyItem2 = Lua_MoneyItem.new(self.content);
            self.moneyItem2.name = "moneyItem2";
            self.moneyItem2:setMoneyType(Lua_MoneyData.BIND_GOLD);
            self.moneyItem2:setDepth(4);
            self.moneyItem2:replaceSpecialBgAtlas(self.isSpecial)

            self.moneyItem3 = Lua_MoneyItem.new(self.content);
            self.moneyItem3.name = "moneyItem3";
            self.moneyItem3:setMoneyType(Lua_MoneyData.COPPER);
            self.moneyItem3:setDepth(4);
            self.moneyItem3:replaceSpecialBgAtlas(self.isSpecial);
        end

        if self.moneyItem4 ~= nil and money_type == nil then
            self.moneyItem4.mainContent:SetActive(false)
        end

        if getLanType() == 1 and self.moneyItem5 == nil and self.showMarketMoney ~= 0 then
            --if self.moneyItem5 == nil and self.showMarketMoney == 1 then
            if self.moneyItem5 == nil 
                and DataCenter.roleData:checkGameSwich("diamond") ~= 0 then
                self.moneyItem5 = Lua_MoneyItem.new(self.content);
                self.moneyItem5.name = "moneyItem5";
                self.moneyItem5:setMoneyType(Lua_MoneyData.JEWEL);
                self.moneyItem5:setDepth(4);
                self.moneyItem5:replaceSpecialBgAtlas(self.isSpecial)
            end

            self.moneyItem1:setLocation(-32, 335, 0);
            self.moneyItem2:setLocation(185, 335, 0);
            self.moneyItem3:setLocation(402, 335, 0);
            if self.moneyItem5 ~= nil then
                self.moneyItem5:setLocation(-254, 335, 0);
                self.moneyItem5.mainContent:SetActive(true);
            end
        else
            if self.moneyItem5 ~= nil and money_type == nil then
                self.moneyItem5.mainContent:SetActive(false);
            end
            
            self.moneyItem1:setLocation(74, 329, 0);
            self.moneyItem2:setLocation(290, 329, 0);
            self.moneyItem3:setLocation(508, 329, 0);
        end
    elseif self.showMoney2 == true then
        if self.moneyItem1 == nil then
            self.moneyItem1 = Lua_MoneyItem.new(self.content);
            self.moneyItem1:setMoneyType(Lua_MoneyData.GOLD);
            self.moneyItem1:setDepth(4);
            self.moneyItem1:replaceSpecialBgAtlas(self.isSpecial)

            self.moneyItem2 = Lua_MoneyItem.new(self.content);
            self.moneyItem2:setMoneyType(Lua_MoneyData.BIND_GOLD);
            self.moneyItem2:setDepth(4);
            self.moneyItem2:replaceSpecialBgAtlas(self.isSpecial)

            self.moneyItem3 = Lua_MoneyItem.new(self.content);
            self.moneyItem3:setMoneyType(Lua_MoneyData.COPPER);
            self.moneyItem3:setDepth(4);
            self.moneyItem3:replaceSpecialBgAtlas(self.isSpecial)
        end

        if self.moneyItem4 == nil then
            self.moneyItem4 = Lua_MoneyItem.new(self.content);
            self.moneyItem4:setLocation(-254, 335, 0);
            self.moneyItem4:setDepth(4);
            self.moneyItem4:replaceSpecialBgAtlas(self.isSpecial)
        end

        if self.moneyItem5 ~= nil then
            self.moneyItem5.mainContent:SetActive(false);
        end

        self.moneyItem1:setLocation(-32, 335, 0);
        self.moneyItem2:setLocation(185, 335, 0);
        self.moneyItem3:setLocation(402, 335, 0);
        self.moneyItem4.mainContent:SetActive(true)
        self.moneyItem4:setMoneyType(money_type);
    end
end

function Lua_FullSizeWindow:updateBgImage(val)
    if self.bgPath == val then
        return;
    end
    
    self.bgPath = val;
    if self.imgBg ~= nil then
        self.imgBg:setUrl(self.bgPath);
    end
end

function Lua_FullSizeWindow:setBlackMaskFun(val)
end