Lua_HeadIconItem = class("Lua_HeadIconItem", Lua_DisplayObject);
function Lua_HeadIconItem:ctor(p)	
	self:superCall("ctor", p, nil);
end

function Lua_HeadIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_icon_txk_d", 0, 0, 100, 100);
	self.headBg.name = "headBg";
	self.headBg:setDepth(3);

	self.headIcon = UICreate.createImage(self.content, "", 0, 0, 0, 0);
	self.headIcon.name = "headIcon";
	self.headIcon:setDepth(4);

    self.headFrame = UICreate.createUIAtlasImage(self.content, "", "", 0, 10, 0, 0);
    self.headFrame.name = "headFrame";
    self.headFrame:setDepth(5);

    self:setData(DataCenter.roleData.career, DataCenter.roleData.profession, nil);
end

function Lua_HeadIconItem:setData(career, profession, frameData)
	if frameData == nil then -- 未穿戴头像框
		self.headBg:setAltas("common_atlas_1", "ui_common_icon_txk_d");
		self.headBg:SetDimensions(100, 100);
	else
		self.headFrame:setAltas(frameData.atlas, frameData.sprite);
		self.headFrame:SetDimensions(120, 120);
	end
	self.headFrame:setEnable(frameData ~= nil);

	self.headIcon:SetDimensions(90, 90);
	if type(profession) == "number" then
		if frameData == nil then
			self.headIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career, profession));
		else
			self.headIcon:setUrl(Lua_ThingDefine.getFashionHeadIconUrlByCareer(career, profession));
		end
	elseif type(profession) == "string" then
		-- 系统默认
		local isDefault = DataCenter.roleData:isDefaultHead(career, profession);
		if isDefault then
			if frameData == nil then
				self.headIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(profession, 0));
			else
				self.headIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(profession, 1));
			end
		else
			self.headIcon:setUrl(profession, 99, true);
			self.headIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆
		end
	end
end

function Lua_HeadIconItem:showFrameEffect(id)
	if id ~= nil and type(id) == "number" then
		if self.frameEffect ~= nil then
			self.frameEffect:dispose();
			self.frameEffect = nil;
		end

		local effectStr = getConfig({"chat_attire", id, "effect"});
		local effectPosX = getConfig({"chat_attire", id, "effect_offset_right", 1});
		local effectPosY = getConfig({"chat_attire", id, "effect_offset_right", 2});
		local depth = getConfig({"chat_attire", id, "depth"});
		local scaleX = getConfig({"chat_attire", id, "scale", 1});
		local scaleY = getConfig({"chat_attire", id, "scale", 2});
	    
	    if effectStr == nil then
	    	return;
	    end
		self.frameEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..effectStr, effectStr, 0, 0);
		self.frameEffect:SetRenderQueue(self.headBg, depth, 2, false);
		self.frameEffect:setLocation(effectPosX, effectPosY, 0);
		self.frameEffect:setSacle(scaleX, scaleY);
	end
end

function Lua_HeadIconItem:dispose()
	if self.headBg ~= nil then
		self.headBg:dispose();
		self.headBg = nil;
	end
	if self.headIcon ~= nil then
		self.headIcon:dispose();
		self.headIcon = nil;
	end
	if self.headFrame ~= nil then
		self.headFrame:dispose();
		self.headFrame = nil;
	end
	if self.frameEffect ~= nil then
		self.frameEffect:dispose();
		self.frameEffect = nil;
	end

	self:superCall("dispose");
end