
checkRequire("Lua_NumberInputItem");
Lua_ItemBuyWindow = class("Lua_ItemBuyWindow", Lua_Window);
function Lua_ItemBuyWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ItemBuyWindow";
	self.skinName = "ItemBuyWindow_skin";
	self.isClickClose = true;
end
function Lua_ItemBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.subBtn:addClickFuntion(self,self.onBuyClick);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(3);
	self.itemImg:setLocation(-140,150,0);

	self.numItem = Lua_NumberInputItem.new(self.content);
	self.numItem:setDepth(3);
	self.numItem:setLocation(-48,-83);
	self.numItem:setMinMaxValue(1,999);
	self.numItem:setAddTen(true);
	self.numItem:setWindowOffset(305,-70);

	self.numItem.owner = self;
	self.numItem.callBack = self.onNumChange;
end
function Lua_ItemBuyWindow:showWin(param)
	self.data = param;
	self.itemVo = Lua_ToolVo.createToolVo(self.data.itemId,1,0);
	self.itemImg.data = self.itemVo;
	self.itemTxt.text = self.itemVo.colorName;
	self.outTxt.text = self.itemVo.des;
	self.perTxt.text = tostring(self.itemVo.goldPrice);
	if self.data.moneyType == Lua_MoneyData.GOLD_AND_BINDGOLD or self.data.moneyType == Lua_MoneyData.BIND_GOLD then
		self.moneyIcon1:setAltas(Lua_MoneyData.getMoneyIconAtlas(Lua_MoneyData.BIND_GOLD), 
			Lua_MoneyData.getIconSpByMoneyType(Lua_MoneyData.BIND_GOLD));
		self.moneyIcon2:setAltas(Lua_MoneyData.getMoneyIconAtlas(Lua_MoneyData.BIND_GOLD), 
			Lua_MoneyData.getIconSpByMoneyType(Lua_MoneyData.BIND_GOLD));
	else
		self.moneyIcon1:setAltas(Lua_MoneyData.getMoneyIconAtlas(Lua_MoneyData.GOLD), 
			Lua_MoneyData.getIconSpByMoneyType(Lua_MoneyData.GOLD));
		self.moneyIcon2:setAltas(Lua_MoneyData.getMoneyIconAtlas(Lua_MoneyData.GOLD), 
			Lua_MoneyData.getIconSpByMoneyType(Lua_MoneyData.GOLD));
	end
	self.numItem:setNum(1);
end
function Lua_ItemBuyWindow:onNumChange(val)
	local costNum = val * self.itemVo.goldPrice;
	if DataCenter.moneyData:isMoneyEnough(self.data.moneyType, costNum, false, false) == true then
		self.allTxt.text = Lua_ColorDefine.colorStr(tostring(costNum), Lua_ColorDefine.GREEN_STR);
	else
		self.allTxt.text = Lua_ColorDefine.colorStr(tostring(costNum), Lua_ColorDefine.RED_STR);
	end
end
function Lua_ItemBuyWindow:onBuyClick(go)
	local costNum = self.numItem.num * self.itemVo.goldPrice;
	local showType = -1;
	if (self.data.moneyType == Lua_MoneyData.GOLD_AND_BINDGOLD or self.data.moneyType == Lua_MoneyData.BIND_GOLD) 
		and DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.BIND_GOLD, costNum, false, false) == true then
		showType = 5;
	end
	if showType == -1 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, costNum, true, true) == true then
			showType = 2;
		end
	end
	if showType ~= -1 then
		Lua_PackUtil.buyItem(self.itemVo.id, showType, self.numItem.num, false);
		self:hide();
	end
end