-- tips显示的模型
checkRequire("Lua_MyPlayerModel");
Lua_ItemShowModelPanel = class("Lua_ItemShowModelPanel", Lua_DisplayObject);
function Lua_ItemShowModelPanel:ctor(p, bgW, bgH, bgPosX, bgPosY, modelSpPos, modelSpRot, modelSpSca, isImage, isClickRot)
	self.bgWidth = bgW;
	self.bgHeight = bgH;
	self.bgPosX = bgPosX;
	self.bgPosY = bgPosY;

	self.modelSpPos = modelSpPos == nil and Vector3(0, 0, 0) or modelSpPos; -- 模型位置
	self.modelSpRot = modelSpRot == nil and Vector3(0, 0, 0) or modelSpRot; -- 模型旋转角度
	self.modelSpSca = modelSpSca == nil and Vector3(1, 1, 1) or modelSpSca; -- 模型大小
	self.isImage = isImage == nil and true or isImage; -- 是否读取路径图片
	self.isClickRot = isClickRot == nil and true or isClickRot; -- 是否屏蔽模型旋转

	self:superCall("ctor", p, nil);
end

function Lua_ItemShowModelPanel:dispose()
	self:showFashionModel(nil);
	self:showEffectModel(false);
	self:onMouseUpHandle();
	self:clearTimer();

	if self.myPlayerModel ~= nil then
		self.myPlayerModel:dispose();
		self.myPlayerModel = nil;
	end
	if self.magnifyBtn ~= nil then
		self.magnifyBtn:dispose();
		self.magnifyBtn = nil;
	end
	self:superCall("dispose");
end


function Lua_ItemShowModelPanel:buildShowItem()
	self:superCall("buildShowItem");
	if self.bgWidth == nil then
		self.bgWidth = 348;
	end
	if self.bgHeight == nil then
		self.bgHeight = 439;
	end
	if self.bgPosX == nil then
		self.bgPosX = 0;
	end
	if self.bgPosY == nil then
		self.bgPosY = self.bgHeight / 2;
	end

	self.showBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_tips_d", self.bgPosX, self.bgPosY, self.bgWidth, self.bgHeight);
	self.showBg.name = "showBg";
	self.showBg.pivot = UIWidget.Pivot.Top;
	self.showBg:setDepth(0);

	if self.isImage == false then
		self.bg = UICreate.createUIAtlasImage(self.content, "", "", self.bgPosX, self.bgPosY, self.bgWidth, self.bgHeight);
	else
		self.bg = UICreate.createImage(self.content, "/images/role/ui_figure_bg_02.png", self.bgPosX, self.bgPosY, self.bgWidth, self.bgHeight);
	end
	self.bg.pivot = UIWidget.Pivot.Top;
	self.bg.name = "bg";
	self.bg:setDepth(2);

	if self.isClickRot == true then
		self.bg:addClickFuntion(self, self.onMouseDownHandle);
		self.bg:addMouseUpFuntion(self, self.onMouseUpHandle);
		self.bg.clickScale = false;
	end

	self.modelSpr = UICreate.createGameObject(self.content, 0, 0, 0);
	-- self.modelSpr.transform.localEulerAngles = self.modelSpRot;
	-- self.modelSpr.transform.localScale = self.modelSpSca;
	-- self.modelSpr.transform.localPosition = self.modelSpPos;
    LuaUtil.setObjRot(self.modelSpr, self.modelSpRot.x, self.modelSpRot.y, self.modelSpRot.z);
	LuaUtil.setObjScale(self.modelSpr, self.modelSpSca.x, self.modelSpSca.y, self.modelSpSca.z);
    LuaUtil.setObjPos(self.modelSpr, self.modelSpPos.x, self.modelSpPos.y, self.modelSpPos.z);
end

function Lua_ItemShowModelPanel:onMouseDownHandle(go, state)
	if self.isRotStart == nil or self.isRotStart == false then
		self.isRotStart = true;
		self.startPos = UnityEngine.Input.mousePosition.x;
		self.startRot = self.modelSpr.transform.localEulerAngles.y;
		Lua_CommonUtil.addTimer("TipsShowModelRotation", 0.05, self, self.TipsShowModelRotation);
	end
end

function Lua_ItemShowModelPanel:onMouseUpHandle(go, state)
	if self.isRotStart == true then
		self.isRotStart = false;
		Lua_CommonUtil.removeTimer(self, self.TipsShowModelRotation);
	end
end

function Lua_ItemShowModelPanel:TipsShowModelRotation()
	local dt = self.startPos - UnityEngine.Input.mousePosition.x;
	local trot = self.startRot + dt;
	-- self.modelSpr.transform.localEulerAngles = Vector3(0, trot, 0);
    LuaUtil.setObjRot(self.modelSpr, 0, trot, 0);
end

function Lua_ItemShowModelPanel:setShowData(vo)
	if vo == nil then
		return;
	end

	-- 时装碎片、装备碎片特殊处理
	if vo.subType == Lua_PackTypeDefine.FASION_CHIP or vo.subType == Lua_PackTypeDefine.EQUIP_CHIP then 
		vo = Lua_ToolVo.createToolVo(tonumber(vo.config.tipShowModel));
		if vo == nil then
			return;
		end
	end

	local list = vo.config.tipShow_pos;
	if list == nil or #list < 2 then
		self.modelPos = Vector3(0, -155, 0);
	else
		self.modelPos = Vector3(list[1], list[2], 0);
	end
	list = vo.config.tipShow_rot;
	if list == nil or #list < 3 then
		self.modelRot = Vector3(0, 90, 0);
	else
		self.modelRot = Vector3(list[1], list[2], list[3]);
	end

	list = vo.config.tipShow_scale;
	if list == nil then
		self.modelSca = 170;
	else
		if type(list) == "number" then
			self.modelSca = list;
		else
			if list[1] == nil then
				self.modelSca = 170;
			else
				self.modelSca = list[1];
			end
		end
	end

	--装备、时装、时装碎片
	if vo.subType == Lua_PackTypeDefine.EQUIP or vo.subType == Lua_PackTypeDefine.FASION then
		local modelData = UsData();
		if vo.career == nil or vo.career == 0 then
			modelData.career = DataCenter.roleData.career;
		else
		    modelData.career = vo.career;
		end

		if modelData.career == 2 then
			modelData.gender = Lua_ThingDefine.FEMALE;
		else
			modelData.gender = Lua_ThingDefine.MALE;
		end

		if vo.subType == Lua_PackTypeDefine.EQUIP then
			if vo.part == 12 then
				modelData.weapon_id = vo.id; -- 武器
			elseif vo.part == 2 then
				modelData.clothes_id = vo.id; -- 衣服
			end
		elseif vo.subType == Lua_PackTypeDefine.FASION then
			if vo.part == 3 then
				modelData.fashion_clothes_id =  vo.id;--时装衣服
			elseif vo.part == 2 then
				modelData.fashion_weapon_id = vo.id;--时装武器
			elseif vo.part == 1 then
				modelData.fashionHeadId = vo.id;--时装头饰
			end
		end
		modelData.nickname = "";
		modelData.hp = 1;
		modelData.kind = 2;
		modelData.isShowName = false;
		modelData.IsUI = true;
		self:showFashionModel(modelData);
		self:showEffectModel(false);
		self:clearTimer();
		self:showDiImg(true);
	else
		local modelPath = vo.modelPath;
		if modelPath == nil then
			self:showEffectModel(false);
		else
			if modelPath.isEffect then
				self.bRegisterTimer = true;
				if vo.subType ~= Lua_PackTypeDefine.HEADFRAME_OR_BUBBLE or vo.subType ~= Lua_PackTypeDefine.FASHION_BACKGROUND then
					Lua_CommonUtil.addTimer("TipsShowModelEffectUpdate", 2, self, self.TipsShowModelEffectUpdate);
				end
			end

			self.urlStr = modelPath.urlStr;
			self.modelName = modelPath.modelName;
			-- print("Lua_ItemShowModelPanel", vo.subType);
			if vo.subType == Lua_PackTypeDefine.HEADFRAME_OR_BUBBLE -- 头像框、气泡
				or vo.subType == Lua_PackTypeDefine.SERVANT_MOUNT_TRANS -- 宠骑
				or vo.subType == Lua_PackTypeDefine.ROLE_MOUNT then -- 角色坐骑
				self:showEffectModel(true, modelPath.uiShowAction, false);
				self:showDiImg(true);
			elseif vo.subType == Lua_PackTypeDefine.FASHION_BACKGROUND then -- 装扮背景
				self:showEffectModel(true, modelPath.uiShowAction, false);
				self:showFashionBgModel(vo.id);
				self:showDiImg(false);
			else
				self:showEffectModel(true, modelPath.uiShowAction);
				self:showDiImg(true);
			end
		end
		self:showFashionModel(nil);
	end
end

function Lua_ItemShowModelPanel:showDiImg(val)
	if val then
		if self.diImg == nil then
			self.diImg = UICreate.createImage(self.content, "/images/common/ui_common_bg_dizuo1.png", self.bgPosX - 12, -self.bgPosY - 11, 0, 0);
			self.diImg.pivot = UIWidget.Pivot.Bottom;
			self.diImg:setDepth(1);
		end
		self.diImg:setEnable(true);
	else
		if self.diImg ~= nil then
			self.diImg:setEnable(false);
		end
	end
end

function Lua_ItemShowModelPanel:TipsShowModelEffectUpdate()
	if self.modelEff == nil then 
		self:clearTimer();
		return; 
	end
	local effectRoot = self.modelEff.mainContent;
	if effectRoot ~= nil then
		effectRoot:SetActive(false);
		effectRoot:SetActive(true);
	end
end

function Lua_ItemShowModelPanel:clearTimer()
	if self.bRegisterTimer == true then
		self.bRegisterTimer = false;
		Lua_CommonUtil.removeTimer(self, self.TipsShowModelEffectUpdate);
	end
end

-- 时装模型，装备模型展示
function Lua_ItemShowModelPanel:showFashionModel(modelData)
	if modelData ~= nil then
		if self.playerModel == nil then
			self.playerModel = ModelPlayer();
		end
		self.playerModel:init(self.modelSpr, self.modelPos, self.modelRot, modelData, nil, self.modelSca);
		self.playerModel:SetRenderQueue(self.bg, 5, 2);
	else
		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
	end
end

-- 非时装模型展示
function Lua_ItemShowModelPanel:showEffectModel(isEffect, uiShowAction, resetPatticl)
	if isEffect == true then
		if resetPatticl == nil then
			resetPatticl = true;
		end

		if self.modelEff == nil then
			self.modelEff = UICreate.createUIEffect(self.modelSpr, self.urlStr, self.modelName, 0, 0);
		end
		self.modelEff:SetRenderQueue(self.bg, 5, 2, resetPatticl);
		self.modelEff:setRot(self.modelRot.x, self.modelRot.y, self.modelRot.z);
		self.modelEff:setSacle(self.modelSca, self.modelSca, self.modelSca);
		self.modelEff:setLocation(self.modelPos.x, self.modelPos.y);
		self.modelEff:setUrl(self.urlStr, self.modelName);
		if self.bRegisterTimer ~= true and uiShowAction ~= nil then
			self.modelEff:setAction(uiShowAction);
		end
	else
		if self.modelEff ~= nil then
			self.modelEff:dispose();
			self.modelEff = nil;
		end
	end
end

-- 装扮背景
function Lua_ItemShowModelPanel:showFashionBgModel(id)
	local list = DataCenter.FashionData:getItem(id);
	self.bgData = list;

	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	self.bg = UICreate.createImage(self.content, "/images/fashionBg/tips_"..list.id..".png", self.bgPosX, self.bgPosY, self.bgWidth, self.bgHeight);
	self.bg.pivot = UIWidget.Pivot.Top;

	if self.myPlayerModel == nil then
		self.myPlayerModel = Lua_MyPlayerModel.new(self.modelSpr, self.bg);
		self.myPlayerModel:setLocation(0, -170, -300);
		self.myPlayerModel:setScale(0.8, 0.8, 0.8);
	end
	if self.magnifyBtn == nil then
		self.magnifyBtn = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_sousuo", -148, 175, 0, 0);
		self.magnifyBtn.name = "magnifyBtn";
		self.magnifyBtn:setDepth(3);
		self.magnifyBtn:addClickFuntion(self, self.onMagnifyBtnClick);
	end
end

function Lua_ItemShowModelPanel:onMagnifyBtnClick()
	Lua_WindowUtil.openWin("Lua_ItemDetailWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FasionBgShowWindow", WinParam.ACTION_OPEN, self.bgData);
end

function Lua_ItemShowModelPanel:setDepth(val)
	self:superCall("setDepth", val);

	self.showBg:setDepth(val);
	self.bg:setDepth(val + 2);
	if self.modelEff ~= nil then
		self.modelEff:setDepth(val + 5);
	end
	if self.diImg ~= nil then
		self.diImg:setDepth(val + 1);
	end
	if self.magnifyBtn ~= nil then
		self.magnifyBtn:setDepth(val + 3);
	end
end