Lua_ListCell = class("Lua_ListCell", Lua_DisplayObject);
function Lua_ListCell:ctor(p, skin)
	self.frameBuild = false;
	self:superCall("ctor",p, skin, false);
	self._selected = false;
end

function Lua_ListCell:checkSaveParam(key)
	if key == "onBuildingItem" or key == "checkSaveParam" or key == "saveFunKey" or key == "saveParam" or key == "setLocation" or key == "setBoxSize" then
		return false;
	end
	return self.skinBuilded == false;
end

function Lua_ListCell:setDragParant(p)
	self.dragParant = p;
end

function Lua_ListCell:setLocation(posx,posy,posz)
	self:superCall("setLocation", posx, posy, posz);

	self.itemX = posx;
	self.itemY = posy;
	self.minX = posx - self.boxW / 2;
	self.maxX = posx + self.boxW / 2;
	self.minY = posy - self.boxH / 2;
	self.maxY = posy + self.boxH / 2;
end

function Lua_ListCell:isBounds(posx, posy)
	if posx > self.minX and posx < self.maxX and posy > self.minY and posy < self.maxY then
		return true;
	end
	return false;
end

function Lua_ListCell:setBoxSize(boxW, boxH)
	self.boxW = boxW;
	self.boxH = boxH;
end

function Lua_ListCell:onPlayerSoundClick(go)
	--LuaUtil.senEvent(NotiConst.GUIDE_CLICK, self.content)
end

function Lua_ListCell:setData(data)
	
end

function Lua_ListCell:setCellSeqIndex(idx)
	self.cellSeqIndex = idx
	self.content.name = self.classname..tostring(self.cellSeqIndex);
end

function Lua_ListCell:checkOutBound(showRect)
	if self.whenInView ~= nil and self.setShowRect ~= nil then
		if self.setShowRect:intersects(showRect) == true then
			self:whenInView(true);
		else
			self:whenInView(false);
		end
	end
end

function Lua_ListCell:checkScale(p_pos, mpos, ox, oy, minScale, maxScale, distance)
	local left_x = self.maxX + p_pos.x - ox;
	local top_y = self.maxY + p_pos.y + oy;
	local d = math.abs(left_x - mpos.x);
	local v = d / distance;
	if v > 1 then
		self:setScale(minScale, minScale);
	else 
		local ms = minScale + (1 - v) * (maxScale - minScale);
		self:setScale(ms, ms);
	end
	return d;
end

function Lua_ListCell:onSelectionChange(val)
	self._selected = val;
end

function Lua_ListCell:dispose()
	self.dragParant = nil;
	self:superCall("dispose");
end

function Lua_ListCell.Get:selected()
	return self._selected;
end