-- 通用标签组件（类似“已击杀”，“已领取”等红绿底印章+文本显示的标记 可以用这个组件）
Lua_MarkItem = class("Lua_MarkItem", Lua_DisplayObject)
-- fontEffect  0:无效果，1：投影，2，描边，3：描边8
function Lua_MarkItem:ctor(p, bgAtlasName, bgSpriteName, showText, fontSize, fontColor, fontEffect, fontEffectColor, fontName)
    self.bgAtlasName = bgAtlasName == nil and "common_atlas_2" or bgAtlasName;
    self.bgSpriteName = bgSpriteName == nil and "" or bgSpriteName;
    self.showText = showText == nil and "" or showText;
    self.fontSize = fontSize == nil and 22 or fontSize;
    self.fontColor = fontColor == nil and Color.New(1, 1, 1, 1) or fontColor;
    self.fontEffect = fontEffect == nil and 0 or fontEffect;
    self.fontEffectColor = fontEffectColor == nil and nil or fontEffectColor;
    self.fontName = fontName == nil and Lua_MyUISettings.defaultFontName or fontName;
    self:superCall("ctor", p);
end

function Lua_MarkItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, self.bgAtlasName, self.bgSpriteName, 0, 0, 0, 0);
    self.bg:setDepth(self.depth + 1);

    self.label = UICreate.createLabel(self.content, self.showText, 0, 0, 100, 30, self.fontSize);
    self.label:setDepth(self.depth + 2);
    self.label.uiwidget.color = self.fontColor;
    self.label.effectStyle = self.fontEffect;
    self.label.pivot = UIWidget.Pivot.Center;
    self.label.fontName = self.fontName;
    self.label:setLocation(0, -2, 0);

    if self.fontEffectColor ~= nil then
        self.label.effectColorStr = self.fontEffectColor;
    end
end

function Lua_MarkItem:setDepth(val)
    self:superCall(val);
    self.bg:setDepth(val + 1);
    self.label:setDepth(val + 2);
end

-- 设置印章背景图大小
function Lua_MarkItem:setBgSize(sx, sy)
    if self.bg ~= nil then
        self.bg:SetDimensions(sx, sy);
    end
end

-- 设置印章背景图旋转角度
function Lua_MarkItem:setBgRotation(rx, ry, rz)
    if self.bg ~= nil then
        -- self.bg.mainContent.transform.localRotation = Quaternion.Euler(rx, ry, rz);
        LuaUtil.setObjRot(self.bg.mainContent, rx, ry, rz);
    end
end

-- 设置文本旋转角度
function Lua_MarkItem:setLabelRotation(rx, ry, rz)
    if self.label ~= nil then
        -- self.label.mainContent.transform.localRotation = Quaternion.Euler(rx, ry, rz);
        LuaUtil.setObjRot(self.label.mainContent, rx, ry, rz);
    end
end

-- 设置文本位置
function Lua_MarkItem:setLabelPos(px, py)
    --if self.label ~= nil then
        --self.label:setLocation(px, py, 0);
    --end
end

function Lua_MarkItem:setGray(val)
    self.bg:setGray(val);
    self.label:setGray(val);
end

-- 设置印章UI
function Lua_MarkItem:setBgAltas(str, atlasName)
    if atlasName == nil then
        atlasName = "common_atlas_2"
    end
    self.bg:setAltas(atlasName, str)
end

-- 设置文本TEXT
function Lua_MarkItem:setLabelText(str)
    self.label.text = str
end

function Lua_MarkItem:setActive(val)
    self.bg:setEnable(val);
    self.label:setEnable(val);
end