-- local rd = DataCenter.roleData;
-- local modelData = UsData();
-- modelData.career = rd.career;
-- modelData.gender = 1;
-- modelData.weapon_id = rd.weapon_id;
-- modelData.clothes_id = rd.clothes_id;
-- modelData.mount_id = rd.mount_id;
-- modelData.wingId = rd.wingId;
-- modelData.fairyId = rd.fairyId;
-- modelData.faqiId = rd.faqiId;
-- modelData.spoorId = rd.spoorId;
-- modelData.fashion_weapon_id = rd.fashion_weapon_id;
-- modelData.fashion_clothes_id = rd.fashion_clothes_id;
-- modelData.fashionHeadId = rd.fashionHeadId;
-- modelData.nickname = "";
-- modelData.hp = 1;
-- modelData.kind = 1;
-- modelData.IsUI = true;
-- modelData.curState:setState(4, true);

-- self.playerModel = Lua_ModelPlayer.new(self.content);
-- self.playerModel:init(Vector3(0,0,0), Vector3(0,0,0), modelData, 100);
-- self.playerModel:setRenderQueue(self.winBg, 5, 2);
-- self.playerModel:setRotEnable(true, 0,0,300,300);

Lua_ModelPlayer = class("Lua_ModelPlayer", Lua_DisplayObject);
function Lua_ModelPlayer:init(defaultPos, defaultRot, modelData, defaultScale)
	self.defaultRot = defaultRot;
	self.modelData = modelData;
	self.sca = defaultScale;
	self.isFirst = nil;
	self:setLocation(defaultPos.x, defaultPos.y,defaultPos.z);

	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	self.playerModel = UserPlayer(self.content);
	self.playerModel.parent = self.content;
	self.playerModel.data = modelData;
	self.playerModel.anData.IsUI = modelData.IsUI;
	self.playerModel:faceToCam();
	self.playerModel:loadBody();

	-- self.playerModel.root.transform.localEulerAngles = Vector3(defaultRot.x, defaultRot.y,defaultRot.z);
	-- self.playerModel.root.transform.localScale = Vector3(defaultScale, defaultScale, defaultScale);
	LuaUtil.setObjRot(self.playerModel.root, defaultRot.x, defaultRot.y, defaultRot.z);
	LuaUtil.setObjScale(self.playerModel.root, defaultScale, defaultScale, defaultScale);

	self:addTimer("Lua_ModelPlayer", 0.01, self, self.onEnterFrame);
end

function Lua_ModelPlayer:setRotEnable(val, px, py, width, height, depth)
	if val == true then
		if self.rotBg == nil then
			self.rotBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 0, 0);
			self.rotBg.name = "rotBg";
			self.rotBg.alpha = 0.01;
			self.rotBg.depth = depth;
		end
		self.rotBg:SetDimensions(width, height);
		self.rotBg:setLocation(px, py);

		if self._rotEnable ~= val then
			self.rotBg:addClickFuntion(self, self.onMouseDown);
			self.rotBg:addMouseUpFuntion(self, self.onMouseUp);
		end
	else
		if self.rotBg ~= nil then
			self.rotBg:removeClickFuntion(self, self.onMouseDown);
			self.rotBg:removeClickFuntion(self, self.onMouseUp);
			self.rotBg:clearListener();
		end
	end
	self._rotEnable = val;
end

function Lua_ModelPlayer:onMouseDown(go)
	if self.playerModel == nil or self.playerModel.avatar == nil then
		return;
	end

	if self.isRotStart == nil or self.isRotStart == false then
		self.isRotStart = true;
		self.startPos = UnityEngine.Input.mousePosition.x;
		self.startRot = self.playerModel.root.transform.localEulerAngles.y;
		self:addTimer("Lua_ModelPlayer_modelRot", 0.003, self, self.onModelRoting);
	end
end

function Lua_ModelPlayer:onMouseUp(go)
	if self.isRotStart == true then
		self.isRotStart = false;
		Lua_CommonUtil.removeTimer(self, self.onModelRoting);
	end
end

function Lua_ModelPlayer:setRenderQueue(sc, offset, sortType)
	if sc == nil or sc.widget == nil then
		return;
	end
	self.widget = sc.widget;
	self.offset = offset;
	self.sortType = sortType;
	self.isResetQueue = true;
end

function Lua_ModelPlayer:onModelRoting()
	local dt = UnityEngine.Input.mousePosition.x - self.startPos;
	local trot = self.startRot - dt;
	-- self.playerModel.root.transform.localEulerAngles = Vector3(0, trot, 0);
	LuaUtil.setObjRot(self.playerModel.root, self.defaultRot.x, trot, self.defaultRot.z);
end

-- function Lua_ModelPlayer.Get:finalRenderQueue()
-- 	if self.widget ~= nil and self.widget.drawCall ~= nil then
-- 		self.renderQueue = self.widget.drawCall.finalRenderQueue + self.offset;
-- 	else
-- 		return 0;
-- 	end
-- 	return self.renderQueue;
-- end

function Lua_ModelPlayer:onEnterFrame()
	if self.playerModel == nil or self.playerModel.avatar == nil then
		return;
	end

	if self.isFirst == nil and self.mount_id ~= nil and self.mount_id ~= 0 then
		local objTransForm = ContainerUtil.findBoneTransform(self.playerModel.root.transform, self.mount_id.."");
		if objTransForm ~= nil then
			self.isFirst = true;
			-- objTransForm.localScale = Vector3(1, 1, 1);
			LuaUtil.setTfScale(objTransForm, 1, 1, 1);
		end
	end
	self:resetQueue();
	-- self:resetScale();
	self:resetLayer();
end

function Lua_ModelPlayer:resetLayer()
	if self.layerTime == nil or getTime() - self.layerTime > 1 then
		self.layerTime = getTime();
		EffectUitl.transLayer(self.playerModel.root, 5);
	end
end

function Lua_ModelPlayer:resetScale()
	EffectUitl.setParticleScaleMode(self.playerModel.root, true);
end

function Lua_ModelPlayer:resetQueue()
	EffectUitl.setObjRenderQueue(self.playerModel.root, self.widget, self.offset, self.sortType);
	-- if self.widget == nil or self.widget.drawCall == nil then
	-- 	return;
	-- end

	-- local frq = self.finalRenderQueue;
	-- if frq == 0 then
	-- 	return;
	-- end

	-- local materials = Array();
	-- local inList = {};
	-- local listQueue = Array();
	-- local renderers = self.playerModel.root:GetComponentsInChildren(typeof(UnityEngine.Renderer));
	-- local len = renderers.Length - 1;
	-- for i = 0, len do
	-- 	local mts = renderers[i].materials;
	-- 	local mlen = mts.Length - 1;
	-- 	for j = 0,mlen do
	-- 		materials:add(mts[j]);
	-- 		local tmpQueue = mts[j].renderQueue;
	-- 		if inList[tmpQueue] == nil then
	-- 			inList[tmpQueue] = 1;
	-- 			listQueue:add({q = tmpQueue});
	-- 		end
	-- 	end
	-- end
	-- listQueue:sort("q", false);

	-- local dicQueue = {};
	-- for i = 1, listQueue:getSize() do
	-- 	dicQueue[listQueue[i].q] = i;
	-- end

	-- local f;
	-- for i = 1, materials:getSize() do
	-- 	f = frq + dicQueue[materials[i].renderQueue];
	-- 	materials[i].renderQueue = f;
	-- end
end

function Lua_ModelPlayer:dispose()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.rotBg ~= nil then
		self.rotBg:dispose();
		self.rotBg = nil;
	end

	self:superCall("dispose");
end