Lua_MoneyItem = class("Lua_MoneyItem", Lua_DisplayObject);
function Lua_MoneyItem:ctor(p)
	self:superCall("ctor", p, "MoneyItem_skin", true);
end
function Lua_MoneyItem:buildShowItem()
	self:superCall("buildShowItem");
	self.moneyAddSp:addClickFuntion(self, self.onMoneyAddClick);
	self:addLuaEvent("MONEY_UPDATE", self, self.onMoneyUpdate);
end
function Lua_MoneyItem:onMoneyAddClick(val)
	if self.moneyType == Lua_MoneyData.GOLD then
		if Lua_WindowUtil.isWindowShowing("Lua_ChongzhiWindow") == true and DataCenter.rechargeData.selectNum==1 then
			OperateAlert.show(LanUtil.getValue(122575));
		else
			Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN,1);
		end
	elseif self.moneyType == Lua_MoneyData.JEWEL and getLanType() == 1 then -- 韩服
		Lua_WindowUtil.openWin("Lua_ExchangeJewelWindow", WinParam.ACTION_OPEN);
	else
		local arr = Array();
        arr:add(Lua_ToolVo.new(self.moneyType, 1, 1));
        Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end
function Lua_MoneyItem:setMoneyType(val)
	self.moneyType = val;
	self:onMoneyUpdate(nil);
	self.moneyIcon:setAltas(Lua_MoneyData.getMoneyIconAtlas(val), Lua_MoneyData.getIconSpByMoneyType(val));
	-- self.moneyIcon:setAltas("icon_atlas_3","money_209000004");
	self.moneyIcon:resetSize();
	self.moneyAddSp:setEnable(true);
end
function Lua_MoneyItem:onMoneyUpdate(obj)
	if self.moneyType ~= nil then
		if getLanType() == 1 and self.moneyType == Lua_MoneyData.GOLD then
			self.moneyTxt.text = Lua_CommonUtil.trnsLongNum(DataCenter.moneyData:getMoney(self.moneyType));	
		else
			self.moneyTxt.text = Lua_CommonUtil.getNumberTrans(DataCenter.moneyData:getMoney(self.moneyType), 100000000);
		end
	end
end
function Lua_MoneyItem:setDepth(val)
	self:superCall("setDepth", val);
	if self.moneyBg ~= nil then self.moneyBg:setDepth(val) end;
	if self.moneyAddSp ~= nil then self.moneyAddSp:setDepth(val+1) end;
	if self.moneyIcon ~= nil then self.moneyIcon:setDepth(val+1) end;
	if self.moneyTxt ~= nil then self.moneyTxt:setDepth(val+1) end;
end

function Lua_MoneyItem:replaceSpecialBgAtlas(isSpecial)
	if isSpecial == true then
		self.moneyBg:setAltas("iconantlas4","special_frst_resource");
		self.moneyAddSp:setAltas("iconantlas4","special_frst_add");
		self.moneyAddSp:SetDimensions(42, 42);
	else
		self.moneyAddSp:SetDimensions(46, 46);
	end
end