Lua_MyPlayerModel = class("Lua_MyPlayerModel", Lua_DisplayObject);
function Lua_MyPlayerModel:ctor(p, depthTxt, defaultPos, defaultRot, defaultScale, modelType, canRot)
	self.depthTxt = depthTxt;
	self.defaultPos = defaultPos == nil and Vector3(0, 0, 0) or defaultPos;
	self.defaultRot = defaultRot == nil and Vector3(0, 90, 0) or defaultRot;
	self.defaultScale = defaultScale == nil and 200 or defaultScale;
	self.modelType = modelType == nil and 1 or modelType;
	self.canRot = canRot == nil and true or canRot;
	self:superCall("ctor", p);
end

function Lua_MyPlayerModel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_MyPlayerModel";

	self:addLuaEvent("PLAYER_MODEL_UPDATE", self, self.onModelUpdate);
	self:onModelUpdate();
end

function Lua_MyPlayerModel:onModelUpdate(o)
	local rd = DataCenter.roleData;
	self.modelData = UsData();
	self.modelData.roleId = rd.roleId;
	self.modelData.career = rd.career;
	self.modelData.gender = 1;
	self.modelData.weapon_id = rd.weapon_id;
	self.modelData.clothes_id = rd.clothes_id;
	self.modelData.mount_id = rd.mount_id;
	self.modelData.wingId = rd.wingId;
	self.modelData.fairyId = rd.fairyId;
	self.modelData.faqiId = rd.faqiId;
	self.modelData.spoorId = rd.spoorId;
	self.modelData.fashion_weapon_id = rd.fashion_weapon_id;
	self.modelData.fashion_clothes_id = rd.fashion_clothes_id;
	self.modelData.fashionHeadId = rd.fashionHeadId;
	self.modelData.nickname = "";
	self.modelData.hp = 1;
	self.modelData.kind = 1;
	self.modelData.isShowName = false;
	self.modelData.IsUI = true;

	self:updateModel();
end

function Lua_MyPlayerModel:updateModel()
	if self.playerModel == nil then
		self.playerModel = ModelPlayer();
	end
	self.playerModel:init(self.content, self.defaultPos, self.defaultRot, self.modelData, nil, self.defaultScale);
	self.playerModel:setRotEnable(self.canRot, 0, 200, 900, 400, 2);
	self.playerModel:SetRenderQueue(self.depthTxt, 0, 2);

	if (self.modelType == 2) then
		if self.modelTexture == nil then
			self.modelTexture = UIModelTexture();
			local imgPos = Vector2(-3, 168);
			local imgSize = Vector2(670, 661);
			self.modelTexture:init(self.content, imgPos, imgSize, self.depthTxt.depth);
		end
	end
end

function Lua_MyPlayerModel:setAction(val)
	if self.playerModel ~= nil then
		self.playerModel:setAction(val);
	end
end

function Lua_MyPlayerModel:setDir(val)
	if self.playerModel ~= nil then
		self.playerModel:setDir(val);
	end
end

function Lua_MyPlayerModel:dispose()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	self:superCall("dispose");
end