Lua_NumberImage = class("Lua_NumberImage", Lua_DisplayObject);
function Lua_NumberImage:ctor(p)
	self.list = Array();
	self._num = 0;
	self._minFix = 0;
	self.numWidth = 18;
	self.prefix = "";
	self.lastStr = "";
	self.lastWidth = 20;
	self._pivot = 1;
	self.numAtlas = "number_atlas";
	self:superCall("ctor", p);
	self.width = 0;
end

function Lua_NumberImage.Get:num()
	return self._num;
end

function Lua_NumberImage.Set:num(val)
	self._num = val;
	self._addIcon = nil;
	self:update();
end

function Lua_NumberImage.Set:pivot(val)
	self._pivot = val;
end

function Lua_NumberImage:setMinFix(val)
	self._minFix = val <= 1 and 1 or val;
end

function Lua_NumberImage:setAddIcon(str)
	self._addIcon = str;
	self:update();
end

function Lua_NumberImage:update()
	local str = tostring(self._num);
	if self._addIcon ~= nil then
		str = self._addIcon;
	end

	while string.len(str) < self._minFix do
		str = "0"..str;
	end

	for i = 1, self.list:getSize() do
		self.list[i]:setEnable(false);
	end

	local len = string.len(str);
	local w = self.lastStr == "" and self.numWidth * len or self.numWidth * len + self.lastWidth;
	if self._pivot == 1 then
		w = 0;
	elseif self._pivot == 2 then
		w = - w / 2 + self.numWidth / 2;
	else
		w = -w;
	end

	local singleStr;
	local icon;
	for i = 1, len do
		singleStr = string.sub(str, i, i);
		if singleStr == "." then
			singleStr = "point";
		elseif singleStr == "+" then
			singleStr = "+";
		end

		icon = self:getOneSprite(i);
		icon.depth = self.depth;
		icon:setAltas(self.numAtlas, self.prefix .. singleStr);
		icon:setLocation(w + self.numWidth * (i - 1), 0, 0);
		icon:resetSize();
		icon:setEnable(true);
	end

	if self.lastStr ~= "" then
		icon = self:getOneSprite(len + 1);
		icon.depth = self.depth;
		icon:setAltas(self.numAtlas, self.prefix .. self.lastStr);
		icon:setLocation(w + self.numWidth * (len - 1) + self.lastWidth, 0, 0);
		icon:resetSize();
		icon:setEnable(true);
	end
	self.width = self.lastStr == "" and self.numWidth * len or self.numWidth * len + self.lastWidth;
end

function Lua_NumberImage:getOneSprite(count)
	if self.list:getSize() >= count then
		return self.list[count];
	end
	local sp = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.list:add(sp);
	return sp;
end

function Lua_NumberImage:setDepth(val)
	self:superCall("setDepth", val);

	self.depth = val;
	for i = 1, self.list:getSize() do
		self.list[i].depth = val;
	end
end

function Lua_NumberImage:getRenderObj()
	if self.list ~= nil and self.list:getSize() then
		return self.list[1];
	end
	return nil;
end

function Lua_NumberImage:setAlpha(val)
	for i = 1, self.list:getSize() do
		self.list[i].alpha = val;
	end
end

function Lua_NumberImage:setNumGray(val)
	for i = 1, self.list:getSize() do
		self.list[i]:setGray(val);
	end
end

function Lua_NumberImage:setNumScale(scale1, scale2)
	for i = 1, self.list:getSize() do
		self.list[i]:setScale(scale1, scale2, 1);
	end
end

function Lua_NumberImage:setNumEnable(val)
	local str = tostring(self._num);
	for i = 1, string.len(str) do
		self.list[i]:setEnable(val);
	end
end