Lua_NumberInputItem =class("Lua_NumberInputItem",Lua_DisplayObject)
function Lua_NumberInputItem:ctor(p)
	self.num = 1;
	self:superCall("ctor", p, "NumberInput_skin");
end

function Lua_NumberInputItem:buildShowItem()
	self:superCall("buildShowItem");

	self.addSp:addClickFuntion(self, self.onAddClick);
	self.add10Sp:addClickFuntion(self, self.onAdd10Click);
	self.subSp:addClickFuntion(self, self.onSubtractionClick);
	self.numBg:addClickFuntion(self, self.onShowNumberWindow);
end

function Lua_NumberInputItem:setMinMaxValue(minNum, maxNum)
	self.maxNum = maxNum;
	self.minNum = minNum == nil and 1 or minNum;
end

function Lua_NumberInputItem:onAddClick(go)
	self.num = self.num + 1;
	self:setNum(self.num);
end

function Lua_NumberInputItem:onAdd10Click(go)
	self.num = self.num + 10;
	self:setNum(self.num);
end

function Lua_NumberInputItem:onSubtractionClick(go)
	self.num = self.num - 1;
	self:setNum(self.num);
end

function Lua_NumberInputItem:setNum(val)
	self.num = val;
	if self.num <= self.minNum then
		self.num = self.minNum;
	end

	if self.num > self.maxNum then
		self.num = self.maxNum;
	end

	self.numTxt.text = tostring(self.num);
	if self.callBack ~= nil then
		self.callBack(self.owner, self.num);
	end
end

function Lua_NumberInputItem:setDepth(val)
	self:superCall("setDepth", val);

	self.subSp:setDepth(val + 1);
	self.numBg:setDepth(val);
	self.numTxt:setDepth(val + 1);
	self.addSp:setDepth(val + 1);
	self.add10Sp:setDepth(val + 1);
	self.add10SpTxt:setDepth(val + 2);
end

function Lua_NumberInputItem:setWindowOffset(px, py)
	self.px = px;
	self.py = py;
end

function Lua_NumberInputItem:setAddTen(val)
	self.add10Sp:setEnable(val);
	self.add10SpTxt:setEnable(val);
end

function Lua_NumberInputItem:onShowNumberWindow(go)
	self.numArr = Array();
	local list = {};
	list.pox = self.px == nil and 0 or self.px;
	list.poy = self.py == nil and 0 or self.py;
	list.callBackOwner = self;
	list.callBack = self.onInputClick;
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, list);
end

function Lua_NumberInputItem:onInputClick(data)
	if data.state == 1 then
		self.numArr:add(data.num);
		local str = "";
		for i=1,self.numArr:getSize() do
			str = str..self.numArr[i];
		end
		self:setNum(tonumber(str));
	elseif data.state == 0 then
		self:setNum(0);
		self.numArr:clear();
	end
end

function Lua_NumberInputItem:setNumCallBack(owner,callBack)
	self.owner = owner;
	self.callBack = callBack
end

function Lua_NumberInputItem:dispose()
	self.owner = nil;
	self.callBack = nil;
	
	self:superCall("dispose");
end