Lua_OutTimeItem = class("Lua_OutTimeItem",Lua_DisplayObject)
function Lua_OutTimeItem:ctor(p, timeColor)
	if timeColor == nil then
		self.timeColor = Lua_ColorDefine.GREEN_STR;
	else
		self.timeColor = timeColor;
	end
	self:superCall("ctor", p, "OutTimeItem_skin")
end

function Lua_OutTimeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.plusBtn:addClickFuntion(self, self.onAddPlusClick);

	self:addLuaEvent("OUT_LINE_TIME", self, self.onOutLineTime);
	sendMsg(11404303);
end

function Lua_OutTimeItem:setDepth(val)
	self:superCall("setDepth", val);

	self.countingTxt:setDepth(val);
	self.label:setDepth(val);
	self.plusBtn:setDepth(val + 1);
end

function Lua_OutTimeItem:onOutLineTime(o)
	local h = math.floor(o.total_time / 3600);
	local m = math.floor((o.total_time - h * 3600) / 60);
	local str = "";
	if m == 0 then
		str = h..LanUtil.getValue(44);
	elseif h == 0 and m ~= 0 then
		str = m..LanUtil.getValue(25);
	else
		str = h..LanUtil.getValue(44)..m..LanUtil.getValue(25);
	end

	self.countingTxt.text = "["..self.timeColor.."]"..str.."[-]";
	local posX = self.countingTxt.mainContent.transform.localPosition.x + self.countingTxt.width + 33;
	self.plusBtn:setLocation(posX, -172);
	self:showEffect(o.total_time <= 0, posX);
end

function Lua_OutTimeItem:onAddPlusClick(go)
	if DataCenter.funcOpenData:isOpened(10030) == false then
		local s = getConfig({"func_open", 10030, "advance_message"});
		if s ~= nil then
			OperateAlert.show(s);
		end
		return;
	end
	Lua_WindowUtil.openWin("Lua_OutLineAddWindow");
end

function Lua_OutTimeItem:showEffect(val, posX)
	if val == true then
		if self.hangEffect == nil then
			self.hangEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_guajishijian", "gui_guajishijian", 0, 0);
			self.hangEffect:setLoop(true);
			self.hangEffect:SetRenderQueue(self.label, 11, 2, false);
		end
		self.hangEffect:setLocation(posX, -172, 0);
		self.hangEffect:setEnable(true);
	else
		if self.hangEffect ~= nil then
			self.hangEffect:setEnable(false);
		end
	end
end