Lua_PetBasicPanel = class("Lua_PetBasicPanel", Lua_DisplayObject);
function Lua_PetBasicPanel:ctor(p)
	self._skillInfoList = nil;
	self._itemInfoList = nil;
	self._modelList = nil;
	self._commonData = nil;
	self._curStage = 1;
	self.curModelIndex = 1;
	self.curModelId = 1;
	self.isFirstTime = true;
	self.isUsing = false;
	self.isAdvancing = false;
	self.autoCheck = false
	self.isShowItemOutPutWindow = false;

	self:superCall("ctor", p, "PetPanel_skin");
end

function Lua_PetBasicPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:initPanel();

	if self.modelType == 1 then
		self.rootPos = self.modelTexture.root.transform.localPosition;
		self.rootRot = self.modelTexture.root.transform.localEulerAngles;
		self.rootSca = self.modelTexture.root.transform.localScale;
		self.effectPos = self.modelTexture.uiEffect.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.uiEffect.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.uiEffect.mainContent.transform.localScale;
	elseif self.modelType == 2 then
		self.effectPos = self.modelTexture.mainContent.transform.localPosition;
		self.effectRot = self.modelTexture.mainContent.transform.localEulerAngles;
		self.effectSca = self.modelTexture.mainContent.transform.localScale;
	end

	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);-- 图标红点更新
	self:addLuaEvent("UPDATE_PET_PANEL_RED_DOT", self, self.updateRedDot);-- 图标红点更新
	self:addLuaEvent("PACK_UPDATE", self, self.updataItemToolImage);
end

function Lua_PetBasicPanel:initPanel()
	-- 自动进阶时，不允许玩家进行操作，2022/5/10：修改需求，不做处理
	self.mask = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_zhezhao", 0, 0, 2000, 2000);
	self.mask.name = "mask";
	self.mask.alpha = 0.01;
	self.mask:setDepth(10);
	self.mask:addClickFuntion(self, self.onMaskClick);
	self.mask:setEnable(false);

	self.petStateTxt:setEnable(false);

	self.increaseAttackObj:SetActive(false);
	self.increaseHitObj:SetActive(false);
	self.increaseDefenceObj:SetActive(false);
	self.increaseCritObj:SetActive(false);

	self.prevBtn.clickScale = false;
	self.nextBtn.clickScale = false;
	self.prevBtn:addClickFuntion(self, self.onPrevBtn);
	self.nextBtn:addClickFuntion(self, self.onNextBtn);

	self.commonBtn1:addClickFuntion(self, self.onCommonBtn1);
	self.commonBtn3:addClickFuntion(self, self.onCommonBtn3);
	self.yinCangCheckBox:addBoxChange(self, self.yinCangCheckBoxClick);

	self.rightBtn1:addClickFuntion(self, self.onRightBtn1);
	self.rightBtn2:addClickFuntion(self, self.onRightBtn2);

	self.skillBtnList = Array();
	self.skillBtnList:add({bg = self.skillBg1, skill = self.skill1});
	self.skillBtnList:add({bg = self.skillBg2, skill = self.skill2});
	self.skillBtnList:add({bg = self.skillBg3, skill = self.skill3});
	self.skillBtnList:add({bg = self.skillBg4, skill = self.skill4});
	self.skillBtnList:add({bg = self.skillBg5, skill = self.skill5});

	for i = 1, self.skillBtnList.getSize() do
		self.skillBtnList[i].skill.clickScale = false;
		self.skillBtnList[i].skill.mainContent:SetActive(false);
		self.skillBtnList[i].skill:addClickFuntion(self, self.onSkill);
		self.skillBtnList[i].skill:addMouseUpFuntion(self, self.onSkillRelease);
	end

	self.itemBtnList = Array();
	self.itemBtnList:add({bg = self.itmeBg1, item = self.item1, arrow = self.itemArrow1, num = self.itemNum1, count = self.countTxt1});
	self.itemBtnList:add({bg = self.itmeBg2, item = self.item2, arrow = self.itemArrow2, num = self.itemNum2, count = self.countTxt2});
	self.itemBtnList:add({bg = self.itmeBg3, item = self.item3, arrow = self.itemArrow3, num = self.itemNum3, count = self.countTxt3});
	for i = 1, self.itemBtnList.getSize() do
		self.itemBtnList[i].item.clickScale = false;
		self.itemBtnList[i].item:addClickFuntion(self, self.onItem);
		self.itemBtnList[i].item:addMouseUpFuntion(self, self.onItemRelease);
		self.itemBtnList[i].item:setEnable(false);
		self.itemBtnList[i].arrow:SetActive(false);

		self.arrowUpIcon = UICreate.createUIAtlasImage(self.itemBtnList[i].arrow, "common_atlas_1", "ui_common_xjt_02", 0, 0, 0, 0);
		self.arrowUpIcon.name = "arrowUpIcon";
		self.arrowUpIcon:setDepth(10);
	end

	self.fightNum = Lua_NumberImage.new(self.rightObj);
	self.fightNum.numWidth = 13;
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(285, 235, 0);

	self.huanXing_Mark = Lua_MarkItem.new(self.content, "common_atlas_2", "ui_common_tishi", LanUtil.getValue(110258), 20, Color.New(1, 1, 1, 1), 0, Lua_ColorDefine.transColor("ffffff"));
	self.huanXing_Mark:setDepth(self.depth + 10);
	self.huanXing_Mark:setLocation(-69, -38, 0);
	self.huanXing_Mark:setEnable(true);

	self:initModelTexture();
	self:setExpBarValue(0, 0, "", "");

	self.starList = Array();
	self.starList:add(self.star_01);
	self.starList:add(self.star_02);
	self.starList:add(self.star_03);
	self.starList:add(self.star_04);
	self.starList:add(self.star_05);
	self.starList:add(self.star_06);
	self.starList:add(self.star_07);
	self.starList:add(self.star_08);
	self.starList:add(self.star_09);
	self.starList:add(self.star_10);

	self.itemImg = Lua_ToolImage.new(self.itemObj);
	self.itemImg:setDepth(10);

	self.upgradeDescTxt.text = "";

	if self.isNeedUpgradeDescTxt then
		self.dragHeight = 150;
		self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 420, 150));
		self.dragContainer:setLocation(272, 90, 0);
		self.petAttrPanel = Lua_PetAttrPanel.new(self.content);
		self.dragContainer:addSubContainer(self.petAttrPanel, true);
	else
		self.dragHeight = 130;
		self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 420, 130));
		self.dragContainer:setLocation(272, 104, 0);
		self.petAttrPanel = Lua_PetAttrPanel.new(self.content);
		self.dragContainer:addSubContainer(self.petAttrPanel, true);
	end
end

function Lua_PetBasicPanel:updateAutoInfo()
	-- 这个方法目前只适合侍宠系统调用servantData 写死
	if self.AutoCheckBoxBg == nil then
		local iconName = "ui_common_widget_gouxuan2"
		self.auto_up = 0
		self.panelClickIndex = -1;
		if self.classname == "Lua_MountPanel" then
			self.auto_up = Lua_MountData.AUTO_UP
			Lua_MountData.AUTO_CHECK = Lua_MountData.AUTO_UP == 1;
		else
			self.auto_up = Lua_ServantData.AUTO_UP
			Lua_ServantData.AUTO_CHECK = Lua_ServantData.AUTO_UP == 1;
		end

		if self.auto_up == 1 then
			self.autoCheck = true
			iconName = "ui_common_widget_gouxuan"
		else
			self.autoCheck = false
			iconName = "ui_common_widget_gouxuan2"
		end
		self.AutoCheckBoxBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", iconName, 72.5, -210.5, 0, 0);
		self.AutoCheckBoxBg.name = "AutoCheckBoxBg";
		self.AutoCheckBoxBg:setDepth(10);
		self.AutoCheckBoxBg:addClickFuntion(self, self.onAutoCheckBox);

		self.tipsTxt = UICreate.createLabel(self.content, "", 94, -212.5, 400, 30, 22);
		self.tipsTxt.name = "tipsTxt";
		self.tipsTxt.pivot = UIWidget.Pivot.Left;
		self.tipsTxt.text = "[85A8BE]" .. LanUtil.getValue(110547) .. "[-]";
		self.tipsTxt:setDepth(10);
	end
end

function Lua_PetBasicPanel:onAutoCheckBox()
	local auto_check = false
	if self.classname == "Lua_MountPanel" then
		Lua_MountData.AUTO_CHECK = not Lua_MountData.AUTO_CHECK
		auto_check = Lua_MountData.AUTO_CHECK
		Lua_MountData.AUTO_UP = auto_check == true and 1 or 0
	else
		Lua_ServantData.AUTO_CHECK = not Lua_ServantData.AUTO_CHECK
		auto_check = Lua_ServantData.AUTO_CHECK
		Lua_ServantData.AUTO_UP = auto_check == true and 1 or 0
	end

	self.autoCheck = auto_check;
	if auto_check == true then
		self.AutoCheckBoxBg:setAltas("common_atlas_1", "ui_common_widget_gouxuan")
	else
		self.AutoCheckBoxBg:setAltas("common_atlas_1", "ui_common_widget_gouxuan2")
	end
end

function Lua_PetBasicPanel:showNewFeatureWin()
	Lua_MsgUtil.callFunc("HIDE_PET_OR_FEATURE_WIN", {modelType = self.modelType, animType = self.animType, featureData = self.commonData, panelName = self.content.name});
end

function Lua_PetBasicPanel:initModelTexture()
	if self.modelType == nil then
		return;
	elseif self.modelType == 1 then
		local imgPos;
		if self.isChange then
			imgPos = Vector2(-45, -34);
		elseif self.isMountPos then
			imgPos = Vector2(-83, 61);
		else
			imgPos = Vector2(-83, -34);
		end
		local imgSize = Vector2(1175, 680);
		local modelRot = Vector3(0, 180, 0);
		local modelOffset = Vector2(0, -406);
		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 360);
		self.modelTexture:setRotEnable(true, -228, 71, 665, 400, 2);
	elseif self.modelType == 2 then
		self.modelTexture = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
		self.modelTexture:SetRenderQueue(self.bg, -1, 2);
		self.modelTexture:setLocation(-305, -126, -200);
		self.modelTexture:setRot(0, 0, 0);
		self.modelTexture:setSacle(260, 260, 260);
	end
end

function Lua_PetBasicPanel.Get:commonData()
	return self._commonData;
end

function Lua_PetBasicPanel.Set:commonData(val)
	if val == nil then
		return;
	end
	self._commonData = val;

	local servantData = val;
	if self.stage == nil then
		self.stage = servantData.stage;
	elseif self.stage < servantData.stage then
		self:showNewFeatureWin();
		return;
	end

	self:updateRightBtn1();
	local isShowBtn = getConfig({"func_open", 10087, "advance_function" });
	local isFuncOpened = DataCenter.funcOpenData:isOpened(10087);

	if isFuncOpened then
		self.commonBtnObj1:SetActive(true);
		self.commonBtn1:setAltas("icon_atlas_1", "ui_icon_huanhua");
	else
		if isShowBtn == 1 then
			self.commonBtnObj1:SetActive(true);
			self.commonBtn1:setAltas("icon_atlas_1", "ui_icon_huanhua_s");
		else
			self.commonBtnObj1:SetActive(false);
		end
	end

	self.modelList = servantData:getServantShapeList();
	local usingIndex = servantData.usingIndex;
	local len = self.modelList:getSize();
	if usingIndex == 0 and self.isFirstTime == true then
		if servantData.stage > len then
			self:showModelByIndex(len);
		else
			self:showModelByIndex(servantData.stage);
		end
	elseif usingIndex == 0 and self.isFirstTime == false then
		self:showModelByIndex(self.curModelIndex);
	else
		self:showModelByIndex(usingIndex);
	end

	self.fightNum.num = servantData.force;
	self:setStageText(servantData.stage, servantData.starLvl);
	self:setStars(servantData.starLvl);

	self:updataItemToolImage();

	local maxLvlExp;
	if servantData.isMaxLvl == 1 then
		maxLvlExp = servantData:getMaxExp();
		local beyondNum = servantData.evolutionExp - maxLvlExp;
		if beyondNum > 0 then
			beyondNumText = LanUtil.getValue(110510);
		else
			beyondNumText = "";
		end
		self:setExpBarValue(maxLvlExp, maxLvlExp, LanUtil.formateStr(LanUtil.getValue(110509) .. beyondNumText, tostring(beyondNum)));
	elseif servantData.isMaxLvl == 0 then
		maxLvlExp = servantData:getMaxExp(servantData.evolutionLvl);
		self:setExpBarValue(servantData.evolutionExp, maxLvlExp);
	end

	self.skillInfoList = servantData.skillVoList

	-- 影藏原来的属性文本
	self.attackObj:SetActive(false);
	self.hitObj:SetActive(false);
	self.defenceObj:SetActive(false);
	self.critObj:SetActive(false);
	self:updateAttrPanel();
	self:updateRedDot();
	self.isFirstTime = false;
end

function Lua_PetBasicPanel:updateAttrPanel()
	local arr = Array();
	for i = 1, self.commonData.curAttrArr:getSize() do
		arr:add({curAttr = self.commonData.curAttrArr[i], nextAttr = self.commonData.nextAttrArr[i], isMount = self.isNeedUpgradeDescTxt});
	end

	self.petAttrPanel:setData(arr);
	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = self.petAttrPanel:getHeight() > self.dragHeight;
end

function Lua_PetBasicPanel:setStars(num)
	num = math.floor(num);
	if self.starList == nil and (num < 0 or num > 10) then
		return;
	end

	if num ~= 0 then
		for i = 1, num do
			self.starList[i]:setAltas("common_atlas_1", "ui_common_xing_01");
		end
	end

	if num ~= 10 then
		for i = num + 1, self.starList:getSize() do
			self.starList[i]:setAltas("common_atlas_1", "ui_common_xing_02");
		end
	end
end

function Lua_PetBasicPanel:updataItemToolImage()
	if self._commonData == nil then
		return;
	end

	local itemInfo = self._commonData:getEvoItemList(self._commonData.evolutionLvl);
	local itemId = itemInfo[1];
	local needNum = itemInfo[2];
	local itemNum = DataCenter.packData:getBagType(2):getItemNum(itemId);
	self:setItemData(itemId, itemNum, needNum);

	self.itemInfoList = self._commonData.panaceaToolVoList;
end

function Lua_PetBasicPanel:setItemData(id, num, needNum)
	self.itemImg.data = Lua_ToolVo.new(id, num);
	self.itemImg:showNumLimit(num, needNum, 2);

	self.itemNumDic = {};
	self.itemNumDic.num = num;
	self.itemNumDic.needNum = needNum;
end

function Lua_PetBasicPanel:onIconClick(go)
	if self.itemImg.data == nil then
		return;
	end

	if self.itemNumDic == nil or self.itemNumDic.num >= self.itemNumDic.needNum then
		Lua_PackUtil.showItemInfo(self.itemImg.data);
	else
		local arr = Array();
		arr:add(self.itemImg.data);
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
	end
end

function Lua_PetBasicPanel.Set:skillInfoList(val)
	self._skillInfoList = val;
	if self.skillBtnList == nil or val:getSize() == 0 then
		return;
	end

	for i = 1, self.skillBtnList.getSize() do
		self.skillBtnList[i].skill.mainContent:SetActive(true);
		self.skillBtnList[i].skill:setAltas(val[i].atlasName, val[i].iconName);
		self.skillBtnList[i].isActivated = val[i].isActivated;

		if val[i].isActivated == true then
			self.skillBtnList[i].skill.color = Color.New(1, 1, 1, 1);
		else
			self.skillBtnList[i].skill.color = Color.New(0, 1, 1, 1);
		end

		self.skillBtnList[i].bg.mainContent:SetActive(val[i].isShowSkill);
		self.skillBtnList[i].skill.mainContent:SetActive(val[i].isShowSkill);
	end
end

function Lua_PetBasicPanel:setItemImage(widget, atlas, spName)
	if atlas ~= nil and spName ~= nil then
		widget:setDefault("item1", "default_item");
		widget:setAltas(atlas, spName);
		widget:setEnable(true);
	else
		widget:setEnable(false);
	end
end

function Lua_PetBasicPanel.Set:itemInfoList(val)
	self._itemInfoList = val;
	if self.itemBtnList == nil then
		return;
	end

	local itemNum;
	local limit;
	local stage;
	local index = 1;
	for i = 1, self.itemBtnList:getSize() do
		self:setItemImage(self.itemBtnList[i].item, val[i].atlas, val[i].referenceId);
		self.itemBtnList[i].num.text = val[i].count;
		itemNum = DataCenter.packData:getBagType(2):getItemNum(val[i].id);
		if itemNum ~= 0 then
			self.itemBtnList[i].count.text = "+" .. itemNum;
		else
			self.itemBtnList[i].count.text = "";
		end

		limit = val[i].cond.limit;
		stage = val[i].cond.stage;
		val[i].itemNum = itemNum
		if itemNum > 0 and val[i].count < limit and self.commonData.stage >= stage then
			index = i;
			val[i].isCanUse = true;
			self.itemBtnList[i].arrow:SetActive(true);
		else
			val[i].isCanUse = false;
			self.itemBtnList[i].arrow:SetActive(false);
		end
	end
end

function Lua_PetBasicPanel:setAttrLabel(index, text)
	if index == 1 then
		self.attackLabel.text = text;
		self:updateAttrLabelPos(self.attackTxt, self.increaseAttackObj, self.attackLabel);
	elseif index == 2 then
		self.hitLabel.text = text;
		self:updateAttrLabelPos(self.hitTxt, self.increaseHitObj, self.hitLabel);
	elseif index == 3 then
		self.defenceLabel.text = text;
		self:updateAttrLabelPos(self.defenceTxt, self.increaseDefenceObj, self.defenceLabel);
	elseif index == 4 then
		self.critLabel.text = text;
		self:updateAttrLabelPos(self.critTxt, self.increaseCritObj, self.critLabel);
	end
end

function Lua_PetBasicPanel:setAttackTxt(lower, upper, increase)
	self.increaseAttackObj:SetActive(true);
	if self._commonData ~= nil and self._commonData.isMaxLvl == 1 then
		self.increaseAttackObj:SetActive(false);
	end

	if upper == nil then
		upper = "";
	else
		upper = "-" .. upper;
	end

	self.attackTxt.text = lower .. upper;
	self:updateAttrLabelPos(self.attackTxt, self.increaseAttackObj, self.attackLabel);
	self.increaseAttackTxt.text = increase;
end

function Lua_PetBasicPanel:setHitTxt(num, increase)
	self.increaseHitObj:SetActive(true);
	if self._commonData ~= nil and self._commonData.isMaxLvl == 1 then
		self.increaseHitObj:SetActive(false);
	end

	self.hitTxt.text = num;
	self:updateAttrLabelPos(self.hitTxt, self.increaseHitObj, self.hitLabel);
	self.increaseHitTxt.text = increase;
end

function Lua_PetBasicPanel:setDefenceTxt(num, increase)
	self.increaseDefenceObj:SetActive(true);
	if self._commonData ~= nil and self._commonData.isMaxLvl == 1 then
		self.increaseDefenceObj:SetActive(false);
	end

	self.defenceTxt.text = num;
	self:updateAttrLabelPos(self.defenceTxt, self.increaseDefenceObj, self.defenceLabel);
	self.increaseDefenceTxt.text = increase;
end

function Lua_PetBasicPanel:setCritTxt(num, increase)
	self.increaseCritObj:SetActive(true);
	if self._commonData ~= nil and self._commonData.isMaxLvl == 1 then
		self.increaseCritObj:SetActive(false);
	end

	self.critTxt.text = num;
	self:updateAttrLabelPos(self.critTxt, self.increaseCritObj, self.critLabel);
	self.increaseCritTxt.text = increase;
end

function Lua_PetBasicPanel:updateAttrLabelPos(attrTxt, attrObj, label)
	attrTxt:setLocation(label.mainContent.transform.localPosition.x + label.width, 0, 0);
	LuaUtil.setObjPos(attrObj, attrTxt.mainContent.transform.localPosition.x + attrTxt.width + 28, 0, 0);
end

function Lua_PetBasicPanel:setExpBarValue(value, maxValue, txt)
	if txt == nil then
		self.expBar:setText(tostring(value) .. "/" .. tostring(maxValue));
	else
		self.expBar:setText(tostring(txt));
	end
	self.expBar:setMaxValue(maxValue);
	self.expBar:setValue(value);
end

function Lua_PetBasicPanel.Get:modelList()
	return self._modelList;
end

function Lua_PetBasicPanel.Set:modelList(val)
	self._modelList = val;
end

function Lua_PetBasicPanel:showModelByIndex(index)
	self.curModelIndex = index == nil and 1 or index;
	if self._modelList ~= nil then
		self:showCurModel();
	end
end

function Lua_PetBasicPanel:showCurModel()
	self:setSwitchBtn();

	self.nameTxt.text = self._modelList[self.curModelIndex].name;

	local curModel = self.modelList[self.curModelIndex];
	self:setActivationStateText(curModel.activationLvl);

	self:setModel();
	self.curModelId = curModel.id;
	self:onChangeState();

	if self.classname == "Lua_MountPanel" then
		self.commonBtnObj4:SetActive(false);
	else
		self.commonBtnObj4:SetActive(true);
	end
end

function Lua_PetBasicPanel:setActivationStateText(lvl)
	if self._modelList[self.curModelIndex].isActivated then
		self.petStateTxt:setEnable(false);
		if DataCenter.funcOpenData:isOpened(10141) == true and self.itemArr ~= nil then
			-- 骑装显示
			for i = 1, self.itemArr:getSize() do
				self.itemArr[i]:setEnable(true)
			end
		end
	else
		local stage = math.floor(lvl / 10) + 1;
		local numStr = string.split(LanUtil.getValue(110507), ",");
		local words = string.split(LanUtil.getValue(110508), ",");
		self.petStateTxt.text = numStr[stage + 1] .. words[1] .. words[3];
		self.petStateTxt.mainContent:SetActive(true);

		if DataCenter.funcOpenData:isOpened(10141) == true and self.itemArr ~= nil then
			-- 骑装隐藏
			for i = 1, self.itemArr:getSize() do
				self.itemArr[i]:setEnable(false);
			end
		end
	end
	self:updateCommonBtn2();
end

function Lua_PetBasicPanel:updateCommonBtn2()
	self.isUsing = self.commonData.isUsing == 1;
end

function Lua_PetBasicPanel:onChangeState()
	if self._commonData.servantShape == self.curModelId then
		self.commonBtnObj3:SetActive(false)
		self.huanXing_Mark:setEnable(true)
	else
		self.commonBtnObj3:SetActive(true);
		self.huanXing_Mark:setEnable(false);

		if self._modelList[self.curModelIndex].isActivated == true then
			self.commonBtnObj3:SetActive(true);
		else
			self.commonBtnObj3:SetActive(false);
		end
	end
end

function Lua_PetBasicPanel:setModel()
	if self.modelTexture == nil then
		return;
	end

	local curModel = self.modelList[self.curModelIndex];
	local rootPos = nil;
	local rootRot = nil;
	local rootSca = nil;
	local effectPos = nil;
	local effectRot = nil;
	local effectSca = nil;
	if self.curModelId ~= curModel.id then
		if self.modelType == 1 then
			self.modelTexture:setEffectActive(false);
			self.modelTexture:addLuaLoadedCallBack(self, self.delayShowModel);
		end

		local modelInfo = self._commonData:getModelInfo(curModel.id);
		if (modelInfo == nil) then
			self.modelTexture:setUrl("/mounts/" .. curModel.id, tostring(curModel.id));
		else
			self.modelTexture:setUrl(modelInfo.floder .. "/" .. modelInfo.fileName, tostring(modelInfo.modelName));

			if modelInfo.rootPos == nil then
				rootPos = self.rootPos;
			else
				rootPos = Vector3(modelInfo.rootPos[1], modelInfo.rootPos[2], modelInfo.rootPos[3]);
			end

			if modelInfo.rootRot == nil then
				rootRot = self.rootRot;
			else
				rootRot = Vector3(modelInfo.rootRot[1], modelInfo.rootRot[2], modelInfo.rootRot[3]);
			end

			if modelInfo.rootSca == nil then
				rootSca = self.rootSca;
			else
				rootSca = Vector3(modelInfo.rootSca[1], modelInfo.rootSca[2], modelInfo.rootSca[3]);
			end

			if modelInfo.pos == nil then
				effectPos = self.effectPos;
			else
				effectPos = Vector3(modelInfo.pos[1], modelInfo.pos[2], modelInfo.pos[3]);
			end

			if modelInfo.rot == nil then
				effectRot = self.effectRot;
			else
				effectRot = Vector3(modelInfo.rot[1], modelInfo.rot[2], modelInfo.rot[3]);
			end

			if modelInfo.sca == nil then
				effectSca = self.effectSca;
			else
				effectSca = Vector3(modelInfo.sca[1], modelInfo.sca[2], modelInfo.sca[3]);
			end
        end

		if self.modelType == 1 then
			self.modelTexture:setEffectPos(effectPos.x, effectPos.y, effectPos.z);
			self.modelTexture:setModelAngle(effectRot.x, effectRot.y, effectRot.z);
			self.modelTexture:setModelOffset(rootPos.x, rootPos.y, rootPos.z);
			self.modelTexture.uiEffect:setSacle(effectSca.x, effectSca.y, effectSca.z);
		    LuaUtil.setObjRot(self.modelTexture.root, rootRot.x, rootRot.y, rootRot.z);
			LuaUtil.setObjScale(self.modelTexture.root, rootSca.x, rootSca.y, rootSca.z);
		elseif self.modelType == 2 then
			self.modelTexture:SetRenderQueue(self.bg, -1, 2);
			self.modelTexture:setRot(0, 0, 0);
		end
    end
end

function Lua_PetBasicPanel:delayShowModel()
	self.modelTexture:setEffectActive(true);
end

function Lua_PetBasicPanel:onPrevBtn(go)
	if self._modelList ~= nil then
		if self.curModelIndex > 1 then
			self.curModelIndex = self.curModelIndex - 1;
		end
		self:showCurModel();
	end
end

function Lua_PetBasicPanel:onNextBtn(go)
	if self._modelList ~= nil then
		local listLength = self._modelList.getSize();
		if self.curModelIndex < listLength then
			self.curModelIndex = self.curModelIndex + 1;
		end
		self:showCurModel();
	end
end

function Lua_PetBasicPanel:setSwitchBtn()
	if self.curModelIndex <= 1 then
		self.prevBtn.mouseEnable = false;
		self.prevBtn:setAltas("common_atlas_2", "ui_common_jiantou_02");
	elseif self.curModelIndex == 2 then
		self.prevBtn.mouseEnable = true;
		self.prevBtn:setAltas("common_atlas_2", "ui_common_jiantou_01");
	end

	local listLength = self._modelList.getSize();
	local maxVisibleModelIndex = self._commonData.stage + Lua_CommonUtil.getCommonConfig("limit_visible", 1);
	maxVisibleModelIndex = maxVisibleModelIndex > listLength and listLength or maxVisibleModelIndex;
	if self.curModelIndex >= maxVisibleModelIndex then
		self.nextBtn.mouseEnable = false;
		self.nextBtn:setAltas("common_atlas_2", "ui_common_jiantou_02");
	elseif self.curModelIndex < maxVisibleModelIndex then
		self.nextBtn.mouseEnable = true;
		self.nextBtn:setAltas("common_atlas_2", "ui_common_jiantou_01");
	end
end

function Lua_PetBasicPanel:onCommonBtn1(go)
	if self.commonData ~= nil then
		if DataCenter.funcOpenData:isOpened(10087) then
			self:openTranWin();
		else
			local s = getConfig({"func_open", 10087, "advance_message"});
			if s ~= nil then
				OperateAlert.show(s);
			end
		end
	end
end

function Lua_PetBasicPanel:openTranWin()
end

function Lua_PetBasicPanel:onCommonBtn3()
	if self.commonData ~= nil then
		self._commonData:sUse(self.modelList[self.curModelIndex].id);
	end
end

function Lua_PetBasicPanel:yinCangCheckBoxClick()
	if self.commonData ~= nil then
		if self.yinCangCheckBox.seleted == true then
			self._commonData:sNonuse(0);
		else
			self._commonData:sNonuse(1);
		end
	end
end

function Lua_PetBasicPanel:onRightBtn1(go)
	if self._commonData ~= nil then
		if self.isAdvancing then
			self:setAutoLvlUpTimer(false);
		else
			self:setAutoLvlUpTimer(true);
		end
	end
end

function Lua_PetBasicPanel:onRightBtn2(go)
	if self.classname == "Lua_MountPanel" then
		self.panelClickIndex = 1
	else
		if self.panelClickIndex ~= nil then
			self.panelClickIndex = -1
		end
	end

	if self._commonData ~= nil then
		self:lvlUpOnce();
	end
end

function Lua_PetBasicPanel:showItemOutPutWindow()
	if self.itemImg.data == nil then
		return;
	end
	if self.isShowItemOutPutWindow == false then
		return;
	end

	if self.itemNumDic ~= nil and self.itemNumDic.num < self.itemNumDic.needNum then
		local arr = Array();
		arr:add(self.itemImg.data);
		arr:add(Lua_ToolVo.new(103045003, 1, 0));
		if Lua_WindowUtil.isWindowShowing("Lua_ItemOutputWindow") == false then
			if self.autoCheck == false then
				self.isAdvancing = false
				self:updateRightBtn1()
				Lua_WindowUtil.openWin("Lua_ItemOutputWindow", WinParam.ACTION_OPEN, arr);
			end
		end
		Lua_CommonUtil.removeTimer(self, self.lvlUpOnce);
	end
end

function Lua_PetBasicPanel:onMaskClick(go)
end

function Lua_PetBasicPanel:updateFightState()
	self.isUsing = self.commonData.isUsing == 1 and true or false;
	self:updateCommonBtn2();
end

function Lua_PetBasicPanel:setCheckBoxBtnImage()
	self.yinCangCheckBox.seleted = not self.isUsing;
end

function Lua_PetBasicPanel:onSkill(go)
	LuaUtil.setObjScale(go, 1.1, 1.1, 1.1);
	if self._skillInfoList == nil then
		return;
	end

	for i = 1, self.skillBtnList.getSize() do
		if self.skillBtnList[i].skill.name == go.name then
			self:openSkillDetailWindow(self._skillInfoList[i]);
		end
	end
end

function Lua_PetBasicPanel:onSkillRelease(go, state)
	LuaUtil.setObjScale(go, 1, 1, 1);
end

function Lua_PetBasicPanel:openSkillDetailWindow(data)
	data.commonData = self.commonData;
	Lua_WindowUtil.openWin("Lua_PetSkillDetailWindow", WinParam.ACTION_OPEN, data);
end

function Lua_PetBasicPanel:onItem(go)
	LuaUtil.setObjScale(go, 1.1, 1.1, 1.1);
	if self._itemInfoList == nil then
		return;
	end

	for i = 1, self.itemBtnList.getSize() do
		if self.itemBtnList[i].item.name == go.name then
			if self._itemInfoList[i].isCanUse == true then
				self:useItem(i, self._itemInfoList[i].itemNum);
			else
				self:openItemDetailWindow(self._itemInfoList[i]);
			end
		end
	end
end

function Lua_PetBasicPanel:onItemRelease(go, state)
	LuaUtil.setObjScale(go, 1, 1, 1);
end

function Lua_PetBasicPanel:openItemDetailWindow(data)
	Lua_WindowUtil.openWin("Lua_PetPanaceaDetailWindow", WinParam.ACTION_OPEN, data);
end

function Lua_PetBasicPanel:useItem(index, num)
	if self.lastUseItemTime == nil then
		self.lastUseItemTime = 0;
	end

	if getTime() - self.lastUseItemTime > 0.3 then
		if num == nil then
			num = 1;
		end
		self.commonData:sUseItem(index - 1, num);
		self.lastUseItemTime = getTime();
	end
end

function Lua_PetBasicPanel:setStageText(stage, starLvl)
	local numStr = string.split(LanUtil.getValue(110507), ",");
	local words = string.split(LanUtil.getValue(110508), ",");
	local numWord1 = numStr[stage + 1];
	local numWord2 = numStr[starLvl + 1];
	if numWord1 ~= nil and numWord2 ~= nil then
		local stageStr = numWord1 .. words[1] .. numWord2 .. words[2];
		self.levelTxt.text = stageStr;
	end
end

function Lua_PetBasicPanel:setAutoLvlUpTimer(state)
	if type(state) ~= "table" then
		if state == true then
			Lua_CommonUtil.addTimer("lvlUpOnce", 0.1, self, self.lvlUpOnce);
		else
			Lua_CommonUtil.removeTimer(self, self.lvlUpOnce);
		end
		self.isAdvancing = state;
	else
		if self._commonData.isMaxLvl == 0 then
			self.isAdvancing = state.state;
			local arr = Array();
			arr:add(self.itemImg.data);
			arr:add(Lua_ToolVo.new(103045003, 1, 0));
			if Lua_WindowUtil.isWindowShowing("Lua_ItemOutputWindow") == false then
				self:updateRightBtn1()
				Lua_WindowUtil.openWin("Lua_ItemOutputWindow", WinParam.ACTION_OPEN, arr);
				Lua_CommonUtil.removeTimer(self, self.lvlUpOnce);
			end

			if self.panelClickIndex ~= nil and self.panelClickIndex ~= -1 then
				return;
			end

			if self.AutoCheckBoxBg ~= nil then
				self:updateRightBtn1()
				if self.autoCheck ~= false then
					self:onAutoCheckBox()
				end
			end
		end
	end
	self:updateRightBtn1();
	if self._commonData ~= nil and self._commonData.isMaxLvl == 0 and self.autoCheck == false then
		self:showItemOutPutWindow();
	end
end

function Lua_PetBasicPanel:updateRightBtn1()
	if self.isAdvancing == true then
		self.rightBtn1.label = LanUtil.getValue(110523);
	else
		self.rightBtn1.label = LanUtil.getValue(110504);
	end
end

function Lua_PetBasicPanel:lvlUpOnce()
	if self.lastLvlTime == nil then
		self.lastLvlTime = 0;
	end

	if getTime() - self.lastLvlTime > 0.05 then
		self.commonData:sServantAnvance();
		self.lastLvlTime = getTime();
	end
end

function Lua_PetBasicPanel:isShowMask(isShow)
	self.isAdvancing = isShow;
	self:updateRightBtn1();
end

function Lua_PetBasicPanel:updateRedDot(obj)
	if self.eventIdList ~= nil then
		self:setFunBtn1RedDotState(obj);
		self:setFunBtn2RedDotState(obj);
		self:setComBtn1RedDotState(obj);
		self:setSkillRedDotState(obj);
	end
end

function Lua_PetBasicPanel:setFunBtn1RedDotState(obj)
	local idList = self.eventIdList.funBtn1;
	local isShowRedDot = self:isShowRedDot(idList, obj);
	self.funBtn1RedDot = self:setRedDotState(self.rightBtn1.mainContent, self.funBtn1RedDot, isShowRedDot, Vector3(85, 22, 0));
end

function Lua_PetBasicPanel:setFunBtn2RedDotState(obj)
	local idList = self.eventIdList.funBtn2;
	local isShowRedDot = self:isShowRedDot(idList, obj);
	self.funBtn2RedDot = self:setRedDotState(self.rightBtn2.mainContent, self.funBtn2RedDot, isShowRedDot, Vector3(85, 22, 0))
end

function Lua_PetBasicPanel:setComBtn1RedDotState(obj)
	local idList = self.eventIdList.comBtn1;
	local isShowRedDot = self:isShowRedDot(idList, obj);
	self.comBtnObj1RedDot = self:setRedDotState(self.commonBtnObj1, self.comBtnObj1RedDot, isShowRedDot, Vector3(19.5, 20.5, 0))
end

function Lua_PetBasicPanel:setSkillRedDotState(obj)
	local idList = self.eventIdList.skill;
	local isShowRedDot = self:isShowRedDot(idList, obj);

	for i = 1, self.skillBtnList:getSize() do
		if (self.skillBtnList[i].isActivated == true
			and self._skillInfoList[i].skillLvl < self.commonData:getSkillLvl(i)
			and self._skillInfoList[i].skillLvlUpItemInfo.needNum <= DataCenter.packData:getBagType(2):getItemNum(self._skillInfoList[i].skillLvlUpItemInfo.itemId)) then
				self.skillBtnList[i].redDot = self:setRedDotState(self.skillBtnList[i].bg.mainContent, self.skillBtnList[i].redDot, isShowRedDot, Vector3(30, 30, 0));
		else
			self.skillBtnList[i].redDot = self:setRedDotState(self.skillBtnList[i].bg.mainContent, self.skillBtnList[i].redDot, false, Vector3(30, 30, 0))
		end
	end
end

function Lua_PetBasicPanel:isShowRedDot(idList, obj)
	local isShowRedDot = false;
	for k, v in ipairs(idList) do
		if obj == nil then
			if DataCenter.redDotData:getRedDotStateByEventId(v) then
				isShowRedDot = true;
			end
		else
			if v == obj.evenId then
				if obj.bShow then
					isShowRedDot = true;
				end
			else
				if DataCenter.redDotData:getRedDotStateByEventId(v) then
					isShowRedDot = true;
				end
			end
		end
	end
	return isShowRedDot;
end

function Lua_PetBasicPanel:setRedDotState(parentObj, redDot, isShow, pos, depth)
	if redDot == nil then
		pos = pos == nil and Vector3(0, 0, 0) or pos;
		redDot = UICreate.createUIAtlasImage(parentObj, "common_atlas_1", "ui_common_hongdian", pos.x, pos.y, 0, 0);
		redDot.name = "redDot";
		depth = depth == nil and 20 or depth;
		redDot:setDepth(depth);
	end
	redDot:setEnable(isShow);
	return redDot;
end

function Lua_PetBasicPanel:dispose()
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.AutoCheckBoxBg ~= nil then
		self.AutoCheckBoxBg:dispose()
		self.AutoCheckBoxBg = nil
	end
	if self.tipsTxt ~= nil then
		self.tipsTxt:dispose()
		self.tipsTxt = nil
	end
	self._commonData = nil;
	self.data = nil;
	Lua_CommonUtil.removeTimer(self, self.lvlUpOnce);
	Lua_CommonUtil.removeTimer(self, self.onModelRoting);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PetAttrPanel = class("Lua_PetAttrPanel", Lua_DragContainerItem);
function Lua_PetAttrPanel:ctor(p)
	self.height = 220;
	self:superCall("ctor", p);
end

function Lua_PetAttrPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_PetAttrPanel:setData(data)
	if self.itemArr == nil then
		self.itemArr = Array();
		
		local item;
		for i = 1, data:getSize() do
			item = Lua_PetAttrItem.new(self.content);
			self.itemArr:add(item);
		end
	end

	local startY = 0;
	if data:getSize() > 0 then
		startY = data[1].isMount and 60 or 50;
	end

	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:setLocation(-205, startY, 0);
		self.itemArr[i]:setData(data[i]);

		startY = startY - self.itemArr[i]:getHeight();
	end

	if self.itemArr:getSize() > 0 then
		self.height = self.itemArr:getSize() * self.itemArr[1]:getHeight();
	else
		self.height = 0;
	end
end

function Lua_PetAttrPanel:getHeight()
	return self.height;
end

function Lua_PetAttrPanel:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PetAttrItem = class("Lua_PetAttrItem", Lua_DisplayObject);
function Lua_PetAttrItem:ctor(p)
	self:superCall("ctor", p, "petAttItem_skin");
end

function Lua_PetAttrItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.label.text = data.curAttr.attrStr .. "：";

	if data.curAttr.attack_upper == nil then
		self.txt.text = data.curAttr.value;
	else
		self.txt.text = data.curAttr.attack_lower.value .. "-" .. data.curAttr.attack_upper.value;
	end

	local posX = self.label.mainContent.transform.localPosition.x + self.label.width;
	local posY = self.label.mainContent.transform.localPosition.y;
	self.txt:setLocation(posX, posY, 0);

	posX = self.txt.mainContent.transform.localPosition.x + self.txt.width + 13;
	posY = self.txt.mainContent.transform.localPosition.y;
	LuaUtil.setObjPos(self.increaseObj, posX, posY, 0);

	if data.nextAttr == nil then
		self.increaseObj:SetActive(false);
	else
		if data.nextAttr.attack_upper == nil then
			self.increaseTxt.text = "+" .. data.nextAttr.value;
		else
			self.increaseTxt.text = "+" .. data.nextAttr.attack_lower.value .. "-" .. data.nextAttr.attack_upper.value;
		end
	end
end

function Lua_PetAttrItem:getHeight()
	return self.txt.height + 4;
end