Lua_ProccessBar = class("Lua_ProccessBar", Lua_DisplayObject);
function Lua_ProccessBar:ctor(p, multi)
	self.multi = multi or false
	self.totalHpNum = 1;
	self:superCall("ctor", p, nil, false);
end

function Lua_ProccessBar:buildShowItem()
	self:superCall("buildShowItem");

	-- 红、黄、紫、蓝、绿
	self.nextSpriteName = Array("ui_zhujiemian_progress_19", "ui_zhujiemian_progress_20", "ui_zhujiemian_progress_21",
		"ui_zhujiemian_progress_22", "ui_zhujiemian_progress_23");

	local spriteName;
	local textFontSize;
	local textPosY;
	if self.multi then
		spriteName = "ui_zhujiemian_progress_19";
		textFontSize = 18;
		textPosY = -1.5;

		self.barSp2 = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_progress_20", 0, 0, 0, 0);
		self.barSp2.name = "barSp2";
		self.barSp2.pivot = UIWidget.Pivot.Left;
		self.barSp2.type = UIBasicSprite.Type.Filled;
		self.barSp2.fillDirection = UIBasicSprite.FillDirection.Horizontal;
		self.barSp2:setDepth(2);
		
		self.hpNumTxt = UICreate.createLabel(self.content, "", 306, -1.5, 50, 20, 18);
		self.hpNumTxt.name = "hpNumTxt";
		self.hpNumTxt.pivot = UIWidget.Pivot.Right;
		self.hpNumTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.hpNumTxt.effectStyle = 3;
		self.hpNumTxt.effectColorStr = Lua_ColorDefine.transColor("000000", 1);
		self.hpNumTxt:setEffectDistance(0.5, 0.5);
		self.hpNumTxt:setDepth(4);
	else
		spriteName = "ui_zhujiemian_progress_01";
		textFontSize = 16;
		textPosY = 0;
	end

	self.barSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", spriteName, 0, 0, 0, 0);
	self.barSp.name = "barSp";
	self.barSp.pivot = UIWidget.Pivot.Left;
	self.barSp.type = UIBasicSprite.Type.Filled;
	self.barSp.fillDirection = UIBasicSprite.FillDirection.Horizontal;
	self.barSp:setDepth(3);

	self.infoTxt = UICreate.createLabel(self. content, "0/0", 0, textPosY, 170, 20, textFontSize);
	self.infoTxt.name = "infoTxt";
	self.infoTxt.pivot = UIWidget.Pivot.Left;
	self.infoTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.infoTxt.effectStyle = 3;
	self.infoTxt.effectColorStr = Lua_ColorDefine.transColor("000000", 1);
	self.infoTxt:setEffectDistance(0.5, 0.5);
	self.infoTxt:setDepth(4);
end

function Lua_ProccessBar:setDepth(val)
	self.barSp:setDepth(val + 2);
	self.infoTxt:setDepth(val + 3);
	if self.barSp2 ~= nil then
		self.barSp2:setDepth(val + 1);
	end
	if self.hpNumTxt ~= nil then
		self.hpNumTxt:setDepth(val + 3);
	end
end

function Lua_ProccessBar:setTxtOffet(ox, oy)
	self.infoTxt:setLocation(ox, oy, 0);
end

function Lua_ProccessBar:setTxtCenter()
	self.infoTxt.pivot = UIWidget.Pivot.Center;

	local textPosY;
	if self.multi then
		textPosY = -1.5;
	else
		textPosY = -0.5;
	end
	self.infoTxt:setLocation(self.barSp.width / 2 - 5, textPosY, 0);
end

function Lua_ProccessBar:setBarSprite(atlas, spriteName, w, h)
	if self.multi == false then
		self.barSp:setAltas(atlas, spriteName);
	end

	if w == nil or h == nil then
		self.barSp:resetSize();
		if self.barSp2 ~= nil then
			self.barSp2:resetSize();
		end
	else
		self.barSp:SetDimensions(w, h);
		if self.barSp2 ~= nil then
			self.barSp2:SetDimensions(w, h);
		end
	end
end

function Lua_ProccessBar:setBarNum(val)
	self.totalHpNum = val;
end

function Lua_ProccessBar:setInfoTxt(curValue, maxValue, showMax, showPercent)
	curValue = tonumber(curValue);
	maxValue = tonumber(maxValue);
	if showMax == nil or showMax then
		self.infoTxt.text = Lua_CommonUtil.getNumberTrans(curValue) .."/".. Lua_CommonUtil.getNumberTrans(maxValue);
	else
		if showPercent == true then
			local num = math.floor(curValue * 100 / maxValue);
			if num < 0 then
				num = 0;
			elseif num > 100 then
				num = 100;
			end
			self.infoTxt.text = num .."%";
		else
			self.infoTxt.text = Lua_CommonUtil.getNumberTrans(curValue);
		end
	end

	if self.multi then
		-- 99 ~ 0
		local curHpNum = math.ceil(curValue / maxValue * self.totalHpNum); -- 向上
		self.hpNumTxt.text = "x".. curHpNum;

		local per = maxValue / self.totalHpNum; -- 单一血条量
		local process = curValue % per; -- 当前血条量
		if curValue >= maxValue then
			process = per;
		elseif curValue <= 0 then
			process = 0;
		end

		local idx = 5 - curHpNum % 5;
		local curShowHpRate = process / per;
		if curShowHpRate <= 0 then
			curShowHpRate = 0;
		elseif curShowHpRate > 1 then
			curShowHpRate = 1;
		end
		self.barSp.fillAmount = curShowHpRate;
		self.barSp:setAltas("mainWindow_atlas", self.nextSpriteName[idx]);

		self.barSp2:setEnable(curValue >= per and per > 1);
		if self.barSp2.isActive then
			idx = idx + 1 > 5 and 1 or idx + 1;
			self.barSp2:setAltas("mainWindow_atlas", self.nextSpriteName[idx]);
		end
	else
		if curValue / maxValue <= 0 then
			self.barSp.fillAmount = 0;
		elseif curValue / maxValue > 1 then
			self.barSp.fillAmount = 1;
		else
			self.barSp.fillAmount = curValue / maxValue;
		end
	end
end