Lua_RotActionItem = class("Lua_RotActionItem");
function Lua_RotActionItem:ctor(sp)
	self.sp = sp;
	self.startRot = 0;
end

function Lua_RotActionItem:setParams(speed, allRot, owner, callBack)
	self.speed = speed;
	self.allRot = allRot;
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_RotActionItem:onEnterFrame()
	if self.startCircle == true then
		local pt = getTime() - self.startTime;
		if self.runTime <= pt then
			self.curRot = self.startRot + self.allRot;
			self.startCircle = false;
			if self.owner ~= nil and self.callBack ~= nil then
				self.callBack(self.owner);
			end
			Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
			Lua_CommonUtil.delayCall(1, self, self.updatePanel);
		else
			self.curRot = self.startRot + self.startSpeed * pt - self.speed * pt * pt / 2;
		end
		-- self.sp.mainContent.transform.localRotation = Quaternion.Euler(0, 0, self.curRot);
		LuaUtil.setObjRot(self.sp.mainContent, 0, 0, self.curRot);
	end
end

function Lua_RotActionItem:setRot(val)
	-- self.sp.mainContent.transform.localRotation = Quaternion.Euler(0, 0, val);
	LuaUtil.setObjRot(self.sp.mainContent, 0, 0, val);
	self.startRot = val;
end

function Lua_RotActionItem:start()
	Lua_CommonUtil.addTimer("Lua_RotActionItem", 0.01, self, self.onEnterFrame);
	self.runTime = math.sqrt(2 * self.allRot / self.speed);
	self.startSpeed = self.runTime * self.speed;
	self.curRot = 0;
	self.startRot = 0;
	self.startTime = getTime();
	self.startCircle = true;
end

function Lua_RotActionItem:updatePanel()
	Lua_MsgUtil.callFunc("UPDATE_YUAN_BAO_DOUBLE_INFORMATION"); -- 更新元宝大翻倍界面
end

function Lua_RotActionItem:dispose()
	self.owner = nil;
	self.callBack = nil;
	Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
end