-- 多段血条显示
Lua_SectionProccessBar = class("Lua_SectionProccessBar", Lua_DisplayObject);
function Lua_SectionProccessBar:ctor(p, eachNum, sectionNum)
	self.eachNum = eachNum;
	self.sectionNum = sectionNum;
	self:superCall("ctor", p, nil);
end

function Lua_SectionProccessBar:dispose()
	if self.hpBar ~= nil then
		self.hpBar:dispose();
		self.hpBar = nil;
	end

	self:superCall("dispose");
end


function Lua_SectionProccessBar:buildShowItem()
	self:superCall("buildShowItem");
	local startX = -88;
	local bgWidth = 176;
	local barWidth = bgWidth - 41;
	local barStartX = startX + 40;

	self.hpBarBg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "jdt_bg02", startX, 0, bgWidth, 41);
	self.hpBarBg.pivot = UIWidget.Pivot.Left;
	self.hpBarBg:setLocation(startX, 0);
	self.hpBarBg:setDepth(1);

	self.infoTxt = UICreate.createLabel(self.content, "15", 0, 0, 60, 30, 22);
	self.infoTxt.pivot = UIWidget.Pivot.Center;
	self.infoTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
    self.infoTxt:setLocation(startX + 19, 0, 0);
    self.infoTxt:setDepth(4);

    self.hpBar = Lua_ProccessBar.new(self.content);
    self.hpBar:setBarSprite("iconantlas1", "jdt_bar04", barWidth, 12);
    self.hpBar:setLocation(barStartX, 0, 0);
    self.hpBar:setInfoTxt(1, 1);
    self.hpBar.infoTxt.text = "";
    self.hpBar:setDepth(2);

    local sectionW = barWidth / self.sectionNum;
    for i = 1, self.sectionNum - 1 do
    	local secImg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "jdt_section", barStartX + sectionW * i, 0, 3, 12);
    	secImg:setDepth(5);
    end
end

function Lua_SectionProccessBar:setInfoTxt(curValue, maxValue)
	local num = math.ceil(curValue / self.eachNum);
	self.infoTxt.text = tostring(num);

	self.hpBar:setInfoTxt(curValue, maxValue);
    self.hpBar.infoTxt.text = "";
end