-- 图文混排组件
Lua_ShowItem = class("Lua_ShowItem", Lua_DisplayObject);

function Lua_ShowItem:ctor(p)
	self:superCall("ctor", p);

	self.showPosX = 0;
	self.showPosY = 0;
	self.numSpacing = 0;
	self.upIconSpacing = 0;
	self.addNumSpacing = 0;

	self.isWords = false;
	self.wordsFontSize = 20;

	self.isNum = false;
	self.numFontSize = 20;

	self.isAddNum = false;
	self.addNumFontSize = 20;
end

function Lua_ShowItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ShowItem:setData(data)
	self.data = data;

	if self.isWords and self.wordsLab == nil then
		self.wordsLab = UICreate.createLabel(self.content, "", self.showPosX, self.showPosY, 100, 30, self.wordsFontSize);
		self.wordsLab.name = "wordsLab"; 
		self.wordsLab.depth = 10;
		self.wordsLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		local wordsColor = data.wordsColor == nil and Lua_ColorDefine.WHITE_STR or data.wordsColor;
		self.wordsLab.colorStr = Lua_ColorDefine.transColor(wordsColor);
	end

	if self.isNum and self.numLab == nil then
		self.numLab = UICreate.createLabel(self.content, "", 0, self.showPosY, 100, 30, self.numFontSize);
		self.numLab.name = "numLab"; 
		self.numLab.depth = 10;
		self.numLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		local numColor = data.numColor == nil and Lua_ColorDefine.WHITE_STR or data.numColor;
		self.numLab.colorStr = Lua_ColorDefine.transColor(numColor);
	end

	if self.isAddNum and self.addNumLab == nil then
		self.addNumLab = UICreate.createLabel(self.content, "", 0, self.showPosY, 100, 30, self.addNumFontSize);
		self.addNumLab.name = "addNumLab"; 
		self.addNumLab.depth = 10;
		self.addNumLab.overflowMethod = UILabel.Overflow.ResizeFreely;
		local addNumColor = data.addNumColor == nil and Lua_ColorDefine.WHITE_STR or data.addNumColor;
		self.addNumLab.colorStr = Lua_ColorDefine.transColor(addNumColor);
	end

	if self.isWords and self.isNum then
		local wordsColor = data.wordsColor == nil and Lua_ColorDefine.WHITE_STR or data.wordsColor;
		self.wordsLab.colorStr = Lua_ColorDefine.transColor(wordsColor);
		self.wordsLab.text = data.wordsStr == nil and "" or data.wordsStr;
		
		local numColor = data.numColor == nil and Lua_ColorDefine.WHITE_STR or data.numColor;
		self.numLab.colorStr = Lua_ColorDefine.transColor(numColor);
		self.numLab.text = data.numStr == nil and "" or data.numStr;

		local posX = self.wordsLab.mainContent.transform.localPosition.x + self.wordsLab.width + self.numSpacing;
		local posY = self.numLab.mainContent.transform.localPosition.y;
		local posZ = self.numLab.mainContent.transform.localPosition.z;
		self.numLab:setLocation(posX, posY, posZ);

		if self.isAddNum then
			local addNumColor = data.addNumColor == nil and Lua_ColorDefine.WHITE_STR or data.addNumColor;
			self.addNumLab.colorStr = Lua_ColorDefine.transColor(addNumColor);
			self.addNumLab.text = data.addNumStr == nil and "" or data.addNumStr;

			posX = self.numLab.mainContent.transform.localPosition.x + self.numLab.width + self.addNumSpacing;
			posY = self.addNumLab.mainContent.transform.localPosition.y;
			posZ = self.addNumLab.mainContent.transform.localPosition.z;
			self.addNumLab:setLocation(posX, posY, posZ);
		end
	end
end

-- 前面中文，后面数字，例如： 攻击: 99
function Lua_ShowItem:setAttrTxt(fontSize1, fontSize2, txt1, txt2, gap, isCenter)
	if self.nameTxt == nil then
		self.nameTxt = UICreate.createLabel(self.content, "", 0, 0, 50, 30, 18);
		self.nameTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.nameTxt:setDepth(10);
		self.nameTxt.name = "nameTxt"; 
	end
	if self.numTxt == nil then
		self.numTxt = UICreate.createLabel(self.content, "", 0, 0, 50, 30, 24);
		self.numTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.numTxt:setDepth(10);
		self.numTxt.name = "numTxt"; 
	end

	self.nameTxt.fontSize = fontSize1;
	self.numTxt.fontSize = fontSize2;

	self.nameTxt.text = txt1;
	self.numTxt.text = txt2;

	if isCenter then
		local halfWidth = (self.nameTxt.width + self.numTxt.width) / 2;
		self.nameTxt:setLocation(-halfWidth, 0, 0);
		self.numTxt:setLocation(-halfWidth + self.nameTxt.width + gap, 0, 0);
	else
		self.nameTxt:setLocation(0, 0, 0);
		self.numTxt:setLocation(self.nameTxt.width + gap, 0, 0);
	end
end

function Lua_ShowItem:dispose()
	if self.wordsLab ~= nil then
		self.wordsLab:dispose();
		self.wordsLab = nil;
	end
	if self.numLab ~= nil then
		self.numLab:dispose();
		self.numLab = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end