Lua_SkillAnimalItem = class("Lua_SkillAnimalItem", Lua_DisplayObject)
function Lua_SkillAnimalItem:ctor(p)
	self:superCall("ctor", p, "SkillAnimalItem_skin");
end

function Lua_SkillAnimalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIcon:setEnable(false);
	self.skillIcon:addClickFuntion(self, self.onSkillClick);

	self:addLuaEvent("UPDATE_SHOWSKILL_SELECT", self, self.setSelectState);
end

function Lua_SkillAnimalItem:setInfo(data)
	self:onUpdateModel(data);
end

function Lua_SkillAnimalItem:onUpdateModel(data)
	self.data = data;

	self.skillIcon:setAltas(data.atlas, data.skill_icon);
	self.skillLvLab.text = "Lv:" .. data.skill_lvl;
	
	self.skillIcon:setGray(not data.activation_state);
	self.lockIcon:setEnable(not data.activation_state);
end

function Lua_SkillAnimalItem:showLvlTxt(val)
	self.skillLvLab:setEnable(val);
end

-- 2020/9/20 策划要求不显示
function Lua_SkillAnimalItem:showLockIcon(val)
	self.lockIcon:setEnable(val);
end

function Lua_SkillAnimalItem:setSelectState(state)
	-- print(state, self.skillIcon.isActive, self.lockIcon.isActive);
	self.selectIcon:setEnable(state);
end

function Lua_SkillAnimalItem:onSkillClick(go)
	self:setSelectState(true);
	Lua_WindowUtil.openWin("Lua_SacredSkillWindow", WinParam.ACTION_OPEN, self.data);
end

function Lua_SkillAnimalItem:setDepth(depth)
	self.skillIBg:setDepth(depth);
	self.skillIcon:setDepth(depth + 1);
	self.selectIcon:setDepth(depth + 2);
	self.skillLvLab:setDepth(depth + 3);
	self.lockIcon:setDepth(depth + 4);
end

function Lua_SkillAnimalItem:dispose()
	self:superCall("dispose");
end