-- 滑块进度条
Lua_SliderProgressBar = class("Lua_SliderProgressBar", Lua_DisplayObject);
function Lua_SliderProgressBar:ctor(p, barWidth, barHeight, txtSize, bgAtals, bgSpName, barAtals, barSpName, sliderAtals, sliderSpName, txtColor)
	self.bgAtals = bgAtals == nil and "common_atlas_1" or bgAtals;
	self.bgSpriteName = bgSpName == nil and "common_progress_1_b" or bgSpName;
	self.barAtals = barAtals == nil and "common_atlas_1" or barAtals;
	self.barSpriteName = barSpName == nil and "common_progress_1_f1" or barSpName;
	self.sliderAtals = sliderAtals == nil and "settingsWindow_atlas" or sliderAtals;
	self.sliderSpriteName = sliderSpName == nil and "ui_shezhi_widget_01" or sliderSpName;
	self.txtColor = txtColor == nil and "ffffff" or txtColor;
	self.txtSize = txtSize == nil and 18 or txtSize;
	self.barWidth = barWidth == nil and 120 or barWidth;
	self.barHeight = barHeight == nil and 30 or barHeight;
	self:superCall("ctor", p);

	self.selectNum = 1;
	self.maxVal = 1;
	self.minVal = 0;
end

function Lua_SliderProgressBar:buildShowItem()
	self:superCall("buildShowItem");

	self.bar = UICreate.createProgressBar(self.content, self.bgAtals, self.bgSpriteName, self.barAtals, self.barSpriteName, 0, 0, self.barWidth, self.barHeight);
	self.bar:setText("");
	self.bar:createSlider(self.sliderAtals, self.sliderSpriteName);
	self.bar:addSlideEndFun(self, self.onSlideEndFun);
    self.bar:addSlidingFun(self, self.onSlideingFun);

	self.numText = UICreate.createLabel(self.content, "", 0, 0, 10, 22, self.txtSize);
    self.numText.pivot = UIWidget.Pivot.Center;
    self.numText.overflowMethod = UILabel.Overflow.ResizeFreely;

    self.subBtn = UICreate.createUIAtlasImage(self.content,  "common_atlas_2", "ui_common_btn_15", -(self.barWidth / 2) - 29, 0, 33, 35);

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);

    self.addBtn = UICreate.createUIAtlasImage(self.content,  "common_atlas_2", "ui_common_btn_12", (self.barWidth / 2) + 32, 0, 33, 35);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
end

function Lua_SliderProgressBar:onSlideEndFun(val)
	self.selectNum = val;
	if self.selectNum < self.minVal then
		self.selectNum = self.minVal;
		self.bar:setValue(self.selectNum);
	end
	self:updateTxt();
end

function Lua_SliderProgressBar:onSlideingFun(val)
	self.selectNum = val;
	if self.selectNum < self.minVal then
		self.selectNum = self.minVal;
		self.bar:setValue(self.selectNum);
	end
	self:updateTxt();
end

function Lua_SliderProgressBar:onSubBtnClick(go)
	self.selectNum = self.selectNum - 1;
	self:checkBarValue();
end

function Lua_SliderProgressBar:onAddBtnClick(go)
	self.selectNum = self.selectNum + 1;
	self:checkBarValue();
end

function Lua_SliderProgressBar:checkBarValue()
	if self.selectNum > self.maxVal then
		self.selectNum = self.maxVal;
	elseif self.selectNum < self.minVal then
		self.selectNum = self.minVal;
	end
	self.bar:setValue(self.selectNum);
	self:updateTxt();
end

function Lua_SliderProgressBar:updateTxt()
	self.numText.text = Lua_ColorDefine.colorStr(tostring(self.selectNum), self.txtColor)
	local posx = (self.selectNum / self.maxVal) * self.barWidth;
    posx = math.min(self.barWidth, posx);
    posx = math.max(5, posx);
    posx = posx - self.barWidth / 2;
	-- local posx = -(self.barWidth / 2) + (self.selectNum / self.maxVal) * self.barWidth - self.numText.width / 2;
    self.numText:setLocation(posx, 0);

    if self.owner ~= nil and self.changeFun ~= nil then
    	self.changeFun(self.owner, self.selectNum);
    end
end

function Lua_SliderProgressBar:setMaxValue(val)
	self.maxVal = val;
	if self.bar ~= nil then
		self.bar:setMaxValue(val);
	end
end

function Lua_SliderProgressBar:setValue(val)
	self.selectNum = val;
	if self.bar ~= nil then
		self.bar:setValue(self.selectNum);
		self:updateTxt();
	end	
end  

function Lua_SliderProgressBar:setMinValue(val)
	self.minVal = val;
end

function Lua_SliderProgressBar:setDepth(val)
	self.bar.depth = val;
	self.numText:setDepth(val + 5);
	self.subBtn:setDepth(val);
	self.addBtn:setDepth(val);
end

function Lua_SliderProgressBar:addChangeCallBackFun(owner, changeFun)
	self.owner = owner;
	self.changeFun = changeFun;
end

function Lua_SliderProgressBar:dispose()
    self.owner = nil;
	self.callBack = nil;
	
    self:superCall("dispose");
end