Lua_TextArea = class("Lua_TextArea", Lua_DisplayObject);
function Lua_TextArea:ctor(p, w, h)
	self.textWidth = w;
	self.textHeight = h;
	self:superCall("ctor", p);
end

function Lua_TextArea:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(self.textWidth / 2, -self.textHeight / 2, self.textWidth, self.textHeight));
	self.insideItem = Lua_TextArenInsideItem.new(self.content, self.textWidth, self.textHeight);
	self.dragContainer:addSubContainer(self.insideItem);

	WindowMananger.getInstance():resetChildParent(self.content.transform);
	LuaUtil.updateWindowDepth(nil);
end

function Lua_TextArea:setText(val)
	self.insideItem:setText(val);
	self.dragContainer:updateChildPos()
end

function Lua_TextArea:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.insideItem ~= nil then
		self.insideItem:dispose();
		self.insideItem = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TextArenInsideItem = class("Lua_TextArenInsideItem", Lua_DragContainerItem);
function Lua_TextArenInsideItem:ctor(p, w, h)
	self.textWidth = w;
	self.textHeight = h;
	self:superCall("ctor", p);
end

function Lua_TextArenInsideItem:buildShowItem()
	self:superCall("buildShowItem");

	self.label = UICreate.createLabel(self.content, "", 0, 0, self.textWidth, 30, 24);
	self.label.pivot = UIWidget.Pivot.TopLeft;
	self.label.overflowMethod = UILabel.Overflow.ResizeHeight;
end

function Lua_TextArenInsideItem:setText(val)
	self.label.text = val;
end

function Lua_TextArenInsideItem:getHeight()
	return self.label.height;
end

function Lua_TextArenInsideItem:dispose()
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end

	self:superCall("dispose");
end