Lua_ThirdSizeWindow = class("Lua_ThirdSizeWindow", Lua_Window)
function Lua_ThirdSizeWindow:ctor(isModel, layer, showClose, titleText, showTitle)
	self:superCall("ctor");

	self.isModel = isModel == nil and true or isModel; -- 黑色背景遮罩
	self.layer = layer == nil and 3500 or layer; -- 默认正常窗口层级3500
	self.showClose = showClose == nil and true or showClose;
	self.titleText = titleText == nil and "" or titleText; -- 标题内容
	self.showTitle = showTitle == nil and true or showTitle; -- 是否显示标题

	self.showBg = true;
	self.titleBgOffsetX = 0;
	self.titleBgOffsetY = -28;
	self.titleTxtOffsetX = 0;
	self.titleTxtOffsetY = -29;
end

function Lua_ThirdSizeWindow:buildShowItem()
	self:superCall("buildShowItem");

	if self.showTitle == true then
		self.titleBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_btd_03", 0, 0, self.w, 56);
		self.titleBg:setLocation(self.winOffsetX + self.titleBgOffsetX, self.h / 2 + self.winOffsetY + self.titleBgOffsetY, 0);
		self.titleBg:setDepth(self.depth + 2);
		self.titleBg.clickScale = false;
		self.titleBg:addClickFuntion(self,self.onTitleClick);
		self.titleBg.name = "titleBg";
			
		if self.titleText ~= nil then
			self.titleNameText = UICreate.createLabel(self.content, tostring(self.titleText) , 0, 0, 180, 30, 30);
			self.titleNameText.pivot = UIWidget.Pivot.Center;
			self.titleNameText.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.titleNameText:setLocation(self.winOffsetX + self.titleTxtOffsetX, self.h / 2 + self.winOffsetY + self.titleTxtOffsetY, 0);		
			self.titleNameText:setDepth(self.depth + 3);
			self.titleNameText.name = "titleNameText";
		end
	end

	if self.showClose and self.btnClose ~= nil then
		self.btnClose:setSacle(0.8, 0.8);
	end
end

function Lua_ThirdSizeWindow:onCloseClick()
	self:hide();
end

function Lua_ThirdSizeWindow:onBgClick()
end

function Lua_ThirdSizeWindow:onTitleClick(go)
end

function Lua_ThirdSizeWindow:dispose()
	if self.titleBg ~= nil then
		self.titleBg:dispose();
		self.titleBg = nil;
	end
	if self.titleNameText ~= nil then
		self.titleNameText:dispose();
		self.titleNameText = nil;
	end
	
	self:superCall("dispose");
end