Lua_ToolImage = class("Lua_ToolImage", Lua_DisplayObject);
function Lua_ToolImage:ctor(p)
	self.defaultWidth = 74;
	self.defaultHeight = 74;
	self.frameBuild = false;
	self:superCall("ctor", p);
end

function Lua_ToolImage:buildShowItem()
	self:superCall("buildShowItem");

	self.numberSize = 18;
	self.item_bg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_prop_1", 0, 0, 75, 77);
	self.item_bg.name = "item_bg";
	self.item_bg:setDepth(self.depth);

	self:setCanClick(true);
end

function Lua_ToolImage:dispose()
	Lua_MsgUtil.removeEventListener("PUT_WING_UPDATE", self, self.onCheckWingChange);
	Lua_MsgUtil.removeEventListener("BASE_PARAM_COMPLETE", self, self.onCheckEquChange);
	self:superCall("dispose");
end

function Lua_ToolImage:setCanClick(val)
	if val == true then
		self.item_bg.mouseEnable = true;
		self.item_bg:addClickFuntion(self, self.onIconClick);
	else
		self.item_bg.mouseEnable = false;
		self.item_bg:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_ToolImage:removeFun(val)
	if val == true then
		self.item_bg:addClickFuntion(self, self.onIconClick);
	else
		self.item_bg:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_ToolImage:setDefaultIcon(atlas, spriteName)
	self.dAtlas = atlas;
	self.dSpritename = spriteName;
end

function Lua_ToolImage:showDefaultIcon(val)
	if val == true and self.dAtlas ~= nil and self.dSpritename ~= nil then
		if self.defaultIcon == nil then
			self.defaultIcon = UICreate.createUIAtlasImage(self.content, self.dAtlas, self.dSpritename, 0, 0, 74, 76); -- self.defaultWidth, self.defaultHeight);
			self.defaultIcon.name = "defaultIcon";
		end
		self.defaultIcon:setAltas(self.dAtlas, self.dSpritename);
		self.defaultIcon:setDepth(self.depth + 1);
		self.defaultIcon:setEnable(true);
	else
		if self.defaultIcon ~= nil then
			self.defaultIcon:setEnable(false);
		end
	end
end

function Lua_ToolImage:setDefaultIconGray(val)
	if self.defaultIcon ~= nil then
		self.defaultIcon:setGray(val);
	end
end

function Lua_ToolImage:setItemImage(atlas, spName)
	if atlas ~= nil and spName ~= nil then
		if self.item_img == nil then
			self.item_img = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, self.defaultWidth, self.defaultHeight);
			self.item_img.name = "item_img";
		end
		self.item_img:setDefault("item1", "default_item");
		self.item_img:setAltas(atlas, spName);
		self.item_img:setDepth(self.depth + 1);
		self.item_img:setEnable(true);
	else
		if self.item_img ~= nil then
			self.item_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showRtDesc(val, mustShow)
	if mustShow == true and val ~= nil and val ~= "" then
		if self.rtDescTxt == nil then
			self.rtDescTxt = UICreate.createLabel(self.content, nil, 34, 25, 71, 24, 18);
			self.rtDescTxt.name = "rtDescTxt";
			self.rtDescTxt.pivot = UIWidget.Pivot.Right;
			self.rtDescTxt.overflowMethod = UILabel.Overflow.ShrinkContent;
		end
		self.rtDescTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.rtDescTxt.effectStyle = 3;
		self.rtDescTxt.effectColorStr = Lua_ColorDefine.transColor("000000");
		self.rtDescTxt:setEffectDistance(2, 2);
		self.rtDescTxt:setDepth(self.depth + 3);
		self.rtDescTxt.text = val;
		self.rtDescTxt:setEnable(true);
	else
		if self.rtDescTxt ~= nil then
			self.rtDescTxt:setEnable(false);
		end
	end
end

function Lua_ToolImage:showNum(val, mustShow)
	if mustShow == true or val > 1 then
		local colorStr = val ~= 0 and Lua_ColorDefine.WHITE_STR or "FA3B3B";
		if self.num_txt == nil then
			self.num_txt = UICreate.createLabel(self.content, nil, 34, -25, 71, 24, self.numberSize);
			self.num_txt.name = "num_txt";
			self.num_txt.overflowMethod = UILabel.Overflow.ResizeFreely;
		end
		self.num_txt.pivot = UIWidget.Pivot.Right;
		self.num_txt.text = Lua_ColorDefine.colorStr(Lua_CommonUtil.getNumberTrans(val), colorStr);
		self.num_txt.effectStyle = 3;
		self.num_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
		self.num_txt:setEffectDistance(2, 2);
		self.num_txt:setDepth(self.depth + 5);
		self.num_txt:setEnable(true);
	else
		if self.num_txt ~= nil then
			self.num_txt:setEnable(false);
		end
	end
end

-- 显示物品等级 --自传字符串格式
function Lua_ToolImage:showItemLvl(val, mustShow)
	if mustShow == true or val ~= nil then
		if self.num == nil then
			self.num = UICreate.createLabel(self.content, nil, 0, -25, 71, 24, 18);
			self.num.name = "num";
			self.num.overflowMethod = UILabel.Overflow.ShrinkContent;
		end
		self.num.pivot = UIWidget.Pivot.Center;
		self.num.text = tostring(val);
		self.num.effectStyle = 3;
		self.num.effectColorStr = Lua_ColorDefine.transColor("000000");
		self.num:setEffectDistance(1, 1);
		self.num:setDepth(self.depth + 3);
		self.num:setEnable(true);
	else
		if self.num ~= nil then
			self.num:setEnable(false);
		end
	end
end

function Lua_ToolImage:showNumFromNumberOne(val, mustShow)
	if mustShow == true or val >= 1 then
		if self.num_txt == nil then
			self.num_txt = UICreate.createLabel(self.content, nil, 34, -25, 71, 24, self.numberSize);
			self.num_txt.name = "num_txt";
			self.num_txt.overflowMethod = UILabel.Overflow.ShrinkContent;
		end
		self.num_txt.pivot = UIWidget.Pivot.Right;
		self.num_txt.text = tostring(Lua_CommonUtil.getNumberTrans(val));
		self.num_txt.effectStyle = 3;
		self.num_txt.effectColorStr = Lua_ColorDefine.transColor("192e41");
		self.num_txt:setEffectDistance(1, 1);
		self.num_txt:setDepth(self.depth + 5);
		self.num_txt:setEnable(true);
	else
		if self.num_txt ~= nil then
			self.num_txt:setEnable(false);
		end
	end
end

function Lua_ToolImage:showNumLimit(bagNum, needNum, style, pivot, posX)
	style = style or 1;
	pivot = pivot or 1;
	local colorStr = bagNum >= needNum and Lua_ColorDefine.GREEN_STR or Lua_ColorDefine.RED_STR;
	local str = "";
	if style == 1 then
		str = LanUtil.formateStr("{1}/[{2}]{3}[-]", needNum, colorStr, bagNum);
	elseif style == 2 then
		str = LanUtil.formateStr("[{1}]{2}[-]/{3}", colorStr, bagNum, needNum);
	end

	if self.num_txt == nil then
		self.num_txt = UICreate.createLabel(self.content, nil, 0, 0, 100, self.numberSize, self.numberSize);
		self.num_txt.name = "num_txt";
		self.num_txt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.num_txt.effectStyle = 3;
		self.num_txt.effectColorStr = Lua_ColorDefine.transColor("000000");
		self.num_txt:setEffectDistance(2, 2);
	end
	if pivot == 1 then
		posX = posX or 34;
		self.num_txt.pivot = UIWidget.Pivot.Right;
	elseif pivot == 2 then
		posX = posX or 0;
		self.num_txt.pivot = UIWidget.Pivot.Center;
	elseif pivot == 3 then
		posX = posX or -34;
		self.num_txt.pivot = UIWidget.Pivot.Left;
	end
	self.num_txt.text = str;
	self.num_txt:setEnable(true);
	self.num_txt:setDepth(self.depth + 5);
	self.num_txt:setLocation(posX, -23, 0);
end

function Lua_ToolImage:showNum2(leftNum, totalNum, style)
	style = style or 1;
	local str = "";
	if leftNum ~= 0 then
		if (style == 1) then
			str = totalNum .. "/[" .. Lua_ColorDefine.GREEN_STR .. "]" .. leftNum .. "[-]";
		elseif (style == 2) then
			str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. leftNum .. "[-]/" .. totalNum;
		end
	else
		if (style == 1) then
			str = totalNum .. "/[" .. Lua_ColorDefine.RED_STR .. "]" .. leftNum .. "[-]";
		elseif (style == 2) then
			str = "[" .. Lua_ColorDefine.RED_STR .. "]" .. leftNum .. "[-]/" .. totalNum;
		end
	end

	if self.num_txt == nil then
		self.num_txt = UICreate.createLabel(self.content, nil, 34, -23, 66, 24, self.numberSize);
		self.num_txt.name = "num_txt";
	end
	self.num_txt.pivot = UIWidget.Pivot.Right;
	self.num_txt.text = str;
	self.num_txt.effectStyle = 3;
	self.num_txt.effectColorStr = Lua_ColorDefine.transColor("192e41");
	self.num_txt:setEffectDistance(0.5, 0.5);
	self.num_txt:setDepth(self.depth + 5);
	self.num_txt:setEnable(true);
end

function Lua_ToolImage:clearCdListener()
	Lua_MsgUtil.removeEventListener("ITEM_CD_UPDATE", self, self.onCheckItemCd);
	Lua_CommonUtil.removeTimer(self, self.onShowCdmask);
	self:showCDMask(false);
end

function Lua_ToolImage:addCdListener()
	if self.data ~= nil and self.data.cool ~= 0 then
		self:addLuaEvent("ITEM_CD_UPDATE", self, self.onCheckItemCd);
	end
end

function Lua_ToolImage:onCheckItemCd(o)
	if self.data ~= nil and(o == nil or o == self.data.subType) then
		local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local t = bag:getCoolTime(self.data);
		if t ~= nil and t > UnityEngine.Time.realtimeSinceStartup then
			self:addTimer("item_cd", 0.01, self, self.onShowCdmask);
			self:onShowCdmask();
		end
	end
end

function Lua_ToolImage:onShowCdmask()
	if self.data ~= nil and self.data.cool ~= 0 then
		local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local t = bag:getCoolTime(self.data);
		local nt = UnityEngine.Time.realtimeSinceStartup;
		if t ~= nil and t > nt then
		local left =(t - nt) / self.data.cool;
			self:showCDMask(true, left);
			else
			self:showCDMask(false);
		end
	else
		self:showCDMask(false);
	end
end

function Lua_ToolImage:showCDMask(val, curPer)
	if val == true then
		if self.cdMask == nil then
			self.cdMask = UICreate.createUIAtlasImage(self.content, "iconantlas2", "main_exp_bg", 0, 0, 74, 74);
			self.cdMask.name = "cdMask";
			self.cdMask.type = UIBasicSprite.Type.Filled;
			self.cdMask.fillDirection = UIBasicSprite.FillDirection.Radial360;
		end
		self.cdMask.fillAmount = Mathf.Clamp(curPer, 0, 1);
		self.cdMask:setDepth(self.depth + 7);
		self.cdMask:setEnable(true);
	else
		if self.cdMask ~= nil then
			self.cdMask:setEnable(false);
		end
	end
end

function Lua_ToolImage:showNewTip(val)
	if val == true then
		if self.new_tip == nil then
			self.new_tip = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_new", -16, 32, 44, 26);
			self.new_tip.name = "new_tip";
		end
		self.new_tip:setDepth(self.depth + 7);
		self.new_tip:setEnable(true);
	else
		if self.new_tip ~= nil then
			self.new_tip:setEnable(false);
		end
	end
end

function Lua_ToolImage:showLock(val)
	if val == true then
		if self.lock_img == nil then
			self.lock_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_suo_00", -27, -24, 16, 24);
			self.lock_img.name = "lock_img";
			self.lock_img:setScale(0.8, 0.8);
		end
		self.lock_img:setDepth(self.depth + 4);
		self.lock_img:setEnable(true);
	else
		if self.lock_img ~= nil then
			self.lock_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showMustDrop(val)
	if val == true then
		if self.must_drop_img == nil then
			self.must_drop_img = Lua_MarkItem.new(self.content, "iconantlas2", "boss_drop_mark", LanUtil.getValue(121611), 20, Color.New(1, 1, 1, 1), 0, Lua_ColorDefine.transColor("ffffff"));
			self.must_drop_img:setBgRotation(0, 0, 0);
			self.must_drop_img:setLabelRotation(0, 0, 4);
			self.must_drop_img:setLabelPos(-19, -1);
			self.must_drop_img:setBgSize(67, 38);
			self.must_drop_img:setLocation(10, -23, 0);
		end
		self.must_drop_img:setDepth(self.depth + 7);
		self.must_drop_img:setEnable(true);
	else
		if self.must_drop_img ~= nil then
			self.must_drop_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showLockSlot(val, atlasName, spName)
	if val == true then
		if self.lock_slot_img ~= nil then
			self.lock_slot_img:dispose()
			self.lock_slot_img = nil
		end
		if self.lock_slot_img == nil then
			atlasName = atlasName or "common_atlas_1";
			spName = spName or "ui_common_suo_01";
			self.lock_slot_img = UICreate.createUIAtlasImage(self.content, atlasName, spName, 0, 0, 0, 0);
			self.lock_slot_img.name = "lock_slot_img";
		end
		self.lock_slot_img:setDepth(self.depth + 5);
		self.lock_slot_img:setEnable(true);
	else
		if self.lock_slot_img ~= nil then
			self.lock_slot_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showSelected(val)
	self.selected = val;
	if val == true then
		if self.selected_img == nil then
			self.selected_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 56, 44);
			self.selected_img.name = "selected_img";
		end
		self.selected_img:setDepth(self.depth + 6);
		self.selected_img:setEnable(true);
	else
		if self.selected_img ~= nil then
			self.selected_img:setEnable(false);
		end
	end
end

-- 红点显示
function Lua_ToolImage:showRedDot(val)
	if val == true then
		if self._redDotIcon == nil then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 31, 31, 0, 0);
			self._redDotIcon.name = "redDotIcon";
			self._redDotIcon:setDepth(25);
		end
		self._redDotIcon:setEnable(true);
	else
		if self._redDotIcon ~= nil then
			self._redDotIcon:setEnable(false);
		end
	end
end

function Lua_ToolImage:showCloseSp(val, canClick, eventName, windowName, size)
	if val == true then
		if self.close_img == nil and windowName == nil then
			self.close_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_qx", 28, 28, 30, 30);
		elseif self.close_img == nil and windowName ~= nil then
			self.close_img = UICreate.createUIAtlasImage(self.content, "iconantlas1", "daojujianhao", 25, 25, 20, 20);
			if size ~= nil then
				self.close_img:SetDimensions(size.x, size.y)
			end
		end
		self.close_img.name = "close_img";
		self.close_img:setDepth(self.depth + 6);
		self.close_img:setEnable(true);
		if canClick == true then
			self.closeEvent = eventName;
			self.close_img:addClickFuntion(self, self.onCloseClick);
		else
			self.closeEvent = nil;
			self.close_img:removeClickFuntion(self, self.onCloseClick);
			self.close_img:clearListener();
		end
	else
		if self.close_img ~= nil then
			self.close_img:setEnable(false);
			self.closeEvent = nil;
			self.close_img:removeClickFuntion(self, self.onCloseClick);
			self.close_img:clearListener();
		end
	end
	if size ~= nil and canClick == true and self.close_img ~= nil then
		local bc = self.close_img.mainContent:GetComponent("BoxCollider");
		bc.isTrigger = true;
		bc.center = Vector3(0, 0, 0);
		bc.size = Vector3(size.x + 10, size.x + 10, 0);
	end
end

function Lua_ToolImage:onCloseClick(o)
	if self.closeEvent ~= nil then
		Lua_MsgUtil.callFunc(self.closeEvent, self._data);
	end
end

function Lua_ToolImage:showNoImg(val)
	if val == true then
		if self.no_img == nil then
			self.no_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_jz", 18, -21, 40, 40);
			self.no_img.name = "no_img";
		end
		self.no_img:setDepth(self.depth + 6);
		self.no_img:setEnable(true);
	else
		if self.no_img ~= nil then
			self.no_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showNotYetImg(val)
	if val == true then
		if self.not_yet_img == nil then
			self.not_yet_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_js", 18, -21, 42, 36);
			self.not_yet_img.name = "not_yet_img";
		end
		self.not_yet_img:setDepth(self.depth + 6);
		self.not_yet_img:setEnable(true);
	else
		if self.not_yet_img ~= nil then
			self.not_yet_img:setEnable(false);
		end
	end
end

function Lua_ToolImage:showStars(star)
	if star ~= nil and star > 0 then
		if self.stars == nil then
			self.stars = Array();
		end
		local len = self.stars:getSize();
		for i = 1, len do
			self.stars[i]:setEnable(false);
		end
		for i = 1, star do
			local s = nil;
			if self.stars[i] ~= nil then
				s = self.stars[i];
			else
				s = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xx", 0, 0, 28, 28);
				self.stars:add(s);
			end
			s:setDepth(self.depth + 6);
			s:setLocation(-23, 26 - 18 *(i - 1), 0);
			s:setEnable(true);
		end
	else
		if self.stars ~= nil then
			local len = self.stars:getSize();
			for i = 1, len do
				self.stars[i]:setEnable(false);
			end
		end
	end
end

function Lua_ToolImage:showBetterTip(val)
	if val ~= nil and val ~= 0 then
		if self.better_img == nil then
			self.better_img = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_js", 25, -24, 42, 36);
			self.better_img.name = "better_img";
		end
		if val == 1 then
			self.better_img:setAltas("common_atlas_1", "ui_common_xjt");
			self.better_img:resetSize();
			self:showRoundEff(self.data.roundEffect);
		else
			self.better_img:setAltas("common_atlas_1", "ui_common_xjt_b");
			self.better_img:resetSize();
			self:showRoundEff(self:getDefaultRoundState() or self.data.roundEffect);
		end
		self.better_img:setDepth(self.depth + 6);
		self.better_img:setEnable(true);
	else
		if self.better_img ~= nil then
			self.better_img:setEnable(false);
		end
		if self.data == nil then
			self:showRoundEff(false);
		else
			if self.data.force ~= 0 then
				self:showRoundEff(self.data.roundEffect);
			end
		end
	end
end

function Lua_ToolImage:getDefaultRoundState()
	if self.data == nil then
		return false;
	end
	return self.data.show_default_round_effect and(self.defaultRoundEffect == true)
end

function Lua_ToolImage:showMaskSp(val)
	if val == true then
		if self.maskSp == nil then
			self.maskSp = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 75, 75);
			self.maskSp.name = "maskSp";
		end
		self.maskSp:setDepth(self.depth + 2);
		self.maskSp:setEnable(true);
	else
		if self.maskSp ~= nil then
			self.maskSp:setEnable(false);
		end
	end
end

function Lua_ToolImage:setDepth(val)
	self:superCall("setDepth", val);
	if self.item_bg ~= nil then self.item_bg:setDepth(val) end;
	if self.item_img ~= nil then self.item_img:setDepth(val + 1) end;
	if self.maskSp ~= nil then self.maskSp:setDepth(val + 2); end
	if self.defaultIcon ~= nil then self.defaultIcon:setDepth(val) end;
	if self.new_tip ~= nil then self.new_tip:setDepth(val + 7) end;
	if self.num_txt ~= nil then self.num_txt:setDepth(val + 4) end;
	if self.num ~= nil then self.num:setDepth(val + 3) end;
	if self.rtDescTxt ~= nil then self.rtDescTxt:setDepth(val + 3) end;
	if self.lock_img ~= nil then self.lock_img:setDepth(val + 3) end;
	if self.lock_slot_img ~= nil then self.lock_slot_img:setDepth(val + 5) end;
	if self.selected_img ~= nil then self.selected_img:setDepth(val + 6) end;
	if self.no_img ~= nil then self.no_img:setDepth(val + 6) end;
	if self.close_img ~= nil then self.close_img:setDepth(val + 6) end;
	if self.not_yet_img ~= nil then self.not_yet_img:setDepth(val + 6) end;
	if self.better_img ~= nil then self.better_img:setDepth(val + 6) end;
	if self.must_drop_img ~= nil then self.must_drop_img:setDepth(val + 7) end;
	if self.cdMask ~= nil then self.cdMask:setDepth(val + 7) end;
	
	if self.stars ~= nil then
		for i = 1, self.stars:getSize() do
			self.stars[i]:setDepth(val + 6);
		end
	end
end

function Lua_ToolImage:setGray(val)
	if self.item_bg ~= nil then self.item_bg:setGray(val) end;
	if self.item_img ~= nil then self.item_img:setGray(val) end;
	if self.new_tip ~= nil then self.new_tip:setGray(val) end;
	if self.num_txt ~= nil then self.num_txt:setGray(val) end;
	if self.num ~= nil then self.num:setGray(val) end;
	if self.rtDescTxt ~= nil then self.rtDescTxt:setGray(val) end;
	if self.lock_img ~= nil then self.lock_img:setGray(val) end;
	if self.lock_slot_img ~= nil then self.lock_slot_img:setGray(val) end;
	if self.no_img ~= nil then self.no_img:setGray(val) end;
	if self.close_img ~= nil then self.close_img:setGray(val) end;
	if self.not_yet_img ~= nil then self.not_yet_img:setGray(val) end;
	if self.better_img ~= nil then self.better_img:setGray(val) end;
	if self.must_drop_img ~= nil then self.must_drop_img:setGray(val) end;
	if self.defaultIcon ~= nil then self.defaultIcon:setGray(val) end;

	if self.stars ~= nil then
		for i = 1, self.stars:getSize() do
			self.stars[i]:setGray(val);
		end
	end
end

function Lua_ToolImage:showLvlTxt(val)
	if val == true then
		if self.gm_Lvl_Txt == nil then
			self.gm_Lvl_Txt = UICreate.createLabel(self.content, "", 0, 0, 71, 30, 22);
			self.gm_Lvl_Txt.name = "gm_Lvl_Txt";
			self.gm_Lvl_Txt.pivot = UIWidget.Pivot.Right;
			self.gm_Lvl_Txt.text = "";
			self.gm_Lvl_Txt.effectColorStr = "2986344448";
			self.gm_Lvl_Txt.effectStyle = 3;
			self.gm_Lvl_Txt:setEffectDistance(1, 1);
			self.gm_Lvl_Txt:setDepth(self.depth + 10);
			self.gm_Lvl_Txt:setLocation(35, 25, 0);
		end
		if self._data ~= nil and self._data.subType == Lua_PackTypeDefine.SHENSHOU_EQU and self._data.gm_level ~= nil and self._data.gm_level ~= 0 then
			self.gm_Lvl_Txt.text = "+" .. self.data.gm_level
			self.gm_Lvl_Txt:setEnable(true);
		else
			self.gm_Lvl_Txt.text = ""
			self.gm_Lvl_Txt:setEnable(false);
		end
	else
		if self.gm_Lvl_Txt ~= nil then
			self.gm_Lvl_Txt:setEnable(false);
		end
	end
end

function Lua_ToolImage.Set:data(val)
	self._data = val;
	if val == nil then
		self:showLvlTxt(false)
		self:showNewTip(false);
		self:showNum(0, false);
		self:showLock(false);
		self:showNoImg(false);
		self:showNotYetImg(false);
		self:showItemBgByName("ui_common_prop_1");
		self:setItemImage(nil, nil);
		self:showStars(0);
		self:showBetterTip(0);
		self:showDefaultIcon(true);
		self:showQualityEff(false);
		self:showRoundEff(false);
		self:showStampEff(false);
		self:showArmyEff(false);
		self:showItemBg(true);
		self:showRtDesc(nil, false);
		self:showMaskSp(false);
		Lua_MsgUtil.removeEventListener("PUT_WING_UPDATE", self, self.onCheckWingChange);
		Lua_MsgUtil.removeEventListener("BASE_PARAM_COMPLETE", self, self.onCheckEquChange);
	else
		self:showLvlTxt(true)
		self:showQualityEff(val.bShowQualityEff);
		if val.roundEffect == true then
			self:showRoundEff(val.roundEffect);
		else
			if val.force == 0 then
				self:showRoundEff(self:getDefaultRoundState());
			end
		end
		self:showStampEff(val.subType == Lua_PackTypeDefine.STAMP_ITEM and val.stamp_type ~= 0);
        if val.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then-- 军魂
            self:showRoundEff(true);
        else
            self:showArmyEff(false);
        end
		self:setItemImage(val.atlas, val.referenceId);
		self:showNum(val.count, false);
		self:showRtDesc(val.rtDesc, true);
		self:showNewTip(self._data.newTag == 1 and self._data.packType == Lua_PackData.BAG_PACK);
		self:showLock(val.bind == 1);
		self:showDefaultIcon(false);
		if self._data.type == 1 or self._data.subType == Lua_PackTypeDefine.WING_ITEM then
			if self._data.packType == 999 then
				self:showNoImg(false);
				self:showNotYetImg(false);
				self:showMaskSp(false);
				self:showBetterTip(0);
			else
				if self._data.career ~= 0 and self._data.career ~= DataCenter.roleData.career and self._data.subType ~= Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then
					self:showNoImg(true);
					self:showMaskSp(true);
					self:showBetterTip(0);
					self:showNotYetImg(false);
				else
					self:showNoImg(false);
					if self._data.useLvl > DataCenter.roleData.level or self._data.profession > DataCenter.roleData.profession then
						self:showNotYetImg(true);
						self:showMaskSp(true);
						self:showBetterTip(0);
					else
						self:showNotYetImg(false);
						self:showMaskSp(false);
						if val.packType ~= nil and val.packType ~= 0 and val.packType ~= Lua_PackData.EQU_PACK then
							if val.subType == Lua_PackTypeDefine.WING_ITEM then-- 神翼特殊处理
								self:onCheckWingChange();
							else
								self:onCheckEquChange();
							end
						else
							self:showBetterTip(0);
						end
					end
				end
			end
			self:showStars(self._data.star);
		else
			self:showMaskSp(false);
			self:showNotYetImg(false);
			self:showNoImg(false);
			self:showStars(0);
			if val.packType == Lua_PackData.STAMP_PACK and val.stamp_type ~= 0 and DataCenter.roleData.level >= val.useLvl then
				self:onCheckEquChange();
			elseif val.packType == Lua_PackData.ARMY_PACK and DataCenter.roleData.level >= val.useLvl then
				self:onCheckEquChange();
			else
				self:showBetterTip(0);
			end
		end
		self:showMustDrop(val.mustDrop == true);
		self:showItemBg(val.bShowItemBg);
		if val.subType == Lua_PackTypeDefine.WING_ITEM and(self._data.packType ~= 999 and self._data.packType ~= nil) then
			self:addLuaEvent("PUT_WING_UPDATE", self, self.onCheckWingChange);
			Lua_MsgUtil.removeEventListener("BASE_PARAM_COMPLETE", self, self.onCheckEquChange);
		elseif self._data.type == 1 and(self._data.packType ~= 999 and self._data.packType ~= nil) then
			self:addLuaEvent("BASE_PARAM_COMPLETE", self, self.onCheckEquChange);
			Lua_MsgUtil.removeEventListener("PUT_WING_UPDATE", self, self.onCheckWingChange);
		else
			Lua_MsgUtil.removeEventListener("PUT_WING_UPDATE", self, self.onCheckWingChange);
			Lua_MsgUtil.removeEventListener("BASE_PARAM_COMPLETE", self, self.onCheckEquChange);
		end
	end
end

function Lua_ToolImage:onCheckEquChange()
	if self._data == nil or self.noCompare == true then
		return;
	end

	if self._data.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖
		if DataCenter.funcOpenData:isOpened(10221) == true then
			local zodiacVo = DataCenter.zodiacUtil:getZodiacVoById(self._data.career); -- 生肖Vo
			if zodiacVo ~= nil then
				local holeVo = zodiacVo:getHoleVoByPart(self._data.part); -- 孔位Vo
				if holeVo.equipVo == nil then
					self:showBetterTip(2);
				else
					if self._data.force > holeVo.equipVo.force then
						self:showBetterTip(2);
					elseif self._data.force < holeVo.equipVo.force then
						self:showBetterTip(1);
					else
						self:showBetterTip(0);
					end
				end
			end
			return;
		end
	end

	if self._data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 骑装
		if DataCenter.funcOpenData:isOpened(10141) == true then
			local mountEqu = DataCenter.mountEquipData:getArrByPartData(self._data.part);
			if mountEqu == nil then
				self:showBetterTip(2);
			else
				if self._data.force > mountEqu.mountEquipVo.force then
					self:showBetterTip(2);
				elseif self._data.force < mountEqu.mountEquipVo.force then
					self:showBetterTip(1);
				else
					self:showBetterTip(0);
				end
			end
			return;
		end
	end

	if self._data.subType == Lua_PackTypeDefine.STAMP_ITEM then -- 魂印
		if DataCenter.funcOpenData:isOpened(10161) == true then
			local vo = DataCenter.stampData:getArrByStampInfo(self._data.part);
			if vo ~= nil then
				if self._data.force > vo.stampVo.stampBascForce then
					self:showBetterTip(2);
				else
					self:showBetterTip(0);
				end
			else
				if DataCenter.stampData:isUnlockStamp(self._data.part) == true then
					self:showBetterTip(2);
				else
					self:showBetterTip(0);
				end
			end
			return;
		end
	end

	if self._data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then -- 军魂
		if DataCenter.funcOpenData:isOpened(10193) == true then
			if self._data.isSameType == true or self._data.isShowItemReplaceRed == true then
				self:showBetterTip(2);
			else
				self:showBetterTip(0);
			end
			return;
		end
	end

	if self._data.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
		local myEqu = DataCenter.sacredAnimalData:getAnimalEquipByPart(self._data.part);
		if myEqu == nil then
			self:showBetterTip(2);
		else
			if self._data.force > myEqu.force then
				self:showBetterTip(2);
			elseif self._data.force < myEqu.force then
				self:showBetterTip(1);
			else
				self:showBetterTip(0);
			end
		end
		return;
	end

	if self._data.career ~= 0 and self._data.career ~= DataCenter.roleData.career then
		self:showBetterTip(0);
		return;
	end

	if self._data.useLvl > DataCenter.roleData.level or self._data.profession > DataCenter.roleData.profession then
		self:showBetterTip(0);
		return;
	end

	if self._data.type == 1 and self._data.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
		local myEqu = DataCenter.equData:getEquByPart(self._data.part);
		if myEqu == nil then
			self:showBetterTip(2);
		else
			if self._data.score > myEqu.score then -- force改为score，用装备评分代替
				self:showBetterTip(2);
			elseif self._data.score < myEqu.score then
				self:showBetterTip(1);
			else
				self:showBetterTip(0);
			end
		end
	end
end

-- 神翼变换监听
function Lua_ToolImage:onCheckWingChange()
	if self._data == nil then
		return;
	end
	local hideArrow = self._data.useLvl > DataCenter.roleData.level;
	if self._data.career ~= 0 and self._data.career ~= DataCenter.roleData.career then
		hideArrow = true;
	end
	if self._data.profession > DataCenter.roleData.profession then
		hideArrow = true;
	end
	if hideArrow then
		self:showBetterTip(0);
		return;
	end

	local wingForce = DataCenter.GodWingData:getForce();
	if wingForce > self._data.force then
		self:showBetterTip(1);
	elseif wingForce < self._data.force then
		self:showBetterTip(2);
	else
		self:showBetterTip(0);
	end
end

-- 显示背景
function Lua_ToolImage:showItemBg(bShowItemBg)
	if self._data == nil or self.item_bg == nil then
		return;
	end

	local altasSize = self._data.altasSize;
	if bShowItemBg ~= true then -- 灵纹不需要显示底框
		self.item_bg.alpha = 0.01;
		if self.item_img ~= nil then
			if altasSize ~= nil then
				self.item_img:SetDimensions(altasSize[1], altasSize[2]);
			else
				self.item_img:SetDimensions(76, 76);
			end
		end
	else
		if self.item_img ~= nil then
			if altasSize ~= nil then -- 默认大小
				local sw = self.defaultWidth / altasSize[1];
				local sh = self.defaultHeight / altasSize[2];
				if sw > sh then
					self.item_img:SetDimensions(altasSize[1] * sh, altasSize[2] * sh);
				else
					self.item_img:SetDimensions(altasSize[1] * sw, altasSize[2] * sw);
				end
			else
				self.item_img:SetDimensions(self.defaultWidth, self.defaultHeight);
			end
		end

		self.item_bg.alpha = 1;
		if self._data.subType == Lua_PackTypeDefine.STAMP_ITEM and self._data.stamp_type ~= 0 then
			self:showItemBgByName("ui_common_prop_1");
		elseif self._data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
			self:showItemBgByName("ui_common_prop_1");
		else
			local color = self._data.color;
			if color >= 1 and color <= 6 then
				self:showItemBgByName("ui_common_prop_" .. 1 + color);
			else
				self:showItemBgByName("ui_common_prop_6");
			end
		end
	end
end

function Lua_ToolImage:showItemBgByName(stringName)
	self.item_bg:setAltas("common_atlas_1", stringName);
end

function Lua_ToolImage.Get:data()
	return self._data;
end

function Lua_ToolImage:onIconClick(go)
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self._data, false, false, self.isShowBtns);
	elseif self.setOutputId ~= nil then
		Lua_WindowUtil.openWin("Lua_OutputWindow", nil, self.setOutputId);
	end
end

-- 是否显示tip右侧按钮
function Lua_ToolImage.Set:isShowBtns(val)
	self._isShowBtns = false;
end

function Lua_ToolImage.Get:isShowBtns()
	return self._isShowBtns;
end

-- 显示特效 背景一块的特效
function Lua_ToolImage:showQualityEff(bShowEff)
	bShowEff = bShowEff == nil and false or bShowEff;
	if self._data ~= nil and bShowEff == true then
		local str = "gui_award_light0" .. self._data.color;
		if self.qualityEff == nil then
			self.qualityEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
			self.qualityEff.name = "qualityEff";
			self.qualityEff:setLoop(true);
			self.qualityEff:setSacle(700, 700, 1);
			self.qualityEff:SetRenderQueue(self.item_bg, -1, 2);
		else
			self.qualityEff:setUrl("/effects/scsEffects/" .. str, str);
		end
	else
		if self.qualityEff ~= nil then
			self.qualityEff:dispose();
			self.qualityEff = nil;
		end
	end
end

function Lua_ToolImage:showRoundEffectView(val)
	self.roundEffectView = val;
	if self.roundEffectView == true then
		if self.roundEff ~= nil then
			self.roundEff:setEnable(true);
		end
	else
		if self.roundEff ~= nil then
			self.roundEff:setEnable(false);
		end
	end
end

-- 显示特效 转圈特效
function Lua_ToolImage:showRoundEff(bShowEff)
	bShowEff = bShowEff == nil and false or bShowEff;

	if self._data ~= nil and bShowEff == true then
		if self._data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
			self:showArmyEff(bShowEff);
			if self.roundEff ~= nil then
				self.roundEff:dispose();
				self.roundEff = nil;
			end
			return;
		end

		local str = nil;
		if self._data.color == 3 then
			str = "gui_purple_box";
		elseif self._data.color == 4 then
			str = "gui_orange_box";
		elseif self._data.color == 5 then
			str = "gui_red_box";
		elseif self._data.color == 2 then
			str = "gui_blue_box";
		elseif self._data.color == 6 then
			str = "gui_pink_box";
		end
		if str == nil then return; end

		if self.roundEff == nil then
			self.roundEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
			self.roundEff.name = "roundEff";
			self.roundEff:setLoop(true);
			self.roundEff:SetRenderQueue(self.item_bg, 5, 2);
		else
			self.roundEff:setUrl("/effects/scsEffects/" .. str, str);
		end
	else
		if self.roundEff ~= nil then
			self.roundEff:dispose();
			self.roundEff = nil;
		end
		if self.armyEff ~= nil then
			self.armyEff:dispose();
			self.armyEff = nil;
		end
	end
end

-- 显示特效 魂印特效
function Lua_ToolImage:showStampEff(bShowEff)
	bShowEff = bShowEff == nil and false or bShowEff;

	if self._data ~= nil and bShowEff == true then
		local str = self._data.stamp_effect;
		if str == nil then
			if self.stampEff ~= nil then
				self.stampEff:dispose();
				self.stampEff = nil;
			end
			return;
		end
		if self.stampEff == nil then
			self.stampEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
			self.stampEff.name = "stampEff";
			self.stampEff:setLoop(true);
			self.stampEff:SetRenderQueue(self.item_bg, 5, 2, false);
		else
			self.stampEff:setUrl("/effects/scsEffects/" .. str, str);
		end
	else
		if self.stampEff ~= nil then
			self.stampEff:dispose();
			self.stampEff = nil;
		end
	end
end

-- 显示特效 军魂特效
function Lua_ToolImage:showArmyEff(bShowEff)
	if self._data ~= nil and bShowEff == true then
		local str = self._data.army_effect;
		if str == nil then
			if self.armyEff ~= nil then
				self.armyEff:dispose();
				self.armyEff = nil;
			end
			return;
		end
		if self.armyEff == nil then
			self.armyEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
			self.armyEff.name = "armyEff";
			self.armyEff:setLoop(true);
			self.armyEff:SetRenderQueue(self.item_bg, 0, 2, false);
		else
			self.armyEff:setUrl("/effects/scsEffects/" .. str, str);
		end
	else
		if self.armyEff ~= nil then
			self.armyEff:dispose();
			self.armyEff = nil;
		end
	end
end