-- 藏宝阁结算界面
Lua_TreasureResultWindow = class("Lua_TreasureResultWindow", Lua_FullSizeWindow);
function Lua_TreasureResultWindow:ctor()
    self:superCall("ctor");

    self.bgPath = "/images/treasureActivity/ui_treasure_bg_10.jpg";
    self.showClose = false;
    self.showTitle = false;
    self.showMoney = false;
    self.isClickClose = false;
    self.bShowRuneChips = false;
    self.bShowRuneCrystal = false;
    self.isShowNewTags = false;
    self.needItemName = true;
    self.itemWidth = 160;
    self.itemHeight = 140;
    self.needShowIconBg = true;
    self.skinName = "TreasureResultWindow_skin";
end

function Lua_TreasureResultWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self.againBtn:addClickFuntion(self, self.onAgainBtnClick);
    self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

    if self.bShowRuneChips == true then
        self.sureBtn:setLocation(-135, -285);
        self.againBtn:setLocation(135, -285);

        self.huanwenBg = UICreate.createUIAtlasImage(self.content, "copy_atlas_2", "ui_fuben_title_01", 0, -205, 508, 58);
        self.huanwenBg:setDepth(2);

        self.numTxt = UICreate.createLabel(self.content, "", -115, -205, 360, 30, 24);
        self.numTxt:setDepth(3);
        self.numTxt.pivot = UIWidget.Pivot.Left;
    end

    if self.bShowRuneCrystal == true then -- 灵晶
        self.sureBtn:setLocation(-135, -285);
        self.againBtn:setLocation(135, -285);

        self.crystalTxt = UICreate.createLabel(self.content, "", -115, -220, 360, 30, 24);
        self.crystalTxt:setDepth(3);
        self.crystalTxt.pivot = UIWidget.Pivot.Left;

        self.itemBg = UICreate.createUIAtlasImage(self.content, "item9", "201060101", 16, -220, 40, 40);
        self.itemBg:setDepth(2);
        self.itemBg:addClickFuntion(self, self.onIconClick);
    end
end
function Lua_TreasureResultWindow:setSubBtnPos(x, y)
    if self.sureBtn ~= nil then
        self.sureBtn:setLocation(x, y);
    end
end
function Lua_TreasureResultWindow:setAgainBtnState(bol)
    if self.againBtn ~= nil then
        self.againBtn.mainContent:SetActive(bol);
    end
end

function Lua_TreasureResultWindow:setShowResultData(arr, chipNum, rtDesc)
    self:clearEff();
    if arr ~= nil then
        local len = arr:getSize();
        if len > 0 then
            -- 表现
            local startX =(len < 5) and(-((len - 1) * self.itemWidth) / 2) or(-(4 * self.itemWidth) / 2);
            local startY =(math.ceil(len / 5) * self.itemHeight - 20) / 2 - 52;
            self.rewardsArr = Array();
            for i = 1, len do
                local item = Lua_TreasureResultItem.new(self.content, self.needShowIconBg, self.isShowNewTags);
                item:setDepth(1);
                item:setNeedName(self.needItemName);
                item:setData(arr[i]);
                local numX =(i - 1) % 5;
                local numY = math.floor((i - 1) / 5);
                item:setLocation(startX + numX * self.itemWidth, startY - numY * self.itemHeight, 0);
                item:setScale(1.3, 1.3);
                item:setEnable(false);
                if rtDesc ~= nil then
                    item:setShowRtDesc(rtDesc[i]);
                end
                self.rewardsArr:add(item);
            end

            self.rewardsNum = 1;
            if len > 1 and self.bStart == nil or self.bStart == false then
                Lua_CommonUtil.addTimer("playRewardItemEffect", 0.1, self, self.playRewardItemEffect, nil, -1);
                self.bStart = true;
            end
            self:playEffEct();
        end
    end

    if self.bShowRuneChips == true then
        self.numTxt.text = LanUtil.formateStr(LanUtil.getValue(121410), tostring(chipNum));
    end

    if self.bShowRuneCrystal == true then
        local num = DataCenter.treasureData.getRuneCrystalNum;
        if num ~= 0 then
            self.crystalTxt.uiwidget.gameObject:SetActive(true);
            self.crystalTxt.text = LanUtil.formateStr(LanUtil.getValue(121438), tostring(num));
            
            self.itemBg:setEnable(true);
            self.huanwenBg:SetDimensions(508, 68);
            self.numTxt:setLocation(-115, -192);
        else
            self.itemBg:setEnable(false);
            self.crystalTxt.uiwidget.gameObject:SetActive(false);
            self.huanwenBg:SetDimensions(508, 58);
            self.numTxt:setLocation(-115, -205);
        end
    end
end

function Lua_TreasureResultWindow:onIconClick()
    local tvo = Lua_ToolVo.new(tonumber(201060101))
    Lua_PackUtil.showItemInfo(tvo,false,nil,true);
end

function Lua_TreasureResultWindow:onSureBtnClick(go)
    self:hide();
end

function Lua_TreasureResultWindow:onAgainBtnClick(go)
    self:hide();
end

-- 播放动画
function Lua_TreasureResultWindow:playRewardItemEffect()
    self.rewardsNum = self.rewardsNum + 1;
    if self.rewardsNum >= self.rewardsArr:getSize() then
        if self.bStart == true then
            Lua_CommonUtil.removeTimer(self, self.playRewardItemEffect);
            self.bStart = false;
        end
    end
    self:playEffEct();
end

-- 动画
function Lua_TreasureResultWindow:playEffEct()
    local item = self.rewardsArr[self.rewardsNum];
    item:setEnable(true);
    TweenUtil.getInstance():addTween(item.content, 0.3, 0, nil, nil, Vector3(1, 1, 1));
end

function Lua_TreasureResultWindow:clearEff()
    if self.bStart ~= nil and self.bStart == true then
        Lua_CommonUtil.removeTimer(self, self.playRewardItemEffect);
        self.bStart = false;
    end

    if self.rewardsArr ~= nil then
        for i = 1, self.rewardsArr:getSize() do
            local item = self.rewardsArr[i];
            TweenUtil.getInstance():stop(item.content);
            item:dispose();
        end
        self.rewardsArr:clear();
        self.rewardsArr = nil;
    end
end

function Lua_TreasureResultWindow:dispose()
    self:clearEff();
    self:superCall("dispose");
end






-- 结算奖励item
Lua_TreasureResultItem = class("Lua_TreasureResultItem", Lua_DisplayObject);
function Lua_TreasureResultItem:ctor(p, bShowBg, isShowNewTags)
    self.isNeedName = true;
    self.bShowBg =(bShowBg == nil) and true or bShowBg;
    if isShowNewTags == nil then
        self.isShowNewTags = false
    else
        self.isShowNewTags = isShowNewTags
    end
    self:superCall("ctor", p, nil);
end

function Lua_TreasureResultItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "wpk_01", 0, 0, 80, 80);
    self.bg:setDepth(2);
    self.bg.alpha = 0.01;
    self.bg:addClickFuntion(self, self.onIconClick);

    -- 道具图标
    if self.bShowBg == false then
        self.item_img = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
        self.item_img:setDefault("item1", "default_item");
        self.item_img:setDepth(3);
        -- self.item_img:addClickFuntion(self, self.onIconClick);
    else
        self.item = Lua_ToolImage.new(self.content);
        self.item:setDepth(10);
        self.item:setLocation(0, 0, 0);
        self.item:setCanClick(false);
    end

    -- 道具名
    self.itemName = UICreate.createLabel(self.content, "", 0, -65, 360, 30, 24);
    self.itemName:setDepth(3);
    self.itemName.pivot = UIWidget.Pivot.Center;
end

function Lua_TreasureResultItem:onIconClick(go)
    if self.data ~= nil then
        Lua_PackUtil.showItemInfo(self.data, false, nil, false);
    end
end

function Lua_TreasureResultItem:setData(vo)
    self.data = vo;
    if vo ~= nil and self.isNeedName == true then
        self.itemName.text = vo.colorName;
    else
        self.itemName.text = "";
    end

    if self.bShowBg == true then
        self:showQualityEff(false);
        self.item.data = vo;
        self.item:showNewTip(self.isShowNewTags)
    else
        if vo ~= nil and vo.atlas ~= nil and vo.referenceId ~= nil then
            self.item_img:setEnable(true);
            self.item_img:setAltas(vo.atlas, vo.referenceId);
            self:showQualityEff(true);
        else
            self:showQualityEff(false);
            self.item_img:setEnable(false);
        end
    end
end

function Lua_TreasureResultItem:setNeedName(val)
    self.isNeedName = val;
end

-- 显示特效
function Lua_TreasureResultItem:showQualityEff(bShowEff)
    bShowEff = bShowEff == nil and false or bShowEff;
    if self.data ~= nil and bShowEff == true then
        local str = "gui_award_light0" .. self.data.color;
        if self.qualityEff == nil then
            self.qualityEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
            self.qualityEff:setLoop(true);
            self.qualityEff:setSacle(500, 500, 500);
            self.qualityEff:SetRenderQueue(self.item_img, -1, 2);
        else
            self.qualityEff:setUrl("/effects/scsEffects/" .. str, str);
        end
    else
        if self.qualityEff ~= nil then
            self.qualityEff:dispose();
            self.qualityEff = nil;
        end
    end
end

function Lua_TreasureResultItem:setShowRtDesc(data)
    if data ~= nil then
        if data.isGodFurnace == 1 and data.val ~= 0 then
            self.item:showRtDesc(LanUtil.formateStr(LanUtil.getValue(144503), tostring(data.val)), true);
        end
    end
end

function Lua_TreasureResultItem:dispose()
    self:showQualityEff(false);

    self:superCall("dispose");
end