Lua_Window = class("Lua_Window", Lua_EventOwner);
Lua_Window.frameBuild = false;
function Lua_Window:ctor()
	self.w = 500;
	self.h = 500;
	self.winOffsetX = 0;
	self.winOffsetY = 0;
	self.btnCloseOffsetX = -32;
	self.btnCloseOffsetY = -26;

	self.depth = 0;
	self.layer = 3500;
	self.bgSprite = "ui_common_widget_05";
	self.blackAlpha = 1;
	self.isModel = true;
	self.showBg = false;
	self.showClose = true;
	self.isClickClose = false;

	-- C#
	self.offsetDepth = 10;
	self.showBlackMask = true;
	self.setHasBlackMask = false;

	self.windowName = "windowName";
	self.skinName = nil;

	self:superCall("ctor");
end

function Lua_Window:buildPanel(go)
	self.windowObj = UICreate.createGameObject(go,0,0,0);
	self.windowObj.name = self.windowName;

	self.content = UICreate.createGameObject(self.windowObj, 0, 0, 0);
	self.content.name = "content";
	-- self.content.transform.localScale = Vector3.one;
	-- self.content.transform.localPosition = Vector3.zero;
	LuaUtil.setObjScale(self.content, 1, 1, 1);
	LuaUtil.setObjPos(self.content, 0, 0, 0);

	self.contentPanel = self.content:AddComponent(typeof(UIPanel));
	self.contentPanel.depth = 3500;
	self.contentPanel.startingRenderQueue = 3500;
	self.contentPanel.renderQueue = UIPanel.RenderQueue.StartAt;

	if Lua_Window.frameBuild == true and self.skinName ~= nil then
		self.skinBuilded = false;
		self.delayFunArr = Array();
		self.skinTable = checkRequire(self.skinName);
		self.conTable = {};
		self.conTable["content"] = self["content"];
		self.itemIndex = 1;
		Lua_CommonUtil.addTimer("BuildItem", 0.001, self, self.onBuildingItem);
	else
		self.skinBuilded = true;
		self:buildFromSkin();
		self:buildShowItem();
	end
end

function Lua_Window:onBuildingItem()
	local isEnd = false;
	for i = 1, 5 do
		isEnd = Lua_WindowUtil.buildFromSkinEachFrame(self, self.skinTable, self.conTable, self.itemIndex);
		if isEnd == true then
			break;
		else
			self.itemIndex = 1 + self.itemIndex;
		end
	end

	if isEnd == true then
		self.conTable = nil;
		self.skinTable = nil;
		self.skinBuilded = true;
		Lua_CommonUtil.removeTimer(self, self.onBuildingItem);

		self:buildShowItem();
		self:updateWindowDepth();
		if self.delayShowWin == true then
			self:doShowWin();
		end

		for i = 1, self.delayFunArr:getSize() do
			self.delayFunArr[i].fun(self, self.delayFunArr[i].param);
		end
	end
end

function Lua_Window:updateWindowDepth()
	LuaUtil.updateWindowDepth(self.windowName);
end

function Lua_Window:buildFromSkin()
	if self.skinName ~= nil then
		Lua_WindowUtil.buildFromSkin(self, self.skinName, self.content);
	end
end

function Lua_Window:buildShowItem()
	if self.showBg == true and self.winBg == nil then
		self.winBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", self.bgSprite, self.winOffsetX, self.winOffsetY, self.w, self.h);
		self.winBg.name = "winBg";
		self.winBg:setDepth(-1);
	end

	if self.winBg ~= nil then
		self.winBg.clickScale = false;
		self.winBg:addClickFuntion(self, self.onBgClick);
	end

	if self.showClose == true and self.btnClose == nil then
		self.btnClose = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_btn_gb", 0, 0, 0, 0);
		self.btnClose.name = "btnClose";
		self.btnClose.depth = self.depth + 10;
		self.btnClose:setLocation(self.w / 2 + self.winOffsetX + self.btnCloseOffsetX, self.h / 2 + self.winOffsetY + self.btnCloseOffsetY, 0);
	end

	if self.btnClose ~= nil then
		self.btnClose:addClickFuntion(self, self.onBtnCloseClick);		
	end

	if self.isModel == true then
		self.maskBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_zhezhao", 0, 0, 0, 0);
		self.maskBg.name = "maskBg";
		self.maskBg.alpha = self.blackAlpha;
		self.maskBg:setDepth(-10);
		self.maskBg:SetDimensions(2560, 2000);
		self.maskBg:addClickFuntion(self, self.onMaskClick);
	end
end

function Lua_Window:setShowData(v)
	if self.skinBuilded == true or Lua_Window.frameBuild == false then
		self:doShowWin();
	else
		self.delayShowWin = true;
	end
end

function Lua_Window:doShowWin()
	self.delayShowWin = false;
	local showWinData = Lua_WindowUtil.getWinData(self.windowName, true);

	local showWinDataArr = Lua_WindowUtil.getWinListData(self.windowName, true);
	if showWinDataArr ~= nil and showWinDataArr:getSize() > 0 then
		for i = 1, showWinDataArr:getSize() do
			self:showWin(showWinDataArr[i]);
		end
	end
end

function Lua_Window:showWin(param)
	self.showData = param;
end

function Lua_Window:setDepth(v)
	self.depth = v;
end

function Lua_Window:setBlackMaskFun(val)
	if self.maskBg ~= nil then
		self.maskBg:setEnable(val);
	end
end

function Lua_Window:getPreLoadList()
	if self.skinName ~= nil then
		-- local arr = Lua_WindowUtil.getPreLoadList(self.skinName);
		-- return arr;
	end
	return nil;
end

function Lua_Window:onBgClick(go)
end

function Lua_Window:onBtnCloseClick(go)
	self:hide();
	Lua_WindowUtil.openWin("Lua_DragDownWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_CLOSE);
end

function Lua_Window:hide()
	Lua_WindowUtil.openWin(self.windowName, WinParam.ACTION_CLOSE);
end

function Lua_Window:onMaskClick(go)
	if self.isClickClose == true then
		self:hide();
	end
end

function Lua_Window:dispose()
	if self.winBg ~= nil then
		self.winBg:dispose();
		self.winBg = nil;
	end
	if self.btnClose ~= nil then
		self.btnClose:dispose();
		self.btnClose = nil;
	end
	if self.maskBg ~= nil then
		self.maskBg:dispose();
		self.maskBg = nil;
	end
	-- if self.content ~= nil and IsNil(self.content) == false then
	-- 	UnityEngine.GameObject.Destroy(self.content);
	-- 	self.content = nil;
	-- end
	-- if self.windowObj ~= nil and IsNil(self.windowObj) == false then
	-- 	UnityEngine.GameObject.Destroy(self.windowObj);
	-- 	self.windowObj = nil;
	-- end
	Lua_CommonUtil.removeTimer(self, self.onBuildingItem);

	self:superCall("dispose");
end