DataCenter = nil;
local isInit = false;

function getVersionStr()
    local version_time = "version_time";
    return version .. "." .. version_time;
end

function getLuaVersion()
    return "1.4.9.0_20011301"; 
end

function getCVersion() 
    if c_version == nil then
        c_version = tonumber(LanUtil.getValue(578));
    end
    return c_version;
end

function getPackName()--包号
    return DataCenter.roleData.market_code;
end

function getAgentName()--渠道
    return DataCenter.roleData.agent;
end

function isHeadReplaceOpen()--自定义头像是否开启
    if getShowTips() == false then
        return false;
    end
    
    if headReplace == nil then
        local str = CommonUtil.getVersionInfo();
        local arr = string.split(str,"|");
        local inlayVersion = tonumber(arr[1]);
        headReplace = (inlayVersion >= 201812050001) or (inlayVersion == -1);
    end
    return headReplace;
end

--0国内，1韩语, 2繁体, 3公会
function getLanType()--语言版本
    if c_lanType == nil then
        c_lanType = tonumber(LanUtil.getValue(577));
        if c_lanType == 577 then
            c_lanType = 0;
        end
    end
    return c_lanType;
end

function getPid()--pid
    if pid == nil then
        initReflection();
        local a = typeof(PlayerData);
        local b = tolua.getfield(a,"pid"); 
        if b == nil then
            pid = -1;
        else
            pid = b:Get(PlayerData.getInstance());
        end 
    end
    return pid;
end

function getGid()--gid
    if gid == nil then
        initReflection();
        local a = typeof(PlayerData);
        local b = tolua.getfield(a,"gid"); 
        if b == nil then
            gid = -1;
        else
            gid = b:Get(PlayerData.getInstance());
        end 
    end
    return gid;
end

function getShowTips()
    if coreShowTips == nil then
        if getCVersion() < 1258 then
            coreShowTips = true;
        else
            coreShowTips = PlayerData.getInstance().phpData.no_func_open_tips == 0;
        end
    end
    return coreShowTips;
end

function getRechargeStyle()
    if getCVersion() < 1258 then
        return 0;
    end
    return PlayerData.getInstance().phpData.recharge_style;
end

function initDebug()
    --local breakInfoFun, xpcallFun = require("LuaDebug")("localhost", 7003);
end

function initReflection()
    if DataCenter.initReflection == nil then
        DataCenter.initReflection = 1;
        require "tolua.reflection";
        tolua.loadassembly("Assembly-CSharp");
        tolua.loadassembly("mscorlib");
        print("CommonUtil.isGooglePlatform64 = ", CommonUtil.isGooglePlatform64);
        if CommonUtil.isApplePlatform == false and CommonUtil.isGooglePlatform64 == false then
            if tostring(UnityEngine.Application.platform) ~= "WindowsEditor" or GlobalVar.luaDecodeType == 2 then
                tolua.loadassembly("work");
            end
        end
        local BindingFlags = require 'System.Reflection.BindingFlags'
    end
end

function initLua()
    checkRequire("Array");
    checkRequire("ProtoPublic_pb");
    checkRequire("Time");
    checkRequire("coroutine2");
    checkRequire("Lua_DisplayObject");
    checkRequire("Lua_EventOwner");
    checkRequire("Lua_ColorDefine");
    checkRequire("Lua_WindowUtil");
    checkRequire("Lua_CommonUtil");
    checkRequire("Lua_RewardsUtil");
    checkRequire("Lua_SocketManager");
    checkRequire("Lua_Window");
    checkRequire("Lua_DragContainer");
    checkRequire("Lua_FullSizeWindow");
    checkRequire("Lua_FullSizeTabBaseWindow");
    checkRequire("Lua_FullSizeTabWindow");
    checkRequire("Lua_FullSizeTabLeftWindow");
    checkRequire("Lua_SpecialFullSizeTabLeftWindow")
    checkRequire("Lua_SecondSizeWindow");
    checkRequire("Lua_ThirdSizeWindow");
    checkRequire("Lua_ProxyManager");
    checkRequire("Lua_RewardItem");
    checkRequire("Lua_ToolImage");
    checkRequire("Lua_NumberImage");
    checkRequire("Lua_MapEffect");
    checkRequire("Lua_ThingTableGen");
    checkRequire("Lua_ButtonList");
    checkRequire("Lua_SliderProgressBar");
    checkRequire("Lua_TextArea");
    checkRequire("Lua_DragList");
    checkRequire("Lua_HookControl");
    checkRequire("Lua_TaskHookControl");
    checkRequire("Lua_CShaprFunction");
    checkRequire("Lua_NeverTipData");
    checkRequire("Lua_Rectangle");
    checkRequire("Lua_DragSubButtonList");
    checkRequire("Lua_DragTitleList");
    checkRequire("Lua_MenuPopListData");
    checkRequire("Lua_FightUtil");
    checkRequire("Lua_MarkItem");
    checkRequire("Lua_RewardDragItem");
    checkRequire("uilang");
    checkRequire("Lua_TreasureResultWindow");
    checkRequire("Lua_StringArray");
    checkRequire("Lua_SectionProccessBar");
    checkRequire("Lua_DragCustomBtnList");
    checkRequire("Lua_HeadIconItem");
    checkRequire("Lua_ShowItem");
    checkRequire("Lua_DragSecButtonList");
    checkRequire("Lua_PlatformUtil");
    checkRequire("Lua_LoadFileType");
    checkRequire("Lua_ActivityBaseWindow");
    checkRequire("Lua_SDKInterface");

    DataCenter = { };
    DataCenter.sdkInterface = Lua_SDKInterface.new();

    Lua_SocketManager.getInstace():init();
    Lua_ColorDefine.initColor();
    Lua_ProxyManager.initProxy();
    addEvents();
    initComponentStyle();
end

function addEvents()
    isInit = true;
    -- MsgUtil.addEventListener("ENTER_FRAME", nil, onEnterFrame);
    MsgUtil.addEventListener("FIRST_ENTER_GAME", nil, onFirstEnterGame);
    MsgUtil.addEventListener("SCENE_LOADED", nil, onSceneLoaded);
    MsgUtil.addEventListener("ENTER_MIRROR_MAP", nil, onEnterMirrorMap);
    MsgUtil.addEventListener("ENTER_OR_EXIT_MIRROR_MAP", nil, onEnterOrExitMirrorMap);
end

function initComponentStyle()
    -- C#已添加 这里方便查看
    -- UICreate.addStyle(1, "common_atlas_1", "ui_common_btn_02", "ui_common_btn_02");
    -- UICreate.addStyle(2, "common_atlas_1", "ui_common_widget_gouxuan2", "ui_common_widget_gouxuan");
    
    UICreate.addStyle(12, "common_atlas_1", "ui_common_btn_01", "ui_common_btn_01");
    UICreate.addStyle(13, "common_atlas_1", "ui_common_btn_02", "ui_common_btn_02");
    UICreate.addStyle(14, "common_atlas_1", "ui_common_btn_03", "ui_common_btn_03");
    UICreate.addStyle(15, "common_atlas_1", "ui_common_btn_04", "ui_common_btn_04");
    UICreate.addStyle(16, "common_atlas_1", "ui_common_btn_8", "ui_common_btn_8");
    UICreate.addStyle(17, "common_atlas_1", "ui_common_btn_9", "ui_common_btn_9");
    UICreate.addStyle(18, "common_atlas_1", "ui_common_widget_gouxuan2", "ui_common_widget_gouxuan");
    UICreate.addStyle(19, "common_atlas_1", "ui_common_btn_p1", "ui_common_btn_p1");
    UICreate.addStyle(20, "common_atlas_1", "ui_common_btn_p5", "ui_common_btn_p5");
    UICreate.addStyle(21, "common_atlas_1", "ui_common_btn_p6", "ui_common_btn_p6");
    UICreate.addStyle(22, "common_atlas_2", "ui_common_btn_01_yy", "ui_common_btn_01_yy");
    UICreate.addStyle(23, "common_atlas_1", "ui_common_btn_p7", "ui_common_btn_p7");
    UICreate.addStyle(24, "yinyuan_altas", "ui_marriage_btn_01", "ui_marriage_btn_01");
    UICreate.addStyle(25, "yinyuan_altas", "ui_marriage_btn_02", "ui_marriage_btn_02");
    UICreate.addStyle(26, "common_atlas_2", "ui_common_btn_14", "ui_common_btn_14");
    UICreate.addStyle(27, "common_atlas_1", "ui_common_btn_x9", "ui_common_btn_x9");
    UICreate.addStyle(28, "mainWindow_atlas", "ui_zhujiemian_btn_07", "ui_zhujiemian_btn_07");
    UICreate.addStyle(29, "common_atlas_1", "ui_common_btn_p8", "ui_common_btn_p8");
    UICreate.addStyle(30, "common_atlas_1", "ui_common_btn_x8", "ui_common_btn_x8");
    UICreate.addStyle(31, "common_atlas_1", "ui_common_btn_c1", "ui_common_btn_c1");
    UICreate.addStyle(32, "common_atlas_1", "ui_common_btn_c2", "ui_common_btn_c2");
    UICreate.addStyle(33, "common_atlas_1", "ui_common_btn_13", "ui_common_btn_13");
    UICreate.addStyle(34, "common_atlas_2", "ui_common_btn_teshu_01", "ui_common_btn_teshu_01");
    UICreate.addStyle(35, "yinyuan_altas", "ui_marriage_btn_05", "ui_marriage_btn_05");
    UICreate.addStyle(36, "recharge_atlas", "ui_chongzhi_btn_01", "ui_chongzhi_btn_01");
    UICreate.addStyle(37, "recharge_atlas", "ui_chongzhi_btn_02", "ui_chongzhi_btn_02");
    UICreate.addStyle(38, "recharge_atlas", "ui_chongzhi_btn_03", "ui_chongzhi_btn_03");
    UICreate.addStyle(39, "common_atlas_1", "ui_common_btn_w14", "ui_common_btn_w14");
    UICreate.addStyle(40, "treasureActivity_atlas", "ui_cbzd_an", "ui_cbzd_an");
    UICreate.addStyle(41, "reward_atlas", "ui_reward_btn_01", "ui_reward_btn_01");
    UICreate.addStyle(42, "bless_atlas", "ui_bless_an_2", "ui_bless_an_2");
    UICreate.addStyle(43, "common_atlas_2", "ui_common_btn_z10", "ui_common_btn_z10");
    UICreate.addStyle(44, "poolParty_atlas", "ui_ycpd_btn", "ui_ycpd_btn");
    UICreate.addStyle(45, "treasure_atlas", "ui_treasure_btn_03", "ui_treasure_btn_03");
    UICreate.addStyle(46, "treasure_atlas", "ui_treasure_btn_04", "ui_treasure_btn_04");
    UICreate.addStyle(47, "treasure_atlas", "ui_treasure_btn_05", "ui_treasure_btn_05");
    UICreate.addStyle(48, "xinqianWindow_atlas", "ui_smxj_btn", "ui_smxj_btn");
    UICreate.addStyle(49, "common_atlas_3", "ui_common_btn_w16", "ui_common_btn_w16");
    UICreate.addStyle(50, "common_atlas_3", "ui_common_btn_w17", "ui_common_btn_w17");
    UICreate.addStyle(51, "fairyWindow_atlas", "ui_jlxf_btn_01", "ui_jlxf_btn_01");
    UICreate.addStyle(52, "VipExperience_atlas", "ui_vip_btn_01", "ui_vip_btn_01");
    UICreate.addStyle(53, "common_atlas_3", "ui_common_btn_w18", "ui_common_btn_w18");
    UICreate.addStyle(54, "crazyEggs_atlas", "ui_jdjc_an1", "ui_jdjc_an1");
    UICreate.addStyle(55, "crazyEggs_atlas", "ui_jdjc_an", "ui_jdjc_an");
    UICreate.addStyle(56, "common_atlas_3", "ui_common_btn_w19", "ui_common_btn_w19");
    UICreate.addStyle(57, "godFurnace_atlas", "ui_sllb_btn_01", "ui_sllb_btn_01");
    UICreate.addStyle(58, "godFurnace_atlas", "ui_sllb_btn_02", "ui_sllb_btn_02");
    UICreate.addStyle(59, "charmking_atlas", "ui_mlzw_btn_01", "ui_mlzw_btn_01");
    UICreate.addStyle(60, "rechargeEnjoyDraw_atlas", "ui_czccl_an", "ui_czccl_an");
    UICreate.addStyle(61, "common_atlas_2", "ui_common_btn_y12", "ui_common_btn_y12");
    UICreate.addStyle(62, "common_atlas_2", "ui_common_btn_y13", "ui_common_btn_y13");
    UICreate.addStyle(63, "recharge_atlas", "ui_chongzhi_tips", "ui_chongzhi_tips");
end

function onFirstEnterGame(o)
    -- 测试完成，先屏蔽
    -- if logChange == nil and SDKPlatform.IsNoSdk then 
    --     logChange = true;
    --     MsgUtil.callFunc("SHOW_LOG_CHANGE");
    --     MsgUtil.callFunc("SHOW_FPS");
    -- end

    DataCenter.configLoaded = 1;
    DataCenter.thingData:clearCloakTemp();
    if DataCenter.roleData == nil then
        DataCenter.roleData = Lua_RoleData.new();
    end
    DataCenter.roleData:fromCData();
    if DataCenter.neverTip == nil then
        DataCenter.neverTip = Lua_NeverTipData.new();
    end

    local ot = os.date("*t", os.time())
    local loginStr = "l_" .. DataCenter.roleData.roleId;
    local lday = UnityEngine.PlayerPrefs.GetInt(loginStr);
    if lday == 0 or lday ~= ot.yday + 100 then
        DataCenter.todayFirstLoaded = true;
        UnityEngine.PlayerPrefs.SetInt(loginStr, ot.yday + 100);
    else
        DataCenter.todayFirstLoaded = false;
    end

    Lua_CommonUtil.checkPreloadScene(DataCenter.roleData.level);

    -- 获取结缘面板信息
    Lua_ProxyManager.getProxy("Lua_MarryProxy"):sMarryInfoMsg();

    -- 获取装备信息
    sendMsg(11400601);

    -- 获取背包信息
    local cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.BAG_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.WHARE;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.LW_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.JH_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.CARD_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.STAMP_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.ARMY_PACK;
    sendMsg(11400101, cmd);
    
    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.TREASURE_SOTRE;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.SACRED_ANIMAL_BAG;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.PAGODA_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.ZODIAC_PACK;
    sendMsg(11400101, cmd);

    cmd = ProtoPublic_pb.Proto11400101();
    cmd.pack_type = Lua_PackData.SECRET_PACK;
    sendMsg(11400101, cmd);

    -- 请求灵魂信息，红点处理
    local openLvl = getConfig({"func_open", 10112, "cond_level"});
    if DataCenter.roleData.level >= openLvl then
        sendMsg(11403301);
    end

    -- 获取神兽面板
    Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sInitMsg();

    -- 获取首充状态
    local cmd = ProtoPublic_pb.Proto11401812();
    cmd.type = 0;
    sendMsg(11401812, cmd);

    -- 获取投资计划信息
    local cmd = ProtoPublic_pb.Proto11401810();
    cmd.grade = 0;
    sendMsg(11401810, cmd);

    -- 获取运营活动
    local cmd = ProtoPublic_pb.Proto11400009();
    cmd.priority = 1;
    sendMsg(11400009, cmd);

    local cmd = ProtoPublic_pb.Proto11400009();
    cmd.priority = 4;
    sendMsg(11400009, cmd);

    -- 请求挂机设置
    sendMsg(11401001);
    -- 获取技能列表
    sendMsg(10400701);
    -- 获取当前任务的列表
    sendMsg(11400325);
    -- 请求自己帮派信息
    sendMsg(10100606, nil);
    -- 系统提示详细内容
    sendMsg(10400007);
    sendMsg(11401201);
    sendMsg(11401702);
    -- 请求灵纹兑换界面信息
    sendMsg(11403831);
    -- 请求获取神翼穿戴信息
    sendMsg(11403817);
    -- 请求充值礼金礼包
    sendMsg(11401818);
    -- 请求全民盛典
    sendMsg(11400021);
    -- 请求觉醒界面
    sendMsg(11405211);
    -- 请求跨服3v3战队信息
    sendMsg(11405511);
    sendMsg(11405508);
    -- 头像
    sendMsg(10110011);
    -- 相框、气泡
    sendMsg(11402601);
    
    DataCenter.isHangFirst = true;
    local taskProxy = Lua_ProxyManager.getProxy("Lua_TaskProxy");
    if taskProxy ~= nil and taskProxy.tempMsgList:getSize() > 0 then
        local msgLen = taskProxy.tempMsgList:getSize();
        for i = 1, msgLen do
            taskProxy:onUpdateTruckTask(taskProxy.tempMsgList[i]);
        end
        taskProxy.tempMsgList:clear();
    end
    Lua_ProxyManager.getProxy("Lua_SysSettingsProxy"):initData();
    if DataCenter.hook == nil then
        DataCenter.hook = Lua_HookControl.new();
    end
    DataCenter.hook:dispose();
    DataCenter.hook:initHook();

    if DataCenter.taskHook == nil then
        DataCenter.taskHook = Lua_TaskHookControl.new();
    end
    DataCenter.taskHook:dispose();
    DataCenter.taskHook:initHook();

    Lua_WindowUtil.openWin("Lua_MainMenuWindow", WinParam.ACTION_OPEN);
    DataCenter.changeJobData:taskShow(true);
    DataCenter.changeJobData.professionShow = true;

    DataCenter.guideData:doShowWelcomeWin(); -- 角色等级低于2级默认打开欢迎界面

    -- if DataCenter.giftData.hasSend ~= nil and DataCenter.giftData.hasSend == true then
    --     Lua_WindowUtil.openWin("Lua_GiftDropOutWindow", WinParam.ACTION_OPEN, nil);
    -- end
    addFirstRedDot();
end

function addFirstRedDot()
    --DataCenter.redDotData:updateRedDotVoState(13002, true);
    DataCenter.redDotData:updateRedDotVoState(22054, true); -- 玲珑宝塔登录红点
    DataCenter.redDotData:updateRedDotVoState(22056, true); -- 跨服云购登录红点
end

function onEnterMirrorMap()
    onSceneLoaded(nil);
end

function onEnterOrExitMirrorMap()
    -- 2018.4.17 改为由服务端通知是否继续自动做任务 消息号：81400204
    --[[    if DataCenter.hook ~= nil then
        Lua_CommonUtil.addTimer("delayCheckHook",1,nil,delayHookCallBack,nil,1);

    end --]]
    -- print("DataCenter.roleData.sceneId",DataCenter.roleData.sceneId);
    local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneCfg.isMirrorMap == false then
        -- 镜像副本出来时，先停止挂机
        DataCenter.hook:stop(true);
    end
end

function delayHookCallBack()
    -- print("do delayHookCallBack");
    local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneCfg ~= nil then
        local needDoTruck = sceneCfg.config.is_mirror_map == nil or sceneCfg.config.is_mirror_map == 0 and true or false;
        --  print("needDoTruck "..tostring(needDoTruck));
        if needDoTruck == true then
            DataCenter.hook:doTruckTask();
        end
    end
end

function onSceneLoaded(o)
    Lua_WindowUtil.openWin("Lua_CopyBuffListWindow", WinParam.ACTION_CLOSE);

    c_hookCurMonsterTarget(0);
    DataCenter.hook:clearDefaultPos();
    sendMsg(10400108);
    sendMsg(10600106);

    DataCenter.copyInfoData:clear();
    DataCenter.thingData:dispose(false);

    local sceneId = DataCenter.roleData.sceneId;
    local menuItem = getConfig( { "scene", sceneId, "menu_item" });
    Lua_MsgUtil.callFunc("UPDATE_MAIN_MENU", menuItem);
    Lua_MsgUtil.callFunc("SCENE_LOADED", menuItem);

    local sceneData = Lua_SceneConfigData.getSceneConfig(sceneId);
    if DataCenter.roleData.curLuaSceneId == nil or DataCenter.roleData.curLuaSceneId ~= sceneId then
        if sceneData.enter_tip ~= nil then
            OperateAlert.show(sceneData.enter_tip);
        end
        DataCenter.roleData.curLuaSceneId = sceneId;
    end
    if sceneId < 20000 or sceneData.copy_type == 34 then
        DataCenter.copyInfoData:clearCopyType();
        DataCenter.copyInfoData:clear();
    end
    local curOpenWin = sceneData.config.open_win;
    local lastSceneData = nil;
    if DataCenter.roleData.lastScene ~= nil then
        local lastOpenWin = getConfig( { "scene", DataCenter.roleData.lastScene, "open_win" });
        lastSceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.lastScene);
        if lastSceneData.copy_type == 34 or sceneData.copy_type ~= 34 then
            DataCenter.hook:stop();
        end
        if lastOpenWin ~= nil then
            for i, v in ipairs(lastOpenWin) do
                if curOpenWin == nil or table.indexOf(curOpenWin, v) == -1 then
                    Lua_WindowUtil.openWin(v, WinParam.ACTION_CLOSE);
                end
            end
        end

        -- 退出武林大会场景后打开功能界面
        if DataCenter.roleData.lastScene == Lua_WulindahuiData.wulindahuiSceneId then
            Lua_WindowUtil.openWin("Lua_CopyWulinWindow", WinParam.ACTION_OPEN, nil);
        end

        -- 退出天选之战场景后打开功能界面
        if DataCenter.roleData.lastScene == Lua_TheSelectionWarData.theSelectionWarSceneId then
            Lua_WindowUtil.openWin("Lua_TheSelectionWarWindow", WinParam.ACTION_OPEN, nil);
        end
        --退出帮派篝火关闭聊天窗口
        if DataCenter.roleData.lastScene == 30101 then
            DataCenter.chatData.firstGangOpenWin=true;
            Lua_WindowUtil.openWin("Lua_ChatWindow", WinParam.ACTION_CLOSE, nil);
        end
    end
    if curOpenWin ~= nil then
        for i, v in ipairs(curOpenWin) do
            Lua_WindowUtil.openWin(v, WinParam.ACTION_OPEN);
        end
    end

    -- 战斗说明描述弹框
    if sceneData.config.popHelpTipsId ~= nil then
        local str = LanUtil.getValue(sceneData.config.popHelpTipsId);
        if str ~= nil and str ~= "" then
            Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_CLOSE);
            -- 先关闭防止显示不对
            Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, str);
        end
    end
    Lua_MsgUtil.callFunc("TORRIGHT_SHOWHIDE_ALL",{value=false,needRefresh=0});
    -- 更新右上角图标
    Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS", true);
    if sceneData.close_right_top == 1 then
        -- 右上角图标缩进去
        DataCenter.allRtData:setSystemState(false);
    else
        DataCenter.allRtData:setSystemState(true);
        if lastSceneData ~= nil
            and lastSceneData.close_right_top == 1 then
            DataCenter.allRtData:setPlayerState(true);
        end
    end
    Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
    if sceneData.close_chat == 1  then
        DataCenter.chatData.firstGangOpenWin=true;
        Lua_WindowUtil.openWin("Lua_ChatWindow", WinParam.ACTION_CLOSE, nil);
    end

    if sceneData.guide_id ~= 0 then
        Lua_WindowUtil.openWin("Lua_GuideWindow", WinParam.ACTION_OPEN, sceneData.guide_id);
    end
    local rp = DataCenter.thingData:getThingObj(DataCenter.roleData.roleId);
    if rp ~= nil then
        if lastSceneData ~= nil --[[and lastSceneData.isSwimScene ~= sceneData.isSwimScene]] then
            rp.player:resetBodyUrl();
            rp.player:loadBody();
        end
        rp.player:cancelCollect();
    end
end

function addLuaWindow()
    initLua();
end

function setWindowTable(winName)
    local c = checkRequire(winName);
    local win = c.new();
    win.windowName = winName;
    WindowMananger.getInstance():setWinTable(winName, win);
end

function openWin(winName, win, winRoot)
    if win ~= nil then
        win:buildPanel(winRoot);
    end
end

function closeWin(win)
    win:dispose();
end

-- local aaa = 0;
-- function onEnterFrame()
--     if isInit ~= true then
--         return;
--     end
--     Lua_CommonUtil.frameScript();
--     Lua_MsgUtil.checkRemoveEvent();
--     if getTime() - aaa > 30 then
--         LuaGC();
--         aaa = getTime();
--     end
-- end

local gcTime = 30;
local gcIntervalTime = 30;
local isGc = false;
function onEnterFrame()
    if isInit ~= true then
        return;
    end

    DataCenter.frameStartTime = getTime();
    Lua_CommonUtil.frameScript();
    Lua_MsgUtil.checkRemoveEvent();
    if isGc == true then
        -- local c = collectgarbage("count")
        -- print("回收前collectgarbage count = " .. c.. " kb");
        if collectgarbage("step", 256) == true then
            isGc = false;
            gcTime = DataCenter.frameStartTime + gcIntervalTime;
            -- c = collectgarbage("count")
            -- print("回收后collectgarbage count = " .. c.. " kb");
        end
    else
        if DataCenter.frameStartTime > gcTime then
            isGc = true;
        end
    end    
end

function sendMsg(msgid, msg, socketType)
    if msg ~= nil then
        local pb_data = msg:SerializeToString();
        ProtolBuffer.data = pb_data;
    end
    ProtolBuffer.msgid = msgid;
    if socketType == nil then
        socketType = 1; -- main_socket
    end
    LuaUtil.sendSocket(socketType);
end

function clearLua()
    Lua_CommonUtil.clearAllTimer()
    for k, v in pairs(DataCenter) do
        if type(v) == "table" and v.dispose ~= nil then
            v:dispose();
        end
    end
    DataCenter.investmentPlanData.peakInvestmentOpen = nil;
    DataCenter.OperationalActivitiesData:clearOpenActive();
    Lua_SocketManager.getInstace():dicconnectAll();
    Lua_RewardsUtil.clear();
end