--游戏公告 Window
Lua_AnnouncementWindow = class("Lua_AnnouncementWindow", Lua_Window);

function Lua_AnnouncementWindow:ctor()
    self:superCall("ctor");

    self.w = 1006;
    self.h = 579;
    self.layer = 3600;
    self.showBg = false;
    self.isModel = true;

    self.windowName = "Lua_AnnouncementWindow";
    self.skinName = "AnnouncementWindow_skin";
end

function Lua_AnnouncementWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.titleTxt.text = LanUtil.getValue(123604);
    self.sureBtn.label = LanUtil.getValue(123606);
    self.sureBtn:addClickFuntion(self, self.hide);

    self.dragContainer = Lua_DragContainer.new(self.content, 1,  Vector4(0, 0, 860, 340));
    self.dragContainer:setLocation(0, 0, 0);
    self.AnnouncementItem = Lua_AnnouncementItem.new(self.dragContainer);
    self.dragContainer:updateChildPos();
end

function Lua_AnnouncementWindow:dispose()
    self:superCall("dispose");
end

function Lua_AnnouncementWindow:showWin(param)
    self:superCall("showWin", param);
    if param ~= nil then
        self.titleTxt.text = param.title ~= nil and param.title or LanUtil.getValue(123604);
        self.AnnouncementItem:setText(param.content ~= nil and param.content or LanUtil.getValue(123605));
        self.dragContainer:updateChildPos();
    else
        local formData = {};
        formData.func = "notice";
        formData.package = ServerConfig.market;
        local tokenstr = decodeTabToJson(formData);
        UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestStr, tokenstr, self, self.loadAnnouncementComplete, self.loadAnnouncementErr, true);
    end
end

function Lua_AnnouncementWindow:loadAnnouncementComplete(text)
    if LanUtil.IsNullOrEmpty(text) then
        self:hide();
        return;
    end

    local obj = decodeJson(text);
    if obj ~= nil then
        self.titleTxt.text = obj.title ~= nil and obj.title or LanUtil.getValue(123604);
        self.AnnouncementItem:setText(obj.content ~= nil and obj.content or LanUtil.getValue(123605));
        self.dragContainer:updateChildPos();
    end
end

function Lua_AnnouncementWindow:loadAnnouncementErr(text)
    print("公告报错");
    self:hide();
end





































Lua_AnnouncementItem = class("Lua_AnnouncementItem", Lua_DragContainerItem);
function Lua_AnnouncementItem:ctor(dragContainer)
    self:superCall("ctor", dragContainer.sub);

    dragContainer:addSubContainer(self, true);
end

function Lua_AnnouncementItem:buildShowItem()
    self:superCall("buildShowItem");

    self.contentTxt = UICreate.createLabel(self.content, "", -430, 170, 860, 20, 24);
    self.contentTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
    self.contentTxt.pivot = UIWidget.Pivot.TopLeft;
    self.contentTxt.spacingY = 5;
    self.contentTxt.text = LanUtil.getValue(123605);
end

function Lua_AnnouncementItem:setText(val)
    self.contentTxt.text = val;
end

function Lua_AnnouncementItem:getHeight()
    return self.contentTxt.height;
end

function Lua_AnnouncementItem:dispose()
    if self.contentTxt.text ~= nil then
        self.contentTxt:dispose();
        self.contentTxt = nil;
    end
    self:superCall("dispose");
end