--创角 Window
Lua_CreateRoleWindow = class("Lua_CreateRoleWindow", Lua_FullSizeWindow);

function Lua_CreateRoleWindow:ctor()
    self:superCall("ctor", false, false, 3500, false, false, false);

    self.windowName = "Lua_CreateRoleWindow";
    self.skinName = "CreateRoleWindow_skin";
end

function Lua_CreateRoleWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.winBg:setEnable(false);
    -- self.careerBg:setEnable(false);

    self.lastTime = 0;
    self.isRotStart = false;
    self._career = GlobalVar.serverDefaultCareer;
    self.isLoadScene = false;

    self.maxNameLen = Lua_CommonUtil.getCommonConfig("common", "max_name_len");
    if self.maxNameLen == nil then
        self.maxNameLen = 12;
    end

    self:addLuaEvent("BACK_RANDOM_NAME", self, self.onRandomNameBack);
    self:addLuaEvent("SELECTE_CREATEROLE_CAREER", self, self.onSelectCareer);

    self:addCSharpEvent("DISPOSE_SCENE_DONE", self, self.onDisposeSceneDone);
    self:addCSharpEvent("CREATE_ROLE_BACK", self, self.onCreateRoleBack);

    self:loadScene();
end

function Lua_CreateRoleWindow:dispose()
    if self.isLoadScene then
        self.isLoadScene = false;
        CreateRoleModel.DestoryCreateRoleModel();
        CreateRoleSceneController.DestoryCreateRoleScene();
    end
    Lua_CommonUtil.removeTimer(self, self.onCreateRoleRoting);

    if self.careerItem1 ~= nil then
        self.careerItem1:dispose();
        self.careerItem1 = nil;
    end
    if self.careerItem2 ~= nil then
        self.careerItem2:dispose();
        self.careerItem2 = nil;
    end
    if self.careerItem3 ~= nil then
        self.careerItem3:dispose();
        self.careerItem3 = nil;
    end
    if self.rotBg ~= nil then
        self.rotBg:dispose();
        self.rotBg = nil;
    end

    local main_camera = UnityEngine.Camera.main;
    main_camera.clearFlags = UnityEngine.CameraClearFlags.SolidColor;

    self:superCall("dispose");
end

function Lua_CreateRoleWindow:onDisposeSceneDone(o)
    if self.isLoadScene then
        self.isLoadScene = false;
        Lua_WindowUtil.openWin("Lua_SelectRoleWindow", WinParam.ACTION_OPEN, DataCenter.serverData.serverRoleData);
        self:hide();
    end
end

function Lua_CreateRoleWindow:loadScene()
    CreateRoleSceneController.getInstance():LoadScene(self, self.loadRoleModel);
end

function Lua_CreateRoleWindow:loadRoleModel()
    CreateRoleModel.getInstance():loadModel(self._career, self, self.onLoadRoleComplete);
end

function Lua_CreateRoleWindow:onLoadRoleComplete()
    local ro = ContainerUtil.getConainer("UI Root");
    if ro ~= nil then
        LuaUtil.setObjPos(ro, 10, 0, 0);
    end

    -- 初始化摄像头
    local main_camera = UnityEngine.Camera.main;
    main_camera.clearFlags = UnityEngine.CameraClearFlags.Skybox;
    main_camera.nearClipPlane = 0.3;
    main_camera.farClipPlane = 1000;
    main_camera.fieldOfView = 50;
    LuaUtil.setObjPos(main_camera.gameObject, 0, 0.75, 3);
    LuaUtil.setObjRot(main_camera.gameObject, -10.36, 180, 0.2);

    local main_cameraRoot = ContainerUtil.getConainer("camRoot");
    LuaUtil.setObjPos(main_cameraRoot, 0, 0, 0);
    LuaUtil.setObjRot(main_cameraRoot, 0, 0, 0);

    self:initUI();
    self:setCareer(self._career);

    self.isLoadScene = true;
end

function Lua_CreateRoleWindow:setCareer(val)
    self._career = val;

    self.careerItem1:setSelected(self._career == 1);
    self.careerItem2:setSelected(self._career == 2);
    if CommonUtil.lanType ~= 3 then
        self.careerItem3:setSelected(self._career == 3);
    end
    self._gender = self._career == 2 and 2 or 1;

    self:onRandom();
    CreateRoleModel.getInstance():setModel(self._career);

    self.careerNameImg:setAltas("login_atlas", "ui_create_role_font_" .. self._career);
    self.careerNameImg:resetSize();
    self.careerDescImg:setAltas("login_atlas", "ui_create_role_font_0" .. self._career);
    self.careerDescImg:resetSize();

    local str = LanUtil.getValue(123614 + self._career);
    if str ~= nil and str ~= "" then
        if CommonUtil.lanType==4 then
            local maxWidth = 0;
            local width = 29;
            self.careerDescTxt.overflowMethod = UILabel.Overflow.ResizeFreely;

            local slist = string.split(str, " ");
            for i = 1, slist:getSize() do
                self.careerDescTxt.text = slist[i];
                if self.careerDescTxt.width > maxWidth then
                    maxWidth = self.careerDescTxt.width;
                end
            end

            self.careerDescTxt:SetDimensions(maxWidth, 30);
            self.careerDescTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
            self.careerDescTxt.text = str;
            self.careerDescBg:setEnable(true);

            if maxWidth > 29 then
                width = maxWidth;
            end
            if self.careerDescTxt.height > 100 then
                self.careerDescBg:SetDimensions(width + 5, self.careerDescTxt.height + 10 + maxWidth);
            else
                self.careerDescBg:SetDimensions(width + 5, 122 + maxWidth);
            end
            maxWidth = 0;
            width = 0;
            self.careerDescBg:setLocation(MainWinDefine.V_width / 2 - 245, MainWinDefine.V_height / 2 - 197 - (self.careerDescBg.height / 2));
        else
            self.careerDescTxt.text = str;
            self.careerDescBg:setEnable(true);
        end               
    else
        self.careerDescTxt.text = "";
        self.careerDescBg:setEnable(false);
    end
end

function Lua_CreateRoleWindow:initUI()
    self.leftBg:setLocation(-MainWinDefine.V_width / 2 + 182, 0, 0);
    self.btnBack:setLocation(-MainWinDefine.V_width / 2 + 77, MainWinDefine.V_height / 2 - 47, 0);
    self.btnStart:setLocation(MainWinDefine.V_width / 2 - 115, -MainWinDefine.V_height / 2 + 118, 0);
    self.careerBg:setLocation(MainWinDefine.V_width / 2 - 175, MainWinDefine.V_height / 2 - 270, 0);
    self.careerNameImg:setLocation(MainWinDefine.V_width / 2 - 181, MainWinDefine.V_height / 2 - 150, 0);
    self.careerDescImg:setLocation(MainWinDefine.V_width / 2 - 186, MainWinDefine.V_height / 2 - 357, 0);
    self.careerDescBg:setLocation(MainWinDefine.V_width / 2 - 258, MainWinDefine.V_height / 2 - 266, 0);
    self.careerDescTxt:setLocation(MainWinDefine.V_width / 2 - 258, MainWinDefine.V_height / 2 - 266, 0);

    self.careerItem1 = Lua_CareerSelectItem.new(self.content);
    self.careerItem1:setCareer(1);
    self.careerItem1:setLocation(-MainWinDefine.V_width / 2 + 74, MainWinDefine.V_height / 2 -380, 0);
    self.careerItem1:setDepth(4);

    self.careerItem2 = Lua_CareerSelectItem.new(self.content);
    self.careerItem2:setCareer(2);
    self.careerItem2:setLocation(-MainWinDefine.V_width / 2 + 130, -MainWinDefine.V_height / 2 + 198, 0);
    self.careerItem2:setDepth(4);

    if CommonUtil.lanType ~= 3 then
        self.careerItem3 = Lua_CareerSelectItem.new(self.content);
        self.careerItem3:setCareer(3);
        self.careerItem3:setLocation(-MainWinDefine.V_width / 2 + 223, -MainWinDefine.V_height / 2 + 92, 0);
        self.careerItem3:setDepth(4);
    end
    
    self.rotBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 300, 510);
    self.rotBg.alpha = 0.01;
    self.rotBg.name = "rotBg";
    self.rotBg:setDepth(5);
    self.rotBg:addClickFuntion(self, self.onMouseDown);
    self.rotBg:addMouseUpFuntion(self, self.onMouseUp);

    self.txtInput.characterLimit = 6;
    self.txtInput.maxBytes = self.maxNameLen;
    self.txtInput.onValidate = OnRoleNameValidate;
    self.txtInput.text = LanUtil.getValue(123618);

    self.btnBack:addClickFuntion(self, self.onBack);
    self.btnStart:addClickFuntion(self, self.onStart);
    self.btnRandom:addClickFuntion(self, self.onRandom);
end

function Lua_CreateRoleWindow:onMouseDown(go)
    if self.isRotStart == false then
        self.isRotStart = true;
        self.startPos = UnityEngine.Input.mousePosition.x;
        self.startRot = CreateRoleModel.getInstance().modellocalEulerAngles;
        self:addTimer("CreateRoleRot", 0.003, self, self.onCreateRoleRoting);
    end
end

function Lua_CreateRoleWindow:onMouseUp(go)
    if self.isRotStart == true then
        self.isRotStart = false;
        Lua_CommonUtil.removeTimer(self, self.onCreateRoleRoting);
    end
end

function Lua_CreateRoleWindow:onCreateRoleRoting(val)
    local dt = self.startPos - UnityEngine.Input.mousePosition.x;
    local trot = self.startRot + dt;
    CreateRoleModel.getInstance():rotationModel(trot);
end

function Lua_CreateRoleWindow:onSelectCareer(obj)
    self:setCareer(tonumber(obj));
end

function Lua_CreateRoleWindow:OnRoleNameValidate(text, charIndex, addedChar)
    if CommonUtil.lanType ~= 0 then-- 除国内限制输入，其他地区版本不处理
        return addedChar;
    end
    if (addedChar >= 0x4e00 and addedChar <= 0x9fa5) then return addedChar end;   --这个主要是汉字的范围  
    if (addedChar >= 'A' and addedChar <= 'Z') then return addedChar end;
    if (addedChar >= 'a' and addedChar <= 'z') then return addedChar end;
    if (addedChar >= '0' and addedChar <= '9') then return addedChar end;
    return 0;
end

function Lua_CreateRoleWindow:onRandomNameBack(o)
    self.txtInput.text = o;
end

function Lua_CreateRoleWindow:onStart(go)
    local name = self.txtInput.text;
    name = string.gsub(name, " ", "");
    name = string.gsub(name, "\n", "");
    name = string.gsub(name, "\r", "");

    if name.Length == 0 then
        OperateAlert.show(LanUtil.getValue(123619));
        return;
    end
    local len = LanUtil.getStrLen(name);
    if len > self.maxNameLen then
        OperateAlert.show(LanUtil.getValue(123620));
        return;
    end
    if CommonUtil.lanType == 1 then
        if FilterText.GetInstance():IsInvalid(name, true, 1)then
            --名字包含敏感字或空格，打印警告错误
            OperateAlert.show(LanUtil.getValue(123621));
            return;
        end
    else
        if FilterText.GetInstance():IsInvalid(name, true, 0) or FilterText.GetInstance():IsInvalid(name, true, 1) then
            --名字包含敏感字或空格，打印警告错误
            OperateAlert.show(LanUtil.getValue(123621));
            return;
        end
    end

    local si, ei = string.find(name, "\\");
    if si ~= nil and si > 0 then
        OperateAlert.show(LanUtil.getValue(123621));
        return;
    end
        
    if getTime() - self.lastTime < 3 then
        return;
    end
    self.lastTime = getTime();
    AudioUtil.playBeginClickBtnSound();

    local market;
    if Lua_PlatformUtil.IsWindowsPlayer then
        local s = SDKPlatform.ChannelID;
        if s == nil or s == "" then
            s = "0";
        end
        market = tonumber(s);
    else
        market = ServerConfig.market;
    end
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):sCreateRoleBack(name, self._gender, market, self._career);
end

function Lua_CreateRoleWindow:onRandom(go)
    Lua_ProxyManager.getProxy("Lua_LoginProxy"):sRandomName(self._gender);
end

function Lua_CreateRoleWindow:onCreateRoleBack(o)
    self:onBack();
end

function Lua_CreateRoleWindow:onHide(go)
    CreateRoleModel.getInstance():setVisible(false);
    self:hide();
end

function Lua_CreateRoleWindow:onBack(go)
    if DataCenter.serverData.serverRoleData ~= nil then -- 有角色
        CreateRoleModel.getInstance():setVisible(false);
        CreateRoleModel.DestoryCreateRoleModel();
        CreateRoleSceneController.DestoryCreateRoleScene();
    else
        if CommonUtil.lanType ~= 1
            or Lua_PlatformUtil.IsWindowsPlayer
            or Lua_PlatformUtil.IsWindowsEditor then
                LuaUtil.relogin();
        else
            CreateRoleModel.getInstance():setVisible(false);
            LuaUtil.reconnectLoginOut();
            self:hide();
        end
    end
end

























Lua_CareerSelectItem = class("Lua_CareerSelectItem", Lua_DisplayObject);

function Lua_CareerSelectItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_CareerSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.careerImg = UICreate.createUIAtlasImage(self.content, "login_atlas", "ui_create_role_icon_01", 0, 0, 0, 0);
    self.careerImg.name = "careerImg";
    self.careerImg:setDepth(5);
    self.careerImg:addClickFuntion(self, self.onItemClick);
end

function Lua_CareerSelectItem:setCareer(career)
    self._career = career;
    self:setSelected(self._bSelected);
end

function Lua_CareerSelectItem:setSelected(val)
    self._bSelected = val;
    if self._bSelected then
        self.careerImg:setAltas("login_atlas", "ui_create_role_icon_0" .. self._career);
    else
        self.careerImg:setAltas("login_atlas", "ui_create_role_icon_" .. self._career);
    end
end

function Lua_CareerSelectItem:onItemClick(go)
    if self._bSelected == false then
        Lua_MsgUtil.callFunc("SELECTE_CREATEROLE_CAREER", self._career);
    end
end