--游戏登录 Window
Lua_LoginWindow = class("Lua_LoginWindow", Lua_Window);

function Lua_LoginWindow:ctor()
    self:superCall("ctor");

    self.showClose = false;
    self.showBg = false;
    self.isModel = false;

    self.windowName = "Lua_LoginWindow";
    self.skinName = "LoginWindow_skin";
end

function Lua_LoginWindow:buildShowItem()
    self:superCall("buildShowItem");

    GlobalVar.isInGame = 0;

    self.nameTxt.text = LanUtil.getValue(123600);
    self.codeTxt.text = LanUtil.getValue(123601);
    self.loginBtnTxt.text = LanUtil.getValue(123602);

    self.lblLoginId = UICreate.createInput(self.content, "", -105, 31, 280, 50, 28);
    self.lblLoginId.pivot = UIWidget.Pivot.Left;
    self.lblLoginId:setDepth(5);
    self.lblLoginId.effectColorStr = "4282007667";
    self.lblLoginId.effectStyle = 1;
    if Lua_PlatformUtil.IsWindowsPlayer or Lua_PlatformUtil.IsWindowsEditor then
        self.lblLoginId.overflowMethod = UILabel.Overflow.ResizeFreely;
    end

    self.lblPwd = UICreate.createInput(self.content, "", -105, -42, 280, 50, 28);
    self.lblPwd.pivot = UIWidget.Pivot.Left;
    self.lblPwd:setDepth(5);
    self.lblPwd.effectColorStr = "4282007667";
    self.lblPwd.effectStyle = 1;

    self.versionTxt = UICreate.createLabel(self.content, "version:" .. Version.SHOW_VERSION, 0, 0, 200, 30, 22);
    self.versionTxt:setLocation(MainWinDefine.V_width / 2 - 200,  - MainWinDefine.V_height / 2 + 50);
    
    self.loginBtn:addClickFuntion(self, self.onStartClick);

    MsgUtil.callFunc("LOGIN_BG_CHANGE", "/images/loading/" .. PlayerData.getInstance().phpData.login_bg);

    if UnityEngine.PlayerPrefs.HasKey("userId") == true then
        self.lblLoginId.text = UnityEngine.PlayerPrefs.GetString("userId");
    else
        self.lblLoginId.text = "enter_name";
    end

    if UnityEngine.PlayerPrefs.HasKey("password") == true then
        self.lblPwd.text = UnityEngine.PlayerPrefs.GetString("password");
    else
        self.lblPwd.text = "label";
    end
end

function Lua_LoginWindow:dispose()
    self:superCall("dispose");
end

function Lua_LoginWindow:onStartClick(go)
    if self.lblLoginId.text == "" then
        OperateAlert.show(LanUtil.getValue(107484));
        return;
    end

    local nameStr = self.lblLoginId.text;
    nameStr = string.gsub(nameStr, " ", "");
    nameStr = string.gsub(nameStr, "\n", "");
    nameStr = string.gsub(nameStr, "\r", "");
    UnityEngine.PlayerPrefs.SetString("userId", nameStr);
    UnityEngine.PlayerPrefs.SetString("password", self.lblPwd.text);
    ServerConfig.userID = nameStr;

    Lua_WindowUtil.openWin("Lua_ServerSelectWindow", WinParam.ACTION_OPEN);
    self:hide();
end