--选角 Window
Lua_SelectRoleWindow = class("Lua_SelectRoleWindow", Lua_FullSizeWindow);

function Lua_SelectRoleWindow:ctor()
    self:superCall("ctor", false, false, 3500, false, false, false, "/images/role/ui_create_role_1.png");
    
    self.windowName = "Lua_SelectRoleWindow";
    self.skinName = "SelectRoleWindow_skin";
end

function Lua_SelectRoleWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.isRotStart = false;
    self.lastTime = 0;
    self.isLoadScene = false;
    self.content.gameObject:SetActive(false);

    self:addLuaEvent("SELECTE_ROLEDATA_UPDATE", self, self.onSelectRole);

    self:addCSharpEvent("DISPOSE_SCENE_DONE", self, self.onDisposeSceneDone);
    self:addCSharpEvent("SELECT_ROLE_BACK", self, self.onSelectRoleBack);

    self:loadScene();
end

function Lua_SelectRoleWindow:dispose()
    if self.isLoadScene then
        self.isLoadScene = false;
        CreateRoleSceneController.DestoryCreateRoleScene();
    end
    
    Lua_CommonUtil.removeTimer(self, self.onSelectRoleRoting);
    self:onMouseUp();

    if self.fabaoEff ~= nil then
        self.fabaoEff:dispose();
        self.fabaoEff = nil;
    end
    if self.roleModel1 ~= nil then
        self.roleModel1:dispose();
        self.roleModel1 = nil;
    end
    if self.roleModel2 ~= nil then
        self.roleModel2:dispose();
        self.roleModel2 = nil;
    end
    if self.roleModel3 ~= nil then
        self.roleModel3:dispose();
        self.roleModel3 = nil;
    end

    local main_camera = UnityEngine.Camera.main;
    main_camera.clearFlags = UnityEngine.CameraClearFlags.SolidColor;

    self:superCall("dispose");
end

function Lua_SelectRoleWindow:onDisposeSceneDone(o)
    if self.isLoadScene then
        self.isLoadScene = false
        Lua_WindowUtil.openWin("Lua_CreateRoleWindow", WinParam.ACTION_OPEN);
        self:hide();
    end
end


function Lua_SelectRoleWindow:initUI()
    self.content.gameObject:SetActive(true);

    self.leftBg:setLocation(-MainWinDefine.V_width / 2 + 182, 0, 0);
    self.careerNameImg:setLocation(MainWinDefine.V_width / 2 - 181, MainWinDefine.V_height / 2 - 150, 0);
    self.careerDescImg:setLocation(MainWinDefine.V_width / 2 - 186, MainWinDefine.V_height / 2 - 357, 0);

    self.btnBack:addClickFuntion(self, self.onBack);
    self.btnBack:setLocation(-MainWinDefine.V_width / 2 + 77, MainWinDefine.V_height / 2 - 47, 0);

    self.btnStart:addClickFuntion(self, self.onStart);
    self.btnStart:setLocation(MainWinDefine.V_width / 2 - 115, -MainWinDefine.V_height / 2 + 118, 0);

    self.careerBg:setLocation(MainWinDefine.V_width / 2 - 175, MainWinDefine.V_height / 2 - 270, 0);
    -- self.careerBg:setEnable(false);

    if CommonUtil.lanType==4 then
        self.careerDescBg:SetDimensions(34, 152);
        self.careerDescBg:setLocation(MainWinDefine.V_width / 2 - 245, MainWinDefine.V_height / 2 - 235);

        self.careerDescTxt.pivot = UIWidget.Pivot.Center;
        self.careerDescTxt:setDepth(5);
        self.careerDescTxt:setLocation(MainWinDefine.V_width / 2 - 245, MainWinDefine.V_height / 2 - 235);
    else
        self.careerDescBg:setLocation(MainWinDefine.V_width / 2 - 258, MainWinDefine.V_height / 2 - 266, 0);

        self.careerDescTxt.pivot = UIWidget.Pivot.Center;
        self.careerDescTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
        self.careerDescTxt:setLocation(MainWinDefine.V_width / 2 - 258, MainWinDefine.V_height / 2 - 266, 0);
    end
       
    self.roleItem1 = Lua_RoleSelectItem.new(self.content);
    self.roleItem1:setLocation(-MainWinDefine.V_width / 2 + 74, MainWinDefine.V_height / 2 -380, 0);
    self.roleItem1:setDepth(4);

    self.roleItem2 = Lua_RoleSelectItem.new(self.content);
    self.roleItem2:setLocation(-MainWinDefine.V_width / 2 + 130, -MainWinDefine.V_height / 2 + 198, 0);
    self.roleItem2:setDepth(4);

    self.roleItem3 = Lua_RoleSelectItem.new(self.content);
    self.roleItem3:setLocation(-MainWinDefine.V_width / 2 + 223, -MainWinDefine.V_height / 2 + 92, 0);
    self.roleItem3:setDepth(4);

    self.fabaoEff = UICreate.createUIEffect(self.content, nil, nil, -80, -210);
    self.fabaoEff.name = "fabaoEff";

    self.rotBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 300, 510);
    self.rotBg.name = "rotBg";
    self.rotBg.alpha = 0.01;
    self.rotBg:setDepth(5);
    self.rotBg:addClickFuntion(self, self.onMouseDown);
    self.rotBg:addMouseUpFuntion(self, self.onMouseUp);
end

function Lua_SelectRoleWindow:loadScene()
    CreateRoleSceneController.getInstance():LoadScene(self, self.onLoadSceneComplete);
end

function Lua_SelectRoleWindow:onLoadSceneComplete()
    Lua_WindowUtil.openWin("LoadingScreenWindow", WinParam.ACTION_CLOSE);

    -- 初始化摄像头
    local main_camera = UnityEngine.Camera.main;
    main_camera.clearFlags = UnityEngine.CameraClearFlags.Skybox;
    main_camera.nearClipPlane = 0.3;
    main_camera.farClipPlane = 1000;
    main_camera.fieldOfView = 60;
    LuaUtil.setObjPos(main_camera.gameObject, 0, 0.77, 2.25);
    LuaUtil.setObjRot(main_camera.gameObject, -3, 180, 0.2);

    local main_cameraRoot = ContainerUtil.getConainer("camRoot");
    LuaUtil.setObjPos(main_cameraRoot, 0, 0, 0);
    LuaUtil.setObjRot(main_cameraRoot, 0, 0, 0);

    self:initUI();
    if self.showData ~= nil then
        local len = #self.showData;
        self.roleItem1:setRoleData(len > 0 and self.showData[1] or nil);
        self.roleItem2:setRoleData(len > 1 and self.showData[2] or nil);
        self.roleItem3:setRoleData(len > 2 and self.showData[3] or nil);
        if len > 0 then
            self.roleItem1:setSelected(true);
            self:onSelectRole(self.showData[1]);
        end
    else
        self.roleItem1:setRoleData(nil);
        self.roleItem2:setRoleData(nil);
        self.roleItem3:setRoleData(nil);
    end

    self.isLoadScene = true;
end

function Lua_SelectRoleWindow:onMouseDown(go)
    local user;
    if self.selectedItem1 then
        user = self.roleModel1;
    elseif self.selectedItem2 then
        user = self.roleModel2;
    elseif self.selectedItem3 then
        user = self.roleModel3;
    end

    if user == nil or user.avatar == nil then
        return;
    end

    if self.isRotStart == false then
        self.isRotStart = true;
        self.startPos = UnityEngine.Input.mousePosition.x;
        self.startRot = user.direction;
        self:addTimer("onSelectRoleRoting", 0.003, self, self.onSelectRoleRoting);
    end
end

function Lua_SelectRoleWindow:onMouseUp(go)
    if self.isRotStart == true then
        self.isRotStart = false;
        Lua_CommonUtil.removeTimer(self, self.onSelectRoleRoting);
    end
end

function Lua_SelectRoleWindow:onSelectRoleRoting()  
    local user;
    if self.selectedItem1 then
        user = self.roleModel1;
    elseif self.selectedItem2 then
        user = self.roleModel2;
    elseif self.selectedItem3 then
        user = self.roleModel3;
    end

    if user ~= nil then
        local dt = self.startPos - UnityEngine.Input.mousePosition.x;
        local trot = self.startRot - dt;
        user.direction = trot;
    end
end

function Lua_SelectRoleWindow:onStart(go)
    if self.selectRoleData == nil then
        return;
    end

    if getTime() - self.lastTime < 3 then
        return;
    end
    self.lastTime = getTime();
    AudioUtil.playBeginClickBtnSound();

    Lua_MsgUtil.callFunc("START_LOGIN_GAME", self.selectRoleData.role_id);
end

function Lua_SelectRoleWindow:onSelectRoleBack(o)
    self:onBack();
end
    
function Lua_SelectRoleWindow:onHide(go)
    self:hide();
end

function Lua_SelectRoleWindow:onBack(go)
    if CommonUtil.lanType ~= 1
        or Lua_PlatformUtil.IsWindowsPlayer
        or Lua_PlatformUtil.IsWindowsEditor then
            LuaUtil.relogin();
    else
        LuaUtil.reconnectLoginOut();
        self:hide();
    end
end


function Lua_SelectRoleWindow:onSelectRole(obj)
    self.selectRoleData = obj;
    if self.selectRoleData == nil then -- 进入创角
        CreateRoleSceneController.DestoryCreateRoleScene();
    else
        -- 展示
        DataCenter.sdkInterface.isCreateRole = false;
        self.selectedItem1 = self.roleItem1:checkSelectedByRoleId(self.selectRoleData.role_id);
        self.selectedItem2 = self.roleItem2:checkSelectedByRoleId(self.selectRoleData.role_id);
        self.selectedItem3 = self.roleItem3:checkSelectedByRoleId(self.selectRoleData.role_id);
        self:setRoleModel();
        self:setFaqiModel();

        self.careerNameImg:setAltas("login_atlas", "ui_create_role_font_" .. self.selectRoleData.career);
        self.careerNameImg:resetSize();
        self.careerDescImg:setAltas("login_atlas", "ui_create_role_font_0" .. self.selectRoleData.career);
        self.careerDescImg:resetSize();
        local str = LanUtil.getValue(123614 + self.selectRoleData.career);
        if str ~= nil and str ~= "" then
            if CommonUtil.lanType==4 then
                local maxWidth = 0;
                local width = 29;
                self.careerDescTxt.overflowMethod = UILabel.Overflow.ResizeFreely;

                local slist = string.split(str, " ");
                for i = 1, slist:getSize() do
                    self.careerDescTxt.text = slist[i];
                    if self.careerDescTxt.width > maxWidth then
                        maxWidth = self.careerDescTxt.width;
                    end
                end
                self.careerDescTxt:SetDimensions(maxWidth, 30);
                self.careerDescTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
                self.careerDescTxt.text = str;
                self.careerDescBg:setEnable(true);
                if maxWidth > 29 then
                    width = maxWidth;
                end
                if self.careerDescTxt.height > 100 then
                    self.careerDescBg:SetDimensions(width + 5, self.careerDescTxt.height + 10 + maxWidth);
                else
                    self.careerDescBg:SetDimensions(width + 5, 122 + maxWidth);
                end
                maxWidth = 0;
                width = 0;
                self.careerDescBg:setLocation(MainWinDefine.V_width / 2 - 245, MainWinDefine.V_height / 2 - 197 - (self.careerDescBg.height /2));            
            else
                self.careerDescTxt.text = str;
                self.careerDescBg:setEnable(true);
            end
        else
            self.careerDescTxt.text = "";
            self.careerDescBg:setEnable(false);
        end
    end
end

function Lua_SelectRoleWindow:setRoleModel()
    local user;
    if self.selectedItem1 then
        if self.roleModel1 == nil  then
            self.roleModel1 = UserPlayer();
            user = self.roleModel1;
        else
            self.roleModel1.root.gameObject:SetActive(true);
            self.roleModel1.direction = 90;
            self.roleModel1:setFaQiActionStandState();
        end

        if self.roleModel2 ~= nil then
            self.roleModel2.root.gameObject:SetActive(false);
        end
        if self.roleModel3 ~= nil then
            self.roleModel3.root.gameObject:SetActive(false);
        end
    elseif self.selectedItem2 then
        if self.roleModel2 == nil then
            self.roleModel2 = UserPlayer();
            user = self.roleModel2;
        else
            self.roleModel2.root.gameObject:SetActive(true);
            self.roleModel2.direction = 90;
            self.roleModel2:setFaQiActionStandState();
        end

        if self.roleModel1 ~= nil then
            self.roleModel1.root.gameObject:SetActive(false);
        end
        if self.roleModel3 ~= nil then
            self.roleModel3.root.gameObject:SetActive(false);
        end
    elseif self.selectedItem3 then
        if self.roleModel3 == nil then
            self.roleModel3 = UserPlayer();
            user = self.roleModel3;
        else
            self.roleModel3.root.gameObject:SetActive(true);
            self.roleModel3.direction = 90;
            self.roleModel3:setFaQiActionStandState();
        end

        if self.roleModel2 ~= nil then
            self.roleModel2.root.gameObject:SetActive(false);
        end
        if self.roleModel1 ~= nil then
            self.roleModel1.root.gameObject:SetActive(false);
        end
    else
        if self.roleModel1 ~= nil then
            self.roleModel1.root.gameObject:SetActive(false);
        end
        if self.roleModel2 ~= nil then
            self.roleModel2.root.gameObject:SetActive(false);
        end
        if self.roleModel3 ~= nil then
            self.roleModel3.root.gameObject:SetActive(false);
        end
    end

    if user ~= nil then
        local usd = UsData();
        usd.roleId = self.selectRoleData.role_id; -- 账号
        usd.nickname = self.selectRoleData.name; -- 玩家名
        usd.lvl = self.selectRoleData.level; -- 等级
        usd.career = self.selectRoleData.career; -- 职业
        usd.profession = self.selectRoleData.profession; -- 转职
        usd.gender = self.selectRoleData.sex; -- 性别
        usd.weapon_id = self.selectRoleData.weapon;  -- 武器
        usd.clothes_id = self.selectRoleData.clothes; -- 衣服
        usd.fashion_weapon_id = self.selectRoleData.fashion_weapon; -- 时装武器
        usd.fashion_clothes_id = self.selectRoleData.fashion_clothes; -- 时装衣服
        usd.fashionHeadId = self.selectRoleData.fashion_head; -- 时装头饰
        --usd.faqiId = self.selectRoleData.mw_shape; -- 法宝
        usd.wingId = self.selectRoleData.wing; -- 神翼
        usd.fairyId = self.selectRoleData.fairy_shape; -- 仙器
        usd.spoorId = self.selectRoleData.spoor_shape; -- 足迹

        usd.showShadow = false;
        usd.canBeClick = false;
        usd.isShowName = false;

        usd.hp = 1;
        usd.px = 0;
        usd.py = 0;
        usd.pz = 0;
        usd.dir = 90;
        usd.kind = 2;

        user.data = usd;
        user:setFaQiActionStandState();
        LuaUtil.setObjPos(user.root.gameObject, 0, 0, 0);
    end
end

function Lua_SelectRoleWindow:setFaqiModel()
    if self.selectRoleData ~= nil and self.selectRoleData.mw_shape > 0 then
        if self.selectRoleData.mw_shape ~= self.curFaqiId then
            self.curFaqiId = self.selectRoleData.mw_shape;
            self.curFaqiCareer = self.selectRoleData.career;

            local fileName;
            local floder;
            local modelName;
            local faqiData = getConfig({"playerHanger", tonumber(self.selectRoleData.mw_shape)});
            if faqiData == nil then
                faqiData = getConfig({"playerHanger", tostring(self.selectRoleData.mw_shape)});
            end
            if faqiData ~= nil then
                fileName = faqiData.fileName;
                floder = faqiData.floder;
                modelName = faqiData.modelName;
            else
                fileName = tostring(self.selectRoleData.mw_shape);
                floder = "/mounts";
                modelName = tostring(self.selectRoleData.mw_shape);
            end
            self.fabaoEff:setFullUrl(UrlManager.ModelPath(fileName, floder), modelName);
        end
        self.fabaoEff:setEnable(true);
        self.fabaoEff:setAction(1);
        self.fabaoEff:setSacle(200, 200, 200);
        self.fabaoEff:SetRenderQueue(self.careerDescTxt, 1, 2);
        self.fabaoEff:setRot(0,180,0);
    else
        self.fabaoEff:setEnable(false);
    end
end




































Lua_RoleSelectItem = class("Lua_RoleSelectItem", Lua_DisplayObject);

function Lua_RoleSelectItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_RoleSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.nameBg = UICreate.createUIAtlasImage(self.content, "login_atlas", "ui_create_role_winght_2", 0, 0, 0, 0);
    self.nameBg.name = "nameBg";
    self.nameBg:setDepth(3);
    self.nameBg:setLocation(103, 0);
    self.nameBg:addClickFuntion(self, self.onItemClick);

    self.addImg = UICreate.createUIAtlasImage(self.content, "login_atlas", "ui_create_role_icon_4", 0, 0, 0, 0);
    self.addImg.name = "addImg";
    self.addImg:setDepth(5);
    self.addImg:addClickFuntion(self, self.onItemClick);

    self.nameTxt = UICreate.createLabel(self.content, "", 70, 10, 250, 30, 20);
    self.nameTxt.name = "nameTxt";
    self.nameTxt.pivot = UIWidget.Pivot.Left;
    self.nameTxt.colorStr = "4290109439";
    self.nameTxt.depth = 5;

    self.lvlTxt = UICreate.createLabel(self.content, "", 72, -12, 250, 30, 20);
    self.lvlTxt.name = "lvlTxt";
    self.lvlTxt.pivot = UIWidget.Pivot.Left;
    self.lvlTxt.colorStr = "4290109439";
    self.lvlTxt.depth = 5;
end

function Lua_RoleSelectItem:setRoleData(obj)
    self.roleData = obj;
    if obj ~= nil then
        self.nameTxt.text = self.roleData.name;
        self.lvlTxt.text = "Lv." .. self.roleData.level;
        self.nameBg:setEnable(true);
        self:setSelected(self._bSelected);
    else
        self.nameTxt.text = "";
        self.lvlTxt.text = "";
        self.nameBg:setEnable(false);
        self.addImg:setAltas("login_atlas", "ui_create_role_icon_4");
    end
end

function Lua_RoleSelectItem:checkSelectedByRoleId(roleId)
    if self.roleData == nil then
        self:setSelected(false);
    else
        self:setSelected(self.roleData.role_id == roleId);
    end
    return self._bSelected;
end

function Lua_RoleSelectItem:setSelected(val)
    self._bSelected = val;
    if self._bSelected then
        if self.roleData ~= nil then
            self.addImg:setAltas("login_atlas", "ui_create_role_icon_0" .. self.roleData.career);
            self.addImg:resetSize();
        end
    else
        if self.roleData ~= nil then
            self.addImg:setAltas("login_atlas", "ui_create_role_icon_" .. self.roleData.career);
            self.addImg:resetSize();
        end
    end
end

function Lua_RoleSelectItem:onItemClick(go)
    if self._bSelected == false then
        Lua_MsgUtil.callFunc("SELECTE_ROLEDATA_UPDATE", self.roleData);
    end
end