--服务器列表 Window
Lua_ServerListWindow = class("Lua_ServerListWindow", Lua_Window);

function Lua_ServerListWindow:ctor()
    self:superCall("ctor");

    self.w = 1102;
    self.h = 623;
    self.showClose = false;
    self.showBg = false;

    self.windowName = "Lua_ServerListWindow";
    self.skinName = "ServerListWindow_skin";
end

function Lua_ServerListWindow:buildShowItem()
    self:superCall("buildShowItem");

    GlobalVar.isInGame = 0;
    self._selectIdx = -999;

    self.titleTxt.text = LanUtil.getValue(123625);
    self.txt1.text = LanUtil.getValue(123609);
    self.txt2.text = LanUtil.getValue(123612);
    self.txt3.text = LanUtil.getValue(123613);
    self.txt4.text = LanUtil.getValue(123622);
    self.txt5.text = LanUtil.getValue(123614);

    self.enterBtn.label = LanUtil.getValue(123603);
    self.enterBtn:addClickFuntion(self, self.onEnterBtnClick);
    self.btnClose:addClickFuntion(self, self.hide);

    self.titleList = Lua_DragList.new(self.content, 1 ,Vector4(0, -190, 220, 440));
    self.titleList:setListCell(Lua_ServerTitleItem, 65, 220, 1);
    self.titleList:setLocation(-443, 135);

    self.dragList = Lua_DragList.new(self.content, 1, Vector4(175, -148, 850, 430));
    self.dragList:setListCell(Lua_ServerListItem, 120, 425, 2);
    self.dragList:setLocation(-52, 155);

    self:addLuaEvent("SELECTE_SERVER", self, self.onSelectedServer);
    self:addLuaEvent("SELECTE_SERVER_INDEX", self, self.onSelectIndex);
    self:addLuaEvent("SERVER_INFO_UPDATE", self, self.updateTitleList);

    Lua_WindowUtil.openWin("Lua_StartWindow", WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_LoginWindow", WinParam.ACTION_CLOSE);

    self:updateTitleList();
end

function Lua_ServerListWindow:dispose()
    self:superCall("dispose");
end

-- 更新左侧列表
function Lua_ServerListWindow:updateTitleList()
    if DataCenter.serverData ~= nil and DataCenter.serverData.allZoneList:getSize() > 0 then
        if DataCenter.serverData.myServerList:getSize() > 0 then -- 选中我的服务器
            DataCenter.serverData.selectTitleIdx = DataCenter.serverData.allZoneList[1].zone;
        else
            if DataCenter.serverData.selectServerData ~= nil then
                DataCenter.serverData.selectTitleIdx = DataCenter.serverData.selectServerData.zone;
            else
                DataCenter.serverData.selectTitleIdx = DataCenter.serverData.allZoneList[DataCenter.serverData.allZoneList:getSize()].zone;
            end
        end
        self.titleList:setLuaArrayData(DataCenter.serverData.allZoneList);
        self:setSelectIndex(DataCenter.serverData.selectTitleIdx);
    end
end

function Lua_ServerListWindow:onSelectIndex(idx)
    DataCenter.serverData.selectTitleIdx = idx;
    self:setSelectIndex(DataCenter.serverData.selectTitleIdx);

    local showList = self.titleList.showList;
    for i = 1, showList:getSize() do
        showList[i]:updateSelected();
    end
end

function Lua_ServerListWindow:setSelectIndex(idx)
    if DataCenter.serverData == nil then
        return;
    end

    if self._selectIdx ~= idx then
        self._selectIdx = idx;
        local list;
        if self._selectIdx == -1 then --自己服务器
            list = DataCenter.serverData.myServerList;
        else
            list = DataCenter.serverData.allServerDic[idx];
        end
        self.dragList:setLuaArrayData(list);
    end
end

function Lua_ServerListWindow:onEnterBtnClick(go)
    Lua_MsgUtil.callFunc("SERVER_ENTER_CLCIK");
    self:hide();
end

function Lua_ServerListWindow:onSelectedServer(data)
    DataCenter.serverData.selectServerData = data;

    local showList = self.dragList.showList;
    for i = 1, showList:getSize() do
        showList[i]:updateSelected();
    end
end
























Lua_ServerTitleItem = class("Lua_ServerTitleItem", Lua_ListCell);

function Lua_ServerTitleItem:ctor(p)
    self:superCall("ctor", p, "ServerTitleItem_skin");
end

function Lua_ServerTitleItem:buildShowItem()
    self:superCall("buildShowItem");

    self._bSelected = false;
end

function Lua_ServerTitleItem:setData(data)
    self.data = data;
    self.txt.text = data.name;
    self:updateSelected();
end

function Lua_ServerTitleItem:updateSelected()
    if self.data ~= nil and self.data.zone == DataCenter.serverData.selectTitleIdx then
        self.bg:setAltas("login_atlas", "ui_landing_btn_02");
        self.txt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
        self._bSelected = true;
    else
        self.bg:setAltas("login_atlas", "ui_landing_btn_03");
        self.txt.colorStr = Lua_ColorDefine.transColor("8F96A3");
        self._bSelected = false;
    end
end

function Lua_ServerTitleItem:onPlayerSoundClick()
    if self._bSelected == false then
        Lua_MsgUtil.callFunc("SELECTE_SERVER_INDEX", self.data.zone);
    end
end



























Lua_ServerListItem = class("Lua_ServerListItem", Lua_ListCell);

function Lua_ServerListItem:ctor(p)
    self:superCall("ctor", p, "ServerListItem_skin");
end

function Lua_ServerListItem:buildShowItem()
    self:superCall("buildShowItem");

    self._bSelected = false;
    self.selectBg:setEnable(false);
end

function Lua_ServerListItem:setData(data)
    if data == nil then
        return;
    end

    self.data = data;
    self.nameTxt.text = data.name;

    local str = data.getState;
    if str ~= nil and str ~= "" then
        self.signTxt.text = str;
        self.signBg:setEnable(true);
    else
        self.signTxt.text = "";
        self.signBg:setEnable(false);
    end
    self.statusIcon:setAltas("login_atlas", data.getStateIcon);
    self:updateSelected();
end

function Lua_ServerListItem:updateSelected()
    if self.data ~= nil and self.data.name == DataCenter.serverData.selectServerData.name then
        self.selectBg:setEnable(true);
        self._bSelected = true;
    else
        self.selectBg:setEnable(false);
        self._bSelected = false;
    end
end

function Lua_ServerListItem:onPlayerSoundClick()
    if self._bSelected == false then
        Lua_MsgUtil.callFunc("SELECTE_SERVER", self.data);
    end
end