--服务器选择 Window
Lua_ServerSelectWindow = class("Lua_ServerSelectWindow", Lua_Window);

function Lua_ServerSelectWindow:ctor()
    self:superCall("ctor");

    self.showClose = false;
    self.showBg = false;
    self.isModel = false;

    self.windowName = "Lua_ServerSelectWindow";
    self.skinName = "ServerSelectWindow_skin";
end

function Lua_ServerSelectWindow:buildShowItem()
    self:superCall("buildShowItem");

    GlobalVar.isInGame = 0;
    GlobalVar.notReconnect = 1;

    self.protocolSelect = -1;
    self.lastTime = -10;

    self.backBtn:addClickFuntion(self, self.onBackClick);
    self.backBtn:setLocation(-MainWinDefine.V_width / 2 + 78, MainWinDefine.V_height / 2 - 41, 0);

    local isShow = PlayerData.getInstance().phpData.no_func_open_tips == 0;
    self.annBg:setLocation(-MainWinDefine.V_width / 2 + 70, -MainWinDefine.V_height / 2 + 70)
    self.annIcon:setLocation(-MainWinDefine.V_width / 2 + 70, -MainWinDefine.V_height / 2 + 70);
    self.annIcon:setEnable(isShow);
    self.annBg:setEnable(isShow);

    self.switchBg:setLocation(-MainWinDefine.V_width / 2 + 180, -MainWinDefine.V_height / 2 + 70, 0);
    self.switchIcon:setLocation(-MainWinDefine.V_width / 2 + 180, -MainWinDefine.V_height / 2 + 70, 0);

    self.annIcon:addClickFuntion(self, self.onAnnClick);
    self.switchIcon:addClickFuntion(self, self.onSwitchClick);

    self.enterBtnTxt.text = LanUtil.getValue(123603);
    self.enterBtn:addClickFuntion(self, self.onEnterClick);

    self.serverNameBg:addClickFuntion(self, self.onServerNameClick);

    self.serverItem = Lua_ServerSelectItem.new(self.content);
    self.serverItem:setLocation(-158, -148);

    self:addLuaEvent("SELECTE_SERVER", self, self.onSelectedServer);
    self:addLuaEvent("SERVER_ENTER_CLCIK", self, self.onServerEnterClick);
    
    self:addCSharpEvent("SERVER_SELECT_BACK", self, self.onServerSelectBack);

    --关掉进入按钮界面
    Lua_WindowUtil.openWin("Lua_StartWindow", WinParam.ACTION_CLOSE);
    MsgUtil.callFunc("LOGIN_BG_CHANGE", "/images/loading/" .. PlayerData.getInstance().phpData.login_bg);
    self:loadServerList();
end

function Lua_ServerSelectWindow:dispose()
    self:superCall("dispose");
end

function Lua_ServerSelectWindow:loadServerList()
    local formData = {};
    formData.uid = ServerConfig.userID;
    formData.v = Version.SHOW_VERSION;
    formData.package = ServerConfig.market;
    formData.device = ServerConfig.device;
    formData.sys_model = ServerConfig.sysModel;
    formData.sys_version = ServerConfig.sysVersion;
    formData.pefix_ext = DataCenter.sdkInterface.login_token;

    print("Lua_ServerSelectWindow", ServerConfig.userID,ServerConfig.sysModel);
    local rurl = decodeTabToJson(formData);
    print("prefixRequestLoginStr:" .. UrlManager.prefixRequestLoginStr);
    print("loadServerList:" .. rurl);
    UploadManager.getInstance():uploadPhpPost(UrlManager.prefixRequestLoginStr, rurl, self, self.loadServerComplete, self.loadServerError, true);
end

function Lua_ServerSelectWindow:loadServerComplete(text)
    print("loadServerComplete = " .. text);
    if LanUtil.IsNullOrEmpty(text) then
        self:loadServerError(text);
        return;
    end

    local obj = decodeJson(text);
    if obj == nil then
        self:loadServerError("服务器列表解析失败");
        return;
    end
    print("aes severlist === " .. text);

    if obj.code ~= nil then
        local code = tonumber(tostring(obj.code));
        if code == 0 then -- 失败
            print("get serverInfo fail : ", text);
            if obj.error ~= nil then
                self:loadServerError(tostring(obj.error));
                OperateAlert.show(tostring(obj.error));
                return;
            end
        end
    end

    self:setServerListData(obj);
    self:loadAnnouncement();-- 有公告则显示公告
end


function Lua_ServerSelectWindow:loadServerError(text)
    print("获取服务器列表失败: ", text);
    local tipsData = {};
    tipsData.type = 1;
    tipsData.titleName = LangDefine.getValue(1);
    tipsData.des = LangDefine.getValue(16); --文本描述
    tipsData.owner = self;
    tipsData.subFun = self.onReLoadServerList;
    tipsData.cancelFun = self.onReLoadServerList;
    Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, tipsData);
end

function Lua_ServerSelectWindow:onReLoadServerList()
    self:loadServerList();
end

function Lua_ServerSelectWindow:loadAnnouncement()
    print(" GlobalVar.bShowAnnouncement=== ",GlobalVar.bShowAnnouncement,"  PlayerData.getInstance().phpData.bTishenServer==" ,PlayerData.getInstance().phpData.bTishenServer);
    if GlobalVar.bShowAnnouncement or PlayerData.getInstance().phpData.bTishenServer then
        return;
    end
    Lua_MsgUtil.callFunc("GET_ANNOUNCEMENT_INFO");
end

function Lua_ServerSelectWindow:setServerListData(obj)
    DataCenter.serverData:readFromJson(obj);
    self:onSelectedServer(DataCenter.serverData.getDefaultServer);
    Lua_MsgUtil.callFunc("SERVER_INFO_UPDATE");
end

function Lua_ServerSelectWindow:onSelectedServer(obj)
    DataCenter.serverData.selectServerData = obj;
    self.serverItem:setData(obj);
end

function Lua_ServerSelectWindow:onServerEnterClick(obj)
    self:onEnterClick(nil);
end

function Lua_ServerSelectWindow:onServerSelectBack(obj)
    self:onBackClick(nil);
end

function Lua_ServerSelectWindow:onEnterClick(go)
    local selectedServer = DataCenter.serverData.selectServerData;
    if selectedServer == nil then
        OperateAlert.show(LanUtil.getValue(123611));
        return;
    end
    if DataCenter.serverData.isBan then
        OperateAlert.show(LanUtil.getValue(123624));
        return;
    end
    if selectedServer.is_create == 0 then
        OperateAlert.show(LanUtil.getValue(100756));
        return;
    end
    if LuaManager.getInstance().isBind == false then
        OperateAlert.show(LanUtil.getValue(10028));
        return;
    end
    UnityEngine.PlayerPrefs.SetString("selectServer", selectedServer.flag);
    if getTime() - self.lastTime < 1 then
        return;
    end
    self.lastTime = getTime();

    AudioUtil.playBeginClickBtnSound();
    if selectedServer.status == -1 then
        local td = {};
        td.des = LanUtil.getValue(10007);
        td.titleName = LanUtil.getValue(10008);
        td.txtPos = {x = 0, y = 38};
        td.type = 2;
        Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, td);
        return;
    end
    local max = selectedServer.max_online;
    if selectedServer.online >= max and max ~= 0 then
        local td = {};
        td.des = LanUtil.getValue(10009);
        td.titleName = LanUtil.getValue(10008);
        td.txtPos = {x = 0, y = 38};
        td.type = 2;
        Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, td);
        return;
    end
    if selectedServer.status == 0 then
        local td = {};
        td.des = selectedServer.text;
        td.titleName = LanUtil.getValue(10008);
        td.txtPos = {x = 0, y = 38};
        td.type = 2;
        Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, td);
        return;
    end

    local hostname = selectedServer.server_addr;
    local str = ConnectionManager.getInstace():decodeServerAddresses(hostname);
    if str == nil or str == "" then
        DataCenter.loginData.gatewayIP = hostname;
    else
        DataCenter.loginData.gatewayIP = str;
        local val = ConnectionManager.getInstace():isIPv4(hostname);
        if val == 1 then
            SDKInfo.isIPv4 = true;
        elseif val == 0 then
            SDKInfo.isIPv4 = false;
        end
    end
    
    DataCenter.loginData.gatewayPort = selectedServer.server_port;
    ServerConfig.flag = selectedServer.sign;
    ServerConfig.time = selectedServer.tick;
    ServerConfig.sign = selectedServer.flag;
    ServerConfig.serverId = selectedServer.sort;
    ServerConfig.serverName = selectedServer.name;
    UnityEngine.PlayerPrefs.SetString("selectServer", ServerConfig.sign);
    UnityEngine.PlayerPrefs.GetString("selectServer");

    print(" selectedServer.name =====  " .. selectedServer.name);

    Lua_WindowUtil.openWin("Lua_ActivityIndicatorWindow", WinParam.ACTION_OPEN);
    ConnectionManager.getInstace():connectionSocket(Connection.VALIDATION_SOCKET, DataCenter.loginData.gatewayIP, DataCenter.loginData.gatewayPort, true, true);
end

function Lua_ServerSelectWindow:onServerNameClick(go)
    if DataCenter.serverData == nil then
        return;
    end
    Lua_WindowUtil.openWin("Lua_ServerListWindow", WinParam.ACTION_OPEN);
end

function Lua_ServerSelectWindow:onAnnClick(go)
    Lua_MsgUtil.callFunc("GET_ANNOUNCEMENT_INFO");
end

function Lua_ServerSelectWindow:onBackClick(go)
    LuaUtil.relogin();
end

function Lua_ServerSelectWindow:onSwitchClick()
    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.SwitchUser);
end



















Lua_ServerSelectItem = class("Lua_ServerSelectItem", Lua_DisplayObject);
   
function Lua_ServerSelectItem:ctor(p)
    self:superCall("ctor", p, "ServerSelectItem_skin");
end

function Lua_ServerSelectItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_ServerSelectItem:setData(data)
    if data == nil then
        return;
    end
    self.serverNameTxt.text = data.name;
    self.stateIcon:setAltas("login_atlas", data.getStateIcon);
end
