-- 游戏开始 Window
Lua_StartWindow = class("Lua_StartWindow", Lua_Window);

function Lua_StartWindow:ctor()
    self:superCall("ctor");

    self.showClose = false;
    self.showBg = false;
    self.isModel = false;

    self.windowName = "Lua_StartWindow";
end

function Lua_StartWindow:buildShowItem()
    self:superCall("buildShowItem");

    DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.GetScreenHeight); -- 获取sdk屏幕刘海高度

    GlobalVar.isInGame = 0;

    local mainCamera = UnityEngine.Camera.main;
    mainCamera.clearFlags = UnityEngine.CameraClearFlags.SolidColor;

    self.versionTxt = UICreate.createLabel(self.content, "version:" .. Version.SHOW_VERSION, 0, 0, 150, 30, 22);
    self.versionTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
    self.versionTxt:setDepth(2);
    self.versionTxt:setLocation(MainWinDefine.V_width / 2 - 200, -MainWinDefine.V_height / 2 + 50);

    self.startBtn = UICreate.createUIAtlasImage(self.content, "login_atlas", "ui_landing_btn_ks", 0, 0, 0, 0);
    self.startBtn:addClickFuntion(self, self.onStartClick);
    self.startBtn:setDepth(1);
end

function Lua_StartWindow:dispose()
    self:superCall("dispose");
end

function Lua_StartWindow:doShowWin()
    self:superCall("doShowWin");

    if DataCenter.sdkInterface.login_token == nil then
        self:onStartClick();
    else
        Lua_MsgUtil.callFunc("LOGIN_BACK_SEVER_SELECTED");
    end
end

function Lua_StartWindow:onStartClick(go)
    if SDKPlatform.IsNoSdk then
        if NoServerUtil.noServer then
            NoServerUtil.enterGame();
        else
            Lua_WindowUtil.openWin("Lua_LoginWindow", WinParam.ACTION_OPEN);
        end
        self:hide();
    else
        if Lua_PlatformUtil.IsAndroid() or Lua_PlatformUtil.IsIPhonePlayer() then
            ServerConfig.userID = "";
            DataCenter.sdkInterface:callSDKInterface(Lua_SDKMessageType.Login, "");
        end
    end
end  
 