--登录模块 Data
Lua_LoginData = class("Lua_LoginData");

function Lua_LoginData:ctor()
    self.gatewayIP = "192.168.8.163"; --游戏网关IP   由中央服务器列表分配，切不可擅自改写，由这个ip去10700101验证返回正确的ip
    self.gatewayPort = 10511; --网关端口    服务端分配，切不可擅自改写
    
    self._addressList = Array();
end

function Lua_LoginData:addAddress(list)
    if self._addressList ~= nil then
        self._addressList:clear();
    end

    for i = 1, #list do
        local vo = Lua_SceneAddressVo.new();
        vo:fromServer(list[i]);
        self._addressList:add(vo);
    end
end

function Lua_LoginData:getAddress(sceneId)
    for i = 1, self._addressList:getSize() do
        if self._addressList[i].scene_id == sceneId then
            return self._addressList[i];
        end
    end
    return nil;
end



















Lua_SceneAddressVo = class("Lua_SceneAddressVo");

function Lua_SceneAddressVo:ctor()
    self:dispose();
end

function Lua_SceneAddressVo:dispose()
    self.address = nil;
    self.domain = nil;
    self.port = nil;
    self.scene_id = nil;
end

function Lua_SceneAddressVo:fromServer(msg)
    self.scene_id = msg.scene_id;
    self.port = msg.port;
    self.domain = msg.domain;

    if LanUtil.IsNullOrEmpty(self.domain) ~= true then
        local str = ConnectionManager.getInstace():decodeServerAddresses(self.domain);
        if str == nil or str == "" then
            self.address = self.domain;
        else
            self.address = str;
        end
    else
        self.address = msg.address;
    end
end