Lua_DropItemThing = class("Lua_DropItemThing", Lua_ThingPlayer);
function Lua_DropItemThing:loadBodyComplete()
    self:genNamePos();
    self:showName();
end
function Lua_DropItemThing:genNamePos()
    if self.headContainer == nil then
        local tf = nil;
        if self.player.avatar ~= nil then
            tf = ContainerUtil.findBoneTransform(self.player.avatar.transform, "name");
        end
        if tf == nil then
            self.headContainer = UICreate.createGameObject(self.player.root);
            -- self.headContainer.transform.localEulerAngles = Vector3(0, 0, 0);
            -- self.headContainer.transform.localScale = Vector3(0.012, 0.012, 0.012);
            -- self.headContainer.transform.localPosition = Vector3(0, 0.75, 0);

            LuaUtil.setObjRot(self.headContainer, 0, 0, 0);
            LuaUtil.setObjScale(self.headContainer, 0.012, 0.012, 0.012);
            LuaUtil.setObjPos(self.headContainer, 0, 0.75, 0);
        else
            self.headContainer = tf.gameObject;
            -- self.headContainer.transform.localScale = Vector3(0.012, 0.012, 0.012);
            LuaUtil.setObjScale(self.headContainer, 0.012, 0.012, 0.012);
        end
        self.headContainer.name = "name";
    end
    self.player:faceToCam();
end
function Lua_DropItemThing:showName()
    local luaData = nil;
    local rid = tonumber(tostring(self.player.data.roleId));
    luaData = DataCenter.thingData.dropDic[rid];
    if luaData == nil then
        return;
    end
    local tvo = Lua_ToolVo.createToolVo(luaData.item_id, 1, 1);
    local ns = tvo.colorName;
    if DataCenter.moneyData:isMoney(luaData.item_id) then
        ns = ns .. "[" .. Lua_ColorDefine.getItemColorStr(tvo.color) .. "]*" .. luaData.amount .. "[-]"
    end
    if self.player.data.isShowName == false or ns == nil or ns.Length == "" or self.headContainer == nil then
        return;
    end
    if self.titleText == nil then
        self.titleText = UICreate.createLabel(self.headContainer, "", 0, 0, 300, 30, 20);
        self.titleText.pivot = UIWidget.Pivot.Center;
        self.titleText.effectStyle = 3;
        self.titleText.effectColorStr = Lua_ColorDefine.BLACK;
        self.titleText.overflowMethod = UILabel.Overflow.ResizeFreely;
        self.titleText:setDepth(2);
    end
    if self.nameBg == nil then
        self.nameBg = UICreate.createUIAtlasImage(self.headContainer, "iconantlas2", "item_name_bg", 0, 0, 130, 40);
        self.nameBg:setDepth(1);
    end
    self.titleText.text = ns;
    self.nameBg:SetDimensions(self.titleText.width + 40, 40);
    self:updateNameState();
end
function Lua_DropItemThing:updateNameState()
    local pd = PlayerData.getInstance();
    if pd:getSettingValue("SHIELD_DROP_NAME") == 1 then
        if self.headContainer ~= nil then
            self.headContainer:SetActive(false);
        end
    else
        if self.headContainer ~= nil then
            self.headContainer:SetActive(true);
        end
    end
end
function Lua_DropItemThing:clearRes()
    self:superCall("clearRes");
    if self.nameBg ~= nil then
        self.nameBg:dispose();
        self.nameBg = nil;
    end
end