checkRequire("Lua_PetChatSprite");
Lua_ThingPlayer = class("Lua_ThingPlayer");
function Lua_ThingPlayer:setPlayer(player)
    self.player = player;
    self.effectList = Array();
end
function Lua_ThingPlayer:initData()
    if self.player.data.kind == 5 then
        -- 传送阵
        return;
    end
    if self.player.data.kind == Lua_ThingDefine.PLAYER or self.player.data.kind == Lua_ThingDefine.USER then
        if self.player.data.IsUI == true then
            return;
        end
    end
    local rid = tonumber(tostring(self.player.data.roleId));
    DataCenter.thingData:addThingObj(rid, self);
end
function Lua_ThingPlayer:loadBodyComplete()
    self:genNamePos();
    self:showName();
    self:showLeagueName();
    self:showCollectTipsUI();
    self:updateTitle();
    self:updateAscription();
    self:updateOccupation();
    self:updateHpBar();
    self:updateChatSprite();
    self:updateShieldState();
    Lua_CommonUtil.addTimer("THING_PLAYER_LOADED_BODY", 0.5, self, self.updateHeadThingPosition, nil, 1);
    -- self:updateHeadThingPosition();
    if (self.player.data.kind == Lua_ThingDefine.PLAYER or self.player.data.kind == Lua_ThingDefine.USER) then
        if self:showSwimAct() == true then
            self.player.data.curState:setState(3, true);
            self:updateClock();
        else
            self.player.data.curState:setState(3, false);
        end
    end
end
function Lua_ThingPlayer:showSwimAct()
    if DataCenter.roleData.sceneId ~= nil then
        if self.player.data.IsUI ~= true then
            local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
            if sceneConfig ~= nil and sceneConfig.isSwimScene == true then
                return true;
            else
                return false;
            end
        end
    end
    return false;
end
function Lua_ThingPlayer:updateShieldState()
    self:updateClock();
end
function Lua_ThingPlayer:checkHideEffect()
    local pd = PlayerData.getInstance();
    
    local rid = tonumber(tostring(self.player.data.roleId));
    if DataCenter.roleData.roleId == 0 then
        return false;
    end
    if rid ~= DataCenter.roleData.roleId then
        local shieldOther = pd:getSettingValue("SHIELD_OTHER_PET") == 1;
        return shieldOther == true
    else
        local shieldMe = pd:getSettingValue("SHIELD_MYEFFECT") == 1;
        return shieldMe == true
    end
    return true;
end
function Lua_ThingPlayer:updateClock()
    if self.isDispose == true then
        return;
    end
    if (self.player.data.kind == Lua_ThingDefine.PLAYER or self.player.data.kind == Lua_ThingDefine.USER) and self:showSwimAct() == true then
        self:addEffect(10741, nil);
        return;
    end
    local ldata = self:getLuaData();
    local rid = tonumber(tostring(self.player.data.roleId));
    local cloakId = DataCenter.thingData:getCloakTemp(rid);
    if cloakId == nil then
        if ldata == nil then
            return;
        end
        cloakId = ldata.cloak;
    end
    if cloakId == nil 
        or cloakId == 0 
        or self:checkHideEffect() == true then
        self:addEffect(10741, nil);
        return;
    end
    if self.player.data.kind == Lua_ThingDefine.PLAYER or self.player.data.kind == Lua_ThingDefine.USER then
        if ((ldata ~= nil and ldata.transferId ~= 0 and self.player.data.IsUI == false) or (cloakId == nil or cloakId == 0)) then
            self:addEffect(10741, nil);
        else
            local eff = getConfig({"cloak_info", cloakId, "illusion"});
            self:addEffect(10741, tostring(eff));
        end
    end
end

function Lua_ThingPlayer:addEffect(t, str)
    local len = self.effectList:getSize();
    for i=1,len do
        if self.effectList[i].effectType == t then
            if self.effectList[i].effectStr == str then
                return;
            else
                self.effectList[i].effect:dispose();
                self.effectList:remove(i);
                break;
            end
        end
    end
    if str == nil then
        return;
    end
    local effectObj = {effectType=t, effectStr=str};
    local pd = getConfig({"playerHanger", str});
    if pd == nil then
        pd = getConfig({"playerHanger", tonumber(str)});
    end
    if pd == nil then
        return;
    end
    local t = nil;
    if self.player.avatar == nil then
        return;
    end
    if pd.hang == "base" or pd.hang == nil then
        t = self.player.avatar.transform;
    else
        t = ContainerUtil.findBoneTransform(self.player.avatar.transform, pd.hang, "mount_point");
    end
    if t ~= nil then
        local effect = UICreate.createUIEffect(t.gameObject, pd.floder.."/"..pd.fileName, pd.modelName,0,0);
        if self.player.data.IsUI == true then
            effect.showLayer = 5;
        else
            effect.showLayer = 1;
        end
        
        local ldata = self:getLuaData();
        local career = self.player.data.career;
        local pos = nil;
        if pd["wing_pos"..career] ~= nil then
            pos = Vector3(pd["wing_pos"..career][1],pd["wing_pos"..career][2],pd["wing_pos"..career][3]);
        elseif pd["wing_pos"] ~= nil then
            pos = Vector3(pd["wing_pos"][1],pd["wing_pos"][2],pd["wing_pos"][3]);
        else
            pos = Vector3(0,0,0);
        end
        local rot = nil;
        if pd["wing_rot"..career] ~= nil then
            rot = Quaternion.Euler(pd["wing_rot"..career][1],pd["wing_rot"..career][2],pd["wing_rot"..career][3]);
        elseif pd["wing_rot"] ~= nil then
            rot = Quaternion.Euler(pd["wing_rot"][1],pd["wing_rot"][2],pd["wing_rot"][3]);
        else
            rot = Vector3(0,0,0);
        end
        local sca = nil;
        if pd["wing_sca"..career] ~= nil then
            sca = Vector3(pd["wing_sca"..career][1],pd["wing_sca"..career][2],pd["wing_sca"..career][3]);
        elseif pd["wing_sca"] ~= nil then
            sca = Vector3(pd["wing_sca"][1],pd["wing_sca"][2],pd["wing_sca"][3]);
        else
            sca = Vector3(1,1,1);
        end
        effect:setRot(rot.x, rot.y, rot.z);
        effect:setSacle(sca.x, sca.y, sca.z);
        effect:setLocation(pos.x, pos.y, pos.z);

        effectObj.effect = effect;

        self.effectList:add(effectObj);
    end
end

function Lua_ThingPlayer:hideName()
    if self.titleSp ~= nil then
        self.titleSp:dispose();
        self.titleSp = nil;
    end
    if self.titleEffect ~= nil then
        self.titleEffect:dispose();
        self.titleEffect = nil;
    end
    if self.titleText ~= nil then
        self.titleText:dispose();
        self.titleText = nil;
    end
    if self.ascrEffect ~= nil then
        self.ascrEffect:dispose();
        self.ascrEffect = nil;
    end
    if self.occuEffect ~= nil then
        self.occuEffect:dispose();
        self.occuEffect = nil;
    end
    if self.leagueNameTxt ~= nil then
        self.leagueNameTxt:dispose();
        self.leagueNameTxt = nil;
    end
    if self.serverNameTxt ~= nil then
        self.serverNameTxt:dispose();
        self.serverNameTxt = nil;
    end
    if self.chatItem ~= nil then
        self.chatItem:dispose();
        self.chatItem = nil;
    end
    if self.hpBar ~= nil then
        self.hpBar:dispose();
        self.hpBar = nil;
    end
    if self.hpBarBg ~= nil then
        self.hpBarBg:dispose();
        self.hpBarBg = nil;
    end
    if self.headContainer ~= nil then
        UnityEngine.GameObject.DestroyImmediate(self.headContainer);
        self.headContainer = nil;
    end
end
function Lua_ThingPlayer:genNamePos()
    if self.player.data.isShowName == true and self.headContainer == nil then
        local tf = nil;
        if self.player.avatar ~= nil then
            tf = ContainerUtil.findBoneTransform(self.player.root.transform, "name");
        end
        if tf == nil then
            self.headContainer = UICreate.createGameObject(self.player.root);
            LuaUtil.setObjPos(self.headContainer, 0, self.player.data.kind == 5 and 1.1 or 2.2, 0);
            LuaUtil.setObjRot(self.headContainer, 0, 0, 0);
        else
            self.headContainer = tf.gameObject;
        end
        if (self.player.data.kind == Lua_ThingDefine.NPC 
            or self.player.data.kind == Lua_ThingDefine.MONSTER)
            and self.player.data ~= nil
            and self.player.data.objId ~= 0 then
            local monsterData = Lua_MonsterConfigData.new(self.player.data.objId);
            local scale = (monsterData ~= nil and monsterData.isCollect == false) and monsterData.scale or 1;
            LuaUtil.setObjScale(self.headContainer, 0.012 / scale, 0.012 / scale, 0.012 / scale);

            if monsterData.nameOffsetY ~= nil then
                LuaUtil.setObjPos(self.headContainer, 0, monsterData.nameOffsetY, 0);
            end
        else
            LuaUtil.setObjScale(self.headContainer, 0.012, 0.012, 0.012);
        end
        
        self.headContainer.name = "name";
    end
    self.player:faceToCam();
end
function Lua_ThingPlayer:getLuaData()
    local rid = tonumber(tostring(self.player.data.roleId));
    local luaData = DataCenter.thingData:getThing(rid);
    return luaData;
end
function Lua_ThingPlayer:showCollectTipsUI()
    local luaData = self:getLuaData();
    if luaData == nil or luaData.monsterData == nil or luaData.monsterData.effect_tip == nil then
        if self.tipsUIEffect ~= nil then
            self.tipsUIEffect:setEnable(false);
        end
        return;
    end
    if self.tipsUIEffect == nil then
        self.tipsUIEffect = UICreate.createUIEffect(self.headContainer, "/effects/scsEffects/"..luaData.monsterData.effect_tip, 
            luaData.monsterData.effect_tip, 0, 0);
        self.tipsUIEffect.showLayer = 1;
        self.tipsUIEffect:setSacle(0.8, 0.8, 0.8);
        self.tipsUIEffect:setLocation(0, 40, 0);
    end
    self.tipsUIEffect:setEnable(true);
end
function Lua_ThingPlayer:showLeagueName()
    if self.player.data.kind == 5 or self.player.data.isShowName == false then
        return;
    end

    local luaData = self:getLuaData();
    if luaData ~= nil and luaData.leagueName ~= nil and luaData.leagueName ~= "" and self.headContainer ~= nil then
        if self.leagueNameTxt == nil then
            self.leagueNameTxt = UICreate.createLabel(self.headContainer, "", 0, 0, 200, 30, 20);
            self.leagueNameTxt.name = "leagueNameTxt";
            self.leagueNameTxt.pivot = UIWidget.Pivot.Center;
            self.leagueNameTxt.effectStyle = 3;
            self.leagueNameTxt.effectColorStr = Lua_ColorDefine.BLACK;
            self.leagueNameTxt:setEffectDistance(0.5, 0.5);
        else
            if self.headContainer ~= nil and self.headContainer.transform ~= nil then
                -- print("luaData.objId" .. tostring(luaData.objId) .. " , name:" .. tostring(luaData.name));
                self.leagueNameTxt:setParent(self.headContainer.transform);
            end
        end
        self.leagueNameTxt.overflowMethod = UILabel.Overflow.ResizeFreely;

        local str = "";
        -- 帮派联赛，帮派颜色要根据阵营变化
        if DataCenter.factionLeagueActData ~= nil and DataCenter.factionLeagueActData.bInFactionLeagueActScene == true then
            local campId = self.player.data.camp_id;
            if campId == 0 then
                campId = tonumber(tostring(self.player.data.sub_id));
            end
            if campId ~= 0 then
                if campId == Lua_CampWarUtil.CAMPWARID_RED then
                    str = "[ff0000][" .. luaData.leagueName .. "][-]";
                elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
                    str = "[55d2ff][" .. luaData.leagueName .. "][-]";
                end
            end
        else
            str = "[55d2ff]" .. luaData.leagueName .. "[-]";
        end

        self.leagueNameTxt.text = str;
        self.leagueNameTxt:setLocation(0, 23, 0);
    else
        if self.leagueNameTxt ~= nil then
            self.leagueNameTxt:dispose();
            self.leagueNameTxt = nil;
        end
    end
    local sdata = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if luaData ~= nil 
        and luaData.server_name ~= nil 
        and luaData.server_name ~= "" 
        and self.headContainer ~= nil
        and sdata.show_server_name == 1 then
        if self.serverNameTxt == nil then
            self.serverNameTxt = UICreate.createLabel(self.headContainer, "", 0, 0, 200, 30, 20);
            self.serverNameTxt.name = "serverNameTxt";
            self.serverNameTxt.pivot = UIWidget.Pivot.Center;
            self.serverNameTxt.effectStyle = 3;
            self.serverNameTxt.effectColorStr = Lua_ColorDefine.BLACK;
            self.serverNameTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
            self.serverNameTxt:setEffectDistance(0.5, 0.5);
            self.serverNameTxt:setLocation(0, 46, 0);
        end
        self.serverNameTxt.text = "[55d2ff]"..luaData.server_name.."[-]";
    else
        if self.serverNameTxt ~= nil then
            self.serverNameTxt:dispose();
            self.serverNameTxt = nil;
        end
    end
end
function Lua_ThingPlayer:showName()
    if self.player.data.kind == 5 and DataCenter.campWarData.bInCampWarScene == true then
        -- 夺旗大战不需要显示传送阵名字
        return;
    end
    if self.player.data.isShowName == false then
        return;
    end
    local ns = self.player.data.nickname;
    local luaData = self:getLuaData();
    if luaData ~= nil and luaData.copy_player == true then
        ns = ns.."("..LanUtil.getValue(122256)..")";
    end

    if tonumber(tostring(self.player.data.roleId)) == 901010306 then
        if self.hongniang_BG == nil then
            self.hongniang_BG = UICreate.createUIAtlasImage(self.headContainer, "marryWindow", "marry_proffer1", 0, 35, 0, 0);
            self.hongniang_BG:setEnable(false);
        end
    end
    if luaData ~= nil and self.player.data.kind == 8 then
        local wData = DataCenter.thingData:getThing(luaData.master_id);
        if wData ~= nil then
            ns = LanUtil.formateStr(LanUtil.getValue(110041), wData.name);
        end
    end
    if ns == nil or ns.Length == "" or self.headContainer == nil then
        return;
    end

    if self.titleText == nil then
        if self.player.data.kind == 5 then
            self.titleText = UICreate.createLabel(self.headContainer, "", 0, 0, 300, 30, 24);
            self.titleText.effectStyle = 2;
            self.titleText.effectColorStr = Lua_ColorDefine.transColor("551e00");
            self.titleText:setEffectDistance(1, 1);
            self.titleText.applyGradient = 1;
            self.titleText.gradientTop = "3439329177";
            self.titleText.gradientBottom = "4294629149";
        else
            self.titleText = UICreate.createLabel(self.headContainer, "", 0, 0, 200, 30, 20);
            self.titleText.effectStyle = 3;
            self.titleText.effectColorStr = Lua_ColorDefine.BLACK;
            self.titleText:setEffectDistance(0.5, 0.5);
        end
        self.titleText.name = "titleText";
        self.titleText.pivot = UIWidget.Pivot.Center;
        self.titleText:setDepth(2);
    end
    self.titleText.overflowMethod = UILabel.Overflow.ResizeFreely;
    if luaData ~= nil then
        Lua_CommonUtil.removeTimer(self, self.onTombCountDownStep);
        if luaData.reliveEndTime ~= nil and luaData.reliveEndTime > getTime() then
            self.tombEndTime = luaData.reliveEndTime;
            self.titleText:SetDimensions(200, 47);
            Lua_CommonUtil.addTimer("tomb_countdown_" .. tostring(luaData.objId), 0.5, self, self.onTombCountDownStep, nil, -1);
            return;
        end

        if DataCenter.campWarData.bInCampWarScene == true 
            and self.player.data.kind ~= 5 
            and self.player.data.camp_id ~= 0 then
            if DataCenter.roleData.camp_id == self.player.data.camp_id then
                ns = "[" .. Lua_ColorDefine.WHITE_STR .. "]" .. ns .. "[-]";
            else
                ns = "[" .. Lua_ColorDefine.RED_STR .. "]" .. ns .. "[-]";
            end
        else
            if self.player.data.kind == 1 or self.player.data.kind == 2 then
                local colorName = luaData.nameColor;
                if colorName ~= nil then
                    ns = "[" .. Lua_ColorDefine.getItemColorStr(colorName) .. "]" .. ns .. "[-]";
                end
            end
        end
        -- 军衔
        if luaData.militaryRank ~= nil and luaData.militaryRank ~= 0 then
            local junxianName = getConfig( { "military_rank", "junxian", luaData.militaryRank });
            local junxianColor = getConfig( { "military_rank", "junxian_color", luaData.militaryRank });
            ns = junxianColor .. "[" .. junxianName .. "][-]" .. ns;
        end
        if luaData.permission == 8 then
            ns = "[feab19]["..LanUtil.getValue(120232).."][-]"..ns;
        end
        if luaData.hooking == true then
            ns = ns .. LanUtil.getValue(110643);
        end
    end

    -- 阵营
    if self.player.data.kind ~= 5 then
        local campId = self.player.data.camp_id;
        if campId == 0 then
            campId = tonumber(tostring(self.player.data.sub_id));
        end
        if campId ~= 0 and (DataCenter.campWarData.bInCampWarScene == true or DataCenter.roleData.sceneId == 71701) then
            if campId == Lua_CampWarUtil.CAMPWARID_RED then
                ns = "[ff0000][" .. DataCenter.campWarUtil:getCampNameById(campId) .. "][-]" .. ns;
            elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
                ns = "[55d2ff][" .. DataCenter.campWarUtil:getCampNameById(campId) .. "][-]" .. ns;
            end
            -- local rid = tonumber(tostring(self.player.data.roleId));
            -- if rid == tonumber(DataCenter.roleData.roleId) then
            --     ns = "[55d2ff][" .. DataCenter.campWarUtil:getCampNameById(campId) .. "][-]" .. ns;
            -- else
            --     if campId ~= DataCenter.roleData.camp_id then
            --         -- 敌人
            --         ns = "[ff0000][" .. DataCenter.campWarUtil:getCampNameById(campId) .. "][-]" .. ns;
            --     else
            --         -- 己方阵营
            --         ns = "[55d2ff][" .. DataCenter.campWarUtil:getCampNameById(campId) .. "][-]" .. ns;
            --     end
            -- end
        end
    end
    self.titleText.text = ns;
    --觉醒副本采集物前缀
    if luaData ~= nil then
        if luaData.preName ~= nil then
            self:showNamePreEffect(luaData.preName);
        else
            self:removeNamePreEffect();
        end
    end
end
function Lua_ThingPlayer:showNamePreEffect(str)
    if self.preNameEffect == nil and self.headContainer ~= nil then
        self.preNameEffect = UICreate.createUIEffect(self.headContainer,nil ,nil, 0, 0);
        self.preNameEffect.showLayer = 1;
        self.preNameEffect:setUrl("/effects/scsEffects/"..str, str);
    end
    if self.preNameEffect ~= nil then
        local offfsetX = -90;
        if self.titleText ~= nil then
            offfsetX = (-1 * self.titleText.width / 2) - 15;
        end
        self.preNameEffect:setLocation(offfsetX,0,0);
    end
end
function Lua_ThingPlayer:removeNamePreEffect()
    if self.preNameEffect ~= nil then
        self.preNameEffect:dispose();
        self.preNameEffect  = nil;
    end
end
function Lua_ThingPlayer:onTombCountDownStep()
    local now = getTime();
    local luaData = self:getLuaData();
    if luaData ~= nil and luaData.reliveEndTime ~= nil and luaData.reliveEndTime >= now then
        local timeStr = TimeTransform.getInstance():transSeconds6(luaData.reliveEndTime - now, true, true);
        local tname = LanUtil.formateStr(LanUtil.getValue(121644), luaData.otherName, tostring(luaData.otherLvl), timeStr);
        self.titleText.text = tname;
    else
        Lua_CommonUtil.removeTimer(self, self.onTombCountDownStep);
    end
end
function Lua_ThingPlayer:updateAscription()
    if self.player.data.isShowName == false then
        return;
    end
    local luaData = self:getLuaData();
    if luaData == nil or self.headContainer == nil then
        return;
    end
    local ascriptionState = luaData.ascription_state;
    if ascriptionState ~= 0 then
        if self.ascrEffect == nil then
            if ascriptionState == 1 then
                self.ascrEffect = UICreate.createUIEffect(self.headContainer, "/effects/scsEffects/drop_ownership", "drop_ownership", 0, 0);
            elseif ascriptionState == 2 then
                if self.headSp == nil then
                    self.headSp = UICreate.createUIAtlasImage(self.headContainer, luaData.atlasAndSprite[1], luaData.atlasAndSprite[2], 0, 43, 0, 0);
                    self.headSp:resetSize();
                end
            else
                self.ascrEffect = UICreate.createUIEffect(self.headContainer, "/effects/scsEffects/"..luaData.ascriptionEffect, luaData.ascriptionEffect, 0, 0);
            end
            if self.ascrEffect ~= nil then
                self.ascrEffect.showLayer = 1;
                self.ascrEffect:setSacle(100, 100, 100);
                self.ascrEffect:setLocation(0, 70, 0);
                -- self.ascrEffect.mainContent.transform.localRotation = Quaternion.Euler(0, 180, 0);
                LuaUtil.setObjRot(self.ascrEffect.mainContent, 0, 180, 0);
            end
        end
        if ascriptionState == 1 then
            if self.ascrEffect ~= nil then
                self.ascrEffect:setUrl("/effects/scsEffects/drop_ownership", "drop_ownership");
            end
        elseif ascriptionState == 2 then
            if self.headSp == nil then
                self.headSp = UICreate.createUIAtlasImage(self.content, luaData.atlasAndSprite[1], luaData.atlasAndSprite[2], 0, 43, 0, 0);
                self.headSp:resetSize();
            end
        else
            if self.ascrEffect ~= nil then
                self.ascrEffect:setUrl("/effects/scsEffects/"..luaData.ascriptionEffect, luaData.ascriptionEffect);
            end
        end
        if self.ascrEffect ~= nil then
            self.ascrEffect:setEnable(true);
        end
    else

        if self.ascrEffect ~= nil then
            self.ascrEffect:dispose();
        end
        if self.headSp ~= nil then
            self.headSp:dispose();
            self.headSp = nil;
        end
        self.ascrEffect = nil;
    end

end
function Lua_ThingPlayer:updateOccupation()

    if self.player.data.isShowName == false then
        return;
    end
    local luaData = self:getLuaData();
    if luaData == nil or luaData.occupy_state==nil or self.headContainer == nil then
        return;
    end
    local ascriptionState = luaData.occupy_state;
    if ascriptionState ~= 0 then
        if self.occuEffect == nil then
            self.occuEffect = UICreate.createUIEffect(self.headContainer, "/effects/scsEffects/hdzc_04", "hdzc_04", 0, 0);
            self.occuEffect.showLayer = 1;
            self.occuEffect:setSacle(100, 100, 100);
            self.occuEffect:setLocation(0, 70, 0);
            -- self.occuEffect.mainContent.transform.localRotation = Quaternion.Euler(0, 180, 0);
            LuaUtil.setObjRot(self.occuEffect.mainContent, 0, 180, 0);
        end
        if ascriptionState == 1 then
            self.occuEffect:setUrl("/effects/scsEffects/hdzc_04", "hdzc_04");
        end
        self.occuEffect:setEnable(true);
    else
        if self.occuEffect ~= nil then
            self.occuEffect:dispose();
        end
        self.occuEffect = nil;
    end

end
function Lua_ThingPlayer:updateChatSprite()
    if self.player.data.kind ~= 8 then
        return;
    end

    local luaData = self:getLuaData();
    if luaData == nil then
        return;
    end
    if tonumber(luaData.master_id) ~= DataCenter.roleData.roleId then
        return;
    end

    if self.chatItem == nil 
        and self.headContainer ~= nil then
        self.chatItem = Lua_PetChatSprite.new(self.headContainer, 250, 100);
        self.chatItem:setLocation(0,30, 0);
    end
end
-- 更新采集物头顶血条
function Lua_ThingPlayer:updateHpBar()
    if self.player.data.kind ~= 3 then
        return;
    end

    local luaData = self:getLuaData();
    if luaData == nil or luaData.isShowHpBar == false or self.headContainer == nil then
        return;
    end

    local curVal = luaData.hp;
    if curVal < 0 then
        curVal = 0;
    end
    local totalVal = luaData.maxHp;
    if curVal == nil or totalVal == nil or totalVal <= 0 then
        return;
    end

    if luaData.eachBloodVal > 0 then -- 分段
        if self.hpBar == nil then
            local num = math.ceil(totalVal / luaData.eachBloodVal);
            self.hpBar = Lua_SectionProccessBar.new(self.headContainer, luaData.eachBloodVal, num);
            self.hpBar:setLocation(0, 35, 0);
        end
        self.hpBar:setInfoTxt(curVal, totalVal);
    else
        if self.hpBar == nil then
            self.hpBarBg = UICreate.createUIAtlasImage(self.headContainer, "iconantlas1", "jdt_bg01", 0, 35, 334, 18);
            self.hpBarBg.name = "hpBarBg";
            
            self.hpBar = Lua_ProccessBar.new(self.headContainer);
            self.hpBar:setLocation(-165, 35, 0);
            self.hpBar:setBarSprite("iconantlas1", "jdt_bar01", 330, 16);
        end
        self.hpBar:setInfoTxt(curVal, totalVal);
        self.hpBar.infoTxt.text = "";
    end
end

function Lua_ThingPlayer:updateTitle()
    if self.player.data.isShowName == false then
        return;
    end

    local luaData = self:getLuaData();
    if luaData == nil or self.headContainer == nil then
        return;
    end
    
    if luaData.labelId == nil or luaData.labelId == 0 then
        if self.titleSp ~= nil then
            self.titleSp:dispose();
            self.titleSp = nil;
        end
        if self.titleEffect ~= nil then
            self.titleEffect:dispose();
            self.titleEffect = nil;
        end
    else
        local tdata = Lua_TitleData.new(luaData.labelId);
        if self.titleEffect ~= nil then
            self.titleEffect:dispose();
            self.titleEffect = nil;
        end
        if tdata.effect == nil then
            if self.titleSp == nil then
                self.titleSp = UICreate.createUIAtlasImage(self.headContainer, nil, nil, 0, 0, 0, 0);
                self.titleSp.name = "titleSp";
            end
            self.titleSp:setAltas("item7", tostring(tdata.referenceId));
            self.titleSp:setLocation(0, 40, 0);
            self.titleSp:resetSize();
        else
            if self.titleSp ~= nil then
                self.titleSp:dispose();
                self.titleSp = nil;
            end
            if self.titleEffect == nil then
                self.titleEffect = UICreate.createUIEffect(self.headContainer, "/effects/scsEffects/"..tdata.effect, tdata.effect, 0, 0);
            end
            self.titleEffect:setUrl("/effects/scsEffects/"..tdata.effect,tdata.effect);
            self.titleEffect.showLayer = 1;
            if tdata.config.scene_size == nil then
                self.titleEffect:setSacle(250,250,250);
            else
                self.titleEffect:setSacle(tdata.config.scene_size[1],tdata.config.scene_size[2],tdata.config.scene_size[3]);
            end
            self.titleEffect:setLocation(0, 40, 0);
        end
        
    end
end
-- 更新头顶挂件位置
function Lua_ThingPlayer:updateHeadThingPosition()
    self.curHeadHeight = 0;
    if self.leagueNameTxt ~= nil and self.leagueNameTxt.text ~= "" then
        self.curHeadHeight = self.curHeadHeight + 22;
        self.leagueNameTxt:setLocation(0, self.curHeadHeight, 0);
    end
    if self.serverNameTxt ~= nil and self.serverNameTxt.text ~= "" then
        self.curHeadHeight = self.curHeadHeight + 22;
        self.serverNameTxt:setLocation(0, self.curHeadHeight, 0);
    end
    if self.titleSp ~= nil then
        self.curHeadHeight = self.curHeadHeight + 33;
        self.titleSp:setLocation(0, self.curHeadHeight, 0);
    end
    if self.titleEffect ~= nil then
        self.curHeadHeight = self.curHeadHeight + 33;
        self.titleEffect:setLocation(0, self.curHeadHeight, 0);
    end
    if self.ascrEffect ~= nil then
        self.curHeadHeight = self.curHeadHeight + 70;
        self.ascrEffect:setLocation(0, self.curHeadHeight, 0);
    end
    if self.headSp ~= nil then
        self.curHeadHeight = self.curHeadHeight + 42;
        self.headSp:setLocation(0, self.curHeadHeight, 0);
    end
    if self.occuEffect ~= nil then
        self.curHeadHeight = self.curHeadHeight + 70;
        self.occuEffect:setLocation(0, self.curHeadHeight, 0);
    end
    if self.hpBar ~= nil then
        self.curHeadHeight = self.curHeadHeight + 35;
        if self.hpBarBg ~= nil then
            self.hpBarBg:setLocation(0, self.curHeadHeight, 0);
            self.hpBar:setLocation(-165, self.curHeadHeight, 0);
        else
            self.hpBar:setLocation(0, self.curHeadHeight, 0);
        end
    end
end
function Lua_ThingPlayer:playerThunderStrikeEffect()
    if self.player ~= nil then
        self.player:onPlayThunderStrikeEffect();
    end
end
function Lua_ThingPlayer:clearRes()
    Lua_CommonUtil.removeTimer(self, self.updateHeadThingPosition);
    Lua_CommonUtil.removeTimer(self, self.onTombCountDownStep);
    if self.titleSp ~= nil then
        self.titleSp:dispose();
        self.titleSp = nil;
    end
    if self.titleEffect ~= nil then
        self.titleEffect:dispose();
        self.titleEffect = nil;
    end
    if self.titleText ~= nil then
        self.titleText:dispose();
        self.titleText = nil;
    end
    if self.ascrEffect ~= nil then
        self.ascrEffect:dispose();
        self.ascrEffect = nil;
    end
    if self.headSp ~= nil then
        self.headSp:dispose();
        self.headSp = nil;
    end
    if self.occuEffect ~= nil then
        self.occuEffect:dispose();
        self.occuEffect = nil;
    end
    if self.leagueNameTxt ~= nil then
        self.leagueNameTxt:dispose();
        self.leagueNameTxt = nil;
    end
    if self.serverNameTxt ~= nil then
        self.serverNameTxt:dispose();
        self.serverNameTxt = nil;
    end
    if self.tipsUIEffect ~= nil then
        self.tipsUIEffect:dispose();
        self.tipsUIEffect = nil;
    end
    if self.hpBar ~= nil then
        self.hpBar:dispose();
        self.hpBar = nil;
    end
    if self.hpBarBg ~= nil then
        self.hpBarBg:dispose();
        self.hpBarBg = nil;
    end

    local len = self.effectList:getSize();
    for i=1,len do
        self.effectList[i].effect:dispose();
    end
    self.effectList:clear();

    self:removeNamePreEffect();
    self.headContainer = nil;
end
function Lua_ThingPlayer:dispose()
    self.isDispose = true;
    -- print("Lua_ThingPlayer dispose", self.index);
end