Lua_PetChatSprite = class("Lua_PetChatSprite", Lua_DisplayObject);
function Lua_PetChatSprite:ctor(p, w, h)
	self.bg_width = w;
	self.bg_height = h;
	self:superCall("ctor", p);
end
function Lua_PetChatSprite:buildShowItem()
    self:superCall("buildShowItem");
    self.bg = UICreate.createUIAtlasImage(self.content, "iconantlas2", "chat_pao", 0, 0, self.bg_width, self.bg_height);
    self.bg.depth = 2;
    self.bg.pivot = Lua_WindowUtil.getPivot(8);
    self.bg:setLocation(0,0,0);

    self.textWidth = self.bg_width - 22;
    self.textField = UICreate.createLabel(self.content, "", 0, 0, self.textWidth, 50, 20);
    self.textField.colorStr = "4293915901";
    self.textField.overflowMethod = UILabel.Overflow.ResizeHeight;
    self.textField.pivot = Lua_WindowUtil.getPivot(7);
    self.textField:setLocation(0,0,0);
    self.textField.depth = 3;
    self.textField.spacingY = 5;
    self:setShowState(false);

    self:addTimer("Lua_PetChatSprite", 1, self, self.onEnterFrame);
end
function Lua_PetChatSprite:setTxt(str)
	self.textField.text = str;
	self.textField:setLocation(-1 * self.textWidth / 2, 20, 0);
	self.bg:SetDimensions(self.bg_width, self.textField.height + 36);
	self:setShowState(true);
	self.startShowTime = getTime();
end
function Lua_PetChatSprite:setShowState(val)
	self.isShowing = val;
	self.textField:setEnable(val);
	self.bg:setEnable(val);
end
function Lua_PetChatSprite:onEnterFrame()
	if self.isShowing == true then
		local lastTime = getConfig({"pet_chat", "last_time"});
		if getTime() - self.startShowTime > lastTime then
			DataCenter.roleData.startPetTime = getTime();
			self:setShowState(false);
		end
	else
		local interval = getConfig({"pet_chat", "interval"});
		if DataCenter.roleData.petChatCountDown == -1 then
			local st = getConfig({"pet_chat", "start_time"});
			DataCenter.roleData.petChatCountDown = st;
		end
		DataCenter.roleData.petChatCountDown = DataCenter.roleData.petChatCountDown - 1;
		if DataCenter.roleData.petChatCountDown <= 0 then
			if getRandomRange(100) <= getConfig({"pet_chat", "rate"}) then
				local sid = DataCenter.roleData.sceneId;
				local list = getConfig({"pet_chat", "scene_tips", sid});
				if list == nil then
					local lv = DataCenter.roleData.level;
					local lvTips = getConfig({"pet_chat", "lvl_tips"});
					for i,v in ipairs(lvTips) do
						if lv <= v.level then
							list = v.tips;
							break;
						end
					end
				end
				if list ~= nil then
					local len = #list;
					local index = getRandomRange(len);
					local lastIndex = DataCenter.roleData.petLastIndex;
					while len > 1 and index == lastIndex do
						index = getRandomRange(len);
					end
					self:setTxt(list[index]);
					DataCenter.roleData.petLastIndex = index;
				end
			end
			DataCenter.roleData.petChatCountDown = interval;
		end
	end
end
function Lua_PetChatSprite:onSceneChange(o)
	local sid = DataCenter.roleData.sceneId;
	local list = getConfig({"pet_chat", "scene_tips", sid});
	if list ~= nil then
		local len = #list;
		local index = getRandomRange(len);
		self:setTxt(list[index]);
	end
end