checkRequire("Lua_AchievementVo");
Lua_AchievementData = class("Lua_AchievementData");
Lua_AchievementData.GEREN = 1;
Lua_AchievementData.ZHUANBEI = 2;
Lua_AchievementData.HUOBAN = 3;
Lua_AchievementData.SHEJIAO = 4;
Lua_AchievementData.LICHENG = 5;
Lua_AchievementData.ALL_ACH = 9;
function Lua_AchievementData:ctor()
	self:dispose();
end

function Lua_AchievementData:dispose()
	self.childDic = nil;
	self.allList = nil;
	self.childToMain = nil;
	self.achChanlePoint = {};
end

function Lua_AchievementData:canGetNum(t)
	self:initAchList();
	local rs = 0;
	for k,v in pairs(self.allList) do
		if v.status == 1 and (t == 0 or v.ach_index == t) then
			rs = rs + 1;
		end
	end
	return rs;
end

function Lua_AchievementData:getSortList()
	if self.sortList == nil then
		self.sortList = Array();
		local c = getConfig({"achieve_class"});
		for k,v in pairs(c) do
			v.key = tonumber(k);
			self.sortList:add(v);
		end
		self.sortList:sort("sort", false);
	end
	return self.sortList;
end

function Lua_AchievementData:getChildList(val)
	if self.childDic == nil then
		self.childDic = {};
		self.childToMain = {};
		local c = getConfig({"child_achieve"});
		for k,v in pairs(c) do
			local b = tonumber(v.base_type);
			if self.childDic[b] == nil then
				self.childDic[b] = Array();
			end
			self.childToMain[tonumber(k)] = v.base_type;
			self.childDic[b]:add({data=tonumber(k), name=v.name, sort=v.sort});
		end
		for k,v in pairs(self.childDic) do
			v:sort("sort", false);
		end
	end
	return self.childDic[val];
end

function Lua_AchievementData:initAchList()
	self:getChildList(1);
	if self.allList == nil then
		self.allList = {};
		local c = getConfig({"achieve_list"});
		for k,v in pairs(c) do
			local vo = Lua_AchievementVo.new(k,v);
			self.allList[tonumber(k)] = vo;
			local base_type = self.childToMain[vo.ach_index];
			if self.achChanlePoint[base_type] == nil then
				self.achChanlePoint[base_type] = 0;
			end
			self.achChanlePoint[base_type] = self.achChanlePoint[base_type] + vo.ach_amount;
		end
	end
end

function Lua_AchievementData:getAchVo(id)
	self:initAchList();
	return self.allList[tonumber(id)];
end

function Lua_AchievementData:getAchList(val)
	self:initAchList();
	local arr = Array();
	for k,v in pairs(self.allList) do
		if v.ach_index == val then
			arr:add(v);
		end
	end
	arr:sort("sort", false);
	return arr;
end

function Lua_AchievementData:from51401101(msg)
	self:initAchList();
	for i,v in ipairs(msg.achieve_list) do
		if self.allList[v.achieve_id] ~= nil then
			self.allList[v.achieve_id]:fromAchDetail(v);
		end
	end
	self.achLevel = msg.achieve_level;
	self.point_set = msg.point_set;
	self.progress = msg.progress;
end

function Lua_AchievementData.Get:exp()
	if self.progress == nil then
		return 0;
	end
	return self.progress;
end

function Lua_AchievementData:getChanelAmount(val)
	if self.point_set == nil then
		return 0;
	end
	for i,v in ipairs(self.point_set) do
		if v.obj_id == val then
			return v.obj_value;
		end
	end
	return 0;
end

function Lua_AchievementData:getChanelMax(val)
	if self.achChanlePoint == nil or self.achChanlePoint[val] == nil then
		return 0;
	end
	return self.achChanlePoint[val];
end