-- 只爱一人
Lua_OnlyLovesOnePersonPanel = class("Lua_OnlyLovesOnePersonPanel", Lua_DisplayObject)
function Lua_OnlyLovesOnePersonPanel:ctor(p)
	self:superCall("ctor", p, "OnlyLovesOnePersonPanel_skin");
end

function Lua_OnlyLovesOnePersonPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 703, 229));
	self.dragList:setListCell(Lua_OnlyLovesOnePersonItem, 51, 703, 1);
	self.dragList:setLocation(121, -135, 0);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 12;
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(-419, -153, 0);

	self.subBtn:addClickFuntion(self, self.onBtnGoingClick);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA",self,self.updatePanelInfo);
	-- DataCenter.OperationalActivitiesData:sGetOperationalActivities(self.act_index, self.first_type);
end

function Lua_OnlyLovesOnePersonPanel:updatePanelInfo()
	if DataCenter.OpenDressCarnivalData.first_type ~= self.first_type then
		return;
	end

	self.eTimeNum = DataCenter.OpenDressCarnivalData.stop_tick; -- 活动结束时间
	local start_tick = DataCenter.OpenDressCarnivalData.start_tick; -- 活动开始时间
	local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
	local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
	self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), tostring(atimeStr1 .. "--" .. atimeStr2));

	self.times = DataCenter.OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）
	self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), TimeTransform.getInstance():transSeconds1((self.eTimeNum - self.times), true));
	Lua_CommonUtil.addTimer("onlyLovesOne_Timer", 1, self, self.onTimeStrTimer);

	local content = DataCenter.OpenDressCarnivalData.content;
	self.tips.text = LanUtil.formateStr(LanUtil.getValue(127302), tostring(content));

	local title_id = getConfig({"item",DataCenter.OpenDressCarnivalData.title_id,"effect_prop"}).label_id;
	local getTitleForce = DataCenter.OpenDressCarnivalData:getTitleForce(title_id);
	self.fightNum.num = getTitleForce;
	self.fightNum:setNumScale(0.85, 0.85);

	local getEffact = getConfig({"label", title_id, "effect"});
	local effect_size = getConfig({"label", title_id, "effect_size"});
	local effect_location = getConfig({"label", title_id, "effect_location"});
	if self.rsEffect == nil then
		self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. getEffact, getEffact, 0, 0);
		self.rsEffect:SetRenderQueue(self.end_time, 4, 2, false);
		self.rsEffect:setSacle(effect_size[1], effect_size[2], effect_size[3]); -- 模型比例
		if effect_location == nil then
			self.rsEffect:setLocation(-379, -100, 0);
		else
			self.rsEffect:setLocation(effect_location[1], effect_location[2], effect_location[3]);
		end
	end

	self.redDot:setEnable(false);
	self.subBtn:setBtnEnable(true);

	self.isWedding = DataCenter.marryData.wedding_id; -- 是否结婚
	self.isReward = DataCenter.OpenDressCarnivalData.draw_flag; -- 0未领取，1已领取，2表示条件不足
	if self.isWedding ~= 0 and self.isWedding ~= nil then -- 已结婚
		if self.isReward == 0 then
			self.redDot:setEnable(true);
			self.subBtn.label = LanUtil.getValue(122527);
		elseif self.isReward == 1 then
			self.subBtn:setBtnEnable(false);
			self.subBtn.label = LanUtil.getValue(122528);
		else
			self.subBtn.label = LanUtil.getValue(127307);
		end
	else
		self.subBtn.label = LanUtil.getValue(127306);
	end

	local arr = DataCenter.OpenDressCarnivalData.getOnlyLovesOneData;
	self.dragList:setLuaArrayData(arr, false);
end

function Lua_OnlyLovesOnePersonPanel:onTimeStrTimer()
	self.eTimeNum = self.eTimeNum - 1;
	if self.eTimeNum - self.times > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), TimeTransform.getInstance():transSeconds1(self.eTimeNum - self.times, true));
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_OnlyLovesOnePersonPanel:onBtnGoingClick()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1027, nil);
	if avo == nil then
		return;
	end

	local reward_index = DataCenter.OpenDressCarnivalData.reward_index;
	if self.isWedding ~= 0 and self.isWedding ~= nil then -- 已结婚
		if self.isReward == 0 then -- 未领取
			DataCenter.OperationalActivitiesData:buyReward(tonumber(avo.act_index), tonumber(reward_index), 1);
		elseif self.isReward == 2 then -- 补办婚宴
			Lua_WindowUtil.openWin("Lua_MailBoxWindow", WinParam.ACTION_OPEN, 2);
			Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE);
		end
	else -- 前往结婚
		Lua_WindowUtil.openWin("Lua_MarryWindow", WinParam.ACTION_OPEN);
		Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_OnlyLovesOnePersonPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OnlyLovesOnePersonItem = class("Lua_OnlyLovesOnePersonItem", Lua_ListCell);
function Lua_OnlyLovesOnePersonItem:ctor(p)
	self:superCall("ctor", p, "OnlyLovesOnePersonItem_skin");
end

function Lua_OnlyLovesOnePersonItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.rank <= 3 then
		self.rankIcon:setAltas("loversRecharge_atlas", "ui_qlczb_no" .. data.rank);
	else
		self.rankLab.text = data.rank;
	end

	self.name_left.text = data.left_name;
	self.name_right.text = data.reght_name;

	self.rankLab:setEnable(data.rank > 3);
	self.rankIcon:setEnable(data.rank <= 3);
end