-- 技能数据

Lua_ArmySkillVo = class("Lua_ArmySkillVo")
function Lua_ArmySkillVo:ctor()
    self:superCall("ctor");
end

function Lua_ArmySkillVo:formServer(obj)
	if obj == nil then
		return;
	end

	self.skill_id = obj.skill_id;       -- 魂装id
    self.activate = obj.activate;       -- 激活状态
    self.lvl = obj.skill_level; -- 技能等级
end

function Lua_ArmySkillVo.Get:skillVo() -- vo
    local vo = Lua_SkillVo.new(self.skill_id);
    if vo == nil then
        return nil;
    end
    return vo;
end

function Lua_ArmySkillVo.Get:skill_level()
    if self.activate == 0 then
    	return self.lvl +1;
    else
    	return self.lvl;
    end
end

function Lua_ArmySkillVo.Get:show_lvl()
	return "lv."..self.skill_level
end

function Lua_ArmySkillVo.Get:max_skill_level()
	return #self.skillConfig.activation_cond;
end

function Lua_ArmySkillVo.Get:is_max_lvl()
	if self.skill_level >= self.max_skill_level then
		return true;
	end

	return false;
end

function Lua_ArmySkillVo.Get:activation_lvl() -- 激活等级
    local list = self.skillConfig.activation_cond
    if self.skill_class == 1 then
    	if self.activate == 0 then
    		return LanUtil.formateStr(LanUtil.getValue(140511),tostring(list[self.lvl+1]));
    	else
    		return LanUtil.formateStr(LanUtil.getValue(140550),tostring(list[self.lvl+1]));
    	end
    elseif self.skill_class == 2 then  -- 强化总和
    	return LanUtil.formateStr(LanUtil.getValue(140546),tostring(self.armyInfo.all_intensify_lvl),tostring(list[1]));
    elseif self.skill_class == 3 then  -- 等阶总和
    	if self.activate == 0 then
    		return LanUtil.formateStr(LanUtil.getValue(140547),tostring(list[self.lvl+1]));
    	else
    		return LanUtil.formateStr(LanUtil.getValue(140551),tostring(list[self.lvl+1]));
    	end
    end
end

function Lua_ArmySkillVo.Get:skillConfig() -- 技能
    local config = getConfig({"army_soul_skill", self.skill_id});
    if config == nil then
        return nil;
    end
    return config;
end

function Lua_ArmySkillVo.Get:skill_atlas() -- 图集
	if self.skill_result == 1 then
		return tostring(self.skillConfig.atlas);
	else
		return tostring(self.skillVo.atlas);
	end
end	


function Lua_ArmySkillVo.Get:skill_icon() -- 技能图标
	if self.skill_result == 1 then
		return tostring(self.skillConfig.skill_icon);
	else
		return tostring(self.skillVo.skillIcon);
	end
end

function Lua_ArmySkillVo.Get:skill_name()
	if self.skill_class == 2 then
		return self.skillConfig.remark;
	else
		return self.skillConfig.remark.."lv."..self.skill_level;
	end
end

function Lua_ArmySkillVo.Get:skill_class() -- 1军魂技能 2魂装技能 3套装技能
	return self.skillConfig.skill_class;
end

function Lua_ArmySkillVo.Get:skill_result() -- 1加属性类技能 2效果类技能
	return self.skillConfig.skill_type;
end

function Lua_ArmySkillVo.Get:skill_type() -- 技能类型  1主动 4被动
	return LanUtil.formateStr(LanUtil.getValue(140544),tostring(LanUtil.getValue(110601)));
end

function Lua_ArmySkillVo.Get:skill_cd() -- 技能冷缩
	if self.skill_result == 1 then
		return LanUtil.formateStr(LanUtil.getValue(140545),tostring(self.skillConfig.cool));
	else
		return LanUtil.formateStr(LanUtil.getValue(140545),tostring(self.skillVo.cool));
	end
end

function Lua_ArmySkillVo.Get:des()
	if self.skillConfig.dic == nil then
		return nil;
	end
	return self.skillConfig.dic;
end

function Lua_ArmySkillVo.Get:base_des() -- 军魂技能属性描述
	if self.skill_result == 1 then
		if self.skillConfig.skill_prop ~= nil then
			local str = "";
		    for k,v in ipairs(Lua_ThingDefine.params) do
		        local val = getConfig({"army_soul_prop", self.skillConfig.skill_prop[1], v});
		        if val ~= nil  then
		            if str == "" then
		                str = "";
		            else
		                str = str..",";
		            end
		            local base;
		            if self.skill_class == 2 then
		            	base = val[1];
		            else
		            	base = val[self.skill_level];
		            end
		            if Lua_ThingDefine.isPercentParam(v) then
		                base = base.."%";
		            end
		            local s = Lua_ThingDefine.getParamName(v).."+"..base;
		            str = str..s;
		        end
		    end
		    return LanUtil.formateStr(self.des, tostring(str));
		else
			return LanUtil.formateStr(self.des, tostring(self.skillConfig.extra_value.."%"));
		end
	else
		local detail = self.skillVo:getCurPercent(self.skill_level);
    	local des = LanUtil.formateStr(self.skillVo.des, tostring(math.abs(detail)));

    	return des;
	end
end

function Lua_ArmySkillVo.Get:next_des() -- 军魂技能下级属性描述
	if self.skill_result == 1 then
		local str = "";
		if self.is_max_lvl ~= true then
		    for k,v in ipairs(Lua_ThingDefine.params) do
		        local val = getConfig({"army_soul_prop", self.skillConfig.skill_prop[1], v});
		        if val ~= nil  then
		            if str == "" then
		                str = "";
		            else
		                str = str..",";
		            end
		            local base;
		            if self.skill_class == 2 then
		            	base = val[1];
		            else
		            	base = val[self.skill_level+1];
		            end
		            if Lua_ThingDefine.isPercentParam(v) then
		                base = base.."%";
		            end
		            local s = Lua_ThingDefine.getParamName(v).."+"..base;
		            str = str..s;
		        end
		    end
		    return LanUtil.formateStr(self.des, tostring(str));
		else
			return LanUtil.getValue(140548);
		end
	else
		if self.is_max_lvl ~= true then
			local detail = self.skillVo:getCurPercent(self.skill_level+1);
	    	local des = LanUtil.formateStr(self.skillVo.des, tostring(math.abs(detail)));

	    	return des;
	    else
	    	return LanUtil.getValue(140548);
	    end
	end
end

function Lua_ArmySkillVo.Get:skill_force()
	if self.skill_result == 2 then
		return 0;
	end

	if self.activate == 0 then 
		return 0;
	end

	local list = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"army_soul_prop", self.skillConfig.skill_prop[1], v});
        if val ~= nil  then
            local base;
            if self.skill_class == 2 then
            	base = val[1];
            else
            	base = val[self.skill_level];
            end

            list[v] =  base;
        end
    end
    
	return Lua_FightUtil.caculateConfigForce(list);
end

