-- 军魂数据类
checkRequire("Lua_ArmySoulVo");
Lua_ArmySoulData = class("Lua_ArmySoulData");
function Lua_ArmySoulData:ctor()
	self.armyInfo = {};
	self.selectIndex = 1;
	self.selectEqpIndex = 1;
	self.select_type = 1;
	self.orderPart = nil;
	self.selectId = nil;
	self.selectEqpId = nil;
	self.isSelectPack = true;
end

function Lua_ArmySoulData:dispose()
	self.armyInfo = {};
	self.selectIndex = 1;
	self.selectEqpIndex = 1;
	self.select_type = 1;
	self.orderPart = nil;
	self.selectId = nil;
	self.selectEqpId = nil;
	self.isSelectPack = true;

	self.calss_info = nil;
	if self.armyArr ~= nil then
		self.armyArr:dispose();
		self.armyArr:clear();
		self.armyArr = nil;
	end
end

-- 军魂信息
function Lua_ArmySoulData:fromServer51404020(msg)
	if msg == nil then
		return;
	end

	if self.armyArr == nil then
		self.armyArr = Array();
	else
		self.armyArr:clear();
	end

	local vo;
	local list = msg.army_soul_info;
	for k, v in ipairs(list) do
		vo = Lua_ArmySoulVo.new();
		vo:formServer(v);
		vo.index = k;
		self.armyArr:add(vo);
	end
end

-- 通过军魂id 获取vo
function Lua_ArmySoulData:getArrByArmyInfo(army_id)
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].army_id == army_id then
			return self.armyArr[i];
		end
	end
	return nil;
end

-- 通过军魂id 槽号 获取vo
function Lua_ArmySoulData:getArmyEquipInfo(army_id, part)
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].army_id == army_id then
			for k,v in pairs(self.armyArr[i].armyEquipInfo) do
				if v.part == part then
					return v;
				end
			end
		end
	end
	return nil;
end

-- 通过军魂类型 获取vo
function Lua_ArmySoulData:getArmySoulNmae(_type)
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].soul_type == _type then
			return self.armyArr[i];
		end
	end
	return nil;
end

-- 通过色值 获取 强化石对应值
function Lua_ArmySoulData:getIntensifySoulNum(color)
	local list = {self.army_purple, self.army_orange, self.army_red, self.army_pink};
	return list[color - 1];
end

-- 背包大小
function Lua_ArmySoulData.Get:pack_size()
	return getConfig({"army_soul_base", "pack_size", "value"});
end

-- 分解数据
function Lua_ArmySoulData.Get:resolve_color()
	return getConfig({"army_soul_base", "resolve_color", "value"});
end

-- 分解
function Lua_ArmySoulData:decompose(id)
	local list = getConfig({"cloak_decompose", id, "decompose_item"});
	return list[2];
end

-- 分解获得总额
function Lua_ArmySoulData:cloakResolveNum(arr, id)
	local resolveNum = 0;
	for i = 1, arr:getSize() do
		if arr[i].decomposeId == id then
			resolveNum = resolveNum + arr[i].decompose;
		end
	end
	return resolveNum;
end

-- 背包魂印Tips分解
function Lua_ArmySoulData:onResolveTipsClick(data, bool)
	if self.resolveArr == nil then
		self.resolveArr = Array();
	else
		self.resolveArr:clear();
	end
	self.resolveArr:add({id = data.id, index = data.index});

	if bool == true then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(140549),
			type = 1, subFun = self.onSubCallback});
	else
		Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sResolveArmyEquip(self.resolveArr);
	end
end

function Lua_ArmySoulData:onSubCallback()
	Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sResolveArmyEquip(self.resolveArr);
end

-- 红点处理
-- 主界面 变强 红点 检测
function Lua_ArmySoulData:checkArmyRedDotSate()
	if self.armyArr == nil then
		return;
	end

	self:isShowArmyActIconRed(self:isShowArmyActivatRed()); -- 激活
	self:isShowArmyUpgradIconRed(self:isShowArmyUpgradRed()); -- 提升
	self:isShowArmyResolveIconRed(self:isShowEquipResolveRed()); -- 分解
	self:isShowArmyAdornIconRed(self:isShowEquipAdornRed()); -- 穿戴
	self:isShowArmyReplaceIconRed(self:isShowEquipReplaceRed()); -- 替换
	self:isShowArmyIntensifyIconRed(self:isShowEquipIntensifyRed()); -- 强化
	self:isShowArmyOrderIconRed(self:isShowEquipOrderRed()); -- 升阶
end

-- 打开军装界面按钮 红点显隐
function Lua_ArmySoulData:isShowOpenEquipRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isShowEquipItmeRed == true then
			return true;
		end
	end
	return false;
end

-- 军魂 激活 红点显隐
function Lua_ArmySoulData:isShowArmyActivatRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isShowActivatRed == true then
			return true;
		end
	end
	return false;
end

-- 军魂 提升 红点显隐
function Lua_ArmySoulData:isShowArmyUpgradRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isShowUpgradRed == true then
			return true;
		end
	end
	return false;
end

-- 军装 分解按钮 红点显隐
function Lua_ArmySoulData:isShowEquipResolveRed()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.ARMY_PACK); -- 军魂背包
	local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.ARMY_EQUIP_ITEM});
	for i = 1, arr:getSize() do
		if arr[i].color <= self.resolve_color then
			return true;
		end
	end
	return false;
end

-- 军装穿戴 红点显隐
function Lua_ArmySoulData:isShowEquipAdornRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isEquipAdornRed == true then
			return true;
		end
	end
	return false;
end

-- 军装替换 红点显隐
function Lua_ArmySoulData:isShowEquipReplaceRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isEquipReplaceRed == true then
			return true;
		end
	end
	return false;
end

-- 军装强化 红点显隐
function Lua_ArmySoulData:isShowEquipIntensifyRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isEquipIntensifyRed == true then
			return true;
		end
	end
	return false;
end

-- 军装升阶 红点显隐
function Lua_ArmySoulData:isShowEquipOrderRed()
	for i = 1, self.armyArr:getSize() do
		if self.armyArr[i].isEquipOrderRed ~= nil then
			return true;
		end
	end
	return false;
end

-- 变强处理
-- 激活
function Lua_ArmySoulData:isShowArmyActIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22041, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22041, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 提升
function Lua_ArmySoulData:isShowArmyUpgradIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22042, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22042, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 分解
function Lua_ArmySoulData:isShowArmyResolveIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22043, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22043, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 穿戴
function Lua_ArmySoulData:isShowArmyAdornIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22044, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22044, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 替换
function Lua_ArmySoulData:isShowArmyReplaceIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22045, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22045, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 强化
function Lua_ArmySoulData:isShowArmyIntensifyIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22046, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22046, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 升阶
function Lua_ArmySoulData:isShowArmyOrderIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22047, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22047, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end