checkRequire("Lua_ArmySoulData");
Lua_ArmySoulProxy = class("Lua_ArmySoulProxy");
function Lua_ArmySoulProxy:ctor()
	DataCenter.armySoulData = Lua_ArmySoulData.new();

	LuaUtil.addLuaMsg(51404020, self, self.rOpenArmySoulInfo);  -- 获取军魂界面信息（返回）
	LuaUtil.addLuaMsg(51404022, self, self.sIntensifyArmyState); -- 提升特效
end

-- 获取军魂面板信息（返回）
function Lua_ArmySoulProxy:rOpenArmySoulInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51404020();
		msg:ParseFromString(mp.data);
		DataCenter.armySoulData.army_pink = msg.army_soul_resource_pink;
		DataCenter.armySoulData.army_red = msg.army_soul_resource_red;
		DataCenter.armySoulData.army_orange = msg.army_soul_resource_orange;
		DataCenter.armySoulData.army_purple = msg.army_soul_resource_purple;
		DataCenter.armySoulData:fromServer51404020(msg);
		DataCenter.armySoulData:checkArmyRedDotSate(); -- 更新 军魂红点
		Lua_MsgUtil.callFunc("UPDATE_ARMY_INFO");
	end
end

-- 获取 提升军魂 后是否成功（返回）
function Lua_ArmySoulProxy:sIntensifyArmyState(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51404022();
		msg:ParseFromString(mp.data);
		if msg.ret == 1 then
			Lua_MsgUtil.callFunc("UPDATE_INTENS_ARMY"); -- 是否成功
		end
	end
end





-- 获取军魂界面数据
function Lua_ArmySoulProxy:sOpenArmyPanelInfo()
	sendMsg(11404020);
end

-- 激活军魂
function Lua_ArmySoulProxy:sActivateArmySoul(army_id)
	local cmd = ProtoPublic_pb.Proto11404021();
	cmd.army_id = tonumber(army_id);
	sendMsg(11404021, cmd);
end

-- 提升军魂
function Lua_ArmySoulProxy:sPromoteArmySoul(army_id)
	local cmd = ProtoPublic_pb.Proto11404022();
	cmd.army_id = tonumber(army_id);
	sendMsg(11404022, cmd);
end

-- 强化军魂
function Lua_ArmySoulProxy:sIntensifyArmyEquip(army_id,part)
	local cmd = ProtoPublic_pb.Proto11404024();
	cmd.army_id = tonumber(army_id);
	cmd.part = tonumber(part);
	sendMsg(11404024, cmd);
end

-- 分解军魂
function Lua_ArmySoulProxy:sResolveArmyEquip(list)
	local cmd = ProtoPublic_pb.Proto11404026();
	local item;
	for i = 1, list:getSize() do
		item = ProtoPublic_pb.ProtoDecomposeSoul();
		item.pkg_index = list[i].index;
		item.item_id = list[i].id;
		cmd.item_list:addToList(item);
	end
	sendMsg(11404026, cmd);
end

-- 进阶魂装
function Lua_ArmySoulProxy:sUpgardOrderEquip(army_id, part)
	local cmd = ProtoPublic_pb.Proto11404027();
	cmd.army_id = tonumber(army_id);
	cmd.part = tonumber(part);
	sendMsg(11404027, cmd);
end

-- 佩戴魂装
function Lua_ArmySoulProxy:sSdornArmyEquip(army_id, item_id,pkg_index)
	local cmd = ProtoPublic_pb.Proto11404023();
	cmd.army_id = tonumber(army_id);
	cmd.item_id = tonumber(item_id);
	cmd.pkg_index = tonumber(pkg_index);
	sendMsg(11404023, cmd);
end

-- 魂印替换
function Lua_ArmySoulProxy:sReplaceArmyEquip(army_id, item_id,pkg_index)
	local cmd = ProtoPublic_pb.Proto11404025();
	cmd.army_id = tonumber(army_id);
	cmd.item_id = tonumber(item_id);
	cmd.pkg_index = tonumber(pkg_index);
	sendMsg(11404025, cmd);
end

-- 卸下魂装
function Lua_ArmySoulProxy:sUnloadArmyEquip(army_id, part)
	local cmd = ProtoPublic_pb.Proto11404028();
	cmd.army_id = tonumber(army_id);
	cmd.part = tonumber(part);
	sendMsg(11404028, cmd);
end