Lua_AwakeRecastVo = class("Lua_AwakeRecastVo")
function Lua_AwakeRecastVo:ctor(id, config)
	self.modeleId = id;
	self.config = config ~= nil and config or getConfig({"fantastic", id});

	self.level = 0;
	self.recastMinimumNum = 0;
end

function Lua_AwakeRecastVo.Get:getRecastIragment()
	if self._getRecastIragment == nil then
		self:formServer();
	end
	return self._getRecastIragment;
end

function Lua_AwakeRecastVo:formServer(data)
	local debris_recast;
	local recast_property;
	local is_break;
	local debris_message;
	if data == nil then
		self.level = 0;
		self.model_flag = 0;
		
		self.recastMinimumNum = 0; -- 重铸最小等级
		debris_message = {};
		is_break = {};
		debris_recast = {};
		recast_property = {};
	else
		self.level = data.model_level;
		self.model_flag = data.model_flag;

		self.recastMinimumNum = data.recast_model; -- 重铸最小等级
		debris_recast = data.debris_recast;
		recast_property = data.recast_property;
		is_break = data.is_break;
		debris_message = data.debris_message;
	end

	local vo;
	self._getRecastIragment = Array()
	for i = 1, #self.config.item_id do
		vo = DataCenter.awakeRecastUtil:getAwakeRecastInfo(self.config.item_id[i], debris_recast[i]);
		vo.modeleId = self.modeleId;
		vo.index = i;
		vo.recastMinimumNum = self.recastMinimumNum;
		vo.debris_message = debris_message[i];
		vo.is_break = is_break[i];
		vo.altas = self.config.altas[i];
		vo.recast_level = debris_recast[i] == nil and 0 or debris_recast[i];
		vo.recastPropertyListMsg = recast_property[i];
		self._getRecastIragment:add(vo);
	end	
end

-- 获取模型幻化名字
function Lua_AwakeRecastVo.Get:modelName()
	local color = Lua_ColorDefine.getItemColorStr(self.config.color);
	if self.level == 0 then
		return "[" .. color .. "]" .. self.config.name .. "[-]";
	else
		return "[" .. color .. "]" .. self.config.name.."+"..self.level .. "[-]";
	end
end

function Lua_AwakeRecastVo.Get:skillInfo()
	local isEnable;
	local arr = Array();
	for i = 1, #self.skillInfoDic do
		isEnable = self.skillInfoDic[i][1] > self.recastMinimumNum and false or true;
		arr:add({isEnable = isEnable, recastLv = self.skillInfoDic[i][1], skillId = self.skillInfoDic[i][2]});
	end
	return arr;
end

-- 重铸技能信息
function Lua_AwakeRecastVo.Get:skillInfoDic()
	return self.config.model_skill_recast;
end

-- 幻化头像
function Lua_AwakeRecastVo.Get:model_icon()
	return self.config.model_icon;
end

-- 重铸红点
function Lua_AwakeRecastVo.Get:isRedDot()
	if self.getRecastIragment ~= nil then
		for i = 1, self.getRecastIragment:getSize() do
			if self.getRecastIragment[i].isRecastRedDot then
				return true;
			end
		end
	end
	return false;
end

function Lua_AwakeRecastVo.Get:sort()
	return self.config.sort;
end