Lua_AwakeRecastlevelVo = class("Lua_AwakeRecastlevelVo")
function Lua_AwakeRecastlevelVo:ctor(id)
    self:superCall("ctor");
    self.modeleId = tonumber(id);
    if self.config == nil then
   	 	self.config = getConfig({"recast_debris", self.modeleId})
   	end
	self.unreal_level = 0;   --模型幻化等级
end
function Lua_AwakeRecastlevelVo.Get:levelValue()
	return self.config.arr_value;  
end
function Lua_AwakeRecastlevelVo.Get:name()
	return self.config.name;
end
function Lua_AwakeRecastlevelVo.Get:recastId() --通过等级获取重铸碎片
	if self.level == 0  then
		return self.levelValue[1]; 
	end
	return self.levelValue[self.level]; 
end
function Lua_AwakeRecastlevelVo.Get:isRedDot()
	if self.isMaxLevel == true then
		return false;
	end
	if self.debris_message == 0 then
		return false;
	end
	if self.is_break == 0 then                 
		--  重塑
		if self.recastInfo.getPrimaryCost >= self.recastInfo.needPrimaryCost then
			return true;
		end
	else
		-- 突破 
		if self.recastInfo.getBreakCostCost >= self.recastInfo.needBreakCostCost then
			return true;
		end
	end
	return false;
end
function Lua_AwakeRecastlevelVo.Get:isBreakBtnRedDot()
	if self.is_break == 1 then 
		if self.recastInfo.getBreakCostCost >= self.recastInfo.needBreakCostCost then
			return true;
		end
	end
	return false
end
function Lua_AwakeRecastlevelVo.Get:isTenBtnRedDot()
	if self.is_break == 0 then 
		if self.recastInfo.getPrimaryCost >= self.recastInfo.needPrimaryCost*10 then
			return true;
		end
	end
	return false
end
function Lua_AwakeRecastlevelVo.Get:isOneBtnRedDot()
	if self.is_break == 0 then 
		if self.recastInfo.getPrimaryCost >= self.recastInfo.needPrimaryCost then
			return true;
		end
	end
	return false
end
function Lua_AwakeRecastlevelVo:formServer(data)   --更新服务端下发信息
	if data == nil then
		return;
	end
	self.data = data;
	self.model_level = data.model_level;   --模型幻化等级
	self.level = data.debris_recast;
	self.recastPropertyList = data.recast_property.obj_list;
	self.is_break = data.is_break;
	self.debris_message = data.debris_message;
	self.index = data.index;
end
function Lua_AwakeRecastlevelVo.Get:recastInfo()
	if self._recastInfo == nil then
	 	self._recastInfo = DataCenter.awakeRecastUtil:awakeRecastInfo(self.recastId);
	end
	return self._recastInfo
end
function Lua_AwakeRecastlevelVo.Get:isMaxLevel()-- 是否达到最大等级
	local isObjValueMax = false;
	for i,v in ipairs(self.recastPropertyList) do
		for k,j in pairs(self.recastInfo.property_upper) do
			if v.obj_id >= j[1] then
				if v.obj_value == j[3] then
					isObjValueMax = true;
				end
			end
		end
	end
	if self.level == #self.levelValue and isObjValueMax == true then
		return true;
	end
	return false;
end
function Lua_AwakeRecastlevelVo.Get:force()-- z战力
	local _force = {};
	for i,v in ipairs(self.recastPropertyList) do
		if v.obj_value ~= 0 then
			_force[tonumber(v.obj_id)] = v.obj_value;
		end   
	end
	return Lua_FightUtil.caculateForce(_force);	 
end