-- 幻化信息 vo
Lua_AwakeUnrealVo = class("Lua_AwakeUnrealVo")
function Lua_AwakeUnrealVo:ctor()
end

function Lua_AwakeUnrealVo:formServer(var)
	if var == nil then
		return;
	end
	
	self.model_id = var.model_id; -- 模型ID
	self.model_lvl = var.model_level; -- 模型幻化等级
	self.model_flag = var.model_flag;
	self.debris_message = var.debris_message; -- 碎片信息
end

-- 碎片 信息
function Lua_AwakeUnrealVo.Get:chipVo()
	local tvo;
	local arr = Array();
	local itemId = self.config.item_id;
	for i,v in ipairs(self.debris_message) do
		tvo = Lua_ToolVo.new(itemId[i]);
		tvo.chip_lvl = v;
		tvo.chip_part = i;
		arr:add(tvo);
	end
	return arr;
end

-- 幻化红点
function Lua_AwakeUnrealVo.Get:isShowUnrealRed()
	local bagNum;
	local useNum;
	for i = 1, self.chipVo:getSize() do
		if  self.chipVo[i].chip_lvl < self.getMaxLevel then
			bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.chipVo[i].id);
			useNum = self:getUpdateNum(self.chipVo[i].chip_part,self.chipVo[i].chip_lvl);
			if bagNum >= useNum then
				return true;
			end
		end
	end
	return false;
end





-- 是否达到最大等级
function Lua_AwakeUnrealVo.Get:getMaxLevel()
	return getConfig({"awakeUnrealCommon", "limit_level", "value"});
end

-- 是否达到最大等级
function Lua_AwakeUnrealVo.Get:isMaxLevel()
	if self.model_lvl == self.getMaxLevel then
		return true;
	end
	return false;
end

-- 幻化信息
function Lua_AwakeUnrealVo.Get:config()
	return getConfig({"fantastic", self.model_id});
end

-- 品質
function Lua_AwakeUnrealVo.Get:color()
	return self.config.color;
end

-- 属性名字
function Lua_AwakeUnrealVo.Get:attrNameDic()
	return self.config.item_attribute;
end

-- 幻化头像
function Lua_AwakeUnrealVo.Get:model_icon()
	return self.config.model_icon;
end

function Lua_AwakeUnrealVo.Get:modelpos()
	return self.config.modelpos;
end

function Lua_AwakeUnrealVo.Get:modelros()
	return self.config.modelros;
end

function Lua_AwakeUnrealVo.Get:modelsca()
	return self.config.modelsca;
end

-- 获取模型幻化名字
function Lua_AwakeUnrealVo.Get:model_name()
	local color = Lua_ColorDefine.getItemColorStr(self.color);
	if self.model_lvl == 0 then
		return "[" .. color .. "]" .. self.config.name .. "[-]";
	else
		return "[" .. color .. "]" .. self.config.name.."+"..self.model_lvl .. "[-]";
	end
end

-- 当前幻化属性加成
function Lua_AwakeUnrealVo.Get:getUpUnrealNum()
	local list = getConfig({"awakeUnrealCommon", "attribute_ratio_fantastic", "arr_value"});
	local next_lvl = self.model_lvl % 2;
	if next_lvl == 0 then
		if self.model_lvl == 0 then
			return 0;
		else
			return list[self.model_lvl / 2][2] / 100;
		end
	else
		if self.model_lvl == 1 then
			return 0;
		else
			return list[(self.model_lvl - 1) / 2][2] / 100;
		end
	end
end

-- 下级幻化属性加成
function Lua_AwakeUnrealVo.Get:getNextUnrealProp()
	local list = getConfig({"awakeUnrealCommon", "attribute_ratio_fantastic", "arr_value"});
	if self.isMaxLevel == false then
		local next_lvl = self.model_lvl % 2;
		if next_lvl == 0 then
			if self.model_lvl == 0 then
				return LanUtil.formateStr(LanUtil.getValue(126009), tostring(list[1][1]), tostring(list[1][2]));
			else
				return LanUtil.formateStr(LanUtil.getValue(126009), tostring(list[self.model_lvl / 2 + 1][1]), tostring(list[self.model_lvl / 2 + 1][2]));
			end
		else
			return LanUtil.formateStr(LanUtil.getValue(126009), tostring(list[(self.model_lvl - 1) / 2 + 1][1]), tostring(list[(self.model_lvl - 1) / 2 + 1][2]));
		end
	else
		return LanUtil.formateStr(LanUtil.getValue(126024), tostring(list[self.model_lvl / 2][2]));
	end
end

-- 碎片升级消耗，激活消耗
function Lua_AwakeUnrealVo:getUpdateNum(index, chip_lvl)
	return self.config.upgrade_cost[index][chip_lvl + 1];
end

-- 通过槽号 获取碎片单个战力
function Lua_AwakeUnrealVo:getChipForce(index)
	local _attrName = self.attrNameDic[index];
	return Lua_FightUtil.caculateConfigForce({_attrName = self.config.attr[index][self.model_lvl]});
end

-- 通过槽号 获取下级属性
function Lua_AwakeUnrealVo:genNextAttProp(index)
	local _attrName;
	local _attrInfo;
	local str = "";
	local desStr;
	local _curAttrName = self.attrNameDic[index];
	for i,v in ipairs(self.debris_message) do
		_attrName = self.attrNameDic[i];
		_index = self:getAttrIndex(_attrName);
		_attrInfo = self.config.attr[_index];
		if v == 0 then
			if tostring(_attrName) == _curAttrName then
				desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]0 [00E125]+".._attrInfo[v + 1].."[-]";
			else
				desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]0";
			end
		else
			if tostring(_attrName) == _curAttrName and v < self.getMaxLevel then
				local num1 = _attrInfo[v] + (math.ceil(_attrInfo[v] * self.getUpUnrealNum));
				local num2 = _attrInfo[v + 1] - _attrInfo[v];
				desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]"..num1.." [00E125]+"..num2.."[-]";
			else
				desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]".. (_attrInfo[v] + math.ceil(_attrInfo[v] * self.getUpUnrealNum));
			end
		end

		if str == "" then
			str = "";
		else
			str = str.."\n";
		end
		str = str..desStr;
	end
	return str;
end

-- 属性封装
function Lua_AwakeUnrealVo.Get:getAttProp()
	local _attrName;
	local _index;
	local _attrInfo;
	local desStr;
	local str = "";
	for i,v in ipairs(self.debris_message) do
		_attrName = self.attrNameDic[i];
		_index = self:getAttrIndex(_attrName);
		_attrInfo = self.config.attr[_index];
		if v == 0 then
			desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]0";
		else
			desStr = "[85A8BE]"..Lua_ThingDefine.getParamName(_attrName).."：[-]".. (_attrInfo[v] + math.ceil(_attrInfo[v] * self.getUpUnrealNum));
		end

		if str == "" then
			str = "";
		else
			str = str.."\n";
		end
		str = str..desStr;
	end
	return str;
end

-- 战力
function Lua_AwakeUnrealVo.Get:getForce()
	local _index;
	local _attrInfo;
	local list = {};
	for i,v in ipairs(self.debris_message) do
		if v ~= 0 then
			_index = self:getAttrIndex(self.attrNameDic[i]);
			_attrInfo = self.config.attr[_index];
			list[self.attrNameDic[i]] = _attrInfo[v];
		end
	end
	return Lua_FightUtil.caculateConfigForce(list);
end

function Lua_AwakeUnrealVo:getAttrIndex(attrName)
	for i = 1, #self.attrNameDic do
		if attrName == self.attrNameDic[i] then
			return i;
		end
	end
end

-- 技能
function Lua_AwakeUnrealVo.Get:getUnrealSkill()
	local skillVo;
	local arr = Array();
	local skill = self.config.skill; -- 主动技能
	for _,v in ipairs(skill) do
		skillVo  = Lua_SkillVo.new(v);
		if self.model_lvl > 0 then
			skillVo.isStateDes = true;
		end
		arr:add(skillVo);
	end

	local passsive = self.config.unlock_passsive;
	local passive_skill = self.config.passive_skill; -- 被动技能
	for _,v in ipairs(passive_skill) do
		skillVo  = Lua_SkillVo.new(v);
		if self.model_lvl >= passsive then
			skillVo.isStateDes = true;
		end
		arr:add(skillVo);
	end
	return arr;
end

function Lua_AwakeUnrealVo.Get:sort()
	return self.config.sort;
end