Lua_AwakeUtil = {};
function Lua_AwakeUtil.getConfig()
	return getConfig({"awake", "awake_property"});
end

function Lua_AwakeUtil.cost(index) -- 升阶花费道具
	if index > #Lua_AwakeUtil.getConfig().cost then
		index = #Lua_AwakeUtil.getConfig().cost;
	end
	return Lua_AwakeUtil.getConfig().cost[index].item
end

function Lua_AwakeUtil.costnum(index) -- 升阶花费数量
	local moneynum;
	for k,v in pairs(Lua_AwakeUtil.getConfig().cost[index].money) do
		if v ~= 0 then
			moneynum =  v;
		end
	end
	return moneynum;
end

function Lua_AwakeUtil:lvlConversion(val, bIsStageDic)
	local count = 0;
	local stageDic = {};
	if val < 10 then
		count = Lua_CommonUtil.transChineseNumber(1);
		if bIsStageDic then
			stageDic.stage = 1;
		end
	else
		count = Lua_CommonUtil.transChineseNumber((val / 10) + 1);
		if bIsStageDic then
			stageDic.stage = math.floor((val / 10) + 1);
		end
	end

	if val >= #Lua_AwakeUtil.getConfig().cost then
		if bIsStageDic then
			return {stage = 7, starLvl = 10};
		end
		return LanUtil.formateStr(LanUtil.getValue(120012), tostring(Lua_CommonUtil.transChineseNumber(7)), tostring(Lua_CommonUtil.transChineseNumber(10)));
	end

	if bIsStageDic then
		stageDic.starLvl = math.floor(val % 10);
		return stageDic;
	end
	val = Lua_CommonUtil.transChineseNumber(val % 10);
	return LanUtil.formateStr(LanUtil.getValue(120012), tostring(count), tostring(val));
end

function Lua_AwakeUtil:propertyDefine(total_prop_list)
	local str = "";
	for k,v in ipairs(total_prop_list) do
		str = str.. getConfig({"attr_common", v.attr_id, "common"}) .."："..v.attr_value.."\n";
	end
	return str;
end

function Lua_AwakeUtil:bloodDefine(total_prop_list)
	local str;
	for k,v in ipairs(total_prop_list) do
		if tonumber(v.attr_id) == 2001 then
			str = "[FFFFFF]"..v.attr_value;
		end
	end
	return str;
end

function Lua_AwakeUtil:attackDefine(total_prop_list)
	local str;
	for k,v in ipairs(total_prop_list) do
		if tonumber(v.attr_id) == 2008 then
			str = "[FFFFFF]"..v.attr_value;
		end
	end
	return str;
end

function Lua_AwakeUtil:defenceDefine(total_prop_list)
	local str;
	for k,v in ipairs(total_prop_list) do
		if tonumber(v.attr_id) == 2009 then
			str = "[FFFFFF]"..v.attr_value;
		end
	end
	return str;
end

function Lua_AwakeUtil:addproperty(lvl)
	local str = "";
	local config = getConfig({"awake", "awake_property", "attr"});
	for k,v in pairs(config) do
		if str == "" then
			str = "";
		else
			str = str.."\n";
		end
		str = str..v[lvl];
	end
	return str;
end

function Lua_AwakeUtil:addBloodProperty(lvl)
	lvl = lvl + 1;
	local bloodDic = getConfig({"awake", "awake_property", "attr", "blood"});
	if lvl > #Lua_AwakeUtil.getConfig().cost then
		return 0;
	else
		return bloodDic[lvl + 1] - bloodDic[lvl];
	end
end

function Lua_AwakeUtil:addAttackProperty(lvl)
	lvl = lvl + 1;
	local attackDic = getConfig({"awake", "awake_property", "attr", "attack"});
	if lvl > #Lua_AwakeUtil.getConfig().cost then
		return 0;
	else
		return attackDic[lvl + 1] - attackDic[lvl];
	end
end

function Lua_AwakeUtil:addDefenceProperty(lvl)
	lvl = lvl + 1;
	local defenceDic = getConfig({"awake", "awake_property", "attr", "defence"});
	if lvl > #Lua_AwakeUtil.getConfig().cost then
		return 0;
	else
		return defenceDic[lvl + 1] - defenceDic[lvl];
	end
end

function Lua_AwakeUtil:modelName(lvl)
	local nameDic = getConfig({"awake", "model_name"});
	return nameDic[lvl];
end

function Lua_AwakeUtil:awakeModelId()
	return getConfig({"awake", "model_id"});
end

function Lua_AwakeUtil:clientNameShow(id)
	return getConfig({"awake", "client_Show", id, "name"});
end

function Lua_AwakeUtil:clientSkillhow(id)
	return getConfig({"awake", "client_Show", id});
end

function Lua_AwakeUtil:showrder()
	return getConfig({"awake", "showrder"});
end

function Lua_AwakeUtil:modelpos(id)
	return getConfig({"awake", "client_Show", id, "modelpos"});
end

function Lua_AwakeUtil:modelros(id)
	return getConfig({"awake", "client_Show", id, "modelros"});
end

function Lua_AwakeUtil:modelsca(id)
	return getConfig({"awake", "client_Show", id, "modelsca"});
end

function Lua_AwakeUtil:modelHead()
	return {"guanyu_bianshen", "lvbu_bianshen"};
end

function Lua_AwakeUtil:getmodelpos(id)
	return getConfig({"awake", "client_Show", id, "getmodelpos"});
end

function Lua_AwakeUtil:getmodelros(id)
	return getConfig({"awake", "client_Show", id, "getmodelros"});
end

function Lua_AwakeUtil:getmodelsca(id)
	return getConfig({"awake", "client_Show", id, "getmodelsca"});
end

function Lua_AwakeUtil:gettips(id)
	return getConfig({"awake", "client_Show", id, "gettips"});
end