-- 兽灵技能Vo
Lua_BeastSoulSkillVo = class("Lua_BeastSoulSkillVo");
function Lua_BeastSoulSkillVo:ctor(id, config)
    self.id = id;	
    if config == nil then
    	config = getConfig({ "zodiac_spirit_skill", id });
    end
    self.config = config;
    self:resetServerInfo();
end

function Lua_BeastSoulSkillVo:resetServerInfo()
    self.level = 0;
    self.isActivate = 0; -- 激活状态: 0未激活 1激活
end

function Lua_BeastSoulSkillVo:updateServerInfo(serverInfo)
    if serverInfo == nil or serverInfo.skill_id ~= self.id then
        return;
    end

    self.level = serverInfo.skill_level;
    self.isActivate = serverInfo.activate;
end

function Lua_BeastSoulSkillVo.Get:remark()
    return self.config.remark;
end

-- 技能种类
function Lua_BeastSoulSkillVo.Get:skill_class()
    return self.config.skill_class;
end

-- 技能上限
function Lua_BeastSoulSkillVo.Get:max_level()
    return self.config.max_level;
end

-- 升级条件
function Lua_BeastSoulSkillVo.Get:activation_cond()
    return self.config.activation_cond;
end

-- 技能属性值
function Lua_BeastSoulSkillVo.Get:skill_prop()
    return self.config.skill_prop;
end

-- 技能类型
function Lua_BeastSoulSkillVo.Get:skillType()
    return self.config.skill_types;
end

function Lua_BeastSoulSkillVo.Get:atlasName()
	return self.config.atlasName;
end

function Lua_BeastSoulSkillVo.Get:iconName()
	return self.config.iconName;
end











-- 是否达到最大等级
function Lua_BeastSoulSkillVo.Get:isMaxLevel()
    if self.level >= self.max_level then
        return true;
    end
    return false;
end

-- 升级条件
function Lua_BeastSoulSkillVo.Get:upCondition()
    local lvl = self.level + 1;
    return self.activation_cond[lvl];
end

-- 顶级属性值
function Lua_BeastSoulSkillVo.Get:maxProp()
	local len = #self.skill_prop;
	return (self.skill_prop[len] * 100).."%";
end

-- 当前等级属性值
function Lua_BeastSoulSkillVo.Get:currentProp()
	local lvl = self.level;
	return (self.skill_prop[lvl] * 100).."%";
end

-- 下一等级属性值
function Lua_BeastSoulSkillVo.Get:nextProp()
	local lvl = self.level + 1;
	return "[00E125]"..(self.skill_prop[lvl] * 100).."%[-]";
end