-- 兽灵配置
checkRequire("Lua_BeastSoulVo");
checkRequire("Lua_BeastSoulSkillVo");
checkRequire("Lua_BeastSoulResolveVo");
Lua_BeastSoulUtil = class("Lua_BeastSoulUtil");
function Lua_BeastSoulUtil:ctor()
    self:superCall("ctor");
end

function Lua_BeastSoulUtil:resetBeastSoulInfo()
    if self._beastSoulDic ~= nil then
		for k, v in pairs(self.beastSoulInfoDic) do
	    	v:resetServerInfo();
	    end
	end
end

function Lua_BeastSoulUtil:resetBeastSoulSkill()
	if self.skillDic ~= nil then
		for k, v in pairs(self.skillDic) do
	    	v:resetServerInfo();
	    end
	end
end

function Lua_BeastSoulUtil:updateBeastSoulInfo(serverInfo)
	if serverInfo == nil or serverInfo.id == nil then
		return;
	end

	local vo = self.beastSoulInfoDic[serverInfo.id];
	if vo ~= nil then
		vo:updateServerInfo(serverInfo);
	end
end

function Lua_BeastSoulUtil.Get:beastSoulDic()
	if self._beastSoulDic == nil then
		self._beastSoulDic = {};
		self._beastSoulInfoDic = {};

		local config = getConfig({ "zodiac_spirit_intensify" });
		local vo = nil;
		for k,v in pairs(config) do
			vo = Lua_BeastSoulVo.new(k, v);
			if self._beastSoulDic[vo.mainType] == nil then
				self._beastSoulDic[vo.mainType] = Array();
			end
			self._beastSoulDic[vo.mainType]:add(vo);
			self._beastSoulInfoDic[k] = vo;
		end

		for k,v in pairs(self._beastSoulDic) do
			v:sort("id", false);
		end
	end
	return self._beastSoulDic;
end

function Lua_BeastSoulUtil.Get:beastSoulInfoArr()
	if self._beastSoulInfoArr == nil then
		self._beastSoulInfoArr = Array();
		local len = 0;
		for k, arr in pairs(self.beastSoulDic) do
			len = arr:getSize();
			if len > 0 then
	    		self._beastSoulInfoArr:add({ name = arr[1].mainName, sub = arr });
			end
		end
	end
	return self._beastSoulInfoArr;
end

function Lua_BeastSoulUtil.Get:beastSoulInfoDic()
	return self._beastSoulInfoDic;
end

function Lua_BeastSoulUtil:getBeastSoulVoById(id)
	local dic = self.beastSoulInfoDic;
	if dic ~= nil and dic[id] ~= nil then
		return dic[id];
	end
	return nil;
end

-- 兽灵属性数据
function Lua_BeastSoulUtil:getAttributeCfgById(id)
	if self.attributeCfg == nil then
		self.attributeCfg = {};
	end
	if self.attributeCfg[id] == nil then
		local config = getConfig({ "zodiac_spirit_attr", id });
		if config == nil then
			return nil;
		end
		self.attributeCfg[id] = config;
	end
	return self.attributeCfg[id];
end

-- 兽灵技能数据
function Lua_BeastSoulUtil:getSkillVoById(id)
	if self.skillDic == nil then
		self.skillDic = {};
	end
	if self.skillDic[id] == nil then
		local config = getConfig({ "zodiac_spirit_skill", id });
		if config == nil then
			return nil;
		end
		self.skillDic[id] = Lua_BeastSoulSkillVo.new(id, config);
	end
	return self.skillDic[id];
end

-- 强化消耗道具Vo 显示用
function Lua_BeastSoulUtil:getCostVoById(id)
	if self.costVoDic == nil then
		self.costVoDic = {};
	end
	if self.costVoDic[id] == nil then
		self.costVoDic[id] = Lua_ToolVo.createToolVo(id);
	end
	return self.costVoDic[id];
end

-- 兽灵分解数据
function Lua_BeastSoulUtil:getResolveVoById(id)
	if self.resolveDic == nil then
		self.resolveDic = {};
	end
	if self.resolveDic[id] == nil then
		local config = getConfig({ "zodiac_spirit_decompose", id });
		if config == nil then
			return nil;
		end
		self.resolveDic[id] = Lua_BeastSoulResolveVo.new(id, config);
	end
	return self.resolveDic[id];
end

-- 分解获得道具总数
function Lua_BeastSoulUtil:getResolveTotalNum(arr, id)
    local resolveNum = 0;
    local resolveVo = nil;
    for i = 1, arr:getSize() do
    	resolveVo = self:getResolveVoById(arr[i].id);
    	if resolveVo ~= nil then
	    	if resolveVo.resolveId == id then
		    	resolveNum = resolveNum + (resolveVo.resolveNum * arr[i].count);
		    end
		end
    end
    return resolveNum;
end

function Lua_BeastSoulUtil:getCommonConfig(name, _type)
	if self.commonDic == nil then
		self.commonDic = {};
	end
	if self.commonDic[name] == nil then
		local config = getConfig({"zodiac_spirit_base", name});
		if config == nil then
			return nil;
		end
		self.commonDic[name] = config;
	end

	if _type == 1 then
		return self.commonDic[name].value;
	else
		return self.commonDic[name].arr;
	end
end

-- 分解背包大小
function Lua_BeastSoulUtil.Get:packSize()
    local packSize = self:getCommonConfig("pack_size", 1);
    if packSize ~= nil then
    	return packSize;
    end
    return 0;
end