Lua_BossDetailInfoVo = class("Lua_BossDetailInfoVo")
function Lua_BossDetailInfoVo:ctor(type)
	self.type = type;
	self.totalChall = 0;
	self.leftChall = 0;
	self.costTicket = 0;
	self.leftTicket = 0;
	self.firstPlay = 0;
	self.bossDetailSet = {};
	self.itemRecord = {};
	self.reliveEndTimes = {};
	self.playerMounts = {};
end

function Lua_BossDetailInfoVo:fromServer(msg)
	self.firstPlay = msg.first_play; -- 是否新手指引
	self.totalChall = msg.total_chall; -- 总挑战次数
	self.leftChall = msg.left_chall; -- 剩余挑战次数
	self.leftTicket = msg.left_ticket; -- 剩余挑战券
	if msg.cost_ticket ~= nil then
		self.costTicket = msg.cost_ticket; -- 消耗挑战券
	end

	-- print("Lua_BossDetailInfoVo"..self.type..", left_ticket"..self.leftTicket.." , cost_ticket"..self.costTicket);
	self.bossDetailSet = msg.boss_detail_set;
	self.gather_time_info = msg.gather_time_info;
	self.left_fatigued = msg.left_fatigued;
	self.total_fatigued = msg.total_fatigued;
	self.itemRecord = msg.item_record;
	self.start_time = tonumber(tostring(msg.next_change_trvl_time));
	self.end_time = tonumber(tostring(msg.next_change_trvl_end_time));

	-- boss状态信息
	if self.bossDetailSet ~= nil then
		local monsterInfo;
		for k, v in ipairs(self.bossDetailSet) do
			self.playerMounts[tostring(v.monster_id)] = v.player_amount;

			monsterInfo = getConfig({"monster", v.monster_id});
			if monsterInfo ~= nil then
				if v.is_live == 0 or monsterInfo.monster_type == nil or monsterInfo.monster_type == 0
					or monsterInfo.monster_type >= 1 and monsterInfo.monster_type <= 9 then
					self.reliveEndTimes[tostring(v.monster_id)] = getTime() + v.relive_sec;
				end
			else
				CommonUtil.logError("monster is no monster_id："..v.monster_id);
			end
		end
	end
end	