-- 夺旗大战数据
Lua_CampWarData = class("Lua_CampWarData");
function Lua_CampWarData:ctor()
    self:superCall("ctor");

    self:resetFightInfo();
end

function Lua_CampWarData:dispose()
	self:resetFightInfo();

	if self.sceneTransArr ~= nil then
		self.sceneTransArr:clear();
		self.sceneTransArr = nil;
	end
end

-- 是否在夺旗大战的场景里
function Lua_CampWarData.Get:bInCampWarScene()
	if DataCenter.roleData.sceneId == Lua_CampWarUtil.campWarSceneId
	 or DataCenter.roleData.sceneId ==  Lua_CampWarUtil.kuafu_campWarSceneId then
		return true;
	end
	return false;
end

-- 战斗信息
function Lua_CampWarData:fromServerCampWarFightInfo(msg)
	-- msg.self_score; -- 自己分数
	-- msg.camp_scores; -- 每个阵营分数
	-- msg.self_camp; -- 自己所在阵营，从1开始
	-- msg.zone; -- 赛区
	-- msg.left_time; -- 剩余时间
	-- msg.rank; -- 排名
	-- msg.count_down; -- 倒计时
	self.jifenNum = msg.self_score;
	self.campId = msg.self_camp;
	self.zone = msg.zone;
	self.residueTime = msg.left_time;
	self.rank = msg.rank;
	self.countDown = msg.count_down;
	self.campScoresArr = msg.camp_scores;
	self.fightInfoGetTime = getTime();
end

-- 自己的阵营名字
function Lua_CampWarData.Get:myCampName()
	return DataCenter.campWarUtil:getCampNameById(self.campId);
end

-- 战斗剩余时间
function Lua_CampWarData.Get:fightResidueTime()
	if self.residueTime > 0 then
		return self.residueTime - (getTime() - self.fightInfoGetTime);
	end

	return 0;
end

-- 战斗开始倒计时剩余时间
function Lua_CampWarData.Get:fightCountDown()
	if self.countDown > 0 then
		return self.countDown - (getTime() - self.fightInfoGetTime);
	end

	return 0;
end

-- 阵营1的分数
function Lua_CampWarData.Get:redCampScore()
	if self.campScoresArr ~= nil and #self.campScoresArr > 0 then
		return tonumber(self.campScoresArr[2]);
	end

	return 0;
end

-- 阵营2的分数
function Lua_CampWarData.Get:blueCampScore()
	if self.campScoresArr ~= nil and #self.campScoresArr > 1 then
		return tonumber(self.campScoresArr[1]);
	end

	return 0;
end

function Lua_CampWarData:resetFightInfo()
	self.jifenNum = 0;
	self.campId = 0;
	self.zone = 0;
	self.residueTime = 0;
	self.rank = 0;
	self.countDown = 0;
	self.campScoresArr = nil;
	self.fightInfoGetTime = 0;

	self.transOpenState = 0;
 	self.transOpenReturnState = 0;
end

-- 控制场景传送阵状态
function Lua_CampWarData:updateCampWarSceneTrans(msg)
	-- msg.state; -- 状态，1表示开启，2表示关闭
 	-- msg.open_return; -- 是否开启返回
 	self:clearSceneTrans();
 	self.transOpenState = msg.state;
 	self.transOpenReturnState = msg.open_return;
 	if self.transOpenState == 1 then -- 开启
 		self.sceneTransArr = Array();
 		local arr = DataCenter.campWarUtil.campWarSceneTrans;
 		if arr ~= nil then
 			local len = arr:getSize();
 			for i = 1, len do
 				ThingUtil.instance:addExit(arr[i]);
 				self.sceneTransArr:add(arr[i].roleId);
 			end
 		end

 		if msg.open_return == 1 then -- 开启返回传送阵
 			arr = DataCenter.campWarUtil.campWarSceneTrans_return;
	 		if arr ~= nil then
	 			len = arr:getSize();
	 			for i = 1, len do
	 				ThingUtil.instance:addExit(arr[i]);
	 				self.sceneTransArr:add(arr[i].roleId);
	 			end
	 		end
 		end
 	end
end

function Lua_CampWarData:clearSceneTrans()
	if self.sceneTransArr ~= nil then
		local len = self.sceneTransArr:getSize();
		for i = 1, len do
			ThingUtil.instance:removeThing(self.sceneTransArr[i]);
		end
		self.sceneTransArr:clear();
		self.sceneTransArr = nil;
	end
end