checkRequire("Lua_CampWarData")
checkRequire("Lua_CampWarUtil")
Lua_CampWarProxy = class("Lua_CampWarProxy");
function Lua_CampWarProxy:ctor()
    DataCenter.campWarData = Lua_CampWarData.new();
    DataCenter.campWarUtil = Lua_CampWarUtil.new();

    LuaUtil.addLuaMsg(50400801, self, self.rEnterCampWarScene);	    -- 进入活动(返回)
    LuaUtil.addLuaMsg(50400803, self, self.rCampWarRankInfo);	    -- 请求战场排行榜(返回)

    LuaUtil.addLuaMsg(80100501, self, self.rCampWarFightInfo);	    -- 战场信息(主动)
    LuaUtil.addLuaMsg(80100502, self, self.rCampWarFightResult);	    -- 战场结算(主动)
    LuaUtil.addLuaMsg(80100510, self, self.rCampWarTransferState);	    -- 传送阵状态(主动)
end

-----------------------------------------------------
-- 上行协议

-- 进入活动
function Lua_CampWarProxy:sEnterCampWarScene()
	sendMsg(10400801);
end

-- 个人信息
function Lua_CampWarProxy:sOwnerCampWarInfo()
	sendMsg(10400805);
end

-- 排行榜
function Lua_CampWarProxy:sCampWarRankInfo()
	local cmd = ProtoPublic_pb.Proto10400803();
    cmd.page = 1;   -- 请求的页数
    sendMsg(10400803, cmd);
end

-- 退出场景
function Lua_CampWarProxy:sExitScene()
	sendMsg(10400902);
end



-----------------------------------------------------
-- 下行协议

-- 请求进入夺旗大战活动（返回）
function Lua_CampWarProxy:rEnterCampWarScene(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_CampWarWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
		-- OperateAlert.show(LanUtil.getValue(122716));
	end
end

-- 请求战场排行榜(返回)
function Lua_CampWarProxy:rCampWarRankInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50400803();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("rCampWarRankInfo", msg);
    end
end

-- 战场信息(主动)
function Lua_CampWarProxy:rCampWarFightInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80100501();
        msg:ParseFromString(mp.data);
        DataCenter.campWarData:fromServerCampWarFightInfo(msg);
        Lua_MsgUtil.callFunc("rCampWarFightInfo");
    end
end

-- 战场结算(主动)
function Lua_CampWarProxy:rCampWarFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80100502();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_CampWarResultWindow", WinParam.ACTION_OPEN, msg);
    end
end

-- 传送阵状态(主动)
function Lua_CampWarProxy:rCampWarTransferState(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80100510();
        msg:ParseFromString(mp.data);
        -- msg.state; -- 状态，1表示开启，2表示关闭
        -- msg.open_return; -- 是否开启返回
        DataCenter.campWarData:updateCampWarSceneTrans(msg);
        Lua_MsgUtil.callFunc("CAMPWAR_TRANSFER_UPDATE", msg);
    end
end