-- 夺旗大战配置
Lua_CampWarUtil = class("Lua_CampWarUtil");
Lua_CampWarUtil.campWarSceneId = 40401;
Lua_CampWarUtil.kuafu_campWarSceneId = 70401;
Lua_CampWarUtil.CAMPWARID_RED = 2; -- 阵营2
Lua_CampWarUtil.CAMPWARID_BLUE = 1;	-- 阵营1
function Lua_CampWarUtil:ctor()
    self:superCall("ctor");
    self.exitIdx = 1;
end

function Lua_CampWarUtil.Get:campWarStartTime()
	if self._campWarStartTime == nil then
		self._campWarStartTime = "";
		self._campWarEndTime = "";
		local activityId = getConfig({"camp_const", "activity_id", "value"});
		if activityId ~= nil then
			self._campWarStartTime = DataCenter.xianshiData:getDataById(activityId).startDayTime;
			self._campWarEndTime = DataCenter.xianshiData:getDataById(activityId).endDayTime;
		end
	end

	return self._campWarStartTime;
end

function Lua_CampWarUtil.Get:campWarEndTime()
	if self._campWarEndTime == nil then
		self._campWarStartTime = "";
		self._campWarEndTime = "";
		local activityId = getConfig({"camp_const", "activity_id", "value"})
		if activityId ~= nil then
			self._campWarStartTime = DataCenter.xianshiData:getDataById(activityId).startDayTime;
			self._campWarEndTime = DataCenter.xianshiData:getDataById(activityId).endDayTime;
		end
	end

	return self._campWarEndTime;
end

-- 阵营
function Lua_CampWarUtil:getCampNameById(campId)
	local result = "";
	if campId ~= nil then
		campId = tonumber(campId);
		if campId == Lua_CampWarUtil.CAMPWARID_RED then
			result = LanUtil.getValue(122710);
		elseif campId == Lua_CampWarUtil.CAMPWARID_BLUE then
			result = LanUtil.getValue(122709);
		end
	end

	return result;
end

function Lua_CampWarUtil.Get:campWarWinNeedScore()
	return getConfig({"camp_const", "win_score", "value"});
end

function Lua_CampWarUtil.Get:campWarResultCloseTime()
	return getConfig({"camp_const", "close_time", "value"});
end

-- 传送阵
function Lua_CampWarUtil.Get:campWarSceneTrans()
	if self._sceneTransArr == nil then
		self._sceneTransArr = Array();
		local exitData = self:createExit("transfer_point_a");
		if exitData ~= nil then
			self._sceneTransArr:add(exitData);
		end
		
		exitData = self:createExit("transfer_point_b");
		if exitData ~= nil then
			self._sceneTransArr:add(exitData);
		end	
	end

	return self._sceneTransArr;
end

-- 传送阵（返回）
function Lua_CampWarUtil.Get:campWarSceneTrans_return()
	if self._sceneReturnTransArr == nil then
		self._sceneReturnTransArr = Array();
		local exitData = self:createExit("transfer_return_a");
		if exitData ~= nil then
			self._sceneReturnTransArr:add(exitData);
		end
		
		exitData = self:createExit("transfer_return_b");
		if exitData ~= nil then
			self._sceneReturnTransArr:add(exitData);
		end	
	end

	return self._sceneReturnTransArr;
end

function Lua_CampWarUtil:createExit(transId)
	local obj = getConfig({"camp_const", transId, "arr"})
	if obj ~= nil then
		local exitData = ThingUtil.instance:createExitData(self.exitIdx, DataCenter.roleData.sceneId, obj[1][1], obj[1][2], obj[1][3], obj[2][1], obj[2][2], obj[2][3]);
		self.exitIdx = self.exitIdx + 1;
		return exitData;
	end

	return nil;
end