-- 武库数据类
checkRequire("Lua_CardHoleVo")
checkRequire("Lua_cardGroupVo")
Lua_CardData = class("Lua_CardData");
function Lua_CardData:ctor()
	self.cardHolesInfo = {};
	self.openGrooveId = 0; -- 解锁号
	self.fragment = 0; -- 器源碎片
	self.select_card = 2;
	self.isAutoCardResolve = 0;
end

function Lua_CardData:dispose()
	self.cardHolesInfo = {};
	self.isAutoCardResolve = 0;
	self.fragment = 0; -- 器源碎片
	self.openGrooveId = 0;
	self.select_card = 2;
	if self.cardSkillInfo ~= nil then
		self.cardSkillInfo:dispose();
		self.cardSkillInfo:clear();
		self.cardSkillInfo = nil;
	end
end

-- 孔位信息
function Lua_CardData:fromServerHoldsInfo(msg)
	if msg == nil then
		return;
	end
	self.msg = msg;

	self.cardSkillInfo = Array();
	local group_list = msg.group_list;
	for i,v in ipairs(group_list) do
		local vo = Lua_cardGroupVo.new(v.obj_id)
		vo.color = v.obj_value;
		if vo.skill_min_color <= v.obj_value and vo.attr_min_color <= v.obj_value then
			self.cardSkillInfo:add(vo);
		end
	end

	local list = msg.armory_list;
	for k, v in ipairs(list) do
		local vo = Lua_CardHoleVo.new();
		vo:formServer(v);
		self.cardHolesInfo[tonumber(vo.cardPart)] = vo;
	end
end

-- 通过槽号 获取卡牌vo
function Lua_CardData:getArrByCardInfo(groove_id)
	if self.cardHolesInfo[groove_id] == nil then
		return nil;
	end
	return self.cardHolesInfo[groove_id];
end

-- 获得卡牌战力
function Lua_CardData.Get:getCardForce()
	if self.msg == nil then
		return 0;
	end

	local list = self.msg.prop_list;
	local force = {};
	for i,v in ipairs(list) do
		if v.obj_value ~= 0 then
			force[tonumber(v.obj_id)] = v.obj_value;
		end
	end
	return Lua_FightUtil.caculateForce(force);
end

-- 卡牌属性
function Lua_CardData.Get:genAttProp()
	local arr = Array();
	if self.msg == nil then
		return arr;
	end

	local attr = self.msg.prop_list;
	for i,v in ipairs(attr) do
		if v.obj_value ~= 0 then
			local s = getConfig( { "attr_name2", v.obj_id});
			local _s = LanUtil.formateStr(s, tostring("[FFFFFF]"..v.obj_value.."[-]"));
			str = "[85A8BE]".._s.."[-]";
			arr:add(str);
		end
	end
	return arr;
end

-- -- 标记同类型最高战力ID
-- function Lua_CardData:getCardHighForceId(_type) 
-- 	local _arr = Array();
-- 	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
-- 	local arr = bagData:getBagAllData();
-- 	for i = 1, arr:getSize() do
-- 		if arr[i].card_type ~= 0 then
-- 			if arr[i].card_number == _type then 
-- 				_arr:add(arr[i]);
-- 			end
-- 		end
-- 	end
	
-- 	local list = {};
-- 	_arr:sort("force", true);
-- 	local force = _arr[1].force;
-- 	for i = 1, _arr:getSize() do
-- 		if _arr[i].force == force then
-- 			list[_arr[i].index] = 1;
-- 		end
-- 	end
-- 	return list;
-- end

-- -- 背包满自动分解卡牌数据
-- function Lua_CardData.Get:getAutoResolveCardList()
-- 	local _arr = Array();
-- 	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
-- 	local arr = bagData:getBagAllData();
-- 	for i = 1, arr:getSize() do
-- 		if arr[i].color < 5 or arr[i].card_type == 0 then
-- 			if arr[i].card_type == 0 then
-- 				_arr:add(arr[i]);
-- 			else
-- 				if self:getCardHighForceId(arr[i].card_number)[arr[i].index] ~= 1 then
-- 					_arr:add(arr[i]);
-- 				end
-- 			end
-- 		end
-- 	end
-- 	return _arr;
-- end





-- 红点处理
-- 背包是否拥有核心卡牌
function Lua_CardData.Get:isHaveKernelCard()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();
	for i = 1, arr:getSize() do
		if arr[i].card_type == 2 then
			return true;
		end
	end
	return false;
end

-- 背包是否拥有普通卡牌卡牌
function Lua_CardData.Get:isHaveCommonCard()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();
	for i = 1, arr:getSize() do
		if arr[i].card_type == 1 then
			return true;
		end
	end
	return false;
end

-- 判断背包是否有不同类型的 普通卡片
function Lua_CardData.Get:isHaveTypeOneCard()
	local list = self.cardHolesInfo;
	local _list = {}
	for i,v in ipairs(list) do
		if v.card_id ~= 0 then
			_list[v.cardVo.card_number] = 1;
		end
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();
	for i = 1, arr:getSize() do
		if arr[i].card_type == 1 and _list[arr[i].card_number] ~= 1 then
			return true;
		end
	end
	return false;
end

-- 主界面 卡牌变强 红点 检测
function Lua_CardData:checkCardRedDotSate()
	-- 穿戴
	self:isShowDressIconRed(self:isShowCardDressRed());

	-- 分解
	self:isShowResolveIconRed(self:isShowCardResolveRed());
end

--主界面 卡牌穿戴 红点处理
function Lua_CardData:isShowCardDressRed()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();
	local cardList = self.cardHolesInfo;
	for i,v in ipairs(cardList) do
		if v.open_status == 1 then -- 开启状态
			if v.card_id == 0 then -- 没穿戴
				if v.armory_type == 1 and self.isHaveCommonCard and self.isHaveTypeOneCard then -- 普通卡牌
					return true;
				elseif v.armory_type == 2 and self.isHaveKernelCard then -- 核心卡牌
					return true;
				end
			end
		end
	end
	return false;
end

-- 主界面 卡牌分解 红点处理
function Lua_CardData:isShowCardResolveRed()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.CARD_PACK);
	local arr = bagData:getBagAllData();
	for i = 1, arr:getSize() do
		if arr[i].color <= 2 or arr[i].card_type == 0 then
			return  true;
		end
	end
	return false;
end

-- 主界面红点 可穿戴 变强事件
function Lua_CardData:isShowDressIconRed(bool)
	if bool == true then
		DataCenter.redDotData:updateRedDotVoState(22023, true); -- 客户端主动添加红点事件
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22023, val = 1, bShow = true});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true); -- 变强事件
	else
		DataCenter.redDotData:updateRedDotVoState(22023, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22023, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end
end

-- 主界面红点 可分解 变强事件
function Lua_CardData:isShowResolveIconRed(bool)
	if bool == true then
		DataCenter.redDotData:updateRedDotVoState(22022, true); -- 客户端主动添加红点事件
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22022, val = 1, bShow = true});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true); -- 变强事件
	else
		DataCenter.redDotData:updateRedDotVoState(22022, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22022, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end
end