-- 卡牌位置信息
Lua_CardHoleVo = class("Lua_CardHoleVo")
function Lua_CardHoleVo:ctor()
end

function Lua_CardHoleVo:formServer(obj)
	if obj == nil then
		return;
	end

	self.cardPart = obj.index; -- 位置索引 从1开始
	self.open_status = obj.open_status; -- 开启状态 1开启 0未开启
	self.armory_type = obj.armory_type; -- 位置类型 1普通 2核心

	self.card_info = obj.crad;
	self.card_id = obj.crad.id;
	self.card_bind = obj.crad.bind;

	self.card_level = obj.crad.equipment.card_level;
end

function Lua_CardHoleVo.Get:cardVo()
	if self.card_id ~= nil and self.card_id ~= 0 then
		local vo = Lua_ToolVo.createToolVo(self.card_info.id,self.card_info.amount,self.card_info.bind);
		vo:fromServer(self.card_info);
		vo.cardPart = self.cardPart;
		vo.armory_type = self.armory_type;
		vo.card_level = self.card_level;
		return vo;
	end
	return nil;
end

-- 是否达到最大等级
function Lua_CardHoleVo.Get:isMaxLevel()
	local max_level = getConfig({"card_armory", self.card_id, "max_level"}); -- 强化最高等级
	if self.card_level == max_level then
		return true;
	end
	return false;
end

-- 升级属性
function Lua_CardHoleVo.Get:updateProp()
	local arr = Array();
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"card_armory", self.card_id, v});
		if val ~= nil then
			local s = "[85A8BE]"..Lua_ThingDefine.getParamName(v).."+ ".."[-]"..val[self.card_level+1];
			arr:add(s);
		end
	end
	return arr;
end

-- 下级升级属性
function Lua_CardHoleVo.Get:updateAddProp()
	local arr = Array();
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"card_armory", self.card_id, v});
		if val ~= nil then
			local s;
			if self.isMaxLevel == false then
				s = "+"..val[self.card_level + 2];
				arr:add(s);
			end
		end
	end
	return arr;
end





-- Item 卡牌 红点
-- 检测item 红点
function Lua_CardHoleVo.Get:checkCardIconRed()
	if self:isShowCardUpgradeRed() or self:isShowCardDressRed() then
		return true;
	end
	return false
end

-- 升级 红点处理 
function Lua_CardHoleVo:isShowCardUpgradeRed()
	if self.isMaxLevel == false and self.card_id ~= 0 then
		local fragment = DataCenter.cardData.fragment;
		local need_fragment = self.cardVo.cost_item_num;
		if tonumber(fragment) >= tonumber(need_fragment) then
			return true
		end
	end
	return false;
end

--卡牌界面 穿戴 红点处理
function Lua_CardHoleVo:isShowCardDressRed()
	local isHaveCommonCard = DataCenter.cardData.isHaveCommonCard;
	local isHaveKernelCard = DataCenter.cardData.isHaveKernelCard;
	local isHaveTypeOneCard = DataCenter.cardData.isHaveTypeOneCard;
	if self.open_status == 1 then -- 开启状态
		if self.card_id == 0 then -- 没穿戴
			if self.armory_type == 1 and isHaveCommonCard and isHaveTypeOneCard then -- 普通卡牌
				return true;
			elseif self.armory_type == 2 and isHaveKernelCard then -- 核心卡牌
				return true;
			end
		end
	end
	return false;
end