--武库
checkRequire("Lua_CardData");
checkRequire("Lua_CardUtil");
Lua_CardProxy = class("Lua_CardProxy");
function Lua_CardProxy:ctor()
	DataCenter.cardData = Lua_CardData.new();
	DataCenter.cardUtil = Lua_CardUtil.new();

	LuaUtil.addLuaMsg(51407101, self, self.rOpenCardPanelInfo);
	LuaUtil.addLuaMsg(51407102, self, self.rApparelCard);
	LuaUtil.addLuaMsg(51407105, self, self.rResolveCard);
end

-- 获取武库面板信息（返回）
function Lua_CardProxy:rOpenCardPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51407101();
		msg:ParseFromString(mp.data);
		DataCenter.cardData.fragment = msg.fragment;--器源碎片
		DataCenter.cardData.isAutoCardResolve = msg.auto_decom_status;--自动分解状态 0关 1开
		DataCenter.cardData:fromServerHoldsInfo(msg);

		-- 更新卡牌主界面红点
		DataCenter.cardData:checkCardRedDotSate();
		Lua_MsgUtil.callFunc("UPDATE_CARD_INFO");
	end
end

-- 穿戴卡牌（返回）
function Lua_CardProxy:rApparelCard(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_CardPackWindow");
	end
end

-- 分解卡牌（返回）
function Lua_CardProxy:rResolveCard(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51407105();
		msg:ParseFromString(mp.data);
		DataCenter.cardData.fragment = msg.fragment; -- 器源碎片
		Lua_MsgUtil.callFunc("RESOLVE_CARD_INFO");
	end
end





-- 获取武库面板信息
function Lua_CardProxy:sOpenCardPanelInfo()
	sendMsg(11407101);
end

-- 佩戴卡牌
function Lua_CardProxy:sInlaySoul(groove_id, pack_index)
	local cmd = ProtoPublic_pb.Proto11407102();
	cmd.armory_index = tonumber(groove_id); -- 槽号
	cmd.pack_index =tonumber(pack_index); -- 背包索引
	sendMsg(11407102, cmd);
end

-- 卸下灵魂
function Lua_CardProxy:sDischargeSoul(groove_id)
	local cmd = ProtoPublic_pb.Proto11407103();
	cmd.index = tonumber(groove_id); -- 槽号
	sendMsg(11407103, cmd);
end

-- 升级卡牌
function Lua_CardProxy:sUpgradeCard(groove_id)
	local cmd = ProtoPublic_pb.Proto11407104();
	cmd.index = tonumber(groove_id);
	sendMsg(11407104, cmd);
end

-- 分解卡牌
function Lua_CardProxy:sResolveCard(list)
	local cmd = ProtoPublic_pb.Proto11407105();
	for i = 1, list:getSize() do
		cmd.index_list:append(list[i].index);
	end
	sendMsg(11407105, cmd);
end

-- 武库背包自动分解
function Lua_CardProxy:sAutoResolveCard(status)
	local cmd = ProtoPublic_pb.Proto11407106();
	cmd.auto_decom_status = status;--0关，1开
	sendMsg(11407106, cmd);
end