-- 武库配置数据
checkRequire("Lua_cardGroupVo");
Lua_CardUtil = class("Lua_CardUtil");
function Lua_CardUtil:ctor()
end

function Lua_CardUtil:getOpenCardLvl(part)
	local arr = getConfig({"card_const", "armory_pos", "arr_value"});
	for i = 1, #arr do
		if i == part then
			return arr[i][2];
		end
	end
	return nil;
end

-- 分解获得总额
function Lua_CardUtil:cardResolveNum(arr)
	local resolveNum = 0;
	for i=1,arr:getSize() do
		resolveNum = resolveNum + arr[i].decompose;
	end
	return resolveNum;
end





-- 卡牌技能封装
function Lua_CardUtil.Get:getArrByCardGroupInfo()
	if self.cardGroup == nil then
		self.cardGroup = {};
		local config = getConfig({"card_group"});
		if config ~= nil then
			for k, v in pairs(config) do
				local vo = Lua_cardGroupVo.new(k, v);
				if self.cardGroup[k] == nil then
					self.cardGroup[k] = Array();
				end
				self.cardGroup[k]:add(vo);
			end
		end
	end
	return self.cardGroup;
end

-- 通过id获取 vo
function Lua_CardUtil:getCardGroupInfo(id)
	if self.getArrByCardGroupInfo[id] == nil then
		return nil;
	end

	local arr = self.getArrByCardGroupInfo[id];
	for i=1, arr:getSize() do
		return arr[i];
	end
	return nil;
end

-- 通过id数组获取 vo集合数据
function Lua_CardUtil:getArrCardGroupInfo(list)
	local arr = Array();
	for i,v in ipairs(list) do
		local _arr = self.getArrByCardGroupInfo[v];
		if _arr ~= nil then
			arr:add(_arr[1]);
		end
	end
	return arr;
end





-- 卡牌组合界面数据
-- 获取卡牌组合
function Lua_CardUtil:getArrByAllCardGroupInfo(data, color)
	local arr = Array();
	local _arr = self.cardConfigInfo;
	local card_group = data.card_group;
	for i=1,_arr:getSize() do
		for k,v in ipairs(card_group) do
			if _arr[i].data.card_number == v and _arr[i].data.color == color then
				local vo = Lua_CardVo.new(_arr[i].id)
				vo.card_level = 0;
				arr:add(vo);
			end
		end
	end
	return arr;
end

-- 获取卡牌组合技能
function Lua_CardUtil:getArrByAllCardGroupSkill(data, color)
	local str = "";
	local skill = data.skill;
	for i,v in ipairs(skill) do
		local skillVO  = Lua_SkillVo.new(v)
		local detail = skillVO:getCurPercent(color);
		local des = LanUtil.formateStr(skillVO.des, tostring(math.abs(detail)));
		local _s = skillVO.name.."："..des;

		if str == "" then
			str = "";
		else
			str = str.."\n";
		end
		str = str.."[85A8BE]".._s.."[-]";
	end
	return str;
end

-- 获取卡牌属性
function Lua_CardUtil:getCardGroupSkillProp(data, color)
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.percentage_params) do
		local val = getConfig({"card_group", data.id, v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."  ";
			end
			local s = "[85A8BE]"..Lua_ThingDefine.getParamName(v) .."：".."[00E125]"..val[color].."%".."[-]";
			str = str..s;
		end
	end
	return str;
end

-- 器谱/强化数据
function Lua_CardUtil.Get:cardConfigInfo()
	if self.dic == nil then
		self.dic = Array();

		local config = getConfig({"card_armory"});
		if config ~= nil then
			for k, v in pairs(config) do
				self.dic:add({id = k, data = v, itemVo = Lua_ToolVo.createToolVo(k), weight = v.card_number * 10 + v.color});
			end
		end
		self.dic:sort("weight",false);
	end
	return self.dic;
end

-- 用于卡牌组合界面页签显示
function Lua_CardUtil.Get:getCardCalssList()
	if self.arrList == nil then
		self.arrList = Array();

		local arr;
		local config = getConfig({"cardClass"});
		for k,v in ipairs(config) do
			arr = Array();
			for i, j in ipairs(v.class_group) do
				arr:add({name = self:getCardGroupInfo(j).groupName, data = self:getCardGroupInfo(j),
					class_id = k, class_color = v.class_color}); 
			end
			self.arrList:add({name = v.class_name, sub = arr});
		end
	end
	return self.arrList;
end