Lua_TodayChargeData = class("Lua_TodayChargeData")
function Lua_TodayChargeData:ctor()
	self.leichongList = Array();
	self.todayLeichongRewardList = Array();
end

function Lua_TodayChargeData:fromServer81401803(msg)
	if msg == nil then
		return;
	end
	self.leichongList:clear();
	self.todayLeichongRewardList:clear();

	for i = 1, #msg.total_rewards_list do
		self.leichongList:add({
			id = i - 1,
			sum = msg.sum, -- 累积次数所要充值的金额
			days = msg.total_charge_count, -- 累计充值天数
			effectId = msg.total_effect_item_list[i], -- 各累充奖励中带特效的道具id集合
			state = msg.total_rewards_state[i], -- 各阶段累充奖励领取状态
			count = msg.total_rewards_count[i], -- 各阶段获取累充奖励的所需天数
			rewards = msg.total_rewards_list[i] -- 累充各阶段奖励ID
		});
	end

	for i = 1, #msg.reward_list do
		self.todayLeichongRewardList:add({
			id = i,
			state = msg.rewards_state[i], -- 各阶段的奖励状态
			rewardsId = msg.reward_list[i],  -- 各阶段奖励ID
			need_gold = msg.need_gold_list[i] -- 每日累充金额集合
		});
	end
end

-- 请求获取每日充值的奖励信息
function Lua_TodayChargeData:sGetRewardItemInfomation()
	sendMsg(11401803)
end

-- 请求领取每日充值奖励
function Lua_TodayChargeData:sGetTodayReward(reward_index)
	local cmd = ProtoPublic_pb.Proto11401804();
	cmd.reward_index = reward_index;
	sendMsg(11401804, cmd);
end

-- 请求领取每日充值累计天数奖励
function Lua_TodayChargeData:sGetSeveralDaysReward(reward_index)
	local cmd = ProtoPublic_pb.Proto11401814();
	cmd.reward_index = reward_index;
	sendMsg(11401814, cmd);
end