checkRequire("Lua_TodayChargeData");
Lua_TodayChargeProxy = class("Lua_TodayChargeProxy");
function Lua_TodayChargeProxy:ctor()
	DataCenter.todayChargeData = Lua_TodayChargeData.new();

	LuaUtil.addLuaMsg(81401803, self, self.rGetRewardItemInfomation);
	LuaUtil.addLuaMsg(51401804, self, self.rGetTodayReward);
	LuaUtil.addLuaMsg(51401814, self, self.rGetSeveralDaysReward);
	LuaUtil.addLuaMsg(81401809, self, self.onTodayIconState);
end

-- 每日充值奖励信息（通知）
function Lua_TodayChargeProxy:rGetRewardItemInfomation(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401803();
		msg:ParseFromString(mp.data);
		DataCenter.todayChargeData:fromServer81401803(msg)
		Lua_MsgUtil.callFunc("GET_REWARD_ITEM_INFORMATION", msg)
	end
end

-- 请求领取每日充值奖励
function Lua_TodayChargeProxy:rGetTodayReward(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121422));
	end
end

-- 请求领取每日充值累计天数奖励
function Lua_TodayChargeProxy:rGetSeveralDaysReward(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121422));
	end
end

function Lua_TodayChargeProxy:onTodayIconState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401809();
		msg:ParseFromString(mp.data);
		if msg.dr_open == true then
			Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10011);
		else
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10011);
		end
	end
end