Lua_CharmKingData = class("Lua_CharmKingData");
Lua_CharmKingData.ACT_CHARM = 1054;
function Lua_CharmKingData:ctor()
end

function Lua_CharmKingData:sCharmKingInfo()
	local cmd = ProtoPublic_pb.Proto10105601();
	cmd.first_type = Lua_CharmKingData.ACT_CHARM;
	sendMsg(10105601, cmd);
end

function Lua_CharmKingData:fromServer50105630(msg)
	if msg == nil then
		return;
	end

	self.man_rankers = msg.man_rankers;
	self.woman_rankers = msg.woman_rankers;
	self.act_info = msg.act_info;
	self.end_tick = tonumber(tostring(self.act_info.end_tick));
	self.aggregate_value = msg.aggregate_value;
	self.role_id = msg.role_id;
	self.man_rank_reward = msg.man_rank_reward;
	self.woman_rank_reward = msg.woman_rank_reward;
	self.aggregate_reward = msg.aggregate_reward;
	self.first_type = msg.first_type;
	self.rank = msg.rank;
	self.server_flag = msg.server_flag;
	self.sex = msg.sex; -- 玩家性别
	self.rank_condition = msg.rank_condition;
	self.today_value = msg.today_value;
	self.discount_item_id = msg.discount_item_id;
	self.discount = tonumber(msg.discount);
	self.charm_total = msg.charm_total;
	self.flag = msg.flag;-- 1 魅力，2 为盈香
	self.isShowGift = (msg.server_reward_flag == 1);
	self.grid_amount = msg.grid_amount;
	self.settl_start_time = msg.settlement_time.obj_id;
	self.settl_end_time = msg.settlement_time.obj_value;
	self.settl_switch = msg.settlement_flag; -- 积分榜结算flag
end

function Lua_CharmKingData.Get:man_rankersArr()
	local maleRankArr = Array();
	for k, v in ipairs(self.man_rankers) do
		maleRankArr:add({name = v.name, career = v.career, profession = v.profession, server_name = v.server_name,
			rank = v.rank, frameId = v.head_frame_id, role_head = v.role_head_name, receive_value = v.charm_value});
	end

	maleRankArr:sort("rank", false);
	return maleRankArr;
end

function Lua_CharmKingData.Get:woman_rankersArr()
	local femaleRankArr = Array();
	for k, v in ipairs(self.woman_rankers) do
		femaleRankArr:add({name = v.name, career = v.career, profession = v.profession, server_name = v.server_name,
			rank = v.rank, frameId = v.head_frame_id, role_head = v.role_head_name, receive_value = v.charm_value});
	end

	femaleRankArr:sort("rank", false);
	return femaleRankArr;
end

function Lua_CharmKingData.Get:manChampionList()
	return self.man_rankersArr[1];
end

function Lua_CharmKingData.Get:womanChampionList()
    return self.woman_rankersArr[1];
end

function Lua_CharmKingData.Get:man_rankersList()
	local manArr = Array();
	local list = Array();
	local len = self.man_rankersArr:getSize();
	if len >= 2 then
		for i = 2, len do
			manArr:add(self.man_rankersArr[i])
		end
	end

	local rank_val = 2;
	for i = 1, self.grid_amount - 1 do
		if manArr[i] ~= nil then
			list:add({rankList = manArr[i], isEmpty = false, rank = rank_val});
		else
			list:add({isEmpty = true, rank = rank_val});
		end
		rank_val = rank_val + 1;
	end
	return list;
end

function Lua_CharmKingData.Get:woman_rankersList()
	local womanArr = Array();
	local list = Array();
	local len = self.woman_rankersArr:getSize();
	if len >= 2 then
		for i = 2, len do
			womanArr:add(self.woman_rankersArr[i])
		end
	end

	local rank_val = 2;
	for i = 1, self.grid_amount - 1 do
		if womanArr[i] ~= nil then
			list:add({rankList = womanArr[i], isEmpty = false, rank = rank_val});
		else
			list:add({isEmpty = true, rank = rank_val});
		end
		rank_val = rank_val + 1;
	end
	return list;
end

function Lua_CharmKingData.Get:man_rank_rewardList()
	local obj;
	local rewardArr;
	local tvo;
	local maleRankRewardArr = Array();
	for i = 1, #self.man_rank_reward do
		obj = self.man_rank_reward[i].reward_items;
		rewardArr = Array();
		for j = 1, #obj do            
			tvo = Lua_ToolVo.createToolVo(obj[j].id, obj[j].count, obj[j].bind);
			tvo:fromServer(obj[j])
			tvo.show_effect = obj[j].show_effect;
			rewardArr:add(tvo)
		end
		maleRankRewardArr:add({rewardList = rewardArr, rank_limit = self.man_rank_reward[i].cond});
	end
	return maleRankRewardArr;
end

function Lua_CharmKingData.Get:woman_rank_rewardList()
	local obj;
	local rewardArr;
	local tvo;
	local femaleRankRewardArr = Array();
	for i = 1, #self.woman_rank_reward do
		obj = self.woman_rank_reward[i].reward_items;
		rewardArr = Array();
		for j = 1, #obj do
			tvo = Lua_ToolVo.createToolVo(obj[j].id, obj[j].count, obj[j].bind);
			tvo:fromServer(obj[j]);
			tvo.show_effect = obj[j].show_effect;
			rewardArr:add(tvo)
		end
		femaleRankRewardArr:add({rewardList = rewardArr, rank_limit = self.woman_rank_reward[i].cond});
	end
	return femaleRankRewardArr;
end

function Lua_CharmKingData.Get:aggregate_rewardList()
	-- 达到奖励
	local obj;
	local rewardArr;
	local tvo;
	local aggregate_rewardArr = Array();
	for i = 1, #self.aggregate_reward do
		obj = self.aggregate_reward[i].reward_items;
		rewardArr = Array();
		for j = 1, #obj do          
			tvo = Lua_ToolVo.createToolVo(obj[j].id, obj[j].count, obj[j].bind);
			tvo:fromServer(obj[j])
			tvo.show_effect = obj[j].show_effect;
			rewardArr:add(tvo)
		end
		aggregate_rewardArr:add({first_type = self.first_type, index = self.aggregate_reward[i].index, flag = self.flag,
			rewardList = rewardArr, state = self.aggregate_reward[i].state, cond = self.aggregate_reward[i].cond[1],
			aggregate_value = self.aggregate_value, settl_switch = self.settl_switch});
	end
	return aggregate_rewardArr;
end

function Lua_CharmKingData.Get:dicountList()
	local tvo = Lua_ToolVo.createToolVo(self.discount_item_id);
	return {discount_item_id = self.discount_item_id, discount_item = tvo,
		price = tvo.goldPrice, discount_price = math.ceil(tvo.goldPrice * self.discount / 10)};
end

-- 检查活动是否开启
function Lua_CharmKingData:checkActIsOpen(data)
	if data.state == 1 then
		self.isOpen = true;
		if data.act_item_discount.obj_id ~= nil and data.act_item_discount.obj_id ~= 0 then
			self.discount_item_id = data.act_item_discount.obj_id;
			self.discount_price = math.ceil(Lua_ToolVo.createToolVo(self.discount_item_id).goldPrice * data.act_item_discount.obj_value / 10);
		end
	else
		self.isOpen = false;
	end
end