Lua_BulletinConfigVo = class("Lua_BulletinConfigVo");
function Lua_BulletinConfigVo:ctor(configId)
    self:superCall("ctor");

    self.itemInfo = { };
    self.configId = configId;
    self.config = getConfig( { "brocast", self.configId });
end

function Lua_BulletinConfigVo.Get:chatChanle()
    if self._chatChanle == nil then
        self._chatChanle = Array();
        if self.config ~= nil then
            for i = 1, #self.config.type do
                self._chatChanle:add(self.config.type[i]);
            end
        end
    end

    return self._chatChanle;
end

function Lua_BulletinConfigVo.Get:content()
    if self.config ~= nil and self.config.content ~= nil then
        return self.config.content;
    else
        return "";
    end
end

function Lua_BulletinConfigVo.Get:boardContent()
    if self.config ~= nil and self.config.boardContent ~= nil then
        return self.config.boardContent;
    else
        return "";
    end
end

function Lua_BulletinConfigVo.Get:notice()
    if self.config ~= nil then
        return self.config.notice;
    else
        return 0;
    end
end

function Lua_BulletinConfigVo.Get:priority()
    if self.config ~= nil and self.config.priority ~= nil then
        return self.config.priority;
    else
        return 0;
    end
end

function Lua_BulletinConfigVo.Get:display_horn()
    if self.config ~= nil and self.config.display_horn ~= nil then
        return self.config.display_horn;
    else
        return 0;
    end
end

function Lua_BulletinConfigVo.Get:times()
    if self.config ~= nil and self.config.times ~= nil and self.config.times > 0 then
        return self.config.times;
    else
        return 1;
    end
end

function Lua_BulletinConfigVo.Get:functionStr()
    if self.config ~= nil then
        return self.config.functionStr;
    else
        return "";
    end
end

function Lua_BulletinConfigVo.Get:changeNumDic()
    if self._changeNumDic == nil then
        self._changeNumDic = { };
        self._changeNumDic[40101] = true;
        self._changeNumDic[40201] = true;
        self._changeNumDic[40301] = true;
        self._changeNumDic[40401] = true;
        self._changeNumDic[40501] = true;
        self._changeNumDic[40601] = true;
        self._changeNumDic[40701] = true;
        self._changeNumDic[40801] = true;
    end
    return self._changeNumDic;
end

function Lua_BulletinConfigVo:genBulletinContent(id, index, val)
    if id == 70101 and index == 1 then
        local c = getConfig( { "military_rank", "junxian" });
        local c2 = getConfig( { "military_rank", "junxian_color" });
        return c2[val] .. c[val] .. "[-]";
    end

    if self.changeNumDic[id] == true and index == 1 then
        local numStr = string.split(LanUtil.getValue(110507), ",");
        local index = val / 10 + 2;
        return numStr[index];
    end

    return nil;
end

-- parseType nil或0 用content（聊天面板内容）   1用boardContent（公告板内容）
function Lua_BulletinConfigVo:parseContent(msg, parseType)
    self.itemInfo = { };
    local str;
    if parseType ~= nil and parseType == 1 then
        str = self.boardContent;
    else
        str = self.content;
    end
    local len = #msg.shout_detail_list;
    for i = 1, len do
        local sd = msg.shout_detail_list[i];
        local substr = nil;
        if sd.parse_type == 1 then
            substr = self:genBulletinContent(self.configId, i - 1, sd.single_value);
            if substr == nil then
                substr = self:getInt(sd);
            end
        elseif sd.parse_type == 2 then
            substr = self:genBulletinContent(self.configId, i - 1, tostring(sd.single_id));
            if substr == nil then
                substr = self:getInt64(sd);
            end
        elseif sd.parse_type == 3 then
            substr = self:genBulletinContent(self.configId, i - 1, sd.single_content);
            if substr == nil then
                substr = self:getString(sd);
            end
        elseif sd.parse_type == 4 then
            -- 个人觉得genBulletinContent暂时没必要判断这个类型 2018.04.03
            -- substr = self:genBulletinContent(self.configId, i - 1, self:getRoleName(sd));
            -- if substr == nil then
            -- 	substr = self:getRoleName(sd);
            -- end
            substr = self:getRoleName(sd);
        elseif sd.parse_type == 5 then
            -- 个人觉得genBulletinContent暂时没必要判断这个类型 2018.04.03
            -- substr = self:genBulletinContent(self.configId, i - 1, sd.single_value);
            -- if substr == nil then
            -- 	substr = self:getItem(sd);
            -- end
            substr = self:getItemName(sd);
        elseif sd.parse_type == 6 then
            substr = self:getItem(sd, i);
        elseif sd.parse_type == 7 then
            substr = self:getAttrs(sd);
        elseif sd.parse_type == 8 then
            substr = self:getSkillNames(sd);
        elseif sd.parse_type == 9 then
            substr = self:getEquName(sd, i);
        end

        if substr == nil then
            substr = "";
        end
        local temp = "{" ..(i - 1) .. "}";
        str = LanUtil.replaceStr(str, temp, substr);
    end
    return str;
end

function Lua_BulletinConfigVo:getInt(value)
    return tostring(value.single_value);
end

function Lua_BulletinConfigVo:getInt64(value)
    return tostring(value.single_id);
end

function Lua_BulletinConfigVo:getString(value)
    return value.single_content;
end

function Lua_BulletinConfigVo:getRoleName(value)
    local isSameServer = 1;
    if value.role_info.server_name ~= ""
        and DataCenter.roleData.server_name ~= ""
        and value.role_info.server_name ~= DataCenter.roleData.server_name then
        isSameServer = 0;
    end
    return "[url=playerClick_" .. value.role_info.role_id .. "_" .. value.role_info.role_name .. "_" .. isSameServer .. "][u]" .. value.role_info.role_name .. "[/u][-]";
end

function Lua_BulletinConfigVo:getItemName(value)
    if value.single_value ~= nil and value.single_value > 0 then
        local tvo = Lua_ToolVo.new(value.single_value);
        return "[u]" .. tvo.colorName .. "[/u]";
    end
    return "";
end

function Lua_BulletinConfigVo:getEquName(v, idx)
    local equvo = Lua_ToolVo.createToolVo(v.equipment.item.id, v.equipment.item.amount, v.equipment.item.bind);
    equvo:fromServer(v.equipment.item);
    equvo:fromEquipPart(v.equipment);
    local str = v.equipment.item.id .. idx;
    local nameStr = equvo.colorName;
    equvo.packType = 999;
    self.itemInfo[str] = equvo;
    return "[url=itemClick_" .. str .. "][u]" .. nameStr .. "[/u][/url]";
end

function Lua_BulletinConfigVo:getItem(value, idx)
    if value.item_tips ~= nil and value.item_tips.id ~= nil and value.item_tips.id > 0 then
        local tvo = Lua_ToolVo.createToolVo(value.item_tips.id);
        tvo:fromServer(value.item_tips);
        --tvo.packType = Lua_PackTypeDefine.EQUIP;
        if DataCenter.moneyData:isMoney(value.item_tips.id) == true then
            -- 货币
            return tvo.count .. tvo.name;
        else
            local str = value.item_tips.id .. idx;
            local nameStr = "";
            if tvo.subType == Lua_PackTypeDefine.WING_ITEM and tvo.wingColor ~= nil then
                -- 神翼
                if tvo.wingColor == 0 then
                    nameStr = "[55d2ff]" .. tvo.name .. "[-]"
                elseif tvo.wingColor == 1 then
                    nameStr = "[ff59fd]" .. tvo.name .. "[-]"
                elseif tvo.wingColor == 2 then
                    nameStr = "[ed9700]" .. tvo.name .. "[-]"
                elseif tvo.wingColor == 3 then
                    nameStr = "[ff5151]" .. tvo.name .. "[-]"
                end
            else
                nameStr = tvo.colorName;
            end
            self.itemInfo[str] = tvo;
            if tvo.count > 1 then
                return "[url=itemClick_" .. str .. "][u]" .. nameStr .. "[/u][00E125]X" .. tvo.count .. "[-][/url]";
            else
                return "[url=itemClick_" .. str .. "][u]" .. nameStr .. "[/u][/url]";
            end
        end
    end

    return self:getItemName(value);
end

function Lua_BulletinConfigVo:getAttrs(value)
    if value.attr_tips ~= nil then
        return Lua_PackUtil.genAttName(value.attr_tips);
    end

    return "";
end
function Lua_BulletinConfigVo:getSkillNames(value)
    local str = "";
    local skillId = tonumber(tostring(value.single_value))
    local part = Lua_ToolVo.new(value.item_tips.id).part
    local list = Lua_ZhuLingUtil.getZhuLingSkillBySkillId(part, skillId)
    str = "[url=openWin_Lua_SacredSkillWindow_" .. skillId .. "_" .. part .. "]" .. "[u]" .. list.name .. "lv." .. list.skill_lvl .. "[/u][/url]:" .. list.reMark;
    return str
end