checkRequire("Lua_ChatVo");
checkRequire("Lua_SystemChatVo");
Lua_ChatData = class("Lua_ChatData");

Lua_ChatData.Max_RecordTimes = 300;
Lua_ChatData.MIN_VOICE_TIME = 0.5;

Lua_ChatData.CHANEL_ALL_MSG = 0;
Lua_ChatData.CHANEL_WORLD = 1;
Lua_ChatData.CHANEL_FACTION = 2;
Lua_ChatData.CHANEL_TEAM = 3;
Lua_ChatData.CHANEL_SYSTEM = 4;
Lua_ChatData.CHANEL_PRIVATE = 6;
Lua_ChatData.CHANEL_FRIEND = 7;
Lua_ChatData.CHANEL_ALL = 8;
Lua_ChatData.CHANEL_QUYU = 5;
Lua_ChatData.CHANEL_CREATE_TEAM = 9;
Lua_ChatData.CHANEL_WORLD_KUAFU = 11;

Lua_ChatData.CHAT_TYPE_TEXT = 1;
Lua_ChatData.CHAT_TYPE_VOICE = 2;
Lua_ChatData.CHAT_TYPE_XUANYAO = 5;
Lua_ChatData.CHAT_TYPE_GIFT = 10; -- 红包

Lua_ChatData.MAX_MSG_NUM = 30;

function Lua_ChatData:ctor()
	self.dic = {};
	self.privateDic = {};
	self.dic[0] = Array();
	self.selectedChanel = Lua_ChatData.CHANEL_WORLD;
	self.selectedIndex = 1;
	self.newNumber = {};
	self._isLock = 0;
	self.redDotList={};--聊天红点
	self.chatTypeRedDotInfo = {};
    self.curTime=0;
    self.firstGangOpenWin=true;
    self.showItemData = nil;
    self.showType = 0;
    self.isInSpread = false;

    self.shieldData = {};
end

function Lua_ChatData:dispose()
	self.dic = {};
	self.dic[0] = Array();
	self.privateDic = {};
	self.selectedChanel = Lua_ChatData.CHANEL_WORLD;
	self.selectedIndex = 1;
	self._isLock = 0;
	self.newNumber = {};
	self.chatTypeRedDotInfo = {};
    self.firstGangOpenWin=true;
    self.showItemData = nil;
    self.showType = 0;
    Lua_CommonUtil.removeTimer(self, self.gangAnswerTiming);
end

function Lua_ChatData:setChatShowItem(val, data)
	self.showItemData = data;
	if data == nil then
		self.showType = 0;
	else
		self.showType = val;
	end
end

function Lua_ChatData:updataGangAnswerInfo(data)
    self.gangData=data;
    if self.gangData == nil then
        return;
    end
    self.gangTime=self.gangData.left_time;
    self.curTime = getTime();
    Lua_CommonUtil.removeTimer(self, self.gangAnswerTiming);
    Lua_CommonUtil.addTimer("gangAnswerTiming", 0.01, self, self.gangAnswerTiming, nil, -1);
end

function Lua_ChatData:gangAnswerTiming()
    local num = getTime();
    self.gangData.left_time = self.gangData.left_time - (num - self.curTime);
    self.curTime = num;
    if self.gangTime - self.gangData.left_time >= 1 or self.gangData.left_time<=0 then
        self.gangTime=self.gangData.left_time;
        if self.gangTime <= 0 then
            self.gangTime=0;
        end
        Lua_MsgUtil.callFunc("CHAT_GANGANSWER_CHANGE");
    end
    if self.gangData.left_time <= 0 then
        Lua_CommonUtil.removeTimer(self, self.gangAnswerTiming);
    end

end
function Lua_ChatData.Get:isLock()
	return self._isLock;
end

function Lua_ChatData.Set:isLock(val)
	self._isLock = val;
	if val == 0 then
		self.newNumber = {};
	end
end

function Lua_ChatData:getChanleNewMsgNum(chanle)
	if self.newNumber[chanle] == nil then
		return 0;
	end
	return self.newNumber[chanle];
end

function Lua_ChatData:setChanleNewMsgNum(chanle, val)
	self.newNumber[chanle] = val;
end

function Lua_ChatData:getChanleShield(chanle)
	if self.shieldData[chanle] == nil then
		return 0;
	end
	return self.shieldData[chanle];
end

function Lua_ChatData:setChanleShield(chanle, val)
	self.shieldData[chanle] = val;
end

function Lua_ChatData:addChatMsg(msg)
	if self.dic[msg.channel] == nil then
		self.dic[msg.channel] = Array();
	end
	local arr = self.dic[msg.channel];
	arr:add(msg);
	if self.chatTypeRedDotInfo[msg.channel] == nil or self.chatTypeRedDotInfo[msg.channel] == false then
		self.chatTypeRedDotInfo[msg.channel] = true;
	end
	while true do
		if arr:getSize() > Lua_ChatData.MAX_MSG_NUM then
			arr:remove(1);
		else
			break;
		end
	end
	if self:isSaveToAll(msg) == true then
		self.dic[0]:add(msg);
		while true do
			if self.dic[0]:getSize() > 40 then
				self.dic[0]:remove(1);
			else
				break;
			end
		end
	end
	if self._isLock == 1 then
		local nowNum = self:getChanleNewMsgNum(msg.channel);
		self:setChanleNewMsgNum(msg.channel, nowNum + 1);
	end
	Lua_MsgUtil.callFunc("ADD_CHAT_MSG", msg);
end

function Lua_ChatData:isSaveToAll(msg)
	if msg.channel == Lua_ChatData.CHANEL_WORLD 
		or msg.channel == Lua_ChatData.CHANEL_FACTION
		or msg.channel == Lua_ChatData.CHANEL_TEAM
		or msg.channel == Lua_ChatData.CHANEL_CREATE_TEAM
		or msg.channel == Lua_ChatData.CHANEL_QUYU
		or msg.channel == Lua_ChatData.CHANEL_WORLD_KUAFU
		or msg.channel == Lua_ChatData.CHANEL_SYSTEM then
		return true;
	end
	return false;
end

function Lua_ChatData:getChannelMsgList(channel)
	return self.dic[channel];
end

function Lua_ChatData:getPrivateMsgList(role_id)
	local rid = tonumber(role_id);
	if self.privateDic[rid] == nil then
		return Array();
	else
		return self.privateDic[rid];
	end
end

function Lua_ChatData:addPrivateChatMsg(msg)
	local rid = msg.role_id;
	if DataCenter.roleData.roleId == msg.role_id then
		rid = msg.target_id;
	end
	if self.privateDic[rid] == nil then
		self.privateDic[rid] = Array();
	end
	if msg.role_id~=DataCenter.roleData.roleId then
		self.redDotList[tonumber(rid)]=true;
		Lua_MsgUtil.callFunc("UPDATE_SOCIAL_REDDOT");
		Lua_MsgUtil.callFunc("UPDATE_FRIEND_REDDOT");
	end
	local arr = self.privateDic[rid];
	arr:add(msg);
	while true do
		if arr:getSize() > 30 then
			arr:remove(1);
		else
			break;
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_PRIVATE_MSG", rid);
end

function Lua_ChatData.Get:maxMsgLen()
	return Lua_CommonUtil.getCommonConfig("chat_len", 1);
end

function Lua_ChatData:setRedDotList(rid,val)
	self.redDotList[rid]=val;
end

-- 系统播报配置
function Lua_ChatData:getSystemChatVoById(id)
	if self._systemChatInfo == nil then
		self._systemChatInfo = {};
	end

	id = tonumber(id);
	if self._systemChatInfo[id] == nil then
		local config = getConfig({"systemChatInfo", id});
		local vo = Lua_SystemChatVo.new(id, config);
		self._systemChatInfo[id] = vo;
	end
	return self._systemChatInfo[id];
end

-- 是否屏蔽语音
function Lua_ChatData.Get:bVoiceShield()
	if self._bVoiceShield == nil then
		local pn = SDKPlatform.GetPackageName();
        if pn ~= nil then
            local list = string.split(pn, "_");
            local len = list:getSize();
            local cid = tostring(list[len]);
			local arr = Lua_CommonUtil.getCommonConfig("voiceShieldByPackageID", 3);
			if arr ~= nil and #arr > 0 then
				for i = 1, #arr do
					if tostring(arr[i]) == cid then
						self._bVoiceShield = true;
						return true;
					end
				end
			end
		end
		self._bVoiceShield = false;
	end

	return self._bVoiceShield;
end