-- 系统播报数据
Lua_SystemChatVo = class("Lua_SystemChatVo")
function Lua_SystemChatVo:ctor(id, config)
    self:superCall("ctor");

	self.id = id;
	if config == nil then
		self.config = getConfig({"systemChatInfo", id});	
	else
		self.config = config;
	end
end

function Lua_SystemChatVo.Get:content()
	if self.config ~= nil and self.config.desc ~= nil then
		return self.config.desc;
	end
	return "";
end

function Lua_SystemChatVo.Get:shoutContent()
	if self.config ~= nil and self.config.shoutContent ~= nil then
		return self.config.shoutContent;
	end
	return "";
end

function Lua_SystemChatVo.Get:showTime()
	if self.config ~= nil and self.config.playTime ~= nil and self.config.playTime > 0 then
		return self.config.playTime;
	end
	return 5;
end

function Lua_SystemChatVo.Get:minLv()
	if self.config ~= nil and self.config.level ~= nil and self.config.level[1] ~= nil then
		return self.config.level[1];
	end
	return 0;
end

function Lua_SystemChatVo.Get:maxLv()
	if self.config ~= nil and self.config.level ~= nil and self.config.level[2] ~= nil then
		return self.config.level[2];
	end
	return 99999999;
end

function Lua_SystemChatVo.Get:whiteScene()
	if self.config ~= nil and self.config.whiteScene ~= nil then
		return self.config.whiteScene;
	end
	return nil;
end

function Lua_SystemChatVo.Get:blackScene()
	if self.config ~= nil and self.config.blackScene ~= nil then
		return self.config.blackScene;
	end
	return nil;
end

function Lua_SystemChatVo:checkCanShow()
	if self.config == nil then
		return false;
	end

	local lv = DataCenter.roleData.level;
	if lv < self.minLv or lv > self.maxLv then
		return false;
	end

	local sceneId = DataCenter.roleData.sceneId;
	local list = self.whiteScene;
	if list ~= nil and #list > 0 then
		local bShow = false;
		for i = 1, #list do
			if tonumber(list[i]) == tonumber(sceneId) then
				bShow = true;
			end
		end

		if bShow == false then
			return false;
		end
	end

	list = self.blackScene;
	if list ~= nil and #list > 0 then
		for i = 1, #list do
			if tonumber(list[i]) == tonumber(sceneId) then
				return false;
			end
		end
	end

	return true;
end