checkRequire("Lua_ChatNoHeadItem");
checkRequire("Lua_ChatHeadRightItem");
checkRequire("Lua_ChatHeadLeftItem");
Lua_ChatDragContainer = class("Lua_ChatDragContainer", Lua_DragContainer);
function Lua_ChatDragContainer:ctor(p, ltype, vsize, cellWidth, isFriend)
	self.cellWidth = cellWidth == nil and 370 or cellWidth;
	self.lastTime = getTime();
	self.isFriend = isFriend;
	self:superCall("ctor", p, ltype, vsize);
end

function Lua_ChatDragContainer:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_ChatDragContainer";
end

function Lua_ChatDragContainer:onMouseDownHandle(go,state)
	self:superCall("onMouseDownHandle", go, state);

	self.mouseMoving = true;
end

function Lua_ChatDragContainer:onMouseUpHandle(go,state)
	self:superCall("onMouseUpHandle", go, state);
	
	self.lastTime = getTime();
	self.mouseMoving = false;
end

function Lua_ChatDragContainer:updateChatList(list, moveToLast)
	self:clear();
	if list == nil then
		return;
	end

	self.lastTime = 0;

	local chatVo;
	local chatItem = nil;
	for i = 1, list:getSize() do
		chatVo = list[i];
		chatItem = self:genItem(chatVo);
		self:addSubContainer(chatItem, false);
	end
	self:updateChildPos();

	if moveToLast == nil or moveToLast == true then
		self:moveToChildIndex(9999, true);
	end
end

function Lua_ChatDragContainer:genItem(chatVo)
	local chatItem = nil;
	if chatVo.role_id == 0 or chatVo.role_id == nil then
		chatItem = Lua_ChatWithChanelItem.new(self.content, self.cellWidth, true);
	elseif chatVo.role_id == DataCenter.roleData.roleId then
		chatItem = Lua_ChatHeadRightItem.new(self.content, self.cellWidth);
	else
		chatItem = Lua_ChatHeadLeftItem.new(self.content, self.cellWidth);
	end
	chatItem.isFriend = self.isFriend;
	chatItem:setData(chatVo);
	return chatItem;
end

function Lua_ChatDragContainer:addNewChat(chatVo, limitLen, moveToLast)
	local chatItem = self:genItem(chatVo);
	local toLast = moveToLast == nil or moveToLast == true;
	self:addSubContainer(chatItem, false);
	if toLast == false then
		limitLen = limitLen * 2;
	end

	while true do
		if self.childrenList:getSize() > limitLen then
			local chatItem = self.childrenList[1];
			chatItem:dispose();
			self.childrenList:remove(1);
		else
			break;
		end
	end
	self:updateChildPos();

	if self.mouseMoving ~= true 
		and getTime() - self.lastTime > 3
		and toLast then
		self:moveToChildIndex(9999);
	end
end

function Lua_ChatDragContainer:clear()
	if self.childrenList:getSize() == 0 then
		return;
	end

	while true do
		local chatItem = self.childrenList[1];
		chatItem:dispose();
		self.childrenList:remove(1);
		if self.childrenList:getSize() == 0 then
			break;
		end
	end
end