checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatGiftItem");
checkRequire("Lua_ChatVipItem");
Lua_ChatHeadLeftItem = class("Lua_ChatHeadLeftItem", Lua_DragContainerItem);
function Lua_ChatHeadLeftItem:ctor(p, cellWidth)
	self.type = 2;
	self.cellWidth = cellWidth == nil and 330 or cellWidth;
	self:superCall("ctor", p, "ChatHeadLeftItem_skin", false);
end

function Lua_ChatHeadLeftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_ChatHeadLeftItem";

	self.headIconItem = Lua_HeadIconItem.new(self.content);
	self.headIconItem.headIcon.clickScale = false;
	self.headIconItem.headIcon:addClickFuntion(self, self.onHeadClick);
	self.headIconItem:setDepth(5);
	self.headIconItem:setScale(0.9, 0.9, 0.9);
	self.headIconItem:setLocation(40, -52, 0);

	self.infoItem = Lua_ChatInfoItem.new(self.content, self.cellWidth - 130, true);
	self.infoItem:setLocation(116, -43, 0);
end

function Lua_ChatHeadLeftItem:setData(vo)
	self.chatData = vo;
	local nameStr = "[6385AA]"..vo.name.."[-]";
	if self.chatData.channel == Lua_ChatData.CHANEL_QUYU then
		nameStr = nameStr..Lua_ChatUtil.FACE_SPACE.."[00a106]"..self.chatData.server_name.."[-]";
	elseif self.chatData.channel == Lua_ChatData.CHANEL_WORLD_KUAFU and self.chatData.server_name~=nil then
        local str1 = self.chatData.server_name --string.match(self.chatData.server_name,"%a%d+");
        if str1 == nil then
            str1= "";
        end
        nameStr = "[00a106]"..str1.."[-]"..Lua_ChatUtil.FACE_SPACE..nameStr;
	else
		if vo.military_rank ~= 0 then
			nameStr = nameStr..Lua_ChatUtil.FACE_SPACE..Lua_ThingDefine.getJunXianName(vo.military_rank);
		end
	end
	self.nameTxt.text = nameStr;

	local profession = isHeadReplaceOpen() and vo.role_head_name or vo.profession;
	if vo.head_frame_id ~= nil and vo.head_frame_id ~= 0 then
		self.headIconItem:setData(vo.career, profession, DataCenter.roleData:getHeadFrame(vo.head_frame_id));
		self.headIconItem:showFrameEffect(vo.head_frame_id);
	else
		self.headIconItem:setData(vo.career, profession);
	end

	if vo.vip ~= nil and vo.vip ~= 0 then
		if self.vipItem == nil then
			self.vipItem = Lua_ChatVipItem.new(self.content, true);
		end
		self.vipItem:setEnable(true);
		self.vipItem:setVipLevel(vo.vip);
		self.vipItem:setLocation(130 + self.nameTxt.width + self.vipItem.vipNum.numWidth / 2, -12, 0);
	else
		if self.vipItem ~= nil then
			self.vipItem:setEnable(false);
		end
	end
	
	local posX;
	if vo.permission == 8 then
		posX = 95 + self.nameTxt.width;
		if vo.vip ~= nil and vo.vip ~= 0 then
			posX = posX + self.vipItem.vipNum.width + self.vipItem.vipNum.numWidth / 2 + 37;
		else
			posX = posX;
		end
		self.zhidaoSp:setLocation(posX, -12, 0);
		self.zhidaoSp:setEnable(true);
	else
		self.zhidaoSp:setEnable(false);
	end

	local contentAltas = "role_atlas";
	local contentSprite = "ui_figure_icon_txd1";
	if vo.air_bubble_id ~= nil and vo.air_bubble_id ~= 0 then
		local list = DataCenter.roleData:getChatBubble(vo.air_bubble_id, 1);
		contentAltas = list.atlas;
		contentSprite = list.sprite;

		self.infoItem.modelLabel.effectStyle = 3;
		self.infoItem.modelLabel.effectColorStr = Lua_ColorDefine.transColor("08324C");
		self.infoItem.modelLabel:setEffectDistance(1, 1);
	end

	local pos_y = -50;
	local infoPosXOffest = 11;
	if vo.type == Lua_ChatData.CHAT_TYPE_TEXT or vo.type == Lua_ChatData.CHAT_TYPE_XUANYAO then
		self.contentBg:setAltas(contentAltas, contentSprite);

		self.infoItem:setChatData(vo);
		self.infoItem:setData("[FFFFFF]".. vo:getMsg(false, false).."[-]");

		self.h = self.infoItem:getHeight() + 47;
	elseif vo.type == Lua_ChatData.CHAT_TYPE_VOICE then
		self.contentBg:setAltas(contentAltas, contentSprite);

		self.soundItem = Lua_ChatSoundItem.new(self.content, 1);
		self.soundItem:setLocation(192, -62, 0);
		self.soundItem:setData(vo);
		self.soundItem:setDepth(3);

		if vo.content ~= nil and string.len(vo.content) > 0 then
			self.infoItem:setChatData(vo);
			self.infoItem:setData(vo:getMsg(false, false));
			self.infoItem:setLocation(116, -97, 0);
			self.h = self.infoItem:getHeight() + 109;
			pos_y = -104;
		else
			self.h = 93;
		end
	elseif vo.type == Lua_ChatData.CHAT_TYPE_GIFT then -- 红包
		self.contentBg:setAltas("chatPanel_atlas", "ui_gangs_bg_09");
		
		if self.giftItem == nil then
			self.giftItem = Lua_ChatGiftItem.new(self.content);
			self.giftItem:setLocation(114, -66, 0);
		end

		self.infoItem:setChatData(vo);
		self.infoItem:setWidth(self.cellWidth - 157);
		self.infoItem:setData(vo:getMsg(false, false));

		self.h = self.infoItem:getHeight();
		if self.h < self.giftItem:getHeight() then
			self.h = self.giftItem:getHeight();
		end
		self.h = self.h + 47;
		infoPosXOffest = 11;
	end
  
	local contentX = 87;
	local contentY = -35;
	local addHeight = 0;
	local infoPosYOffest = 0;
	local minWidth = 0;
	if vo.air_bubble_id ~= 0 and vo.type ~= Lua_ChatData.CHAT_TYPE_GIFT then
		contentX = getConfig({"chat_attire",vo.air_bubble_id, "left_offset", 1});
		contentY = getConfig({"chat_attire",vo.air_bubble_id, "left_offset", 2});
		infoPosXOffest = getConfig({"chat_attire",vo.air_bubble_id, "left_offset", 3});
		addHeight = getConfig({"chat_attire",vo.air_bubble_id, "left_offset", 4});
		minWidth = getConfig({"chat_attire",vo.air_bubble_id, "min_width"});
	end

	local contentHeight = self.h - 27;
	if contentHeight <= 70 and vo.air_bubble_id ~= 0 then
		infoPosYOffest = (addHeight + 56 - contentHeight) / 2
		contentHeight = 70;
	end
	if contentHeight > 70 and vo.air_bubble_id ~= 0 then
		contentHeight = contentHeight + 24;
		infoPosYOffest = (addHeight + 10) / 2;
	end

	local w = self.infoItem:getWidth() + 40;
	posX = 85 + (contentX -85) + w / 2 - self.infoItem:getWidth() / 2 + infoPosXOffest;
	if self.giftItem ~= nil then
		w = w + self.giftItem:getWidth();
		posX = posX + self.giftItem:getWidth();
	else
		posX = posX;
	end
	self.infoItem:setLocation(posX, pos_y - infoPosYOffest, 0);

	if self.soundItem ~= nil and w < self.soundItem:getWidth() then
		w = self.soundItem:getWidth();
		if self.fengexian ~= nil then
			self.fengexian:SetDimensions(w - 30, 2);
			self.fengexian:setLocation(120 + (w - 30) / 2, -87, 0);
		end
	end
	if vo.air_bubble_id ~= 0 then
    	if w < minWidth then
			w = minWidth;
		end
	end
	self.contentBg:SetDimensions(w, contentHeight + addHeight);
	self.contentBg:setLocation(contentX, contentY, 0);
	if self.soundItem ~= nil then
		self.soundItem:setBgAltas(contentAltas, contentSprite, w, contentHeight + addHeight);
	end
end

function Lua_ChatHeadLeftItem:onPlayerSoundClick()
	if self.chatData.type == Lua_ChatData.CHAT_TYPE_GIFT and DataCenter.roleData.leagueName~="" then
		Lua_WindowUtil.openWin("Lua_FactionRedEnvelopeWindow", WinParam.ACTION_OPEN, nil);
	else
		self.infoItem:checkUrlClick();
	end
end

function Lua_ChatHeadLeftItem:checkOutBound(showRect)
	if self.headIconItem.frameEffect ~= nil then
		local rect = Lua_Rectangle.new(self.x, self.y - 70, 0, 70);
		self.headIconItem.frameEffect:setEnable(showRect:containeRect(rect));
	end
end

function Lua_ChatHeadLeftItem:getHeight()
	return self.h < 117 and 140 or self.h + 20;
end

function Lua_ChatHeadLeftItem:onHeadClick(go)
	if self.chatData.channel == Lua_ChatData.CHANEL_WORLD_KUAFU then
        return;
    end
	if self.chatData.channel == Lua_ChatData.CHANEL_QUYU then
		self.chatData.isSameServer = 0;
		Lua_ChatUtil.playerMenuPopListShow(self.chatData, false, nil, true);
	else
		Lua_ChatUtil.playerMenuPopListShow(self.chatData, false);
	end
end

function Lua_ChatHeadLeftItem:dispose()
	if self.isDispose_2 ~= true then
		WindowMananger.getInstance():returnToPool(self.content.transform);
	end
	if self.headIconItem ~= nil then
		self.headIconItem:dispose();
		self.headIconItem = nil;
	end
	self:superCall("dispose");
end