checkRequire("Lua_ChatSoundItem");
checkRequire("Lua_ChatGiftItem");
checkRequire("Lua_ChatVipItem");
Lua_ChatHeadRightItem = class("Lua_ChatHeadRightItem", Lua_DragContainerItem);
function Lua_ChatHeadRightItem:ctor(p, cellWidth)
	self.type = 3;
	self.cellWidth = cellWidth == nil and 330 or cellWidth;
	self:superCall("ctor", p, "ChatHeadRightItem_skin", false);
end

function Lua_ChatHeadRightItem:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_ChatHeadRightItem";

	self.headIconItem = Lua_HeadIconItem.new(self.content);
	self.headIconItem:setDepth(5);
	self.headIconItem:setScale(0.9, 0.9, 0.9);

	self.infoItem = Lua_ChatInfoItem.new(self.content, self.cellWidth - 130, true);
end

function Lua_ChatHeadRightItem:setData(vo)
	self.chatData = vo;
	local nameStr = "[6385AA]"..vo.name.."[-]";
	if self.chatData.channel == Lua_ChatData.CHANEL_QUYU then
		nameStr = "[00A106]"..self.chatData.server_name.."[-]"..Lua_ChatUtil.FACE_SPACE..nameStr;
	elseif self.chatData.channel == Lua_ChatData.CHANEL_WORLD_KUAFU and self.chatData.server_name~=nil then
        local str1 = self.chatData.server_name --string.match(self.chatData.server_name,"%a%d+");
        if str1 == nil then
            str1= "";
        end
        nameStr = "[00a106]"..str1.."[-]"..Lua_ChatUtil.FACE_SPACE..nameStr;
	else
		if vo.military_rank ~= 0 then
			nameStr = Lua_ThingDefine.getJunXianName(vo.military_rank)..Lua_ChatUtil.FACE_SPACE..nameStr;
		end
	end
	self.nameTxt.text = nameStr;
	self.nameTxt:setLocation(self.cellWidth - 85, -12, 0);

	local profession = isHeadReplaceOpen() and vo.role_head_name or vo.profession;
	if vo.head_frame_id ~= nil and vo.head_frame_id ~= 0 then
		self.headIconItem:setData(vo.career, profession, DataCenter.roleData:getHeadFrame(vo.head_frame_id));
		self.headIconItem:showFrameEffect(vo.head_frame_id);
	else
		self.headIconItem:setData(vo.career, profession);
	end

	if vo.vip ~= nil and vo.vip ~= 0 then
		if self.vipItem == nil then
			self.vipItem = Lua_ChatVipItem.new(self.content, false);
		end
		self.vipItem:setEnable(true);
		self.vipItem:setVipLevel(vo.vip);
		self.vipItem:setLocation(self.cellWidth - self.nameTxt.width - 85 - self.vipItem.vipNum.width, -12, 0);
	else
		if self.vipItem ~= nil then
			self.vipItem:setEnable(false);
		end
	end

	local posX;
	if vo.permission == 8 then
		posX = self.cellWidth - self.nameTxt.width - 85;
		if vo.vip ~= nil and vo.vip ~= 0 then
			posX = posX - self.vipItem.vipNum.width - self.vipItem.vipNum.numWidth / 2 - 34;
		else
			posX = posX;
		end
		self.zhidaoSp:setLocation(posX, -12, 0);
		self.zhidaoSp:setEnable(true);
	else
		self.zhidaoSp:setEnable(false);
	end

	local contentAltas = "role_atlas";
	local contentSprite = "ui_figure_icon_txd1";
	if vo.air_bubble_id ~= 0 then
		local list = DataCenter.roleData:getChatBubble(vo.air_bubble_id);
		contentAltas = list.atlas;
		contentSprite = list.sprite;

		self.infoItem.modelLabel.effectStyle = 3;
		self.infoItem.modelLabel.effectColorStr = Lua_ColorDefine.transColor("08324C");
		self.infoItem.modelLabel:setEffectDistance(1, 1);
	end

	local pos_y = 0;
	local infoPosXOffest = -8;
	if vo.type == Lua_ChatData.CHAT_TYPE_TEXT or vo.type == Lua_ChatData.CHAT_TYPE_XUANYAO then
		self.contentBg:setAltas(contentAltas, contentSprite);
		self.contentBg:setSacle(-1, 1, 1);

		self.infoItem:setChatData(vo);
		self.infoItem:setData("[FFFFFF]"..vo:getMsg(false, false).."[-]");

		self.h = self.infoItem:getHeight() + 47;
		pos_y = -49;
	elseif vo.type == Lua_ChatData.CHAT_TYPE_VOICE then
		-- print(contentAltas, contentSprite);
		self.contentBg:setAltas(contentAltas, contentSprite);
		self.contentBg:setSacle(-1, 1, 1);

		self.soundItem = Lua_ChatSoundItem.new(self.content, 2);
		self.soundItem:setLocation(self.cellWidth - 178, -62, 0);
		self.soundItem:setData(vo);
		self.soundItem:setDepth(3);

		if vo.content ~= nil and string.len(vo.content) > 0 then
			self.infoItem:setChatData(vo);
			self.infoItem:setData("[FFFFFF]"..vo:getMsg(false, false).."[-]");
			self.h = self.infoItem:getHeight() + 109;
			pos_y = -104;
		else
			self.h = 93;
		end
	elseif vo.type == Lua_ChatData.CHAT_TYPE_GIFT then -- 红包
		self.contentBg:setAltas("chatPanel_atlas", "ui_gangs_bg_09");
		self.contentBg:setSacle(-1, 1, 1);

		if self.giftItem == nil then
			self.giftItem = Lua_ChatGiftItem.new(self.content);
			self.giftItem:setLocation(289, -68, 0);
		end

		self.infoItem:setChatData(vo);
		self.infoItem:setWidth(self.cellWidth - 157);
		self.infoItem:setData("[FFFFFF]"..vo:getMsg(false, false).."[-]");
		
		self.h = self.infoItem:getHeight();
		if self.h < self.giftItem:getHeight() then
			self.h = self.giftItem:getHeight();
		end
		self.h = self.h + 47;
		pos_y = -49;
		infoPosXOffest = 12
	end


	local contentX = 0;
	local contentY = -35;
	local addHeight = 0;
	local minWidth = 0;
	if vo.air_bubble_id ~= 0 and vo.type ~= Lua_ChatData.CHAT_TYPE_GIFT then -- 红包特殊处理
		contentX = getConfig({"chat_attire", vo.air_bubble_id, "right_offset", 1});
		contentY = getConfig({"chat_attire", vo.air_bubble_id, "right_offset", 2});
		infoPosXOffest = getConfig({"chat_attire", vo.air_bubble_id, "right_offset", 3});
		addHeight = getConfig({"chat_attire", vo.air_bubble_id, "right_offset", 4});
		minWidth = getConfig({"chat_attire", vo.air_bubble_id, "min_width"});
	end

	local infoPosYOffest = 0;
	local contentHeight = self.h - 27;
	if contentHeight < 70 and vo.air_bubble_id ~= 0 then
		infoPosYOffest = (addHeight + 56 - contentHeight) / 2;
		contentHeight = 70;
	end
	if contentHeight > 70 and vo.air_bubble_id ~= 0 then
		contentHeight = contentHeight + 24;
		infoPosYOffest = (addHeight + 10) / 2;
	end

	local w = self.infoItem:getWidth() + 40;
	if self.giftItem ~= nil then
		w = w + self.giftItem:getWidth();
	end
	if self.soundItem ~= nil and w < self.soundItem:getWidth() then
		w = self.soundItem:getWidth();
		if self.fengexian ~= nil then
			self.fengexian:SetDimensions(w, 2);
			self.fengexian:setLocation(self.cellWidth + 10 - w, -87, 0);
		end
	end
	if vo.air_bubble_id ~= 0 then
		if w < minWidth then
			w = minWidth;
		end
	end
	if self.infoItem:getWidth() >= self.cellWidth - 130 then
		infoPosXOffest = infoPosXOffest + 4;
	end
	posX = self.cellWidth - 80 - self.infoItem:getWidth() / 2 - w / 2 + contentX + infoPosXOffest;
	posX = self.giftItem == nil and posX or posX - self.giftItem:getWidth();
	self.infoItem:setLocation(posX, pos_y - infoPosYOffest, 0);
	self.headIconItem:setLocation(self.cellWidth -29, -52, 0);

	-- 红包(翻转过)
	posX = vo.type == Lua_ChatData.CHAT_TYPE_GIFT and self.cellWidth - 80 - w or self.cellWidth - 80 - w + contentX;
	self.contentBg:SetDimensions(w, contentHeight + addHeight);
	self.contentBg:setLocation(self.cellWidth - 80 - w, contentY, 0);
	if self.soundItem ~= nil then
		self.soundItem:setBgAltas(contentAltas, contentSprite, w, contentHeight + addHeight);
	end
end

function Lua_ChatHeadRightItem:onPlayerSoundClick()
	if self.chatData.type == Lua_ChatData.CHAT_TYPE_GIFT and DataCenter.roleData.leagueName ~= "" then
		Lua_WindowUtil.openWin("Lua_FactionRedEnvelopeWindow", WinParam.ACTION_OPEN);
	else
		self.infoItem:checkUrlClick();
	end
end

function Lua_ChatHeadRightItem:checkOutBound(showRect)
	if self.headIconItem.frameEffect ~= nil then
		local rect = Lua_Rectangle.new(self.x, self.y - 70, 0, 70);
		self.headIconItem.frameEffect:setEnable(showRect:containeRect(rect));
	end
end

function Lua_ChatHeadRightItem:getHeight()
	return self.h < 117 and 140 or self.h + 20;
end

function Lua_ChatHeadRightItem:dispose()
	if self.isDispose_2 ~= true then
		WindowMananger.getInstance():returnToPool(self.content.transform);
	end
	if self.headIconItem ~= nil then
		self.headIconItem:dispose();
		self.headIconItem = nil;
	end
	self:superCall("dispose");
end