Lua_ChatInfoItem = class("Lua_ChatInfoItem", Lua_DisplayObject);
function Lua_ChatInfoItem:ctor(p, w, mouseEnbale)
	self.textWidth = w == nil and 330 or w;
	self.faceShowList = Array();
	self.faceHideList = Array();
	self._width = 10;
	self._height = 10;
	self.mouseEnbale = mouseEnbale;
	self:superCall("ctor", p);
end

function Lua_ChatInfoItem:buildShowItem()
	self:superCall("buildShowItem");

	self.modelLabel = UICreate.createLabel(self.content, "", -20, -2, self.textWidth, 30, 20);
	self.modelLabel.name = "modelLabel";
	self.modelLabel.pivot = Lua_WindowUtil.getPivot(1);
	self.modelLabel.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.modelLabel.spacingY = 6;
	self.modelLabel:setDepth(2);
	self.modelLabel:setLocation(0, 0, 0);
end

function Lua_ChatInfoItem:setWidth(value)
	self.textWidth = value;
	self.modelLabel:SetDimensions(self.textWidth, 28);
end

function Lua_ChatInfoItem:getWidth()
	return self._width;
end

function Lua_ChatInfoItem:getHeight()
	return self._height; -- + 5;
end

function Lua_ChatInfoItem:setChatData(data)
	self.chatData = data;
end

function Lua_ChatInfoItem:setData(str)
	self:returnToHideList();

	local arr = Lua_ChatUtil.genChatString(str, "/%d%d");
	local tempStr = "";
	for i = 1, arr:getSize() do
		if Lua_ChatUtil.isChatFace(arr[i]) == true then
			tempStr = tempStr..Lua_ChatUtil.FACE_SPACE;
			self.modelLabel.text = tempStr;
			local vec = self.modelLabel:lastPrintedSize(tempStr);
			local img = self:genFace(string.sub(arr[i], 2, 3));
			if string.len(tempStr) == 0 then
				img:setLocation(vec.x, -9, 0);
			else
				img:setLocation(vec.x, -vec.y + 17, 0);
			end
			img:setDepth(3);
			tempStr = tempStr..Lua_ChatUtil.FACE_SPACE..Lua_ChatUtil.SPACE;
		else
			tempStr = tempStr..arr[i];
		end
	end
	self.modelLabel.text = tempStr;

	local vec = self.modelLabel:lastPrintedSize(tempStr);
	if vec.y > 26 then
		self._width = self.textWidth;
	else
		self._width = vec.x;
	end
	self._height = vec.y;
end

function Lua_ChatInfoItem:genFace(faceIndex)
	local str = tostring(faceIndex);
	if string.len(str) < 2 then
		str = "0"..str;
	end

	local img;
	if self.faceHideList:getSize() > 0 then
		img = self.faceHideList:remove(1);
	else
		img = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 30, 30);
	end
	img:setAltas("icon_atlas_2", "ui_chat_bq_"..str);
	img:setEnable(true);
	self.faceShowList:add(img);
	return img;
end

function Lua_ChatInfoItem:returnToHideList()
	local len = self.faceShowList:getSize();
	for i = 1, len do
		self.faceShowList[i]:setEnable(false);
		self.faceHideList:add(self.faceShowList[i]);
	end
	self.faceShowList:clear();
end

function Lua_ChatInfoItem:checkUrlClick()
	local urlStr = self.modelLabel:getUrlByMousePos()
	if urlStr ~= nil then
		if self.chatData ~= nil and self.chatData.itemData ~= nil then
			Lua_ChatUtil.urlClickHandle(urlStr, self.chatData.itemData);
		elseif self.chatData ~= nil and self.chatData.mingSuoChatData ~= nil then
			Lua_ChatUtil.urlClickHandle(urlStr, self.chatData.mingSuoChatData);
		else
			Lua_ChatUtil.urlClickHandle(urlStr, self.chatData);
		end
	end
end

function Lua_ChatInfoItem:onItemClick(itemId)
end

function Lua_ChatInfoItem:onHeadClick(rid)
	-- local menuTypes = Array();
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_CHECK_INFO,rid));
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_PRIVATE_CHAT,rid));
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND,rid));
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_TEAM,rid));
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_UNION,rid));
	-- menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_JOIN_BLACK,{role_id=rid,name=self.chatData.name}));
	-- Lua_WindowUtil.openWin("Lua_MenuPopListWindow",WinParam.ACTION_OPEN,menuTypes);

	Lua_ChatUtil.playerMenuPopListShow(self.chatData, false);
end