Lua_ChatSoundItem = class("Lua_ChatSoundItem", Lua_DisplayObject);
function Lua_ChatSoundItem:ctor(p, t)
	self:superCall("ctor", p, t == 1 and "ChatLeftSoundItem_skin" or "ChatRightSoundItem_skin");
end

function Lua_ChatSoundItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showIconArr = Array();
	self.showIconArr:add(self.soundSp1);
	self.showIconArr:add(self.soundSp2);
	self.showIconArr:add(self.soundSp3);
	
	self.sendTime = 0;

	self.bg.alpha = 0.01;
	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onSoundBgClick);
	
	self.timeTxt.effectStyle = 3;
	self.timeTxt.effectColorStr = Lua_ColorDefine.transColor("08324C");
	self.timeTxt:setEffectDistance(1, 1);
	
	self:addCSharpEvent("CHAT_PLAY_SOUND", self, self.onVoicePlay);
end

function Lua_ChatSoundItem:setData(vo)
	self._data = vo;
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(120212), tostring(vo.voice_len));
end

function Lua_ChatSoundItem:setDepth(val)
	self:superCall("setDepth", val);

	self.bg:setDepth(val);
	self.soundSp1:setDepth(val + 1);
	self.soundSp2:setDepth(val + 1);
	self.soundSp3:setDepth(val + 1);
	self.timeTxt:setDepth(val + 2);
end

function Lua_ChatSoundItem:setBgAltas(atlas, spriteName, width, height)
	self.bg:setAltas(atlas, spriteName);
	self.bg:SetDimensions(width, height);
end

function Lua_ChatSoundItem:onSoundBgClick(go)
	if self._data == nil then
		return;
	end
	if getTime() - self.sendTime < 2 then
		return;
	end
	self.sendTime = getTime();

	-- self:playVoiceEff();

	local msg = ProtoPublic_pb.Proto10200006();
	msg.channel = self._data.channel;
	msg.voice_id = self._data.voice_id;
	sendMsg(10200006, msg, 2);
end

-- 图片显隐
function Lua_ChatSoundItem:onVoicePlay(msg)
	if msg == nil or self._data == nil then
		return;
	end

	if self._data.type == Lua_ChatData.CHAT_TYPE_VOICE then
		if tonumber(tostring(self._data.voice_id)) == tonumber(tostring(msg)) then
			self:playVoiceEff();
		else
			self:endVoiceEff();
		end
	end
end

function Lua_ChatSoundItem:playVoiceEff()
	if tonumber(self._data.voice_len) > 0 then
		self:showOrHideVoiceEff(1);

		self.startTime = getTime();
		self.showIdx = 0;
		self:startVoiceEff();
		self:showVoiceEff();
	end
end

function Lua_ChatSoundItem:startVoiceEff()
	if self.onCountDown ~= true then
		self.onCountDown = true;
		Lua_CommonUtil.addTimer("Lua_ChatSoundItem", 0.3, self, self.showVoiceEff);
	end
end

function Lua_ChatSoundItem:showVoiceEff()
	local dt = getTime() - self.startTime;
	if dt >= tonumber(self._data.voice_len) then
		self:endVoiceEff();
	else
		self.showIdx = self.showIdx + 1;
		if self.showIdx > 3 then
			self.showIdx = 1;
		end
		self:showOrHideVoiceEff(self.showIdx);
	end
end

function Lua_ChatSoundItem:endVoiceEff()
	if self.onCountDown == true then
		self.onCountDown = false;
		self:showOrHideVoiceEff(3);
		Lua_CommonUtil.removeTimer(self, self.showVoiceEff);
	end
end

function Lua_ChatSoundItem:showOrHideVoiceEff(index)
	for i = 1, self.showIconArr:getSize() do
		self.showIconArr[i]:setEnable(i <= index);
	end
end

function Lua_ChatSoundItem:getWidth()
	return 195;
end

function Lua_ChatSoundItem:dispose()
	self:endVoiceEff();
	self:superCall("dispose");
end