checkRequire("Lua_ChatChanelIconItem");
checkRequire("Lua_ChatGiftItem");
checkRequire("Lua_ChatNoHeadVipItem");
Lua_ChatWithChanelItem = class("Lua_ChatWithChanelItem", Lua_DragContainerItem);
function Lua_ChatWithChanelItem:ctor(p, width, mouseEnble, isMini)
	self.type = 1;
	self.width = width -3;
	self.mouseEnble = mouseEnble;
	self.isMini = isMini;
	self:superCall("ctor", p); 
end

function Lua_ChatWithChanelItem:buildShowItem()
	self:superCall("buildShowItem"); 
	
	self.h = 0;
	self.infoItem = Lua_ChatInfoItem.new(self.content, self.width, self.mouseEnble);
	self.infoItem:setLocation(0, 0, 0);
end

function Lua_ChatWithChanelItem:setData(vo)
	self.infoItem:setChatData(vo);
	local str = vo:getMsg(true, true, self.isMini);
	local hasVip = false;
	if vo.role_id ~= nil and vo.role_id ~= 0 and vo.vip ~= nil and vo.vip ~= 0 then
		if self.vipIcon == nil then
			self.vipIcon = Lua_ChatNoHeadVipItem.new(self.content);
		end
		self.vipIcon:setEnable(true);
		self.vipIcon:setLocation(62, -6, 0);
		self.vipIcon:setVipLevel(vo.vip);
		str = "　 " .. str;
		hasVip = true;
	else
		self.infoItem:setLocation(0, 0, 0);
		if self.vipIcon ~= nil then
			self.vipIcon:setEnable(false);
		end
	end

	if vo.type == Lua_ChatData.CHAT_TYPE_VOICE then
		str = str.."/99  "..vo.voice_len.."s";
	end

	if vo.role_id == nil then
		self.infoItem.modelLabel.fontSize = 22;
		if self.chanelItem ~= nil then
			self.chanelItem:setEnable(false);
		end
	else
		self.infoItem.modelLabel.fontSize = 20;
		if self.chanelItem == nil then
			self.chanelItem = Lua_ChatChanelIconItem.new(self.content);
			self.chanelItem:setLocation(23, -9, 0);
		end
		self.chanelItem:setEnable(true);
		self.chanelItem:setChanle(vo.channel);
	end
	self.infoItem:setData(str);
	self.h = self.infoItem:getHeight() + (vo.role_id == nil and 15 or 9);

	if vo.type == Lua_ChatData.CHAT_TYPE_GIFT then -- 红包
		if self.giftItem == nil then
			self.giftItem = Lua_ChatGiftItem.new(self.content);
			self.giftItem:setScale(0.5, 0.5);
			if hasVip == true then
				self.giftItem:setLocation(80, -9, 0);
			else
				self.giftItem:setLocation(50, -9, 0);
			end
		end
	else
		if self.giftItem ~= nil then
			self.giftItem:dispose();
			self.giftItem = nil;
		end
	end
end

function Lua_ChatWithChanelItem:getHeight()
	return self.h;
end

function Lua_ChatWithChanelItem:dispose()
	if self.isDispose_2 ~= true then
		WindowMananger.getInstance():returnToPool(self.content.transform);
	end
	self:superCall("dispose");
end

function Lua_ChatWithChanelItem:onPlayerSoundClick()
  	self.infoItem:checkUrlClick();
end