checkRequire("Lua_BulletinConfigVo")
checkRequire("Lua_BulletinVo")
checkRequire("Lua_ChatData");
Lua_ChatProxy = class("Lua_ChatProxy");
function Lua_ChatProxy:ctor()
	self:superCall("ctor");
	DataCenter.chatData = Lua_ChatData.new();
	LuaUtil.addLuaMsg(80200001, self, self.returnPublicChatMsg);
	LuaUtil.addLuaMsg(80200002, self, self.onLaba);
	LuaUtil.addLuaMsg(80200003, self, self.returnPrivateChatMsg);
	LuaUtil.addLuaMsg(80200006, self, self.returnAutoBroadcasting);
	LuaUtil.addLuaMsg(80200007, self, self.onBroadcasting);
	LuaUtil.addLuaMsg(80200008, self, self.onSystemChatInfo);
	LuaUtil.addLuaMsg(80400116, self, self.onKuaFuServerInfo);
    LuaUtil.addLuaMsg(80401501, self, self.updataGangAnswerInfo);
	LuaUtil.addLuaMsg(80401502, self, self.onGangBroadInfo);

	Lua_MsgUtil.addEventListener("LUA_CONNECT_SUCCESS", self, self.onSocketConnected);

	MsgUtil.addEventListener(EventsDefine.CONNECT_CHAT_SERVER, self, self.onStartConnectChat);
	MsgUtil.addEventListener("ADD_CHECK_CHAT_SOCKET", self, self.onCheckChatSocket);
end

function Lua_ChatProxy:onStartConnectChat()
    local data = DataCenter.loginData:getAddress(201);
    ConnectionManager.getInstace():connectionSocket(Connection.CHAT_SOCKET, data.address, data.port, false, false);
end

function Lua_ChatProxy:onCheckChatSocket(val)
	if val == 1 then
		Lua_CommonUtil.addTimer("checkSocket", 2, self, self.onCheckSocket);
	else
		Lua_CommonUtil.removeTimer(self, self.onCheckSocket);
	end
end

function Lua_ChatProxy:onCheckSocket()
	if ConnectionManager.getInstace():isConnection(Connection.CHAT_SOCKET) == false then
		local data = DataCenter.loginData:getAddress(201);
		if data == nil then
			return;
		end
		ConnectionManager.getInstace():connectionSocket(Connection.CHAT_SOCKET, data.address, data.port, false, true);
	else
		sendMsg(10999999, nil, Connection.CHAT_SOCKET);
	end

	if PlayerData.getInstance().isKuaFuOpen == true then
		if ConnectionManager.getInstace():isConnection(Connection.KUAFU_SOCKET) == false then
			ConnectionManager.getInstace():connectionSocket(Connection.KUAFU_SOCKET, PlayerData.getInstance().kuafuServer, PlayerData.getInstance().kuafuPort, false, true);
		else
			sendMsg(10999999, nil, Connection.KUAFU_SOCKET);
		end
	end 
end

function Lua_ChatProxy:updataGangAnswerInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80401501();
        msg:ParseFromString(mp.data);
        DataCenter.chatData:updataGangAnswerInfo(msg);
        if DataCenter.roleData.sceneId==30101 and DataCenter.chatData.gangData.state~=0 and DataCenter.chatData.firstGangOpenWin==true then
            DataCenter.chatData.firstGangOpenWin=false;
            Lua_WindowUtil.openWin("Lua_ChatWindow", WinParam.ACTION_OPEN, 3);
        end
        Lua_MsgUtil.callFunc("CHAT_GANGANSWER_CHANGE");
    end
end
function Lua_ChatProxy:sendGangAnswer(str)
    local cmd = ProtoPublic_pb.Proto10401541();
    cmd.answer = tostring(str);
    sendMsg(10401541, cmd);
end
function Lua_ChatProxy:onGangBroadInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80401502();
        msg:ParseFromString(mp.data);
        Lua_CommonUtil.addTimer("deleyShowGangBroad", 0.8, self, self.deleyShowGangBroad, msg, 1);

    end
end
function Lua_ChatProxy:deleyShowGangBroad(msg)
    local chatVo = Lua_ChatVo.new();
    chatVo.type = Lua_ChatData.CHAT_TYPE_TEXT;
    chatVo.channel = Lua_ChatData.CHANEL_FACTION;
    chatVo.hideChannel = true;
    chatVo.content = msg.info;
    chatVo.shoutContent = msg.info;
    DataCenter.chatData:addChatMsg(chatVo);
    Lua_CommonUtil.removeTimer(self, self.deleyShowGangBroad);
end
function Lua_ChatProxy:onKuaFuServerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400116();
		msg:ParseFromString(mp.data);
		
		DataCenter.chatData.showKuaFu = msg.state;
		if msg.state == 1 then
			if getCVersion() >= 1255 then
				MsgUtil.callFunc("CONNECT_SOCKET", {type=3, serverName=msg.chat_ip, port=msg.chat_port, 
					session=msg.session_info.session, account=msg.session_info.account});
			else
				DataCenter.chatData.chat_ip = msg.session_info.chat_ip;
				DataCenter.chatData.chat_port = msg.session_info.chat_port;
				DataCenter.chatData.session = msg.session_info.session;
				DataCenter.chatData.account = msg.session_info.account;
				Lua_SocketManager.getInstace():connect(3, msg.chat_ip, msg.chat_port);
			end
		else
			if getCVersion() >= 1255 then
				MsgUtil.callFunc("CLOSE_ONE_SOCKET", {type=3});
			else
				Lua_SocketManager.getInstace():disconnect(3);
			end
		end
	end
end

function Lua_ChatProxy:onSocketConnected(o)
	if o == 3 then
		if getCVersion() < 1255 then
			local cmd = ProtoPublic_pb.Proto10200001();
	        cmd.account = DataCenter.chatData.account;
	        cmd.role_id = DataCenter.roleData.roleId;
	        cmd.session = DataCenter.chatData.session;
	        sendMsg(10200001, cmd, 3);
	    end
	end
end

function Lua_ChatProxy:onLaBaBack(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_LaBaInputWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_ChatProxy:returnPublicChatMsg(mp)
	local msg = ProtoPublic_pb.Proto80200001();
	msg:ParseFromString(mp.data);
	for i,v in ipairs(msg.content) do
		local isShield = DataCenter.chatData:getChanleShield(v.channel);
		if isShield == 0 then
			local chatVo = Lua_ChatVo.new();
			chatVo:fromServer(v);
			DataCenter.chatData:addChatMsg(chatVo);
		end
	end
end

function Lua_ChatProxy:returnPrivateChatMsg(mp)
	local msg = ProtoPublic_pb.Proto80200003();
	msg:ParseFromString(mp.data);
	for i,v in ipairs(msg.content) do
		local isShield = DataCenter.chatData:getChanleShield(v.channel);
		if isShield == 0 then
			local chatVo = Lua_ChatVo.new();
			chatVo:fromServer(v);
			DataCenter.chatData:addPrivateChatMsg(chatVo);
			DataCenter.friendData:setLastChatTime(v);

			if chatVo.role_id ~= DataCenter.roleData.roleId then
				local cmd = ProtoPublic_pb.Proto10100009();
			    cmd.role_id = chatVo.role_id;
			    cmd.type = 1;
			    if chatVo.type ~= 1 then
			    	cmd.content = "";
			    else
			    	cmd.content = chatVo.content;
			    end
			    sendMsg(10100009,cmd);
			else
				local cmd = ProtoPublic_pb.Proto10100009();
			    cmd.role_id = chatVo.target_id;
			    cmd.type = 1;
			    if chatVo.type ~= 1 then
			    	cmd.content = "";
			    else
			    	cmd.content = chatVo.content;
			    end
			    sendMsg(10100009,cmd);
			end
		end
	end
end

function Lua_ChatProxy:returnAutoBroadcasting(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end
	
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80200006();
		msg:ParseFromString(mp.data);
        local bcv = Lua_BulletinConfigVo.new(msg.shout_id);
        local shoutStr = bcv:parseContent(msg, 1);
        if bcv.notice == 1 then
            local bv = Lua_BulletinVo.new();
            bv.content = shoutStr;
            bv.priority = bcv.priority + (tostring(msg.role_id) == tostring(DataCenter.roleData.roleId) and 10000 or 0);
            bv.circle = bcv.times;
            bv.itemInfo = bcv.itemInfo;
            bv.display_horn = bcv.display_horn;
            Lua_WindowUtil.openWin("Lua_BulletinBoardSecWindow", WinParam.ACTION_OPEN, bv);
        end
        local str = bcv:parseContent(msg);
        local list = bcv.chatChanle;
        local len = list:getSize();
        for i = 1, len do
            if list[i] > 0 then
				local chatVo = Lua_ChatVo.new();
				chatVo.channel = list[i];
				chatVo.type = Lua_ChatData.CHAT_TYPE_TEXT;
				chatVo.role_id = 0;
				chatVo.content = str;
				chatVo.shoutContent = shoutStr;
				chatVo.itemInfo = bcv.itemInfo;
				DataCenter.chatData:addChatMsg(chatVo);
			end
        end
    end
end

function Lua_ChatProxy:onBroadcasting(mp)
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80200007();
		msg:ParseFromString(mp.data);
        local bv = Lua_BulletinVo.new();
        bv.content = msg.content;
        bv.priority = 20000;
        bv.circle = 1;
        Lua_WindowUtil.openWin("Lua_BulletinBoardWindow", WinParam.ACTION_OPEN, bv);
    end
end

function Lua_ChatProxy:onLaba(mp)
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80200002();
		msg:ParseFromString(mp.data);
        for i = 1, #msg.content do
            local bv = Lua_BulletinVo.new();
            bv.content = "[00E125]"..msg.content[i].name..":[-]"..msg.content[i].content;
            bv.priority = 1;
            bv.circle = 1;
            -- Lua_WindowUtil.openWin("Lua_LaBaWindow", WinParam.ACTION_OPEN, bv);
            Lua_WindowUtil.openWin("Lua_LaBaSecWindow", WinParam.ACTION_OPEN, bv);

            local cvo = Lua_ChatVo.new();
            cvo:fromServer(msg.content[i]);
            cvo.channel = Lua_ChatData.CHANEL_WORLD;
            DataCenter.chatData:addChatMsg(cvo);
        end
    end
end

-- 系统播报
function Lua_ChatProxy:onSystemChatInfo(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end
		
	if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto80200008();
		msg:ParseFromString(mp.data);
		local vo = DataCenter.chatData:getSystemChatVoById(msg.id);
		if vo ~= nil and vo:checkCanShow() == true then
			local bv = Lua_BulletinVo.new();
            bv.content = vo.shoutContent;
            bv.priority = 1;
            bv.circle = 1;
            bv.showTime = vo.showTime;
            Lua_WindowUtil.openWin("Lua_LaBaSecWindow", WinParam.ACTION_OPEN, bv);

            local chatVo = Lua_ChatVo.new();
		    chatVo.type = Lua_ChatData.CHAT_TYPE_TEXT;
		    chatVo.channel = Lua_ChatData.CHANEL_SYSTEM;
		    chatVo.role_id = 0;
		    chatVo.content = vo.content;
		    chatVo.shoutContent = vo.shoutContent;
		    DataCenter.chatData:addChatMsg(chatVo);
		end
    end
end