checkRequire("Lua_BitOperation");
Lua_ChatUtil = { };
Lua_ChatUtil.MAX_FACE_INDEX = 30;
Lua_ChatUtil.FACE_SPACE = "\u{00A0}\u{00A0}";
Lua_ChatUtil.SPACE = "\u{00A0}";
function Lua_ChatUtil.genChatString(str)
    local rs = Array();
    local startIndex = 0;
    local endIndex = 0;
    local lastStart = 1;
    while true do
        startIndex, endIndex = string.find(str, "/%d%d", endIndex + 1); -- /%d%d 表情
        if startIndex == nil then break end
        if lastStart < startIndex then
            rs:add(string.sub(str, lastStart, startIndex - 1));
        end
        rs:add(string.sub(str, startIndex, endIndex));
        lastStart = endIndex + 1;
    end
    local stringLen = string.len(str);
    if lastStart ~= stringLen then
        rs:add(string.sub(str, lastStart, stringLen));
    end
    return rs;
end
function Lua_ChatUtil.filterStr(str)
    if Lua_ChatUtil.filterStrFun == nil or Lua_ChatUtil.filterInstance == nil then
        initReflection();
        local t = typeof('FilterText');
        local func = tolua.getmethod(t, 'GetInstance');
        Lua_ChatUtil.filterInstance = func:Call()
        func:Destroy();
        func = nil;
        Lua_ChatUtil.filterStrFun = tolua.getmethod(t, 'GetFilterStr', typeof('System.String'), typeof('System.Int32'));
    end
    local con = Lua_ChatUtil.filterStrFun:Call(Lua_ChatUtil.filterInstance, str, 0)
    return con;
end
function Lua_ChatUtil.getChatLen(str, len)
    if Lua_ChatUtil.chatLenFun == nil then
        initReflection();
        local t = typeof('ChatUtil');
        Lua_ChatUtil.chatLenFun = tolua.getmethod(t, 'getFilterStr', typeof('System.String'), typeof('System.Int32'));
    end
    local con = Lua_ChatUtil.chatLenFun:Call(str, len);
    return con;
end
function Lua_ChatUtil.sendWordMsg(channel, str, xstr, checkLen, socketType)
    local cmd = ProtoPublic_pb.Proto10200002();
    cmd.type = 1;
    cmd.voice_len = 0;
    local vitem = DataCenter.chatData.showItemData;
    cmd.scontent = xstr;
    if DataCenter.chatData.showType ~= 0 and vitem ~= nil then
        if DataCenter.chatData.showType == 1 then
            local sa = Lua_StringArray.new();
            sa:writeInt(1);
            vitem:genContentString(sa);
            cmd.type = 5;
            cmd.scontent = sa.content;
        elseif DataCenter.chatData.showType == 2 then
            cmd.scontent = vitem.content;
            cmd.type = 5;
        end
    end
    if checkLen == true then
        str = Lua_ChatUtil.filterStr(str);
        str = Lua_ChatUtil.getChatLen(str, 100);
    end
    cmd.channel = channel;

    cmd.wcontent = str;
    sendMsg(10200002, cmd, socketType);
end

function Lua_ChatUtil.sendActivityWordMsg(channel, str, xstr, checkLen, socketType)
    local cmd = ProtoPublic_pb.Proto10400131();
    cmd.type = 1;
    cmd.voice_len = 0;
    if checkLen == true then
        str = Lua_ChatUtil.filterStr(str);
        str = Lua_ChatUtil.getChatLen(str, 100);
    end
    cmd.wcontent = str;
    cmd.channel = channel;
    cmd.scontent = xstr;
    sendMsg(10400131, cmd, socketType);
end
function Lua_ChatUtil.sendPrivateVoiceMsg(roleId)
    local voiceByte = ChatRecordSound.getInstance().soundByte;
    if voiceByte == nil then
        return;
    end
    local voiceTime = ChatRecordSound.getInstance().voiceTime;
    ChatRecordSound.getInstance():clear();
    if voiceTime < 2 then
        OperateAlert.show(LanUtil.getValue(120210));
        return;
    end
    local cmd = ProtoPublic_pb.Proto10200003();
    cmd.type = 2;
    cmd.voice_len = math.floor(voiceTime + 0.5);
    cmd.wcontent = "";
    cmd.dst_role_id = roleId;

    require 'tolua.reflection';
    tolua.loadassembly('Assembly-CSharp');
    tolua.loadassembly('mscorlib');
    local t = typeof('WriteByteArray');
    local wba = tolua.createinstance(t);
    local func = tolua.getmethod(t, 'writeInt32', typeof('System.Int32'));
    func:Call(wba, 1)
    func:Destroy();
    func = tolua.getmethod(t, 'writeByteList', typeof('System.Byte'):MakeArrayType());
    func:Call(wba, voiceByte)
    func:Destroy();

    func = tolua.getmethod(t, 'getBytes');
    local t2 = typeof(MsgPacket);
    local nnn = tolua.createinstance(t2);
    nnn.data = func:Call(wba);
    cmd.vcontent = nnn.data;
    func:Destroy();

    sendMsg(10200003, cmd, 2);
end
function Lua_ChatUtil.sendVoiceMsg(channel, str, socketType)
    local voiceByte = ChatRecordSound.getInstance().soundByte;
    if voiceByte == nil then
        return;
    end
    local voiceTime = ChatRecordSound.getInstance().voiceTime;
    ChatRecordSound.getInstance():clear();
    if voiceTime < 2 then
        OperateAlert.show(LanUtil.getValue(120210));
        return;
    end
    local cmd = ProtoPublic_pb.Proto10200002();
    local str1 = "";
    local vtype = 1;
    str1 = Lua_ChatUtil.filterStr(str1);
    str1 = Lua_ChatUtil.getChatLen(str1, 100);
    if voiceByte == nil then
        OperateAlert.show("没有声音数据");
        return;
    end
    cmd.type = 2;
    cmd.voice_len = math.floor(voiceTime + 0.5);
    cmd.wcontent = str1;
    cmd.channel = channel;

    require 'tolua.reflection';
    tolua.loadassembly('Assembly-CSharp');
    tolua.loadassembly('mscorlib');
    local t = typeof('WriteByteArray');
    local wba = tolua.createinstance(t);
    local func = tolua.getmethod(t, 'writeInt32', typeof('System.Int32'));
    func:Call(wba, vtype)
    func:Destroy();
    func = tolua.getmethod(t, 'writeByteList', typeof('System.Byte'):MakeArrayType());
    func:Call(wba, voiceByte)
    func:Destroy();

    func = tolua.getmethod(t, 'getBytes');
    local t2 = typeof(MsgPacket);
    local nnn = tolua.createinstance(t2);
    nnn.data = func:Call(wba);
    cmd.vcontent = nnn.data;
    func:Destroy();

    sendMsg(10200002, cmd, socketType);
end
function Lua_ChatUtil.isChatFace(str)
    local len = string.len(str);
    if len ~= 3 then
        return false;
    end
    local startIndex = 0;
    local endIndex = 0;
    startIndex, endIndex = string.find(str, "/%d%d", 1);
    if startIndex == nil then
        return false;
    end
    local num = tonumber(string.sub(str, 2, 3));
    if num >= 0 and(num <= Lua_ChatUtil.MAX_FACE_INDEX or num == 99) then
        return true;
    end
    return false;
end
function Lua_ChatUtil.checkChannelCanSend(channel)
    local lv = DataCenter.roleData.level;
    if channel == Lua_ChatData.CHANEL_WORLD then
        if lv < Lua_CommonUtil.getCommonConfig("world_chat_lv", 1) then
            OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110151), tostring(Lua_CommonUtil.getCommonConfig("world_chat_lv", 1))));
            return false;
        end
        return true;
    elseif channel == Lua_ChatData.CHANEL_FACTION then
        return true;
    elseif channel == Lua_ChatData.CHANEL_TEAM then
        return true;
    elseif channel == Lua_ChatData.CHANEL_QUYU then
        return true;
    end
    return false;
end

function Lua_ChatUtil.urlClickHandle(urlStr, itemData)
    if urlStr ~= nil then
        local arr = string.split(urlStr, "_");
        if arr[1] == "jointTeam" then
            local td = DataCenter.teamData;
            if td.hasTeam == true then
                OperateAlert.show(LanUtil.getValue(122230));
                return;
            end
            if arr:getSize() > 3 then
                local lv = DataCenter.roleData.level;
                local minLv = tonumber(arr[3]);
                local maxLv = tonumber(arr[4]);
                if lv < minLv or lv > maxLv then
                    OperateAlert.show(LanUtil.getValue(122260));
                    return;
                end
            end
            local rid = tonumber(arr[2]);
            if rid ~= DataCenter.roleData.roleId then
                local cmd = ProtoPublic_pb.Proto10100307();
                cmd.role_id = rid;
                sendMsg(10100307, cmd);
                OperateAlert.show(LanUtil.getValue(122247));
            end
        elseif arr[1] == "showItem" then
            -- 		local itemId = tonumber(arr[2]);
            Lua_PackUtil.showItemInfo(itemData);
        elseif arr[1] == "showMingSuo" then
            Lua_WindowUtil.openWin("Lua_MingSuoTipsWindow", WinParam.ACTION_OPEN, itemData);
        elseif arr[1] == "playerClick" then
            local rid = tonumber(arr[2]);
            local teamState = tonumber(arr[5]);
            local leagueName = tonumber(arr[6]);
            local roleName = arr[3];
            if rid ~= DataCenter.roleData.roleId then
                -- Lua_ChatUtil.onHeadClick(rid, teamState, leagueName);
                if arr[4] == nil or arr[4] == "1" then
                    Lua_ChatUtil.playerMenuPopListShow( { role_id = rid, team = teamState, league_name = leagueName, name = roleName });
                else
                    Lua_ChatUtil.playerMenuPopListShow( { role_id = rid, team = teamState, league_name = leagueName, name = roleName, isSameServer = 0 }, nil, nil, true);
                end
            else
                OperateAlert.show(LanUtil.getValue(120226));
            end
        elseif arr[1] == "itemClick" then
            -- local itemId = tonumber(arr[2]);
            local str = arr[2];
            if str ~= nil and itemData ~= nil and itemData.itemInfo ~= nil and itemData.itemInfo[str] ~= nil then
                local soul_id = itemData.itemInfo[str]["id"];
                local soul_level = itemData.itemInfo[str]["soul_level"];
                local config = itemData.itemInfo[str]["config"];
                local soul_type = config["type"]
                local subType = config["subType"]
                if soul_type == 8 and subType == Lua_PackTypeDefine.GATHERSOUL_ITEM then
                    -- 灵魂道具判断，用于广播点击显示Tips
                    local tvo = Lua_ToolVo.createToolVo(soul_id)
                    tvo.soul_level = soul_level;
                    tvo.isShowBtn = false;
                    Lua_PackUtil.showItemInfo(tvo);
                else
                    Lua_PackUtil.showItemInfo(itemData.itemInfo[str]);
                end
            end
        elseif arr[1] == "clickUrl" then
            local str = "";
            local len = arr:getSize();
            for i = 2, len do
                str = str .. arr[i];
                if i ~= len then
                    str = str .. "_";
                end
            end
            UnityEngine.Application.OpenURL(str);
        elseif arr[1] == "enterBossCopy" then
            local sid = tonumber(arr[2]);
            local hlCfg = getConfig( { "tv_god_scene" });
            local open_level = 0;
            local layerNum = 0;
            for k, v in ipairs(hlCfg) do
                if tonumber(v.scene_id) == sid and v.open_level ~= nil and DataCenter.roleData.level < tonumber(v.open_level) then
                    open_level = tonumber(v.open_level);
                    layerNum = tonumber(k);
                    break;
                end
            end
            if open_level > 0 and layerNum > 0 then
                OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121673), tostring(layerNum), tostring(open_level)));
                return;
            end
            DataCenter.bossData:sEnterBossScene(0, 0, 1, tonumber(arr[4]), tonumber(arr[3]), sid, false);
        elseif arr[1] == "openWin" then
            if arr[5] ~= nil and arr[6] ~= nil and(DataCenter.roleData.leagueId == "0" or DataCenter.roleData.leagueId == 0) then
                Lua_WindowUtil.openWin(arr[5] .. "_" .. arr[6]);
                return;
            end
            local openWinName = arr[2] .. "_" .. arr[3];
            local rtData = DataCenter.allRtData.topRightIconDic[10098];
            if openWinName == "Lua_PanGuWindow" and(rtData == nil or rtData.canShow == false) then
                OperateAlert.show(LanUtil.getValue(122586))
                return;
            end
            local rtData = DataCenter.allRtData.topRightIconDic[10112];
            if openWinName == "Lua_FestivalCarnivalWindow" and(rtData == nil or rtData.canShow == false) then
                OperateAlert.show(LanUtil.getValue(122586))
                return;
            end
            local awakeTaskData = DataCenter.allRtData.topRightIconDic[10108];
            if openWinName == "Lua_AwakeTaskWindow" and(awakeTaskData == nil or awakeTaskData.canShow == false) then
                OperateAlert.show(LanUtil.getValue(122586))
                return;
            end
            if openWinName == "Lua_SacredSkillWindow" then
                local id = tonumber(arr[4])
                local part = tonumber(arr[5])
                local skilData = Lua_ZhuLingUtil.getZhuLingSkillBySkillId(part, id)
                Lua_WindowUtil.openWin(openWinName, WinParam.ACTION_OPEN, skilData);
                return;
            end
            if openWinName == "Lua_YunBiaoWindow" then
                local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
                if sceneData.copy_type == 34 then
                    OperateAlert.show(LanUtil.getValue(122258));
                    return;
                end
                Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):goYunBiao();
            end
            local aData = DataCenter.OperationalActivitiesData:getActTypeByWindowName(openWinName);
            if aData ~= nil then
                local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(aData.f, aData.s);
                local rtData = DataCenter.allRtData:getIconByWindowName(openWinName);
                if avo == nil and rtData == nil then
                    OperateAlert.show(LanUtil.getValue(110646));
                    return;
                end
                if rtData == nil then
                    local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
                    if sceneData.show_server_name == 1 then
                        OperateAlert.show(LanUtil.getValue(122593));
                        return;
                    end
                else
                    if rtData == nil or rtData.canShow == false then
                        OperateAlert.show(LanUtil.getValue(122593));
                        return;
                    end
                end
                if rtData ~= nil and arr[4] == nil then
                    Lua_WindowUtil.openWin(arr[2] .. "_" .. arr[3], WinParam.ACTION_OPEN, { iconId = rtData.id });
                    return;
                end
            end

            if arr[5] ~= nil then
                Lua_WindowUtil.openWin(arr[2] .. "_" .. arr[3], WinParam.ACTION_OPEN, { openIdx = tonumber(arr[4]), nameIndex = tonumber(arr[5]) });
            else
                Lua_WindowUtil.openWin(arr[2] .. "_" .. arr[3], WinParam.ACTION_OPEN, tonumber(arr[4]));
            end
        end
    end

end

function Lua_ChatUtil.onHeadClick(rid, level)
    local menuTypes = Array();
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_CHECK_INFO, rid));
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_PRIVATE_CHAT, rid));
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND, rid));
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_TEAM, { rid, level }));
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_UNION, rid));
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_JOIN_BLACK, { role_id = rid, name = "" }));
    Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_OPEN, menuTypes);
end

-- 玩家弹框列表{role_id = 玩家id, team = 队伍id, league_name = 帮派名字,name=玩家名字}
function Lua_ChatUtil.playerMenuPopListShow(otherPlayerInfo, isCheckDeleteFriend, isMyBlack, isKuafu)
    if otherPlayerInfo == nil or otherPlayerInfo.role_id == nil then
        return;
    end

    local rid = otherPlayerInfo.role_id;
    if Lua_CommonUtil.trnsLongNum(rid) == Lua_CommonUtil.trnsLongNum(DataCenter.roleData.roleId) then
        OperateAlert.show(LanUtil.getValue(120226));
        return;
    end

    local menuTypes = Array();
    menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_CHECK_INFO, { rid = rid, isSameServer = otherPlayerInfo.isSameServer }));
    if isKuafu ~= true then
        menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_SEND_FLOWER, otherPlayerInfo));

        if DataCenter.friendData:isMyFriend(rid) == true then
            if isCheckDeleteFriend ~= nil and isCheckDeleteFriend == true then
                -- 删除好友
                menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_DELETE_FRIEND, otherPlayerInfo));
                -- else -- 私聊
                -- 	menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_PRIVATE_CHAT, rid));
            end
        else
            -- 添加好友
            if isMyBlack ~= nil and isMyBlack == true then
                menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND, { data = otherPlayerInfo, tipsWin = true }));
            else
                menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND, rid));
            end
        end


        if otherPlayerInfo.team ~= 0 and DataCenter.teamData.hasTeam == false then
            -- 加入队伍
            menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_REQ_JOIN_TEAM, rid));
        elseif otherPlayerInfo.team == 0 then
            -- 邀请组队
            menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_TEAM, rid));
        end

        -- 邀请入帮
        if DataCenter.roleData.leagueId ~= 0 and(otherPlayerInfo.league_name == nil or otherPlayerInfo.league_name == "") then
            menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_UNION, rid));
        end

        if DataCenter.friendData:isInBlack(rid) == false then
            menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_JOIN_BLACK, otherPlayerInfo));
        else
            menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_REMOVE_BLACK, rid));
        end
    end
    Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_OPEN, menuTypes);
end
function Lua_ChatUtil.replaceChatMsg(str)
    str = Lua_ChatUtil.fullToHalf(str);
    local restr = {
        { "一", "1" },{ "二", "2" },{ "三", "3" },{ "四", "4" },{ "五", "5" },{ "六", "6" },{ "七", "7" },{ "八", "8" },{ "九", "9" },{ "零", "0" },
        { "①", "1" },{ "②", "2" },{ "③", "3" },{ "④", "4" },{ "⑤", "5" },{ "⑥", "6" },{ "⑦", "7" },{ "⑧", "8" },{ "⑨", "9" },{ "⑩", "10" }
    };
    for i, v in ipairs(restr) do
        str = string.gsub(str, v[1], v[2]);
    end
    return str;
end
function Lua_ChatUtil.checkSendMsg(str)
    str = string.gsub(str, "/%d%d", "  ");
    local numcount = Lua_ChatUtil.findNumberCount(str);
    local worldcount = Lua_ChatUtil.findWorldCount(str);
    if numcount == worldcount then
        -- 纯数字
        if numcount >= 7 then
            return 1;
        else
            return 0;
        end
    else
        if worldcount >= 5 then
            return 2;
        else
            return 0;
        end
    end
end
function Lua_ChatUtil.findNumberCount(str)
    local num = 0;
    local index = 1;
    while true do
        local a = string.find(str, "%d", index);
        if a == nil then
            break;
        end
        index = a + 1;
        num = num + 1;
    end
    return num;
end
function Lua_ChatUtil.findWorldCount(str)
    local num = 0;
    local index = 1;
    while true do
        local a = string.find(str, "%w", index);
        if a == nil then
            break;
        end
        index = a + 1;
        num = num + 1;
    end
    return num;
end
-- 全角转半角
function Lua_ChatUtil.fullToHalf(str)
    local newStr = "";
    local pos = 1;
    while pos <= #str do
        local oneCount = Lua_ChatUtil.getOneCount(string.byte(str, pos));
        if oneCount == 3 then
            local char = string.sub(str, pos, pos + 2);
            local unicodeNum = Lua_ChatUtil.utf8ToNum(char);
            -- print(unicodeNum);
            if unicodeNum == 12288 then -- 全角空格
                unicodeNum = 32;
                nextStr = string.char(unicodeNum);
                pos = pos + oneCount;
            elseif unicodeNum >= 65281 and unicodeNum <= 65374 then -- 其它全角字符
                unicodeNum = unicodeNum - 65248;
                nextStr = string.char(unicodeNum);
                pos = pos + oneCount;
            else  -- 中文
                nextStr = string.sub(str, pos, pos);
                pos = pos + 1;
            end
        else
            nextStr = string.sub(str, pos, pos);
            pos = pos + 1;
        end
        newStr = newStr .. nextStr;
    end
    return newStr;
end
-- utf8转unicode有效码值
function Lua_ChatUtil.utf8ToNum(char)
    local num = 0;
    local pos = 1;
    while pos <= #char do
        local oneCount = Lua_ChatUtil.getOneCount(string.byte(char, pos));
        if oneCount < 1 then
            num = string.byte(char, pos);
            oneCount = 1;
        else
            boundary = 8;
            i = oneCount + 1;
            while i < boundary * oneCount do
                if i % boundary == 0 then -- 8位后处理下一字节，根据编码规则跳过首两位
                    i = i + 2;
                end                
                local weiCount = boundary - i % boundary; -- 一个字节的剩余位数
                local val1 = 2 ^(weiCount - 1);
                local val2 = string.byte(char, pos + math.floor(i / boundary)); -- 获取当前字节
                local newNum = Lua_BitOperation.lShift(num, 1); 
                if Lua_BitOperation.andOp(val1, val2) ~= 0 then -- 判断当前位是否为1
                    -- print(1)
                    num = Lua_BitOperation.orOp(newNum, 1);
                else
                    -- print(0)
                    num = newNum;
                end
                i = i + 1;
            end
        end
        pos = pos + oneCount;
    end
    return num;
end
-- 获取一个字节中，从最高位开始连续的1的个数
function Lua_ChatUtil.getOneCount(num)
    if nil == num then
        return -1
    end
    local count = 0
    while Lua_BitOperation.andOp(num, 0x80) ~= 0 do
        -- 和10000000进行与操作判断最高位是否为1
        count = count + 1
        num = Lua_BitOperation.lShift(num, 1);
    end
    return count
end