--披风数据类

checkRequire("Lua_CloakVo") -- vo
Lua_CloakData = class("Lua_CloakData");
function Lua_CloakData:ctor()
    self:superCall("ctor");
    self.cloakInfo = {};
    self.selectCloakId = nil;
    self.cloak_pink = 0;
    self.cloak_red = 0;
    self.cloak_orange = 0;
    self.cloak_purple = 0;
    self.hide_state = 0;
end

function Lua_CloakData:dispose()
    self.cloakInfo = {};
    self.calss_info = nil;
    self.selectCloakId = nil;
    self.cloak_pink = 0;
    self.cloak_red = 0;
    self.cloak_orange = 0;
    self.cloak_purple = 0;
    self.hide_state = 0;
end

-- 披风信息
function Lua_CloakData:fromServerInfo(msg)
    if msg == nil then
        return;
    end
    self.msg = msg;
    local list = msg.cloak_info;
    for k, v in ipairs(list) do
        local vo = Lua_CloakVo.new();
        vo:formServer(v);
        self.cloakInfo[tonumber(vo.cloak_id)] = vo;
    end
end

function Lua_CloakData:getIntensifySoulNum(color)--通过槽号 获取vo
    local list = {self.cloak_purple,self.cloak_orange,self.cloak_red,self.cloak_pink};
    return list[color-2];
end


function Lua_CloakData:getArrByCloakInfo(cloak_id)--通过槽号 获取vo
    if self.cloakInfo[tonumber(cloak_id)] ~= nil then
        return self.cloakInfo[tonumber(cloak_id)];
    end

    return nil;
end

-- 披风常量
function Lua_CloakData.Get:cloak_star() -- 披风星级
    return getConfig({"cloak_base", "cloak_star", "value"});
end

-- 背包大小
function Lua_CloakData.Get:pack_size() -- 披风星级
    return getConfig({"cloak_base", "pack_size", "value"});
end

-- 披风基础属性ID
function Lua_CloakData.Get:prop_id() -- 披风星级
    return getConfig({"cloak_base", "prop_id", "value"});
end

function Lua_CloakData:decompose(id) -- 分解
    local list = getConfig({"cloak_decompose",id,"decompose_item"});
    return list[2];
end

function Lua_CloakData.Get:selectClass(id) -- 选择大类,
    if self.calss_info == nil then
        self.calss_info = getConfig({"cloakClass"});
    end
    for i,v in ipairs(self.calss_info) do
        for j,k in ipairs(v.cloak_group_list) do
            if k == self.selectCloakId then
                return i;
            end
        end
    end
    return nil;
end

function Lua_CloakData.Get:selectGroup(id) -- 选择小类
    if self.calss_info == nil then
        self.calss_info = getConfig({"cloakClass"});
    end
    for i,v in ipairs(self.calss_info) do
        for j,k in ipairs(v.cloak_group_list) do
            if k == self.selectCloakId then
                return j;
            end
        end
    end
    return nil;
end

function Lua_CloakData:cloakResolveNum(arr,color) -- 分解获得总额
    local resolveNum = 0;
    for i=1,arr:getSize() do
        if arr[i].color == color then
            if arr[i].count > 1 then
                resolveNum = resolveNum + arr[i].decompose*arr[i].count;
            else
                resolveNum = resolveNum + arr[i].decompose;
            end
        end
    end
    return resolveNum;
end

function Lua_CloakData.Get:getCloakInfo()--用于 界面页签显示
    if self.calss_info == nil then
        self.calss_info = getConfig({"cloakClass"});
    end
    local arr = Array();
    arr:clear();
    for k,v in pairs(self.calss_info) do
        local list = v.cloak_group_list;
        local sub1 = Array();
        if list ~= nil then
            for i, j in pairs(list) do
                local _data = self:getArrByCloakInfo(j);
                sub1:add({name=_data.name, decName=_data.decName, specialNum = 1, data = _data}); 
            end 
        end 
        arr:add({name=v.cloak_class_name, specialNum = 1, sub=sub1});           
    end

    return arr;
end

function Lua_CloakData.Get:getCloakClassRed() --页签大类红点
    if self.calss_info == nil then
        self.calss_info = getConfig({"cloakClass"});
    end
    local redList = {}
    for k,v in pairs(self.calss_info) do
        for i, j in pairs(v.cloak_group_list) do
            local _data = self:getArrByCloakInfo(j);
            if _data.isShowActivatRed == true or _data.isShowUpgradeStarRed == true 
                or _data.isShowIntensifyRed == true or _data.isShowAdjoinRed == true then
                redList[k] = true;
            end
        end
    end
    return redList;
end

function Lua_CloakData.Get:getCloakSubRed() --页签子类红点
    if self.calss_info == nil then
        self.calss_info = getConfig({"cloakClass"});
    end
    local redList = {}
    for k,v in pairs(self.calss_info) do
        redList[k] = {};
        for i, j in pairs(v.cloak_group_list) do
            local _data = self:getArrByCloakInfo(j);
            if _data.isShowActivatRed == true or _data.isShowUpgradeStarRed == true 
                or _data.isShowIntensifyRed == true or _data.isShowAdjoinRed == true then
                redList[k][i] = true;
            end
        end
    end
    return redList;
end
----------------------------------------------------------------------------------------------------------------------------------------
-- 红点处理

-- 主界面  变强  红点  检测
function Lua_CloakData:checkCloakRedDotSate()
    
    if self:isShowCloakActivatRed() == true then   -- 激活
        self:isShowActivatIconRed(true);
    else
        self:isShowActivatIconRed(false);
    end

    if self:isShowCloakStarRed() == true then      -- 升星
        self:isShowStarIconRed(true);
    else
        self:isShowStarIconRed(false);
    end

    if self:isShowCloakResolveRed() == true then   -- 分解
        self:isShowResolveIconRed(true);
    else
        self:isShowResolveIconRed(false);
    end

    if self:isShowCloakAddRed() == true then       -- 附灵
        self:isShowAddIconRed(true);
    else
        self:isShowAddIconRed(false);
    end

    if self:isShowCloakIntensifyRed() == true then -- 强化
        self:isShowIntensifyIconRed(true);
    else
        self:isShowIntensifyIconRed(false);
    end

end

function Lua_CloakData:isShowCloakActivatRed() -- 界面激活按钮 红点显隐
    local list = self.cloakInfo;
    for i,v in pairs(list) do
        if v.isShowActivatRed == true then
            return true;
        end
    end

    return false;
end

function Lua_CloakData:isShowCloakStarRed() -- 界面升星按钮 红点显隐
    local list = self.cloakInfo;
    for i,v in pairs(list) do
        if v.isShowUpgradeStarRed == true then
            return true;
        end
    end

    return false;
end

function Lua_CloakData.Get:isHaceActivateCloak() -- 是否有激活 披风
    local list = self.cloakInfo;
    for i,v in pairs(list) do
        if v.activate == 1 then
            return true;
        end
    end

    return false;
end

function Lua_CloakData:isShowCloakResolveRed() -- 界面分解按钮 红点显隐
    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK); --背包
    local arr = bagData:getBagAllData();

    if self.isHaceActivateCloak ~= true then
        return false;
    end
    for i=1,arr:getSize() do
        if arr[i].subType == Lua_PackTypeDefine.CLOAK_RESOLVE_ITEM then
            return true;
        end
    end

    return false;
end

function Lua_CloakData:isShowCloakAddRed() -- 界面附灵按钮 红点显隐
    local list = self.cloakInfo;
    for i,v in pairs(list) do
        if v.isShowAdjoinRed == true then
            return true;
        end
    end

    return false;
end

function Lua_CloakData:isShowCloakIntensifyRed() -- 主界面  强化  红点处理
    local list = self.cloakInfo;
    for i,v in pairs(list) do
        if v.isShowIntensifyRed == true then
            return true;
        end
    end

    return false;
end

----------------------------------------------------------------------------------------------------------------------------------------
-- 变强处理

function Lua_CloakData:isShowResolveIconRed(bool) -- 分解 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22036, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22036, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22036, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22036, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_CloakData:isShowActivatIconRed(bool) -- 激活 变强事件 
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22037, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22037, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22037, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22037, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_CloakData:isShowIntensifyIconRed(bool) -- 强化 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22038, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22038, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22038, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22038, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_CloakData:isShowStarIconRed(bool) -- 升星 变强事件 
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22039, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22039, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22039, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22039, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_CloakData:isShowAddIconRed(bool) -- 附灵 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22040, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22040, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22040, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22040, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end


