Lua_MenuPopListData= class("Lua_MenuPopListData");
--悬浮菜单按钮类型
Lua_MenuPopListData.BTN_CHECK_INFO = "BTN_CHECK_INFO"; --查看信息
Lua_MenuPopListData.BTN_REQ_JOIN_TEAM = "BTN_REQ_JOIN_TEAM";	--申请入队
Lua_MenuPopListData.BTN_INVITE_TEAM = "BTN_INVITE_TEAM";	--邀请入队
Lua_MenuPopListData.BTN_ADD_FRIEND = "BTN_ADD_FRIEND";	--添加好友
Lua_MenuPopListData.BTN_FACTION_LIFTING_POS= "BTN_FACTION_LIFTING_POS";--提升帮派职位 
Lua_MenuPopListData.BTN_FACTION_LOWERING_POS= "BTN_FACTION_LOWERING_POS";--降低帮派职位 
Lua_MenuPopListData.BTN_FACTION_TRANSFER_LEADER = "BTN_FACTION_TRANSFER_LEADER";--移交帮主
Lua_MenuPopListData.BTN_FACTION_KICKOUT = "BTN_FACTION_KICKOUT";--踢出帮派
Lua_MenuPopListData.BTN_INVITE_UNION = "BTN_INVITE_UNION";	--邀请加盟
Lua_MenuPopListData.BTN_DELETE_FRIEND = "BTN_DELETE_FRIEND";	--删除好友
Lua_MenuPopListData.BTN_JOIN_BLACK = "BTN_JOIN_BLACK";	--加入黑名单
Lua_MenuPopListData.BTN_SEND_FLOWER = "BTN_SEND_FLOWER";	--送花
Lua_MenuPopListData.BTN_TRACKING = "BTN_TRACKING";	--追踪
Lua_MenuPopListData.BTN_REMOVE_BLACK = "BTN_REMOVE_BLACK";	--移出黑名单
Lua_MenuPopListData.BTN_PRIVATE_CHAT = "BTN_PRIVATE_CHAT";	--私聊
Lua_MenuPopListData.BTN_CHANGE_TEAM_LEADER = "BTN_CHANGE_TEAM_LEADER";	--移交队长
Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_LEADER = "BTN_CHANGE_KUAFU_TEAM_LEADER";	--移交3V3队长
Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_LEADER = "BTN_CHANGE_KUAFU_TEAM_KICKOUT";	--提出3v3战队
Lua_MenuPopListData.BTN_SUBMIT_EQU_TO_FACTION="BTN_SUBMIT_EQU_TO_FACTION";--上缴(装备到帮派)
Lua_MenuPopListData.BTN_OPEN_MARKET = "BTN_OPEN_MARKET";--打开市场界面
Lua_MenuPopListData.BTN_OPEN_FACTION_DEPOT = "BTN_OPEN_FACTION_DEPOT";--打开帮派仓库
Lua_MenuPopListData.BTN_FAST_FINISH_TASK = "BTN_FAST_FINISH_TASK";--快速完成任务
Lua_MenuPopListData.BTN_POOL_INVITE = "BTN_POOL_INVITE";-- 邀请上船
Lua_MenuPopListData.BTN_POOL_APPLY = "BTN_POOL_APPLY";  -- 申请上船
Lua_MenuPopListData.BTN_POOL_PLEASE_LEAVE = "BTN_POOL_PLEASE_LEAVE";-- 请离

function Lua_MenuPopListData:ctor(btnType,params,btnEnable)
	self.btnType = btnType;	--按钮类型
	self.params = params ;	--按钮点击时，回调的传参
	self.btnEnable = btnEnable == nil and true or false; -- 是否可点击（不可点击时，按钮应该置灰）
	self.owner = self;
	self.clickCallBack = self.clickCB;
end

function Lua_MenuPopListData:clickCB()
	if self.btnType == Lua_MenuPopListData.BTN_CHECK_INFO then
		self:onCheckInfoClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_REQ_JOIN_TEAM then
		self:onJoinTeamClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_INVITE_TEAM then
		self:onInviteTeamClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_ADD_FRIEND then
		self:onAddFriendClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_FACTION_LIFTING_POS then
		self:onFactionChangePos();
	elseif self.btnType == Lua_MenuPopListData.BTN_FACTION_LOWERING_POS then
		self:onFactionChangePos();
	elseif self.btnType == Lua_MenuPopListData.BTN_FACTION_TRANSFER_LEADER then
		self:onFactionTransferLeaderClick();	
	elseif self.btnType == Lua_MenuPopListData.BTN_FACTION_KICKOUT then
		self:onFactionKickoutClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_INVITE_UNION then
		self:onInviteUnionClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_DELETE_FRIEND then
		self:onDeleteFriendClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_JOIN_BLACK then
		self:onJoinBlackClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_SEND_FLOWER then
		self:onSendFlowerClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_TRACKING then
		self:onTrackingClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_REMOVE_BLACK then
		self:onRemoveBlackClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_PRIVATE_CHAT then
		self:onPrivateChatClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_CHANGE_TEAM_LEADER then
		self:onChangeTeamLeader();
	elseif self.btnType == Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_LEADER then
		self:onChangeKuaFuTeamLeader();
	elseif self.btnType == Lua_MenuPopListData.BTN_SUBMIT_EQU_TO_FACTION then
		self:submitEquToFaction();
	elseif self.btnType == Lua_MenuPopListData.BTN_OPEN_MARKET then
		self:onOpenMarketClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_OPEN_FACTION_DEPOT then
		self:onOpenFactionDepot();
	elseif self.btnType == Lua_MenuPopListData.BTN_FAST_FINISH_TASK then
		self:fastFinishTask();
	elseif self.btnType == Lua_MenuPopListData.BTN_POOL_INVITE then
		self:onPoolInviteClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_POOL_APPLY then
		self:onPoolApplyClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_POOL_PLEASE_LEAVE then
		self:onPoolPleaseLeaveClick();
	elseif self.btnType == Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_KICKOUT then
		self:onPoolPleaseKuaFuKickoutClick();
	end 
	Lua_MsgUtil.callFunc("MENU_POP_LIST_DISPOSE");
	Lua_WindowUtil.openWin("Lua_MenuPopListWindow",WinParam.ACTION_CLOSE);
end

function Lua_MenuPopListData:onPoolInviteClick() -- 邀请上船
	Lua_ProxyManager.getProxy("Lua_PoolPartyProxy"):sBoarding(2,self.params);
end

function Lua_MenuPopListData:onPoolApplyClick() -- 申请上船
	Lua_ProxyManager.getProxy("Lua_PoolPartyProxy"):sBoarding(1,self.params);
end

function Lua_MenuPopListData:onPoolPleaseLeaveClick() -- 请离
	Lua_ProxyManager.getProxy("Lua_PoolPartyProxy"):sDisembark(2,self.params);
end

function Lua_MenuPopListData:fastFinishTask()
	local tipData = {};
	local taskVo = DataCenter.taskData:getTaskById(self.params);
	
	local costGold = 1;
	if taskVo ~= nil then
		costGold = taskVo.fastFinishCostGold;
	end
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD,costGold,true,true) == false then
		return;
	end
	tipData.des = LanUtil.formateStr(LanUtil.getValue(122920),tostring(costGold));  
	tipData.owner = self;
	tipData.type = 1;
	tipData.taskId = self.params;
--	print("self.params "..tostring(self.params));
	tipData.subFun = self.confirmFastFinishTask;   --确定
	tipData.neverTip = Lua_NeverTipData.FAST_FINISH_LEAGUE_TASK;
	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.FAST_FINISH_LEAGUE_TASK) == false then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	else
		self:confirmFastFinishTask(tipData);
	end

end
function Lua_MenuPopListData:confirmFastFinishTask(tipData)
--	print("tipData.taskId "..tostring(tipData.taskId));
	DataCenter.taskData:fastFinishTask(tipData.taskId);
end

function Lua_MenuPopListData:onOpenFactionDepot()
	if DataCenter.roleData.leagueId ~= nil then
		Lua_WindowUtil.openWin("Lua_FactionMainWindow",WinParam.ACTION_OPEN,3);
		Lua_WindowUtil.openWin("Lua_FactionDepotWindow",WinParam.ACTION_OPEN);
	else
		OperateAlert.show(LanUtil.getValue(122920));
	end
end

function Lua_MenuPopListData:onOpenMarketClick()
	Lua_WindowUtil.openWin("Lua_MarketWindow",WinParam.ACTION_OPEN);
end

function Lua_MenuPopListData:submitEquToFaction()
	Lua_WindowUtil.openWin("Lua_SubmitEquToFactionWindow",WinParam.ACTION_OPEN,self.params);
end

function Lua_MenuPopListData:onCheckInfoClick()
	if type(self.params) == "table" then
      if self.params.isSameServer == 0 then
        local cmd = ProtoPublic_pb.Proto11400550();
        cmd.role_id = self.params.rid;
        sendMsg(11400550,cmd);
      else
        local cmd = ProtoPublic_pb.Proto10100156();
        cmd.role_id = self.params.rid;
        sendMsg(10100156,cmd);
      end
    else
      local cmd = ProtoPublic_pb.Proto10100156();
      cmd.role_id = self.params;
      sendMsg(10100156,cmd);
    end
end
 
function Lua_MenuPopListData:onJoinTeamClick()
	local msg = getProtoMsg("Proto10100307");
	msg.role_id = self.params;
	sendMsg(10100307,msg);
end

function Lua_MenuPopListData:onInviteTeamClick()
	local td = DataCenter.teamData;
	if td.hasTeam == false then
		OperateAlert.show(LanUtil.getValue(120224));
		return;
	end
	if td.isTeamFull == true then
		OperateAlert.show(LanUtil.getValue(122233));
		return;
	end
	local msg = getProtoMsg("Proto10100307");
	msg.role_id = self.params;
	sendMsg(10100307,msg);
end

function Lua_MenuPopListData:onAddFriendClick()
  if type(self.params) == "table" and self.params.tipsWin ~= nil and self.params.tipsWin==true then
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(120113),string.format("[ff0000]%s[-]",self.params.data.name));  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.addFriendDetermine;   --确定
	self.tempData=self.params.data;
	--tipData.cancelFun = self.onSubClick;  -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
  else
	local msg = getProtoMsg("Proto10100164");
    msg.friend_id = self.params;
    sendMsg(10100164,msg);
  end
end
function Lua_MenuPopListData:addFriendDetermine()
	local msg = getProtoMsg("Proto10100159");
	msg.role_id = self.tempData.role_id;
	msg.remove_type=0;
	sendMsg(10100159,msg);
end
function Lua_MenuPopListData:onFactionChangePos()
	local msg = getProtoMsg("Proto10100616");
	msg.role_index = self.params.roleId;
	msg.target_pos = self.params.pos;
	sendMsg(10100616,msg);
	
end


function Lua_MenuPopListData:onFactionTransferLeaderClick()
	
	local tipData = {};
--	print("self.params.roleName "..tostring(self.params.roleName));
	tipData.des = LanUtil.formateStr(LanUtil.getValue(121052),self.params.roleName);  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.transferLeader;   --确定
	self.tempData=self.params;	
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);

end
function Lua_MenuPopListData:transferLeader()
	local msg  = getProtoMsg("Proto10100618");
	msg.role_index = self.tempData.roleIndex;
	sendMsg(10100618,msg);
end
function Lua_MenuPopListData:onFactionKickoutClick()
	local tipData = {};
--	print("self.params.roleName "..tostring(self.params.roleName));
	tipData.des = LanUtil.formateStr(LanUtil.getValue(121051),self.params.roleName);  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.kickOutConfirm;   --确定
	self.tempData=self.params;	
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);

end
function Lua_MenuPopListData:kickOutConfirm()
	local msg = getProtoMsg("Proto10100617");
	msg.role_index = self.tempData.roleId;
	sendMsg(10100617,msg);
end

function Lua_MenuPopListData:onInviteUnionClick()
    local leagueId=DataCenter.roleData.leagueId;
	local msg = getProtoMsg("Proto10100609");
	msg.league_index = leagueId;
	msg.invitee = self.params;
	sendMsg(10100609,msg);
end
function Lua_MenuPopListData:onPoolPleaseKuaFuKickoutClick()
	local msg = getProtoMsg("Proto11405503");
	msg.remover_member_id = self.params;
	sendMsg(11405503,msg);
end
function Lua_MenuPopListData:onDeleteFriendClick()
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(120119),string.format("[ff0000]%s[-]",self.params.name));  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.deleteFriendDetermine;   --确定
	self.tempData=self.params;
	--tipData.cancelFun = self.onSubClick;  -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end
function Lua_MenuPopListData:deleteFriendDetermine(tipData)
	local msg = getProtoMsg("Proto10100152");
	msg.role_id:append(self.tempData.role_id);
	msg.src_friend_type = 1;
	sendMsg(10100152,msg);
end
function Lua_MenuPopListData:onJoinBlackClick()
	local tipData = {};
	if self.params.name == nil then
		tipData.des = LanUtil.formateStr(LanUtil.getValue(120112),string.format("[ff0000]%s[-]",self.params.role_name));  
	else
		tipData.des = LanUtil.formateStr(LanUtil.getValue(120112),string.format("[ff0000]%s[-]",self.params.name));  
	end
	
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.joinBlackDetermine;   --确定
	self.tempData=self.params;
	--tipData.cancelFun = self.onSubClick;  -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end
function Lua_MenuPopListData:joinBlackDetermine(tipData)
	local msg = getProtoMsg("Proto10100158");
	msg.role_id = self.tempData.role_id;
	sendMsg(10100158,msg);
end

function Lua_MenuPopListData:onSendFlowerClick()
 	Lua_WindowUtil.openWin("Lua_FriendSendFlowerWindow",nil,self.params)
end

function Lua_MenuPopListData:onTrackingClick()
end

function Lua_MenuPopListData:onRemoveBlackClick()
	local msg = getProtoMsg("Proto10100159");
	msg.role_id = self.params;
	msg.remove_type=1;
	sendMsg(10100159,msg);
end

function Lua_MenuPopListData:onPrivateChatClick()
	if DataCenter.funcOpenData:isOpened(10022, true) == false then
		return;
	end
	Lua_WindowUtil.openWin("Lua_MailBoxWindow", nil, {openIdx=1,data=tonumber(self.params)});
end

function Lua_MenuPopListData:onChangeTeamLeader()
	local msg = getProtoMsg("Proto10100303");
	msg.role_id = self.params;
	sendMsg(10100303,msg);
end
function Lua_MenuPopListData:onChangeKuaFuTeamLeader()
	local msg = getProtoMsg("Proto11405505");
	msg.captian_id = self.params;
	sendMsg(11405505,msg);
end
function Lua_MenuPopListData:dispose()
	self.owner = nil;
	self.params = nil;
	self.clickCallBack = nil;
end
function Lua_MenuPopListData.getBtnLabel(type)
	if type == Lua_MenuPopListData.BTN_CHECK_INFO then
		return LanUtil.getValue(107470);
	elseif type == Lua_MenuPopListData.BTN_REQ_JOIN_TEAM then
		return LanUtil.getValue(107471);
	elseif type == Lua_MenuPopListData.BTN_INVITE_TEAM then
		return LanUtil.getValue(107472);
	elseif type == Lua_MenuPopListData.BTN_ADD_FRIEND then
		return LanUtil.getValue(107473);
	elseif type == Lua_MenuPopListData.BTN_INVITE_UNION then
		return LanUtil.getValue(107474);
	elseif type == Lua_MenuPopListData.BTN_DELETE_FRIEND then
		return LanUtil.getValue(107475);
	elseif type == Lua_MenuPopListData.BTN_JOIN_BLACK then
		return LanUtil.getValue(107476);
	elseif type == Lua_MenuPopListData.BTN_SEND_FLOWER then
	    return LanUtil.getValue(107477);
	elseif type ==	Lua_MenuPopListData.BTN_FACTION_LIFTING_POS then
		return  LanUtil.getValue(107478);
	elseif type ==	Lua_MenuPopListData.BTN_FACTION_LOWERING_POS then
		return  LanUtil.getValue(107479);
	elseif type ==	Lua_MenuPopListData.BTN_FACTION_TRANSFER_LEADER then
		return  LanUtil.getValue(107480);
	elseif type ==	Lua_MenuPopListData.BTN_FACTION_KICKOUT then
		return  LanUtil.getValue(107481);
	elseif type == Lua_MenuPopListData.BTN_TRACKING then
	    return LanUtil.getValue(107482);
	elseif type == Lua_MenuPopListData.BTN_REMOVE_BLACK then
	    return LanUtil.getValue(107483);
	elseif type == Lua_MenuPopListData.BTN_PRIVATE_CHAT then
   	    return LanUtil.getValue(107599);
	elseif type == Lua_MenuPopListData.BTN_CHANGE_TEAM_LEADER then
		return LanUtil.getValue(122217);
	elseif type == Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_LEADER then
		return LanUtil.getValue(122217);
	elseif type == Lua_MenuPopListData.BTN_SUBMIT_EQU_TO_FACTION then
		return LanUtil.getValue(122915);
	elseif type == Lua_MenuPopListData.BTN_OPEN_MARKET then
		return LanUtil.getValue(122916);
	elseif type == Lua_MenuPopListData.BTN_OPEN_FACTION_DEPOT then
		return LanUtil.getValue(122917);
	elseif type == Lua_MenuPopListData.BTN_FAST_FINISH_TASK then
		return LanUtil.getValue(122918);
	elseif type == Lua_MenuPopListData.BTN_POOL_INVITE then
		return LanUtil.getValue(140818);
	elseif type == Lua_MenuPopListData.BTN_POOL_APPLY then
		return LanUtil.getValue(140819);
	elseif type == Lua_MenuPopListData.BTN_POOL_PLEASE_LEAVE then
		return LanUtil.getValue(140820);
	elseif type ==  Lua_MenuPopListData.BTN_CHANGE_KUAFU_TEAM_KICKOUT then
		return LanUtil.getValue(140317);
	end
end

