checkRequire("Lua_MenuPopListData");
Lua_MenuPopListWindow = class("Lua_MenuPopListWindow", Lua_Window);
function Lua_MenuPopListWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_MenuPopListWindow";
	self.w = 144;
	self.h = 251;
	self.isClickClose = false;
	self.isModel = true;
	self.showClose = false;
	self.blackAlpha = 0.02;
end

function Lua_MenuPopListWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showTime = getTime();
	self.btnShowList = Array();
	self.btnHideList = Array();

	self.bgSp = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_widget_srk", 0, 0, self.w, self.h);
	self.bgSp:setDepth(-1);

	self:addLuaEvent("MENU_POP_LIST_DISPOSE", self, self.removeAllBtnToPool);
	self:addLuaEvent("UPDATE_MENU_POP_LIST_POSITION", self, self.onUpdatePosition);
	self:addCSharpEvent("UICAMERA_CLICK", self, self.onCameraClick);
end

function Lua_MenuPopListWindow:onUpdatePosition(vec)
	self.content.transform.localPosition = vec;
end

function Lua_MenuPopListWindow:showWin(params)
	self:superCall("showWin", params);

	local upSpace = 10;
	self.h = params:getSize() * 48 + 2 * upSpace;
	self.bgSp:SetDimensions(self.w, self.h);
	self.bgSp:setLocation(self.w / 2, -self.h / 2);

	local menuData;
	local btnLab ;
	local tbtn;
	local len = params:getSize();
	for i = 1, len do
		menuData = params[i];
		btnLab = Lua_MenuPopListData.getBtnLabel(menuData.btnType);

		tbtn = self:createBtn();
		tbtn.name = "Button" .. i;
		tbtn.label = btnLab;
		if menuData.btnEnable == true then
			tbtn:setBtnEnable(true);
			if menuData.clickCallBack ~= nil then
				tbtn:addClickFuntion(menuData.owner, menuData.clickCallBack);
			end
		else
			tbtn:setBtnEnable(false);
		end
		tbtn:setLocation(self.w / 2, -1 * i * 48 + 48 / 2 - upSpace, 0);
		tbtn:setDepth(self.depth + 2);
	end
	
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(UnityEngine.Input.mousePosition);
	local winBase = ContainerUtil.getConainer("uiContainer");
	local winPos = winBase.transform:InverseTransformPoint(screenpos);
	local tw = winPos.x + self.w;
	if tw > MainWinDefine.V_width / 2 then
		tw = MainWinDefine.V_width / 2 - self.w;	
	else
		tw = winPos.x;
	end
	
	local th = winPos.y - self.h;
	if th < -1 * MainWinDefine.V_height / 2 then
		th = -1 * MainWinDefine.V_height / 2 + self.bgSp.height;
	else
		th = winPos.y;
	end
	-- self.content.transform.localPosition = Vector3(tw, th, 0);
	LuaUtil.setObjPos(self.content, tw, th, 0);
end

function Lua_MenuPopListWindow:onCameraClick(val)
	if getTime() - self.showTime < 0.5 then
		return;
	end
	self.showTime = getTime();

	local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.bgSp.mainContent.transform:InverseTransformPoint(screenpos);
	local hw = self.bgSp.width / 2;
	local hh = self.bgSp.height / 2;
	if mousePosition.x > hw or mousePosition.x < -hw or mousePosition.y < -hh or mousePosition.y > hh then
		self:hide();
	end
end

function Lua_MenuPopListWindow:createBtn()
	local tbtn;
	if self.btnHideList:getSize() > 0 then
		tbtn = self.btnHideList:remove(1);
	else
		tbtn =  UICreate.createButton(self.content, "", 0, 0, 120, 43);
		tbtn:setStyle(30);
		tbtn:setDepth(self.depth + 2);
	end
	tbtn.txt.colorStr = Lua_ColorDefine.transColor("FFFCB7");
	tbtn.txt.fontSize = 22;
	self.btnShowList:add(tbtn);
	return tbtn;
end

function Lua_MenuPopListWindow:removeAllBtnToPool()
	for i = 1, self.btnShowList:getSize() do
		self.btnShowList[i]:dispose();
	end

	for i = 1, self.btnHideList:getSize() do
		self.btnHideList[i]:dispose();
	end
	self.btnHideList:clear();
	self.btnShowList:clear();
end

function Lua_MenuPopListWindow:dispose()
	self:removeAllBtnToPool();
	self:superCall("dispose");
end