Lua_CopyInfoData = class("Lua_CopyInfoData");
function Lua_CopyInfoData:ctor()
	self:clear();
	self:clearCopyType();
end

function Lua_CopyInfoData:clearCopyType()
	self.script_type = 0;
	self.script_degree = 0;
	self.team_mate = 0;
end

function Lua_CopyInfoData:clear()
	self.cur_wave = 0;
	self.total_wave = 0;
	self.kill_monster = 0;
	self.total_monster = 0;
	self.finish_wave = 0;
	self.kill_special = nil;

	self.starStartTime = 0;
	self.cur_star = 0;
	self.left_time = 0;
	self.pause_last_time = 0;

	self.timeStartTime = 0;
	self.ready_tick = 0;
	self.left_tick = 0;
	self.extra_tick = 0;
	self.out_tick = 0;
	self.reward_tick = 0;

	self.total_exp = 0;

	self.percent = 0;
	self.inspire_buy = 0;
	self.inspire_amount = 0;
	self.copper_buy = 0;
	self.copper_amount = 0;
	self.gold_buy = 0;
	self.check_state = 0;

	self.used_times = 0;
	self.free_times = 0;
	self.total_times = 0;
	self.inside_circle = 0;
	self.pause_tick = 0;
	self.outside_circle = 0;
	self.cur_wheel = nil;
	self.wheel_record = nil;
	self.lastJuHunTime = -1;
	self.pause_start_time = 0;
	self.wave_time = 0;
	self.wave_start_time = 0;
	self.combine_times = 0;

	self.left_monster = 0;
	self.escape_monster = 0;
	self.slow_tick = 0;
	self.slow_wave = 0;

	self.isSlow = false;
	self.isAutoSlow = false;
end

function Lua_CopyInfoData:from80404101(msg)
	self.script_type = msg.script_type;
	self.script_degree = msg.script_degree;
	self.team_mate = msg.team_mate;
	self.copy_start_time = getTime();
	self.combine_times = msg.combine_times;
end

function Lua_CopyInfoData:from80404103(msg)
	self.cur_wave = msg.cur_wave;
	self.total_wave = msg.total_wave;
	self.kill_monster = msg.kill_monster;
	self.total_monster = msg.total_monster;
	self.finish_wave = msg.finish_wave;
	self.kill_special = msg.kill_special;
	self.left_monster = msg.left_monster;
	self.escape_monster = msg.escape_monster;
end

function Lua_CopyInfoData:from80404104(msg)
	self.starStartTime = getTime();
	self.cur_star = msg.cur_star;
	self.left_time = msg.left_time;
end

function Lua_CopyInfoData:from80404105(msg)
	self.timeStartTime = getTime();
	self.ready_tick = msg.ready_tick;
	self.left_tick = msg.left_tick;
	self.extra_tick = msg.extra_tick;
	self.out_tick = msg.out_tick;
	self.reward_tick = msg.reward_tick;
	self.wave_stop_tick = msg.wave_stop_tick;
	self.pause_last_time = 0;
end

function Lua_CopyInfoData:from80404107(msg)
	self.total_exp = msg.total_exp;
end

function Lua_CopyInfoData:from80404108(msg)
	self.nowTime = getTime();
	self.percent = msg.percent;
	self.inspire_buy = msg.inspire_buy;
	self.inspire_amount = msg.inspire_amount;
	self.copper_buy = msg.copper_buy;
	self.copper_amount = msg.copper_amount;
	self.gold_buy = msg.gold_buy;
	self.check_state = msg.liberty_state;
	self.slow_tick = msg.slow_tick;
	self.slow_wave = msg.slow_wave;

	if DataCenter.allRtData:getHasClick(10049) == false then
		if self.check_state == 0 then
			Lua_WindowUtil.openWin("Lua_CopyGuWuWindow", WinParam.ACTION_OPEN);
		else
			if (self.check_state ~= 3 and self.percent < 50) or (self.check_state == 3 and self.percent < 100) then
				Lua_WindowUtil.openWin("Lua_CopyGuWuWindow", WinParam.ACTION_OPEN);
			end
		end
		DataCenter.allRtData:setHasClick(10049);
		Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
	end
end

function Lua_CopyInfoData:from80404109(msg)
	self.used_times = msg.used_times;
	self.free_times = msg.free_times;
	self.total_times = msg.total_times;
	self.cur_wheel = msg.cur_wheel;
	self.wheel_record = msg.wheel_record;
	self.wave_time = msg.wave_end_tick;
	self.wave_start_time = getTime();
	if self.pause_start_time == 0 then
		if msg.pause_tick ~= 0 then
			self.pause_start_time = getTime();
		end
	else
		if msg.pause_tick == 0 then
			self.pause_last_time = self.pause_last_time + getTime() - self.pause_start_time;
			self.pause_start_time = 0;
		end
	end
	
	if msg.pause_tick ~= 0 then
		self.pause_tick = msg.pause_tick - 2;
	else
		self.pause_tick = msg.pause_tick;
	end
	self.lastJuHunTime = getTime();
end