checkRequire("Lua_CopyZodiacVo");
Lua_CopyVo = class("Lua_CopyVo");
function Lua_CopyVo:ctor(id)
	self.id = id;
	self.config = getConfig({"copy_main", id});
end

function Lua_CopyVo.Get:name()
	return self.config.name;
end

function Lua_CopyVo.Get:atlas()
	return self.config.atlas;
end

function Lua_CopyVo.Get:icon_name()
	return self.config.icon_name;
end

function Lua_CopyVo.Get:show_in_window()
	return self.config.show_in_window;
end

function Lua_CopyVo.Get:evenIds()
	return self.config.evenIds;
end

function Lua_CopyVo.Get:vip_index()
	return self.config.vip_index;
end

function Lua_CopyVo.Get:times()
	return self.config.times;
end

function Lua_CopyVo.Get:priority()
	return self.config.priority;
end

function Lua_CopyVo.Get:title_sp()
	return self.config.title_sp;
end

function Lua_CopyVo.Get:bg_name()
	return self.config.bg_name;
end

function Lua_CopyVo.Get:des()
	return self.config.des;
end

function Lua_CopyVo.Get:fight_tip()
	return self.config.fight_tip;
end

function Lua_CopyVo.Get:show_items()
	return self.config.show_items;
end

function Lua_CopyVo.Get:open_fun()
	return self.config.open_fun;
end

function Lua_CopyVo.Get:win_name()
	return self.config.win_name;
end

function Lua_CopyVo.Get:another_config()
	return self.config.another_config;
end

function Lua_CopyVo:getMateType(degree)
	local v = getConfig({self.another_config, 2000000 + 1000 * self.id + degree, "mate_type"});
	if v == nil then
		return 0;
	end
	return v;
end

function Lua_CopyVo.Get:output_des()
	if self.config.output_des == nil then
		return "";
	end
	return self.config.output_des;
end

function Lua_CopyVo.Get:cost_item()
	if self.config.cost_item == nil then
		return 0;
	end
	return self.config.cost_item[1][1];
end

function Lua_CopyVo.Get:cost_item_num()
	if self.config.cost_item == nil then
		return 0;
	end
	return self.config.cost_item[1][2];
end

function Lua_CopyVo.Get:day_time()
	if self.config.times == nil then
		return 1;
	end
	return self.config.times;
end

function Lua_CopyVo.Get:member_num()
	if self.config.member_num == nil then
		return 1;
	end
	return self.config.member_num;
end

function Lua_CopyVo.Get:degree_amount()
	if self.config.degree_amount == nil then
		return 3;
	end
	return self.config.degree_amount;
end

function Lua_CopyVo.Get:script_type()
	if self.config.script_type == nil then
		return 1;
	end
	return self.config.script_type;
end

function Lua_CopyVo.Get:open_lv()
	if self.config.open_level == nil then
		return 50;
	end
	return self.config.open_level;
end

function Lua_CopyVo.Get:prof_level()
	if self.config.prof_level == nil then
		return 0;
	end
	return self.config.prof_level;
end

function Lua_CopyVo:isOpened()
	if self.open_fun ~= nil then
		return DataCenter.funcOpenData:isOpened(self.open_fun, false);
	end
	return true;
end

function Lua_CopyVo.Get:showResultStar()
	local item = self.config.show_items;
	if item == nil then
		return false;
	end
	for i,v in ipairs(item) do
		if v == 1 then
			return true;
		end
	end
	return false;
end

function Lua_CopyVo:getDegressStar(val)
	if self.degressInfo == nil then
		return 0;
	end
	for i,v in ipairs(self.degressInfo) do
		if v.degree == val then
			return v.star;
		end
	end
	return 0;
end

function Lua_CopyVo:isDegressPass(dif)
	if self.degreeRecord == nil then
		return false;
	end
	return self.degreeRecord >= dif;
end

function Lua_CopyVo:getDegreeConfig(dif)
	local v = getConfig({ self.another_config, 2000000 + 1000 * self.script_type + dif });
	return v;
end

function Lua_CopyVo:getCleanStar(dif)
	local v = getConfig({ self.another_config, 2000000 + 1000 * self.script_type + dif });
	if v == nil then
		return 0;
	end
	if v.clean_star == nil then
		return 0;
	end
	return v.clean_star;
end

function Lua_CopyVo:getCleanVip(dif)
	local v = getConfig({ self.another_config, 2000000 + 1000 * self.script_type + dif });
	if v == nil then
		return 0;
	end
	if v.clean_vip == nil then
		return 0;
	end
	return v.clean_vip;
end

function Lua_CopyVo:getBuyTimeCostType()
	if self._costType == -1 then
		self:getBuyTimeCostList();
	end
	return self._costType;
end

function Lua_CopyVo:getBuyTimeCostList()
	if self.costList == nil then
		self.costList = Array();
		for i,v in ipairs(self.config.cost) do
			if v[1] ~= 0 then
				self.costList:add(v[1]);
				self._costType = Lua_MoneyData.GOLD;
			elseif v[2] ~= 0 then
				self.costList:add(v[2]);
				self._costType = Lua_MoneyData.BIND_GOLD;
			else
				self.costList:add(v[3]);
				self._costType = Lua_MoneyData.COPPER;
			end 
		end
	end
	return self.costList;
end

function Lua_CopyVo:getWavePos(dif, wave)
	if self.wavePosDic == nil then
		self.wavePosDic = {};
	end

	local waveName = dif.."_"..wave;
	if self.wavePosDic[waveName] == nil and self.wavePosDic[waveName] ~= 1 then
		local wave_script = "s20501";
		if self.id == Lua_CopyData.XIELING_COPY then
			wave_script = "s20601";
		end

		local t = getConfig({wave_script});
		for k,v in pairs(t) do
			if v.degree == dif and v.wave == wave then
				local p = v.point_coordxy[1];
				self.wavePosDic[waveName] = {x=p[1], y=p[2], z=p[3]};
				break;
			end
		end

		if self.wavePosDic[waveName] == nil then
			self.wavePosDic[waveName] = 1;
		end
	end
	return self.wavePosDic[waveName];
end

function Lua_CopyVo:getWaveClearWalls(dif, wave)
	if self.wallDic == nil then
		self.wallDic = {};
	end

	local waveName = dif.."_"..wave;
	if self.wallDic[waveName] == nil and self.wallDic[waveName] ~= 1 then
		local wave_script = "s20501";
		if self.id == Lua_CopyData.XIELING_COPY then
			wave_script = "s20601";
		end

		local t = getConfig({wave_script});
		for k,v in pairs(t) do
			if v.degree == dif and v.wave == wave then
				local p = v.clear_walls;
				if p ~= nil then
					self.wallDic[waveName] = p;
					break;
				end
			end
		end

		if self.wallDic[waveName] == nil then
			self.wallDic[waveName] = 1;
		end
	end
	return self.wallDic[waveName];
end

function Lua_CopyVo.Get:moneys()
	if self.config.moneys ~= nil then
		return self.config.moneys;
	end
	return nil;
end

function Lua_CopyVo:getEndTime(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "end_tick"});
	if v == 0 or v == nil then
		return 8;
	end
	return v;
end

function Lua_CopyVo:getDegreeName(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "name"});
	if v == nil then
		return self.name;
	end
	return v;
end

function Lua_CopyVo:getDegreeFightTips(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "degree_fight_tips"});
	if v == nil then
		return "";
	end
	return v;
end

-- 扫荡消耗
function Lua_CopyVo:getSaoDangCost(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree});
	return v.clean_cost;
end

-- 组队副本获取等级
function Lua_CopyVo:getCopyMinLv(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree});
	return v.open_level;
end

-- 玲珑副本获取保护npc
function Lua_CopyVo:getCopyProtectNpc(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree});
	return v.protect_npc;
end

-- 剩余次数
function Lua_CopyVo.Get:leftTimes()
	if self._leftTimes == nil then
		return 0;
	end
	return self._leftTimes;
end

function Lua_CopyVo.Set:leftTimes(val)
	if val == nil or val < 0 then
		val = 0;
	end
	self._leftTimes = val;
end

function Lua_CopyVo.Get:lang_id()
	if self.config.lang_id == nil then
		return 0;
	end
	return self.config.lang_id;
end

function Lua_CopyVo:getCollectionPriority(degree, objid)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree});
	local extra_monster = v.extra_monster;
	for i,v in ipairs(extra_monster) do
		if v[1] == objid then
			if v[3] ~= nil then
				return v[3];
			end
		end
	end
	return 0;
end

function Lua_CopyVo:getJunHunOutside(wave, index)
	if wave == 0 or index == 0 then
		return "";
	end

	local juhunMonster = getConfig({"s21001"});
	for k,v in pairs(juhunMonster) do
		if v.rand_index == index and v.wave == wave then
			return LanUtil.formateStr(LanUtil.getValue(121168),tostring(v.max_count));
		end
	end
	return "0";
end

function Lua_CopyVo:getJunHunInside(index)
	if index == 0 then
		return "";
	end

	local rs = getConfig({"rand_wheel", index, "desc"});
	if rs == nil then
		return tostring(index)
	end
	return rs;
end

function Lua_CopyVo:getCanCombine(degree)
	return self.config.can_combine == 1;
end

function Lua_CopyVo:getCombineCost(val, degree)
	if val <= 1 then
		return 0;
	end
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "combine_cost", val - 1, 2});
	return v;
end

function Lua_CopyVo:getCombineLevel(degree)
	local v = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "combine_level"});
	return v;
end

function Lua_CopyVo:setMatch(degree, num)
	if self.matchDic == nil then
		self.matchDic = {};
	end
	self.matchDic[degree] = num;
end

function Lua_CopyVo:getMatch(degree)
	if self.matchDic == nil then
		return 0;
	end
	if self.matchDic[degree] == nil then
		return 0;
	end
	return self.matchDic[degree];
end

function Lua_CopyVo:clearMatch()
	self.matchDic = {};
end

function Lua_CopyVo:getAllMonster(degree) -- 幻灵副本界面信息
	local arr = Array();
	local level = getConfig( { self.another_config, 2000000 + 1000 * self.id + degree, "level"});
	local cfg = getConfig( { self.another_config });
	if cfg ~= nil and level ~= nil then
		for k,v in pairs(cfg) do
			if v.level == level then
				local list = {};
				list.id = k; -- ID
				list.name = v.name; -- 难度名
				list.open_fightng = v.open_fightng; -- 开启战力
				list.reward = v.reward; -- 首通奖励
				list.monster_ID = v.monster_ID; -- 怪物ID
				list.monster_name = getConfig({"monster", v.monster_ID, "name"}); -- 怪物名
				list.monster_icon = getConfig({"monster", v.monster_ID, "head_src"}); -- 怪物头像
				arr:add(list);
			end
		end
	end
	arr:sort("id", false);
	return arr;
end

function Lua_CopyVo:getDegreeIndex(degree) -- 幻灵副本层数所在索引
	local arr = self:getAllMonster(degree);
	local len = arr:getSize();
	local id = 2000000 + 1000 * self.id + degree;
	for i = 1, len do
		if arr[i].id == id then
			return i;
		end
	end
	return nil;
end

function Lua_CopyVo.Set:degressInfo(val)
	self._degressInfo = val;
	self._zodiacInfoDic = nil;
end

function Lua_CopyVo.Get:degressInfo()
	return self._degressInfo;
end

-- 生肖副本
function Lua_CopyVo.Get:zodiacInfoDic()
	if self._zodiacInfoDic == nil then
		self._zodiacInfoDic = {};
		local vo = nil;
		local len = #self.degressInfo;
		for i,v in ipairs(self.degressInfo) do
			vo = self:getCopyZodiacVoById(2000000 + 1000 * self.id + v.degree);
			if vo ~= nil then
				vo.degree = v.degree;
				vo.isOpen = v.star; -- 1开启 0未开启
				if i == len then -- 生肖统领显示12生肖中最小的生肖之力
					vo.zodiacPower = self.minZodiacPower;
				else
					vo.zodiacPower = self.zodiac_power[i];
				end
				if vo.zodiac_type ~= nil then
					self._zodiacInfoDic[vo.zodiac_type] = vo;
				end
			end
		end
	end
	return self._zodiacInfoDic;
end

function Lua_CopyVo.Get:zodiacInfoArr()
	self._zodiacInfoArr = Array();
	self._zodiacInfoArr:clear();
	for i,v in ipairs(self.zodiacInfoDic) do
		self._zodiacInfoArr:add({ sortNum = v.isOpen, vo = v });
	end
	self._zodiacInfoArr:sort("sortNum", true);
	return self._zodiacInfoArr;
end

function Lua_CopyVo:updateCopyZodiacVo(_type, vo)
	vo.zodiacPower = self.zodiacInfoDic[_type].zodiacPower;
	self.zodiacInfoDic[_type] = vo;
end

function Lua_CopyVo:getCopyZodiacVoById(id)
	if self._copyZodiacVoDic == nil then
		self._copyZodiacVoDic = {};
	end
	if self._copyZodiacVoDic[id] == nil then
		local config = getConfig({ self.another_config, id });
		if config == nil then
			return nil;
		end
		local vo = Lua_CopyZodiacVo.new(id, config);
		self._copyZodiacVoDic[id] = vo;
	end
	return self._copyZodiacVoDic[id];
end

function Lua_CopyVo.Get:minZodiacPower()
	local min = 9999999999;
	for i,v in ipairs(self.zodiac_power) do
		if min > v then
			min = v;
		end
	end
	return min;
end

-- 击杀怪物提示
function Lua_CopyVo:getKillMonsterTip(degree)
	local v = getConfig({self.another_config, 2000000 + 1000 * self.id + degree});
	return v.kill_monster_tip;
end