-- 生肖副本Vo
Lua_CopyZodiacVo = class("Lua_CopyZodiacVo");
function Lua_CopyZodiacVo:ctor(id, config)
	self.id = id;
	if config == nil then
    	config = getConfig({ "zodiac_script", id });
    end
    self.config = config;

	self.isOpen = 0;
	self.zodiacPower = 0;
	self.degree = 0; -- 难度
end

-- 难度=阶数
function Lua_CopyZodiacVo.Get:rank()
	return self.config.degree;
end

function Lua_CopyZodiacVo.Get:name()
	return self.config.name;
end

function Lua_CopyZodiacVo.Get:remark()
	return self.config.remark;
end

-- 开启等级限制
function Lua_CopyZodiacVo.Get:open_level()
	return self.config.open_level;
end

-- 表示对应星期数开启该副本
function Lua_CopyZodiacVo.Get:open_day()
	return self.config.open_day;
end

-- 相冲的生肖类型
function Lua_CopyZodiacVo.Get:clash_zodiac()
	return self.config.clash_zodiac;
end

-- [生肖标识，升级所需生肖之力] 1鼠2马3牛4羊5虎6猴13全部生肖
function Lua_CopyZodiacVo.Get:upgrade()
	return self.config.upgrade;
end

-- 扫荡等级限制
function Lua_CopyZodiacVo.Get:clean_level()
	return self.config.clean_level;
end

-- 扫荡消耗
function Lua_CopyZodiacVo.Get:clean_cost()
	return self.config.clean_cost;
end

-- 奖励
function Lua_CopyZodiacVo.Get:reward()
	return self.config.reward;
end

-- 扫荡奖励
function Lua_CopyZodiacVo.Get:clean_reward()
	return self.config.clean_reward;
end

-- 生肖类型
function Lua_CopyZodiacVo.Get:zodiac_type()
	return self.config.zodiac_type;
end

-- 奖励展示
function Lua_CopyZodiacVo.Get:reward_show()
	return self.config.reward_show;
end

-- 生肖相冲信息
function Lua_CopyZodiacVo.Get:zodiac_desc()
	return self.config.zodiac_desc;
end

-- 模型ID
function Lua_CopyZodiacVo.Get:model_id()
	return self.config.model_id;
end

-- BOSS等级
function Lua_CopyZodiacVo.Get:boss_level()
	return self.config.boss_level;
end

function Lua_CopyZodiacVo.Get:atlasName()
	return self.config.atlasName;
end

function Lua_CopyZodiacVo.Get:iconName()
	return self.config.iconName;
end







-- 扫荡消耗Vo
function Lua_CopyZodiacVo.Get:cleanCostVo()
	local vo = Lua_ToolVo.createToolVo(self.clean_cost[1], self.clean_cost[2]);
	vo.haveNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.clean_cost[1]);
	return vo;
end

function Lua_CopyZodiacVo.Get:allSameZodiac()
	if self._allSameZodiac == nil then
		self._allSameZodiac = Array();

		local config = getConfig({ "zodiac_script" });
		for k,v in pairs(config) do
			if v.zodiac_type == self.zodiac_type then
				self._allSameZodiac:add({ id = k, data = v });
			end
		end
	end
	self._allSameZodiac:sort("id", false);
	return self._allSameZodiac;
end

-- 是否达到最大阶
function Lua_CopyZodiacVo.Get:isMaxDegree()
	if self.upgrade == nil then
		return true;
	end
	return false;
end

function Lua_CopyZodiacVo.Get:openDes()
	local openDes = "";
	if self.isOpen == 0 then
		local str = "";
		for i,v in ipairs(self.open_day) do
			str = str .. LanUtil.getValue(100 + v);
		end
		openDes = LanUtil.formateStr(LanUtil.getValue(143608), str);
	end
	return openDes;
end

function Lua_CopyZodiacVo.Get:powerName()
	-- 1鼠2马3牛4羊5虎6猴13全部生肖
	local str = "";
	if self.clash_zodiac ~= nil then
		if self.clash_zodiac == 13 then
			str = LanUtil.getValue(143606);
		else
			str = Lua_ThingDefine.getParamName(Lua_ThingDefine.zodiacParams[self.clash_zodiac]);
		end
	end
	return str;
end

function Lua_CopyZodiacVo.Get:rewardShowArr()
	if self._rewardShowArr == nil then
		self._rewardShowArr = Array();

		local arr = self.allSameZodiac;
		local len = arr:getSize();
		local list = nil;
		for i = 1, len do
			list = {};
			list.open_level = arr[i].data.boss_level;
			if i == 1 then
				list.power = 0;
			else
				list.power = arr[i - 1].data.upgrade[2];
			end
			list.rewards = self:getRewardShowById(arr[i].data.reward_show);
			self._rewardShowArr:add(list);
		end
	end
	self._rewardShowArr:sort("power", false);
	return self._rewardShowArr;
end

function Lua_CopyZodiacVo:getRewardShowById(id)
	local arr = Array();
	local config = getConfig({"rewards" , id, "client_goods_list"});
	for i,v in ipairs(config) do
		arr:add(Lua_ToolVo.createToolVo(v[1], v[2], v[3]));
	end
	return arr;
end

function Lua_CopyZodiacVo.Get:rewardArr()
	if self._rewardArr == nil then
		self._rewardArr = Array();
		local config = getConfig({"rewards" , self.reward[1], "client_goods_list"});
		for i,v in ipairs(config) do
			self._rewardArr:add(Lua_ToolVo.createToolVo(v[1], v[2], v[3]));
		end
	end
	return self._rewardArr;
end

function Lua_CopyZodiacVo.Get:isShowUpgradeRedDot()
	if self.isOpen == 0 then
		return false;
	end

	if self.isMaxDegree then
		return false;
	end

	if self.zodiacPower >= self.upgrade[2] then
		return true;
	end
	return false;
end