checkRequire("Lua_CopyData");
checkRequire("Lua_CopyInfoData");
Lua_CopyProxy = class("Lua_CopyProxy");
function Lua_CopyProxy:ctor()
	DataCenter.copyData = Lua_CopyData.new();
	DataCenter.copyInfoData = Lua_CopyInfoData.new();

	LuaUtil.addLuaMsg(50404101, self, self.onEnterCopyResult); -- 进入副本（返回）
	LuaUtil.addLuaMsg(50404102, self, self.onSingleCopyInfo); -- 副本信息（返回）
	LuaUtil.addLuaMsg(50404103, self, self.onCopySaoDangResult); -- 扫荡（返回）
	LuaUtil.addLuaMsg(50404104, self, self.onCopyTime); -- 副本次数（返回）
	LuaUtil.addLuaMsg(50404105, self, self.onAllInfo); -- 所有副本信息（返回）
	LuaUtil.addLuaMsg(50404108, self, self.onCopyBuffList); -- 提取buff列表（返回）
	LuaUtil.addLuaMsg(50404109, self, self.onCopyBuffGetResult); -- 获取buff（返回）
	LuaUtil.addLuaMsg(50404110, self, self.onGuWuBack); -- 副本鼓舞（返回）
	LuaUtil.addLuaMsg(50404111, self, self.onJuHunZhuanPanInfo); -- 转动轮盘（返回）
	LuaUtil.addLuaMsg(50404115, self, self.onYinYuanAskBuyTime); -- 请求伴侣购买副本次数（返回）
	LuaUtil.addLuaMsg(50404120, self, self.rCopyZodiacUpgrade); -- 生肖副本boss升级（返回）

	LuaUtil.addLuaMsg(80404101, self, self.onCopyStartInfo); -- 副本开始信息（通知）
	LuaUtil.addLuaMsg(80404102, self, self.onCopyEnd); -- 副本结算信息（通知）
	LuaUtil.addLuaMsg(80404103, self, self.onCopyMonsterInfo); -- 副本怪物信息（通知）
	LuaUtil.addLuaMsg(80404104, self, self.onCopyStarInfo); -- 副本星级信息（通知）
	LuaUtil.addLuaMsg(80404105, self, self.onCopyTimeInfo); -- 副本时间信息（通知）
	LuaUtil.addLuaMsg(80404107, self, self.onCopyExpInfo); -- 副本经验信息（通知）
	LuaUtil.addLuaMsg(80404108, self, self.onCopyGuWuInfo); -- 副本鼓舞信息（通知）
	LuaUtil.addLuaMsg(80404109, self, self.onCopyJuHunInfo); -- 副本轮盘信息（通知）
	LuaUtil.addLuaMsg(80404110, self, self.onYinYuanSelectedInfo); -- 副本默契考验信息（通知）

	LuaUtil.addLuaMsg(81400205, self, self.onQuitCopyToGuide); -- 事件触发通知
	LuaUtil.addLuaMsg(50100331, self, self.onCopyMatchNumber); -- 获取匹配人数（返回）

	Lua_MsgUtil.addEventListener("GET_COPY_BUFF", self, self.onGetCopyBuff);
	Lua_MsgUtil.addEventListener("OPEN_GAMEPLAY_UI", self, self.onOpenGamePlayerUI);
	Lua_MsgUtil.addEventListener("OPEN_COPY_UI", self, self.onOpenCopyUI);
	MsgUtil.addEventListener("SCENE_LOADED", self, self.onSceneLoaded);
end

function Lua_CopyProxy:onYinYuanNotBuyClick(data)
	local msg = ProtoPublic_pb.Proto10104102();
	msg.script_type = data.script_type;
	msg.count = 1;
	msg.reply = 0;
	sendMsg(10104102, msg);
end

function Lua_CopyProxy:onYinYuanBuyClick(data)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, data.cost.bind_gold, true, true) == false then
		return;
	end
	local msg = ProtoPublic_pb.Proto10104102();
	msg.script_type = data.script_type;
	msg.count = 1;
	msg.reply = 1;
	msg.cost.copper = data.cost.copper;
	msg.cost.gold = data.cost.gold;
	msg.cost.bind_gold = data.cost.bind_gold;
	msg.cost.bind_copper = data.cost.bind_copper;
	sendMsg(10104102, msg);
end

function Lua_CopyProxy:onGetCopyBuff(o)
	sendMsg(10404108);
end

function Lua_CopyProxy:sSlow(wave)
	local cmd = ProtoPublic_pb.Proto10404118();
	cmd.wave = wave;
	sendMsg(10404118, cmd);
end

function Lua_CopyProxy:sInspire(types)
	local cmd = ProtoPublic_pb.Proto10404110();
	cmd.type = types;
	sendMsg(10404110, cmd);
end

function Lua_CopyProxy:sSetAutoInspire(diamond_state, gold_state)
	local cmd = ProtoPublic_pb.Proto10404121();
	cmd.diamond_state = diamond_state and 1 or 0;
	cmd.gold_state = gold_state and 1 or 0;
	sendMsg(10404121, cmd);
end





function Lua_CopyProxy:onEnterCopyResult(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_CopyYinYuanWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyXieLingWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyJueXingWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyLingWenWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyMoneyWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyQiankunWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyShenLianWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyJunHunWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyZodiacWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_CopyProxy:onSingleCopyInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404102();
		msg:ParseFromString(mp.data);
		
		local copyVo = DataCenter.copyData:getCopyById(msg.script_type);
		copyVo.leftTimes = msg.left_times;
		copyVo.sum_times = msg.sum_times;
		copyVo.leftBuyTimes = msg.left_buy_times;
		copyVo.degressInfo = msg.script_info;
		copyVo.degreeRecord = msg.degree_record;
		copyVo.dailyReward = msg.daily_reward;
		copyVo.left_partner_buy = msg.left_partner_buy;
		copyVo.spectral_power = msg.spectral_power; -- 幻灵战力
		copyVo.zodiac_power = msg.zodiac_power; -- 生肖之力
		Lua_MsgUtil.callFunc("COPY_DATA_UPDATE");
	end
end

function Lua_CopyProxy:onCopySaoDangResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404103();
		msg:ParseFromString(mp.data);
		if msg.script_type == Lua_CopyData.JUHUN_COPY then
			Lua_WindowUtil.openWin("Lua_JuHunZhuanPanWindow", WinParam.ACTION_OPEN, {saoDang = 1, data = msg});
		else
			Lua_WindowUtil.openWin("Lua_CopySaoDangWindow", WinParam.ACTION_OPEN, msg);
		end
	end
end

function Lua_CopyProxy:onCopyTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404104();
		msg:ParseFromString(mp.data);
		local copyVo = DataCenter.copyData:getCopyById(msg.script_type);
		if copyVo ~= nil then
			-- copyVo.leftTimes = msg.left_times;
			-- copyVo.leftBuyTimes = msg.left_buy_times;
			Lua_MsgUtil.callFunc("COPY_DATA_UPDATE");
			OperateAlert.show(LanUtil.getValue(121140));
		end
	end
end

function Lua_CopyProxy:onAllInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404105();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.scripts) do
			local copyVo = DataCenter.copyData:getCopyById(v.script_type);
			if copyVo ~= nil then
				copyVo.leftTimes = v.left_times;
				copyVo.sumTimes = v.sum_times;
				copyVo.degreeRecord = v.degree;
				copyVo.leftBuyTimes = v.buy_times;
				copyVo.left_partner_buy = v.partner_buy_times;
			end
		end
		Lua_MsgUtil.callFunc("COPY_DATA_UPDATE");
	end
end

function Lua_CopyProxy:onCopyBuffList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404108();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_CopyBuffListWindow", WinParam.ACTION_OPEN, msg);
	end
end

function Lua_CopyProxy:onCopyBuffGetResult(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121127));
		Lua_WindowUtil.openWin("Lua_CopyBuffListWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_CopyProxy:onGuWuBack(mp)
	if mp.errno == 0 then
		local str = LanUtil.formateStr(LanUtil.getValue(121146),tostring(DataCenter.copyInfoData.percent));
		OperateAlert.show(str);
	else
		if not Lua_WindowUtil.isWindowShowing("Lua_CopyGuWuWindow") then
			Lua_WindowUtil.openWin("Lua_CopyGuWuWindow", WinParam.ACTION_OPEN);
		end
	end
end

function Lua_CopyProxy:onJuHunZhuanPanInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404111();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("JUNHUN_RESULT", msg);
	end
end

function Lua_CopyProxy:onYinYuanAskBuyTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404115();
		msg:ParseFromString(mp.data);

		local copyVo = DataCenter.copyData:getCopyById(msg.script_type);
		local tipData = {};
		tipData.des = LanUtil.formateStr(LanUtil.getValue(121174), tostring(msg.cost.bind_gold));
		tipData.owner = self;
		tipData.type = 1;
		tipData.cost = msg.cost;
		tipData.script_type = msg.script_type;
		tipData.cancelFun = self.onYinYuanNotBuyClick;
		tipData.subFun = self.onYinYuanBuyClick;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_CopyProxy:rCopyZodiacUpgrade(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50404120();
		msg:ParseFromString(mp.data);

		local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.ZODIAC_COPY);
		local zodiacVo = copyVo:getCopyZodiacVoById(2017000 + msg.degree);
		zodiacVo.degree = msg.degree;
		zodiacVo.isOpen = msg.is_open;
		copyVo:updateCopyZodiacVo(zodiacVo.zodiac_type, zodiacVo);
		Lua_MsgUtil.callFunc("COPY_DATA_UPDATE");
	end
end

function Lua_CopyProxy:onCopyStartInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404101();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404101(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyEnd(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404102();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_CopyYinYuanSelecteWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_CopyResultWindow", WinParam.ACTION_OPEN, msg);
		DataCenter.copyInfoData:clear();
		
		local taskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
		if taskList ~= nil and taskList:getSize()>0 then
			local tvo = taskList[1];
			if tvo.copyResultGuide ~= nil and tvo.copyResultGuide[1] == msg.script_type and tvo.copyResultGuide[2] == msg.script_degree then
				Lua_WindowUtil.openWin("Lua_GuideWindow", nil, tonumber(tvo.copyResultGuide[3]));
			end
		end
	end
end

function Lua_CopyProxy:onCopyMonsterInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404103();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404103(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
		Lua_MsgUtil.callFunc("JUHUN_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyStarInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404104();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404104(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyTimeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404105();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404105(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyExpInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404107();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404107(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyGuWuInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404108();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404108(msg);
		Lua_MsgUtil.callFunc("COPY_GUWU_INFO_UPDATE")
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
	end
end

function Lua_CopyProxy:onCopyJuHunInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404109();
		msg:ParseFromString(mp.data);
		DataCenter.copyInfoData:from80404109(msg);
		Lua_MsgUtil.callFunc("COPY_INFO_UPDATE");
		Lua_MsgUtil.callFunc("JUHUN_INFO_UPDATE");

		local info = DataCenter.copyInfoData;
		if info.script_type == Lua_CopyData.JUHUN_COPY then
			if info.pause_tick > 0 
				and Lua_WindowUtil.isWindowShowing("Lua_JuHunZhuanPanWindow") == false
				and info.cur_wave < 5 then
				Lua_WindowUtil.openWin("Lua_JuHunZhuanPanWindow", WinParam.ACTION_OPEN);
			end
		end
	end
end

function Lua_CopyProxy:onYinYuanSelectedInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404110();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_CopyYinYuanSelecteWindow", WinParam.ACTION_OPEN, msg);
	end
end

function Lua_CopyProxy:onQuitCopyToGuide(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81400205();
		msg:ParseFromString(mp.data);
		if msg.event_type == 1 then
			-- 首次从某场景出来（value）
			local sceneCfg = Lua_SceneConfigData.getSceneConfig(tonumber(msg.event_value));
			if sceneCfg ~= nil and sceneCfg.config ~= nil then
				local guideId = sceneCfg.config.quit_to_guide;
				if guideId ~= nil then
					DataCenter.guideData.needContinueTruck = true;
					Lua_WindowUtil.openWin("Lua_GuideWindow", nil, guideId);
				end
			end
		elseif msg.event_type == 0 then
			-- 首次进入某场景（value）
		end
	end
end

function Lua_CopyProxy:onCopyMatchNumber(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100331();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.mate_list) do
			local copyVo = DataCenter.copyData:getCopyById(tonumber(v.id));
			copyVo:setMatch(v.value, v.sub);
		end
		Lua_MsgUtil.callFunc("COPY_MATCH_NUMBER");
	end
end

function Lua_CopyProxy:onOpenGamePlayerUI(playId)
	if playId == nil then
		return;
	end

	local playVo = DataCenter.copyData:getCopyById(tonumber(playId));
	if playVo ~= nil then
		Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_OPEN, {openIdx = 1});
		Lua_WindowUtil.openWin(playVo.win_name, nil, playVo);
	end
end

function Lua_CopyProxy:onOpenCopyUI(playId)
	if playId == nil then
		return;
	end

	local playVo = DataCenter.copyData:getCopyById(tonumber(playId));
	if playVo ~= nil then
		Lua_WindowUtil.openWin("Lua_CopyWindow", WinParam.ACTION_OPEN, {openIdx = 1});
		Lua_WindowUtil.openWin(playVo.win_name, nil, playVo);
	end
end

function Lua_CopyProxy:onSceneLoaded()
	Lua_CommonUtil.addTimer("delayHook", 1, self, self.checkDelayHook, nil, 1);
end

function Lua_CopyProxy:checkDelayHook()
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneCfg ~= nil and sceneCfg.enterAutoHook == true then
		DataCenter.hook:start();
	end
end