Lua_CopyUtil = {};
function Lua_CopyUtil.sendGetCopyInfoMsg(copyId)
	local cmd = ProtoPublic_pb.Proto10404102();
	cmd.script_type = copyId;
	sendMsg(10404102, cmd);
	local copyVo = DataCenter.copyData:getCopyById(copyId);
	if copyVo.member_num == 3 then
		copyVo:clearMatch();
		local cmd = ProtoPublic_pb.Proto10100331();
		cmd.script_type = copyId;
		sendMsg(10100331, cmd);
	end
end

function Lua_CopyUtil.canEnterCopy(copyId, degree)
	local copyVo = DataCenter.copyData:getCopyById(copyId);
	if copyVo == nil then
		return false;
	end
	if degree > 1 and copyVo:isDegressPass(degree-1) == false then
		return false;
	end
	if copyVo:getCopyMinLv(degree) > DataCenter.roleData.level then
		return false;
	end
	return true;
end

function Lua_CopyUtil.enterCopy(copyId, degree, combineTime)
	--[[
	local copyVo = DataCenter.copyData:getCopyById(copyId);
	if degree > 1 and copyVo:isDegressPass(degree-1) == false then
		OperateAlert.show(LanUtil.getValue(121122));
		return;
	end
	if copyVo == nil then
		OperateAlert.show(LanUtil.getValue(121110));
		return;
	end
	if copyVo.leftTimes == nil or copyVo.leftTimes == 0 then
		OperateAlert.show(LanUtil.getValue(121111));
		return;
	end
	]]
	
	local cmd = ProtoPublic_pb.Proto10404101();
	cmd.script_type = copyId;
	cmd.script_degree = degree;
	if combineTime ~= nil then
		cmd.combine_times = combineTime;
	end
	sendMsg(10404101, cmd);
	--DataCenter.copyInfoData:clear();
end

function Lua_CopyUtil.saoDangCopy(copyId, degree)
	--[[
	local copyVo = DataCenter.copyData:getCopyById(copyId);
	if copyVo == nil then
		OperateAlert.show(LanUtil.getValue(121110));
		return;
	end
	if copyVo.leftTimes == nil or copyVo.leftTimes == 0 then
		OperateAlert.show(LanUtil.getValue(121111));
		return;
	end

	local vip = DataCenter.roleData.vipType;
	local needVip = copyVo:getCleanVip(degree);
	if needVip > vip then
        local name = getConfig( { "vip_level", needVip, "view_name"})
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121119),name));
		return;
	end

	local star = copyVo:getDegressStar(degree);
	local needStar = copyVo:getCleanStar(degree);
	if needStar > star then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121118), tostring(needStar)));
		return;
	end
	]]
	local cmd = ProtoPublic_pb.Proto10404103();
	cmd.script_type = copyId;
	cmd.script_degree = degree;
	cmd.times = 1;
	sendMsg(10404103, cmd);
	--DataCenter.copyInfoData:clear();
end

function Lua_CopyUtil.buyCopyTime(copyId, val)
	local cmd = ProtoPublic_pb.Proto10404104();
	cmd.script_type = copyId;
	cmd.times = val;
	sendMsg(10404104, cmd);
end

function Lua_CopyUtil.urlClickHandle(url)
	if url ~= nil then
		local arr = string.split(url, "_");
		if arr[1] == "goToStore" then
			Lua_WindowUtil.openWin("Lua_ShopWindow", nil, {openIdx = tonumber(arr[2]), itemID = tonumber(arr[3]),isShowEffectInFirst = true});
		end
	end
end

-- 生肖副本boss升级
function Lua_CopyUtil.bossUpgrade(degree)
	local cmd = ProtoPublic_pb.Proto10404120();
	cmd.zodiac_degree = degree;
	sendMsg(10404120, cmd);
end