-- 跨服充值/消费排行
checkRequire("Lua_CrossServerRechargeData");
Lua_CrossServerRechargeProxy = class("Lua_CrossServerRechargeProxy");
function Lua_CrossServerRechargeProxy:ctor()
	DataCenter.crossServerRechargeData = Lua_CrossServerRechargeData.new();

	LuaUtil.addLuaMsg(50105601, self, self.rRechargeInfo); -- 界面信息（返回）
	LuaUtil.addLuaMsg(50105602, self, self.rUpdateAwardInfo); -- 领取奖励（返回）
end

-- 界面信息（返回）
function Lua_CrossServerRechargeProxy:rRechargeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105601();
		msg:ParseFromString(mp.data);
		DataCenter.crossServerRechargeData:fromServer50105601(msg);
		Lua_MsgUtil.callFunc("UPDARE_RECHERGE_INFO");
	end
end

-- 更新领取奖励 （返回）
function Lua_CrossServerRechargeProxy:rUpdateAwardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105602();
		msg:ParseFromString(mp.data);
		DataCenter.crossServerRechargeData.acc_reward = msg.acc_reward;

		if msg.first_type == Lua_CrossServerRechargeData.ACT_RECHARGE then
			DataCenter.crossServerRechargeData.total_gold = msg.total_gold;
		end
		Lua_MsgUtil.callFunc("UPDARE_AWARD_INFO");
	end
end





-- 请求充值界面信息
function Lua_CrossServerRechargeProxy:sUseRechargeInfo()
	local cmd = ProtoPublic_pb.Proto10105601();
	cmd.first_type = Lua_CrossServerRechargeData.ACT_RECHARGE;
	sendMsg(10105601, cmd);
end

-- 请求消费界面信息
function Lua_CrossServerRechargeProxy:sUseConsumeInfo()
	local cmd = ProtoPublic_pb.Proto10105601();
	cmd.first_type = Lua_CrossServerRechargeData.ACT_CONSUME;
	sendMsg(10105601, cmd);
end

-- 请求充值玩家信息
function Lua_CrossServerRechargeProxy:sUseRechargePalyInfo(role_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10105603();
	cmd.role_id = role_id;
	cmd.server_flag = server_flag;
	cmd.first_type = Lua_CrossServerRechargeData.ACT_RECHARGE;
	sendMsg(10105603, cmd);
end

-- 请求消费玩家信息
function Lua_CrossServerRechargeProxy:sUseConsumePalyInfo(role_id, server_flag)
	local cmd = ProtoPublic_pb.Proto10105603();
	cmd.role_id = role_id;
	cmd.server_flag = server_flag;
	cmd.first_type = Lua_CrossServerRechargeData.ACT_CONSUME;
	sendMsg(10105603, cmd);
end

-- 领取充值奖励
function Lua_CrossServerRechargeProxy:sGetRechargeAwardeInfo(index)
	local cmd = ProtoPublic_pb.Proto10105602();
	cmd.index = tonumber(index);
	cmd.first_type = Lua_CrossServerRechargeData.ACT_RECHARGE;
	sendMsg(10105602, cmd);
end

-- 领取消费奖励
function Lua_CrossServerRechargeProxy:sGetConsumeAwardeInfo(index)
	local cmd = ProtoPublic_pb.Proto10105602();
	cmd.index = tonumber(index);
	cmd.first_type = Lua_CrossServerRechargeData.ACT_CONSUME;
	sendMsg(10105602, cmd);
end