checkRequire("Lua_Cus_SerData");
Lua_Cus_SerProxy = class("Lua_Cus_SerProxy");

function Lua_Cus_SerProxy:ctor()
    self:superCall("ctor");

    DataCenter.cur_serData = Lua_Cus_SerData.new();

    LuaUtil.addLuaMsg(50100901, self, self.rOpenPanel)
    LuaUtil.addLuaMsg(50100902, self, self.rCustomerSVCRecord)
    LuaUtil.addLuaMsg(50100903, self, self.rSubmitQuestion);
    --LuaUtil.addLuaMsg(80100901, self, self.rReadRecord);
    LuaUtil.addLuaMsg(50100905, self, self.rDeleteRecord);
end


--返回打开客服大界面
function Lua_Cus_SerProxy:rOpenPanel(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100901();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("OPEN_PANEL", msg);
	end
end

--返回打开客服界面-回复标签
function Lua_Cus_SerProxy:rCustomerSVCRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100902();
		msg:ParseFromString(mp.data);
	    DataCenter.cur_serData:fromServer(msg);
		Lua_MsgUtil.callFunc("REPLY_LABEL")
	end
end

--玩家提交客服记录
function Lua_Cus_SerProxy:rSubmitQuestion(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100903();
		msg:ParseFromString(mp.data);
		if msg.is_summit == 1 then
	 		OperateAlert.show(LanUtil.getValue(120609));
	 	elseif msg.is_summit == 0 then
	 		OperateAlert.show(LanUtil.getValue(120614));
	 	end
	end
end

--玩家阅读客服记录
function Lua_Cus_SerProxy:rReadRecord(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100901();
		msg:ParseFromString(mp.data);
		DataCenter.cur_serData:init80100901(msg);
	end
end

--玩家删除客服记录
function Lua_Cus_SerProxy:rDeleteRecord(mp)
	if mp.errno == 0 then
		DataCenter.cur_serData:sCustomerSVCRecord()
		OperateAlert.show(LanUtil.getValue(110055))
	end
end
