Lua_DailyRebateData = class("Lua_DailyRebateData");
function Lua_DailyRebateData:ctor()
    self:superCall("ctor");
end

function Lua_DailyRebateData:fromServer50105221(msg)
    self.days = msg.days;
    -- 已充值天数
    self.ex_reward = msg.ex_reward;
    -- 额外奖励
    self.reward = msg.reward;
    -- 奖励
    self.reward_state = msg.reward_state;
    -- 奖励状态 0未达成，1可领取，2已领取

end

function Lua_DailyRebateData:sDailyRebateInfo()
    -- 获取天天返利信息
    sendMsg(10105221)
end

function Lua_DailyRebateData:sGetReward(day)
    -- 领取奖励
    local cmd = ProtoPublic_pb.Proto10105220();
    cmd.index = day - 1;   
    sendMsg(10105220, cmd);
end

function Lua_DailyRebateData.Get:ex_rewardList()
    local ex_rewardArr = Array();
    local len=#self.ex_reward;
    for i=1,len do
        local list = { };
        local rewardVo = Lua_ToolVo.createToolVo(self.ex_reward[i].reward[1].id, self.ex_reward[i].reward[1].count, self.ex_reward[i].reward[1].bind);
        rewardVo:fromServer(self.ex_reward[i].reward[1])
        list.reward = rewardVo;
        list.day = self.ex_reward[i].day;
        list.curdays = self.days;
        list.isShowEffect = self.ex_reward[i].effect[1];
        ex_rewardArr:add(list);
    end
    return ex_rewardArr;
end

function Lua_DailyRebateData.Get:dailyRewardList()
    local dailyRewardArr = Array();
    local len=#self.reward
    for i=1,len do
        local list = { };
        local rewardLen=#self.reward[i].reward;
        local rewardArr = Array();
        for j=1,rewardLen do            
            local rewardVo = Lua_ToolVo.createToolVo(self.reward[i].reward[j].id, self.reward[i].reward[j].count, self.reward[i].reward[j].bind);
            rewardVo:fromServer(self.reward[i].reward[j])
            rewardArr:add(rewardVo);
        end
        list.reward = rewardArr;
        list.day = self.reward[i].day;
        list.isShowEffect = self.reward[i].effect;
        list.rewardState = self:getRewardState(list.day);
        dailyRewardArr:add(list);
    end
    return dailyRewardArr;
end

function Lua_DailyRebateData:getRewardState(day)
    return self.reward_state[day];
end

function Lua_DailyRebateData.Get:bestRewardName()
    local rewardId = self.ex_reward[#self.ex_reward].reward[1].id
    local name = getConfig({"item",rewardId,"name"});
    return name;
end