Lua_ReviveCountDownWindow = class("Lua_ReviveCountDownWindow", Lua_Window);
function Lua_ReviveCountDownWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ReviveCountDownWindow";
	self.skinName = "ReviveCountDownWindow_skin";
	self.blackAlpha = 0.5;
	self.showClose = false;
end

function Lua_ReviveCountDownWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.barIcon.type = UIBasicSprite.Type.Filled;
	self.barIcon.fillDirection = UIBasicSprite.FillDirection.Radial360;

	self.leftTimeNum = Lua_NumberImage.new(self.content);
	self.leftTimeNum.prefix = "f_";
	self.leftTimeNum.pivot = 2;
	self.leftTimeNum.numWidth = 44;
	self.leftTimeNum:setDepth(6);
	self.leftTimeNum:setLocation(9.5, 13, 0);
end

function Lua_ReviveCountDownWindow:showWin(param)
	self:superCall("showWin", param);

	self.config = param.config;
	self.startTime = getTime();
	Lua_CommonUtil.addTimer("Lua_ReviveCountDownWindow", 0.01, self, self.onCountDown);
	self:onCountDown();
end

function Lua_ReviveCountDownWindow:onCountDown()
	if self.config.test ~= true then -- 用于test
		if DataCenter.roleData.hp > 0 then
			self:hide();
			return;
		end
	end

	local pastTime = getTime() - self.startTime;

	local leftTime = 0;
	if self.config ~= nil and self.config.wait ~= nil then
		leftTime = self.config.wait - (getTime() - self.startTime);
	else
		if DataCenter.yunBiaoData.isOngoing then
			leftTime = getConfig({"convoy_const", "car_relive_time", "value"}) - pastTime;
		else
			leftTime = Lua_CommonUtil.getCommonConfig("relive_time", 1) - pastTime;
		end
	end

	if self.isFirst ~= true then
		self.isFirst = true;
		self.openTime = math.ceil(leftTime);
	end
	self.barIcon.fillAmount = leftTime / self.openTime;

	if leftTime <= 0 then
		if self.config ~= nil then
			if self.config.relive_type == 2 and self.config.free_local == 1 then
				self:relive(2);
			else
				self:relive(1);
			end
		else
			self:relive(1);
		end
	else
		self.leftTimeNum.num = math.ceil(leftTime);
		self.leftTimeNum:setNumScale(1.3, 1.3);
	end
end

function Lua_ReviveCountDownWindow:relive(reliveType)
	if self.config.test ~= true then
		local cmd = ProtoPublic_pb.Proto10400203();
		cmd.relive = reliveType; -- 1复活点复活 2原地复活 4随机点复活
		sendMsg(10400203, cmd);
	end
	self:hide();
end

function Lua_ReviveCountDownWindow:dispose()
	self.isFirst = false;
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end