--幻灵/星灵数据类

checkRequire("Lua_EidolonVo")
checkRequire("Lua_StarSpiritSkillVo")

Lua_EidolonData = class("Lua_EidolonData");
function Lua_EidolonData:ctor()
    self:superCall("ctor");
    self.eidolonInfo = {};
    self.selectIndex = 1;
    self.eidolonBtnSelectIndex = 1;
    self.eidolonItemSelectIndex = 1;
    self.selectItemId = nil;
    self.fantasy_soul_stone = 0;

    self.btnSelectedIndex = nil;-- 幻灵btn标记
end

function Lua_EidolonData:dispose()
    self.eidolonInfo = {};
    self.selectIndex = 1;
    self.eidolonBtnSelectIndex = 1;
    self.eidolonItemSelectIndex = 1;
    self.selectItemId = nil;
    self.btnSelectedIndex = nil;-- 幻灵btn标记
    self.fantasy_soul_stone = 0;
end

-- 幻灵数据
function Lua_EidolonData:fromServerEidolonInfo(msg)
    if msg == nil then
        return;
    end
    self.msg = msg;
    self.total_prop = msg.total_prop
    local list = msg.fantasy_soul;
    for k, v in ipairs(list) do
        local vo = Lua_EidolonVo.new(v.id);
        vo:formServer(v);
        self.eidolonInfo[tonumber(vo.id)] = vo;
    end

end

function Lua_EidolonData:getArrByEidolonInfo(id)-- 通过ID 获取vo
    if self.eidolonInfo[tonumber(id)] ~= nil then
        return self.eidolonInfo[tonumber(id)];
    end
end

function Lua_EidolonData:getArrByEidolonTypeInfo(_type)--通过类型 获取vo
    local arr = Array();
    if self.eidolonInfo == nil then
        return arr;
    end

    local eidolonInfo = self.eidolonInfo;
    for k,v in pairs(eidolonInfo) do
        if v.item_type == _type then
           arr:add(v);
        end
    end
    arr:sort("sort",false);
    return arr;
end

function Lua_EidolonData:updateEidolonVo(eidolonVo)--更新vo数据
    self.eidolonInfo[tonumber(eidolonVo.id)] = eidolonVo;
end

function Lua_EidolonData.Get:getAttName()--属性总览
    local str = "";
    if self.total_prop == nil then
        return str;
    end

    local attr = self.total_prop;
    self.arr = Array();
    for i,v in ipairs(attr) do
        if v.obj_value ~= 0 then
            self.arr:add(i)
            local s = getConfig( { "attr_name2", v.obj_id});
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end

            local _s = LanUtil.formateStr(s, tostring("[00E125]"..v.obj_value.."[-]"));
            str = str.."[B1CAF4]".._s.."[-]";
        end
    end
    return str;  
end

-- 幻灵总战力
function Lua_EidolonData.Get:getEidolonAllRore()
    if self.eidolonInfo == nil then
        return 0;
    end

    local eidolonInfo = self.eidolonInfo;
    local fore = 0;
    for k,v in pairs(eidolonInfo) do
        fore = fore + v.eidolonBaseForce
    end

    return fore;
end

------------------------------------------------------------------------------------------------------------------------------
-- 星灵数据

function Lua_EidolonData:fromServerSpiritInfo(msg)
    if msg == nil then
        return;
    end

    self.star_soul_lvl = msg.star_soul_lvl;     -- 星灵等级
    self.break_count = msg.break_count;         -- 突破次数
    self.pass_count = msg.pass_count;           -- 通关次数
    local star_soul_skill = msg.star_soul_skill;-- 星灵技能
    self.starSpiritArr = Array();
    self.starSpiritArr:clear();
    for i,v in ipairs(star_soul_skill) do
        local vo = Lua_StarSpiritSkillVo.new();
        vo:formServer(v);
        vo.index = i;
        self.starSpiritArr:add(vo);
    end
end

function Lua_EidolonData:star_spirit_lvl(index) -- 幻灵页签等级
    if self.isCanBreak ~= true then
        if self.break_count+1 == index then
            return self.star_soul_lvl%10;
        else
            return self.star_soul_lvl;
        end
    else
        return self.star_soul_lvl;
    end
end

function Lua_EidolonData.Get:isCanBreak() -- 是否可以突破
    if self.star_soul_lvl == nil or self.star_soul_lvl == 0 then
        return false;
    end

    if self.star_soul_lvl%10 == 0 then
        if self.star_soul_lvl/10 > self.break_count then
            return true;
        end
    end

    return false;
end

function Lua_EidolonData.Get:select_index() -- 星灵当前默认选择页签
    if self.break_count == 0 or self.break_count == nil then
        return self.selectIndex;
    end
    
    return self.break_count+1;
end

function Lua_EidolonData.Get:is_max_select_index() -- 是否选择最大页
    if self.break_count == 0 or self.break_count == nil then
        return false;
    end
    if self.break_count == DataCenter.eidolonUtil.starSpiritMaxIndex then
        return true;
    end
    return false;
end

-- 属性封装
function Lua_EidolonData.Get:starSpiritBaseProp() -- 星灵基础属性封装
    local str = "";
    if self.star_soul_lvl == nil then
        return str;
    end

    local id = self.star_soul_lvl;
    for k,v in ipairs(Lua_ThingDefine.params) do
        if id == 0 then
            local val = getConfig({"star_soul", id+1, v});
            if val ~= nil then
                if str == "" then
                    str = "";
                else
                    str = str.."\n";
                end

                local base = "0";
                if Lua_ThingDefine.isPercentParam(v) then
                    base = base.."%";
                end
                local s = "[3f6180]"..Lua_ThingDefine.getParamName(v)..":".."[-]"
                .."[192e41]"..base.."[-]";
                str = str..s;
            end
        else
            local val = getConfig({"star_soul", id, v});
            if val ~= nil then
                if str == "" then
                    str = "";
                else
                    str = str.."\n";
                end
                
                local base = val;
                if Lua_ThingDefine.isPercentParam(v) then
                    base = base.."%";
                end
                local s = "[3f6180]"..Lua_ThingDefine.getParamName(v)..":".."[-]"
                .."[192e41]"..base.."[-]";
                str = str..s;
            end
        end
    end
    return str;
end

function Lua_EidolonData.Get:starSpiritNexteProp() -- 星灵下级属性封装
    local str = "";
    if self.star_soul_lvl == nil then
        return str;
    end

    local id = self.star_soul_lvl;
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"star_soul", id+1, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            local base;
            local val1;
            if id == 0 then
                val1 = 0;
            else
                val1 = getConfig({"star_soul", id, v});
            end
            base = val - val1;
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end
            local s = base;
            str = str..s;
        end
    end
    return str;
end

function Lua_EidolonData.Get:starSpiritForce() -- 晶灵战力
    local id = self.star_soul_lvl;
    if id == nil or id == 0 then
        return 0;
    end

    local list = {};
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"star_soul", id, v});
        if val ~= nil then
            list[v] = val;
        end
    end

    return Lua_FightUtil.caculateConfigForce(list);
end

----------------------------------------------------------------------------------------------------------------------------------------
-- 红点处理

-- 界面btn页签红点
function Lua_EidolonData:isShowBtnEidolonRed(_type)

    if self.eidolonInfo == nil then
        return false;
    end

    local eidolonInfo = self.eidolonInfo;
    for k,v in pairs(eidolonInfo) do
        if v.item_type == _type then
            if v.checkEidolonItemRed == true then
                return true;
            end
        end
    end

    return false;
end

--分解  红点处理
function Lua_EidolonData:isShowEidolonResolveRed()
    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.EIDOLON_ITEM});
    local len = arr:getSize();

    if arr ~= nil and len >0 then
        return true;
    end

    return false;
end

--灵晶升级  红点处理
function Lua_EidolonData.Get:isShowStarUpGardRed()
    if self.pass_count > self.star_soul_lvl then
        return true;
    end
    return false;
end
