-- 星灵技能数据

Lua_StarSpiritSkillVo = class("Lua_StarSpiritSkillVo")
function Lua_StarSpiritSkillVo:ctor()
    self:superCall("ctor");
end

function Lua_StarSpiritSkillVo:formServer(obj)
	if obj == nil then
		return;
	end

	self.id = obj.skill_id;   -- 技能id
	self.lvl = obj.skill_lvl; -- 技能等级
    self.activate = obj.activation_state;-- 激活状态
end

function Lua_StarSpiritSkillVo.Get:skillVo() -- vo
    local vo = Lua_SkillVo.new(self.id);
    if vo == nil then
        return nil;
    end
    return vo;
end

function Lua_StarSpiritSkillVo.Get:skill_level()
    if self.activate == 0 then
    	return self.lvl +1;
    else
    	return self.lvl;
    end
end

function Lua_StarSpiritSkillVo.Get:skill_type() -- 技能类型  1主动 4被动
	return tostring(LanUtil.getValue(142013));
end

function Lua_StarSpiritSkillVo.Get:max_skill_level()
	return #DataCenter.eidolonUtil.star_skill_break;
end

function Lua_StarSpiritSkillVo.Get:is_max_lvl()
	if self.skill_level >= self.max_skill_level then
		return true;
	end

	return false;
end

function Lua_StarSpiritSkillVo.Get:getBackLvl() -- 突破等级
	local num = DataCenter.eidolonData.break_count;
	if num == nil then
		return
	end
	local lvl = DataCenter.eidolonUtil.star_skill_break[num+1];
	if self.activate == 0 then
		return LanUtil.formateStr(LanUtil.getValue(142012),tostring(lvl));
	else
		return LanUtil.formateStr(LanUtil.getValue(142014),tostring(lvl));
	end
end

function Lua_StarSpiritSkillVo.Get:base_des() -- 技能属性描述
	local detail = self.skillVo:getCurPercent(self.skill_level);
	local bloodPercent = self.skillVo:getCurBloodPercent(self.skill_level);

	return LanUtil.formateStr(self.skillVo.des, tostring(bloodPercent), tostring(detail));
end

function Lua_StarSpiritSkillVo.Get:next_des() -- 军魂技能下级属性描述
	local detail = self.skillVo:getCurPercent(self.skill_level+1);
	local bloodPercent = self.skillVo:getCurBloodPercent(self.skill_level+1);

	return LanUtil.formateStr(self.skillVo.des, tostring(bloodPercent), tostring(detail));
end



