--幻灵/星灵

checkRequire("Lua_EidolonData");
checkRequire("Lua_EidolonUtil");
Lua_EidolonProxy = class("Lua_EidolonProxy");
function Lua_EidolonProxy:ctor()
	self:superCall("ctor");
    DataCenter.eidolonData = Lua_EidolonData.new();
    DataCenter.eidolonUtil = Lua_EidolonUtil.new();
	
	LuaUtil.addLuaMsg(51401860, self, self.rOpenEidolonPanelInfo);   -- 获取幻灵面板信息（返回
    LuaUtil.addLuaMsg(51401861, self, self.rEidolonActivationInfo);  -- 激活
    LuaUtil.addLuaMsg(51401862, self, self.rEidolonIntensifyInfo);   -- 强化
    LuaUtil.addLuaMsg(51401863, self, self.rEidolonUpgradeStarInfo); -- 升星
    LuaUtil.addLuaMsg(51401864, self, self.rEidolonResolveInfo);     -- 分解
    LuaUtil.addLuaMsg(51401866, self, self.sEidolonStateEff);        -- 特效
    LuaUtil.addLuaMsg(51401865, self, self.rOpenStarSpiritPanelInfo);-- 获取星灵面板信息（返回）
end

-----------------------------------------------------------------------------------
-- 上行消息号 

-- 获取幻灵面板信息
function Lua_EidolonProxy:sOpenEidolonPanelInfo()
    sendMsg(11401860);
end

-- 激活幻灵
function Lua_EidolonProxy:sActivationEidolon(color,id)
    local cmd = ProtoPublic_pb.Proto11401861();
    cmd.color = color;
    cmd.id = id;
    sendMsg(11401861, cmd);
end

-- 强化幻灵
function Lua_EidolonProxy:sIntensifyEidolon(color,id)
    local cmd = ProtoPublic_pb.Proto11401862();
    cmd.color = color;
    cmd.id = id;
    sendMsg(11401862, cmd)
end

-- 升星幻灵
function Lua_EidolonProxy:sUpgradeStarEidolon(color,id)
    local cmd = ProtoPublic_pb.Proto11401863();
    cmd.color = color;
    cmd.id = id;
    sendMsg(11401863, cmd)
end

-- 分解幻灵
function Lua_EidolonProxy:sResolveEidolon(list)
    local cmd = ProtoPublic_pb.Proto11401864();
    for i = 1, list:getSize() do
        cmd.item_index:append(list[i].index);
    end
    sendMsg(11401864, cmd);
end

-- 获取星灵面板信息
function Lua_EidolonProxy:sOpenStarSpiritPanelInfo()
    sendMsg(11401865);
end

-- 升级星灵
function Lua_EidolonProxy:sUpgradeStarSpirit(type)
    local cmd = ProtoPublic_pb.Proto11401866();
    cmd.type = type;      -- 1升级 2突破
    sendMsg(11401866, cmd)
end



-----------------------------------------------------------------------------------
-- 下行消息

-- 获取星灵面板信息（返回）
function Lua_EidolonProxy:rOpenStarSpiritPanelInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401865();
        msg:ParseFromString(mp.data);
        DataCenter.eidolonData:fromServerSpiritInfo(msg);
        Lua_MsgUtil.callFunc("UPDATE_STAR_SPIRIT_INFO");
    end
end

-- 获取幻灵面板信息（返回）
function Lua_EidolonProxy:rOpenEidolonPanelInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401860();
        msg:ParseFromString(mp.data);
        DataCenter.eidolonData:fromServerEidolonInfo(msg);
        DataCenter.eidolonData.fantasy_soul_stone = tonumber(msg.fantasy_soul_stone);
        Lua_MsgUtil.callFunc("UPDATE_EIDOLON_INFO");
    end
end

-- 激活返回信息（返回）
function Lua_EidolonProxy:rEidolonActivationInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401861();
        msg:ParseFromString(mp.data);
        local vo = DataCenter.eidolonData:getArrByEidolonInfo(msg.id);
        vo.activation_state = 1;
        DataCenter.eidolonData:updateEidolonVo(vo);
        DataCenter.eidolonData.total_prop = msg.total_prop;
        OperateAlert.show(LanUtil.getValue(142020));
        Lua_MsgUtil.callFunc("UPDATE_ACTIVATION_INFO");
    end
end

-- 强化返回信息（返回）
function Lua_EidolonProxy:rEidolonIntensifyInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401862();
        msg:ParseFromString(mp.data);

        local vo = DataCenter.eidolonData:getArrByEidolonInfo(msg.id);
        vo.intensify_lvl = msg.intensify_lvl;
        DataCenter.eidolonData:updateEidolonVo(vo);
        DataCenter.eidolonData.fantasy_soul_stone = tonumber(msg.fantasy_soul_stone);
        DataCenter.eidolonData.total_prop = msg.total_prop;
        OperateAlert.show(LanUtil.getValue(142021));
        Lua_MsgUtil.callFunc("UPDATE_Intensify_INFO");
    end
end

-- 升星返回信息（返回）
function Lua_EidolonProxy:rEidolonUpgradeStarInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401863();
        msg:ParseFromString(mp.data);
        local vo = DataCenter.eidolonData:getArrByEidolonInfo(msg.id);
        vo.star_lvl = msg.star_lvl;
        DataCenter.eidolonData:updateEidolonVo(vo);
        DataCenter.eidolonData.total_prop = msg.total_prop;
        OperateAlert.show(LanUtil.getValue(142019));
        Lua_MsgUtil.callFunc("UPDATE_UPGARD_STAR_INFO");
    end
end

-- 分解返回信息（返回）
function Lua_EidolonProxy:rEidolonResolveInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401864();
        msg:ParseFromString(mp.data);
        DataCenter.eidolonData.fantasy_soul_stone = tonumber(msg.fantasy_soul_stone);
        Lua_MsgUtil.callFunc("UPDATE_EIDOLON_RESOLVE_INFO");
    end
end

-- 升星突破 是否成功（返回）
function Lua_EidolonProxy:sEidolonStateEff(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401866();
        msg:ParseFromString(mp.data);
        if msg.type == 2 then
            Lua_MsgUtil.callFunc("UPDATE_STAR_SPIRIT_EFF");--是否成功
        elseif msg.type == 1 then
            OperateAlert.show(LanUtil.getValue(142022));
        end
    end
end