-- 幻灵配置数据

checkRequire("Lua_StarSpiritVo");
Lua_EidolonUtil = class("Lua_EidolonUtil");
function Lua_EidolonUtil:ctor()
    self:superCall("ctor");
end

function Lua_EidolonUtil:eidolonResolveNum(arr) -- 分解获得总额
    local resolveNum = 0;
    for i=1,arr:getSize() do
        resolveNum = resolveNum + arr[i].decompose;
    end
    return resolveNum;
end


-- 幻灵
function Lua_EidolonUtil.Get:getButtonInfo()-- 幻灵页签数据
    if self.buttonInfo == nil then
        self.buttonInfo = Array();
        local _arr = getConfig({"fantasy_soul_const", "eidolon_type", "arr"});
        if _arr ~= nil then
            for i=1, #_arr do
                self.buttonInfo:add({index = _arr[i][1],name = _arr[i][2]})
            end  
        end
    end
    return self.buttonInfo;
end

function Lua_EidolonUtil.Get:pack_size() -- 背包大小
    return getConfig({"fantasy_soul_const", "max_pack_num", "value"});
end

function Lua_EidolonUtil.Get:eidolon_ecompose_id() -- 幻灵分解材料ID
   return getConfig({"fantasy_soul_const", "eidolon_ecompose_id", "value"});
end

function Lua_EidolonUtil.Get:maxStarNum() --幻灵最大星数
    return getConfig({"fantasy_soul_const", "max_star_num", "value"});
end




-- 星灵
function Lua_EidolonUtil.Get:starSpiritMaxLvl() --星灵最高等级
	return getConfig({"fantasy_soul_const", "star_soul_max_lvl", "value"});
end

 -- 星灵技能等级突破描述值
function Lua_EidolonUtil.Get:star_skill_break()
    return getConfig({"fantasy_soul_const", "star_skill_break", "arr"});
end

function Lua_EidolonUtil.Get:starSpiritMaxIndex() --星灵最大页数
	return self.starSpiritMaxLvl/10;
end


---------------------------------------------------------------------------------------------------------------------------------------
-- 星灵数据封装
function Lua_EidolonUtil.Get:getStarSpiritInfo() -- 星灵vo
	if self.starSpirit == nil then
        self.starSpirit = {};
        local config = getConfig({"star_soul"});
        if config ~= nil then
            for k, v in pairs(config) do
                local vo = Lua_StarSpiritVo.new(k, v);
                self.starSpirit[k] = vo;
            end
        end
    end

    return self.starSpirit;
end

function Lua_EidolonUtil:getStarSpiritVo(index) -- 通过index获取 vo
	if self.getStarSpiritInfo[index] == nil then
		return nil;
	end

    return self.getStarSpiritInfo[index];
end

function Lua_EidolonUtil.Get:isMaxLvl() --是否达到最高等级
	if self.starSpiritMaxLvl == DataCenter.eidolonData.star_soul_lvl then
		return true;
	end
	return false;
end

