-- 答题数据
Lua_EveryDayAnswerData = class("Lua_EveryDayAnswerData");
function Lua_EveryDayAnswerData:ctor()
    self:superCall("ctor");

    self.ownRightNum = 0;
    self.ownScoreNum = 0;
    self.ownAnswerRank = 0;
    self.ownAnswerExp = 0;
    self.ownAnswerUseTime = 0;
    self.answerReduiseTime = 0;
    self.answerWaitTime = 0;
    self.getOwnAnswerInfoTime = 0;

    self:resetQuestionInfo();
    self:resetAnswerResult();
end

function Lua_EveryDayAnswerData:dispose()
    self.ownRightNum = 0;
    self.ownScoreNum = 0;
    self.ownAnswerRank = 0;
    self.ownAnswerExp = 0;
    self.ownAnswerUseTime = 0;
    self.answerReduiseTime = 0;
    self.answerWaitTime = 0;
    self.getOwnAnswerInfoTime = 0;

    self:resetQuestionInfo();
    self:resetAnswerResult();
end

function Lua_EveryDayAnswerData.Get:bInAnswerScene()
	if DataCenter.roleData.sceneId == 30101 then
        return true;
    end

    return false;
end

function Lua_EveryDayAnswerData:fromServerMyAnswerInfo(msg)
	-- msg.right_num;   -- 答对题数
    -- msg.score_num;   -- 积分
    -- msg.rank;   -- 排名
    -- msg.exp;   -- 经验
    -- msg.used_time;   -- 使用时间
    -- msg.left_time;   -- 剩余时间
    -- msg.wait_time;   -- 剩余等待时间
    if msg == nil then
    	return;
    end

    self.ownRightNum = msg.right_num;
    self.ownScoreNum = msg.score_num;
    self.ownAnswerRank = msg.rank;
    self.ownAnswerExp = msg.exp;
    self.ownAnswerUseTime = msg.used_time;
    self.answerReduiseTime = msg.left_time;
    self.answerWaitTime = msg.wait_time;
    self.getOwnAnswerInfoTime = getTime();
end

function Lua_EveryDayAnswerData:fromServerQuestionInfo(msg)
	-- msg.topic_desc;	-- 问题描述
    -- msg.cur_stage;	-- 当前第几题
    -- msg.left_time;	-- 剩余时间
    if msg == nil then
    	return;
    end

    self.questionDesc = msg.topic_desc;
    self.questionIndex = msg.cur_stage;
    self.questionReduiseTime = msg.left_time;
    self.questionGetTime = getTime();
end

function Lua_EveryDayAnswerData:fromServerAnswerResult(msg)
	-- msg.name;	-- 第一名
    -- msg.left_time;	-- 剩余时间
    if msg == nil then
    	return;
    end

    self.answerFirstName = msg.name;
    -- self.answerExitLeftTime = msg.left_time;
    -- self.getExitInfoTime = getTime();

    self:resetQuestionInfo();
end

-- 清除问题
function Lua_EveryDayAnswerData:resetQuestionInfo()
    self.questionDesc = "";
    self.questionIndex = 0;
    self.questionReduiseTime = 0;
    self.questionGetTime = 0;
end

-- 清除结束记录
function Lua_EveryDayAnswerData:resetAnswerResult()
    self.answerFirstName = "";
    self.answerExitLeftTime = 0;
    self.getExitInfoTime = 0;
end