checkRequire("Lua_EveryDayAnswerData")
checkRequire("Lua_EveryDayAnswerUtil")
Lua_EveryDayAnswerProxy = class("Lua_EveryDayAnswerProxy");
function Lua_EveryDayAnswerProxy:ctor()
    DataCenter.answerData = Lua_EveryDayAnswerData.new();
    DataCenter.answerUtil = Lua_EveryDayAnswerUtil.new();

    LuaUtil.addLuaMsg(50401531, self, self.rEnterAnswerScene);	    -- 请求进入答题活动（返回）
    LuaUtil.addLuaMsg(50405021, self, self.rOwnerAnswerInfo);	    -- 个人信息(返回)
    LuaUtil.addLuaMsg(50405022, self, self.rAnswerRankInfo);	    -- 排行榜(返回)
    LuaUtil.addLuaMsg(50405023, self, self.rAnswerJump);			-- 跳跃(返回)

    LuaUtil.addLuaMsg(80405011, self, self.rAnswerInfoUpdate);	    -- 通知刷新问题(主动)
    LuaUtil.addLuaMsg(80405012, self, self.rAnswerEndInfo);	    -- 结束界面(主动)
    LuaUtil.addLuaMsg(80405013, self, self.rAnswerResult);	    -- 通知问题答案(主动)
end

-----------------------------------------------------
-- 上行协议

-- 进入活动场景
function Lua_EveryDayAnswerProxy:sEnterAnswerScene()
	sendMsg(10401531);
end

-- 个人信息
function Lua_EveryDayAnswerProxy:sOwnerAnswerInfo()
	sendMsg(10405021);
end

-- 排行榜
function Lua_EveryDayAnswerProxy:sAnswerRankInfo()
	sendMsg(10405022);
end

-- 跳跃
function Lua_EveryDayAnswerProxy:sAnswerJump(areaIdx)
	local cmd = ProtoPublic_pb.Proto10405023();
    cmd.area = areaIdx;   -- 区域，1表示对，2表示错
    sendMsg(10405023, cmd);
end

-- 退出场景
function Lua_EveryDayAnswerProxy:sExitScene()
	sendMsg(10400902);
end



-----------------------------------------------------
-- 下行协议

-- 请求进入答题活动（返回）
function Lua_EveryDayAnswerProxy:rEnterAnswerScene(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_EveryDayAnswerWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
		DataCenter.answerData:resetQuestionInfo();
	    DataCenter.answerData:resetAnswerResult();
	end
end

-- 个人信息(返回)
function Lua_EveryDayAnswerProxy:rOwnerAnswerInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50405021();
        msg:ParseFromString(mp.data);
        -- msg.right_num;   -- 答对题数
        -- msg.score_num;   -- 积分
        -- msg.rank;   -- 排名
        -- msg.exp;   -- 经验
        -- msg.used_time;   -- 使用时间
        -- msg.left_time;   -- 剩余时间
        -- msg.wait_time;   -- 剩余等待时间
        -- msg.answer;	-- 答题情况，0表示没有，1表示对，2表示错
        DataCenter.answerData:fromServerMyAnswerInfo(msg);
        Lua_MsgUtil.callFunc("rOwnerAnswerInfo", msg.answer);
    end
end

-- 排行榜(返回)
function Lua_EveryDayAnswerProxy:rAnswerRankInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50405022();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("rAnswerRankInfo", msg);
    end
end

-- 跳跃(返回)
function Lua_EveryDayAnswerProxy:rAnswerJump(mp)
	if mp.errno == 0 then

    end
end

-- 通知刷新问题(主动)
function Lua_EveryDayAnswerProxy:rAnswerInfoUpdate(mp)
	if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80405011();
        msg:ParseFromString(mp.data);
        -- msg.topic_desc;	-- 问题描述
        -- msg.cur_stage;	-- 当前第几题
        -- msg.left_time;	-- 剩余时间
        DataCenter.answerData:fromServerQuestionInfo(msg);
        Lua_MsgUtil.callFunc("rAnswerInfoUpdate");
    end
end

-- 结束界面(主动)
function Lua_EveryDayAnswerProxy:rAnswerEndInfo(mp)
	if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80405012();
        msg:ParseFromString(mp.data);
        -- msg.name;	-- 第一名
        -- msg.left_time;	-- 剩余时间
        DataCenter.answerData:fromServerAnswerResult(msg);
        Lua_MsgUtil.callFunc("rAnswerEndInfo");
    end
end

-- 
function Lua_EveryDayAnswerProxy:rAnswerResult(mp)
	if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80405013();
        msg:ParseFromString(mp.data);
        -- msg.answer_id;	-- 答案ID（1 A 2 B）
        
    end
end