-- 答题配置
Lua_EveryDayAnswerUtil = class("Lua_EveryDayAnswerUtil");
function Lua_EveryDayAnswerUtil:ctor()
    self:superCall("ctor");

end

-- 根据玩家位置判断玩家是在a区域
function Lua_EveryDayAnswerUtil:checkPosInAArea(pos)
	if self.aAreaMaxX == nil then
		local obj = getConfig({"answer_const", "a_area", "arr"});
		if pos ~= nil and obj ~= nil then
			self.aAreaMaxX = obj[2][1];
			self.aAreaMinX = obj[1][1];
			self.aAreaMaxZ = obj[1][2];
			self.aAreaMinZ = obj[2][2];
		else
			return false;
		end
	end

	if pos.x >= self.aAreaMinX and pos.x <= self.aAreaMaxX and pos.z <= self.aAreaMaxZ and pos.z >= self.aAreaMinZ then
		return true;
	end
	return false;
end

-- 根据玩家位置判断玩家是在b区域
function Lua_EveryDayAnswerUtil:checkPosInBArea(pos)
	if self.bAreaMaxX == nil then
		local obj = getConfig({"answer_const", "b_area", "arr"});
		if pos ~= nil and obj ~= nil then
			self.bAreaMaxX = obj[2][1];
			self.bAreaMinX = obj[1][1];
			self.bAreaMaxZ = obj[1][2];
			self.bAreaMinZ = obj[2][2];
		else
			return false;
		end
	end

	if pos.x >= self.bAreaMinX and pos.x <= self.bAreaMaxX and pos.z <= self.bAreaMaxZ and pos.z >= self.bAreaMinZ then
		return true;
	end
	return false;
end

-- 获取a的随机位置
function Lua_EveryDayAnswerUtil:getAAreaMoveToPos()
	local obj = getConfig({"answer_const", "a_moveToTarget", "arr"});
	if obj ~= nil then
		local randomX = self.rangeNum / 2 - math.random(self.rangeNum);
		local randomZ = self.rangeNum / 2 - math.random(self.rangeNum);
		return Vector3(obj[1] + randomX, obj[2], obj[3] + randomZ);
	end

	return Vector3(0, 0, 0);
end

-- 获取a的随机位置
function Lua_EveryDayAnswerUtil:getBAreaMoveToPos()
	local obj = getConfig({"answer_const", "b_moveToTarget", "arr"});
	if obj ~= nil then
		local randomX = self.rangeNum / 2 - math.random(self.rangeNum);
		local randomZ = self.rangeNum / 2 - math.random(self.rangeNum);
		return Vector3(obj[1] + randomX, obj[2], obj[3] + randomZ);
	end

	return Vector3(0, 0, 0);
end

function Lua_EveryDayAnswerUtil.Get:rangeNum()
	return getConfig({"answer_const", "moveToTarget_range", "value"})
end

function Lua_EveryDayAnswerUtil.Get:forcePlayerExitTimes()
	return getConfig({"answer_const", "finish_time", "value"})
end

function Lua_EveryDayAnswerUtil.Get:rankBeforeThreeUrl()
	return {"ui_paihang_widget_no1", "ui_paihang_widget_no2", "ui_paihang_widget_no3"};
end

function Lua_EveryDayAnswerUtil.Get:answerStartTime()
	if self._answerStartTime == nil then
		self._answerStartTime = "";
		local activityId = getConfig({"answer_const", "activity_id", "value"})
		if activityId ~= nil then
			self._answerStartTime = DataCenter.xianshiData:getDataById(activityId).startDayTime;
			self._answerEndTime = DataCenter.xianshiData:getDataById(activityId).endDayTime;
		end
	end

	return self._answerStartTime;
end

function Lua_EveryDayAnswerUtil.Get:answerEndTime()
	if self._answerEndTime == nil then
		self._answerEndTime = "";
		local activityId = getConfig({"answer_const", "activity_id", "value"})
		if activityId ~= nil then
			self._answerStartTime = DataCenter.xianshiData:getDataById(activityId).startDayTime;
			self._answerEndTime = DataCenter.xianshiData:getDataById(activityId).endDayTime;
		end
	end

	return self._answerEndTime;
end