checkRequire("Lua_FactionMemberVo");
checkRequire("Lua_FactionApplyVo");
checkRequire("Lua_FactionInfoVo");
checkRequire("Lua_FactionListVo");
checkRequire("Lua_FactionLogVo");
checkRequire("Lua_FactionDepotLogVo");
checkRequire("Lua_FactionSkillVo");
checkRequire("Lua_FactionDefine");
Lua_FactionData = class("Lua_FactionData")
function Lua_FactionData:ctor()
	self.showFactionList = Array(); -- 所有帮派列表
	self.factionMemberList = Array(); -- 帮派成员列表
	self.applyFactionIds = Array(); -- 已申请入帮的帮派id
	self.joinApplyList = Array(); -- 申请入帮审核列表
	self.factionLogList = Array(); -- 帮派日志数据
	self.factionDepotLogList =Array(); -- 帮派仓库日志数据
	self.factionSkillList = Array();
	self.factionDepotBatchMode = false; -- 帮派仓库批量处理模式
	self.autoDestructionList = {}; -- 帮派仓库自动销毁状态
	self.autoDestructionState = false;
	self.factionDonateEquipList = nil; -- 幫派選擇捐獻裝備列表
	self.donateEquipNum = 0;
end

function Lua_FactionData:dispose()
	self:cleanMyFactionData();
end

function Lua_FactionData:cleanMyFactionData()
	self.factionMemberList:clear();
	self.applyFactionIds:clear();
	self.joinApplyList:clear();
	self.factionLogList:clear();
	self.factionDepotLogList:clear();
	self.factionSkillList:clear();
	self.factionDepotBatchMode = false;
	self.factionDonateEquipList = nil; -- 幫派選擇捐獻裝備列表
	self.donateEquipNum = 0;
end

-- 请求帮派列表
function Lua_FactionData:sFactionList()
	local msg = getProtoMsg("Proto10100601");
	msg.page_index = 1;
	msg.show_join =  0;
	sendMsg(10100601, msg);
end

-- 请求创建帮派
function Lua_FactionData:sCreateFaction(fname)
	local msg = getProtoMsg("Proto10100602");
	msg.league_name = fname;
	msg.league_intro = "";
	msg.create_type = 1;
	sendMsg(10100602,msg);
end

-- 请求加入帮派
function Lua_FactionData:sReqJoinFaction(idSet)
	local msg = getProtoMsg("Proto10100604");
	for i = 1, idSet:getSize() do
		msg.apply_set:append(idSet[i]);
	end
	sendMsg(10100604, msg);
end
	
-- 请求成员列表
function Lua_FactionData:sMyFactionMemberList(pageIdx)
	local msg = getProtoMsg("Proto10100614");
	msg.page_index = pageIdx;
	sendMsg(10100614, msg);
end

-- 请求申请入帮列表
function Lua_FactionData:sJoinApplyList(pageIdx)
	local msg = getProtoMsg("Proto10100615");
	msg.page_index = pageIdx;
	sendMsg(10100615, msg);
end

-- 请求同意申请入帮
function Lua_FactionData:sAgreeApply(arr)
	local msg = getProtoMsg("Proto10100619");
	for i = 1, arr:getSize() do
		msg.role_set:append(arr[i]);
	end
	sendMsg(10100619, msg);
end

-- 请求拒绝申请入帮
function Lua_FactionData:sRefuseApply(arr)
	local msg = getProtoMsg("Proto10100620");
	for i = 1, arr:getSize() do
		msg.role_set:append(arr[i]);
	end
	sendMsg(10100620, msg);
end





-- 返回帮派列表
function Lua_FactionData:fromServer50100601(msg)
	self.showFactionList:clear();
	for i,v in ipairs(msg.league_set) do
		local tvo = Lua_FactionListVo.new(v);
		self.showFactionList:add(tvo);
		local haveInJoinApplyList = self.applyFactionIds:indexOf(tvo.leagueIndex) == -1 and false or true;
		if  haveInJoinApplyList == false and tvo.applyFlag == 1 then -- 已经申请过的，标记在applyFactionIds里面
			self.applyFactionIds:add(tvo.leagueIndex);
		elseif haveInJoinApplyList == true and tvo.applyFlag == 0 then -- 没有申请过，但是在applyFactionIds里面的话，就要移除
			self.applyFactionIds:removeItem(tvo.leagueIndex);
		end
	end
end

-- 申请加入帮派返回
function Lua_FactionData:fromServer50100604(idSet)
	for i = 1, #idSet do
		local idx = self.applyFactionIds:indexOf(idSet[i]);
		if idx == -1 then
			self.applyFactionIds:add(idSet[i]);
		end
	end
end

-- 返回自己的帮派数据
function Lua_FactionData:fromServer50100606(msg)
	if self.myFactionInfo == nil then
		self.myFactionInfo = Lua_FactionInfoVo.new();
	end
	self.myFactionInfo:fromServer(msg);
end

-- 返回成员列表
function Lua_FactionData:fromServer50100614(msg)
	if self.factionMemberList ~= nil then
		self.factionMemberList:clear();
	end

	local vo;
	for i,v in ipairs(msg.member_set) do
		vo = Lua_FactionMemberVo.new();
		vo:fromServer(v);
		self.factionMemberList:add(vo);
	end
end

-- 请求入帮列表返回
function Lua_FactionData:fromServer50100615(msg)
	self.joinApplyList:clear();
	for i=1,#msg.apply_set do
		local fvo = Lua_FactionApplyVo.new();
		fvo:fromServer(msg.apply_set[i]);
		self.joinApplyList:add(fvo);
	end
end

function Lua_FactionData:fromServer50100621(list)
	self.factionLogList:clear();

	local vo;
	for i,v in ipairs(list) do
		vo = Lua_FactionLogVo.new();
		vo:fromServer(v);
		self.factionLogList:add(vo);
	end
end

function Lua_FactionData:fromServer50100627(msg)
	self.myFactionInfo.myContri = msg.cur_contri;

	local len = 0;
	if self.factionSkillList:getSize() == 0 then
		-- 初始化技能列表
		local keyArr = Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC;
		len = keyArr:getSize();
		for i = 1, len do
			local svo = Lua_FactionSkillVo.new(i, 1, false);
			self.factionSkillList:add(svo);
		end
	end

	len = self.factionSkillList:getSize();
	for k,v in ipairs(msg.skill_set) do
		for i = 1, len do
			if self.factionSkillList[i].skillType == v.obj_id then
				self.factionSkillList[i]:updateSkillLv(v.obj_value, true);
				break;
			end
		end
	end
end

function Lua_FactionData:fromServer50100628(msg)
	self.myFactionInfo.myContri = msg.cur_contri;

	local len = self.factionSkillList:getSize();
	for i = 1, len do
		if self.factionSkillList[i].skillType == msg.skill_id then
			self.factionSkillList[i]:updateSkillLv(msg.skill_level, true);
			break;
		end
	end
end

function Lua_FactionData:fromServer50100630(arr)
	self.factionDepotLogList:clear();
	
	for i,v in ipairs(arr) do
		local lvo = Lua_FactionDepotLogVo.new();
		lvo.logTick = v.log_tick;
		lvo.logContent = v.log_content;
		lvo.item = Lua_ToolVo.createToolVo(v.item.id,v.item.amount,v.item.bind);
		lvo.item:fromServer(v.item);
		self.factionDepotLogList:add(lvo);
	end
end

function Lua_FactionData:fromServer50100640(msg)
	self.autoDestructionList = {};
	self.autoDestructionList[1] = msg.color;
	self.autoDestructionList[2] = msg.grade;
	self.autoDestructionList[3] = msg.star;
end

function Lua_FactionData:fromServer50401542(msg)
	self.gangData = msg;

	for i = 1, #msg.rank_list do
		if tonumber(msg.rank_list[i].league_id) == tonumber(DataCenter.roleData.leagueId) then
			self.tempTotal = msg.rank_list[i].league_score;
			self.tempRank = msg.rank_list[i].rank;
		end
	end

	if self.gangRank == nil or self.gangRank ~= self.tempRank or self.gangTotal == nil or self.gangTotal ~= self.tempTotal then
		self.gangRank = self.tempRank;
		self.gangTotal = self.tempTotal;
		Lua_MsgUtil.callFunc("SETGANGRANKINFO");
	end
end





-- 判断自己是否帮主
function Lua_FactionData.Get:isLeader()
	if self.myFactionInfo == nil then
		return false;
	end
	return self.myFactionInfo.leaguePos == Lua_FactionDefine.FACTION_POS_LEADER;
end

-- 判断自己是否副帮主
function Lua_FactionData.Get:isDeputyLeader()
	if self.myFactionInfo == nil then
		return false;
	end
	return self.myFactionInfo.leaguePos == Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER;
end

-- 存储帮派捐献物品
function Lua_FactionData:setDonateEquipList(index, id)
	if self.factionDonateEquipList == nil then
		self.factionDonateEquipList = {};
		self.donateEquipNum = 0;
	end
	if self.factionDonateEquipList[index] == nil then
		self.factionDonateEquipList[index] = id;
		self.donateEquipNum = self.donateEquipNum + 1;
	else
		self.factionDonateEquipList[index] = nil;
		self.donateEquipNum = self.donateEquipNum - 1;
	end
end

-- 获取帮派捐献物品状态
function Lua_FactionData:getDonateEquipState(index)
	if self.factionDonateEquipList == nil then
		return false;
	end
	return self.factionDonateEquipList[index] ~= nil;
end

-- 重置帮派捐献物品状态列表
function Lua_FactionData:clearDonateEquipList()
	if self.factionDonateEquipList ~= nil then
		self.factionDonateEquipList = nil
		self.donateEquipNum = 0;
	end
end