Lua_FactionDefine = class("Lua_FactionDefine")
Lua_FactionDefine.FACTION_POS_NORMAL = 0;
Lua_FactionDefine.FACTION_POS_ELITE = 10;
Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER = 30;
Lua_FactionDefine.FACTION_POS_LEADER = 40;
Lua_FactionDefine.FACTION_POS_LIST = Array();
Lua_FactionDefine.FACTION_POS_LIST:add(Lua_FactionDefine.FACTION_POS_NORMAL);
Lua_FactionDefine.FACTION_POS_LIST:add(Lua_FactionDefine.FACTION_POS_ELITE);
Lua_FactionDefine.FACTION_POS_LIST:add(Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER);
Lua_FactionDefine.FACTION_POS_LIST:add(Lua_FactionDefine.FACTION_POS_LEADER);

Lua_FactionDefine.FACTION_POS_LIST_REV =Array();
Lua_FactionDefine.FACTION_POS_LIST_REV:add(Lua_FactionDefine.FACTION_POS_LEADER);
Lua_FactionDefine.FACTION_POS_LIST_REV:add(Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER);
Lua_FactionDefine.FACTION_POS_LIST_REV:add(Lua_FactionDefine.FACTION_POS_ELITE);
Lua_FactionDefine.FACTION_POS_LIST_REV:add(Lua_FactionDefine.FACTION_POS_NORMAL);

Lua_FactionDefine.SKILL_TYPE_HEALTH = 1;
Lua_FactionDefine.SKILL_TYPE_MAGIC = 2;
Lua_FactionDefine.SKILL_TYPE_ATTACK = 3;
Lua_FactionDefine.SKILL_TYPE_DEFENCE = 4;
Lua_FactionDefine.SKILL_TYPE_HIT = 5;
Lua_FactionDefine.SKILL_TYPE_DODGE = 6;
Lua_FactionDefine.SKILL_TYPE_CRIT = 7;
Lua_FactionDefine.SKILL_TYPE_TOUGHNESS = 8;
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC =Array();
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("health");
--Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("magic");
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("attack");
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("defence");
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("hit");
Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("dodge");
--Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("crit");
--Lua_FactionDefine.SKILL_ATRRIBUTE_KEY_DIC:add("toughness");

Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC =Array();
Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110839));--生命
--Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(107487));--法力
Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110840));--攻击
Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110841));--防御
Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110843));--命中
Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110844));--闪避
--Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110842));--暴击
--Lua_FactionDefine.SKILL_ATRRIBUTE_LABEL_DIC:add(LanUtil.getValue(110845));--韧性

Lua_FactionDefine.ATT_REF_DIC={};
Lua_FactionDefine.ATT_REF_DIC["health"]=1;
Lua_FactionDefine.ATT_REF_DIC["magic"]=2;
Lua_FactionDefine.ATT_REF_DIC["attack"]=4;
Lua_FactionDefine.ATT_REF_DIC["defence"]=5;
Lua_FactionDefine.ATT_REF_DIC["hit"]=6;
Lua_FactionDefine.ATT_REF_DIC["dodge"]=7;
Lua_FactionDefine.ATT_REF_DIC["crit"]=8;
Lua_FactionDefine.ATT_REF_DIC["toughness"]=9;

function Lua_FactionDefine.getPositionNameByPos(pos)
	if pos == Lua_FactionDefine.FACTION_POS_NORMAL then -- 帮众
		return LanUtil.getValue(121008);
	elseif pos == Lua_FactionDefine.FACTION_POS_ELITE then -- 精英
		return LanUtil.getValue(121009);
	elseif pos == Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER then -- 副帮主
		return LanUtil.getValue(121010);
	elseif pos == Lua_FactionDefine.FACTION_POS_LEADER then -- 帮主
		return LanUtil.getValue(121011);
	end
	return "";
end
--获取下个提升职位 位置
function Lua_FactionDefine.getNextLiftingPos(curPos)
	local idx = Lua_FactionDefine.FACTION_POS_LIST:indexOf(curPos);
	if idx == -1 or curPos == Lua_FactionDefine.FACTION_POS_LEADER then
		return curPos;
	end
	local nextPos = idx +1;
	return Lua_FactionDefine.FACTION_POS_LIST[nextPos];
end

--获取降低职位 位置
function Lua_FactionDefine.getNextLoweringPos(curPos)
	local idx = Lua_FactionDefine.FACTION_POS_LIST:indexOf(curPos);
	if idx == -1 or curPos == Lua_FactionDefine.FACTION_POS_NORMAL then
		return curPos;
	end
	local nextPos = idx -1;
	return Lua_FactionDefine.FACTION_POS_LIST[nextPos];
end