Lua_FactionSkillVo = class("Lua_FactionSkillVo")
function Lua_FactionSkillVo:ctor(skillType,skillLv,isLearn)
	self.skillType = skillType;
	self.skillLv = skillLv;
	self.skillId = self.skillType*1000 + self.skillLv;
	self.isLearn = isLearn;
	self._skillOpenLv = -1;
	self._config = nil;
	self._isMax = false;
	self:updateIsMaxLv();
end

function Lua_FactionSkillVo:updateSkillLv(lv,isLearn)
	self.skillLv = lv;
	self.isLearn = isLearn;
	self.skillId = self.skillType*1000 + self.skillLv;
	self._config = nil;
	self:updateIsMaxLv();
end

function Lua_FactionSkillVo:updateIsMaxLv()
	local tcfg = getConfig({"league_skill", self.skillType * 1000 + self.skillLv + 1});
	self._isMax = tcfg == nil and true or false;
end

function Lua_FactionSkillVo.Get:isMax()
	return self._isMax;
end

function Lua_FactionSkillVo.Get:skillOpenLv()
	-- if self._skillOpenLv == -1 then	
		local tlv = -1;
		local lvCfg = getConfig({"league_level"});
		for k,v in pairs(lvCfg) do
			if v.open_skill~= nil then
				for i,j in ipairs(v.open_skill) do
					if j == self.skillType then
						tlv = tonumber(k);
						break;
					end
				end
				if tlv ~= -1 then
					break;
				end
			end
		end
		return tlv;
	-- end
	-- return self._skillOpenLv;
end

function Lua_FactionSkillVo.Get:config()
	if self._config == nil then
		self._config = getConfig({"league_skill", self.skillId})
		if self._config == nil then
			print("league_skill is no", self.skillId);
		end
	end
	return self._config;
end

function Lua_FactionSkillVo.Get:name()
	return self.config.name;
end

function Lua_FactionSkillVo.Get:skillIcon()
	return self.config.icon_id;
end

function Lua_FactionSkillVo.Get:contri()
	return self.config.contri;
end

function Lua_FactionSkillVo.Get:redDot()
	return self.config.red_dot;
end

function Lua_FactionSkillVo.Get:health()
	return self.config.health;
end

function Lua_FactionSkillVo.Get:magic()
	return self.config.magic;
end

function Lua_FactionSkillVo.Get:attack()
	return self.config.attack;
end

function Lua_FactionSkillVo.Get:defence()
	return self.config.defence;
end

function Lua_FactionSkillVo.Get:hit()
	return self.config.hit;
end

function Lua_FactionSkillVo.Get:dodge()
	return self.config.dodge;
end

function Lua_FactionSkillVo.Get:crit()
	return self.config.crit;
end

function Lua_FactionSkillVo.Get:toughness()
	return self.config.toughness;
end