checkRequire("Lua_FactionData")
Lua_FactionProxy = class("Lua_FactionProxy")
function Lua_FactionProxy:ctor()
	DataCenter.factionData = Lua_FactionData.new();

	LuaUtil.addLuaMsg(50100601, self, self.rFactionList); -- 返回帮派列表
	LuaUtil.addLuaMsg(50100602, self, self.rCreateFaction); -- 创建帮派返回
	LuaUtil.addLuaMsg(50100604, self, self.rFactionApply); -- 申请加入帮派返回
	LuaUtil.addLuaMsg(50100606, self, self.rMyFactionInfo); -- 查询自己帮派返回
	LuaUtil.addLuaMsg(50100608, self, self.rExitFaction); -- 退出帮派返回
	LuaUtil.addLuaMsg(50100614, self, self.rFactionMemberList); -- 查询帮派成员列表
	LuaUtil.addLuaMsg(50100615, self, self.rFactionApplyList); -- 查询入帮申请列表
	LuaUtil.addLuaMsg(50100617, self, self.rKickout); -- 帮派踢出成员返回
	LuaUtil.addLuaMsg(50100619, self, self.rAcceptApply); -- 接受入帮申请返回
	LuaUtil.addLuaMsg(50100620, self, self.rRefuseApply); -- 拒绝入帮申请返回
	LuaUtil.addLuaMsg(50100621, self, self.rLogList); -- 帮派日志返回
	LuaUtil.addLuaMsg(50100626, self, self.rDonateInfo); -- 打开捐献面板信息返回
	LuaUtil.addLuaMsg(50100627, self, self.rSkillDataInfo); -- 帮派技能数据
	LuaUtil.addLuaMsg(50100628, self, self.rSkillUpgrade); -- 帮派技能升级
	LuaUtil.addLuaMsg(50100630, self, self.rFactionDepotData); -- 帮派仓库物品列表数据
	LuaUtil.addLuaMsg(50100640, self, self.rAutoDestructionState); -- 获取帮派仓库自动销毁的设定
	LuaUtil.addLuaMsg(50100641, self, self.rSkillUpgrade); -- 开启或关闭帮派仓库自动销毁装备
	LuaUtil.addLuaMsg(50401542, self, self.rGangRankInfo);
	LuaUtil.addLuaMsg(80400344, self, self.rFactionStateUpdate); -- 帮派状态更新（league_state：宗派状态，1表示加入，2表示被踢出）

	Lua_MsgUtil.addEventListener("S_FACTION_SEARCH_BY_NAME", self, self.sFactionSearchByName);
	Lua_MsgUtil.addEventListener("OPEN_FACTION_UI", self, self.onOpenFactionUI);
	Lua_MsgUtil.addEventListener("TODO_FACTION_TASK", self, self.todoFactionTask);
end

function Lua_FactionProxy:rFactionList(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100601");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100601(msg);
		Lua_MsgUtil.callFunc("FACTION_SHOWLIST_UPDATE");
	end
end

function Lua_FactionProxy:rCreateFaction(mp)
	if mp.errno == 0 then
		sendMsg(10100606, nil);
		Lua_WindowUtil.openWin("Lua_FactionListWindow", WinParam.ACTION_CLOSE, nil);
		Lua_WindowUtil.openWin("Lua_FactionMainWindow",WinParam.ACTION_OPEN, nil);
		Lua_MsgUtil.callFunc("FACTION_CREATE_SUCCESS");
	end
end

function Lua_FactionProxy:rFactionApply(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100604");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100604(msg.apply_set);
		Lua_MsgUtil.callFunc("FACTION_APPLY_LIST_UPDATE");
		DataCenter.factionData:sFactionList();
	end
end

function Lua_FactionProxy:rMyFactionInfo(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100606");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100606(msg);
		Lua_MsgUtil.callFunc("FACTION_MY_FACTION_INFO");
	end
end

function Lua_FactionProxy:rExitFaction(mp)
	if mp.errno == 0 then
		-- 退出帮派时清理数据
		DataCenter.roleData.leagueId = 0;
		DataCenter.roleData.leagueName = "";
		DataCenter.factionData:cleanMyFactionData();
		Lua_WindowUtil.openWin("Lua_FactionMainWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_FactionListWindow", WinParam.ACTION_OPEN);
	end
end

function Lua_FactionProxy:rFactionMemberList(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100614");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100614(msg);
		Lua_MsgUtil.callFunc("FACTION_FACTION_MEMBER_LIST");
	end
end

function Lua_FactionProxy:rFactionApplyList(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100615");
		msg:ParseFromString(mp.data);
		DataCenter.factionData.myFactionInfo:setAutoAcceptFromServer(msg);
		DataCenter.factionData:fromServer50100615(msg);
		Lua_MsgUtil.callFunc("FACTION_JOIN_APPLY_LIST_UPDATE");
	end
end

function Lua_FactionProxy:rKickout(mp)
	if mp.errno == 0 then
		DataCenter.factionData:sMyFactionMemberList(1);		
	end
end

function Lua_FactionProxy:rAcceptApply(mp)
	if mp.errno == 0 then
		DataCenter.factionData:sMyFactionMemberList(1);
	end
end

function Lua_FactionProxy:rRefuseApply(mp)
	if mp.errno == 0 then
		DataCenter.factionData:sMyFactionMemberList(1);
	end
end

function Lua_FactionProxy:rLogList(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100621");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100621(msg.log_set);
		Lua_MsgUtil.callFunc("FACTION_LOG_UPDATE");
	end
end

function Lua_FactionProxy:rDonateInfo(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100626");
		msg:ParseFromString(mp.data);
		DataCenter.factionData.myFactionInfo:setDonateDataFromServer(msg);
		Lua_MsgUtil.callFunc("FACTION_DONATE_DATA_UPDATE");
	end
end

function Lua_FactionProxy:rSkillDataInfo(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100627");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100627(msg);
		Lua_MsgUtil.callFunc("FACTION_SKILL_LIST_UPDATE");
	end
end

function Lua_FactionProxy:rSkillUpgrade(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100628");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100628(msg);
		Lua_MsgUtil.callFunc("FACTION_SKILL_UPGRADE", msg.skill_id);
	end
end

function Lua_FactionProxy:rFactionDepotData(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100630");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100630(msg.donate_log);

		DataCenter.factionData.myFactionInfo.deportScore = msg.store_score;
		DataCenter.factionData.autoDestructionState = msg.clear_state == 1;
		Lua_MsgUtil.callFunc("FACTION_DEPOT_LOG_UPDATE");
	end
end

function Lua_FactionProxy:rAutoDestructionState(mp)
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto50100640");
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50100640(msg);
		Lua_MsgUtil.callFunc("AUTO_DESTRUTION_STATE");
	end
end

function Lua_FactionProxy:rGangRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50401542();
		msg:ParseFromString(mp.data);
		DataCenter.factionData:fromServer50401542(msg);
		-- Lua_MsgUtil.callFunc("SETGANGRANKINFO", msg);
	end
end

function Lua_FactionProxy:rFactionStateUpdate(mp)
	local showHaveFaction = false;
	if mp.errno == 0 then
		local msg = getProtoMsg("Proto80400344");
		msg:ParseFromString(mp.data);
		-- 被踢出、主动退出帮派时清理数据
		if msg.league_state == 2 or msg.league_state == 3 then
			DataCenter.roleData.leagueId = 0;
			DataCenter.roleData.leagueName = "";
			DataCenter.factionData:cleanMyFactionData();
			Lua_WindowUtil.openWin("Lua_FactionMainWindow",WinParam.ACTION_CLOSE);
			if msg.league_state == 2 then
				OperateAlert.show(LanUtil.getValue(121016));
			else
				OperateAlert.show(LanUtil.getValue(121046));
			end
			showHaveFaction = true;
		elseif msg.league_state == 1 then
			-- 进入帮派
			if Lua_WindowUtil.isWindowShowing("Lua_FactionListWindow") == true then
				Lua_WindowUtil.openWin("Lua_FactionListWindow", WinParam.ACTION_CLOSE);
				Lua_WindowUtil.openWin("Lua_FactionMainWindow", WinParam.ACTION_OPEN);
			end
			showHaveFaction = false;
			OperateAlert.show(LanUtil.getValue(121015));
		end
	end
	Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10013, state = showHaveFaction});
end





function Lua_FactionProxy:sFactionSearchByName(str)
	local msg = getProtoMsg("Proto10100607");
	msg.name = str;
	sendMsg(10100607, msg);
end

function Lua_FactionProxy:onOpenFactionUI()
	if DataCenter.roleData.leagueId ~= "0" and DataCenter.roleData.leagueId ~= 0 then
		Lua_WindowUtil.openWin("Lua_FactionMainWindow");
	else
		Lua_WindowUtil.openWin("Lua_FactionListWindow");
	end
end

function Lua_FactionProxy:todoFactionTask()
	-- local arr = Lua_CommonUtil.getCommonConfig("faction_task_noclose_ui_in_scenes", 3);
	-- for k,v in ipairs(arr) do
	-- 	if tonumber(DataCenter.roleData.sceneId) == tonumber(v) then
	-- 		--指定场景内不给进行帮派任务
	-- 		OperateAlert.show(LanUtil.getValue(122938));
	-- 		return;
	-- 	end
	-- end

	if tonumber(DataCenter.roleData.sceneId) > 20000 then
		OperateAlert.show(LanUtil.getValue(122938));
		return;
	end

	if Lua_WindowUtil.isWindowShowing("Lua_FactionMainWindow") then
		Lua_WindowUtil.openWin("Lua_FactionMainWindow", WinParam.ACTION_CLOSE);
	end

	local taskList = DataCenter.taskData:getListByType(Lua_TaskDefine.LEAGUE);
	if taskList:getSize() > 0 then
		taskList[1]:exeTask();
	end
end

function Lua_FactionProxy:sDonatePackEqu()
	if DataCenter.factionData.factionDonateEquipList ~= nil then
		local cmd = getProtoMsg("Proto10100629");
		local obj;
		for k, v in pairs(DataCenter.factionData.factionDonateEquipList) do
			obj = ProtoPublic_pb.ProtoPairObj();
			obj.obj_id = k;
			obj.obj_value = v;
			cmd.index_item_id:addToList(obj);
		end
		sendMsg(10100629, cmd);
		DataCenter.factionData:clearDonateEquipList();
	end
end