Lua_FactionHuntingData = class("Lua_FactionHuntingData");
function Lua_FactionHuntingData:ctor()
	self:superCall("ctor");
    
    self.result_list = nil;
end

function Lua_FactionHuntingData:dispose()
    self.result_list = nil;
    Lua_CommonUtil.removeTimer(self, self.onShowFightResult);
end

function Lua_FactionHuntingData:sFactionFactionHuntingMsg()--守猎界面信息
    sendMsg(10100649);
end

function Lua_FactionHuntingData:sPaymentStoneMsg(id,num)--缴纳灵石
    local cmd = ProtoPublic_pb.Proto10100650(); 
    cmd.item_id = id;--喂养物品ID
    cmd.feed_num = num;--数量
    sendMsg(10100650, cmd)
end

function Lua_FactionHuntingData:sOpenFactionHuntingMsg(type,id)--开启守猎
    sendMsg(10100651)
end 

function Lua_FactionHuntingData:sOpenFactionHuntingSceneMsg()--进入守猎场景
    sendMsg(10100652)
end

function Lua_FactionHuntingData:sGoFactionHuntingSceneMsg()--守猎场景初始化
    sendMsg(10400851)
end

function Lua_FactionHuntingData:sOpenFactionHuntingRankMsg()--守猎排行榜
    sendMsg(10400852)
end

function Lua_FactionHuntingData:goFactionHuntingInfo(msg)--守猎界面返回信息
    if msg == nil then
        return
    end
    self.hunting_list = {};
    self.hunting_list.openTimes = msg.open_times;--挑点次数
    self.hunting_list.donateAmount = msg.donate_amount;--拥有灵石数量
    -- self.hunting_list.averageLevel = msg.average_level;--世界平均等级
    self.hunting_list.openState = msg.open_state;--开启宁守猎状态
    self.hunting_list.leftTime = msg.left_time;--剩余时间
    self.hunting_list.rights = msg.rights;--权限
    self.hunting_list.isOpenMen = msg.opener;--是否为开启人

end

function Lua_FactionHuntingData:goFactionHuntingSceneInfo(msg)--守猎战斗返回信息
    if msg == nil then
        return
    end
    self.combat_list = {};
    self.combat_list.leftTime = msg.left_time;--剩余时间
    self.combat_list.cur = msg.cur;--当前血量
    self.combat_list.total = msg.total;--总boss数
    self.combat_list.percent = msg.percent;--百分比

    -- print("剩余时间=="..self.combat_list.leftTime)
    -- print("当前boss数=="..self.combat_list.cur)
    -- print("总boss数=="..self.combat_list.total)
    -- print("百分比=="..self.combat_list.percent)
   
end

function Lua_FactionHuntingData:goFactionHuntingRankInfo(msg)--守猎排行界面返回信息

    if msg == nil then
        return
    end

    self.rank_arr = Array() 
    for i,v in ipairs(msg.rank_list) do
        local list = {};
        list.id = i;
        list.rank = v.rank_index;--排名
        list.name = v.role_name;--玩家名字
        list.lvl = v.level;--等级
        list.harm = v.fight_score;--伤害比例
        self.rank_arr:add(list) 
    end
    
    self.rank_list = {};
    self.rank_list.rank = msg.self_info.rank_index;--自己最终排名
    self.rank_list.name = msg.self_info.role_name;--玩家名字
    self.rank_list.lvl = msg.self_info.level;--等级
    self.rank_list.harm = msg.self_info.fight_score;--自己总伤害比例

    -- print("自己最终排名=="..self.rank_list.rank)
    -- print("玩家名字=="..self.rank_list.name)
    -- print("等级=="..self.rank_list.lvl)
    -- print("自己总伤害比例=="..self.rank_list.harm)
    if msg.type == 1 then
        self.result_list = {} --结算
        self.result_list.state = msg.state;
        self.result_list.luckyPlayer = msg.lucky_player;--幸运玩家
        self.result_list.lastPlayer = msg.last_player;--最后一击玩家
        self.result_list.rewardId = msg.reward_id;--获得的奖励ID
        self.result_list.pick_up = msg.pick_up; -- 捡起的物品
        -- print("获得的奖励ID=="..self.result_list.rewardId)
        self.result_list.harm = msg.self_info.fight_score;--自己总伤害比例
        self.result_list.rank = msg.self_info.rank_index;--自己最终排名
        self.result_list.leftTime = msg.left_time --boss死亡剩余时间
    end
end

function Lua_FactionHuntingData:huntingList()
    return self.hunting_list
end

function Lua_FactionHuntingData:combatList()
    return self.combat_list
end

function Lua_FactionHuntingData:rankArr()
    return self.rank_arr
end

function Lua_FactionHuntingData:rankList()
    return self.rank_list
end

function Lua_FactionHuntingData:resultList()
    return self.result_list
end

function Lua_FactionHuntingData.Get:bInHuntingScene()

    local sceneID = DataCenter.factionHuntingUtil.huntSenceId;
    if DataCenter.roleData.sceneId == sceneID then
        return true;
    end
    return false;
end

-- 红点检测
function Lua_FactionHuntingData:checkRedDotSate()
    -- 喂养部分
    local itemId = DataCenter.factionHuntingUtil.openHuntGoods[1];
    if itemId ~= nil then
        local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(itemId);
        if num > 0 then
            DataCenter.redDotData:updateRedDotVoState(10505, true);
            Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10505, val = -1, bShow = true});
        else
            DataCenter.redDotData:updateRedDotVoState(10505, false);
            Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10505, val = -1, bShow = false});
        end
    end

    if self.hunting_list == nil then
        DataCenter.redDotData:updateRedDotVoState(10504, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
        return;
    end

    -- 开启或进入部分
    if DataCenter.factionHuntingUtil.huntLeague > DataCenter.roleData.level then -- 等级未到不能开启也不能进入
        DataCenter.redDotData:updateRedDotVoState(10504, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
        return;
    else
        if self.hunting_list.openState == 0 then--状态判断
            -- 权限
            if self.hunting_list.rights ~= 1 then--职位判断--权限
                DataCenter.redDotData:updateRedDotVoState(10504, false);
                Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
                return;
            end

            if self.hunting_list.openTimes >= DataCenter.factionHuntingUtil.huntTimes then -- 没有次数
                DataCenter.redDotData:updateRedDotVoState(10504, false);
                Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
                return;
            end

            if self.hunting_list.donateAmount < DataCenter.factionHuntingUtil.openHuntGoods[2] then -- 开启消耗不足
                DataCenter.redDotData:updateRedDotVoState(10504, false);
                Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
                return;
            end

            local curTime = tonumber(os.date("%H%M"));
            if curTime < DataCenter.factionHuntingUtil.huntTime[1] or curTime > DataCenter.factionHuntingUtil.huntTime[2] then -- 不在活动时间内
                DataCenter.redDotData:updateRedDotVoState(10504, false);
                Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = false});
                return;
            end

            -- 可以开启
            DataCenter.redDotData:updateRedDotVoState(10504, true);
            Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = true});
        else 
            -- 可以进入
            DataCenter.redDotData:updateRedDotVoState(10504, true);
            Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 10504, val = -1, bShow = true});
        end
    end
end