-- 帮派狩猎配置
checkRequire("Lua_FactionHuntingBossVo")
Lua_FactionHuntingUtil = class("Lua_FactionHuntingUtil");
function Lua_FactionHuntingUtil:ctor()
    self:superCall("ctor");

end

function Lua_FactionHuntingUtil.Get:huntLeague()--帮派守猎开启等级
	return getConfig({"league_const", "league_hunt", "value"});
end

function Lua_FactionHuntingUtil.Get:huntTimes()--守猎每周开启次数
	return getConfig({"league_const", "hunt_times", "value"});
end

function Lua_FactionHuntingUtil.Get:openHuntGoods()--开启守猎的物品
	return getConfig({"league_const", "open_hunt_goods", "arr"});
end

function Lua_FactionHuntingUtil.Get:attendHuntTime()--进入帮派参加守猎需要时间
	return getConfig({"league_const", "attend_hunt_time", "value"});
end

function Lua_FactionHuntingUtil.Get:huntGoods()--上缴灵石物品ID
	return getConfig({"league_const", "hunt_goods", "value"});
end

function Lua_FactionHuntingUtil.Get:huntContri()--上缴每个灵石获得贡献
	return getConfig({"league_const", "hunt_contri", "value"});
end

function Lua_FactionHuntingUtil.Get:storeCapcity()--社團倉庫容量
	return getConfig({"league_const", "store_capcity", "value"});
end

function Lua_FactionHuntingUtil.Get:huntGoodsInfo()
	return getConfig({"item", self.huntGoods});
end

function Lua_FactionHuntingUtil.Get:allHuntBossInfo()
	if self._allHuntBossInfo == nil then
		self._allHuntBossInfo = Array();
		local config = checkRequire("hunt_boss");
		if config ~= nil then
			for i, v in ipairs(config) do
				local vo = Lua_FactionHuntingBossVo.new(i, v);
				self._allHuntBossInfo:add(vo);
			end
		end

		self._allHuntBossInfo:sort("minLv", false);
	end

	return self._allHuntBossInfo;
end

function Lua_FactionHuntingUtil.Get:huntTime()--帮派狩猎可挑战时间
	return getConfig({"league_const", "hunt_time", "arr"});
end

function Lua_FactionHuntingUtil.Get:huntFightEndWaitTime()--帮派狩猎结束等待时间
	return getConfig({"league_const", "hunt_fightEnd_outWaitTime", "value"});
end

function Lua_FactionHuntingUtil:timeStr(num)
	local st = num;
	local h = math.floor(st / 100);
	local m = st - h * 100;
	local s_str = h..":"..Lua_CommonUtil.fixNumerLen(m, 2);
	return s_str;
end

function Lua_FactionHuntingUtil.Get:showTime()--帮派狩猎可挑战时间
	local huntTimes = getConfig({"league_const", "hunt_time", "arr"});
	
	local str1 = self:timeStr(huntTimes[1]);
	local str2 = self:timeStr(huntTimes[2]);
	self.show_Time = str1.."-"..str2;

	return self.show_Time;
end

function Lua_FactionHuntingUtil.Get:maxHuntAmount()--守猎库存上限
	return getConfig({"league_const", "max_hunt_amount", "value"});
end

-- function Lua_FactionHuntingUtil.Get:huntBossId()--帮派守猎bossid
-- 	return getConfig({"league_const", "hunt_boss_id", "value"});
-- end

-- function Lua_FactionHuntingUtil.Get:huntBossRotation()--帮派守猎boss模型初始旋转位置
-- 	return getConfig({"league_const", "hunt_boss_id", "rotation"});
-- end

-- function Lua_FactionHuntingUtil.Get:huntBossPosition()--帮派守猎boss模型初始位置
-- 	return getConfig({"league_const", "hunt_boss_id", "position"});
-- end

-- function Lua_FactionHuntingUtil.Get:huntBossScaling()--帮派守猎boss缩放比例
-- 	return getConfig({"league_const", "hunt_boss_id", "scaling"});
-- end

-- function Lua_FactionHuntingUtil.Get:huntRewardId()--帮派守猎boss奖励ID
-- 	return getConfig({"league_const", "hunt_reward_id", "value"});
-- end

function Lua_FactionHuntingUtil.Get:huntSenceId()--狩猎场景id
	return getConfig({"league_const", "hunt_sence_id", "value"});
end

function Lua_FactionHuntingUtil.Get:huntCloseTime()--自动关闭狩猎结算界面时间
	return getConfig({"league_const", "hunt_close_time", "value"});
end

function Lua_FactionHuntingUtil.Get:huntCloseSenceTime()--自动关闭Tips界面时间
	return getConfig({"league_const", "hunt_close_sence_time", "value"});
end 

function Lua_FactionHuntingUtil.Get:huntStarTime()--星级时间
	return getConfig({"league_const", "hunt_star_time", "arr"});
end

-- 根据世界等级获取奖励id
function Lua_FactionHuntingUtil:getHuntBossInfo()
	local worldLv = DataCenter.roleData.worldLevel;
	local arr = self.allHuntBossInfo;
	local len = arr:getSize();
	for i = 1, len do
		if arr[i]:checkIsBornThis(worldLv) == true then
			return arr[i];
		end
	end

	return nil;
end