-- 帮派联赛
Lua_FactionLeagueActData = class("Lua_FactionLeagueActData");
function Lua_FactionLeagueActData:ctor()
	self:superCall("ctor");
    
    self:dispose();
end

-- 是否在帮派联赛的场景里
function Lua_FactionLeagueActData.Get:bInFactionLeagueActScene()
	if DataCenter.roleData.sceneId == Lua_FactionLeagueActUtil.factionLeagueActSceneId then
		return true;
	end

	return false;
end

function Lua_FactionLeagueActData:dispose()
	self.openDay = 0;
    self.state = 0;
    self.groupInfo = nil;

    self.worshipPalaceLeagueName = "";
    self.worshipPalaceLeader = nil;
    self.worshipPalaceTimes = 0;
    self.worshipPalaceReunion = 0;
    self.worshipPalaceRight = 0;
    self.worshipPalaceSalary = 0;

    self.getInfoTime = 0;
    self.left_time = 0;
    self.first_league = nil;
    self.second_league = nil;
    self.self_rank = 0;
    self.self_score = 0;
    self.count_down = 0;

    self.reunionAllocationFlag = 0;
    self.reunionMemberList = nil;
    self.reunionLeftGoods = nil;

    self.endAllocationFlag = 0;
    self.endMemberList = nil;
    self.endLeftGoods = nil;
    self.endKillName = nil;

    self.actProgressInfo = {};
end

-- 帮派联赛面板信息
function Lua_FactionLeagueActData:actPanelInfoFromServer(msg)
	-- msg.league_list; -- 帮派列表
    -- msg.last_list; 	-- 最后一列
    -- msg.state; -- 状态，1表示有列表，0表示没有
    -- msg.wday; -- 开服天服
    self.state = msg.state;
    self.openDay = msg.wday;
    
    self.groupInfo = {};
    if self.state == 1 then -- 1表示有列表，0表示没有
	    if msg.league_list ~= nil and #msg.league_list > 0 then
	    	for i = 1, #msg.league_list do 
	    		local idx = math.floor((i - 1)/4) + 1;
	    		if self.groupInfo[idx] == nil then
	    			self.groupInfo[idx] = Array();
	    		end
	    		self.groupInfo[idx]:add(msg.league_list[i]);
	    	end
	    end

	    -- if msg.last_list ~= nil and #msg.last_list > 0 then
	    -- 	local arr = Array();
	    -- 	for i = 1, #msg.last_list do 
	    -- 		arr:add(msg.last_list[i]);
	    -- 	end
	    -- 	self.groupInfo[5] = arr;
	    -- else
	    -- 	self.groupInfo[5] = nil;
	    -- end
	end

end

-- 活动开始时间（本/下周..）
function Lua_FactionLeagueActData.Get:actStartWDayStr()
	if self.openDay == nil or self.openDay <= 0 then
		return "";
	end

	local cur = tonumber(os.date("%w"));
	if cur == 0 then
		cur = 7;
	end
	local num = DataCenter.factionLeagueActUtil.actOpenDay;
	local week = DataCenter.factionLeagueActUtil.actOpenWeekArr;
	if week ~= nil and week:getSize() > 0 then
		local len = week:getSize();
		local showDay;
		if self.openDay > num then
			for i = 1, len do
				local day = week[i];
				if day == 0 then
					day = 7;
				end
				if day >= cur then -- 本周了
					showDay = day;
					break;
				end
			end
		else
			for i = 1, len do
				local day = week[i];
				if day == 0 then
					day = 7;
				end
				if day >= cur and day - cur > num - self.openDay then -- 本周了
					showDay = day;
					break;
				end
			end
		end

		if showDay ~= nil then -- 本周
			if showDay == 7 then
				showDay = 0;
			end
			return LanUtil.formateStr(LanUtil.getValue(123933), LanUtil.getValue(100 + showDay));
		else
			showDay = week[1];
			if showDay == 7 then
				showDay = 0;
			end
			return LanUtil.formateStr(LanUtil.getValue(123934), LanUtil.getValue(100 + showDay));
		end 
	end

	-- local cur = tonumber(os.date("%w"));
	-- if cur == 0 then
	-- 	cur = 7;
	-- end
	-- local num = DataCenter.factionLeagueActUtil.actOpenDay;
	-- if self.openDay > num then
	-- 	local week = DataCenter.factionLeagueActUtil.actOpenWeekArr;
	-- 	if week ~= nil and week:getSize() > 0 then
	-- 		local len = week:getSize();
	-- 		local showDay;
	-- 		local startW = self.openDay + (7 - cur);
	-- 		startW = startW - math.floor(startW / 7) * 7; -- 开服是周几
	-- 		local openStartW = startW + num;
	-- 		openStartW = openStartW - math.floor(openStartW / 7) * 7; -- 开服第一次活动是周几
	-- 		if self.openDay - num > 7 - openStartW then
	-- 			for i = 1, len do
	-- 				if week[i] >= cur then -- 本周了
	-- 					showDay = week[i];
	-- 					break;
	-- 				end
	-- 			end
	-- 		end

	-- 		if showDay ~= nil then -- 本周
	-- 			if showDay == 7 then
	-- 				showDay = 0;
	-- 			end
	-- 			return LanUtil.formateStr(LanUtil.getValue(123933), LanUtil.getValue(100 + showDay));
	-- 		else
	-- 			showDay = week[1];
	-- 			if showDay == 7 then
	-- 				showDay = 0;
	-- 			end
	-- 			return LanUtil.formateStr(LanUtil.getValue(123934), LanUtil.getValue(100 + showDay));
	-- 		end 
	-- 	end
	-- else
	-- 	if cur + num - self.openDay > 7 then -- 下周
	-- 		num = cur + self.openDay - num - 7;
	-- 		if num == 7 then
	-- 			num = 0;
	-- 		end
	-- 		return LanUtil.formateStr(LanUtil.getValue(123934), LanUtil.getValue(100 + num));
	-- 	else -- 当前周
	-- 		num = cur + num - self.openDay;
	-- 		return LanUtil.formateStr(LanUtil.getValue(123933), LanUtil.getValue(100 + num));
	-- 	end
	-- end

	return "";
end

-- 英雄殿信息
function Lua_FactionLeagueActData:worshipPalaceInfoFromServer(msg)
	-- msg.league_name; -- 帮派名
    -- msg.leader; 	-- 殿主
    -- msg.times; -- 被膜拜次数
    -- msg.win; -- 蝉联几届
    -- msg.right; -- 是否是帮主,1表示是
    -- msg.salary; -- 是否有工资，0表示没有，1表示有
    -- msg.worship; -- 是否已膜拜，0表示没有，1表示有
    self.worshipPalaceLeagueName = msg.league_name;
    self.worshipPalaceLeader = msg.leader;
    self.worshipPalaceKillCon = msg.kill_con;
    if self.worshipPalaceLeader ~= nil and self.worshipPalaceLeader.role_name ~= nil and self.worshipPalaceLeader.role_name ~= "" then
    	self.worshipPalaceReunion = msg.win;
    	self.worshipPalaceTimes = msg.times;
    	self.worshipPalaceRight = msg.right;
	    self.worshipPalaceSalary = msg.salary;
	    self.worshipPalaceWorship = msg.worship;
    else
    	self.worshipPalaceReunion = 0;
    	self.worshipPalaceTimes = 0;
    	self.worshipPalaceRight = 0;
	    self.worshipPalaceSalary = 0;
	    self.worshipPalaceWorship = 0;
    end
end

-- 赛况
function Lua_FactionLeagueActData:actProgressInfoFromServer(msg)
	-- msg.league_list; -- 列表
    -- msg.type; 	-- 类型
    -- msg.stage; 	-- 当前第几阶段
    self.actProgressInfo[tonumber(msg.type)] = msg;
end

-- 战场情况
function Lua_FactionLeagueActData:actFightingInfoFromServer(msg)
	-- msg.left_time; -- 剩余时间
    -- msg.first_league; 	-- 第一个帮派信息
    -- msg.second_league; -- 第二个帮派信息
    -- msg.self_rank; 	-- 自己排名
    -- msg.self_score; -- 自己积分
    -- msg.count_down; 	-- 倒计时
    self.getInfoTime = getTime();
    self.left_time = msg.left_time;
    self.first_league = msg.first_league;
    self.second_league = msg.second_league;
    self.self_rank = msg.self_rank;
    self.self_score = msg.self_score;
    self.count_down = msg.count_down;
end

function Lua_FactionLeagueActData.Get:fightCountDown()
	local num = self.count_down - (getTime() - self.getInfoTime);
	if num < 0 then
		return 0;
	end
	return num;
end

function Lua_FactionLeagueActData.Get:fightLeftTime()
	local num = self.left_time - (getTime() - self.getInfoTime);
	if num < 0 then
		return 0;
	end
	return num;
end

-- 蝉联奖励
function Lua_FactionLeagueActData:actReunionInfoFromServer(msg)
	-- msg.member_list; -- 分配列表
    -- msg.left_goods; 	-- 剩余物品
    -- msg.dis_flag; -- 是否已分配，0表示未分配
    self.reunionAllocationFlag = msg.dis_flag;
    self.reunionMemberList = msg.member_list;
    self.reunionLeftGoods = msg.left_goods;
end

-- 终结奖励
function Lua_FactionLeagueActData:actEndInfoFromServer(msg)
	-- msg.member_list; -- 分配列表
    -- msg.left_goods; 	-- 剩余物品
    -- msg.dis_flag; -- 是否已分配，0表示未分配
    -- msg.kill_name; -- 终结帮派
    self.endAllocationFlag = msg.dis_flag;
    self.endMemberList = msg.member_list;
    self.endLeftGoods = msg.left_goods;
    self.endKillName = msg.kill_name;
end

function Lua_FactionLeagueActData:resetAllocationList()
	self.allocationInfo = nil;
end

function Lua_FactionLeagueActData:setAllocationListState(roleId, state)
	self.allocationInfo = {};
	self.allocationInfo[roleId] = state;
	Lua_MsgUtil.callFunc("FACTION_ACT_DATA_CHANGE");
end

function Lua_FactionLeagueActData:getAllocationListState(roleId)
	if self.allocationInfo == nil then
		return nil;
	end
	return self.allocationInfo[roleId];
end

function Lua_FactionLeagueActData:getAllocationList()
	local arr = Array();
	if self.allocationInfo ~= nil then
		for k, v in pairs(self.allocationInfo) do
			if v == true then
				arr:add(k);
			end
		end 
	end

	return arr;
end