-- 帮派联赛
checkRequire("Lua_FactionLeagueActData");
checkRequire("Lua_FactionLeagueActUtil");
Lua_FactionLeagueActProxy = class("Lua_FactionLeagueActProxy");
function Lua_FactionLeagueActProxy:ctor()
	self:superCall("ctor");
	DataCenter.factionLeagueActData = Lua_FactionLeagueActData.new();
	DataCenter.factionLeagueActUtil = Lua_FactionLeagueActUtil.new();
	LuaUtil.addLuaMsg(50100661, self, self.rFactionLeagueActPanelInfo);	    	-- 联赛界面信息(返回)
    LuaUtil.addLuaMsg(50100662, self, self.rWorshipPalaceInfo);	    			-- 英雄殿(返回)
    LuaUtil.addLuaMsg(50100663, self, self.rLookFactionLeagueActProgress);		-- 查看赛况(返回)
    LuaUtil.addLuaMsg(50100664, self, self.rEnterFactionLeagueAct);	    		-- 进入联赛(返回)
    LuaUtil.addLuaMsg(50100665, self, self.rWorshipPalaceWorship);              -- 膜拜(返回)
    LuaUtil.addLuaMsg(50100666, self, self.rWorshipPalaceGetReward);            -- 领取奉禄(返回)
    LuaUtil.addLuaMsg(50100667, self, self.rFactionLeagueActReunionInfo);       -- 打开蝉联奖励分配(返回)
    LuaUtil.addLuaMsg(50100668, self, self.rFactionLeagueActReunionAllocation); -- 提交蝉联奖励分配(返回)
    LuaUtil.addLuaMsg(50100669, self, self.rFactionLeagueActEndInfo);           -- 打开终结奖励(返回)
    LuaUtil.addLuaMsg(50100670, self, self.rFactionLeagueActEndAllocation);     -- 提交终结奖励分配(返回)
    LuaUtil.addLuaMsg(50400351, self, self.rFactionLeagueActFightSceneInfo);	-- 战场详情(返回)
    LuaUtil.addLuaMsg(50400353, self, self.rFactionLeagueActRankInfo);	    	-- 排行榜(返回)

    LuaUtil.addLuaMsg(80400386, self, self.rFactionLeagueActFightResult);	    -- 结算信息(主动)
end

-----------------------------------------------------
-- 上行协议

-- 联赛界面信息
function Lua_FactionLeagueActProxy:sFactionLeagueActPanelInfo()
	sendMsg(10100661);
end

-- 英雄殿
function Lua_FactionLeagueActProxy:sWorshipPalaceInfo()
	sendMsg(10100662);
end

-- 查看赛况
function Lua_FactionLeagueActProxy:sLookFactionLeagueActProgress(pType)
	local cmd = ProtoPublic_pb.Proto10100663();
    cmd.type = pType;   -- 类型
    sendMsg(10100663, cmd);
end

-- 进入联赛
function Lua_FactionLeagueActProxy:sEnterFactionLeagueAct()
    sendMsg(10100664);
end

-- 英雄殿膜拜
function Lua_FactionLeagueActProxy:sWorshipPalaceWorship()
	sendMsg(10100665);
end

-- 英雄殿领取俸禄
function Lua_FactionLeagueActProxy:sWorshipPalaceGetReward()
	sendMsg(10100666);
end

-- 打开蝉联奖励分配
function Lua_FactionLeagueActProxy:sFactionLeagueActReunionInfo()
    sendMsg(10100667);
end

-- 提交蝉联奖励分配
function Lua_FactionLeagueActProxy:sFactionLeagueActReunionAllocation(list)
    local cmd = ProtoPublic_pb.Proto10100668();
    if list ~= nil then
        local len = list:getSize();
        for i = 1, len do
            cmd.dis_list:append(tonumber(list[i]));
        end
    end
    sendMsg(10100668, cmd);
end

-- 打开终结奖励
function Lua_FactionLeagueActProxy:sFactionLeagueActEndInfo()
    sendMsg(10100669);
end

-- 提交终结奖励分配
function Lua_FactionLeagueActProxy:sFactionLeagueActEndAllocation(list)
    local cmd = ProtoPublic_pb.Proto10100670();
    if list ~= nil then
        local len = list:getSize();
        for i = 1, len do
            cmd.dis_list:append(tonumber(list[i]));
        end
    end
    sendMsg(10100670, cmd);
end

-- 战场详情
function Lua_FactionLeagueActProxy:sFactionLeagueActFightSceneInfo()
	sendMsg(10400351);
end

-- 排行榜
function Lua_FactionLeagueActProxy:sFactionLeagueActRankInfo()
	sendMsg(10400353);
end

-- 退出场景
function Lua_FactionLeagueActProxy:sExitScene()
	sendMsg(10400902);
end



-----------------------------------------------------
-- 下行协议

-- 联赛界面信息（返回）
function Lua_FactionLeagueActProxy:rFactionLeagueActPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100661();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:actPanelInfoFromServer(msg);
        Lua_MsgUtil.callFunc("rFactionLeagueActPanelInfo");
	end
end

-- 英雄殿（返回）
function Lua_FactionLeagueActProxy:rWorshipPalaceInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100662();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:worshipPalaceInfoFromServer(msg);
        Lua_MsgUtil.callFunc("rWorshipPalaceInfo");
	end
end

-- 查看赛况(返回)
function Lua_FactionLeagueActProxy:rLookFactionLeagueActProgress(mp)
	if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50100663();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:actProgressInfoFromServer(msg);
        Lua_MsgUtil.callFunc("rLookFactionLeagueActProgress", msg.type);
	end
end

-- 进入联赛(返回)
function Lua_FactionLeagueActProxy:rEnterFactionLeagueAct(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_FactionLeagueActWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_WorshipPalaceWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_FactionLeagueActProgressWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_FactionLeagueActAllocationWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_FactionLeagueActReunionWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_FactionLeagueActEndWindow", WinParam.ACTION_CLOSE, nil);
    end
end

-- 膜拜(返回)
function Lua_FactionLeagueActProxy:rWorshipPalaceWorship(mp)
	if mp.errno == 0 then
        
	end
end

-- 领取奉禄(返回)
function Lua_FactionLeagueActProxy:rWorshipPalaceGetReward(mp)
	if mp.errno == 0 then
        
	end
end

-- 打开蝉联奖励分配(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActReunionInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50100667();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:actReunionInfoFromServer(msg)
        Lua_MsgUtil.callFunc("rFactionLeagueActReunionInfo");
    end
end

-- 提交蝉联奖励分配(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActReunionAllocation(mp)
    if mp.errno == 0 then
        
    end
end

-- 打开终结奖励(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActEndInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50100669();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:actEndInfoFromServer(msg)
        Lua_MsgUtil.callFunc("rFactionLeagueActEndInfo");
    end
end

-- 提交终结奖励分配(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActEndAllocation(mp)
    if mp.errno == 0 then
        
    end
end

-- 战场详情(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActFightSceneInfo(mp)
	if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto50400351();
        msg:ParseFromString(mp.data);
        DataCenter.factionLeagueActData:actFightingInfoFromServer(msg)
        Lua_MsgUtil.callFunc("rFactionLeagueActFightSceneInfo");
	end
end

-- 排行榜(返回)
function Lua_FactionLeagueActProxy:rFactionLeagueActRankInfo(mp)
	if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto50400353();
        msg:ParseFromString(mp.data);
        -- msg.rank; 	-- 列表
        Lua_MsgUtil.callFunc("rFactionLeagueActRankInfo", msg);
	end
end

-- 结算信息(主动)
function Lua_FactionLeagueActProxy:rFactionLeagueActFightResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400386();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_FactionLeagueActFightResultWindow", WinParam.ACTION_OPEN, msg);
	end
end