-- 蝉联奖励vo
Lua_FactionLeagueActReunionVo = class("Lua_FactionLeagueActReunionVo");
function Lua_FactionLeagueActReunionVo:ctor(id, config)
    self.id = id;
    if config == nil then
    	config = getConfig({"league_battle_con_reward", id});
    end
    self.config = config;
end

function Lua_FactionLeagueActReunionVo.Get:minWorldLv()
	return tonumber(self.config.level_range[1]);
end

function Lua_FactionLeagueActReunionVo.Get:maxWorldLv()
	return tonumber(self.config.level_range[2]);
end

function Lua_FactionLeagueActReunionVo.Get:reunionRewardsArr()
	if self._reunionRewardsArr == nil then
		self._reunionRewardsArr = Array();
		local list = self.config.reward;
		if list ~= nil then
			for i = 1, #list do
				local obj = list[i];
				local vo = Lua_ToolVo.createToolVo(tonumber(obj[1]), tonumber(obj[2]));
				self._reunionRewardsArr:add(vo);
			end
		end
	end
	return self._reunionRewardsArr;
end

function Lua_FactionLeagueActReunionVo.Get:endRewardsArr()
	if self._endRewardsArr == nil then
		self._endRewardsArr = Array();
		local list = self.config.kill_reward;
		if list ~= nil then
			for i = 1, #list do
				local obj = list[i];
				local vo = Lua_ToolVo.createToolVo(tonumber(obj[1]), tonumber(obj[2]));
				self._endRewardsArr:add(vo);
			end
		end
	end
	return self._endRewardsArr;
end

function Lua_FactionLeagueActReunionVo.Get:buffVoArr()
	if self._buffVoArr == nil then
		self._buffVoArr = Array();
		local list = self.config.buf_prop;
		if list ~= nil then
			for i = 1, #list do
				local num = tonumber(list[i]);
				if num > 0 then
					local buffVo = Lua_BuffVo.new(getConfig({"league_battle_const", "attackor_buff", "arr"})[i]);
					buffVo.value2 = num;
					self._buffVoArr:add(buffVo);
				end
			end
		end
	end
	return self._buffVoArr;
end

function Lua_FactionLeagueActReunionVo.Get:buffItemVoArr()
	if self._buffItemVoArr == nil then
		self._buffItemVoArr = Array();
		local list = self.config.buf_prop;
		if list ~= nil then
			for i = 1, #list do
				local num = tonumber(list[i]);
				if num > 0 then
					local vo = Lua_ToolVo.createToolVo(getConfig({"league_battle_const", "attackorBuff_itemId", "arr"})[i]);
					local buffVo = Lua_BuffVo.new(getConfig({"league_battle_const", "attackor_buff", "arr"})[i]);
					buffVo.value2 = num;
					vo.buffDesc = buffVo.des;
					print("buffVo.des = ", buffVo.des);
					self._buffItemVoArr:add(vo);
				end
			end
		end
	end
	return self._buffItemVoArr;
end