-- 帮派联赛
checkRequire("Lua_FactionLeagueActReunionVo");
Lua_FactionLeagueActUtil = class("Lua_FactionLeagueActUtil");
Lua_FactionLeagueActUtil.factionLeagueActSceneId = 30301;
Lua_FactionLeagueActUtil.TYPE_REUNION = 1;
Lua_FactionLeagueActUtil.TYPE_END = 2;
function Lua_FactionLeagueActUtil:ctor()
end

function Lua_FactionLeagueActUtil:getRankNameByIdx(idx)
	if self._rankNameArr == nil then
		local str = LanUtil.getValue(123968);
		if str ~= nil and str ~= "123968" then
			self._rankNameArr = str:split("、");
		end
		if self._rankNameArr == nil then
			self._rankNameArr = Array();
		end
	end

	if self._rankNameArr[idx] == nil then
		return LanUtil.getValue(123969);
	end
	return self._rankNameArr[idx];
end

function Lua_FactionLeagueActUtil.Get:actVoArr()
	if self._actVoArr == nil then
		self._actVoArr = Array();

		local list = getConfig({"league_battle_const", "activity_list", "arr"});
		if list ~= nil then
			for i = 1, #list do
				local vo = DataCenter.xianshiData:getDataById(tonumber(list[i]));
				if vo ~= nil then
					self._actVoArr:add(vo);
				end
			end
		end
		self._actVoArr:sort("id", false);
	end
	return self._actVoArr;
end

-- 开服天数限制
function Lua_FactionLeagueActUtil.Get:actOpenDay()
	local arr = self.actVoArr;
	if arr:getSize() > 0 then
		return arr[1].open_day;
	end
	return 0;
end

-- 每周开启周几
function Lua_FactionLeagueActUtil.Get:actOpenWeekArr()
	local arr = self.actVoArr;
	if arr:getSize() > 0 then
		return arr[1].weekArr;
	end
	return nil;
end

-- 轮次时间
function Lua_FactionLeagueActUtil:getActRoundTime(roundTimes)
	local arr = self.actVoArr;
	if arr:getSize() >= roundTimes then
		return arr[roundTimes].timeStr;
	end
	return "";
end

-- 活动胜利需要积分
function Lua_FactionLeagueActUtil.Get:actWinNeedScore()
	return getConfig({"league_battle_const", "win_score", "value"});
end

-- 结算界面自动关闭时间
function Lua_FactionLeagueActUtil.Get:actResultCloseTime()
	return getConfig({"league_battle_const", "quit_time", "value"});
end

-- 每日俸禄
function Lua_FactionLeagueActUtil:getEveryDayReward(pos)
	if pos == Lua_FactionDefine.FACTION_POS_ELITE then	--精英
		return getConfig({"league_battle_const", "salary_reward", "arr"})[3];
	elseif pos == Lua_FactionDefine.FACTION_POS_DEPUTY_LEADER then--副帮主
		return getConfig({"league_battle_const", "salary_reward", "arr"})[2];
	elseif pos == Lua_FactionDefine.FACTION_POS_LEADER then--帮主
		return getConfig({"league_battle_const", "salary_reward", "arr"})[1];
	-- elseif pos == Lua_FactionDefine.FACTION_POS_NORMAL then -- 帮众
	-- 	return LanUtil.getValue(121008);
	end
	return getConfig({"league_battle_const", "salary_reward", "arr"})[4];
end

-- 帮主特权 
function Lua_FactionLeagueActUtil:getLeagueLeaderRewardArr()
	if self.leaderArr == nil then
		self.leaderArr = Array();
		local list = getConfig({"league_battle_const", "leagueleader_itemId", "arr"});
		if list ~= nil then
			for i = 1, #list do
				local vo = Lua_ToolVo.createToolVo(tonumber(list[i]));
				self.leaderArr:add(vo);
			end
		end
	end

	return self.leaderArr;
end

-- 蝉联奖励
function Lua_FactionLeagueActUtil:getActReunionRewards()
	local worldLv = DataCenter.roleData.worldLevel;
	local resultArr = Array();
	local info = self.actReunionRewardInfo;
	for k, v in pairs(info) do
		local len = v:getSize();
		for i = 1, len do
			local vo = v[i];
			if vo.minWorldLv <= worldLv and worldLv <= vo.maxWorldLv then
				resultArr:add({num = tonumber(k), vo = vo});
				break;
			end
		end
	end
	return resultArr;
end

function Lua_FactionLeagueActUtil:getActEndVoByNum(idx)
	local worldLv = DataCenter.roleData.worldLevel;
	local arr = self.actReunionRewardInfo[tonumber(idx)];
	if arr == nil then
		if idx < self.minReunionNum then
			arr = self.actReunionRewardInfo[self.minReunionNum];
		elseif idx > self.maxReunionNum then
			arr = self.actReunionRewardInfo[self.maxReunionNum];
		end
	end

	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			local vo = arr[i];
			if vo.minWorldLv <= worldLv and worldLv <= vo.maxWorldLv then
				return vo;
			end
		end
	end
	return nil;
end

function Lua_FactionLeagueActUtil.Get:actReunionRewardInfo()
	if self._actReunionRewardInfo == nil then
		self.minReunionNum = 9999999;
		self.maxReunionNum = 0;
		self._actReunionRewardInfo = {};
		local config = checkRequire("league_battle_con_reward");
		for k, v in ipairs(config) do
			if v.range ~= nil and #v.range >= 2 then
				local vo = Lua_FactionLeagueActReunionVo.new(k, v);
				local min = tonumber(v.range[1]);
				local max = tonumber(v.range[2]);
				for i = min, max do
					if self._actReunionRewardInfo[i] == nil then
						self._actReunionRewardInfo[i] = Array();
					end
					self._actReunionRewardInfo[i]:add(vo);

					if self.minReunionNum > i then
						self.minReunionNum = i;
					end
					if self.maxReunionNum < i then
						self.maxReunionNum = i;
					end 
				end
			end
		end

		for k, v in pairs(self._actReunionRewardInfo) do
			v:sort("minWorldLv", false);
		end
	end
	return self._actReunionRewardInfo;
end

-- 清除墙
function Lua_FactionLeagueActUtil.Get:clearWavesArr()
	if self._clearWavesArr == nil then
		self._clearWavesArr = Array();
		local list = getConfig({"league_battle_const", "clear_waves", "arr"});
		if list ~= nil and #list > 0 then
			for i = 1, #list do
				self._clearWavesArr:add(list[i]);
			end
		end
	end
	return self._clearWavesArr;
end