Lua_FairyVo = class("Lua_FairyVo");
function Lua_FairyVo:ctor(index)
	self.index = index;

	self.validTick = self.fairyConfig.valid_tick;
	self.fairyId = self.fairyConfig.fairy_id;
	self.itemId = self.fairyConfig.item_id;
	self.addAutopickRage = self.fairyConfig.add_autopick_rage;
	self.property = self.fairyConfig.property;
	self.effect = self.fairyConfig.effect;
	self.sceneIdArr = self.fairyConfig.scene_id;

	self.isCanRenew = self.fairyConfig.is_can_renew ~= 0;
	self.isShow = self.fairyConfig.is_show == 1;
	self.show_lvl = self.fairyConfig.show_lvl ~= nil and self.fairyConfig.show_lvl or nil;

	self.isEquiped = false;
end

function Lua_FairyVo.Get:fairyConfig()
	if self._fairyConfig == nil then
		self._fairyConfig = getConfig({"fairy"})[self.index];
	end
	return self._fairyConfig;
end

function Lua_FairyVo:fromServer(data)
	self.isEquiped = false;
	
	local fairyInfo = data.fairy_info;
	if fairyInfo.fairy_type == self.index then
		self.isEquiped = true;
		self.activeTimes = fairyInfo.active_times;
		self.expireTimes = fairyInfo.expire_times;
		self.validTimes = fairyInfo.valid_times;
		self.isUsed = fairyInfo.is_use;
	end
end

function Lua_FairyVo.Get:bExpire()
	if self.expireTimes == nil then
		return true;
	end
	if self.expireTimes - DataCenter.roleData.serverTime > 0 then
		return false;
	end
	return true;
end

function Lua_FairyVo.Get:toolVo()
	if self._toolVo == nil then
		self._toolVo = Lua_ToolVo.new(self.itemId)
	end
	return self._toolVo;
end

function Lua_FairyVo.Get:name()
	return self.toolVo.name;
end

function Lua_FairyVo.Get:autopickLimit()
	return self.fairyConfig.autopick_limit;
end

function Lua_FairyVo.Get:referenceIndex()
	return self.fairyConfig.referenceIndex;
end

function Lua_FairyVo.Get:des()
	return self.fairyConfig.des;
end

function Lua_FairyVo.Get:tipsDes1()
	if self.fairyConfig.tips_des ~= nil then
		return self.fairyConfig.tips_des.des1;
	end
	return "";
end

function Lua_FairyVo.Get:tipsDes2()
	if self.fairyConfig.tips_des ~= nil then
		return self.fairyConfig.tips_des.des2;
	end
	return "";
end