checkRequire("Lua_FashionVo");
checkRequire("Lua_FashionSuitVo");
Lua_FashionData = class("Lua_FashionData");
function Lua_FashionData:ctor()
	self:dispose();
end

function Lua_FashionData:dispose()
	self.defaultItems = {};
	self.defaultSuits = {};
	self.isWear_list = {};
	self._id = nil;
	if self._fashion_infoList ~= nil then
		self._fashion_infoList = nil
	end
end

function Lua_FashionData:sWearFashion(fashionId)
	local msg = ProtoPublic_pb.Proto11402605();
	msg.fashion_id = fashionId;
	sendMsg(11402605, msg);
end

function Lua_FashionData:sActivateSuit(suitId)
	local msg = ProtoPublic_pb.Proto11402607();
	msg.suit_id = suitId;
	sendMsg(11402607, msg);
end

function Lua_FashionData:fromServer51402601(list)
	for i,v in pairs(list) do
		if self.fashion_infoList[v.fashion_id]~= nil then
			self.fashion_infoList[v.fashion_id]:fromServer(v);
		end
	end

	for i,v in pairs(list) do
		if v.is_wear == 1 then 
			self.isWear_list[i] = v.fashion_id;
		end
	end
end

function Lua_FashionData:fromServer51402602(msg)
	for i,v in ipairs(msg) do
		self.fashion_infoList[v.fashion_id]:fromServer(v);
	end
end

function Lua_FashionData:fromServer51402603(msg)
	self.fashion_infoList[msg.fashion_id]:fromServer(msg);
end

function Lua_FashionData:unLoadFashion(id)
	self.unloadid = id;
	if self.unloadid ~= 0 then
		self.fashion_infoList[self.unloadid].is_wear = 0;
	end
end

function Lua_FashionData:saveCurrentid(id)
	self.currentid = id;
	self.fashion_infoList[self.currentid].is_wear = 1;
end

function Lua_FashionData:fromServer51402606(msg)
	self.acti_suit_list = msg.acti_suit_list; -- 已激活套装id
	self.acti_item_list = msg.acti_item_list; -- 已激活物品id
	Lua_MsgUtil.callFunc("FASHION_SUIT_UPDATE");
end

function Lua_FashionData:fromServer51402607(msg)
	self.acti_suit_list = msg.acti_suit_list; -- 已激活套装id
	Lua_MsgUtil.callFunc("FASHION_SUIT_UPDATE");
end





function Lua_FashionData:getItemByType(type)
	local itemConfig;
	local playerLv = DataCenter.roleData.level;
	local fashion_info = Array();
	for i,v in pairs(self.fashion_infoList) do
		itemConfig = Lua_WingUtil.getItemData(v.itemId);
		if v.type == type and tonumber(itemConfig.visible_lvl) <= playerLv then
			fashion_info:add(v);
		end
	end

	fashion_info:sort("sortNum", false);
	return fashion_info;
end

function Lua_FashionData:getDefaultItem(t)
	return self.defaultItems[t];
end

function Lua_FashionData:getDefaultItemId(t)
	if self.defaultItems[t] == nil then
		local rd = DataCenter.roleData;
		if t == 1 then
			return rd.fashion_clothes_id;
		elseif t == 2 then
			return rd.fashion_weapon_id;
		elseif t == 3 then
			return rd.fashionHeadId;
		end
	else
		return self.defaultItems[t].itemId;
	end
end

function Lua_FashionData:setDefaultItem(t, data)
	self.defaultItems[t] = data;
end

function Lua_FashionData:clearDefaultData()
	self.defaultItems = {};
end

function Lua_FashionData.Get:fashion_infoList()
	if self._fashion_infoList == nil then
		self._fashion_infoList = {};
		local careernum = DataCenter.roleData.career;
		self.allFasions = getConfig({ "fashion", "all_fashion_id"});
		for i,v in pairs(self.allFasions) do
			local single_info = Lua_FashionVo.new(v);
			if single_info.career == careernum or single_info.career == 0 then
				self._fashion_infoList[tonumber(v)] = single_info;
			end
		end
	end
	return self._fashion_infoList;
end

-- function Lua_FashionData:addOneItem(oneItem)
-- 	if self.fashion_infoList[oneItem.fashion_id] == nil then
-- 		self.fashion_infoList[oneItem.fashion_id] = oneItem;
-- 	end
-- end

-- function Lua_FashionData:removeOneItem(oneItem)
-- 	if self.fashion_infoList[oneItem.fashion_id] == nil then
-- 		return;
-- 	end

-- 	if self.fashion_infoList[oneItem.fashion_id] ~= nil then
-- 		self.fashion_infoList[oneItem.fashion_id]=nil
-- 	end
-- end

-- function Lua_FashionData:removeItems(list)
-- 	for i,v in ipairs(list) do
-- 		self:removeOneItemByIndex(v);
-- 	end
-- end

function Lua_FashionData:getItemByItemId(id)
	if self.fashion_infoList[id] == nil then
		return nil;
	end
	return self.fashion_infoList[id];
end

function Lua_FashionData.Get:getFashionSuitInfo() -- 适合的所有套装ID
	self.fashionSuitInfo = Array();
	
	local vo;
	local config = getConfig({"suit"});
	if config ~= nil then
		for k, v in pairs(config) do
			vo = Lua_FashionSuitVo.new(k, v);
			if v.career == DataCenter.roleData.career or v.career == 0 then
				self.fashionSuitInfo:add(vo);
			end
		end
	end

	self.fashionSuitInfo:sort("id", false);
	return self.fashionSuitInfo;
end

function Lua_FashionData.Get:getFashionSuitClass() --用于套装界面页签显示
	if self.arr == nil then
		self.arr = getConfig({ "fashionSuit_class" });
	end

	local fashionSuitClass = Array();
	for k,v in pairs(self.arr) do
		local sub1 = Array();
		for i = 1, self.getFashionSuitInfo:getSize() do
			if self.getFashionSuitInfo[i].isActivateSuit == true and v.isActivate == 1 then --已激活套装
				sub1:add({ name = self.getFashionSuitInfo[i].isActiSuit_name, data = self.getFashionSuitInfo[i] });
			elseif self.getFashionSuitInfo[i].isActivateSuit == false and v.isActivate == 0 then --未激活套装
				sub1:add({ name = self.getFashionSuitInfo[i].unActiSuit_name, data = self.getFashionSuitInfo[i] });
			end
		end

		local class_name;
		local totalNum = self.getFashionSuitInfo:getSize();
		local isActivateNum = #self.acti_suit_list;
		if v.isActivate == 1 then
			class_name = v.suit_class_name .. "("..isActivateNum..")";
		elseif v.isActivate == 0 then
			class_name = v.suit_class_name .. "("..tostring(totalNum - isActivateNum)..")";
		end
		fashionSuitClass:add({ name = class_name, sub = sub1 });
	end
	return fashionSuitClass;
end

-- 套装 class 列表红点更新
function Lua_FashionData.Get:updateClassRedList()
	if self.arr == nil then
		self.arr = getConfig({ "fashionSuit_class" });
	end

	local isRedList = {};
	for k,v in pairs(self.arr) do
		local len = self.getFashionSuitInfo:getSize()
		for i = 1, len do
			if self.getFashionSuitInfo[i].isActivateSuit == true and v.isActivate == 1 then --已激活套装
				isRedList[k] = false;
			elseif self.getFashionSuitInfo[i].isActivateSuit == false and v.isActivate == 0 then --未激活套装
				local total_itemNum = self.getFashionSuitInfo[i].itemArr:getSize();
				local isActivate_itemNum = 0;
				for j=1,total_itemNum do
					if self.getFashionSuitInfo[i].itemArr[j].isActivate == true then
						isActivate_itemNum = isActivate_itemNum + 1;
					end
				end
				if isActivate_itemNum == total_itemNum then
					isRedList[k] = true;
				end
			end
		end
	end
	return isRedList;
end

-- 套装 Sub 列表红点更新
function Lua_FashionData.Get:updateSubRedList()
	if self.arr == nil then
		self.arr = getConfig({ "fashionSuit_class" });
	end

	local suitInfo = self.getFashionSuitInfo;
	local len = suitInfo:getSize();
	local arr = Array();
	for i = 1, len do
		if suitInfo[i].isActivateSuit ~= true then --未激活套装
			arr:add(suitInfo[i]);
		end
	end

	local isRedList = {};
	local len1 = len - arr:getSize(); -- 已激活长度
	for k,v in pairs(self.arr) do
		isRedList[k] = {};
		if k == 1 then -- 已激活套装
			for i = 1, len1  do
				isRedList[k][i] = false;
			end
		end

		if k == 2 then -- 未激活套装
			for i = 1,arr:getSize() do
				isRedList[k][i] = arr[i].isActivateId;
			end
		end
	end
	return isRedList;
end

-- 根据self._id得到btn索引和道具索引
function Lua_FashionData.Get:getIndex()
	local btn_index;
	local item_index;
	local list = {};
	if self._id ~= nil then
		for i = 1, 6 do
			local arr = self:getItemByType(i);
			for j = 1, arr:getSize() do
				if arr[j].id == self._id then
					btn_index = i;
					item_index = j;
					break;
				elseif arr[j].shard_id == self._id then
					btn_index = i;
					item_index = j;
					break;
				end
			end
		end
		list.btn_index = btn_index;
		list.item_index = item_index;
		return list;
	end
end

-- 根据id判断是道具id还是碎片id，得到道具id和特效名
function Lua_FashionData:getItem(id)
	local _id;
	local _effectName;
	local list = {};
	local arr = self:getItemByType(6);
	for i=1,arr:getSize() do
		if arr[i].id == id then
			_id = arr[i].id;
			_effectName = arr[i].effectName;
			break;
		elseif arr[i].shard_id == id then
			_id = arr[i].id;
			_effectName = arr[i].effectName;
			break;
		end
	end
	list.id = _id;
	list.effectName = _effectName;
	return list;
end

-- 是否穿戴中
function Lua_FashionData:isDress(_type)
	local arr = DataCenter.FashionData:getItemByType(_type);
	for i=1,arr:getSize() do
		if arr[i].is_wear == 1 then
			return true;
		end
	end
	return false;
end

-- 已穿戴索引
function Lua_FashionData:getDressIndex(_type)
	local arr = DataCenter.FashionData:getItemByType(_type);
	for i = 1, arr:getSize() do
		if arr[i].is_wear == 1 then
			return i;
		end
	end
	return nil;
end

-- 是否激活
function Lua_FashionData:isActivate(_type, id)
	local arr = DataCenter.FashionData:getItemByType(_type);
	for i = 1,arr:getSize() do
		if arr[i].id == id then
			if arr[i].active_type == 1 then
				return true;
			end
		end
	end
	return false;
end

-- 背景特效位置、缩放
function Lua_FashionData:getBgEffectOffset(id, offset)
	return getConfig({"fashionBg_effect", id, offset});
end

-- 根据类型获取已经穿戴的数据
function Lua_FashionData:getIsWearDataByType(_type)
	local arr = self:getItemByType(_type);
	local data;
	for i = 1,arr:getSize() do
		if arr[i].is_wear == 1 then
			data = arr[i];
			break;
		end
	end
	return data;
end