Lua_FashionSuitVo = class("Lua_FashionSuitVo");
function Lua_FashionSuitVo:ctor(id, config)
	self.id = id;
	self.config = config;
end

-- 法宝位置
function Lua_FashionSuitVo.Get:magicweapon_pos()
	return self.config.magicweapon_pos;
end

-- 人物位置
function Lua_FashionSuitVo.Get:person_pos()
	return self.config.person_pos;
end

-- 人物朝向
function Lua_FashionSuitVo.Get:person_rot()
	return self.config.person_rot;
end

-- 人物缩放
function Lua_FashionSuitVo.Get:person_sca()
	return self.config.person_sca;
end

-- 侍宠位置
function Lua_FashionSuitVo.Get:servant_pos()
	return self.config.servant_pos;
end

-- 侍宠朝向
function Lua_FashionSuitVo.Get:servant_rot()
	return self.config.servant_rot;
end

-- 侍宠缩放
function Lua_FashionSuitVo.Get:servant_sca()
	return self.config.servant_sca;
end

-- 职业
function Lua_FashionSuitVo.Get:career()
	return self.config.career;
end

-- 套装道具id（模型id）
function Lua_FashionSuitVo.Get:suit_item()
	return self.config.suit_item;
end

-- 对应物品id（道具id）
function Lua_FashionSuitVo.Get:get_item_id()
	return self.config.get_item_id;
end

-- 套装名称
function Lua_FashionSuitVo.Get:suit_name()
	return self.config.suit_name;
end

-- 已激活套装id
function Lua_FashionSuitVo.Get:getActivateSuitList()
    local list = {};
    if DataCenter.FashionData.acti_suit_list ~= nil then
	    for i,v in ipairs(DataCenter.FashionData.acti_suit_list) do
	        list[v] = 1;
	    end
	end
    return list;
end

-- 已激活套装
function Lua_FashionSuitVo.Get:isActivateSuit()
	if self.getActivateSuitList[self.id] == 1 then
		return true;
	end
	return false;
end

-- 已激活物品id
function Lua_FashionSuitVo.Get:getActivateItemList()
	local list = {}
    if DataCenter.FashionData.acti_item_list ~= nil then
	    for i,v in ipairs(DataCenter.FashionData.acti_item_list) do
			list[v] = true;
	    end
	end
	return list;
end

function Lua_FashionSuitVo.Get:itemArr()
	local arr = Array();
	local _list = self.get_item_id;
	for i,v in ipairs(self.suit_item) do
		arr:add({id = _list[i], isActivate = self.getActivateItemList[v]});
	end
	return arr;
end

function Lua_FashionSuitVo.Get:isActivateId()
	local arr = self.itemArr;
	for j = 1, arr:getSize() do
		if arr[j].isActivate ~= true then
			return false;
		end
	end
	return true;
end

-- 激活的套装名称
function Lua_FashionSuitVo.Get:isActiSuit_name()
	local total_itemNum = self.itemArr:getSize();
	return self.suit_name .. "("..total_itemNum.."/"..total_itemNum..")";
end

-- 未激活的套装名称
function Lua_FashionSuitVo.Get:unActiSuit_name()
	local total_itemNum = self.itemArr:getSize();
	local isActivate_num = 0;
	for i = 1, total_itemNum do
		if self.itemArr[i].isActivate == true then
			isActivate_num = isActivate_num + 1;
		end
	end
	return self.suit_name.."("..isActivate_num.."/"..total_itemNum..")";
end