checkRequire("Lua_FestivalCarnivalEventVo")
Lua_FestivalCarnivalData = class("Lua_FestivalCarnivalData");
function Lua_FestivalCarnivalData:ctor()
end

function Lua_FestivalCarnivalData:sFestivalCarnivalInfo()
	sendMsg(10105311);
end

function Lua_FestivalCarnivalData:sFestivalCarnivalExchange(data)
	local cmd = ProtoPublic_pb.Proto10105312();
	cmd.index = data.index;
	cmd.money_temp = data.money_temp;
	cmd.times = data.times
	sendMsg(10105312, cmd);
end

function Lua_FestivalCarnivalData:fromServer50105311(msg)
	if msg == nil then
		return;
	end

	self.act_index = msg.act_index; -- 活动索引
	self.end_tick = msg.end_tick; -- 活动结束时间
	self.wolrd_submit = msg.wolrd_submit; -- 世界提交进度
	self.world_reward = msg.world_reward; -- 世界提交进度奖励
	self.persen_sumit = msg.persen_sumit; -- 个人提交进度
	self.persen_reward = msg.persen_reward; -- 个人提交进度奖励
	self.persen_submit_reward = msg.persen_submit_reward; -- 个人兑换奖励
	self.title = msg.title;
	self.icon = msg.icon;
	self.content = msg.content; -- 规则说明
	self.rare_reward_show = msg.rare_reward_show; -- 珍稀道具展示
	self.rand_reward_show = msg.rand_reward_show; -- 随机道具展示
end

function Lua_FestivalCarnivalData.Get:rewardShowList()
	local arr = Array();
	local list1 = {};
	list1.rewardList = Array();
	list1.title = LanUtil.getValue(128711);
	for k, v in ipairs(self.rare_reward_show) do
		list1.rewardList:add(v);
	end
	arr:add (list1);

	local list2 = {};
	list2.rewardList = Array();
	list2.title = LanUtil.getValue(128712);
	for i, j in ipairs(self.rand_reward_show) do
		list2.rewardList:add(j);
	end
	arr:add (list2);
	return arr;
end

function Lua_FestivalCarnivalData.Get:worldList()
	local arr = Array()
	if self.world_reward ~= nil then
		local eventVo;
		for i = 1, #self.world_reward do
			eventVo = Lua_FestivalCarnivalEventVo.new(self.world_reward[i].events[1].events)
			eventVo:fromServer(self.world_reward[i])
			arr:add(eventVo)
		end
	end
	return arr;
end

function Lua_FestivalCarnivalData.Get:persenList()
	local arr = Array();
	if self.persen_reward ~= nil then
		for i = 1, #self.persen_reward do
			arr:add({rewardId = self.persen_reward[i].rewards, sum_progress = self.persen_reward[i].acc_submit});
		end
		arr:sort("sum_progress", false);
	end
	return arr;
end

function Lua_FestivalCarnivalData.rewardList(val)
	local itemList = Array();
	local itemDic = {};
	local dtidx = 1;
	local step = 1;
	for i = 1, val:getSize() do
		local tr = Lua_RewardsUtil.getRewardList(val[i]);
		local rewards = tr.rewards;
		local dropMarks = tr.dropMarks;
		for k, v in ipairs(rewards) do
			dtidx = dtidx + 1;
			local str = v.id .. v.bind .. v.star;
			local inObj = itemDic[str];
			if inObj == nil then
				inObj = {};
				inObj.id = v.id;
				inObj.amount = v.amount;
				inObj.bind = v.bind;
				inObj.star = v.star;
				inObj.attr = v.attr;
				inObj.step = step;
				inObj.bShowItemBg = bShowItemBg;
				if roundEffect ~= nil then
					inObj.roundEffect = roundEffect;
				else
					inObj.roundEffect = v.roundEffect;
				end
				step = step + 1;

				if dropMarks ~= nil and table.indexOf(dropMarks, k - 1) ~= -1 then
					inObj.mustDrop = true;
				end
				itemDic[str] = inObj;
			else
				inObj.amount = inObj.amount + v.amount;
			end
		end
	end

	for k, v in pairs(itemDic) do
		itemList:add(v);
	end
	itemList:sort("step", false);
	return itemList;
end

function Lua_FestivalCarnivalData.Get:exchangeList()
	local arr = Array()
	if self.persen_submit_reward ~= nil then
		local obj;
		local list;
		for i = 1, #self.persen_submit_reward do
			obj = self.persen_submit_reward[i];
			
			list = {};
			list.index = obj.index;
			list.money = tonumber(tostring(obj.temp_money.gold));
			list.item = Lua_ToolVo.createToolVo(obj.need_item[1].id);
			list.need_count = obj.need_item[1].amount;
			list.exchange_start_tick = tonumber(tostring(obj.start_tick));
			list.exchange_end_tick = tonumber(tostring(obj.end_tick));
			list.daily_start = tonumber(tostring(obj.daily_start));
			list.daily_end = tonumber(tostring(obj.daily_end));
			arr:add(list);
		end
	end
	return arr;
end

function Lua_FestivalCarnivalData.Get:theme()
	return self._theme;
end

function Lua_FestivalCarnivalData.Set:theme(value)
	self._theme = value;
end

function Lua_FestivalCarnivalData.Get:end_time()
	return self._end_time;
end

function Lua_FestivalCarnivalData.Set:end_time(value)
	self._end_time = value;
end

function Lua_FestivalCarnivalData:updateEvent(data)
	self.event = data;

	if self._eventlist == nil then
		self._eventlist = Array();
	else
		self._eventlist:clear();
	end

	local doubleExpOpen = false;
	local doubleCopyOpen = false;
	for i = 1, #self.event do
		if self.event[i].events == 1 and self.event[i].args[1] > 0 then
			doubleExpOpen = true;
			self.exp_last_time = tonumber(tostring(self.event[i].args[1]));
			self._eventlist:add(self.event[i]);
		elseif self.event[i].events == 2 and self.event[i].args[1] > 0 then
			doubleCopyOpen = true;
			self.copy_last_time = tonumber(tostring(self.event[i].args[1]));
			self._eventlist:add(self.event[i]);
		end
	end

	if doubleExpOpen then
		self:addDoubleExp(self.exp_last_time);
	else
		self:removeDoubleExp();
	end

	if doubleCopyOpen then
		self:addDoubleCopy(self.copy_last_time);
	else
		self:removeDoubleCopy();
	end
end

function Lua_FestivalCarnivalData.Get:eventlist()
	return self._eventlist;
end

function Lua_FestivalCarnivalData:removeEvent()
	self:removeDoubleCopy();
	self:removeDoubleExp();
end

function Lua_FestivalCarnivalData:addDoubleExp(time)
	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10115);
	Lua_MsgUtil.callFunc("UPDATE_RTICON_SHOWTIME", {iconId = 10115, showTime = time, isShoWBule = true});
	Lua_MsgUtil.callFunc("ADD_BUFF_WIN_BUFF", {id = 40300, leftTime = time ,value2 = 100});
end

function Lua_FestivalCarnivalData:addDoubleCopy(time)
	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10113);
	Lua_MsgUtil.callFunc("UPDATE_RTICON_SHOWTIME", {iconId = 10113, showTime = time, isShoWBule = true});

	local doubleConfing = getConfig({"doubleActivity"});
	local id;
	local list = {};
	for k, v in pairs(doubleConfing) do
		id = tonumber(k);
		if id > 1 then
			list[id - 1] = id;
		end
	end
	DataCenter.OpenDressCarnivalData:addDoubleCopy(list);
end

function Lua_FestivalCarnivalData:removeDoubleExp()
	Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10095);
	Lua_MsgUtil.callFunc("REMOVE_BUFF_WIN_BUFF", 40300);
end

function Lua_FestivalCarnivalData:removeDoubleCopy()
	Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10113);
	DataCenter.OpenDressCarnivalData:removeCopyDoubleExp();
end