﻿checkRequire("Lua_FestivalCarnivalData")
Lua_FestivalCarnivalProxy = class("Lua_FestivalCarnivalProxy")
function Lua_FestivalCarnivalProxy:ctor()
	DataCenter.festivalCarnivalData = Lua_FestivalCarnivalData.new();

	LuaUtil.addLuaMsg(50105311, self, self.rFestivalCarnivalInfo);-- 获取节日狂欢信息（返回）
	LuaUtil.addLuaMsg(80105311, self, self.onFestivalCarnivalISOpen);-- 节日狂欢活动状态（主动）

	Lua_MsgUtil.addEventListener("ADD_BUFF_WIN_BUFF", self, self.addBuff);
	Lua_MsgUtil.addEventListener("REMOVE_BUFF_WIN_BUFF", self, self.removeBuff);
end

function Lua_FestivalCarnivalProxy:rFestivalCarnivalInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105311();
		msg:ParseFromString(mp.data);
		DataCenter.festivalCarnivalData:fromServer50105311(msg)
		Lua_MsgUtil.callFunc("UPDATA_FESTIVAL_CARNIVAL_PANEL");
		Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT");
	end
end

function Lua_FestivalCarnivalProxy:onFestivalCarnivalISOpen(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105311();
		msg:ParseFromString(mp.data);

		if #msg.world_events > 0 then
			DataCenter.festivalCarnivalData:updateEvent(msg.world_events)
		else
			DataCenter.festivalCarnivalData:removeEvent();
		end

		DataCenter.festivalCarnivalData.theme = msg.theme
		if msg.end_tick ~= nil then 
			DataCenter.festivalCarnivalData.end_time = tonumber(tostring(msg.end_tick));          
			local leftTime = tonumber(tostring(msg.end_tick)) - tonumber(tostring(GlobalVar.cur_tick));
			if msg.open == true and leftTime > 0 then
				local info = Lua_ActivitiesInfo.new();
				info.act_index = msg.act_index
				info.first_type = 1047;
				info.second_type = 0;
				info.priority = 1;
				info.title = msg.title;
				info.icon_type = msg.icon;
				info.sort = 1;
				DataCenter.OperationalActivitiesData:addAct(info);
			else
				DataCenter.OperationalActivitiesData:removeAct(1047);
			end
		end
	end
end

function Lua_FestivalCarnivalProxy:addBuff(list)-- 在buff栏添加buff显示
	local buffVo = Lua_BuffVo.new(list.id);
	buffVo.s_time = getTime();
	buffVo.value2 = list.value2; -- 百分比
	buffVo.lask_tick = list.leftTime; -- 剩余时间

	DataCenter.roleData:updateBuff(buffVo);
	if buffVo.hunluan == 1 then
		DataCenter.thingData.lastSelectedTime = 0;
	end
	Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
end

function Lua_FestivalCarnivalProxy:removeBuff(id)-- 在buff栏移除buff显示
	DataCenter.roleData:removeBuff(id);
	Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
end