checkRequire("Lua_FootprintData");
Lua_FootprintProxy = class("Lua_FootprintProxy");
function Lua_FootprintProxy:ctor()
	DataCenter.footprintData = Lua_FootprintData.new();

	LuaUtil.addLuaMsg(51403501, self, self.rGetPanelInfo); -- 获取足迹信息（返回）
	LuaUtil.addLuaMsg(51403502, self, self.rAdvance); -- 足迹进阶（返回）
	LuaUtil.addLuaMsg(51403507, self, self.rSkillLvlUp); -- 足迹技能升级（返回）
	LuaUtil.addLuaMsg(51403508, self, self.rUseItem); -- 足迹使用足灵（返回）
	LuaUtil.addLuaMsg(51403509, self, self.rHuaXingMsg); -- 足迹化形（返回）
	LuaUtil.addLuaMsg(51403515, self, self.rUse); -- 足迹佩戴/隐藏（返回）
end

function Lua_FootprintProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403501();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:fromServer51403501(msg);
		Lua_MsgUtil.callFunc("FOOTPRINT_PANEL_UPDATE");
	end
end

function Lua_FootprintProxy:rAdvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403502();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:advance(msg);
		-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.footprintData:sServantPanelInfo();
	end
	DataCenter.footprintData:sGetPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_FootprintProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403507();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_FootprintProxy:rUseItem(mp)
	DataCenter.footprintData:sGetPanelInfo();
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403508();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:useItem(msg);
		-- Lua_MsgUtil.callFunc("MOUNT_PANEL_UPDATE");
	end
end

function Lua_FootprintProxy:rHuaXingMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403509();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:setShapeId(msg)
		Lua_MsgUtil.callFunc("FOOT_HUANXING_UPDATE", msg);
	end
end

function Lua_FootprintProxy:rUse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403515();
		msg:ParseFromString(mp.data);
		DataCenter.footprintData:updateState(msg);
		-- Lua_MsgUtil.callFunc("UESAGE_STATE_UPDATE");
	end
end





function Lua_FootprintProxy:sFuncOpen(mp)
    local shapeList = DataCenter.footprintData:getServantShapeList();
    DataCenter.footprintData:sUse(shapeList[1].id, 1);
    DataCenter.footprintData:sHuanXingMsg(shapeList[1].id)
end