checkRequire("Lua_EquipVo");
checkRequire("Lua_QiangHuaUtil");
checkRequire("Lua_ZhuLingUtil");
Lua_EquipData = class("Lua_EquipData");
Lua_EquipData.XIANGQIAN_TO_PACK = 1
function Lua_EquipData:ctor()
	self.parts = {};
	self.star = 0;
	self.indensify = 0;
	self.jewel = 0;
	self.jewf_countHole = 0;
	self.jewf_count = 0;
	self._selected_EquArr = Array();
end

function Lua_EquipData:dispose()
	self.parts = {};
	self.star = 0;
	self.indensify = 0;
	self.jewel = 0;
	self.jewf_countHole = 0;
	self.jewf_count = 0;
	self._windowData = nil;
	if self._selected_EquArr ~= nil then
		self._selected_EquArr:dispose();
		self._selected_EquArr:clear();
	end
end

function Lua_EquipData:fromServer51400601(msg)
	if msg == nil then
		return;
	end

	self.star = msg.star;
	self.indensify = msg.indensify;
	self.jewel = msg.jewel;
	self.free_polish_times = msg.free_polish_times;

	local equvo;
	for i, v in ipairs(msg.parts) do
		equvo = Lua_ToolVo.createToolVo(v.item.id, v.item.amount, v.item.bind);
		equvo:fromServer(v.item);
		if equvo.fromEquipPart ~= nil then
			equvo:fromEquipPart(v);
		end
		self.parts[v.part] = equvo;
	end
end

-- 根据位置获得道具信息
function Lua_EquipData:getEquByPart(part)
	if self.parts[part] ~= nil and self.parts[part].id == 0 then
		return nil;
	end
	return self.parts[part];
end

-- 每个部位宝石孔的总数
function Lua_EquipData:getJewf_countHoleByPart(part)
	self.jewf_countHole = #self:getEquByPart(part).jewel;
	return self.jewf_countHole;
end

-- 装备孔解锁的数量
function Lua_EquipData:getJewf_countByPart(part)
	local jewel = self:getEquByPart(part).jewel;
	self.jewf_countHole = #jewel;
	self.jewf_count = 0;
	for i = 1, self.jewf_countHole do
		if jewel[i].id >= 0 then
			self.jewf_count = self.jewf_count + 1;
		end
	end
	return self.jewf_count;
end

function Lua_EquipData:getJewf_typeByPart(part, id)
	local jewel = self:getEquByPart(part).jewel;
	for i = 1, self.jewf_countHolet do
		if jewel[i].id > 0 then
			jewf_type = Lua_ToolVo.new(jewel[i].id, 0, 0).jewel_type;
			if self.equipImg.data.jewel_type == 0 then
				return 0;
			else
				return 1;
			end
		end
	end
end

function Lua_EquipData.Get:equipArr()
	return self._equipArr;
end

function Lua_EquipData.Set:equipArr(val)
	self._equipArr = val;
	self._selected_EquArr:clear();
	self:onHandlEquArr();
end

function Lua_EquipData.Get:outPutData()
	return self._outPutData;
end

function Lua_EquipData.Set:outPutData(val)
	self._outPutData = val;
end

function Lua_EquipData:getRefineCount(val, idx)
	local _count = 0;
	if val.career ~= 0 then
		for i = 1, 12 do
			local _eq = self:getEquByPart(i);
			if _eq ~= nil
				and _eq.refine ~= 0
				and _eq.refine >= idx
				and self:getJewelryByPart(_eq.equPart) ~= -1
				and val.career == _eq.career
				and val.order <= _eq.order then
				_count = _count + 1;
			end
		end
	else
		-- 饰品
		for i = 1, 12 do
			local _eq = self:getEquByPart(i);
			if _eq ~= nil
				and _eq.refine ~= 0
				and _eq.refine >= idx
				and self:getJewelryByPart(_eq.equPart) ~= -1
				and val.career == _eq.career then
				_count = _count + 1;
			end
		end
	end
	return _count;
end

function Lua_EquipData:getSuitNumList(idx, isRefresh)
	if self.suitNumList == nil or isRefresh then 
		local orderNumList = {};
		local totalNum = 0;
		for i = 1, 12 do
			local equVo = self:getEquByPart(i);
			if equVo ~= nil and equVo.career ~= 0 and equVo.refine == idx then
				if orderNumList[equVo.order] == nil then
					orderNumList[equVo.order] = 0;
				end
				orderNumList[equVo.order] = orderNumList[equVo.order] + 1;
				totalNum = totalNum + 1;
			end
		end

		local orderList = {};
		local startIdx = 1;
		for k, v in pairs(orderNumList) do
			orderList[startIdx] = k;
			startIdx = startIdx + 1;
		end
		table.sort(orderList, function(a, b) return a < b; end);

		local order;
		local count = 0;
		local temp;
		for i = 1, #orderList do
			order = orderList[i];
			temp = orderNumList[order];

			orderNumList[order] = totalNum - count;
			count = count + temp;
		end

		self.suitNumList = {};
		for i = 2, 6, 2 do
			self.suitNumList[i] = 0;
			for k, v in pairs(orderNumList) do
				if self.suitNumList[i] < k and v >= i then
					self.suitNumList[i] = k;
				end
			end
		end
	end
	return self.suitNumList;
end

function Lua_EquipData:getJewelryByPart(part)
	return getConfig({"equipment_refine", "jewelry_part"})[part];
end

function Lua_EquipData:onHandlEquArr()
	local _mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType({Lua_PackTypeDefine.EQUIP});
	for i = 1, #self._equipArr do
		if _mater ~= nil and _mater:getSize() ~= 0 then
			for j = 1, _mater:getSize() do
				if self.outPutData ~= nil
					and _mater[j].star == self._equipArr[i][3]
					and _mater[j].career == self.outPutData.career
					and _mater[j].order == self._equipArr[i][4]
					and _mater[j].color == self._equipArr[i][5] then
					if self._selected_EquArr:indexOf(_mater[j]) == -1 then
						self._selected_EquArr:add(_mater[j]);
					end
				end
			end
		end
	end
end

function Lua_EquipData:getComposeEquArr(_composeEquipArrr)
	if _composeEquipArrr == nil then
		return;
	end
	
	local selected_composeEquArr = Array();
	local _mater = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsBySubType( { Lua_PackTypeDefine.EQUIP });
	if _mater ~= nil and _mater:getSize() ~= 0 then
		for i = 1, _mater:getSize() do
			if _composeEquipArrr[5] == 1 then
				-- 手镯戒指主装备
				if _mater[i].order == _composeEquipArrr[1]
					and _mater[i].star == _composeEquipArrr[2]
					and _mater[i].color == _composeEquipArrr[3]
					and _mater[i].part == _composeEquipArrr[4]
					and _mater[i].isPut ~= true then
					selected_composeEquArr:add(_mater[i]);
				end
			elseif _composeEquipArrr[5] == 4 then
				-- 护符项链
				if _mater[i].order >= _composeEquipArrr[1]
					and _mater[i].star == _composeEquipArrr[2]
					and _mater[i].color == _composeEquipArrr[3]
					and _mater[i].part == _composeEquipArrr[4]
					and _mater[i].isPut ~= true then
					selected_composeEquArr:add(_mater[i]);
				end
			else
				-- 手镯戒指辅装备
				if _mater[i].order >= _composeEquipArrr[1]
					and _mater[i].star >= _composeEquipArrr[2]
					and _mater[i].color >= _composeEquipArrr[3]
					and _mater[i].part == _composeEquipArrr[4]
					and _mater[i].isPut ~= true then
					selected_composeEquArr:add(_mater[i]);
				end
			end
		end
	end

	selected_composeEquArr:sortf(self, self.sortFun);
	return selected_composeEquArr
end

function Lua_EquipData:sortFun(a, b)
	if a.order > b.order then
		return false
	elseif a.order == b.order then
		return a.color <= b.color;
	end
	return true;
end

function Lua_EquipData:getComposeEquCount(arr)
	return self:getComposeEquArr(arr):getSize();
end

function Lua_EquipData:canCompose(childList)
	local canComposeArr = Array();

	-- 手镯戒指合成材料
	local curItemCount;
	if childList.item ~= nil then
		for i = 1, #childList.item do
			curItemCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(childList.item[i][1]);
			canComposeArr:add(curItemCount >= childList.item[i][2]);
		end
	end

	-- 手镯戒指主装备
	if childList.main_equip ~= nil then
		local main_equip = childList.main_equip;
		main_equip[5] = 1;

		local main_equipCount = self:getComposeEquCount(main_equip);
		canComposeArr:add(main_equipCount > 0);
	end

	-- 手镯戒指辅装备
	if childList.son_equip ~= nil then
		local son_equip = childList.son_equip;
		local son_equipCount;
		for k = 1, #son_equip do
			son_equip[k][5] = k + 1;
			son_equipCount = self:getComposeEquCount(son_equip[k]);
			canComposeArr:add((son_equipCount - k) > 0);
		end
	end

	-- 护符项链
	if childList.equip ~= nil then
		childList.equip[1][5] = 4;
		return self:getComposeEquCount(childList.equip[1]) >= #childList.equip;
	end

	for i = 1, canComposeArr:getSize() do
		if canComposeArr[i] == false then
			return false;
		end
	end
	return true;
end

function Lua_EquipData.Get:numDic()
	return self._numDic;
end

function Lua_EquipData.Set:numDic(value)
	self._numDic = value;
end

function Lua_EquipData.Get:subDic()
	return self._subDic;
end

function Lua_EquipData.Set:subDic(value)
	self._subDic = value;
end

function Lua_EquipData.Get:neckNumDic()
	return self._neckNumDic;
end

function Lua_EquipData.Set:neckNumDic(value)
	self._neckNumDic = value;
end

function Lua_EquipData.Get:neckSubDic()
	return self._neckSubDic;
end

function Lua_EquipData.Set:neckSubDic(value)
	self._neckSubDic = value;
end

function Lua_EquipData.Get:selected_EquArr()
	return self._selected_EquArr;
end
function Lua_EquipData.Set:selected_EquArr()
	self._selected_EquArr = Array();
end

function Lua_EquipData.Get:RonglianRedDotArr()
	return self._ronglianRedDot;
end

function Lua_EquipData.Set:RonglianRedDotArr(value)
	self._ronglianRedDot = value;
end

function Lua_EquipData.Get:RonglianConfigData()
	if self._listDataArr == nil then
		self._listDataArr = Array();

		local len = #getConfig({ "equipment_compose", "career_equip" });
		local equitDic;
		local list;
		for i = 1, len do
			equitDic = getConfig({ "equipment_compose", "order_equip", "a" .. i })
			for k, v in pairs(equitDic) do
				for key, value in pairs(v[2]) do
					equitInfo = getConfig({ "equipment_compose", value });

					list = {};
					list.mainKey = i;
					list.EuqipKey = key;
					list.careerAndsubIndex = k;
					list.star = equitInfo.star
					list.name = equitInfo.name
					list.priority = equitInfo.priority
					list.rate_arr = equitInfo.rate_arr
					list.materials = equitInfo.materials
					list.output = equitInfo.output
					list.type = equitInfo.type;
					list.order = equitInfo.order;
					list.costItem = equitInfo.cost_item;
					list.mtCount = 0
					list.listKey = list.materials[1][1]
								.. list.materials[1][2]
								.. list.materials[1][3]
								.. list.materials[1][4]
								.. list.materials[1][5]
								.. list.materials[1][6];
					
					self._listDataArr:add(list);
				end
			end
		end
	end
	return self._listDataArr;
end

function Lua_EquipData:getRonglianRedData()
	local redDotArr = Array();
	if self.RonglianConfigData ~= nil then
		local len = self.RonglianConfigData:getSize();
		for i = 1, len do
			-- 职业 星数 子按钮 部位 "a1001"
			if self.RonglianConfigData[i].isRedDot == true then
				local list = {};
				list.carrer = self.RonglianConfigData[i].mainKey;
				list.mainIndex = tonumber(string.sub(self.RonglianConfigData[i].careerAndsubIndex, 3, 3)) + 1;
				list.subIndex = tonumber(string.sub(self.RonglianConfigData[i].careerAndsubIndex, 4, 5));
				list.EuqipKey = self.RonglianConfigData[i].EuqipKey;
				redDotArr:add(list);
			end
		end
	end
	return redDotArr;
end

function Lua_EquipData:getMaterialCountByKey(listKey)
	if self.RonglianConfigData ~= nil then
		local len = self.RonglianConfigData:getSize();
		for i = 1, len do
			if self.RonglianConfigData[i].listKey == listKey then
				return self.RonglianConfigData[i].mtCount;
			end
		end
	end
	return 0;
end

function Lua_EquipData.Get:ForgingWindowData()
	if self._windowData == nil then
		return nil;
	end
	return self._windowData;
end

function Lua_EquipData.Set:ForgingWindowData(data)
	self._windowData = data;
end

function Lua_EquipData.Get:jwelCostConig()
	if self._jwelCostConig == nil then
		self._jwelCostConig = getConfig({ "stone_refine" });
	end
	return self._jwelCostConig;
end

function Lua_EquipData.Get:equipJueXingConfig()
	if self._equipJueXingConfig == nil then
		self._equipJueXingConfig = getConfig({ "equipCommonConfig" });
	end
	return self._equipJueXingConfig["constant"];
end

function Lua_EquipData.Get:equipJueXingCostConfig()
	if self._equipJueXingCostConfig == nil then
		self._equipJueXingCostConfig = getConfig({ "equip_awake" });
	end
	return self._equipJueXingCostConfig;
end

function Lua_EquipData.Get:equipFuLingCostConfig()
	if self._equipFuLingCostConfig == nil then
		self._equipFuLingCostConfig = getConfig({ "equip_spirit" });
	end
	return self._equipFuLingCostConfig;
end

function Lua_EquipData.Get:equipJingCuiCostConfig()
	if self._equipJingCuiCostConfig == nil then
		self._equipJingCuiCostConfig = getConfig({ "equip_succinct" });
	end
	return self._equipJingCuiCostConfig;
end

function Lua_EquipData.Get:equipJingCuiConfig()
	if self._equipJingCuiConfig == nil then
		self._equipJingCuiConfig = getConfig({ "equipJingCuiCommonConfig" });
	end
	return self._equipJingCuiConfig["constant"];
end

function Lua_EquipData.Get:equipMingKeConfig()
	if self._equipMingKeConfig == nil then
		self._equipMingKeConfig = getConfig({ "stone_engrave" });
	end
	return self._equipMingKeConfig;
end

function Lua_EquipData.Get:equipMingKeCommonConfig()
	if self._equipMingKeCommonConfig == nil then
		self._equipMingKeCommonConfig = getConfig({ "MingKeCommonConfig" });
	end
	return self._equipMingKeCommonConfig["constant"];
end