checkRequire("Lua_EquipData");
checkRequire("Lua_CuiLianUtil");
checkRequire("Lua_HeChengUtil");
checkRequire("Lua_AmuletNecklaceUtil");
Lua_ForgingProxy = class("Lua_ForgingProxy");
function Lua_ForgingProxy:ctor()
	DataCenter.equData = Lua_EquipData.new();

	LuaUtil.addLuaMsg(51400601, self, self.rUpdateListInfo); -- 装备信息（返回）
	LuaUtil.addLuaMsg(51400611, self, self.rUpQiangHuaInfo); -- 强化装备（返回）
	LuaUtil.addLuaMsg(51400618, self, self.rCuiLianInfo); -- 装备淬练（返回）
	LuaUtil.addLuaMsg(51400625, self, self.rRongLianInfo); -- 装备合成（返回）
	LuaUtil.addLuaMsg(51400627, self, self.rJinJieInfo); -- 装备进阶（返回）
	LuaUtil.addLuaMsg(51400628, self, self.rZhuLingInfo); -- 装备注灵（返回）
	LuaUtil.addLuaMsg(51400629, self, self.rJingLianInfo); -- 宝石精炼（返回）
	LuaUtil.addLuaMsg(51400630, self, self.rHeChengInfo); -- 手镯戒指合成（返回）
	LuaUtil.addLuaMsg(51400631, self, self.rJueXingInfo); -- 装备觉醒（返回）
	LuaUtil.addLuaMsg(51400632, self, self.rFuLingInfo); -- 装备附灵（返回）
	LuaUtil.addLuaMsg(51400633, self, self.rJingCuiInfo); -- 装备精粹（返回）
	LuaUtil.addLuaMsg(51400635, self, self.rMingKeInfo); -- 宝石铭刻（返回）

	Lua_MsgUtil.addEventListener("PACK_EQUIP_UPDATE", self, self.onPackDataUpdate);
	Lua_MsgUtil.addEventListener("PACK_INIT_INFO", self, self.onPackDataUpdate);
	Lua_MsgUtil.addEventListener("RONG_HE_RED_DOT_UPDATE", self, self.onRongHeRedDotUpdate);
end

function Lua_ForgingProxy:rUpdateListInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400601();
		msg:ParseFromString(mp.data);
		DataCenter.equData:fromServer51400601(msg);
		Lua_MsgUtil.callFunc("EQU_UPDATE");
	end
end

function Lua_ForgingProxy:rUpQiangHuaInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400611();
		msg:ParseFromString(mp.data);
		if msg.crit[1] == true then
			Lua_MsgUtil.callFunc("FORGING_BAO_JI");
		end
		if msg.level_up == true then
			Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
		end
	end
end

function Lua_ForgingProxy:rCuiLianInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:rJinJieInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:rZhuLingInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400628();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED", msg);
	end
end

function Lua_ForgingProxy:rJingLianInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400629();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED", msg);
	end
end

function Lua_ForgingProxy:rRongLianInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
	Lua_MsgUtil.callFunc("UPDATE_COST");
end

function Lua_ForgingProxy:rHeChengInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end

	if mp.errno == 1784 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_FAILED");
	end
end

function Lua_ForgingProxy:rJueXingInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:rFuLingInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:rJingCuiInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:rMingKeInfo(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("FORGING_PLAY_SUCCEED");
	end
end

function Lua_ForgingProxy:onRongHeRedDotUpdate()
	Lua_MsgUtil.removeEventListener("RONG_HE_RED_DOT_UPDATE", self, self.onRongHeRedDotUpdate);
	self:onPackDataUpdate();
end

function Lua_ForgingProxy:onPackDataUpdate()
	local configArr = DataCenter.equData.RonglianConfigData;
	local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local equipArr = packData:getItemsBySubType({ Lua_PackTypeDefine.EQUIP });
	local count;
	local key;
	local needCount;
	for i = 1, configArr:getSize() do
		count = 0;
		configArr[i].isRedDot = false;
		for j = 1, equipArr:getSize() do
			key = "0"..equipArr[j].count..equipArr[j].star..equipArr[j].order..equipArr[j].color..equipArr[j].career;
			if configArr[i].listKey == key then
				count = count + 1;
				needCount = #configArr[i].materials - #configArr[i].rate_arr + 1;
				if count >= needCount then
					if configArr[i].costItem ~= nil then
						configArr[i].isRedDot = packData:getItemNum(configArr[i].costItem[1][1]) >= configArr[i].costItem[1][2];
					else
						configArr[i].isRedDot = true;
					end
				else
					configArr[i].isRedDot = false;
				end
			end
		end
		configArr[i].mtCount = count;
	end
	DataCenter.equData.RonglianRedDotArr = configArr;

	local hasRedDot = false;
	for i = 1, configArr:getSize() do
		if configArr[i].isRedDot == true then
			hasRedDot = true;
			break;
		end
	end

	if DataCenter.funcOpenData:isOpened(10082) == true then
		DataCenter.redDotData:updateRedDotVoState(16002, hasRedDot);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 16002, val = hasRedDot and 1 or 0, bShow = hasRedDot});
		-- Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10018, state = hasRedDot});
		-- Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", hasRedDot);
	end
	Lua_MsgUtil.callFunc("UPDATE_RONGLIAN_REDDOT");
	Lua_MsgUtil.callFunc("UPDATE_RONGLIANPANEL_REDDOT");

	self:updateComposeRedDot()
end

function Lua_ForgingProxy:updateComposeRedDot()
	local num;
	local boolVal;
	local info;
	local subDic = {};
	local numDic = {};
	local showRedDot = false;
	local composeList = Lua_HeChengUtil:getComposeList();
	for i = 1, composeList:getSize() do
		num = 0;
		subDic[i] = {};
		for j = 1, composeList[i].sub:getSize() do
			boolVal = false
			for k, v in pairs(composeList[i].sub[j].data) do
				info = Lua_HeChengUtil.getInfList(v).materials;
				info.main_equip[4] = k + 8;
				if info.son_equip ~= nil then
					for l = 1, #info.son_equip do
						info.son_equip[l][4] = k + 8;
					end
				end

				if DataCenter.equData:canCompose(info) then
					boolVal = true;
					break;
				end
			end

			if boolVal then
				num = num + 1;
			end
			subDic[i][j] = boolVal;
		end

		numDic[i] = num > 0;
		if num > 0 then
			showRedDot = true;
		end
	end
	DataCenter.equData.numDic = numDic;
	DataCenter.equData.subDic = subDic;

	if DataCenter.funcOpenData:isOpened(10170) == true then
		DataCenter.redDotData:updateRedDotVoState(17002, showRedDot);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 17002, val = showRedDot and 1 or 0, bShow = showRedDot});
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10018, state = showRedDot});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", showRedDot);
	end
	self:updateAmuletNecklaceRedDot();
end

function Lua_ForgingProxy:updateAmuletNecklaceRedDot()
	local num;
	local boolVal;
	local info;
	local isShowRedDot = false;
	local neckSubDic = {};
	local neckNumDic = {};
	local neckComposeList = Lua_AmuletNecklaceUtil:getComposeList();
	for i = 1, neckComposeList:getSize() do
		num = 0;
		neckSubDic[i] = {};
		for j = 1, neckComposeList[i].sub:getSize() do
			boolVal = false;
			for k, v in pairs(neckComposeList[i].sub[j].data) do
				info = Lua_AmuletNecklaceUtil.getInfList(v).materials;
				info.equip[1][4] = k + 6;
				if DataCenter.equData:canCompose(info) then
					boolVal = true;
					break;
				end
			end

			if boolVal then
				num = num + 1;
			end
			neckSubDic[i][j] = boolVal;
		end

		neckNumDic[i] = num > 0;
		if num > 0 then
			isShowRedDot = true;
		end
	end
	DataCenter.equData.neckNumDic = neckNumDic;
	DataCenter.equData.neckSubDic = neckSubDic;

	if DataCenter.funcOpenData:isOpened(10196) == true then
		DataCenter.redDotData:updateRedDotVoState(17003, isShowRedDot);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 17003, val = isShowRedDot and 1 or 0, bShow = isShowRedDot});
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10018, state = isShowRedDot});
		-- Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", isShowRedDot);
	end
end





function Lua_ForgingProxy:sQiangHuaMsg(part, autoMtd)
    local cmd = ProtoPublic_pb.Proto11400611();
    cmd.part = part;
    cmd.auto_indensify = autoMtd
    sendMsg(11400611, cmd);
end