Lua_ZhuLingUtil = { };

-- until 静态类只用来读取配置数据。

function Lua_ZhuLingUtil.getPropertyConfig()
    return getConfig( { "equipment_mana" });
end

function Lua_ZhuLingUtil.getCostConfig()
    return getConfig( { "equipment_zhuling_cost" });
end

function Lua_ZhuLingUtil.getSkillConfig()
    return getConfig( { "equipment_zhuling_skill" })
end

function Lua_ZhuLingUtil.getLimit(part)
    local limit = Array()
    limit:add(Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["rank_limit"])
    limit:add(Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["star_limit"])
    limit:add(Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["color_limit"])
    return limit;
end

function Lua_ZhuLingUtil.getCostRank_item(part)
    return Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["rank_item"]
end

function Lua_ZhuLingUtil.getCostRank_cost(part, mana_rank)
    if mana_rank >= #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["rank_cost"] then
        mana_rank = #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["rank_cost"]
    end
    return Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["rank_cost"][mana_rank]
end

function Lua_ZhuLingUtil.getCostLevel_item(part)
    return Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_item"]
end

function Lua_ZhuLingUtil.getCostLevel_cost(part, mana_rank, mana_level)
    if mana_rank >= #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_cost"] then
        mana_rank = #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_cost"]
    end
    if mana_level >= #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_cost"][mana_rank] then
        mana_level = #Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_cost"][mana_rank]
    end
    return Lua_ZhuLingUtil.getCostConfig()["cost_" .. part]["level_cost"][mana_rank][mana_level]
end

function Lua_ZhuLingUtil.getMaxValueByPart(part)
    return #Lua_ZhuLingUtil.getPropertyConfig()["property_" .. part]["zhuling_name"]
end

function Lua_ZhuLingUtil.getZhuLingName(part, index)
    if index <= 0 then
        return ""
    end
    local maxValue = Lua_ZhuLingUtil.getMaxValueByPart(part)
    if index > maxValue then
        return LanUtil.getValue(120576)
    end
    return Lua_ZhuLingUtil.getPropertyConfig()["property_" .. part]["zhuling_name"][index]
end

function Lua_ZhuLingUtil.getSkillPropertyByIndex(skillId)
    return Lua_ZhuLingUtil.getSkillConfig()[skillId]
end

function Lua_ZhuLingUtil.getZhuLingPorpertyAttr(part, index)
    local arr = Array()
    if index <= 0 then
        return arr
    end
    local maxValue = Lua_ZhuLingUtil.getMaxValueByPart(part)
    if index <= 0 or index > maxValue then
        return arr
    end
    for k, v in ipairs(Lua_ThingDefine.params) do
        if Lua_ZhuLingUtil.getPropertyConfig()["property_" .. part][v] ~= nil then
            local list = { }
            list.property = v;
            list.attrName = Lua_ThingDefine.getParamName(v);
            list.isPercent = Lua_ThingDefine.isPercentParam(v)
            list.value = Lua_ZhuLingUtil.getPropertyConfig()["property_" .. part][v][index]
            arr:add(list)
        end
    end
    return arr
end

function Lua_ZhuLingUtil.getZhuLingSkillArr(value, part, index)
    local arr = Array()
    local maxValue = Lua_ZhuLingUtil.getMaxValueByPart(part)

    if index <= 0 or index > maxValue then
        return arr
    end
    local skillData = Lua_ZhuLingUtil.getPropertyConfig()["property_" .. part]["skill_id"][index]
    if type(skillData) == "number" then
        return arr
    else
        local len = #skillData
        for i = 1, len do
            local skillid = skillData[i]
            local skillConfig = Lua_ZhuLingUtil.getSkillPropertyByIndex(skillid)
            local list = { }
            list.name = Lua_CuiLianUtil.getEquip_part(part) .. skillConfig.name
            list.atlas = skillConfig.atlas;
            list.skill_icon = skillConfig.skill_icon;
            list.reMark = Lua_CuiLianUtil.getEquip_part(part) .. skillConfig.remark;
            list.desc_name = skillConfig.desc_name;
            list.skill_lvl = skillConfig.skill_lvl;
            if value == 1 then
                list.activation_state = index >= skillConfig.skill_condition
            else
                list.activation_state = index - 1 >= skillConfig.skill_condition
            end
            if list.activation_state == false then
                list.skill_open_des = skillConfig.skill_open_des
            else
                list.skill_open_des = LanUtil.getValue(120575)
            end
            arr:add(list)
        end
    end
    return arr
end

function Lua_ZhuLingUtil.getZhuLingSkillBySkillId(part, skillid)
    local skillid = skillid
    local skillConfig = Lua_ZhuLingUtil.getSkillPropertyByIndex(skillid)
    local list = { }
    list.name = Lua_CuiLianUtil.getEquip_part(part) .. skillConfig.name
    list.atlas = skillConfig.atlas;
    list.skill_icon = skillConfig.skill_icon;
    list.reMark = Lua_CuiLianUtil.getEquip_part(part) .. skillConfig.remark;
    list.desc_name = skillConfig.desc_name;
    list.skill_lvl = skillConfig.skill_lvl;
    list.skill_open_des = skillConfig.skill_open_des
    return list
end