-- 招财猫
Lua_FortuneCatData = class("Lua_FortuneCatData");
function Lua_FortuneCatData:ctor()
    self:dispose();
end

function Lua_FortuneCatData:dispose()
	self._leftTime = 0;
	self._getLeftTime = 0;
	self.curRechargeTotal = 0;
	self.conRechargeTotal = 0;
	self.curShowInfo = nil;
	self.descContent = "";
end

function Lua_FortuneCatData:fromServer51400015(obj)
	self._leftTime = obj.stop_tick - obj.times;
	self._getLeftTime = getTime();
	self.descContent = obj.content;

	if obj.reward_info == nil or #obj.reward_info <= 0 then
		self.curShowInfo = nil;
		self.conRechargeTotal = 0;
	else
		local info = obj.reward_info[1];
		self.curShowInfo = {};
		if info.cond ~= nil and #info.cond > 1 then -- 1是消耗值 2是消耗类型 3是需要累充的金额
			self.curShowInfo.costNum = tonumber(info.cond[1]);
			self.curShowInfo.costType = tonumber(info.cond[2]);
			self.conRechargeTotal = tonumber(info.cond[3]);
		end

		local arr = Array();
		local highArr = Array();
		local isHaveHigh = false;
		if info.reward_set ~= nil and #info.reward_set > 0 then
			for i = 1, #info.reward_set do
				local vo = info.reward_set[i];
				if vo.equipment.star ~=1 then
					arr:add({gainNum = tonumber(vo.amount), gainType = tonumber(vo.id)});
				else
					highArr:add({gainNum = tonumber(vo.bind), gainType = tonumber(vo.id)});
					isHaveHigh = true;
				end
			end
		end
		if info.reward_set ~= nil and #info.reward_set > 0 and isHaveHigh==false then
			for i = 1, #info.reward_set do
				local vo = info.reward_set[i];
				highArr:add({gainNum = tonumber(vo.bind), gainType = tonumber(vo.id)});
			end
		end
		self.curShowInfo.rewards = arr;
		self.curShowInfo.highRewards = highArr;
	end
end

-- 活动剩余时间
function Lua_FortuneCatData.Get:residueTime()
	local num = self._leftTime - (getTime() - self._getLeftTime);
	if num < 0 then
		num = 0;
	end
	num = math.floor(num);
	return num;
end