checkRequire("Lua_FriendSortTool");
Lua_FriendData = class("Lua_FriendData");
Lua_FriendData.RECENT_CONTACT_TYPE = 1;-- 服务端为7
Lua_FriendData.FRIEND_TYPE = 2;-- 服务端为1
Lua_FriendData.ENEMY_TYPE = 3;-- 服务端为5
Lua_FriendData.BLACK_TYPE = 4;-- 服务端为3
function Lua_FriendData:ctor()
    self:superCall("ctor");
    self.friendType = Array();
    self.friendList = { };
    self.allTypeList = { }
    self.recommendList = Array();
    self.friendRequestList = Array();
    self.onlineFriend = Array();
    self.invitedTeamList = Array();
    self.invitedUnionList = Array();
    self.inRetrunFlowerInfo = Array();
    self.flowerIdList = Array();
    for i = 1, 4 do
        self.allTypeList[i] = Array();
    end
    self.chatTime = { };
    self.enemyRedDotList = { };
end
-- 请求获取好友列表
function Lua_FriendData:sFriendList(friend_type)
    if DataCenter.funcOpenData:isOpened(10022) == false then
        return;
    end
    local cmd = ProtoPublic_pb.Proto10100150();
    cmd.friend_type = friend_type;
    sendMsg(10100150, cmd);
end
-- 请求获取推荐好友
function Lua_FriendData:sRecommendList(change)
    local cmd = ProtoPublic_pb.Proto10100154();
    cmd.another = change;
    sendMsg(10100154, cmd);
    -- sendMsg(10100154);
end
-- 请求搜索好友好友
function Lua_FriendData:sSearchFriend(name)
    local cmd = ProtoPublic_pb.Proto10100153();
    cmd.name = name;
    sendMsg(10100153, cmd);
end
-- 发送好友请求
function Lua_FriendData:sAddFriendRequest(data)
    local cmd = ProtoPublic_pb.Proto10100164();
    cmd.friend_id = data.role_id;
    sendMsg(10100164, cmd);
end
-- 更新推荐好友列表
function Lua_FriendData:init50100153(msg)
    self.recommendList = Array();
    if #msg.friend_info > 0 then
        for i, v in ipairs(msg.friend_info) do
            self.recommendList:add(v)
        end
    else
        -- 服务端如果一直返回friend_info长度为0 ，这里就会一直发送请求，这样造成死循环。先屏蔽代码
        -- DataCenter.friendData:sRecommendList(false);
    end
end
-- 获取推荐好友列表
function Lua_FriendData:getRecommendList()
    if self.recommendList == nil then
        return nil;
    end
    return self.recommendList;
end
-- 处理被添加
function Lua_FriendData:init80100109(msg)
    self.friendRequestList:add(msg.friend_info)
end
-- 更新申请列表
function Lua_FriendData:init50100167(msg)
    self.friendRequestList = Array();
    for i, v in ipairs(msg.apply_list) do
        self.friendRequestList:add(v)
    end
end
-- 获取被添加列表
function Lua_FriendData:getFriendRequestList()
    if self.friendRequestList == nil then
        return nil;
    end
    return self.friendRequestList;
end
-- 全部同意或者全部拒绝清除好友请求数据
function Lua_FriendData:clearFriendRequestList()
    if self.friendRequestList:getSize() > 0 then
        self.friendRequestList:clear()
    end
end
-- 单个同意或者单个拒绝
function Lua_FriendData:removeOneFriendRequest(data)
    for i = 1, self.friendRequestList:getSize() do
        if self.friendRequestList[i].friend_id == data.friend_id then
            self.friendRequestList:remove(i);
            return;
        end
    end
end
-- 处理邀请入队
function Lua_FriendData:init80400309(msg)
    local invitedTeamInfo = { }
    invitedTeamInfo.role_id = msg.role_id
    invitedTeamInfo.role_name = msg.role_name
    invitedTeamInfo.role_level = msg.role_level
    invitedTeamInfo.fight_force = msg.fight_force
    invitedTeamInfo.league_name = msg.league_name
    invitedTeamInfo.other_info = msg.other_info
    self.invitedTeamList:add(invitedTeamInfo);
end
-- 获取整个邀请入队数组
function Lua_FriendData:getInvitedTeamList()
    if self.invitedTeamList == nil then
        return nil;
    end
    return self.invitedTeamList;
end
-- 响应入队清除所有数据
function Lua_FriendData:clearInvitedTeamList()
    if self.invitedTeamList:getSize() > 0 then
        self.invitedTeamList:clear();
    end
end
-- 拒绝入队清除第一个数据
function Lua_FriendData:removeFristTeamInvitedInfo()
    if self.invitedTeamList:getSize() > 0 then
        self.invitedTeamList:remove(1);
        return;
    end
end
-- 处理邀请入盟
function Lua_FriendData:init80400410(msg)
    local invitedUnionInfo = { }
    invitedUnionInfo.league_index = msg.league_index
    invitedUnionInfo.league_name = msg.league_name
    invitedUnionInfo.inviter_id = msg.inviter_id
    invitedUnionInfo.inviter_name = msg.inviter_name
    self.invitedUnionList:add(invitedUnionInfo);
end
-- 获取整个邀请入盟数组
function Lua_FriendData:getInvitedUnionList()
    if self.invitedUnionList == nil then
        return nil;
    end
    return self.invitedUnionList;
end
-- 同意申请入盟清除所有数据
function Lua_FriendData:clearInvitedUnionList()
    if self.invitedUnionList:getSize() > 0 then
        self.invitedUnionList:clear();
    end
end
-- 拒绝入盟清除第一个数据
function Lua_FriendData:removeFristUnionInvitedInfo()
    if self.invitedUnionList:getSize() > 0 then
        self.invitedUnionList:remove(1);
        return;
    end
end
-- 处理回赠鲜花窗口
function Lua_FriendData:init80101410(msg)
    local retrunFlowerInfo = { }
    retrunFlowerInfo.item_id = msg.item_id
    retrunFlowerInfo.sender_id = msg.sender_id
    retrunFlowerInfo.sender_name = msg.sender_name
    retrunFlowerInfo.receiver_id = msg.receiver_id
    retrunFlowerInfo.receiver_name = msg.receiver_name
    retrunFlowerInfo.add = msg.add
    self.inRetrunFlowerInfo:add(retrunFlowerInfo);
end
-- 获取鲜花配置
function Lua_FriendData:getMarriageConfig()
    self.flowerIdList = Array();
    local confing = getConfig( { "wedding_flower" });
    for k, v in ipairs(confing) do
        self.flowerIdList:add(v);
    end
    if self.flowerIdList == nil then
        return nil;
    end
    return self.flowerIdList;
end
-- 获取赠送鲜花玩家数据
function Lua_FriendData:getInRetrunFlowerInfo()
    if self.inRetrunFlowerInfo == nil then
        return nil;
    end
    return self.inRetrunFlowerInfo;
end
-- 赠送鲜花玩家清除第一个数据
function Lua_FriendData:removeFristRetrunFlowerInfo()
    if self.inRetrunFlowerInfo:getSize() > 0 then
        self.inRetrunFlowerInfo:remove(1);
        return;
    end
end
-- 送花返回更新好友亲密度
function Lua_FriendData:init50101406(msg)
    for j = 1, self.allTypeList[Lua_FriendData.FRIEND_TYPE]:getSize() do
        if msg.receiver_id == self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.role_id then
            self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.intimacy = self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.intimacy + msg.intimacy;
        end
    end
    for j = 1, self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:getSize() do
        if msg.receiver_id == self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][j].info.role_id then
            self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][j].info.intimacy = self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][j].info.intimacy + msg.intimacy;
        end
    end
end
-- 发送接受好友申请
function Lua_FriendData:sAgreeFriendRequest(agreeList)
    local cmd = ProtoPublic_pb.Proto10100165();
    for i = 1, agreeList:getSize() do
        if agreeList[i].friend_id ~= nil then
            cmd.friend_id_set:append(agreeList[i].friend_id);
        end
    end
    sendMsg(10100165, cmd);
end
-- 删除接受好友申请
function Lua_FriendData:sRefusedFriendRequest(refusedList)
    local cmd = ProtoPublic_pb.Proto10100166();
    for i = 1, refusedList:getSize() do
        if refusedList[i].friend_id ~= nil then
            cmd.friend_id_set:append(refusedList[i].friend_id);
        end
    end
    sendMsg(10100166, cmd);
end
-- 请求在线好友
function Lua_FriendData:sOnlineFriend()
    sendMsg(10100168);
end
-- 请求在线好友返回
function Lua_FriendData:init50100168(msg)
    self.onlineFriend = Array();
    for i, v in ipairs(msg.friend_list) do
        for k, p in ipairs(v.friends_info) do
            local onlinefriend = Lua_FriendSortTool.new()
            onlinefriend.info = p
            self.onlineFriend:add(onlinefriend)
        end
    end
end
-- 获取在线好友列表
function Lua_FriendData:getOnlineFriendList()
    if self.onlineFriend == nil then
        return nil;
    end
    self.onlineFriend:sort("sortIntimacy", true);
    return self.onlineFriend;
end
--[[根据好友类型获取好友列表
function Lua_FriendData:getFriendListByType(Type)
    if self.friend_list[Type] == nil then
		return nil;
	end
	local list = self.friend_list[Type];
    return list;
end]]
-- 获取所有列表
function Lua_FriendData:getAllTypeList()
    if self.allTypeList == nil then
        return nil;
    end
    return self.allTypeList;
end
-- 返回好友列表
function Lua_FriendData:init50100150(msg)
    self.friendList = { };
    self.friendType = Array();
    for i, v in ipairs(msg.friend_list) do
        self.friendList[v.friend_type] = v.friends_info
        self.friendType:add(v.friend_type);
        self.allTypeList[i] = Array();
    end
    self:sortAllFriends();
end
-- 返回需要更新最近联系人
function Lua_FriendData:init50100155(msg)
    local temp = self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE];
    for i = 1, temp:getSize() do
        if msg.friend_info.role_id == temp[i].info.role_id then
            return;
        end
    end
    self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE] = Array();
    local friend = Lua_FriendSortTool.new()
    friend.info = msg.friend_info
    self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:add(friend);
    for i = 1, temp:getSize() do
        self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:add(temp[i]);
    end
    self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:sort("sortRecent", true);
end
-- 返回查看玩家详细信息
function Lua_FriendData:init50100156(msg)
    local detailedInfo = { };
    detailedInfo.parts = {};
    detailedInfo.msg = msg;
    for i, v in ipairs(msg.equip_list.parts) do
        if v.item.id ~= 0 then
            local equvo = Lua_ToolVo.createToolVo(v.item.id, v.item.amount, v.item.bind);
            equvo:fromServer(v.item);

            if equvo.fromEquipPart ~= nil then
                equvo:fromEquipPart(v);
            end
            equvo.packType = 999;
            -- equvo.bolIdx = 1;
            -- 1为史诗列表,2为传说列表
            detailedInfo.parts[v.part] = equvo;
        else
            detailedInfo.parts[v.part] = nil;
        end
    end
    if msg.fairy_item.id ~= 0 and msg.fairy_item.id ~= nil then
        detailedInfo.equipedFairyItem = nil;
        detailedInfo.equipedFairyItem = Lua_ToolVo.new(msg.fairy_item.id);
        detailedInfo.equipedFairyItem:fromServer(msg.fairy_item);
        detailedInfo.equipedFairyItem.timeOut = nil;
        detailedInfo.equipedFairyItem.effective_time = nil;
        detailedInfo.equipedFairyItem.fairyType = nil;
    end
    if msg.wing_item.id ~= 0 and msg.wing_item.id ~= nil then
        detailedInfo.equipedWingItem = nil;
        detailedInfo.equipedWingItem = Lua_ToolVo.new(msg.wing_item.id);
        detailedInfo.equipedWingItem:fromServer(msg.wing_item);
        detailedInfo.equipedWingItem.timeOut = nil;
        detailedInfo.equipedWingItem.effective_time = nil
    end
    Lua_WindowUtil.openWin("Lua_PlayerInfoTipsWindow", WinParam.ACTION_OPEN, detailedInfo);
end
-- 接受好友后 更新好友列表
function Lua_FriendData:init50100165(msg)
    for i, v in ipairs(msg.friend_list) do
        local friend = Lua_FriendSortTool.new()
        friend.info = v
        self.allTypeList[Lua_FriendData.FRIEND_TYPE]:add(friend)
    end
    -- 好友加入数组
    self.allTypeList[Lua_FriendData.FRIEND_TYPE]:sort("sortFriend", true);
end
-- 被加为好友 更新好友列表
function Lua_FriendData:init80100101(msg)
    local friend = Lua_FriendSortTool.new()
    friend.info = msg.friend_info
    -- 好友加入数组
    self.allTypeList[Lua_FriendData.FRIEND_TYPE]:add(friend);
    self.allTypeList[Lua_FriendData.FRIEND_TYPE]:sort("sortFriend", true);
    -- 判断申请列表有没有同意者
    for i = 1, self.friendRequestList:getSize() do
        if self.friendRequestList[i].friend_id == msg.friend_info.role_id then
            self.friendRequestList:remove(i);
            return;
        end
    end
end
function Lua_FriendData:sortAllFriends()
    -- 分类型加入数组排序
    for j = 1, self.friendType:getSize() do
        for i, v in ipairs(self.friendList[self.friendType[j]]) do
            local friend = Lua_FriendSortTool.new()
            friend.info = v
            if self.friendType[j] == 1 then
                if self.chatTime[v.role_id] ~= nil then
                    friend.info.last_chat = self.chatTime[v.role_id];
                end
                self.allTypeList[Lua_FriendData.FRIEND_TYPE]:add(friend)
            elseif self.friendType[j] == 3 then
                self.allTypeList[Lua_FriendData.BLACK_TYPE]:add(friend)
            elseif self.friendType[j] == 5 then
                self.allTypeList[Lua_FriendData.ENEMY_TYPE]:add(friend)
            elseif self.friendType[j] == 7 then
                if self.chatTime[v.role_id] ~= nil then
                    friend.info.last_chat = self.chatTime[v.role_id];
                end
                self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:add(friend);
            end
        end
    end
    -- 排序
    self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:sort("sortRecent", true);
    self.allTypeList[Lua_FriendData.FRIEND_TYPE]:sort("sortFriend", true);
    self.allTypeList[Lua_FriendData.ENEMY_TYPE]:sort("sortEnemy", true);
    self.allTypeList[Lua_FriendData.BLACK_TYPE]:sort("sortBlack", true);
end
-- 处理返回加入黑名单信息
function Lua_FriendData:init50100158(msg)
    -- 好友拉黑
    if msg.src_friend_type == 1 then
        for i = 1, self.allTypeList[Lua_FriendData.FRIEND_TYPE]:getSize() do
            if msg.role_id == self.allTypeList[Lua_FriendData.FRIEND_TYPE][i].info.role_id then
                self.allTypeList[Lua_FriendData.FRIEND_TYPE]:remove(i);
                return;
            end
        end
        -- 仇人拉黑
        -- elseif msg.src_friend_type==5 then
        --  for i=1,self.allTypeList[Lua_FriendData.ENEMY_TYPE]:getSize() do
        --     if self.allTypeList[Lua_FriendData.ENEMY_TYPE][i]~=nil and msg.role_id==self.allTypeList[Lua_FriendData.ENEMY_TYPE][i].info.role_id then
        --          self.allTypeList[Lua_FriendData.ENEMY_TYPE]:remove(i);
        --     end
        --  end
        -- 最近联系人拉黑
    elseif msg.src_friend_type == 6 then
        for i = 1, self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:getSize() do
            if msg.role_id == self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][i].info.role_id then
                self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:remove(i);
                return;
            end
        end
    end
    -- 把该玩家加进黑名单列表
    local friend = Lua_FriendSortTool.new()
    friend.info = msg.friend_info
    -- 黑名单加入数组
    self.allTypeList[Lua_FriendData.BLACK_TYPE]:add(friend);
    self.allTypeList[Lua_FriendData.BLACK_TYPE]:sort("sortBlack", true);
end
-- 处理返回移出黑名单信息
function Lua_FriendData:init50100159(msg)
    local tempInfo;
    for i = 1, self.allTypeList[Lua_FriendData.BLACK_TYPE]:getSize() do
        if msg.role_id == self.allTypeList[Lua_FriendData.BLACK_TYPE][i].info.role_id then
            tempInfo = self.allTypeList[Lua_FriendData.BLACK_TYPE][i];
            self.allTypeList[Lua_FriendData.BLACK_TYPE]:remove(i);
            return;
        end
    end
    if msg.des_friend_type == 1 then
        local friend = Lua_FriendSortTool.new()
        friend.info = tempInfo.info;
        -- 好友加入数组
        self.allTypeList[Lua_FriendData.FRIEND_TYPE]:add(friend);
        self.allTypeList[Lua_FriendData.FRIEND_TYPE]:sort("sortFriend", true);
    end
end
-- 处理删除好友返回
function Lua_FriendData:init50100152(msg)
    for i, v in ipairs(msg.role_set) do
        for j = 1, self.allTypeList[Lua_FriendData.FRIEND_TYPE]:getSize() do
            if v == self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.role_id then
                self.allTypeList[Lua_FriendData.FRIEND_TYPE]:remove(j);
                return;
            end
        end
    end
end
-- 处理被删除好友返回
function Lua_FriendData:init80100110(msg)
    for j = 1, self.allTypeList[Lua_FriendData.FRIEND_TYPE]:getSize() do
        if msg.role_id == self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.role_id then
            self.allTypeList[Lua_FriendData.FRIEND_TYPE]:remove(j);
            return;
        end
    end
end
-- 判斷是不是我的好友
function Lua_FriendData:isMyFriend(rid)
    local myFriendList = self.allTypeList[Lua_FriendData.FRIEND_TYPE];
    if myFriendList == nil then
        return false;
    end
    local len = myFriendList:getSize();
    for i = 1, len do
        if rid == tonumber(myFriendList[i].info.role_id) then
            return true;
        end
    end
    return false;
end
function Lua_FriendData:getFriendData(rid)
    local myFriendList = self.allTypeList[Lua_FriendData.FRIEND_TYPE];
    if myFriendList == nil then
        return nil;
    end
    local len = myFriendList:getSize();
    for i = 1, len do
        if rid == tonumber(myFriendList[i].info.role_id) then
            return myFriendList[i];
        end
    end
    return nil;
end

function Lua_FriendData:isInBlack(rid)
    local myBlackList = self.allTypeList[Lua_FriendData.BLACK_TYPE];
    if myBlackList == nil then
        return false;
    end
    local len = myBlackList:getSize();
    for i = 1, len do
        if rid == tonumber(myBlackList[i].info.role_id) then
            return true;
        end
    end
    return false;
end
-- 判断好友红点
function Lua_FriendData:checkFriendRedDot()
    local all_list = self.allTypeList
    local chatRedDotList = DataCenter.chatData.redDotList;
    for k, v in pairs(all_list) do
        for j = 1, v:getSize() do
            if k == 1 or k == 2 then
                if chatRedDotList[tonumber(v[j].info.role_id)] ~= nil and chatRedDotList[tonumber(v[j].info.role_id)] == true then
                    return true;
                end
            elseif k == 3 then
                if self.enemyRedDotList[tonumber(v[j].info.role_id)] ~= nil and self.enemyRedDotList[tonumber(v[j].info.role_id)] == true then
                    return true;
                end
            end
        end
    end
    if DataCenter.redDotData:getRedDotStateByEventId(10008) == true then
        return true;
    end
    return false;
end
-- 判断社交红点
function Lua_FriendData:checkSocialRedDot()
    if DataCenter.redDotData:getRedDotStateByEventId(10001) == true then
        return true;
    end
    if DataCenter.redDotData:getRedDotStateByEventId(10088) == true then
        return true;
    end
    self.treasure = DataCenter.marryData.self_treasure;
    if DataCenter.marryData.wedding_id ~= 0 and self.treasure ~= nil then
        if tonumber(tostring(self.treasure.buy_tick)) ~= 0 and(self.treasure.day_reward == 0 or self.treasure.once_reward == 0) then
            return true;
        end
        if DataCenter.redDotData:getRedDotStateByEventId(11601) == true then
            return true;
        end
    else
        if DataCenter.funcOpenData:isOpened(10086) == true and DataCenter.marryData.doNotMarriedRedDot == true then
            return true;
        end
    end
    return self:checkFriendRedDot();
end
-- 记录私聊时间
function Lua_FriendData:setLastChatTime(msg)
    for j = 1, self.allTypeList[Lua_FriendData.FRIEND_TYPE]:getSize() do
        if msg.role_id == self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.role_id then
            self.allTypeList[Lua_FriendData.FRIEND_TYPE][j].info.last_chat = msg.time
        end
    end
    for j = 1, self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:getSize() do
        if msg.role_id == self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][j].info.role_id then
            self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE][j].info.last_chat = msg.time
        end
    end
    self.chatTime[msg.role_id] = msg.time;
    self.allTypeList[Lua_FriendData.RECENT_CONTACT_TYPE]:sort("sortRecent", true);
    self.allTypeList[Lua_FriendData.FRIEND_TYPE]:sort("sortFriend", true);
end
-- 记录仇人
function Lua_FriendData:init80100114(msg)
    local enemy = Lua_FriendSortTool.new()
    enemy.info = msg.friend_info
    self.allTypeList[Lua_FriendData.ENEMY_TYPE]:add(enemy)
    self.enemyRedDotList[tonumber(msg.friend_info.role_id)] = true
end
function Lua_FriendData:setEnemyRedDot(index, val)
    self.enemyRedDotList[index] = val;
end
function Lua_FriendData:dispose()
    self:superCall("dispose");
    DataCenter.chatData.redDotList = { };
    DataCenter.friendData.enemyRedDotList = { };
end
--[[Lua_FriendData = class("Lua_FriendData");
Lua_FriendData.FRIEND_TYPE = 1;
Lua_FriendData.BLACK_TYPE = 5;
function Lua_FriendData:ctor()
	self.dic = {};
end
function Lua_FriendData:dispose()
	self.dic = {};
end
function Lua_FriendData:fromServer(msg)
	if self.dic[msg.friend_type] == nil then
		self.dic[msg.friend_type] = Array();
	end
	self.dic[msg.friend_type]:clear();
	for i,v in ipairs(msg.friend_list) do
		self.dic[msg.friend_type]:add(v);
	end
end
function Lua_FriendData:addFriend(info)
	if self.dic[Lua_FriendData.FRIEND_TYPE] == nil then
		return;
	end
	local len = self.dic[Lua_FriendData.FRIEND_TYPE]:getSize();
	for i=1,len do
		if self.dic[Lua_FriendData.FRIEND_TYPE][i].role_id == info.role_id then
			self.dic[Lua_FriendData.FRIEND_TYPE][i] = info;
			return;
		end
	end
	self.dic[Lua_FriendData.FRIEND_TYPE]:add(info);
end]]
