﻿Lua_FuHunVo = class("Lua_FuHunVo");
function Lua_FuHunVo:ctor(part)
    self.part = part;
end
function Lua_FuHunVo:fromServer(msg)
    self.is_activate = msg.is_activate == 1;
    self.soul_jade_total = msg.soul_jade_total;
    self.cast_power_level = msg.cast_power_level;
    self.open_light_level = msg.open_light_level;
    self.soul_jade_info = msg.soul_jade_info
end
function Lua_FuHunVo.Get:config()
    return DataCenter.fuHunData.equipHunConfig[self.part]
end

function Lua_FuHunVo.Get:kaiGuangState()
    return self.open_light_level > 0
end

function Lua_FuHunVo.Get:zhuHunConfig()
    return DataCenter.fuHunData.equipZhuHunConfig
end

function Lua_FuHunVo.Get:name()
    return self.config.name
end

function Lua_FuHunVo.Get:duanhun_icon()
    return self.config.duanhun_icon
end

function Lua_FuHunVo.Get:kaiguang_icon()
    return self.config.kaiguang_icon
end

function Lua_FuHunVo.Get:duanhun_icon_effect()
    return self.config.duanhun_icon_effect
end

function Lua_FuHunVo.Get:duanhun_icon_white()
    return self.config.duanhun_icon_white
end

function Lua_FuHunVo.Get:duanhun_icon_yellow()
    return self.config.duanhun_icon_yellow
end

function Lua_FuHunVo.Get:duanhun_show_effect()
    if self.is_activate == true then
        return self.duanhun_icon_yellow
    else
        return self.duanhun_icon_white
    end
end

function Lua_FuHunVo.Get:kaiguang_small_effect()
    return self.config.kaiguang_small_effect
end

function Lua_FuHunVo.Get:kaiguang_big_effect()
    return self.config.kaiguang_big_effect
end

function Lua_FuHunVo.Get:partName()
    local colorStr = "[adadad]"
    if self.open_light_level > 0 then
        colorStr = "[b1caf4]"
    end
    return colorStr .. self.config.part_name
end

function Lua_FuHunVo.Get:SkillOrSuit()
    return DataCenter.fuHunData.equipSuitConfig.soul_equip_group[self.part]
end

function Lua_FuHunVo.Get:isCanKaiGuang()
    return self.soul_jade_total >= self.config.open_level
end

function Lua_FuHunVo.Get:CostItem()
    local arr = Array()
    local configData = self.config["cost"]
    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        arr:add(itemVo)
    end
    return arr
end

function Lua_FuHunVo.Get:baseAttr()
    local arr = Array()
    for k, v in ipairs(Lua_ThingDefine.params) do
        local attrList = { }
        if self.config[v] ~= nil then
            attrList.attrName = Lua_ThingDefine.getParamName(v)
            attrList.value = self.config[v]
            attrList.index = Lua_ThingDefine.getParaRankByParams(v)
            attrList.attr = v
            arr:add(attrList)
        end
    end
    arr:sort("index", false)
    return arr
end

function Lua_FuHunVo.Get:redDotState()
    if self.fuHunRedDot == true then
        return true
    end
    local arr = self.HunYuVoArr
    local len = arr:getSize()
    for i = 1, len do
        if arr[i].hunYuRedDot == true then
            return true
        end
    end
    return false
end

function Lua_FuHunVo.Get:fuHunRedDot()
    local costItemArr = self.CostItem
    local redDot = true
    local id = 0
    local len = costItemArr:getSize()
    for i = 1, len do
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemArr[i].id);
        if hadCount < costItemArr[i].count then
            redDot = false
            break;
        end
    end
    redDot = redDot and self.is_activate == false
    return redDot
end

function Lua_FuHunVo.Get:kaiGuangRedDot()
    if self.isCanKaiGuang == false then
        return false
    end
    local configData = DataCenter.fuHunData.equipKaiGuangConfig[self.part * 10000 + self.open_light_level + 1]
    local costItemList
    local len = 0
    if configData == nil then
        return false
    else
        costItemList = configData["cost"]
        len = #costItemList
    end
    local isShowRedDot = true
    for i = 1, len do
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costItemList[i][1]);
        if hadCount < costItemList[i][2] then
            isShowRedDot = false
            break
        end
    end
    return isShowRedDot
end

function Lua_FuHunVo.Get:txtInfoShow()
    local arr = Array()
    local str1 = ""
    local str2 = ""
    local str3 = ""
    local str4 = ""
    local curKey = self.part * 10000 + self.cast_power_level
    local nextKey = self.part * 10000 + self.cast_power_level + 1
    if self.cast_power_level ~= 0 then
        str1 = LanUtil.formateStr(LanUtil.getValue(141311), tostring(self.cast_power_level))
        str2 = LanUtil.formateStr(LanUtil.getValue(141304), tostring(self.zhuHunConfig[curKey]["txt_show"]), tostring(self.zhuHunConfig[curKey]["soul_base_percent"]))
        if self.zhuHunConfig[nextKey] ~= nil then
            str3 = LanUtil.formateStr(LanUtil.getValue(141305), tostring(self.zhuHunConfig[nextKey]["txt_show"]), tostring(self.zhuHunConfig[nextKey]["soul_base_percent"]))
            str4 = LanUtil.formateStr(LanUtil.getValue(141306), tostring(self.soul_jade_total), tostring(self.zhuHunConfig[nextKey]["soul_jade"]));
        else
            str3 = LanUtil.getValue(141310)
            str4 = ""
        end
    else
        str1 = LanUtil.getValue(141307)
        str2 = LanUtil.formateStr(LanUtil.getValue(141308), tostring(self.zhuHunConfig[nextKey]["txt_show"]), tostring(self.zhuHunConfig[nextKey]["soul_base_percent"]));
        str3 = LanUtil.formateStr(LanUtil.getValue(141309), tostring(self.soul_jade_total), tostring(self.zhuHunConfig[nextKey]["soul_jade"]));
        str4 = ""
    end
    arr:add(str1)
    arr:add(str2)
    arr:add(str3)
    arr:add(str4)
    return arr
end



function Lua_FuHunVo.Get:HunYuVoArr()
    local arr = Array()
    for k, v in ipairs(self.soul_jade_info) do
        local list = { }
        list.hunYuLvl = v.soul_jade_level
        list.is_open = v.is_open == 1
        list.iconName = self:getHunYuIconNameByIndex(list.is_open, k)
        list.hunYuRedDot = self:getHunYuRedDotState(k, list.hunYuLvl) and list.is_open
        arr:add(list)
    end
    return arr
end

function Lua_FuHunVo:getHunYuRedDotState(hunYuType, lvl)
    local arr = Array()
    local redDot = true
    local configData = DataCenter.fuHunData.equipHunYuConfig[self.part * 10000 + hunYuType - 1]["cost"][lvl + 1]
    if configData == nil then
        return false
    end
    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(configData[i][1]);
        if hadCount < configData[i][2] then
            redDot = false
            break
        end
    end
    return redDot
end

function Lua_FuHunVo:getHunYuIconNameByIndex(state, k)
    if state == false then
        return "fuhun_hui"
    else
        return self.iconList[k]
    end
end

function Lua_FuHunVo.Get:iconList()
    if self._iconList == nil then
        self._iconList = { "fuhun_lv", "fuhun_lan", "fuhun_zi", "fuhun_cheng", "fuhun_hong" }
    end
    return self._iconList
end

function Lua_FuHunVo:dispose()
    self:superCall("dispose");
end