Lua_CrystalWarData = class("Lua_CrystalWarData");
function Lua_CrystalWarData:ctor()
    self:superCall("ctor");
    self.crystalSceneId = 0
end
------------------------------ 玩法---限时活动---水晶之战----------------
function Lua_CrystalWarData:fromServer80100601(msg)
    self.self_score = msg.self_score;
    self.camp_scores = msg.camp_scores;
    self.self_camp = msg.self_camp
    self.zone = msg.zone
    self.residueTime = msg.left_time;
    self.rank = msg.rank
    self.count_down = msg.count_down
    self.fightInfoGetTime = getTime();
    self.gather_state = msg.gather_state
    self.camp_value = msg.camp_morale[self.self_camp]
    self.crystalSceneId = DataCenter.roleData.sceneId
end

function Lua_CrystalWarData:fromServer80100602(msg)
    self.camp_rank = msg.camp_rank;
    self.self_rank = msg.self_rank;
    self.self_score = msg.self_score
    self.self_reward = msg.self_reward
    self.camp_reward = msg.camp_reward;
end

function Lua_CrystalWarData:getCampNameById(id)
    if id == 1 then
        -- 北魏
        return LanUtil.getValue(122709)
    else
        return LanUtil.getValue(122710)
    end
end

function Lua_CrystalWarData.Get:buffNum()
    local _buffNum = 0
    local dataList = self.buffStateList
    local len = #self.buffStateList
    for i = 1, len do
        if dataList[i].state == true then
            _buffNum = _buffNum + 1
        end
    end
    return _buffNum
end

function Lua_CrystalWarData.Get:buffStateList()
    local list = { }
    if self.gather_state ~= nil then
        for k, v in ipairs(self.gather_state) do
            local dataList = { }
            dataList.index = k
            dataList.state = v.value == 1
            dataList.camp_id = v.sub
            dataList.name = self:getMapColorName(v.sub) .. v.name
            dataList.id = tonumber(tostring(v.id))
            dataList.map_pos = self.crystal_pos[k]
            dataList.UiName = self:getMapUiName(v.sub)
            list[k] = dataList
        end
    end
    return list
end

function Lua_CrystalWarData.Get:crystalConfig()
    if self._crystalConfig == nil then
        self._crystalConfig = getConfig( { "crystal_war_const" })
    end
    return self._crystalConfig
end

function Lua_CrystalWarData.Get:myCampName()
    if self.self_camp ~= nil then
        if self.self_camp == 1 then
            return LanUtil.getValue(128108)
        else
            return LanUtil.getValue(128109)
        end
    end
    return "";
end

function Lua_CrystalWarData:getMapColorName(camp_id)
    local str = ""
    if camp_id == 1 then
        str = LanUtil.getValue(128117)
    elseif camp_id == 2 then
        str = LanUtil.getValue(128118)
    end
    return str;
end

function Lua_CrystalWarData:getMapUiName(camp_id)
    local str = "map_fszz_stone"
    if camp_id == 1 then
        str = "map_fszz_stone"
    elseif camp_id == 2 then
        str = "map_fszz_stone"
    end
    return str;
end

-- 战斗剩余时间
function Lua_CrystalWarData.Get:fightResidueTime()
    if self.residueTime > 0 then
        return self.residueTime -(getTime() - self.fightInfoGetTime);
    end
    return 0;
end

function Lua_CrystalWarData.Get:fightCountDown()
    if self.count_down == nil then
        self.count_down = 0
    end
    if self.count_down > 0 then
        return self.count_down -(getTime() - self.fightInfoGetTime);
    end

    return 0;
end

function Lua_CrystalWarData.Get:blueCampScore()
    return self.camp_scores[1];
end

function Lua_CrystalWarData.Get:redCampScore()
    return self.camp_scores[2];
end

function Lua_CrystalWarData.Get:campWarWinNeedScore()
    return self.crystalConfig.win_score.value;
end

function Lua_CrystalWarData.Get:close_time()
    if self.crystalConfig.close_time == nil then
        return 0
    end
    return self.crystalConfig.close_time.value;
end

function Lua_CrystalWarData.Get:bossScore()
    return self.crystalConfig.morale_value.value;
end

function Lua_CrystalWarData.Get:buff_pos()
    return self.crystalConfig.buff_pos.arr;
end

function Lua_CrystalWarData.Get:crystal_pos()
    return self.crystalConfig.crystal_pos.arr;
end

function Lua_CrystalWarData:dispose()
    self.crystalSceneId = 0
    self:superCall("dispose");
end