Lua_GamePlayData = class("Lua_GamePlayData");
function Lua_GamePlayData:ctor()
    self:superCall("ctor");
    self.curChallengeTimes = 0;
    self.curBeBuyTimes = 0;
    self.curCanBuyTimes = 0;
    self.rankRewardState = -1;
    self.oldClickChangeListTime = 0;

    self:resetFightInfo();
end

function Lua_GamePlayData:dispose()
    self.curChallengeTimes = 0;
    self.curBeBuyTimes = 0;
    self.curCanBuyTimes = 0;
    self.rankRewardState = -1;
    self.oldClickChangeListTime = 0;

    self:resetFightInfo();
end

function Lua_GamePlayData.Get:bInBiWuScene()
    return DataCenter.roleData.sceneId == 50401;
end

function Lua_GamePlayData:fromServerArenaInfo(msg)
    self.challengeList = msg.target_list;
    self.curChallengeTimes = msg.cur_left_times; -- 剩余挑战次数
    self.curBeBuyTimes = msg.cur_buy_times;  -- 当前已购买挑战次数
    self.curCanBuyTimes = msg.cur_can_buy_times;  -- 当前可购买挑战次数
    self.rankRewardState = msg.reward_state; -- 领取状态 -1 不可领取 0 未领取 1 领取
    self.oldClickChangeListTime = msg.list_cd;  -- 列表刷新cd
end

function Lua_GamePlayData:fromServerArenaFightingInfo(msg)
    -- self.fight_leftTime = msg.left_time;   -- 剩余时间
    -- self.fight_startLeftTime = msg.ready_left_time; -- 战斗前倒计时
    self.fight_selfFightInfo = msg.self_fight;
    self.fight_targetFightInfo = msg.target_fight;
    self.fight_selfInfo = msg.self_info;
    self.fight_targetInfo = msg.target_info;
end

function Lua_GamePlayData:fromServerArenaFightingTimeInfo(msg)
    self.fight_getTime = getTime();
    self.fight_leftTime = tonumber(msg.left_time);   -- 剩余时间
    self.fight_startLeftTime = tonumber(msg.ready_left_time); -- 战斗前倒计时
end

function Lua_GamePlayData:resetFightInfo()
    self.fight_getTime = 0;
    self.fight_leftTime = 0;   -- 剩余时间
    self.fight_startLeftTime = 0; -- 战斗前倒计时
    self.fight_selfFightInfo = nil;
    self.fight_targetFightInfo = nil;
    self.fight_selfInfo = nil;
    self.fight_targetInfo = nil;
end

-- 比武排行奖励配置
function Lua_GamePlayData:getBiWuRankRewards()
    if self.rankRewards == nil then
        self.rankRewards = Array();
        local config = checkRequire("arena_plus_settle");
        if config ~= nil then
            for i, v in ipairs(config) do
                self.rankRewards:add(v);
            end
        end
    end

    return self.rankRewards;
end

function Lua_GamePlayData:getBiWuByTimesCost()
    if self.biwuTimesCostArr == nil then
        self.biwuTimesCostArr = Array();
        local list = getConfig({"arena_plus_info", "buy_cost_money", "arr"});
        if list ~= nil then
            local num = #list;
            for i = 1, num do
                self.biwuTimesCostArr:add(list[i]);
            end
        end
    end
    return self.biwuTimesCostArr;
end