Lua_GiftItem = class("Lua_GiftItem", Lua_DisplayObject);
function Lua_GiftItem:ctor(p)
    self.frameBuild = false;
    self.isOpen = false;
    self:superCall("ctor", p);
end
function Lua_GiftItem:buildShowItem()
    self:superCall("buildShowItem");
    self.moveTime = getConfig( { "drop_packet", "move_time" }).value;
    self.boxIcon = UICreate.createUIAtlasImage(self.content, "daily_atlas_2", "ui_tjhl_01", 0, 0, 0, 0);
    self.dropEffect = UICreate.createUIEffect(self.boxIcon.mainContent, "/effects/scsEffects/gui_fallen_gift", "gui_fallen_gift", 0, 0);
    self.dropEffect:SetRenderQueue(self.boxIcon, 5, 2, false);
end
function Lua_GiftItem:setData(data)
    self.index = data.index
    self.leftTime = data.left_time;
    self.giftInfo = data.item_set;
    self.startPosX = data.start_pos_x;
    self.startPosY = data.start_pos_y;
    self.endPosX = data.end_pos_x;
    self.endPosY = data.end_pos_y;
    self.packet_type = data.packet_type;
    self:setStartPos();
    self:setGiftStyle();
    self:onPlayAnim();
end

function Lua_GiftItem:setStartPos()
    self.boxIcon:setLocation(self.startPosX, self.startPosY, 0)
end

function Lua_GiftItem:setGiftStyle()
    self.boxIcon:setAltas("daily_atlas_2", self.packet_type == 1 and "ui_tjhl_01" or "ui_tjhl_02");
end

function Lua_GiftItem:onPlayAnim()
    TweenUtil.getInstance():addTween(self.boxIcon.mainContent, self.moveTime, 0, Vector3(self.endPosX, self.endPosY, 0), nil, nil);
    self:addFun();
end
function Lua_GiftItem:addFun()
    self.boxIcon:addClickFuntion(self, self.onOpenBoxClick)
end
function Lua_GiftItem:onOpenBoxClick()
    Lua_ProxyManager.getProxy("Lua_GiftActivitiesProxy"):sGetRewards(tonumber(self.index));
end
function Lua_GiftItem:showEffect()
    self.boxIcon:setAltas("daily_atlas_2", self.packet_type == 1 and "ui_tjhl_01_S" or "ui_tjhl_02_S");
    self.boxIcon:setEnable(true);
    if self.effect == nil then
        self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_open_gift", "gui_open_gift", self.endPosX, self.endPosY);
        self.effect:SetRenderQueue(self.boxIcon, 5, 2, false);
    end

    Lua_CommonUtil.delayCall(1, self, self.onDestroyItem);
end
function Lua_GiftItem:onDestroyItem()
    self.effect:dispose();
    self.effect = nil;
    self.boxIcon:setEnable(false);
end
function Lua_GiftItem:dispose()
    TweenUtil.getInstance():stop(self.boxIcon.mainContent);
    self:superCall("dispose");
end