checkRequire("Lua_CrystalWarData")
Lua_CrystalWarProxy = class("Lua_CrystalWarProxy");
function Lua_CrystalWarProxy:ctor()
    DataCenter.crystalWarData = Lua_CrystalWarData.new();

    LuaUtil.addLuaMsg(50400860, self, self.rEnterScene);
    -- 进入活动(返回)
    LuaUtil.addLuaMsg(50400861, self, self.rRankInfo);
    -- 请求排行榜(返回)

    LuaUtil.addLuaMsg(80100601, self, self.rWarFightInfo);
    -- 战场信息(主动)
    LuaUtil.addLuaMsg(80100602, self, self.rWarFightResult);
    -- 战场结算(主动)
end

-----------------------------------------------------
-- 上行协议

-- 进入活动
function Lua_CrystalWarProxy:sEnterScene()
    sendMsg(10400860);
end

-- 排行榜
function Lua_CrystalWarProxy:sInitRankMsg()
    sendMsg(10400861);
end

-- 退出场景
function Lua_CrystalWarProxy:sExitScene()
    sendMsg(10400902);
end



-----------------------------------------------------
-- 下行协议

-- 请求进入夺旗大战活动（返回）
function Lua_CrystalWarProxy:rEnterScene(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_CrystalWarWindow", WinParam.ACTION_CLOSE);
        Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
    end
end

-- 请求战场排行榜(返回)
function Lua_CrystalWarProxy:rRankInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50400803();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("UPDATA_CRYSTAL_RANK", msg);
    end
end

-- 战场信息(主动)
function Lua_CrystalWarProxy:rWarFightInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80100601();
        msg:ParseFromString(mp.data);
        DataCenter.crystalWarData:fromServer80100601(msg);
        Lua_MsgUtil.callFunc("UPDATA_CRYSTAL_PANEL");
    end
end

-- 战场结算(主动)
function Lua_CrystalWarProxy:rWarFightResult(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80100602();
        msg:ParseFromString(mp.data);
        Lua_WindowUtil.openWin("Lua_CrystalWarResultWindow", WinParam.ACTION_OPEN, msg);
    end
end