Lua_GiftPlayData = class("Lua_GiftPlayData");

function Lua_GiftPlayData:ctor()
    self:superCall("ctor");
    self._itemArr = Array();
    self._specialItemArr = Array()
    self._specialItemList = { }
    
end
function Lua_GiftPlayData.Get:specialArr()
    if self._specialArr == nil then
        self._specialArr = Lua_CommonUtil.getCommonConfig("special_gift_item", 3);
    end
    return self._specialArr;
end
function Lua_GiftPlayData:fromServer81400110(msg)
    self.items = msg.items;
    if msg.items ~= nil then
        self._itemArr:clear();
        self._specialItemArr:clear()
        self._specialItemList = { }
        for k, v in ipairs(msg.items) do
            local isAdd = true
            local vo = Lua_ToolVo.new(v.id, v.amount, v.bind);
            vo:fromServer(v);
            vo.packType = Lua_PackData.BAG_PACK;
            vo.bShowQualityEff = true;
            for i = 1, #self.specialArr do
                if self.specialArr[i] == v.id then
                    isAdd = false
                    vo.bShowQualityEff = false;
                    if self._specialItemList[vo.id] == nil then
                        self._specialItemList[vo.id] = vo
                    else
                        self._specialItemList[vo.id].count = self._specialItemList[vo.id].count + vo.count
                    end
                    break
                end
            end
            if isAdd then
                self._itemArr:add(vo);
            end
        end
    end
    if self._itemArr:getSize() ~= 0 then
        Lua_WindowUtil.openWin("Lua_RewardGainWindow", WinParam.ACTION_OPEN, self._itemArr);
    end
end

function Lua_GiftPlayData.Get:itemArr()
    return self._itemArr;
end

function Lua_GiftPlayData.Set:itemArr()
    self._itemArr = Array();
end

function Lua_GiftPlayData.Get:specialItemArr()
    for k, v in pairs(self._specialItemList) do
        self._specialItemArr:add(v)
    end
    return self._specialItemArr;
end

function Lua_GiftPlayData.Set:itemIndex(value)
    self._itemIndex = value;
end
function Lua_GiftPlayData.Get:itemIndex()
    return self._itemIndex
end

function Lua_GiftPlayData:dispose()
    self._itemArr:clear();
    self._specialItemArr:clear()
    self._specialItemList = { }
    self:superCall("dispose");
end
