checkRequire("Lua_GodWingVo");
checkRequire("Lua_GodWingSynthesisInfoVo");
checkRequire("Lua_WingSortTool");
Lua_GodWingData = class("Lua_GodWingData");
function Lua_GodWingData:ctor()
	self.wingSynthesisInfoList = {};
	self.packWingList = {};
	self.packEquipList = {};
	self.selectEquipNum = Array();
	self.selectWingNum = Array();
	self.myEquipList = Array();
	self.myWingList = Array();
end

function Lua_GodWingData:getPackWingInfoList()
	if self.myWingList ~= nil then
		return self.myWingList;
	end
end

function Lua_GodWingData:getPackEquipInfoList()
	if self.myEquipList ~= nil then
		return self.myEquipList;
	end
end

function Lua_GodWingData:getWingInfoByWingRank(wing_rank)
	if self.wingSynthesisInfoList[wing_rank] == nil then
		return nil;
	end
	return self.wingSynthesisInfoList[wing_rank];
end

-- 精炼神翼信息
function Lua_GodWingData:init51403812(msg)
	self.wing_id = msg.wing_id;
	self.wing_progress = msg.wing_progress;
	self.color = msg.color;
	self.props_info = msg.props_info;
	self.attributes = msg.attributes;
	self.wing_class = msg.wing_class;
	self:setAttributes(self.attributes);
end

function Lua_GodWingData.Get:hasPutWing()
	if self.wear_wing_id == 0 or self.wear_wing_id == nil then
		return false;
	end
	return true;
end

function Lua_GodWingData:getForce()
	if self.wear_wing_id == 0 or self.wear_wing_id == nil then
		return 0;
	end
	if self.wing_id == 0 or self.wing_id == nil then
		return 0;
	end
	return Lua_FightUtil.caculateConfigForce(self.attributes);
end

function Lua_GodWingData:setAttributes(attributes)
	self.attributesList = {};
	if attributes.damage ~= 0 then
		self.attributesList[Lua_FightUtil.DAMAGE_STR] = attributes.damage;
	end
	if attributes.blood ~= 0 then
		self.attributesList[Lua_FightUtil.BLOOD_MAX_STR] = attributes.blood;
	end
	if attributes.attack ~= 0 then
		self.attributesList[Lua_FightUtil.ATTACK_STR] = attributes.attack;
	end
	if attributes.crit ~= 0 then
		self.attributesList[Lua_FightUtil.DEFENCE_STR] = attributes.defence;
	end
	if attributes.attack ~= 0 then
		self.attributesList[Lua_FightUtil.CRIT_STR] = attributes.crit;
	end
	if attributes.hit ~= 0 then
		self.attributesList[Lua_FightUtil.TOUGHNESS_STR] = attributes.toughness;
	end
	if attributes.attack ~= 0 then
		self.attributesList[Lua_FightUtil.HIT_STR] = attributes.hit;
	end
	if attributes.avoid ~= 0 then
		self.attributesList[Lua_FightUtil.AVOID_STR2] = attributes.avoid;
	end
	if attributes.reduction ~= 0 then
		self.attributesList[Lua_FightUtil.REDUCTION_STR] = attributes.reduction;
	end
end

-- 穿戴神翼信息
function Lua_GodWingData:init51403817(msg)
	self.wear_wing_id = msg.wing_id;
	self.wear_wing_class = msg.wing_class;
	self.wear_wing_color = msg.wing_color;
	self.wear_wing_zizhi = msg.wing_zizhi;
	self.wear_wing_attri = msg.wing_attri;
	self.wear_wing_bind = msg.wing_bind;
	self.wing_shape = msg.wing_shape;
	self.is_wear = msg.is_wear;
	self.time_left = msg.time_left;
	self:setAttributes(self.wear_wing_attri);
end

function Lua_GodWingData:init81403810(msg)
	self.limitWingInfo = msg;
end

function Lua_GodWingData:init51403814(msg)
	self.wear_wing_id = msg.wing_id;
end

function Lua_GodWingData:init51403810(list)
	self.wingSynthesisInfoList = { };
	for i, v in pairs(list) do
		if v.wing_rank ~= nil then
			local to = Lua_GodWingSynthesisInfoVo.new();
			to:fromServer(v);
			self:addOneWingSynthesisInfo(to);
		end
	end
end

function Lua_GodWingData:init51403811(msg)
	for i, v in pairs(self.wingSynthesisInfoList) do
		if v.wing_rank == msg.wing_class then
			self.wingSynthesisInfoList[v.wing_rank].need_props_info = msg.need_props_info;
		end
	end
	self.is_chenggong = msg.is_chenggong;
end

function Lua_GodWingData:init51403816(msg)
	self.packWingList = {};
	self.wingListNum = Array()
	self.myWingList = Array()
	if msg.wing_deatil ~= nil then
		for i, v in ipairs(msg.wing_deatil) do
			if v.wing_id ~= nil then
				local to = Lua_GodWingVo.new(v.wing_id);
				to:fromServer(v);
				self:addOneWingInfo(to);
				self.wingListNum:add(v.wing_pack_index)
			end
		end
	end

	if self.selectWingNum:getSize() ~= 0 then
		for i = 1, self.selectWingNum:getSize() do
			for k = 1, self.wingListNum:getSize() do
				if self.wingListNum[k] == self.selectWingNum[i] then
					self:removePackWingListById(self.selectWingNum[i]);
				end
			end
		end
	end

	if self.packWingList ~= nil then
		for i, v in pairs(self.packWingList) do
			self.myWingList:add(v);
		end
	end
end

function Lua_GodWingData:init51403818(msg)
	self.packEquipList = {};
	self.equipListNum = Array()
	if msg.equip_list ~= nil then
		for i, v in ipairs(msg.equip_list) do
			local tv = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemByIndex(v.pkg_index);
			local equData = DataCenter.equData;
			local careernum = DataCenter.roleData.career;
			local myEqu = equData:getEquByPart(tv.part);
			if (careernum ~= tv.career and tv.career ~= 0) or (myEqu ~= nil
				and (careernum == tv.career or tv.career == 0) and tv.force < myEqu.force) then
				self.packEquipList[v.pkg_index] = v
				self.equipListNum:add(v.pkg_index)
			end
		end
	end
	self:sortMyEquipList();
end

-- 刷新装备数据
function Lua_GodWingData:sortMyEquipList()
	self.myEquipList = Array()
	if self.selectEquipNum:getSize() ~= 0 then
		for i = 1, self.selectEquipNum:getSize() do
			for k = 1, self.equipListNum:getSize() do
				if self.equipListNum[k] == self.selectEquipNum[i] then
					self:removePackEquipListById(self.selectEquipNum[i]);
				end
			end
		end
	end

	if self.packEquipList ~= nil then
		for i, v in pairs(self.packEquipList) do
			local info = Lua_WingSortTool.new();
			info.equip = v
			info.select = false
			self.myEquipList:add(info);
		end
	end
	self.myEquipList:sort("aa", true);
end

-- 通过id移除已经选择的装备
function Lua_GodWingData:removePackEquipListById(id)
	if self.packEquipList[id] ~= nil then
		self.packEquipList[id] = nil
	end
end

-- 通过id移除已经选择的神翼
function Lua_GodWingData:removePackWingListById(id)
	if self.packWingList[id] ~= nil then
		self.packWingList[id] = nil
	end
end

-- 通过翅膀id存到数组
function Lua_GodWingData:addOneWingInfo(oneInfo)
	if oneInfo.wing_pack_index ~= nil and self.packWingList[oneInfo.wing_pack_index] == nil then
		self.packWingList[oneInfo.wing_pack_index] = oneInfo;
	end
end

-- 通过神翼等阶存到数组
function Lua_GodWingData:addOneWingSynthesisInfo(oneInfo)
	if oneInfo.wing_rank ~= nil and self.wingSynthesisInfoList[oneInfo.wing_rank] == nil then
		self.wingSynthesisInfoList[oneInfo.wing_rank] = oneInfo;
	end
end

-- 所有选择的装备
function Lua_GodWingData:addOnePackEquipInfo(oneInfo)
	if oneInfo.pkg_index ~= nil then
		self.selectEquipNum:removeItem(oneInfo.pkg_index);
		self.packEquipList[oneInfo.pkg_index] = oneInfo;
	end
	self:sortMyEquipList();
end

function Lua_GodWingData:removeOnePackEquipInfo(oneInfo)
	if oneInfo.pkg_index ~= nil then
		self.selectEquipNum:add(oneInfo.pkg_index);
		self.packEquipList[oneInfo.pkg_index] = nil;
	end
	self:sortMyEquipList();
end

-- 所有选择的神翼
function Lua_GodWingData:addOnePackWingInfo(oneInfo)
	if oneInfo.wing_pack_index ~= nil then
		self.selectWingNum:removeItem(oneInfo.wing_pack_index);
	end
end

function Lua_GodWingData:removeOnePackWingInfo(oneInfo)
	if oneInfo.wing_pack_index ~= nil then
		self.selectWingNum:add(oneInfo.wing_pack_index);
	end
end

-- 移除所有选择的装备或者神翼
function Lua_GodWingData:clearSelectEquipNum()
	if self.selectEquipNum:getSize() ~= 0 then
		self.selectEquipNum:clear()
	end
end

function Lua_GodWingData:clearSelectWingNum()
	if self.selectWingNum:getSize() ~= 0 then
		self.selectWingNum:clear()
	end
end

-- 当前选择的单个装备
function Lua_GodWingData:saveSelectEquip(data)
	self.equipData = data;
end

function Lua_GodWingData:getSelectEquip()
	if self.equipData ~= nil then
		return self.equipData
	end
end

-- 当前选择的单个神翼
function Lua_GodWingData:saveSelectWing(data)
	self.wingData = data;
end

function Lua_GodWingData:deleteSelectWing()
	self.wingData = nil;
end

function Lua_GodWingData:getSelectWing()
	if self.wingData ~= nil then
		return self.wingData
	end
end

-- 根据神翼品阶及颜色显示对应名字
function Lua_GodWingData:getWingName(classId, color)
	local lvltxt
	if classId == 0 then
		lvltxt = LanUtil.getValue(110714)
	elseif classId == 1 then
		lvltxt = LanUtil.getValue(110715)
	elseif classId == 2 then
		lvltxt = LanUtil.getValue(110716)
	end

	if color == 0 then
		lvltxt = "[55d2ff]" .. lvltxt .. LanUtil.getValue(110720) .. "[-]"
	elseif color == 1 then
		lvltxt = "[ff59fd]" .. lvltxt .. LanUtil.getValue(110721) .. "[-]"
	elseif color == 2 then
		lvltxt = "[ed9700]" .. lvltxt .. LanUtil.getValue(110722) .. "[-]"
	elseif color == 3 then
		lvltxt = "[ff5151]" .. lvltxt .. LanUtil.getValue(110723) .. "[-]"
	end
	return lvltxt;
end