checkRequire("Lua_GodWingData");
Lua_GodWingProxy = class("Lua_GodWingProxy");
function Lua_GodWingProxy:ctor()
	DataCenter.GodWingData = Lua_GodWingData.new();

	LuaUtil.addLuaMsg(51403810, self, self.rOpenWingSynthesisInfo);
	LuaUtil.addLuaMsg(51403811, self, self.rWingSynthesis);
	LuaUtil.addLuaMsg(51403812, self, self.rOpenWingWindow);
	LuaUtil.addLuaMsg(51403813, self, self.rRetrunMistake);
	LuaUtil.addLuaMsg(51403815, self, self.rUnloadWing);
	LuaUtil.addLuaMsg(51403816, self, self.rGetPackWingWindow);
	LuaUtil.addLuaMsg(51403817, self, self.rGetWearWingWindow);
	LuaUtil.addLuaMsg(51403818, self, self.rGetPackEquipWindow);
	LuaUtil.addLuaMsg(51403814, self, self.rPutWing);
	LuaUtil.addLuaMsg(81403810, self, self.rLimitWingTime);
end

function Lua_GodWingProxy:rOpenWingSynthesisInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403810();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403810(msg.wing_synthesis_info);
		Lua_MsgUtil.callFunc("ON_OPENWING_SYNTHETIC_WINDOW");
	end
end

function Lua_GodWingProxy:rWingSynthesis(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403811();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403811(msg);
		Lua_MsgUtil.callFunc("ON_WING_SYNTHESIS");
	end
end

function Lua_GodWingProxy:rOpenWingWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403812();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403812(msg);
		Lua_MsgUtil.callFunc("ON_OPEN_WING_WINDOW");
	end
end

function Lua_GodWingProxy:rRetrunMistake(mp)
	-- if mp.errno == 1781 then
	-- 	OperateAlert.show(LanUtil.getValue(110729));
	-- end
end

function Lua_GodWingProxy:rUnloadWing(mp)
	if mp.errno == 0 then
		sendMsg(11403817);
	end
end

function Lua_GodWingProxy:rGetPackWingWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403816();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403816(msg);
		Lua_MsgUtil.callFunc("CREATE_WING_ITEM");
	end
end

function Lua_GodWingProxy:rGetWearWingWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403817();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403817(msg);
		Lua_MsgUtil.callFunc("WING_UPDATE");
		Lua_MsgUtil.callFunc("PUT_WING_UPDATE");
	end
end

function Lua_GodWingProxy:rGetPackEquipWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403818();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403818(msg);
		Lua_MsgUtil.callFunc("CREATE_EQUIP_ITEM");
	end
end

function Lua_GodWingProxy:rPutWing(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403814();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init51403814(msg);
		Lua_MsgUtil.callFunc("PUT_WING_UPDATE");
		
		local config = Lua_WingUtil.getLimitWingConfig("id")
		local careernum = DataCenter.roleData.career;
		if config[careernum] ~= msg.wing_id then
			Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_FeatureMainWindow", WinParam.ACTION_OPEN, 3);
		end
		Lua_ProxyManager.getProxy("Lua_PackProxy"):checkBetterEqu();
	end
end

function Lua_GodWingProxy:rLimitWingTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81403810();
		msg:ParseFromString(mp.data);
		DataCenter.GodWingData:init81403810(msg);

		if msg.is_show == 0 and msg.is_windows == 0 then
			Lua_MsgUtil.callFunc("UPDATE_WING_TIPS", 0);
		elseif msg.is_show == 0 and msg.is_windows == 1 then
			Lua_WindowUtil.openWin("Lua_TimeLimitWingWindow", WinParam.ACTION_OPEN, nil);
			Lua_MsgUtil.callFunc("UPDATE_WING_TIPS", 0);
		elseif msg.is_show == 1 and msg.is_windows == 0 then
			Lua_MsgUtil.callFunc("UPDATE_WING_TIPS", 1);
		end
	end
end