Lua_GuideData = class("Lua_GuideData")
function Lua_GuideData:ctor()
	self.needGuideId = 0;
	self.needContinueTruck = false;
	self.stopMoveToGuide = false;
	
end
function Lua_GuideData:dispose()
	self._levelUpDataDic = nil;
end
function Lua_GuideData:checkLevelUpToGuide()
	local roleLv = DataCenter.roleData.level;
	if DataCenter.funcOpenData:isInForbiddenLevelGuideScene() == true then
		return;
	end
	if self.levelUpDataDic[roleLv] ~= nil then
		if Lua_WindowUtil.isWindowShowing("Lua_GuideWindow") == true then
			Lua_WindowUtil.openWin("Lua_GuideWindow",WinParam.ACTION_CLOSE);
		end
		Lua_WindowUtil.openWin("Lua_GuideWindow",WinParam.ACTION_OPEN,self.levelUpDataDic[roleLv]);
	end
	
end

function Lua_GuideData.Get:levelUpDataDic()
	if self._levelUpDataDic == nil then
		self._levelUpDataDic={};
		local cfg = getConfig({"levelup_zhiyin"});
		for k,v in ipairs(cfg) do
			self._levelUpDataDic[v.level] = v.guide_id;
		end
	end
	return self._levelUpDataDic;
end
function Lua_GuideData:doShowGuideWin()
	if self.needGuideId ~= 0 then
		Lua_WindowUtil.openWin("Lua_GuideWindow", nil, self.needGuideId);
		self.needGuideId =  0;
	end
	
end

function Lua_GuideData:doContinueTruck()
	if self.needContinueTruck == true or self.stopMoveToGuide == true then		
		self.needContinueTruck = false;
		self.stopMoveToGuide = false;
		local truckTaskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
		if truckTaskList:getSize()>0 then
			DataCenter.hook:doTruckTask();
		end
	end
end

function Lua_GuideData:doShowWelcomeWin()
	if DataCenter.roleData.level <= 1 and getShowTips() == true then
		if not Lua_WindowUtil.isWindowShowing("Lua_WelcomeWindow") then
			Lua_WindowUtil.openWin("Lua_WelcomeWindow", WinParam.ACTION_OPEN);
		end
	end
end

