Lua_HangUpSettingsData = class("Lua_HangUpSettingsData");
function Lua_HangUpSettingsData:ctor()
	self.items = {
		"auto_drug",--自动喝药，0未设置1优先使用小药瓶2优先使用大药瓶
		"auto_drug_blood",--吃药血量
		"auto_drug_magic",--吃药蓝量
		"auto_buy_drug",--自动买药
		"relive_type",--1自动复活
		"auto_avoid_boss",--1自动避开boss
		"auto_pickup",--自动拾取
		"auto_pick_color",--自动拾取装备颜色
		"auto_sell",--自动出售装备
		"auto_eat_equipt",--自动吞噬装备
		"hook_pk_state",--离线挂机pk模式
		"auto_call_beast",--自动使用变身技能
		"auto_back_main",--夜间推送
		"hook_monster_sort"--挂机范围
	};
	self:dispose();
end
function Lua_HangUpSettingsData.Get:auto_sell()
	return self._auto_sell;
end
function Lua_HangUpSettingsData.Set:auto_sell(val)
	self._auto_sell = val;
end
function Lua_HangUpSettingsData:clearExp()
	self.expRate = -1;
	self.expRateShow = -1;
end
function Lua_HangUpSettingsData:setExpRate(rate, isShow)
	self.expRate = rate;
	self.expRateShow = isShow;

	Lua_MsgUtil.callFunc("HOKK_EXP_RATE");
end

function Lua_HangUpSettingsData:getMaxHookTime()
	if self._maxTime == nil then
		self._maxTime = getConfig({"hook","hook_time_limit"});
	end
	return self._maxTime;
end
function Lua_HangUpSettingsData:dispose()
	self.auto_buy_drug = 1;--自动买药；0未设置，1 自动购买
	self.auto_drug = 1;--自动喝药，0未设置1优先使用小药瓶2优先使用大药瓶
	self.auto_drug_blood = 80;--使用血量
	self.auto_drug_magic = 80;--使用蓝量
	self.relive_type = 0;
	self.auto_avoid_boss = 1;
	self.auto_pickup = 1;--0未设置
	self.auto_sell = 0;--自动出售绿色，蓝色
	self.auto_eat_equipt = 1;--背包小于5
	self.hook_pk_state = 0;
	self.auto_pick_color = 1;
	self.hook_monster_sort = 0;
	self.auto_call_beast = 0;
	self.auto_back_main = 1;

	self.outLineLeftTime = -1;
	self.showNoMoneyWin = false;
	self:clearExp();
end
function Lua_HangUpSettingsData:fromServer(data)
	for i,v in ipairs(self.items) do
		self[v] = data[v];
	end
end
function Lua_HangUpSettingsData:saveHangUp()
	local cmd = ProtoPublic_pb.Proto11401004();
	for i,v in ipairs(self.items) do
		cmd.hook_detail[v] = self[v];
	end
	sendMsg(11401004, cmd);
end

function Lua_HangUpSettingsData:useOutTimeItem(data, num)
	local maxTime = self:getMaxHookTime();
	if maxTime <= self.outLineLeftTime then
		OperateAlert.show(LanUtil.getValue(110230));
		return;
	end
	if self.itemNum == 0 then
		Lua_WindowUtil.openWin("Lua_ItemBuyWindow", nil, {itemId=self.itemId, moneyType=Lua_MoneyData.GOLD_AND_BINDGOLD});
	else
		local oneItemTime = data.effect_prop.value;
		local addTime = num * oneItemTime;
		local all_time = addTime + self.outLineLeftTime;
		
		if all_time > maxTime then--溢出
			local tipData = {};
            tipData.des = LanUtil.getValue(110229);
            tipData.owner = self;
            tipData.type = 1;
            tipData.data = {itemData=data, num=num};
            tipData.subFun = self.onTipSubClick;   --确定
            Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			local msg = ProtoPublic_pb.Proto11400106();
			msg.index = data.index;
        	msg.amount = num;
        	sendMsg(11400106, msg);
		end
	end
end
function Lua_HangUpSettingsData:onTipSubClick(data)
	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = data.data.itemData.index;
	msg.amount = data.data.num;
	sendMsg(11400106, msg);
end