checkRequire("Lua_HangUpSettingsData");
checkRequire("Lua_ServerSaveData");
Lua_HangUpSettingsProxy = class("Lua_HangUpSettingsProxy");
function Lua_HangUpSettingsProxy:ctor()
	self:superCall("ctor");
	DataCenter.hangUpSettingsData = Lua_HangUpSettingsData.new();
	DataCenter.saveData = Lua_ServerSaveData.new();
	LuaUtil.addLuaMsg(51401001, self, self.rGetHangUpPanelInfo);

	LuaUtil.addLuaMsg(51404303, self, self.onOutLineLeftTime);
	LuaUtil.addLuaMsg(80404301, self, self.onOutLineResult);

	LuaUtil.addLuaMsg(50100171, self, self.onSaveServerData);
end

function Lua_HangUpSettingsProxy:onSaveServerData(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100171();
		msg:ParseFromString(mp.data);
		DataCenter.saveData:fromServer(msg);
	end
end

function Lua_HangUpSettingsProxy:rGetHangUpPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401001();
		msg:ParseFromString(mp.data);
		DataCenter.hangUpSettingsData:fromServer(msg.hook_detail);
		Lua_MsgUtil.callFunc("HANGUP_PANEL_UPDATE");
	end
end

function Lua_HangUpSettingsProxy:onOutLineResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404301();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_OutLineResultWindow", nil, msg);
	end
end

function Lua_HangUpSettingsProxy:onOutLineLeftTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51404303();
		msg:ParseFromString(mp.data);
		if msg.item_id ~= 0
			and DataCenter.hangUpSettingsData.outLineLeftTime ~= -1
			and msg.total_time > DataCenter.hangUpSettingsData.outLineLeftTime then
			local cTime = msg.total_time - DataCenter.hangUpSettingsData.outLineLeftTime;
			Lua_WindowUtil.openWin("Lua_OutLineUseItemWindow", WinParam.ACTION_AUTO, {itemId=msg.item_id, changeTime=cTime, nowTime=msg.total_time});
		end
		DataCenter.hangUpSettingsData.outLineLeftTime = msg.total_time;
		Lua_MsgUtil.callFunc("OUT_LINE_TIME", msg);

		if DataCenter.isHangFirst == true 
			and msg.total_time < getConfig({"hook","hook_tips_time"})
			and DataCenter.funcOpenData:isOpened(10030) == true then
			DataCenter.isHangFirst = false;
			local msg = {};
			msg.type = Lua_MenuTipData.OUT_LINE_TIP;
			msg.altas = "mainWindow_atlas";
			msg.spriteName = "ui_zhujiemian_icon_13";
			msg.state = 1;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		else
			local msg = {};
			msg.type = Lua_MenuTipData.OUT_LINE_TIP;
			msg.state = 0;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		end
	end
end