checkRequire("Lua_SceneConfigData");

Lua_HookControl = class("Lua_HookControl");
Lua_HookControl.HOOKING_DELAY = 0.2;
function Lua_HookControl:start(dt)
    -- 地图限制不能挂机
    local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneCfg ~= nil and sceneCfg.config.unableHook and sceneCfg.config.unableHook == 1 then
        OperateAlert.show(LanUtil.getValue(121818));
        return;
    end
    if GlobalVar.isActing then
        return;
    end
    self._taskType = dt == nil and self._taskType or dt;
    if GlobalVar.hooking == true then
        return;
    end
    DataCenter.attackedData:clearMoveTo();
    self.checkHookTime = 0;
    DataCenter.doingTask = false;
    GlobalVar.hooking = true;
    self.checkHookMonster = nil;
    DataCenter.hangUpSettingsData:clearExp();
    local cmd = ProtoPublic_pb.Proto11400011();
    cmd.hooking = true;
    sendMsg(11400011, cmd);

    local rd = DataCenter.roleData;
    self._setScene = DataCenter.roleData.sceneId;
    self._startPos = {x=rd.px,y=rd.py,z=rd.pz};

    self._lastControlTime = 0;
    Lua_MsgUtil.callFunc(EventsDefine.HOOK_STATE_CHANGE);
    
    Lua_WindowUtil.openWin("Lua_HookWindow",WinParam.ACTION_OPEN);
end
function Lua_HookControl:getStartPos()
    if self._startPos == nil then
        local rd = DataCenter.roleData;
        self._startPos = {x=rd.px,y=rd.py,z=rd.pz};
    end
    return self._startPos;
end
function Lua_HookControl:stop(clearTask)    
    if GlobalVar.isActing then
        return;
    end
    if clearTask == true then
        self._taskType = 0;
    end
    if GlobalVar.hooking == false then
        return;
    end
    DataCenter.hangUpSettingsData:clearExp();
    MsgUtil.callFunc("PLAYER_STOP");
    local cmd = ProtoPublic_pb.Proto11400011();
    cmd.hooking = false;
    sendMsg(11400011, cmd);

    self._monsterId = 0;
    self.curTruckTask = 0;
    self.dropItemId = 0;
    self.nextSkill = nil;
    GlobalVar.hooking = false;
    Lua_MsgUtil.callFunc(EventsDefine.HOOK_STATE_CHANGE);
    Lua_WindowUtil.openWin("Lua_HookWindow",WinParam.ACTION_CLOSE,nil);
end
function Lua_HookControl:initHook()
    self._taskType = 0;
    self._monsterId = 0;
    self._lastMoveTime = 0;
    self._lastHookTime = 0;
    self._posDirty = true;
    self._curPos = Vector3();
    self.selectedId = 0;
    self.moveInterval = 0;
    self.checkHookTime = 0;
    self.curTruckTask = 0;
    self.nextSkill = nil;
    self._lastControlTime = getTime();
    Lua_CommonUtil.addTimer("OnHooking", 0.2, self, self.onHooking);
    self.canAutoDrug = false;
    Lua_MsgUtil.addEventListener("SCENE_LOADED",self,self.onSceneLoaded);--场景切换完毕
    Lua_MsgUtil.addEventListener("SCENE_CHANGE",self,self.onSceneChange);--场景切换
end
function Lua_HookControl:setNextSkill(nextSkill, lastTime)
    self.nextSkill = nextSkill;
    self.nextLastTime = lastTime;
    self.nextStartTime = getTime();
end
function Lua_HookControl:setCheckHookMonster(mid)
    self.checkHookMonster = tonumber(mid);
end
function Lua_HookControl:onSceneLoaded()
    --切换好场景后才能喝药恢复
    self.canAutoDrug = true;
end
function Lua_HookControl:onSceneChange()
    self.canAutoDrug = false;
end
function Lua_HookControl:dispose()
    Lua_HookControl:stop(true);
end
function Lua_HookControl:getCurPos()
    local rd = DataCenter.roleData;
    self._curPos:Set(rd.px, rd.py, rd.pz);
    return self._curPos;
end
function Lua_HookControl:resetControlTime(time)
    self._lastControlTime = getTime() + time;
    self.curTruckTask = 0;
    self.dropItemId = 0;
    self.checkHookMonster = nil;
    DataCenter.doingTask = false;
end
function Lua_HookControl:isTemp()
    return getTime() - self._lastControlTime < 0;
end
function Lua_HookControl:setCurSelectedId(val)
    PlayerData.getInstance().selectedId = val;
    if self.selectedId ~= val then
        self.selectedId = val;
    end
end
function Lua_HookControl:onHooking()
    if GlobalVar.isActing then
        return;
    end
    local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneCfg == nil or sceneCfg.config == nil then
        return;
    end
    if sceneCfg ~= nil and sceneCfg.config.unableHook and sceneCfg.config.unableHook == 1 then
        self:stop();
        return;
    end
    if self:isTemp() then--临时挂机
        return;
    end
    if getTime() - self._lastHookTime < Lua_HookControl.HOOKING_DELAY then
        return;
    end
    self._posDirty = true;
    if getTime() - self.checkHookTime > 10 then
        self.checkHookTime = getTime();
        GlobalVar.walking = true;
    else
        GlobalVar.walking = false;
    end
    --local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    --有主线任务时，优先做主线任务
    --策划需求 屏蔽自动做主线 2018.3.21 
    --[[if sceneConfig.no_auto_task == 0 and self._monsterId == 0 and self:doTruckTask() == true then
        return;
    end--]]
    if GlobalVar.hooking == true then
        self:doNormalMap();
    else
        if self.checkHookMonster ~= nil then
            local rs = DataCenter.thingData:getNearMonsterByType(self:getCurPos(), self.checkHookMonster);
            if rs ~= nil then
                local cp = self:getCurPos();
                local dx = cp.x - rs.px;
                local dz = cp.z - rs.pz;
                local curDis = math.abs(dx) + math.abs(dz);
                if curDis < 8000 then
                    local mv = self.checkHookMonster;
                    self:start();
                    self:setMonsterTarget(mv);
                    self.checkHookMonster = nil;
                end
            end
        end
    end
    --自动使用药水
    self:doAutoDrug();
end
function Lua_HookControl:doTruckTask()
    local truckTaskList = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
    if truckTaskList:getSize()>0 then
        local truckTaskVo = truckTaskList[1];
        --print("self.curTruckTask "..tostring(self.curTruckTask).." , truckTaskVo.taskId:"..tostring(truckTaskVo.taskId));
        if self.curTruckTask == truckTaskVo.taskId then
            return true;
        end
        self.curTruckTask = truckTaskVo.taskId;
        truckTaskVo:exeTask();
        return true;
    end
    return false;
end
function Lua_HookControl:findAnotherTarget()
    local cp = self:getCurPos();
    local targetObj = DataCenter.thingData:findAttackTarget(cp, true, 2000, self._monsterId, true);
    if targetObj == nil then
        return 0;
    end
    return targetObj.objId;
end
function Lua_HookControl:setDefaultPos(px,py,pz)
    self.setTargetPos = Vector3(px,py,pz);
end
function Lua_HookControl:clearDefaultPos()
    self.setTargetPos = nil;
end
function Lua_HookControl:doNormalMap()
    local cp = self:getCurPos();
    --查找最近的掉落物
    local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    if bag:getLeftSize() > 0 then
        local dropItem = DataCenter.thingData:findNearestDrop(cp, true);
        if dropItem ~= nil then
            --if self.dropItemId ~= dropItem.objId then
            self.dropItemId = dropItem.objId;
            WorldMapUtil.moveTo(DataCenter.roleData.sceneId, dropItem.px, dropItem.py, dropItem.pz, 0, 0, nil, 0);
            --end
            return;
        end
    end
    local targetObj = DataCenter.thingData:findAttackTarget(cp, true, 2000, self._monsterId);
    if targetObj == nil then
        if DataCenter.hangUpSettingsData.hook_monster_sort == 1 
            and self._setScene == DataCenter.roleData.sceneId
            and self._startPos ~= nil then
            if getTime() - self.moveInterval > 1 then
                self.moveInterval = getTime();
                WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self._startPos.x, self._startPos.y, self._startPos.z, 0, 0, nil, 0);
            end
            return;
        end
        if self.setTargetPos ~= nil then
            if getTime() - self.moveInterval > 1 then
                self.moveInterval = getTime();
                WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self.setTargetPos.x, self.setTargetPos.y, self.setTargetPos.z, 0, 0, nil, 0);
            end
        --[[
        else
            local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
            local monsterConfig = sceneConfig:findNearestMonster(self._monsterId, cp);
            if monsterConfig ~= nil then
                if getTime() - self.moveInterval > 1 then
                    self.moveInterval = getTime();
                    WorldMapUtil.moveTo(DataCenter.roleData.sceneId, monsterConfig.posX, monsterConfig.posY, monsterConfig.posZ, 
                        self._monsterId, 3, nil, 0);
                end
            end
        end
        ]]
        end
        return;
    else
        self:setCurSelectedId(targetObj.objId);
    end
    LuaUtil.log("setTargetPos22:");
    local sid = PlayerData.getInstance():isDoingCanMoveSkill();
    if sid ~= 0 then
        local svo = DataCenter.skillData:getSkillData(sid);
        if svo ~= nil then
            WorldMapUtil.moveToPos(targetObj.px, targetObj.py, targetObj.pz, svo.auto_distance);
            return;
        end
    end
    LuaUtil.log("setTargetPos33:");
    local skillvo = nil;
    if self.nextSkill ~= nil and getTime() - self.nextStartTime < self.nextLastTime then
        local svo = DataCenter.skillData:getSkillData(self.nextSkill);
        if svo ~= nil and svo.canUse == true then
            skillvo = svo;
        end
    end
    if skillvo == nil then
        skillvo = DataCenter.skillData:findUseSkill();
    end
    LuaUtil.log("setTargetPos44:"..tostring(skillvo == nil));
    if skillvo == nil then
        return;
    end
    LuaUtil.log("setTargetPos66:");
    if skillvo.skillType == Lua_SkillDefine.SKILL_TYPE_JUEXING then
        if self.lastTransSkillTime == nil or getTime() - self.lastTransSkillTime > 2 then
            Lua_MsgUtil.callFunc("USE_TRANSFER_SKILL", true);
            self.lastTransSkillTime = getTime();
            LuaUtil.log("setTargetPos77:");
            return;
        end
    end
    LuaUtil.log("setTargetPos99:");
    if skillvo.skillType == Lua_SkillDefine.SKILL_TYPE_CAREER then
        DataCenter.skillData.lastCareerTime = UnityEngine.Time.realtimeSinceStartup;
    end
    MsgUtil.callFunc("USE_SKILL", {skillId=skillvo.skillId, targetId=Lua_CommonUtil.trnsLongNum(tonumber(self.selectedId)), isAuto=true});
end
function Lua_HookControl:hookMoveTo(vec)
end
function Lua_HookControl:reset()
    GlobalVar.hooking = false;
end
function Lua_HookControl:setMonsterTarget(targetId)
    self._monsterId = tonumber(targetId);
end
function Lua_HookControl:resetHookTime(time)
end
function Lua_HookControl:stopWalk()
    MsgUtil.callFunc("PLAYER_STOP_WALK");
end

function Lua_HookControl:doAutoDrug()
    if self.canAutoDrug == false then
        return;
    end
    local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneConfig.limit_recover_item == 1 then
        return;
    end
    if DataCenter.roleData.hp <= 0 then
        return;
    end
    if DataCenter.hangUpSettingsData.auto_drug == 0 then
        return;
    end
    local hpDrug = false;
    if self.autoHpDrug == nil or getTime() - self.autoHpDrug > 0.9 then
        self.autoHpDrug = getTime();
        hpDrug = true;
        self:doDrug(Lua_PackTypeDefine.HP_DRUG_ITEM,"hp","maxHp","auto_drug_blood","auto_blood_item", "buy_blood_time");
    end
    if hpDrug == false and (self.autoMpDrug == nil or getTime() - self.autoMpDrug > 1.1) then
        self.autoMpDrug = getTime();
        self:doDrug(Lua_PackTypeDefine.MP_DRUG_ITEM,"mp","maxMp","auto_drug_magic","auto_magic_item", "buy_blood_magic");
    end
end
function Lua_HookControl:doDrug(t, val, maxVal, cval, buyItems, buyTime)
    local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local rd = DataCenter.roleData;
    local hd = DataCenter.hangUpSettingsData;
    if rd[val] * 100 / rd[maxVal] < hd[cval] then
        local hpDrugs = bag:getItemsBySubType({t});
        local needBuy = true;
        if hpDrugs:getSize() > 0 then
            if DataCenter.hangUpSettingsData.auto_drug == 1 then
                hpDrugs:sort("id", true);
            else
                hpDrugs:sort("id", false);
            end
            for i=1,hpDrugs:getSize() do
                if hpDrugs[i].useLvl <= DataCenter.roleData.level then
                    if bag:isCool(hpDrugs[i]) == false then
                        Lua_PackUtil.useItem(hpDrugs[i], 1);
                    end
                    needBuy = false;
                    break;
                end
            end
        end
        if needBuy == true then
            if self[buyTime] ~= nil and getTime() - self[buyTime] < 5 then
                return;
            end
            if DataCenter.hangUpSettingsData.auto_buy_drug == 1 
                and bag.packSize ~= nil and bag:getLeftSize() > 0 then
                local itemsList = getConfig({"hook",buyItems});
                local len = #itemsList;
                local fixItem = -1;
                local hasBuy = false;
                for i=1,len do
                    local itemId = itemsList[len - i + 1];
                    local canBuy = self:canBuyItem(itemId);
                    if fixItem == -1 and canBuy == 2 then
                        fixItem = itemId;
                    end
                    if canBuy == 0 then
                        local tvo = Lua_ToolVo.createToolVo(itemId, 1, 1);
                        local cNum = DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER);
                        local maxNum = math.floor(cNum / tvo.copperPrice);
                        local pnum = math.min(maxNum, 50); 
                        if pnum > 0 then
                            hasBuy = true;
                            Lua_PackUtil.buyItem(itemId, 2, pnum);
                            self[buyTime] = getTime();
                            break;
                        end
                    end
                end
                if hasBuy == false and DataCenter.hangUpSettingsData.showNoMoneyWin ~= true and fixItem ~= -1 then
                    if getShowTips() == true then
                        Lua_WindowUtil.openWin("Lua_DrugNoMoneyWindow", nil, fixItem);
                    end
                    DataCenter.hangUpSettingsData.showNoMoneyWin = true;
                end
            end
        end
    end
end
function Lua_HookControl:canBuyItem(itemId)
    local tvo = Lua_ToolVo.createToolVo(itemId, 1, 1);
    if tvo.useLvl > DataCenter.roleData.level then
        return 1;
    end
    if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, tvo.copperPrice, false, false) == false then
        return 2;
    end
    return 0;
end
function Lua_HookControl:doAutoEat()
end