Lua_HookWindow = class("Lua_HookWindow", Lua_Window);
function Lua_HookWindow:ctor()
	self:superCall("ctor");
	self.layer = 500;
	self.windowName = "Lua_HookWindow";
	self.skinName = "HookWindow_skin";
	self.isModel = false;
	self.showingIndex = -1;
	self.autoCloseCount = 0;
	self.showClose = false;
	self.showBg = false;
end
function Lua_HookWindow:buildShowItem()
	self:superCall("buildShowItem");	
	-- self.content.transform.localPosition = Vector3(0, - MainWinDefine.V_height / 2 + 150,0);
	LuaUtil.setObjPos(self.content, 0, - MainWinDefine.V_height / 2 + 202, 0);

	self.exeTxt:setEnable(false);
	self.expBg:setEnable(false);

	self:addLuaEvent("HOKK_EXP_RATE", self, self.onHookExpRate);
	self:addLuaEvent("UPDATE_HOOK_POS", self, self.updatePos);
	self:addTimer("check", 0.1, self, self.onHookStateCheck);
	self:onHookStateCheck();
	self:onHookExpRate();
end
function Lua_HookWindow:onHookExpRate(o)
	local hdata = DataCenter.hangUpSettingsData;
	if hdata.expRateShow ~= 1 or hdata.expRate == -1 then
		self.exeTxt:setEnable(false);
		self.expBg:setEnable(false);
	else
		self.exeTxt:setEnable(true);
		self.expBg:setEnable(true);
        --local txtColor=self:getExeTxtColor(math.floor(hdata.expRate));
		self.exeTxt.text = LanUtil.formateStr(LanUtil.getValue(110231),Lua_CommonUtil.getNumberTrans(math.floor(hdata.expRate)));
        --self.exeTxt.color = self:getExeTxtColor(math.floor(hdata.expRate));
	end
end
function Lua_HookWindow:onHookStateCheck()
	if GlobalVar.hooking == true then
		if DataCenter.hook:isTemp() then--临时手动状态
			self.Sprite:setAltas("mainWindow_atlas","ui_zhujiemian_widget_32");
		else
			self.Sprite:setAltas("mainWindow_atlas","ui_zhujiemian_widget_21");
		end
	end
end
function Lua_HookWindow:getExeTxtColor(val)
    val = tonumber(tostring(val));
    val = math.floor(val);
    if val < 1000000 then
        return Color.New(25 / 255, 46 / 255, 65 / 255, 1);
    end
    if val < 10000000 then
        return Color.New(8 / 255, 199 / 255, 17 / 255, 1);
    end
    if val < 100000000 then
        return Color.New(0, 162 / 255, 238 / 255, 1);
    end
    if val < 1000000000000 then
        return Color.New(227 / 255, 0, 203 / 255, 1);
    end
    if val < 10000000000000000 then
        return Color.New(238 / 255, 157 / 255, 0, 1);
    end
    return Color.New(1, 0, 0, 1);
end

function Lua_HookWindow:updatePos(val)
	-- self.content.transform.localPosition = Vector3(-8, val, 0);
	LuaUtil.setObjPos(self.content, -8, val, 0);
end