checkRequire("Lua_KuaFuUtil");
checkRequire("Lua_KuaFuTeamVo");
Lua_KuaFuData = class("Lua_KuaFuData");
function Lua_KuaFuData:ctor()
	self.isDeath = true;
end

-- 战队列表
function Lua_KuaFuData:teamListInfo(msg)
	self.notApplyList = Array();
	self.applyList = msg.self_info.apply_list;
	self.beInvitedList = msg.self_info.be_invited_list;
	self.combat_team_list = msg.combat_team_list
	self.self_info = msg.self_info;
	self:allApplyList();
	self:allInvitedList();
	self:dissatisfactionallApplyList();
	self:dissatisfactionallInvitedList();
	self:checkShowKuaFuTeamTip();
end

function Lua_KuaFuData:checkShowKuaFuTeamTip()
	if self:allInvitedList():getSize() > 0 then
		local msg = {};
		msg.type = Lua_MenuTipData.KUAFU_TEAM_InVITED;
		msg.altas = "icon_atlas_5";
		msg.spriteName = "activity_small_tips_kf3v3zd";
		msg.state = 1;
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);

		DataCenter.redDotData:updateRedDotVoState(22102, true);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22102, val = 1, bShow = true});
	else
		local msg = {};
		msg.type = Lua_MenuTipData.KUAFU_TEAM_InVITED;
		msg.state = 0;
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);

		DataCenter.redDotData:updateRedDotVoState(22102, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22102, val = 0, bShow = false});
	end
end

function Lua_KuaFuData:allApplyList()
	local arr = Array();
	for i,v in ipairs(self.combat_team_list) do
		local data = {};
		data.id = tonumber(v.id)
		data.captain_name = v.captain_name;
		data.captain_id = tonumber(v.captain_id);     --队长ID
		data.name = v.name;                           --战队名
		data.fight_force = tonumber(v.fight_force);   --战队战力
		data.grade_id = v.grade_id;                   --战队等级ID
		data.score = v.score;                         --战队积分
		data.honour = v.honour;                       --战队荣耀
		data.team_member = v.team_member;             --小组成员
		data.fight_member = v.fight_member;           --参战小组成员
		data.rank = i;                                --排名
		data.value = 2;
		for i,v in ipairs(self.self_info.apply_list) do
			if tonumber(v.obj_id) == tonumber(data.id) then
				data.value = v.obj_value;
			end
		end
		arr:add(data);
	end
	arr:sort("score",true);

	local arrLen = arr:getSize();
	for i = 1, arrLen do
		arr[i].rank = i;
	end	
	return arr;
end

-- 不显示满员的申请列表
function Lua_KuaFuData:dissatisfactionallApplyList()
	local arr = Array();
	local data = self:allApplyList();
	local len = data:getSize();
	local num = 0;
	for i = 1,len do
		if #data[i].team_member ~= 3 then
			num = num + 1 ;
			data[i].rank = num;
			arr:add(data[i]);
		end
	end
	arr:sort("score",true);
	return arr;
end

-- 所有的受邀列表
function Lua_KuaFuData:allInvitedList()
	local arr = Array();
	local data = self:allApplyList();
	local len = data:getSize();
	for i = 1,len do
		for k,v in ipairs(self.self_info.be_invited_list) do
			if tonumber(v.obj_id) == tonumber(data[i].id) then
				arr:add(data[i]);
			end
		end
	end
	arr:sort("score",true);

	local arrLen = arr:getSize();
	for i = 1, arrLen do
		arr[i].rank = i;
	end
	return arr;
end

-- 不显示满员的受邀列表
function Lua_KuaFuData:dissatisfactionallInvitedList()
	local arr = Array();
	local data = self:allInvitedList();
	local len = data:getSize();
	for i = 1,len do
		if #data[i].team_member ~= 3 then
			arr:add(data[i]);
		end
	end
	arr:sort("score", true);

	local arrLen = arr:getSize();
	for i = 1, arrLen do
		arr[i].rank = i;
	end
	return arr;
end

function Lua_KuaFuData:teamInterface(msg)
	self.left_fight_times = msg.left_fight_times;         --挑战次数
	self.left_buy_times = msg.left_buy_times;             --剩余购买 
	self.left_fight_sec = msg.left_fight_sec;             --未匹配为0
	self.is_match = msg.is_match;                         --是否匹配中，0 没有在匹配，1 匹配中, 2 匹配成功
	self.win_rate = msg.win_rate;                         --胜率
	self.honor = msg.honor;                               --荣耀
	self.honor_reward = msg.honor_reward;                 --荣耀奖励 value：0不可领取，1可领取，2已领取
	self.fight_season_reward = msg.fight_season_reward;   --场次奖励：value：0不可领取，1可领取，2已领取
	self.total_battle_times = msg.total_battle_times;     --总战斗场次
	self.season_end_tick = msg.season_end_tick;           --赛季结束时间
	self.self_team_member = msg.self_team_member;
	self.match_team_member = msg.match_team_member;
	self.season = msg.season;
	self.cur_fight = msg.cur_fight;
	if msg.self_combat_team.name == "" then
		self.self_combat_team = nil;
	else
		self.self_combat_team = msg.self_combat_team;
	end

	self.teamMemberArr = Array();
	self.honorRewardArr = Array();
	for i,v in ipairs(msg.honor_reward) do
		local data = {};
		data.teamGloryReward = Lua_KuaFuUtil:teamGloryReward(i);
		data.obj_value = v.obj_value;
		data.index = v.obj_id;
		self.honorRewardArr:add(data);
	end

	self.fightSeasonRewardArr = Array();
	for i,v in ipairs(msg.fight_season_reward) do
		local data = {};
		data.obj_value = v.obj_value;
		data.setIndex = i;
		data.obj_id = v.obj_id;
		data.index = Lua_KuaFuUtil:frequencyReard()[i];
		self.fightSeasonRewardArr:add(data);
	end
	self:isMatch()
end

function Lua_KuaFuData.Get:isHonorRod()
	if self.honorRewardArr == nil then
		return false;
	end

	local len = self.honorRewardArr:getSize();
	for i = 1, len do
		if self.honorRewardArr[i].obj_value == 1 then
			return true;
		end
	end
	return false;
end

function Lua_KuaFuData:isMatch()
	if self.is_match == 1 or self.is_match == 3 then
		return true;
	end
end

function Lua_KuaFuData:lookTeamInfo(msg)
	if msg.combat_team_info.name == "" then
		self.combat_team_info = nil;
	else
		self.combat_team_info = msg.combat_team_info;
	end

	self.memberInfoArr = Array();
	for i,v in ipairs(msg.member_info) do
		local data = {};
		local msg = Lua_KuaFuTeamVo.new()
		msg:fromServer(v,i);
		self.memberInfoArr:add(msg);
	end
	self.memberInfoArr:sort("sortIdx", true);

	local len = self.memberInfoArr:getSize();
	while (len < 3) do
		local data = {};
		self.memberInfoArr:add(data);
		len = len + 1;
	end

	self.shenQingArr = Array();
	for i, v in ipairs(msg.apply_list) do
		self.shenQingArr:add(v);
	end
	self.auto_apply = msg.auto_apply;
	self:checkShenQingShowKuaFuTeamTip();
end

function Lua_KuaFuData:checkShenQingShowKuaFuTeamTip()
	if self.shenQingArr:getSize() > 0 then
		local msg = {};
		msg.type = Lua_MenuTipData.KUAFU_TEAM_APPALY;
		msg.altas = "icon_atlas_5";
		msg.spriteName = "activity_small_tips_kf3v3zd";
		msg.state = 1;
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);

		DataCenter.redDotData:updateRedDotVoState(22101, true);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22101, val = 1, bShow = true});
	else
		local msg = {};
		msg.type = Lua_MenuTipData.KUAFU_TEAM_APPALY;
		msg.state = 0;
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);

		DataCenter.redDotData:updateRedDotVoState(22101, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22101, val = 0, bShow = false});
	end
end

function Lua_KuaFuData:teamRank(msg)
	self.teamRankArr = Array()
	for i,v in ipairs(msg.combat_team_rank) do
		local data = {}
		data.captain_id = tonumber(v.captain_id);
		data.name = v.name;
		data.captain_name = v.captain_name;
		data.fight_force = tonumber(v.fight_force);
		data.grade_id = v.grade_id;
		data.score = v.score;
		data.honour = v.honour;
		data.rank = v.rank;
		self.teamRankArr:add(data);
	end
	self.self_combat_team = msg.self_combat_team;
end

function Lua_KuaFuData:onRoleInfo(msg)
	self.ownRoleArr = Array();
	self.emenyRoleArr = Array();
	self.leftArr = Array();
	self.rightArr = Array();
	for i,v in ipairs(msg.left_team_member) do
		local data = {};
		data.role_id = tonumber(v.role_id)
		data.team_name = v.team_name;
		data.role_name = v.role_name;
		data.level = v.level;
		data.career = v.career;
		data.sex = v.sex;
		data.profession = v.profession;
		data.fight_force = v.fight_force;
		data.cur_server_flag = v.cur_server_flag;
		data.role_head_name = v.role_head_name;
		if tonumber(DataCenter.roleData.roleId) ~= tonumber(v.role_id) then
			self.leftArr:add(data)
		end
		self.ownRoleArr:add(data);
	end

	for i,v in ipairs(msg.right_team_member) do
		local data = {};
		data.role_id = tonumber(v.role_id)
		data.team_name = v.team_name;
		data.role_name = v.role_name;
		data.level = v.level;
		data.career = v.career;
		data.sex = v.sex;
		data.profession = v.profession;
		data.fight_force = v.fight_force;
		data.cur_server_flag =v.cur_server_flag;
		data.role_head_name = v.role_head_name;
		self.emenyRoleArr:add(data);
		self.rightArr:add(data);
	end
	self.ownRoleLen = self.ownRoleArr:getSize();
	self.emenyRoleLen = self.emenyRoleArr:getSize();
end

function Lua_KuaFuData:onTeamFightInfo(msg)
	local arr = Array()
	self.tarArr = Array();
	self.ownArr = Array();
	self.selfArr = Array();
	local isLeft,isRight;
	for i,v in ipairs(msg.left_role) do
		if tonumber(DataCenter.roleData.roleId) ~= tonumber(v.role_base.role_id) then
			self.ownArr:add(v)
		end
	end
	for i,v in ipairs(msg.right_role) do
		self.tarArr:add(v)
	end
	self.remainingTime = msg.left_sec;
end

function Lua_KuaFuData:onUpdateData(msg)
	self.leader_id = msg.leader_id;
	self.targetVo = Array();
	for i,v in ipairs(msg.team_member) do
		self.targetVo:add(v);
	end
end

function Lua_KuaFuData.Get:hasTeam()
	if tonumber(self.leader_id) == DataCenter.roleData.roleId then
		return false;
	else
		return true;
	end
end