checkRequire("Lua_KuaFuData");
Lua_KuaFuProxy = class("Lua_KuaFuProxy");
function Lua_KuaFuProxy:ctor()
    DataCenter.KuaFuData = Lua_KuaFuData.new();
    LuaUtil.addLuaMsg(51405502, self, self.rPlayerApplyTeam);
    LuaUtil.addLuaMsg(51405511, self, self.rTeamList);  
    LuaUtil.addLuaMsg(51405508, self, self.rLookTeamInfo);  
    LuaUtil.addLuaMsg(51405520, self, self.rTeamInterfaceInfo);
    LuaUtil.addLuaMsg(51405521, self, self.rTeamRankInfo);
    LuaUtil.addLuaMsg(50105501, self, self.onTeamInviteList);
    LuaUtil.addLuaMsg(50105502, self, self.rCompetitiveStart);
    LuaUtil.addLuaMsg(51405501, self, self.rCreateTeam); 
    LuaUtil.addLuaMsg(51405506, self, self.rRenameCreateTeam); 
 	LuaUtil.addLuaMsg(80105501, self, self.rTeamReconfig);
 	LuaUtil.addLuaMsg(80405502, self, self.rStartCountdown);
 	LuaUtil.addLuaMsg(80405503, self, self.rCombatSettlement);
 	LuaUtil.addLuaMsg(80405504, self, self.rRoleInfo); 
 	LuaUtil.addLuaMsg(80405506, self, self.rTeamFightInfo);        	
end

function Lua_KuaFuProxy:rTeamInterfaceInfo(mp)      --界面信息
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405520();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:teamInterface(msg)
		Lua_MsgUtil.callFunc("INTERFACE_INFO");
	end
end

function Lua_KuaFuProxy:rRenameCreateTeam(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405506();
		msg:ParseFromString(mp.data);
		if msg.ret == 1 then
			OperateAlert.show(LanUtil.getValue(140331));
		end
	end
end

function Lua_KuaFuProxy:rCompetitiveStart(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105502();
		msg:ParseFromString(mp.data);
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(140334), tostring(msg.name)));	
	end
end

function Lua_KuaFuProxy:rCreateTeam(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405501();
		msg:ParseFromString(mp.data);
		if msg.ret == 1 then
			OperateAlert.show(LanUtil.getValue(140330));
			Lua_WindowUtil.openWin("Lua_TeamCreateWindow", WinParam.ACTION_CLOSE)
			Lua_WindowUtil.openWin("Lua_TeamApplyWindow", WinParam.ACTION_CLOSE)
		end
	end
end

function Lua_KuaFuProxy:rTeamRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405521();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:teamRank(msg)
		Lua_MsgUtil.callFunc("INTERFACE_RANKINFO");
	end
end

function Lua_KuaFuProxy:rPlayerApplyTeam(mp)     --竞技玩家申请加入战队
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405502();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:selfInfo(msg)
		Lua_MsgUtil.callFunc("PLAYERAPPLYTEAM");
	end
end

function Lua_KuaFuProxy:onTeamInviteList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105501();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData.isKuaFuTeam = true;
		Lua_WindowUtil.openWin("Lua_TeamInviteWindow", WinParam.ACTION_OPEN, msg);
	end
end

function Lua_KuaFuProxy:rLookTeamInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405508();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:lookTeamInfo(msg)
		Lua_MsgUtil.callFunc("LOOKTEAM_INFO");
	end
end

function Lua_KuaFuProxy:rTeamList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405511();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:teamListInfo(msg)
		Lua_MsgUtil.callFunc("APPLYTEAMLIST");
	end
end

function Lua_KuaFuProxy:rTeamReconfig(mp)
	GlobalVar.hooking = true;
    DataCenter.hook:stop(false);
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105501();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:onUpdateData(msg);
		Lua_WindowUtil.openWin("Lua_KuaFuTeamCommiteWindow", WinParam.ACTION_OPEN);
		Lua_MsgUtil.callFunc("KUAFU_TEAM_INFO_UPDATE");
	end
end

function Lua_KuaFuProxy:rStartCountdown(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405502();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_FightInfoShowWindow", WinParam.ACTION_CLOSE);
		Lua_MsgUtil.callFunc("ZHEZHAO_END_TIME", msg.left_sec);
	end
end

function Lua_KuaFuProxy:rCombatSettlement(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405503();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_KuaFuFuBenWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_KuaFuDeathWindow", WinParam.ACTION_CLOSE)
		Lua_WindowUtil.openWin("Lua_KuaFuFightEndWindow", WinParam.ACTION_OPEN, msg);
		DataCenter.KuaFuData.kuafuHookInng = false;
	end
end

function Lua_KuaFuProxy:rRoleInfo(mp)
	Lua_WindowUtil.openWin("Lua_KuaFuWindow", WinParam.ACTION_CLOSE);
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405504();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:onRoleInfo(msg)
		Lua_WindowUtil.openWin("Lua_FightInfoShowWindow", WinParam.ACTION_OPEN, msg.left_sec);
		Lua_MsgUtil.callFunc("KUAFU_FIGHT_TEAM_INFO");
	end
end

function Lua_KuaFuProxy:rTeamFightInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405506();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData:onTeamFightInfo(msg)
		for i, v in ipairs(msg.left_role) do
			if tonumber(DataCenter.roleData.roleId) == tonumber(v.role_base.role_id) then
				if tonumber(v.blood) == 0 then
					self:deathTip();
				end
			end
		end
		for i, v in ipairs(msg.right_role) do
			if tonumber(DataCenter.roleData.roleId) == tonumber(v.role_base.role_id) then
				if tonumber(v.blood) == 0  then
					self:deathTip();
				end
			end
		end
		Lua_MsgUtil.callFunc("TEAMFIGHT_INFO");
	end
end

function Lua_KuaFuProxy:deathTip()
	if DataCenter.KuaFuData.isDeath == true then
		DataCenter.KuaFuData.isDeath = false;
		Lua_WindowUtil.openWin("Lua_KuaFuDeathWindow", WinParam.ACTION_OPEN)
	end
end