checkRequire("Lua_WingUtil");
Lua_LeaderBoardData = class("Lua_LeaderBoardData");
function Lua_LeaderBoardData:ctor()
end

function Lua_LeaderBoardData:getleaderBoard(rank_type, data_type)
	local cmd = ProtoPublic_pb.Proto10100701();
	cmd.rank_type = rank_type;
	cmd.data_type = data_type;
	sendMsg(10100701, cmd);
end

function Lua_LeaderBoardData:oneleaderBoard(role_id, rank_type, rank_index)
	local cmd = ProtoPublic_pb.Proto10100702();
	cmd.role_id = role_id;
	cmd.rank_type = rank_type;
	cmd.rank_index = rank_index;
	sendMsg(10100702, cmd);
end

function Lua_LeaderBoardData:fromServer50100701(msg)
	if msg == nil then
		return;
	end

	self.ranktype = msg.rank_type; -- 排行榜类型
	-- self.rankrecordlist = msg.rank_record_list; -- 排行数据
	-- self.mycurrank  = msg.my_rank_record.cur_rank; -- 自己的排行数据，没上榜为nil

	if msg.my_rank_record.cur_rank < 100 and msg.my_rank_record.cur_rank > 0 then
		self.mycurrank = msg.my_rank_record.cur_rank;
	else
		self.mycurrank = LanUtil.getValue(120011);
	end

	if msg.my_rank_record.vip_type ~= 0 then
		if getLanType() == 2 and tonumber(msg.my_rank_record.vip_type) == 100 then
			self.myViplvl = "+"; -- "會員+";
		else
			local vipStr = getConfig({"vip_level", msg.my_rank_record.vip_type, "view_name"});
			self.myViplvl = vipStr; -- "會員" .. vipStr;
		end
	else
		self.myViplvl = nil;
	end
	
	self.mycareer = msg.my_rank_record.career;
	self.myprofession = msg.my_rank_record.profession;

	if msg.my_rank_record.display_content == "" then
		self.myname = LanUtil.getValue(120134);
	else
		self.myname = msg.my_rank_record.display_content;
	end
	self.myrankvalue = msg.my_rank_record.rank_value;
	self.myadditional_id = msg.my_rank_record.additional_id;

	if self.mycareer == 0 then
		self.mymountername = msg.my_rank_record.additional_id;
	elseif self.ranktype == 13 then
		self.mymountername = Lua_CommonUtil.getNumberTrans(msg.my_rank_record.rank_value_ex).."/"..LanUtil.getValue(25);
	elseif self.ranktype == 1 or self.ranktype == 2 or self.ranktype == 15 or self.ranktype == 16 or self.ranktype == 17 then
		self.mymountername = Lua_ThingDefine.getJobName(self.mycareer, self.myprofession)
	elseif msg.my_rank_record.display_ex ~= "" and self.ranktype ~= 1 and (self.ranktype ~= 2 and self.ranktype ~= 15
		and self.ranktype ~= 16 and self.ranktype ~= 13 and self.ranktype ~= 12) then
		self:getLvDes(msg.my_rank_record.rank_value);
		self.mymountername = msg.my_rank_record.display_ex;
		self.myrankvalue = self.equal;
	elseif self.ranktype == 12 then
		self.mymountername = msg.my_rank_record.additional_id;
	elseif msg.my_rank_record.display_ex == "" then
		self.mymountername = LanUtil.getValue(120134);
		self.myrankvalue = LanUtil.getValue(120134);
	end
	
	local data;
	self.rankData = Array();
	for i = 1, #msg.rank_record_list do
		data = {};
		data.sort = msg.rank_record_list[i].cur_rank;
		data.profession = msg.rank_record_list[i].profession;
		data.name = msg.rank_record_list[i].display_content;
		data.career = msg.rank_record_list[i].career;
		data.roleid = msg.rank_record_list[i].role_id;
		data.rankvalue = msg.rank_record_list[i].rank_value;

		if msg.rank_record_list[i].vip_type == 0 then
			data.viplvl = nil; -- "";
		else
			local vipStr = getConfig({"vip_level", msg.rank_record_list[i].vip_type, "view_name"});
			data.viplvl = vipStr; -- "會員" .. vipStr;
		end

		if getLanType() == 2 and tonumber(msg.rank_record_list[i].vip_type) == 100 then
			data.viplvl = "+"; -- "會員+";
		end

		if data.career == 0 then
			data.additionalid = msg.rank_record_list[i].additional_id;
		elseif self.ranktype == 13 then
			data.additionalid = Lua_CommonUtil.getNumberTrans(msg.rank_record_list[i].rank_value_ex).."/"..LanUtil.getValue(120808);
		elseif self.ranktype == 1 or self.ranktype == 2 or self.ranktype == 15 or self.ranktype == 16 or self.ranktype == 17 then
			data.additionalid = Lua_ThingDefine.getJobName(data.career, data.profession)
		elseif self.ranktype == 101 then -- 宝石排行
			data.rankvalue = LanUtil.formateStr(LanUtil.getValue(127206), tostring(msg.rank_record_list[i].rank_value))
		elseif self.ranktype == 102 then -- 充值排行
			data.rankvalue = LanUtil.formateStr(LanUtil.getValue(127205), tostring(msg.rank_record_list[i].rank_value))
		elseif self.ranktype == 103 then -- 消费排行
			data.rankvalue = LanUtil.formateStr(LanUtil.getValue(127205), tostring(msg.rank_record_list[i].rank_value))
		elseif self.ranktype ~= 1 and self.ranktype ~= 2 and self.ranktype ~= 12 and self.ranktype ~= 13
			and self.ranktype ~= 15 and self.ranktype ~= 16 and self.ranktype ~= 17 then
			self:getLvDes(tonumber(tostring(msg.rank_record_list[i].rank_value)));
			data.additionalid = msg.rank_record_list[i].display_ex;
			data.rankvalue = self.equal;
		elseif self.ranktype == 12 then
			data.additionalid = msg.rank_record_list[i].additional_id;
		end
		self.rankData:add(data);
	end
end

function Lua_LeaderBoardData:getLvDes(val)
	local lvlShow;
	local count = 0;
	if self.ranktype == 4 or self.ranktype == 5 then
		if val / 10 < 7 then
			count = math.floor(val / 10) + 1;
			lvlShow = val % 10;
		else
			count = math.floor(val / 10);
			lvlShow = 10;
		end
	else
		if tonumber(val % 10) == 0 and val ~= 0 then
			-- if self.ranktype == 4 or self.ranktype == 5 then
			-- 	local num = getConfig({"rank_pannel", self.ranktype, "max_order"});
			-- 	if tonumber(val / 10) < num then
			-- 		count = Lua_CommonUtil.transChineseNumber(math.ceil(val / 10) + 1);
			-- 		lvlShow = Lua_CommonUtil.transChineseNumber(0);
			-- 	else
			-- 		count = Lua_CommonUtil.transChineseNumber(math.ceil(val / 10));
			-- 		lvlShow = Lua_CommonUtil.transChineseNumber(10);
			-- 	end
			-- else
				if val / 10 < 7 then
					count = Lua_CommonUtil.transChineseNumber(math.ceil(val / 10) + 1);
					lvlShow = Lua_CommonUtil.transChineseNumber((0));
				else
					count = Lua_CommonUtil.transChineseNumber(math.ceil(val / 10));
					lvlShow = Lua_CommonUtil.transChineseNumber((10));
				end
			-- end
		else
			count = Lua_CommonUtil.transChineseNumber(math.ceil(val / 10));
			lvlShow = Lua_CommonUtil.transChineseNumber((val % 10));
		end
	end

	if self.ranktype == 3 then
		self.equal = LanUtil.formateStr(LanUtil.getValue(120013), tostring(Lua_CommonUtil.transChineseNumber(val)));
	else
		if self.ranktype == 4 or self.ranktype == 5 then
			-- self.equal = LanUtil.formateStr(LanUtil.getValue(120012), count, lvlShow);
			local numStr = string.split(LanUtil.getValue(110507), ",");
			local words = string.split(LanUtil.getValue(110508), ",");
			local numWord1 = numStr[tonumber(count) + 1];
			local numWord2 = numStr[tonumber(lvlShow) + 1];
			if numWord1 ~= nil and numWord2 ~= nil then
				self.equal = numWord1 .. words[1] .. numWord2 .. words[2];
			end
		else
			self.equal = LanUtil.formateStr(LanUtil.getValue(120012), count, lvlShow);
		end
	end
	-- print(self.ranktype, val, self.equal);
end

function Lua_LeaderBoardData.Get:rankArr()
	return self.rankData;
end

function Lua_LeaderBoardData:fromServer50100702(msg)
	if msg == nil then
		return;
	end
	
	self.mounterid = msg.model_id; -- 模型id
	self.ranktype = msg.rank_type;
	self.force = tonumber(tostring(msg.force)); -- 战力
	self.career = msg.career; -- 职业
	self.name = msg.name;
	self.weapon = msg.weapon;
	self.roleId = tonumber(msg.role_id);-- 武器
	self.clothes = msg.clothes; -- 衣服
	self.fashion_weapon = msg.fashion_weapon; -- 时装武器
	self.fashion_clothes = msg.fashion_clothes; -- 时装衣服
	self.magic_weapon = msg.magic_weapon; -- 法宝id
	self.spoor_info = msg.spoor_info; -- 足迹
	self.top_wing_id = msg.top_wing_id;
	self.fairy_act = msg.fairy_act; -- 仙器
	self.fashionHeadId = msg.fashion_headdress;
	self.fashionBgId = msg.fashion_background_id;

	DataCenter.thingData:setCloakTemp(msg.role_id, msg.cloak);

	local modelList = nil;
	if self.mounterid ~= 0 then
		if self.ranktype == 3 then
			local itemConfig = Lua_WingUtil.getItemData(self.mounterid);
			self.name = itemConfig.name;
			self.mounterid = Lua_WingUtil.getWingModelConfig(self.mounterid);
			-- return;
		elseif self.ranktype == 4 then
			modelList = DataCenter.servantData:getShapConfig(); -- 侍宠
		elseif self.ranktype == 5 then
			modelList = DataCenter.mountData:getShapConfig(); -- 坐骑
		elseif self.ranktype == 6 then
			modelList = DataCenter.servantWeaponData:getShapConfig(); -- 宠武
		elseif self.ranktype == 7 then
			modelList = DataCenter.servantMountData:getShapConfig(); -- 宠骑
		elseif self.ranktype == 8 then
			modelList = DataCenter.servantWingData:getShapConfig(); -- 宠翼
		elseif self.ranktype == 9 then
			modelList = DataCenter.footprintData:getShapConfig(); -- 足迹
		elseif self.ranktype == 10 then
			modelList = DataCenter.magicWeaponData:getShapConfig(); -- 法宝
		elseif self.ranktype == 11 then
			modelList = DataCenter.talismanData:getShapConfig(); -- 仙器
		end
		self:modelnameList(modelList, self.mounterid);
	end
end

function Lua_LeaderBoardData:modelnameList(modelList, mounterid)
	if modelList ~= nil then
		for k, v in pairs(modelList) do
			if mounterid == v[1] then
				self.name = v[3];
			end
		end
	end

	local shapeConfig = getConfig({"playerHanger", tonumber(mounterid)});
	if shapeConfig ~= nil then
		self.floder = shapeConfig.floder;
		self.fileName = shapeConfig.fileName;
		self.modelName = shapeConfig.modelName;
	else
		self.floder = shapeConfig.floder;
		self.fileName = mounterid;
		self.modelName = mounterid;
	end

	if self.ranktype == 9 then
		local shapeConfig = getConfig({"effect", tonumber(mounterid)});
		self.floder = "/" .. shapeConfig.floder;
		self.fileName = shapeConfig.path;
		self.modelName = shapeConfig.path;
	end

	if self.ranktype == 10 then
		self.setmodelAngle = {300, -30, 0};
	else
		self.setmodelAngle = {0, 0, 0};
	end

	local mounter_pos = shapeConfig.mounter_pos;
	local mounter_rot = shapeConfig.mounter_rot
	local mounter_sca = shapeConfig.mounter_sca;
	if mounter_pos == nil then
		self.mounter_pos = {-145, -150, 200};
		self.mounter_rot = {8, - 180, 0};
		self.mounter_sca = {200, 200, 200};
	else
		self.mounter_pos = mounter_pos;
		self.mounter_rot = mounter_rot;
		self.mounter_sca = mounter_sca;
	end
end

function Lua_LeaderBoardData:ismounterID(type_index)
	self.mounterid = 1;

	type_index = tonumber(type_index);
	if type_index == 3 then
		local a = string.sub(803010001, 1, 4);
		local b = string.sub(803010001, 6, -1);
		self.mounterID = tonumber(a .. DataCenter.roleData.career .. b);
	elseif type_index == 4 then
		self.mounterID = 700010001;
	elseif type_index == 5 then
		self.mounterID = 600010001;
	elseif type_index == 6 then
		self.mounterID = 701010001;
	elseif type_index == 7 then
		self.mounterID = 702010001;
	elseif type_index == 8 then
		self.mounterID = 703010001;
	elseif type_index == 9 then
		self.mounterID = 800000001;
	elseif type_index == 10 then
		self.mounterID = 801010001;
	elseif type_index == 11 then
		self.mounterID = 802010001;
	end
	self:modelnameList(nil, self.mounterID);
end