Lua_LeftInfoBaseWindow = class("Lua_LeftInfoBaseWindow", Lua_Window);
function Lua_LeftInfoBaseWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.BASE_LAYER;
	self.showClose = false;
	self.isModel = false;
end

function Lua_LeftInfoBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.closeBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_title_03", 0, 0, 0, 0);
	self.closeBtn.name = "closeBtn";
	self.closeBtn.clickScale = false;
	self.closeBtn:addClickFuntion(self, self.onCloseClick);
	self.closeBtn:setDepth(1);

	self.closeIcon = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_jiantou_02", 0, 0, 0, 0);
	self.closeIcon.name = "closeIcon";
	self.closeIcon:setSacle(0.8, 0.8);
	self.closeIcon:setDepth(2);

	self:onScreenResize();
	self:setShowState(true);

	self:addCSharpEvent("SCREEN_RESIZE", self, self.onScreenResize);
end

function Lua_LeftInfoBaseWindow:onCloseClick(g)
	self:setShowState(not self.state);
end

function Lua_LeftInfoBaseWindow:onScreenResize(o)
	-- self.content.transform.localPosition = Vector3(-MainWinDefine.V_width / 2 + self.offsetWidth, self.offsetHeight, 0);
	LuaUtil.setObjPos(self.content, -MainWinDefine.V_width / 2 + self.offsetWidth, self.offsetHeight, 0);
end

function Lua_LeftInfoBaseWindow:setShowState(val)
	if self.isChangeLimitTimeBoss ~= val then
		self.isChangeLimitTimeBoss = val;
		Lua_MsgUtil.callFunc("SHOWORHIDE_LIMITTIME", val);
	end

	self.state = val;
	if val then
		self.closeBtn:setLocation(253.5, 135, 0);
		self.closeIcon:setLocation(252, 139, 0);
		self.closeIcon:setSacle(0.8, 0.8);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(-MainWinDefine.V_width / 2 + self.offsetWidth, self.offsetHeight, 0), nil, nil);
	else
		self.closeBtn:setLocation(253.5 + self.closeBtn.width + 13, 135, 0);
		self.closeIcon:setLocation(252 - 1.5 + self.closeBtn.width + 13, 139, 0);
		self.closeIcon:setSacle(-0.8, 0.8);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(-MainWinDefine.V_width / 2 + self.hideOffset, self.offsetHeight, 0), nil, nil);
	end
end

function Lua_LeftInfoBaseWindow.Get:offsetWidth()
	return 0;
end

function Lua_LeftInfoBaseWindow.Get:offsetHeight()
	return -2;
end

function Lua_LeftInfoBaseWindow.Get:hideOffset()
	return -269;
end