checkRequire("Lua_LuckySignData");
Lua_LuckySignProxy = class("Lua_LuckySignProxy");
function Lua_LuckySignProxy:ctor()
	DataCenter.luckySignData =  Lua_LuckySignData.new();

	LuaUtil.addLuaMsg(50105741, self, self.rLuckySignInfo);	-- 打开好运灵签界面（返回）
	LuaUtil.addLuaMsg(50105742, self, self.rLuckySignDraw);	-- 抽奖（返回）
	LuaUtil.addLuaMsg(80105604, self, self.rLuckySignRecords);	-- 通知全服记录
end

-- 请求界面信息
function Lua_LuckySignProxy:sLuckySignInfo()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.LUCKY_SIGN);
end

-- 打开/关闭界面
function Lua_LuckySignProxy:sLuckySignWinStatus(val)
	local cmd = ProtoPublic_pb.Proto10105605();
	cmd.first_type = Lua_OperationalActivitiesData.LUCKY_SIGN;
	cmd.oper_type = val; -- 1打开，0关闭
	sendMsg(10105605, cmd);
end

-- 抽奖 0是一次抽奖，1是十次
function Lua_LuckySignProxy:sLuckySignDraw(index)
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.LUCKY_SIGN, index);
end

-- 打开好运灵签界面（返回）
function Lua_LuckySignProxy:rLuckySignInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105741();
		msg:ParseFromString(mp.data);
		DataCenter.luckySignData:fromServer50105741(msg);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_SIGN_INFO");
	end
end

-- 抽奖（返回）
function Lua_LuckySignProxy:rLuckySignDraw(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105742();
		msg:ParseFromString(mp.data);
		DataCenter.luckySignData.specialRewardList = msg.top_reweards;
		
		local tvoArr = DataCenter.luckySignData.specialRewardList;
		if tvoArr:getSize() >= 1 then
			Lua_WindowUtil.openWin("Lua_getLuckySignWindow", nil, tvoArr);
		end
	end
end

-- 通知全服记录
function Lua_LuckySignProxy:rLuckySignRecords(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105604();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_LUCKY_SIGN_RECORDS", msg.rewards);
	end
end