checkRequire("Lua_ServantCommonData");
Lua_MagicWeaponData = class("Lua_MagicWeaponData", Lua_ServantCommonData);
function Lua_MagicWeaponData:ctor()
end

function Lua_MagicWeaponData:sGetPanelInfo()
	sendMsg(11402501);
end

function Lua_MagicWeaponData:sServantAnvance()
	sendMsg(11402502);
end

function Lua_MagicWeaponData:sUseItem(index, num)
	local cmd = ProtoPublic_pb.Proto11402509();
	cmd.index = index;
	cmd.use_num = num
	sendMsg(11402509, cmd);
end

function Lua_MagicWeaponData:sUse(id, type)
	local cmd = ProtoPublic_pb.Proto11402505();
	cmd.mw_id = id;
	cmd.put_on = type;
	sendMsg(11402505, cmd);
end

function Lua_MagicWeaponData:sSkillLvlUp(id)
	local cmd = ProtoPublic_pb.Proto11402508();
	cmd.skill_id = id;
	sendMsg(11402508, cmd);
end

function Lua_MagicWeaponData:sHuanXingMsg(shape_id)
	local cmd = ProtoPublic_pb.Proto11402510();
	cmd.shape_id = shape_id;
	sendMsg(11402510, cmd)
end

function Lua_MagicWeaponData.Get:config()
	if self._config == nil then
		self._config = getConfig({"magicweapon"});
	end
	return self._config;
end

function Lua_MagicWeaponData:fromServer51402501(data)
	self.isMaxLvl = data.is_max_lvl;
	self.evolutionExp = data.evolution_exp;
	self.servantShape = data.shape_id;
	self.name = data.name;
	self.force = data.force;
	self.isUsing = data.is_wear;

	self:calcLvl(data.evolution_lvl);
	self:getCurAttrData(data.total_prop_list);
	self:getNextAttrData(data.next_prop_list);
	self:getSkillListData(data.skill_list);
	self:getPanaceaListData(data.use_soul);
end

function Lua_MagicWeaponData:advance(data)
	-- print("data.is_evolution  "..data.is_evolution);
end

function Lua_MagicWeaponData:skillLvlUp(data)
	for i = 1, self.skillVoList:getSize() do
		if self.skillVoList[i].skillId == data.skill_id then
			self.skillVoList[i].skillLvl = data.skill_lvl;
		end
	end
end

function Lua_MagicWeaponData:updateState(data)
	if data.put_on == true then
		self.isUsing = 1;
		self.servantShape = data.mw_id;
	else
		self.isUsing = 0;
		self.servantShape = 0;
	end
end

function Lua_MagicWeaponData:useItem(data)
	-- print("item   "..data.index.."  "..data.use_num);
end

function Lua_MagicWeaponData:getBaseAttrDic()
	return self.config.magic_weapon_base;
end

function Lua_MagicWeaponData:getShapConfig()
	return self.config.magic_weapon_shape;
end

function Lua_MagicWeaponData:setShapeId(msg)
	self.servantShape = msg.shape_id;
end