checkRequire("Lua_MagicWeaponData");
Lua_MagicWeaponProxy = class("Lua_MagicWeaponProxy");
function Lua_MagicWeaponProxy:ctor()
	DataCenter.magicWeaponData = Lua_MagicWeaponData.new();

	LuaUtil.addLuaMsg(51402501, self, self.rGetPanelInfo); -- 获取法宝界面信息（返回）
	LuaUtil.addLuaMsg(51402502, self, self.rAdvance); -- 法宝进阶（返回）
	LuaUtil.addLuaMsg(51402505, self, self.rUse); -- 佩戴/隐藏法宝（返回）
	LuaUtil.addLuaMsg(51402508, self, self.rSkillLvlUp); -- 法宝技能升级（返回）
	LuaUtil.addLuaMsg(51402509, self, self.rUseItem); -- 法宝使用魂珠（返回）
	LuaUtil.addLuaMsg(51402510, self, self.rHuaXingMsg); -- 法宝化形（返回）
end

function Lua_MagicWeaponProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402501();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:fromServer51402501(msg);
		Lua_MsgUtil.callFunc("MAGIC_WEAPON_PANEL_UPDATE");
	end
end

function Lua_MagicWeaponProxy:rAdvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402502();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:advance(msg);
		-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.magicWeaponData:sServantPanelInfo();
	end
	DataCenter.magicWeaponData:sGetPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_MagicWeaponProxy:rUse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402505();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:updateState(msg);
		-- Lua_MsgUtil.callFunc("UESAGE_STATE_UPDATE");
	end
end

function Lua_MagicWeaponProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402508();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_MagicWeaponProxy:rUseItem(mp)
	DataCenter.magicWeaponData:sGetPanelInfo();
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402509();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:useItem(msg);
		-- Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_MagicWeaponProxy:rHuaXingMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402510();
		msg:ParseFromString(mp.data);
		DataCenter.magicWeaponData:setShapeId(msg);
		Lua_MsgUtil.callFunc("MAGIC_HUANXING_UPDATE", msg);
	end
end





function Lua_MagicWeaponProxy:sFuncOpen(mp)
	local shapeList = DataCenter.magicWeaponData:getServantShapeList();
	DataCenter.magicWeaponData:sUse(shapeList[1].id, true);
	DataCenter.magicWeaponData:sHuanXingMsg(shapeList[1].id);
end