checkRequire("Lua_MailVo");
Lua_MailData = class("Lua_MailData");
function Lua_MailData:ctor()
	self:dispose();
end

function Lua_MailData:dispose()
	self.mailInfoArr = Array();
	self.adjunctInfoArr = Array();
end

-- 请求获取邮件列表
function Lua_MailData:sMailList()
	sendMsg(11400301);
end

-- 请求获取邮件信息
function Lua_MailData:sMailInfo(mail_id)
	local cmd = ProtoPublic_pb.Proto11400302();
	cmd.mail_id = mail_id;
	sendMsg(11400302, cmd);
end

-- 请求提取邮件附件
function Lua_MailData:sMailAdjunct(mail_id)
	local cmd = ProtoPublic_pb.Proto11400304();
	cmd.mail_id = mail_id;
	sendMsg(11400304, cmd);
end

-- 请求获取所有邮件附件
function Lua_MailData:sGetAllAdjunct()
	sendMsg(11400305);
end

-- 请求删除邮件
function Lua_MailData:sDeleteMail(del_type, mailID)
	local cmd = ProtoPublic_pb.Proto11400306();
	cmd.del_type = del_type;
	cmd.del_list:append(mailID);
	sendMsg(11400306, cmd);
end

function Lua_MailData:sDeleteMails(del_type, arr)
	if arr:getSize() == 0 then
		return;
	end

	local cmd = ProtoPublic_pb.Proto11400306();
	cmd.del_type = del_type;
	for i = 1, arr:getSize() do
		cmd.del_list:append(arr[i]);
	end
	sendMsg(11400306, cmd);
end

--请求发送邮件
function Lua_MailData:sSendMail(mailTable)
	local cmd = ProtoPublic_pb.Proto11400307();
	cmd.receiver_name = mailTable.receiver_name; -- 收件人角色名
	cmd.mail_title = mailTable.mail_title; -- 邮件标题
	cmd.mail_content = mailTable.mail_content; -- 邮件内容
	cmd.mail_gold = mailTable.mail_gold; -- 邮件元宝
	cmd.mail_copper = mailTable.mail_copper; -- 邮件铜钱
	-- 附件列表
	for i = 1, #mailTable.attach_list do
		cmd.attach_list[i].mail_index = mailTable.attach_list[i].mail_index; -- 附件索引，5个格子之一
		cmd.attach_list[i].pack_index = mailTable.attach_list[i].pack_index;-- 附件对应背包中索引 
		cmd.attach_list[i].pack_amount = mailTable.attach_list[i].pack_amount; -- 附件数量
	end
	sendMsg(11400307, cmd);
end

function Lua_MailData:fromServer51400301(msg)
	if msg == nil then
		return;
	end

	self.deposit_mail_amount = msg.deposit_mail_amount; -- 寄存的邮件数量

	if self.mailInfoArr:getSize() > 0 then
		self.mailInfoArr:dispose();
		self.mailInfoArr:clear();
	end

	local vo;
	for i = 1, #msg.mail_list do
		vo = Lua_MailVo.new();
		vo:fromServer(msg.mail_list[i])
		self.mailInfoArr:add(vo);
	end
	self.mailInfoArr:sort("priority", true)
end

function Lua_MailData:fromServer51400302(msg)
	if msg == nil then
		return;
	end

	if self.adjunctInfoArr:getSize() > 0 then
		self.adjunctInfoArr:dispose();
		self.adjunctInfoArr:clear();
	end

	-- goods_list附件列表
	for i = 1, #msg.goods_list do
		self.adjunctInfoArr:add(msg.goods_list[i])
	end

	if tonumber(tostring(msg.exp)) ~= 0 then
		self.adjunctInfoArr:add({id = 209000006, amount = tonumber(tostring(msg.exp))});
	end
end





function Lua_MailData:getMailByMailId(val)
	for i = 1, self.mailInfoArr:getSize() do
		if self.mailInfoArr[i].mail_id == val then
			return self.mailInfoArr[i];
		end
	end
	return nil;
end