checkRequire("Lua_MailData");
Lua_MailProxy = class("Lua_MailProxy");
function Lua_MailProxy:ctor()
	DataCenter.mailData = Lua_MailData.new();

	LuaUtil.addLuaMsg(51400301, self, self.rMailList);
	LuaUtil.addLuaMsg(51400302, self, self.rMailInfomation);
	LuaUtil.addLuaMsg(51400304, self, self.rMailAdjunct);
	LuaUtil.addLuaMsg(51400305, self, self.rGetAllAdjunct);
	LuaUtil.addLuaMsg(51400306, self, self.rDeleteMail);
end

-- 返回邮件列表
function Lua_MailProxy:rMailList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400301();
		msg:ParseFromString(mp.data);
		DataCenter.mailData:fromServer51400301(msg);
		Lua_MsgUtil.callFunc("UPDATE_MAIL_DATA")
	end
end

-- 返回邮件信息
function Lua_MailProxy:rMailInfomation(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400302();
		msg:ParseFromString(mp.data);
		DataCenter.mailData:fromServer51400302(msg)
		Lua_MsgUtil.callFunc("MAIL_INFOMATION", msg); -- 直接抛事件给面板显示内容
	end
end

-- 返回邮件附件（包括货币）
function Lua_MailProxy:rMailAdjunct(mp)
	if mp.errno == 0 then
		DataCenter.mailData:sMailList();
		OperateAlert.show(LanUtil.getValue(110056));
	end
end

-- 返回提取所有的附件
function Lua_MailProxy:rGetAllAdjunct(mp)
	if mp.errno == 0 then
		DataCenter.mailData:sMailList();
		OperateAlert.show(LanUtil.getValue(110056));
		Lua_MsgUtil.callFunc("SETENABLE_FALSE", false)
	end
end

-- 返回删除邮件
function Lua_MailProxy:rDeleteMail(mp)
	if mp.errno == 0 then
		DataCenter.mailData:sMailList();
		OperateAlert.show(LanUtil.getValue(110055));
	end
end