function c_start(dt)
	DataCenter.hook:start(dt);
end

function c_stop(clearTask)
	GlobalVar.hooking = false;
    Lua_MsgUtil.callFunc(EventsDefine.HOOK_STATE_CHANGE);
    Lua_WindowUtil.openWin("Lua_HookWindow",WinParam.ACTION_CLOSE,nil);
end

function c_hookSetMonsterType(targetId)
	DataCenter.hook:setMonsterTarget(tonumber(targetId));
end

function c_hookCurMonsterTarget(targetId, isClick)
	local hunluan = DataCenter.roleData:hasHunLuan(); 
	local r = 0;
	if  hunluan == false then
		r = tonumber(targetId);
	else
		if isClick == true then
            DataCenter.thingData.lastSelectedTime = 0;
        end
		local cp = DataCenter.hook:getCurPos();
		local targetObj = DataCenter.thingData:findAttackTarget(cp, isAuto, 0);
	    if targetObj == nil then
	    	r = 0;
	    end
	    r = tonumber(targetObj.objId);
	end	
	PlayerData.getInstance().selectedId = r;
	if DataCenter.hook.selectedId ~= r then
		DataCenter.hook.selectedId = r;
	end
	Lua_MsgUtil.callFunc("SELECTED_TARGET_CHANGE");
end
function c_resetControlTime(time)
	DataCenter.attackedData:clearMoveTo();
	DataCenter.hook:resetControlTime(time);
end

function c_findTarget(isAuto)
	local cp = DataCenter.hook:getCurPos();
    local targetObj = DataCenter.thingData:findAttackTarget(cp, isAuto, 0, DataCenter.hook._monsterId);
    if targetObj == nil then
    	return "0";
    end
    local sid = tonumber(targetObj.objId);
    return Lua_CommonUtil.trnsLongNum(sid);
end

function c_isTargetSuit(targetId, isAuto)
	local tid = tonumber(targetId);
	local thingVo = DataCenter.thingData:getThing(tid);
	if thingVo == nil then
		return false;
	end
	local b = DataCenter.thingData:checkTargetCanAttactk(thingVo, isAuto);
	return b;
end

function c_genBulletinContent(id, index, val)
	if id == 70101 and index == 1 then
		local c = getConfig({"military_rank", "junxian"});
		return c[val];
	end
	if (id == 40101 or id == 40201 or id == 40301 or id == 40401 or id == 40501 or id == 40601 or id == 40701 or id == 40801) and index == 1 then
		local numStr = string.split(LanUtil.getValue(110507),",");
		local index = val/10 +2;
		return numStr[index];
	end
	return nil;
end

function c_getBagEmptySize(showTip)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local leftNum = bagData:getLeftSize();
	if showTip == true and leftNum <= 0 then
		if DataCenter.packData.lastShowTipTime == nil then
			DataCenter.packData.lastShowTipTime = 0;
		end
		if getTime() - DataCenter.packData.lastShowTipTime > 3 then
			DataCenter.packData.lastShowTipTime = getTime();
			OperateAlert.show(LanUtil.getValue(110865));
		end
		if Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") == false 
		and Lua_WindowUtil.isWindowShowing("Lua_PackWindow") == false then
			if DataCenter.packData.lastShowTipDic == nil then
				DataCenter.packData.lastShowTipDic = {};
			end
			if DataCenter.packData.lastShowTipDic[Lua_PackData.BAG_PACK] == nil 
				or getTime() - DataCenter.packData.lastShowTipDic[Lua_PackData.BAG_PACK] > 10 then
				DataCenter.packData.lastShowTipDic[Lua_PackData.BAG_PACK] = getTime();
				DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
			end
		end
	end
	return leftNum;
end

function c_checkFightTargetTeamState(targetId)
	if DataCenter.roleData.pkState ~= Lua_ThingDefine.PK_STATE_TEAM then
		return true;
	end
	local vid = tonumber(tostring(targetId));
	local thingVo = DataCenter.thingData:getThing(vid);
	if thingVo == nil then
		return false;
	end
	if thingVo.kind == Lua_ThingDefine.MONSTER then
		return true;
	else--队伍判断和帮派判断
		if DataCenter.roleData.leagueId ~= 0 then
			if thingVo.leagueId == DataCenter.roleData.leagueId then
				return false;
			end
		end
		if DataCenter.teamData.hasTeam == true then
			local td = DataCenter.teamData:getTeamMember(thingVo.objId);
			if td ~= nil then
				return false;
			end
		end
	end
	return true;
end

function c_hookSetMonsterTarget(targetId)
	DataCenter.hook:setMonsterTarget(targetId);
end

function c_addWinData(winName, data)
	Lua_WindowUtil.addWinData(winName, data);
end

function c_showInChat(chanel, contentStr)
	if chanel == 0 then
		return;
	end
	local chatVo = Lua_ChatVo.new();
	chatVo.channel = chanel;
	chatVo.type = Lua_ChatData.CHAT_TYPE_TEXT;
	chatVo.role_id = 0;
	chatVo.content = contentStr;
	DataCenter.chatData:addChatMsg(chatVo);
end
--打开复活面板
function c_showReviveWindow()
	local c = getConfig({"scene",DataCenter.roleData.sceneId, "relive"});
	local param = {};
	param.config = c;
	if(DataCenter.yunBiaoData.isOngoing == true) then
		Lua_WindowUtil.openWin("Lua_ReviveCountDownWindow", WinParam.ACTION_OPEN,param);
	else
		if(c==nil) then
			Lua_WindowUtil.openWin("Lua_PlayerDeadWindow", WinParam.ACTION_OPEN, param);
		else
			if(c.win_type~=nil and c.win_type==2) then
				Lua_WindowUtil.openWin("Lua_ReviveCountDownWindow", WinParam.ACTION_OPEN,param);
			else
				Lua_WindowUtil.openWin("Lua_PlayerDeadWindow", WinParam.ACTION_OPEN, param);
			end
		end
	end
end
--关闭复活面板
function c_hideReviveWindow()
	Lua_WindowUtil.openWin("Lua_PlayerDeadWindow", WinParam.ACTION_CLOSE, nil);
end

-- 检测是否可以采集
function c_checkCanCollectTarget(targetId, monsterId)
	-- 如果有掉落的采集物，判断背包是否够
	local curCfg = getConfig({"monster", tonumber(monsterId)});
	if curCfg ~= nil and curCfg.drop_reward ~= nil and curCfg.drop_reward > 0 then
		local checkBagSize = getConfig({"rewards", curCfg.drop_reward, "checkBagSize"});
		if checkBagSize ~= nil then
			local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		    if bagData:getLeftSize() < checkBagSize then
		        return LanUtil.getValue(123112);
		    end
		end
	end

	-- 夺宝大逃杀
	if DataCenter.snatchWarData.bInSnatchWarScene == true then
		if DataCenter.snatchWarData.curOwnSnatchWarGiftVo ~= nil then -- 身上已有宝箱
			return LanUtil.getValue(123108);
		else
			local str = DataCenter.snatchWarData:checkCanCollectGiftById(targetId);
			if str ~= nil and str ~= "" then -- 采集满了不能再采集
				return str;
			end
		end
	elseif DataCenter.campWarData.bInCampWarScene == true or DataCenter.factionLeagueActData.bInFactionLeagueActScene == true then
		local clickPlayer = ThingUtil.instance:getThingById(targetId);
		if clickPlayer ~= nil then
			local campId = clickPlayer.data.camp_id;
			if campId == 0 then
				campId = tonumber(tostring(clickPlayer.data.sub_id));
			end
	        if campId ~= 0 and campId == DataCenter.roleData.camp_id then -- 己方阵营的采集物
	            return LanUtil.getValue(122718);
	        end
		end
	end

	return "";
end

function tranceTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask)
	return DataCenter.roleData:tranceTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
end

function setMyPos(px,py,pz,dir)
	local rd = DataCenter.roleData;
	rd.px = px;
	rd.py = py;
	rd.pz = pz;
	rd.dir = dir;

	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneConfig:isInBossArea(Vector3(px,0,pz)) == true then
		Lua_MsgUtil.callFunc("TORRIGHT_SHOWHIDE_ALL",{value=true,needRefresh=1});
	else
		Lua_MsgUtil.callFunc("TORRIGHT_SHOWHIDE_ALL",{value=false,needRefresh=1});
	end
end

function c_getFairyPickUpRage(itemType)
	if itemType == 5 then -- 拾取类buff，不能精灵拾取
		return 0;
	end

	if(DataCenter.fairyData.equipedfairyInfo~=nil 
		and DataCenter.fairyData.equipedfairyInfo.addAutopickRage~=nil) then
		--findRange = findRange + DataCenter.fairyData.equipedfairyInfo.addAutopickRage;
		local autopickLimit = DataCenter.fairyData.equipedfairyInfo.autopickLimit;
		if(autopickLimit~=nil) then
			for k,v in ipairs(autopickLimit) do
				if(v==DataCenter.roleData.sceneId) then
					return 0;
				end
			end
		end
		return DataCenter.fairyData.equipedfairyInfo.addAutopickRage;
	end
	return 0;
end

function c_switchTarget()
	DataCenter.thingData:addLastSlectedTarget(DataCenter.hook.selectedId);
    local s = DataCenter.hook:findAnotherTarget();
    c_hookCurMonsterTarget(s, false);
end

function c_showLevelUpEffect()
--	Lua_MsgUtil.callFunc("ROLE_LEVEL_UP_SHOW_EFFECT");
	Lua_WindowUtil.openWin("Lua_RoleLevelUpTips",WinParam.ACTION_OPEN, 1);
end
function c_rideOn()
	DataCenter.mountData:sChatMiniRide();
end

function c_checkMoveBackToExcuTask()
	--移动被服务端拉回后，检查是否需要执行任务
	if DataCenter.taskData.excutingTaskId ~= nil then
		Lua_CommonUtil.removeTimer( DataCenter.taskData, DataCenter.taskData.delayDoMoveBackExcuTask);
		Lua_CommonUtil.addTimer("delayDoMoveBackExcuTask",0.5,DataCenter.taskData,DataCenter.taskData.delayDoMoveBackExcuTask,DataCenter.taskData.excutingTaskId,1);		
	end
end

function c_clearExcutingTaskId()
	DataCenter.taskData.excutingTaskId = nil;
end
function c_excuTask(taskId)
	local taskVo = DataCenter.taskData:getTaskById(taskId);
	if taskVo == nil then
		return;
	end
	taskVo:exeTask();
end
function playerFireworkUIEffect()
--	Lua_MsgUtil.callFunc("PLAY_FIREWORK_UIEFFECT");
end

function c_startAct(actId)
	if DataCenter.actingManager == nil then
		checkRequire("Lua_ActingManager");
		DataCenter.actingManager = Lua_ActingManager.new();
	end
	DataCenter.actingManager:startAct(actId);
end