checkRequire("Lua_ForenoticePanel");
checkRequire("Lua_TopLeftIconPanel");
checkRequire("Lua_PlayerPanel");
checkRequire("Lua_TopRightPanel");
checkRequire("Lua_MinMapPanel");
checkRequire("Lua_SkillIconPanel");
checkRequire("Lua_ChatMiniPanel");
checkRequire("Lua_Joystick");
checkRequire("Lua_TaskAndTeamPanel");
checkRequire("Lua_PowerAndWifiPanel");
checkRequire("Lua_TargetPanel");
checkRequire("Lua_MainExpBarPanel");
checkRequire("Lua_OutButtonPanel");
checkRequire("Lua_CountDownAnimation");
checkRequire("Lua_XinQianIcon");
checkRequire("Lua_AttackedList");
checkRequire("Lua_VipProgressPanel");
Lua_MainMenuWindow = class("Lua_MainMenuWindow", Lua_FullSizeWindow);

Lua_MainMenuWindow.PLAYERPANEL_INDEX = 1;-- 左上角角色面板
Lua_MainMenuWindow.TOPRIGHT_INDEX = 2;-- 右上角图标栏
Lua_MainMenuWindow.MINIMAP_INDEX = 3;-- 右上角小地图
Lua_MainMenuWindow.SKILLICON_INDEX = 4;-- 右下角技能栏+功能栏
Lua_MainMenuWindow.CHAT_INDEX = 5;-- 下方聊天迷你面板
Lua_MainMenuWindow.JOYSTICK_INDEX = 6;-- 摇杆
Lua_MainMenuWindow.TASKANDTEAM_INDEX = 7;-- 左边任务栏
Lua_MainMenuWindow.BATTERY_WIFI_INDEX = 8;-- 左下角电量、wifi显示
Lua_MainMenuWindow.EXP_BAR_INDEX = 9;-- 下方经验条
Lua_MainMenuWindow.TARGET_INDEX = 10;-- 目标
Lua_MainMenuWindow.OUT_BTN_INDEX = 11;-- 退出按钮
Lua_MainMenuWindow.FORENOTICE_INDEX = 12;--新功能预告面板
Lua_MainMenuWindow.TOPLEFT_ICONS_INDEX = 13;--左上角图标
Lua_MainMenuWindow.XIN_JIAN_INDEX = 14;--信笺
Lua_MainMenuWindow.ATTACK_LIST = 15;--受击列表
Lua_MainMenuWindow.VIP_PROGRESS = 16;--vip进度

function Lua_MainMenuWindow:ctor()
    self.windowName = "Lua_MainMenuWindow";
    self.itemDic = { };
    self.itemShowStateDic = { };
    self:superCall("ctor", false, false, 500, false, false, false);
end

function Lua_MainMenuWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.isShow = false;
    self.content:SetActive(self.isShow);

    self.itemShowStateDic[Lua_MainMenuWindow.PLAYERPANEL_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.TOPRIGHT_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.MINIMAP_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.SKILLICON_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.CHAT_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.JOYSTICK_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.TASKANDTEAM_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.BATTERY_WIFI_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.EXP_BAR_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.TARGET_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.OUT_BTN_INDEX] = true;
	self.itemShowStateDic[Lua_MainMenuWindow.FORENOTICE_INDEX] = true;
	self.itemShowStateDic[Lua_MainMenuWindow.TOPLEFT_ICONS_INDEX] = true;
    self.itemShowStateDic[Lua_MainMenuWindow.XIN_JIAN_INDEX] = false;
    self.itemShowStateDic[Lua_MainMenuWindow.ATTACK_LIST] = false;
    self.itemShowStateDic[Lua_MainMenuWindow.VIP_PROGRESS] = true;

    self.playerPanel = Lua_PlayerPanel.new(self.content);
    self.topRightPanel = Lua_TopRightPanel.new(self.content);
    self.miniMapPanel = Lua_MinMapPanel.new(self.content);
    self.skillIconPanel = Lua_SkillIconPanel.new(self.content);
    self.chatPanel = Lua_ChatMiniPanel.new(self.content);
    self.joyStick = Joystick(self.content);
    self.taskAndTeamPanel = Lua_TaskAndTeamPanel.new(self.content);
    self.powerAndWifiPanel = Lua_PowerAndWifiPanel.new(self.content);
    self.expBarPanel = Lua_MainExpBarPanel.new(self.content);
    self.targetPanel = Lua_TargetPanel.new(self.content);
    self.targetPanel:setEnable(false);
    self.outPanel = Lua_OutButtonPanel.new(self.content);
	self.forenoticePanel = Lua_ForenoticePanel.new(self.content);
	self.topLeftIconPanel = Lua_TopLeftIconPanel.new(self.content);
    self.xinQianIcon = Lua_XinQianIcon.new(self.content);
    self.attackList = Lua_AttackedList.new(self.content);
    self.attackList:setEnable(false);
    self.vipProgressPanel = Lua_VipProgressPanel.new(self.content);

    self:updateWindowDepth();
    self:onScreenResize(nil);

    self:addLuaEvent("UPDATE_MAIN_MENU", self, self.onUpdateMainMenu);
    self:addCSharpEvent("SCREEN_RESIZE", self, self.onScreenResize);
    self:addLuaEvent("SETSKILLMENUSTATE", self, self.setSkillMenuState);
    self:addLuaEvent("SELECTED_TARGET_CHANGE", self, self.onSelectedTargetChange);
    self:addLuaEvent("TRANS_REQUEST", self, self.onTransRequestChange);
    self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded);
	self:addLuaEvent("OUTSCENE_COUNTDOWN_TIME", self, self.onOutSceneCountDown);
    self:addLuaEvent("OUTMONSTRE_COMEDOWN_TIME", self, self.onOutSceneCountDown);
	self:addLuaEvent("PLAY_FIREWORK_UIEFFECT",self,self.playFireworkUIEffect);
end

function Lua_MainMenuWindow:onScreenResize(obj)
    local half_w = MainWinDefine.V_width / 2;
    local half_h = MainWinDefine.V_height / 2;

    self.itemDic[Lua_MainMenuWindow.PLAYERPANEL_INDEX] = { item = self.playerPanel, showPos = Vector3(-half_w, half_h, 0), hidePos = Vector3(-half_w - 300, half_h + 300, 0) };
    self.itemDic[Lua_MainMenuWindow.TOPRIGHT_INDEX] = { item = self.topRightPanel, showPos = Vector3(half_w - 160, half_h - 74, 0), hidePos = Vector3(half_w - 30, half_h + 230, 0) };
    self.itemDic[Lua_MainMenuWindow.MINIMAP_INDEX] = { item = self.miniMapPanel, showPos = Vector3(half_w, half_h, 0), hidePos = Vector3(half_w + 155, half_h + 155, 0) };
    self.itemDic[Lua_MainMenuWindow.SKILLICON_INDEX] = { item = self.skillIconPanel, showPos = Vector3(half_w, -half_h, 0), hidePos = Vector3(half_w + 200, -half_h - 300, 0) };
    self.itemDic[Lua_MainMenuWindow.JOYSTICK_INDEX] = { item = self.joyStick, showPos = Vector3(-half_w + 165, -half_h + 133, 0), hidePos = Vector3(-half_w - 100, -half_h - 100, 0) };
    self.itemDic[Lua_MainMenuWindow.CHAT_INDEX] = { item = self.chatPanel, showPos = Vector3(0, -half_h + 125, 0), hidePos = Vector3(0, -half_h - 100, 0) };
    self.itemDic[Lua_MainMenuWindow.TASKANDTEAM_INDEX] = { item = self.taskAndTeamPanel, showPos = Vector3(-half_w, half_h - 183, 0), hidePos = Vector3(-half_w - 1527, half_h - 125, 0) };
    self.itemDic[Lua_MainMenuWindow.BATTERY_WIFI_INDEX] = { item = self.powerAndWifiPanel, showPos = Vector3(-half_w + 20, -half_h, 0), hidePos = Vector3(-half_w, -half_h - 40, 0) };
    self.itemDic[Lua_MainMenuWindow.EXP_BAR_INDEX] = { item = self.expBarPanel, showPos = Vector3(0, -half_h + 3, 0), hidePos = Vector3(0, -half_h - 10, 0) };
    self.itemDic[Lua_MainMenuWindow.TARGET_INDEX] = { item = self.targetPanel, showPos = Vector3(-half_w + 470, half_h - 70, 0), hidePos = Vector3(-half_w + 470, half_h + 200, 0) };
    self.itemDic[Lua_MainMenuWindow.OUT_BTN_INDEX] = { item = self.outPanel, showPos = Vector3(half_w - 50, half_h - 130, 0), hidePos = Vector3(half_w + 300, half_h - 180, 0) };
	self.itemDic[Lua_MainMenuWindow.FORENOTICE_INDEX] = { item = self.forenoticePanel, showPos = Vector3(-half_w + 356, half_h - 248, 0), hidePos = Vector3(-half_w - 380, half_h - 248, 0) };
	self.itemDic[Lua_MainMenuWindow.TOPLEFT_ICONS_INDEX] = { item = self.topLeftIconPanel, showPos = Vector3(-half_w + 346, half_h - 2 , 0), hidePos = Vector3(-half_w - 100, half_h - 248, 0) };
    self.itemDic[Lua_MainMenuWindow.XIN_JIAN_INDEX] = { item = self.xinQianIcon, showPos = Vector3(-half_w + 335, half_h - 350, 0), hidePos = Vector3(-half_w - 100, half_h - 353, 0) };
    self.itemDic[Lua_MainMenuWindow.ATTACK_LIST] = { item = self.attackList, showPos = Vector3(half_w - 331, 0, 0), hidePos = Vector3(half_w + 500, 0, 0) };
    self.itemDic[Lua_MainMenuWindow.VIP_PROGRESS] = { item = self.vipProgressPanel, showPos = Vector3(-half_w + 367, half_h - 385, 0), hidePos = Vector3(-half_w - 200, half_h - 353, 0) };

    self:updateShowHideItem();
end
function Lua_MainMenuWindow:onOutSceneCountDown(msg)
    if msg == nil then
        return;
    end

    local num = msg.left_time;
    if num == nil then
        num = msg.left_sec;
    end
    if msg.scene_id == DataCenter.roleData.sceneId and msg.scene_id ~= nil then
        self.aniType = msg.scene_id;
    else
        self.aniType = msg.type;-- 0退出场景 1退出副本 2进入X层 3开始
    end

    if num > 0 then
        if self.outCountDownAni == nil then
            local showType = 0;         --转换类型 对应 Lua_CountDownAnimation 里面 showType 类型
            if self.aniType == 0 then
                showType = 3;
            elseif self.aniType == 1 then
                showType = 2; 
            elseif self.aniType == 2 then
                showType = 4;
            elseif self.aniType == DataCenter.roleData.sceneId then--区分怪物攻城
                showType = 5;
            elseif self.aniType == 3 then
                showType = 6;
            end
            self.outCountDownAni = Lua_CountDownAnimation.new(self.content, self, self.outCountDownComplete, showType);
            self.outCountDownAni:setDepth(10);
            if showType == 5 then
                self.outCountDownAni:setLocation(0, MainWinDefine.V_height / 2 - 400, 0);
            else
                self.outCountDownAni:setLocation(0, MainWinDefine.V_height / 2 - 265, 0);
            end
        end
        self.outCountDownAni:playCountDown(num, 1);
    else
        self:outCountDownComplete();
    end
end

function Lua_MainMenuWindow:outCountDownComplete()
    if self.outCountDownAni ~= nil then
        self.outCountDownAni:dispose();
        self.outCountDownAni = nil;
    end
    Lua_MsgUtil.callFunc("OUTSCENE_COUNTDOWN_COMPLETE", self.aniType);
end

function Lua_MainMenuWindow:onSceneLoaded()
    if self.isShow == false then
        self.isShow = true;
        Lua_MsgUtil.callFunc("PLAY_WELCOME_VIDEO");
        self.content:SetActive(self.isShow);
    end

    if self.skillIconPanel ~= nil then
        local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
        if sceneCfg ~= nil then
            if sceneCfg.config.show_skillicon_state then
                self.skillIconPanel:setMenuState(sceneCfg.config.show_skillicon_state);
			else
				--默认显示技能
				self.skillIconPanel:setMenuState(2);
            end
            self.skillIconPanel:setShowSkillList(sceneCfg.config.skill_list);
            if self.outCountDownAni ~= nil then
               self:outCountDownComplete();
            end
        else
            self.skillIconPanel:setShowSkillList(nil);
        end
    end
end
function Lua_MainMenuWindow:onUpdateMainMenu(obj)
    for i, v in ipairs(self.itemShowStateDic) do
        self.itemShowStateDic[i] = false;
    end

    if obj ~= nil then
        for i, v in ipairs(obj) do
            self.itemShowStateDic[v] = true;
        end
    end
    self:updateShowHideItem();
end
function Lua_MainMenuWindow:dispose()
    self:superCall("dispose");
    if self.joyStick ~= nil then
        self.joyStick:dispose();
    end
    Lua_CommonUtil.removeTimer(self, self.onScreenResize);
end

function Lua_MainMenuWindow:updateShowHideItem()
    for i, v in ipairs(self.itemShowStateDic) do
        local t = self.itemDic[i];
        if t ~= nil then
            if v == true then
                -- TweenUtil.getInstance():addTween(t.item.mainContent, 0.1, 0, t.showPos, nil, nil);
                -- 策划需求，夺旗大战位置下移2018.04.08
                if Lua_MainMenuWindow.ATTACK_LIST == i then
                    t.item:setEnable(true);
                end
                if i == Lua_MainMenuWindow.TARGET_INDEX and 
                    (DataCenter.campWarData.bInCampWarScene == true 
                    or DataCenter.roleData.sceneId == 71701--水晶之战
                    or DataCenter.factionLeagueActData.bInFactionLeagueActScene == true) then
                    TweenUtil.getInstance():addTween(t.item.mainContent, 0.1, 0, Vector3(- MainWinDefine.V_width / 2 + 400, MainWinDefine.V_height / 2 - 140, 0), nil, nil);
                else
                    TweenUtil.getInstance():addTween(t.item.mainContent, 0.1, 0, t.showPos, nil, nil);
                end
            else
                TweenUtil.getInstance():addTween(t.item.mainContent, 0.1, 0, t.hidePos, nil, nil);

                if DataCenter.WulindahuiData.bInWulindahuiScene == true and  i==Lua_MainMenuWindow.TASKANDTEAM_INDEX then -- 武林大会场景(注意场景id写死，配置修改的时候也得改)
                   TweenUtil.getInstance():addTween(t.item.mainContent, 0.1, 0, Vector3(- ( MainWinDefine.V_width / 2) - 600, (MainWinDefine.V_height / 2) - 125, 0), nil, nil);
                end
            end
        end
    end
end

function Lua_MainMenuWindow:setSkillMenuState(state)
    if self.skillIconPanel ~= nil then
        self.skillIconPanel:setMenuState(state);
    end
end

function Lua_MainMenuWindow:onSelectedTargetChange(val)
    if getShowTips() == false then
        return;
    end
    if DataCenter.answerData.bInAnswerScene == true then -- 答题不显示目标
        self.targetPanel:setEnable(false);
        return;
    end

    local v = DataCenter.hook.selectedId;
    local thingVo = DataCenter.thingData:getThing(v);
	local monCfg = nil;
	local selectId = tostring(PlayerData.getInstance().selectedId);
	if selectId ~= nil  and  selectId ~= "0" then
		local tid = selectId;
		
		monCfg = getConfig({"monster",tonumber(selectId)}); 
	end
    if (v == 0 or thingVo == nil) and  monCfg == nil then
        self.targetPanel:setEnable(false);
        DataCenter.poolPartyData.selectPlayrId = nil; -- 泳池派对，点击人物记录人物ID，请勿删除
    else
		if thingVo ~= nil then
            self.targetPanel:setData(thingVo);
            self.targetPanel:setEnable(true);
        elseif monCfg ~= nil and selectId ~= "0" then
            self.targetPanel:setNpcData(monCfg);            
            self.targetPanel:setEnable(true);
		else
			self.targetPanel:setEnable(false);
		end
    end
end

function Lua_MainMenuWindow:onTransRequestChange(val)
    if self.transIcon == nil then
        self.transIcon = UICreate.createUIAtlasImage(self.content, "transWindow", "trans_icon", 220, -245, 0, 0);
        self.transIcon:addClickFuntion(self, self.onTransIconClick)
    end

    if val == false then
        self.transIcon.mainContent:SetActive(false);
    else
        self.transIcon.mainContent:SetActive(true);
    end
end
function Lua_MainMenuWindow:onTransIconClick(val)
    local tipData = { };
    tipData.des = LanUtil.formateStr(LanUtil.getValue(122001), DataCenter.transData.roleInviteName);
    tipData.owner = self;
    tipData.cancelName = LanUtil.getValue(122007)
    tipData.titleName = LanUtil.getValue(122006)
    tipData.type = 1;
    tipData.subFun = self.onSubCallback;
    tipData.cancelFun = self.onCancelCallback;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end
function Lua_MainMenuWindow:onSubCallback(val)
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sTransReplyMsg(1, DataCenter.transData.roleInviteId);
end
function Lua_MainMenuWindow:onCancelCallback()
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sTransReplyMsg(0, DataCenter.transData.roleInviteId);
end

function Lua_MainMenuWindow:playFireworkUIEffect()
	self:addTimer("delayPlayFirework",1.5,self,self.delayPlayFirework);
end
function Lua_MainMenuWindow:delayPlayFirework()
	Lua_CommonUtil.removeTimer(self,self.delayPlayFirework);
	if self.fireworkEffect == nil then
		self.fireworkEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/jijieling_tx","jijieling_tx",0,0);
	end
	self:addTimer("delayDisposeFriework",2,self,self.disposeFirework);
end

function Lua_MainMenuWindow:disposeFirework()
	Lua_CommonUtil.removeTimer(self,self.disposeFirework)
	if self.fireworkEffect ~= nil then
		self.fireworkEffect:dispose();
		self.fireworkEffect = nil;
	end
end