-- 神秘信笺按钮
Lua_XinQianIcon = class("Lua_XinQianIcon", Lua_DisplayObject);
function Lua_XinQianIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_XinQianIcon:buildShowItem()
	self:superCall("buildShowItem");

	local half_w = MainWinDefine.V_width / 2;
	local half_h = MainWinDefine.V_height / 2;
	self.showPoint =  Vector3(-half_w + 335, half_h - 350, 0);
	self.hidePoint =  Vector3(-half_w - 100, half_h - 353, 0);

	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.onActDataUpdate);
	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.onActInfo);
	self:addLuaEvent("TASK_AND_TEAM_PANEL_SHOWHIDE", self, self.onTaskShowHide);
end

function Lua_XinQianIcon:onActDataUpdate()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1016, nil);
	if avo ~= nil then
		DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index,1016);
	else
		self:setXinQianIconState(false, false);
	end
end

function Lua_XinQianIcon:onActInfo(msg)
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1016, nil);
	if avo == nil then
		self:setXinQianIconState(false, false);
		return;
	end

	if msg.act_detail.first_type == 1016 then
		if msg.act_detail.cur_index == -1 then
			self:setXinQianIconState(false, false);
		else
			local stop_tick = tonumber(tostring(msg.act_detail.stop_tick));
			local nowServerTime = tonumber(tostring(GlobalVar.cur_tick));
			self.leftTime = stop_tick - nowServerTime;
			self.startTime = getTime();

			local curStep = msg.act_detail.cur_index;
			local curStepData = msg.act_detail.reward_info[curStep + 1];
			self:setXinQianIconState(true, curStepData.arrive > curStepData.drawed);
		end
	end
end

function Lua_XinQianIcon:setXinQianIconState(val, redValue)
	if val == true then
		if self.xinQianIcon == nil then
			self.xinQianIcon = UICreate.createUIAtlasImage(self.content, "xinqianWindow_atlas", "ui_smxj_hdicon", 0, 0, 0, 0);
			self.xinQianIcon:setDepth(1);
			self.xinQianIcon:addClickFuntion(self, self.onXinQianClick);
		end
		self.xinQianIcon:setEnable(true);

		if self.timeTxt == nil then
			self.timeTxt = UICreate.createLabel(self.content, "", 0, -52, 200, 30, 20);
			self.timeTxt.pivot = UIWidget.Pivot.Center;
			self.timeTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.timeTxt.effectColorStr = Lua_ColorDefine.transColor("000000");
			self.timeTxt.effectStyle = 3;
			self.timeTxt:setEffectDistance(1, 1);
			self.timeTxt:setDepth(0);
		end
		self.timeTxt:setEnable(true);
		self:addTimer("Lua_XinQianIcon", 1, self, self.onCountDown);
	else
		if self.xinQianIcon ~= nil then
			self.xinQianIcon:setEnable(false);
		end
		if self.timeTxt ~= nil then
			self.timeTxt:setEnable(false);
		end
	end
	self:setXinQianRedDot(val, redValue);
end

function Lua_XinQianIcon:onXinQianClick()
	Lua_WindowUtil.openWin("Lua_XinQianWindow");
end

function Lua_XinQianIcon:onCountDown()
	if self.leftTime ~= nil then
		local pt = getTime() - self.startTime;
		local lt = self.leftTime - pt;
		if lt >= 0 then
			lt = math.floor(lt);
			self.timeTxt.text = "[00E125]"..TimeTransform.getInstance():transSeconds6(lt, false, true).."[-]";
		else
			self:setXinQianIconState(false, false);
			self.timeTxt.text = "00:00";
		end
	end
end

function Lua_XinQianIcon:setXinQianRedDot(val, redState)
	if val and redState then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 32, 26, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(5);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_XinQianIcon:onTaskShowHide(val)
	if val == true then
		TweenUtil.getInstance():addTween(self.content, 0.1, 0, self.showPoint, nil, nil);
	else
		TweenUtil.getInstance():addTween(self.content, 0.1, 0, self.hidePoint, nil, nil);
	end
end

function Lua_XinQianIcon:dispose()
	if self.xinQianIcon ~= nil then
		self.xinQianIcon:dispose();
		self.xinQianIcon = nil;
	end
	if self.timeTxt ~= nil then
		self.timeTxt:dispose();
		self.timeTxt = nil;
	end
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	self:superCall("dispose");
end