checkRequire("Lua_AttackedListItem");
Lua_AttackedList = class("Lua_AttackedList", Lua_DisplayObject);
function Lua_AttackedList:ctor(p)
	self:superCall("ctor",p,"AttackedList_skin");
end
function Lua_AttackedList:buildShowItem()
	self:superCall("buildShowItem");
	self.leftBg2:addClickFuntion(self, self.onCloseClick);

	self.dragList = Lua_DragList.new(self.obj,1, Vector4(0, 0, 256, 154));
    self.dragList:setLocation(0, -20, 0);
    self.dragList:setListCell(Lua_AttackedListItem, 32, 256, 1);

    self:addLuaEvent("UPDATE_ATTACKED_DATA", self, self.onUpdateAttackedData);
    self:addLuaEvent("MENU_STATE_CHANGE", self, self.onMenuStateChange);
    self.showItems = false;
    self:setState(1);
end
function Lua_AttackedList:onMenuStateChange(o)
    if o[2] > 10 then
        if o[1] == 1 then
            -- self.obj.transform.localPosition = Vector3(-100, 0, 0);
            LuaUtil.setObjPos(self.obj, -100, 0, 0);
        else
            -- self.obj.transform.localPosition = Vector3(0, 0, 0);
            LuaUtil.setObjPos(self.obj, 0, 0, 0);
        end
    else
        -- self.obj.transform.localPosition = Vector3(0, 0, 0);
        LuaUtil.setObjPos(self.obj, 0, 0, 0);
    end
end
function Lua_AttackedList:onUpdateAttackedData(o)
    local len = DataCenter.attackedData.attackedList:getSize();
    if len == 0 then
        self.showItems = false;
    else
        self.showItems = true;
    end
    local rd = DataCenter.roleData;
    if rd.nameColor ~= 0 then
        self.showItems = false;
    end
    self.dragList:setLuaArrayData(DataCenter.attackedData.attackedList);
    self:setState(self.state);
end
function Lua_AttackedList:onCloseClick(o)
    if self.state == 1 then
        self:setState(0);
    else
        self:setState(1);
    end
end
function Lua_AttackedList:setState(val)
    self.state = val;
    self.txt:setEnable(self.showItems);
    self.leftBg1:setEnable(self.showItems);
    self.leftBg2:setEnable(self.showItems);
    self.arrowSp:setEnable(self.showItems);
    if self.state == 1 then
        self.dragList:setEnable(true and self.showItems);
        self.bg:setEnable(true and self.showItems);
        self.titleTxt:setEnable(true and self.showItems);
        self.fege:setEnable(true and self.showItems);

        self.leftBg1:setLocation(-163,61,0);
        self.leftBg2:setLocation(-163,-10,0);
        self.txt:setLocation(-163,61,0);
        self.arrowSp:setLocation(-163,-10,0);
        -- self.arrowSp.mainContent.transform.localRotation = Quaternion.Euler(0, 0, -90);
        LuaUtil.setObjRot(self.arrowSp.mainContent, 0, 0, -90);
    else
        self.dragList:setEnable(false and self.showItems);
        self.bg:setEnable(false and self.showItems);
        self.titleTxt:setEnable(false and self.showItems);
        self.fege:setEnable(false and self.showItems);

        self.leftBg1:setLocation(115,61,0);
        self.leftBg2:setLocation(115,-10,0);
        self.txt:setLocation(115,61,0);
        self.arrowSp:setLocation(115,-10,0);
        -- self.arrowSp.mainContent.transform.localRotation = Quaternion.Euler(0, 0, 90);
        LuaUtil.setObjRot(self.arrowSp.mainContent, 0, 0, -90);
    end
end