Lua_AttackedData = class("Lua_AttackedData");
function Lua_AttackedData:ctor()
	self.attackedList = Array();
end
function Lua_AttackedData:dispose()
	self.attackedList = Array();
end
function Lua_AttackedData:fromServer(val)
	local dic = {};
	local len = self.attackedList:getSize();
	for i=1,len do
		dic[self.attackedList[i].id] = 1;
	end
	self.attackedList:clear();
	local newList = Array();
	for i,v in ipairs(val.hatred_list) do
		local rid = tonumber(v.obj_id);
		local tvo = DataCenter.thingData:getThing(rid);
		if tvo ~= nil then
			if dic[rid] == nil then
				newList:add(rid);
			end
			self.attackedList:add({id=rid, time=tonumber(v.obj_value)});
		end
	end
	self.attackedList:sort("time", true);
	len = newList:getSize();
	local rd = DataCenter.roleData;
    if rd.nameColor == 0 then
    	for i=1,len do
			local tvo = DataCenter.thingData:getThing(newList[i]);
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122261), tvo.name));
		end
    end
	Lua_MsgUtil.callFunc("UPDATE_ATTACKED_DATA",self.vo);
end
function Lua_AttackedData:clearMoveTo()
	self.moveToTarget = 0;
	Lua_CommonUtil.removeTimer(self, self.onCheckMoveTo);
end
function Lua_AttackedData:setMoveTo(val)
	self.moveToTarget = val;
	self:onCheckMoveTo();
	Lua_CommonUtil.addTimer("onCheckMoveTo", 1, self, self.onCheckMoveTo);
end
function Lua_AttackedData:onCheckMoveTo()
	local playerData = DataCenter.thingData:getThing(self.moveToTarget);
	if playerData ~= nil then
		local rd = DataCenter.roleData;
		DataCenter.hook:stop();
		DataCenter.hook:setCurSelectedId(self.moveToTarget);
		local dx = rd.px - playerData.px;
		local dz = rd.pz - playerData.pz;
		local curDis = math.abs(dx) + math.abs(dz);
		if curDis > 500 then
			if DataCenter.thingData:checkTargetCanAttactk(playerData, false) == false then
				WorldMapUtil.moveToPos(playerData.px, playerData.py, playerData.pz, 150);
			else
				local skillvo = DataCenter.skillData:findUseSkill();
				if skillvo ~= nil then
					MsgUtil.callFunc("USE_SKILL", {skillId=skillvo.skillId, targetId=Lua_CommonUtil.trnsLongNum(tonumber(self.moveToTarget)), 
						isAuto=false});
				end
			end
		else
			self:clearMoveTo();
		end
	else
		self:clearMoveTo();
	end
end