Lua_ForenoticePanel = class("Lua_ForenoticePanel", Lua_DisplayObject);
function Lua_ForenoticePanel:ctor(p)
	self:superCall("ctor", p, "ForenoticePanel_skin");
end

function Lua_ForenoticePanel:buildShowItem()
	self:superCall("buildShowItem");

	local half_w = MainWinDefine.V_width / 2;
	local half_h = MainWinDefine.V_height / 2;
	self.showPoint =  Vector3(- half_w + 362, half_h - 248, 0);
	self.hidePoint =  Vector3(- half_w - 280, half_h - 248, 0);

	-- if self.modelImg == nil then
	-- 	self.modelImg = UICreate.createImage(self.content,"",0,0,0,0);
	-- end
	-- self.modelImg:setLocation(0,53,0);
	-- self.modelImg:setDepth(3);
	-- self.modelImg:addClickFuntion(self,self.onImgClick);

	self.depth = -500;
	self.desk:setDepth(self.depth + 1);
	self.titleBg:setDepth(self.depth + 1);
	self.nameTxt:setDepth(self.depth + 2);
	self.lvTxt:setDepth(self.depth + 2);

	self.showIcon = UICreate.createUIAtlasImage(self.content, "", "", 9, 38, 0, 0);
	self.showIcon.name = "showIcon";
	self.showIcon:setDepth(self.depth + 5);
	self.showIcon:setEnable(false);

	self.maskBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 9, -63, 140, 200);
	self.maskBg.name = "maskBg";
	self.maskBg.alpha = 0.01;
	self.maskBg.pivot = UIWidget.Pivot.Bottom;
	self.maskBg.clickScale = false;
	self.maskBg:setDepth(self.depth + 10);
	
	self:addTimer("resetMaskBox", 1, self, self.delaySetMaskBox);

	self:addLuaEvent("SHOW_HIDE_TRAILER", self, self.checkNoticeShow);
	self:addLuaEvent("TASK_AND_TEAM_PANEL_SHOWHIDE", self, self.onTaskShowHide);
	self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded);
end

function Lua_ForenoticePanel:delaySetMaskBox()
	Lua_CommonUtil.removeTimer(self, self.delaySetMaskBox);
	if self.maskBg ~= nil then
		self.maskBg:addClickFuntion(self, self.onImgClick);
	end
end

function Lua_ForenoticePanel:checkNoticeShow(trailerId)
	self:setFootAni(false);

	self.trailerId = trailerId;
	if self.trailerId == 0 or self.trailerId == nil then
		self:setEnable(false);
	else
		self:setEnable(true);
		
		self.cfg = getConfig({"func_open", self.trailerId});
		if self.cfg ~= nil then
			if self.modelEffect ~= nil then
				self.modelEffect:dispose();
				self.modelEffect = nil;
			end

			if self.cfg.picture_or_model == 2 then
				local modelName = self.cfg.trailer_left_model[DataCenter.roleData.career];
				self.modelEffect = UICreate.createUIEffect(self.content, "/mounts/".. modelName, modelName, 0, 0);
				self.modelEffect:SetRenderQueue(self.desk, 1, 2, false);
				
				local pos = self.cfg.trailer_left_model_pos;
				if pos ~= nil then
					self.modelEffect:setLocation(pos[1], pos[2], 300);
				else
					self.modelEffect:setLocation(9, 5, 300);
				end

				local rot = self.cfg.trailer_left_model_rot;
				if rot ~= nil then
					self.modelEffect:setRot(rot[1], rot[2], rot[3]);
				end

				local scale = self.cfg.trailer_left_model_scale;
				if scale ~= nil then
					self.modelEffect:setSacle(scale[1], scale[2], scale[3]);
				end

				if self.trailerId == 10050 then
					-- 2018.3.23 策划需求：法宝模型要一直在待机状态
					self.modelEffect:setAction(1);
				elseif self.trailerId == 10025 then
					-- 2018.3.23 策划需求：足迹模型要循环播放
					-- self.modelEffect:setLoop(true);
					self:setFootAni(true);
				end
				-- self.modelImg:setUrl("/images/forenotice/" .. self.cfg.trailer_left_icon .. ".png");
			elseif self.cfg.picture_or_model == 1 then
				self.showIcon:setAltas(self.cfg.trailer_left_icon[1], self.cfg.trailer_left_icon[2])
			end
			self.nameTxt.text = self.cfg.name;
			self.lvTxt.text = self.cfg.tailer_des;
		end
		self.showIcon:setEnable(self.cfg ~= nil and self.cfg.picture_or_model == 1);
	end
end

function Lua_ForenoticePanel:setFootAni(val)
	if val then
		Lua_CommonUtil.addTimer("ForenoticeModelEffect", 2, self, self.effectLoop);
	else
		Lua_CommonUtil.removeTimer(self, self.effectLoop);
	end
end

function Lua_ForenoticePanel:effectLoop()
    if self.modelEffect == nil then
    	return;
    end

    local effectRoot = self.modelEffect.mainContent;
    if effectRoot ~= nil then
        effectRoot:SetActive(false);
        effectRoot:SetActive(true);
    end
end

function Lua_ForenoticePanel:onTaskShowHide(val)
	if val == true then
		TweenUtil.getInstance():addTween(self.content, 0.1, 0, self.showPoint, nil, nil);
	else
		TweenUtil.getInstance():addTween(self.content, 0.1, 0, self.hidePoint, nil, nil);
	end
end

function Lua_ForenoticePanel:onSceneLoaded()
	local menu = getConfig({"scene", DataCenter.roleData.sceneId, "menu_item"});
	local showFore = false;
	for i, v in ipairs(menu) do
		if v == Lua_MainMenuWindow.FORENOTICE_INDEX then
			showFore = true;
			break;
		end
	end

	if showFore == true then
		self:addTimer("delaySetUI", 0.5, self, self.delaySetUI);
	end
end

function Lua_ForenoticePanel:delaySetUI()
	Lua_CommonUtil.removeTimer(self, self.delaySetUI);
	TweenUtil.getInstance():stop(self.content);
	if DataCenter.taskData.zoomOutTaskUI then
		self:setLocation(self.showPoint.x, self.showPoint.y, self.showPoint.z);
	else
		self:setLocation(self.hidePoint.x, self.hidePoint.y, self.hidePoint.z);
	end
end

function Lua_ForenoticePanel:onImgClick(go)
	if self.cfg ~= nil then
		Lua_WindowUtil.openWin("Lua_ForenoticeDetailWindow", nil, self.trailerId);
	end
end

function Lua_ForenoticePanel:dispose()
	if self.showIcon ~= nil then
		self.showIcon:dispose();
		self.showIcon = nil;
	end
	if self.maskBg ~= nil then
		self.maskBg:dispose();
		self.maskBg = nil;
	end
	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end
	self:setFootAni(false);

	self:superCall("dispose");
end