-- 功能图标数据
checkRequire("Lua_MenuIconData");
Lua_AllMenuIconData = class("Lua_AllMenuIconData");
Lua_AllMenuIconData.ROLEICONID = 10015; -- 角色人物图标id
function Lua_AllMenuIconData:ctor()
	self.curFloatTargetPosX = 0;
	self.curFloatTargetPosY = 0;
	self.clickDic = {};
end

function Lua_AllMenuIconData:dispose()
	self.clickDic = {};
	if self._menuIconDic ~= nil then
		for k, v in pairs(self._menuIconDic) do
			v:resetInfo();
		end
	end
end

function Lua_AllMenuIconData:getHasClick(id)
	return self.clickDic[id] == 1;
end

function Lua_AllMenuIconData:setHasClick(id)
	self.clickDic[id] = 1;
end

function Lua_AllMenuIconData.Get:menuIconDic()
	if self._menuIconDic == nil then
		self._menuIconDic = {};

		local menuIconData;
		local topRightIcon = getConfig({"topRightIcon"});
		if topRightIcon ~= nil then
			for iconId, info in pairs(topRightIcon) do
				if info.pos_type == 2 then
					menuIconData = Lua_MenuIconData.new(iconId, info);
					self._menuIconDic[iconId] = menuIconData;
				end
			end
		end
	end
	return self._menuIconDic;
end

function Lua_AllMenuIconData:addIconDataWithAct(iconId)
	if self.menuIconDic[iconId] == nil then
		self._menuIconDic[iconId] = Lua_TopRightIconData.new(iconId);
	end
end

function Lua_AllMenuIconData:removeIcon(iconId)
	if self.menuIconDic[iconId] ~= nil then
		self._menuIconDic[iconId] = nil;
	end
end