checkRequire("Lua_FuncItemData");
Lua_FuncOpenData = class("Lua_FuncOpenData")
function Lua_FuncOpenData:ctor()
	self:dispose();
end

function Lua_FuncOpenData:dispose()
	self.openedList = Array();
	self.openedIds = Array();
	self.initChecked = false;
	self.smallestTrailerId = nil;
	self.smallestSort = 0;
	self.floatingIconList = Array();
	self.menuFloatingPos = {};
	self.showLockEffect = {};
    self.isPanGuNew = 0;
    self.panguShow = 0;
end

function Lua_FuncOpenData:addFloatIconData(tb)
	local hasIn = false;
	for i = 1, self.floatingIconList:getSize() do
		if self.floatingIconList[i].iconName == tb.iconName then
			hasIn = true;
			break;
		end
	end

	if hasIn == false then
		self.floatingIconList:add(tb);
	end
end

function Lua_FuncOpenData:checkShowFloatIconWin()
	local tb;
	if self.floatingIconList:getSize() > 0 then
		tb = self.floatingIconList[1];
		self.floatingIconList:removeItem(tb);
		Lua_WindowUtil.openWin("Lua_IconFloatingWindow", WinParam.ACTION_OPEN, tb);
		return true;
	end
	return false;
end

function Lua_FuncOpenData:initSmallTrailerId()	
	local cfg = getConfig({"func_open"});
	for k,v in pairs(cfg) do
		if v.open_sort == 1 then
			-- self.smallestTrailerId = tonumber(k);
			self.smallestSort = v.open_sort;
		end
	end
end

function Lua_FuncOpenData:isOpened(funId, isShowTips)
	if funId == 10022 and DataCenter.roleData.permission == 8 then
		return true;
	end

	if self.openedIds:indexOf(funId) == -1 then
		if isShowTips ~= nil and isShowTips == true then
			local s = getConfig({"func_open", funId, "advance_message"});
			if s ~= nil then
				OperateAlert.show(s);
			end
		end
		return false;
	else
		return true;
	end
end

function Lua_FuncOpenData:openAll()
	local cfg = getConfig({"func_open"});
	local openIds = Array();
	for k, v in pairs(cfg) do
		if self.openedIds:indexOf(k) == -1 then	
			local fund = Lua_FuncItemData.new(k);
			self.openedList:add(fund);
			
			self.openedIds:add(k);
			openIds:add(k);

			if fund.iconId ~= nil then
				local iconData = DataCenter.menuIconData.menuIconDic[tonumber(fund.iconId)];
				if iconData == nil then
					iconData = DataCenter.allRtData.topRightIconDic[tonumber(fund.iconId)];		
				end
				if iconData ~= nil then
					iconData:setFunOpenState(true);
				end
			end
		end
	end

	DataCenter.allRtData.curFloatTargetPosX = 0;
	DataCenter.allRtData.curFloatTargetPosY = 0;
	self.openInCMD = true;
	Lua_MsgUtil.callFunc("FUNCTION_OPEN", openIds);
end

function Lua_FuncOpenData:setPanGuData(value, show)
	self.isPanGuNew = value;
	self.panguShow = show;
	self:checkOpenedFunc(false);
end

function Lua_FuncOpenData:checkOpenedFunc(dispatchEvent)
	-- if self.smallestTrailerId == nil then
	-- 	self:initSmallTrailerId();
	-- end

	local cfg = getConfig({"func_open"});
	local playerLv = DataCenter.roleData.level;
	local taskFinish = DataCenter.taskData.taskFinish;
	local profLv = DataCenter.roleData.profession;
	local bThrowEvent = false;
	local trailerId =  self.smallestTrailerId 
	local open_sort = self.smallestSort;
	local needShowOpenTips = false;
	local isInLitmitScene = Lua_FuncOpenData.isInLimitScene();
	local openIds = Array();
	local openIcons = Array();
	for k, v in pairs(cfg) do
		local canShow = true;
		if self.openedIds:indexOf(k) == -1 then
			if v.cond_level ~= nil and v.cond_level > playerLv then
				canShow = false;
			elseif v.cond_task ~= nil and taskFinish:indexOf(v.cond_task) == -1 then
				canShow = false;
			elseif v.prof_level ~= nil and v.prof_level > profLv then
				canShow = false;
			end

			-- 时空战场新老服特殊区分处理
			if tonumber(k) == 10139 and tonumber(self.isPanGuNew) == 1 and tonumber(self.panguShow) ~= 2 and canShow then
				canShow = false;
			end

			if canShow == true then
				local fund = Lua_FuncItemData.new(k);
				self.openedList:add(fund);
				self.openedIds:add(k);
				openIds:add(k);
				bThrowEvent = true;

				-- 更新图标功能开启状态
				if fund.iconId ~= nil then
					openIcons:add(fund.iconId);
					local iconData = DataCenter.menuIconData.menuIconDic[tonumber(fund.iconId)];
					if iconData == nil then
						iconData = DataCenter.allRtData.topRightIconDic[tonumber(fund.iconId)];
						if iconData ~= nil then
							-- 刚开启的右上角图标
							if self.initChecked and iconData.bFunOpenState == false and iconData.config.icon_float == 1 then
								DataCenter.allRtData.openningRightIconId = fund.iconId;
								if iconData.config.client_show == 0 then
									-- 刚开启的功能飘向已开启的右上角图标
									local sizeStr = LuaUtil.getUIItemSize(iconData.config.float_target_path);
									local arr = string.split(sizeStr, "|");
									DataCenter.allRtData.curFloatTargetPosX = tonumber(arr[3]);
									DataCenter.allRtData.curFloatTargetPosY = tonumber(arr[4]);
								end
							end

							if self.initChecked == true and v.guide_id ~= nil then
								self:setNeedGuideId(v.guide_id);
							end
						end
					else
						if self.initChecked == true and v.guide_id ~= nil then
							self:setNeedGuideId(v.guide_id);
						end
					end

					if iconData ~= nil then
						iconData:setFunOpenState(true);
					end
				else
					if self.initChecked == true and v.guide_id ~= nil then
						self:setNeedGuideId(v.guide_id);
					end
				end

				if v.open_sort ~= nil and v.open_sort > open_sort then
					trailerId = tonumber(k);
					open_sort = v.open_sort;
				end

				if dispatchEvent == true and self.initChecked == true then
					if v.open_interface == 1 then
						needShowOpenTips = true;
						Lua_WindowUtil.openWin("Lua_FuncOpenTipsPanel", WinParam.ACTION_OPEN, v);
					elseif v.open_interface == 2 and getShowTips() then
						needShowOpenTips = true;
						Lua_WindowUtil.openWin("Lua_FuncOpenModelPanel", WinParam.ACTION_OPEN, {id = k, param = v});
					end

					if needShowOpenTips == true then
						self:delayCloseTips();
					end

					-- 林天山：弹出功能开启提示框时，人物需要停止移动，关闭提示界面后继续执行主线任务（2018.3.15策划需求）
					if (v.open_interface == 1 or v.open_interface == 2) and isInLitmitScene == false then
						DataCenter.hook:stop(true);
						local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
						if rolePlayer ~= nil then
							rolePlayer:stopMove(true,true);
						end
						Lua_ProxyManager.getProxy("Lua_TaskProxy"):clearDelayExcuTask();
					end
				end
			end
		end
	end

	if dispatchEvent == true and bThrowEvent == true then
		Lua_MsgUtil.callFunc("FUNCTION_OPEN", openIds);
		-- 是否要触发指引
		if needShowOpenTips == false then
			DataCenter.guideData:doShowGuideWin();
		end
		if openIcons:getSize() > 0 then
			self:checkShowLockIcon(openIcons[1]);
		end
	end

	if open_sort ~= nil then
		local haveNext = false;
		local taskFinish = DataCenter.taskData.taskFinish;
		for k,v in pairs(cfg) do
			if v.open_sort == open_sort + 1 then
				trailerId = tonumber(k);
				if v.trailer == 1 then -- 1需要显示预告，0不需要显示预告
					haveNext = true;
				else
					if (v.cond_level ~= nil and v.cond_level > playerLv)
						or (v.cond_task ~= nil and taskFinish:indexOf(v.cond_task) == -1)
						or (v.prof_level ~= nil and v.prof_level > profLv) then
						haveNext = true;
					end
				end
				break;
			end
		end
		self.smallestSort = open_sort;

		if haveNext == true then
			Lua_MsgUtil.callFunc("SHOW_HIDE_TRAILER", trailerId);
		else
			Lua_MsgUtil.callFunc("SHOW_HIDE_TRAILER", 0);
		end
	end
end

function Lua_FuncOpenData:setNeedGuideId(val)
	if self:isInForbiddenGuideScene() == true then
		return;
	end
	DataCenter.guideData.needGuideId = val;
end

function Lua_FuncOpenData:delayCloseTips()
	if Lua_FuncOpenData.isInLimitScene() == true then
		Lua_CommonUtil.removeTimer(self, self.closeFuncOpenTips);
		Lua_CommonUtil.addTimer("closeFuncOpenTips", 3, self, self.closeFuncOpenTips, nil, 1);
	end
end

function Lua_FuncOpenData:closeFuncOpenTips()
	if Lua_WindowUtil.isWindowShowing("Lua_FuncOpenTipsPanel") then
		Lua_MsgUtil.callFunc("CLOSE_FUNC_OPEN_TIPS");
		-- Lua_WindowUtil.openWin("Lua_FuncOpenTipsPanel", WinParam.ACTION_CLOSE);
	elseif Lua_WindowUtil.isWindowShowing("Lua_FuncOpenModelPanel") then
	
		Lua_MsgUtil.callFunc("CLOSE_FUNC_OPEN_MODEL");
		-- Lua_WindowUtil.openWin("Lua_FuncOpenModelPanel", WinParam.ACTION_CLOSE);
	end
end

function Lua_FuncOpenData.isInLimitScene()	
	if getConfig({"common", "open_limit_scenes"}) == nil then
		return false;
	end

	-- 是否在指引限制地图里面，指引限制地图里面弹开启提示时不限制玩家移动打怪，并3秒后自动关闭开启弹窗提示
	local curSceneId = DataCenter.roleData.sceneId;
	local cfg = Lua_CommonUtil.getCommonConfig("open_limit_scenes",3)
	for i = 1, #cfg do
		if tostring(cfg[i]) == tostring(curSceneId) then
			return true;
		end
	end
	return false;
end

function Lua_FuncOpenData:isInForbiddenGuideScene()	
	if getConfig({"common", "forbidden_guide_scenes"}) == nil then
		return false;
	end

	local curSceneId = DataCenter.roleData.sceneId;
	-- 是否在禁止指引地图里面，
	local cfg = Lua_CommonUtil.getCommonConfig("forbidden_guide_scenes",3)
	for i = 1, #cfg do
		if tostring(cfg[i]) == tostring(curSceneId) then
			return true;
		end
	end
	return false;
end

function Lua_FuncOpenData:isInForbiddenLevelGuideScene()
	if getConfig({"common", "forbidden_level_guide_scenes"}) == nil then
		return false;
	end

	local curSceneId = DataCenter.roleData.sceneId;
	-- 是否在禁止指引地图里面，
	local cfg = Lua_CommonUtil.getCommonConfig("forbidden_level_guide_scenes", 3)
	for i = 1, #cfg do
		if tostring(cfg[i]) == tostring(curSceneId) then
			return true;
		end
	end
	return false;
end

function Lua_FuncOpenData:checkShowLockIcon(iconId)
	for k,v in pairs(self.iconDataList) do
		if k == tostring(iconId) and v.show_lock_lv ~= nil then
			for i,j in ipairs(v.show_lock_lv) do
				if DataCenter.roleData.level == j then
					Lua_MsgUtil.callFunc("SHOW_LOCK_ICON_EFFECT",iconId);
					break;
				end
			end
			break;
		end
	end
end

function Lua_FuncOpenData:checkAllIconLock()
	for k,v in pairs(self.iconDataList) do
		if v.show_lock_lv ~= nil then
			for i,j in ipairs(v.show_lock_lv) do
				if DataCenter.roleData.level == j then
					Lua_MsgUtil.callFunc("SHOW_LOCK_ICON_EFFECT", tostring(k));
				end
			end
		end
	end
end

function Lua_FuncOpenData.Get:iconDataList()
	if self._iconDataList == nil then
		self._iconDataList = {};
		
		local topRightIcon = getConfig({"topRightIcon"});
		if topRightIcon ~= nil then
			for i, titem in pairs(topRightIcon) do
				self._iconDataList[tostring(i)] = titem;
			end
		end
	end
	return self._iconDataList;
end