Lua_MenuIconData = class("Lua_MenuIconData");
function Lua_MenuIconData:ctor(iconid, config)
	self.config = config;
	self.iconId = iconid;
	self.redDotShowClientState = false;
	self.bFunOpenState = false;
end

function Lua_MenuIconData:resetInfo()
	self.redDotShowClientState = false;
	self.bFunOpenState = false;
	self.showState = nil;
end

function Lua_MenuIconData.Set:iconId(iconid)
	self.id = tonumber(iconid);
	if self.config == nil then
		self.config = getConfig({"topRightIcon", self.id});
	end
end

function Lua_MenuIconData.Get:canShow()
	if self.showState ~= nil and self.showState == false then
		return false;
	end

	-- 功能开启
	if self.bFunOpenState == false then
		return false;
	end

	if self:checkSceneFix() == false then
		return false;
	end

	if self.icon_switch ~= nil and DataCenter.roleData:checkGameSwich(self.icon_switch) ~= 1 then
		return false;
	end
	return true;
end

function Lua_MenuIconData:checkSceneFix()
	local sceneId = DataCenter.roleData.sceneId;
	local len = self.blackList:getSize();
	if len ~= 0 then
		for i = 1, len do
			if self.blackList[i] == sceneId then
				return false;
			end
		end
		return true;
	end

	len = self.whiteList:getSize();
	if len ~= 0 then
		for i = 1, len do
			if self.whiteList[i] == sceneId then
				return true;
			end
		end
		return false;
	end

	return true;
end

function Lua_MenuIconData:setState(val)
	self.showState = val;
end

function Lua_MenuIconData:setFunOpenState(val)
	self.bFunOpenState = val;
end

function Lua_MenuIconData.Get:icon_switch()
	return self.config.icon_switch;
end

-- 红点状态
function Lua_MenuIconData:setRedDotShowState(val)
	val = val == nil and false or val;
	self.redDotShowClientState = val;
end

-- 获取图标红点显示状态
function Lua_MenuIconData.Get:redDotShowState()
	-- 客户端控制和服务端控制同时支持红点显示
	if self.redDotShowClientState then
		return self.redDotShowClientState;
	end
	return DataCenter.redDotData:getIconShowRedDotState(self.id)
end

function Lua_MenuIconData.Get:iconAtlas()
	if self.config.icon_atlas == nil then
		return "righttop";
	end
	return self.config.icon_atlas;
end

function Lua_MenuIconData.Get:icon()
	return self.config.icon;
end

function Lua_MenuIconData.Get:param()
	return self.config.param;
end

function Lua_MenuIconData.Get:fun_str()
	return self.config.fun_str;
end

function Lua_MenuIconData.Get:show_effect()
	return self.config.show_effect;
end

function Lua_MenuIconData.Get:lv()
	return self.config.lv;
end

function Lua_MenuIconData.Get:type()
	return self.config.type;
end

function Lua_MenuIconData.Get:sort_index()
	if self.config.sort_index == nil then
		return 0;
	end
	return self.config.sort_index;
end

function Lua_MenuIconData.Get:isNested()
    return self.config.is_nested;
end

function Lua_MenuIconData.Get:blackList()
	if self._blackList == nil then
        self._blackList = Array();
        local bk = self.config.black_maps;
        if bk ~= nil then
            for i,v in ipairs(bk) do
            	self._blackList:add(tonumber(v));
            end
        end
    end
    return self._blackList;
end

function Lua_MenuIconData.Get:whiteList()
	if self._whiteList == nil then
        self._whiteList = Array();
        local bk = self.config.white_maps;
        if bk ~= nil then
            for i,v in ipairs(bk) do
            	self._whiteList:add(tonumber(v));
            end
        end
    end
    return self._whiteList;
end

function Lua_MenuIconData.Get:iconFloat()
	return self.config.icon_float;
end

function Lua_MenuIconData.Get:floatTargetPath()
	return self.config.float_target_path;
end

function Lua_MenuIconData.Get:effect_url()
	return self.config.effect_url;
end
function Lua_MenuIconData.Get:show_lock_lv()
	return self.config.show_lock_lv;
end