checkRequire("Lua_MenuTipData");
checkRequire("Lua_MenuTipItem");
Lua_MenuTipContainer = class("Lua_MenuTipContainer", Lua_DisplayObject);
function Lua_MenuTipContainer:buildShowItem()
	self:superCall("buildShowItem");

	self.list = Array();

	self:addLuaEvent("SCENE_LOADED", self, self.updateListPos);
end

function Lua_MenuTipContainer:addData(data)
	for i = 1, self.list:getSize() do
		if self.list[i].data.type == data.type then
			return;
		end
	end

	local item = Lua_MenuTipItem.new(self.content);
	item:setData(data);
	self.list:add(item);
	self:updateListPos();
end

function Lua_MenuTipContainer:removeData(data)
	local change = false;
	for i = 1, self.list:getSize() do
		if self.list[i].data.type == data.type then
			self.list[i]:dispose();
			self.list:remove(i);
			change = true;
			break;
		end
	end

	if change then
		self:updateListPos();
	end
end

function Lua_MenuTipContainer:updateListPos()
	local tempList = Array();
	local isMysterious = false;
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	for i = 1, self.list:getSize() do
		if self.list[i].data.kuafuHide == nil or sceneData.show_server_name == 0 then
			self.list[i]:setEnable(true);
			if self.list[i].data.type == Lua_MenuTipData.MYSTERIOUS_ICON then
				self.list[i]:setLocation(-12, 0, 0);
				isMysterious = true;
			else
				tempList:add(self.list[i]);
			end
		else
			self.list[i]:setEnable(false);
		end
	end

	for i = 1,tempList:getSize() do
		if isMysterious == true then
			tempList[i]:setLocation((i - 1) * 60 + 48, 0, 0);
		else
			tempList[i]:setLocation((i - 1) * 60, 0, 0);
		end
	end
end