﻿Lua_MenuTipItem = class("Lua_MenuTipItem", Lua_DisplayObject);
function Lua_MenuTipItem:buildShowItem()
	self:superCall("buildShowItem");

	self.iconBg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_title_04", 0, 0, 50, 52);
	self.iconBg.name = "iconBg";
	self.iconBg:setDepth(1);
	self.iconBg:addClickFuntion(self, self.onIconClick)

	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 45, 45);
	self.icon.name = "icon";
	self.icon:setDepth(2);
	self.icon:addLoadCompleteFun(self, self.onIconLoadComplete);
end

function Lua_MenuTipItem:setData(data)
	self.data = data;

	self.icon:setAltas(self.data.altas, self.data.spriteName);
	self.icon:resetSize();

	-- 2022/8/9 策划要求，不需要显示特效
	-- if self.data.openAct ~= nil or self.data.type == Lua_MenuTipData.TIME_ACTIVITY_ICON
	-- 	or self.data.type == Lua_MenuTipData.MYSTERIOUS_ICON
	-- 	or self.data.type == Lua_MenuTipData.KUAFU_TEAM_APPALY then
	-- 	if self.effect == nil then
	-- 		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/activity_circle", "activity_circle", 0, 0);
	-- 		self.effect:setScale(0.65, 0.65, 1);
	-- 		self.effect:SetRenderQueue(self.icon, 2, UIEffect.NormalSort);
	-- 	end
	-- else
	-- 	if self.effect ~= nil then
	-- 		self.effect:dispose();
	-- 		self.effect = nil;
	-- 	end
	-- end
end

function Lua_MenuTipItem:onIconLoadComplete()
	self.icon:resetSize();
end

function Lua_MenuTipItem:onIconClick(go)
	if self.data.type == Lua_MenuTipData.FREIND then
		Lua_WindowUtil.openWin("Lua_FriendRequestWindow", WinParam.ACTION_OPEN, nil);
	elseif self.data.type == Lua_MenuTipData.TEAM_INVITE then
		self:onInviteTeamClick();
	elseif self.data.type == Lua_MenuTipData.UNION_INVITE then
		self:onInviteUnionClick();
	elseif self.data.type == Lua_MenuTipData.KUAFU_TEAM_InVITED then
		self:onKuaFuiconClick();
	elseif self.data.type == Lua_MenuTipData.KUAFU_TEAM_APPALY then
		self:onKuaFuiconAppalyClick();
	elseif self.data.type == Lua_MenuTipData.MAIL_ICON then
		self:onMailIconClick();
	elseif self.data.type == Lua_MenuTipData.OUT_LINE_TIP then
		self:onOutLineTip();
	elseif self.data.type == Lua_MenuTipData.PROBATION_FAIRY then
		Lua_WindowUtil.openWin("Lua_ProbationFairyPurchaseWindow", WinParam.ACTION_OPEN, self.data.fairyInfo);
	elseif self.data.type == Lua_MenuTipData.MYSTERIOUS_ICON then
			-- if self.effect ~= nil then
			-- 	self.effect:dispose();
			-- 	self.effect = nil;
			-- end
			Lua_WindowUtil.openWin("Lua_MysteriousBuyWindow", WinParam.ACTION_OPEN, self.data.act_index);
	elseif self.data.type == Lua_MenuTipData.WING_TIP then
		Lua_WindowUtil.openWin("Lua_TimeLimitWingWindow", WinParam.ACTION_OPEN, nil);
	elseif self.data.type == Lua_MenuTipData.CAR_ICON then
		Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):moveToNpc(2);
	elseif self.data.type == Lua_MenuTipData.TIME_ACTIVITY_ICON then
		local tActVo = DataCenter.xianshiData:getDataById(self.data.openAct);
		if tActVo.fun_str == "Lua_YunBiaoWindow" then
			Lua_WindowUtil.openWin("Lua_ActiveTipWindow", nil, self.data.openAct);
		elseif tActVo.fun_str ~= nil and tActVo.fun_str ~= "" then
			Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_OPEN, 2);
			Lua_WindowUtil.openWin(tActVo.fun_str);
		end
		-- Lua_WindowUtil.openWin("Lua_TimelimitActivityTips",WinParam.ACTION_OPEN,self.data.openAct);
	elseif self.data.type == Lua_MenuTipData.MARRYINFO_ICON then
		Lua_WindowUtil.openWin("Lua_MarryInfoWindow", WinParam.ACTION_OPEN, nil);
	elseif self.data.type == Lua_MenuTipData.MARRYYQ_ICON then
		if DataCenter.marryData.weddingArr:getSize() == 1 then
			Lua_WindowUtil.openWin("Lua_YaoQingHanWindow", WinParam.ACTION_OPEN, DataCenter.marryData.weddingArr[1]);
		else
			Lua_WindowUtil.openWin("Lua_MarryYaoQingWindow", WinParam.ACTION_OPEN, nil);
		end
	elseif self.data.type == Lua_MenuTipData.BUY_LOVE_GIFT then
		self:onBuyLoveGift();
	elseif self.data.type == Lua_MenuTipData.ACT_PEAK_AUCTION then -- 巅峰竞拍
		self:onAuctionBidTips(self.data.data);
	else
		if self.data.openAct ~= nil then--活动的
			local tActVo = DataCenter.xianshiData:getDataById(self.data.openAct);
			if tActVo.fun_str == "Lua_YunBiaoWindow" then
				if DataCenter.yunBiaoData.escortTimes == 0 then
					OperateAlert.show(LanUtil.getValue(122110));
					return;
				end
				Lua_WindowUtil.openWin("Lua_ActiveTipWindow", nil, self.data.openAct);
			elseif tActVo.fun_str ~= nil and tActVo.fun_str ~= "" then
				-- Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_OPEN, 2);
				Lua_WindowUtil.openWin(tActVo.fun_str);
			end
		end
	end
end

function Lua_MenuTipItem:onOutLineTip()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(110232), type = 1, subFun = self.onOpenHangUp});
	Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.OUT_LINE_TIP, state = 0});
end

function Lua_MenuTipItem:onOpenHangUp()
	Lua_WindowUtil.openWin("Lua_SettingsWindow", nil);
end

function Lua_MenuTipItem:onInviteTeamClick()
	if DataCenter.teamData.hasTeam then
		Lua_WindowUtil.openWin("Lua_TeamJointListWindow");
	else
		Lua_WindowUtil.openWin("Lua_TeamRecieveWindow");
	end
end

function Lua_MenuTipItem:onKuaFuiconClick()
	-- if DataCenter.teamData.hasTeam then
		Lua_WindowUtil.openWin("Lua_TeamApplyWindow", nil, false);
	-- else
	-- 	Lua_WindowUtil.openWin("Lua_TeamApplyWindow");
	-- end
end

function Lua_MenuTipItem:onKuaFuiconAppalyClick()
	-- if DataCenter.teamData.hasTeam then
		sendMsg(11405508);
		Lua_WindowUtil.openWin("Lua_KuaFuTeamJointListWindow");
	-- else
	-- 	Lua_WindowUtil.openWin("Lua_TeamApplyWindow");
	-- end
end

-- 打开邀请入盟界面
function Lua_MenuTipItem:onInviteUnionClick()
	self.invitedUnionPlayer = DataCenter.friendData:getInvitedUnionList()
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(120121),
		string.format("[ff0000]%s[-]", self.invitedUnionPlayer[1].inviter_name),
		string.format("[ff0000]%s[-]", self.invitedUnionPlayer[1].league_name));
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.agreeUnion; -- 确定
	tipData.cancelFun = self.noAgreeUnion; -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

-- 同意加入帮派
function Lua_MenuTipItem:agreeUnion(tipData)
	local msg = getProtoMsg("Proto10100604");
	msg.apply_set:append(self.invitedUnionPlayer[1].league_index);
	sendMsg(10100604, msg);
	DataCenter.friendData:clearInvitedUnionList();
	Lua_MsgUtil.callFunc("UPDATE_INVITE_UNION_TIPS");
end

-- 拒绝加入帮派
function Lua_MenuTipItem:noAgreeUnion(tipData)
	local msg = getProtoMsg("Proto10100638");
	msg.league_index = self.invitedUnionPlayer[1].league_index;
	sendMsg(10100638, msg);
	DataCenter.friendData:removeFristUnionInvitedInfo();
	Lua_MsgUtil.callFunc("UPDATE_INVITE_UNION_TIPS");
end

function Lua_MenuTipItem:onMailIconClick(go)
	local len = DataCenter.mailData.mailInfoArr:getSize();
	local arr = Array();
	for i = 1, len do
		if DataCenter.mailData.mailInfoArr[i].has_read == 0 or DataCenter.mailData.mailInfoArr[i].has_attach == 1 then
			arr:add(DataCenter.mailData.mailInfoArr[i].mail_id);
		end
	end
	Lua_WindowUtil.openWin("Lua_MailBoxWindow", WinParam.ACTION_OPEN, 3)
end

-- 购买爱情礼盒
function Lua_MenuTipItem:onBuyLoveGift()
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(124139), DataCenter.marryData.req_name,
		tostring(DataCenter.marryData.loveGiftGold));
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.agreeBuyLoveGift; -- 确定
	tipData.cancelFun = self.noAgreeBuyLoveGift; -- 取消
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

-- 同意购买爱情礼盒
function Lua_MenuTipItem:agreeBuyLoveGift(tipData)
	-- 检查元宝是否足够
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD,DataCenter.marryData.loveGiftGold,false,true) == false then 
		return;
	end

	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = 1;
	sendMsg(10101413, cmd);
end

-- 拒绝购买爱情礼盒
function Lua_MenuTipItem:noAgreeBuyLoveGift(tipData)
	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = 3;
	sendMsg(10101413, cmd);
end

function Lua_MenuTipItem:onAuctionBidTips(data)
	Lua_WindowUtil.openWin("Lua_AuctionBidTipsWindow", WinParam.ACTION_OPEN, data);
	Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.ACT_PEAK_AUCTION, state = 0});
end