-- 升级提示
Lua_RoleLevelUpTips = class("Lua_RoleLevelUpTips", Lua_Window);
function Lua_RoleLevelUpTips:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RoleLevelUpTips";
	self.isModel = false;
	self.showClose = false;
end

function Lua_RoleLevelUpTips:buildShowItem()
	self:superCall("buildShowItem");

	self:showModel();

	-- self.roleLvUpEffect = UICreate.createUIEffect(self.content, "/effects/fight/gui_levelup", "gui_levelup", 1.5, -235);
	-- self.roleLvUpEffect.circulate = true;
	-- self.roleLvUpEffect:setDepth(5);

	self.lvNum = Lua_NumberImage.new(self.content);
	self.lvNum.pivot = 2;
	self.lvNum.numWidth = 29;
	self.lvNum.prefix = "ui_role_level_";
	self.lvNum:setDepth(10);
	self.lvNum:setLocation(1.5, 165, -1000);
end

function Lua_RoleLevelUpTips:showWin(param)
	self:showModel();

	-- self.roleLvUpEffect:setEnable(true);
	-- local renderObj = self.lvNum:getRenderObj();
	-- self.roleLvUpEffect:SetRenderQueue(renderObj, -4, 2, false);
	self.lvNum:setEnable(true);
	self.lvNum.num = DataCenter.roleData.level;

	self:addTimer("hideLevelUpEffect", 2, self, self.hideEffect);
	self:addTimer("destroyLevelUpEffect", 600, self, self.hide);
end

function Lua_RoleLevelUpTips:showModel()
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	self.modelTexture = UIModelTexture();
	self.modelTexture:init(self.content, Vector2(0, 0), Vector2(1280, 720), 0, Vector3(0, 0, 0), Vector2(1.5, -85), 1);
	self.modelTexture:setCamView(8);
	self.modelTexture:setCamPos(-6000, 0, 0);
	self.modelTexture:setUrl("/effects/fight/gui_levelup", "gui_levelup");
end

function Lua_RoleLevelUpTips:hideEffect()
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	-- self.roleLvUpEffect:setEnable(false);
	self.lvNum:setEnable(false);
	Lua_CommonUtil.removeTimer(self, self.hideEffect);
end

function Lua_RoleLevelUpTips:dispose()
	-- if self.roleLvUpEffect ~= nil then
	-- 	self.roleLvUpEffect:dispose();
	-- 	self.roleLvUpEffect = nil;
	-- end
	if self.lvNum ~= nil then
		self.lvNum:dispose();
		self.lvNum = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.destroyLevelUpEffect);

	self:superCall("dispose");
end