Lua_MinMapPanel = class("Lua_MinMapPanel", Lua_DisplayObject);
function Lua_MinMapPanel:ctor(p)
	self.mapW = 20000;
	self.mapH = 20000;
	self.mapOffsetX = 0 ;
	self.mapOffsetY = 0 ;
	self.lastClickTime = 0;
    self:superCall("ctor", p, "MinMapPanel_skin", true);
	
end
function Lua_MinMapPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.content.name = "Lua_MinMapPanel";
   

	--[[self.mapContainer = UICreate.createGameObject(self.content,-77,-94);
	self.uiPanel = self.mapContainer:AddComponent(typeof(UIPanel));
	self.uiPanel.cullWhileDragging = false;
    self.uiPanel.softBorderPadding = false;    
    self.uiPanel.clipSoftness = Vector2(0, 0);
    self.uiPanel.clipOffset = Vector2(0, 0);
    self.uiPanel.anchorOffset = false;
    self.uiPanel.widgetsAreStatic = false;
    self.uiPanel.baseClipRegion = Vector4(0,0,156,120);
    self.uiPanel.clipping = UIDrawCall.Clipping.SoftClip;--]]
    self.titleBg:addClickFuntion(self, self.onTitleBgClick);
    self.mapBg:addClickFuntion(self, self.onMapBgClick);
    self.mapBg.clickScale = false;
    self.titleBg.clickScale = false;
	self.uvRect = Vector4(0,0,1,1);
	self.mapMinImg = UICreate.createImage(self.content,"",-82,-52,0,0);
    self:addLuaEvent("SCENE_CHANGE", self, self.onSceneChange);
    self:addLuaEvent("ON_LINE_INFO", self, self.onMapNameChange);
	
	self.ownPoint = UICreate.createUIAtlasImage(self.content,  "mainWindow_atlas", "ui_zhujiemian_icon_06", -82, -52, 0, 0);
	self.ownPoint:setDepth(7);
	self:onSceneChange(nil);
	self:addTimer("setMiniMapUV", 0.07, self, self.onEnterFrame);
	
end

function Lua_MinMapPanel:onMapBgClick(go)
	Lua_WindowUtil.openWin("Lua_MapWindow", WinParam.ACTION_AUTO, nil);
end

function Lua_MinMapPanel:onTitleBgClick(go)
	self.lastClickTime = getTime();
    sendMsg(10400123);--分線信息
end
function Lua_MinMapPanel:showDragDownPanel()
	local dragData = {};
	dragData.datas = Array();

	local rd = DataCenter.roleData;
	for i=1,rd.allLines:getSize() do
		dragData.datas:add(LanUtil.formateStr(LanUtil.getValue(110642),tostring(rd.allLines[i])));
	end
	dragData.width = 140;
	dragData.height = 113;
	dragData.itemWidth = 115;
	dragData.rowSpacing = 37;
	dragData.offsetX = MainWinDefine.V_width / 2 - 80;
	dragData.offsetY = MainWinDefine.V_height / 2 - 80;
	dragData.fontSize = 24;
	dragData.bgAltas = "common_atlas_1"; 
	dragData.bgSprite = "ui_common_widget_001";
	dragData.itemBgAltas = "common_atlas_1"; 
	dragData.itemNotSelectSprite = "ui_common_btn_p9";
	dragData.itemSelectSprite = "ui_common_btn_p8";
	dragData.callBackOwner = self;
	dragData.callBack = self.onLineSelected;
	dragData.selected = 1;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_MinMapPanel:onLineSelected(val)
	local rd = DataCenter.roleData;
	local targetLine = rd.allLines[val];
	if targetLine == nil then
		return;
	end
	if targetLine == rd.curLine then
		local str = LanUtil.formateStr(LanUtil.getValue(110644),tostring(targetLine))
		OperateAlert.show(str);
		return;
	end
	MsgUtil.callFunc("PLAYER_STOP");
	local cmd = ProtoPublic_pb.Proto10400120();
    cmd.lines = targetLine;
    sendMsg(10400120,cmd);
end

function Lua_MinMapPanel:onEnterFrame()
	if self.mapScaleX == nil or self.mapScaleY == nil then
		return;
	end
    --[[local tx = math.floor(PlayerData.getInstance().data.px/100);
    local ty = math.floor(PlayerData.getInstance().data.py/100);
	local tz = math.floor(PlayerData.getInstance().data.pz/100);--]]

	local px = (PlayerData.getInstance().data.px) / self.mapW;
	local pz = (PlayerData.getInstance().data.pz) / self.mapH;
	
	
--	self.uvRect:Set(px-0.08,pz-0.08,0.16,0.16);
	self.uvRect:Set(px-self.mapOffsetX,pz-self.mapOffsetY,self.mapScaleY,self.mapScaleX);
	self.mapMinImg:setUVRect(self.uvRect);
	if DataCenter.roleData ~= nil then
		-- self.ownPoint.mainContent.transform.localRotation = Quaternion.Euler(0, 0, PlayerData.getInstance().data.dir - 90);
		LuaUtil.setObjRot(self.ownPoint.mainContent, 0, 0, PlayerData.getInstance().data.dir - 90);
	end
--    self.myPosTxt.text = "("..tostring(tx)..","..tostring(ty)..","..tostring(tz)..")";
--    self.nowTimeTxt.text = tostring(GlobalVar.cur_tick);
end
function Lua_MinMapPanel:onSceneChange(obj)
	self.mapMinImg:SetDimensions(160, 50);
--	local cData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
   
    if DataCenter.roleData ~= nil then
--		self.ownPoint.mainContent.transform.localRotation = Quaternion.Euler(0, 0, DataCenter.roleData.dir - 90);
        local cData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if  cData.config==nil or cData.config.size == nil then 
			return;
		end
        self:onMapNameChange();

		if cData.config.map_size ~= nil then
			self.mapW = cData.config.map_size[1];
			self.mapH = cData.config.map_size[2];
		else
			self.mapW = cData.config.size[1];
			self.mapH = cData.config.size[2];
		end

		if cData.config.min_map_scale ~= nil then
			self.mapScaleX = cData.config.min_map_scale[1];
			self.mapScaleY = cData.config.min_map_scale[2];
		else
			self.mapScaleX = 0.16;
			self.mapScaleY = 0.12;
		end
		if cData.config.min_map_offset ~= nil then
			self.mapOffsetX = cData.config.min_map_offset[1];
			self.mapOffsetY = cData.config.min_map_offset[2];
			--[[print("self.mapOffsetX "..tostring(self.mapOffsetX));
			print("self.mapOffsetY "..tostring(self.mapOffsetY));--]]
		else
			self.mapOffsetX=0;
			self.mapOffsetY=0;
		end
		--[[self.mapOffsetX = -4000;
		self.mapOffsetY = -4000;--]]
		if cData.config.res_min ~= nil then
			self.mapMinImg:setUrl("/maps/"..cData.config.res_min);
			--self.mapMinImg:setUrl("/maps/s10101/s10101_s.png");
		end
    end
end
function Lua_MinMapPanel:onMapNameChange(obj)
	local cData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local rd = DataCenter.roleData;
	if rd.curLine == 0 then
		self.titleTxt.text = cData.name;
	else
		self.titleTxt.text = cData.name.."("..LanUtil.formateStr(LanUtil.getValue(110642),tostring(DataCenter.roleData.curLine))..")";
		if getTime() - self.lastClickTime < 0.3 then
			self.lastClickTime = 0;
			self:showDragDownPanel();
		end
	end
end