Lua_MonsterListItem = class("Lua_MonsterListItem", Lua_ListCell);
function Lua_MonsterListItem:ctor(p)
	self:superCall("ctor", p, "MonsterListItem_skin", true);
end

function Lua_MonsterListItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	
	local co = Lua_MonsterConfigData.new(data.id);
	local colorStr = data.colorStr == nil and "[85A8BE]" or data.colorStr;
	self.lvLab.text = colorStr .. "Lv."..co.level.."[-]";
	self.MonsterNameLab.text = "[85A8BE][u]"..co.name.."[/u][-]";

	local width = data.width == nil and 268 or data.width;
	local height = data.height == nil and 57 or data.height;
	self.selectIcon:SetDimensions(width, height);

	self.line:setEnable(data.showState == nil and true or data.showState);
	self.selectIcon:setEnable(data.selected);
end

function Lua_MonsterListItem:onPlayerSoundClick(go)
	DataCenter.hook:stop(true);
	local ac = WorldMapUtil.genArriveActionVo({type = 8, monsterId = Lua_CommonUtil.trnsLongNum(self._data.id), dailytask=0});
	WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self._data.posX, self._data.posY, self._data.posZ, 0, 0, ac, 0);

	Lua_MsgUtil.callFunc("MonsterCopyInfo_CLICK", self._data);
end