checkRequire("Lua_MonsterListItem");
Lua_MonsterListPanel = class("Lua_MonsterListPanel", Lua_DisplayObject);
function Lua_MonsterListPanel:ctor(p)
    self:superCall("ctor", p, "MonsterListPanel_skin", false);
end
function Lua_MonsterListPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self,self.onSwitchClick)

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 255, 206));
    self.dragList:setLocation(0, -144, 0);
    self.dragList:setListCell(Lua_MonsterListItem, 30, 255, 1);
    self.state = 1;
    self:updateMonsterList();
end
function Lua_MonsterListPanel:onSwitchClick(go)
	if self.state == 1 then
		self.state = 2;
	else
		self.state = 1;
	end
	self:updateMonsterList();
end
function Lua_MonsterListPanel:updateMonsterList()
	local arr = Array();
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local monsterList = sceneConfig.config.monster;
	if monsterList ~= nil then
		for i,v in ipairs(monsterList) do
			local co = Lua_MonsterConfigData.new(v.id);
			if self.state == 1 then
				if co.boss == 0 then
					arr:add(v);
				end
			else
				if co.boss == 1 then
					arr:add(v);
				end
			end
		end
	end
	self.dragList:setLuaArrayData(arr);
	Lua_MsgUtil.callFunc("MONSTER_LIST_SWITCH", self.state);
end