checkRequire("Lua_ProccessBar");
checkRequire("Lua_TopLeftDefine");
Lua_PlayerPanel = class("Lua_PlayerPanel", Lua_DisplayObject);
function Lua_PlayerPanel:ctor(p)
    self:superCall("ctor", p, "PlayerPanel_skin", true);
end

function Lua_PlayerPanel:buildShowItem()
	self:superCall("buildShowItem");
	local content = self.content;
	content.name = "Lua_PlayerPanel";

	--[[self.debugBtn = UICreate.createButton(self.content, "debug", 90, -158, 120, 40);
	self.debugBtn:addClickFuntion(self, self.onDebugClick);

	self.debugBtn = UICreate.createButton(self.content, "Entrance", 217, -158, 120, 40);
	self.debugBtn:addClickFuntion(self, self.onEntranceClick);--]]

	self.hpBar:setBarPosOffset(-128, 0);
	self.mpBar:setBarPosOffset(-128, 0);

	self.headIcon:addClickFuntion(self,self.onHeadClick);
	self.pkIcon:addClickFuntion(self, self.onPkStateClick);
--  self.chargeIcon:addClickFuntion(self, self.onChargeClick);
-- 	self.vipIcon:addClickFuntion(self, self.onVipClick);
 	self.buffIcon:addClickFuntion(self, self.onBuffIconClick);

 	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "a_";
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum.numWidth = 16;
	self.fightNum.num = 0;
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(160, -23, 0);

	local effectName = "gui_zhanli_fire";
	self.fightEffect = UICreate.createUIEffect(self.content,"/effects/fight/"..effectName,effectName,138,-23);	
	self.fightEffect:SetRenderQueue(self.fightImg, 2, 2,false);

	local vec = self.headIcon.mainContent.transform.localPosition;
	self.redDotIcon = UICreate.createUIAtlasImage(content, "common_atlas_1", "ui_common_hongdian", vec.x + 26, vec.y + 35, 0, 0);
	self.redDotIcon:setDepth(self.depth + 6);

	self.careerImg = UICreate.createImage(content, "", 65, -112, 0, 0);
	self.careerImg.depth = 7;

	self:setHeadUrl(DataCenter.roleData.career,DataCenter.roleData.profession);

 	self:addLuaEvent("PK_STATE_UPDATE", self, self.onPkStateChange);
 	self:addLuaEvent("ROLE_DATA_CHANGE", self, self.onRoleDataUpdate);
    self:addLuaEvent("USE_VIP_CARD", self, self.useVipCard); --进入游戏时使用v+卡的特殊处理
    self:addLuaEvent("ROLE_HP_UPDATE", self, self.onProperUpdate);
    self:addLuaEvent("ROLE_BUFF_UPDATE", self, self.onBuffUpdate);
    self:addLuaEvent("REFRESH_MENUICON_REDDOT", self, self.onUpdateRedDotState);
	self:addLuaEvent("EXTRACTION_UPDATE",self,self.onChangeJob);
	self:addLuaEvent("UPDATE_MAIN_MENU", self, self.onUpdateMainMenu);

	self:addCSharpEvent("PLAYER_LEVEL_UP", self, self.onCheckBetterEqu);
	self:addLuaEvent("UPCHANGEJOB_UPDATE", self, self.onCheckBetterEqu);
	self:addLuaEvent("ROLE_HEAD_UPDATE", self, self.updateRoleHead);
	
	self.showVipInScene = true;
 	self:onPkStateChange();
 	self:onRoleDataUpdate();
 	self:onUpdateRedDotState(nil);
	self.xzsBtn:addClickFuntion(self,self.onXZSClick);
	--获取vip信息
	DataCenter.vipData:sGetRoleVipInfo();
	--BUG #7729 主界面小助手图标先隐藏掉
	self.xzsBtn:setEnable(false);
	self.xzsBg:setEnable(false);
	
	LuaUtil.updateWindowDepth(nil);
end
function Lua_PlayerPanel:onUpdateMainMenu(obj)
	self.showVipInScene = false;
	if obj ~= nil then
        for i, v in ipairs(obj) do
            if v == Lua_MainMenuWindow.TOPLEFT_ICONS_INDEX then
				self.showVipInScene = true;
				break;
			end
        end
    end
end


function Lua_PlayerPanel:showHideVipExpeTips(time)
	if time > 0 then	
		Lua_MsgUtil.callFunc("TOP_LEFT_SHOW_ICON",Lua_TopLeftDefine.VIP_EXPIRED_TIPS);
		Lua_MsgUtil.callFunc("VIP_EXPERIENCE_TIPS_UPDATE_COUNTDOWN",time);
		
	else
		Lua_MsgUtil.callFunc("TOP_LEFT_HIDE_ICON",Lua_TopLeftDefine.VIP_EXPIRED_TIPS);		
	end
end
--[[function Lua_PlayerPanel:onVipUpgrade(vipType)
	self.vipTxt.text = "VIP"..tostring(vipType);
end--]]
function Lua_PlayerPanel:onChangeJob()
	self:setHeadUrl(DataCenter.roleData.career,DataCenter.changeJobData.profession);
end
function Lua_PlayerPanel:setHeadUrl(career,profession)
	if career ~= 0 then
		self.careerImg:SetDimensions(0,0);
		self.careerImg:setUrl(Lua_ThingDefine.getNameIconUrlByCareer(career,profession));

		if isHeadReplaceOpen() == true then
			self:updateRoleHead();
		else
			self.headIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career,profession));
		end
	end
end
function Lua_PlayerPanel:updateRoleHead()
	local role_head = DataCenter.roleData.getDressHead;
    if role_head ~= nil and role_head ~= "" then
    	local isDefault = DataCenter.roleData:isDefaultHead(DataCenter.roleData.career, role_head);
        if isDefault == true then
        	self.headIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
            -- self.headIcon:setLocation(67, -59, 0);
        else
            self.headIcon:setUrl(role_head, 99, true);
            self.headIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆
	    	-- self.headIcon:setRoundSize(1, 0.5,0.5,0.5);--菱形
	    	-- self.headIcon:setLocation(60.5, -61, 0);
        end
    end
end
function Lua_PlayerPanel:onXZSClick(go)
	--Lua_WindowUtil.openWin("Lua_HelpWindow");
end

function Lua_PlayerPanel:onHeadClick(go)
	Lua_WindowUtil.openWin("Lua_RoleMainWindow");
end

function Lua_PlayerPanel:onPkStateChange(go)
	local rd = DataCenter.roleData;
	if rd.pkState == Lua_ThingDefine.PK_STATE_PEASE then
		self.pkIcon:setAltas("mainWindow_atlas", "ui_zhujiemian_btn_03");
		self.pkTxt.text = LanUtil.getValue(110012);
	elseif rd.pkState == Lua_ThingDefine.PK_STATE_ALL then
		self.pkIcon:setAltas("mainWindow_atlas", "ui_zhujiemian_btn_05");
		self.pkTxt.text = LanUtil.getValue(110014);
	elseif rd.pkState == Lua_ThingDefine.PK_STATE_CAMP then
		self.pkIcon:setAltas("mainWindow_atlas", "ui_zhujiemian_btn_00");
		self.pkTxt.text = LanUtil.getValue(110036);
	else
		self.pkIcon:setAltas("mainWindow_atlas", "ui_zhujiemian_btn_04");
		self.pkTxt.text = LanUtil.getValue(110013);
	end	
end

function Lua_PlayerPanel:callBackFun(val)
	print("chargeClick callback "..tostring(val));
end

function Lua_PlayerPanel:onChargeClick(go)
	Lua_WindowUtil.openWin("Lua_RewardWindow");
end

function Lua_PlayerPanel:onProperUpdate(go)
	local rd = DataCenter.roleData;
	self.hpBar:setMaxValue(rd.maxHp);
    self.hpBar:setValue(rd.hp);
    self.hpBar:setText(Lua_CommonUtil.getNumberTrans(rd.hp).."/"..Lua_CommonUtil.getNumberTrans(rd.maxHp));

    self.mpBar:setMaxValue(rd.maxMp);
    self.mpBar:setValue(rd.mp);
    self.mpBar:setText(Lua_CommonUtil.getNumberTrans(rd.mp).."/"..Lua_CommonUtil.getNumberTrans(rd.maxMp));
	self.lvLabel.text = tostring(rd.level);
--	self:onVipUpgrade(DataCenter.vipData.level);
end

function Lua_PlayerPanel:onRoleDataUpdate()
	self:onProperUpdate();
	self.fightNum.num = DataCenter.roleData.force;
	self.fightNum:setNumScale(0.67, 0.67);
end

function Lua_PlayerPanel:onPkStateClick(go)
	-- 地图限制不能更改pk状态
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneCfg ~= nil and sceneCfg.config.pk_state_locked and sceneCfg.config.pk_state_locked == 1 then
        OperateAlert.show(LanUtil.getValue(100685));
        return;
    end
    
	Lua_WindowUtil.openWin("Lua_PkModeWindow");
end

function Lua_PlayerPanel:onVipClick(go)
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 10097);
end

function Lua_PlayerPanel:onDebugClick(go)
	Lua_WindowUtil.openWin("Lua_DebugWindow");
end

function Lua_PlayerPanel:onEntranceClick(go)
	Lua_WindowUtil.openWin("Lua_AllEntranceWindow");
end

function Lua_PlayerPanel:onBuffUpdate(go)
	local rd = DataCenter.roleData;
	if rd.buffList ~= nil then
		local num = 0;
		for i=1,rd.buffList:getSize() do
			if rd.buffList[i].show_icon == 1 then
				num = num + 1;
			end
		end
		self.buffTxt.text = "BUFFX"..num;
	end
end

function Lua_PlayerPanel:onBuffIconClick(go)
	local rd = DataCenter.roleData;
	if rd.buffList ~= nil and rd.buffList:getSize() > 0 then
		Lua_WindowUtil.openWin("Lua_BuffListWindow");
	end
end

-- 更新红点状态
function Lua_PlayerPanel:onUpdateRedDotState(iconId)
	if iconId == nil then
		iconId = Lua_AllMenuIconData.ROLEICONID;
	end

	if tonumber(iconId) == Lua_AllMenuIconData.ROLEICONID then
		local iconData = DataCenter.menuIconData.menuIconDic[iconId];
		if iconData ~= nil then
			self.redDotIcon:setEnable(iconData.redDotShowState);
		else
			self.redDotIcon:setEnable(false);
		end
	end
end

-- 升级和转职的时候检测更好的装备
function Lua_PlayerPanel:onCheckBetterEqu(o)
	Lua_ProxyManager.getProxy("Lua_PackProxy"):checkBetterEqu(true);
end

function Lua_PlayerPanel:useVipCard()
    if Lua_VipUseExperienceCardWindow==nil then
        Lua_CommonUtil.addTimer("vipCardTimer", 4, self, self.openVipUseExperienceCardWindow);    
   end
end

function Lua_PlayerPanel:openVipUseExperienceCardWindow()   
    if Lua_VipUseExperienceCardWindow==nil then
        Lua_WindowUtil.openWin("Lua_VipUseExperienceCardWindow", WinParam.ACTION_OPEN);
        Lua_CommonUtil.removeTimer(self, self.openVipUseExperienceCardWindow);
    end
end