Lua_PowerAndWifiPanel = class("Lua_PowerAndWifiPanel",Lua_DisplayObject);
function Lua_PowerAndWifiPanel:ctor(p)
	self:superCall("ctor",p,"PowerAndWifiPanel_skin", true);
	self.lastTime = 0;
end
function Lua_PowerAndWifiPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.content.name = "Lua_PowerAndWifiPanel";

	self.batterBar.type = UIBasicSprite.Type.Filled;
    self.batterBar.fillDirection = UIBasicSprite.FillDirection.Horizontal;

	self.timeNowTxt.text = tostring(GlobalVar.cur_tick);
	self:addTimer("buildShowItem", 1, self, self.onEnterFrame);

	self.carmeraBtn:addClickFuntion(self,self.onCameraBtnClick);
end
function Lua_PowerAndWifiPanel:onEnterFrame()
	self.timeNowTxt.text =  GlobalVar.serverTimeStr;
	if getTime() - self.lastTime > 1.5 then
		self.lastTime = getTime();

		if CommonUtil.isApplePlatform  then
			self.batterBar:setEnable(false);
			self.batterBg:setEnable(false);
		else
			local ts = CommonUtil.getBatteryLevel() / 100;
			if ts >= 1 then
				ts = 1;
			end
			if ts <= 0 then
				ts = 0;
			end
			self.batterBar.fillAmount = ts;

			if GlobalVar.getSocketTime() < 0.3 then
				self.wifiSp:setAltas("mainWindow_atlas", "ui_zhujiemian_icon_07");
			elseif GlobalVar.getSocketTime() < 0.6 then
				self.wifiSp:setAltas("mainWindow_atlas", "ui_zhujiemian_icon_23");
			else
				self.wifiSp:setAltas("mainWindow_atlas", "ui_zhujiemian_icon_24");
			end
		end
	end
	DataCenter.thingData:clearLastSelectedList();
end
function Lua_PowerAndWifiPanel:onCameraBtnClick(go)
	CameraControl.Instance:updateToDefault(true);
end