checkRequire("Lua_MenuIconBaseItem");
Lua_MenuPanel = class("Lua_MenuPanel", Lua_DisplayObject);
function Lua_MenuPanel:ctor(p, owner, redFun)
	self.openedList = Array(); -- 存放已开启图标列表
	self.redDotNum = 0;
	self.owner = owner;
	self.redFun = redFun;
	self.isInited = false;
	self:superCall("ctor", p); -- "MenuPanel_skin"
end

function Lua_MenuPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.iconList = Array();
	self.lastUpdateIconTime = 0;
	self.curFloatIcon = nil;
	self:addListener();	
	self:onFunctionOpen(nil);
end

function Lua_MenuPanel:addListener()
	self:addLuaEvent("FUNCTION_OPEN", self, self.onFunctionOpen); -- 关闭回赠窗口，刷新界面
	self:addLuaEvent("UPDATE_INVITE_UNION_TIPS", self, self.updateInviteUnionTips); -- 刷新邀请入帮tips显示
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateNewTips);
	self:addLuaEvent("INRETRUN_FLOWER_WINDOW", self, self.inRetrunFlowerWindow); -- 打开回赠鲜花窗口
	self:addLuaEvent("UPDATE_RETRUN_FLOWER_WINDOW", self, self.updateRetrunFlowerWindow); -- 关闭回赠窗口，刷新界面
	self:addLuaEvent("REFRESH_MENUICON_REDDOT", self, self.onUpdateIconRedDot); -- 图标红点更新
	self:addLuaEvent("ICON_FLOATING_COMPLETE", self, self.iconFloatingComplete); -- 功能开启时飘入图标动作结束
	self:addLuaEvent("UPDATE_WING_TIPS", self, self.updateWingTips); -- 刷新限时神翼tips显示
	self:addLuaEvent("SHOW_LOCK_ICON_EFFECT", self, self.showLockIconEffect);
	
	self:checkClientReddot();
end

function Lua_MenuPanel:showLockIconEffect(iconId)
	if self.iconList ~= nil then
		for i = 1, self.iconList:getSize() do 
			if self.iconList[i].iconId == tonumber(iconId) then
				self.iconList[i]:showHideLockEffect(true);
				break;
			end
		end
	end
end

function Lua_MenuPanel:checkClientReddot()
	local showHaveFaction = false;
	if DataCenter.roleData.leagueId == 0 then
		showHaveFaction = true;
	end
	-- print("DataCenter.roleData.leagueId", DataCenter.roleData.leagueId, showHaveFaction);
	Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10013, state = showHaveFaction});
end

function Lua_MenuPanel:iconFloatingComplete()
	if self.floatingIcon ~= nil then
		self.floatingIcon:setEnable(true);
		self.floatingIcon = nil;
		self.curFloatIcon = nil;
	end
	self:setIconPosition();
end

function Lua_MenuPanel:onFunctionOpen(openIds)
	if self.content == nil or DataCenter.menuIconData == nil then
		return;
	end

	if self.isInited == true and openIds ~= nil then
		self.openningIconId = Array();
		for i = 1, openIds:getSize() do
			local cfg = getConfig({"func_open", openIds[i]});
			if cfg ~= nil and cfg.icon_id ~= nil then
				self.openningIconId:add(cfg.icon_id);
			end
			-- print("openIds[i]", openIds[i], cfg.icon_id);
		end
	end
	
	local menuIconDic = DataCenter.menuIconData.menuIconDic;
	local menuIcon;
	local hasAddIcon = false;
	for iconId, iconData in pairs(menuIconDic) do
		if self.openedList:indexOf(iconId) == -1 and iconData.canShow == true and iconData.config.client_show == 1 then
			self.openedList:add(iconId);
			
			menuIcon = Lua_MenuIconBaseItem.new(self.content, nil, nil, iconData);
			menuIcon.content.name = "icon"..iconId;
			if self.openningIconId ~= nil and self.openningIconId:indexOf(iconId) ~= -1 then
				menuIcon:checkShowLockEffect(true);
			else
				menuIcon:checkShowLockEffect();
			end
			self.iconList:add(menuIcon);
			
			if self.isInited == true and iconData.iconFloat == 1 then
				self.curFloatIcon = iconId;
			end

			hasAddIcon = true;
			if iconData.redDotShowState then
				self.redDotNum = self.redDotNum + 1;
				if self.owner ~= nil then
					self.redFun(self.owner);
				end
			end
		end
	end
	self.openningIconId = nil;
	self.iconList:sort("sortIndex", false);

	self:setIconPosition();
	if hasAddIcon == true and self.isInited == false then
		self.isInited = true;
	end
end

-- 红点刷新
function Lua_MenuPanel:onUpdateIconRedDot(iconId)
	if self.iconList ~= nil then
		local len = self.iconList:getSize();
		for i = 1, len do
			local icon = self.iconList[i];
			if icon.iconId == tonumber(iconId) then
				local redState = icon.iconData.redDotShowState;
				if icon.iconData ~= nil and icon.bShowRedDot ~= redState then
					if redState == true then
						self.redDotNum = self.redDotNum + 1;
					else
						self.redDotNum = self.redDotNum - 1;
					end

					if self.owner ~= nil then
						self.redFun(self.owner);
					end
				end
				icon:refreshRedDot();
				return;
			end
		end
	end
end

function Lua_MenuPanel:setEnable(val)
	self:superCall("setEnable",val);
	
	if val == true and self.curFloatIcon == nil then
		-- self.curFloatIcon 不为空的时候说明正在开启图标，这里就不处理位置了。
		local time = 0;
		local curIcon;
		local posx = -144;
		local posy = 483;
		for i = 1, self.iconList:getSize() do
			curIcon = self.iconList[i];
			TweenUtil.getInstance():stop(curIcon.mainContent);

			time = ((i - 1) % 5 == 0 and 0 or time) + 0.08;
			posx = -56 - 88 * math.floor((i - 1) / 5);
			posy = ((i - 1) % 5 == 0 and 483 or posy) - 90;
			if self.floatingIcon == curIcon then
				curIcon:setLocation(posx, posy, 0);
			else
				curIcon:setLocation(posx + 200, posy, 0);
				TweenUtil.getInstance():addTween(curIcon.mainContent, 0.2, time, Vector3(posx, posy, 0), nil, nil);
			end
		end
	end
end

function Lua_MenuPanel:setIconPosition()
	local curIcon;
	local posx = -144;
	local posy = 475;
	for i = 1, self.iconList:getSize() do
		curIcon = self.iconList[i];
		TweenUtil.getInstance():stop(curIcon.mainContent);
		posx = -56 - 88 * math.floor((i - 1) / 5);
		posy = ((i - 1) % 5 == 0 and 475 or posy) - 88;
		-- print("curIcon.iconId", curIcon.iconId, posx, posy);
		curIcon:setLocation(posx, posy, 0);
		-- 需要等待飘入的图标，先隐藏
		if self.curFloatIcon ~= nil
			and tonumber(self.curFloatIcon) == tonumber(curIcon.iconId)
			and curIcon.iconFloat == 1
			and curIcon.floatTargetPath ~= nil
			and DataCenter.funcOpenData.openInCMD ~= true then
			
			curIcon:setEnable(false);
			self.floatingIcon = curIcon;

			local sizeStr = LuaUtil.getUIItemSize(curIcon.floatTargetPath);
			local arr = string.split(sizeStr, "|");
			local px = tonumber(arr[3]);
			local py = tonumber(arr[4]);
			DataCenter.funcOpenData.menuFloatingPos[curIcon.iconId] = {posX = px, posY = py};
			DataCenter.menuIconData.curFloatTargetPosX = px;
			DataCenter.menuIconData.curFloatTargetPosY = py;
		else
			curIcon:setEnable(true);
		end
	end
end

function Lua_MenuPanel:updateInviteUnionTips()
	local invitetList = DataCenter.friendData:getInvitedUnionList()
	if invitetList:getSize() > 0 then
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.UNION_INVITE, state = 1,
			altas = "icon_atlas_5", spriteName = "activity_small_tips_styq"});
	else
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.UNION_INVITE, state = 0});
	end
end

function Lua_MenuPanel:inRetrunFlowerWindow()
	Lua_WindowUtil.openWin("Lua_InReturnSendFlowerWindow", WinParam.ACTION_OPEN)
end

function Lua_MenuPanel:updateRetrunFlowerWindow()
	local inRetrunFlowerList = DataCenter.friendData:getInRetrunFlowerInfo();
	if inRetrunFlowerList:getSize() > 0 then
		Lua_WindowUtil.openWin("Lua_InReturnSendFlowerWindow", WinParam.ACTION_OPEN);
	end
end

function Lua_MenuPanel:updateNewTips(obj)
	if tonumber(obj.evenId) == 10001 then
		if tonumber(obj.val) > 0 then
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.MAIL_ICON, state = 1, openAct = true,
				altas = "mainWindow_atlas", spriteName = "ui_zhujiemian_icon_12"});
		else
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.MAIL_ICON, state = 0});
		end
	end

	if tonumber(obj.evenId) == 10008 then
		if tonumber(obj.val) > 0 then
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.FREIND, state = 1,
				altas = "icon_atlas_5", spriteName = "activity_small_tips_tjhy"});
		else
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.FREIND, state = 0});
		end
	end
end

function Lua_MenuPanel:updateWingTips(val)
	if val == 1 then
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.WING_TIP, state = 1,
			altas = "mainWindow_atlas", spriteName = "ui_zhujiemian_icon_14"});
	else
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.WING_TIP, state = 0});
	end
end

function Lua_MenuPanel:dispose()
	self.owner = nil;
	self.redFun = nil;
	if self.iconList ~= nil then
		for i = 1, self.iconList:getSize() do
			TweenUtil.getInstance():stop(self.iconList[i].mainContent);
			self.iconList[i]:dispose();
		end
		self.iconList:clear();
		self.iconList = nil;
	end

	self:superCall("dispose");
end