-- 场景显示的技能面板
checkRequire("Lua_SkillIconItem");
Lua_SceneSkillPanel = class("Lua_SceneSkillPanel", Lua_DisplayObject);
function Lua_SceneSkillPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.switchTargetBg = UICreate.createUIAtlasImage(self.content, "iconantlas2", "xzs_btn_bg", -326, 46, 0, 0);
	self.switchTargetBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_19", -326, 46, 0, 0);
	self.switchTargetBtn:addClickFuntion(self, self.onSwitchTargetClick);

	self.careerSkillSps = Array();
	self.careerPos = {};
	self.careerPos[1] = {{-55,221}};
	self.careerPos[2] = {{-122,212}, {-200,108}};
	self.careerPos[3] = {{-55,221},{-150,218},{-218,150}};
	self.careerPos[4] = {{-55,221},{-150,218},{-218,150},{-221,55}};

	self:addLuaEvent("SKILL_SHOW", self, self.onSkillShow);
end

function Lua_SceneSkillPanel:setEnable(val)
	self:superCall("setEnable", val);
	if val == true then
		self:setLocation(365, 0, 0);
		TweenUtil.getInstance():addTween(self.content, 0.4, 0, Vector3(0, 0, 0), nil, nil);
	end
end

-- 显示的技能id列表
function Lua_SceneSkillPanel:setShowSkillList(list)
	self.showList = list;
	if list == nil or #list <= 0 then
		self:setEnable(false);
		return;
	end

	local sii;
	local posInfo = self.careerPos[#list];
	local len = self.careerSkillSps:getSize();
	local num = #list - len;
	while (num > 0) do
		sii = Lua_SkillIconItem.new(self.content, false);
		sii:setData(nil);
		sii.showTips = true;
		self.careerSkillSps:add(sii);
		num = num - 1;
	end

	while (num < 0) do
		sii = self.careerSkillSps:shift();
		sii:dispose();
		num = num + 1;
	end

	for i = 1, #list do
		sii = self.careerSkillSps[i];
		sii:setLocation(posInfo[i][1], posInfo[i][2]);
		sii.content.name = "careerSkillSp_"..i;
	end
	self:onSkillShow();
end

function Lua_SceneSkillPanel:onSwitchTargetClick(go)
	DataCenter.thingData:addLastSlectedTarget(DataCenter.hook.selectedId);
	local s = DataCenter.hook:findAnotherTarget();
	c_hookCurMonsterTarget(s, false);
end

function Lua_SceneSkillPanel:onSkillShow(obj)
	if DataCenter.skillData == nil or self.showList == nil then
		return;
	end

	local step = 1;
	local len = #self.showList;
	for i = 1, len do 
		local vo = DataCenter.skillData:getSkillData(self.showList[i]);
		if vo ~= nil and vo:hasLearn() == true then
			local sii = self.careerSkillSps[step];
			if sii ~= nil then
				sii:setData(vo);
			end
			step = step + 1;
		end
	end
	
	len = self.careerSkillSps:getSize();
	for i = step, len do
		self.careerSkillSps[i]:setData(nil);
	end
end

function Lua_SceneSkillPanel:dispose()
	TweenUtil.getInstance():stop(self.content);

	self:superCall("dispose");
end