Lua_SkillIconItem = class("Lua_SkillIconItem", Lua_DisplayObject);
function Lua_SkillIconItem:ctor(p,isBaseSkill)
	self.isBaseSkill = isBaseSkill ;
	self.clickTime = 0;
	self:superCall("ctor",p);
end

function Lua_SkillIconItem:buildShowItem()
	self:superCall("buildShowItem");
	
	if self.isBaseSkill == true then
		self.baseSkillBg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_17", 0, 0, 0, 0);
		self.baseSkillBg.name = "baseSkillBg";
		self.baseSkillBg:setDepth(0);
	end

	self.skillBg =  UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_13", 0, 0, 0, 0);
	self.skillBg.name = "skillBg";
	self.skillBg:setDepth(1);
	
	self.skillImg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.skillImg.name = "skillImg";
	self.skillImg:setDepth(2);
	-- self.skillImg:addLoadCompleteFun(self, self.onLoadCompleteImg);
	self.skillImg:addClickFuntion(self, self.onSkillClick);
	self.skillImg:addMouseUpFuntion(self, self.onMouseUpHandle);

	self.coolMask = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_28", 0, 0, 0, 0);
	self.coolMask.name = "coolMask";
	self.coolMask.type = UIBasicSprite.Type.Filled;
	self.coolMask.fillDirection = UIBasicSprite.FillDirection.Radial360;
	self.coolMask:setDepth(3);
	
	self.cdCirle = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_29", 0, 0, 0, 0);
	self.cdCirle.name = "cdCirle";
	self.cdCirle.type = UIBasicSprite.Type.Filled;
	self.cdCirle.fillDirection = UIBasicSprite.FillDirection.Radial360;
	self.cdCirle:setDepth(4);

	self.coolTxt = UICreate.createLabel(self.content, "0", 0, 0, 50, 30, 24);
	self.coolTxt.name = "coolTxt";
	self.coolTxt.pivot = UIWidget.Pivot.Center;
	self.coolTxt.effectStyle = 2;
	self.coolTxt.effectColorStr = Lua_ColorDefine.transColor("000000");
	self.coolTxt:setEffectDistance(2, 2);
	self.coolTxt:setDepth(5);

	self.pressAct = false;
	self.isPressing = false;

	self:addLuaEvent("LUA_SKILL_COOL", self, self.onSkillDataUpdate);
	self:addLuaEvent("SCENE_CHANGE", self, self.onSceneChange);
end

function Lua_SkillIconItem:onSceneChange()
	Lua_WindowUtil.openWin("Lua_SkillMenuTipsWindow", WinParam.ACTION_CLOSE);
	if self.isPressing == true then
		self.isPressing = false;
		Lua_CommonUtil.removeTimer(self, self.onPressing);
	end
end

function Lua_SkillIconItem:dispose()
	self:superCall("dispose");
	Lua_CommonUtil.removeTimer(self, self.onCoolUpdate);
	Lua_CommonUtil.removeTimer(self, self.onPressing);
end

function Lua_SkillIconItem:setData(skillVo)
	self._data = skillVo;
	if self._data ~= nil then
		self.skillImg:setAltas(self._data.atlas, self._data.skillIcon);
		if self._data.skillType == 5 then -- 普通攻击-需要大图标
			self.skillBg:setEnable(false);

			self.skillImg:SetDimensions(114, 114);
			self.skillImg:setLocation(-10, 10);
		else
			self.skillBg:setEnable(true);

			self.skillImg:SetDimensions(68, 68);
			self.skillImg:setLocation(0, 0);
		end
		self:checkIsCoolDown();

		--还没学习技能
		if self._data:hasLearn() == false then
			self.coolMask:setEnable(true);
			if self.lockIcon == nil then
				self.lockIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
				self.lockIcon:setDepth(4);
				self.lockIcon:setAltas("common_atlas_1", "ui_common_suo_01");
			end

			if self.lockTxt == nil then
				self.lockTxt = UICreate.createLabel(self.content, "0", 0, -36, 100, 30, 20);
				self.lockTxt.pivot = UIWidget.Pivot.Center;
				self.lockTxt.effectStyle = 2;
				self.lockTxt.effectColorStr = Lua_ColorDefine.transColor("000000");
				self.lockTxt:setEffectDistance(1, 1);
				self.lockTxt:setDepth(6);
				self.lockTxt.text = LanUtil.formateStr(LanUtil.getValue(110636), tostring(self._data:getActiveLv()));
			end
			self.skillImg.mouseEnable = false;
		else
			if self.lockIcon ~= nil then
				self.lockIcon:setEnable(false);
			end

			if self.lockTxt ~= nil then
				self.lockTxt:setEnable(false);
			end
			self.skillImg.mouseEnable = true;
		end
	else
		self.skillImg:setAltas("common_atlas_1", "ui_common_suo_01");
		self.skillImg:SetDimensions(28, 36);
		self.coolMask:setEnable(true);
		self.cdCirle:setEnable(true);
		self.coolTxt:setEnable(false);
		self.isPressing = false;
		Lua_CommonUtil.removeTimer(self, self.onPressing);
	end
end

function Lua_SkillIconItem:onSkillDataUpdate(val)
	if self._data == nil then
		return;
	end

	if self._data.skillId == val then
		self:checkIsCoolDown();
	end
end

function Lua_SkillIconItem:checkIsCoolDown()
	if self._data == nil then
		return;
	end
	self:onCoolUpdate();

	if self._data.isCool == 2 then
		Lua_CommonUtil.addTimer("SkillDataUpdate", 0.01, self, self.onCoolUpdate);
	end
end

function Lua_SkillIconItem:onCoolUpdate()
	if self._data == nil or self._data.skillType == Lua_SkillDefine.SKILL_TYPE_BASE then
		self.coolMask:setEnable(false);
		self.cdCirle:setEnable(false);
		self.coolTxt:setEnable(false);
		return;
	end

	if self._data.isCool == 2 then
		self.coolMask:setEnable(true);
		self.cdCirle:setEnable(true);
		self.coolTxt:setEnable(true);
		local cd = self._data.curCoolTime;
		self.coolTxt.text = tostring(math.floor(cd));
		local fa = cd / self._data.cool;
		self.coolMask.fillAmount = Mathf.Clamp(fa, 0, 1);
		self.cdCirle.fillAmount = Mathf.Clamp(fa, 0, 1);
	else
		self.coolMask:setEnable(false);
		self.cdCirle:setEnable(false);
		self.coolTxt:setEnable(false);
		Lua_CommonUtil.removeTimer(self, self.onCoolUpdate);
	end
end

function Lua_SkillIconItem:onLoadCompleteImg()
	self.skillImg:resetSize();
end

function Lua_SkillIconItem:onSkillClick(go)
	if self._data == nil then
		return;
	end

	if self.pressAct == true or self.showTips == true then
		if self.isPressing == false then
			self.isPressing = true;
			self.clickTime = getTime();
			Lua_CommonUtil.addTimer("SkillDataUpdate", 0.2, self, self.onPressing);
			self:useSkill();
		end
	else
		self:useSkill();
	end
end

function Lua_SkillIconItem:useSkill()
	local c = self._data.isCool;
	if self._data.skillType ~= Lua_SkillDefine.SKILL_TYPE_BASE and c ~= 0 then
		return;
	end

	if DataCenter.roleData.mp < self._data.costMagic then
		OperateAlert.show(LanUtil.getValue(110613));
		return;
	end

	if self._data.skillType == Lua_SkillDefine.SKILL_TYPE_CAREER then
		DataCenter.skillData.lastCareerTime = UnityEngine.Time.realtimeSinceStartup;
	end

	if self.mustAuto == true then
		if GlobalVar.hooking == true then
			DataCenter.hook:setNextSkill(self._data.skillId,4);
		else
			MsgUtil.callFunc("USE_SKILL", {skillId=self._data.skillId, targetId=0, isAuto=self.mustAuto});
		end
	else
		MsgUtil.callFunc("USE_SKILL", {skillId=self._data.skillId, targetId=0});
	end
end

function Lua_SkillIconItem:onMouseUpHandle(go)
	if self.pressAct ~= true and getTime() - self.clickTime < 1 then
		self:useSkill();
	end

	Lua_WindowUtil.openWin("Lua_SkillMenuTipsWindow", WinParam.ACTION_CLOSE);
	if self.isPressing == true then
		self.isPressing = false;
		Lua_CommonUtil.removeTimer(self, self.onPressing);
	end
end

function Lua_SkillIconItem:onPressing()
	if self.isPressing == true then
		if self.pressAct == true then
			self:useSkill();
		end
		if self.showTips == true 
			and self._data.show_tip == 1
			and self._data:hasLearn() == true
			and WindowMananger.getInstance():isWindowShowing("Lua_SkillMenuTipsWindow") == false
			and getTime() - self.clickTime > self._data.show_tip_time then
			local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
			local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
			Lua_WindowUtil.openWin("Lua_SkillMenuTipsWindow", WinParam.ACTION_OPEN, {skillData = self._data, pos=screenpos});
		end
	end
end