checkRequire("Lua_MenuPanel");
checkRequire("Lua_SkillPanel");
checkRequire("Lua_SceneSkillPanel");
checkRequire("Lua_TransferSkillPanel");
Lua_SkillIconPanel = class("Lua_SkillIconPanel", Lua_DisplayObject);
function Lua_SkillIconPanel:ctor(p)
    self:superCall("ctor", p);
    -- "SkillIconPanel_Skin"
end

function Lua_SkillIconPanel:buildShowItem()
    self:superCall("buildShowItem");
    local content = self.content;
    content.name = "Lua_SkillIconPanel";

    self.changeBtn = Lua_MenuIconBaseItem.new(self.content, self, self.onChangeClick, nil, "mainWindow_atlas", "ui_zhujiemian_icon_17");
    self.changeBtn:setIconBg("mainWindow_atlas", "ui_zhujiemian_btn_06");
    self.changeBtn.name = "changeBtn";
    self.changeBtn:setIconSpSize(60, 60);
    self.changeBtn:setIconPos(0, 0);
    self.changeBtn:setLocation(-42, 498, 0);

    local vec = self.changeBtn.mainContent.transform.localPosition;
    self.redDotIcon = UICreate.createUIAtlasImage(content, "common_atlas_1", "ui_common_hongdian", vec.x + 22, vec.y + 21, 0, 0);
    self.redDotIcon:setDepth(self.depth + 3);

    self.bagBtn = Lua_MenuIconBaseItem.new(self.content, self, self.onPackClick, nil, "icon_atlas_1", "ui_icon_beibao");
    self.bagBtn.mainContent.name = "bagBtn";
    self.bagBtn:setLocation(-131, 498, 0);

    vec = self.bagBtn.mainContent.transform.localPosition;
    self.bagRedDotIcon = UICreate.createUIAtlasImage(content, "common_atlas_1", "ui_common_hongdian", vec.x + 22, vec.y + 21, 0, 0);
    self.bagRedDotIcon:setDepth(self.depth + 3);

    self.menuPanel:setEnable(false);
    self.skillPanel:setEnable(false);
    
    self:addLuaEvent("UPDATE_MAIN_MENU", self, self.onSceneChange);
    self:addLuaEvent("SET_MAIN_MENU", self, self.onSetMainMenuState);
    self:addLuaEvent("TRANSFER_BUFF_CHANGE", self, self.onTransBuffChange);
    self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onUpdateMingSuoRedDot)--命锁红点
    -- self:addLuaEvent("BAG_COMBINE_REDDOTSTATE_CHANGE", self, self.onUpdateRedDot);--合成红点
    -- self:addLuaEvent("BAG_SOUL_REDDOTSTATE_CHANGE", self, self.onUpdateRedDot);----聚魂红点
    -- self:onUpdateRedDot();
    self:onUpdateMingSuoRedDot()
end
function Lua_SkillIconPanel:onTransBuffChange(o)
    self:updateState(self.state);
end
function Lua_SkillIconPanel:onUpdateMingSuoRedDot()
    if DataCenter.redDotData:getRedDotStateByEventId(22032) then
        self.bagRedDotIcon:setEnable(true);
    else
        self.bagRedDotIcon:setEnable(false);
    end
end
function Lua_SkillIconPanel:onUpdateRedDot(o)
    self.bagRedDotIcon:setEnable(false);
    -- 	if self.state ~= 1 and self.state ~= 2 then
    -- 		self.bagRedDotIcon:setEnable(false);
    -- 		return;
    -- 	end

    -- 	if self.bagRedDotIcon ~= nil then

    -- 		--local isOpenCombine = DataCenter.funcOpenData:isOpened(10033, false) --是否开启合成功能
    -- 		local isOpenSoul = DataCenter.funcOpenData:isOpened(10033, false)--是否开启聚魂功能

    -- 		--local combineRed = DataCenter.combineUtil.bIconRedDotState;--合成红点状态
    -- 		local soulRed = DataCenter.gatherSoulData.bIconRedDotState;--聚魂红点状态

    -- 		if soulRed == true and isOpenSoul == true then
    -- 			self.bagRedDotIcon:setEnable(true);
    -- 		else
    -- 			self.bagRedDotIcon:setEnable(false);
    -- 		end
    -- 	end
end

function Lua_SkillIconPanel:onSceneChange(o)
    if self.isInit ~= true then
        self:setMenuState(2);
        self.isInit = true;
    end
end

function Lua_SkillIconPanel:onChangeClick(go)
    self:setMenuState(self.state == 1 and 2 or 1);
    -- 2018.07.03策划需求
    if self.state == 1 then
        -- 右上角图标缩进去
        DataCenter.allRtData:setSystemState(true);
        DataCenter.allRtData:setPlayerState(true);
    else
        DataCenter.allRtData:setSystemState(false);
    end
    Lua_MsgUtil.callFunc("TORRIGHT_UPDATE");
end

function Lua_SkillIconPanel:onSetMainMenuState(o)
    self:setMenuState(o);
end

function Lua_SkillIconPanel.Get:menuPanel()
    if self._menuPanel == nil then
        self._menuPanel = Lua_MenuPanel.new(self.content, self, self.updateChangeBtnRedDot);
        self._menuPanel:setLocation(13, 15, 0);
    end
    return self._menuPanel;
end

function Lua_SkillIconPanel.Get:skillPanel()
    if self._skillPanel == nil then
        self._skillPanel = Lua_SkillPanel.new(self.content);
    end
    return self._skillPanel;
end

function Lua_SkillIconPanel.Get:transSkillPanel()
    if self._transSkillPanel == nil then
        self._transSkillPanel = Lua_TransferSkillPanel.new(self.content);
    end
    return self._transSkillPanel;
end
function Lua_SkillIconPanel:canShowTransferSkill()
    return DataCenter.roleData:isTransing();
end
function Lua_SkillIconPanel:setMenuState(state)
    if self.state == state then
        return;
    end
    self:updateState(state);
end

function Lua_SkillIconPanel:updateState(state)
    self.state = state;
    local s1 = state == 1;
    if s1 == true then
        self.menuPanel:setEnable(s1);
    else
        if self._menuPanel ~= nil then
            self._menuPanel:setEnable(false);
        end
    end

    if self.sceneSkillPanel ~= nil then
        self.sceneSkillPanel:setEnable(state ~= 1);
    else
        local s2 = state ~= 1;
        if s2 == true then
            if DataCenter.poolPartyData.isInPoolPartyScene == true then -- 进入泳池派对场景隐藏技能
                if self._skillPanel ~= nil then
                    self._skillPanel:setEnable(false);
                end
                if self._transSkillPanel ~= nil then
                    self._transSkillPanel:setEnable(false);
                end
            else
                if self:canShowTransferSkill() then
                    self.transSkillPanel:setEnable(true);
                    if self._skillPanel ~= nil then
                        self._skillPanel:setEnable(false);
                    end
                else
                    self.skillPanel:setEnable(true);
                    if self._transSkillPanel ~= nil then
                        self._transSkillPanel:setEnable(false);
                    end
                end
            end
        else
            if self._skillPanel ~= nil then
                self._skillPanel:setEnable(false);
            end
            if self._transSkillPanel ~= nil then
                self._transSkillPanel:setEnable(false);
            end
        end
    end

    if self.state == 1 then
        self.changeBtn:setIcon("mainWindow_atlas", "ui_zhujiemian_icon_18");
        self.changeBtn:setEnable(true);
        self.bagBtn:setEnable(true);
        -- self:onUpdateRedDot();
        self:updateChangeBtnRedDot();
        -- TweenUtil.getInstance():addTween(self.changeBtn.mainContent, 1, 0, nil, Quaternion.Euler(0, 0, -45), nil);
    elseif self.state == 2 then
        self.changeBtn:setIcon("mainWindow_atlas", "ui_zhujiemian_icon_17");
        self.changeBtn:setEnable(true);
        self.bagBtn:setEnable(true);
        -- self:onUpdateRedDot();
        self:updateChangeBtnRedDot();
        -- TweenUtil.getInstance():addTween(self.changeBtn.mainContent, 1, 0, nil, Quaternion.Euler(0, 0, 0), nil);
    else
        self.changeBtn:setEnable(false);
        self.redDotIcon:setEnable(false);
        self.bagBtn:setEnable(false);
        self.bagRedDotIcon:setEnable(false);
    end
    Lua_MsgUtil.callFunc("MENU_STATE_CHANGE", { self.state, self.menuPanel.openedList:getSize() });
end

-- 更新切换红点
function Lua_SkillIconPanel:updateChangeBtnRedDot()
    if self.state == 2 then
        if self.menuPanel ~= nil and self.menuPanel.redDotNum > 0 then
            self.redDotIcon:setEnable(true);
        else
            self.redDotIcon:setEnable(false);
        end
    else
        self.redDotIcon:setEnable(false);
    end
end

function Lua_SkillIconPanel:setShowSkillList(list)
    local needShow = false;
    if DataCenter.roleData.sceneId == 40101 then
        -- 防止字段误用
        needShow = true;
    end

    local bActive = false;
    if needShow == true and list ~= nil and #list > 0 then
        if self._skillPanel ~= nil then
            self._skillPanel:setEnable(false);
        end
        if self._transSkillPanel ~= nil then
            self._transSkillPanel:setEnable(false);
        end
        if self.sceneSkillPanel == nil then
            self.sceneSkillPanel = Lua_SceneSkillPanel.new(self.content);
        end
        self.sceneSkillPanel:setShowSkillList(list);

        bActive = state ~= 1;
        if self.sceneSkillPanel.isActive ~= bActive then
            self.sceneSkillPanel:setEnable(bActive);
        end
    else
        if self.sceneSkillPanel ~= nil then
            self.sceneSkillPanel:dispose();
            self.sceneSkillPanel = nil;
        end

        bActive = state ~= 1;
        if self:canShowTransferSkill() then
            if self.transSkillPanel.isActive ~= bActive then
                self.transSkillPanel:setEnable(bActive);
            end
            if self._skillPanel ~= nil then
                self._skillPanel:setEnable(false);
            end
        else
            if self.skillPanel.isActive ~= bActive then
                self.skillPanel:setEnable(bActive);
            end
            if DataCenter.poolPartyData.isInPoolPartyScene == true then -- 进入泳池派对场景隐藏技能
                self.skillPanel:setEnable(false);
            end
            if self._transSkillPanel ~= nil then
                self._transSkillPanel:setEnable(false);
            end
        end
    end
end

function Lua_SkillIconPanel:onPackClick(go)
    Lua_WindowUtil.openWin("Lua_PackWindow");
end

function Lua_SkillIconPanel:dispose()
    self:superCall("dispose");
end