checkRequire("Lua_SkillPanelBase");
checkRequire("Lua_TransferWaitItem");

Lua_SkillPanel = class("Lua_SkillPanel", Lua_SkillPanelBase);
function Lua_SkillPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.lastJumpClick = 0;

    self:addCSharpEvent("PLAYER_LEVEL_UP", self, self.onMarryIconEvent);

    self.jumpSkillBg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_15", -33, 44, 0, 0);
    self.jumpSkillBg.name = "jumpSkillBg";
    self.jumpSkillBg.clickScale = false;
    self.jumpSkillBg:setDepth(0);
    self.jumpSkillBg:addClickFuntion(self, self.emptyFun);

    self.jumpSkillSp = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_icon_15", -26, 35, 0, 0);
    self.jumpSkillSp.name = "jumpSkillSp";
    self.jumpSkillSp:setLocation(-19, 31);
    self.jumpSkillSp:setDepth(5);
    self.jumpSkillSp:addClickFuntion(self, self.onJumpClick);

    self.transItem = Lua_TransferWaitItem.new(self.content);
    self.transItem:setLocation(-324, 155, 0);

    self.careerSkillSps = Array();
    local careerPos = { { -208, 50 }, { -201, 144 }, { -137, 207 }, { -49, 219 } };
    for i, v in ipairs(careerPos) do
        local sii = Lua_SkillIconItem.new(self.content, false);
        sii:setLocation(v[1], v[2]);
        sii.content.name = "careerSkillSp_" .. i;
        sii:setData(nil);
        sii.showTips = true;
        self.careerSkillSps:add(sii);
    end
    self.isInited = false;
    self:addLuaEvent("SKILL_SHOW", self, self.onSkillShow);
    self:onSkillShow();
    self.isInited = true;
end

function Lua_SkillPanel:emptyFun()
end
--[[function Lua_SkillPanel:onBaseSkillBgClick(go)
	self.baseSkillSp:onSkillClick(nil);
end
function Lua_SkillPanel:onBaseSkillBgMouseUp(go)
	self.baseSkillSp:onMouseUpHandle(nil);
end--]]
function Lua_SkillPanel:setEnable(val)
    self:superCall("setEnable", val)
    self.transItem:setEnable(val);
end

function Lua_SkillPanel:onJumpClick(go)
    if DataCenter.roleData.fightState == true then
        OperateAlert.show(LanUtil.getValue(110614));
        return;
    end
    if DataCenter.yunBiaoData.isOngoing == true then
        OperateAlert.show(LanUtil.getValue(110637));
        return;
    end
    local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    if sceneConfig.never_jump == 1 then
        OperateAlert.show(LanUtil.getValue(121138));
        return;
    end
    local nt = getTime();
    local cdTime = Lua_CommonUtil.getCommonConfig("jump_cd", 1) / 1000;
    if nt - self.lastJumpClick < cdTime then
        return;
    end
    self.lastJumpClick = nt;
    MsgUtil.callFunc("PLAYER_JUMP_CLICK");
end
function Lua_SkillPanel:onSkillShow(obj)
    if DataCenter.skillData == nil then
        return;
    end
    local suitList = DataCenter.skillData:getSkillSuitList(0);
    if suitList == nil then
        return;
    end
    if DataCenter.skillData.needFloatingSkill == true and self.isInited == true then

        --[[ local sec = Lua_CommonUtil.getCommonConfig("icon_floating_time", 1);
        Lua_CommonUtil.delayCall(sec, self, self.onFloatingComplete);--]]
        self:addLuaEvent("SKILL_FLOATING_COMPLETE", self, self.onFloatingComplete);
        return;
    end
    self.baseSkillSp:setData(suitList.baseSkill);
    local len = self.careerSkillSps:getSize();
    for i = 1, len do
        self.careerSkillSps[i]:setData(nil);
    end
    len = suitList.careerSkills:getSize();
    for i = 1, len do
        local svo = suitList.careerSkills[i];
        local slot = DataCenter.skillData:getSkillSlot(svo.skillId);
        if slot ~= nil then
            local sii = self.careerSkillSps[slot];
            if sii ~= nil then
                sii:setData(svo);
            end
        end
    end
end
function Lua_SkillPanel:onFloatingComplete()
    DataCenter.skillData.needFloatingSkill = false;
    self:onSkillShow(nil);
end