checkRequire("Lua_SkillIconItem");
checkRequire("Lua_JueXingSkillItem");
checkRequire("Lua_TransferItem");
Lua_SkillPanelBase = class("Lua_SkillPanelBase", Lua_DisplayObject);
function Lua_SkillPanelBase:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("NOTICE_BESTRONG_STATE", self, self.onBeStrongIconEvent);
	self:addLuaEvent("NOTICE_BESTRONG_ID", self, self.onBeStrongIconEvent2)
	self:addLuaEvent("FAIRY_ICON_UPDATE", self, self.onFairyIconUpdate);
	self:addCSharpEvent("PLAYER_LEVEL_UP", self, self.onMarryIconEvent);

	self.baseSkillSp = Lua_SkillIconItem.new(self.content, true);
	self.baseSkillSp.content.name = "baseSkillSp";
	self.baseSkillSp.pressAct = true;
	self.baseSkillSp:setLocation(-84, 88);
	self.baseSkillSp:setData(nil);

	self.switchTargetBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_19", -312.5, 39.5, 0, 0);
	self.switchTargetBtn.name = "switchTargetBtn";
	self.switchTargetBtn:addClickFuntion(self, self.onSwitchTargetClick);

	self.marryBtn = UICreate.createUIAtlasImage(self.content, "yinyuan_altas", "ui_zhujiemian_213", -241, 372, 0, 0);
	self.marryBtn.name = "marryBtn";
	self.marryBtn:setDepth(1);
	self.marryBtn:addClickFuntion(self, self.onMarryClick);

	if getShowTips() then
		self.bgBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_20", -125, 376, 0, 0);
		self.bgBtn.name = "bgBtn";
		self.bgBtn:setDepth(0);

		self.beStrongBtn = UICreate.createUIAtlasImage(self.content, "icon_atlas_1", "ui_zhujiemian_icon_19", -125, 363, 0, 0);
		self.beStrongBtn.name = "beStrongBtn";
		self.beStrongBtn:setDepth(5);
		self.beStrongBtn:addClickFuntion(self, self.onBeStrongClick);

		self.hongdian = UICreate.createUIAtlasImage(self.beStrongBtn.mainContent, "common_atlas_1", "ui_common_hongdian", 20, 25, 0, 0);
		self.hongdian.name = "hongdian";
		self.hongdian:setDepth(15);
		self.hongdian.clickScale = false;
		self.hongdian:setEnable(true);

		self.effect = UICreate.createUIEffect(self.beStrongBtn.mainContent, "/effects/scsEffects/eu1_001", "eu1_001", 3, 10);
		self.effect.name = "effect";
		self.effect:SetRenderQueue(self.bgBtn, 1, UIEffect.NormalSort);
	end

	self.jueXingItem = Lua_JueXingSkillItem.new(self.content);
	self.jueXingItem:setLocation(-79, 254, 0);

	self:onFairyIconUpdate();
	-- if DataCenter.beStrongData.envent_status ~= nil then
		self:onBeStrongIconEvent(DataCenter.beStrongData.envent_status == 1);
	-- end
	self:onMarryIconEvent();
end

function Lua_SkillPanelBase:onMarryIconEvent()
	local marryData = Lua_CommonUtil.getCommonConfig("Wedding_Preview_and_over", 3);
	local start_lvl = marryData[1][1];
	local end_lvl = marryData[1][2];
	self.marryBtn:setEnable(DataCenter.roleData.level >= start_lvl and DataCenter.roleData.level <= end_lvl);

	for i = 1, #marryData[2] do
		if DataCenter.roleData.level == marryData[2][i] then
			Lua_WindowUtil.openWin("Lua_MarryYuGaoWindow", WinParam.ACTION_OPEN);
			break;
		end
	end
end

function Lua_SkillPanelBase:onFairyIconUpdate()
	if getShowTips() == false then
		return;
	end

	if self.fairyBtnBg == nil then
		self.fairyBtnBg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_widget_20", -45, 376, 0, 0);
		self.fairyBtnBg.name = "fairyBtnBg";
		self.fairyBtnBg:setDepth(0);
	end

	if self.fairyBtn == nil then
		self.fairyBtn = UICreate.createUIAtlasImage(self.content, "icon_atlas_1", "ui_zhujiemian_icon_20", -45, 363, 0, 0);
		self.fairyBtn.name = "fairyBtn";
		self.fairyBtn.type = UIBasicSprite.Type.Simple; -- 加MakePixelPerfect()等于resetSize()
		self.fairyBtn:setDepth(1);
		-- self.fairyBtn:addLoadCompleteFun(self, self.onLoadCompleteFun);
		self.fairyBtn:addClickFuntion(self, self.onFairyBtnClick);
	end

	local equipedfairyInfo = DataCenter.fairyData.equipedfairyInfo;
	if equipedfairyInfo ~= nil then
		local index = equipedfairyInfo.referenceIndex == nil and equipedfairyInfo.index or equipedfairyInfo.referenceIndex;
		if index ~= nil and index ~= 0 then
			self.fairyBtn:setAltas("icon_atlas_1", "icon_sprite_" .. index);
			self.fairyBtn:setLocation(-45, 369, 0);
		end
	else
		self.fairyBtn:setAltas("icon_atlas_1", "ui_zhujiemian_icon_20");
		self.fairyBtn:setLocation(-45, 363, 0);
	end
	self.fairyBtn.widget:MakePixelPerfect();
end

function Lua_SkillPanelBase:onLoadCompleteFun()
	self.fairyBtn:resetSize();
end

function Lua_SkillPanelBase:onMarryClick()
	Lua_WindowUtil.openWin("Lua_MarryYuGaoWindow");
end

function Lua_SkillPanelBase:onBeStrongClick()
	Lua_WindowUtil.openWin("Lua_BeStrongWindow");
end

function Lua_SkillPanelBase:onFairyBtnClick()
	Lua_WindowUtil.openWin("Lua_FairyListWindow");
end

function Lua_SkillPanelBase:setEnable(val)
	self:superCall("setEnable", val);

	if val then
		self:setLocation(365, 0, 0);
		TweenUtil.getInstance():addTween(self.content, 0.4, 0, Vector3(0, 0, 0), nil, nil);
	end
end

function Lua_SkillPanelBase:onBeStrongIconEvent(val)
	if getShowTips() == false then
		return;
	end

	-- print("进入", val)
	-- 9.18 取消跨服对变强屏蔽
	-- if DataCenter.roleData.sceneId ~= nil then
	-- 	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	-- 	if sceneConfig.kuafu_map == 1 then
	-- 		self.bgBtn:setEnable(false);
	-- 		self.beStrongBtn:setEnable(false);
	-- 		return;
	-- 	end
	-- end

	self.initPanel = true
	Lua_ProxyManager.getProxy("Lua_BeStrongProxy"):sInitInfo();
end

function Lua_SkillPanelBase:onBeStrongIconEvent2(len)
	if self.initPanel ~= nil and self.initPanel == true then
		self.initPanel = false

		local mainArr = DataCenter.beStrongData:mainBeStrongArr();
		self.bgBtn:setEnable(mainArr:getSize() ~= 0);
		self.beStrongBtn:setEnable(mainArr:getSize() ~= 0);
	end
end

function Lua_SkillPanelBase:onSwitchTargetClick(go)
	DataCenter.thingData:addLastSlectedTarget(DataCenter.hook.selectedId);
	local s = DataCenter.hook:findAnotherTarget();
	c_hookCurMonsterTarget(s, false);
end