Lua_TransferItem = class("Lua_TransferItem", Lua_DisplayObject);
function Lua_TransferItem:ctor(p)
	self:superCall("ctor",p, "TransferTimeItem_skin");
end
function Lua_TransferItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("TRANSFER_BUFF_CHANGE", self, self.onTransBuffChange);
	self:onTransferTimer();
end
function Lua_TransferItem:setEnable(val)
    self:superCall("setEnable", val)
    if val == true then
    	self:addTimer("Lua_TransferItem", 0.4, self, self.onTransferTimer);
    else
    	Lua_CommonUtil.removeTimer(self, self.onTransferTimer)
    end
end
function Lua_TransferItem:onTransBuffChange(o)
	self.isTransfering = DataCenter.roleData:isTransing();
	if self.isTransfering == true then
		self.buffVo = DataCenter.roleData:getBuffById(1114);
	end
end
function Lua_TransferItem:onTransferTimer()
	if self.isTransfering == nil then
		self:onTransBuffChange();
	end
	if self.isTransfering == true then
		local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if sceneData.not_show_transfer_time == 1 then
			self.timeTxt:setEnable(false);
		else
			if self.buffVo == nil then
				self.buffVo = DataCenter.roleData:getBuffById(1114);
			end
			local lt = 0;
			if self.buffVo ~= nil then
				lt = math.floor(self.buffVo.leftTime);
			end
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(126008),tostring(lt));
			self.timeTxt:setEnable(true);
		end
	end
end