checkRequire("Lua_SkillPanelBase");
Lua_TransferSkillPanel = class("Lua_TransferSkillPanel", Lua_SkillPanelBase);
function Lua_TransferSkillPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.careerSkillSps = Array();
	self.careerPos = {};
	self.careerPos[1] = {{-55,214}};
	self.careerPos[2] = {{-239,107}, {-180,214}};
	self.careerPos[3] = {{ - 243, 103 }, { - 213, 209 }, { - 101, 243 }};
	self.careerPos[4] = {{ - 221, 55 }, { - 218, 150 }, { - 150, 218 }, { - 55, 221 }};

	self.transItem = Lua_TransferItem.new(self.content);
    self.transItem:setLocation(-210, 30, 0);

	self:addLuaEvent("SKILL_SHOW", self, self.onSkillShow);
	self:addLuaEvent("UPDATE_TRANS_SKILL_BUFF", self, self.onUpdateTransSkill);
	self:addLuaEvent("TRANSFER_BUFF_CHANGE", self, self.onTransBuffChange);
	self:addLuaEvent("SKILL_SHOW", self, self.onUpdateTransSkill);
	self:onUpdateTransSkill();
end
function Lua_TransferSkillPanel:setEnable(val)
    self:superCall("setEnable", val)
    self.transItem:setEnable(val);
    if val == true then
    	self:onUpdateTransSkill();
    end
end
function Lua_TransferSkillPanel:onTransBuffChange()
	if DataCenter.roleData:isTransing() == false then
		self.baseSkillSp:setData(nil);
		local len = self.careerSkillSps:getSize();
		for i=1,len do
			self.careerSkillSps[i]:setData(nil);
		end
	end
end
function Lua_TransferSkillPanel:onUpdateTransSkill()
	local buffVo = DataCenter.roleData:getBuffById(1114);
	if buffVo ~= nil then
		local arr = getConfig({"awake","client_Show",buffVo.value1,"skill"});
		local baseSkill = getConfig({"awake","client_Show",buffVo.value1,"base_skill"});
		local skillList = {};
		local index = 1;
		if arr ~= nil then
			for i,v in ipairs(arr) do
				local vo = DataCenter.skillData:getSkillData(v);
				if vo ~= nil and vo.skillType == 1 and vo:hasLearn() == true then
					skillList[index] = v;
					index = index + 1;
				end
			end
		end
		self:setShowSkillList(skillList);
		self.baseSkillSp:setData(DataCenter.skillData:getSkillData(baseSkill));
	end
end
-- 显示的技能id列表
function Lua_TransferSkillPanel:setShowSkillList(list)
	self.showList = list;
	if list == nil or #list <= 0 then
		self:setEnable(false);
		return;
	end

	local sii;
	local posInfo = self.careerPos[#list];
	local len = self.careerSkillSps:getSize();
	local num = #list - len;
	while (num > 0) do
		sii = Lua_SkillIconItem.new(self.content, false);
		sii:setData(nil);
		sii.showTips = true;
		self.careerSkillSps:add(sii);
		num = num - 1;
	end

	while (num < 0) do
		sii = self.careerSkillSps:shift();
		sii:dispose();
		num = num + 1;
	end

	for i = 1, #list do
		sii = self.careerSkillSps[i];
		sii:setLocation(posInfo[i][1], posInfo[i][2]);
		sii.content.name = "careerSkillSp_"..i;
	end
	self:onSkillShow();
end

function Lua_TransferSkillPanel:onSkillShow(obj)
	if DataCenter.skillData == nil or self.showList == nil then
		return;
	end

	local step = 1;
	local len = #self.showList;
	for i = 1, len do 
		local vo = DataCenter.skillData:getSkillData(self.showList[i]);
		if vo ~= nil and vo:hasLearn() == true then
			if vo.skillType == 5 then
				self.baseSkillSp:setData(vo);
			else
				local slot = DataCenter.skillData:getSkillSlot(vo.skillId);
				if slot == nil then
					slot = vo.slot;
				end
        		if slot ~= nil then
        			local sii = self.careerSkillSps[slot];
					if sii ~= nil then
						sii:setData(vo);
						sii:setEnable(true);
					end
				end
				step = step + 1;
			end
		end
	end
	
	len = self.careerSkillSps:getSize();
	for i = step, len do
		self.careerSkillSps[i]:setData(nil);
		self.careerSkillSps[i]:setEnable(false);
	end
end

function Lua_TransferSkillPanel:dispose()
	TweenUtil.getInstance():stop(self.content);

	self:superCall("dispose");
end