Lua_TransferWaitItem = class("Lua_TransferWaitItem", Lua_DisplayObject);
function Lua_TransferWaitItem:ctor(p)
	self:superCall("ctor",p, "TransferItem_skin");
end
function Lua_TransferWaitItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addCSharpEvent("FUNCTION_OPEN", self, self.onIconState);
	self:addLuaEvent("SKILL_UPDATE", self, self.onSkillUpdate);
	self:addLuaEvent("TRANS_SKILL_UPDATE_DATA", self, self.onSkillUpdate);
	self:addLuaEvent("USE_TRANSFER_SKILL", self, self.onTransClick);
	self:addCSharpEvent("PLAYER_LEVEL_UP", self, self.onJueXingIconEvent);
	self.sp:setAltas(nil,nil);
	self:onIconState();
	self:onJueXingIconEvent();
	self.sp:addClickFuntion(self, self.onTransClick);
end
function Lua_TransferWaitItem:onTransClick(o)
	if DataCenter.funcOpenData:isOpened(10117) == true then
		if self.skillVo ~= nil then
			local c = self.skillVo.isCool;
			if c ~= 0 then
				return;
			end
			local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
			if sceneData.canTransfer == false then
				OperateAlert.show(LanUtil.getValue(126006));
				return;
			end
			if getCVersion() >= 1180 then
				self.effectLoaded = false;
				self.modelLoaded = false;
				self.isAuto = o == true;
				local modelId = self.skillVo.config.detail[1].effect[3].model;
				local modelStr = getConfig({"item",modelId,"model"});
				PreLoadManager.getInstance():preLoadEffect("/mounts/"..modelStr, self, self.onModelLoaded);

				local effect = self.skillVo.config.actionEffect;
				PreLoadManager.getInstance():preLoadEffect("/effects/fight/"..effect, self, self.onEffectLoaded);
			else
				self:doTransfer();
			end
		end
	else
		Lua_WindowUtil.openWin("Lua_AwakeHeraldWindow");
	end
end

function Lua_TransferWaitItem:onJueXingIconEvent()
    local marryData = Lua_CommonUtil.getCommonConfig("juexing_preview", 3);
    local start_lvl = marryData[1][1];
    --local end_lvl = marryData[1][2];

    local auto_lvlArr = marryData[2];
    for i = 1, #auto_lvlArr do
        if DataCenter.roleData.level == auto_lvlArr[i] then
            Lua_WindowUtil.openWin("Lua_AwakeHeraldWindow");
            break;
        end
    end
    if DataCenter.roleData.level >= start_lvl then
        self.sp:setEnable(true);
		self.txt:setEnable(true);
		self.txtBg:setEnable(true);
    else
        self.sp:setEnable(false);
		self.txt:setEnable(false);
		self.txtBg:setEnable(false);
    end
end

function Lua_TransferWaitItem:onModelLoaded()
	self.modelLoaded = true;
	if self.modelLoaded == true and self.effectLoaded == true then
		self:doTransfer();
	end
end
function Lua_TransferWaitItem:onEffectLoaded()
	self.effectLoaded = true;
	if self.modelLoaded == true and self.effectLoaded == true then
		self:doTransfer();
	end
end
function Lua_TransferWaitItem:doTransfer()
	if DataCenter.roleData:isTransing() == true then
		return;
	end
	if self.isAuto ~= true then
		MsgUtil.callFunc("PLAYER_STOP");
	end
	MsgUtil.callFunc("USE_SKILL", {skillId=self.skillVo.skillId, targetId=0, isAuto = self.isAuto});
end

function Lua_TransferWaitItem:onIconState()
	if DataCenter.funcOpenData:isOpened(10117) == false then
		self.sp:setAltas("icon_atlas_2","juexing_yugao");
		self.txt.text = getConfig({"func_open", 10117, "advance_message"});
	else
		self:onSkillUpdate();
	end
end
function Lua_TransferWaitItem:onSkillUpdate()
	self.skillVo = DataCenter.skillData:findTransSkill();
	if self.skillVo ~= nil then
		self.sp:setEnable(true);
		self.txt:setEnable(true);
		self.txtBg:setEnable(true);
		self.sp:setAltas("icon_atlas_2",self.skillVo.skillIcon);
		self:onTransferTimer();
	else		
		--self:onJueXingIconEvent();
	end
end
function Lua_TransferWaitItem:setEnable(val)
    self:superCall("setEnable", val)
    if val == true then
    	self:addTimer("Lua_TransferWaitItem", 0.4, self, self.onTransferTimer);
    else
    	Lua_CommonUtil.removeTimer(self, self.onTransferTimer)
    end
end
function Lua_TransferWaitItem:onTransferTimer()
	if self.skillVo ~= nil then
		if self.skillVo.isCool == 2 then
			local cd = self.skillVo.curCoolTime;

			local dt = UnityEngine.Time.realtimeSinceStartup - self.skillVo.lastTime;
			self.txt:setEnable(true);
			self.txtBg:setEnable(true);
			self.txt.text = TimeTransform.getInstance():transSeconds6(cd, false, true);
			self:showEffect(false);
		else
			self.txt:setEnable(false);
			self.txtBg:setEnable(false);
			self:showEffect(true);
		end
	end
end
function Lua_TransferWaitItem:showEffect(val)
	if val == true then
		if self.effect == nil then
			self.effect =  UICreate.createUIEffect(self.content, nil, nil, -5.5, 0);
			local effectName = "transfer_fire";
			self.effect:setUrl("/effects/fight/"..effectName,effectName);
			self.effect:setDepth(5);
			self.effect:setScale(0.9,0.9,0.9);
			self.effect:SetRenderQueue(self.sp,-4,2,true);
		end
	else
		if self.effect ~= nil then
			self.effect:dispose();
			self.effect = nil;
		end
	end
end