-- BOSS血条显示面板
checkRequire("Lua_BossTargetItem");
Lua_BossTargetPanel = class("Lua_BossTargetPanel", Lua_DisplayObject);
function Lua_BossTargetPanel:ctor(p)
	self:superCall("ctor", p, "BossTargetPanel_skin");
end

function Lua_BossTargetPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.cancelHookList = Array();
	
	self.hpBar = Lua_ProccessBar.new(self.content, true);
	self.hpBar:setTxtCenter();
	self.hpBar:setDepth(3);
	self.hpBar:setLocation(10, 3, 0);

	self.item = Lua_BossTargetItem.new(self.content);
	self.item:setDepth(3);
	self.item:setLocation(-42, 19, 0);

	self:setBelongEnable(false);

	local tdic = Lua_CommonUtil.getCommonConfig("cancel_hook_after_kill", 3);
	for k,v in ipairs(tdic) do
		self.cancelHookList:add(v);
	end

	self.cancelHookLvLimit =  Lua_CommonUtil.getCommonConfig("cancel_hook_lvl_limit", 1);
	self.cancelHookAfterInterval = Lua_CommonUtil.getCommonConfig("cancel_hook_after_interval", 1);

	self:addLuaEvent("BOSS_REWARD_BELONG_CHANGE", self, self.rewardBelongChange);
end

function Lua_BossTargetPanel:setData(val)
	self.thingVo = val;

	self.item:setData(val);
	self.nameTxt.text = val.name;
	
	self.hpBar:setBarNum(val.monsterData.lifeNum);
	self.hpBar:setInfoTxt(val.hp, val.maxHp, false, true);

	self:checkBelongName(val.reward_belong);
	
	if val.hp <= 0 and self.cancelHookList:indexOf(val.configId) ~= -1 and DataCenter.roleData.level < self.cancelHookLvLimit then
		self:addTimer("Lua_BossTargetPanel", self.cancelHookAfterInterval, self, self.delayToStopHook);
	end
end

function Lua_BossTargetPanel:delayToStopHook()
	Lua_CommonUtil.removeTimer(self, self.delayToStopHook);
	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end
end

function Lua_BossTargetPanel:checkBelongName(bname)
	if bname ~= nil and bname ~= "" then
		self.guishuNameTxt.text = bname;
		self:setBelongEnable(true);
	else
		self:setBelongEnable(false);
	end
end

function Lua_BossTargetPanel:setBelongEnable(val)
	self.guishuBg:setEnable(val);
	self.guishuLb:setEnable(val);
	self.guishuNameTxt:setEnable(val);

	if self.item.bossState and val then
		self.item.rageIconBg:setEnable(false);
	end
end

function Lua_BossTargetPanel:rewardBelongChange(msg)
	-- msg:Proto80400119
	if thingVo == nil or tonumber(thingVo.objId) ~= tonumber(msg.ai_id) then
		return;
	end
	self:checkBelongName(msg.reward_belong);
end

function Lua_BossTargetPanel:setEnable(val)
	self:superCall("setEnable", val);

	if val == false then
		self.item:clearRes();
	end
end