Lua_MonsTargetHeadBasePanel = class("Lua_MonsTargetHeadBasePanel", Lua_DisplayObject);
function Lua_MonsTargetHeadBasePanel:ctor(p, skin)
	self:superCall("ctor", p, skin);
end

function Lua_MonsTargetHeadBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	if self.rageNumTxt ~= nil then
		self.rageNumTxt:setEnable(false);
	end
end

function Lua_MonsTargetHeadBasePanel:setDepth(val)
	self:superCall("setDepth", val);

	self.rageIconBg:setDepth(val + 6);
	self.rageIcon:setDepth(val + 7);
	self.rageNumTxt:setDepth(val + 7);
end

function Lua_MonsTargetHeadBasePanel:setData(val)
	if self.rageNumTxt ~= nil then
		if self.bossScene == nil then
			self.bossScene= {};

			local tlBossCfg = getConfig({"limit_boss_scene"});
			for k,v in ipairs(tlBossCfg) do
				self.bossScene[v.scene_id] = 1;
			end
			
			tlBossCfg = getConfig({"limit_guide_monster"});
			for k,v in pairs(tlBossCfg) do
				self.bossScene[v.scene_id] = 1;
			end
		end

		local sceneId = DataCenter.roleData.sceneId;
		local isInTimeLimitBossScene = false;
		if self.bossScene[sceneId] == 1 then
			isInTimeLimitBossScene = true;		
		end

		local energy = nil;
		if val.monsterData ~= nil then
			energy = getConfig({"monster", val.monsterData.objId, "energy"});
		end

		-- 限时boss副本里面要显示击杀boss时增加的愤怒值
		if isInTimeLimitBossScene and val.monsterData ~= nil then
			self.rageNumTxt:setEnable(true);
			local rage = 0;
			local timeLimitMonsCfg = getConfig({"limit_boss", val.monsterData.objId});
			if timeLimitMonsCfg ~= nil then
				rage = timeLimitMonsCfg.kill_boss_point;
			end
			self:showBossPoint(true, rage);
		elseif energy ~= nil then
			self.rageNumTxt:setEnable(true);
			self:showBossPoint(true, energy);
		else
			self:showBossPoint(false, 0);
		end
	end
end

function Lua_MonsTargetHeadBasePanel:showBossPoint(val, num)
	if self.bossState ~= val then
		self.bossState = val;
		if self.bossState == true then
			self.rageIcon:setEnable(true);
			self.rageIconBg:setEnable(true);
		else
			self.rageNumTxt:setEnable(false);
			self.rageIcon:setEnable(false);
			self.rageIconBg:setEnable(false);
		end
	end

	if val then
		self.rageNumTxt.text = num;
	end
end