﻿checkRequire("Lua_MonsTargetHeadBasePanel");
Lua_MonsterTargetItem = class("Lua_MonsterTargetItem", Lua_MonsTargetHeadBasePanel);
function Lua_MonsterTargetItem:ctor(p)
	self:superCall("ctor", p, "MonsterTargetItem_skin");
end

function Lua_MonsterTargetItem:buildShowItem(val)
	self:superCall("buildShowItem");

	self.content.name = "Lua_MonsterTargetItem";

	self.headBg:setDepth(1);
	self.headBg:addClickFuntion(self, self.onHeadClick)
end

function Lua_MonsterTargetItem:setDepth(val)
	self:superCall("setDepth", val);

	self.headBg:setDepth(val + 1);
	self.lvTxt:setDepth(val + 2);
end

function Lua_MonsterTargetItem:setData(val)
	self:superCall("setData", val);

	self.data = val;
	if val.monsterData ~= nil and val.monsterData.hide_lv == 1 then
		self.lvTxt:setEnable(false);
	else
		self.lvTxt.text = tostring(val.lvl);
		self.lvTxt:setEnable(true);
	end
end

function Lua_MonsterTargetItem:setNpcData(val)
	self.rageNumTxt:setEnable(false);
	self.rageIcon:setEnable(false);
	self.rageIconBg:setEnable(false);
	self.lvTxt.text = val.lvl == nil and "1" or val.lvl;
end

function Lua_MonsterTargetItem:onHeadClick(val)
	if self.data ~= nil and self.data.kind == Lua_ThingDefine.USER then
		-- Lua_WindowUtil.openWin("Lua_SmallMenuWindow");
		local thingVo = DataCenter.thingData:getThing(DataCenter.hook.selectedId);
		local tid = DataCenter.hook.selectedId;
		if thingVo ~= nil and thingVo.copy_player then
			tid = thingVo.copy_id;
		end

		local isSameServer = 1;
		if thingVo.server_name ~= "" and DataCenter.roleData.server_name ~= "" and thingVo.server_name ~= DataCenter.roleData.server_name then
			isSameServer = 0;
		end

		local menuTypes = Array();
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_CHECK_INFO, {rid = tid, isSameServer = isSameServer}));
		if DataCenter.friendData:isMyFriend(tid) == false and isSameServer == 1 then
			menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND, tid));
		end

		-- 泳池派对
		if DataCenter.funcOpenData:isOpened(10199) and DataCenter.poolPartyData.isInPoolPartyScene then
			if DataCenter.poolPartyData.sun_bath_type ~= 2 then -- 自己船 拥有者
				if tonumber(DataCenter.poolPartyData.partner_id) == tonumber(thingVo.copy_id) then -- 在自己船上的人
					menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_POOL_PLEASE_LEAVE, tid)); -- 请离
				else
					menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_POOL_INVITE, tid)); -- 邀请上船
				end

				if DataCenter.poolPartyData.sun_bath_type == 0 then -- 自己不在船上
					if thingVo.sun_bath_type == 1 or thingVo.sun_bath_type == 2 then -- 对方有船
						menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_POOL_APPLY, tid)); -- 申请上船
					end
				end
			end
		end
		Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_OPEN, menuTypes);
	end
end