-- 血条显示
checkRequire("Lua_MonsterTargetPanel");
checkRequire("Lua_BossTargetPanel");
Lua_TargetPanel = class("Lua_TargetPanel", Lua_DisplayObject);
function Lua_TargetPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_TargetPanel";

	self.panelType = 0;
	self.monsterPanel = nil;
	self.bossPanel = nil;

	if getShowTips() == true then
		self:addTimer("check_target_far", 1, self, self.onCheckTargetFar);
		self:addLuaEvent("SELECTED_TARGET_INFOCHANGE", self, self.onSelectedTargetInfoUpdate);
	end
end

function Lua_TargetPanel:setData(val)
	self.tid = val.objId;
	if val.kind == Lua_ThingDefine.MONSTER and val.boss == 1 then
		self:genPanel(1);
	else
		self:genPanel(2);

		-- 泳池派对
		if DataCenter.funcOpenData:isOpened(10199) and DataCenter.poolPartyData.isInPoolPartyScene then
			local thingVo = DataCenter.thingData:getThing(DataCenter.hook.selectedId);
			local tid = DataCenter.hook.selectedId;
			if thingVo ~= nil and thingVo.copy_player then
				tid = thingVo.copy_id;
			end
			DataCenter.poolPartyData.selectPlayrId = tid;
		end
	end
	self.item:setData(val);
end

function Lua_TargetPanel:genPanel(val)
	if self.panelType == val then
		return;
	end

	if self.item ~= nil then
		self.item:setEnable(false);
	end

	self.panelType = val;
	if self.panelType == 1 then
		if self.bossPanel == nil then
			self.bossPanel = Lua_BossTargetPanel.new(self.content);
			self.bossPanel:setLocation(76, -45, 0);
		end
		self.item = self.bossPanel;
	else
		if self.monsterPanel == nil then
			self.monsterPanel = Lua_MonsterTargetPanel.new(self.content);
			self.monsterPanel:setLocation(37, 29, 0);
		end
		self.item = self.monsterPanel;
	end
	self.item:setEnable(true);
end

function Lua_TargetPanel:onSelectedTargetChange(o)
	local v = DataCenter.hook.selectedId;
	if v == 0 then
		if self.item ~= nil then
			self.item:setEnable(false);
		end
		self.panelType = -1;
	else
		local tcfg = getConfig({"monster", v});
		local thingVo = DataCenter.thingData:getThing(v);
		if self.tid == DataCenter.hook.selectedId and thingVo ~= nil then
			self:setData(thingVo);
		elseif  tcfg ~= nil then
			self:setNpcData(tcfg);
		end
	end
end

function Lua_TargetPanel:setNpcData(tcfg)
	self:genPanel(2);

	self.item:setEnable(true);
	self.item:setNpcData(tcfg);	
	self:setEnable(true);
end

function Lua_TargetPanel:onCheckTargetFar(val)
	local v = tonumber(tostring(PlayerData.getInstance().selectedId));
	if v ~= 0 then
		local thingVo = DataCenter.thingData:getThing(v);
		local pos;
		if thingVo == nil then
			thingVo = ThingUtil.instance:getThingById(v);
			if thingVo ~= nil then
				pos = {px = thingVo.data.px, py = thingVo.data.py, pz = thingVo.data.pz};
			else
				c_hookCurMonsterTarget(0, false);
				return;
			end
		else
			pos = thingVo;
		end

		local curPos = DataCenter.hook:getCurPos();
		local dis = math.abs(pos.px - curPos.x) + math.abs(pos.py - curPos.y) + math.abs(pos.pz - curPos.z);
		if self.trange == nil then
			self.trange = DataCenter.roleData.hookRange;
		end

		if dis > self.trange then
			c_hookCurMonsterTarget(0, false);
		end
	end
end

function Lua_TargetPanel:onSelectedTargetInfoUpdate()
	self:onSelectedTargetChange();
end

function Lua_TargetPanel:dispose()
	if self.monsterPanel ~= nil then
		self.monsterPanel:dispose();
		self.monsterPanel = nil;
	end
	if self.bossPanel ~= nil then
		self.bossPanel:dispose();
		self.bossPanel = nil;
	end
	DataCenter.poolPartyData.selectPlayrId = nil; -- 泳池派对，点击人物记录人物ID，请勿删除

	self:superCall("dispose");
end