-- 环式任务界面
Lua_DailyRoutineWindow = class("Lua_DailyRoutineWindow", Lua_Window)
function Lua_DailyRoutineWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DailyRoutineWindow";
	self.skinName = "DailyRoutineWindow_skin";
end

function Lua_DailyRoutineWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.frameBg.imgTypeNum = 4;
	self.frameBg.widget.border = Vector4(250, 0, 250, 0);
	self.titleNameText.text = LanUtil.getValue(122922);
	self.bar:SetDimensions(1, 16);

	self:addLuaEvent("ROUTINE_BOX_REWARD_INFO", self, self.onUpdateBoxState);
	DataCenter.taskData.needCheckRoutineWinClose = false;

	-- self.picBg = UICreate.createImage(self.content, "/images/common/routine_task_bg.png", -239, -28, 510, 552);
	-- self.picBg:setDepth(3);

	if getLanType() == 2 then
		self.arr = getConfig({"vip_level", DataCenter.vipData.level, "routine_value"});

		self.costGoldIcon:setAltas("icon_atlas_3", "money_20900000"..tostring(self.arr[1]));
		self.costOneGoldIcon:setAltas("icon_atlas_3", "money_20900000"..tostring(self.arr[1]));

		self.timeTxt = UICreate.createLabel(self.content, "", 0, -108, 200, 30, 20);
		self.timeTxt.name = "timeTxt";
		self.timeTxt.pivot = UIWidget.Pivot.Center;
		self.timeTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.timeTxt:setDepth(3);
		self.timeTxt:setEnable(false);

		self.autoChk = UICreate.createCheckBox(self.content, LanUtil.formateStr(LanUtil.getValue(122943),tostring(self.arr[3])), 308, -216, 192, 24);
		self.autoChk:setStyle(18);
		self.autoChk.txt.fontSize = 24;
		self.autoChk.txt.colorStr = Lua_ColorDefine.transColor("85A8BE", 1);
		self.autoChk:addBoxChange(self,self.autoClick);
		self.autoChk.depth = 5;

		self.isDouble = false;
		if DataCenter.neverTip:getNeverValue("DailyRoutineAutoClick") == true then
			self.autoChk.seleted = true;
			self.isDouble = true;
		end
		self.autoChk:setEnable(false);
		self.isCan = false;
	end
	
	self.oneKeyBtn:addClickFuntion(self,self.oneKeyClick);
	self.finishRoundBtn:addClickFuntion(self,self.onFinishRoundClick);
	self.startTaskBtn:addClickFuntion(self,self.onStartTaskClick);
	self.onekeyGetRewardBtn:addClickFuntion(self,self.onOneKeyClick);
	self:setAllComplete(false);
end

function Lua_DailyRoutineWindow:autoClick(val, checkChange)
	DataCenter.neverTip:setNeverValue("DailyRoutineAutoClick", self.autoChk.seleted);
	self.isDouble = self.autoChk.seleted;
end

function Lua_DailyRoutineWindow:setAllComplete(val)
	local showInfo = not val;
	
	self.curRoundLb:setEnable(showInfo);
	self.curTargetLb:setEnable(showInfo);
	self.curRewardLb:setEnable(showInfo);
	self.curRoundTxt:setEnable(showInfo);
	self.curTargetTxt:setEnable(showInfo);
	self.expTxt:setEnable(showInfo);
	self.copperTxt:setEnable(showInfo);
	self.copperIcon:setEnable(showInfo);
	self.expIcon:setEnable(showInfo);
	self.costLb:setEnable(showInfo);
	self.costGoldIcon:setEnable(showInfo);
	self.costTxt:setEnable(showInfo);
	self.oneKeyBtn:setEnable(showInfo);
	if val == true then
		self.finishRoundBtn:setEnable(showInfo);
		self.startTaskBtn:setEnable(showInfo);
	end
	
	self.costOneTxt:setEnable(showInfo);
	self.costOneGoldIcon:setEnable(showInfo);
	self.costOneLb:setEnable(showInfo);	
	
	self.getRewardTips:setEnable(val);
	self.onekeyGetRewardBtn:setEnable(val);

	if getLanType() == 2 and self.taskVo ~= nil then
		self.autoChk:setEnable(self.taskVo.routineIndex ~= 0 and showInfo);
		self.costTxt:setEnable(false);
		self.costLb:setEnable(false);
		self.costGoldIcon:setEnable(false);
		self.temp = tonumber(self.arr[2]);
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.temp, false, false) == true or DataCenter.moneyData:isMoneyEnough(209000000 + tonumber(self.arr[1]), self.temp, false, false) == true then
			self.costOneTxt.text = "[85A8BE]"..tostring(self.temp).."[-]";
			self.isCan = true;
		else
			self.costOneTxt.text = "[ff0000]"..tostring(self.temp).."[-]";
			self.isCan = false;
		end

		if self.taskVo.routineIndex == 0 and showInfo then
			self.startTaskBtn:setLocation(0,-190);
			self.oneKeyBtn:setEnable(false);
			self.costOneGoldIcon:setEnable(false);
			self.costOneTxt:setEnable(false);
			self.costOneLb:setEnable(false);
		elseif self.taskVo.status == Lua_TaskDefine.ACCEPTED and self.taskVo.taskId ~= Lua_TaskDefine.ROUNTINE_FINISH_TASK then
			self.oneKeyBtn:setEnable(true);
			self.oneKeyBtn.label = LanUtil.getValue(124116);
			self.finishRoundBtn.label = LanUtil.getValue(122952);
		end

		if self.taskVo.status == Lua_TaskDefine.DELIVERED and self.taskVo.routineIndex ~= 0 then
			self.oneKeyBtn.label = LanUtil.getValue(122901);
			self.finishRoundBtn.label = LanUtil.formateStr(LanUtil.getValue(122944), tostring(self.arr[3]));
			self.costOneGoldIcon:setAltas("icon_atlas_3", "money_20900000"..tostring(self.arr[1]));

			-- self.costGoldIcon:setEnable(false);
			-- self.costTxt:setEnable(false);
			-- self.costLb:setEnable(false);
			self.timeTxt:setEnable(true);
			self.isAuto = true;
			self.endTime = getTime() + 10;
			Lua_CommonUtil.removeTimer(self,self.checkAutoGet);
			Lua_CommonUtil.addTimer("autoGetRoutineReward", 0.5, self,self.checkAutoGet);
		end
	end
end

function Lua_DailyRoutineWindow:checkAutoGet()
	local now = getTime();
	if self.endTime ~= nil and now < self.endTime then
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122902), tostring(math.ceil(self.endTime - now)));
	else
		self.isAuto = true;
		self:hide();
	end
end

function Lua_DailyRoutineWindow:dispose()
	Lua_CommonUtil.removeTimer(self,self.checkAutoGet);
	if getLanType() == 2 and self.taskVo.status == Lua_TaskDefine.DELIVERED and self.isAuto == true then
		local cmd = getProtoMsg("Proto11400328");
		cmd.task_id = self.taskVo.taskId;
		if self.isDouble == true and self.isCan == true then
			cmd.is_double = 1;
		else
			self.autoChk.seleted = false;
			cmd.is_double = 0;
		end
		sendMsg(11400328, cmd);
	end
	self:superCall("dispose");
end

function Lua_DailyRoutineWindow:onUpdateBoxState()
	local boxInfo = DataCenter.taskData.routineBoxRewardInfo;
	if self.boxesList == nil then
		local myLvl =  DataCenter.taskData.rountRewardRoleLv
		local boxCfg = getConfig({"routine_box_rewards"});
		local curCfg = nil ;
		if boxCfg ~= nil then
			for k,v in ipairs(boxCfg) do
				if myLvl >= v.use_lvl[1] and myLvl <= v.use_lvl[2] then
					curCfg = v;
					break;
				end
			end
		end

		if curCfg ~= nil then
			local stageCount = curCfg.stage_count;
			self.lastRound = stageCount[#stageCount];
			self.boxesList =Array();
			local isDouble = true;
			for k,v in ipairs(curCfg.item_rewards) do
				isDouble = not isDouble;

				local titem = Lua_DailyRoutineBox.new(self.content, isDouble);
				local tx = stageCount[k] / self.lastRound * 500;
				titem:setLocation(-240 + tx, 165, 0);
				titem:setRound(stageCount[k]);
				titem:setData(v);
				titem:setShowItem(curCfg.client_show_item[k]);
				self.boxesList:add(titem);
			end
		end
	end
	self:setProcess();
	
	local routineIndex = self.taskVo.routineIndex;
	-- if self.taskVo.status == Lua_TaskDefine.DELIVERED then
	-- 	routineIndex = routineIndex +1;
	-- end
	
	local len = self.boxesList:getSize();
	local btnGray = true;
	for i = 1, len do
		if boxInfo[i] ~= nil and self.boxesList[i] ~= nil then
			local needShow = false;
			if boxInfo[i].value == 0  then
				if routineIndex > tonumber(boxInfo[i].id) then
					needShow = true;
				elseif DataCenter.taskData.routineIsAllComplete == 1 then
					needShow = true;
				end
			end
			self.boxesList[i]:setGot(boxInfo[i].value == 1);

			if boxInfo[i].value ~= 1 then
				btnGray = false;
			end
			self.boxesList[i]:showHideEffect(needShow);
		end
	end

	self:setAllComplete(DataCenter.taskData.routineIsAllComplete == 1);
	if btnGray then
		self:setBtnGray();
	end
end

function Lua_DailyRoutineWindow:setBtnGray()
	if DataCenter.taskData.needCheckRoutineWinClose == true then
		DataCenter.taskData.needCheckRoutineWinClose = false;
		Lua_WindowUtil.openWin("Lua_DailyRoutineWindow", WinParam.ACTION_CLOSE);
		return;
	end

	self.onekeyGetRewardBtn.label = LanUtil.getValue(110029);
	self.onekeyGetRewardBtn:setGray(true);
end

function Lua_DailyRoutineWindow:checkMirrorTaskLimit()
	-- 在镜像副本里面不让快速完成任务
	if self.taskVo == nil then
		return true;
	end

	if self.taskVo.config.under_task_type == 3 and tonumber(DataCenter.roleData.sceneId) == tonumber(self.taskVo.afterAcceptScene) then
		return false;
	end
	return true;
end

-- 完成本环
function Lua_DailyRoutineWindow:onFinishRoundClick()
	if getLanType() == 2 and self.taskVo.status == Lua_TaskDefine.DELIVERED and self.taskVo.routineIndex~=0 then
		if DataCenter.neverTip:getNeverValue("DailyRoutineBox2") == true then
			self:onStartTaskClick();
			return;
		end

		self.isDouble = true;
		local tipData = {};
		tipData.titleName = LanUtil.getValue(122946);
		if tonumber(self.arr[1]) == 1 then
			tipData.des = LanUtil.formateStr(LanUtil.getValue(122953), tostring(self.arr[2]), tostring(self.arr[3]));
		elseif tonumber(self.arr[1]) == 2 then
			tipData.des = LanUtil.formateStr(LanUtil.getValue(122954), tostring(self.arr[2]), tostring(self.arr[3]));
		elseif tonumber(self.arr[1]) == 3 then
			tipData.des = LanUtil.formateStr(LanUtil.getValue(122955), tostring(self.arr[2]), tostring(self.arr[3]));
		end

		-- if tonumber(self.arr[1]) ~= 3 then
		-- 	tipData.showHint = LanUtil.getValue(122950);
		-- end

		tipData.owner = self;
		tipData.type = 1;
		tipData.neverTip = "DailyRoutineBox2";
		tipData.subFun = self.onStartTaskClick;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		return;
	end

	if self:checkMirrorTaskLimit() == false then
		OperateAlert.show(LanUtil.getValue(122933));
		return;
	end

	local vipLv =DataCenter.roleData.vipType;
	local vipLimit = getConfig({"task_setting", "new_routine_fast_vip_limi"});
	if vipLv < vipLimit and getLanType() ~= 2 then
		local name = getConfig({"vip_level", vipLimit, "view_name"});
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122924), name));
		return;
	end

	local fastPreRoundCost = getConfig({"task_setting","routine_fast_money"});
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, fastPreRoundCost, true, true) == false then
		return;
	end

	if getLanType() == 2 then
		self.isAll = false;
		self:getFantiAllReward();
		return;
	end

	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.ONE_KEY_FINISH_ROUTINE) then
		self:finishCurRound(nil);
		return;
	end

	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(122928),tostring(fastPreRoundCost));
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.finishCurRound;
	tipData.neverTip = Lua_NeverTipData.ONE_KEY_FINISH_ROUTINE;	
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_DailyRoutineWindow:finishCurRound()
	local cmd = getProtoMsg("Proto11400346");
	cmd.type = 3;
	cmd.is_all = 0;
	sendMsg(11400346, cmd);
	self.isAuto = false;
	self:hide();
end
	
-- 一件完成所有环
function Lua_DailyRoutineWindow:oneKeyClick()
	if getLanType() == 2 then
		if self.taskVo.status == Lua_TaskDefine.DELIVERED and self.taskVo.routineIndex ~= 0 then
			self.isDouble = false;
			self:onStartTaskClick();
			return;
		else
			-- self:moveToTask();
			self.taskVo:exeTask();
			self:hide();
			return;
		end
	end

	if self:checkMirrorTaskLimit() == false then
		OperateAlert.show(LanUtil.getValue(122933));
		return;
	end

	local vipLv =DataCenter.roleData.vipType;
	local vipLimit = getConfig({"task_setting","new_routine_fast_vip_limi"}) ;
	if vipLv < vipLimit and getLanType() ~= 2 then
		local name = getConfig({"vip_level", vipLimit, "view_name"})
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122924), name));
		return;
	end

	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.costGold, true, true, true) == false then
		return;
	end

	if getLanType() == 2 then
		self.isAll = true;
		self:getFantiAllReward();
		return;
	end

	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.ONE_KEY_FINISH_ROUTINE) == true then
		self:onOkClick(nil);
		return;
	end

	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(122925), tostring(self.costGold));
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onOkClick;
	tipData.neverTip = Lua_NeverTipData.ONE_KEY_FINISH_ROUTINE;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_DailyRoutineWindow:getFantiAllReward()
	if DataCenter.neverTip:getNeverValue("DailyRoutineBox") == true then
		self:onOkClickDouble();
		return;
	end

    local tipData = {};
	-- self.allGold = self.costGold;
	-- local singleGold = self.costGold;
	-- if self.isAll == true then
	-- 	tipData.titleName = LanUtil.getValue(122945);
	-- 	local rand=self.taskVo.routineIndex<1 and self.taskVo.routineIndex or self.taskVo.routineIndex - 1;
	-- 	self.allGold = self.costGold+tonumber(self.arr[2]) * (self.taskVo.routineTotal - rand );
	-- 	singleGold = self.costGold;
	-- else
		tipData.titleName = LanUtil.getValue(122946);
	-- 	singleGold = getConfig({"task_setting","routine_fast_money"});
	-- 	self.allGold = tonumber(self.arr[2]);
	-- end

	if tonumber(self.arr[1]) == 1 then
		tipData.des = LanUtil.formateStr(LanUtil.getValue(122947), tostring(self.arr[2]), tostring(self.arr[3]));
	elseif tonumber(self.arr[1]) == 2 then
		tipData.des = LanUtil.formateStr(LanUtil.getValue(122948), tostring(self.arr[2]), tostring(self.arr[3]));
	elseif tonumber(self.arr[1]) == 3 then
		tipData.des = LanUtil.formateStr(LanUtil.getValue(122949), tostring(self.arr[2]), tostring(self.arr[3]));
	end

	-- if tonumber(self.arr[1]) ~= 3 then
	-- 	tipData.showHint = LanUtil.getValue(122950);
	-- end

	tipData.owner = self;
	tipData.type = 1;
	-- tipData.cancelName = LanUtil.getValue(122951)
	-- tipData.subName = LanUtil.formateStr(LanUtil.getValue(122952), tostring(self.arr[3]));
	tipData.neverTip = "DailyRoutineBox";
	tipData.subFun = self.onOkClickDouble;
	-- tipData.cancelFun = self.onOkClickFanti;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end
function Lua_DailyRoutineWindow:onOkClickDouble(val)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD,tonumber(self.arr[2]), true, true, true) == false then
		return;
	end

	local cmd = getProtoMsg("Proto11400346");
	cmd.type = 3;
	if self.isAll == true then
		cmd.is_all = 1;
	else
		cmd.is_all = 0;
	end
	sendMsg(11400346,cmd);
	self.isAuto = false;
	self:hide();
end

function Lua_DailyRoutineWindow:onOkClickFanti(val)
	local cmd = getProtoMsg("Proto11400346");
	cmd.type = 3;
	if self.isAll == true then
		cmd.is_all = 1;
	else
		cmd.is_all = 0;
	end
	sendMsg(11400346,cmd);
	self.isAuto = false;
	self:hide();
end

function Lua_DailyRoutineWindow:onOkClick(val)
	local cmd = getProtoMsg("Proto11400346");
	cmd.type = 3;
	cmd.is_all = 1;
	sendMsg(11400346,cmd);
	self.isAuto = false;
	self:hide();
end

function Lua_DailyRoutineWindow:onStartTaskClick()
	local cmd = getProtoMsg("Proto11400328");
	cmd.task_id = self.taskVo.taskId;
	if getLanType() == 2 then
		if self.isDouble == true then
			cmd.is_double = 1;
		else
			cmd.is_double = 0;
		end
		self.isAuto = false;
	end
	sendMsg(11400328,cmd);
	self:hide();
end

function Lua_DailyRoutineWindow:onOneKeyClick()
	local bCan = false;
	local len = self.boxesList:getSize();
	for i=1,len do
		if self.boxesList[i].canGetReward == true then
			local cmd = getProtoMsg("Proto11400352");
			cmd.box_index = self.boxesList[i].routine_index;
			sendMsg(11400352,cmd);
			bCan = true;
			self:setBtnGray();
		end
	end
	
	-- 已经完成所有环线任务
	if bCan == true and DataCenter.taskData.routineIsAllComplete == 1 then
		DataCenter.taskData.needCheckRoutineWinClose = true;
	end
end

function Lua_DailyRoutineWindow:showWin(param)
	self.taskVo = param;
	
	if self.taskVo.status == Lua_TaskDefine.ACCEPT then
		self.startTaskBtn:setEnable(true);
		self.finishRoundBtn:setEnable(false);
		self.costOneLb:setEnable(false);
		self.costOneGoldIcon:setEnable(false);
		self.costOneTxt:setEnable(false);
	else
		self.startTaskBtn:setEnable(false);
		self.finishRoundBtn:setEnable(true);
		self.costOneLb:setEnable(true);
		self.costOneGoldIcon:setEnable(true);
		self.costOneTxt:setEnable(true);
	end
	
	sendMsg(11400351, nil);
	-- sendMsg(11400352, nil);
end

function Lua_DailyRoutineWindow:setProcess()
	self.curRoundTxt.text =tostring(self.taskVo.routineIndex).."/"..tostring(self.taskVo.routineTotal);
	local process = self.taskVo.routineIndex / self.lastRound;
	if process > 1 then
		process = 1;
	end
	self.bar:SetDimensions(process * 475, 16);
	
	local roleLvl = DataCenter.roleData.level;
	local expRewards = getConfig({"routine_ordinary_rewards",roleLvl});
	-- self.taskVo.config.under_task_type ~= 0 and 
	if expRewards ~= nil and DataCenter.taskData.routineIsAllComplete ~= 1  then
		self.expTxt.text = Lua_CommonUtil.getNumberTrans(tonumber(expRewards["exp_value_"..self.taskVo.config.under_task_type]));			
		self.copperTxt.text = Lua_CommonUtil.getNumberTrans(tonumber(expRewards["money_value_"..self.taskVo.config.under_task_type]));		
	end
	
	self.curTargetTxt.text = self.taskVo.curDesc;
	local fastPreRoundCost = getConfig({"task_setting","routine_fast_money"});
	local leftRound = self.taskVo.routineTotal - self.taskVo.routineIndex +1; 
	if DataCenter.taskData.routineIsAllComplete == 0 and self.taskVo.config.under_task_type == 0 then
		-- 第一轮虚拟任务不算消耗元宝,其他需要+1
		leftRound = self.taskVo.routineTotal - self.taskVo.routineIndex ; 
	end
	self.costGold = fastPreRoundCost * leftRound;
	
	if self.taskVo.status == Lua_TaskDefine.ACCEPT then
		-- 未接取状态下，显示0消耗
		fastPreRoundCost = 0;
	end
	
	local colorStr = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGold, false, false) and "[85A8BE]" or "[FF1616]";	
	self.costTxt.text = colorStr .. self.costGold .. "[-]";
	
	colorStr = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, fastPreRoundCost, false, false) and "[85A8BE]" or "[FF1616]";
	self.costOneTxt.text = colorStr .. fastPreRoundCost .. "[-]";
end





--------------------------------------------------





Lua_DailyRoutineBox = class("Lua_DailyRoutineBox", Lua_DisplayObject);
function Lua_DailyRoutineBox:ctor(p, isDouble)
	self:superCall("ctor", p, "DailyRoutineBox_skin");

	self.canGetReward = false;
	self.isDouble = isDouble;
end

function Lua_DailyRoutineBox:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon:addClickFuntion(self, self.onBoxClick);
	self.boxIcon:addLoadCompleteFun(self, self.onLoadCompleteFun);
end

function Lua_DailyRoutineBox:setData(val)
	self.data = val;
end

function Lua_DailyRoutineBox:onBoxClick()
	if self.canGetReward == false then
		local boxInfo = DataCenter.taskData.routineBoxRewardInfo;
		for k,v in ipairs(boxInfo) do
			if tonumber(v.id) == tonumber(self.routine_index) and v.value == 1 then
				-- OperateAlert.show(LanUtil.getValue(122931));
				return;
			end
		end

		if self.showBoxToolVo ~= nil then
			Lua_PackUtil.showItemInfo(self.showBoxToolVo, false);
		end
		-- OperateAlert.show(LanUtil.getValue(122930));
	else
		local cmd = getProtoMsg("Proto11400352");
		cmd.box_index = self.routine_index;
		sendMsg(11400352,cmd);
		DataCenter.taskData.needCheckRoutineWinClose = true;
	end
end

function Lua_DailyRoutineBox:onLoadCompleteFun()
	self.boxIcon:resetSize();
end

function Lua_DailyRoutineBox:setShowItem(itemData)
	self.showBoxToolVo = Lua_ToolVo.createToolVo(itemData[1], itemData[2], itemData[3]);
end

function Lua_DailyRoutineBox:showHideEffect(val)
	self.canGetReward = val;
	if val == true then
		if self.qualityEff == nil then
			self.qualityEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_kaiqibaoxiang", "gui_kaiqibaoxiang", 0, 0);
			self.qualityEff:setLoop(true);
		end
		self.qualityEff:SetRenderQueue(self.boxIcon, 1, 2,false);
	else
		if self.qualityEff ~= nil then
			self.qualityEff:dispose();
			self.qualityEff  = nil;
		end
	end

	-- local curRoutineTask = DataCenter.taskData:getListByType(Lua_TaskDefine.ROUTINE)[1];
	-- 索引小于等于当前环数，并且需要隐藏特效的，说明已领，显示已领宝箱
	-- if curRoutineTask ~= nil and self.routine_index <= curRoutineTask.routineIndex then
	-- end
end

function Lua_DailyRoutineBox:setGot(val)
	local boxSp;
	if self.isDouble then
		if val then
			boxSp = "ui_common_baoxiang1_2";
		else
			boxSp ="ui_common_baoxiang2";
		end
	else
		if val then
			boxSp = "ui_common_baoxiang1_s";
		else
			boxSp ="ui_common_baoxiang1";
		end
	end
	self.boxIcon:setAltas("common_atlas_2", boxSp);
end

function Lua_DailyRoutineBox:setRound(val)
	self.routine_index =val;
	self.boxTxt1.text = LanUtil.formateStr(LanUtil.getValue(122923), tostring(val));
end