Lua_NeedDoNowWindow = class("Lua_NeedDoNowWindow", Lua_Window);
function Lua_NeedDoNowWindow:ctor()
	self:superCall("ctor");

	self.layer = 3450;
	self.showClose = false;
	self.isModel = false;
	self.skinName ="NeedDoNowWindow_skin";
	self.windowName ="Lua_NeedDoNowWindow";
end

function Lua_NeedDoNowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList = Array();

	self:onScreenResize();

	self.cfgList = DataCenter.taskData:getNeedDoList();
	-- 长度为0不显示
	if self.cfgList:getSize() == 0 then
		self:addTimer("delayHide",0.01,self,self.hide);
		return;
	end

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, -112, 158, 218));
	self.dragList:setLocation(0, 0, 0);
	self.dragList:setListCell(Lua_NeedDoNowItem, 55, 158, 1);
	self.dragList:setLuaArrayData(self.cfgList, true);

	local len = self.cfgList:getSize();
	local bgHeight = 30 + len * 58;
	if bgHeight > 230 then
		bgHeight = 230;
	end
	self.bg:SetDimensions(162,bgHeight);

	self:addCSharpEvent("SCREEN_RESIZE", self, self.onScreenResize);
end

function Lua_NeedDoNowWindow:onScreenResize()
	local half_w = MainWinDefine.V_width / 2;
	local half_h = MainWinDefine.V_height / 2;
	-- self.content.transform.localPosition = Vector3(-half_w+370,half_h-218,0);
	LuaUtil.setObjPos(self.content, -half_w+370, half_h-218, 0);
end

function Lua_NeedDoNowWindow:setWinPosition()
end

-- function Lua_NeedDoNowWindow:onBtnClick(go)
-- 	local idx = self.btnList:indexOf(go);
-- 	print("Lua_NeedDoNowWindow:onBtnClick",idx);
-- end

-- function Lua_NeedDoNowWindow:createBtn()
-- 	local tbtn =  UICreate.createButton(self.content,"",0,0,141,54);
-- 	tbtn:setStyle(4);
-- 	tbtn.txt.color= Color.New(116/255, 64/255, 0, 1);
-- 	tbtn.txt.effectStyle=0;
-- 	tbtn.txt.fontSize = 24;
-- 	tbtn:setDepth(self.depth+2);
-- 	return tbtn;
-- end





--------------------------------------------------





Lua_NeedDoNowItem =  class("Lua_NeedDoNowItem",Lua_ListCell)
function Lua_NeedDoNowItem:ctor(p)	
	self:superCall("ctor", p,"NeedDoNowItem_skin");
end

function Lua_NeedDoNowItem:setData(cfg)
	self.cfg = cfg;
	self.labelTxt.text = self.cfg.btn_label;
end

function Lua_NeedDoNowItem:onPlayerSoundClick(go)
	Lua_WindowUtil.openWin("Lua_NeedDoNowWindow",WinParam.ACTION_CLOSE);
	if self.cfg == nil or self.cfg.action == nil then
		return;
	end

	local action = self.cfg.action;
	if action.type == 1 then
		--打开UI
		Lua_WindowUtil.openWin(action.win,WinParam.ACTION_OPEN,action.param);
	elseif action.type == 2 then
		--派发事件
		Lua_MsgUtil.callFunc(action.event,action.param);
	elseif action.type == 3 then
		--执行某类型任务

		local tlist = DataCenter.taskData:getListByType(action.taskType);
		if tlist ~= nil and tlist:getSize()>0 then
			local ttask = tlist[1];
			if ttask.taskType == Lua_TaskDefine.ROUTINE then
				local canExcu = DataCenter.taskData:handelOpenDailyTask(ttask);
				if canExcu == false then
					return;
				end
			end
			tlist[1]:exeTask();
		end
	end
end