-- 社团环任务捐献界面
Lua_SubmitEquToFactionWindow = class("Lua_SubmitEquToFactionWindow", Lua_Window);
function Lua_SubmitEquToFactionWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SubmitEquToFactionWindow";
	self.skinName = "SubmitEquToFactionWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
	self.blackAlpha = 0.5;
end

function Lua_SubmitEquToFactionWindow:buildShowItem()
	self:superCall("buildShowItem");

	local half_w = MainWinDefine.V_width / 2;
	local half_h = MainWinDefine.V_height / 2;
	-- self.content.transform.localPosition = Vector3(-half_w + 450, half_h - 340, 0);
	LuaUtil.setObjPos(self.content, -half_w + 450, half_h - 340, 0);

	self.curSelectEqu = nil;

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 300, 250));
	self.dragList:setListCell(Lua_SubmitEquToFactionItem, 98, 300, 1);
	self.dragList:setLocation(0, 17, 0);

	self.submitBtn:addClickFuntion(self, self.onSubmitClick);

	self:addLuaEvent("SUBMIT_EQU_TO_FACTION_SELECT", self, self.onSelectCallback);
end

-- param = {taskId = 任务id, quality = 装备品质, grade = 装备阶数}
function Lua_SubmitEquToFactionWindow:showWin(param)
	self.taskId = param.taskId;
	local needStar = 0;
	if param.star ~= nil then
		needStar = param.star;
	end

	local bagItems = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getBagAllData();
	local otherList =Array();
	local purpleList = Array();
	for i = 1, bagItems:getSize() do
		-- 符合装备品质、阶数的才显示
		if bagItems[i].subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 上交物品屏蔽骑装
			if bagItems[i].config.type == 1 and bagItems[i].color >= param.quality and bagItems[i].order >= param.grade
				and bagItems[i].star >= needStar then
				if bagItems[i].color == 3 then
					purpleList:add(bagItems[i]);
				else
					otherList:add(bagItems[i]);
				end
			end
		end
	end

	if purpleList:getSize() ~= 0 then
		purpleList:sort("submitEquPr", false);
		self.dragList:setLuaArrayData(purpleList, false);
	else
		otherList:sort("submitEquPr", false);
		self.dragList:setLuaArrayData(otherList, false);
	end
	self.dragList:setSelected(1);
end

function Lua_SubmitEquToFactionWindow:onSelectCallback(val)
	self.curSelectEqu = val;
end

function Lua_SubmitEquToFactionWindow:onSubmitClick(go)
	if self.dragList.data:getSize() == 0 then
		OperateAlert.show(LanUtil.getValue(122921));
		return;
	end

	if self.curSelectEqu ~= nil then
		local cmd = getProtoMsg("Proto11400338");
		cmd.task_id = self.taskId;
		cmd.item_list:append(self.curSelectEqu.index);
		sendMsg(11400338, cmd);
	end
	self:hide();
end

function Lua_SubmitEquToFactionWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_SubmitEquToFactionItem = class("Lua_SubmitEquToFactionItem",Lua_ListCell)
function Lua_SubmitEquToFactionItem:ctor(p)
	self:superCall("ctor", p, "SubmitEquToFactionItem_skin");

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setScale(0.8, 0.8);
	self.toolImg:setCanClick(false);
	self.toolImg:setLocation(-100, 3, 0);
end

function Lua_SubmitEquToFactionItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.toolImg.data = data;
	self.toolImg:showNewTip(false);

	self.nameLab.text = data.colorName;
	self.scoreTxt.text = LanUtil.formateStr(LanUtil.getValue(122919), tostring(data.force));
end

function Lua_SubmitEquToFactionItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		Lua_MsgUtil.callFunc("SUBMIT_EQU_TO_FACTION_SELECT", self._data);
	end
	self.selectIcon:setEnable(val);
end

function Lua_SubmitEquToFactionItem:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end