checkRequire("Lua_TeamPanel");
checkRequire("Lua_TaskPanel");
checkRequire("Lua_MonsterListPanel");
Lua_TaskAndTeamPanel = class("Lua_TaskAndTeamPanel", Lua_DisplayObject);
function Lua_TaskAndTeamPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_TaskAndTeamPanel";
	self.subContainer = UICreate.createGameObject(self.content, 0, 0);

	local arr = Array();
	arr:add(LanUtil.getValue(107491));
	arr:add(LanUtil.getValue(120204));

	self.btnList = Lua_ButtonList.new(self.subContainer, arr, 113, self, self.onButtonListClick,
		"ui_zhujiemian_title_02", "ui_zhujiemian_title_01", Vector4(0, 0, 112, 32), Vector4(0, 0, 112, 32),
		Lua_ColorDefine.transColor("F2F7FF"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(22, 22, 112, 32), 2, 
		"mainWindow_atlas", Vector3(0, 0, 0), Vector3(0, 0, 0), "2D3640", "815800");
	self.btnList:setLocation(66, -15, 0);
	self.btnList:setDepth(5);
	self.btnList:setSelected(1, true);
	
	-- 怪物攻城显示排行榜UI图标
	self.rankBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_bang", 0, 0, 0, 0);
	self.rankBtn.name = "rankBtn";
	self.rankBtn.clickScale = false;
	self.rankBtn:addClickFuntion(self, self.onOpenRankClick);
	self.rankBtn:setEnable(false);

	self.hideBtnBg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_title_03", 253, -19, 35, 43);
	self.hideBtnBg.name = "hideBtnBg";
	self.hideBtnBg.clickScale = false;
	self.hideBtnBg:addClickFuntion(self, self.onHideBtnClick);
	self.hideBtnBg:setDepth(1);

	self.hideBtn = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_jiantou_02", 253, -15, 17, 25);
	self.hideBtn.name = "hideBtn";
	self.hideBtn:setDepth(2);

	self.isShowing = false;
	self:setShowHide(true);
	self:onTeamInfoUpdate();

	self:addLuaEvent("MONSTER_LIST_SWITCH", self, self.onMonsterListChange);
	self:addLuaEvent("TEAM_INFO_UPDATE", self, self.onTeamInfoUpdate);
	self:addLuaEvent("OPEN_MONSTER_ISSTATE", self, self.openMonsterIsState);
	self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded);
end

function Lua_TaskAndTeamPanel:onMonsterListChange(state)
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneConfig.show_monster_list == 1 then
		if state == 1 then
			self.btnList.pageArr[1].txt.text = LanUtil.getValue(110039);
		else
			self.btnList.pageArr[1].txt.text = LanUtil.getValue(110040);
		end
	else
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(107491);
	end
end

function Lua_TaskAndTeamPanel:onSceneLoaded()
	if self.panelState ~= nil then
		self:onButtonListClick(self.panelState);
	end
end

-- 队伍信息更新
function Lua_TaskAndTeamPanel:onTeamInfoUpdate(o)
	local teamData = DataCenter.teamData;
	if teamData.hasTeam and teamData.teamerArr:getSize() > 1 then
		self.btnList:setBtnTextByIdx(LanUtil.getValue(120204).."x"..teamData.teamerArr:getSize(), 2);
	else
		self.btnList:setBtnTextByIdx(LanUtil.getValue(120204), 2);
	end
end

-- function Lua_TaskAndTeamPanel:testUIImage()
-- 	local path = "Lua_MainMenuWindow/content/Lua_SkillIconPanel/gameObject/icon10015/iconSp";
-- 	local tgo = LuaUtil.getUIItem(path);
-- 	if tgo == nil then
-- 		return;
-- 	end
-- 	self.uiImage = UIImageTexture();
-- 	self.uiImage.init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 550);
-- end

function Lua_TaskAndTeamPanel:onHideBtnClick(go)
	self:setShowHide(not self.isShowing);
end

function Lua_TaskAndTeamPanel.Get:taskPanel()
	if self._taskPanel == nil then
		self._taskPanel = Lua_TaskPanel.new(self.subContainer);
	end
	return self._taskPanel;
end

function Lua_TaskAndTeamPanel.Get:monsterListPanel()
	if self._monsterListPanel == nil then
		self._monsterListPanel = Lua_MonsterListPanel.new(self.subContainer);
		self._monsterListPanel:setLocation(130, 0);
	end
	return self._monsterListPanel;
end

function Lua_TaskAndTeamPanel.Get:teamPanel()
	if self._teamPanel == nil then
		self._teamPanel = Lua_TeamPanel.new(self.subContainer);
		self._teamPanel:setLocation(0, -160);
	end
	return self._teamPanel;
end

function Lua_TaskAndTeamPanel:setShowHide(val)
	self.isShowing = val;
	self.subContainer:SetActive(val);

	if self.isShowing then
		self.hideBtn:setSacle(1, 1);
		self.hideBtn:setLocation(253, -16, 0);
		self.hideBtnBg:setLocation(253, -19, 0);
		self.rankBtn:setLocation(293, -15, 0);
	else
		self.hideBtn:setSacle(-1, 1);
		self.hideBtn:setLocation(20, -16, 0);
		self.hideBtnBg:setLocation(20, -19, 0);
		self.rankBtn:setLocation(60, -15, 0);

		if Lua_WindowUtil.isWindowShowing("Lua_NeedDoNowWindow") then
			Lua_WindowUtil.openWin("Lua_NeedDoNowWindow", WinParam.ACTION_CLOSE);
		end
		if Lua_WindowUtil.isWindowShowing("Lua_MenuPopListWindow") then
			Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_CLOSE);
		end
	end
	DataCenter.taskData.zoomOutTaskUI = self.isShowing;
	Lua_MsgUtil.callFunc("TASK_AND_TEAM_PANEL_SHOWHIDE", self.isShowing);
end

function Lua_TaskAndTeamPanel:onButtonListClick(val)
	self.panelState = val;
	if val == 1 then
		local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if sceneConfig.show_monster_list == 1 then
			if self._taskPanel ~= nil then
				self.taskPanel:setEnable(false);
			end
			self.monsterListPanel:setEnable(true);
			self.monsterListPanel:updateMonsterList();
		else
			if self._monsterListPanel ~= nil then
				self._monsterListPanel:setEnable(false);
			end
			self.taskPanel:setEnable(true);
			self:onMonsterListChange();
		end
		
		if self._teamPanel ~= nil then
			self.teamPanel:setEnable(false);
		end
	else
		if self._monsterListPanel ~= nil then
			self._monsterListPanel:setEnable(false);
		end

		if self._taskPanel ~= nil then
			self.taskPanel:setEnable(false);
		end
		self.teamPanel:setEnable(true);
	end
end

function Lua_TaskAndTeamPanel:openMonsterIsState(state)
	if state == nil or state == 0 then
		self.rankBtn:setEnable(false);
	else
		self.rankBtn:setEnable(true);
	end
end

function Lua_TaskAndTeamPanel:onOpenRankClick()
	Lua_WindowUtil.openWin("Lua_MonsterComeRankWindow", WinParam.ACTION_OPEN);
end