checkRequire("Lua_TaskItemGuide");
checkRequire("Lua_TaskChapterItem");
checkRequire("Lua_TaskDefine")
checkRequire("Lua_RoutineTaskGuideTips");
Lua_TaskPanel = class("Lua_TaskPanel", Lua_DisplayObject);
function Lua_TaskPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.taskSortIdxByType = Array(
		Lua_TaskDefine.CAR,
		Lua_TaskDefine.TRUCK,
		Lua_TaskDefine.PROFESSION,
		Lua_TaskDefine.ROUTINE,
		Lua_TaskDefine.XIANSHI,
		Lua_TaskDefine.LEAGUE,
		Lua_TaskDefine.RELATION, 
		Lua_TaskDefine.BRANCH
	);
	self.chapterItem = Lua_TaskChapterItem.new(self.content);
	
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 260, 280));
	self.dragList:setListCell(Lua_TaskItem, 70, 256, 1);
	self.dragList:setLocation(140, -172, 0);

	if getShowTips() == false then
		self.showTaskListType = Array(Lua_TaskDefine.TRUCK);
	else
		self.showTaskListType = Array(
			Lua_TaskDefine.TRUCK,
			Lua_TaskDefine.PROFESSION,
			Lua_TaskDefine.ROUTINE,
			Lua_TaskDefine.BRANCH,
			Lua_TaskDefine.LEAGUE,
			Lua_TaskDefine.CAR,
			Lua_TaskDefine.XIANSHI
		);
	end
	self:addLuaEvent("TASK_UPDATE", self, self.updateTaskList);
	self:addLuaEvent("OPEN_SUBMIT_EQU_TO_FACTION", self, self.openSubmitMenu);
	self:addLuaEvent("FUNCTION_OPEN", self, self.onFunctionOpen);
	self:addLuaEvent("SHOW_ROUTINE_TASK_GUIDE_TIPS", self, self.showRoutineTaskGuideTips);
	self:updateTaskList();
end

function Lua_TaskPanel:onFunctionOpen(openIds)
	if openIds:indexOf(10026) == -1 or getShowTips() == false then
		return;
	end
	-- 刚开启每日环任务功能的时候，自动选择每日环任务
	self.checkSelectRountin = 1;
end

function Lua_TaskPanel:updateTaskList()
	local typesLen = self.showTaskListType:getSize();
	local arr;
	local list = Array();
	local resortList = Array();
	for i = 1, typesLen do
		arr = DataCenter.taskData:getListByType(self.showTaskListType[i]);
		for j = 1, arr:getSize() do
			list:add(arr[j]);
			if arr[j]:canShowArraow() then
				resortList:add(arr[j]);
			end
		end
	end
	list:sortf(self, self.sortFun);
	resortList:sort("arrow_sort", false);

	local stvo;
	local idx;
	for i = 1, resortList:getSize() do
		stvo = resortList[i];
		idx = list:indexOf(stvo);
		if idx > stvo.arrow_sort then
			list:removeItem(stvo);
			if stvo ~= nil then
				list:add(stvo, stvo.arrow_sort);
			end
		end
	end
	
	local truckTaskList =  DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK)
	local hasChapter = false;
	if truckTaskList:getSize() > 0 and truckTaskList[1].chapterData ~= nil then
		hasChapter = true;
		self.chapterItem:setData(truckTaskList[1]);
		self.chapterItem:setEnable(true);
		self.chapterItem:setLocation(138, -78, 0);

		if self.chapterShow ~= 1 then
			self.dragList:clearList();
		end
		self.chapterShow = 1;
	else
		hasChapter = false;
		self.chapterItem:setEnable(false);

		if self.chapterShow ~= 2 then
			self.dragList:clearList();
		end
		self.chapterShow = 2;
	end
	local posY = hasChapter and -213 or -172;
	local height = hasChapter and 180 or 280;
	self.dragList:setRect(Vector4(0, 0, 260, height));
	self.dragList:setLuaArrayData(list, false);
	self.dragList:setLocation(140, posY, 0);

	local arr = self.dragList.showList;
	if self.checkSelectRountin == 1 and arr:getSize() > 1 then -- 刚开启每日环任务功能的时候，自动选择每日环任务。为了指引能显示
		local item;
		for i = 1, arr:getSize() do
			item = arr[i];
			if item.data.taskType == Lua_TaskDefine.TRUCK then
				item:onSelectionChange(false);
				item:disposeCantAcceptEffect();
			elseif item.data.taskType == Lua_TaskDefine.ROUTINE then
				item:onSelectionChange(true);
				item:doShowCantAcceptEffect();
				self.checkSelectRountin = nil;
			end
		end		
	end
end

function Lua_TaskPanel:showRoutineTaskGuideTips()
	local arr = self.dragList.showList;
	local item;
	for i = 1, arr:getSize() do
		item = arr[i];
		if item.data.taskType == Lua_TaskDefine.TRUCK then
			item:onSelectionChange(false);
		elseif item.data.taskType == Lua_TaskDefine.ROUTINE then
			DataCenter.taskData.showingRoutineGuideTaskId = item.data.taskId;
			item:onSelectionChange(true);
			item:showRoutineGuideTips();
		end
	end
end

function Lua_TaskPanel:sortFun(ta, tb)
	-- 主线任务没有断的时候，永远排第一，断了的话，有环线任务则环线任务排第一，主线第二
	if ta.taskType == Lua_TaskDefine.TRUCK then
		if ta.status == Lua_TaskDefine.UNACCEPT then
			return tb.taskType ~= Lua_TaskDefine.ROUTINE;
		else
			return true;
		end
	elseif tb.taskType == Lua_TaskDefine.TRUCK then
		if tb.status == Lua_TaskDefine.UNACCEPT then
			return ta.taskType == Lua_TaskDefine.ROUTINE;
		else
			return false;
		end
	end

	-- 断了的话，有环线任务则环线任务排第一
	local mainTaskVo = DataCenter.taskData.mainTaskVo;
	if mainTaskVo == nil or mainTaskVo.status == Lua_TaskDefine.UNACCEPT then
		if ta.taskType == Lua_TaskDefine.ROUTINE then
			return true;
		elseif tb.taskType == Lua_TaskDefine.ROUTINE then
			return false;
		end
	end
	
	-- 其他完成的排前面
	if ta.taskType == Lua_TaskDefine.PROFESSION then		
		if DataCenter.changeJobData.iscolorProfession then
			if tb.status == Lua_TaskDefine.DELIVERED then
				return self.taskSortIdxByType:indexOf(ta.taskType) < self.taskSortIdxByType:indexOf(tb.taskType);
			end
			return true;		
		end
	elseif tb.taskType == Lua_TaskDefine.PROFESSION then
		if DataCenter.changeJobData.iscolorProfession then
			if ta.status == Lua_TaskDefine.DELIVERED then
				return self.taskSortIdxByType:indexOf(ta.taskType) < self.taskSortIdxByType:indexOf(tb.taskType);
			end
			return false;		
		end
	end
	
	if ta.status == Lua_TaskDefine.DELIVERED then
		return true
	elseif tb.status == Lua_TaskDefine.DELIVERED then 
		return false;
	end

	if ta.taskType == Lua_TaskDefine.BRANCH and tb.taskType == Lua_TaskDefine.BRANCH then
		return ta.task_sort < tb.task_sort;
	end
	return self.taskSortIdxByType:indexOf(ta.taskType) < self.taskSortIdxByType:indexOf(tb.taskType);
end

function Lua_TaskPanel:openSubmitMenu(val)
	local sceneId = DataCenter.roleData.sceneId;
    local menuItem = getConfig({"scene", sceneId, "menu_item"});
	local canShow = false;
	for k,v in ipairs(menuItem) do
		if v == Lua_MainMenuWindow.TASKANDTEAM_INDEX then
			canShow = true;
			break;
		end
	end

	local taskVo = DataCenter.taskData:getTaskById(val);
	if canShow and taskVo ~= nil then
		local menuTypes = Array();
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_SUBMIT_EQU_TO_FACTION, {taskId = val, quality = taskVo.conditionQuality, grade = taskVo.conditionGrade, star = taskVo.conditionStar}));
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_OPEN_MARKET, nil));
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_OPEN_FACTION_DEPOT, nil));
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_FAST_FINISH_TASK, val));
		Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_OPEN, menuTypes);
		Lua_MsgUtil.callFunc("UPDATE_MENU_POP_LIST_POSITION", Vector3(-MainWinDefine.V_width / 2 + 270, MainWinDefine.V_height / 2 - 280, 0));
	end
end





--------------------------------------------------





Lua_TaskItem = class("Lua_TaskItem",Lua_ListCell)
function Lua_TaskItem:ctor(p)
	self:superCall("ctor", p, "TaskItem_skin");
end

function Lua_TaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selected_show = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xzk", 0, 0, 266, 80);
	self.selected_show.name = "selected_show";
	self.selected_show:setDepth(3);

	self.selected_hide = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xzk", 0, 0, 266, 80);
	self.selected_hide.name = "selectedBg";
	self.selected_hide.alpha = 0.1;
	self.selected_hide:addClickFuntion(self, self.onContentClick);
	self.selected_hide:setDepth(-2);

	self.flyShoes =  UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_icon_21", 101, 0, 32.5, 45);
	self.flyShoes.name = "flyShoes";
	self.flyShoes:setDepth(4);
	self.flyShoes:addClickFuntion(self, self.onFlyClick);

	self.giftbox = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_xianshibaoxiang", "gui_xianshibaoxiang", 101, -13);
	self.giftbox.name = "giftbox";
	self.giftbox:setDepth(5);
	self.giftbox:SetRenderQueue(self.titleTxt, 10, 2, false);

	self.boxIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_baoxiang2", 101, -13, 0, 0);
	self.boxIcon.name = "boxIcon";
	self.boxIcon:setSacle(0.4, 0.4);
	self.boxIcon:setDepth(6);
end

function Lua_TaskItem:setData(taskVo)
	self.data = taskVo;
	if taskVo == nil then
		return;
	end

	self.showBoxState = taskVo.taskType == Lua_TaskDefine.XIANSHI;

	local titleColor = Lua_TaskDefine.getTaskTitleColor(taskVo.status, taskVo.taskType);
	local titleName = Lua_TaskDefine.getTaskNameTitle(taskVo.taskType);
	local titleStatus = Lua_TaskDefine.getTaskStatusLabel(taskVo.status);
	self.titleTxt.text = titleColor .. titleName .. taskVo.name .. taskVo.rountineStr .. titleStatus;
	if taskVo.taskType == Lua_TaskDefine.XIANSHI and taskVo.status == Lua_TaskDefine.ACCEPTED then
		self:addTimer("xianshi", 0.5, self, self.onXianShiCountDown);
		self:onXianShiCountDown();
	else
		Lua_CommonUtil.removeTimer(self, self.onXianShiCountDown);
	end

	local contentColor = taskVo.taskId == Lua_TaskDefine.ROUNTINE_FINISH_TASK and "[00E125]" or Lua_TaskDefine.getTaskContentColor(taskVo.status);
	self.contentTxt.text = contentColor .. taskVo.curDesc.."[-]";
	
	if taskVo.taskType == Lua_TaskDefine.ROUTINE and taskVo.status ~= Lua_TaskDefine.ACCEPT then
		if self.autoMark == nil then
			self.autoMark = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_zhujiemian_icon_26", 0, 0, 0, 0)
			self.autoMark:setDepth(4);
			self.autoMark:addClickFuntion(self, self.onAutoMarkClick);
		end
		self.autoMark:setEnable(true);
	else
		if self.autoMark ~= nil then
			self.autoMark:setEnable(false);
		end
	end
	if self.autoMark ~= nil then
		self.autoMark:setLocation(-116 + self.titleTxt.width + 9, 12, 0);
	end

	self:updateGiftBoxState();
	self:showPointEffect(taskVo.newTask == 1);
	self:showCantAcceptGuideTxtImg();
	self:showCantAcceptEffect();

	local needshow = self.data:curStatusShowFlyShoesEffect();
	if needshow then
		self:createFlyShoestEffect();
	else
		self:disposeFlyShoestEffect();
	end

	local guide = DataCenter.taskData.showingRoutineGuideTaskId;
	if guide and guide == taskVo.taskId then
		self:showRoutineGuideTips();
	else
		self:hideRoutineGuideTips();
	end

	-- 支线 战力变强类型，要显示变强图标
	self:showHideBeStrongIcon(taskVo.taskType == Lua_TaskDefine.BRANCH and taskVo.subType == 800 and taskVo.status == Lua_TaskDefine.ACCEPTED);

	if self.data:canShowArraow() then
		if self.flyArrowEffect == nil then
			self.flyArrowEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..self.data.arrow_effect, self.data.arrow_effect, 310, 0);
			self.flyArrowEffect:setDepth(5);
			self.flyArrowEffect:SetRenderQueue(self.titleTxt, 10, 2, false);
		end
	else
		if self.flyArrowEffect ~= nil then
			self.flyArrowEffect:dispose();
			self.flyArrowEffect = nil;
		end
	end
	self.flyShoes:setEnable(self.data:curStatusShowFlyShoes());
end

function Lua_TaskItem:onXianShiCountDown()
	if self.data.taskType == Lua_TaskDefine.XIANSHI then
		local titleColor = Lua_TaskDefine.getTaskTitleColor(self.data.status, self.data.taskType);
		local titleName = Lua_TaskDefine.getTaskNameTitle(self.data.taskType);
		local titleStatus = Lua_TaskDefine.getTaskStatusLabel(self.data.status);
		local time = math.floor(self.data.task_time - DataCenter.roleData.serverTime);
		local timeStr = LanUtil.formateStr(LanUtil.getValue(122942), TimeTransform.getInstance():transSeconds6(time, false, true));
		self.titleTxt.text = titleColor .. titleName .. self.data.name .. self.data.rountineStr .. titleStatus .. timeStr;
	else
		Lua_CommonUtil.removeTimer(self, self.onXianShiCountDown);
	end
end

function Lua_TaskItem:updateGiftBoxState()
	self.giftbox:setEnable(self.inViewBox and self.showBoxState);
	self.boxIcon:setEnable(self.inViewBox and self.showBoxState);
	if self.cantAcceptEffect ~= nil then
		self.cantAcceptEffect:setEnable(self.inViewBox);
	end
end

function Lua_TaskItem:showPointEffect(val)
	if val and self.data.accept_effect ~= nil then
		if self.pointEffect == nil then
			self.pointEffect = UICreate.createUIEffect(self.content, nil ,nil, 305, 0);
			self.pointEffect:setDepth(5);
			self.pointEffect:SetRenderQueue(self.titleTxt, 10, 2, false);
		end
		self.pointEffect:setUrl("/effects/scsEffects/"..self.data.accept_effect, self.data.accept_effect);
		self.pointEffect:setEnable(true);
	else
		if self.pointEffect ~= nil then
			self.pointEffect:setEnable(false);
		end
	end
end

function Lua_TaskItem:showCantAcceptGuideTxtImg()
	if self.data.taskType ~= Lua_TaskDefine.TRUCK then
		self:disposeCantAcceptGuideTxtImg();
		return;
	end

	if self.data.status == Lua_TaskDefine.UNACCEPT then
		if not self.cantDoGuideTxtImg then
			self.cantDoGuideTxtImg = UICreate.createUIAtlasImage(self.content, "zhiyin_atlas", "ui_point_widget_01", 99, 0, 0, 0);
			self.cantDoGuideTxtImg:setDepth(4);
			if self.cantDoGuideTxt == nil then
				self.cantDoGuideTxt = UICreate.createLabel(self.content, nil, 77, 0, 44, 44, 22);
				self.cantDoGuideTxt.text = "[BFD5DE]升級指引[-]"
				self.cantDoGuideTxt.effectStyle = 3;
				self.cantDoGuideTxt.effectColorStr = Lua_ColorDefine.transColor(Lua_ColorDefine.BLACK_STR, 0.6);
				self.cantDoGuideTxt:setDepth(5);
			end
		end
	else
		self:disposeCantAcceptGuideTxtImg();
	end
end

function Lua_TaskItem:disposeCantAcceptGuideTxtImg()
	if self.cantDoGuideTxtImg ~= nil then
		self.cantDoGuideTxtImg:dispose();
		self.cantDoGuideTxtImg = nil;
	end
	if self.cantDoGuideTxt then
		self.cantDoGuideTxt:dispose();
		self.cantDoGuideTxt = nil
	end
end

-- 主线任务不可接的时候要显示特效、指引
function Lua_TaskItem:showCantAcceptEffect()
	if self.data.taskType ~= Lua_TaskDefine.TRUCK then
		self:disposeCantAcceptEffect();
		return;
	end

	if self.data.status == Lua_TaskDefine.UNACCEPT and DataCenter.taskData.hasShowCantAcceptEff == false then
		DataCenter.taskData.hasShowCantAcceptEff = true;
		self:doShowCantAcceptEffect();
		if self.data.unacceptTips ~= nil and self.guideArrow == nil then
			self.guideArrow = Lua_TaskItemGuide.new(self.content);
			self.guideArrow:setClickCB(self, self.onContentClick);
			self.guideArrow:setLocation(240, 0, 0);
		end

		if self.guideArrow ~= nil then
			self.guideArrow:setDesc(self.data.unacceptTips);
		end
	elseif self.data.status ~= Lua_TaskDefine.UNACCEPT then 
		self:disposeCantAcceptEffect();
	end
end

function Lua_TaskItem:doShowCantAcceptEffect()
	if self.cantAcceptEffect == nil then
		self.cantAcceptEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/renwulantexiao", "renwulantexiao", -99.5, 1.5);
		self.cantAcceptEffect:setDepth(5);
		self.cantAcceptEffect:setSacle(1.02, 0.99, 1);
		self.cantAcceptEffect:setLocation(-99.5, 1.5);
		self.cantAcceptEffect:SetRenderQueue(self.titleTxt, 5, 2, false);
	end
end

function Lua_TaskItem:disposeCantAcceptEffect()
	if self.cantAcceptEffect ~= nil then
		self.cantAcceptEffect:dispose();
		self.cantAcceptEffect = nil;
	end
	DataCenter.taskData.hasShowCantAcceptEff = false;
end

function Lua_TaskItem:createFlyShoestEffect()
	if self.flyShoesEffect == nil then
		self.flyShoesEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/xiaofeixie_tx", "xiaofeixie_tx", 100, 0);
		self.flyShoesEffect:setDepth(5);
		self.flyShoesEffect:SetRenderQueue(self.titleTxt, 10, 2, false);
	end
	if self.flyShoesEffect2 == nil then
		self.flyShoesEffect2 = UICreate.createUIEffect(self.content, "/effects/scsEffects/xiaofeixie_tx1", "xiaofeixie_tx1", 225, 0);
		self.flyShoesEffect2:setDepth(5);
		self.flyShoesEffect2:SetRenderQueue(self.titleTxt,10,2,false);
	end
end

function Lua_TaskItem:disposeFlyShoestEffect()
	if self.flyShoesEffect ~= nil then
		self.flyShoesEffect:dispose();
		self.flyShoesEffect = nil;
	end
	if self.flyShoesEffect2 ~= nil then
		self.flyShoesEffect2:dispose();
		self.flyShoesEffect2 = nil;
	end
end

function Lua_TaskItem:showRoutineGuideTips()
	if self.routineGuideTips == nil then
		self.routineGuideTips = Lua_RoutineTaskGuideTips.new(self.content);	
		self.routineGuideTips:setRenderQueue(self.titleTxt);
	end
	self:checkRoutineGuidePos();
end

function Lua_TaskItem:checkRoutineGuidePos()
	if self.routineGuideTips == nil then
		return;
	end

	local posY = self.cellSeqIndex == 1 and 0 or 16;
	self.routineGuideTips:setLocation(288, posY, 0);
end

function Lua_TaskItem:hideRoutineGuideTips()
	if self.routineGuideTips ~= nil then
		self.routineGuideTips:dispose();
		self.routineGuideTips = nil;
	end
	if self.data.taskType == Lua_TaskDefine.ROUTINE then
		DataCenter.taskData.showingRoutineGuideTaskId = nil;
	end
end

function Lua_TaskItem:showHideBeStrongIcon(val)
	if val then
		self.strongIconState = true;
		self.contentTxt:SetDimensions(200, 20);
		if self.beStrongIcon == nil then
			self.beStrongIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_zhujiemian_icon_27", 99, 2, 0, 0);
			self.beStrongIcon:setDepth(2);
			self.beStrongIcon:addClickFuntion(self, self.onStrongClick);
		end
		self.beStrongIcon:setEnable(true);
	else
		self.strongIconState = false;
		self.contentTxt:SetDimensions(243, 20);
		if self.beStrongIcon ~= nil then
			self.beStrongIcon:setEnable(false);
		end
	end
end

function Lua_TaskItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 128, self.itemY - 33, 256, 66);
	self.inViewBox = showRect:containeRect(rect);
	self:updateGiftBoxState();
end

function Lua_TaskItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);
	self:checkRoutineGuidePos();
end

function Lua_TaskItem:onPlayerSoundClick(go)
	self:superCall("onPlayerSoundClick", go);

	if self.strongIconState then
		self:onStrongClick();
	else
		self:disposeCantAcceptEffect();
		self:hideRoutineGuideTips();
		self:onContentClick();
	end
end

function Lua_TaskItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	self.selected_show:setEnable(val);
end

function Lua_TaskItem:onContentClick()
	if self.data ~= nil then
		if self.data.task_null == 1 then
			if self.data.taskType == Lua_TaskDefine.LEAGUE then
				OperateAlert.show(LanUtil.getValue(122939));
			end
			return;
		end

		self:showPointEffect(false);
		self.data.newTask = 0;
		if self.data.status == Lua_TaskDefine.UNACCEPT and self.data.taskType == Lua_TaskDefine.TRUCK then
			-- 主线任务中断时，点击要弹提示面板
			local cfgIds = Lua_CommonUtil.getCommonConfig("show_needdo_task", 3);
			if cfgIds == nil then
				return;
			end

			local needShow = false;
			for k,v in ipairs(cfgIds) do
				if tonumber(v) == tonumber(self.data.taskId) then
					needShow = true;
					break;
				end
			end

			if needShow == true then
				local needDoList = DataCenter.taskData:getNeedDoList();
				-- 2018.6.21需求：只显示“环式任务”选项时，不显示Lua_NeedDoNowWindow，显示独立的环式任务指引框
				if needDoList:getSize() == 1 and needDoList[1].func_id == 10026 then
					Lua_MsgUtil.callFunc("SHOW_ROUTINE_TASK_GUIDE_TIPS");
				else
					Lua_WindowUtil.openWin("Lua_NeedDoNowWindow",WinParam.ACTION_AUTO);
				end
			end
			return;
		end

		if self.data.taskType == Lua_TaskDefine.TRUCK then
			if Lua_WindowUtil.isWindowShowing("Lua_NeedDoNowWindow") then
				Lua_WindowUtil.openWin("Lua_NeedDoNowWindow",WinParam.ACTION_CLOSE);
			end
		end

		-- 环式任务点击弹出独立界面
		local canExcu = DataCenter.taskData:handelOpenDailyTask(self.data);
		if not canExcu then return; end

		self:disposeCantAcceptEffect();
		if self.guideArrow ~= nil then
			self.guideArrow:dispose();
			self.guideArrow = nil;
		end
		self.data:exeTask();

		if self.data.taskType == Lua_TaskDefine.BRANCH
			and DataCenter.taskData.taskClickDic[self.data.subType] == nil then
			DataCenter.taskData.taskClickDic[self.data.subType] = 1;
			Lua_MsgUtil.callFunc("TASK_UPDATE");
		end
	end
end

function Lua_TaskItem:onFlyClick()
	if self.data.task_null == 1 then
		if self.data.taskType == Lua_TaskDefine.LEAGUE then
			OperateAlert.show(LanUtil.getValue(122939));
		end
		return;
	end
	self.data:doTransfer();
end

function Lua_TaskItem:onStrongClick()
	local px = -MainWinDefine.V_width / 2 + -30;
	local py = MainWinDefine.V_height / 2 - 270;
	Lua_WindowUtil.openWin("Lua_BeStrongWindow", WinParam.ACTION_AUTO, {tx = px, ty = py, tz = 0});
end

function Lua_TaskItem:onAutoMarkClick()
	if self.data ~= nil then
		if self.data.taskType == Lua_TaskDefine.ROUTINE then
			Lua_WindowUtil.openWin("Lua_DailyRoutineWindow", WinParam.ACTION_OPEN, self.data);
		end
	end
end