checkRequire("Lua_TeamHasItem");
checkRequire("Lua_TeamNoItem");
Lua_TeamPanel = class("Lua_TeamPanel", Lua_DisplayObject);
function Lua_TeamPanel:ctor(p)
    self:superCall("ctor", p, "TeamPanel_skin", false);
end

function Lua_TeamPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onTeamBgClick);

	self:onTeamInfoUpdate();

	self:addLuaEvent("TEAM_INFO_UPDATE", self, self.onTeamInfoUpdate);
end

function Lua_TeamPanel:onTeamBgClick(o)
	if DataCenter.teamData.hasTeam then
		Lua_WindowUtil.openWin("Lua_TeamWindow");
	end
end

function Lua_TeamPanel:onTeamInfoUpdate(o)
	if DataCenter.teamData.hasTeam then
		if self._noTeamItem ~= nil then
			self.noTeamItem:setEnable(false);
		end
		self.hasTeamItem:setEnable(true);
	else
		self.noTeamItem:setEnable(true);
		if self._hasTeamItem ~= nil then
			self._hasTeamItem:setEnable(false);
		end
	end
end

function Lua_TeamPanel.Get:hasTeamItem()
	if self._hasTeamItem == nil then
		self._hasTeamItem = Lua_TeamHasItem.new(self.content);
		self._hasTeamItem:setLocation(0, 0);
	end
	return self._hasTeamItem;
end

function Lua_TeamPanel.Get:noTeamItem()
	if self._noTeamItem == nil then
		self._noTeamItem = Lua_TeamNoItem.new(self.content);
		self._noTeamItem:setLocation(141, 20);
	end
	return self._noTeamItem;
end