Lua_TeamerItem = class("Lua_TeamerItem", Lua_DisplayObject);
function Lua_TeamerItem:ctor(p)
	self:superCall("ctor", p, "TeamerItem_skin");
end

function Lua_TeamerItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("TEAM_INFO_UPDATE", self, self.onTeamUpdate);
end

function Lua_TeamerItem:onTeamUpdate(o)
	local td = DataCenter.teamData;
	if td.hasTeam == false then
		self:setState(0, 0, 3);
	else
		local len = td.teamerArr:getSize();
		local nearNum = 0;
		local onLineNum = 0;
		for i=1,len do
			if td.teamerArr[i].online_flag == 1 then
				if td.teamerArr[i].nearby == true or td.teamerArr[i].role_id == DataCenter.roleData.roleId then
					nearNum = nearNum + 1;
				end
				onLineNum = onLineNum + 1;
			end
		end
		self:setState(nearNum, onLineNum, len);
	end

	local addExp = td:getAddExp();
	self.expTxt.text = "Exp:+"..addExp.."%";
end

function Lua_TeamerItem:hideItem()
	self.expTxt:setEnable(false);
	self.arrowSp:setEnable(false);
end

function Lua_TeamerItem:setState(nearNum, onLineNum, allNum)
	for i = 1, 3 do
		if i <= allNum then
			self["tp"..i]:setEnable(true);
			if i <= nearNum then
				self["tp"..i]:setAltas("team_atlas", "ui_team_icon_01"); -- 绿色
			elseif i <= onLineNum then
				self["tp"..i]:setAltas("team_atlas", "ui_team_icon_02"); -- 红色
			else
				self["tp"..i]:setAltas("team_atlas", "ui_team_icon_03"); -- 灰色
			end
		else
			self["tp"..i]:setEnable(false);
		end
	end
end