checkRequire("Lua_TopLeftDefine")
checkRequire("Lua_VipExperienceTips");
checkRequire("Lua_LijinIcon");
checkRequire("Lua_TopLeftIcon");
Lua_TopLeftIconPanel = class("Lua_TopLeftIconPanel",Lua_DisplayObject)
function Lua_TopLeftIconPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.iconsDic = {};
	self.showList = Array();
	self.hideList = Array();

	self.lijinIconLvls = Lua_CommonUtil.getCommonConfig("lijin_icon_show_lvl", 3);

	self:checkIcon();
	self:showIcon(Lua_TopLeftDefine.VIP_EXPIRED_TIPS);

	self:addLuaEvent("TOP_LEFT_SHOW_ICON", self, self.showIcon);
	self:addLuaEvent("TOP_LEFT_HIDE_ICON", self, self.hideIcon);
	self:addCSharpEvent("PLAYER_LEVEL_UP", self, self.checkIcon);
end

function Lua_TopLeftIconPanel:checkIcon()
	if self.content == nil then
		return;
	end

	local myLv = DataCenter.roleData.level;
	if myLv >= self.lijinIconLvls[1] and myLv <= self.lijinIconLvls[2] then
		self:showIcon(Lua_TopLeftDefine.LIJIN_ICON);
	else
		self:hideIcon(Lua_TopLeftDefine.LIJIN_ICON);
	end
end

function Lua_TopLeftIconPanel:showIcon(type)
	if self.iconsDic[type] == nil then
		if type == Lua_TopLeftDefine.VIP_EXPIRED_TIPS then
			self.iconsDic[type] = Lua_VipExperienceTips.new(self.content,type);
		elseif type == Lua_TopLeftDefine.LIJIN_ICON then
			self.iconsDic[type] = Lua_LijinIcon.new(self.content,type);
		else
			self.iconsDic[type] = Lua_TopLeftIcon.new(self.content,type);
		end
	end
	self.iconsDic[type]:setEnable(true);

	local ticon = self.iconsDic[type];
	if self.showList:indexOf(ticon) == -1 then
		self.showList:add(ticon);
	end

	if self.hideList:indexOf(ticon) ~= -1 then
		self.hideList:removeItem(ticon);
	end
	self:updateIconPos();
end

function Lua_TopLeftIconPanel:hideIcon(type)
	local ticon = self.iconsDic[type];
	if ticon ~= nil then
		self.iconsDic[type]:setEnable(false);
	else
		return;
	end

	if self.showList:indexOf(ticon) ~= -1 then
		self.showList:removeItem(ticon);
	end

	if self.hideList:indexOf(ticon) == -1 then
		self.hideList:add(ticon);
	end
	self:updateIconPos();
end

function Lua_TopLeftIconPanel:updateIconPos()
	self.showList:sort("type", false);
	local ticon;
	for i = 1, self.showList:getSize() do
		ticon = self.showList[i];
		ticon:setLocation(8 + (i-1) * 65, -33, 0);
	end
end