checkRequire("Lua_TopLeftIcon");
Lua_VipExperienceTips = class("Lua_VipExperienceTips", Lua_TopLeftIcon);
function Lua_VipExperienceTips:ctor(p,type)
	self:superCall("ctor", p, "VipExperienceTips_skin", type);
end

function Lua_VipExperienceTips:buildShowItem()
	self:superCall("buildShowItem");

	self.initRed = false;
	self.icon:setDepth(0);
	self.icon:addClickFuntion(self, self.onIconClick);

	self:showHideDesc(false);

	self:addLuaEvent("VIP_GET_ROLE_VIPINFORMATION", self, self.checkVipExpiredTime);
	self:addLuaEvent("VIP_EXPERIENCE_TIPS_UPDATE_COUNTDOWN", self, self.updateCountDown);
	self:addLuaEvent("VIP_EXPIRED", self, self.onVipExpired);
	self:addLuaEvent("HIDE_VIP_ICON_REDDOT", self, self.showHideReddot);
end

function Lua_VipExperienceTips:checkVipExpiredTime(obj)
	self.vipInfoMsg = obj;
	if obj == nil then 
		return;
	end

	if DataCenter.vipData.vip_type == 1 then
		self.contentTxt.text = LanUtil.getValue(121319);
	end
	if DataCenter.vipData.vip_type == 5 then
		self.contentTxt.text = LanUtil.getValue(121330);
	end

	self.vipLvTxt.fontSize = 26;
	if DataCenter.vipData.level == 100 then
		if getLanType() == 2 then
			self.vipLvTxt.fontSize = 20;
			self.curlevelStr = "限時";
		else
			self.curlevelStr = "V+";
		end
	else
		self.curlevelStr = tostring(DataCenter.vipData.level);
	end
	self.vipLvTxt.text = self.curlevelStr;

	local surplusTime = tonumber(obj.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
	if DataCenter.vipData.isTiYan == true then
		self:showHideDesc(true);
		self:updateCountDown(surplusTime);
	else
		self:showHideDesc(false);
		self:updateCountDown(0);
	end

	-- if DataCenter.redDotData:getRedDotStateByEventId(11181) == true then -- 暂时屏蔽
	-- 	self:showHideReddot(true);
	-- else
	-- 	self:showHideReddot(false);
	-- end

	if self.initRed == false then
		if DataCenter.vipData.vip_type <= 1 or DataCenter.vipData.vip_type == 5 or DataCenter.vipData.gift_state == 1 then
			self.initRed = true;
			-- 非vip或体验vip要显示红点
			self:showHideReddot(true);
		end
	end
end

function Lua_VipExperienceTips:updateCountDown(time)
	self.endTime = time + getTime();
	if time > 0 then
		self:addTimer("checkCDStep", 0.3, self, self.checkCDStep);
	else
		Lua_CommonUtil.removeTimer(self, self.checkCDStep);
	end
end

function Lua_VipExperienceTips:checkCDStep()
	local now = getTime();
	if self.endTime >=  now  then
		if DataCenter.vipData.vip_type == 5 then
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121331), TimeTransform.getInstance():transSeconds1(self.endTime - now, true));
		elseif DataCenter.vipData.vip_type == 1 then
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121318), TimeTransform.getInstance():transSeconds6(self.endTime - now, false, true));
		end
	end
end

function Lua_VipExperienceTips:onVipExpired()
	self:updateCountDown(0);
	self:showHideReddot(true);
	DataCenter.vipData:sGetRoleVipInfo();
end

function Lua_VipExperienceTips:showHideDesc(val)
	self.contentTxt:setEnable(val);
	self.timeTxt:setEnable(val);
	self.bg:setEnable(val);
end

function Lua_VipExperienceTips:onIconClick()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 10097);
end