checkRequire("Lua_TopRightIconData");
Lua_AllRightTopData = class("Lua_AllRightTopData");
function Lua_AllRightTopData:ctor()
	self.isInit = false;
	self.sysState = true;
	self.playerState = true;
	self.curFloatTargetPosX = 0;
	self.curFloatTargetPosY = 0;
	self.clickDic = {};
end

function Lua_AllRightTopData:setSystemState(val)
	self.sysState = val;
end

function Lua_AllRightTopData:setPlayerState(val)
	self.playerState = val;
end

function Lua_AllRightTopData:getShowState()
	return self.playerState and self.sysState;
end

function Lua_AllRightTopData:dispose()
	self.isInit = false;
	self.showArr = Array();
	self.clickDic = {};
	self.openningRightIconId = nil;
	self.curFloatTargetPosX = 0;
	self.curFloatTargetPosY = 0;
	self.sysState = true;
	self.playerState = true;
	if self._topRightIconDic ~= nil then
		for k, v in pairs(self._topRightIconDic) do
			v:resetInfo();
		end
		self._topRightIconDic = nil;
	end
	Lua_MsgUtil.callFunc("CLEAN_TOPRIGHT_ICON_DATA");
end

function Lua_AllRightTopData:getHasClick(id)
	return self.clickDic[id] == 1;
end

function Lua_AllRightTopData:setHasClick(id)
	self.clickDic[id] = 1;
end

function Lua_AllRightTopData.Get:topRightIconDic()
	if self._topRightIconDic == nil then
		self._topRightIconDic = {};

		local topRightIconData
		local config = getConfig({"topRightIcon"});
		if config ~= nil then		
			for iconId, info in pairs(config) do
				if info.pos_type == 1 or info.pos_type == 3 or info.pos_type == 4 then
					topRightIconData = Lua_TopRightIconData.new(iconId, info);
					topRightIconData.act_id = info.client_show == 1 and 0 or -1;
					self._topRightIconDic[iconId] = topRightIconData;
				end
			end
		end
	end
	return self._topRightIconDic;
end

function Lua_AllRightTopData:addIconDataWithAct(iconId, actId)
	local topRightIconData = self.topRightIconDic[iconId];
	if topRightIconData == nil then -- 没找到则创建一个
		topRightIconData = Lua_TopRightIconData.new(iconId);
	end
	topRightIconData.act_id = actId;
	self.topRightIconDic[iconId] = topRightIconData;
end

function Lua_AllRightTopData:removeIcon(iconId)
	if self.topRightIconDic[iconId] ~= nil then
		self._topRightIconDic[iconId] = nil;
	end
end

function Lua_AllRightTopData:getIconByWindowName(val)
	local list = self.topRightIconDic;
	if list ~= nil then
		for i, v in pairs(list) do
			if v ~= nil and v.type == 1 and v.param == val and v.canShow == true then
				return v;
			end
		end
	end
	return nil;
end

-- 对应行隐藏图标数据
function Lua_AllRightTopData:getShowType3List()
	local showArr = Array();
	local list = self.topRightIconDic;
	if list ~= nil then
		for i, v in pairs(list) do
			if v ~= nil and v.pos_type == 3 then
				if v.canShow == true then
					showArr:add(v);
				else
					if self.clickDic[v.id] ~= nil then
						self.clickDic[v.id] = 0;
					end
				end
			end
		end
	end
	return showArr;
end

-- 对应行展示图标数据
function Lua_AllRightTopData:getShowList()
	local showArr = Array();
	local list = self.topRightIconDic;
	if list ~= nil then
		for i, v in pairs(list) do
			if v ~= nil then -- and v.pos_type == 1 then
				if v.canShow then
					showArr:add(v);
				else
					if self.clickDic[v.id] ~= nil then
						self.clickDic[v.id] = 0;
					end
				end
			end
		end
	end
	return showArr;
end