checkRequire("Lua_TopRightIconGuide");
Lua_TopRightIcon = class("Lua_TopRightIcon", Lua_DisplayObject);
function Lua_TopRightIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.aphaAddStep = Lua_CommonUtil.getCommonConfig("topRight_iconAphaAddStep", 1);
	if self.aphaAddStep == nil or self.aphaAddStep == 0 then
		self.aphaAddStep = 0.3;
	elseif self.aphaAddStep < 0 then
		self.aphaAddStep = -self.aphaAddStep;
	end

	self.aphaSubStep = Lua_CommonUtil.getCommonConfig("topRight_iconAphaSubStep", 1);
	if self.aphaSubStep == nil or self.aphaSubStep == 0 then
		self.aphaSubStep = -0.3;
	elseif self.aphaSubStep > 0 then
		self.aphaSubStep = -self.aphaSubStep;
	end
	
	self.bg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_icon_gntb", 0, 0, 0, 0);
	self.bg:setDepth(self.depth + 10);

	self.icon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
	self.icon:setDepth(self.depth + 11);
		
	if self.data ~= nil then
		self:setData(self.data);
	end

	self:addLuaEvent("LOCK_EFFECT_LIST", self, self.onEffectListUpdate);
end

function Lua_TopRightIcon.Get:countTxt()
	if self._countTxt == nil then
		self._countTxt = UICreate.createLabel(self.content, "", 0, 0, 100, 100, 20);
		self._countTxt.pivot = UIWidget.Pivot.Top;
		self._countTxt:setLocation(0, -35, 0);
		self._countTxt.text = "00:00";
		self._countTxt.effectColorStr = "2986344448";
		self._countTxt.effectStyle = 3;
		self._countTxt:setEffectDistance(2, 2);
		self._countTxt.spacingY = 4;
		self._countTxt:setDepth(self.depth + 13);
		self._countTxt:setEnable(false);
	end
	return self._countTxt;
end

function Lua_TopRightIcon.Get:redDotIcon()
	if self._redDotIcon == nil then
		if self.data ~= nil and self.data.pos == 4 then
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 32, 67, 0, 0);
		else
			self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 25, 25, 0, 0);
		end
		
		self._redDotIcon:setDepth(self.depth + 12);
	end
	return self._redDotIcon;
end

function Lua_TopRightIcon:dispose()
	self.owner = nil;
	self.completeFun = nil;
	self:clearAphaTimer();
	self:cleanEff();

	self:cleanGuideArrow();
	self:clearTimer();
	self:showHideLockEffect(false);
	self:superCall("dispose");
end

function Lua_TopRightIcon.Get:sort_index()
	if self.data.sort_index == nil then
		return 0;
	end
	return self.data.sort_index;
end

function Lua_TopRightIcon:setData(value)
	self.data = value;
	
	self.icon.name = self.data.icon;
	self.icon:setDepth(self.depth + 10);
	self.icon:setAltas(self.data.iconAtlas, self.data.icon);
	--self.icon:SetDimensions(72, 74);
	--self.icon.clickScale = false;
	self.icon:addClickFuntion(self, self.OnIconPress);

	self:updateData();
	self:updateRedDotState();
	self:onEffectListUpdate();
end

function Lua_TopRightIcon:updateData()
	local avo = self.data.actData;
	if avo ~= nil then
		if avo.activity_state == 1 then
			self.countTxt:setEnable(true);
			self.countTxt.text = LanUtil.formateStr(LanUtil.getValue(110026), avo.startTimeStr);
			self:clearTimer();
		elseif avo.activity_state == 2 then
			self.countTxt:setEnable(true);
			self:onCountDown();
			if self.bTimer == nil or self.bTimer == false then
				self.bTimer = true;
				self:addTimer("onEnterFrame", 0.5, self, self.onCountDown);
			end
		else
			if self._countTxt ~= nil then
				self._countTxt:setEnable(false);
			end
			self:clearTimer();
		end
	else
		local num = self.data.showCountTime;
		local showOpenStr = self.data.showOpenStr;
		if showOpenStr==false and num ~= nil and num > 0 then
			self.countTxt:setEnable(true);
			self:onCountDown();
			if self.bTimer == nil or self.bTimer == false then
				self.bTimer = true;
				self:addTimer("onEnterFrame", 0.5, self, self.onCountDown);
			end
		elseif showOpenStr==true and num ~= nil then
			self.countTxt:setEnable(true);
			self.countTxt.text = num;
			self:clearTimer();
		else
			if self._countTxt ~= nil then
				self._countTxt:setEnable(false);
			end
			self:clearTimer();
		end
	end

	self:updateEff();
	self:updateGuideArrow();
end

-- 更新指引显示
function Lua_TopRightIcon:updateGuideArrow()
	if self.data ~= nil and self.data.guideShow ~= nil and self.data.guideShow > 0 and self.data.guideStr ~= nil then
		if self.data.guideShow == 1 then -- 跟随图标存在
			self:createGuideArrow();
		else
			if DataCenter.allRtData:getHasClick(self.data.id) == false then
				self:createGuideArrow();
			else
				self:cleanGuideArrow();
			end
		end
	else
		self:cleanGuideArrow();
	end
end

function Lua_TopRightIcon:guideComplete()
	self:cleanGuideArrow();
end

function Lua_TopRightIcon:createGuideArrow()
	if self.data == nil then
		self:cleanGuideArrow();
		return;
	end

	if self.guideArrow == nil then
		self.guideArrow = Lua_TopRightIconGuide.new(self.content, self, self.guideComplete);
	end
	self.guideArrow:setData(self.data.guidePos, self.data.guidePivot, self.data.guideStr, self.data.guideTime);
	if self.data.guidePos == 1 then -- 上
		self.guideArrow:setLocation(0, 43, 0);
	elseif self.data.guidePos == 2 then -- 下
		self.guideArrow:setLocation(0, -43, 0);
	elseif self.data.guidePos == 3 then -- 左
		self.guideArrow:setLocation(-43, 0, 0);
	elseif self.data.guidePos == 4 then -- 右
		self.guideArrow:setLocation(43, 0, 0);
	end
end

function Lua_TopRightIcon:cleanGuideArrow()
	if self.guideArrow ~= nil then
		self.guideArrow:dispose();
		self.guideArrow = nil;
	end
end

-- 更新特效显示
function Lua_TopRightIcon:updateEff()
	if self.data ~= nil and self.data.show_effect ~= nil and self.data.show_effect > 0 then
		if self.data.show_effect == 1 then -- 跟随图标存在
			self:createEff();
		else
			if DataCenter.allRtData:getHasClick(self.data.id) == false then
				self:createEff();
			else
				self:cleanEff();
			end
		end
	else
		self:cleanEff();
	end
end

function Lua_TopRightIcon:createEff()
	if self.data == nil then
		self:cleanEff();
		return;
	end

	if self.effect == nil and self.data.pos ~= 4 then
		local url = self.data.effect_url;
		if url == nil then
			url = "activity_circle";
		end

		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. url, url, 3, -3.5);
		self.effect:SetRenderQueue(self.bg, 5, UIEffect.NormalSort);
	end
end

function Lua_TopRightIcon:cleanEff()
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
end

-- 红点状态更新
function Lua_TopRightIcon:updateRedDotState()
	if self.data == nil then
		return;
	end

	local redState = self.data.redDotShowState;
	if self.bShowRedDot ~= redState then
		if redState == true then
			self.redDotIcon:setEnable(true);
		else
			if self._redDotIcon ~= nil then
				self.redDotIcon:setEnable(false);
			end

			-- 登录显示，点击前如果红点状态从有到无则消失, 点击后有红点则继续保留，无红点则消失
			if self.bShowRedDot ~= nil then
				if self.data.show_effect ~= nil and self.data.show_effect == 2 then
					DataCenter.allRtData:setHasClick(self.data.id);
					self:updateEff();
				end

				-- 保持跟红点类是
				if self.data.guideShow ~= nil and self.data.guideShow == 2 then
					DataCenter.allRtData:setHasClick(self.data.id);
					self:updateGuideArrow();
				end
			end
		end
		self.bShowRedDot = redState;
	end
end

function Lua_TopRightIcon:setRedDotIcon(state, name, even_value)
    if name == self.data.red_dot_mark then
    	self:setRedDotEnable(state)
    end
end

function Lua_TopRightIcon:OnIconPress(go)
	if (self.data == nil) then
		return;
	end
	if self.lockEffect ~= nil then
		DataCenter.roleData:updateLockState(self.data.id, 0);
	end

	--type(1:打开面板，2：派发事件
	if self.data.type ~= nil  and self.data.param ~= nil then
		-- local iconFlagList = DataCenter.OperationalActivitiesData.activityIconFlagList;-- 是否存在子图标标识
		-- if iconFlagList ~= nil then 
		-- 	print(self.data.id,"存在子图标   = =",iconFlagList[self.data.id])
		-- 	if iconFlagList[self.data.id] == 1 then -- 存在子图标
		-- 		Lua_WindowUtil.openWin("Lua_FactionHuntingRankWindow",nil,{iconId = self.data.id})
		-- 		return;
		-- 	end
		-- end
		if self.data.type == 1 then
			local actId = self.data.act_id;
			if actId ~= nil then
				local vo = DataCenter.xianshiData:getDataById(actId);
				if vo ~= nil and vo.attend ~= nil and vo.attend == 1 then
					OperateAlert.show(LanUtil.getValue(122721));
					return;
				end
			end
			if self.data.isNested == 0 or self.data.isNested == nil then
				Lua_WindowUtil.openWin(self.data.param,nil,{iconId = self.data.id})
			else
                Lua_WindowUtil.openWin(self.data.param,nil,{openIdx = self.data.isNested, iconId = self.data.id})
			end
		elseif self.data.type == 2 then
			if self.data.param == "GO_YUN_BIAO" then
				if DataCenter.yunBiaoData.escortTimes == 0 then
					OperateAlert.show(LanUtil.getValue(122110));
					return;
				end
				Lua_WindowUtil.openWin("Lua_ActiveTipWindow", nil, self.data.act_idt);
			else
				Lua_MsgUtil.callFunc(self.data.param);
			end
		end
	end

	-- 登录显示，点击前有红点则继续保留
	if self.data.show_effect ~= nil then
		if self.data.show_effect == 2 then
			local redState = self.data.redDotShowState;
			if redState == false then
				DataCenter.allRtData:setHasClick(self.data.id);
			end
		elseif self.data.show_effect == 3 then
			DataCenter.allRtData:setHasClick(self.data.id);
		end
	end
	self:updateEff();
	self:updateGuideArrow();
	self:showHideLockEffect(false);
end

function Lua_TopRightIcon:onCountDown()
	local avo = self.data.actData;
	if avo ~= nil and avo.activity_state == 2 then
		local leftTime = math.floor(avo:getLeftTime());
		self.countTxt.text = LanUtil.formateStr(LanUtil.getValue(110034), TimeTransform.getInstance():transSeconds6(leftTime, true, true));
		-- self.countTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]"..TimeTransform.getInstance():transSeconds6(leftTime, true, true).."[-]";
		if (leftTime <= 0) then
			avo.activity_state = 3;
			Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS", nil);
		end
	else
		local num = self.data.showCountTime;
		if num ~= nil then
			if self.data.isShoWBule == true then
				self.countTxt.text = LanUtil.formateStr(LanUtil.getValue(110034), TimeTransform.getInstance():transSeconds6(num, false, true));				
			else
				self.countTxt.text = LanUtil.formateStr(LanUtil.getValue(110037), TimeTransform.getInstance():transSeconds6(num, false, true));
			end
			if num <= 0 then
				if self._countTxt ~= nil then
					self._countTxt:setEnable(false);
				end
				self:clearTimer();
                if self.data.id==10113 then  --移除双倍副本UI
                    DataCenter.OpenDressCarnivalData:removeCopyDoubleExp() 
                end
                if self.data.id==10115 then --移除节日狂欢双倍经验buff栏显示
                    Lua_MsgUtil.callFunc("REMOVE_BUFF_WIN_BUFF", 40300);
                end
                Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", self.data.id);--倒计时结束移除图标
			end
			return;
		end
		self:clearTimer();
	end
end

function Lua_TopRightIcon:clearTimer()
	if self.bTimer ~= nil and self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end
end
function Lua_TopRightIcon:showHideLockEffect(val)
	if val == true then
		DataCenter.roleData:updateLockState(self.data.id, 1);
		if self.lockEffect == nil and DataCenter.roleData:getLockEffectState(self.data.id) ~= 0 then
			self.lockEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_suoding", "gui_suoding", 0, 0);
			self.lockEffect:SetRenderQueue(self.bg, 5, 2);
		end
	else
		if self.lockEffect ~= nil then
			self.lockEffect:dispose();
			self.lockEffect = nil;
		end
	end
end

function Lua_TopRightIcon:onEffectListUpdate(o)
	if self.data == nil then
		return;
	end
	local val = DataCenter.roleData:getLockEffectState(self.data.id);
	if val == 1 then
		self:showHideLockEffect(true);
	elseif val == 0 then
		self:showHideLockEffect(false);
	end
end

function Lua_TopRightIcon:checkShowLockEffect(force)
	local tlist = self.data.show_lock_lv;
	if tlist == nil then
		self:showHideLockEffect(false);
		return;
	end
	local roleLv = DataCenter.roleData.level;
	for k,v in ipairs(tlist) do
		if force == true or  v == roleLv then
			self:showHideLockEffect(true);
			return ;
		end
	end
--	self:showHideLockEffect(false);
end 

-- posZ用于缓动的apha值
function Lua_TopRightIcon:addAphaEff(startApha, endApha, owner, callback, stepNum)
	self.owner = owner;
	self.completeFun = callback;
	self.startApha = startApha;
	if self.endApha ~= endApha then
		self.endApha = endApha;
		self.bg.alpha = startApha;
		self.icon.alpha = startApha;
		if self._countTxt ~= nil then
			self._countTxt.alpha = startApha;
		end
		if self._redDotIcon ~= nil then
			self._redDotIcon.alpha = startApha;
		end
	end

	if self.startApha < self.endApha then
		self.addStep = self.aphaAddStep;
	else
		if stepNum ~= nil and stepNum ~= 0 then
			if stepNum > 0 then
				self.addStep = -stepNum;
			else
				self.addStep = stepNum;
			end
		else
			self.addStep = self.aphaSubStep;
		end
	end

	if self.bTweenTimer == nil or self.bTweenTimer == false then
		self.bTweenTimer = true;
		Lua_CommonUtil.addTimer("updateTopRightIconApha", 0.05, self, self.updateTopRightIconApha, nil, -1);
	end

	if self.guideArrow ~= nil then
		self.guideArrow:setEnable(false);
	end
	if self.effect ~= nil then
		self.effect:setEnable(false);
	end
	if self.lockEffect ~= nil then
		self.lockEffect:setEnable(false);
	end
end

function Lua_TopRightIcon:updateTopRightIconApha()
	self.startApha = self.startApha + self.addStep;
	if (self.addStep > 0 and tonumber(self.startApha) >= self.endApha) or (self.addStep < 0 and tonumber(self.startApha) <= self.endApha) then
		self.bg.alpha = self.endApha;
		self.icon.alpha = self.endApha;
		if self._countTxt ~= nil then
			self._countTxt.alpha = self.endApha;
		end
		if self._redDotIcon ~= nil then
			self._redDotIcon.alpha = self.endApha;
		end
		if self.guideArrow ~= nil then
			self.guideArrow:setEnable(true);
		end
		if self.effect ~= nil then
			self.effect:setEnable(true);
		end
		if self.lockEffect ~= nil then
			self.lockEffect:setEnable(true);
		end
		self:clearAphaTimer();
		if self.owner ~= nil and self.completeFun ~= nil then
			self.completeFun(self.owner, self);
		end 
		return;
	end
	self.bg.alpha = self.startApha;
	self.icon.alpha = self.startApha;
	if self._countTxt ~= nil then
		self._countTxt.alpha = self.startApha;
	end
	if self._redDotIcon ~= nil then
		self._redDotIcon.alpha = self.startApha;
	end
end

function Lua_TopRightIcon:clearAphaTimer()
	if self.bTweenTimer == true then
		Lua_CommonUtil.removeTimer(self, self.updateTopRightIconApha);
		self.bTweenTimer = false;
	end
end