Lua_TopRightIconData = class("Lua_TopRightIconData");
function Lua_TopRightIconData:ctor(iconid, configObj)
	self.config = configObj;
	self.id = iconid;
	self.redDotShowClientState = false;
	self.bFunOpenState = false;
	self._showOpenStr = false;
end

function Lua_TopRightIconData:resetInfo()
	self.redDotShowClientState = false;
	self.bFunOpenState = false;
	self.showState = nil;
	self._showOpenStr = false;
end

function Lua_TopRightIconData.Set:iconId(iconid)
	self.id = tonumber(iconid);
	if self.config == nil then
		self.config = getConfig({"topRightIcon", self.id});
	end
end

function Lua_TopRightIconData.Get:iconId()
	return self.id;
end

-- 判断图标在右上角收缩状态下是否显示
function Lua_TopRightIconData:checkShrinkShow()
	local list = self.shrink_white_maps;
	if list == nil or #list <= 0 then
		return false;
	end

	local sceneId = DataCenter.roleData.sceneId;
	for i = 1, #list do
		if tonumber(list[i]) == tonumber(sceneId) then
			return true;
		end
	end
	return false;
end

function Lua_TopRightIconData.Get:canShow()
	-- if self.showState == true then -- 这个代码很有疑问
	-- 	return self:checkSceneFix();
	-- end

	if self.showState ~= nil and self.showState == false then
		return false;
	end

	if self.icon_switch ~= nil and DataCenter.roleData:checkGameSwich(self.icon_switch) ~= 1 then
		return false;
	end
	
	if self.bFunOpenState == false then
		return false;
	end

	if self.exCondition == false then
		return false;
	end

	if tonumber(self.id) == 10099 then--霸权图标特殊判断
		if DataCenter.roleData:showBaQuan() == false then
			return false;
		end
	end

	local noAct = self.act_id == nil or self.act_id == -1;
	if noAct == true then
		return false;
	elseif self.act_id == 0 then
		return self:checkSceneFix();
	else
		local vo = DataCenter.xianshiData:getDataById(self.act_id);
		if vo == nil or vo.activity_state == 0 or vo.activity_state == 3 then
			return false;
		end
		return self:checkSceneFix();
	end
end

function Lua_TopRightIconData:checkSceneFix()
	local sceneId = DataCenter.roleData.sceneId;
	local len = self.blackList:getSize();
	if len ~= 0 then
		for i=1,len do
			if self.blackList[i] == sceneId then
				return false;
			end
		end
		return true;
	end
	
	len = self.whiteList:getSize();
	if len ~= 0 then
		for i=1,len do
			if self.whiteList[i] == sceneId then
				return true;
			end
		end
		return false;
	end
	return true;
end

function Lua_TopRightIconData:setState(val)
	self.showState = val;
end

function Lua_TopRightIconData:setFunOpenState(val)
	self.bFunOpenState = val;
end

-- 红点状态
function Lua_TopRightIconData:setRedDotShowState(val)
	val = (val == nil) and false or val;
	self.redDotShowClientState = val;
end

-- 获取图标红点显示状态
function Lua_TopRightIconData.Get:redDotShowState()
	-- 客户端控制和服务端控制同时支持红点显示
	if self.redDotShowClientState == true then
		return self.redDotShowClientState;
	end
	return DataCenter.redDotData:getIconShowRedDotState(self.id)
end

function Lua_TopRightIconData.Get:actData()
	if self.act_id == nil or self.act_id == -1 then
		return nil;
	end
	local xianshiData = DataCenter.xianshiData;
	local vo = xianshiData:getDataById(self.act_id);
	return vo;
end

-- 策划特殊需求图标显示时间
function Lua_TopRightIconData.Set:showCountTime(val)
	self._showCountTime = val;
	self.getShowCountTime = getTime();
end

function Lua_TopRightIconData.Set:showOpenStr(val)
	self._showOpenStr = val;
end

function Lua_TopRightIconData.Get:showOpenStr(val)
	return self._showOpenStr;
end

-- 策划特殊需求图标显示时间
function Lua_TopRightIconData.Get:showCountTime()
	if self._showCountTime == nil then
		return nil;
	end

	if self._showOpenStr==false then
		local num = self._showCountTime - (getTime() - self.getShowCountTime);
		num = math.floor(num);
		if num <= 0 then
			self._showCountTime = nil;
			return 0;
		end
		return num;
	else
		return self._showCountTime;
	end
end

function Lua_TopRightIconData.Get:icon()
	return self.config.icon;
end

function Lua_TopRightIconData.Get:iconAtlas()
	if self.config.icon_atlas == nil then
		return "righttop";
	end
	return self.config.icon_atlas;
end

function Lua_TopRightIconData.Get:param()
	return self.config.param;
end

function Lua_TopRightIconData.Get:fun_str()
	return self.config.fun_str;
end

function Lua_TopRightIconData.Get:icon_switch()
	return self.config.icon_switch;
end

function Lua_TopRightIconData.Get:show_effect()
	if self.config.show_effect == nil then
		return 0;
	end
	return self.config.show_effect;
end

function Lua_TopRightIconData.Get:lv()
	return self.config.lv;
end

function Lua_TopRightIconData.Get:type()
	return self.config.type;
end

function Lua_TopRightIconData.Get:pos()
	if self.config.pos == nil then
		return 3;
	end
	return self.config.pos;
end

function Lua_TopRightIconData.Get:type()
	return self.config.type;
end

function Lua_TopRightIconData.Get:sort_index()
	if self.config.sort_index == nil then
		return 0;
	end
	return self.config.sort_index;
end

function Lua_TopRightIconData.Get:isNested()
	return self.config.is_nested;
end

function Lua_TopRightIconData.Get:blackList()
	if self._blackList == nil then
		self._blackList = Array();
		local bk = self.config.black_maps;
		if bk ~= nil then
			for i,v in ipairs(bk) do
				self._blackList:add(tonumber(v));
			end
		end
	end
	return self._blackList;
end

function Lua_TopRightIconData.Get:whiteList()
	if self._whiteList == nil then
		self._whiteList = Array();
		local bk = self.config.white_maps;
		if bk ~= nil then
			for i,v in ipairs(bk) do
				self._whiteList:add(tonumber(v));
			end
		end
	end
	return self._whiteList;
end

function Lua_TopRightIconData.Get:effect_url()
	return self.config.effect_url;
end

function Lua_TopRightIconData.Get:show_lock_lv()
	return self.config.show_lock_lv;
end

function Lua_TopRightIconData.Get:pos_type()
	return self.config.pos_type;
end

function Lua_TopRightIconData.Get:guideShow()
	return self.config.guideShow;
end

function Lua_TopRightIconData.Get:guidePos()
	return self.config.guidePos;
end

function Lua_TopRightIconData.Get:guidePivot()
	return self.config.guidePivot;
end

function Lua_TopRightIconData.Get:guideStr()
	return self.config.guideStr;
end

function Lua_TopRightIconData.Get:guideTime()
	return self.config.guideTime;
end

function Lua_TopRightIconData.Get:shrink_white_maps()
	return self.config.shrink_white_maps;
end

function Lua_TopRightIconData.Get:act_idt()
	return self.config.act_idt;
end

function Lua_TopRightIconData.Get:name()
	return self.config.name;
end