-- 右上角图标指引
Lua_TopRightIconGuide = class("Lua_TopRightIconGuide", Lua_DisplayObject);
function Lua_TopRightIconGuide:ctor(p, owner, callback)
	self.completeFun = callback;
	self.owner = owner;

	self:superCall("ctor", p, nil);
end

function Lua_TopRightIconGuide:buildShowItem()
	self:superCall("buildShowItem");
	
	self.bg = UICreate.createUIAtlasImage(self.content, "iconantlas2", "activity_icon_bg", 0, 0, 0, 0);
	self.bg:setDepth(self.depth);

	self.txt = UICreate.createLabel(self.content, "", 0, 0, 100, 30, 20);
	self.txt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.txt:setDepth(self.depth + 1);
end

function Lua_TopRightIconGuide:setDepth(val)
	self:superCall("setDepth", val);

	self.bg:setDepth(val);
	self.txt:setDepth(val + 1);
end

function Lua_TopRightIconGuide:dispose()
	self:clearTimer();

	self:superCall("dispose");
end

-- 结束指引的回调
function Lua_TopRightIconGuide:endShowGuide()
	if self.owner ~= nil and self.completeFun ~= nil then
		self.completeFun(self.owner);
	end
end

-- dirType 1上 2下 3左 4右，根据这个显示对应的指引框及朝向
-- txtDeviation 1上 2下 3左 4右，根据这个显示对应的文字偏移
-- showStr 显示文字
-- showTime 显示倒计时结束关闭，配合showType=0作用
function Lua_TopRightIconGuide:setData(dirType, txtDeviation, showStr, showTime)
	self.txt.text = showStr;
	local bgW = 0;
	local bgH = 0;
	local urlStr = "";
	local rot;
	if dirType == 1 then
		bgW = self.txt.width + 20;
		bgH = self.txt.height + 45;
		urlStr = "guide_arrow1";
		if txtDeviation == 3 then
			self.txt.pivot = UIWidget.Pivot.Bottom;
			self.bg:setSacle(1, -1, 1);
			self.bg:setLocation(-bgW / 2 + 40, 0);
			self.txt:setLocation(-bgW / 2 + 40, 33);
		elseif txtDeviation == 4 then
			self.txt.pivot = UIWidget.Pivot.Bottom;
			self.bg:setSacle(-1, -1, 1);
			self.bg:setLocation(bgW / 2 - 40, 0);
			self.txt:setLocation(bgW / 2 - 40, 33);
		end
		self.bg.pivot = UIWidget.Pivot.Top;
	elseif dirType == 2 then
		bgW = self.txt.width + 20;
		bgH = self.txt.height + 45;
		urlStr = "guide_arrow1";
		if txtDeviation == 3 then
			self.txt.pivot = UIWidget.Pivot.Top;
			self.bg:setSacle(1, 1, 1);
			self.bg:setLocation(-bgW / 2 + 40, 0);
			self.txt:setLocation(-bgW / 2 + 40, -33);
		elseif txtDeviation == 4 then
			self.txt.pivot = UIWidget.Pivot.Top;
			self.bg:setSacle(-1, 1, 1);
			self.bg:setLocation(bgW / 2 - 40, 0);
			self.txt:setLocation(bgW / 2 - 40, -33);
		end
		self.bg.pivot = UIWidget.Pivot.Top;
	elseif dirType == 3 then
		bgW = self.txt.width + 45;
		bgH = self.txt.height + 20;
		urlStr = "guide_arrow2";
		if txtDeviation == 1 then
			self.txt.pivot = UIWidget.Pivot.Right;
			self.bg:setSacle(-1, -1, 1);
			self.bg:setLocation(0, bgH / 2 - 30);
			self.txt:setLocation(-33, bgH / 2 - 30);
		elseif txtDeviation == 2 then
			self.txt.pivot = UIWidget.Pivot.Right;
			self.bg:setSacle(-1, 1, 1);
			self.bg:setLocation(0, -bgH / 2 + 30);
			self.txt:setLocation(-33, -bgH / 2 + 30);
		end
		self.bg.pivot = UIWidget.Pivot.Left;
	elseif dirType == 4 then
		bgW = self.txt.width + 45;
		bgH = self.txt.height + 20;
		urlStr = "guide_arrow2";
		if txtDeviation == 1 then
			self.txt.pivot = UIWidget.Pivot.Left;
			self.bg:setSacle(1, -1, 1);
			self.bg:setLocation(0, bgH / 2 - 30);
			self.txt:setLocation(33, bgH / 2 - 30);
		elseif txtDeviation == 2 then
			self.txt.pivot = UIWidget.Pivot.Left;
			self.bg:setSacle(1, 1, 1);
			self.bg:setLocation(0, -bgH / 2 + 30);
			self.txt:setLocation(33, -bgH / 2 + 30);
		end
		self.bg.pivot = UIWidget.Pivot.Left;
	end
	self.bg:setAltas("iconantlas4", urlStr);
	self.bg:SetDimensions(bgW, bgH);
	
	if showTime ~= nil and showTime > 0 then
		self.showTime = showTime;
		self.startTime = getTime();
		if self.bRegistTimer == nil or self.bRegistTimer == false then
			self.bRegistTimer = true;
			self:addTimer("topRightIconGuideTime", 0.5, self, self.topRightIconGuideTime);
		end
	else
		self:clearTimer();
	end
end

function Lua_TopRightIconGuide:topRightIconGuideTime()
	local num = self.showTime - (getTime() - self.startTime);
	if num <= 0 then
		self:clearTimer();
		if self.owner ~= nil and self.completeFun ~= nil then
			self.completeFun(self.owner);
		end
		return;
	end
end

function Lua_TopRightIconGuide:clearTimer()
	if self.bRegistTimer == true then
		self.bRegistTimer = false;
		Lua_CommonUtil.removeTimer(self, self.topRightIconGuideTime);
	end
end