checkRequire("Lua_TopRightIconData");
checkRequire("Lua_TopRightIcon");
Lua_TopRightNewPanel = class("Lua_TopRightNewPanel", Lua_DisplayObject);
Lua_TopRightNewPanel.LINE_X = -78;
Lua_TopRightNewPanel.LINE1_Y = 32;
Lua_TopRightNewPanel.LINE2_Y = -52;
Lua_TopRightNewPanel.LINE3_Y = -136;
function Lua_TopRightNewPanel:ctor(p)
	self:superCall("ctor", p, "TopRightPanel_skin", true);
end

function Lua_TopRightNewPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_TopRightNewPanel";

	-- 隐藏状态（_showState = false）的面板
	self.hIconList1 = Array();
	-- self.h1.transform.localPosition = Vector3(Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0);
	LuaUtil.setObjPos(self.h1, Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0);

	-- 显示状态（_showState = true）的面板
	self.shrinkShowArr = Array();
	self.openShowArr = Array();
	self.shrinkRedDotNum = 0; -- 红点计数
	self.openRedDotNum = 0; -- 红点计数
	self.iconList1 = Array();
	-- self.c1.transform.localPosition = Vector3(Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0);
	LuaUtil.setObjPos(self.c1, Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0);
	
	local vec = self.closeBtn.mainContent.transform.localPosition;
	self.redDotIcon = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot", vec.x + 5, vec.y + 13, 0, 0);
	self.redDotIcon:setDepth(self.depth + 3);

	self.closeBtn.clickScale = false;
	self.closeBtn:addClickFuntion(self, self.onCloseClick);

	self:setShowState(true);
	Lua_CommonUtil.delayCall(1, self, self.initClientIcon);
	
	self:addLuaEvent("TORRIGHT_UPDATE", self, self.setShowState);
	self:addLuaEvent("TOPRIGHT_UPDATE_ICONS", self, self.updateRightTopIcons);
	self:addLuaEvent("FUNCTION_OPEN", self, self.onFunctionOpen);--关闭回赠窗口，刷新界面
	self:addLuaEvent("RIGHT_TOP_FLOATING_COMPLETE", self, self.iconFloatingComplete);
	self:addLuaEvent("SHOW_LOCK_ICON_EFFECT", self, self.showLockIconEffect);
	-- 注意！！！红点显示通过 MAINICON_UPDATE_REDDOTSTATE 事件，然后在Lua_XianShiProxy接收，这里只负责显示刷新
	self:addLuaEvent("REFRESH_RIGHTTOP_ICONSREDDOT", self, self.onUpdateIconRedDot);

	WindowMananger.getInstance():resetChildParent(self.content.transform);
end

function Lua_TopRightNewPanel:showLockIconEffect(iconId)
	local arr = self.iconList1;
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do 
			if arr[i].data.id == tonumber(iconId) then
				arr[i]:showHideLockEffect(true);
				break;
			end
		end
	end
end

function Lua_TopRightNewPanel:iconFloatingComplete()
	if self.curFloatingIcon ~= nil then
		self.curFloatingIcon:setEnable(true);
		self.curFloatingIcon = nil;
		self.curFloatIcon = nil;
		DataCenter.allRtData.openningRightIconId = nil;
	end
end

function Lua_TopRightNewPanel:onFunctionOpen(openIds)
	self.openningIconId = Array();
	local len = openIds:getSize();
	for i=1,len do
		 local cfg = getConfig({"func_open", openIds[i]});
		if cfg ~= nil and cfg.icon_id ~= nil then
			self.openningIconId:add(cfg.icon_id);
		end
	end
	self:updateRightTopIcons(nil);
end
	
function Lua_TopRightNewPanel:initClientIcon()
	self:updateRightTopIcons(nil);
end

function Lua_TopRightNewPanel:setShowState(val)
	local v = DataCenter.allRtData:getShowState();
	if self._showState == v then
		return;
	end

	self._showState = v;
	if self._showState == true then
		self.closeBtn:setAltas("iconantlas1", "arrow_little");
		self.closeBtn:setSacle(1, 1, 1);

		if self.hIconList1:getSize() <= 0 and self.shrinkShowArr:getSize() > 0 then
			self:showIconByState();
		end
		TweenUtil.getInstance():addTween(self.h1, 0.5, 0, Vector3(1000, Lua_TopRightNewPanel.LINE1_Y, 0), nil, nil);
		TweenUtil.getInstance():addTween(self.c1, 0.5, 0, Vector3(Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0), nil, nil);
	else
		self.closeBtn:setAltas("iconantlas1", "arrow_little");
		self.closeBtn:setSacle(-1, 1, 1);
		
		if self.hIconList1:getSize() <= 0 and self.shrinkShowArr:getSize() > 0 then
			self:showIconByState();
			TweenUtil.getInstance():addTween(self.c1, 0.5, 0, Vector3(Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0), nil, nil);
		else
			TweenUtil.getInstance():addTween(self.c1, 0.5, 0, Vector3(1000, Lua_TopRightNewPanel.LINE1_Y, 0), nil, nil);
		end 
		TweenUtil.getInstance():addTween(self.h1, 0.5, 0, Vector3(Lua_TopRightNewPanel.LINE_X, Lua_TopRightNewPanel.LINE1_Y, 0), nil, nil);
	end

	self:updateArrowRedDot();
end

function Lua_TopRightNewPanel:updateArrowRedDot()
	if self._showState == true then
		self.redDotIcon:setEnable(false);
	else
		if self.shrinkRedDotNum ~= self.openRedDotNum then
			self.redDotIcon:setEnable(true);
		else
			self.redDotIcon:setEnable(false);
		end
	end
end

function Lua_TopRightNewPanel:onCloseClick(go)
	local v = not self._showState;
	if v then
		DataCenter.allRtData:setSystemState(true);
		DataCenter.allRtData:setPlayerState(true);
	else
		DataCenter.allRtData:setPlayerState(false);
	end
	
	self:setShowState(v);
end

function Lua_TopRightNewPanel:updateRightTopIcons(val)
	if val == true then
		self:_updateRightTopIcons();
	else
		Lua_CommonUtil.delayCollectCall("rt", self, self._updateRightTopIcons, nil, 0.2);
	end
end

function Lua_TopRightNewPanel:_updateRightTopIcons(val)
	if self.isDispose_2 == true then
		return;
	end

	self:updateHIconList();
	self:updateIconList();
end

function Lua_TopRightNewPanel:updateIconList()
	self.shrinkRedDotNum = 0; -- 红点计数
	self.openRedDotNum = 0; -- 红点计数
	self.shrinkShowArr = Array();
	self.openShowArr = DataCenter.allRtData:getShowList();
	if self.openShowArr ~= nil then
		self.openShowArr:sort("sort_index", true);
		local len = self.openShowArr:getSize();
		for i = 1, len do
			data = self.openShowArr[i];
			if data:checkShrinkShow() == true then 
				self.shrinkShowArr:add(data);
				if data.redDotShowState == true then
					self.shrinkRedDotNum = self.shrinkRedDotNum + 1;
					self.openRedDotNum = self.openRedDotNum + 1;
				end
			else
				if data.redDotShowState == true then
					self.openRedDotNum = self.openRedDotNum + 1;
				end
			end

		end
	end

	self:showIconByState();
end

function Lua_TopRightNewPanel:showIconByState()
	local dataList;
	if self.hIconList1:getSize() <= 0 and self.shrinkShowArr:getSize() > 0 then
		if self._showState == false then
			dataList = self.shrinkShowArr;
		else
			dataList = self.openShowArr;
		end
	else
		dataList = self.openShowArr;
	end

	local result = 0;
	local arr = self.iconList1;
	if arr ~= nil then
		local icon;
		local data;
		local p = self.c1;
		if dataList ~= nil and p ~= nil then
			dataList:sort("sort_index", true);
			local len = dataList:getSize();
			local count = 0;
			for i = 1, len do
				data = dataList[i];
				count = count + 1;
				self:addIcon(arr, data, count, p);
			end
			self.openningIconId = nil;

			-- 去掉多余
			local num = arr:getSize() - count;
			while (num > 0) do
				icon = arr:remove(count + num);
				icon:dispose();
				icon = nil;
				num = num - 1;
			end
		end
	end
	self:updateArrowRedDot();
end

function Lua_TopRightNewPanel:addIcon(sourceArr, data, count, p)
	local icon = sourceArr[count];
	if icon == nil then
		icon = Lua_TopRightIcon.new(p);
		icon:setDepth(self.depth + 1);
		sourceArr:add(icon);
	end
	icon:setData(data);
	if self.openningIconId ~= nil and self.openningIconId:indexOf(data.iconId) ~= -1 then
		icon:checkShowLockEffect(true);
	else
		icon:checkShowLockEffect();
	end
	
	local cutPosx = ((count - 1) % 5) * -84;
	local cutPosy = math.floor((count - 1) / 5) * -84;
	icon:setLocation(cutPosx, cutPosy, 0);

	if data.config.icon_float == 1 and tonumber(DataCenter.allRtData.openningRightIconId) == tonumber(data.iconId) then
		self.curFloatingIcon = icon;
		local sizeStr = LuaUtil.getUIItemSize(data.config.float_target_path);					
		local posarr = string.split(sizeStr,"|");
		local px = tonumber(posarr[3]);
		local py = tonumber(posarr[4]);
		DataCenter.allRtData.curFloatTargetPosX = px;
		DataCenter.allRtData.curFloatTargetPosY = py;
		icon:setEnable(false);
	else
		icon:setEnable(true);
	end				
end

-- 刷新对应iconId的红点显示
function Lua_TopRightNewPanel:onUpdateIconRedDot(iconId)
	local iconData = DataCenter.allRtData.topRightIconDic[iconId];
	if iconData == nil then
		return;
	end

	if iconData.canShow == true then
		local arr = self.iconList1;
		if arr ~= nil then
			local len = arr:getSize();
			for i = 1, len do 
				if arr[i].data.id == tonumber(iconId) then
					arr[i]:updateRedDotState();
					break;
				end
			end
		end		

		self.shrinkRedDotNum = 0; -- 红点计数
		self.openRedDotNum = 0; -- 红点计数
		local len = self.openShowArr:getSize();
		for i = 1, len do
			if self.openShowArr[i].redDotShowState == true then
				self.openRedDotNum = self.openRedDotNum + 1;
			end
		end
		len = self.shrinkShowArr:getSize();
		for i = 1, len do
			if self.shrinkShowArr[i].redDotShowState == true then
				self.shrinkRedDotNum = self.shrinkRedDotNum + 1;
			end
		end
		self:updateArrowRedDot();
	end
end

-- 更新_showState = false时显示的图标（主要用于副本）
function Lua_TopRightNewPanel:updateHIconList()
	local arr = self.hIconList1;
	if arr ~= nil then
		local dataList = DataCenter.allRtData:getShowType3List();
		local icon;
		local data;
		local p = self.h1;
		if dataList ~= nil and p ~= nil then
			dataList:sort("sort_index", true);
			local len = dataList:getSize();
			local count = 0;
			for i = 1, len do
				data = dataList[i];
				count = count + 1;
				self:addIcon(arr, data, count, p);
			end
			self.openningIconId = nil;

			-- 去掉多余
			local num = arr:getSize() - count;
			while (num > 0) do
				icon = arr:remove(count + num);
				icon:dispose();
				icon = nil;
				num = num - 1;
			end
		end
	end
end

function Lua_TopRightNewPanel:dispose()
	TweenUtil.getInstance():stop(self.c1);
	TweenUtil.getInstance():stop(self.h1);

	self:superCall("dispose");
end