-- 右上角图标界面
checkRequire("Lua_TopRightIconData");
checkRequire("Lua_TopRightIcon");
Lua_TopRightPanel = class("Lua_TopRightPanel", Lua_DisplayObject);
Lua_TopRightPanel.LINE_X = -108;
Lua_TopRightPanel.LINE1_Y = 32;
Lua_TopRightPanel.LINE2_Y = -52;
Lua_TopRightPanel.LINE3_Y = -136;
function Lua_TopRightPanel:ctor(p)
	self:superCall("ctor", p, "TopRightPanel_skin", true);
end

function Lua_TopRightPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_TopRightPanel";
	-- self.c1.transform.localPosition = Vector3(Lua_TopRightPanel.LINE_X, Lua_TopRightPanel.LINE1_Y, 0);
	LuaUtil.setObjPos(self.c1, Lua_TopRightPanel.LINE_X, Lua_TopRightPanel.LINE1_Y, 0);

	self.hideAll = false;
	self.shrinkRedDotNum = 0; -- 红点计数
	self.openRedDotNum = 0; -- 红点计数
	self.bigIconList = Array();
	self.hideIconList = Array();
	self.iconList1 = Array();
	self.shrinkShowArr = Array();
	self.openShowArr = Array();

	self.closeBtn.clickScale = false;
	self.closeBtn:addClickFuntion(self, self.onCloseClick);

	self.showOrHideTweenTime = Lua_CommonUtil.getCommonConfig("topRight_iconTweenTime", 1);
	if self.showOrHideTweenTime == nil or self.showOrHideTweenTime <= 0 then
		self.showOrHideTweenTime = 0.5;
	end

	local vec = self.closeBtn.mainContent.transform.localPosition;
	self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", vec.x + 5, vec.y + 13, 0, 0);
	self.redDotIcon:setDepth(self.depth + 3);

	self:updateRightTopIcons(true);
	self:setShowState(true);
	self:addListener();
	WindowMananger.getInstance():resetChildParent(self.content.transform);
end

function Lua_TopRightPanel:addListener()
	self:addLuaEvent("TORRIGHT_UPDATE", self, self.setShowState);
	self:addLuaEvent("TOPRIGHT_UPDATE_ICONS", self, self.updateRightTopIcons);
	self:addLuaEvent("FUNCTION_OPEN", self, self.onFunctionOpen);--关闭回赠窗口，刷新界面
	self:addLuaEvent("RIGHT_TOP_FLOATING_COMPLETE", self, self.iconFloatingComplete);
	self:addLuaEvent("SHOW_LOCK_ICON_EFFECT", self, self.showLockIconEffect);
    self:addLuaEvent("SHOW_HIDE_ICON_EFFECT", self, self.showIconEffect);
	-- 注意！！！红点显示通过 MAINICON_UPDATE_REDDOTSTATE 事件，然后在Lua_XianShiProxy接收，这里只负责显示刷新
	self:addLuaEvent("REFRESH_RIGHTTOP_ICONSREDDOT", self, self.onUpdateIconRedDot);
	self:addLuaEvent("TORRIGHT_SHOWHIDE_ALL", self, self.onRightTopShowHideAll);
	self:addLuaEvent("BAQUAN_CLICK", self, self.onBaQuanClick);
end
function Lua_TopRightPanel:onBaQuanClick(go)
	local str = Lua_CommonUtil.getCommonConfig("bafu_url",2);
	if str ~= nil then
		UnityEngine.Application.OpenURL(str);
	end
end
function Lua_TopRightPanel:onRightTopShowHideAll(param)
	if self.hideAll == param.value then
		return;
	end
	self.hideAll = param.value;
	if param.needRefresh == 1 then
		self:_updateRightTopIcons();
	end
end

function Lua_TopRightPanel:onShowBossIcon()
	local iconData = DataCenter.allRtData.topRightIconDic[10007];
	if iconData ~= nil and iconData.exCondition ~= true then
		iconData.exCondition = true;
		self:updateRightTopIcons();
	end
end
function Lua_TopRightPanel:onHideBossIcon()
	local iconData = DataCenter.allRtData.topRightIconDic[10007];
	if iconData ~= nil and iconData.exCondition ~= false then
		iconData.exCondition = false;
		self:updateRightTopIcons();
	end
end
function Lua_TopRightPanel:dispose()
	TweenUtil.getInstance():stop(self.c1);
	if self.iconList1 ~= nil then
		local icon;
		local len = self.iconList1:getSize();
		for i = 1, len do
			icon = self.iconList1[i];
			TweenUtil.getInstance():stop(icon.content);
			icon:dispose();
			icon = nil;
		end
		self.iconList1:clear();
		self.iconList1 = nil;
	end
	if self.hideIconList ~= nil then
		local icon;
		local len = self.hideIconList:getSize();
		for i = 1, len do
			icon = self.hideIconList[i];
			TweenUtil.getInstance():stop(icon.content);
			icon:dispose();
			icon = nil;
		end
		self.hideIconList:clear();
		self.hideIconList = nil;
	end
	if self.shrinkShowArr ~= nil then
		self.shrinkShowArr:clear();
		self.shrinkShowArr = nil;
	end
	if self.openShowArr ~= nil then
		self.openShowArr:clear();
		self.openShowArr = nil;
	end
	self.shrinkRedDotNum = 0; -- 红点计数
	self.openRedDotNum = 0; -- 红点计数

	self:superCall("dispose");
end

function Lua_TopRightPanel:showLockIconEffect(iconId)
	local arr = self.iconList1;
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do 
			if arr[i].data.id == tonumber(iconId) then
				arr[i]:showHideLockEffect(true);
				break;
			end
		end
	end
end
function Lua_TopRightPanel:showIconEffect(dic)
    local arr = self.iconList1;
    if arr ~= nil then
        local len = arr:getSize();
        for i = 1, len do
            if arr[i].data.id == tonumber(dic.iconId) then
                if dic.isShow==true then
                    arr[i]:createEff();
                else
                    arr[i]:cleanEff();
                end
                break;
            end
        end
    end
end

function Lua_TopRightPanel:iconFloatingComplete()
	if self.curFloatingIcon ~= nil then
		self.curFloatingIcon:setEnable(true);
	end
	self.curFloatingIcon = nil;
	self.curFloatIcon = nil;
	DataCenter.allRtData.openningRightIconId = nil;
end

function Lua_TopRightPanel:onFunctionOpen(openIds)
	self.openningIconId = Array();
	local len = openIds:getSize();
	for i = 1, len do
		local cfg = getConfig({"func_open", openIds[i]});
		if cfg ~= nil and cfg.icon_id ~= nil then
			self.openningIconId:add(cfg.icon_id);
		end
	end
	self:updateRightTopIcons(nil);
end

function Lua_TopRightPanel:setShowState(val)
	local v = DataCenter.allRtData:getShowState();
	if self._showState == v then
		return;
	end

	self._showState = v;
	if self._showState == true then
		self.closeBtn:setLocation(-44, 28, 0);
		self.closeBtn:setSacle(1, 1, 1);
	else
		self.closeBtn:setLocation(-36, 28, 0);
		self.closeBtn:setSacle(-1, 1, 1);
	end

	self:updateIconList();
	self:updateArrowRedDot();
	Lua_MsgUtil.callFunc("RIGHT_TOP_CHANGE");
end

function Lua_TopRightPanel:updateArrowRedDot()
	if self._showState == true then
		self.redDotIcon:setEnable(false);
	else
		if self.shrinkRedDotNum ~= self.openRedDotNum then
			self.redDotIcon:setEnable(true);
		else
			self.redDotIcon:setEnable(false);
		end
	end
end

function Lua_TopRightPanel:onCloseClick(go)
	local v = not self._showState;
	if v then
		DataCenter.allRtData:setSystemState(true);
		DataCenter.allRtData:setPlayerState(true);
	else
		DataCenter.allRtData:setPlayerState(false);
	end
	self:setShowState(v);
end

function Lua_TopRightPanel:updateRightTopIcons(val)
	if val == true then
		self:_updateRightTopIcons();
	else
		Lua_CommonUtil.delayCollectCall("rt", self, self._updateRightTopIcons, nil, 0.2);
	end
end

function Lua_TopRightPanel:_updateRightTopIcons(val)
	if self.isDispose_2 == true then
		return;
	end

	self.shrinkRedDotNum = 0; -- 红点计数
	self.openRedDotNum = 0; -- 红点计数
	self.shrinkShowArr = Array();
	self.openShowArr = Array();
	local list = DataCenter.allRtData:getShowList();
	if list ~= nil then
		list:sort("sort_index", true);
		local len = list:getSize();
		for i = 1, len do
			data = list[i];
			if data.pos_type ~= 3 then
				self.openShowArr:add(data);
				if data:checkShrinkShow() == true and self.hideAll ~= true then 
					self.shrinkShowArr:add(data);
					if data.redDotShowState == true then
						self.shrinkRedDotNum = self.shrinkRedDotNum + 1;
						self.openRedDotNum = self.openRedDotNum + 1;
					end
				else
					if data.redDotShowState == true then
						self.openRedDotNum = self.openRedDotNum + 1;
					end
				end
			else
				self.shrinkShowArr:add(data);
			end
		end
	end

	self:updateIconList();
	self:updateArrowRedDot();
end

function Lua_TopRightPanel:updateIconList()
	local dataList;
	if self._showState == false then
		dataList = self.shrinkShowArr;
	else
		dataList = self.openShowArr;
	end

	local icon;
	local data;
	local len;
	local sPosX = 0;
	local sPosY = 0;
	local tPosX = 0;
	local tPosY = 0;
	local count = 0;
	local p = self.c1;
	local arr = Array();
	local offsetX = 88;
	local posDic = {};
	if dataList ~= nil and p ~= nil then
		len = dataList:getSize();

		local bigIconLen = 0;
		for i = 1, len do
			data = dataList[i];
			if data.pos == 4 then
				bigIconLen = bigIconLen + 1;
			end
		end
		for i = 1, len do
			data = dataList[i];
			icon = self:findIconByIconId(data.id);
			if posDic[data.pos] == nil then
				posDic[data.pos] = 0;
			end
			count = posDic[data.pos];
			local addPosX = 0;
			if data.pos == 2 then
				addPosX = 156;
			end
			local bigOffset = bigIconLen * (-offsetX);
			if data.pos == 4 then
				posDic[data.pos] = count + 1;
				tPosX = count * (-offsetX);
				tPosY = -42;
			else
				posDic[data.pos] = count + 1;
				if data.pos == 2 then
					if posDic[data.pos] <= 2 then
						tPosX = count * -offsetX + addPosX + 69;
					else
						tPosX = count * -offsetX + addPosX + bigOffset + 20;
					end
				elseif data.pos == 1 then
					tPosX = count * -offsetX + addPosX + bigOffset;
				else
					tPosX = count * -offsetX + addPosX;
				end
				
				tPosY = (data.pos - 1) * -90;
			end
			
			if icon ~= nil then
				TweenUtil.getInstance():stop(icon.content);
				sPosX = icon.x;
				sPosY = icon.y;
				icon:setData(data);
			else
				if data.pos_type == 4 then
					icon = Lua_TopRightIcon.new(self.c2);
				else
					icon = Lua_TopRightIcon.new(p);
				end
				icon:setDepth(self.depth + 1);
				icon:setData(data);
				sPosX = (count - 1) * -offsetX + addPosX;
				sPosY = tPosY;
				local num = self.showOrHideTweenTime / 0.05;
				icon:addAphaEff(0, 1);
			end

			if data.config.icon_float == 1 and tonumber(DataCenter.allRtData.openningRightIconId) == tonumber(data.iconId) then
				icon:setLocation(tPosX, tPosY, 0);
				self.curFloatingIcon = icon;
				local sizeStr = LuaUtil.getUIItemSize(data.config.float_target_path);					
				local posarr = string.split(sizeStr,"|");
				local px = tonumber(posarr[3]);
				local py = tonumber(posarr[4]);
				DataCenter.allRtData.curFloatTargetPosX = px;
				DataCenter.allRtData.curFloatTargetPosY = py;
				icon:setEnable(false);
			else
				icon:setEnable(true);
				icon:setLocation(sPosX, sPosY, 0);
				-- 缓动
				TweenUtil.getInstance():addTween(icon.content, self.showOrHideTweenTime, 0, Vector3(tPosX, tPosY, 0), nil, nil);
			end

			if self.openningIconId ~= nil and self.openningIconId:indexOf(data.iconId) ~= -1 then
				icon:checkShowLockEffect(true);
			else
				icon:checkShowLockEffect();
			end
			arr:add(icon);
		end
		self.openningIconId = nil;
	end

	len = self.iconList1:getSize();
	for i = 1, len do
		icon = self.iconList1[i];
		TweenUtil.getInstance():stop(icon.content);
		tPosX = icon.x + 84;
		tPosY = icon.y;
		self.hideIconList:add(icon);
		icon:addAphaEff(1, 0, self, self.iconTweenComplete);
		TweenUtil.getInstance():addTween(icon.content, self.showOrHideTweenTime, 0, Vector3(tPosX, tPosY, 1), nil, nil);
	end
	self.iconList1:clear();
	self.iconList1 = arr;
end

function Lua_TopRightPanel:iconTweenComplete(icon)
	if icon ~= nil then
		local len = self.hideIconList:getSize();
		for i = 1, len do 
			if self.hideIconList[i] == icon then
				self.hideIconList:remove(i);
				break;
			end
		end
		TweenUtil.getInstance():stop(icon.content);
		icon:dispose();
		icon = nil;
	end
end

function Lua_TopRightPanel:findIconByIconId(iconId)
	local len = self.iconList1:getSize();
	for i = 1, len do
		if self.iconList1[i].data.id == iconId then
			return self.iconList1:remove(i);
		end
	end

	return nil;
end

-- 刷新对应iconId的红点显示
function Lua_TopRightPanel:onUpdateIconRedDot(iconId)
	local iconData = DataCenter.allRtData.topRightIconDic[iconId];
	if iconData == nil and iconId ~= -1 then
		return;
	end

	if iconId == -1 or iconData.canShow == true then
		local arr = self.iconList1;
		if arr ~= nil then
			local len = arr:getSize();
			for i = 1, len do 
				if iconId == -1 or arr[i].data.id == tonumber(iconId) then
					arr[i]:updateRedDotState();
					if iconId ~= -1 then
						break;
					end
				end
			end
		end		

		self.shrinkRedDotNum = 0; -- 红点计数
		self.openRedDotNum = 0; -- 红点计数
		local len = self.openShowArr:getSize();
		for i = 1, len do
			if self.openShowArr[i].redDotShowState == true then
				self.openRedDotNum = self.openRedDotNum + 1;
			end
		end
		len = self.shrinkShowArr:getSize();
		for i = 1, len do
			if self.shrinkShowArr[i].redDotShowState == true then
				self.shrinkRedDotNum = self.shrinkRedDotNum + 1;
			end
		end
		self:updateArrowRedDot();
	end
end