-- 地图界面数据
checkRequire("Lua_MapWorldInfoVo");
checkRequire("Lua_MapMonsterNoticeVo");
Lua_MapWindowUtil = class("Lua_MapWindowUtil");
Lua_MapWindowUtil.TRANSFER = 1; -- 传送
Lua_MapWindowUtil.NPC = 2;	-- NPC
Lua_MapWindowUtil.MONSTER = 3;	-- 怪物
function Lua_MapWindowUtil:ctor()
    self:superCall("ctor");
    self.sceneTransData = {};
    self.sceneTeleportData = {};
    self.sceneNpcData = {};
    self.sceneMonsterData = {};
    self.sceneSafeData = {};
    self.sceneBornPointData = {};
    self.sceneMonsterNoticeData = {};
    self.sceneSelectId = 0;
end

function Lua_MapWindowUtil.Get:flyShoesItemId()
	if self._flyShoesItemId == nil then
		self._flyShoesItemId = Lua_CommonUtil.getCommonConfig("transfer_item", 1);
	end
	return self._flyShoesItemId;
end

function Lua_MapWindowUtil.Get:worldMapData()
	if self._worldMapData == nil then
		self._worldMapData = Array();
		local config = checkRequire("scene");
		for k, v in pairs(config) do
			if v.world_map ~= nil then
				local vo = Lua_MapWorldInfoVo.new();
				vo:setData(v, k);
				self._worldMapData:add(vo);
			end
		end
	end

	return self._worldMapData;
end

-- 获取地图显示的传送阵
function Lua_MapWindowUtil:getSceneTransInfo(sceneId)
	if self.sceneTransData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "exits"});
		if list ~= nil then
			for k, v in pairs(list) do
				if v.not_show_minimap == nil or v.not_show_minimap ~= 1 then
					arr:add({typeName = "exits", data = v});
				end
			end
		end
		self.sceneTransData[tostring(sceneId)] = arr;
	end

	return self.sceneTransData[tostring(sceneId)];
end

-- 获取地图显示的瞬移点
function Lua_MapWindowUtil:getSceneTeleportInfo(sceneId)
	if self.sceneTeleportData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "teleport_point"});
		if list ~= nil then
			for k, v in pairs(list) do
				if v.not_show_minimap == nil or v.not_show_minimap ~= 1 then
					arr:add({typeName = "teleport", data = v});
				end
			end
		end
		self.sceneTeleportData[tostring(sceneId)] = arr;
	end

	return self.sceneTeleportData[tostring(sceneId)];
end

-- 获取地图显示的npc
function Lua_MapWindowUtil:getSceneNPCInfo(sceneId)
	if self.sceneNpcData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "npc"});
		if list ~= nil then
			for k, v in pairs(list) do
				if v.not_show_minimap == nil or v.not_show_minimap ~= 1 then
					arr:add({typeName = "npc", data = v});
				end
			end
		end
		self.sceneNpcData[tostring(sceneId)] = arr;
	end

	return self.sceneNpcData[tostring(sceneId)];
end

-- 获取地图显示的怪物点
function Lua_MapWindowUtil:getSceneMonsterInfo(sceneId)
	if self.sceneMonsterData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "monster"});
		if list ~= nil then
			for k, v in pairs(list) do
				if v.not_show_minimap == nil or v.not_show_minimap ~= 1 then
					arr:add({typeName = "monster", data = v});
				end
			end
		end
		self.sceneMonsterData[tostring(sceneId)] = arr;
	end

	-- return self.sceneMonsterData[tostring(sceneId)];
	
	-- 特殊做，某些支线不显示
	local arr = self.sceneMonsterData[tostring(sceneId)];
	local result = Array();
	local len = arr:getSize();
	for i = 1, len do
		local vo = arr[i].data;
		if vo.showLine ~= nil then
			for j = 1, #vo.showLine do
				if tonumber(DataCenter.roleData.curLine) == tonumber(vo.showLine[j]) then
					result:add(arr[i]);
					break;
				end	
			end
		else
			result:add(arr[i]);
		end
	end
	return result;
end

-- 获取地图显示的安全区
function Lua_MapWindowUtil:getSceneSafeInfo(sceneId)
	if self.sceneSafeData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "safe_area"});
		if list ~= nil then
			for k, v in pairs(list) do
				if (v.not_show_minimap == nil or v.not_show_minimap ~= 1) and v.res_safe ~= nil and v.res_safe ~= "" then
					arr:add({typeName = "safe", data = v});
				end
			end
		end
		self.sceneSafeData[tostring(sceneId)] = arr;
	end

	return self.sceneSafeData[tostring(sceneId)];
end

-- 获取地图显示的出生点
function Lua_MapWindowUtil:getSceneBornPointInfo(sceneId)
	if self.sceneBornPointData[tostring(sceneId)] == nil then
		local arr = Array();
		local list = getConfig({"scene", sceneId, "born_point"});
		if list ~= nil then
			for k, v in pairs(list) do
				if v.not_show_minimap == nil or v.not_show_minimap ~= 1 then
					arr:add({typeName = "bornPoint", data = v});
				end
			end
		end
		self.sceneBornPointData[tostring(sceneId)] = arr;
	end

	return self.sceneBornPointData[tostring(sceneId)];
end

function Lua_MapWindowUtil:getSceneMonsterPox(sceneId,monsterId)--通过场景ID + 怪物ID 获取某个怪物坐标
	local arr = self:getSceneMonsterInfo(sceneId);
	for i=1,arr:getSize() do
		if arr[i].data.id == monsterId then
			return arr[i].data
		end
	end
	return nil;
end

function Lua_MapWindowUtil:getMonsterNoticeVo(objId)
	if self.sceneMonsterNoticeData[objId] == nil then
		local config = getConfig({"mapMonsterNotice", tonumber(objId)});
		if config == nil then
			return nil;
		end
		local vo = Lua_MapMonsterNoticeVo.new(objId, config);
		self.sceneMonsterNoticeData[objId] = vo;
	end
	
	return self.sceneMonsterNoticeData[objId];
end