-- 市场数据
checkRequire("Lua_MarketSellVo");
Lua_MarketData = class("Lua_MarketData");
Lua_MarketData.BUSINESS_SHOW_TYPE = 1;
Lua_MarketData.BUSINESS_SHOW_LIST = 2;
function Lua_MarketData:ctor()
	self.selectIndex = 1;
	self.marketSellInfo = {};
	self._mineShelvesArr = Array();
end

function Lua_MarketData:dispose()
	self.marketSellInfo = {};
	if self._mineShelvesArr ~= nil then
		self._mineShelvesArr:dispose();
		self._mineShelvesArr:clear();
	end
	self._mineShelvesArr = Array();

	if self.marketRecordArr ~= nil then
		self.marketRecordArr:dispose();
		self.marketRecordArr:clear();
		self.marketRecordArr = nil;
	end
end

function Lua_MarketData:fromServer50100501(msg)
	if msg == nil then
		return;
	end

	-- msg.type; -- 类型
	-- msg.main_type; -- 主类型
	-- msg.sub_type; -- 子类型
	-- msg.page_index; -- 当前页
	-- msg.total_page; -- 总页数
	-- msg.market_set; -- 物品列表
	-- msg.buy_times; -- 今天购买次数
	-- msg.search; -- 来自搜索，1表示是
	self._market_count = msg.market_count;

	if msg.search == 1 then
		self.bSearch = true;

		local list = msg.market_set;
		self.marketSearchArr = Array();
		for i = 1, #list do
			local obj = list[i];
			local vo = Lua_MarketSellVo.new();
			vo:fromServer(obj);
			self.marketSearchArr:add(vo);
		end
	else
		self.bSearch = false;

		local list = msg.market_set;
		local mainType = msg.main_type;
		self.marketSellInfo[mainType] = {};
		for i = 1, #list do
			local obj = list[i];
			local configInfo = DataCenter.marketUtil:getSellGoodsMarketInfo(obj.item_id);
			if configInfo ~= nil then
				local subType = configInfo.type;
				if self.marketSellInfo[mainType][subType] == nil then
					self.marketSellInfo[mainType][subType] = Array();
				end

				local vo = Lua_MarketSellVo.new();
				vo:fromServer(obj);
				self.marketSellInfo[mainType][subType]:add(vo);
			end
		end
	end
	self.todayBuyTimes = msg.buy_times;
end

function Lua_MarketData.Get:market_count()
	return self._market_count;
end

-- 我的上架
function Lua_MarketData:fromServer50100504(msg)
	if msg == nil then
		return;
	end

	self.getMineShelvesInfoTime = getTime();
	if self._mineShelvesArr == nil then
		self._mineShelvesArr = Array();
	end
	self._mineShelvesArr:clear();

	if msg.onsell_set ~= nil then
		for i = 1, #msg.onsell_set do
			self._mineShelvesArr:add(msg.onsell_set[i]);
		end
	end
end

function Lua_MarketData.Get:mineShelvesArr()
	return self._mineShelvesArr;
end

function Lua_MarketData:fromServer50100509(msg)
	if self.marketRecordArr == nil then
		self.marketRecordArr = Array();
	end
	self.marketRecordArr:clear();

	if msg.sell_log2 ~= nil then
		for i = 1, #msg.sell_log2 do
			self.marketRecordArr:add(msg.sell_log2[i]);
		end
	end
end

-- 获取某类售卖的数量
function Lua_MarketData:getSubTypeSellCount(mainType, subType)
	local count = 0;
	if self.marketSellInfo ~= nil and self.marketSellInfo[mainType] ~= nil then
		if subType <= 0 then
			for i, v in pairs(self.marketSellInfo[mainType]) do 
				count = count + v:getSize();
			end
		else
			local arr = self.marketSellInfo[mainType][subType];
			if arr ~= nil then
				count = arr:getSize();
			end
		end
	end
	return count;
end

function Lua_MarketData:getSubTYpeSellArrByStarAndJie(mainType, subType, starNum, jieNum, color, pwNum)
	local arr = self:getSubTYpeSellArr(mainType, subType);
	local result = Array();
	local len = arr:getSize();
	local bl = pwNum == 1 and false or true;
	for i = 1, len do 
		local vo = arr[i];
		if (starNum == 0 or vo.starNum == starNum)
			and (jieNum == 0 or vo.jieNum == jieNum)
			and (color == 0 or vo.color == color)
			and (pwNum == 0 or vo.have_pw == bl) then
			result:add(vo);
		end
	end
	return result;
end

-- 获取某类售卖的数据集
function Lua_MarketData:getSubTYpeSellArr(mainType, subType)
	local arr = Array();
	if self.marketSellInfo ~= nil and self.marketSellInfo[mainType] ~= nil then
		if subType <= 0 then
			for i, v in pairs(self.marketSellInfo[mainType]) do 
				for j = 1, v:getSize() do
					arr:add(v[j]);
				end
			end
		else
			if self.marketSellInfo[mainType][subType] ~= nil then
				arr = self.marketSellInfo[mainType][subType];
			end
		end
	end
	return arr;
end

-- 我能出售物品数组
function Lua_MarketData:minePackSellGoodsArr(packType)
	local arr = Array();
	local bagData = DataCenter.packData:getBagType(packType);
	local bagArr = bagData:getBagAllData();
	local len = bagArr:getSize();
	for i = 1, len do
		local vo = bagArr[i];
		if vo ~= nil then
			-- 判断能否出售
			if self:checkCanOnSheleves(vo) == true then
				local weight = 0;
				if packType == Lua_PackData.CARD_PACK then
					weight = 100000 + vo.color * 1000 + vo.card_level;
				elseif packType == Lua_PackData.STAMP_PACK then
					weight = 100000 + vo.color * 1000 + vo.order;
				end
				arr:add({data = vo, weight = weight});
			end
		end
	end

	if packType == Lua_PackData.CARD_PACK or packType == Lua_PackData.STAMP_PACK then
		arr:sort("weight",true);
	end

	local num = 0;
	len = arr:getSize();
	if len < 24 then
		num = 24 - len;
	elseif len % 4 > 0 then 
		num = 4 - (len % 4);
	end

	for i = 1, num do 
		arr:add({data = i});
	end
	return arr;
end

function Lua_MarketData:checkCanOnSheleves(vo)
	if vo ~= nil and vo.bind ~= 1 and DataCenter.marketUtil:getSellGoodsMarketInfo(vo.id) ~= nil then
		return true;
	end
	return false;
end