checkRequire("Lua_MarketData");
checkRequire("Lua_MarketUtil");
Lua_MarketProxy = class("Lua_MarketProxy");
function Lua_MarketProxy:ctor()
	DataCenter.marketData = Lua_MarketData.new();
	DataCenter.marketUtil = Lua_MarketUtil.new();

	LuaUtil.addLuaMsg(50100501, self, self.rMarketInfoByType);	    -- 市场信息(返回)
	LuaUtil.addLuaMsg(50100502, self, self.rSellGoods);	            -- 上架(返回)
	LuaUtil.addLuaMsg(50100503, self, self.rBuyGoods);	            -- 购买(返回)
	LuaUtil.addLuaMsg(50100504, self, self.rMineShelvesInfo);	    -- 我的上架(返回)
	LuaUtil.addLuaMsg(50100505, self, self.rRemoveByShelves);	    -- 下架(返回)
	LuaUtil.addLuaMsg(50100507, self, self.rMarketGoodsSellInfo);   -- 市场价格(返回)
	LuaUtil.addLuaMsg(50100509, self, self.rMarketRecordsInfo);     -- 出售记录(返回)
	LuaUtil.addLuaMsg(80100511, self, self.SetSellNum);             -- 搜索(返回)
end

-- 获取市场信息(返回)
function Lua_MarketProxy:rMarketInfoByType(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100501();
		msg:ParseFromString(mp.data);
		DataCenter.marketData:fromServer50100501(msg);
		Lua_MsgUtil.callFunc("rMarketInfoByType");
	end
end

-- 上架(返回)
function Lua_MarketProxy:rSellGoods(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121732));
	end
end

-- 购买(返回)
function Lua_MarketProxy:rBuyGoods(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121733));
		if Lua_WindowUtil.isWindowShowing("Lua_PasswordInputWindow") == true then
			Lua_WindowUtil.openWin("Lua_PasswordInputWindow", WinParam.ACTION_CLOSE)
		end
	end
end

-- 我的上架(返回)
function Lua_MarketProxy:rMineShelvesInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100504();
		msg:ParseFromString(mp.data);
		DataCenter.marketData:fromServer50100504(msg);
		Lua_MsgUtil.callFunc("rMineShelvesInfo");
	end
end

-- 下架(返回)
function Lua_MarketProxy:rRemoveByShelves(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(121718));
	end
end

-- 市场价格(返回)
function Lua_MarketProxy:rMarketGoodsSellInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100507();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rMarketGoodsSellInfo", msg);
	end
end

-- 出售记录(返回)
function Lua_MarketProxy:rMarketRecordsInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100509();
		msg:ParseFromString(mp.data);
		DataCenter.marketData:fromServer50100509(msg);
		Lua_MsgUtil.callFunc("rMarketRecordsInfo");
	end
end

-- 市场上架数量通知
function Lua_MarketProxy:SetSellNum(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100511();
		msg:ParseFromString(mp.data);
		-- DataCenter.marketData:fromServerSellInfo(msg);
		Lua_MsgUtil.callFunc("rSetSellNum", msg.market_count);
	end
end





-- 市场信息
function Lua_MarketProxy:sMarketInfoByType(mainType, subType)
	local cmd = ProtoPublic_pb.Proto10100501();
	cmd.main_type = mainType;   -- 主要类型，0表示所有
	cmd.sub_type = subType;     -- 子类型
	cmd.page_index = 0;         -- 请求页
	cmd.sort = 0;               -- 1降序，2升序
	cmd.type = 0;               -- 类型，0时间，1数量，2单价，3总价
	sendMsg(10100501, cmd);
end

-- 上架
function Lua_MarketProxy:sSellGoods(moneyType, idx, count, price, shout, pack_type, password)
	local cmd = ProtoPublic_pb.Proto10100502();
	cmd.money_type = moneyType;    -- 金钱类型0元宝，1绑元
	cmd.index = idx;               -- 物品索引
	cmd.amount = count;            -- 物品数量
	cmd.price = price;             -- 总价
	cmd.shout = shout;             -- 传闻，0表示否
	cmd.pack_type = pack_type;     -- 背包类型
	if password ~= nil then
		cmd.password = password;
	end
	sendMsg(10100502, cmd);
end

-- 购买
function Lua_MarketProxy:sBuyGoods(marketIdx, itemId, count,password)
	local cmd = ProtoPublic_pb.Proto10100503();
	cmd.market_index = marketIdx; -- 市场索引
	cmd.item_id = itemId;         -- 物品ID
	cmd.buy_amount = count;       -- 购买数量
	if password ~= nil then
		cmd.password = password;
	end
	sendMsg(10100503, cmd);
end

-- 我的上架
function Lua_MarketProxy:sMineShelvesInfo()
	sendMsg(10100504);
end

-- 下架
function Lua_MarketProxy:sRemoveByShelves(marketIdx)
	local cmd = ProtoPublic_pb.Proto10100505();
	cmd.market_index = marketIdx; -- 索引
	sendMsg(10100505, cmd);
end

-- 续期
function Lua_MarketProxy:sRenewal(marketIdx)
	local cmd = ProtoPublic_pb.Proto10100506();
	cmd.market_index = marketIdx; -- 索引
	sendMsg(10100506, cmd);
end

-- 市场价格
function Lua_MarketProxy:sMarketGoodsSellInfo(itemId)
	local cmd = ProtoPublic_pb.Proto10100507();
	cmd.item_id = itemId; -- 物品ID
	sendMsg(10100507, cmd);
end

-- 全部取回
function Lua_MarketProxy:sTackBackAll()
	sendMsg(10100508);
end

-- 出售记录
function Lua_MarketProxy:sMarketRecordsInfo()
	sendMsg(10100509);
end

-- 吆喝
function Lua_MarketProxy:sShoutGoods(itemName, amount, price)
	local cmd = ProtoPublic_pb.Proto10100510();
	cmd.item = itemName; -- 物品
	cmd.amount = amount; -- 数量
	cmd.total = price;   -- 总价
	sendMsg(10100510, cmd);
end

-- 搜索
function Lua_MarketProxy:sSearch(searchName)
	local cmd = ProtoPublic_pb.Proto10100511();
	cmd.name = searchName; -- 名称
	sendMsg(10100511, cmd);
end

-- 界面关闭
function Lua_MarketProxy:sMarketWindowClose()
	sendMsg(10100512);
end