﻿checkRequire("Lua_MarryData");
Lua_MarryProxy = class("Lua_MarryProxy");
function Lua_MarryProxy:ctor()
	DataCenter.marryData = Lua_MarryData.new();

	LuaUtil.addLuaMsg(50101401, self, self.rCheckMarryInfoMsg);
	LuaUtil.addLuaMsg(50101402, self, self.rYuYueMarryMsg);
	LuaUtil.addLuaMsg(50101403, self, self.rBuBanMarryMsg);
	LuaUtil.addLuaMsg(50101404, self, self.rBreakMarryMsg);
	LuaUtil.addLuaMsg(50101405, self, self.rRingUpMsg);
	LuaUtil.addLuaMsg(50101407, self, self.rMarryInfoMsg);
	LuaUtil.addLuaMsg(50101408, self, self.rMarryReplyMsg);
	LuaUtil.addLuaMsg(50101413, self, self.rBuyMarryGiftMsg);
	LuaUtil.addLuaMsg(50101414, self, self.rGetMarryGiftMsg);
	LuaUtil.addLuaMsg(50101417, self, self.rYuYueMarryTimeMsg);
	LuaUtil.addLuaMsg(50101418, self, self.rSecondMarryReplyMsg);
	LuaUtil.addLuaMsg(50101419, self, self.rTongBuMarryMsg);
	LuaUtil.addLuaMsg(50401401, self, self.rInMarrySceneMsg);

	LuaUtil.addLuaMsg(51401405, self, self.rUseFlowerMsg);

	LuaUtil.addLuaMsg(80101401, self, self.NoticeSelfMarryInfo);
	LuaUtil.addLuaMsg(80101402, self, self.NoticeMarryAnimFinish);
	LuaUtil.addLuaMsg(80101403, self, self.NoticeMarryIcon);
	LuaUtil.addLuaMsg(80101404, self, self.NoticeMarryReply);
	LuaUtil.addLuaMsg(80101405, self, self.NoticeServerPlayAnim);
	LuaUtil.addLuaMsg(80101407, self, self.NoticeMarryState);
	LuaUtil.addLuaMsg(80101409, self, self.NoticeFlowerCarInfo);
	LuaUtil.addLuaMsg(80101414, self, self.WeddingBanquetTips);
	LuaUtil.addLuaMsg(80101415, self, self.WeddingBanquetAnswer);
	LuaUtil.addLuaMsg(80101416, self, self.NoticeBuyLoveGift);

	LuaUtil.addLuaMsg(80101412, self, self.NoticeMarryTipsWindow);
	LuaUtil.addLuaMsg(80101413, self, self.NoticeMarrySelectedWindow);

	LuaUtil.addLuaMsg(80401402, self, self.NoticeMarryStep);
	LuaUtil.addLuaMsg(80401403, self, self.NoticePlayFlowerAnim);
	LuaUtil.addLuaMsg(80401405, self, self.NoticeMarryVisitor);
	LuaUtil.addLuaMsg(80401406, self, self.NoticePlayFireworks);
	LuaUtil.addLuaMsg(81401421, self, self.NoticeUpdateRingInfo);

	Lua_MsgUtil.addEventListener("OPEN_MARRY_WINDOW", self, self.marryWindowEvent);
	-- Lua_MsgUtil.addEventListener("FUNCTION_OPEN", self, self.onUpdateFunctionOpen);
end

function Lua_MarryProxy:marryWindowEvent(npcId)
	local sceneData = Lua_SceneConfigData.getSceneConfig(10103);
	-- 暂定写10103 洛阳城
	local npcData = sceneData:findNpcById(tonumber(npcId));
	if DataCenter.funcOpenData:isOpened(10086) == true then
		Lua_WindowUtil.openWin("Lua_MarryWindow", WinParam.ACTION_OPEN);
	else
		DataCenter.taskData:showNpcTalkWindow(npcData, tonumber(npcId));
	end
end

function Lua_MarryProxy:rCheckMarryInfoMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101401();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101401(msg);
	end
end

function Lua_MarryProxy:rYuYueMarryMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101402();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101402(msg);
	end
end

function Lua_MarryProxy:rBuBanMarryMsg(mp)
	if mp.errno == 0 then
		-- OperateAlert.show(LanUtil.getValue(121224));
	end
end

function Lua_MarryProxy:rBreakMarryMsg(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_MarryBrokenWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_BreakMarryTipsWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_MarryWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_MarryProxy:rRingUpMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101405();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101405(msg);
		Lua_MsgUtil.callFunc("RING_UPDATE");
	else
		Lua_MsgUtil.callFunc("REMOVE_AUTO_UP");
	end
end

function Lua_MarryProxy:rMarryInfoMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101407();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101407(msg);
		if DataCenter.funcOpenData:isOpened(10086) == false then
			Lua_MsgUtil.addEventListener("FUNCTION_OPEN", self, self.onMarryOpen);
			-- DataCenter.marryData.doNotMarriedRedDot = true;
		else
			Lua_MsgUtil.callFunc("UPDATE_SOCIAL_REDDOT");
		end
		Lua_MsgUtil.callFunc("SET_MARRY_PANEL");
		Lua_MsgUtil.callFunc("SET_LOVE_GIFT_PANEL");
	end
end

function Lua_MarryProxy:onMarryOpen(openIds)
	local len = openIds:getSize();
	for i = 1, len do
		if openIds[i]==10086 then
			-- DataCenter.marryData.doNotMarriedRedDot = true;
			Lua_MsgUtil.callFunc("UPDATE_SOCIAL_REDDOT");
			Lua_MsgUtil.removeEventListener("FUNCTION_OPEN", self, self.onMarryOpen);
		end
	end
end

function Lua_MarryProxy:rMarryReplyMsg(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_MarryTipsWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_MarryProxy:rBuyMarryGiftMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101413();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101413(msg);
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.BUY_LOVE_GIFT, state = 0});
	end
end

function Lua_MarryProxy:rGetMarryGiftMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101414();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101414(msg);
	end
end

function Lua_MarryProxy:rYuYueMarryTimeMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101417();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101417(msg);
	end
end

function Lua_MarryProxy:rSecondMarryReplyMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101418();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101418(msg);
	end
end

function Lua_MarryProxy:rTongBuMarryMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101419();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer50101419(msg);
	end
end

function Lua_MarryProxy:rInMarrySceneMsg(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_YaoQingHanWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_MarryInfoWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_MarryYaoQingWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_MarryProxy:rUseFlowerMsg(mp)
	if mp.errno == 0 then
		-- OperateAlert.show("51401405播放漫天花雨特效");
	end
end

function Lua_MarryProxy:NoticeSelfMarryInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101401();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101401(msg);
	end
end

function Lua_MarryProxy:NoticeMarryAnimFinish(mp)
	if mp.errno == 0 then
	end
end

function Lua_MarryProxy:NoticeMarryIcon(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101403();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101403(msg);
	end
end

function Lua_MarryProxy:NoticeMarryReply(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101404();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101404(msg);
	end
end

function Lua_MarryProxy:NoticeServerPlayAnim(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101405();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101405(msg);
	end
end

function Lua_MarryProxy:NoticeMarryState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101407();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101407(msg);
	end
end

function Lua_MarryProxy:NoticeFlowerCarInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101409();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101409(msg);
	end
end

function Lua_MarryProxy:NoticeMarryTipsWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101412();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101412(msg);
	end
end

function Lua_MarryProxy:NoticeMarrySelectedWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101413();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101413(msg);
	end
end

function Lua_MarryProxy:NoticeMarryStep(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80401402();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80401402(msg);
	end
end
function Lua_MarryProxy:NoticePlayFlowerAnim(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("PLAY_MARRY_EFFECT");
	end
end

function Lua_MarryProxy:NoticeMarryVisitor(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80401405();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80401405(msg);
	end
end

-- 补办婚宴tips
function Lua_MarryProxy:WeddingBanquetTips(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101414();
		msg:ParseFromString(mp.data);
		-- DataCenter.marryData:fromServer80101414(msg);
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(124123),
			type = 1, subFun = self.agreeWeddingBanquet, cancelFun = self.disAgreeWeddingBanquet});
	end
end

function Lua_MarryProxy:agreeWeddingBanquet()
	local cmd = ProtoPublic_pb.Proto10101418();
	cmd.reply = 1;
	sendMsg(10101418, cmd);
end

function Lua_MarryProxy:disAgreeWeddingBanquet()
	local cmd = ProtoPublic_pb.Proto10101418();
	cmd.reply = 0;
	sendMsg(10101418, cmd);
end

-- 补办婚宴应答 
function Lua_MarryProxy:WeddingBanquetAnswer(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101415();
		msg:ParseFromString(mp.data);
		if msg.reply == 1 then
			Lua_WindowUtil.openWin("Lua_WeddingBanquetWindow", WinParam.ACTION_OPEN);
		else
			OperateAlert.show(LanUtil.getValue(124124));
		end
	end
end

-- 爱情礼盒请求赠送通知
function Lua_MarryProxy:NoticeBuyLoveGift(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101416();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80101416(msg);
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.BUY_LOVE_GIFT, state = 1,
			altas = "icon_atlas_5", spriteName = "activity_small_tips_aqlh"});
	end
end

-- 播放烟花特效
function Lua_MarryProxy:NoticePlayFireworks(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80401406();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer80401406(msg);
		if tonumber(msg.use_id)==DataCenter.roleData.roleId then
			Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE);
		end
		Lua_WindowUtil.openWin("Lua_FireWorksEffectWindow", WinParam.ACTION_OPEN, msg.firework_type);
	end
end

-- 更新信物信息
function Lua_MarryProxy:NoticeUpdateRingInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401421();
		msg:ParseFromString(mp.data);
		DataCenter.marryData:fromServer81401421(msg);
		Lua_MsgUtil.callFunc("SET_LOVE_GIFT_PANEL");
	end
end





function Lua_MarryProxy:sCheckMarryInfoMsg()
	sendMsg(10101401);
end

function Lua_MarryProxy:sYuYueMarryMsg(marryType, is_repair)
	local cmd = ProtoPublic_pb.Proto10101402();
	cmd.type = marryType;
	cmd.is_repair = is_repair;
	sendMsg(10101402, cmd);
end

function Lua_MarryProxy:sBuBanMarryMsg(marryType)
	sendMsg(10101403);
end

function Lua_MarryProxy:sBreakMarryMsg()
	sendMsg(10101404);
end

function Lua_MarryProxy:sRingUpMsg()
	sendMsg(10101405);
end

function Lua_MarryProxy:sSendFlowerMsg()
	sendMsg(10101406);
end

function Lua_MarryProxy:sMarryInfoMsg()
	sendMsg(10101407);
end

function Lua_MarryProxy:sOpenMarryPanel() -- 请求姻缘界面信息
	local cmd = ProtoPublic_pb.Proto10101407();
	cmd.open_panel = 1;
	sendMsg(10101407, cmd);
end

function Lua_MarryProxy:sMarryReplyMsg(reply, refuse_type)
	local cmd = ProtoPublic_pb.Proto10101408();
	cmd.reply = reply;
	if refuse_type ~= nil then
		cmd.refuse_type = refuse_type;
	end
	sendMsg(10101408, cmd);
end

function Lua_MarryProxy:sBuyMarryGiftMsg(marryType, id, value)
	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = marryType;
	cmd.other_info.id = id;
	cmd.other_info.value = value;
	sendMsg(10101413, cmd);
end

function Lua_MarryProxy:sGetMarryGiftMsg(marryType, other_info)
	local cmd = ProtoPublic_pb.Proto10101414();
	cmd.type = marryType;
	cmd.other_info = other_info;
	sendMsg(10101414, cmd);
end

function Lua_MarryProxy:sYuYueMarryTimeMsg(hour, min, now_held)
	local cmd = ProtoPublic_pb.Proto10101417();
	if now_held ~= 1 then
		cmd.hour_tick = hour;
		cmd.min_tick = min;
	end
	cmd.now_held = now_held
	sendMsg(10101417, cmd);
end

function Lua_MarryProxy:sSecondMarryReplyMsg(reply)
	local cmd = ProtoPublic_pb.Proto10101418();
	cmd.reply = reply;
	sendMsg(10101418, cmd);
end

function Lua_MarryProxy:sTongBuMarryMsg(marryType)
	local cmd = ProtoPublic_pb.Proto10101419();
	cmd.type = marryType;
	sendMsg(10101419, cmd);
end

function Lua_MarryProxy:sStartMarryNowMsg(wedding_id)
	local cmd = ProtoPublic_pb.Proto10401401();
	cmd.wedding_id = wedding_id;
	sendMsg(10401401, cmd);
end

function Lua_MarryProxy:sUseSendFlowerMsg()
	sendMsg(11401405);
end