-- 姻缘消息处理
checkRequire("Lua_MarryNewData");
checkRequire("Lua_MarryNewUtil");
Lua_MarryNewProxy = class("Lua_MarryNewProxy");
function Lua_MarryNewProxy:ctor()
	DataCenter.marryNewData = Lua_MarryNewData.new();
	DataCenter.marryNewUtil = Lua_MarryNewUtil.new();

	LuaUtil.addLuaMsg(51401406, self, self.rMarryKeepsakeSkillsInfo); -- 获取信物技能列表（返回）
	LuaUtil.addLuaMsg(51401436, self, self.rMarryChildrenInfo); -- 获取仙娃界面信息(返回)
	LuaUtil.addLuaMsg(51401438, self, self.rChildrenUpgradeJie); -- 仙娃升阶(返回)
	LuaUtil.addLuaMsg(50101407, self, self.rMarryInfo); -- 获取结缘面板信息(返回)
	LuaUtil.addLuaMsg(50101405, self, self.rMarryKeepsakeUpgrade); -- 提升信物（返回）
	LuaUtil.addLuaMsg(81401421, self, self.rUpdateKeepsakeInfo); -- 主动通知佩戴信物的信息
end

-- 获取信物技能列表（返回）
function Lua_MarryNewProxy:rMarryKeepsakeSkillsInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401406();
		msg:ParseFromString(mp.data);
		DataCenter.marryNewData:updateKeepsakeSkillsInfo(msg);
		Lua_MsgUtil.callFunc("rMarryKeepsakeSkillsInfo");
	end
end

-- 获取仙娃界面信息(返回)
function Lua_MarryNewProxy:rMarryChildrenInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401436();
		msg:ParseFromString(mp.data);
		DataCenter.marryNewData:updateChildrenInfo(msg);
		Lua_MsgUtil.callFunc("rMarryChildrenInfo");
	end
end

-- 仙娃升阶(返回)
function Lua_MarryNewProxy:rChildrenUpgradeJie(mp)
	Lua_MsgUtil.callFunc("rChildrenUpgradeJie", mp.errno);
end

-- 获取结缘面板信息(返回)
function Lua_MarryNewProxy:rMarryInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101407();
		msg:ParseFromString(mp.data);
		DataCenter.marryNewData:fromServer50101407(msg);
		Lua_MsgUtil.callFunc("rMarryInfo");
	end
end

-- 提升信物(返回)
function Lua_MarryNewProxy:rMarryKeepsakeUpgrade(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101405();
		msg:ParseFromString(mp.data);
		DataCenter.marryNewData.keepsakeInfo = msg.keepsake_info; -- 信物信息
	end
	Lua_MsgUtil.callFunc("rMarryKeepsakeUpgrade", mp.errno);
end

-- 主动通知佩戴信物的信息
function Lua_MarryNewProxy:rUpdateKeepsakeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401421();
		msg:ParseFromString(mp.data);
		DataCenter.marryNewData.keepsakeInfo = msg.keepsake_info;
		Lua_MsgUtil.callFunc("rUpdateKeepsakeInfo");
	end
end





-- 获取信物技能列表
function Lua_MarryNewProxy:sMarryKeepsakeSkillsInfo()
	sendMsg(11401406);
end

-- 仙娃道具分解
function Lua_MarryNewProxy:sChildrenEquipmentSol()
	local cmd = ProtoPublic_pb.Proto11401435();
	local dic = DataCenter.marryNewData.childrenSolveSelectDic;
	for k, v in pairs(dic) do
		if v ~= nil and v == true then
			cmd.index:append(tonumber(k));
		end
	end
	sendMsg(11401435, cmd);
end

-- 获取仙娃界面信息
function Lua_MarryNewProxy:sMarryChildrenInfo()
	sendMsg(11401436);
end

-- 激活仙娃
function Lua_MarryNewProxy:sActiveChildren(childId)
	local cmd = ProtoPublic_pb.Proto11401437();
	cmd.id = childId; -- 仙娃id
	sendMsg(11401437, cmd);
end

-- 仙娃升阶
function Lua_MarryNewProxy:sChildrenUpgradeJie(childId)
	local cmd = ProtoPublic_pb.Proto11401438();
	cmd.id = childId; -- 仙娃id
	sendMsg(11401438, cmd);
end

-- 仙娃升级
function Lua_MarryNewProxy:sChildrenUpgrade()
	sendMsg(11401439);
end

-- 仙娃出战状态修改
function Lua_MarryNewProxy:sChangeChildFightState(childId, fightState)
	local cmd = ProtoPublic_pb.Proto11401440();
	cmd.id = childId; -- 仙娃id
	cmd.state = fightState; -- 0 收回；1 出战
	sendMsg(11401440, cmd);
end

-- 仙娃隐藏|显示
function Lua_MarryNewProxy:sShowHideChildren(ShowState)
	local cmd = ProtoPublic_pb.Proto11401450();
	cmd.state = ShowState; -- 0 收回；1 出战
	sendMsg(11401450, cmd);
end

-- 补办婚宴检查
function Lua_MarryNewProxy:sReissueWedding()
	sendMsg(10101403);
end

-- 提升信物
function Lua_MarryNewProxy:sMarryKeepsakeUpgrade()
	sendMsg(10101405);
end

-- 获取结缘面板信息
function Lua_MarryNewProxy:sMarryInfo()
	sendMsg(10101407);
end

-- 购买爱情礼盒
function Lua_MarryNewProxy:sBuyLoveGiftBox(selectType)
	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = selectType; -- 购买类型 //1购买 2请求赠送 3拒绝购买
	sendMsg(10101413, cmd);
end

-- 领取爱情礼盒
function Lua_MarryNewProxy:sGetLoveGiftBox(selectType)
	local cmd = ProtoPublic_pb.Proto10101414();
	cmd.type = selectType; -- 1一次性 2每天
	sendMsg(10101414, cmd);
end