-- 仙娃技能
Lua_MarryChildrenSkillVo = class("Lua_MarryChildrenSkillVo");
function Lua_MarryChildrenSkillVo:ctor(id, config)
	self.id = id;
	self.config = config or getConfig({"baby_skill", id});
	self:resetServerInfo();
end

function Lua_MarryChildrenSkillVo.Get:name()
	return self.config.name;
end

function Lua_MarryChildrenSkillVo.Get:skillType()
	return self.config.skillType;
end

function Lua_MarryChildrenSkillVo.Get:atlasName()
	return self.config.atlasName;
end

function Lua_MarryChildrenSkillVo.Get:iconName()
	return self.config.iconName;
end

-- 激活需要的仙娃id
function Lua_MarryChildrenSkillVo.Get:activeNeedChildId()
	if self._childId == nil then
		self._childId = 0;
		self._childLv = 0;
		local list = self.config.baby_grade;
		if list ~= nil and #list > 1 then
			self._childId = list[1];
			self._childLv = list[2];
		end
	end
	return self._childId;
end

-- 激活需要的对应仙娃的等阶
function Lua_MarryChildrenSkillVo.Get:activeNeedChildLv()
	if self._childLv == nil then
		self._childId = 0;
		self._childLv = 0;
		local list = self.config.baby_grade;
		if list ~= nil and #list > 1 then
			self._childId = list[1];
			self._childLv = list[2];
		end
	end
	return self._childLv;
end

function Lua_MarryChildrenSkillVo:resetServerInfo()
	self.skillLv = 0;
	self.skillIdx = 0;
	self.activeState = 0; -- 0未激活 1激活
end

function Lua_MarryChildrenSkillVo:updateServerInfo(info)
	self.skillLv = info.skill_lvl;
	self.skillIdx = info.skill_index;
	self.activeState = info.activation_state; -- 0未激活 1激活
end

function Lua_MarryChildrenSkillVo.Get:skillDesc()
	if self._skillDesc == nil then
		local attrValue;
		local step = 0;
		local str = "";
		for i = 1, #Lua_ThingDefine.params do
			attrValue = self.config[Lua_ThingDefine.params[i]];
			if attrValue ~= nil and attrValue ~= 0 then
				step, str = self:getTheDesStr(step, Lua_ThingDefine.params[i], attrValue, str);
			end
		end

		-- 两个特殊属性特殊处理
		attrValue = self.config.felement_attack_multi;
		if attrValue ~= nil and attrValue ~= 0 then
			step, str = self:getTheDesStr(step, "felement_attack_multi", attrValue, str);
		end
		attrValue = self.config.felement_defence_multi;
		if attrValue ~= nil and attrValue ~= 0 then
			step, str = self:getTheDesStr(step, "felement_defence_multi", attrValue, str);
		end

		if step == 0 then
			self._skillDesc = getConfig({"servant_skill", self.id, "reMark"}) or "";
		else
			self._skillDesc = "[8495B4]"..LanUtil.formateStr(LanUtil.getValue(144036), str).."[-]";
		end
	end
	return self._skillDesc;
end

function Lua_MarryChildrenSkillVo:getTheDesStr(step, attrName, attrValue, str)
	local stepNum = step;
	local name = Lua_ThingDefine.getParamName(attrName);
	local desStr = str;
	if attrValue ~= nil and attrValue ~= 0 then
		stepNum = stepNum + 1;
		desStr = stepNum > 1 and desStr.."、" or desStr;
		if Lua_ThingDefine.isPercentParam(attrName) == true then
			desStr = desStr..name.."[FFFFFF]+"..attrValue.."%[-]";
		else
			desStr = desStr..name.."[FFFFFF]+"..attrValue.."[-]";
		end
	end
	return stepNum, desStr;
end