-- 仙娃vo
Lua_MarryChildrenVo = class("Lua_MarryChildrenVo");
function Lua_MarryChildrenVo:ctor(id, config, grade)
    self:resetServerInfo();
    self.id = id;
    if grade ~= nil then
	    self.grade = grade;
	else
		self.grade = 0;
	end
    self._force = 0;
    	
    if config == nil then
    	config = getConfig({ "baby_info", id});
    end
    self.config = config;
end

function Lua_MarryChildrenVo.Get:name()
	return self.config.name;
end

function Lua_MarryChildrenVo.Get:color()
	return self.config.color;
end

function Lua_MarryChildrenVo.Get:type()
	return self.config.type;
end

function Lua_MarryChildrenVo.Get:typeStr()
	return self.config.typeStr;
end

-- 激活需要信物等级
function Lua_MarryChildrenVo.Get:activeNeedKeepsakeLv()
	if self._activeNeedKeepsakeLv == nil then
		self._activeNeedKeepsakeLv = self.config.wedding_item_lvl;
		if self._activeNeedKeepsakeLv == nil then
			self._activeNeedKeepsakeLv = 0;
		end
	end
	return self._activeNeedKeepsakeLv;
end

-- 激活需要消耗道具
function Lua_MarryChildrenVo.Get:activeCostItemVo()
	if self._activeCostItemVo == nil then
		if self.config.item == nil then
			return nil;
		end

		local list = self.config.item;
		if #list < 2 then
			return nil;
		end
		self._activeCostItemVo = Lua_ToolVo.new(list[1], list[2]);
	end
	return self._activeCostItemVo;
end

-- 激活需要对应仙娃等阶要求
function Lua_MarryChildrenVo.Get:activeNeedChildVo()
	if self._activeNeedChildVo == nil then
		if self.config.baby_grade == nil then
			return nil;
		end

		local list = self.config.baby_grade;
		if #list < 2 then
			return nil;
		end
		self._activeNeedChildVo = Lua_MarryChildrenVo.new(list[1], nil, list[2]);
	end
	return self._activeNeedChildVo;
end

-- 外形Id
function Lua_MarryChildrenVo.Get:shapeId()
	return self.config.shape_id;
end

-- 来源说明
function Lua_MarryChildrenVo.Get:sourceStr()
	return self.config.sourceStr;
end

-- 升阶道具增加的经验
function Lua_MarryChildrenVo.Get:gradeCostExp()
	return self.config.shape_id;
end

-- 增加等阶经验的道具
function Lua_MarryChildrenVo.Get:gradeCostItemId()
	return self.config.grade_item;
end

-- 头像名
function Lua_MarryChildrenVo.Get:headSrc()
	return self.config.headSrc;
end

-- 道具id
function Lua_MarryChildrenVo.Get:itemId()
	return self.config.item_id;
end

function Lua_MarryChildrenVo:resetServerInfo()
	self.bActive = false;
	self.grade = 0;
	self.gradeExp = 0;
	self._force = 0;
end

-- 更新服务端信息
function Lua_MarryChildrenVo:updateServerInfo(info)
	if info == nil or info.id ~= self.id then
		return;
	end

	self.bActive = true; -- 已激活
	self.grade = info.grade;
	self.gradeExp = info.grade_exp;
	self._force = info.force;
	-- info.skill_list; -- 激活技能列表

	local list = info.skill_list;
	if list ~= nil and #list > 0 then
		for i = 1, #list do
			local skillVo = DataCenter.marryNewUtil:getChildSkillVoById(list[i].skill_id);
			if skillVo ~= nil then
				skillVo:updateServerInfo(list[i]);
			end
		end
	end
end

function Lua_MarryChildrenVo.Get:skillArr()
	return DataCenter.marryNewUtil:getChildSkillsById(self.id);
end

function Lua_MarryChildrenVo.Get:bOutFighting()
	return self.id == DataCenter.marryNewData.marryFightChildrenId;
end

-- 判断是否可激活
function Lua_MarryChildrenVo:checkActive(showTip)
	if self.bActive == true then
		if showTip == true then
			OperateAlert.show(LanUtil.getValue(144037));
		end
		return false;
	end

	-- 信物等级
	local Lvtips = "";
	if self.activeNeedKeepsakeLv > 0 then
		local keepsakeInfo = DataCenter.marryNewData.keepsakeInfo;
		if keepsakeInfo == nil then
			Lvtips = LanUtil.getValue(144038);
		elseif keepsakeInfo.keepsake_lvl < self.activeNeedKeepsakeLv then
			Lvtips = LanUtil.getValue(144039);
		elseif DataCenter.marryNewData.spouseKeepsakeLv < self.activeNeedKeepsakeLv then
			Lvtips = LanUtil.getValue(144039);
		else
			return true;
		end
	end

	local coTips = "";
	if self.activeCostItemVo ~= nil then
		local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.activeCostItemVo.id);
		if num < self.activeCostItemVo.count then
			coTips = LanUtil.getValue(144040);
		else
			return true;
		end
	end

	local chTips = "";
	if self.activeNeedChildVo ~= nil then
		local vo = DataCenter.marryNewUtil.marryChildrenInfo[self.activeNeedChildVo.id];
		if vo == nil then
			chTips = LanUtil.getValue(144041);
		elseif vo.bActive == false then
			chTips = LanUtil.getValue(144042);
		elseif vo.grade < self.activeNeedChildVo.grade then
			chTips = LanUtil.getValue(144043);
		else
			return true;
		end
	end

	if showTip == true then
		if Lvtips ~= "" then
			OperateAlert.show(Lvtips);
		elseif coTips ~= "" then
			OperateAlert.show(coTips);
		elseif chTips ~= "" then
			OperateAlert.show(chTips);
		end
	end
	return false;
end

-- 判断是否可升级
function Lua_MarryChildrenVo:checkUpgrade(showTip)
	if self.bActive == false then
		if showTip == true then
			OperateAlert.show(LanUtil.getValue(144044));
		end
		return false;
	end

	local gradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.id, self.grade);
	if gradeVo == nil then
		if showTip == true then
			OperateAlert.show(LanUtil.getValue(144045));
		end
		return false;
	end

	local nextGradeVo = DataCenter.marryNewUtil:getChildGradeVo(self.id, self.grade + 1);
	if nextGradeVo == nil then
		if showTip == true then
			OperateAlert.show(LanUtil.getValue(144046));
		end
		return false;
	end

	local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.gradeCostItemId);
	if num <= 0 then
		if showTip == true then
			OperateAlert.show(LanUtil.getValue(144047));
		end
		return false;
	end
	return true;
end

function Lua_MarryChildrenVo.Get:force()
	return self._force;
end