-- 姻缘配置
checkRequire("Lua_MarryChildrenVo");
checkRequire("Lua_MarryChildrenSkillVo");
checkRequire("Lua_MarryChildGradeVo");
checkRequire("Lua_MarryChildrenLvInfoVo");
checkRequire("Lua_MarryTitleVo");
checkRequire("Lua_MarryPledgeVo");
Lua_MarryNewUtil = class("Lua_MarryNewUtil");
function Lua_MarryNewUtil:ctor()
    self:superCall("ctor");
end

-- 仙娃
function Lua_MarryNewUtil.Get:marryChildrenDic()
	if self._marryChildrenDic == nil then
		self._marryChildrenDic = {};
		self._marryChildrenInfo = {};

		local config = getConfig({"baby_info"});
		local vo;
		for k, v in pairs(config) do
			vo = Lua_MarryChildrenVo.new(k, v);
			if self._marryChildrenDic[vo.type] == nil then
				self._marryChildrenDic[vo.type] = Array();
			end
			self._marryChildrenDic[vo.type]:add(vo);
			self._marryChildrenInfo[k] = vo;
		end

		for k, v in pairs(self._marryChildrenDic) do
	    	v:sort("id", false);
	    end 
	end
	return self._marryChildrenDic;
end

-- 仙娃
function Lua_MarryNewUtil.Get:marryChildrenInfo()
	if self._marryChildrenInfo == nil then
		self._marryChildrenInfo = {};
		self._marryChildrenDic = {};

		local config = getConfig({"baby_info"});
		local vo;
		for k, v in pairs(config) do
			vo = Lua_MarryChildrenVo.new(k, v);
			if self._marryChildrenDic[vo.type] == nil then
				self._marryChildrenDic[vo.type] = Array();
			end
			self._marryChildrenDic[vo.type]:add(vo);
			self._marryChildrenInfo[k] = vo;
		end

		for k, v in pairs(self._marryChildrenDic) do
	    	v:sort("id", false);
	    end 
	end
	return self._marryChildrenInfo;
end

function Lua_MarryNewUtil.Get:marryChildrenTitleList()
	if self._marryChildrenTitleList == nil then
		self._marryChildrenTitleList = Array();
		
		for k, arr in pairs(self.marryChildrenDic) do
			if arr:getSize() > 0 then
				self._marryChildrenTitleList:add({name = arr[1].typeStr, sub = arr});
			end
		end
	end
	return self._marryChildrenTitleList;
end

function Lua_MarryNewUtil:updateChildrenVo(serverInfo)
	if serverInfo == nil or serverInfo.id == nil then
		return;
	end

	local vo = self.marryChildrenInfo[serverInfo.id];
	if vo == nil then
		return;
	end
	vo:updateServerInfo(serverInfo);
end

function Lua_MarryNewUtil:resetChildrenInfo()
	local dic = self.marryChildrenInfo;
	for k, v in pairs(dic) do
    	v:resetServerInfo();
    end
end

function Lua_MarryNewUtil.Get:allChildrenGradeAttrs()
	local len;
	local obj;
	local list;
	local gradeVo;
	local step = 0;
	local attrObj = {};
	local dic = self.marryChildrenInfo;
	for k, v in pairs(dic) do
    	if v.bActive == true then
    		local gradeVo = self:getChildGradeVo(v.id, v.grade);
    		if gradeVo ~= nil then
    			list = gradeVo.attrsArr;
	            len = list:getSize();
	            for i = 1, len do
	                obj = list[i];
	                step = step + 1;
	                if attrObj[obj.name] == nil then
	                	attrObj[obj.name] = obj.value;
	                else
	                	attrObj[obj.name] = attrObj[obj.name] + obj.value;
	                end
	            end
    		end
    	end
    end

    local arr = Array();
    if step > 0 then
	    len = #Lua_ThingDefine.params;
		for i = 1, len do
	        local v = attrObj[Lua_ThingDefine.params[i]];
	        if v ~= nil and v ~= 0 then
	            obj = {};
	            obj.name = Lua_ThingDefine.params[i];
		        obj.curValue = v;
		        obj.nextValue = 0;
	            arr:add(obj);
	        end
	    end
	end

    return arr;
end


-- 仙娃技能
function Lua_MarryNewUtil.Get:marryChildrenSkillInfo()
	if self._marryChildrenSkillInfo == nil then
		self._marryChildrenSkillInfo = {};
		self._marryChildrenSkillDic = {};
		local config = checkRequire("baby_skill");
		for k, v in pairs(config) do
			local vo = Lua_MarryChildrenSkillVo.new(k, v);
			if self._marryChildrenSkillInfo[vo.activeNeedChildId] == nil then
				self._marryChildrenSkillInfo[vo.activeNeedChildId] = Array();
			end
			self._marryChildrenSkillInfo[vo.activeNeedChildId]:add(vo);
			self._marryChildrenSkillDic[k] = vo;
		end

		for k, v in pairs(self._marryChildrenSkillInfo) do
	    	v:sort("activeNeedChildLv", false);
	    end 
	end
	return self._marryChildrenSkillInfo;
end

-- 仙娃技能
function Lua_MarryNewUtil.Get:marryChildrenSkillDic()
	if self._marryChildrenSkillDic == nil then
		self._marryChildrenSkillInfo = {};
		self._marryChildrenSkillDic = {};
		local config = checkRequire("baby_skill");
		for k, v in pairs(config) do
			local vo = Lua_MarryChildrenSkillVo.new(k, v);
			if self._marryChildrenSkillInfo[vo.activeNeedChildId] == nil then
				self._marryChildrenSkillInfo[vo.activeNeedChildId] = Array();
			end
			self._marryChildrenSkillInfo[vo.activeNeedChildId]:add(vo);
			self._marryChildrenSkillDic[k] = vo;
		end

		for k, v in pairs(self._marryChildrenSkillInfo) do
	    	v:sort("activeNeedChildLv", false);
	    end 
	end
	return self._marryChildrenSkillDic;
end

function Lua_MarryNewUtil:getChildSkillsById(childId)
	local dic = self.marryChildrenSkillInfo;
	if dic ~= nil and dic[childId] ~= nil then
		return dic[childId];
	end
	return Array();
end

function Lua_MarryNewUtil:getChildSkillVoById(skillId)
	local dic = self.marryChildrenSkillDic;
	if dic ~= nil and dic[skillId] ~= nil then
		return dic[skillId];
	end
	return nil;
end

function Lua_MarryNewUtil:resetChildSkill()
	local dic = self.marryChildrenSkillDic;
	for k, v in pairs(dic) do
    	v:resetServerInfo();
    end
end

function Lua_MarryNewUtil:getChildGradeVo(childId, grade)
	if self._marryChildrenGradeInfo == nil then
		self._marryChildrenGradeInfo = {};
	end

	if self._marryChildrenGradeInfo[childId] == nil then
		self._marryChildrenGradeInfo[childId] = {};	
	end

	if self._marryChildrenGradeInfo[childId][grade] == nil then
		local config;
		if grade < 10 then
			config = getConfig({"baby_grade", tonumber(childId.."0"..grade)});
		else
			config = getConfig({"baby_grade", tonumber(childId..grade)});
		end

		if config ~= nil then
			local vo = Lua_MarryChildGradeVo.new(config.id, config);
			self._marryChildrenGradeInfo[vo.childId][vo.grade] = vo;
		else
			return nil;
		end
	end

	return self._marryChildrenGradeInfo[childId][grade];
end

function Lua_MarryNewUtil:getChildrenLvInfoVoByLv(lv)
	if self._marryChildrenLvInfo == nil then
		self._marryChildrenLvInfo = {};
	end

	if self._marryChildrenLvInfo[lv] == nil then
		local config = getConfig({"baby_level", tonumber(lv)});
		if config ~= nil then
			local vo = Lua_MarryChildrenLvInfoVo.new(lv, config);
			self._marryChildrenLvInfo[lv] = vo;
		end
	end

	return self._marryChildrenLvInfo[lv];
end

function Lua_MarryNewUtil.Get:marryFunInfoArr()
	if self._marryFunInfoArr == nil then
		self._marryFunInfoArr = Array();
		local config = checkRequire("marryFunInfo");
		for k, v in pairs(config) do
			local obj = {};
			obj.id = k;
			obj.config = v;
			self._marryFunInfoArr:add(obj);
		end
		self._marryFunInfoArr:sort("id", false);
	end

	return self._marryFunInfoArr;
end

-- 称号
function Lua_MarryNewUtil.Get:marryTitleArr()
	if self._marryTitleArr == nil then
		self._marryTitleArr = Array();
		local config = checkRequire("wedding_label");
		for k, v in pairs(config) do
			local vo = Lua_MarryTitleVo.new(k, v);
			self._marryTitleArr:add(vo);
		end
	end
	return self._marryTitleArr;
end

-- 信物
function Lua_MarryNewUtil.Get:marryPledgeDic()
	if self._marryPledgeDic == nil then
		self._marryPledgeDic = {};
		local config = checkRequire("wedding_item");
		for k, v in pairs(config) do
			local pledgeVo = Lua_MarryPledgeVo.new(k, v);
			if self._marryPledgeDic[pledgeVo.itemId] == nil then
				self._marryPledgeDic[pledgeVo.itemId] = {};
			end
			self._marryPledgeDic[pledgeVo.itemId][pledgeVo.level] = pledgeVo;
		end
	end
	return self._marryPledgeDic;
end

function Lua_MarryNewUtil:getKeepsakeInfoVo(itemId, lv)
	itemId = tonumber(itemId)
	if self.marryPledgeDic[itemId] == nil then
		return nil;
	end

	return self.marryPledgeDic[itemId][lv];
end

function Lua_MarryNewUtil.Get:defautShowKeepsakeForce()
	if self._defautShowKeepsakeForce == nil then
		self._defautShowKeepsakeForce = getConfig( {"wedding_base", "wedding", "keepsakeForce"});
		if self._defautShowKeepsakeForce == nil then
			self._defautShowKeepsakeForce = 0;
		end
	end

	return self._defautShowKeepsakeForce;
end

function Lua_MarryNewUtil.Get:loveGiftGold()
	if self._loveGiftGold == nil then
	    self._loveGiftGold = getConfig( {"wedding_treasures", 1, "cost_gold"})
	    if self._loveGiftGold == nil then
	        self._loveGiftGold = 0;
	    end
	end

	return self._loveGiftGold;
end

-- 默认展示信物
function Lua_MarryNewUtil.Get:defautShowKeepsakeId()
	if self._defautShowKeepsakeId == nil then
		local arr = getConfig( {"wedding_base", "wedding", "keepsake"});
		if arr ~= nil and #arr > 0 then
			self._defautShowKeepsakeId = arr[1];
		else
			self._defautShowKeepsakeId = 207101101;
		end
	end

	return self._defautShowKeepsakeId;
end

function Lua_MarryNewUtil.Get:getEdibleLimit()
	if self._edibleLimit == nil then
		self._edibleLimit = getConfig( {"wedding_base", "wedding", "edible_limit"});
	end
	return self._edibleLimit;
end