-- 
Lua_MarryPledgeVo = class("Lua_MarryPledgeVo");
function Lua_MarryPledgeVo:ctor(id, config)
    self.id = id;
    if config == nil then
    	config = getConfig({ "wedding_item", id});
    end
    self.config = config;
end

function Lua_MarryPledgeVo.Get:type()
	return self.config.type;
end

function Lua_MarryPledgeVo.Get:itemId()
	return self.config.itemId;
end

function Lua_MarryPledgeVo.Get:level()
	return self.config.level;
end

function Lua_MarryPledgeVo.Get:limit_down()
	return self.config.limit_down;
end

function Lua_MarryPledgeVo.Get:need_exp()
	return self.config.need_exp;
end

function Lua_MarryPledgeVo.Get:max_level()
	return self.config.max_level;
end

function Lua_MarryPledgeVo.Get:costArr()
	if self._costArr == nil then
		self._costArr = Array();
		local list = self.config.cost_item;
		if list ~= nil and #list > 0 then
			for i = 1, #list do
				local toolVo = Lua_ToolVo.createToolVo(list[i][1], list[i][2]);
				self._costArr:add(toolVo);
			end
		end
	end
		
	return self._costArr;
end

function Lua_MarryPledgeVo:checkUpgrade(needTip)
	local nextVo = DataCenter.marryNewUtil:getKeepsakeInfoVo(self.itemId, self.level + 1);
	if nextVo == nil then -- 满级
		if needTip ~= nil and needTip == true then
			OperateAlert.show(LanUtil.getValue(144091));
		end
		return false;
	end

	local arr = self.costArr;
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do 
			local vo = arr[i];
			if vo ~= nil then
				local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(vo.id);
				if num < vo.count then
					if needTip ~= nil and needTip == true then
						OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(144056), vo.name));
					end
					return false;
				end
			end
		end
	end

	return true;
end

function Lua_MarryPledgeVo.Get:attrsArr()
	if self._attrsArr == nil then
		self._attrsArr = Array();
		local len = #Lua_ThingDefine.params;
		for i = 1, len do
	        local v = self.config[Lua_ThingDefine.params[i]];
	        if v ~= nil and v ~= 0 then
	            local obj = {};
	            obj.name = Lua_ThingDefine.params[i];
	            obj.value = v;
	            self._attrsArr:add(obj);
	        end
	    end
	end

	return self._attrsArr;
end

function Lua_MarryPledgeVo.Get:attrsDic()
	if self._attrsDic == nil then
		self._attrsDic = {};
		local arr = self.attrsArr;
		local len = arr:getSize();
		for i = 1, len do
			self._attrsDic[arr[i].name] = arr[i].value;
		end
	end

	return self._attrsDic;
end