-- 姻缘称号
Lua_MarryTitleVo = class("Lua_MarryTitleVo");
function Lua_MarryTitleVo:ctor(id, config)
    self.id = id;
    if config == nil then
    	config = getConfig({"wedding_label", id});
    end
    self.config = config;
end

-- 称号名字
function Lua_MarryTitleVo.Get:label_name()
	return self.config.label_name;
end

-- 称号id
function Lua_MarryTitleVo.Get:label_id()
	return self.config.label_id;
end

-- 所需亲密度
function Lua_MarryTitleVo.Get:need_intimacy()
	return self.config.need_intimacy;
end

-- 亲密度占比
function Lua_MarryTitleVo.Get:intimacyPre()
	if self.config.intimacyPre == nil then
		return 0;
	end
	return self.config.intimacyPre;
end

-- 所需信物等级
function Lua_MarryTitleVo.Get:keepsakeLv()
	return self.config.keepsakeLv;
end

-- 信物占比
function Lua_MarryTitleVo.Get:keepsakePre()
	if self.config.keepsakePre == nil then
		return 0;
	end
	return self.config.keepsakePre;
end

-- 所需仙娃ID
function Lua_MarryTitleVo.Get:childId()
	return self.config.childId;
end

-- 所需仙娃等阶
function Lua_MarryTitleVo.Get:childGrade()
	return self.config.childGrade;
end

-- 仙娃等阶占比
function Lua_MarryTitleVo.Get:childGradePre()
	if self.config.childGradePre == nil then
		return 0;
	end
	return self.config.childGradePre;
end

-- 所需仙娃等级
function Lua_MarryTitleVo.Get:childLv()
	return self.config.childLv;
end

-- 仙娃等级占比
function Lua_MarryTitleVo.Get:childLvPre()
	if self.config.childLvPre == nil then
		return 0;
	end
	return self.config.childLvPre;
end

function Lua_MarryTitleVo.Get:titleData()
	if self._titleData == nil then
		self._titleData = Lua_TitleData.new(self.label_id);
	end
	return self._titleData;
end

-- 百分比
function Lua_MarryTitleVo.Get:activeProgress() 
	local num1 = 0;
	local marryNewData = DataCenter.marryNewData;
	if self.need_intimacy ~= nil and self.need_intimacy > 0 then -- 亲密度
		num1 = marryNewData.intimacy / self.need_intimacy;
		if num1 > 1 then
			num1 = 1;
		end
		num1 = num1 * (self.intimacyPre / 100);
	end

	local num2 = 0;
	if self.keepsakeLv ~= nil and self.keepsakeLv > 0 then -- 信物等级
		local keepsakeInfo = marryNewData.keepsakeInfo;
		if keepsakeInfo ~= nil and keepsakeInfo.keepsake_id > 0 then
			num2 = keepsakeInfo.keepsake_lvl;
		end
		num2 = num2 / self.keepsakeLv;
		if num2 > 1 then
			num2 = 1;
		end
		num2 = num2 * (self.keepsakePre / 100);
	end

	local num3 = 0;
	if self.childId ~= nil and self.childGrade ~= nil and self.childGrade > 0 then -- 仙娃等阶
		local childVo = DataCenter.marryNewUtil.marryChildrenInfo[self.childId];
		if childVo ~= nil then
			if childVo.bActive then
				num3 = childVo.grade;
			end
			num3 = num3 / self.childGrade;
			if num3 > 1 then
				num3 = 1;
			end
			num3 = num3 * (self.childGradePre / 100);
		end
	end

	local num4 = 0;
	if self.childLv ~= nil and self.childLv > 0 then -- 仙娃等级
		num4 = marryNewData.marryChildrenLv / self.childLv;
		if num4 > 1 then
			num4 = 1;
		end
		num4 = num4 * (self.childLvPre / 100);
	end

	return math.floor(num1 + num2 + num3 + num4);
end

function Lua_MarryTitleVo.Get:activeDesc()
	local num;
	local marryNewData = DataCenter.marryNewData;
	local str1 = "";
	if self.need_intimacy ~= nil and self.need_intimacy > 0 then -- 亲密度
		num = marryNewData.intimacy;
		str1 = num.."/"..self.need_intimacy;
		if num < self.need_intimacy then -- 不足
			str1 = Lua_ColorDefine.colorStr(str1, Lua_ColorDefine.RED_STR);
		else
			str1 = Lua_ColorDefine.colorStr(str1, Lua_ColorDefine.GREEN_STR2);
		end
		str1 = LanUtil.formateStr(LanUtil.getValue(144100), str1);
	end

	local str2 = "";
	if self.keepsakeLv ~= nil and self.keepsakeLv > 0 then -- 信物等级
		local vo;
		local keepsakeInfo = marryNewData.keepsakeInfo;
		if keepsakeInfo ~= nil and keepsakeInfo.keepsake_id > 0 then
			num = keepsakeInfo.keepsake_lvl;
			vo = Lua_ToolVo.new(keepsakeInfo.keepsake_id);
		else
			num = 0;
			vo = Lua_ToolVo.new(DataCenter.marryNewUtil.defautShowKeepsakeId);
		end

		str2 = num.."/"..self.keepsakeLv;
		if num < self.keepsakeLv then
			str2 = Lua_ColorDefine.colorStr(str2, Lua_ColorDefine.RED_STR);
		else
			str2 = Lua_ColorDefine.colorStr(str2, Lua_ColorDefine.GREEN_STR2);
		end
		str2 = LanUtil.formateStr(LanUtil.getValue(144101), vo.colorName, str2);
	end

	local str3 = "";
	if self.childId ~= nil and self.childGrade ~= nil and self.childGrade > 0 then -- 仙娃等阶
		local childVo = DataCenter.marryNewUtil.marryChildrenInfo[self.childId];
		if childVo ~= nil then
			if childVo.bActive == false then
				num = 0;
			else
				num = childVo.grade;
			end

			str3 = num.."/"..self.childGrade;
			if num < self.childGrade then
				str3 = Lua_ColorDefine.colorStr(str3, Lua_ColorDefine.RED_STR);
			else
				str3 = Lua_ColorDefine.colorStr(str3, Lua_ColorDefine.GREEN_STR2);
			end
			str3 = LanUtil.formateStr(LanUtil.getValue(144102), childVo.name, str3);
		end
	end

	local str4 = "";
	if self.childLv ~= nil and self.childLv > 0 then -- 仙娃等级
		num = marryNewData.marryChildrenLv;
		str4 = num.."/"..self.childLv;
		if num < self.childLv then -- 不足
			str4 = Lua_ColorDefine.colorStr(str4, Lua_ColorDefine.RED_STR);
		else
			str4 = Lua_ColorDefine.colorStr(str4, Lua_ColorDefine.GREEN_STR2);
		end
		str4 = LanUtil.formateStr(LanUtil.getValue(144103), str4);
	end

	return LanUtil.formateStr(LanUtil.getValue(144099), str1, str2, str3, str4);
end