checkRequire("Lua_MingSuoVo");
Lua_MingSuoData = class("Lua_MingSuoData");
Lua_MingSuoData.ITEM_ID = 209000019;
function Lua_MingSuoData:ctor()
end

function Lua_MingSuoData:dispose()
	if self._floorArr ~= nil then
		self._floorArr:clear()
		self._floorArr = nil
	end
	self:superCall("dispose");
end

function Lua_MingSuoData:fromServer51405401(msg)
	if msg == nil then
		return;
	end

	self.hurdle_info = msg.hurdle_info; -- 关卡信息
	self.present_hurdle = msg.present_hurdle; -- 当前关卡
	self.life_power = msg.life_power; -- 命力总数

	if self.hurdle_info ~= nil then
		-- hurdle_id 关卡id
		for k, v in ipairs(self.hurdle_info) do
			if v.hurdle_id ~= nil and v.hurdle_id ~= 0 and v.hurdle_id <= self.totalFloors then
				self.floorArr[v.hurdle_id]:setLvInfo(v)
			end
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_MINGSUO_PANEL", self.floorArr[self.present_hurdle])
end

-- 当前关卡
function Lua_MingSuoData.Get:curFloor()
	if self.mingsuo_curFloor == nil then
		if self.present_hurdle > self.totalFloors then
			return self.totalFloors;
		end
		return self.present_hurdle;
	else
		return self.mingsuo_curFloor;
	end
end

function Lua_MingSuoData.Set:curFloor(value)
	self.mingsuo_curFloor = value
end





function Lua_MingSuoData.Get:floorArr()
	if self._floorArr == nil then
		self._floorArr = Array();

		local vo;
		local config = getConfig({"life_lock"});
		for k, v in ipairs(config) do
			vo = Lua_MingSuoVo.new(k, false);
			vo:fromConfig(v)
			self._floorArr:add(vo);
		end
	end
	return self._floorArr;
end

function Lua_MingSuoData.Get:totalFloors()
	return self.floorArr:getSize();
end

function Lua_MingSuoData.Get:curFloorArr()
	return self:getMingSuoVoByFloor(self.curFloor);
end

function Lua_MingSuoData:getMingSuoVoByFloor(floor)
	for i = 1, self.floorArr:getSize() do
		if self.floorArr[i].floor == floor then
			return self.floorArr[i]
		end
	end
	return nil;
end





function Lua_MingSuoData:getMingSuoUIByIndex(index)
	if self._colorList == nil then
		self._colorList = {
			"ui_knapsack_icon_b", -- gray
			"ui_knapsack_icon_g", -- green
			"ui_knapsack_icon_h", -- red
			"ui_knapsack_icon_l", -- bule
			"ui_knapsack_icon_o", -- orange
			"ui_knapsack_icon_z", -- purple
			"ui_knapsack_icon_f", -- pink
			"ui_knapsack_icon_y"  -- yellow
		}
	end
	return self._colorList[index];
end