Lua_MingSuoVo = class("Lua_MingSuoVo");
function Lua_MingSuoVo:ctor(floor, islock)
	self.floor = floor;
	self.isLocked = islock == nil and true or islock;
end

function Lua_MingSuoVo:fromConfig(config)
	self.client_floor_show = config.client_floor_show; -- 客户端命槽显示
	self.client_model_show = config.client_model_show; -- 客户端方块显示
	self.client_model_cost = config.client_model_cost; -- 客户端方块激活消耗
	self.floor_name = config.floor_name; -- 关卡名字
	self.model_color = config.model_color; -- 模块颜色
	self.floor_cost = config.floor_cost; -- 快速通关花费
	self.map_pos = config.map_pos; -- 命槽显示位置
	self.model_pos = config.model_pos; -- 模块显示位置
	self.model_fangkuai_pos = config.model_fangkuai_pos; -- 模块里的小方块显示位置
	self.offset_pos = config.offset_pos; -- 拖拽模块偏移位置
end

function Lua_MingSuoVo:setLvInfo(msg)
	local floor = msg.hurdle_id;
	if self.floor == floor then
		self.diamonds_info = msg.diamonds_info;
		self.is_hurdle = msg.is_hurdle;
		self.model_info = msg.model_info;
		self.take_down = msg.take_down;
		self.is_reset = msg.is_reset;
		self:changeFloorShow();
		self:changeModelShow();
	end
	self.isLocked = self.is_hurdle == 0 and self.floor ~= DataCenter.mingSuoData.present_hurdle;
end

function Lua_MingSuoVo:changeFloorShow()
	if self.diamonds_info ~= nil then
		for i = 1, self.floor_show:getSize() do
			local tempVect = self.floor_show[i].pos;
			local tempIndex = -1;
			for j = 1, #self.diamonds_info do
				local pos = Vector2(self.diamonds_info[j].Diamonds_x, self.diamonds_info[j].Diamonds_y);
				if tempVect == pos then
					tempIndex = j;
					break;
				end
			end

			if tempIndex == -1 then
				if self.is_hurdle == 2 and self.is_reset == 0 then
					if self.floor_show[i].value == 0 then
						self.floor_show[i].iconName = "ui_knapsack_icon_c"; -- 不可摆放的位置
					else
						self.floor_show[i].iconName = DataCenter.mingSuoData:getMingSuoUIByIndex(2);
					end
					self.floor_show[i].is_insert = 2;
				elseif self.is_hurdle == 2 and self.is_reset == 1 then
					if self.floor_show[i].value == 0 then
						self.floor_show[i].iconName = "ui_knapsack_icon_c"; -- 不可摆放的位置
					else
						self.floor_show[i].iconName = "ui_knapsack_icon_c";
					end
					self.floor_show[i].is_insert = 2;
				else
					if self.floor_show[i].value == 0 then
						self.floor_show[i].iconName = "ui_knapsack_icon_c"; -- 不可摆放的位置
					else
						self.floor_show[i].iconName = "ui_knapsack_icon_c";
					end
					self.floor_show[i].is_insert = 0;
				end
				self.floor_show[i].canClick = false;
			else
				self.floor_show[i].iconName = DataCenter.mingSuoData:getMingSuoUIByIndex(self.diamonds_info[tempIndex].is_insert);
				self.floor_show[i].is_insert = self.diamonds_info[tempIndex].is_insert;
				self.floor_show[i].canClick = true;
			end
		end
	end
end

function Lua_MingSuoVo:changeModelShow()
	if self.model_info ~= nil and #self.model_info ~= 0 then
		local modelInfo;
		local modelShow;
		for i = 1, #self.model_info do
			modelInfo = self.model_info[i];
			for j = 1, self.model_show:getSize() do
				modelShow = self.model_show[j];
				if modelInfo.model_id == modelShow.modelIndex then
					modelShow.is_activate = modelInfo.is_activate;
					modelShow.is_put_int = modelInfo.is_put_int;
					if modelShow.is_put_int == 1 then
						modelShow.canClick = false;
						modelShow.uiName = "ui_knapsack_icon_c";
					else
						modelShow.canClick = modelShow.is_activate == 1;
						modelShow.uiName = DataCenter.mingSuoData:getMingSuoUIByIndex(modelShow.modelColorIndex);
					end
					break;
				end
			end
		end
	end
end

function Lua_MingSuoVo:getChatShowData()
	local sa = Lua_StringArray.new();
	sa:writeInt(2);
	sa:writeInt(self.floor);
	sa:writeInt(0);

	local putNum = 0;
	if self.diamonds_info ~= nil and #self.diamonds_info ~= 0 then
		local len = #self.diamonds_info;
		sa:writeInt(len);
		for i = 1, len do
			sa:writeInt(self.diamonds_info[i].Diamonds_x);
			sa:writeInt(self.diamonds_info[i].Diamonds_y);
			sa:writeInt(self.diamonds_info[i].is_insert);
			if self.diamonds_info[i].is_insert ~= 0 then
				putNum = putNum + 1;
			end
		end
	else
		sa:writeInt(0);
	end

	if putNum == self:getFloorNum() then
		sa:writeInt(1);
	else
		sa:writeInt(0);
	end
	return sa;
end

function Lua_MingSuoVo:getFloorNum()
	local num = 0;
	for i = 1, self.floor_show:getSize() do
		if self.floor_show[i].value ~= 0 then
			num = num + 1;
		end
	end
	return num;
end

function Lua_MingSuoVo.Get:model_show()
	if self.model_showArr == nil then
		self.model_showArr = Array();

		if self.client_model_show ~= nil then
			local list;
			for i = 1, #self.client_model_show do
				list = {};
				list.modelIndex = i; -- 第几个拼接零件
				list.floor = self.floor; -- 关卡id
				list.modelCost = self.client_model_cost[i];
				list.model_fangkuai_pos = self.model_fangkuai_pos[i];
				list.modelPos = self.model_pos[i];
				list.indexArr = self.client_model_show[i];
				list.offset_pos = self.offset_pos[i];
				list.modelColorIndex = self.model_color[i];
				list.uiName = DataCenter.mingSuoData:getMingSuoUIByIndex(list.modelColorIndex);
				list.initUiName = DataCenter.mingSuoData:getMingSuoUIByIndex(list.modelColorIndex);
				list.is_activate = 0;
				list.canClick = false;
				list.is_put_int = 0;
				self.model_showArr:add(list);
			end
		end
	end
	return self.model_showArr;
end

function Lua_MingSuoVo:getModelById(val)
	for i = 1, self.model_show:getSize() do
		if self.model_show[i].modelIndex == val then
			return self.model_show[i];
		end
	end
	return nil;
end

function Lua_MingSuoVo.Get:modelTotalCost()
	local cost = 0;
	for i = 1, self.model_show:getSize() do
		if self.model_show[i].is_activate == 0 then
			cost = cost + self.model_show[i].modelCost;
		end
	end
	return cost;
end

function Lua_MingSuoVo.Get:floor_show()
	if self.floor_showArr == nil then
		self.floor_showArr = Array();

		if self.client_floor_show ~= nil then
			local list;
			local tempList;
			for i = 1, #self.client_floor_show do
				tempList = self.client_floor_show[i];
				list = {};
				list.pos = Vector2(tempList[1], tempList[2]);
				list.is_insert = 0;
				list.canClick = false;
				if type(tempList[3]) ~= "number" then
					list.attrName = "name";
					list.atlasName = "packWindow";
					list.iconName = "ui_knapsack_icon_c";
					list.value = 0;
				else
					list.attr = tempList[4];
					list.attrName = Lua_ThingDefine.getParamName(tempList[4]);
					list.atlasName = "packWindow";
					list.iconName = "ui_knapsack_icon_c";
					list.value = tempList[5];
				end
				self.floor_showArr:add(list);
			end
		end
	end
	return self.floor_showArr;
end

function Lua_MingSuoVo.Get:score()
	return Lua_FightUtil.caculateConfigForce(self.attrList)
end

function Lua_MingSuoVo.Get:attrList()
	local attrDic = {};
	for i = 1, self.floor_show:getSize() do
		if self.floor_show[i].value ~= 0 and self.floor_show[i].is_insert ~= 0 then
			if attrDic[self.floor_show[i].attr] == nil then
				attrDic[self.floor_show[i].attr] = self.floor_show[i].value;
			else
				attrDic[self.floor_show[i].attr] = attrDic[self.floor_show[i].attr] + self.floor_show[i].value;
			end
		end
	end
	return attrDic;
end