checkRequire("Lua_MingSuoData");
Lua_MingSuoProxy = class("Lua_MingSuoProxy");
function Lua_MingSuoProxy:ctor()
	DataCenter.mingSuoData = Lua_MingSuoData.new();

	LuaUtil.addLuaMsg(51405401, self, self.rMingSuoInfo);
	LuaUtil.addLuaMsg(51405403, self, self.rPutInfo);
end

function Lua_MingSuoProxy:rMingSuoInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405401();
		msg:ParseFromString(mp.data);
		DataCenter.mingSuoData:fromServer51405401(msg);
	end
end

function Lua_MingSuoProxy:rPutInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405403();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("PLAY_ANIMATION_MINGSUO", msg)
	end
end





-- 请求获取关卡数据
function Lua_MingSuoProxy:sinitMsg(hurdle_id)
	local cmd = getProtoMsg("Proto11405401");
	cmd.hurdle_id = hurdle_id; -- 关卡id(id为0则返回当前关卡页面信息)
	sendMsg(11405401, cmd);
end

-- 请求命锁方块激活
function Lua_MingSuoProxy:sJiHuoMsg(hurdle_id, diamonds_id)
	local cmd = getProtoMsg("Proto11405402");
	cmd.hurdle_id = hurdle_id; -- 关卡id
	cmd.diamonds_id = diamonds_id; -- 模快id
	sendMsg(11405402, cmd);
end

-- 请求命锁方块置入取出移动
function Lua_MingSuoProxy:sPutInfoMsg(model_id, hurdle_id, x, y)
	local cmd = getProtoMsg("Proto11405403");
	cmd.model_id = model_id; -- 模快id
	cmd.hurdle_id = hurdle_id; -- 关卡id
	cmd.groove_index.obj_id = x; -- 置入槽中的位置 x
	cmd.groove_index.obj_value = y; -- 置入槽中的位置 y
	sendMsg(11405403, cmd)
end

-- 请求快速通关
function Lua_MingSuoProxy:sPassMsg(hudle_id)
	local cmd = getProtoMsg("Proto11405404");
	cmd.hudle_id = hudle_id; -- 关卡id
	sendMsg(11405404, cmd);
end

-- 重置关卡
function Lua_MingSuoProxy:sReSetMsg(hurdle_id)
	local cmd = getProtoMsg("Proto11405405");
	cmd.hurdle_id = hurdle_id; -- 关卡id
	sendMsg(11405405, cmd);
end