checkRequire("Lua_ServantCommonData");
Lua_MountData = class("Lua_MountData", Lua_ServantCommonData);
Lua_MountData.AUTO_UP = 0;
Lua_MountData.AUTO_CHECK = false;
function Lua_MountData:ctor()
	LuaUtil.addLuaMsg(80400101, self, self.rInit);
end

function Lua_MountData:rInit()
	self.transIdTemp = nil;
	self.idTemp = nil;
end

function Lua_MountData:sMountPanelInfo()
	sendMsg(11400401);
end

function Lua_MountData:sServantAnvance()
	local cmd = ProtoPublic_pb.Proto11400402();
	cmd.cost_type = Lua_MountData.AUTO_UP
	sendMsg(11400402, cmd);
end

function Lua_MountData:sUseItem(index, num)
	local cmd = ProtoPublic_pb.Proto11400408();
	cmd.index = index;
	cmd.use_num = num
	sendMsg(11400408, cmd);
end

function Lua_MountData:sHuanXingMsg(shape_id)
	local cmd = ProtoPublic_pb.Proto11400413();
	cmd.shape_id = shape_id;
	sendMsg(11400413, cmd);
end

function Lua_MountData:sUse(id, type)
	local cmd = ProtoPublic_pb.Proto11400415();
	cmd.mount_id = id;
	cmd.ride_on = type;
	sendMsg(11400415, cmd);
end

function Lua_MountData:sChatMiniRide()
	if DataCenter.roleData.mount_id ~= 0 then
		self.idTemp = DataCenter.roleData.mount_id;
		self.transIdTemp = DataCenter.mountTransData.illId;
		self:sUse(DataCenter.roleData.mount_id, 0);
	else
		local index = self.stage == nil and 1 or self.stage;
		if self.transIdTemp ~= nil and self.transIdTemp ~= 0 then
			self:sUse(self:getServantShapeList()[index].id, 1);
			-- DataCenter.mountTransData:sTransmogrify(self.transIdTemp);
		else
			if (self.idTemp == nil or self.idTemp == 0) then
				self:sUse(self:getServantShapeList()[index].id, 1);
			else
				self:sUse(self.idTemp, 1);
			end
		end
	end
end

function Lua_MountData:sSkillLvlUp(id)
	local cmd = ProtoPublic_pb.Proto11400407();
	cmd.skill_id = id;
	sendMsg(11400407, cmd);
end

function Lua_MountData.Get:config()
	if self._config == nil then
		self._config = getConfig({"mount"});
	end
	return self._config;
end

function Lua_MountData:fromServer51400401(data)
	if data == nil then
		return;
	end

	self.isMaxLvl = data.is_max_lvl; -- 是否满阶
	self.evolutionExp = data.evolution_exp; -- 当前的进阶进度
	self.servantShape = data.mount_shape; -- 使用的坐骑外形 未骑乘则为0
	self.name = data.mount_name; -- 坐骑名字
	self.force = data.force; -- 战力
	self.isUsing = data.is_wear; -- 1显示 0隐藏

	self:calcLvl(data.evolution_lvl);
	self:getCurAttrData(data.total_prop_list);
	self:getNextAttrData(data.next_prop_list);
	self:getSkillListData(data.skill_list);
	self:getPanaceaListData(data.use_beast_soul);
end

function Lua_MountData:setShapeId(msg)
	self.servantShape = msg.shape_id;
end

function Lua_MountData:advance(data)
	-- print("data.is_evolution  "..data.is_evolution);
end

function Lua_MountData:skillLvlUp(data)
	local servantSkillList = self.skillVoList;
	for i = 1, servantSkillList:getSize() do
		if servantSkillList[i].skillId == data.skill_id then
			servantSkillList[i].skillLvl = data.skill_lvl;
		end
	end
end

function Lua_MountData:updateState(data)
	-- DataCenter.mountTransData:sGetPanelInfo();
	if data.ride_on == 1 then
		self.isUsing = 1;
		self.idTemp = 0;
		self.servantShape = data.mount_id
		DataCenter.roleData.mount_id = data.mount_id;
	else
		self.isUsing = 0;
		self.servantShape = 0;
		DataCenter.roleData.mount_id = 0;
	end
end

function Lua_MountData:useItem(data)
	-- print("item   "..data.index.."  "..data.use_num);
	-- local itemList = self.panaceaToolVoList;
	-- itemList[data.index+1]
end

function Lua_MountData:getBaseAttrDic()
	return self.config.mount_base;
end

function Lua_MountData:getShapConfig()
	return self.config.mount_shape;
end

function Lua_MountData:dispose()
	Lua_MountData.AUTO_UP = 0
	Lua_MountData.AUTO_CHECK = false
	self:superCall("dispose");
end