-- 宠骑装备
checkRequire("Lua_MountEquipHoleVo")
Lua_MountEquipData = class("Lua_MountEquipData");
function Lua_MountEquipData:ctor()
	self.mountHolesInfo = {};
	self.mountEquipPartInedx = 0;
	-- self.selectItemData = nil;
	-- self.packEquipList = {};
end

function Lua_MountEquipData:dispose()
	self.mountHolesInfo = {};
	self.mountEquipPartInedx = 0;
	self.selectItemData = nil;
end

-- 孔位信息
function Lua_MountEquipData:fromServer51400401(msg)
	if msg == nil then
		return;
	end
	self.msg = msg;

	local vo;
	local list = msg.equipment_parts;
	for k, v in ipairs(list) do
		vo = Lua_MountEquipHoleVo.new(); -- 孔位Vo
		vo:formServer(v);
		self.mountHolesInfo[tonumber(vo.part)] = vo;
	end
end

-- 通过部位，获取vo
function Lua_MountEquipData:getArrByPartData(part)
	if self.mountHolesInfo[tonumber(part)] ~= nil and self.mountHolesInfo[tonumber(part)].item_id == 0 then
		return nil;
	end
	return self.mountHolesInfo[tonumber(part)];
end

-- 骑装强化数据
function Lua_MountEquipData:getMountEquipIntensifyData()
	local arr = Array();
	for k,v in pairs(self.mountHolesInfo) do
		if v.item_id ~= nil and v.item_id ~= 0 then
			arr:add({vo = v, part = v.part});
		end
	end

	local len = arr:getSize()
	for i = 1, len do
		for j = i + 1, len do
			local a = arr[i];
			local b = arr[j];
			if a.vo.intensify_lvl == a.vo.max_level and b.vo.intensify_lvl ~= b.vo.max_level then
				local temp = arr[i];
				arr[i] = arr[j];
				arr[j] = temp;
			end
		end
	end
	return arr;
end

-- 装备的骑装在强化列表的索引，用于打开强化列表对应骑装
function Lua_MountEquipData:getMountEquipIndex(part)
	local arr = self:getMountEquipIntensifyData();
	for i = 1, arr:getSize() do
		if arr[i].part == part then
			return i;
		end
	end
end

-- 获取加成道具索引
function Lua_MountEquipData:getPackItemList(list)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local arr = bagData:getBagAllData();
	local showItemArray = Array();
	for i = 1, arr:getSize() do
		for j,v in ipairs(list) do
			if arr[i].id == v then
				showItemArray:add(arr[i].index);
			end
		end
	end
	return showItemArray;
end

-- 获取装备索引
function Lua_MountEquipData:getPackEquipList(list)
	local showItemArray = Array();
	for i,v in pairs(list) do
		showItemArray:add(list[i].index);
	end
	return showItemArray;
end

-- 通过骑装部位获取背包是否拥有同部位装备信息
function Lua_MountEquipData:getSamePartEquipData(part)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.MOUNT_EQUIP_TYPE});
	local arr = Array();
	for i = 1, equList:getSize() do
		if equList[i].part == part then
			arr:add(equList[i]);
		end
	end
	arr:sort("zongheForce", true);
	return arr;
end

function Lua_MountEquipData.Get:isShowiconRed()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);--背包
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.MOUNT_EQUIP_TYPE});
	local vo;
	for i = 1, equList:getSize() do
		vo = self:getArrByPartData(equList[i].part);
		if vo == nil then -- 骑装栏未穿戴装备
			return true;
		else
			if DataCenter.roleData.baseParam ~= nil then
				if equList[i].force > vo.mountEquipVo.force then
					return true;
				end
			end
		end
	end
	return false;
end

-- 主界面红点显隐
function Lua_MountEquipData:checkMountRedDotSate()
	DataCenter.redDotData:updateRedDotVoState(11183, self.isShowiconRed);
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11183, val = self.isShowiconRed and 1 or 0, bShow = self.isShowiconRed});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", self.isShowiconRed);--变强事件
end