checkRequire("Lua_MountData");
checkRequire("Lua_MountEquipData");
checkRequire("Lua_MountEquipUtil");
Lua_MountProxy = class("Lua_MountProxy");
function Lua_MountProxy:ctor()
	DataCenter.mountData = Lua_MountData.new();
	DataCenter.mountEquipData = Lua_MountEquipData.new();
	DataCenter.mountEquipUtil = Lua_MountEquipUtil.new();

	LuaUtil.addLuaMsg(51400401, self, self.rGetPanelInfo);-- 获取坐骑信息（返回）
	LuaUtil.addLuaMsg(51400402, self, self.rAdvance); -- 坐骑进阶（返回）
	LuaUtil.addLuaMsg(51400415, self, self.rUse); -- 骑乘（返回）
	LuaUtil.addLuaMsg(51400407, self, self.rSkillLvlUp); -- 坐骑技能升级（返回）
	LuaUtil.addLuaMsg(51400408, self, self.rUseItem); -- 坐骑使用兽魂（返回）
	LuaUtil.addLuaMsg(51400411, self, self.rCompoundMountEquip); -- 坐骑装备合成（返回）
	LuaUtil.addLuaMsg(51400412, self, self.rIntensifyMountEquip); -- 骑装强化（返回）
	LuaUtil.addLuaMsg(51400413, self, self.rHuaXingMsg); -- 坐骑化形（返回）
end

function Lua_MountProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400401();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:fromServer51400401(msg);
		DataCenter.mountEquipData:fromServer51400401(msg);
		Lua_MsgUtil.callFunc("MOUNT_PANEL_UPDATE");
	end
end

function Lua_MountProxy:rAdvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400402();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:advance(msg);
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", {state = false});
	end
	DataCenter.mountData:sMountPanelInfo();
end

function Lua_MountProxy:rUse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400415();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:updateState(msg);
		-- Lua_MsgUtil.callFunc("UESAGE_STATE_UPDATE");
		Lua_MsgUtil.callFunc("UPFATE_MOUNT_STATE");
	end
end

function Lua_MountProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400407();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_MountProxy:rUseItem(mp)
	DataCenter.mountData:sMountPanelInfo();
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400408();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:useItem(msg);
	end
end

function Lua_MountProxy:rHuaXingMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400413();
		msg:ParseFromString(mp.data);
		DataCenter.mountData:setShapeId(msg)
		Lua_MsgUtil.callFunc("MOUNT_HUANXING_UPDATE", msg);
	end
end

function Lua_MountProxy:rCompoundMountEquip(mp)
	if mp.errno ~= 0 then
		Lua_MsgUtil.callFunc("UPDATE_COMPOUND_PANEL"); -- 合成失败更新界面
		Lua_MsgUtil.callFunc("UPDATE_COMPOUND_EFFECT", false); -- 合成特效更新
	else
		Lua_MsgUtil.callFunc("UPDATE_COMPOUND_EFFECT", true); -- 骑装信息更新
	end
end

function Lua_MountProxy:rIntensifyMountEquip(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400412();
		msg:ParseFromString(mp.data);
		
		local vo = DataCenter.mountEquipData:getArrByPartData(msg.part);
		vo.intensify_lvl = msg.intensify_lvl;
		Lua_MsgUtil.callFunc("UPDATE_INTENS_PANEL");
	end
end





function Lua_MountProxy:sFuncOpen()
	local shapeList = DataCenter.mountData:getServantShapeList();
	DataCenter.mountData:sUse(shapeList[1].id, 1);
	DataCenter.mountData:sHuanXingMsg(shapeList[1].id);
end

-- 下行骑装信息处理
-- 穿戴坐骑装备
function Lua_MountProxy:sApparelMountEquip(index)
	local cmd = ProtoPublic_pb.Proto11400409();
	cmd.pkg_index = index; -- 背包索引
	sendMsg(11400409, cmd);
end

-- 卸下坐骑装备
function Lua_MountProxy:sDischargeMountEquip(part)
	local cmd = ProtoPublic_pb.Proto11400410();
	cmd.part = part; -- 部位
	sendMsg(11400410, cmd);
end

-- 坐骑装备合成
function Lua_MountProxy:sCompoundMountEquip(item_id, equip_index, item_index)
	local cmd = ProtoPublic_pb.Proto11400411();
	cmd.compose_id = item_id;
	if equip_index:getSize() ~= nil then
		for i = 1, equip_index:getSize() do
			cmd.cost_equip_index:append(equip_index[i]);
		end
	end

	if item_index ~= nil then
		if item_index:getSize() ~= nil then
			for i = 1, item_index:getSize() do
				cmd.cost_item_index:append(item_index[i]);
			end
		end
	end
	sendMsg(11400411, cmd);
end

-- 坐骑装备强化
function Lua_MountProxy:sIntensifyMountEquip(part, promotion, cost_index)
	local cmd = ProtoPublic_pb.Proto11400412();
	if promotion == 0 then
		cmd.part = part;
	else
		cmd.part = part;
		cmd.promotion = promotion;
		if cost_index:getSize() ~= nil then
			for i = 1, cost_index:getSize() do
				cmd.cost_index:append(cost_index[i]);
			end
		end
	end
	sendMsg(11400412, cmd);
end