--骑装合成VO

Lua_MountEquipCompoundVo = class("Lua_MountEquipCompoundVo");
function Lua_MountEquipCompoundVo:ctor(id,value)
	self.id = id;
	if value == nil  then
		self.config = getConfig( { "me_compose", id });
	else
		self.config = value;
	end 
end

function Lua_MountEquipCompoundVo.Get:remark()--名称
	return self.config.remark;
end

function Lua_MountEquipCompoundVo.Get:mount_class_id()--骑装类
	return self.config.mount_class_id;
end

function Lua_MountEquipCompoundVo.Get:mount_group_id()--骑装组
	return self.config.mount_group_id;
end

function Lua_MountEquipCompoundVo.Get:need_item_num()--合成需要道具个数
	return self.config.need_item_num;
end

function Lua_MountEquipCompoundVo.Get:compose_need_item()--合成需要道具个数
	return self.config.compose_need_item;
end

function Lua_MountEquipCompoundVo.Get:isShowCompoundRed()--合成红点
	local needNum = self.need_item_num;
    local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.compose_need_item[1][1]);
    if bagNum >= needNum then
        return true;
    end
    return false;
end

function Lua_MountEquipCompoundVo.Get:materials()--合成所需道具
	if self._materials == nil then
		self._materials = Array();
		for i,v in ipairs(self.config.compose_need_item) do
			local tvo = Lua_ToolVo.createToolVo(v[1], v[2], 0);
			tvo.isShowBtn = false;
			self._materials:add(tvo);
		end
	end
	return self._materials;
end

function Lua_MountEquipCompoundVo.Get:rate()--合成成功率（百分比）
	return self.config.compose_suc_rate;
end

function Lua_MountEquipCompoundVo.Get:showRateItem()--显示加成道具材料Tips
	local v = self.config.suc_rate_item[1];
	local arr = Array();
	local tvo = Lua_ToolVo.createToolVo(v[1], v[2], 0);
	arr:add(tvo)
	return arr;
end

function Lua_MountEquipCompoundVo.Get:getMaxSucRate()--获取道具成功率上限
	if self.config.suc_rate_item ==nil then
		return nil;
	end
	
	local arr = Array();
	for i,v in ipairs(self.config.suc_rate_item) do
		arr:add(v);
	end
	local len = arr:getSize();
	local maxSucRate = self.config.suc_rate_item[len][3] + self.rate;
	if maxSucRate > 100 then
		maxSucRate = 100;
	end
	return maxSucRate;
end

function Lua_MountEquipCompoundVo.Get:rateItem()--增加成功率的道具
	if self._rateItems == nil then
		self._rateItems = Array();
		for i,v in ipairs(self.config.suc_rate_item) do
			self._rateItems:add({itemId=tonumber(v[1]), rate=tonumber(v[2])});
		end
	end
	return self._rateItems;
end

function Lua_MountEquipCompoundVo:getMountItemLen(list)--获得已放入道具个数
	local arr = Array();
	if arr~= nil then
		arr:clear();
	end
	for i,v in ipairs(list) do
		if v ~= 0 then
			arr:add(v)
		end
	end
	
	return arr:getSize();
end

function Lua_MountEquipCompoundVo:getRateItemRate(list)
	local arr = Array();
	if arr~= nil then
		arr:clear();
	end
	for i,v in ipairs(list) do
		if v ~= 0 then
			arr:add(v)
		end
	end
	local len = arr:getSize();
	for i,v in ipairs(self.config.suc_rate_item) do
		if v[2] == len then
			return v[3];
		end
	end
	return 0;
end

function Lua_MountEquipCompoundVo:isHaveItem(list)--是否放入全部道具
	local arr = Array();
	if arr~= nil then
		arr:clear();
	end
	for i,v in ipairs(list) do
		if v ~= 0 then
			arr:add(v)
		end
	end
	local item_id;
	local len = arr:getSize();
	if len == 0 then
		item_id = self.config.suc_rate_item[1][1];
	else
		item_id = arr[1];
	end
	local packNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(item_id);
	if packNum > 0 and packNum - len <= 0 then
		return true
	end
	return false;
end

function Lua_MountEquipCompoundVo:getBagEquList(putOnItems)
	local arr = Array();
	local dic = {};
	local putOnDic = {};
	if putOnItems ~= nil then
		for i=1,#self.config.compose_need_item do
			if putOnItems[i] ~= nil then
				putOnDic[putOnItems[i].index] = 1;
			end
		end
	end
	for i,v in ipairs(self.config.compose_need_item) do
		dic[v[1]] = 1;
	end
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.MOUNT_EQUIP_TYPE});
	for i=1,equList:getSize() do
		local tvo = equList[i];
		if dic[tvo.id] ~= nil and putOnDic[tvo.index] == nil then
			arr:add(tvo);
		end
	end
	arr:sort("zongheForce", true);
	return arr;
end