-- 宠装空位VO
Lua_MountEquipHoleVo = class("Lua_MountEquipHoleVo")
function Lua_MountEquipHoleVo:ctor()
end

function Lua_MountEquipHoleVo:formServer(msg)
	if msg == nil then
		return;
	end

	self.data = msg;
	self.part = msg.part; -- 槽号1 ~ 4
	self.intensify_lvl = msg.intensify_lvl; -- 强化等级
	self.item_id = msg.item.id; -- ID
	self.amount = msg.item.amount; -- 数量
	self.bind = msg.item.bind; -- 绑定状态
	-- self.star = msg.equipment.star; -- 星级
end

function Lua_MountEquipHoleVo.Get:mountEquipVo()
	if self.part ~= nil and self.item_id ~= 0 then
		local vo = Lua_ToolVo.createToolVo(self.item_id, self.amount, self.bind);
		vo:fromServer(self.data.item);
		vo.intensify_lvl = self.intensify_lvl;
		vo.max_intensify_lvl = self.max_level;
		-- vo.star = self.star;
		vo.mountPart = self.part;
		return vo;
	end
	return nil;
end

-- 穿戴替换红点
function Lua_MountEquipHoleVo.Get:isShowRedDot()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK); -- 背包
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.MOUNT_EQUIP_TYPE});
	local arr = Array();
	for i = 1, equList:getSize() do
		if equList[i].part == self.part then
			arr:add(equList[i]);
		end
	end

	local len = arr:getSize();
	if len > 0 and self.item_id == 0 then
		return true;
	elseif len > 0 and self.item_id ~= 0 then
		for i = 1, len do
			if arr[i].force > self.mountEquipVo.force then
				return true;
			end
		end
	end
	return false;
end





-- 强化强化配置信息
function Lua_MountEquipHoleVo.Get:config()
	return getConfig({"me_intensify", self.item_id});
end

-- 强化最高等级
function Lua_MountEquipHoleVo.Get:max_level()
	return self.config.max_level;
end

-- 每一级强化所需的道具
function Lua_MountEquipHoleVo.Get:cost_item()
	return self.config.cost_item;
end

-- 强化界限
function Lua_MountEquipHoleVo.Get:limit_level()
	return self.config.limit_level;
end

-- 界限突破道具
-- function Lua_MountEquipHoleVo.Get:limit_break_item()
-- 	return self.config.limit_break_item;
-- end

-- 是否显示红点
function Lua_MountEquipHoleVo.Get:isShowIconRed()
	if self.item_id ~= 0 then
		if self.intensify_lvl < self.max_level then
			local packInfo = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
			local packNum = packInfo:getItemNum(self.needItemData[1].id);
			local needNum;
			if self.isBreakLimit == 0 then
				needNum = self.needItemData[1].num;
				if packNum >= needNum then
					return true;
				end
			else
				needNum = self.needItemData:getSize();
				if packNum >= needNum then
					return true;
				end
			end
			-- print(self.isBreakLimit, self.needItemData:getSize(), self.needItemData[1].id, needNum, packNum);
		end
	end
	return false;
end

-- 0 未到达突破界限
function Lua_MountEquipHoleVo.Get:isBreakLimit()
	if self.intensify_lvl + 1 <= self.max_level then
		if (self.intensify_lvl + 1) % self.limit_level == 0 then
			return 1;
		end
	end
	return 0;
end

-- 每一级强化所需的道具
function Lua_MountEquipHoleVo.Get:needItemData()
	local lvl;
	if self.intensify_lvl < self.max_level then
		lvl = self.intensify_lvl + 1;
	else
		lvl = self.intensify_lvl;
	end

	local itemDic = self.cost_item[lvl];
	local arr  = Array()
	for i = 1, #itemDic do
		arr:add({id = tonumber(itemDic[i][1]), num = tonumber(itemDic[i][2])});
	end
	return arr;
end

-- 合成所需道具
function Lua_MountEquipHoleVo.Get:materials()
	local tvo;
	local arr = Array();
	for i = 1, self.needItemData:getSize() do
		tvo = Lua_ToolVo.createToolVo(self.needItemData[i].id);
		tvo.isShowBtn = false;
		arr:add(tvo);
	end
	return arr;
end

function Lua_MountEquipHoleVo:getBagEquList(putOnItems)
	local len = self.needItemData:getSize();
	local putOnDic = {};
	if putOnItems ~= nil then
		for i = 1, len do
			if putOnItems[i] ~= nil then
				putOnDic[putOnItems[i].index] = 1;
			end
		end
	end

	local dic = {};
	for i = 1, len do
		dic[self.needItemData[i].id] = 1;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local equList = bagData:getItemsBySubType({Lua_PackTypeDefine.MOUNT_EQUIP_TYPE});
	local tvo;
	local arr = Array();
	for i = 1, equList:getSize() do
		tvo = equList[i];
		if dic[tvo.id] ~= nil and putOnDic[tvo.index] == nil then
			arr:add(tvo);
		end
	end
	arr:sort("color", false);
	arr:sort("zongheForce", false);
	return arr;
end

function Lua_MountEquipHoleVo.Get:name()
	if self.intensify_lvl == 0 then
		return "["..self.mountEquipVo.colorStr.."]"..self.mountEquipVo.name.."[-]";
	elseif self.intensify_lvl > 0 and self.intensify_lvl < self.max_level then
		return "["..self.mountEquipVo.colorStr.."]"..self.mountEquipVo.name.."+"..self.intensify_lvl.."[-]";
	elseif self.intensify_lvl == self.max_level then
		return "["..self.mountEquipVo.colorStr.."]"..self.mountEquipVo.name.."+"..self.intensify_lvl.."(MAX)[-]";
	end
end

-- 当前强化属性
function Lua_MountEquipHoleVo.Get:intensifyProp()
	local attrDic;
	local attrValue;
	local str;
	for k,v in ipairs(Lua_ThingDefine.params) do
		attrDic = getConfig({"me_intensify", self.item_id, v});
		if attrDic ~= nil then
			attrValue = self.intensify_lvl == 0 and 0 or attrDic[self.intensify_lvl];

			str = str == nil and "" or str.."\n";
			str = str.."[3f6180]"..Lua_ThingDefine.getParamName(v)..":[85A8BE] "..attrValue.."[-]";
		end
	end
	return str;
end

-- 下级强化属性
function Lua_MountEquipHoleVo.Get:nextIntensifyProp()
	if self.intensify_lvl + 1 > self.max_level then
		return;
	end

	local attrDic;
	local attrValue;
	local str;
	for k,v in ipairs(Lua_ThingDefine.params) do
		attrDic = getConfig({"me_intensify", self.item_id, v});
		if attrDic ~= nil then
			str = str == nil and "" or str.."\n";
			str = str..attrDic[self.intensify_lvl + 1];
		end
	end
	return str;
end