checkRequire("Lua_MountTransData");
Lua_MountTransProxy = class("Lua_MountTransProxy");
function Lua_MountTransProxy:ctor()
	self:superCall("ctor");
	DataCenter.mountTransData = Lua_MountTransData.new();
	LuaUtil.addLuaMsg(51400403, self, self.rGetPanelInfo);
	LuaUtil.addLuaMsg(51400404, self, self.rActivation);
	LuaUtil.addLuaMsg(51400406, self, self.rTransmogrify);
	LuaUtil.addLuaMsg(51400405, self, self.rLvlUp);
end

function Lua_MountTransProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400403();
		msg:ParseFromString(mp.data);
		DataCenter.mountTransData:fromServer(msg);
		Lua_MsgUtil.callFunc("MOUNT_TRANS_PANEL_UPDATE");
	end
end

function Lua_MountTransProxy:rActivation(mp)
	--print("rActivation");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400404();
		msg:ParseFromString(mp.data);
		DataCenter.mountTransData:getActivationInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.mountTransData:sGetPanelInfo();
	end
end

function Lua_MountTransProxy:rTransmogrify(mp)
	--print("rTransmogrify");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400406();
		msg:ParseFromString(mp.data);
		DataCenter.mountTransData:getTransInfo(msg);
		DataCenter.mountTransData:sGetPanelInfo();
	end
end

function Lua_MountTransProxy:rLvlUp(mp)
	--print("rLvlUp");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400405();
		msg:ParseFromString(mp.data);
		DataCenter.mountTransData:getLvlUpInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.mountTransData:sGetPanelInfo();
	end
end