﻿Lua_NewServerActivityData = class("Lua_NewServerActivityData");
function Lua_NewServerActivityData:ctor()
	self:superCall("ctor");
end

function Lua_NewServerActivityData:setButtonListData(msg, show_vec, priority)
	self.newServer_Btn_Act_list = msg
	self.newServer_Btn_Show_vec = show_vec
	self.newServer_Btn_Priority = priority
	if self.NewServerRankButton:getSize() > 0 then
		Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10078);
	else
		Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10078);
	end
end

function Lua_NewServerActivityData.Get:NewServerRankButton()
	local arr = Array()
	if self.newServer_Btn_Act_list ~= nil then
		for k, v in ipairs(self.newServer_Btn_Act_list) do
			if v.first_type == Lua_OperationalActivitiesData.ACT_RANK then
				local list = {}
				list.act_index = v.act_index;
				list.title = v.title
				list.first_type = v.first_type;
				list.second_type = v.second_type;
				list.priority = v.priority;
				list.is_virtual_info = v.is_virtual_info;
				list.sort = v.sort;
				list.start_tick = tonumber(tostring(v.start_tick));
				list.end_tick = tonumber(tostring(v.end_tick));
				list.content = v.content;
				list.is_single_icon = v.is_single_icon;
				list.times = tonumber(tostring(v.times));
				list.cancel_tack = tonumber(tostring(v.cancel_tack));
				if self.newServer_Btn_Show_vec ~= nil then
					for key, value in ipairs(self.newServer_Btn_Show_vec) do
						if value.first_type == list.first_type and value.second_type == list.second_type then
							list.sub = value.sub;
							list.value = value.value;
							-- 策划要求不显示问号
							-- if list.value == 1 then
							-- 	list.title = LanUtil.getValue(127208);
							-- end
							break;
						end
					end
				end
				arr:add(list);
			end
		end
	end
	arr:sort("sort", true);
	return arr;
end

function Lua_NewServerActivityData.Get:CurSelectedIndex()
	local index = -1;
	local arr = self.NewServerRankButton;
	local arrLen = self.NewServerRankButton:getSize();
	for i = 1, arrLen do
		if self.NewServerRankButton[i].end_tick > tonumber(tostring(GlobalVar.cur_tick)) and self.NewServerRankButton[i].value ~= 1 then
			index = i;
			break;
		end
	end
	return index;
end

function Lua_NewServerActivityData:setNewSeverActData(msg, rank_type, last_rank_info, rank_stage)
	self.first_type = msg.first_type;
	self.second_type = msg.second_type;
	self.act_index = msg.act_index;
	self.starNum = tonumber(tostring(msg.sub_value));
	self.myRank = tonumber(tostring(msg.second_sub));
	self.reward_info = msg.reward_info;
	self.stop_tick = tonumber(tostring(msg.stop_tick));
	self.start_tick = tonumber(tostring(msg.start_tick));
	self.content = msg.content;
	self.rank_type = rank_type;
	self.last_rank_info = last_rank_info;
	self.rank_stage = rank_stage;
	if self.rank_stage ~= nil and self.rank_stage == 2 then
		if last_rank_info ~= nil then
			self.myRank = last_rank_info.obj_id;
			self.starNum = last_rank_info.obj_value;
		end
	end
end

function Lua_NewServerActivityData.Get:rewardArr()
	local isShow = false;
    local arr = Array()
    for k, v in ipairs(self.reward_info) do
        local list = { }
        list.desTxt = v.content
        list.draw_flag = v.draw_flag
        list.cond = v.cond
        list.greenMark = false;
        if tonumber(tostring(list.cond[3])) == 1 then
            -- 判断排行区间
            -- 确定是否满足排名
            if self.myRank <= tonumber(tostring(list.cond[2])) then -- self.myRank >= tonumber(tostring(list.cond[1]))
                -- 确定是否满足附加条件
                if self.stageDic ~= nil then
                    -- 确定是5位数
                    if list.cond[4] ~= nil then
                        if self.stageDic.stage > tonumber(tostring(list.cond[4])) then
                            list.greenMark = true
                        elseif self.stageDic.stage == tonumber(tostring(list.cond[4])) then
                            if self.stageDic.starLvl >= tonumber(tostring(list.cond[5])) then
                                list.greenMark = true
                            else
                                list.greenMark = false
                            end
                        else
                            list.greenMark = false
                        end
                    end
                else
                    if self.starNum >= tonumber(tostring(list.cond[4])) then
                        list.greenMark = true
                    else
                        list.greenMark = false
                    end
                end
            end
        elseif tonumber(tostring(list.cond[3])) == 0 then
            if self.stageDic ~= nil then
                if list.cond[4] ~= nil then
                    if self.stageDic.stage > tonumber(tostring(list.cond[1])) then
                        list.greenMark = true
                    elseif self.stageDic.stage == tonumber(tostring(list.cond[1])) then
                        if self.stageDic.starLvl >= tonumber(tostring(list.cond[2])) then
                            list.greenMark = true
                        else
                            list.greenMark = false
                        end
                    else
                        list.greenMark = false
                    end
                end
            else
                if self.starNum >= tonumber(tostring(list.cond[1])) then
                    list.greenMark = true
                else
                    list.greenMark = false
                end
            end
        end
        list.voArr = Array()
        for key, value in ipairs(v.reward_set) do
            local rewardVo = Lua_ToolVo.new(value.id, value.amount, value.bind)
            rewardVo:fromServer(value)
            list.voArr:add(rewardVo)
        end
        list.effectArr = v.spec_effect_item

        -- 只显示一次奖励
        if list.greenMark then
        	if isShow then
        		list.greenMark = nil;
        	end
        	isShow = true;
        end
        arr:add(list)
    end
    return arr
end

function Lua_NewServerActivityData.Get:ActState()
	return self.stop_tick >= tonumber(tostring(GlobalVar.cur_tick));
end

function Lua_NewServerActivityData.Get:NewServerConfigData()
	if self.serverConfig == nil then
		self.serverConfig = getConfig({ "newServerRankConfig" });
	end
	return self.serverConfig[self.second_type];
end

function Lua_NewServerActivityData.Get:configArr()
	local arr = Array();
	local listData = self.NewServerConfigData.todo_act;
	for k, v in pairs(listData) do
		local list = {};
		list.altas = v.altas;
		list.iconName = v.iconName;
		list.des = v.des;
		list.winName = v.winName;
		list.winIndex = v.winIndex;
		if v.EventName ~= nil then
			list.EventName = v.EventName; -- 表示去挂机
		end
		if v.isShowEffect ~= nil then
			list.isShowEffect = v.isShowEffect; -- 跳转商城定位的道具id是否显示特效
		end
		if v.itemId ~= nil then
			list.itemId = v.itemId; -- 跳转商城定位的道具id
		end
		if v.open_id ~= nil then
			list.open_id = v.open_id;
		end
		arr:add(list);
	end
	return arr;
end

function Lua_NewServerActivityData.Get:rank_txt()
	return self.NewServerConfigData.rank_txt
end

function Lua_NewServerActivityData.Get:rank_txt2()
	return self.NewServerConfigData.rank_txt2
end

function Lua_NewServerActivityData.Get:lvl_txt()
	return self.NewServerConfigData.lvl_txt
end

function Lua_NewServerActivityData.Get:todo_txt()
	return self.NewServerConfigData.todo_txt
end

function Lua_NewServerActivityData.Get:rank_title()
	return self.NewServerConfigData.rank_title
end

function Lua_NewServerActivityData.Get:tips_txt()
	return self.NewServerConfigData.tips_txt
end

function Lua_NewServerActivityData.Get:img_path()
	return self.NewServerConfigData.img_path
end

function Lua_NewServerActivityData.Get:rank_count()
	return self.NewServerConfigData.rank_count
end

function Lua_NewServerActivityData.Get:rankStr()
	if self.myRank == 0 or self.myRank > self.rank_count then
		if self.ActState == true then
			return LanUtil.formateStr(self.rank_txt, LanUtil.getValue(127204));
		else
			return LanUtil.formateStr(self.rank_txt, LanUtil.getValue(127207));
		end
	else
		return LanUtil.formateStr(self.rank_txt, tostring(self.myRank));
	end
end

function Lua_NewServerActivityData.Get:rankStr2()
	if self.myRank == 0 or self.myRank > self.rank_count then
		return LanUtil.formateStr(self.rank_txt2, LanUtil.getValue(127204));
	else
		return LanUtil.formateStr(self.rank_txt2, tostring(self.myRank));
	end
end

function Lua_NewServerActivityData.Get:stageDic()
	if self.second_type == 4 then
		self._stageDic = DataCenter.servantData:lvlTrans(self.starNum);
	elseif self.second_type == 5 then
		self._stageDic = DataCenter.mountData:lvlTrans(self.starNum);
	elseif self.second_type == 6 then
		self._stageDic = DataCenter.servantWeaponData:lvlTrans(self.starNum);
	elseif self.second_type == 7 then
		self._stageDic = DataCenter.servantMountData:lvlTrans(self.starNum);
	elseif self.second_type == 8 then
		self._stageDic = DataCenter.servantWingData:lvlTrans(self.starNum);
	elseif self.second_type == 9 then
		self._stageDic = DataCenter.footprintData:lvlTrans(self.starNum);
	elseif self.second_type == 10 then
		self._stageDic = DataCenter.magicWeaponData:lvlTrans(self.starNum);
	elseif self.second_type == 11 then
		self._stageDic = DataCenter.talismanData:lvlTrans(self.starNum);
	elseif self.second_type == 18 then
		self._stageDic = Lua_AwakeUtil:lvlConversion(tonumber(self.starNum), true);
	else
		return nil;
	end
	return self._stageDic;
end

function Lua_NewServerActivityData.Get:lvlStr()
	local str = ""
	if self.second_type == 1 then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.starNum));
	elseif self.second_type == 2 then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.starNum));
	elseif self.stageDic ~= nil then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.stageDic.stage), tostring(self.stageDic.starLvl));
	elseif self.second_type == 101 then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.starNum));
	elseif self.second_type == 102 then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.starNum));
	elseif self.second_type == 103 then
		str = LanUtil.formateStr(self.lvl_txt, tostring(self.starNum));
	end
	return str;
end