Lua_CrazyEggsData = class("Lua_CrazyEggsData");
function Lua_CrazyEggsData:ctor()
	self.crazyEggsDataLogin = false;
	self.isItemCreate = false;
	self.isSmashAll = false;
	self.isSmashOne = false;

	self:resetEggSmashSelect();
end

function Lua_CrazyEggsData:dispose()
	self.crazyEggsDataLogin = false;
	self.isItemCreate = false;
	self.isSmashAll = false;
	self.isSmashOne = false;

	self:resetEggSmashSelect();
end

function Lua_CrazyEggsData:resetEggSmashSelect()
	self.eggSmashDic = {};
end

function Lua_CrazyEggsData:fromServer50105711(msg)
	if msg == nil then
		return;
	end

	self.end_tick = msg.activity_info.end_tick; -- 结束时间
	self.content = msg.activity_info.content; -- 内容
	self.gold_pool = msg.gold_pool; -- 金蛋奖池信息
	self.color_pool = msg.color_pool; -- 彩蛋奖池信息
	self.eggs_list = msg.eggs_list; -- 要砸的蛋信息
	self.free_open = msg.free_open; -- 0 关闭免费刷新，1 开启免费刷新
	self.free_fresh = msg.free_fresh; -- 免费刷新次数, 0表示没有免费次数
	self.free_cd = msg.free_cd; -- 免费刷新CD剩余时间，单位秒
	self.free_getTime = getTime();
	self.gold_fresh = msg.gold_fresh; -- 花费多少元宝刷新
	self.reward_record_list = msg.reward_record_list; -- 奖励信息
	self.extra_reward_list = msg.extra_reward_list; -- 额外奖励信息
	self.smash_times = msg.smash_times; -- 已砸蛋次数
	self.gold_egg_cost = msg.gold_egg_cost; -- 金蛋消耗元宝
	self.color_egg_cost = msg.color_egg_cost; -- 彩蛋消耗元宝

	self.eggCount = #msg.eggs_list; -- 蛋数量
end

-- 免费刷新时间
function Lua_CrazyEggsData.Get:freeTime()
	local num = self.free_cd - (getTime() - self.free_getTime);
	if num < 0 then
		return 0;
	end
	return num;
end

-- 金蛋奖池
function Lua_CrazyEggsData.Get:getGoldPool()
	local arr = Array();
	for i,v in ipairs(self.gold_pool) do
		local vo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
		vo.star = v.equipment.star;
		arr:add({vo = vo; show_effect = v.show_effect});
	end
	return arr;
end

-- 彩蛋奖池
function Lua_CrazyEggsData.Get:getColorPool()
	local arr = Array();
	for i,v in ipairs(self.color_pool) do
		local vo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
		vo.star = v.equipment.star;
		arr:add({vo = vo; show_effect = v.show_effect});
	end
	return arr;
end

-- 所有蛋
function Lua_CrazyEggsData.Get:getEggsList()
	local arr = Array();
	for i,v in ipairs(self.eggs_list) do
		local list = {};
		list.index = v.index; -- 蛋的索引，索引从0开始
		list.color = v.color; -- 0 金蛋，1 彩蛋
		list.open = v.open; -- 1 已砸蛋

		if v.color == 0 then
			list.cost = self.gold_egg_cost;
			list.effect = "gui_fengkuangzadan_huangse";
		elseif v.color == 1 then
			list.cost = self.color_egg_cost;
			list.effect = "gui_fengkuangzadan_caise";
		end

		if v.item.id ~= 0 then
			local vo = Lua_ToolVo.createToolVo(v.item.id, v.item.amount, v.item.bind); -- 砸蛋后获得的道具信息
			vo.star = v.item.equipment.star;
			list.vo = vo;
			list.show_effect = v.item.show_effect;
		end
		arr:add(list);
	end	
	return arr;
end

-- 奖励记录信息
function Lua_CrazyEggsData.Get:getRecordData()
	local arr = Array();
	for i,v in ipairs(self.reward_record_list) do
		local list = {};
		list.role_id = v.role_id; -- 角色ID
		list.role_name = v.role_name; -- 角色名
		list.smash_times = v.smash_times; -- 砸蛋次数

		local itemArr = Array();
		for x,y in ipairs(v.item) do
			local vo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			vo:fromServer(y);
			itemArr:add({vo = vo, item_id = y.id, amount = y.amount});
		end

		list.itemArr = itemArr;
		arr:add(list);
	end
	return arr;
end

-- 额外奖励
function Lua_CrazyEggsData.Get:getExtraRewardData()
	local obj;
	local tvo;
	local tvoArr;
	local arr = Array();
	for i = 1, #self.extra_reward_list do
		obj = self.extra_reward_list[i];

		tvoArr = Array();
		for j = 1, #obj.item do
			tvo = Lua_ToolVo.createToolVo(obj.item[j].id, obj.item[j].amount, obj.item[j].bind);
			tvo.star = obj.item[j].equipment.star;
			tvoArr:add({vo = tvo, show_effect = obj.item[j].show_effect});
		end

		arr:add({
			index = obj.index, -- 奖励索引，从0开始
			times = obj.times, -- 需要的次数
			reward_flag = obj.reward_flag, -- 0 没奖励，1 可领取，2 已领取
			sort = (obj.reward_flag + 1) % 3,
			itemArr = tvoArr
		});
	end
	arr:sort("sort", true);
	return arr;
end

-- 金蛋数量
function Lua_CrazyEggsData.Get:totalGoldEgg()
	local goldEgg = 0;
	for i,v in ipairs(self.eggs_list) do
		if v.color == 0 and v.open == 0 then
			goldEgg = goldEgg + 1;
		end
	end
	return goldEgg;
end

-- 彩蛋数量
function Lua_CrazyEggsData.Get:totalColorEgg()
	local colorEgg = 0;
	for i,v in ipairs(self.eggs_list) do
		if v.color == 1 and v.open == 0 then
			colorEgg = colorEgg + 1;
		end
	end
	return colorEgg;
end

-- 砸开所有蛋消耗
function Lua_CrazyEggsData.Get:totalSmashCost()
	return self.totalColorEgg * self.color_egg_cost + self.totalGoldEgg * self.gold_egg_cost;
end

-- 检查砸开蛋数量
function Lua_CrazyEggsData:checkAllSmashCount()
	local smashEgg = 0;
	for i,v in ipairs(self.eggs_list) do
		if v.open == 1 then
			smashEgg = smashEgg + 1;
		end
	end
	return smashEgg;
end

-- 检查是否全部砸开
function Lua_CrazyEggsData:checkIsAllSmash()
	return self:checkAllSmashCount() == self.eggCount;
end

-- 检查是否有免费刷新，用于取消红点
function Lua_CrazyEggsData:checkRedDot()
	if self.free_open == 1 then
		DataCenter.redDotData:updateRedDotVoState(22070, self.free_fresh == 1);
	end
end

function Lua_CrazyEggsData:setEggSmashSelect(eggIdx, bSelect)
	self.eggSmashDic[eggIdx] = bSelect;
end

function Lua_CrazyEggsData:getEggSmashSelect(eggIdx)
	return self.eggSmashDic[eggIdx] or false;
end