-- 累计消费 数据
Lua_CumulativeConsumptionData = class("Lua_CumulativeConsumptionData");
function Lua_CumulativeConsumptionData:ctor()
	self.isLogin = false;
	self.redDotShow = false;
end

function Lua_CumulativeConsumptionData:dispose()
	self.isLogin = false;
	self.redDotShow = false;
end

function Lua_CumulativeConsumptionData:fromServerData(msg)
	if msg == nil then
		return;
	end
	self.icon = msg.activity_info.icon; -- 图标
	self.content = msg.activity_info.content; -- 活动内容
	self.startTick = msg.activity_info.start_tick;-- 活动开始时间
	self.endTick = msg.activity_info.end_tick; -- 活动结束时间
	self.rewards = msg.rewards; -- 奖励 cond：需要的金额
	self.total_gold = msg.total_gold; -- 已消耗元宝数
end

function Lua_CumulativeConsumptionData.Get:getTotalConsumeActData()
	local arr = Array();
	for i,v in ipairs(self.rewards) do
		local list = {};
		list.index = v.index; -- 索引
		list.cond = v.cond[1]; --条件
		list.state = v.state; -- 状态

		local tvoArr = Array();
		for x,y in ipairs(v.reward_items) do
			local tvo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			tvo.star = y.equipment.star;
			tvo.packType = 999;
			tvo.roundEffect = y.show_effect == 1;
			tvoArr:add(tvo);
		end
		list.tvoArr = tvoArr;
		arr:add(list);
	end
	return arr;
end