Lua_ExquisitePagodaData = class("Lua_ExquisitePagodaData")
function Lua_ExquisitePagodaData:ctor()
	self:dispose();
end

function Lua_ExquisitePagodaData:dispose()
	self.isPass = 0; -- 是否跳过动画
	self.drawType = -1; -- 抽奖类型
	self.firstType = 1053; -- 活动类型
	self.index = 0;
	self.isDraw = false; -- 寻宝中

	self.draw_index = 0; -- 抽中索引
	self.draw_layer = 0; -- 抽中层数
end

function Lua_ExquisitePagodaData:fromServer50105610(msg)
	if msg == nil then
		return;
	end

	self.act_info = msg.act_info; -- 活动信息
	self.layer_reward = msg.layer_reward; -- 各层奖励 从一层开始
	self.partake_reward = msg.partake_reward; -- 参与奖励
	self.money_type = msg.money_type; -- 金钱类型
	self.draw_type = msg.draw_type; -- 抽奖类型 id:抽奖次数 value:抽奖金额
	self.is_free_draw = msg.is_free_draw; -- 是否有免费抽奖 0则没有
	self.free_left_time = msg.free_left_time; -- 免费抽奖冷却剩余时间
	self.is_show_reward = msg.is_show_reward; -- 是否展示大奖
	self.special_effect_id = msg.special_effect_id; -- 需要播放特效的道具 value：星级
	self.cur_layer = msg.cur_layer; -- 当前处于第几层
	self.cur_count = msg.cur_count; -- 当前寻宝次数
	self.per_record = msg.per_record; -- 个人记录
	self.whole_record = msg.whole_record; -- 全服记录
	self.special_treasure = msg.special_treasure; -- 宝物id集合 value：星级
	self.model_position = msg.model_position; -- 模型偏移，旋转，缩放
	self.special_force = msg.special_force; -- 大奖战力

	self.content = msg.act_info.content; -- 内容
	self.end_tick = msg.act_info.end_tick; -- 结束时间
	self.start_tick = msg.act_info.start_tick;-- 开始时间
	self.freeDraw_getTime = getTime();
end

function Lua_ExquisitePagodaData.Get:freeDrawTime()
	local num = self.free_left_time - (getTime() - self.freeDraw_getTime);
	if num < 0 then
		return 0;
	end
	return num;
end

-- 宝塔奖励展示
function Lua_ExquisitePagodaData.Get:getLayerRewards()
	local tvo;
	local arr = Array();
	for i,v in ipairs(self.layer_reward) do
		for x,y in ipairs(v.reward_items) do
			tvo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			tvo.star = y.equipment.star;
			tvo.packType = 999;

			arr:add({vo = tvo, show_effect = y.show_effect, isSpecial = y.is_special});
		end	
	end
	return arr;
end

-- 大奖信息
function Lua_ExquisitePagodaData.Get:getSpecialRewardInfo()
	local tvo;
	local rewardInfo = self.layer_reward[#self.layer_reward].reward_items;
	for k,v in ipairs(rewardInfo) do
		tvo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
	end
	return tvo;
end

-- 参与奖励
function Lua_ExquisitePagodaData.Get:getPartakeRewards()
	local list;
	local tvo;
	local arr = Array();
	for i,v in ipairs(self.partake_reward) do
		list = {};
		list.index = v.index; -- 索引
		list.title = v.title; -- 标题
		list.state = v.state; -- 状态 0：不可领取，1：可领取，2已领取
		list.count = v.cond[2]; -- 次数
		list.vipLvl = v.cond[1]; -- vip等级
		list.sortNum = v.state == 2 and 999 or v.index; -- 排序

		for x,y in ipairs(v.reward_items) do
			tvo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			tvo.star = y.equipment.star;
			tvo.packType = 999;

			list.vo = tvo;
			list.show_effect = y.show_effect;
		end
		arr:add(list);
	end
	arr:sort("sortNum", false);
	return arr;
end

-- 抽奖类型：drawCount 抽奖次数，drawMoney 抽奖金额
function Lua_ExquisitePagodaData.Get:getDrawInfo()
	local arr = Array();
	for i,v in ipairs(self.draw_type) do
		arr:add({drawCount = v.obj_id, drawMoney = v.obj_value});
	end
	return arr;
end

-- 模型偏移，旋转，缩放
function Lua_ExquisitePagodaData.Get:getModelInfo()
	local arr = Array();
	for i,v in ipairs(self.model_position) do
		arr:add({x = v.value1, y = v.value2, z = v.value3});
	end
	return arr;
end

function Lua_ExquisitePagodaData.Get:getModelPos()
	return Vector3(self.getModelInfo[1].x, self.getModelInfo[1].y, self.getModelInfo[1].z);
end

function Lua_ExquisitePagodaData.Get:getModelRot()
	return Vector3(self.getModelInfo[2].x, self.getModelInfo[2].y, self.getModelInfo[2].z);
end

function Lua_ExquisitePagodaData.Get:getModelSca()
	return Vector3(self.getModelInfo[3].x, self.getModelInfo[3].y, self.getModelInfo[3].z);
end