Lua_GodFurnaceData = class("Lua_GodFurnaceData");
function Lua_GodFurnaceData:ctor()
    self:dispose();
end

function Lua_GodFurnaceData:dispose()
	self.godFurnaceLogin = false;
	self.isItemCreate = false;
	self.drawType = 0;
end

function Lua_GodFurnaceData:from50105721(msg)
	if msg ~= nil then
		self.end_tick = msg.activity_info.end_tick; -- 结束时间
		self.content = msg.activity_info.content; -- 内容
		self.help_tips = msg.activity_info.help_tips; -- 提示帮助内容
		self.rewards = msg.rewards; -- 奖励
		self.open_value = msg.open_value; -- 开炉需要的值
		self.current_value = msg.current_value; -- 当前剩余值
		self.one_cost = msg.draw_one_cost; -- 抽一次消耗
		self.ten_cost = msg.draw_ten_cost; -- 抽十次消耗
		self.position = msg.position; -- 模型位置
		self.rotation_angle = msg.rotation_angle; -- 模型旋转角度
		self.size = msg.size; -- 模型大小
		self.id = msg.id; -- 神炉值物品id
	end
end

function Lua_GodFurnaceData.Get:getRewardsData()
	local list;
	local tvo;
	local arr = Array();
	for i,v in ipairs(self.rewards) do
		list = {};
		tvo = nil;
		list.index = v.index; -- 索引
		list.value = v.value; -- 神炉值

		if v.value > 0 then
			tvo = Lua_ToolVo.createToolVo(self.id);

			list.item_id = self.id;
			list.is_special = 0;
		elseif v.value == 0 then
			tvo = Lua_ToolVo.createToolVo(v.item.id, v.item.amount, v.item.bind);
			tvo.star = v.item.equipment.star;

			list.item_id = v.item.id;
			list.show_effect = v.item.show_effect;
			list.is_special = v.item.is_special; -- 是否为大奖（模型）
		end
		list.vo = tvo;
		arr:add(list);
	end
	return arr;
end

function Lua_GodFurnaceData.Get:getModelInfo()
	local tvo;
	for i = 1, self.getRewardsData:getSize() do
		if self.getRewardsData[i].is_special == 1 then
			tvo = self.getRewardsData[i].vo;
			break;
		end
	end
	return tvo;
end

function Lua_GodFurnaceData:checkBagPackEnough(bagType)
	local bagData = DataCenter.packData:getBagType(bagType);
	local leftNum = bagData:getLeftSize();
	if leftNum <= 0 then
		DataCenter.packData:showFullBagTip(bagType);
		return false;
	end
	return true;
end

function Lua_GodFurnaceData.Get:getModelPos()
	local str = string.split(self.position, ",");
	return Vector3(tonumber(str[1]), tonumber(str[2]), tonumber(str[3]));
end

function Lua_GodFurnaceData.Get:getModelRot()
	local str = string.split(self.rotation_angle, ",");
	return Vector3(tonumber(str[1]), tonumber(str[2]), tonumber(str[3]));
end

function Lua_GodFurnaceData.Get:getModelSca()
	local str = string.split(self.size, ",");
	return Vector3(tonumber(str[1]), tonumber(str[2]), tonumber(str[3]));
end