Lua_GoodLuckDialData = class("Lua_GoodLuckDialData")
function Lua_GoodLuckDialData:ctor()
	self:dispose();
end

function Lua_GoodLuckDialData:dispose()
	self.isPass = false;
	self.isShow = false;
	self.oneDrawNum = 1; -- 抽奖次数
	self.tenDrawNum = 10;
	self.fiftyDrawNum = 50;
	self.drawType = -1; -- 抽奖类型
	self.ruleTips = ""; -- 后台配置规则说明
	self.isEnd = false;
end

function Lua_GoodLuckDialData:fromServer50101810(msg)
	if msg ~= nil then
		self.cost = msg.cost; -- 每次抽奖花费元宝数
		self.free_draw_once = msg.free_draw_once; -- 是否有免费抽一次
		self.left_time = msg.left_time; -- 获得免费抽奖一次剩余时间
		self.act_left_time = msg.act_left_time; -- 活动剩余时间
		self.draw_count = msg.draw_count; -- 总抽奖次数
		self.add_gold = msg.add_gold; -- 每抽奖一次奖池增加元宝值
		self.recharge_count = msg.recharge_count; -- 已充值元宝
		self.free_draw_reward = msg.free_draw_reward; -- 剩余充值奖励的免费次数
		self.recharge_reward = msg.recharge_reward; -- 充值奖励
		self.exchange_reward = msg.exchange_reward; -- 次数兑换奖励
		self.id_list = msg.id_list; -- 1-10位置物品信息
		self.open_recharge_reward = msg.open_recharge_reward; -- 开启充值奖励 0不开启，1开启
		self.open_free_count = msg.open_free_count; -- 开启倒计时免费奖励 0不开启，1开启
	end
end

-- 转盘展示道具
function Lua_GoodLuckDialData.Get:getShowItem()
	local list;
	local arr = Array();
	for k,v in ipairs(self.id_list) do
		list = {};
		if k == v.site then
			local vo = Lua_ToolVo.createToolVo(v.item_id, v.num, v.bind);
			vo.star = v.start;
			vo.packType = 999;

			list.vo = vo;
			list.percent = math.floor(v.percent * 100); -- 元宝百分比
			list.effect = v.effect; -- 特效 1显示
		end
		arr:add(list);
	end
	return arr;
end

-- 次数兑换幸运奖励
function Lua_GoodLuckDialData.Get:getExchangeReward()
	local vo;
	local list;
	local arr = Array();
	for i,v in ipairs(self.exchange_reward) do
		vo = Lua_ToolVo.createToolVo(v.item_id, v.num, v.bind);
		vo.star = v.start;
		vo.packType = 999;

		list = {};
		list.vo = vo; -- 显示道具
		list.need_draw = v.need_draw; -- 领取需要的次数
		list.effect = v.effec; -- 特效 1显示
		list.state = v.state; -- 领取状态 1已领取 0未领取
		if v.need_draw > self.draw_count then
			list.leftCount = v.need_draw - self.draw_count; -- 差次数
			list.isCanGet = false; -- 是否可领取
		else
			list.leftCount = 0;
			list.isCanGet = true;
		end
		
		if v.state == 0 then
			list.index = i - 1; -- 索引
		elseif v.state == 1 then
			list.index = 999;
		end
		arr:add(list);
	end
	arr:sort("index", false);
	return arr;
end

-- 总免费次数
function Lua_GoodLuckDialData.Get:getAllFreeCount()
	local freeOnce = self.free_draw_once and 1 or 0;
	return freeOnce + self.free_draw_reward;
end

-- 充值奖励
function Lua_GoodLuckDialData.Get:getRechargeReward()
	local isGet;
	local arr = Array();
	if self.recharge_reward ~= nil then
		for i,v in ipairs(self.recharge_reward) do
			isGet = self.recharge_count >= v.obj_id;
			arr:add({rechargeNum = v.obj_id, freeCount = v.obj_value, isGet = isGet});
		end
	end
	return arr;
end