checkRequire("Lua_InvestmentPlanDataVo");
checkRequire("Lua_PeakInvestmentDataVo");
Lua_InvestmentPlanData = class("Lua_InvestmentPlanData");
function Lua_InvestmentPlanData:ctor()
	self.peakInvestmentOpen = nil; --通知巅峰投资开启
end

-- 获取投资计划信息
function Lua_InvestmentPlanData:sGetInvestmentPlanInfo(grade)
	local cmd = ProtoPublic_pb.Proto11401810();
	cmd.grade = grade;
	sendMsg(11401810, cmd);
end

-- 领取投资奖励（投资计划）
function Lua_InvestmentPlanData:sReceiveInvestmentPlanInfo(index)
	local cmd = ProtoPublic_pb.Proto11401811();
	cmd.index = index;
	sendMsg(11401811, cmd);
end

-- 立即投资（投资计划）
function Lua_InvestmentPlanData:sInvestmenting(grade)
	local cmd = ProtoPublic_pb.Proto11401813();
	cmd.invest_grade = grade;
	sendMsg(11401813, cmd);
end

-- 获取巅峰投资信息
function Lua_InvestmentPlanData:sGetPeakInvestmentInfo(grade)
	local cmd = ProtoPublic_pb.Proto11401823();
	cmd.grade = grade;
	sendMsg(11401823, cmd);
end

-- 立即投资（巅峰投资）
function Lua_InvestmentPlanData:sPeakInvestmenting(grade)
	local cmd = ProtoPublic_pb.Proto11401825();
	cmd.invest_grade = grade;
	sendMsg(11401825, cmd);
end

-- 领取投资奖励（巅峰投资）
function Lua_InvestmentPlanData:sReceivePeakInvestmentInfo(index)
	local cmd = ProtoPublic_pb.Proto11401824();
	cmd.index=index;
	sendMsg(11401824, cmd);
end

function Lua_InvestmentPlanData:fromServer51401810(msg)
	if msg == nil then
		return;
	end

	self._investmentInfoArr = Array();
	for i = 1, #msg.reward_status do
		self._investmentInfoArr:add({index = i, status = msg.reward_status[i], reward = msg.invest_rewards[i],
			received_reward = msg.replacement_rewards[i], confingData = self.investmentPlanDic[i]});
	end
	self.currentGrade = msg.grade;
	self.oldGrade = msg.invest_id;
	self.showIcon = msg.show_icon;
end

function Lua_InvestmentPlanData.Get:investmentPlanDic()
	if self._investmentPlanDic == nil then
		self._investmentPlanDic = {};

		local confing = getConfig({"invest_recharge"});
		for k,v in pairs(confing) do
			self._investmentPlanDic[k] = Lua_InvestmentPlanDataVo.new(k);
		end
	end
	return self._investmentPlanDic;
end

function Lua_InvestmentPlanData:formServer51401823(msg)
	if msg == nil then
		return;
	end

	self._investmentInfoArr = Array();
	for i = 1, #msg.reward_status do
		self._investmentInfoArr:add({index = i, status = msg.reward_status[i], reward = msg.invest_rewards[i],
			received_reward = msg.replacement_rewards[i], confingData = self.peakInfoDic[i]});
	end
	self.currentGrade = msg.grade;
	self.oldGrade = msg.invest_id;
	self.showIcon = msg.show_icon;
end

function Lua_InvestmentPlanData.Get:peakInfoDic()
	if self._peakInfoDic == nil then
		self._peakInfoDic = {};

		local confing = getConfig({"top_invest"});
		for k,v in pairs(confing) do
			self._peakInfoDic[k] = Lua_PeakInvestmentDataVo.new(k);
		end
	end
	return self._peakInfoDic;
end

function Lua_InvestmentPlanData.Get:investmentInfoArr()
	if self._investmentInfoArr == nil then 
		return nil;
	end
	return self._investmentInfoArr;
end





function Lua_InvestmentPlanData.Get:peakInvestmentOpen()
	if DataCenter.roleData:checkGameSwich("peak_invest") ~= 1 then
		return 0;
	end
	return self._peakInvestmentOpen;
end

function Lua_InvestmentPlanData.Set:peakInvestmentOpen(value)
	self._peakInvestmentOpen = value;
end

function Lua_InvestmentPlanData:getMoneyList()
	local moneyConfing;
	if self.peakInvestmentOpen == 1 then
		moneyConfing = getConfig({"top_invest", 1, "invest_grade"});
	else
		moneyConfing = getConfig({"invest_recharge", 1, "invest_grade"});
	end

	if moneyConfing == nil then 
		return nil;
	end
	return moneyConfing;
end

function Lua_InvestmentPlanData:getCashGift()
	local cashGiftConfing;
	if self.peakInvestmentOpen == 1 then
		cashGiftConfing = getConfig({"top_invest", 1, "cash_gift"});
	else
		cashGiftConfing = getConfig({"invest_recharge", 1, "cash_gift"});
	end

	if cashGiftConfing==nil then 
		return nil;
	end
	return cashGiftConfing;
end

-- 获得称号ID
function Lua_InvestmentPlanData.Get:getLabelId()
	local labelId;
	if self.peakInvestmentOpen == 1 then
		labelId = getConfig({"top_invest", 1, "label_item_id"});
	else
		labelId = getConfig({"invest_recharge", 1, "label_item_id"});
	end

	if labelId == nil then 
		return nil;
	end
	return labelId;
end

-- 获得最大档次称号索引
function Lua_InvestmentPlanData.Get:getMaxInvestGrade()
	local labelId;
	if self.peakInvestmentOpen == 1 then
		labelId = getConfig({"top_invest", 1, "invest_grade"});
	else
		labelId = getConfig({"invest_recharge", 1, "invest_grade"});
	end

	if labelId == nil then 
		return nil;
	end
	return #labelId - 1;
end