-- 全民BOSS、BOSS首杀 数据

Lua_KillBossActData = class("Lua_KillBossActData");
function Lua_KillBossActData:ctor()
    self:superCall("ctor");

    self.boss_kill = false;
    self.boss_everyone = false;
end

function Lua_KillBossActData:dispose()
    self.boss_kill = false;
    self.boss_everyone = false;
end

function Lua_KillBossActData:getBossFirstKillInfo(msg)
	if msg ~= nil then
		self.bossFirstKill_info = msg.act_info; -- 活动信息
		self.bossFirstKill_reward = msg.reward; -- 击杀奖励
		self.bossFirstKill_detail = msg.boss_detail; -- boss信息

		self.bossFirstKill_content = msg.act_info.content; -- 活动内容
		self.bossFirstKill_startTick = msg.act_info.start_tick;-- 活动开始时间
		self.bossFirstKill_endTick = msg.act_info.end_tick; -- 活动结束时间
	end
end

function Lua_KillBossActData:getBossEveryoneInfo(msg)
	if msg ~= nil then
		self.bossEveryone_info = msg.act_info; -- 活动信息
		self.bossEveryone_reward = msg.reward; -- 活动奖励
		self.bossEveryone_detail = msg.boss_detail; -- boss信息

		self.bossEveryone_content = msg.act_info.content; -- 活动内容
		self.bossEveryone_startTick = msg.act_info.start_tick;-- 活动开始时间
		self.bossEveryone_endTick = msg.act_info.end_tick; -- 活动结束时间
	end
end

function Lua_KillBossActData:getRewardsInfo(msg)
	if msg ~= nil then
		if msg.first_type == Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE then -- 全民BOSS
			self.bossEveryone_reward = msg.reward;
			Lua_MsgUtil.callFunc("UPDATE_ACT_BOSS_EVERYONE");
		end
	end
end

function Lua_KillBossActData.Get:getBossFirstKillData()
	local arr = Array();
	for i,v in ipairs(self.bossFirstKill_detail) do
		local list = {};
		local cfg = getConfig({"monster", v.monster_id});
		list.monster_id = v.monster_id; -- bossID
		list.monster_name = cfg.name; -- boss名
		list.monster_lvl = cfg.lvl; -- boss等级
		list.monster_icon = cfg.head_src; -- boss头像
		list.monster_bornScene = cfg.born_scene_desc; -- boss所属类型
		list.illus_group_id = cfg.illus_group_id; -- BOSS所属图鉴分组ID
		list.relive_sec = v.relive_sec; -- 重新剩余秒数
		list.kill_role_id = v.kill_role_id; -- 击杀者ID
		list.kill_name = v.kill_name; -- 击杀者
		list.kill_type = v.kill_type; -- 击杀类型 1个人击杀 2队伍击杀
		list.is_live = v.is_live; -- 0 不存在 1 存在

		local reward_arr = Array();
		for x,y in ipairs(self.bossFirstKill_reward) do
			if i == x then
				list.index = y.index; -- 索引
				list.state = y.state; -- 状态 0：不可领取，1：可领取，2已领取
				for a,b in ipairs(y.reward_items) do
					local _list = {};
					local vo = Lua_ToolVo.createToolVo(b.id, b.amount, b.bind);
					vo.star = b.equipment.star;
					vo.packType = 999;
					_list.vo = vo;
					_list.show_effect = b.show_effect;
					reward_arr:add(_list);
				end
			end
		end
		list.reward_data = reward_arr;
		arr:add(list);
	end
	return arr;
end

function Lua_KillBossActData.Get:getBossEveryoneData()
	local arr = Array();
	for i,v in ipairs(self.bossEveryone_detail) do
		local cfg = getConfig({"monster", v.monster_id});
		
		local list = {};
		list.monster_id = v.monster_id; -- bossID
		list.monster_name = cfg.name; -- boss名
		list.monster_lvl = cfg.lvl; -- boss等级
		list.monster_icon = cfg.head_src; -- boss头像
		list.monster_bornScene = cfg.born_scene_desc; -- boss所属类型
		list.illus_group_id = cfg.illus_group_id; -- BOSS所属图鉴分组ID
		list.relive_sec = v.relive_sec; -- 重新剩余秒数
		list.is_live = v.is_live; -- 0 不存在 1 存在

		local tvoArr = Array();
		for x,y in ipairs(self.bossEveryone_reward) do
			if i == x then
				list.index = y.index; -- 索引
				list.state = y.state; -- 状态 0：不可领取，1：可领取，2已领取
				for a,b in ipairs(y.reward_items) do
					local tvo = Lua_ToolVo.createToolVo(b.id, b.amount, b.bind);
					tvo.star = b.equipment.star;
					tvo.packType = 999;
					tvo.roundEffect = b.show_effect == 1;
					tvoArr:add(tvo);
				end
			end
		end
		list.tvoArr = tvoArr;
		arr:add(list);
	end
	return arr;
end