Lua_MazeHuntData = class("Lua_MazeHuntData")
function Lua_MazeHuntData:ctor()
end

function Lua_MazeHuntData:dispose()
	if self.slot ~= nil then
		self.slot:dispose();
		self.slot = nil;
	end
end

function Lua_MazeHuntData:fromServer50105210(msg)
	if msg == nil then
		return;
	end

	self.slot = Array(); -- 所有档次
	for i,v in ipairs(msg.slots) do
		self.slot:add({item_list = v.item_list, index = v.index, type = v.type});
	end
	self.show_id = msg.show_id; -- 要展示的物品模型id
	self.tips = msg.tips;
end

function Lua_MazeHuntData:fromServer50105211(msg)
	if msg == nil then
		return;
	end

	self.left_time = msg.left_time; -- 活动剩余时间
	self.open_exchange = msg.open_exchange; -- 是否开启积分对换

	if self.score ~= nil then
		self.istIntegral = self.score > msg.score;
	end
	self.score = msg.score; -- 获得的积分
	self.step = msg.step + 1; -- 已到第几档
	self.number = msg.number; -- 最后一次摇的点数
	self.left_free_count = msg.left_free_count; -- 剩余免费摇次数
	self.one_cost = msg.one_cost; -- 摇筛子消耗
	self.got_items = msg.got_items; -- 已获得物品
	self.exchangeItems = msg.exchange_items; -- 积分对换物品列表
end

function Lua_MazeHuntData:fromServer80105401(msg)
	if msg == nil then
		return;
	end

	self.finish_count = msg.finish_count; -- 全服通关次数
	self.need = msg.need; -- 触发免费摇还需要的通关次数
	self.free = msg.free; -- 下一档免费通关次数
	self.finish_tag = msg.finish_tag; -- 已触发免费档次
end

function Lua_MazeHuntData:fromServerDressUpdate(msg)
	self.record_list = msg.record_list; -- 获奖记录列表
end





function Lua_MazeHuntData:redShow()
	self.isRedShow = false;
	if self.exchangeItems ~= nil then
		for i,v in ipairs(self.exchangeItems) do
			if self.score >= v.type and v.value ~= 0  then
				self.isRedShow = true;
			end
		end
	end
end

function Lua_MazeHuntData:modelUrl(id)
	local itemID = getConfig({"item", id});
	if itemID.modelFile ~= nil then
		if itemID.subType == 511 then
			self.modelFile = "/effects/scsEffects/"..itemID.modelFile;
			self.model = itemID.model;
		else
			self.modelFile = "/model/"..itemID.modelFile;
			self.model = itemID.model;
		end
	end

	local modelId = tonumber(itemID.tipShowModel);
	if modelId ~= nil then
		local playerHangerID = getConfig({"playerHanger", modelId})
		if playerHangerID ~= nil and self.model == nil then
			-- if playerHangerID.modelFile ~= nil then
				self.modelFile = playerHangerID.floder.."/"..playerHangerID.fileName;
				self.model = playerHangerID.fileName;
				self.isLoop = playerHangerID.setAction == 2;

				if playerHangerID.selectShow == nil then
					self.modelFile = playerHangerID.floder.."/"..playerHangerID.fileName;
					self.model = playerHangerID.fileName;
				else
					self.modelFile = playerHangerID.floder.."/"..playerHangerID.selectShow;
					self.model = playerHangerID.selectShow;
				end
			-- end
		end
	end

	local confing = getConfig({"mazeHuntModel", id})
	if confing ~= nil then
		self.mounter_pos = confing.mounter_pos;
		self.mounter_rot = confing.mounter_rot;
		self.mounter_sca = confing.mounter_sca;
		self.await = confing.await;

		if confing.modelFile ~= nil then
			self.modelFile = confing.modelFile
			self.model = confing.model
		end
	else
		self.mounter_pos = {-112, 0, 0};
		self.mounter_rot = {0, 0, 0};
		self.mounter_sca = {20, 20, 20};
	end
end