Lua_NewChargeEverydayData = class("Lua_NewChargeEverydayData")
function Lua_NewChargeEverydayData:ctor()
	self.isOpen = 0; -- 0:关闭 1：开启
	self.accu_recharge_reward = nil;
	self.accu_day_reward = nil;
	self.total_gold = 0;
	self.total_day = 0;
end

function Lua_NewChargeEverydayData:dispose()
	self.accu_recharge_reward = nil;
	self.accu_day_reward = nil;
	self.total_gold = 0;
	self.total_day = 0;
end

function Lua_NewChargeEverydayData:fromServer50105780(msg)
	if msg == nil then
		return;
	end

	self.accu_recharge_reward = msg.accu_recharge_reward; -- 累充奖励
	self.accu_day_reward = msg.accu_day_reward; -- 累天奖励
	self.total_gold = msg.total_gold; -- 累充元宝
	self.total_day = msg.total_day; -- 累充天数

	self._rechargeReward = nil;
	self._dayReward = nil;
end

-- 累充奖励
function Lua_NewChargeEverydayData.Get:rechargeReward()
	if self._rechargeReward == nil then
		self._rechargeReward = Array();
		local list = nil;
		if self.accu_recharge_reward ~= nil then
			for i,v in ipairs(self.accu_recharge_reward) do
				-- reward_state 奖励状态：0不可领，1可领，2已领
				self._rechargeReward:add({index = v.index, cond = v.cond, reward_state = v.reward_state, rewardArr = self:getRewardArr(v.item_list)});
			end
		end
	end
	return self._rechargeReward;
end

-- 累天奖励
function Lua_NewChargeEverydayData.Get:dayReward()
	if self._dayReward == nil then
		self._dayReward = Array();
		local list = nil;
		if self.accu_recharge_reward ~= nil then
			for i,v in ipairs(self.accu_day_reward) do
				-- reward_state 奖励状态：0不可领，1可领，2已领
				self._dayReward:add({index = v.index, cond = v.cond, reward_state = v.reward_state, rewardArr = self:getRewardArr(v.item_list)});
			end
		end
	end
	return self._dayReward;
end

function Lua_NewChargeEverydayData:getRewardArr(list)
	local tvo;
	local arr = Array();
	for i,v in ipairs(list) do
		tvo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
		tvo:fromServer(v);
		arr:add(tvo);
	end
	return arr;
end