-- 开服狂欢数据处理
Lua_OpenDressCarnivalData = class("Lua_OpenDressCarnivalData");
function Lua_OpenDressCarnivalData:ctor()
end

function Lua_OpenDressCarnivalData:dispose()
	self.dressList = nil;
	self.doubleCopyList = nil;
	self.copyDouble = nil;
end

function Lua_OpenDressCarnivalData:getOpenServiceServerInfo(msg) -- 开服狂欢、盛典活动
	if msg == nil then
		return;
	end
	self.msg = msg;

	self.act_index = msg.act_detail.act_index; -- 活动id（索引）
	self.first_type = msg.act_detail.first_type; -- 活动id
	self.end_other = tonumber(msg.act_detail.end_other); -- 活动结束时间--集字特殊使用
	self.start_tick = msg.act_detail.start_tick; -- 活动开始时间
	self.stop_tick = tonumber(msg.act_detail.stop_tick); -- 活动结束时间
	self.times = tonumber(msg.act_detail.times); -- 服务器当前时间戳（客户端使用）
	self.content = msg.act_detail.content; -- 活动描述

	-- 只爱一人
	if msg.act_detail.reward_info[1] ~= nil then
		self.title_id =  msg.act_detail.reward_info[1].reward_set[1].id;--称号ID
		self.draw_flag =  msg.act_detail.reward_info[1].draw_flag;--0未领取，1已领取，2表示条件不足
		self.reward_index = msg.act_detail.reward_info[1].index;--奖励索引
	end

	-- 一生一世
	self.left_current = msg.act_detail.cur_index; -- 甜蜜度
	self.open_server_day = msg.act_detail.open_server_day; -- 开服天数
	
	-- 帮派争霸，集字，累充
	self.combine_server_day = msg.act_detail.combine_server_day; -- 合服天数
	self.icon_type = msg.act_detail.icon_type; -- 图标

	-- 双倍
	if self.first_type == Lua_OperationalActivitiesData.ACT_DOUBLE and msg.act_detail.script_double[msg.act_detail.cur_index] ~= nil then
		self.cur_index = msg.act_detail.cur_index;

		self.script_double = msg.act_detail.script_double[self.cur_index];
		self.start_tick_time = self.script_double.start_tick; -- 开始时间
		self.end_tick_time = self.script_double.end_tick; -- 结束时间
		self.content_tips = self.script_double.content; -- 项目内容
		self.sets_list = self.script_double.sets; -- 项目
		self.level_limit = self.script_double.level_limit; -- 等级限制
	end
end

-- 是否是盛典活动标记
function Lua_OpenDressCarnivalData.Get:isDressCarnival()
	local list = Lua_OperationalActivitiesData.GrandCeremonyList;
	if self.dressList == nil then
		self.dressList = {};
		for i,v in ipairs(list) do
			self.dressList[v] = 1;
		end
	end
	return self.dressList;
end

-- 只爱一人
function Lua_OpenDressCarnivalData.Get:getOnlyLovesOneData()
	local arr = Array()
	for i,v in ipairs(self.msg.act_detail.wedding_rank_detail) do
		arr:add({rank = i, finish_time = v.finish_time_map[1].obj_value,
			left_name = v.one_name, reght_name = v.two_name});
	end
	arr:sort("finish_time", false);

	for i = 1, arr:getSize() do
		arr[i].rank = i;
	end
	return arr
end

-- 一生一世
function Lua_OpenDressCarnivalData.Get:getAllOneIsLlifeLeftData()
	local list;
	local arr = Array()
	for i,v in ipairs(self.msg.act_detail.event_times.obj_list) do
		list = {}
		list.task_id = v.sub; -- 任务id
		list.title_name = v.name; -- 描述
		list.left_count_num = v.value; -- 当前完成进度
		for k,j in ipairs(v.sub_map.obj_list) do
			if j.obj_id == 0 then
				list.right_max_num = j.obj_value;
			end
		end

		arr:add(list);
	end
	return arr
end

-- 集字，累充，帮派争霸，开宗立派，一生一世 (右)，能录有礼
function Lua_OpenDressCarnivalData.Get:getOpenCommonData()
	local list;
	local arr = Array();
	local times = 86400; -- 24小时时间戳
	for i,v in ipairs(self.msg.act_detail.reward_info) do
		list = {}
		list.title_name = v.content; -- 描述
		list.isReward = v.draw_flag; -- 0未领取，1已领取，2表示条件不足
		list.reward_index = v.index; -- 奖励索引
		list.sub_number = v.sub_value;
		list.isPast = i <= self.msg.act_detail.cur_index; -- 登陆有礼是否过期
		list.sub_value = self.msg.act_detail.sub_value; -- 累充值
		list.first_type = self.first_type;
		list.cond = v.cond; -- 条件(大多为奖励的领取条件）
		list.reward_set = v.reward_set;
		list.arrive = v.arrive;
		list.open_tiem = TimeTransform.getInstance():transSeconds8((self.start_tick - times) + i * times, LanUtil.getValue(43)); -- 登录有礼时间
		list.spec_effect_item = v.spec_effect_item; -- 需要显示特效的道具id集合
		arr:add(list);
	end
	return arr;
end

function Lua_OpenDressCarnivalData.Get:getOpenExchangeData()--兑换
	local arr = Array()
	for i,v in ipairs(self.msg.act_detail.reward_info) do
		local list = {}
		list.isReward = v.draw_flag; -- 0未领取，1已领取，2表示条件不足
		list.reward_index = v.index; -- 奖励索引
		list.first_type = self.first_type;
		list.cond = v.cond; -- 条件(大多为奖励的领取条件）
		list.reward_set = v.reward_set;
		list.id = v.reward_set[1].id;
		list.amount = v.reward_set[1].amount;
		list.bind = v.reward_set[1].bind;
		list.name =  getConfig({ "item", v.reward_set[1].id, "name"});

		list.small_id = v.cond[1];
		list.cuont_num = v.cond[2];
		list.Exchange_num = tonumber(v.arrive) - tonumber(v.drawed);
		list.need_item_num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(tonumber(v.cond[1]));
		list.isShowEffect = tonumber(v.reward_set[1].id) == tonumber(v.spec_effect_item[1]);
		arr:add(list);
	end
   	return arr;
end

-- 获得称号战力
function Lua_OpenDressCarnivalData:getTitleForce(id)
	local config = getConfig({"label", id});
	local str = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
		if config[v] ~= nil and config[v] ~= 0 then
			str[v] = config[v]
		end
	end
	return Lua_FightUtil.caculateConfigForce(str);
end

-- 一生一世配置
function Lua_OpenDressCarnivalData.Get:getOpenDressInfo()
	if self.info == nil then
		self.info = {};

		local config = getConfig({"allOneIsLlife"});
		for i,v in pairs(config) do
			self.info[i]= v;
		end
	end
	return self.info;
end

function Lua_OpenDressCarnivalData:getOpenDressDate(id)
	return self.getOpenDressInfo[id];
end

function Lua_OpenDressCarnivalData.Get:getDoubleNnemeInfo()
	local name;
	local str;
	for i,v in ipairs(self.sets_list) do
		name = getConfig({"doubleActivity", tonumber(v.obj_id), "remark"});
		if str == nil then
			str = name;
		else
			str = str..","..name;
		end
	end
	return str
end

-- 是否开启双倍经验
function Lua_OpenDressCarnivalData.Get:isOpenDoubleExp()
	for i,v in ipairs(self.sets_list) do
		if tonumber(v.obj_id) == 1 then
			return true;
		end
	end
	return false
end

-- 获取双倍副本
function Lua_OpenDressCarnivalData:getCopyDoubleExp(list)
	if list == nil then
		return;
	end

	local num;
	self.copyDouble = {};
	for i,v in ipairs(list) do
		num = getConfig({"doubleActivity", tonumber(v), "num"});
		self.copyDouble[num] = 1;
	end
end

-- 获取双倍副本状态
function Lua_OpenDressCarnivalData:isOpenCopyDoubleExp(num)
	if self.copyDouble ~= nil then
		if self.copyDouble[num] == 1 then
			return true;
		end
	end
	return false;
end

-- 是否开启双倍经验
function Lua_OpenDressCarnivalData:isOpenDouble(list)
	for i,v in ipairs(list) do
		if tonumber(v) == 1 then
			return true;
		end
	end
	return false
end

-- 移除双倍副本
function Lua_OpenDressCarnivalData:removeDoubleExp()
	if self.copyDouble == nil then
		return;
	end

	for i,v in pairs(self.copyDouble) do
		self.copyDouble[i] = nil;
	end
end

-- 获取双倍副本(节日狂欢)
function Lua_OpenDressCarnivalData:addDoubleCopy(list)
	if list == nil then
		return;
	end

	local num;
	self.doubleCopyList = {};
	for i,v in ipairs(list) do
		num = getConfig({"doubleActivity", tonumber(v), "num"});
		self.doubleCopyList[num] = 1;
	end
end

-- 获取双倍副本状态(节日狂欢)
function Lua_OpenDressCarnivalData:isOpenCopyDouble(num)
	if self.doubleCopyList ~= nil then
		if self.doubleCopyList[num] == 1 then
			return true;
		end
	end
	return false;
end

-- 移除双倍副本
function Lua_OpenDressCarnivalData:removeCopyDoubleExp()
	if self.doubleCopyList == nil then
		return;
	end

	for i,v in pairs(self.doubleCopyList) do
		self.doubleCopyList[i] = nil;
	end
end