checkRequire("Lua_ActivitiesInfo");
Lua_OperationalActivitiesData = class("Lua_OperationalActivitiesData")
Lua_OperationalActivitiesData.ACT_RANK = 1004; -- 开服冲榜活动
Lua_OperationalActivitiesData.MYSTERIOUS_FIRST = 1030; -- 神秘限购
Lua_OperationalActivitiesData.ACT_RECHARGE = 1002; -- 累充
Lua_OperationalActivitiesData.ACT_CHARCATER = 1013; -- 集字
Lua_OperationalActivitiesData.ACT_FACTION = 1026; -- 帮派争霸
Lua_OperationalActivitiesData.ACT_TREASURE = 1023; -- 藏宝之地
Lua_OperationalActivitiesData.ACT_DOUBLE = 1034;  -- 双倍
Lua_OperationalActivitiesData.ACT_BOSS = 1035; -- boos
Lua_OperationalActivitiesData.ACT_EXCHANGE = 1036; -- 兑换

-- 庆典欢活动列表图标
Lua_OperationalActivitiesData.GrandCeremonyIcon = {10087, 10088, 10089, 10090, 10091, 10092, 10093, 10094, 10104};
-- 庆典 + 开服 活动id列表，用于 是否是 庆典或者开服活动标记
Lua_OperationalActivitiesData.GrandCeremonyList = {1034, 1035, 1033, 1036, 1037, 1027, 1024, 1002, 1013, 1025, 1026};
-- 节日狂欢活动列表图标
-- Lua_OperationalActivitiesData.FestivalCarnivalIcon = {10087, 10088, 10089, 10090, 10091, 10092, 10093, 10094, 10104};
-- 合服欢活动列表
Lua_OperationalActivitiesData.SuitList = {1026, 1019, 1002, 1037, 1028, 1013};

Lua_OperationalActivitiesData.CONSUMPTION_DAY = 1040; -- 每日消费
Lua_OperationalActivitiesData.CONSUMPTION_TOTAL = 1041; -- 累计消费
Lua_OperationalActivitiesData.GIFTS = 1042; -- 0元礼包

Lua_OperationalActivitiesData.ACT_BOSS_FIRSTKILL = 1055; -- BOSS首杀
Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE = 1056; -- 全民BOSS
Lua_OperationalActivitiesData.ACT_CUMULATIVE_CONSUMPTION = 1061; -- 累计消费
Lua_OperationalActivitiesData.ACT_NEW_ZERO_GIFT = 1064; -- 新0元礼包

Lua_OperationalActivitiesData.BIND_COPPER_GIFT = 1063; -- 绑元放送
Lua_OperationalActivitiesData.CYL_RECHARGE = 1057; -- 循环充值
Lua_OperationalActivitiesData.ACT_CONSUME = 1058; -- 循环消费
Lua_OperationalActivitiesData.ACT_CHARM = 1054; -- 魅力之王
Lua_OperationalActivitiesData.ACT_PEAK_AUCTION = 1067; -- 巅峰竞拍
Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT = 1068; -- 喜结良缘
Lua_OperationalActivitiesData.ACT_YUANBAO = 1069; -- 元宝大翻倍
Lua_OperationalActivitiesData.BENEFIT = 1088; -- 进阶特惠 -- 1083
Lua_OperationalActivitiesData.GROUPBUY = 1089; -- 跨服团购
Lua_OperationalActivitiesData.CRAZY_EGGS = 1071; -- 疯狂砸蛋
Lua_OperationalActivitiesData.GOD_FURNACE = 1072; -- 神炉炼宝
Lua_OperationalActivitiesData.CONSUMETREASURE  = 1074;--消费寻宝
Lua_OperationalActivitiesData.DISCOUNTSTORE  = 1075;--折扣商店
Lua_OperationalActivitiesData.SUPER_EXCHANGE = 1079 -- 超值兑换
Lua_OperationalActivitiesData.SUPER_RETURN = 1080 -- 超值返还
Lua_OperationalActivitiesData.RECHARGE_ENJOY_DRAW = 1081 -- 充值抽抽乐
Lua_OperationalActivitiesData.LUCKY_SIGN = 1078 --好运灵签
function Lua_OperationalActivitiesData:ctor()
	self.activitiesInfo = {};
	self.notify_list = Array();
	self.openDayList = {};
	self.dataList = Array();
	self.preDisplay = {}
	self.nationalFestivalList = Array();
	self.exActList = {};
    self.openDiscount = false;
end

function Lua_OperationalActivitiesData:dispose()
	self.bBindCopperGiftLogin = nil;
end

function Lua_OperationalActivitiesData:clearOpenActive()
	self.activitiesInfo = {};
	self.notify_list = Array();
	self.openDayList = {};
	self.dataList = Array();
	self.preDisplay = {}
	self.nationalFestivalList = Array();
	self.exActList = {};
	self.isShowRed = nil;
	self.isShowLondingRed = nil;
    self.openDiscount = false;
end

function Lua_OperationalActivitiesData:getActivitiesByType(firstType, secondType)
	if self.activitiesInfo == nil then
		return nil;
	end

	for k, v in pairs(self.activitiesInfo) do
		if v ~= nil then
			local len = v:getSize();
			for i = 1, len do
				if v[i].first_type == firstType and(secondType == nil or secondType == v[i].second_type) then
					return v[i];
				end
			end
		end
	end
	return nil;
end

function Lua_OperationalActivitiesData:getActivitiesByActindex(actIndex)
	if self.activitiesInfo == nil then
		return nil;
	end

	for k, v in pairs(self.activitiesInfo) do
		if v ~= nil then
			local len = v:getSize();
			for i = 1, len do
				if v[i].act_index == actIndex then
					return v[i];
				end
			end
		end
	end
	return nil;
end

function Lua_OperationalActivitiesData:getActivitiesInfo(priority, getType)
	-- priority：1, 表示开服活动，getType：不填或0表示全部, 1 表示单独图标, 2 表示不是单独图标
	if self.activitiesInfo == nil then
		return nil;
	end

	if self.activitiesInfo[priority] == nil then
		return nil;
	end

	if getType == nil or getType == 0 then
		return self.activitiesInfo[priority];
	else
		local arr = Array();
		local actList = self.activitiesInfo[priority];
		local len = actList:getSize();
		for i = 1, len do
			if getType == 1 and actList[i].is_single_icon == 1 then
				arr:add(actList[i]);
			end

			if getType == 2 and actList[i].is_single_icon == 0 then
				arr:add(actList[i]);
				end
			end
		return arr;
	end
	return self.activitiesInfo;
end

function Lua_OperationalActivitiesData:getOpenDayList(priority)
	if self.openDayList == nil then
		return nil;
	end
	if self.openDayList[priority] == nil then
		return nil;
	end
	return self.openDayList[priority];
end

function Lua_OperationalActivitiesData:getOpenSpecialofferData()
	if self.act_detail == nil then
		return nil;
	end

	local obj;
	local moneyType;
	local moneyCount;
	local data;
	local actdetail = Array();
	for i = 1, #self.act_detail.reward_info do
		obj = self.act_detail.reward_info[i];
		if tonumber(tostring(obj.cond[3])) > 0 then
			moneyType = 209000003;
			moneyCount = tonumber(tostring(obj.cond[3]));
		end
		if tonumber(tostring(obj.cond[4])) > 0 then
			moneyType = 209000002;
			moneyCount = tonumber(tostring(obj.cond[4]));
		end
		if tonumber(tostring(obj.cond[5])) > 0 then
			moneyType = 209000001;
			moneyCount = tonumber(tostring(obj.cond[5]));
		end
		self:attriButes(obj.reward_set[1].id);
		self:getmodelFile(obj.reward_set[1].id);

		data = {};
		data.id = obj.reward_set[1].id;
		data.index = obj.index;
		data.name = self.name;
		data.subType = Lua_ToolVo.getSubType(obj.reward_set[1].id);
		data.part = self.part;
		data.force = self.force;

		data.cond = obj.cond;
		data.allRestricted = tonumber(tostring(obj.cond[1]));
		data.moneyType = moneyType;
		data.money = moneyCount;
		data.sub_value = obj.sub_value;

		data.setAction = self.setAction;
		data.temaiShowModelID = self.temaiShowModelID;
		data.floder = self.floder;
		data.modelFile = self.modelFile;
		data.model = self.model;
		data.mounter_pos = self.mounter_pos;
		data.mounter_rot = self.mounter_rot;
		data.mounter_sca = self.mounter_sca;
		data.offset_pos = self.offset_pos;
		data.setmodelAngle = self.setmodelAngle;

		actdetail:add(data);
	end
	return actdetail;
end

function Lua_OperationalActivitiesData:attriButes(id)
	self.attributes = nil;
	local confing = getConfig({"item", id});
	self.name = confing.name;

	if getConfig({"fashion", id, "attributes"}) ~= nil then
		self.attributes = getConfig({"fashion", id, "attributes"});
	end

	local servant = getConfig({"servant", "illusion", "illusion_shape"});
	for k, v in pairs(servant) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
		end
	end

	local servant_weapon = getConfig({"servant_weapon", "illusion", "illusion_shape"});
	for k, v in pairs(servant_weapon) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = {20, 0, 0};
		end
	end

	local servant_wing = getConfig({"servant_wing", "illusion", "illusion_shape"});
	for k, v in pairs(servant_wing) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = {20, 0, 0};
		end
	end

	local servant_mount = getConfig({"servant_mount", "illusion", "illusion_shape"});
	for k, v in pairs(servant_mount) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = {20, 0, 0};
		end
	end

	local spoor = getConfig({"spoor", "illusion", "illusion_shape"});
	for k, v in pairs(spoor) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
		end
	end

	local magicweapon = getConfig({"magicweapon", "illusion", "illusion_shape"});
	for k, v in pairs(magicweapon) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = { 306, -510, 0 };
		end
	end

	local fairy_act = getConfig({"fairy_act", "illusion", "illusion_shape"});
	for k, v in pairs(fairy_act) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = {25, -93, 166};
		end
	end

	local mount = getConfig({"mount", "illusion", "illusion_shape"});
	for k, v in pairs(mount) do
		if v.name == self.name then
			self.attributes = v.property;
			self.id = v.id;
			self.setmodelAngle = {25, -40, 0};
		end
	end

	if self.attributes == nil then
		local limitWingConfig = getConfig({"wing", "time_limit_wing", str});
		if limitWingConfig ~= nil then
			self.attributes = getConfig({"item", id, "attribute"});
			self.id = Lua_WingUtil.getWingModelConfig(id);
			local str = {};
			for k, v in pairs(self.attributes) do
				str[k] = v;
			end
			self.force = Lua_FightUtil.caculateConfigForce(str);
		end
	else
		local str = {};
		for k, v in pairs(self.attributes) do
			str[k] = v[1];
		end
		self.force = Lua_FightUtil.caculateConfigForce(str);
	end
end

function Lua_OperationalActivitiesData:getmodelFile(id)
	local confing = getConfig({"item", id});
	if confing ~= nil then
		self.name = confing.name;
		if confing.temaiShowModel ~= nil then
			self.temaiShowModelID = confing.temaiShowModel;
		else
			self.temaiShowModelID = nil;
		end
		self.part = confing.part;

		if confing.modelFile ~= nil then
			self.modelFile = confing.modelFile;
			self.model = confing.model;
			self.mounter_pos = confing.mounter_pos;
			self.mounter_rot = confing.mounter_rot;
			self.mounter_sca = confing.mounter_sca;
			if confing.img_sca == nil then
				self.img_sca = {1, 1, 1};
			else
				self.img_sca = confing.img_sca;
			end
			self.setAction = 3;
			self.floder = "/model";
		else
			local shapeConfig = getConfig({"playerHanger", tonumber(self.id)});
			self.floder = shapeConfig.floder;
			self.modelFile = shapeConfig.fileName;
			self.model = shapeConfig.modelName;
			if shapeConfig.temaiShowModel ~= nil then
				self.temaiShowModelID = shapeConfig.temaiShowModel;
			else
				self.temaiShowModelID = nil;
			end

			if shapeConfig.selectShow ~= nil then
				self.modelFile = shapeConfig.selectShow;
				self.model = shapeConfig.selectShow;
			end

			if shapeConfig.setAction ~= nil then
				self.setAction = shapeConfig.setAction;
			else
				self.setAction = 3;
			end
			self.mounter_pos = shapeConfig.Fmounter_pos;
			self.mounter_rot = shapeConfig.Fmounter_rot;
			self.mounter_sca = shapeConfig.Fmounter_sca;
			self.offset_pos = shapeConfig.offset_pos;
		end
	end
end









-- 打开运营活动
function Lua_OperationalActivitiesData:sGetOperationalActivities(act_index, first_type)
	local cmd = ProtoPublic_pb.Proto11400007();
	cmd.act_index = act_index; -- 活动id（索引）
	cmd.first_type = first_type; -- 活动类型
	sendMsg(11400007, cmd);
end

-- 领取精彩的奖励
function Lua_OperationalActivitiesData:receivedReward(data)
	local cmd = ProtoPublic_pb.Proto11400008();
	cmd.act_index = data.act_index; -- 活动id（索引）
	cmd.reward_index = data.reward_index; -- 奖励索引
	cmd.reward_num = data.reward_num; -- 领取奖励的数量
	sendMsg(11400008, cmd);
end

function Lua_OperationalActivitiesData:buyReward(act_index, reward_index, reward_num)
	local cmd = ProtoPublic_pb.Proto11400008();
	cmd.act_index = act_index;
	cmd.reward_index = reward_index;
	cmd.reward_num = reward_num;
	sendMsg(11400008, cmd);
end

-- 获取精彩（运营）活动面板信息
function Lua_OperationalActivitiesData:sGetActivitiesInfo()
	local cmd = ProtoPublic_pb.Proto11400009();
	cmd.priority = 1; -- 活动（开服活动）优先级或类型
	sendMsg(11400009, cmd);
end










-- 获取配置数组
function Lua_OperationalActivitiesData:getDataList()
	if self.dataList:getSize() == 0 then
		local confing = getConfig({"operational_activities_win"});
		for k, v in ipairs(confing) do
			self.dataList:add({first_type = tonumber(v.first_type), second_type = tonumber(v.second_type),
			open_list = v.open_list, btn_text = tonumber(v.btn_text)});
		end
	end

	if self.dataList == nil then
		return nil;
	end
	return self.dataList;
end

-- 获取全民盛典单个数据
function Lua_OperationalActivitiesData:getNationalFestivalData(firstType)
	if self.nationalFestivalList == nil then
		return;
	end
	for i = 1, self.nationalFestivalList:getSize() do
		if self.nationalFestivalList[i].first_type == firstType then
			return self.nationalFestivalList[i];
		end
	end
end










-- 全民盛典信息返回
function Lua_OperationalActivitiesData:init51400021(msg)
	self.nationalFestivalList = Array();
	for k, v in pairs(msg.act_item_list) do
		if v.first_type ~= nil then
			self.nationalFestivalList:add(v);
		end
	end
	self.cur_hai_point = msg.cur_hai_point;
	self.cur_cost_gold = msg.cur_cost_gold;
	self.cost_type = msg.cost_type;
end

function Lua_OperationalActivitiesData:init51400007(msg)
	self.act_detail = msg.act_detail;
end

function Lua_OperationalActivitiesData:init51400009(msg)
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	if msg.act_list == nil then
		return;
	end
	self.act_list = msg.act_list;

	local showingIndex = {};
	if self.activitiesInfo ~= nil and self.activitiesInfo[msg.priority] ~= nil then
		local num;
		for i = 1, self.activitiesInfo[msg.priority]:getSize() do
			num = self.activitiesInfo[msg.priority][i].keyValue;
			showingIndex[num] = self.activitiesInfo[msg.priority][i];
		end
	end

	local actInfo;
	local showRightTopIds = {};
	local newIconList = Array();
	self.activitiesInfo[msg.priority] = Array();
	for k, v in ipairs(msg.act_list) do
		actInfo = Lua_ActivitiesInfo.new();
		actInfo:fromServer(v);
		if actInfo.first_type ~= Lua_OperationalActivitiesData.ACT_RANK then
			self.activitiesInfo[msg.priority]:add(actInfo); -- 移除开服排行
		end

		if actInfo.is_single_icon ~= 0 then
			local num = actInfo.keyValue;
			local iconId = actInfo:getRighTopIconId();
			if iconId ~= nil then
				showRightTopIds[iconId] = 1;
			end

			if showingIndex[num] == nil then
				newIconList:add(actInfo);
			else
				showingIndex[num] = nil;
			end
		end
	end

	local num;
	local iconId;
	for k,v in pairs(self.exActList) do
		num = v.keyValue;
		iconId = v:getRighTopIconId();
		if iconId ~= nil then
			showRightTopIds[iconId] = 1;
		end

		if showingIndex[num] == nil then
			newIconList:add(v);
		else
			showingIndex[num] = nil;
		end
		self.activitiesInfo[v.priority]:add(v);
	end
	self.activitiesInfo[msg.priority]:sort("sort", true);

	for i = 1, newIconList:getSize() do
		iconId = newIconList[i]:getRighTopIconId();
		if iconId ~= nil then
			Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", iconId);
		end

		num = newIconList[i]:getPreNum();
		if newIconList[i].times ~= nil and newIconList[i].start_tick ~= nil and num ~= nil and
			newIconList[i].times - newIconList[i].start_tick < 0 and num == 1 then
			local atimeStr = LanUtil.formateStr(LanUtil.getValue(110026), TimeTransform.getInstance():transSeconds8(newIconList[i].start_tick, "HH:mm"));
			Lua_MsgUtil.callFunc("UPDATE_RTICON_SHOWTIME", { iconId = iconId, showTime = atimeStr, showStr = true });
			self.preDisplay[tonumber(iconId)] = 1;
		end
	end

	for k, v in pairs(showingIndex) do
		iconId = v:getRighTopIconId();
		if showRightTopIds[iconId] == nil then
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", iconId);
		end
	end

	self.openDayList[msg.priority] = Array();
	for k, v in ipairs(msg.show_vec) do
		self.openDayList[msg.priority]:add({first_type = v.first_type, second_type = v.second_type,
		open_day = v.sub, show_flag = v.value});
	end

	if msg.priority == 1 then
		local arr = self:getActivitiesInfo(1, 2);
		if arr:getSize() == 0 and self.openDayList[msg.priority]:getSize() == 0 then
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10012);
		else
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10012);--移除开服活动图标
		end
	end

	local avo = self:getActivitiesByType(Lua_OperationalActivitiesData.MYSTERIOUS_FIRST, nil);
	if avo ~= nil then
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {act_index = avo.act_index, type = Lua_MenuTipData.MYSTERIOUS_ICON, state = 1, kuafuHide = 1,
		altas = "icon_atlas_5", spriteName = "activity_small_tips_smxg"});
	else
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.MYSTERIOUS_ICON, state = 0});
	end

	if self.msg80400108 ~= nil then
		if getTime() - self.setTime80400108 > 1 then
			self.msg80400108 = nil;
		else
			self:init80400108(self.msg80400108);
		end
	end
end

function Lua_OperationalActivitiesData:getActivitiesByIcon(iconId)
	local arr = Array();
	if self.openDayList == nil then
		return arr;
	end

	for k,v in pairs(self.activitiesInfo) do
		for i = 1, v:getSize() do
			if v[i]:getRighTopIconId() == iconId then
				arr:add(v[i]);
			end
		end
	end
	return arr;
end

function Lua_OperationalActivitiesData:init80400100(msg)
end

function Lua_OperationalActivitiesData:init80400180(msg)
	-- if DataCenter.OperationalActivitiesData.appearance == nil then
	-- 	Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON",10045);
	-- else
	-- 	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON",10045);
	-- end

	-- if DataCenter.OperationalActivitiesData.cooloutfit == nil then
	-- 	Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON",10046);
	-- else
	-- 	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON",10046);
	-- end
end

function Lua_OperationalActivitiesData:init80400108(msg)
	self.msg80400108 = msg;
	self.setTime80400108 = getTime();
	self.notify_list = Array();
	for k, v in ipairs(msg.notify_list) do
		if v.priority == 1 then
			self.notify_list:add(v.act_index);
		end
	end

	local openAtionalRedDot = false;
	local nationalRedDot = false;
	local openDressRedDot = false;
	local dailyConsumptionRedDot = false;
	local giftsRedDot = false;
	local openCeremonyRedDot = false; -- 庆典
	local openSuitRedDot = false;
	local treasureActDot = false;
	-- local openFestivalRedDot = false; -- 节日狂欢
	if self.notify_list:getSize() > 0 then
		local len1 = #self.notify_list[1];
		local arr = self:getActivitiesInfo(1, 2);
		local len2;
		if arr ~= nil then
			len2 = arr:getSize();
		end

		local len3 = self.nationalFestivalList:getSize()
		if len1 ~= nil and len2 ~= nil then
			for i = 1, len1 do
				for j = 1, len2 do
					if self.notify_list[1][i] == arr[j].act_index then
						openAtionalRedDot = true;
					end
				end
			end
		end

		if len1 ~= nil and len3 ~= nil then
			for i = 1, len1 do
				for j = 1, len3 do
					-- 全名庆典特殊处理（其中三个活动移到庆典活动，这里屏蔽那三个活动数据）
					if self.nationalFestivalList[j].act_index == 1018  then
						if self.notify_list[1][i] == self.nationalFestivalList[j].act_index then
							nationalRedDot = true;
							-- Lua_MsgUtil.callFunc("UPDATE_NATIONA_FESTIVAL_REDDOT");
						end
					end
				end
			end
		end

		-- 开服狂欢红点判断
		local list = self.getOpenDressActIndexList;
		if len1 ~= nil and list ~= nil then
			for i = 1, len1 do
				for k,v in pairs(list) do
					if self.notify_list[1][i] == v then
						openDressRedDot = true;
					end
				end
			end
		end

        -- 庆典红点判断
        local list = self.getOpenGrandCeremonyList;
        if len1 ~= nil and list ~= nil then
            for i = 1, len1 do
                for k,v in pairs(list) do
                    if self.notify_list[1][i] == v then
                        openCeremonyRedDot = true;
                    end
                end
            end
        end

		-- 节日狂欢红点判断
		-- local list = self.getFestivalCarnivalList;
		-- if len1 ~= nil and list ~= nil then
		-- 	for i = 1, len1 do
		-- 		for k,v in pairs(list) do
		-- 			if self.notify_list[1][i] == v then
		-- 				openFestivalRedDot = true;
		-- 			end
		-- 		end
		-- 	end
		-- end

		-- 合服红点
		local actList = self:getActivitiesByIcon(10102);
		local len = actList:getSize();
		for i = 1, len1 do
			for j = 1, len do
				local vo = actList[j];
				if vo.act_index == self.notify_list[1][i] then
					openSuitRedDot = true;
				end
			end
		end
	end

	local dailyAVO = self:getActivitiesByType(Lua_OperationalActivitiesData.CONSUMPTION_DAY, nil);
	local dailyAVO2 = self:getActivitiesByType(Lua_OperationalActivitiesData.CONSUMPTION_TOTAL, nil);
	if self.notify_list[1] ~= nil and dailyAVO ~= nil and dailyAVO2 ~= nil then
		for i = 1, #self.notify_list[1] do
			if self.notify_list[1][i] == dailyAVO.act_index or self.notify_list[1][i] == dailyAVO2.act_index then
				dailyConsumptionRedDot = true;
			end
		end
	end

	-- 0元礼包
	local giftsAvo = self:getActivitiesByType(Lua_OperationalActivitiesData.GIFTS, nil);
	if self.notify_list[1] ~= nil and giftsAvo ~= nil  then
		for i = 1, #self.notify_list[1] do
			if self.notify_list[1][i] == giftsAvo.act_index then
				giftsRedDot = true;
			end
		end
	end

	-- 藏宝之地
	local treasureActAvo = self:getActivitiesByType(Lua_OperationalActivitiesData.ACT_TREASURE, nil);
	if self.notify_list[1] ~= nil and treasureActAvo ~= nil  then
		for i = 1, #self.notify_list[1] do
			if self.notify_list[1][i] == treasureActAvo.act_index then
				treasureActDot = true;
			end
		end
	end

	-- 开服狂欢登陆红点
	if self.isShowRed == nil and DataCenter.funcOpenData:isOpened(10125) == true then
		local redList = {["1027"] = 21001, ["1024"] = 21002, ["1025"] = 0, ["1026"] = 0, ["1002"] = 21005, ["1013"] = 21006};
		local openList = self:getActivitiesByIcon(10079);
		for i = 1, openList:getSize() do
			local vo = openList[i];
			if vo ~= nil and redList[tostring(vo.first_type)] ~= 0 then
				DataCenter.redDotData:updateRedDotVoState(tonumber(redList[tostring(vo.first_type)]), true);
			end
		end
		self.isShowRed = false;
	end

	self:dressCheckRedDotSate();
	self:ceremonyCheckRedDotSate();
	-- 通过右上角图标ID添加红点，运营活动
	DataCenter.redDotData:updateRedDotVoState(22006, giftsRedDot); -- 0元礼包
	DataCenter.redDotData:updateRedDotVoState(22012, openCeremonyRedDot); -- 庆典活动
	DataCenter.redDotData:updateRedDotVoState(22013, openAtionalRedDot); -- 开服活动
	DataCenter.redDotData:updateRedDotVoState(22014, nationalRedDot); -- 全民庆典
	DataCenter.redDotData:updateRedDotVoState(22015, openDressRedDot); -- 开服狂欢
	DataCenter.redDotData:updateRedDotVoState(22016, dailyConsumptionRedDot); -- 每日消费
	DataCenter.redDotData:updateRedDotVoState(22020, openSuitRedDot); -- 合服
	DataCenter.redDotData:updateRedDotVoState(11210, treasureActDot); -- 藏宝之地
	--DataCenter.redDotData:updateRedDotVoState(22030, openFestivalRedDot); -- 节日狂欢
	Lua_MsgUtil.callFunc("REFRESH_RIGHTTOP_ICONSREDDOT", -1);
end

-- 获取开服活动索引
function Lua_OperationalActivitiesData.Get:getOpenDressActIndexList()
	local openList = self:getActivitiesByIcon(10079);
	local vo;
	local list = {};
	for i = 1, openList:getSize() do
		vo = openList[i];
		list[vo.first_type] = vo.act_index;
	end
	return list;
end

-- 获取节日狂欢索引
function Lua_OperationalActivitiesData.Get:getFestivalCarnivalList()
	local list = {};
	for i,v in ipairs(Lua_OperationalActivitiesData.FestivalCarnivalIcon) do
		local rt = DataCenter.allRtData.topRightIconDic[v];
		if rt ~= nil and rt.canShow ~= false then
			local gList = self:getActivitiesByIcon(v);
			for j = 1, gList:getSize() do
				list[gList[j].first_type] = gList[j].act_index;
			end
		end
	end
	return list;
end

-- 获取庆典活动索引
function Lua_OperationalActivitiesData.Get:getOpenGrandCeremonyList()
	local list = {};
	for i,v in ipairs(Lua_OperationalActivitiesData.GrandCeremonyIcon) do
		local rt = DataCenter.allRtData.topRightIconDic[v];
		if rt ~= nil and rt.canShow ~= false then
			local gList = self:getActivitiesByIcon(v);
			for j = 1, gList:getSize() do
				list[gList[j].first_type] = gList[j].act_index;
			end
		end
	end
	return list;
end

-- 获取合服活动索引
function Lua_OperationalActivitiesData.Get:getOpenSuitList()
	local vo;
	local list = {};
	for k,v in ipairs(Lua_OperationalActivitiesData.SuitList) do
		vo = self:getActivitiesByType(v,0)
		if vo ~= nil then
			list[v] = vo.act_index;
		end
	end
	return list;
end

-- 开服活动变强
function Lua_OperationalActivitiesData:dressCheckRedDotSate()
	local isShowLvelRed = false;
	local isShowLifeRed = false;
	local isShowFoundFaction = false;
	local isShowFactionFight = false;
	local isShowAccumulateCharge = false;
	if self.notify_list:getSize() > 0 then
		local list = self.getOpenDressActIndexList;
		local len = #self.notify_list[1];
		if self.notify_list:getSize() > 0 then
			if len ~= nil and list ~= nil then
				for i = 1, len do
					if self.notify_list[1][i] == list[1027] then
						isShowLvelRed = true;
					elseif self.notify_list[1][i] == list[1024] then
						isShowLifeRed = true;
					elseif self.notify_list[1][i] == list[1025] then
						isShowFoundFaction = true;
					elseif self.notify_list[1][i] == list[1026] then
						isShowFactionFight = true;
					elseif self.notify_list[1][i] == list[1002] then
						isShowAccumulateCharge = true;
					end
				end
			end
		end
	end

	self:setRedDotInfo(22001, isShowLvelRed);
	self:setRedDotInfo(22002, isShowLifeRed);
	self:setRedDotInfo(22003, isShowFoundFaction);
	self:setRedDotInfo(22004, isShowFactionFight);
	self:setRedDotInfo(22005, isShowAccumulateCharge);
end

function Lua_OperationalActivitiesData:setRedDotInfo(redDotId, state, val)
	local value = state and 1 or 0;
	value = val == nil and value or val;
	DataCenter.redDotData:updateRedDotVoState(redDotId, state);
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = redDotId, val = value, bShow = state});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", state); -- 变强事件
end

-- 盛典活动变强
function Lua_OperationalActivitiesData:ceremonyCheckRedDotSate()
	local isShowRechangeRed = false;
	local isShowExchangeRed = false;
	local isShowLondingRed = false;
	local isShowRechargeRitualRed = false;
	local isShowHelloEveryoneRed = false;
	if self.notify_list:getSize() > 0 then
		local list = self.getOpenGrandCeremonyList;
		local len = #self.notify_list[1];
		if self.notify_list:getSize() > 0 then
			if len ~= nil and list ~= nil then
				for i = 1, len do
					if self.notify_list[1][i] == list[1033] then
						isShowRechangeRed = true;
					elseif self.notify_list[1][i] == list[1036] then
						isShowExchangeRed = true;
					elseif self.notify_list[1][i] == list[1037] then
						isShowLondingRed = true;
					elseif self.notify_list[1][i] == list[1017] then
						isShowRechargeRitualRed = true;
					elseif self.notify_list[1][i] == list[1019] then
						isShowHelloEveryoneRed = true;
					end
				end
			end
		end
	end

	self:setRedDotInfo(22007, isShowRechangeRed);
	self:setRedDotInfo(22008, isShowExchangeRed);
	self:setRedDotInfo(22009, isShowLondingRed);
	self:setRedDotInfo(22010, isShowRechargeRitualRed);
	self:setRedDotInfo(22011, isShowHelloEveryoneRed);
	if self.isShowLondingRed == nil then
		self:setRedDotInfo(21007, true);
		self.isShowLondingRed = false;
	end
end

function Lua_OperationalActivitiesData:openCorrespondingWindow(id, str)
	return getConfig({"hiPoint", id, str});
end

function Lua_OperationalActivitiesData:getActTypeByWindowName(winName)
	if self.winToActType == nil then
		self.winToActType = {};
		local ycon = getConfig({"yunying_righttop"});
		for k,v in pairs(ycon) do
			local rt = v.second_type0;
			if rt ~= nil then
				local rtData = DataCenter.allRtData.topRightIconDic[tonumber(rt)];
				if rtData ~= nil and rtData.type == 1 and rtData.param ~= nil then
					local anum = tonumber(k);
					local f = math.floor(anum / 1000);
					local s = anum % 1000;
					self.winToActType[rtData.param] = {f=f,s=s};
				end
			end
		end
		self.winToActType["Lua_MysteriousBuyWindow"] = {f=Lua_OperationalActivitiesData.MYSTERIOUS_FIRST,s=0};
		self.winToActType["Lua_XinQianWindow"] = {f=1016,s=0};
	end
	return self.winToActType[winName];
end

function Lua_OperationalActivitiesData:addAct(info)
	local iconId = info:getRighTopIconId();
	if self.activitiesInfo[info.priority] == nil then
		return;
	end

	local list = self.activitiesInfo[info.priority];
	local isNew = true;
	for i = 1, list:getSize() do
		if list[i].first_type == info.first_type then
			list[i] = info;
			isNew = false;
			break;
		end
	end

	if isNew == true then
		list:add(info);
	end
	self.exActList[info.first_type] = info;
	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", iconId);
end

function Lua_OperationalActivitiesData:removeAct(val)
	local iconId = nil;
	if self.exActList[val] ~= nil then
		local info = self.exActList[val];
		iconId = info:getRighTopIconId();
		local list = self.activitiesInfo[info.priority];
		for i = 1, list:getSize() do
			if list[i].first_type == info.first_type then
				list:remove(i);
				break;
			end
		end

		local arr = self:getActivitiesByIcon(iconId);
		if arr:getSize() == 0 then
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", iconId);
		end
		self.exActList[val] = nil;
	end
end

-- 更新对应活动开启，客户端添加登录红点和变强事件(针对80105601新运营活动消息号)
function Lua_OperationalActivitiesData:updateActOpen(msg)
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	for i,v in ipairs(msg.act_states) do
		local isBeStrong = false;
		if v.state == 1 then
			if v.first_type == Lua_OperationalActivitiesData.BIND_COPPER_GIFT then
				if self.bBindCopperGiftLogin == nil or self.bBindCopperGiftLogin == false then
					self.bBindCopperGiftLogin = true;
					DataCenter.redDotData:updateRedDotVoState(22058, true);
				end
			end

			-- 新0元礼包
			if v.first_type == Lua_OperationalActivitiesData.ACT_NEW_ZERO_GIFT then
				if DataCenter.newZeroGiftData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22059, true);
					DataCenter.newZeroGiftData.isLogin = true;
				end
			end

			-- BOSS首杀
			if v.first_type == Lua_OperationalActivitiesData.ACT_BOSS_FIRSTKILL then
				if DataCenter.killBossActData.boss_kill == false then
					DataCenter.redDotData:updateRedDotVoState(21008, true);
					DataCenter.killBossActData.boss_kill = true;
				end
			end

			-- 全民BOSS
			if v.first_type == Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE then
				if DataCenter.killBossActData.boss_everyone == false then
					DataCenter.redDotData:updateRedDotVoState(21009, true);
					DataCenter.killBossActData.boss_everyone = true;
				end
			end

			-- 单笔充值
			if v.first_type == 1062 then
				isBeStrong = true;
				if DataCenter.OperationalActivitiesData.isSingCharging == nil then
					DataCenter.redDotData:updateRedDotVoState(22060, true); 
					DataCenter.OperationalActivitiesData.isSingCharging = false
				end
				DataCenter.OperationalActivitiesData.isSingCharging = v.has_reward == 1;

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(22060, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22060, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					-- DataCenter.redDotData:updateRedDotVoState(22060, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22060, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
			end

			-- 单笔充值(每日轮换)
			if v.first_type == 1090 then
                isBeStrong = true;
                if DataCenter.OperationalActivitiesData.isSingCharge == nil then
                    DataCenter.redDotData:updateRedDotVoState(22066, true); 
                    DataCenter.OperationalActivitiesData.isSingCharge = false
                end
                if v.has_reward == 1 then
                    DataCenter.redDotData:updateRedDotVoState(22066, true);
                    DataCenter.OperationalActivitiesData.isSingCharge = true;
                     Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22066, val = 1, bShow = true});
                     Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
                else
                    -- DataCenter.redDotData:updateRedDotVoState(22066, false);
                    DataCenter.OperationalActivitiesData.isSingCharge = false;
                    Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22066, val = 0, bShow = false});
                    Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
                end
                 Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
            end

			-- 累计消费
			if v.first_type == Lua_OperationalActivitiesData.ACT_CUMULATIVE_CONSUMPTION then
				if DataCenter.cumulativeConsumptionData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(21012, true);
					DataCenter.cumulativeConsumptionData.isLogin = true;
				end

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(22057, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22057, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(22057, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22057, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
			end

			-- 循环充值
			if v.first_type == Lua_OperationalActivitiesData.CYL_RECHARGE then
				if DataCenter.cyclicRechargeData.recharge_first == false then
					DataCenter.redDotData:updateRedDotVoState(21010, true);
					DataCenter.cyclicRechargeData.recharge_first = true;
				end

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(12220, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12220, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(12220, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12220, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
			end

			-- 循环消费
			if v.first_type == Lua_OperationalActivitiesData.ACT_CONSUME then
				if DataCenter.cyclicRechargeData.consume_first == false then
					DataCenter.redDotData:updateRedDotVoState(21011, true);
					DataCenter.cyclicRechargeData.consume_first = true;
				end

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(12221, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12221, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(12221, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12221, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
			end

			-- 魅力之王
			if v.first_type == Lua_OperationalActivitiesData.ACT_CHARM then
				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(12222, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12222, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(12222, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12222, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end   
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);            
			end

			-- 情侣充值
			if v.first_type == 1065 then 
				if DataCenter.OperationalActivitiesData.isLoveRecharge == nil then
					DataCenter.redDotData:updateRedDotVoState(22061, true);
				end
			end

			-- 巅峰竞拍
			if v.first_type == Lua_OperationalActivitiesData.ACT_PEAK_AUCTION then
				if DataCenter.peakAuctionData.peakAuctionLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22064, true);
					DataCenter.peakAuctionData.peakAuctionLogin = true;
				end
			end

			-- 喜结良缘
			if v.first_type == Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT then
				if DataCenter.tieTheKnotData.tieTheKnotLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22062, true);
					DataCenter.tieTheKnotData.tieTheKnotLogin = true;
				end

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(22063, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22063, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(22063, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22063, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
				Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
			end

			-- 元宝大翻倍
			if v.first_type == Lua_OperationalActivitiesData.ACT_YUANBAO and v.has_reward ~= 1 then
				if DataCenter.yuanBaoDoubleData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22065, true);
					DataCenter.yuanBaoDoubleData.isLogin = true;
				end
			end

			-- 进阶特惠
			if v.first_type == Lua_OperationalActivitiesData.BENEFIT then
				if DataCenter.jinJieBenefitData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22303, true);
					DataCenter.jinJieBenefitData.isLogin = true;
				end
			end

			-- 充值抽抽乐
			if v.first_type == Lua_OperationalActivitiesData.RECHARGE_ENJOY_DRAW then
				if DataCenter.rechargeEnjoyDrawData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22083, true);
					DataCenter.rechargeEnjoyDrawData.isLogin = true;
				end
				DataCenter.redDotData:updateRedDotVoState(22084, v.has_reward == 1);
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22084, val = v.has_reward == 1 and 1 or 0, bShow = v.has_reward == 1});
				Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", v.has_reward == 1);
			end

			-- 消费寻宝
			if v.first_type == Lua_OperationalActivitiesData.CONSUMETREASURE then
				if self.bConsumeTreasureLogin ~= true then
					self.bConsumeTreasureLogin = true;
					DataCenter.redDotData:updateRedDotVoState(22201, true);
				end
				DataCenter.redDotData:updateRedDotVoState(11246, v.has_reward == 1);
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11246, val = v.has_reward == 1 and 1 or 0, bShow = v.has_reward == 1});
				Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", v.has_reward == 1);
			end

			-- 折扣商店
			if v.first_type == Lua_OperationalActivitiesData.DISCOUNTSTORE then
				if self.openDiscount == false then
					DataCenter.redDotData:updateRedDotVoState(22076, true);
					self.openDiscount = true;
				end
			end

			-- 跨服团购
			if v.first_type == Lua_OperationalActivitiesData.GROUPBUY then
				if DataCenter.groupBuyData.isLogin == false then
					DataCenter.redDotData:updateRedDotVoState(22503, true);
					DataCenter.groupBuyData.isLogin = true;
				end

				if v.has_reward == 1 then
					DataCenter.redDotData:updateRedDotVoState(22501, true);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22501, val = 1, bShow = true});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				else
					DataCenter.redDotData:updateRedDotVoState(22501, false);
					Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22501, val = 0, bShow = false});
					Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
				end
			end
		else
			if isBeStrong ==  false then
				DataCenter.redDotData:updateRedDotVoState(22060, false); 
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22060, val = 0, bShow = false});

				DataCenter.redDotData:updateRedDotVoState(22066, false); 
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22066, val = 0, bShow = false});

				Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
			end
		end

		if v.first_type == Lua_OperationalActivitiesData.ACT_CHARM then
			DataCenter.charmKingData:checkActIsOpen(v);
		end
	end
end

-- 活动结束后，玩家未领取奖励，客户端移除变强
function Lua_OperationalActivitiesData:removeActBeStrong(val)
	-- 累计消费
	if val == Lua_OperationalActivitiesData.ACT_CUMULATIVE_CONSUMPTION then
		DataCenter.redDotData:updateRedDotVoState(22057, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22057, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end

	-- 循环充值
	if val == Lua_OperationalActivitiesData.CYL_RECHARGE then 
		DataCenter.redDotData:updateRedDotVoState(12220, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12220, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end

	-- 循环消费
	if val == Lua_OperationalActivitiesData.ACT_CONSUME then
		DataCenter.redDotData:updateRedDotVoState(12221, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12221, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end

	-- 魅力之王
	if val == Lua_OperationalActivitiesData.ACT_CHARM then
		DataCenter.redDotData:updateRedDotVoState(12222, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 12222, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end

	-- 喜结良缘
	if val == Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT then
		DataCenter.redDotData:updateRedDotVoState(22063, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22063, val = 0, bShow = false});
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
	end
end

function Lua_OperationalActivitiesData:updateBindCopperGiftInfo(msg)
	self.bindCopperGiftEndTime = 0;
	if msg ~= nil and msg.act_info ~= nil and msg.act_info.first_type == Lua_OperationalActivitiesData.BIND_COPPER_GIFT then
		self.bindCopperGiftEndTime = tonumber(msg.act_info.end_tick);
	end
end