Lua_RechargeEnjoyDrawData = class("Lua_RechargeEnjoyDrawData");
function Lua_RechargeEnjoyDrawData:ctor()
    self:superCall("ctor");
    self.isLogin = false;
    self.isBoxCreate = false;
    self.addTimes = 1;
    self.timeWholeList = {};
    self.boxIndex = nil;
end

function Lua_RechargeEnjoyDrawData:dispose()
	self.isLogin = false;
	self.isBoxCreate = false;
	self.addTimes = 1;
	self.timeWholeList = {};
	self.boxIndex = nil;
end

function Lua_RechargeEnjoyDrawData:sOpenWindow(state) -- 充值抽抽乐界面打开/关闭
    local cmd = ProtoPublic_pb.Proto10105648();
    cmd.state = state; -- 1打开 0关闭
    sendMsg(10105648, cmd);
end

function Lua_RechargeEnjoyDrawData:fromServerData(msg)
	if msg ~= nil then
		self.start_tick = msg.activity_info.start_tick; -- 开始时间
		self.end_tick = msg.activity_info.end_tick; -- 结束时间
		self.content = msg.activity_info.content; -- 内容
		self.recharge_gold = msg.recharge_gold; -- 每充值该金额抽奖次数+1
		self.has_gold = msg.has_gold; -- 已充值元宝
		self.draw_time = msg.draw_time; -- 可抽奖次数
		self.record_whole = msg.record_whole; -- 全服记录
		self.time_whole = msg.time_whole; -- 全服累计次数
		self.reward_whole = msg.reward_whole; -- 全服奖励
		self.reward_show = msg.reward_show; -- 显示的道具

		for i,v in ipairs(msg.reward_whole) do
			self.timeWholeList[i] = v.draw_time;
		end
	end
end

function Lua_RechargeEnjoyDrawData.Get:getRecordWhole() -- 全服记录
	local arr = Array();
	for i,v in ipairs(self.record_whole) do
		local list = {};
		list.role_id = v.role_id;
		list.role_name = v.role_name;
		list.draw_times = v.draw_times;

		local itemArr = Array();
		for x,y in ipairs(v.proto_item) do
			local vo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			vo:fromServer(y);
			itemArr:add({vo = vo, item_id = y.id, amount = y.amount});
		end
		list.itemArr = itemArr;

		arr:add(list);
	end
	return arr;
end

function Lua_RechargeEnjoyDrawData.Get:getRewardWhole() -- 全服奖励
	local arr = Array();
	for i,v in ipairs(self.reward_whole) do
		local list = {};
		list.index = i
		list.lvl = v.lvl; -- lvl等级要求
		list.draw_time = v.draw_time; -- 次数
		list.state = v.state; -- 状态 2已领取
		arr:add(list);
	end
	return arr;
end

function Lua_RechargeEnjoyDrawData:getRewardWholeByIndex(index)
	local arr = Array();
	for i,v in ipairs(self.reward_whole) do
		if i == index then
			for x,y in ipairs(v.item) do
				local vo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
				vo.star = y.equipment.star;
				arr:add({vo = vo, show_effect = y.show_effect, _type = 2});
			end
		end
	end
	return arr;
end

function Lua_RechargeEnjoyDrawData.Get:getRewardShow() -- 显示的奖励
	local arr = Array();
	for i,v in ipairs(self.reward_show) do
		local vo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
		vo.star = v.equipment.star;
		arr:add({vo = vo, show_effect = v.show_effect, _type = 1});
	end
	return arr;
end

function Lua_RechargeEnjoyDrawData:checkRedDot() -- 检查登录红点是否消失
	if self.draw_time > 0 or DataCenter.redDotData:getRedDotStateByEventId(22084) then -- 有次数时或者有次数累计奖励未领取时,红点不消失
		return false;
	end
	return true;
end