Lua_SuperBargainData = class("Lua_SuperBargainData");
function Lua_SuperBargainData:ctor()
	self:superCall("ctor");
	self.isLogin = false;
end

function Lua_SuperBargainData:dispose()
	self.isLogin = false;
end

function Lua_SuperBargainData:fromServerData(msg)
	if msg ~= nil then
		self.end_tick = msg.activity_info.end_tick;
		self.content = msg.activity_info.content;
		self.reward = msg.reward;
		self.reward_times = msg.reward_times;
		self.commodity = msg.commodity;
	end
end

function Lua_SuperBargainData.Get:getCommodityData() -- 商品数据
	local arr = Array();
	for i,v in ipairs(self.commodity) do
		local list = {};

		local vo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
		vo.star = v.star;

		list.index = i - 1;
		list.vo = vo;
		list.amount = v.amount;
		list.show_effect = v.show_effect;
		list.can_buy_times = v.can_buy_times; -- 可购买次数
		list.price = v.price; -- 价格
		list.cost_type = v.cost_type; -- 货币类型
		arr:add(list);
	end
	return arr;
end

function Lua_SuperBargainData.Get:totalGold()
	local arr = self.getCommodityData;
	local len = arr:getSize();
	local gold = 0;
	for i=1,len do
		if arr[i].can_buy_times > 0 and arr[i].cost_type == Lua_MoneyData.GOLD then
			gold = gold + arr[i].price;
		end
	end
	return gold;
end

function Lua_SuperBargainData.Get:totalBindGold()
	local arr = self.getCommodityData;
	local len = arr:getSize();
	local bindGold = 0;
	for i=1,len do
		if arr[i].can_buy_times > 0 and arr[i].cost_type == Lua_MoneyData.BIND_GOLD then
			bindGold = bindGold + arr[i].price;
		end
	end
	return bindGold;
end

function Lua_SuperBargainData.Get:totalNum()
	local arr = self.getCommodityData;
	local len = arr:getSize();
	local num = 0;
	for i=1,len do
		if arr[i].can_buy_times > 0 then
			num = num + 1;
		end
	end
	return num;
end