Lua_SuperExchangeData = class("Lua_SuperExchangeData");
function Lua_SuperExchangeData:ctor()
    self:superCall("ctor");
    self.exchangeLogin = false;
    self.restoreLogin = false;
end

function Lua_SuperExchangeData:dispose()
	self.exchangeLogin = false;
	self.restoreLogin = false;
end

function Lua_SuperExchangeData:from50105624(msg)
	if msg ~= nil then
		self.exchange_endTick = msg.act_info.end_tick; -- 结束时间
		self.exchange_reward_info = msg.reward_info;
	end
end

function Lua_SuperExchangeData:from50105627(msg)
	if msg ~= nil then
		self.return_endTick = msg.act_info.end_tick; -- 结束时间
		self.return_reward_info = msg.reward_info;
	end
end

function Lua_SuperExchangeData.Get:getExchangeRewardData()
	local arr = Array();
	for i,v in ipairs(self.exchange_reward_info) do
		local list = {};
		list.index = v.index; -- 索引
		list.prime_cost = v.prime_cost; -- 原价
		list.cur_cost = v.cur_cost; -- 现价

		local itemArr = Array();
		for x,y in ipairs(v.item_list) do
			local vo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
			vo.star = y.equipment.star;
			itemArr:add({vo = vo, show_effect = y.show_effect});
		end
		list.itemArr = itemArr;

		list.cur_amount = v.cur_amount; -- 当前兑换次数
		list.total_amount = v.total_amount; -- 最大兑换次数
		list.vip_lvl = v.vip_lvl; -- 所需vip等级

		if v.cur_amount == v.total_amount then
			list.sortNum = 900 + i;
		else
			list.sortNum = i;
		end
		arr:add(list);
	end
	arr:sort("sortNum", false);
	return arr;
end

function Lua_SuperExchangeData.Get:getReturnRewardData()
	local arr = Array();
	for i,v in ipairs(self.return_reward_info) do
		local list = {};
		local cfg = getConfig({"superReturn", v.cost_item});
		if cfg ~= nil then
			list.itemName = cfg.name;
			list.winName = cfg.winName;
			list.winIndex = cfg.winIndex;
			list.funcOpenId = cfg.funcOpenId;

			list.index = v.index; -- 索引
			list.cost_item = v.cost_item; -- 消耗道具

			local itemArr = Array();
			for x,y in ipairs(v.item_list) do
				local vo = Lua_ToolVo.createToolVo(y.id, y.amount, y.bind);
				vo.star = y.equipment.star;
				itemArr:add({vo = vo, show_effect = y.show_effect});
			end
			list.itemArr = itemArr;

			list.cur_amount = v.cur_amount; -- 当前消耗数量
			list.cond_amount = v.cond_amount; -- 条件消耗数量
			list.state = v.state; -- 领取状态0不可领，1可领，2已领

			if v.state == 2 then
				list.sortNum = 900 + i;
			else
				list.sortNum = i;
			end
			arr:add(list);
		else
			CommonUtil.logError("error item "..v.cost_item);
		end
	end
	arr:sort("sortNum", false);
	return arr;
end