checkRequire("Lua_CumulativeConsumptionData");
Lua_CumulativeConsumptionProxy = class("Lua_CumulativeConsumptionProxy");
function Lua_CumulativeConsumptionProxy:ctor()
    self:superCall("ctor");

    DataCenter.cumulativeConsumptionData =  Lua_CumulativeConsumptionData.new();

    LuaUtil.addLuaMsg(50105671, self, self.rCumulativeConsumptionInfo); -- 累计消费界面（返回）
    LuaUtil.addLuaMsg(50105672, self, self.rGetRewardsInfo); -- 累计消费领取（返回）
end

function Lua_CumulativeConsumptionProxy:rCumulativeConsumptionInfo(mp) -- 累计消费界面（返回）
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50105671();
        msg:ParseFromString(mp.data);
        DataCenter.cumulativeConsumptionData:fromServerData(msg);
        Lua_MsgUtil.callFunc("UPDATE_ACT_CUMULATIVE_CONSUMPTION");
    end
end

function Lua_CumulativeConsumptionProxy:rGetRewardsInfo(mp) -- 累计消费领取（返回）
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50105672();
        msg:ParseFromString(mp.data);
        if msg.first_type == Lua_OperationalActivitiesData.ACT_CUMULATIVE_CONSUMPTION then
            Lua_MsgUtil.callFunc("UPDATE_ACT_CUMULATIVE_CONSUMPTION");
        end
    end
end