checkRequire("Lua_ExquisitePagodaData");
Lua_ExquisitePagodaProxy = class("Lua_ExquisitePagodaProxy");
function Lua_ExquisitePagodaProxy:ctor()
	DataCenter.exquisitePagodaData =  Lua_ExquisitePagodaData.new();

	LuaUtil.addLuaMsg(50105610, self, self.rExquisitePagodaInfo); -- 玲珑宝塔界面（返回）
	LuaUtil.addLuaMsg(50105611, self, self.rExquisitePagodaDraw); -- 玲珑宝塔请求抽奖（返回）
	LuaUtil.addLuaMsg(50105612, self, self.rExquisitePagodaReward); -- 玲珑宝塔领取奖励（返回）
	LuaUtil.addLuaMsg(50105613, self, self.rExquisitePagodaDrawEnd); -- 玲珑宝塔完成抽奖（返回）
end

-- 玲珑宝塔界面（返回）
function Lua_ExquisitePagodaProxy:rExquisitePagodaInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105610();
		msg:ParseFromString(mp.data);
		DataCenter.exquisitePagodaData:fromServer50105610(msg);
		Lua_MsgUtil.callFunc("UPDATE_EXQUISITEPAGODA");
	end
end

-- 玲珑宝塔请求抽奖（返回）
function Lua_ExquisitePagodaProxy:rExquisitePagodaDraw(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105611();
		msg:ParseFromString(mp.data);
		-- print(msg.layer, msg.index, msg.is_skip_anima, msg.draw_type)
		if msg.is_skip_anima == 1 or msg.draw_type > 1 then
			if Lua_WindowUtil.isWindowShowing("Lua_ExquisitePagodaResultWindow") == false then
				Lua_WindowUtil.openWin("Lua_ExquisitePagodaResultWindow");
			end
			Lua_MsgUtil.callFunc("rEXQUISITE_PAGODA_DRAW", msg);
			DataCenter.exquisitePagodaData.isDraw = false;
		else
			DataCenter.exquisitePagodaData.draw_layer = msg.layer;
			
			local index = msg.index + 1;
			if msg.layer == 1 then -- 1
				DataCenter.exquisitePagodaData.draw_index = index;
			elseif msg.layer == 2 then -- 2
				DataCenter.exquisitePagodaData.draw_index = index + 6;
			elseif msg.layer == 3 then -- 3
				DataCenter.exquisitePagodaData.draw_index = index + 11;
			elseif msg.layer == 4 then -- 4
				DataCenter.exquisitePagodaData.draw_index = index + 15;
			elseif msg.layer == 5 then -- 5
				DataCenter.exquisitePagodaData.draw_index = index + 18;
			elseif msg.layer == 6 then -- 6
				DataCenter.exquisitePagodaData.draw_index = index + 20;
			end
			Lua_MsgUtil.callFunc("rEXQUISITE_PAGODA_DRAW_RESULT", msg);
		end
	end
end

-- 玲珑宝塔领取奖励（返回）
function Lua_ExquisitePagodaProxy:rExquisitePagodaReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105612();
		msg:ParseFromString(mp.data);
		DataCenter.exquisitePagodaData.partake_reward = msg.rewards;
		Lua_MsgUtil.callFunc("UPDATE_EXQUISITEPAGODA");
	end
end

-- 玲珑宝塔完成抽奖（返回）
function Lua_ExquisitePagodaProxy:rExquisitePagodaDrawEnd(mp)
	if mp.errno == 0 then
		DataCenter.exquisitePagodaData.isDraw = false;
	end
end





-- 提取界面
function Lua_ExquisitePagodaProxy:sOpenExquisitePagodaWin(firstType)
	local cmd = ProtoPublic_pb.Proto10105601();
	cmd.first_type = firstType;
	sendMsg(10105601, cmd);
end

-- 取出/一键取出
function Lua_ExquisitePagodaProxy:sPagodaPackPickUp(pickUpType, index, packType)
	local cmd = ProtoPublic_pb.Proto11401502();
	cmd.take_type = pickUpType; -- 0取出，1一键取出
	cmd.pack_index = index;   -- 物品索引（一键取出时无效）
	cmd.pack_type = packType; -- 背包类型
	sendMsg(11401502, cmd);
end

-- 整理
function Lua_ExquisitePagodaProxy:sPagodaPackClearUp(packType)
	local cmd = ProtoPublic_pb.Proto11400104();
	cmd.pack_type = packType;
	sendMsg(11400104, cmd);
end

-- 抽奖
function Lua_ExquisitePagodaProxy:sExquisitePagodaDraw(drawType, isPass)
	local cmd = ProtoPublic_pb.Proto10105611();
	cmd.draw_type = drawType;   -- 抽奖类型 0免费 1一次 2十次 3五十次
	cmd.is_skip_anima = isPass; -- 是否跳过动画 1是0否
	sendMsg(10105611, cmd);
end

-- 玲珑宝塔完成抽奖
function Lua_ExquisitePagodaProxy:sExquisitePagodaDrawEnd()
	sendMsg(10105613);
end

-- 领取奖励
function Lua_ExquisitePagodaProxy:sGetRewards(index, firstType)
	local cmd = ProtoPublic_pb.Proto10105602();
	cmd.index = index;
	cmd.first_type = firstType;
	sendMsg(10105602, cmd);
end