checkRequire("Lua_GoodLuckDialData");
Lua_GoodLuckDialProxy = class("Lua_GoodLuckDialProxy");
function Lua_GoodLuckDialProxy:ctor()
	DataCenter.goodLuckDialData =  Lua_GoodLuckDialData.new();

	LuaUtil.addLuaMsg(50101810, self, self.rGoodLuckDialInfo);	-- 打开幸运转盘界面（返回）
	LuaUtil.addLuaMsg(50101812, self, self.rGoodLuckDialDraw);	-- 幸运转盘抽奖（返回）
	LuaUtil.addLuaMsg(80101810, self, self.rGoodLuckDialRecords);	-- 通知幸运转盘全服记录
	LuaUtil.addLuaMsg(80101811, self, self.rGoodLuckDialJackpotNow);	-- 通知幸运转盘当前奖池
	LuaUtil.addLuaMsg(80101812, self, self.rOpenGoodLuckDial); -- 通知幸运转盘活动状态
end

-- 打开幸运转盘界面（返回）
function Lua_GoodLuckDialProxy:rGoodLuckDialInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101810();
		msg:ParseFromString(mp.data);
		DataCenter.goodLuckDialData:fromServer50101810(msg);
		Lua_MsgUtil.callFunc("UPDATE_GOODLUCKDIAL");
	end
end

-- 幸运转盘抽奖（返回）
function Lua_GoodLuckDialProxy:rGoodLuckDialDraw(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101812();
		msg:ParseFromString(mp.data);
		if DataCenter.goodLuckDialData.drawType ~= 0 or DataCenter.goodLuckDialData.isPass == true then
			if Lua_WindowUtil.isWindowShowing("Lua_GoodLuckDialResultWindow") == false then
				Lua_WindowUtil.openWin("Lua_GoodLuckDialResultWindow");
			end
		end
		Lua_MsgUtil.callFunc("rGOODLUCKDIAL_DRAW", msg.rewards);
		Lua_MsgUtil.callFunc("rGOODLUCKDIAL_DRAWRESULT", msg.index);
	end
end

-- 通知幸运转盘全服记录
function Lua_GoodLuckDialProxy:rGoodLuckDialRecords(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101810();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rGOODLUCKDIAL_RECORDS", msg.record_list);
	end
end

-- 通知幸运转盘当前奖池
function Lua_GoodLuckDialProxy:rGoodLuckDialJackpotNow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101811();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rGOODLUCKDIAL_JACKPOTNOW", msg.count);
	end
end

-- 通知幸运转盘活动状态
function Lua_GoodLuckDialProxy:rOpenGoodLuckDial(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101812();
		msg:ParseFromString(mp.data);
		if msg.open == true then
			local info = Lua_ActivitiesInfo.new();
			info.act_index = msg.act_index;
			info.first_type = 1050;
			info.second_type = 0;
			info.priority = 1;
			DataCenter.goodLuckDialData.ruleTips = msg.title;
			info.icon_type = 10130;
			info.is_single_icon = 1;
			info.tart_tick = 1;
			info.end_tick=4;
			info.times = 2;
			info.sort = 5;
			DataCenter.OperationalActivitiesData:addAct(info);
			DataCenter.goodLuckDialData.isEnd = false; -- 活动开始
		else
			DataCenter.OperationalActivitiesData:removeAct(1050);
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10130); -- 移除图标
			DataCenter.goodLuckDialData.isEnd = true; -- 活动结束
		end
	end
end

-- 打开界面
function Lua_GoodLuckDialProxy:sOpenGoodLuckDialWin()
	sendMsg(10101810);
end

-- 关闭界面
function Lua_GoodLuckDialProxy:sCloseGoodLuckDialWin()
	sendMsg(10101811);
end

-- 抽奖
function Lua_GoodLuckDialProxy:sGoodLuckDialDraw(index)
	local cmd = ProtoPublic_pb.Proto10101812();
	cmd.index = index;   -- 0：抽1次，1：抽10次，2：抽50次
	sendMsg(10101812, cmd);
end

-- 领取奖励
function Lua_GoodLuckDialProxy:sGetRewards(index)
	local cmd = ProtoPublic_pb.Proto10101813();
	cmd.index = index;
	sendMsg(10101813, cmd);
end