checkRequire("Lua_InvestmentPlanData")
Lua_InvestmentPlanProxy = class("Lua_InvestmentPlanProxy")
function Lua_InvestmentPlanProxy:ctor()
	DataCenter.investmentPlanData = Lua_InvestmentPlanData.new();

	LuaUtil.addLuaMsg(51401810, self, self.rUpdateInvestmentPlan);
	LuaUtil.addLuaMsg(51401811, self, self.rReceiveInvestmentReward);
	LuaUtil.addLuaMsg(51401813, self, self.rInvestmenting);
	LuaUtil.addLuaMsg(81401810, self, self.onPeakInvestmentOpen); -- 通知巅峰投资开启
	LuaUtil.addLuaMsg(51401823, self, self.rUpdatePeakInvestment); -- 获取巅峰投资信息（返回）
	LuaUtil.addLuaMsg(51401824, self, self.rReceivePeakInvestmentReward); -- 领取巅峰投资奖励（返回）
	LuaUtil.addLuaMsg(51401825, self, self.rPeakInvestmenting); -- 点击立即投资(巅峰投资)（返回）
end

function Lua_InvestmentPlanProxy:rUpdateInvestmentPlan(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401810();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:fromServer51401810(msg);
		Lua_MsgUtil.callFunc("rSetInvestmentPlanData");
	end
end

function Lua_InvestmentPlanProxy:rReceiveInvestmentReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401811();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:sGetInvestmentPlanInfo(msg.invest_id);
	end
end

function Lua_InvestmentPlanProxy:rInvestmenting(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401813();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:sGetInvestmentPlanInfo(msg.invest_id);
	end
end

function Lua_InvestmentPlanProxy:onPeakInvestmentOpen(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401810();
		msg:ParseFromString(mp.data);
		if msg.ti_open == true then
			DataCenter.investmentPlanData.peakInvestmentOpen = 1;
			DataCenter.investmentPlanData:sGetPeakInvestmentInfo(0);
		end
	end
end

function Lua_InvestmentPlanProxy:rUpdatePeakInvestment(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401823();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:formServer51401823(msg);
		Lua_MsgUtil.callFunc("rSetInvestmentPlanData");
	end
end

function Lua_InvestmentPlanProxy:rReceivePeakInvestmentReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401824();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:sGetPeakInvestmentInfo(msg.invest_id);
	end
end

function Lua_InvestmentPlanProxy:rPeakInvestmenting(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401825();
		msg:ParseFromString(mp.data);
		DataCenter.investmentPlanData:sGetPeakInvestmentInfo(msg.invest_id);
	end
end