checkRequire("Lua_KillBossActData");
Lua_KillBossActProxy = class("Lua_KillBossActProxy");
function Lua_KillBossActProxy:ctor()
    self:superCall("ctor");

    DataCenter.killBossActData =  Lua_KillBossActData.new();

    LuaUtil.addLuaMsg(50105651, self, self.rKillBossActInfo); -- Boss活动界面（返回）
    LuaUtil.addLuaMsg(50105653, self, self.rGetRewardsInfo); -- Boss击杀领取奖励（返回）
end

function Lua_KillBossActProxy:rKillBossActInfo(mp) -- Boss活动界面（返回）
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50105651();
        msg:ParseFromString(mp.data);
        if msg.first_type == Lua_OperationalActivitiesData.ACT_BOSS_FIRSTKILL then -- BOSS首杀
            DataCenter.killBossActData:getBossFirstKillInfo(msg);
            Lua_MsgUtil.callFunc("UPDATE_ACT_BOSS_FIRSTKILL");
        elseif msg.first_type == Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE then -- 全民BOSS
            DataCenter.killBossActData:getBossEveryoneInfo(msg);
            Lua_MsgUtil.callFunc("UPDATE_ACT_BOSS_EVERYONE");
        end
    end
end

function Lua_KillBossActProxy:rGetRewardsInfo(mp) -- Boss击杀领取奖励（返回）
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50105653();
        msg:ParseFromString(mp.data);
        DataCenter.killBossActData:getRewardsInfo(msg);
    end
end