checkRequire("Lua_MazeHuntData");
Lua_MazeHuntProxy = class("Lua_MazeHuntProxy");
function Lua_MazeHuntProxy:ctor()
	DataCenter.MazeHuntData =  Lua_MazeHuntData.new();

	LuaUtil.addLuaMsg(50105210, self, self.onMazeHuntInfo);
	LuaUtil.addLuaMsg(50105211, self, self.onMazeHuntUpdata);
	LuaUtil.addLuaMsg(50105214, self, self.MazeHuntInFulDressUpdata);
	LuaUtil.addLuaMsg(80105401, self, self.rOnMazeHuntUpdata);
	LuaUtil.addLuaMsg(80105402, self, self.rOpenMazeHunt);
	LuaUtil.addLuaMsg(80105403, self, self.rMazeHuntInFulDressUpdata);
end

-- 请求迷宫寻宝所有档次信息（返回）
function Lua_MazeHuntProxy:onMazeHuntInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105210();
		msg:ParseFromString(mp.data);
		DataCenter.MazeHuntData:fromServer50105210(msg);
		Lua_MsgUtil.callFunc("GET_MAZEHUNTINFO");
	end
end

-- 请求迷宫寻宝状态信息（返回）
function Lua_MazeHuntProxy:onMazeHuntUpdata(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105211();
		msg:ParseFromString(mp.data);
		DataCenter.MazeHuntData:fromServer50105211(msg);
		Lua_MsgUtil.callFunc("GET_MAZEHUNT_UPDATA");
	end
end

-- 请求迷宫寻宝全服记录（返回）
function Lua_MazeHuntProxy:MazeHuntInFulDressUpdata(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105214();
		msg:ParseFromString(mp.data);
		DataCenter.MazeHuntData:fromServerDressUpdate(msg);
		Lua_MsgUtil.callFunc("MAZEHUNT_INFULDRESS");
	end
end

-- 迷宫寻宝通关信息（通知）
function Lua_MazeHuntProxy:rOnMazeHuntUpdata(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105401();
		msg:ParseFromString(mp.data);
		DataCenter.MazeHuntData:fromServer80105401(msg);
		Lua_MsgUtil.callFunc("rMAZEHUNT_UPDATA");
	end
end

-- 迷宫寻宝活动状态（通知）
function Lua_MazeHuntProxy:rOpenMazeHunt(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105402();
		msg:ParseFromString(mp.data);
		if msg.open == true then
			local info = Lua_ActivitiesInfo.new();
			info.act_index = msg.act_index;
			info.first_type = 1048;
			info.second_type = 0;
			info.priority = 1;
			info.title = msg.title;
			info.icon_type = 10116;
			info.is_single_icon = 1;
			info.start_tick = 1;
			info.end_tick = 4;
			info.times = 2;
			info.sort = 5;
			DataCenter.OperationalActivitiesData:addAct(info);
		else
			DataCenter.OperationalActivitiesData:removeAct(1048);
		end
	end
end

-- 迷宫寻宝全服记录（通知）
function Lua_MazeHuntProxy:rMazeHuntInFulDressUpdata(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105403();
		msg:ParseFromString(mp.data);
		DataCenter.MazeHuntData:fromServerDressUpdate(msg);
		Lua_MsgUtil.callFunc("rMAZEHUNT_INFULDRESS");
	end
end





-- 请求迷宫寻宝所有档次信息
function Lua_MazeHuntProxy:sMazeHuntAllInfo()
	sendMsg(10105210);
end

-- 请求迷宫寻宝状态信息
function Lua_MazeHuntProxy:sMazeHuntAllStateInfo()
	sendMsg(10105211);
end

-- 请求迷宫寻宝摇骰一次
function Lua_MazeHuntProxy:sMazeHuntRollDice()
	sendMsg(10105212);
end

-- 请求寻宝积分对换物品
function Lua_MazeHuntProxy:sMazeHuntReplaceGoods(index)
	local cmd = ProtoPublic_pb.Proto10105213();
	cmd.index = index;
	sendMsg(10105213, cmd);
end

-- 请求迷宫寻宝全服记录 1打开全服记录，0关闭全服记录
function Lua_MazeHuntProxy:sMazeHuntAllrecordInfo(oper)
	local cmd = ProtoPublic_pb.Proto10105214();
	cmd.oper = oper;
	sendMsg(10105214, cmd);
end