checkRequire("Lua_OperationalActivitiesData");
checkRequire("Lua_NewServerActivityData");
checkRequire("Lua_OpenDressCarnivalData");
checkRequire("Lua_TieTheKnotData");
checkRequire("Lua_RechargeEnjoyDrawData");
checkRequire("Lua_SuperExchangeData");
checkRequire("Lua_SuperBargainData");
Lua_OperationalActivitiesProxy = class("Lua_OperationalActivitiesProxy")
function Lua_OperationalActivitiesProxy:ctor()
	DataCenter.OperationalActivitiesData = Lua_OperationalActivitiesData.new();
	DataCenter.newServerActivityData = Lua_NewServerActivityData.new();
	DataCenter.OpenDressCarnivalData = Lua_OpenDressCarnivalData.new();
	DataCenter.tieTheKnotData =  Lua_TieTheKnotData.new();
	DataCenter.rechargeEnjoyDrawData = Lua_RechargeEnjoyDrawData.new();
	DataCenter.superExchangeData = Lua_SuperExchangeData.new();
	DataCenter.superBargainData = Lua_SuperBargainData.new();

	LuaUtil.addLuaMsg(51400007, self, self.rAccumulativeRecharge); -- 打开精采(运营)活动（返回）
	LuaUtil.addLuaMsg(51400009, self, self.rActivitiesInfo); -- 获取精彩（运营）活动面板信息（返回）
	LuaUtil.addLuaMsg(51400021, self, self.rNationalFestivalInfo); -- 获取全民盛典面板信息（返回）活动数据表信息顺序：充值大礼，烟花狂欢，全民来嗨，王者降临
	LuaUtil.addLuaMsg(51400022, self, self.rReceiveRecharge); -- 请求领取充值大礼（返回）
	LuaUtil.addLuaMsg(51400024, self, self.rReceiveEveryOne); -- 请求领取全民来嗨礼包（返回）
	LuaUtil.addLuaMsg(80400100, self, self.rUpdateActivitiesIcon); -- 通知开服活动图标开启或关闭
	LuaUtil.addLuaMsg(80400108, self, self.rRedDotActivitiesInfo); -- 通知客户端哪些活动分类（开服、和服等）有奖励可以领取
	-- LuaUtil.addLuaMsg(81400120, self, self.rUpdataEveryOneInfo); -- 通知项目信息更新
	LuaUtil.addLuaMsg(80400180, self, self.specialrActivitiesInfo); -- 通知特殊图标开启或关闭

	LuaUtil.addLuaMsg(80400181, self, self.opendoubleExp); -- 开启经验双倍
	-- LuaUtil.addLuaMsg(50100205, self, self.rBackConfig); -- 提取后台配置（返回）
	LuaUtil.addLuaMsg(51400023, self, self.rReceiveFireworks); -- 购买盛典烟花礼包（返回）

	------------------------------- 新运营活动 ------------------------------------
	LuaUtil.addLuaMsg(50105609, self, self.rBindCopperGiftInfo); -- 绑元放送界面（返回）
	LuaUtil.addLuaMsg(50105731, self, self.rDiscountStoreInfo); -- 折扣商店（返回)
	LuaUtil.addLuaMsg(80105603, self, self.updataInvenInfo); -- 折扣商店库存刷新（返回)
	LuaUtil.addLuaMsg(50105691, self, self.rTieTheKnotInfo); -- 喜结良缘界面（返回）
	LuaUtil.addLuaMsg(80105601, self, self.rUpdateActiveInfo); -- 更新活动状态，运营活动（新)
	LuaUtil.addLuaMsg(50105657, self, self.rRechargeEnjoyDrawInfo); -- 充值抽抽乐界面（返回）
	LuaUtil.addLuaMsg(50105658, self, self.rRechargeEnjoyDrawResult); -- 充值抽抽乐请求抽奖（返回）
	LuaUtil.addLuaMsg(50105624, self, self.rSuperExchangeInfo); -- 获取超级兑换界面（返回）
	LuaUtil.addLuaMsg(50105627, self, self.rSuperReturnInfo); -- 获取超级返还界面（返回）
	LuaUtil.addLuaMsg(50105634, self, self.rConsumeTreasureInfo); --消费寻宝（返回）

	Lua_MsgUtil.addEventListener("OPEN_OPERATIONAL_ACTIVITIES", self, self.openOperationalActivities);
	Lua_MsgUtil.addEventListener("OPEN_NATIONAL_FESTIVAL", self, self.openNationalFestival);
end

-- function Lua_OperationalActivitiesProxy:rBackConfig(mp)
-- 	print("rBackConfig")
-- 	if mp.errno == 0 then
-- 		local msg = ProtoPublic_pb.Proto50100205();
-- 		msg:ParseFromString(mp.data);
-- 		DataCenter.OperationalActivitiesData:init50100205(msg);
-- 		--local data = decodeJson(msg.str);
-- 		--print("Proto50100205", msg.str, data);
-- 	end
-- end

-- 指开服活动
function Lua_OperationalActivitiesProxy:rAccumulativeRecharge(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400007();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init51400007(msg);
		if DataCenter.funcOpenData:isOpened(10125) == true then--开服狂欢
			DataCenter.OpenDressCarnivalData:getOpenServiceServerInfo(msg);
		end

		-- 开服狂欢数据
		-- 这个活动直接保存在数据里面,担心以后会跟其他冲突
		Lua_MsgUtil.callFunc("UPDATE_ONEPANEL_DATA", msg);
		if msg.act_detail.first_type == Lua_OperationalActivitiesData.ACT_RANK then
			DataCenter.newServerActivityData:setNewSeverActData(msg.act_detail, msg.rank_type, msg.last_rank_info,msg.rank_stage);
			Lua_MsgUtil.callFunc("UPDATE_NEWSERVER_ACTDATA");
		end

		-- print("icon_type",msg.act_detail.reward_info,"show_flag",msg.act_detail.show_flag, "可领将个数",msg.act_detail.reward_count)
		-- for i=1,#msg.act_detail.reward_info do
		-- 	print("索引==",msg.act_detail.reward_info[i].index,"条件==",msg.act_detail.reward_info[i].cond,
		-- 		"数量",msg.act_detail.reward_info[i].sub_value,
		-- 		"奖励内容1",msg.act_detail.reward_info[i].reward_set,"force",msg.act_detail.reward_info[i].force,
		-- 		"结束时间",msg.act_detail.stop_tick)
		-- end

		-- for i=1,#msg.act_detail.reward_info[1].cond do
		-- 	print(msg.act_detail.reward_info[1].cond[i])
		-- end
	end
end

-- 用来获取当前渠道开启了哪些活动（id，标题，描述，起始时间，结束时间），开服活动暂时沿用这个
function Lua_OperationalActivitiesProxy:rActivitiesInfo(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400009();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init51400009(msg);
		if msg.priority == 1 then
			-- 1 表示开服活动
			DataCenter.newServerActivityData:setButtonListData(msg.act_list, msg.show_vec, msg.priority);
		end
		Lua_MsgUtil.callFunc("UPDATE_ACTIVITIES_DATA");
		Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT");
	end
end

function Lua_OperationalActivitiesProxy:rNationalFestivalInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400021();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init51400021(msg);
		Lua_MsgUtil.callFunc("SET_NATIONAL_FESTIVAL");
	end
end

function Lua_OperationalActivitiesProxy:rUpdateActivitiesIcon(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end
		local msg = ProtoPublic_pb.Proto80400100();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init80400100(msg);
	end
end

function Lua_OperationalActivitiesProxy:rRedDotActivitiesInfo(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end
		local msg = ProtoPublic_pb.Proto80400108();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init80400108(msg);
		Lua_MsgUtil.callFunc("SET_ACTIVITIES_BTN_REDDOT", false);
	end
end

-- function Lua_OperationalActivitiesProxy:rUpdataEveryOneInfo(mp)
-- 	if mp.errno == 0 then
-- 		local msg = ProtoPublic_pb.Proto81400120();
-- 		msg:ParseFromString(mp.data);
-- 		DataCenter.OperationalActivitiesData:init81400120(msg);
-- 		Lua_MsgUtil.callFunc("SET_NATIONAL_FESTIVAL_PANEL",false);
-- 		Lua_MsgUtil.callFunc("UPDATE_HELLO_ONE_ITEM");
-- 	end
-- end 

function Lua_OperationalActivitiesProxy:rReceiveRecharge(mp)
	if mp.errno == 0 then
		-- local msg = ProtoPublic_pb.Proto51400022();
		-- msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("NATIONAL_FESTIVAL_RECEIVE");
	end
end

function Lua_OperationalActivitiesProxy:rReceiveEveryOne(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400024();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("NATIONAL_FESTIVAL_RECEIVE", msg.index);
	end
end

function Lua_OperationalActivitiesProxy:specialrActivitiesInfo(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end
		local msg = ProtoPublic_pb.Proto80400180();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:init80400180(msg);
	end
end

function Lua_OperationalActivitiesProxy:openOperationalActivities()
	local activitiesList = DataCenter.OperationalActivitiesData:getActivitiesInfo(1, 2)
	local isOpenWin = false;
	for i = 1, activitiesList:getSize() do
		if activitiesList[i].is_virtual_info == 0 then
			isOpenWin = true;
		end
	end

	if isOpenWin then
		Lua_WindowUtil.openWin("Lua_OperationalActivitiesWindow");
	else
		local openDayList = DataCenter.OperationalActivitiesData:getOpenDayList(1);
		if openDayList == nil or openDayList[1] == nil then
			OperateAlert.show(LanUtil.getValue(122575));
		else
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122574), tostring(openDayList[1].open_day)));
		end
	end
end

function Lua_OperationalActivitiesProxy:openNationalFestival()
	local preDisplay = DataCenter.OperationalActivitiesData.preDisplay
	if preDisplay[10065] ~= nil and preDisplay[10065] == 1 then
		OperateAlert.show(LanUtil.getValue(124508));
	else
		Lua_WindowUtil.openWin("Lua_NationalFestivalWindow");
	end
end

function Lua_OperationalActivitiesProxy:opendoubleExp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400181();
		msg:ParseFromString(mp.data);
		if DataCenter.OpenDressCarnivalData:isOpenDouble(msg.sets) then
			Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10095);
			Lua_MsgUtil.callFunc("UPDATE_RTICON_SHOWTIME", {iconId = 10095, showTime = msg.last_time, isShoWBule = true});
		else
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON",10095);
			DataCenter.OpenDressCarnivalData:getCopyDoubleExp(msg.sets);
			if msg.last_time == 0 then
				DataCenter.OpenDressCarnivalData:removeDoubleExp();
			end
		end
	end
end

--购买盛典烟花礼包
function Lua_OperationalActivitiesProxy:sReceiveFireworks(needBuyNum)
	-- print("needBuyNum", needBuyNum);
	if needBuyNum > 0 then
		local cmd = ProtoPublic_pb.Proto11400023();
		cmd.buy_amount = needBuyNum;
		sendMsg(11400023, cmd);
	end
end

--购买盛典烟花礼包（返回）
function Lua_OperationalActivitiesProxy:rReceiveFireworks(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400023();
		msg:ParseFromString(mp.data);
		-- msg.reward_list;   -- 获得的奖励列表
		if Lua_WindowUtil.isWindowShowing("Lua_FireworksCarnivalResultWindow") == false then
			Lua_WindowUtil.openWin("Lua_FireworksCarnivalResultWindow");
		end
		Lua_MsgUtil.callFunc("rReceiveFireworks", msg);
	end
end










----------------------------- 新运营活动 -----------------------------
-- 更新活动状态
function Lua_OperationalActivitiesProxy:rUpdateActiveInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105601();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:updateActOpen(msg);
		for i,v in ipairs(msg.act_states) do
			-- print(v.first_type, v.state);
			if v.state == 1 then
				local info = Lua_ActivitiesInfo.new();
				info.act_index = v.act_index;
				info.first_type = v.first_type;
				info.second_type = 0;
				info.priority = 1;
				info.icon_type = v.icon;
				info.title = v.title;
				info.is_single_icon = 1;
				info.start_tick = 1;
				info.end_tick = 4;
				info.times = 2;
				info.sort = 5;
				DataCenter.OperationalActivitiesData:addAct(info);
			else
				DataCenter.OperationalActivitiesData:removeAct(v.first_type);
				DataCenter.OperationalActivitiesData:removeActBeStrong(v.first_type);
				DataCenter.redDotData:updateRedDotVoState(22060, false)
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22060, val = 1, bShow = false});
				Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
			end
		end
		DataCenter.redDotData:upDataIconRedDotList();

		--跨服充值消费红点检测
		DataCenter.crossServerRechargeData:fromServerActiveInfo(msg);
		DataCenter.crossServerRechargeData:checkServerRedDotSate();
	end
end

-- 提取界面
function Lua_OperationalActivitiesProxy:sGetActivityInfo(first_type)
	local cmd = ProtoPublic_pb.Proto10105601();
	cmd.first_type = first_type;
	sendMsg(10105601, cmd);
end

-- 请求抽奖
function Lua_OperationalActivitiesProxy:sActivityDraw(draw_type)
	local cmd = ProtoPublic_pb.Proto10105016();
	cmd.draw_type = draw_type;
	sendMsg(10105016, cmd);
end

-- 领取奖励
function Lua_OperationalActivitiesProxy:sGetActivityRewards(first_type, index, sub)
	local cmd = ProtoPublic_pb.Proto10105602();
	cmd.first_type = first_type;
	if index ~= nil then
		cmd.index = index;
	end
	if sub ~= nil then
		cmd.sub = sub;
	end
	sendMsg(10105602, cmd);
end

-- 玩家信息
function Lua_OperationalActivitiesProxy:sGetRoleInfo(role_id, server_flag, first_type)
	local cmd = ProtoPublic_pb.Proto10105603();
	cmd.role_id = role_id; -- 玩家id
	cmd.server_flag = server_flag; -- 服务器标识
	cmd.first_type = first_type; -- 活动类型
	sendMsg(10105603, cmd);
end

-- 折扣商店
function Lua_OperationalActivitiesProxy:sWindowIsOpen(first_type, val)
	local cmd = ProtoPublic_pb.Proto10105605();
	cmd.first_type = first_type;
	cmd.oper_type = val;
	sendMsg(10105605, cmd);
end

-- 绑元放送（返回）
function Lua_OperationalActivitiesProxy:rBindCopperGiftInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105609();
		msg:ParseFromString(mp.data);
		DataCenter.OperationalActivitiesData:updateBindCopperGiftInfo(msg);
		Lua_MsgUtil.callFunc("rBindCopperGiftInfo");
	end
end

-- 折扣商店（返回）
function Lua_OperationalActivitiesProxy:rDiscountStoreInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105731();
		msg:ParseFromString(mp.data);
		-- DataCenter.OperationalActivitiesData:init50105601(msg);
		Lua_MsgUtil.callFunc("SET_DISCOUNTSTORE_INFO", msg);
	end
end

-- 折扣商店库存刷新（返回）
function Lua_OperationalActivitiesProxy:updataInvenInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80105603();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("UPDATE_INVEN_DATA", msg);
	end
end

-- 喜结良缘界面（返回）
function Lua_OperationalActivitiesProxy:rTieTheKnotInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105691();
		msg:ParseFromString(mp.data);
		DataCenter.tieTheKnotData:fromServerData(msg);
		Lua_MsgUtil.callFunc("UPDATE_TIE_THE_KNOT");
	end
end

-- 充值抽抽乐界面（返回）
function Lua_OperationalActivitiesProxy:rRechargeEnjoyDrawInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105657();
		msg:ParseFromString(mp.data);
		DataCenter.rechargeEnjoyDrawData:fromServerData(msg);
		Lua_MsgUtil.callFunc("UPDATE_RECHARGE_ENJOY_DRAW");
	end
end

-- 充值抽抽乐请求抽奖（返回）
function Lua_OperationalActivitiesProxy:rRechargeEnjoyDrawResult(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105658();
		msg:ParseFromString(mp.data);
		if Lua_WindowUtil.isWindowShowing("Lua_RechargeEnjoyDrawResult") == false then
			Lua_WindowUtil.openWin("Lua_RechargeEnjoyDrawResult");
		end
		Lua_MsgUtil.callFunc("UPDATE_RECHARGE_ENJOY_DRAW_RESULT", msg);
	end
end

-- 超值兑换
function Lua_OperationalActivitiesProxy:sSuperExchange(index)
	local cmd = ProtoPublic_pb.Proto10105625();
	cmd.index = index;
	sendMsg(10105625, cmd);
end

-- 获取超级兑换界面（返回）
function Lua_OperationalActivitiesProxy:rSuperExchangeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105624();
		msg:ParseFromString(mp.data);
		DataCenter.superExchangeData:from50105624(msg);
		Lua_MsgUtil.callFunc("UPDATE_SUPER_EXCHANGE");
	end
end

-- 获取超级返还界面（返回）
function Lua_OperationalActivitiesProxy:rSuperReturnInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105627();
		msg:ParseFromString(mp.data);
		DataCenter.superExchangeData:from50105627(msg);
		Lua_MsgUtil.callFunc("UPDATE_SUPER_RETURN");
	end
end

-- 消费寻宝（返回）
function Lua_OperationalActivitiesProxy:rConsumeTreasureInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50105634();
		msg:ParseFromString(mp.data);
		-- DataCenter.OperationalActivitiesData:init50105601(msg);
		Lua_MsgUtil.callFunc("SET_CONSUMETREASURE_INFO", msg);
	end
end