checkRequire("Lua_PeakAuctionData");
Lua_PeakAuctionProxy = class("Lua_PeakAuctionProxy");
function Lua_PeakAuctionProxy:ctor()
    self:superCall("ctor");

    DataCenter.peakAuctionData =  Lua_PeakAuctionData.new();

    LuaUtil.addLuaMsg(50105632, self, self.rPeakAuctionData); -- 巅峰竞拍活动界面(返回)
    LuaUtil.addLuaMsg(50105633, self, self.rBidPriceSuccess); -- 巅峰竞拍出价(返回)
    LuaUtil.addLuaMsg(80105602, self, self.rPeakAuctionBidData); -- 更新巅峰竞拍出价信息
end

function Lua_PeakAuctionProxy:sAuctionBidPrice(index, role_id, bid_price) -- 巅峰竞拍出价
    local cmd = ProtoPublic_pb.Proto10105633();
    cmd.index = index; -- 出价物品下标
    cmd.role_id = role_id; -- 玩家id
    cmd.bid_price = bid_price; -- 出价价格
    sendMsg(10105633, cmd);
end

function Lua_PeakAuctionProxy:rPeakAuctionData(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto50105632();
        msg:ParseFromString(mp.data);
        DataCenter.peakAuctionData:from50105632(msg);
        Lua_MsgUtil.callFunc("UPDATE_PEAK_AUCTION");
    end
end

function Lua_PeakAuctionProxy:rBidPriceSuccess(mp)
    if mp.errno == 1 then
        OperateAlert.show(LanUtil.getValue(143216));
    end
end

function Lua_PeakAuctionProxy:rPeakAuctionBidData(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80105602();
        msg:ParseFromString(mp.data);
        DataCenter.peakAuctionData:from80105602(msg);
    end
end