--军装属性vo

Lua_ArmyEquipVo = class("Lua_ArmyEquipVo", Lua_ToolVo);
function Lua_ArmyEquipVo:ctor(id, count, bin)
	self:superCall("ctor", id, count, bin);
end

---------------------------------------------------------------------------------------------------------------------------------------
-- 穿戴数据

function Lua_ArmyEquipVo.Get:part_name() -- 穿戴部位名
    local list = getConfig({"army_soul_base", "soul_part_name", "arr"})
    return list[self.part];
end

function Lua_ArmyEquipVo.Get:getArmyEquipInfo() -- 穿戴军装VO
    return DataCenter.armySoulData:getArmyEquipInfo(self.army_id,self.part)-- 通过军魂id 槽号 获取vo
end

function Lua_ArmyEquipVo.Get:getArmyInfo() -- 军魂配置
    if self._armySoulInfo == nil then
        self._armySoulInfo = {};
        local list = getConfig({"army_soul_info"});
        for k,v in pairs(list) do
            self._armySoulInfo[v.adorn_soul_clothe] = v;
        end
    end

    return self._armySoulInfo;
end

function Lua_ArmyEquipVo.Get:army_name() -- 军魂名
    return self.getArmyInfo[self.soul_type].remark;
end

function Lua_ArmyEquipVo.Get:army_id() -- 军魂id
    return DataCenter.armySoulData:getArmySoulNmae(self.soul_type).army_id;
end

function Lua_ArmyEquipVo.Get:equipConfig() -- 魂装配置
    local config = getConfig({"soul_clothe_info", self.id});
    if config == nil then
        return nil;
    end
    return config;
end

function Lua_ArmyEquipVo.Get:max_intensify_lvl() -- 强化最大等级
    return self.equipConfig.level_upper;
end

function Lua_ArmyEquipVo.Get:soul_type() -- 魂装穿戴类型
    return self.config.stamp_type;
end

function Lua_ArmyEquipVo.Get:decomposeItem() -- 分解物品
    local tvo = Lua_ToolVo.createToolVo(self.equipConfig.decompose_value[1]);
    return tvo;
end

function Lua_ArmyEquipVo.Get:decompose() -- 分解数量
    return self.equipConfig.decompose_value[2];
end

function Lua_ArmyEquipVo.Get:army_effect() -- 军装特效
    return self.config.stamp_effect;
end

function Lua_ArmyEquipVo.Get:isSameType() -- 是否可以穿戴
    if DataCenter.roleData.level < self.useLvl then
        return false;
    end

    if self.getArmyEquipInfo.armyInfo.activate == 0 then
        return false;
    end

    if self.getArmyEquipInfo.equip_id == 0 then
        return true;
    end

    return false;
end

---------------------------------------------------------------------------------------------------------------------------------------
-- 属性封装

function Lua_ArmyEquipVo.Get:armyBaseProp() -- 军装基础属性封装
    if self.soul_order == nil then
        self.soul_order = 0;
    end

    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val1 = getConfig({"army_soul_prop", self.equipConfig.base_prop[1], v});
        local val3 = getConfig({"army_soul_prop", self.equipConfig.intensify_prop[1], v});
        if val1 ~= nil and val3 ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            local base;
            local upGrade_prop = 0;
            if self.equipConfig.order_prop ~= nil then
                local val2 = getConfig({"army_soul_prop", self.equipConfig.order_prop[1], v});
                if self.soul_order > 0 then
                    upGrade_prop = val2[self.soul_order]; 
                end
            end

            local base_prop = val1[1]; 
            base = base_prop + upGrade_prop;

            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end
            local s = "[b1caf4]"..Lua_ThingDefine.getParamName(v)..":".."[-]".."[ecf3ff]"..base.."[-]";

            if self.intensify_lvl ~= nil and self.intensify_lvl > 0 then
                if self.intensify_lvl >= self.max_intensify_lvl then
                    self.intensify_lvl = self.max_intensify_lvl;
                end
                local intensify = val3[self.intensify_lvl];
                if Lua_ThingDefine.isPercentParam(v) then
                    intensify = intensify.."%";
                end
                s = s.."    ["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.formateStr(LanUtil.getValue(110851), tostring(intensify)).."[-]"; 
            end

            str = str..s;
        end
    end
    return str;
end



----------------------------------------------------------------------------------------------------------------------------------------
-- Tiops 替换红点

function Lua_ArmyEquipVo.Get:isShowItemReplaceRed() -- 替换  红点处理
    
    if self.getArmyEquipInfo.equip_id == 0 then
        return false;
    end

    if self.army_part ~= nil then
        return self.getArmyEquipInfo.isShowReplaceRed;
    end

    if self.color > self.getArmyEquipInfo.armyEquipVo.color then
        return true;
    end

    return false;
end