-- 卡牌vo
Lua_CardVo = class("Lua_CardVo", Lua_ToolVo);
function Lua_CardVo:ctor(id, count, bin)
	self:superCall("ctor", id, count, bin);
end

-- 卡片UI
function Lua_CardVo.Get:cardAtlas()
	if self.card_type == 0 then
		local atlas = "/images/card/".. self.id ..".png"
		return atlas;
	else
		local atlas_id = self.id - self.color + 1;
		local atlas = "/images/card/".. atlas_id ..".png"
		return atlas;
	end
end

-- 强化强化配置信息
function Lua_CardVo.Get:cardConfig()
	return getConfig({"card_armory", self.id});
end

-- 强化强化配置信息
function Lua_CardVo.Get:showLevel()
	return "Lv."..self.card_level;
end

-- 卡牌序号
function Lua_CardVo.Get:card_number()
	return self.cardConfig.card_number;
end

-- 普通类型 1 核心灵魂 2 分解卡牌 0
function Lua_CardVo.Get:card_type()
	return self.config.soul_type;
end

-- 卡片位置 普通类型 1 核心灵魂 2 分解卡牌 0
function Lua_CardVo.Get:cord_location()
	if self.card_type == 1 then
		return LanUtil.getValue(124433);
	elseif self.card_type == 2 then
		return LanUtil.getValue(124434);
	else
		return LanUtil.getValue(124448);
	end
end

function Lua_CardVo.Get:cost_item_num()--每一级强化所需的道具数量
	return self.cardConfig.cost_item[tonumber(self.card_level+1)][1][2];
end

-- 属性长度
function Lua_CardVo.Get:prop_len()
	local val;
	local arr =Array();
	for k,v in ipairs(Lua_ThingDefine.params) do
		val = getConfig({"card_armory", self.id, v});
		if val ~= nil then
			arr:add(k);
		end
	end
	return arr:getSize();
end

-- 属性
function Lua_CardVo.Get:cardAttr()
	if self.card_type == 0 then
		return nil;
	end

	if self.card_level == nil then
		self.card_level = 0;
	end

	local list = {};
	local val = getConfig({"card_armory", self.id});
	for i,v in pairs(val) do
		if type(v) == "table" then
			if v[self.card_level+1] ~= nil then
				list[i] = v[self.card_level+1];
			end
		end
	end
	return list;
end

-- 基础属性
function Lua_CardVo.Get:basicsProp()
	local val;
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.params) do
		val = getConfig({"card_armory", self.id, v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end

			local s;
			if self.card_level == 0 then
				s = "[b1caf4]"..Lua_ThingDefine.getParamName(v).."：".."[-]".."[ecf3ff]"..val[1].."[-]";
			else
				local s1 = "[b1caf4]"..Lua_ThingDefine.getParamName(v).."：".."[-]".."[ecf3ff]"..val[1].."[-]";
				local prop = val[self.card_level+1] - val[1];
				s = s1.."   "..LanUtil.formateStr(LanUtil.getValue(128209),tostring(prop));
			end
			str = str..s;
		end
	end
	return str;
end

-- 分解
function Lua_CardVo.Get:decompose()
	local decomposeNum = 0;
	local resolve = getConfig({"card_decompose", self.id,"decompose_num"});
	if self.card_level == 0 then
		decomposeNum = 0;
	elseif self.card_type == 0 then
		decomposeNum = 0;
	else
		for i = 1, self.card_level do
			local s = self.cardConfig.cost_item[tonumber(i)][1][2];
			decomposeNum = decomposeNum + s;
		end
	end
	return decomposeNum + resolve;
end





-- 卡牌组合技能封装
-- 强化数据
function Lua_CardVo.Get:cardConfigInfo()
	if self.dic == nil then
		self.dic = Array();
		local config = getConfig({"card_armory"});
		if config ~= nil then
			for k, v in pairs(config) do
				local list = {}
				list.id = k;
				list.data = v;
				self.dic:add(list);
			end
		end
	end
	return self.dic;
end

-- 卡片组合VO
function Lua_CardVo.Get:cardGroupVo()
	local arr = DataCenter.cardUtil:getArrCardGroupInfo(self.cardConfig.group_id);
	return arr;
end

-- 组合集合
function Lua_CardVo.Get:getCardGroupNameInfo()
	local arr = Array();
	for i=1, self.cardGroupVo:getSize() do 
		local skill_min = self.cardGroupVo[i].skill_min_color;
		local attr_min = self.cardGroupVo[i].attr_min_color;
		local _arr = self.cardConfigInfo;
		local list = {};
		if skill_min <= self.color and attr_min <= self.color then
			local card_group = self.cardGroupVo[i].card_group;
			for j=1,_arr:getSize() do
				for k,v in ipairs(card_group) do
					if _arr[j].data.card_number == v and _arr[j].data.color == self.color then
						local name = getConfig({"item", _arr[j].id}).name;
						list[k] = name;
					end
				end
			end
		end
		arr:add(list);
	end	

	if arr:getSize() > 0 then
		return arr;
	end
	return nil;
end

-- 是否显示组合属性和组合名
function Lua_CardVo.Get:isShowGroup()
	if self.card_type == 0 then
		return false;
	end

	local arr = self.cardGroupVo;
	local len = arr:getSize();
	for i=1, len do 
		if arr[i].skill_min_color <= self.color and arr[i].attr_min_color <= self.color then
			return true;
		end
	end
	return false;
end

-- 组合集合
function Lua_CardVo.Get:getCardGroupName()
	if self.getCardGroupNameInfo == nil then
		return;
	end

	local data = DataCenter.cardData.cardHolesInfo; -- 穿戴卡牌数据
	local name;
	local list = {};
	for i,v in ipairs(data) do
		if v.card_id ~= 0 then
			name = getConfig({"item", v.card_id}).name;
			list[name] = 1;
		end
	end

	local str;
	local arr = Array();
	for i = 1, self.getCardGroupNameInfo:getSize() do
		str = "";
		for j,v in ipairs(self.getCardGroupNameInfo[i]) do
			name = list[v] == 1 and "[00E125]"..v.."[-]" or "[b1caf4]"..v.."[-]";

			if str == "" then
			    str = "";
			else
			    str = str.." ";
			end
			str = str..name;
		end
		arr:add(str);
	end
	
	if arr:getSize() > 0 then
		return arr;
	end
	return nil;
end

-- 组合属性
function Lua_CardVo.Get:getCardGroupProp()
	local arr = Array();
	local list1 = {};
	local list = self.cardConfig.group_id;
	if DataCenter.cardData.msg ~= nil then
		local _list = DataCenter.cardData.msg.group_list;
		for i,v in ipairs(_list) do
			list1[tonumber(v.obj_id)] = v.obj_value;
		end
	end

	for i,j in ipairs(list) do
		local name = getConfig({"card_group", j}).name.."：";
		arr:add(name);
		for k,v in ipairs(Lua_ThingDefine.percentage_params) do
			local val = getConfig({"card_group", j, v});
			if val ~= nil then
				local color = "[b1caf4]";
				if list1[tonumber(j)] == self.color then
					color = "[00E125]";
				end
				local s = color..Lua_ThingDefine.getParamName(v).."：[-]"..val[self.color].."%";
				arr:add(s);
			end
		end
	end
	return arr;
end