﻿checkRequire("Lua_ToolVo");
Lua_EquipVo = class("Lua_EquipVo", Lua_ToolVo);
function Lua_EquipVo:ctor(id, count, bin)
    self.equPart = 0;
    self.intensifyLevel = 0;
    self.intensifyProgress = 0;
    self.refine = 0;
    self.zhuLingIndex = 0;
    self:superCall("ctor", id, count, bin);
end

function Lua_EquipVo:fromEquipPart(v)
    self.equPart = v.part; -- 位置
    self.intensifyLevel = v.intensify_level; -- 强化等级
    self.intensifyProgress = v.intensify_progress;
    self.refine = v.refine;
    self.refine_up = v.refine_up;
    self.packType = 1;
    self.selected = false;
    self.mana_rank = v.mana_rank
    self.mana_level = v.mana_level
    self.zhuLingState = 1
    if self.mana_level == 2 and self.mana_rank ~= 0 then
        self.zhuLingState = 2
    end
    self.awake_level = v.awake_level
    self.spirit_level = v.spirit_level
    self.jingcui_level = v.succinct_level
    ------------------------------
    self.jewl_Level = v.stone_refine_level_;
    self.jewl_Progress = v.stone_refine_progress_;
    -----------------------------
    self.zhuLingIndex =(self.mana_rank - 1) * 3 + self.mana_level + 1
    self.zhuLingRedDot = false;
    self.jewel = v.jewel;
    self.polish_open = v.polish_open
    self.wash_attrs = v.wash_attrs;
    self.polish_open_siz = v.polish_open_siz;
    self.bolIdx = 1;
end

-- 获取不同等阶所在部位最高等级，装备等阶self.order, 部位self.part
function Lua_EquipVo.Get:maxLvl()
    return Lua_QiangHuaUtil.getIndensify_level(self.order, self.part);
end

function Lua_EquipVo.Get:hasJewl()
    local len = #self.jewel
    for i = 1, len do
        if self.jewel[i].id > 0 then
            return true
        end
    end
    return false
end

function Lua_EquipVo.Get:zhuLingMax()
    return self.zhuLingIndex >= Lua_ZhuLingUtil.getMaxValueByPart(self.equPart);
end
function Lua_EquipVo.Get:zhuLingName()
    if self.zhuLingIndex == 0 or self.zhuLingIndex == -2 then
        return "";
    end
    return Lua_ZhuLingUtil.getZhuLingName(self.equPart, self.zhuLingIndex);
end
function Lua_EquipVo.Get:zhuLingAttr()
    return Lua_ZhuLingUtil.getZhuLingPorpertyAttr(self.equPart, self.zhuLingIndex)
end

function Lua_EquipVo.Get:maxJewlState()
    return self.jewl_Level >= #DataCenter.equData.jwelCostConig[self.jwelType]["level_limit"]
end
function Lua_EquipVo.Get:jwelType()
    local value = Lua_QiangHuaUtil.getJewel_part(self.equPart)
    if value == 1 then
        return Lua_PackTypeDefine.DEF_JEWL
    else
        return Lua_PackTypeDefine.ATT_JEWL
    end
end

function Lua_EquipVo.Get:jwelProgress()
    local level = self.jewl_Level + 1
    local dataConfig = DataCenter.equData.jwelCostConig[self.jwelType]["level_limit"];
    local maxValue = #dataConfig;
    if self.jewl_Level == 0 then
        level = 1
    elseif self.jewl_Level >= maxValue then
        level = maxValue
    end
    return dataConfig[level]
end

function Lua_EquipVo.Get:class_lvl_limit()
    return DataCenter.equData.equipJueXingConfig["class_lvl_limit"]
end

function Lua_EquipVo.Get:spirit_lvl_limit()
    return DataCenter.equData.equipJueXingConfig["spirit_lvl_limit"]
end

function Lua_EquipVo.Get:max_lvl_show()
    return DataCenter.equData.equipJueXingConfig["max_lvl_show"][self.order - self.JueXingCondition[1] + 1]
end

function Lua_EquipVo.Get:max_fuling_show()
    return DataCenter.equData.equipJueXingConfig["max_fuling_show"][self.awake_level]
end

function Lua_EquipVo.Get:JueXingCondition()
    return DataCenter.equData.equipJueXingConfig["limit_condition"]
end

function Lua_EquipVo.Get:part_spirit_condition()
    return DataCenter.equData.equipJueXingConfig["spirit_limit"]
end

function Lua_EquipVo.Get:isCanJueXing()
    local condition = self.JueXingCondition
    if self.order < condition[1] or self.color < condition[3] or self.star < condition[2] then
        return false
    end
    return true
end

function Lua_EquipVo.Get:isCanFuLing()
    if self.awake_level < self.part_spirit_condition then
        return false
    end
    return true
end

function Lua_EquipVo.Get:jueXingTxtShow()
    return DataCenter.equData.equipJueXingConfig["juexing_txt_show"]
end

function Lua_EquipVo.Get:fuLingTxtShow()
    return DataCenter.equData.equipJueXingConfig["fuling_txt_show"]
end

function Lua_EquipVo.Get:maxJueXingLvl()
    local len = self.order - self.JueXingCondition[1] + 1
    if len >= #self.class_lvl_limit then
        len = #self.class_lvl_limit
    end
    return self.class_lvl_limit[len]
end

function Lua_EquipVo.Get:theMaxJueXingLvl()
    return self.class_lvl_limit[#self.class_lvl_limit]
end

function Lua_EquipVo.Get:theMaxFuLingLvl()
    return self.spirit_lvl_limit[#self.spirit_lvl_limit]
end

function Lua_EquipVo.Get:maxFuLingLvl()
    local len = self.awake_level
    if len >= #self.spirit_lvl_limit then
        len = #self.spirit_lvl_limit
    end
    if self.awake_level == 0 then
        len = 1
    end
    return self.spirit_lvl_limit[len]
end

function Lua_EquipVo.Get:jueXingConfigData()
    return self:getConfigDataByPartAndLvl(self.equPart, self.awake_level + 1, 1)
end

function Lua_EquipVo.Get:fuLingConfigData()
    return self:getConfigDataByPartAndLvl(self.equPart, self.spirit_level + 1, 2)
end

function Lua_EquipVo.Get:jingCuiConfigData()
    return self:getConfigDataByPartAndLvl(self.equPart, self.jingcui_level + 1, 3)
end

function Lua_EquipVo:getConfigDataByPartAndLvl(part, lvl, valueIndex)
    if valueIndex == 1 then
        return DataCenter.equData.equipJueXingCostConfig[part .. "_" .. lvl]
    elseif valueIndex == 2 then
        if lvl > self.theMaxFuLingLvl then
            lvl = self.theMaxFuLingLvl
        end
        if self.spirit_level == 0 then
            lvl = 1
        end
        return DataCenter.equData.equipFuLingCostConfig[part .. "_" .. lvl]
    elseif valueIndex == 3 then
        return DataCenter.equData.equipJingCuiCostConfig[part * 10000 + lvl]
    end
    return nil
end

function Lua_EquipVo.Get:jueXingCostItem()
    local arr = Array()
    if self.jueXingConfigData == nil then
        return arr
    end
    local configData = self.jueXingConfigData["part_cost"];

    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        arr:add(itemVo)
    end
    return arr
end

function Lua_EquipVo.Get:fuLingCostItem()
    local arr = Array()
    if self.fuLingConfigData == nil or self.spirit_level >= self.theMaxFuLingLvl then
        return arr
    end
    local configData = self.fuLingConfigData["spirit_cost"];
    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        arr:add(itemVo)
    end
    return arr
end

function Lua_EquipVo.Get:jingCuiCostItem()
    local arr = Array()
    if self.jingCuiConfigData == nil or self.jingcui_level >= self.theMaxJingCuiLvl then
        return arr
    end
    local configData = self.jingCuiConfigData["succinct_cost"];
    local len = #configData
    for i = 1, len do
        local itemVo = Lua_ToolVo.new(configData[i][1], configData[i][2])
        arr:add(itemVo)
    end
    return arr
end

function Lua_EquipVo.Get:theMaxJingCuiLvl()
    return DataCenter.equData.equipJingCuiConfig["max_succinct"]
end

function Lua_EquipVo:genContentString(sa)
    self:superCall("genContentString", sa);
    sa:writeInt(self.equPart);
    sa:writeInt(self.intensifyLevel);
    sa:writeInt(self.intensifyProgress);
    sa:writeInt(self.refine);
    sa:writeBool(self.polish_open);
    sa:writeBool(self.refine_up);
    sa:writeInt(self.zhuLingIndex);
    sa:writeInt(self.jewl_Level);
    sa:writeInt(self.awake_level);
    sa:writeInt(self.spirit_level);
    sa:writeInt(self.jingcui_level);

    sa:writeInt(self.polish_open_siz);
    local len = self.jewel == nil and 0 or #self.jewel;
    sa:writeInt(len);
    for i = 1, len do
        sa:writeInt(self.jewel[i].id);
        sa:writeInt(self.jewel[i].bind);
    end
    len = self.wash_attrs == nil and 0 or #self.wash_attrs;
    sa:writeInt(len);
    for i = 1, len do
        sa:writeBool(self.wash_attrs[i].open);
        sa:writeInt(self.wash_attrs[i].attr.attr_id);
        sa:writeInt(self.wash_attrs[i].attr.color);
        sa:writeInt(self.wash_attrs[i].attr.lower);
        sa:writeInt(self.wash_attrs[i].attr.upper);
        sa:writeInt(self.wash_attrs[i].attr.value);
    end
end

function Lua_EquipVo:getJueXingConfig(t, lvl)
    if lvl == nil then
        lvl = self.awake_level;
    end
    local attr = self.baseAttr;
    local len = attr:getSize();
    local rs = { };
    for i = 1, len do
        local val = 0;
        if self.awake_level ~= 0 then
            local configData = self:getConfigDataByPartAndLvl(self.equPart, lvl, 1);
            if t == 1 then
                val = configData["jc_" .. attr[i].attr];
            else
                val = configData["qh_" .. attr[i].attr];
            end
        end
        if t == 1 then
            if attr[i].attr == "attack" then
                rs["attack_min"] = math.floor(val * attr[i].attack_min / 100);
                rs["attack_max"] = math.floor(val * attr[i].attack_max / 100);
            else
                rs[attr[i].attr] = math.floor(val * attr[i].value / 100);
            end
        else
            local qianghuaValue = getConfig( { "equipment_part", "intensify", self.equPart, attr[i].attr, self.intensifyLevel });
            if qianghuaValue ~= nil then
                rs[attr[i].attr] = math.floor(val * qianghuaValue / 100);
            end
        end
    end
    return rs;
end

function Lua_EquipVo:getJueXingBase(lvl)
    return self:getJueXingConfig(1, lvl);
end

function Lua_EquipVo:getJueXingStrong(lvl)
    return self:getJueXingConfig(2, lvl);
end


function Lua_EquipVo:setFromContentString(sa)
    self:superCall("setFromContentString", sa);
    self.equPart = sa:getInt();
    self.intensifyLevel = sa:getInt();
    self.intensifyProgress = sa:getInt();
    self.refine = sa:getInt();
    self.polish_open = sa:getBool();
    self.refine_up = sa:getBool();
    self.zhuLingIndex = sa:getInt();
    self.jewl_Level = sa:getInt();
    self.awake_level = sa:getInt();
    self.spirit_level = sa:getInt();
    self.jingcui_level = sa:getInt();
    self.polish_open_siz = sa:getInt();
    self.jewel = { };
    local len = sa:getInt();
    for i = 1, len do
        local o = { };
        o.id = sa:getInt();
        o.bind = sa:getInt();
        self.jewel[i] = o;
    end
    self.wash_attrs = { };
    local len = sa:getInt();
    for i = 1, len do
        local o = { };
        o.open = sa:getBool();
        o.attr = { };
        o.attr.attr_id = sa:getInt();
        o.attr.color = sa:getInt();
        o.attr.lower = sa:getInt();
        o.attr.upper = sa:getInt();
        o.attr.value = sa:getInt();
        self.wash_attrs[i] = o;
    end
end