checkRequire("Lua_GatherSoulHoleVo")
Lua_GatherSoulData = class("Lua_GatherSoulData");
function Lua_GatherSoulData:ctor()
	self.soulHolesInfo = {};
	self.openGrooveId = 0; -- 灵魂槽id
	self.soulStone = 0; -- 魂石
	self.soulDust = 0; -- 魂之粉尘
	self.isSucceed = 0; -- 凝聚是否成功
	self.isAutoResolve = 0; -- 自动分解状态记录 0关，1开
	self.select_num = 0; -- 设置默认分解灵魂色值--并记录其状态
end

function Lua_GatherSoulData:dispose()
	self.soulHolesInfo = {};
	self.openGrooveId = 0;
	self.soulStone = 0;
	self.soulDust = 0;
	self.isSucceed = 0; -- 凝聚是否成功
	self.isAutoResolve = 0;
	self.select_num = 0;

	self.bIconRedDotState = false;
	if self.arr ~= nil then
		self.arr:clear();
		self.arr = nil;
	end
end

-- 孔位信息
function Lua_GatherSoulData:fromServer51403301(msg)
	if msg == nil then
		return;
	end
	self.msg = msg;

	local vo;
	for k, v in ipairs(msg.groove_list) do
		vo = Lua_GatherSoulHoleVo.new(); -- 孔位VO
		vo:formServer(v);
		self.soulHolesInfo[tostring(vo.id)] = vo;
	end
end

-- 通过槽号获取vo
function Lua_GatherSoulData:getArrByGrooveId(groove_id)
	if self.soulHolesInfo[tostring(groove_id)] == nil and self.soulHolesInfo[tostring(groove_id)].soulId == 0 then
		return nil;
	end
	return self.soulHolesInfo[tostring(groove_id)];
end

-- 属性总览
function Lua_GatherSoulData.Get:genAttName()
	if self.msg == nil then
		return "";
	end

	local str = "";
	local desStr;
	self.arr = Array();
	for i,v in ipairs(self.msg.attr_prop) do
		if v.obj_value ~= 0 then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end
			desStr = LanUtil.formateStr(getConfig({"attr_name2", v.obj_id}), "[00E125]"..v.obj_value.."[-]");
			str = str.."[B1CAF4]"..desStr.."[-]";

			self.arr:add(i);
		end
	end
	return str;
end





-- 红点数据处理
-- 更新页签红点
-- function Lua_GatherSoulData:checkSoulRedDot()
-- 	self.bIconRedDotState = false;
-- 	if self:isShowCohesionRed() == true or self:isShowSoulResolveRed() == true
-- 		or self:isShowSoulUpgradeRed() == true or self:isShowDressRed() == true then
-- 		self.bIconRedDotState = true;
-- 	end
-- 	-- Lua_MsgUtil.callFunc("BAG_SOUL_REDDOTSTATE_CHANGE", self.bIconRedDotState);
-- end

-- 灵魂变强红点检测
function Lua_GatherSoulData:checkSoulRedDotSate()
	self:isShowSoulResolveIconRed(self:isShowSoulResolveRed());
	self:isShowSoulCohesionIconRed(self:isShowCohesionRed());
	self:isShowSoulUpgradeIconRed(self:isShowSoulUpgradeRed());
	self:isShowSoulDressIconRed(self:isShowDressRed());
end

-- 分解界面 红点处理
function Lua_GatherSoulData:isShowSoulResolveRed()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);
	local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.GATHERSOUL_ITEM});
	for i = 1, arr:getSize() do
		if arr[i].prop_type == 1 or arr[i].soul_type == 2 then
			if arr[i].color <= 2 or arr[i].soul_type == 2 then
				return true;
			end
		end
	end
	return false;
end

-- 主界面凝聚按钮红点处理
function Lua_GatherSoulData:isShowCohesionRed()
	local config = getConfig({"soul_compress"});
	for k,v in pairs(config) do
		if v.cost_item == nil then
			if v.level <= DataCenter.roleData.level then
				if v.cost_soul_stone <= self.soulStone then 
					return true;
				end
			end
		else
			if v.level <= DataCenter.roleData.level then
				local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(v.cost_item[1][1]);
				local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(v.cost_item[2][1]);
				local needNum1 = v.cost_item[1][2];
				local needNum2 = v.cost_item[2][2];
				if v.cost_soul_stone <= self.soulStone and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
					return true;
				end
			end
		end
	end
	return false;
end

-- 灵魂升级红点检测
function Lua_GatherSoulData:isShowSoulUpgradeRed()
	if self.msg == nil then
		return;
	end

	for k, v in ipairs(self.msg.groove_list) do
		if v.soul_id ~= 0 then
			local v1 = self:getArrByGrooveId(v.groove);
			if v1 ~= nil then
				local vo = v1.soulVo;
				if vo ~= nil then 
					local isMsxLvl = DataCenter.gatherSoulUtil:isMsxLvl(vo.soulColor,vo.soul_level); -- 是否满级
					if isMsxLvl == false and vo.soulUpgrade ~= nil then
						if self.soulDust >= vo.soulUpgrade then
							return true;
						end
					end
				end
			end
		end
	end
	return false;
end

-- 主界面穿戴红点处理，灵魂佩戴
function Lua_GatherSoulData:isShowDressRed(data)
	local list = self.soulHolesInfo;
	for i,v in pairs(list) do
		if v.isShowSoulDressRed == true then
			return true;
		end
	end
	return false;
end

-- 灵魂分解 变强事件
function Lua_GatherSoulData:isShowSoulResolveIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22017, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22017, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 灵魂凝聚 变强事件
function Lua_GatherSoulData:isShowSoulCohesionIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(11179, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11179, val = bool and 1 or 0, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 灵魂升级 变强事件
function Lua_GatherSoulData:isShowSoulUpgradeIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(11180, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11180, val = 1, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end

-- 灵魂穿戴 变强事件
function Lua_GatherSoulData:isShowSoulDressIconRed(bool)
	DataCenter.redDotData:updateRedDotVoState(22035, bool); -- 客户端主动添加红点事件
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22035, val = 1, bShow = bool});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", bool); -- 变强事件
end





-- 凝聚数据处理
-- 获取等级最高的灵魂索引
function Lua_GatherSoulData:getMinSoulIndex(soul_id)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);
	local arr = bagData:getBagAllData();
	local soulArr = Array();
	for i = 1, arr:getSize() do
		if arr[i].id == soul_id then
			soulArr:add(arr[i])
		end
	end
	soulArr:sort("soul_level", true)
	return soulArr[1].index;
end

-- 多属性凝聚list
function Lua_GatherSoulData:getSoulDoubleArray(arr)
	local _arr = Array();
	for i = 1, #arr do
		_arr:add({id = self:getMaxSoulLvlArray(arr[i][1])[1].id, index = self:getMinSoulIndex(arr[i][1])});
	end
	return _arr;
end

-- 获取灵魂最高等级
function Lua_GatherSoulData:getMaxSoulLvlArray(soul_id)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);
	local arr = bagData:getBagAllData();
	local soulArr = Array();
	for i = 1, arr:getSize() do
		if arr[i].id == soul_id then
			soulArr:add(arr[i])
		end
	end
	soulArr:sort("soul_level", true);
	return soulArr;
end

-- 获取凝集预览灵魂的等级
function Lua_GatherSoulData:getCohesionSoulLevel(vo, arr1, arr2)
	local decompose;
	local color = vo.color;
	local str = 0;
	local lvl = 0;
	local double = DataCenter.gatherSoulUtil.double_soul; 
	if arr1 ~= nil and arr2 ~= nil then
		decompose = arr1[1].gatherResolve + arr2[1].gatherResolve;
		for i = 1, #double[color] do
			str = str + double[color][i];
			if str <= decompose then
				lvl = i;
			end
		end
	else
		local arr;
		if arr1 ~= nil and arr2 == nil then
			arr = arr1;
		elseif arr1 == nil and arr2 ~= nil then
			arr = arr2;
		end

		decompose = arr[1].gatherResolve;
		if decompose > 0 then
			for i = 1, #double[color] do
				str = str + double[color][i];
				if str <= decompose then
					lvl = i;
				end
			end
		else
			lvl = 0;
		end
	end
	return lvl > 0 and lvl or 0;
end

-- 通过 凝聚材料灵魂获取 能聚预览等级
function Lua_GatherSoulData:getSoulLevel(soul_id,soul_id1,soul_id2)
	local tvo = Lua_ToolVo.createToolVo(soul_id);
	local arr1 = self:getMaxSoulLvlArray(soul_id1)
	local arr2 = self:getMaxSoulLvlArray(soul_id2)
	if arr1:getSize() == 0 and arr2:getSize() == 0 then
		soulLevel = 0;
	elseif arr1:getSize() ~= 0 and arr2:getSize() ~= 0 then
		soulLevel = self:getCohesionSoulLevel(tvo,arr1,arr2);
	elseif  arr1:getSize() ~= 0 and arr2:getSize() == 0 then
		soulLevel = self:getCohesionSoulLevel(tvo,arr1);
	else
		soulLevel = self:getCohesionSoulLevel(tvo,arr2);
	end
	return soulLevel
end





-- 背包排序
function Lua_GatherSoulData:sortPackFun(a, b)
	if a == nil or b == nil then
		return false;
	end

	if a.soul_type ~= 2 and b.soul_type == 2 then
		return true;
	elseif a.soul_type ~= 2 and b.soul_type ~= 2 then
		if a.color > b.color then
			return true;
		elseif a.color == b.color then
			if a.soul_level > b.soul_level then
				return true;
			elseif a.soul_level  == b.soul_level then
				if a.sort > b.sort then
					return true;
				end
			end
		end
	elseif a.soul_type == 2 and b.soul_type == 2 then
		if a.color > b.color then
			return true;
		end 
	end
end

-- 分解排序
function Lua_GatherSoulData:sortResolvePackFun(a, b)
	if a == nil or b == nil then
		return false;
	end

	if a.soul_type ~= 2 and b.soul_type == 2 then
		return true
	elseif a.soul_type ~= 2 and b.soul_type ~= 2 then
		if a.color > b.color then
			return true;
		elseif a.color == b.color then
			if a.soul_level > b.soul_level then
				return true;
			elseif a.soul_level  == b.soul_level then
				if a.sort > b.sort then
					return true;
				end
			end
		end
	elseif a.soul_type == 2 and b.soul_type == 2 then 
		if a.color > b.color then
			return true;
		end
	end
	return false;
end





-- 下行背包灵魂的穿戴操作
-- 佩戴灵魂属性 标记
function Lua_GatherSoulData.Get:adornSoulTypeSign()
	local arr = Array();
	for k, v in pairs(self.soulHolesInfo) do
		if v.soulId ~= 0 then
			local vo = v.soulVo
			if vo.prop_type == 1 then
				arr:add(vo.s_only);
			else
				for i = 1, 2 do
					arr:add(vo.b_only[i]);
				end
			end
		end
	end
	return arr;
end

-- 佩戴灵魂和背包 是否拥有相同类型属性判断
function Lua_GatherSoulData:isSameTypeInlayAndPack(sign_num)
	local arr = self.adornSoulTypeSign;
	for i = 1, arr:getSize() do
		if arr[i] == sign_num then
			return true;
		end
	end
	return false;
end

-- 佩戴灵魂和背包是 否是同属性包类型 判断
function Lua_GatherSoulData:isSameTypeSign(data)
	if data.prop_type == 1 then
		return self:isSameTypeInlayAndPack(data.s_only)
	else
		if self:isSameTypeInlayAndPack(data.b_only[1]) or self:isSameTypeInlayAndPack(data.b_only[2]) then
			return true;
		else
			return false;
		end
	end
end

-- 是否解锁核心灵魂
function Lua_GatherSoulData.Get:getIsUnlockCoreSoul()
	if self.msg == nil then
		return false;
	end

	for k, v in ipairs(self.msg.groove_list) do
		if k == 7 and v.unlock == 1 then
			return true;
		end
	end
	return false;
end

-- 是否佩戴核心灵魂
function Lua_GatherSoulData.Get:getIsAdornCoreSoul()
	if self.msg == nil then
		return false;
	end

	for k, v in ipairs(self.msg.groove_list) do
		if k == 7 and v.soul_id ~= 0 then
			return true;
		end
	end
	return false;
end

-- 普通 所有 解锁槽，是否已经佩戴满灵魂
function Lua_GatherSoulData.Get:isAllAdornSoul()
	if self.msg == nil then
		return nil;
	end

	for k, v in ipairs(self.msg.groove_list) do
		if v.unlock == 1 and v.soul_id == 0 and k < 7 then
			return true;
		end
	end
	return nil;
end

-- 获取没有穿戴的背包槽
function Lua_GatherSoulData.Get:getSoulGrooveId()
	if self.msg == nil then
		return;
	end

	for k, v in ipairs(self.msg.groove_list) do
		if v.soul_id == 0 and k < 7 then
			return {groove_id = k - 1};
		end
	end
end

-- 灵魂佩戴
function Lua_GatherSoulData:onAdornSoulClick(data)
	local soul_type = data.soul_type; -- 普通类型0 核心灵魂1 特殊类型为2 
	if soul_type == 0 then -- 普通类型
		if self.isAllAdornSoul == true then -- 解锁槽 可佩戴
			if self:isSameTypeSign(data) == true then -- 是否是同属性
				OperateAlert.show(LanUtil.getValue(124445));
			else
				Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sInlaySoul(self.getSoulGrooveId.groove_id, data.id, data.index);   
			end
		else
			if self:isSameTypeSign(data) == true then -- 是否是同属性
				OperateAlert.show(LanUtil.getValue(124445));
			else
				OperateAlert.show(LanUtil.getValue(244444));
			end
		end
	elseif soul_type == 1 then -- 核心灵魂 
		if self.getIsUnlockCoreSoul == true then
			-- print("核心灵魂 已经解锁")
			if self.getIsAdornCoreSoul == true then
				OperateAlert.show(LanUtil.getValue(124446));
			else
				Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sInlaySoul(6, data.id, data.index);      
			end
		else
			OperateAlert.show(LanUtil.getValue(124447));
		end
	end
end

-- 背包灵魂Tips分解
function Lua_GatherSoulData:onResolveTipsClick(data, bool)
	self.arr = Array();
	self.arr:add({id = data.id, index = data.index});
	if bool == true then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(124416),
			type = 1, subFun = self.onSubCallback});
	else
		Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sResolveSoul(self.arr);
	end
end

function Lua_GatherSoulData:onSubCallback()
	Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sResolveSoul(self.arr);
end

function Lua_GatherSoulData:onDismantleTipsClick(data)--背包灵魂Tips 拆解
	if data == nil then
		return;
	end
	self.data = data;

	local soul_name = data.soulName
	local soul_Front_name = DataCenter.gatherSoulUtil:getSoulFrontName(data.id)
	local soul_Later_name = DataCenter.gatherSoulUtil:getSoulLaterName(data.id)
	local soul_stone = getConfig({"soul_compress",data.id}).cost_soul_stone; -- 返还魂石
	local soul_dust = data.decompose; -- 返还粉尘

	local tipData = {};
	tipData.owner = self;
	tipData.des = LanUtil.formateStr(LanUtil.getValue(124405), tostring(soul_name),
		tostring(soul_Front_name), tostring(soul_Later_name), tostring(soul_stone), tostring(soul_dust));
	tipData.type = 1;
	tipData.titleName = LanUtil.getValue(124443);
	tipData.showHint = LanUtil.getValue(124406);
	tipData.subFun = self.onDismantleClick;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_GatherSoulData:onDismantleClick()
	Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sDisassemSoul(self.data);
end