-- 聚魂孔信息
Lua_GatherSoulHoleVo = class("Lua_GatherSoulHoleVo")
function Lua_GatherSoulHoleVo:ctor()
	self.ownEssence = 0;
end

function Lua_GatherSoulHoleVo:formServer(obj)
	if obj == nil then
		return;
	end

	self.id = obj.groove; -- 槽号0 - 7
	self.soulId = obj.soul_id; -- 灵魂ID
	self.soulLv = obj.soul_level; -- 灵魂等级
	self.color = obj.color; -- 品灵魂颜色
	self.unLock = obj.unlock == 1 and true or false; --是否解锁 1是   0否
end

function Lua_GatherSoulHoleVo.Get:soulVo()
	if self.soulId ~= nil and self.soulLv ~= nil then
		local vo = Lua_ToolVo.createToolVo(self.soulId);
		vo.soul_level = self.soulLv;
		vo.groove_id = self.id;
		return vo;
	end
	return nil;
end

-- Item 灵魂 红点
-- 灵魂界面 穿戴 红点处理
function Lua_GatherSoulHoleVo.Get:isShowSoulDressRed()
	if self.unLock == false then
		return false;
	end

	if self.unLock == true and self.soulId == 0 then
		if self.id < 6 then
			-- print("普通灵魂", self.isHaveCommonSoul)
			if self.isHaveCommonSoul == true then
				return true;
			end
		else
			-- print("核心灵魂", self.isHaveCoreSoul)
			if self.isHaveCoreSoul == true then
				return true;
			end
		end
	end
	return false;
end

-- 背包 是否拥有 不同部属性 灵魂
function Lua_GatherSoulHoleVo.Get:isHaveCommonSoul()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);
	local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.GATHERSOUL_ITEM});
	if arr:getSize() <= 0 then
		return false;
	end

	for i = 1, arr:getSize() do
		if arr[i].soul_type == 0 and arr[i].isShowDressRed == true then
			return true;
		end
	end
	return false;
end

-- 背包 是否拥有核心灵魂
function Lua_GatherSoulHoleVo.Get:isHaveCoreSoul()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.JH_PACK);
	local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.GATHERSOUL_ITEM});
	if arr:getSize() <= 0 then
		return false;
	end

	for i = 1, arr:getSize() do
		if arr[i].soul_type == 1 then
			return true;
		end
	end
	return false;
end