--聚魂属性vo
Lua_GatherSoulVo = class("Lua_GatherSoulVo", Lua_ToolVo);
function Lua_GatherSoulVo:ctor(id, count, bin)
	self:superCall("ctor", id, count, bin);
end

function Lua_GatherSoulVo.Get:attribute()--灵魂属性ID字段  特殊灵魂 没此字段
    local attribute = 0;
    if self.config.attribute ~= nil then
        for i = 1, #self.config.attribute do
            attribute = tonumber(self.config.attribute[i]);
        end
    else
    	return nil;
    end

    return attribute;
end

function Lua_GatherSoulVo.Get:soulColor()--灵魂颜色
    return self.config.color;
end

function Lua_GatherSoulVo.Get:soul_type()--灵魂  普通类型 0 核心灵魂 1  特殊类型为 2 
	return self.config.soul_type;
end

function Lua_GatherSoulVo.Get:soul_location()--灵魂位置  普通类型 0 核心灵魂 1  特殊类型为 2 
    if self.soul_type == 0 then
        return LanUtil.getValue(124433);
    elseif self.soul_type == 1 then
        return LanUtil.getValue(124434);
    else
        return LanUtil.getValue(124448);
    end
end

function Lua_GatherSoulVo.Get:soulLv()--灵魂等级
    return "Lv." ..self.soul_level+1;
end

function Lua_GatherSoulVo.Get:soulName()--灵魂名字
    return "[" .. Lua_ColorDefine.getItemColorStr(self.config.color, false) .. "]" .. self.config.name .. "[-]";
end

function Lua_GatherSoulVo.Get:soulUpgradeName()--灵魂升级
   -- print("灵魂等级"..self.config.soul_level)
	return "[" .. Lua_ColorDefine.getItemColorStr(self.config.color, false) .. "]" .. self.config.name .. "Lv." .. self.soul_level+1 .. "[-]";
end

function Lua_GatherSoulVo.Get:soulPropConfig()--灵魂属性配置
    local config = getConfig({"soul_prop", self.attribute});
    return config;
end

function Lua_GatherSoulVo.Get:prop_type()--属性组合类型 1 单属性 2双属性
    return self.soulPropConfig.prop_type;
end

function Lua_GatherSoulVo.Get:type_list()--属性加成分类 1 固定值 2百分比
    return self.soulPropConfig.type;
end

function Lua_GatherSoulVo.Get:s_only()--单属性标识
    return self.soulPropConfig.s_only;
end

function Lua_GatherSoulVo.Get:b_only()--同属性标识
    return self.soulPropConfig.b_only;
end

function Lua_GatherSoulVo.Get:soulProp()--灵魂升级 属性封装
    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_prop", self.attribute, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            
            local base = val[self.config.color][self.soul_level+1];
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end 

            local s = Lua_ThingDefine.getParamName(v).."+"..base;
            str = str..s;
        end
    end

    return str;
end

function Lua_GatherSoulVo.Get:soulNextProp()-- 灵魂升级 下等级灵魂属性
    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_prop", self.attribute, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            local s = "";
            if val[self.config.color][self.soul_level+2] ~= nil then
                local base = val[self.config.color][self.soul_level+2];
                if Lua_ThingDefine.isPercentParam(v) then
                    base = base.."%";
                end 
                s = "+"..base;
            else
                return s;
            end
            str = str..s;
        end
    end

    return str;
end

function Lua_GatherSoulVo.Get:soulResolveProp()-- 灵魂分解 属性封装
    if self.soul_type == 2 then
        return LanUtil.getValue(124449)..":"..self.decompose;
    end

    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_prop", self.attribute, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            
            local base = val[self.config.color][self.soul_level+1];
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end 

            local s = Lua_ThingDefine.getParamName(v)..":"..base;
            str = str..s;
        end
    end

    return str;
end

function Lua_GatherSoulVo.Get:soulTipsProp()-- 灵魂 基础属性封装
    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_prop", self.attribute, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            
            local base = val[self.config.color][self.soul_level+1];
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end 

            local s = "[b1caf4]"..Lua_ThingDefine.getParamName(v)..":".."[-]".."[ecf3ff]"..base.."[-]";
            str = str..s;
        end
    end

    return str;
end

function Lua_GatherSoulVo.Get:soulCohesionProp()--灵魂 凝聚属性封装
    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_prop", self.attribute, v});
        if val ~= nil then
            if str == "" then
                str = "";
            else
                str = str.."\n";
            end
            
            local base = val[self.config.color][self.soul_level+1];
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end 

            local s = Lua_ThingDefine.getParamName(v).."："..base;
            str = str..s;
        end
    end

    return str;
end

function Lua_GatherSoulVo.Get:soulResolve()--灵魂分解 
    local single = DataCenter.gatherSoulUtil.single_soul; --单属性
    local double = DataCenter.gatherSoulUtil.double_soul; --多属性
    local specail = DataCenter.gatherSoulUtil.specail_decomp; --特殊
    local normal = DataCenter.gatherSoulUtil.normal_decomp; --基础

    if self.soul_type ~= 2 then
        if self.prop_type == 1 then
            return normal[self.config.color] + single[self.config.color][self.soul_level+1];
        elseif self.prop_type == 2 then
            return normal[self.config.color] + double[self.config.color][self.soul_level+1];
        end
    else
        return specail[self.config.color]
    end
end

function Lua_GatherSoulVo.Get:soulUpgrade()--灵魂升级
    local single = DataCenter.gatherSoulUtil.single_soul; --单属性
    local double = DataCenter.gatherSoulUtil.double_soul; --多属性

    if self.prop_type == 1 then
        return single[self.config.color][self.soul_level+1];
    elseif self.prop_type == 2 then
        return double[self.config.color][self.soul_level+1];
    end
end

function Lua_GatherSoulVo.Get:decompose()--分解
    local decompose = 0;
    local decomposeNum = 0;
    local single = DataCenter.gatherSoulUtil.single_soul; --单属性
    local double = DataCenter.gatherSoulUtil.double_soul; --双属性

    if self.soul_type ~= 2 then
        if self.prop_type == 1 then 
            decompose = getConfig({"soul_upgrade_decomp", "normal_decomp", "values"})[tonumber(self.config.color)]; --普通灵魂分解基础值
            if self.soul_level ~= 0 then
                for i=1, self.soul_level do
                    local s = single[self.config.color][i];
                    decomposeNum = decomposeNum + s;
                end
            else
                decomposeNum = 0;
            end
        else
            if self.soul_level ~= 0 then
                for i=1, self.soul_level do
                    local s = double[self.config.color][i];
                    decomposeNum = decomposeNum + s;
                end
            else
                decomposeNum = 0;
            end
        end
    else
        decompose = getConfig({"soul_upgrade_decomp", "specail_decomp", "values"})[tonumber(self.config.color)];--特殊灵魂分解基础值
    end
    
    self._decompose = decompose + decomposeNum;
    return self._decompose;
end

function Lua_GatherSoulVo.Get:gatherResolve()--分解用于计算凝聚等级
    local decomposeNum = 0;
    local single = DataCenter.gatherSoulUtil.single_soul; --单属性
    local double = DataCenter.gatherSoulUtil.double_soul; --双属性
    if self.prop_type == 1 then 
        if self.soul_type == 2 then
            decomposeNum = 0;
        else
            if self.soul_level ~= 0 then
                for i=1, self.soul_level do
                    local s = single[self.config.color][i];
                    decomposeNum = decomposeNum + s;
                end
            else
                decomposeNum = 0;
            end
        end
    else
        if self.soul_level ~= 0 then
            for i=1, self.soul_level do
                local s = double[self.config.color][i];
                decomposeNum = decomposeNum + s;
            end
        else
            decomposeNum = 0;
        end
    end

    return decomposeNum;
end

-------------------------------------------------------------------------------------------------------------------------------------
-- 穿戴红点处理

function Lua_GatherSoulVo.Get:isShowDressRed()
    if DataCenter.roleData.level < self.useLvl then
        return false;
    end

    local isUnlockCoreSoul = DataCenter.gatherSoulData.getIsUnlockCoreSoul;-- 是否解锁核心灵魂
    local isAdornCoreSoul = DataCenter.gatherSoulData.getIsAdornCoreSoul;  -- 是否佩戴核心灵魂
    local IsMaxAdornSoul = DataCenter.gatherSoulData.isAllAdornSoul;       -- 普通 解锁槽是否已经佩戴满灵魂

    if self.soul_type == 0 then --普通类型
        if IsMaxAdornSoul == true then --解锁槽 可佩戴
            if self.prop_type == 1 then
                -- print("是否是同属性   = 单 = ",DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.s_only))
                if DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.s_only) ~= true then-- 是否是同属性
                    return true;
                end
            else
                -- print("是否是同属性   = 双 = ",DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.b_only[1]),"   ",DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.b_only[2]))
                if DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.b_only[1]) ~= true and
                DataCenter.gatherSoulData:isSameTypeInlayAndPack(self.b_only[2]) ~= true then
                    return true;
                end
            end
        end
    elseif self.soul_type == 1 then--核心灵魂 
        if isUnlockCoreSoul == true and isAdornCoreSoul ~= true then
            return true;
        end
    end

    return false;
end