checkRequire("Lua_ItemCombineVo");
-- checkRequire("compose");
-- checkRequire("combine_list");
Lua_ItemCombineUtil = class("Lua_ItemCombineUtil");
Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG = 701
Lua_ItemCombineUtil.SHENSHOU_EQUIP_HECHENG2 = 702
function Lua_ItemCombineUtil:ctor()
	self:superCall("ctor");

	self:dispose();
end

function Lua_ItemCombineUtil:dispose()
	self.bIconRedDotState = false;
	self.combineRedInfo = {};
	self.combineSubRedInfo = {};
end

function Lua_ItemCombineUtil:getCombineListById(t)
	if self.combineAllInfo == nil then
		self.combineAllInfo = {};

		local vo;
		local config = getConfig({ "compose" });
		for i, v in pairs(config) do
			vo = Lua_ItemCombineVo.new(tonumber(i));
			if self.combineAllInfo[v.type] == nil then
				self.combineAllInfo[v.type] = Array();
			end
			self.combineAllInfo[v.type]:add(vo);
		end

		for k, v in pairs(self.combineAllInfo) do
			v:sort("priority", false);
		end
	end
	return self.combineAllInfo[t];
end

function Lua_ItemCombineUtil.Get:combineTitleList()
	local arr = Array();
	local configDic = getConfig({ "combine_list", "tlist" });
	for i = 1, #configDic do
		if configDic[i].sub == nil then
			arr:add(configDic[i]);
		else
			local isOpen = true;
			if configDic[i].open_lvl ~= nil then
				if configDic[i].open_lvl > DataCenter.roleData.level then
					isOpen = false;
				end
			end

			if isOpen == true then
				local subArr = Array();
				for j = 1, #configDic[i].sub do
					configDic[i].sub[j].mainName = configDic[i].name;
					subArr:add(configDic[i].sub[j]);
				end
				arr:add({name = configDic[i].name, data = configDic[i].data,
					career = configDic[i].career, sub = subArr, index = i});
			end
		end
	end
	return arr;
end

function Lua_ItemCombineUtil:checkCombineRedDot()
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	self.bIconRedDotState = false;
	self.combineRedInfo = { };
	self.combineSubRedInfo = { };
	local arr = self.combineTitleList;
	local len = arr:getSize();
	for i = 1, len do
		local redNum = 0;
		local obj = arr[i];
		self.combineSubRedInfo[obj.name] = {};
		if obj.sub ~= nil then
			local subArr = obj.sub;
			local subLen = subArr:getSize();
			for j = 1, subLen do
				local num = 0;
				local list = self:getCombineListById(subArr[j].data);
				if list ~= nil then
					local listLen = list:getSize();
					for k = 1, listLen do
						local vo = list[k];
						if vo:checkRedDotState() == true then
							self.bIconRedDotState = true;
							num = num + 1;
						end
					end
					redNum = redNum + num;
					self.combineSubRedInfo[obj.name][j] = num > 0 and true or false;
				end
			end
		else
			local list = self:getCombineListById(obj.data);
			local listLen = list:getSize();
			for k = 1, listLen do
				local vo = list[k];
				if vo:checkRedDotState() == true then
					self.bIconRedDotState = true;
					redNum = redNum + 1;
				end
			end
		end
		self.combineRedInfo[i] = redNum > 0 and true or false;
	end
	Lua_MsgUtil.callFunc("BAG_COMBINE_REDDOTSTATE_CHANGE", self.bIconRedDotState);
end

function Lua_ItemCombineUtil.Get:selectClass()
	-- 选择大类,
	if self.calss_info == nil then
		self.calss_info = getConfig({ "combine_list" });
	end

	local arr = self.calss_info.tlist;
	for i = 1, #arr do
		local arr1 = arr[i].sub;
		for j = 1, #arr1 do
			if arr1[j].data == self.selectCombineId then
				return i;
			end
		end
	end
	return nil;
end

function Lua_ItemCombineUtil.Get:selectGroup()
	-- 选择小类
	if self.calss_info == nil then
		self.calss_info = getConfig({ "combine_list" });
	end

	local arr = self.calss_info.tlist;
	for i = 1, #arr do
		local arr1 = arr[i].sub;
		for j = 1, #arr1 do
			if arr1[j].data == self.selectCombineId then
				return j;
			end
		end
	end
	return nil;
end