Lua_ItemCombineVo = class("Lua_ItemCombineVo");
function Lua_ItemCombineVo:ctor(id)
    self.id = id;
    self.config = getConfig( { "compose", id });
end
function Lua_ItemCombineVo.Get:name()
    return self.config.name;
end
function Lua_ItemCombineVo.Get:priority()
    return self.config.priority;
end
function Lua_ItemCombineVo.Get:rate()
    return self.config.rate;
end
function Lua_ItemCombineVo.Get:rateCount()
    return self.config.rate_count;
end
function Lua_ItemCombineVo.Get:output()
    return self.config.output;
end
function Lua_ItemCombineVo.Get:type()
    return self.config.type;
end

function Lua_ItemCombineVo.Get:equip()
    return self.config.equip;
end

function Lua_ItemCombineVo.Get:star()
    return self.config.star;
end

function Lua_ItemCombineVo.Get:materials()
    local arr = Array();
    if self.config.materials ~= nil then
        for i, v in ipairs(self.config.materials) do
            arr:add(Lua_ToolVo.createToolVo(tonumber(v[1]), tonumber(v[2])));
        end
    end
    return arr;
end
function Lua_ItemCombineVo.Get:rateItem()
    local arr = Array();
    if self.config.rate_item ~= nil then
        for i, v in ipairs(self.config.rate_item) do
            arr:add( { itemId = tonumber(v[1]), rate = tonumber(v[2]) });
        end
    end
    return arr;
end
function Lua_ItemCombineVo:getRateItemRate(val)
    if self.config.rate_item == nil then
        return 0;
    end
    for i, v in ipairs(self.config.rate_item) do
        if v[1] == val then
            return v[2];
        end
    end
    return 0;
end

function Lua_ItemCombineVo:checkRedDotState()
    self.redDotState = true;
    local useNumDic = { };
    local isSelectBox = DataCenter.packData.isSelectBox
    local list = self.materials;
    local len = list:getSize();
    local overNum = 0;
    for i = 1, len do
        local bagNum;
        if isSelectBox == true and self.universal_item ~= nil then
            bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(list[i].id) + self.universal_item.bagNum;
        else
            bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(list[i].id);
        end
        local itemList = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsById(list[i].id);
        if itemList ~= nil then
            for j = 1, itemList:getSize() do
                if itemList[j].fairyVo ~= nil and itemList[j].fairyVo.expireTimes ~= nil then
                    if itemList[j].fairyVo.isUsed == 1 then
                        local leftTime = itemList[j].fairyVo.expireTimes - DataCenter.roleData.serverTime;
                        if leftTime <= 0 then
                            overNum = overNum + 1;
                        end
                    end
                end
            end
        end
        if useNumDic[list[i].id] == nil then
            useNumDic[list[i].id] = 0;
        end
        useNumDic[list[i].id] = useNumDic[list[i].id] + list[i].count;
        local useNum = useNumDic[list[i].id];
        local leftNum = bagNum - useNum - overNum;
        if leftNum < 0 then
            self.redDotState = false;
            break;
        end
    end
    if self.equip ~= nil then
        local needNum = #self.equip
        local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
        local _arr = bagData:getBagAllData();
        local _len = _arr:getSize()
        local hadCount = 0
        for i = 1, _len do
            if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU and _arr[i].color == self.equip[1][1] and _arr[i].star == self.equip[1][2] then
                hadCount = hadCount + 1
            end
        end
        if hadCount >= needNum then
            self.redDotState = self.redDotState and true
        else
            self.redDotState = false
        end
    end
    return self.redDotState;
end

function Lua_ItemCombineVo.Get:universal_item()
    -- 万能道具
    if self.config.universal_item ~= nil then
        local tvo = Lua_ToolVo.createToolVo(self.config.universal_item);
        tvo.packType = 999;
        tvo.bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.config.universal_item);
        return tvo;
    end
    return nil;
end