Lua_MoneyData = class("Lua_MoneyData");
Lua_MoneyData.COPPER = 209000001; -- 铜钱
Lua_MoneyData.BIND_GOLD = 209000002; -- 金条
Lua_MoneyData.GOLD = 209000003; -- 钻石
Lua_MoneyData.RONGYU = 209000004;
Lua_MoneyData.GONGXIAN = 209000005;
Lua_MoneyData.EXP = 209000006;
Lua_MoneyData.SAVVY = 209000008;
Lua_MoneyData.SHENGWANG = 209000010;
Lua_MoneyData.COPY_JIFEN = 209000011;
Lua_MoneyData.JEWEL = 209000020;
Lua_MoneyData.BIND_COPPER = 4;
Lua_MoneyData.GOLD_AND_BINDGOLD = 8;
Lua_MoneyData.COPPER_AND_BINDCOPPER = 9;
function Lua_MoneyData.getIconSpByMoneyType(moneyId)
	return "money_" .. moneyId;
end

function Lua_MoneyData.getMoneyIconAtlas(moneyId)
	return "icon_atlas_3";
end

function Lua_MoneyData:ctor()
	self.moneyDic = {};
end

function Lua_MoneyData:dispose()
	self.moneyDic = {};
end

-- money的名字
function Lua_MoneyData:getNameByType(moneyType)
	if moneyType == Lua_MoneyData.GOLD then
		return LanUtil.getValue(143305);
	elseif moneyType == Lua_MoneyData.BIND_GOLD then
		return LanUtil.getValue(143306);
	elseif moneyType == Lua_MoneyData.COPPER then
		return LanUtil.getValue(143307);
	end
	return "";
end

function Lua_MoneyData:isMoney(moneyType)
	return
	moneyType == Lua_MoneyData.GOLD
	or moneyType == Lua_MoneyData.BIND_GOLD
	or moneyType == Lua_MoneyData.COPPER
	or moneyType == Lua_MoneyData.SAVVY
	or moneyType == Lua_MoneyData.EXP
	or moneyType == Lua_MoneyData.COPY_JIFEN
	or moneyType == Lua_MoneyData.SHENGWANG
	or moneyType == Lua_MoneyData.RONGYU;
end

function Lua_MoneyData:getMoney(moneyType)
	local myNum = 0;
	if moneyType == Lua_MoneyData.GOLD_AND_BINDGOLD then
		myNum = self:getMoney(Lua_MoneyData.GOLD) + self:getMoney(Lua_MoneyData.BIND_GOLD);
	elseif moneyType == Lua_MoneyData.COPPER_AND_BINDCOPPER then
		myNum = self:getMoney(Lua_MoneyData.COPPER) + self:getMoney(Lua_MoneyData.BIND_COPPER);
	else
		if self.moneyDic[moneyType] == nil then
			myNum = 0;
		else
			myNum = self.moneyDic[moneyType];
		end
	end
	return myNum;
end

function Lua_MoneyData:setMoney(moneyType, moneyCount)
	self.moneyDic[moneyType] = tonumber(tostring(moneyCount));
end

function Lua_MoneyData:kuaFuLimit()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {des = LanUtil.getValue(120867), type = 2});
end

function Lua_MoneyData:isMoneyEnough(t, needNum, showTips, showGotoCharge)
	local isEnough = self:getMoney(t) >= needNum;
	if isEnough == false then
		local str;
		if t == Lua_MoneyData.GOLD or t == Lua_MoneyData.BIND_GOLD or t == Lua_MoneyData.GOLD_AND_BINDGOLD then
			str = LanUtil.getValue(110815);
		elseif t == Lua_MoneyData.COPPER or t == Lua_MoneyData.BIND_COPPER or t == Lua_MoneyData.COPPER_AND_BINDCOPPER then
			str = LanUtil.getValue(110816);
		elseif t == Lua_MoneyData.SAVVY then
			str = LanUtil.getValue(110633);
		elseif t == Lua_MoneyData.JEWEL then
			str = LanUtil.getValue(121750);
		else
			str = LanUtil.getValue(110817);
		end
		if showTips == true then
			OperateAlert.show(str);
		end

		if showGotoCharge == true then
			if (t == Lua_MoneyData.GOLD or t == Lua_MoneyData.BIND_GOLD or t == Lua_MoneyData.GOLD_AND_BINDGOLD) then
				Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
					owner = self,
					des = LanUtil.getValue(110818),
					type = 1,
					subFun = self.onSubCallback
				});
			elseif t == Lua_MoneyData.JEWEL then
				Lua_WindowUtil.openWin("Lua_ExchangeJewelWindow", WinParam.ACTION_OPEN);
			end
		end
	end
	return isEnough;
end

function Lua_MoneyData:onSubCallback(d)
	Lua_WindowUtil.openWin("Lua_CopyYinYuanWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyXieLingWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyJueXingWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyLingWenWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyMoneyWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyQiankunWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_BuyTimesWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_BossCopyBuyTimesWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_DailyRoutineWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyShenLianWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyJunHunWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
end

function Lua_MoneyData:showReconfigPanel(num, owner, callbackFun)
	if getLanType() == 0 then
		callbackFun(owner);
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
		owner = owner,
		des = LanUtil.formateStr(LanUtil.getValue(121225), tostring(num)),
		type = 1,
		subFun = callbackFun
	});
end

-- 元宝兑换钻石比例（韩服）
function Lua_MoneyData.Get:exchange_power()
	return getConfig({ "tiny", "diamond_exchange_rate" }); -- 比例
end

-- 输入框最大（韩服）
function Lua_MoneyData.Get:max_sell_num()
	return Lua_CommonUtil.getCommonConfig("max_sell_num", 1);
end

-- 最大转换钻石（韩服）
function Lua_MoneyData.Get:max_exchange_jewel()
	local money = self:getMoney(Lua_MoneyData.GOLD);
	local num = money * self.exchange_power;
	if num >= self.max_sell_num then
		num = self.max_sell_num;
	end
	return num;
end