checkRequire("Lua_ToolVo");
Lua_PackData = class("Lua_PackData");
Lua_PackData.EQU_PACK = 1;
Lua_PackData.BAG_PACK = 2; --
Lua_PackData.LW_PACK = 3; -- 灵纹背包
Lua_PackData.WHARE = 5; -- 仓库背包
Lua_PackData.TREASURE_SOTRE = 6; -- 藏宝阁临时仓库
Lua_PackData.FACTION_WHARE = 7; -- 帮派仓库背包
Lua_PackData.FACTION_DONATE_BAG = 8; -- 帮派仓库捐献装备背包（用的时背包装备数据）
Lua_PackData.SACRED_ANIMAL_BAG = 9; -- 魂兽装备背包
Lua_PackData.JH_PACK = 11; -- 聚魂背包
Lua_PackData.CARD_PACK = 12; -- 武库卡牌背包
Lua_PackData.PEAK_SOTRE = 13; -- 藏宝阁巅峰抽奖临时仓库
Lua_PackData.STAMP_PACK = 14; -- 魂印背包
Lua_PackData.ARMY_PACK = 15; -- 军团背包
Lua_PackData.PAGODA_PACK = 16; -- 玲珑宝塔临时仓库
Lua_PackData.ZODIAC_PACK = 17; -- 生肖背包
Lua_PackData.SECRET_PACK = 18; -- 秘藏临时仓库
function Lua_PackData:ctor()
	self.packList = {};
	self.useTimes = {};
	self.maxPackSize = 150;
	self.showSalePanel = false;
	self.showWharePanel = false;
	self.showFactionDonateEquPanel = false;
end

function Lua_PackData:dispose()
	self.packList = {};
	self.useTimes = {};
	self._windowData = nil
	DataCenter.combineUtil:dispose();
end

function Lua_PackData:getBagType(bagType)
	if self.packList[bagType] == nil then
		self.packList[bagType] = Lua_PackSingleData.new(bagType);
	end
	return self.packList[bagType];
end

function Lua_PackData:getUseTime(itemId)
	if self.useTimes[itemId] == nil then
		return 0;
	end
	return self.useTimes[itemId];
end

function Lua_PackData:sGSBackGift(id, index, actiCode)
	local cmd = ProtoPublic_pb.Proto11400031();
	cmd.item_id = id; -- 物品id
	cmd.index = index; -- 物品索引
	cmd.acti_code = actiCode; -- 不需要激活码的就置空
	sendMsg(11400031, cmd);
end

function Lua_PackData:showFullBagTip(bagType)
	if bagType == Lua_PackData.BAG_PACK then
		Lua_WindowUtil.openWin("Lua_PackFullWindow", WinParam.ACTION_OPEN);
	end
end

function Lua_PackData.Set:PackWindowData(data)
	self._windowData = data
end

function Lua_PackData.Get:PackWindowData()
	if self._windowData == nil then
		return nil
	end
	return self._windowData
end





Lua_PackSingleData = class("Lua_PackSingleData");
function Lua_PackSingleData:ctor(bagType)
	self.packType = bagType;
	self.typeItemList = {};
	self.itemIndexList = {};
	self.reorderTime = 0;
	self.saleDic = {};
	self.coolDic = {};
end

function Lua_PackSingleData:getCoolTime(val)
	return self.coolDic[val.subType];
end

function Lua_PackSingleData:setCool(val)
	if val.cool ~= 0 then
		self.coolDic[val.subType] = UnityEngine.Time.realtimeSinceStartup + val.cool + 1;
	end
end

function Lua_PackSingleData:isCool(val)
	if self.coolDic[val.subType] == nil then
		return false;
	end
	return UnityEngine.Time.realtimeSinceStartup <= self.coolDic[val.subType];
end

function Lua_PackSingleData:clearSaleList()
	self.saleDic = {};
end

function Lua_PackSingleData:getUsedSize()
	local len = 0;
	for k, v in pairs(self.itemIndexList) do
		len = len + 1;
	end
	return len;
end

function Lua_PackSingleData:saleBlueAndGreen()
	local arr = self:getItemsBySubType( { Lua_PackTypeDefine.EQUIP });
	local saleList = Array();
	for i = 1, arr:getSize() do
		if arr[i].color <= 2 and Lua_PackUtil.isBetterThen(arr[i]) == false then
			saleList:add(arr[i]);
		end
	end
	Lua_PackUtil.soleItems(saleList);
end

function Lua_PackSingleData:getLeftSize()
	return self.packSize - self:getUsedSize();
end

function Lua_PackSingleData:fromServer(packType, list, strengthen)
	local tvo;
	self.typeItemList = {};
	self.itemIndexList = {};
	for i, v in ipairs(list) do
		tvo = Lua_ToolVo.createToolVo(v.id, 1, 1);
		tvo:fromServer(v);
		tvo.packType = packType;
		if strengthen ~= nil and strengthen[i] ~= nil then
			tvo.strengthen = strengthen[i];
		end
		tvo.packType = packType;
		self:addOneItem(tvo);
	end

	if packType == Lua_PackData.SACRED_ANIMAL_BAG then
		Lua_MsgUtil.callFunc("PACK_ANIMALINFO_UPDATE");
	end
	Lua_MsgUtil.callFunc("PACK_INIT_INFO");
end

function Lua_PackSingleData:reoder(must)
	if must == true or getTime() - self.reorderTime > 3 then
		self.reorderTime = getTime();

		local msg = ProtoPublic_pb.Proto11400104();
		msg.pack_type = self.packType;
		for k, v in pairs(self.itemIndexList) do
			if v ~= nil and v.force ~= 0 then
				local p = ProtoPublic_pb.ProtoPairObj();
				p.obj_id = v.index;
				p.obj_value = v.force;
				msg.force_list:addToList(p);
			end
		end
		sendMsg(11400104, msg);
	end
end

function Lua_PackSingleData:addOneItem(oneItem)
	local sortType = oneItem.subType;
	if self.typeItemList[sortType] == nil then
		self.typeItemList[sortType] = {};
	end

	if self.typeItemList[sortType][oneItem.index] == nil then
		self.typeItemList[sortType][oneItem.index] = oneItem;
		self.itemIndexList[oneItem.index] = oneItem;
	else
		local oldItem = self.typeItemList[sortType][oneItem.index];
		oldItem.count = oldItem.count + oneItem.count;
		self.typeItemList[sortType][oneItem.index] = oldItem;
		self.itemIndexList[oldItem.index] = oldItem;
	end
end

function Lua_PackSingleData:removeItemByServer(index, delNum)
	if self.itemIndexList[index] == nil then
		return;
	end

	local oldItem = self.itemIndexList[index];
	local sortType = oldItem.subType;
	if self.typeItemList[sortType] == nil then
		return;
	end
	if self.typeItemList[sortType][oldItem.index] == nil then
		return;
	end
	oldItem = self.typeItemList[sortType][oldItem.index];
	oldItem.count = oldItem.count - delNum;

	self.typeItemList[sortType][oldItem.index] = oldItem;
	self.itemIndexList[oldItem.index] = oldItem;
	if oldItem.count <= 0 then
		self.typeItemList[sortType][oldItem.index] = nil;
		self.itemIndexList[oldItem.index] = nil;
	end
	if oldItem.type == 1 then
		Lua_CommonUtil.delayCollectCall("delPackItem_" .. oldItem.type, self, self.onRemoveItemUpdate, oldItem.type, 0.2);
	end
end

function Lua_PackSingleData:onRemoveItemUpdate(packType)
	Lua_MsgUtil.callFunc("PACK_EQUIP_UPDATE");
end

function Lua_PackSingleData:removeOneItem(oneItem)
	local sortType = oneItem.subType;
	if self.typeItemList[sortType] == nil then
		return;
	end
	if self.typeItemList[sortType][oneItem.index] == nil then
		return;
	end

	local oldItem = self.typeItemList[sortType][oneItem.index];
	oldItem.count = oldItem.count - oneItem.count;
	
	self.typeItemList[sortType][oneItem.index] = oldItem;
	self.itemIndexList[oneItem.index] = oldItem;
	if oldItem.count <= 0 then
		self.typeItemList[sortType][oneItem.index] = nil;
		self.itemIndexList[oneItem.index] = nil;
	end
end

function Lua_PackSingleData:removeOneItemByIndex(index)
	if self.itemIndexList[index] == nil then
		return;
	end
	self:removeOneItem(self.itemIndexList[index]);
end

function Lua_PackSingleData:removeItems(list)
	for i, v in ipairs(list) do
		self:removeOneItemByIndex(v);
	end
end

function Lua_PackSingleData:getItemNum(id)
	local sortType = Lua_ToolVo.getSubType(id);
	if self.typeItemList[sortType] == nil then
		return 0;
	end

	local list = self.typeItemList[sortType];
	local num = 0;
	for k, v in pairs(list) do
		if v.id == id then
			num = num + v.count;
		end
	end
	return num;
end

function Lua_PackSingleData:getItemsById(id)
	local sortType = Lua_ToolVo.getSubType(id);
	if self.typeItemList[sortType] == nil then
		return nil;
	end

	local list = self.typeItemList[sortType];
	local tvoArr = Array();
	for k, v in pairs(list) do
		if v.id == id then
			tvoArr:add(v);
		end
	end
	tvoArr:sort("bind", true);
	return tvoArr;
end

function Lua_PackSingleData:getItemsBySubType(subTypes)
	local tvoArr = Array();
	for k, v in ipairs(subTypes) do
		if self.typeItemList[v] ~= nil then
			for l, w in pairs(self.typeItemList[v]) do
				tvoArr:add(w);
			end
		end
	end
	return tvoArr;
end

function Lua_PackSingleData:getItemByIndex(val)
	return self.itemIndexList[val];
end

function Lua_PackSingleData:getItemByItemId(id)
	local sortType = Lua_ToolVo.getSubType(id);
	if self.typeItemList[sortType] == nil then
		return nil;
	end

	local list = self.typeItemList[sortType];
	for k, v in pairs(list) do
		if v.id == id then
			return v;
		end
	end
	return nil;
end

function Lua_PackSingleData:getBagAllData()
	local tvoArr = Array();
	for k, v in pairs(self.itemIndexList) do
		if v ~= nil then
			tvoArr:add(v);
		end
	end
	return tvoArr;
end