Lua_RewardData = class("Lua_RewardData");
function Lua_RewardData:ctor(id, config)
	self.id = id;
	self.config = config;
end

function Lua_RewardData.Get:rewards()
	if self._rewards == nil then
		self._rewards = {};

		local effectDic = {};
		if self.show_item_effect ~= nil then
			for i,v in ipairs(self.show_item_effect) do
				effectDic[v] = 1;
			end
		end

		if self.client_goods_list ~= nil then
			local itemCfg;
			local canShow;
			local itemID;
			local idx = 1;
			for i,v in ipairs(self.client_goods_list) do
				if self.configCareer ~= nil and self.configCareer == 1 then
					itemCfg = getConfig({"item", v[1]});
					canShow = false;
					if itemCfg.career == nil or itemCfg.career == 0 then
						canShow = true;
					elseif (itemCfg.type == 1 or itemCfg.type == 3) and itemCfg.career == DataCenter.roleData.career then
						canShow = true;
					end
					itemID = v[1];
				else
					canShow = true;
					itemID = self.isAdjust and self:checkCareerItem(v[1]) or v[1];
				end

				if canShow then
					self._rewards[idx] = {
						id = itemID,
						amount = v[2],
						bind = v[3],
						star = v[5] == nil and 0 or v[5],
						attr = self:getAttr(v[6]),
						roundEffect = effectDic[i - 1] ~= nil
					};
					idx = idx + 1;
				end
			end
		end
	end
	return self._rewards;
end

function Lua_RewardData:getAttr(info)
	local attrDic;
	if info ~= nil and info ~= 0 then
		attrDic = {};
		for k,v in ipairs(info) do
			attrDic[k] = {attr_id = v[1], upper = v[2], lower = v[3], value = v[3], color = v[4]};
		end
	end
	return attrDic;
end

function Lua_RewardData:checkCareerItem(itemId)
	if self.career_change_item == nil then
		return itemId;
	end

	for k,v in ipairs(self.career_change_item) do
		for i,j in ipairs(v) do
			if j == itemId then
				return v[DataCenter.roleData.career];
			end
		end
	end
	return itemId;
end

function Lua_RewardData.Get:show_item_effect()
	return self.config.show_item_effect;
end

function Lua_RewardData.Get:client_goods_list()
	return self.config.client_goods_list;
end

function Lua_RewardData.Get:configCareer()
	return self.config.career;
end

function Lua_RewardData.Get:isAdjust()
	return self.config.career_adjust == 1;
end

function Lua_RewardData.Get:career_change_item()
	return self.config.career_change_item;
end

function Lua_RewardData.Get:dropMarks()
	return self.config.show_drop_mark;
end

function Lua_RewardData.Get:rewardsVoArr()
	local obj;
	local tvo;
	local arr = Array();
	for i = 1, #self.rewards do
		obj = self.rewards[i];

		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind);
		tvo.star = obj.star;
		tvo.packType = 999;
		tvo.roundEffect = obj.roundEffect;
		if obj.attr ~= nil then
			tvo.equipment = {star = obj.star, attr = obj.attr};
		end
		arr:add(tvo);
	end
	return arr;
end