--魂印属性vo
Lua_StampVo = class("Lua_StampVo", Lua_ToolVo);
function Lua_StampVo:ctor(id, count, bin)
	self:superCall("ctor", id, count, bin);
end

-- 强化数据，强化最大等级
function Lua_StampVo.Get:max_intensify_lvl()
	local list = getConfig({"soul_imprint", "max_intensify_lvl", "arr"});
	return list[self.order];
end

-- 强化消耗
function Lua_StampVo.Get:intensify_expend()
	local list = getConfig({"soul_imprint_type", self.stamp_type, "upgrade_value",});
	if self.isMaxLvl then
		return tonumber(list[self.intensify_lvl][4])
	else
		return tonumber(list[self.intensify_lvl + 1][4]);
	end
end

-- 强化最大
function Lua_StampVo.Get:intensify_max_bar()
	local list = getConfig({"soul_imprint_type", self.stamp_type, "upgrade_value"});
	if self.isMaxLvl then
		return tonumber(list[self.intensify_lvl][3]);
	else
		return tonumber(list[self.intensify_lvl + 1][3]);
	end
end

-- 是否达到最大强化等级
function Lua_StampVo.Get:isMaxLvl()
	if self.intensify_lvl == nil then
		return false;
	else
		if self.intensify_lvl >= self.max_intensify_lvl then
			return true;
		else
			return false;
		end
	end
end

-- 是否可以强化
function Lua_StampVo.Get:isCanIntensify()
	if self.isMaxLvl ~= true and DataCenter.stampData.stamp_crystal >= self.intensify_expend then
		return true
	end
	return false
end

-- 穿戴数据，魂印穿戴位置名称
function Lua_StampVo.Get:part_name()
	return getConfig({"soul_imprint_part", self.part, "remark"})
end

-- 魂印穿戴位置名称
function Lua_StampVo.Get:stamp_part_Type()
	return getConfig({"soul_imprint_type", self.stamp_type, "remark"})
end

-- 魂印类型：魔印 1，仙印 2，神印 3，特殊材料 0
function Lua_StampVo.Get:stamp_type()
	return self.config.stamp_type;
end

-- 魂印特效
function Lua_StampVo.Get:stamp_effect()
	return self.config.stamp_effect;
end

-- 是否可以拆解 标记
function Lua_StampVo.Get:getCohesionInfo()
	if self.compoundDic == nil then
		self.compoundDic = {};
		local config = getConfig({"soul_imprint_compose"});
		if config ~= nil then
			for k, v in pairs(config) do
				self.compoundDic[k] = 1;
			end
		end
	end
	return self.compoundDic;
end

-- 是否可以拆解
function Lua_StampVo.Get:isCanCohesion()
	if self.getCohesionInfo[self.id] == 1 then
		return true;
	end
	return false;
end

-- 是否是相同类型
function Lua_StampVo.Get:isSameType()
	if self.stamp_type ~= 0 then
		if DataCenter.stampData:getArrByStampInfo(self.part) ~= nil then -- 已佩戴
			return true;
		end
	end
	return false;
end

-- 魂印基础属性封装
function Lua_StampVo.Get:stampBaseProp()
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end

			local base = val[1];
			if Lua_ThingDefine.isPercentParam(v) then
				base = base.."%";
			end

			local s = Lua_ThingDefine.getParamName(v).."："..base;
			if self.intensify_lvl ~= nil and self.intensify_lvl > 0 then
				if self.intensify_lvl > self.max_intensify_lvl then
					self.intensify_lvl = self.max_intensify_lvl
				end

				local add = val[self.intensify_lvl+1]-val[1];
				if Lua_ThingDefine.isPercentParam(v) then
					add = add.."%";
				end

				if val[self.intensify_lvl+1]-val[1] ~= 0 then
					s = s.."    ["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.formateStr(LanUtil.getValue(110851), tostring(add)).."[-]";
				end
			end
			str = str..s;
		end
	end
	return str;
end

-- 魂印极品属性封装
function Lua_StampVo.Get:stampGoodProp()
	if self.attribute[2] == nil then
		return nil;
	end

	local str = "";
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[2], v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end

			local base = val[1];
			if Lua_ThingDefine.isPercentParam(v) then
				base = base.."%";
			end
			local s = "[FF57E9]"..Lua_ThingDefine.getParamName(v).."+"..base.."[-]";
			str = str..s;
		end
	end
	return str;
end

-- 魂印强化
function Lua_StampVo.Get:stampIntensifyProp()
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			if val[1] ~= val[2] then
				if str == "" then
					str = "";
				else
					str = str.."\n";
				end

				if self.intensify_lvl > self.max_intensify_lvl then
					self.intensify_lvl = self.max_intensify_lvl
				end

				local base = val[self.intensify_lvl+1];
				if Lua_ThingDefine.isPercentParam(v) then
					base = base.."%";
				end
				local s = "[85A8BE]"..Lua_ThingDefine.getParamName(v).."：".."[-]"..base;
				str = str..s;
			end
		end
	end
	return str;
end

-- 魂印下级强化
function Lua_StampVo.Get:stampNextIntensifyProp()
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			if val[1] ~= val[2] then
				if str == "" then
					str = "";
				else
					str = str.."\n";
				end

				local add = val[self.intensify_lvl+2];
				if Lua_ThingDefine.isPercentParam(v) then
					add = add.."%";
				end
				str = str..add;
			end
		end
	end
	return str;
end

-- 魂印强化
-- function Lua_StampVo.Get:stampIntensifyProp()
-- 	local arr = Array();
-- 	for k,v in ipairs(Lua_ThingDefine.params) do
-- 		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
-- 		if val ~= nil then
-- 			local base = val[self.intensify_lvl+1];
-- 			if Lua_ThingDefine.isPercentParam(v) then
-- 				base = base.."%";
-- 			end
-- 			local s = "[3f6180]"..Lua_ThingDefine.getParamName(v)..":".."[-]".."[3f6180]"..base.."[-]";
-- 			arr:add(s); 
-- 		end
-- 	end
-- 	return arr;
-- end

-- 下级强化属性
-- function Lua_StampVo.Get:stampNextIntensifyProp()
-- 	local arr = Array();
-- 	for k,v in ipairs(Lua_ThingDefine.params) do
-- 		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
-- 		if val ~= nil then
-- 			local add = val[self.intensify_lvl+2];
-- 			if Lua_ThingDefine.isPercentParam(v) then
-- 				add = add.."%";
-- 			end
-- 			arr:add(add); 
-- 		end
-- 	end
-- 	return arr;
-- end

-- 总属性 用于战力计算
function Lua_StampVo.Get:stampAttr()
	if self.stamp_type == 0 then
		return nil;
	end

	if self.intensify_lvl == nil then
		self.intensify_lvl = 0;
	end

	local list = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			if self.intensify_lvl > 0 then
				list[v] = val[self.intensify_lvl+1] + val[1];
			else
				list[v] = val[1];
			end
		end
	end
	return list;
end

-- 极品属性 战力
function Lua_StampVo.Get:stampGoodForce()
	if self.stamp_type == 0 then
		return nil;
	end

	if self.attribute[2] == nil then
		return 0;
	end

	local list = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[2], v});
		if val ~= nil then
			list[v] = val[1];
		end
	end

	local force = Lua_FightUtil.caculateConfigForce(list);
	return force;
end

-- 基础属性战力
function Lua_StampVo.Get:stampBascForce()
	if self.stamp_type == 0 then
		return nil;
	end

	local list = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			list[v] = val[1];
		end
	end
	return Lua_FightUtil.caculateConfigForce(list) + self.stampGoodForce;
end

-- 特殊属性
function Lua_StampVo.Get:stampSpecialAttr()
	local str = "";
	for k,v in ipairs(Lua_ThingDefine.specialParams) do
		local val = getConfig({"soul_imprint_prop", self.attribute[1], v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end
			local s = Lua_ThingDefine.getParamName(v).."："..val[1];
			str = str..s;
		end
	end

	if str == "" then
		return nil;
	end
	return str;
end

-- 分解
function Lua_StampVo.Get:decompose()
	return getConfig({"soul_imprint_decompose", self.id, "decompose_value"});
end

-- 套装数据，是否显示套装属性
function Lua_StampVo.Get:isShowItemSuit()
	if DataCenter.stampUtil:getSuitInfo(self.id) ~= nil then
		return DataCenter.stampUtil:getSuitInfo(self.id);
	else
		return nil;
	end
end

-- 套装属性
function Lua_StampVo.Get:showItemSuitAttr()
	return self.isShowItemSuit:showItemSuit(self.isSuit)
end

-- 套装名字
function Lua_StampVo.Get:suitName()
	return self.isShowItemSuit:name(self.isSuit);
end

-- 替换  红点处理
function Lua_StampVo.Get:isShowItemReplaceRed()
	if self.stamp_type ~= 0 then
		local vo = DataCenter.stampData:getArrByStampInfo(self.part);
		if vo ~= nil then
			if self.force > vo.stampVo.stampBascForce and DataCenter.roleData.level >= self.useLvl then
				return true;
			end
		end
	end
	return false;
end