checkRequire("Lua_PackTypeDefine");
checkRequire("Lua_ThingDefine");
checkRequire("Lua_FairyVo");
Lua_ToolVo = class("Lua_ToolVo");
function Lua_ToolVo.getSubType(id)
    local c = getConfig( { "item", id });
    if c == nil then
        CommonUtil.logError("no item config " .. id);
    end
    if c.subType ~= nil then
        return c.subType;
    end
    return 0;
end

function Lua_ToolVo.createToolVo(id, count, bind)
    local c = getConfig( { "item", id });
    if id ~= 0 and c == nil then
        CommonUtil.logError("no item config " .. id);
    end
    if id == 0 or c.type == 1 then
        if id ~= 0 and c.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then
            return Lua_ZodiacEquipVo.new(id, count, bind);
        end
        return Lua_EquipVo.new(id, count, bind);
    elseif c.type == 7 then
        return Lua_RuneVo.new(id, count, bind);
    elseif c.type == 8 then
        return Lua_GatherSoulVo.new(id, count, bind);
    elseif c.type == 11 then
        return Lua_CardVo.new(id, count, bind);
    elseif c.type == 12 then
        return Lua_StampVo.new(id, count, bind);
    elseif c.type == 13 then
        return Lua_ArmyEquipVo.new(id, count, bind);   
    else
        return Lua_ToolVo.new(id, count, bind);
    end
end

function Lua_ToolVo:ctor(id, count, bind)
    self.id = id;
    self.count = count == nil and 0 or count;
    self.bind = bind == nil and 0 or bind;
    self.config = getConfig( { "item", id });
    self.stream_id = 0;
    self.star = 0;
    if id ~= 0 and self.config == nil then
        CommonUtil.logError("no item config " .. id);
    end
end
function Lua_ToolVo.Get:strengthen()
    return self._strengthen;
end
function Lua_ToolVo.Set:strengthen(val)
    self._strengthen = val;
end
function Lua_ToolVo:fromServer(val)
    self.index = val.index;
    self.count = val.amount;
    self.bind = val.bind;
    self.useTick = val.use_tick;
    self._serverUseTime = val.use_times;
    self.newTag = val.new_tag == 0 and 1 or 0;
    self.uniqueId = val.unique_id;
    self.timeOut = tonumber(val.timeout); -- 到期时间戳，0表示非限时物品
    self.effective_time = tonumber(val.effective_time);
    self.stream_id = val.stream_id;
    self.show_effect = val.show_effect;
    self.item_describe = val.item_describe;
    -- 后台礼包
    if val.gs_back_gift ~= nil then
        self.gs_back_gift = val.gs_back_gift
        self:onInterpretingData()
    end

    -- 星级
    if val.equipment ~= nil then
        self.star = val.equipment.star;
    elseif val.equip ~= nil then
        -- 市场 装备星级兼容
        self.star = val.start;
    else
        self.star = 0;
    end

    -- 神兽等级
    if self.id ~= 0 and val.equipment ~= nil and self.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
        self.gm_level = val.equipment.gm_level;
    elseif self.id ~= 0 and val.equip ~= nil and self.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
        -- 市场 神兽等级兼容
        self.gm_level = val.equip.gm_level;
    else
        self.gm_level = 0;
    end

    -- 卡牌等级
    if val.equipment ~= nil then
        self.card_level = val.equipment.card_level;
    elseif val.equip ~= nil then
        -- 市场 卡牌等级兼容
        self.card_level = val.equip.card_level;
    else
        self.card_level = 0;
    end

    -- 灵纹等级
    if val.rune_info ~= nil then
        self.rune_level = val.rune_info.rune_level
    end

    -- 灵魂等级
    if val.soul_item ~= nil then
        self.soul_level = val.soul_item.soul_level;
    end

    -- 装备数据
    if val.equipment ~= nil then
        self.equipment = val.equipment;
    elseif val.equip ~= nil then
        -- 市场 装备数据兼容
        self.equipment = val.equip;
        self.count = val.item_amount;
    end

    -- 精灵
    if val.fairy_info ~= nil then
        self.fairyType = val.fairy_info.fairy_type;
        if (self.fairyType ~= nil and self.fairyType ~= 0) then
            self.fairyVo = Lua_FairyVo.new(self.fairyType);
            self.fairyVo:fromServer(val);
        end
    end

    -- 神翼
    if val.wing_equip ~= nil then
        if val.wing_equip.is_generated_attri ~= 0 then
            self.wingAttr = val.wing_equip.wing_attri;
        end
    elseif val.wing_info ~= nil and self.id ~= 0 and self.subType == Lua_PackTypeDefine.WING_ITEM then
        -- 市场 神翼数据兼容
        self.wingAttr = val.wing_info.wing_attri;
        self.wingJieNum = val.wing_info.wing_class;
        self.wingColor = val.wing_info.wing_color;
        self.wingQualifications = tonumber(tostring(val.wing_info.qualifications));
        self.wingIsGenAttr = val.wing_info.is_generated_attri;
    end

    -- 神翼相关数据
    if self.id ~= 0
        and self.subType == Lua_PackTypeDefine.WING_ITEM
        and val.wing_equip ~= nil
        and val.wing_equip.is_generated_attri ~= 0 then
        self.wingAttr = val.wing_equip.wing_attri;
        -- 属性
        self.wingJieNum = val.wing_equip.wing_class;
        -- 神翼等阶
        self.wingColor = val.wing_equip.wing_color;
        -- 神翼品质
        self.wingQualifications = tonumber(tostring(val.wing_equip.qualifications));
        -- 神翼资质
        self.wingIsGenAttr = val.wing_equip.is_generated_attri;
        -- 是否生成过属性
    end
end
function Lua_ToolVo:onInterpretingData()
    -- 0不需要激活码，1需要激活码
    self.activateType = self.gs_back_gift.activate_type;
    -- gm名称
    self.gmName = self.gs_back_gift.gm_name;
    -- QQ账号
    self.qqAccount = self.gs_back_gift.qq_account;
    -- 礼包内容
    self.itemInfo = self.gs_back_gift.item_info;
    -- 特殊道具列表
    self.specialEffectItem = self.gs_back_gift.special_effect_item;
    -- 显示时间	
    self.tick = tonumber(self.gs_back_gift.tick);
    -- 服务器当前时间
    self.times = tonumber(self.gs_back_gift.time);
    self.residueTime = self.tick - self.times;
    self._getTime = getTime();
end

function Lua_ToolVo.Get:backGiftData()
    if self.itemInfo == nil then
        return Array();
    else
        local arr = Array();
        for i, v in ipairs(self.itemInfo) do
            local _list = { }
            _list.id = v.item_id;
            _list.count = v.amount;
            _list.bind = v.bind;
            _list.star = v.star;
            _list.roundEffect = false;
            arr:add(_list);
        end

        if self.specialEffectItem ~= nil then
            for i = 1, arr:getSize() do
                for x, y in ipairs(self.specialEffectItem) do
                    if arr[i].id == y then
                        arr[i].roundEffect = true;
                    end
                end
            end
        end
        return arr;
    end
end

function Lua_ToolVo.Get:treasureItemVo()
    local arr = Array()
    if self.itemInfo ~= nil then
        for k, v in ipairs(self.itemInfo) do
            local vo = Lua_ToolVo.new(v.item_id, v.amount, v.bind)
            vo.star = v.star
            arr:add(vo)
        end
    end
    return arr
end

function Lua_ToolVo.Get:gsBackGiftResidueTime()
    local num = self.residueTime -(getTime() - self._getTime);
    if num < 0 then
        num = 0;
    end
    num = math.floor(num);
    return num;
end

function Lua_ToolVo.Get:useTimes()
    if DataCenter.packData.useTimes[self.id] == nil then
        if self._serverUseTime == nil then
            return 0;
        end
        return self._serverUseTime;
    end
    return DataCenter.packData:getUseTime(self.id);
end

function Lua_ToolVo.Get:gm_maxLvl()
    if self.subType ~= Lua_PackTypeDefine.SHENSHOU_EQU then
        return 0;
    end
    local colorData = DataCenter.sacredAnimalData.configColorData;
    local high_lvl = colorData[tonumber(self.color .. "00" .. self.part)].high_Lvl
    return high_lvl;
end 
function Lua_ToolVo.Get:jipinForce()
    if self.equipment ~= nil and self.equipment.attr ~= nil and #self.equipment.attr > 0 then
        local v = Lua_FightUtil.caculateServerForce(self.equipment.attr);
        return v;
    end
    return 0;
end

function Lua_ToolVo.Get:force()
    self._force = 0;
    if self.equipment ~= nil and self.equipment.attr ~= nil and #self.equipment.attr > 0 then
        self._force = Lua_FightUtil.caculateConfigAndServer(self, self.equipment.attr, showP);
    else 
        self._force = Lua_FightUtil.caculateConfigForce(self);
    end

    if self.subType == Lua_PackTypeDefine.WING_ITEM then
        if self.wingAttr ~= nil then
            self._force = self._force + Lua_FightUtil.caculateConfigForce(self.wingAttr);
        else
            self._force = self._force + Lua_FightUtil.caculateConfigForce(self.attribute);
        end
    end

    if self.subType == Lua_PackTypeDefine.SPRITE then
        self._force = self._force + Lua_FightUtil.caculateConfigForce(self.attribute);
    end

    if self.subType == Lua_PackTypeDefine.CARD_ITEM and self.cardAttr ~= nil then
        -- 卡牌战力
        self._force = self._force + Lua_FightUtil.caculateConfigForce(self.cardAttr);
    end

    if self.subType == Lua_PackTypeDefine.STAMP_ITEM and self.stampAttr ~= nil then
        -- 魂印战力
        self._force = self.stampGoodForce + Lua_FightUtil.caculateConfigForce(self.stampAttr);
    end
    return self._force;
end

function Lua_ToolVo.Get:score()
    self._force = 0;
    if self.equipment ~= nil and self.equipment.attr ~= nil and #self.equipment.attr > 0 then
        self._force = Lua_FightUtil.caculateEquipScore(self, self.equipment.attr);
    else
        self._force = Lua_FightUtil.caculateEquipScore(self);
    end

    if self.subType == Lua_PackTypeDefine.WING_ITEM then
        if self.wingAttr ~= nil then
            self._force = self._force + Lua_FightUtil.caculateConfigForce(self.wingAttr);
        else
            self._force = self._force + Lua_FightUtil.caculateConfigForce(self.attribute);
        end
    end

    if self.subType == Lua_PackTypeDefine.SPRITE then
        self._force = self._force + Lua_FightUtil.caculateConfigForce(self.attribute);
    end

    if self.subType == Lua_PackTypeDefine.CARD_ITEM and self.cardAttr ~= nil then
        -- 卡牌战力
        self._force = self._force + Lua_FightUtil.caculateConfigForce(self.cardAttr);
    end

    if self.subType == Lua_PackTypeDefine.STAMP_ITEM and self.stampAttr ~= nil then
        -- 魂印战力
        self._force = self.stampGoodForce + Lua_FightUtil.caculateConfigForce(self.stampAttr);
    end
    return self._force;
end

function Lua_ToolVo.Get:xiLianGrades()
    local _arr = self.wash_attrs;
    local washArr = Array();
    if _arr ~= nil then
        for i = 1, #_arr do
            if _arr[i].open == true and _arr[i].attr.attr_id ~= 0 then
                washArr:add(_arr[i].attr);
            end
        end
    end
    return Lua_FightUtil.caculateServerForceArray(washArr);
end
function Lua_ToolVo:getQiangHuaValue(part, attValue, intensifyLevel)
    return getConfig( { "equipment_part", "intensify", part, attValue, intensifyLevel });
end
function Lua_ToolVo.Get:zongheForce()
    if self._zongheForce ~= nil and self.lastCaculateTime ~= nil and getTime() - self.lastCaculateTime < 1 then
        return self._zongheForce;
    end
    local baseForce = self.force;
    -- 强化战力
    local len = #Lua_ThingDefine.params;
    local strongDic = { };
    if self.intensifyLevel ~= nil and self.intensifyLevel ~= 0 then
        for i = 1, len do
            local v = self[Lua_ThingDefine.params[i]];
            if (v == nil or v == 0) and Lua_ThingDefine.params[i] == "attack" then
                v = self["attack_min"];
            end
            if v ~= nil and v ~= 0 then
                local strongVal = self:getQiangHuaValue(self.part, Lua_ThingDefine.params[i], self.intensifyLevel);
                strongDic[Lua_ThingDefine.params[i]] = strongVal;
            end
        end
        baseForce = baseForce + Lua_FightUtil.caculateConfigForce(strongDic);
    end
    -- 注灵战力
    if self.zhuLingAttr ~= nil and self.zhuLingAttr:getSize() > 0 then
        len = self.zhuLingAttr:getSize();
        strongDic = { };
        for i = 1, len do
            strongDic[self.zhuLingAttr[i].property] = self.zhuLingAttr[i].value;
        end
        baseForce = baseForce + Lua_FightUtil.caculateConfigForce(strongDic);
    end
    -- 神兽强化战力
    if self.subType == Lua_PackTypeDefine.SHENSHOU_EQU and self.gm_level ~= nil and self.gm_level ~= 0 then
        strongDic = { };
        for i = 1, len do
            local colorData = DataCenter.sacredAnimalData.configColorData;
            local v = self[Lua_ThingDefine.params[i]];
            if v ~= nil and v ~= 0 then
                if self.confingKey == nil then
                    self.confingKey = tonumber(self.color .. "00" .. self.part)
                end
                if colorData[self.confingKey][Lua_ThingDefine.params[i]] ~= nil then
                    local strongVal = colorData[self.confingKey][Lua_ThingDefine.params[i]][self.gm_level];
                    strongDic[Lua_ThingDefine.params[i]] = strongVal;
                end
            end
        end
        baseForce = baseForce + Lua_FightUtil.caculateConfigForce(strongDic);
    end

    -- 生肖装备强化战力
    if self.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM and self.intensifyLevel ~= nil and self.intensifyLevel ~= 0 then
        if self.intensifyAttrsDic ~= nil then
            strongDic = self.intensifyAttrsDic;
            baseForce = baseForce + Lua_FightUtil.caculateConfigForce(strongDic);
        end
    end

    -- 宝石战力
    local jewelForce = 0;
    for i = 1, 5 do
        if self.jewel ~= nil and self.jewel[i] ~= nil and self.jewel[i].id ~= 0 and self.jewel[i].id ~= -1 then
            local tvo = Lua_ToolVo.new(self.jewel[i].id, 0, 0);
            local f = Lua_FightUtil.caculateConfigForce(tvo.attribute);
            jewelForce = jewelForce + f;
            baseForce = baseForce + f;
        end
    end
    -- 觉醒战力
    if self.awake_level ~= nil and self.awake_level ~= 0 then
        local juexingAdd = self:getJueXingBase();
        local f = Lua_FightUtil.caculateConfigForce(juexingAdd);
        baseForce = baseForce + f;
        if self.intensifyLevel ~= nil and self.intensifyLevel ~= 0 then
            local juexingStrongAdd = self:getJueXingStrong();
            local sf = Lua_FightUtil.caculateConfigForce(juexingStrongAdd);
            baseForce = baseForce + sf;
        end
    end
    -- 附灵战力
    if self.spirit_level ~= 0 and self.spirit_level ~= nil then
        local sf = Lua_FightUtil.caculateConfigForce(self.fuLingConfigData);
        baseForce = baseForce + sf;
    end
    if self.jewl_Level ~= 0 and self.jewl_Level ~= nil then
        local val = DataCenter.equData.jwelCostConig[self.jwelType]["Attribute_percent"][self.jewl_Level];
        baseForce = baseForce + math.floor(jewelForce * val / 100);
    end
    -- 洗练战力
    local _arr = self.wash_attrs;
    if _arr ~= nil then
        local washArr = Array();
        for i = 1, #_arr do
            if _arr[i].open == true and _arr[i].attr.attr_id ~= 0 then
                washArr:add(_arr[i].attr);
            end
        end
        baseForce = baseForce + Lua_FightUtil.caculateServerForceArray(washArr);
    end
    self._zongheForce = baseForce;
    self.lastCaculateTime = getTime();
    return baseForce;
end
function Lua_ToolVo.Get:nameWithRefine()
    if self.refine == 1 then
        return LanUtil.getValue(110568) .. self.name;
    elseif self.refine == 2 then
        return LanUtil.getValue(110569) .. self.name;
    else
        return self.name;
    end
end
function Lua_ToolVo.Get:colorNameWithRefine()
    return "[" .. self.colorStr .. "]" .. self.nameWithRefine .. "[-]";
end
function Lua_ToolVo.Get:name()
    return self.config.name;
end
function Lua_ToolVo.Get:colorName()
    return "[" .. self.colorStr .. "]" .. self.config.name .. "[-]";
end
function Lua_ToolVo.Get:NameNum()
    if self.config.color == 3 then
        return "[d900d6]" .. self.config.name .. "x" .. self.count .. "[-]";
    elseif self.config.color == 4 then
        return "[ffce26]" .. self.config.name .. "x" .. self.count .. "[-]";
    elseif self.config.color == 5 then
        return "[f42a2a]" .. self.config.name .. "x" .. self.count .. "[-]";
    end

end

function Lua_ToolVo.Get:equip_upgrade()
    return self.config.equip_upgrade;
end
function Lua_ToolVo.Get:effect()
    return self.config.effect;
end
function Lua_ToolVo.Get:goldPrice()
    return self.config.goldPrice;
end
function Lua_ToolVo.Get:couponPrice()
    return self.config.couponPrice;
end
function Lua_ToolVo.Get:type()
    return self.config.type;
end
function Lua_ToolVo.Get:type_sort()
    if self.config.type_sort ~= nil then
        return self.config.type_sort;
    end
    return 0;
end
function Lua_ToolVo.Get:subType()
    if self.config.subType ~= nil then
        return self.config.subType;
    end
    return 0;
end
function Lua_ToolVo.Get:des()
    if self.subType == Lua_PackTypeDefine.FILLFORMULA_ITEM then
        local str = self.config.des;
        local eff = self.effect_prop;
        if eff ~= nil and eff.name ~= nil and eff.name ~= "" then
            local arr = eff.array;
            if arr ~= nil and #arr >= 3 then
                local num = eff.value + arr[1] * math.pow(arr[2],(DataCenter.roleData.level - arr[3]));
                num = math.floor(num);
                str = LanUtil.replaceStr(str, "{" .. eff.name .. "}", tostring(num));
            end
        end
        self._des = str;
    elseif self.subType == Lua_PackTypeDefine.HP_DRUG_ITEM
        or self.subType == Lua_PackTypeDefine.MP_DRUG_ITEM then
        local str = self.config.des;
        self._des = string.caculateString(str, DataCenter.roleData);
    elseif self.subType == Lua_PackTypeDefine.EXP_DRUG_ITEM then
        local str = self.config.des;
        self._des = string.caculateString(str, DataCenter.roleData, true);
    elseif self.subType == Lua_PackTypeDefine.BUFF_SHOW and self.buffDesc ~= nil then
        self._des = self.buffDesc;
    elseif self.subType == Lua_PackTypeDefine.MARRY_YANHUA_TYPE then
        local str = self.config.des;
        local eff = self.effect_prop;
        if eff ~= nil and eff.name ~= nil and eff.name ~= "" then
            local arr = eff.arg_exp;
            if arr ~= nil and #arr >= 3 then
                local num = eff.exp + arr[1] * math.pow(arr[2],(DataCenter.roleData.level - arr[3]));
                num = math.floor(num);
                str = LanUtil.formateStr(str, Lua_CommonUtil.getNumberTrans(num));
            end
        end
        self._des = str;
    else
        self._des = self.config.des;
    end
    if self._des == nil then
        self._des = "";
    end
    return self._des;
end
function Lua_ToolVo.Get:timeputDes()
    return self.config.outputDes;
end

function Lua_ToolVo:getOutputDesInfo(str)
    if self._outputDesInfo == nil then
        local des = self.outputDes;
    end
    if self._outputDesInfo[str] == nil then
        return nil;
    end
    return self._outputDesInfo[str].openWin;
end

function Lua_ToolVo.Get:outputDes()
    self._outputDes = "";
    self._outputDesInfo = {};
    local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
    local desList = self.config.outputDes;
    if desList ~= nil then
        for i = 1, #desList do
            local obj = desList[i];
            if obj ~= nil and obj.name ~= nil and ((obj.show_kuafu == nil or obj.show_kuafu == 0) or
                (obj.show_kuafu == 1 and sceneConfig.kuafu_map == 0) or (obj.show_kuafu == 2 and sceneConfig.kuafu_map == 1)) then
                if i == #desList then
                    if obj.openWin == nil then
                        self._outputDes = self._outputDes .. "[url=output" .. i .. "]" .. obj.name .. "[/url]";
                    else
                        self._outputDes = self._outputDes .. "[u][url=output" .. i .. "]" .. obj.name .. "[/url][/u]";
                    end
                else
                    if obj.openWin == nil then
                        self._outputDes = self._outputDes .. "[url=output" .. i .. "]" .. obj.name .. "[/url]\n";
                    else
                        self._outputDes = self._outputDes .. "[u][url=output" .. i .. "]" .. obj.name .. "[/url][/u]\n";
                    end
                end
                self._outputDesInfo["output" .. i] = obj;
            end
        end
    end
    return self._outputDes;
end

function Lua_ToolVo.Get:interfaceOutput()
    return self.config.interface_output;
end
function Lua_ToolVo.Get:useLvl()
    if self.config.use_lvl == nil then
        return 1;
    end
    return self.config.use_lvl;
end
function Lua_ToolVo.Get:sysPrice()
    if self.config.sys_price == nil then
        return 0;
    end
    return self.config.sys_price;
end
function Lua_ToolVo.Get:color()
    if self.wingColor ~= nil then
        return self.wingColor + 2;
    end
    if self.config.color == nil then
        return 1;
    end
    return self.config.color;
end
function Lua_ToolVo.Get:colorStr()
    return Lua_ColorDefine.getItemColorStr(self.color, self.darkColor);
end
function Lua_ToolVo.Get:showEffect()
    return self.config.showEffect;
end
function Lua_ToolVo.Get:auction()
    return self.config.auction;
end
function Lua_ToolVo.Get:overlap()
    if self.config.overlap == nil then
        return 0;
    end
    return self.config.overlap;
end

function Lua_ToolVo.Get:cool()
    if self.config.cool == nil then
        return 0;
    end
    return self.config.cool;
end

function Lua_ToolVo.Get:cannotDestroy()
    return self.config.cannotDestroy;
end
function Lua_ToolVo.Get:effect_prop()
    if self.config.effect_prop == nil then
        return { };
    end
    return self.config.effect_prop;
end
function Lua_ToolVo.Get:type_name()
    return self.config.type_name;
end
function Lua_ToolVo.Get:auction()
    return self.config.auction;
end
function Lua_ToolVo.Get:atlas()
    return self.config.atlas;
end
function Lua_ToolVo.Get:isShowTips()
    if self.config.isShowTips == nil then
        return Lua_PackTypeDefine.GET_SHOW_UI_TYPE_NONE;
    end
    return self.config.isShowTips;
end
function Lua_ToolVo.Get:unUse()
    if self.config.unUse == nil then
        return 0;
    end
    return self.config.unUse;
end
function Lua_ToolVo.Get:referenceId()
    local gender = 1;
    local referenceId = nil;
    referenceId = self.config.referenceId;
    if referenceId == nil then
        referenceId = self.id;
    end
    return tostring(referenceId);
end
function Lua_ToolVo.Get:mall_dec()
    return self.config.mall_dec;
end
function Lua_ToolVo.Get:batchUse()
    if self.config == nil then
        return 0;
    end
    return self.config.batchUse;
end
function Lua_ToolVo.Get:compound()
    return self.config.compound;
end
function Lua_ToolVo.Get:use_des()
    return self.config.use_des;
end
function Lua_ToolVo.Get:use_tip()
    return self.config.use_tip;
end
function Lua_ToolVo.Get:part()
    return self.config.part;
end

function Lua_ToolVo.Get:rare()
    if self.config.rare == nil then
        return false;
    end
    if self.type == 1 then
        if self.star >= self.config.rare then
            return true;
        end
        return false;
    else
        return self.config.rare == 1;
    end
end

function Lua_ToolVo.Get:copperPrice()
    if self.config.copperPrice == nil then
        return 0;
    end
    return self.config.copperPrice;
end

function Lua_ToolVo.Get:career()
    if self.config.career == nil then
        return 0;
    end
    return self.config.career;
end
function Lua_ToolVo.Get:attack_min()
    if self.config.attack_min == nil then
        return 0;
    end
    return self.config.attack_min;
end
function Lua_ToolVo.Get:attack_max()
    if self.config.attack_max == nil then
        return 0;
    end
    return self.config.attack_max;
end

function Lua_ToolVo.Get:show_default_round_effect()
    if self.config.show_round_effect == nil then
        return false;
    end
    return self.config.show_round_effect == 1;
end

function Lua_ToolVo.Get:attack()
    if self.config.attack == nil then
        return 0;
    end
    return self.config.attack;
end
function Lua_ToolVo.Get:defence()
    if self.config.defence == nil then
        return 0;
    end
    return self.config.defence;
end
function Lua_ToolVo.Get:reduce_defence()
    if self.config.reduce_defence == nil then
        return 0;
    end
    return self.config.reduce_defence;
end
function Lua_ToolVo.Get:blood()
    if self.config.blood == nil then
        return 0;
    end
    return self.config.blood;
end
function Lua_ToolVo.Get:hit()
    if self.config.hit == nil then
        return 0;
    end
    return self.config.hit;
end
function Lua_ToolVo.Get:dodge()
    if self.config.dodge == nil then
        return 0;
    end
    return self.config.dodge;
end
function Lua_ToolVo.Get:crit()
    if self.config.crit == nil then
        return 0;
    end
    return self.config.crit;
end
function Lua_ToolVo.Get:toughness()
    if self.config.toughness == nil then
        return 0;
    end
    return self.config.toughness;
end
function Lua_ToolVo.Get:order()
    return self.config.order;
end
function Lua_ToolVo.Get:attribute()
    return self.config.attribute;
end
function Lua_ToolVo.Get:legend()
    return self.config.legend;
end
function Lua_ToolVo.Get:rank()
    return self.config.rank;
end
function Lua_ToolVo.Get:profession()
    if self.config.profession == nil then
        return 0;
    end
    return self.config.profession;
end
function Lua_ToolVo.Get:leagueScore()
    return self.config.league_score;
end
function Lua_ToolVo.Get:showRb()
    if self.config.showRb == nil then
        return 0;
    end
    return self.config.showRb;
end

function Lua_ToolVo.Get:gm_intensify()
    if self.config.gm_intensify == nil then
        return 0;
    end
    return self.config.gm_intensify;
end

function Lua_ToolVo.Get:need_money()
    return self.config.need_money;
end
function Lua_ToolVo.Get:rtDesc()
    if self.config.rtDesc ~= nil then
        return self.config.rtDesc;
    end
    return "";
end
function Lua_ToolVo.Get:need_item()
    return self.config.need_item;
end
function Lua_ToolVo.Get:openWin()
    return self.config.openWin;
end
function Lua_ToolVo.Set:bShowItemBg(val)
    self._bMustShowItemBg = val;
    -- true 显示底框， false 不显示底框， nil 根据配置表notShowItemBg字段判断是否显示
end
function Lua_ToolVo.Get:bShowItemBg()
    if self._bMustShowItemBg == nil then
        self._bMustShowItemBg = false;
        if self.config.notShowItemBg == nil or self.config.notShowItemBg == 0 then
            self._bMustShowItemBg = true;
        end
    end

    return self._bMustShowItemBg;
end
function Lua_ToolVo.Get:altasSize()
    return self.config.altasSize;
end
function Lua_ToolVo.Get:leagueBuyScore()
    return self.config.league_buy_score;
end
function Lua_ToolVo:genContentString(sa)
    sa:writeInt(self.id);
    sa:writeInt(self.count);
    sa:writeInt(self.bind);
    if self.timeOut == nil then
        sa:writeInt(0);
    else
        sa:writeInt(self.timeOut);
    end
    if self.equipment ~= nil then
        sa:writeInt(1);
        sa:writeInt(self.equipment.star);
        local len = #self.equipment.attr;
        sa:writeInt(len);
        for i = 1, len do
            sa:writeInt(self.equipment.attr[i].attr_id);
            sa:writeInt(self.equipment.attr[i].color);
            sa:writeInt(self.equipment.attr[i].lower);
            sa:writeInt(self.equipment.attr[i].upper);
            sa:writeInt(self.equipment.attr[i].value);
        end
    else
        sa:writeInt(0);
    end
    if self.rune_level ~= nil then
        sa:writeInt(self.rune_level);
    else
        sa:writeInt(0);
    end
    if self.gm_level ~= nil then
        sa:writeInt(self.gm_level);
    else
        sa:writeInt(0);
    end
    if self.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
        if self.intensify_lvl == nil then
            sa:writeInt(0);
        else
            sa:writeInt(self.intensify_lvl);
        end
        if self.max_intensify_lvl == nil then
            sa:writeInt(50);
        else
            sa:writeInt(self.max_intensify_lvl);
        end
    end

    if self.subType == Lua_PackTypeDefine.STAMP_ITEM then
        if self.intensify_lvl == nil then
            sa:writeInt(0);
        else
            sa:writeInt(self.intensify_lvl);
        end
        if self.max_intensify_lvl == nil then
            sa:writeInt(150);
        else
            sa:writeInt(self.max_intensify_lvl);
        end
    end
end
function Lua_ToolVo:setFromContentString(sa)
    self.packType = 999;
    self.id = sa:getInt();
    self.count = sa:getInt();
    self.bind = sa:getInt();
    self.timeOut = sa:getInt();
    local hasEqu = sa:getInt();
    if hasEqu == 1 then
        self.equipment = { };
        self.equipment.star = sa:getInt();
        self.star = self.equipment.star;
        self.equipment.attr = { };
        local len = sa:getInt();
        for i = 1, len do
            local o = { };
            o.attr_id = sa:getInt();
            o.color = sa:getInt();
            o.lower = sa:getInt();
            o.upper = sa:getInt();
            o.value = sa:getInt();
            self.equipment.attr[i] = o;
        end
    end
    self.rune_level = sa:getInt();
    self.gm_level = sa:getInt();
    if self.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE or self.subType == Lua_PackTypeDefine.STAMP_ITEM then
        self.intensify_lvl = sa:getInt();
        self.max_intensify_lvl = sa:getInt();
    end
    -- self.soul_level = sa:getInt();
end

function Lua_ToolVo.Set:bShowQualityEff(val)
    self._bShowQualityEff = val;
end

function Lua_ToolVo.Get:bShowQualityEff()
    if self._bShowQualityEff == nil then
        return false;
    end

    return self._bShowQualityEff;
end

function Lua_ToolVo.Set:bInitLoveGiftAtt(val)
    self._bInitLoveGiftAtt = val;
    -- true 显示爱情信物初始属性
end

function Lua_ToolVo.Get:bInitLoveGiftAtt()
    if self._bInitLoveGiftAtt == nil then
        return false;
    end

    return self._bInitLoveGiftAtt;
end

-- 帮派任务上交排序权重
function Lua_ToolVo.Get:submitEquPr()
    return self.color * 1000000000 + self.order * 10000000 + self.force;
end

-- 排序
function Lua_ToolVo.Get:sort()
    return self.config.sort;
end

-- 阶数
function Lua_ToolVo.Get:order()
    return self.config.order;
end

function Lua_ToolVo.Get:lvl_use_tips()
    if self.config.lvl_use_tips == nil then
        -- 为0.表示不增加，1表示增加
        return 0;
    end
    return self.config.lvl_use_tips;
end
function Lua_ToolVo.Get:huanhua_rank()
    if self.config.huanhua_rank == nil then
        -- 为0.表示不增加，1表示增加
        return 0;
    end
    return self.config.huanhua_rank;
end

function Lua_ToolVo.Get:qudao_xianshi()
    if self.config.qudao_xianshi == nil then
        -- 为0.表示不增加，1表示增加
        return 0;
    end
    return self.config.qudao_xianshi;
end

function Lua_ToolVo.Get:danyao_zhanli(args)
    if self.config.danyao_zhanli == nil then
        return 0;
    end
    return self.config.danyao_zhanli;
end

function Lua_ToolVo.Get:engrave_limit()
    if self.config.engrave_limit == nil then
        return 0;
    end
    return self.config.engrave_limit;
end

function Lua_ToolVo.Get:modelPath()
    local effectConfig = getConfig({"effect", tostring(self.config.tipShowModel)});
    local bRegisterTimer = nil;
    if effectConfig == nil then
        effectConfig = getConfig({"effect", tonumber(self.config.tipShowModel)});
    end
    if effectConfig == nil then
        effectConfig = getConfig({"playerHanger", tostring(self.config.tipShowModel)});
        if effectConfig == nil then
            effectConfig = getConfig({"playerHanger", tonumber(self.config.tipShowModel)});
        end
        bRegisterTimer = false;
    else
        bRegisterTimer = true;
    end
    if effectConfig == nil then
        return nil;
    end
    local rs = {};
    rs.isEffect = bRegisterTimer;
    rs.uiShowAction = effectConfig.uiShowAction;
    if bRegisterTimer then
        rs.urlStr = "/"..effectConfig.floder.."/"..effectConfig.path;
        rs.modelName = effectConfig.path;
    else
        rs.urlStr = effectConfig.floder.."/"..effectConfig.fileName;
        rs.modelName = effectConfig.modelName;
    end
    return rs;
end

function Lua_ToolVo.Get:baseAttr()
    local arr = Array()
    for k, v in ipairs(Lua_ThingDefine.params) do
        local list = { }
        list.attr = v
        if v == "attack" then
            if self.attack_max ~= nil and self.attack_max ~= 0 then
                list.ChineseName = Lua_ThingDefine.getParamName(v)
                list.attack_min = self.attack_min
                list.attack_max = self.attack_max
                arr:add(list)
            elseif self.config[v] ~= nil then
                list.ChineseName = Lua_ThingDefine.getParamName(v)
                list.value = self.config[v]
                arr:add(list)
            end
        else
            if self.config[v] ~= nil then
                list.ChineseName = Lua_ThingDefine.getParamName(v)
                list.value = self.config[v]
                arr:add(list)
            end
        end
    end
    return arr
end

function Lua_ToolVo:clone()
    local sa = Lua_StringArray.new();
    sa:writeInt(1);
    self:genContentString(sa);
    sa:decodeContent(sa.content);
    sa:getInt();
    local nvo = Lua_ToolVo.createToolVo(self.id, 1, 1);
    nvo:setFromContentString(sa);
    return nvo;
end

-- 姻缘仙娃分解获得经验
function Lua_ToolVo.Get:marryChildrenRolveExp()
    if self._marryChildrenRolveExp == nil then
        self._marryChildrenRolveExp = 0;
        if self.effect_prop ~= nil and self.effect_prop.name == "add_baby_level_exp" then
            local num = self.effect_prop.value;
            if num ~= nil then
                self._marryChildrenRolveExp = num;
            end
        end
    end
    
    return self._marryChildrenRolveExp;
end