-- 生肖装备Vo
Lua_ZodiacEquipVo = class("Lua_ZodiacEquipVo", Lua_ToolVo);
function Lua_ZodiacEquipVo:ctor(id, count, bin)
	self:superCall("ctor", id, count, bin);

	self.intensifyLevel = 0; -- 部位强化等级
	self.isWear = false; -- 是否已经穿戴
end

function Lua_ZodiacEquipVo.Get:rtDesc()
	local langNum = 100;
    if self.order < 10 then
    	langNum = langNum + self.order;
    	return LanUtil.formateStr(LanUtil.getValue(143451), LanUtil.getValue(langNum));
    else
    	langNum = langNum + self.order % 10 + 1;
    	return LanUtil.formateStr(LanUtil.getValue(143452), LanUtil.getValue(langNum));
    end
end

-- 强化上限
function Lua_ZodiacEquipVo.Get:intensify_limit()
	return self.config.intensify_limit;
end

-- 生肖之力
function Lua_ZodiacEquipVo.Get:zodiacPowersDic()
	if self._equipPowersDic == nil then
		self._equipPowersDic = {};
		for i,v in ipairs(Lua_ThingDefine.zodiacParams) do
			local val = self.config[v];
			if val ~= nil and val ~= 0 then
				self._equipPowersDic[v] = val;
			end
		end
	end
	return self._equipPowersDic;
end

-- 基础属性
function Lua_ZodiacEquipVo.Get:baseAttrsDic()
	if self._baseAttrsDic == nil then
		self._baseAttrsDic = {};
		for i,v in ipairs(Lua_ThingDefine.params) do
			local val = self.config[v];
			if val ~= nil and val ~= 0 then
				self._baseAttrsDic[v] = val;
			end
		end
	end
	return self._baseAttrsDic;
end

-- 强化属性
function Lua_ZodiacEquipVo.Get:intensifyAttrsDic()
	local id = self.part * 1000 + self.intensifyLevel;
	local vo = DataCenter.zodiacUtil:getIntensifyVoById(id);
	if vo ~= nil then
		return vo.attrsDic;
	end
	return nil;
end

-- 特殊属性
function Lua_ZodiacEquipVo.Get:specialAttrStr()
	if self._equipPowersStr == nil then
		local str = "";
		local dic = self.zodiacPowersDic;
		for i,v in ipairs(Lua_ThingDefine.zodiacParams) do
			local val = dic[v];
			if val ~= nil then
				if str == "" then
	                str = "";
	            else
	                str = str.."\n";
	            end
	            
	            str = str.."[C7CEDF]"..Lua_ThingDefine.getParamName(v).."：[-]"..val;
			end
		end
		self._equipPowersStr = str;
	end
	return self._equipPowersStr;
end

-- 用于升阶显示
function Lua_ZodiacEquipVo.Get:equipAttrsStr()
	if self._equipAttrsStr == nil then
		local str = "";
		local intensifyStr = "";
		local dic = self.baseAttrsDic;
		local _dic = self.intensifyAttrsDic;
		for i,v in ipairs(Lua_ThingDefine.params) do
			local intensifyVal = _dic[v];
			if intensifyVal ~= nil then
				if Lua_ThingDefine.isPercentParam(v) then
	                intensifyVal = intensifyVal.."%";
	            end
	            intensifyStr = "[13A100]"..LanUtil.formateStr(LanUtil.getValue(110851), tostring(intensifyVal)).."[-]";
			end

			local val = dic[v];
			if val ~= nil then
				if str == "" then
	                str = "";
	            else
	                str = str.."\n";
	            end
	            if Lua_ThingDefine.isPercentParam(v) then
	                val = val.."%";
	            end

	            str = str.."[3F6180]"..Lua_ThingDefine.getParamName(v).."：[-]".."[192E41]"..val.."[-]";
	            if intensifyVal ~= nil then
	            	str = str.."  "..intensifyStr;
	            end
			end
		end
		self._equipAttrsStr = str;
	end
	return self._equipAttrsStr;
end
