-- 聚魂
checkRequire("Lua_GatherSoulData");
checkRequire("Lua_GatherSoulUtil");
Lua_GatherSoulProxy = class("Lua_GatherSoulProxy");
function Lua_GatherSoulProxy:ctor()
	DataCenter.gatherSoulData = Lua_GatherSoulData.new();
	DataCenter.gatherSoulUtil = Lua_GatherSoulUtil.new();

	LuaUtil.addLuaMsg(51403301, self, self.rOpenGatherSoulPanelInfo); -- 打开聚魂面板（返回）
	LuaUtil.addLuaMsg(51403306, self, self.rCohesionSoulInfo); -- 获取凝聚后是否成功（返回）
	LuaUtil.addLuaMsg(81403301, self, self.rSoulUpdataEssenceInfo); -- 通知更新魂之粉尘与魂石
end

-- 打开聚魂面板（返回）
function Lua_GatherSoulProxy:rOpenGatherSoulPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403301();
		msg:ParseFromString(mp.data);
		DataCenter.gatherSoulData.soulDust = msg.soul_dust; -- 魂之粉尘
		DataCenter.gatherSoulData.soulStone = msg.soul_stone; -- 魂石
		DataCenter.gatherSoulData.isAutoResolve = msg.auto_decomp_status; -- 自动分解状态记录 0关，1开
		DataCenter.gatherSoulData.select_num = msg.decomp_type; -- 分解状态记录
		DataCenter.gatherSoulData:fromServer51403301(msg);
		DataCenter.gatherSoulData:checkSoulRedDotSate() -- 灵魂变强红点检测
		Lua_MsgUtil.callFunc("rOpenGatherSoulPanelInfo");
	end
end

-- 获取凝聚后是否成功（返回）
function Lua_GatherSoulProxy:rCohesionSoulInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403306();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rCohesionSoulInfo", msg.state); -- 是否成功
	end
end

-- 通知更新魂之粉尘与魂石
function Lua_GatherSoulProxy:rSoulUpdataEssenceInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81403301();
		msg:ParseFromString(mp.data);
		DataCenter.gatherSoulData.soulDust = msg.soul_dust; -- 魂之粉尘
		DataCenter.gatherSoulData.soulStone = msg.soul_stone; -- 魂石
		Lua_MsgUtil.callFunc("rOpenGatherSoulPanelInfo");
	end
end





-- 打开聚魂面板
function Lua_GatherSoulProxy:sOpenGatherSouPanel()
	sendMsg(11403301);
end

-- 灵魂背包自动分解
function Lua_GatherSoulProxy:sAutoResolveSelectType(status,decomp_type)
	local cmd = ProtoPublic_pb.Proto11403307();
	cmd.status = status; -- 0关，1开
	cmd.decomp_type = decomp_type;
	sendMsg(11403307, cmd);
end

-- 升级灵魂
function Lua_GatherSoulProxy:sUpgradeSoul(groove_id)
	local cmd = ProtoPublic_pb.Proto11403302();
	cmd.groove_id = groove_id;
	sendMsg(11403302, cmd);
end

-- 分解灵魂
function Lua_GatherSoulProxy:sResolveSoul(list)
	local cmd = ProtoPublic_pb.Proto11403303();
	local item;
	for i = 1, list:getSize() do
		item = ProtoPublic_pb.ProtoDecomposeSoul();
		item.item_id = list[i].id; -- 分解道具
		item.pkg_index = list[i].index; -- 背包索引
		cmd.item_list:addToList(item);
	end
	sendMsg(11403303, cmd);
end

-- 镶嵌灵魂
function Lua_GatherSoulProxy:sInlaySoul(groove_id, item_id, pkg_index)
	local cmd = ProtoPublic_pb.Proto11403304();
	cmd.groove_id = groove_id; -- 槽号
	cmd.item_id = item_id; -- 灵魂id
	cmd.pkg_index = pkg_index; -- 背包索引
	sendMsg(11403304, cmd);
end

-- 卸下灵魂
function Lua_GatherSoulProxy:sDischargeSoul(grooveId)
	local arr = Array();
	arr:add({id = grooveId});

	local cmd = ProtoPublic_pb.Proto11403308();
	for i = 1, arr:getSize() do
		cmd.groove_id:append(arr[i].id)
	end
	sendMsg(11403308, cmd);
end

-- 拆解灵魂
function Lua_GatherSoulProxy:sDisassemSoul(data)
	local cmd = ProtoPublic_pb.Proto11403305();
	if data.groove_id ~= nil then -- 穿戴灵魂拆解
		cmd.type = 1;
		cmd.groove_id = data.groove_id;
	else -- 背包灵魂拆解
		cmd.type = 2; -- 1拆解已装备的灵魂，2拆解背包的灵魂
		cmd.item_id = data.id; -- 灵魂id
		cmd.pkg_index = data.index; -- 背包索引
	end
	sendMsg(11403305, cmd);
end

-- 凝聚灵魂
function Lua_GatherSoulProxy:sCohesionSoul(item_id, list)
	local cmd = ProtoPublic_pb.Proto11403306();
	cmd.item_id = item_id; -- 凝聚灵魂id
	if list ~= nil then
		local cost_list;
		for i = 1, list:getSize() do
			cost_list = ProtoPublic_pb.ProtoPairObj();
			cost_list.obj_id = list[i].id; -- 道具id
			cost_list.obj_value = list[i].index; -- 背包索引
			cmd.cost_list:addToList(cost_list);
		end
	end
	sendMsg(11403306, cmd);
end