checkRequire("Lua_EquipVo");
checkRequire("Lua_RuneVo");
checkRequire("Lua_CardVo");
checkRequire("Lua_StampVo");
checkRequire("Lua_GatherSoulVo");
checkRequire("Lua_ArmyEquipVo");
checkRequire("Lua_ZodiacEquipVo");
checkRequire("Lua_PackData");
checkRequire("Lua_MoneyData");
checkRequire("Lua_PackUtil");
checkRequire("Lua_ItemCombineUtil");
Lua_PackProxy = class("Lua_PackProxy");
function Lua_PackProxy:ctor()
    self:superCall("ctor");
    DataCenter.packData = Lua_PackData.new();
    DataCenter.moneyData = Lua_MoneyData.new();
    DataCenter.combineUtil = Lua_ItemCombineUtil.new();

    LuaUtil.addLuaMsg(51400101, self, self.rGetPackInfo);
    LuaUtil.addLuaMsg(51400110, self, self.onSoleBack);
    LuaUtil.addLuaMsg(51400134, self, self.onBatchSoleBack);
    LuaUtil.addLuaMsg(51400125, self, self.onCombineRs);
    LuaUtil.addLuaMsg(51400103, self, self.onPackSizeChange);
    LuaUtil.addLuaMsg(51400106, self, self.onItemUsed);
    LuaUtil.addLuaMsg(81400101, self, self.addPackItem); -- 道具数量增加
    LuaUtil.addLuaMsg(81400102, self, self.delPackItem); -- 道具数量减少
    LuaUtil.addLuaMsg(81400103, self, self.onMoneyUpdate);
    LuaUtil.addLuaMsg(80400216, self, self.onServerTips);
    LuaUtil.addLuaMsg(81400803, self, self.addOtherPackItem);
    LuaUtil.addLuaMsg(81400116, self, self.onUseTimeUpdate);

    LuaUtil.addLuaMsg(81400115, self, self.onWhareSizeChange);
    LuaUtil.addLuaMsg(51400031, self, self.useGSBackGift);
    LuaUtil.addLuaMsg(51400120, self, self.useRoleRename);
    LuaUtil.addLuaMsg(51400121, self, self.useFactionRename);
    --LuaUtil.addLuaMsg(51400154, self, self.updtaeInfo);

    MsgUtil.addEventListener("PLAYER_LEVEL_UP", self, self.onCheckGiftPack);
    self.newEquPutOnTipsIdxList = Array();
    self.openNewItemTipArr = Array()

    self.delayAddType = { };
end
-- function Lua_PackProxy:updtaeInfo(mp)
--     if mp.errno == 0 then
--         local msg = ProtoPublic_pb.Proto51400154();
--         msg:ParseFromString(mp.data);
--         print("0000000000000000000000000000000000")
--     end
-- end

function Lua_PackProxy:onCheckGiftPack()
    local packDataArr = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getBagAllData();
    local packDataArrLen = packDataArr:getSize()
    for i = 1, packDataArrLen do
        if packDataArr[i].lvl_use_tips == 1 and DataCenter.roleData.level >= packDataArr[i].useLvl then
            self.openNewItemTipArr:add(packDataArr[i])
        end
    end
    local openNewItemTipArrLen = self.openNewItemTipArr:getSize()
    if openNewItemTipArrLen ~= 0 then
        Lua_CommonUtil.addTimer("delayOpenNewItemTips", 0.2, self, self.delayOpenNewItemTips, nil, 1);
    end
end
function Lua_PackProxy:delayOpenNewItemTips()
    if self.openNewItemTipArr == nil or self.openNewItemTipArr:getSize() == 0 then
        return;
    end
    local len = self.openNewItemTipArr:getSize();
    local tvo = nil;
    for i = 1, len do
        tvo = self.openNewItemTipArr[i];
        Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tvo.index);
    end
    self.openNewItemTipArr:clear();
end
function Lua_PackProxy:onUseTimeUpdate(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400116();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData;
        for i, v in ipairs(msg.gift_times) do
            bag.useTimes[v.obj_id] = v.obj_value;
        end
    end
end
function Lua_PackProxy:onWhareSizeChange(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400115();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(Lua_PackData.WHARE);
        bag.packSize = msg.number;
        Lua_MsgUtil.callFunc("PACK_UPDATE", Lua_PackData.WHARE);
        if msg.pack_type == Lua_PackData.SACRED_ANIMAL_BAG then
            Lua_MsgUtil.callFunc("PACK_ANIMALINFO_UPDATE");
        end
    end
end
function Lua_PackProxy:onServerTips(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto80400216();
        msg:ParseFromString(mp.data);
        for i, v in pairs(msg.tips_set) do
            if v.type == 0 then
                local tvo = Lua_ToolVo.new(v.id);
                if tvo.config ~= nil then
                    if tvo.showRb == 0 then
                        local str = LanUtil.formateStr(LanUtil.getValue(110862), tvo.colorName, tostring(v.amount));
                        OperateAlert.show(str);
                    else
                        local str = "+" .. tvo.name .. " " .. v.amount;
                        if getCVersion() >= 1180 then
                            OperateAlert.show(str, nil, 1, Lua_ColorDefine.transColorStr("fff9b1", 1), Lua_ColorDefine.transColorStr("efb400", 1),
                            Lua_ColorDefine.transColorStr("420802", 1));
                        else
                            OperateAlert.show(str, nil, 1);
                        end
                    end
                end
            elseif v.type == 2 then
                -- ¾­Ñé
                OperateAlert.show("+EXP " .. Lua_CommonUtil.getNumberTrans(v.exp), nil, 1);
            end
        end

        if msg.tips_str_set ~= nil then
            for i, v in ipairs(msg.tips_str_set) do
                OperateAlert.show(v)
            end
        end
    end
end
function Lua_PackProxy:onPackSizeChange(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto51400103();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
        bag.packSize = msg.pack_size;
        Lua_MsgUtil.callFunc("PACK_UPDATE", Lua_PackData.BAG_PACK);
        OperateAlert.show(LanUtil.getValue(110859));
    end
end
function Lua_PackProxy:rGetPackInfo(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto51400101();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(msg.pack_type);
        bag.packSize = msg.pack_size;
        bag:fromServer(msg.pack_type, msg.item_list, msg.strengthen);
        DataCenter.combineUtil:checkCombineRedDot();
        -- if DataCenter.funcOpenData:isOpened(10112) == true then
        --     DataCenter.gatherSoulData:checkSoulRedDot();
        -- end
        
        if DataCenter.funcOpenData:isOpened(10141) == true then
            Lua_MsgUtil.callFunc("PACK_MOUNTEQUIP_UPDATE");--骑装信息更新
        end
        
        -- GSÀñ°ü
        Lua_MsgUtil.callFunc("PACK_UPDATE", msg.pack_type);

        Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_CLOSE);
        if msg.pack_type == Lua_PackData.BAG_PACK then
            self:checkBetterEqu();
        end
    end
end
function Lua_PackProxy:onCombineRs(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto51400125();
        msg:ParseFromString(mp.data);
        -- if msg.is_success == 1 then
        --     OperateAlert.show(LanUtil.getValue(110833));
        -- else
        --     OperateAlert.show(LanUtil.getValue(110834));
        -- end

        Lua_MsgUtil.callFunc("ITEM_COMBINE_UPDATE", msg);
    end
end
function Lua_PackProxy:addPackItem(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400101();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(msg.pack_type);
        local equipDataUpdate = false;
        local mountEquipDataUpdate = false;
        local holyItemUpdate = false;
        local stampCompoundUpdate = false;
        local cloakResolveUpdate = false;
        local armySoulUpdate = false;
        local eidolonUpdate = false;
        for i, v in ipairs(msg.pack_item_list) do
            local tv = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
            tv:fromServer(v);
            tv.packType = msg.pack_type;
            bag:addOneItem(tv);

            local isBetter = 0;
            local lvlEnougth = tv.useLvl <= DataCenter.roleData.level;
            if msg.pack_type == Lua_PackData.BAG_PACK and tv.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
                if tv.type == 1 or(tv.type == 3 and tv.subType == Lua_PackTypeDefine.WING_ITEM) then
                    -- ×°±¸
                    if (tv.career == 0 or tv.career == DataCenter.roleData.career)
                        and tv.useLvl <= DataCenter.roleData.level
                        and tv.profession <= DataCenter.roleData.profession then
                        if tv.type == 3 and tv.subType == Lua_PackTypeDefine.WING_ITEM then
                            Lua_CommonUtil.addTimer("checkShowNewItemTips", 0.5, self, self.checkShowNewItemTips, tv, 1);
                        elseif tv.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
                            -- todo
                        else
                            isBetter = self:checkShowNewItemTips(tv);
                        end
                    end
                elseif tv.type == 10 and lvlEnougth == true then
                    if tv.isShowTips == Lua_PackTypeDefine.GET_SHOW_UI_TYPE_USE_ITEM and tv.fairyVo ~= nil and tv.fairyVo.isUsed == 0 then
                        Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tv.index);
                    end
                elseif lvlEnougth == true then
                    if tv.isShowTips == Lua_PackTypeDefine.GET_SHOW_UI_TYPE_USE_ITEM then
                        if tv.effect_prop.name == "hook_time" and DataCenter.hangUpSettingsData.outLineLeftTime ~= nil then
                            local t = tv.effect_prop.value;
                            local maxTime = DataCenter.hangUpSettingsData:getMaxHookTime();
                            local lt = maxTime - DataCenter.hangUpSettingsData.outLineLeftTime;
                            local at = tv.effect_prop.value;
                            if lt >= t then
                                Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tv.index);
                            end
                        else
                            Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tv.index);
                        end
                    elseif getShowTips() == true and tv.isShowTips == Lua_PackTypeDefine.GET_SHOW_UI_TYPE_VIP_EXPERIENCE_CARD then
                        Lua_WindowUtil.openWin("Lua_VipUseExperienceCardWindow", WinParam.ACTION_OPEN, tv.index);
                    end
                end
            end

            if tv.stream_id == Lua_PackTypeDefine.PICK_STREAM_TYPE and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 1 then
                if tv.color <= 2 and DataCenter.hangUpSettingsData.auto_sell == 1 and isBetter == 0 then
                    Lua_PackUtil.soleItem(tv, false, true);
                else
                    equipDataUpdate = true;
                    self:checkBetterEqu();
                end
            end

            if tv.subType == Lua_PackTypeDefine.EQUIP and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 1 then --更新装备合成红点
                Lua_MsgUtil.callFunc("PACK_EQUIP_UPDATE");
            end

            if tv.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 1 then
                mountEquipDataUpdate = true;
            end

            if tv.subType == Lua_PackTypeDefine.HOLY_ITEM and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 4 then -- 圣魂更新
                holyItemUpdate = true;
            end

            if tv.subType == Lua_PackTypeDefine.STAMP_SOUL and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 3 then -- 魂印合成
                stampCompoundUpdate = true;
            end

            if tv.subType == Lua_PackTypeDefine.CLOAK_ITEM or tv.subType == Lua_PackTypeDefine.CLOAK_RESOLVE_ITEM 
            or tv.subType == Lua_PackTypeDefine.CLOAK_ADJOIN_ITEM or tv.subType == Lua_PackTypeDefine.CLOAK_ITEM_CHIP then -- 披风
                cloakResolveUpdate = true;
            end

            if tv.subType == Lua_PackTypeDefine.ARMY_SOUL_ITEM and msg.pack_type == Lua_PackData.BAG_PACK and tv.type == 3 then -- 军魂
                armySoulUpdate = true;
            end

            if tv.subType == Lua_PackTypeDefine.EIDOLON_ITEM then -- 幻灵
                eidolonUpdate = true;
            end
        end
        DataCenter.combineUtil:checkCombineRedDot();
        if DataCenter.funcOpenData:isOpened(10008) == true
            and msg.pack_type == Lua_PackData.BAG_PACK
            and DataCenter.hangUpSettingsData.auto_eat_equipt == 1
            and bag:getLeftSize() <= 5 then
            local list = bag:getItemsBySubType( { Lua_PackTypeDefine.EQUIP });
            local len = list:getSize();
            local indexList = Array();
            for i = 1, len do
                local tv = list[i];
                if tv.stream_id == Lua_PackTypeDefine.PICK_STREAM_TYPE
                    and tv.color == 3 then
                    if tv.career ~= DataCenter.roleData.career then
                        indexList:add(tv.index);
                    else
                        local etv = DataCenter.equData:getEquByPart(tv.part);
                        if etv ~= nil and etv.force > tv.force then
                            indexList:add(tv.index);
                        end
                    end
                end
            end
            DataCenter.servantLvlUpData:sEatItem(indexList);
        end
        if self.delayAddType ~= nil then
            self.delayAddType = {};--初始化数据
        end
        self.delayAddType[msg.pack_type] = 1;

        if equipDataUpdate == true then
            self.delayAddType[990] = 1;
        end

        if mountEquipDataUpdate == true then
            self.delayAddType[991] = 1;
        end
        
        if holyItemUpdate == true then -- 圣魂更新
            self.delayAddType[992] = 1;
        end

        if stampCompoundUpdate == true then -- 魂印合成
            self.delayAddType[993] = 1;
        end

        if cloakResolveUpdate == true then -- 披风分解
            self.delayAddType[994] = 1;
        end

        if armySoulUpdate == true then -- 军魂
            self.delayAddType[995] = 1;
        end
        
        if eidolonUpdate == true then -- 幻灵
            self.delayAddType[996] = 1;
        end
        
        Lua_CommonUtil.delayCollectCall("addPackItem_" .. msg.pack_type, self, self.delayAddUpdate, msg.pack_type, 0.2);
    end
end
function Lua_PackProxy:delayAddUpdate()
    for k, v in pairs(self.delayAddType) do
        Lua_MsgUtil.callFunc("PACK_UPDATE", k);
        if k == 990 then
            Lua_MsgUtil.callFunc("PACK_EQUIP_UPDATE");
        elseif k == Lua_PackData.SACRED_ANIMAL_BAG then
            Lua_MsgUtil.callFunc("PACK_ANIMALINFO_UPDATE");
        elseif k == Lua_PackData.JH_PACK then
            -- 聚魂
            Lua_MsgUtil.callFunc("PACK_GATHERSOUL_UPDATE");
            if DataCenter.funcOpenData:isOpened(10112) == true then
                DataCenter.gatherSoulData:checkSoulRedDotSate()
            end
        elseif k == Lua_PackData.CARD_PACK then
            -- 卡牌
            if DataCenter.funcOpenData:isOpened(10149) == true then
                -- 更新卡牌主界面红点
                DataCenter.cardData:checkCardRedDotSate();
                -- 卡牌 数据更新
                Lua_MsgUtil.callFunc("PACK_CARD_UPDATE");
            end
        elseif k == Lua_PackData.STAMP_PACK then
            -- 魂印
            Lua_MsgUtil.callFunc("PACK_STAMP_UPDATE");
            if DataCenter.funcOpenData:isOpened(10161) == true then
                -- 更新 魂印主界面 红点变强
                DataCenter.stampData:checkStampRedDotSate();
            end
        
        elseif k == 991 then
            Lua_MsgUtil.callFunc("PACK_MOUNTEQUIP_UPDATE");--骑装信息更新
            if DataCenter.funcOpenData:isOpened(10141) == true then
                DataCenter.mountEquipData:checkMountRedDotSate();--骑装红点更新
            end
        elseif k == 992 then
            if DataCenter.funcOpenData:isOpened(10161) == true then
                -- 更新 圣魂 红点变强
                DataCenter.stampData:checkStampRedDotSate();
            end
        elseif k == 993 then
            if DataCenter.funcOpenData:isOpened(10161) == true then
                -- 更新 圣魂 红点变强
                DataCenter.stampData:checkStampRedDotSate();
            end
        elseif k == 994 then
            Lua_MsgUtil.callFunc("PACK_CLOAK_UPDATE");--披风
            if DataCenter.funcOpenData:isOpened(10184) == true then
                -- 更新 披风红点
                DataCenter.cloakData:checkCloakRedDotSate();
            end
        elseif k == 995 or k == Lua_PackData.ARMY_PACK then
            if DataCenter.funcOpenData:isOpened(10193) == true then
                -- 更新 军魂红点
                DataCenter.armySoulData:checkArmyRedDotSate();
            end
            Lua_MsgUtil.callFunc("PACK_ARMY_UPDATE");--军魂
        elseif k == 996 then
            if DataCenter.funcOpenData:isOpened(10215) == true then
                Lua_MsgUtil.callFunc("PACK_EIDOLON_UPDATE");--幻灵
            end
        end
    end
end
function Lua_PackProxy:checkShowNewItemTips(tv)
    local equData = DataCenter.equData;
    local myEqu = equData:getEquByPart(tv.part);
    -- print("myEqu",myEqu,tv.part,myEqu.force,tv.force);
    local myForce = 0;
    local isBetter = 0;
    local hasDelayCall = false;
    if myEqu ~= nil then
        myForce = myEqu.score;
    elseif tv.subType == Lua_PackTypeDefine.WING_ITEM then
        myForce = DataCenter.GodWingData:getForce();
    end
    if (((myEqu == nil or myForce < tv.score) and tv.subType ~= Lua_PackTypeDefine.WING_ITEM)
        or(tv.subType == Lua_PackTypeDefine.WING_ITEM and (DataCenter.GodWingData.hasPutWing == false or tv.score > myForce)
        and DataCenter.funcOpenData:isOpened(10066, false) == true)) then
        isBetter = 1;
        --[[²»ÄÜÂíÉÏ´¦ÀíÏÔÊ¾´©´÷×°±¸£¬¿ÉÄÜÍ¬Ê±»áÉý¼¶£¬µ¼ÖÂÌáÉýµÈ¼¶µÄÍ¬Ê±´¦Àí´©´÷ÌáÊ¾µÄ»°£¬
		×°±¸¿É´©´÷µÈ¼¶ÅÐ¶Ï»áÓÐÎó£¨·þÎñ¶ËÃ»·¨ÏÈÏÂ·¢µÈ¼¶ÌáÉýÏûÏ¢ºÅ£©£¬ÕâÀïÖ»ÄÜ¿Í»§¶ËÍ¨¹ýÑÓÊ±´¦Àí´©´÷È¥½â¾öÕâ¸öÎÊÌâ¡£
		--]]
        if Lua_WindowUtil.isWindowShowing("Lua_NewItemTipWindow") == true then
            Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tv.index);
        else
            if hasDelayCall == false then
                hasDelayCall = true;
                Lua_CommonUtil.addTimer("delayOpenNewEquTips", 0.2, self, self.delayOpenNewEquTips, nil, 1);
            end
            self.newEquPutOnTipsIdxList:add(tv);
        end
    end
    return isBetter;
end
function Lua_PackProxy:addOtherPackItem(mp)
    -- 主动通知其他背包添加数据

    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto81400803();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(msg.pack_type);
        for i, v in ipairs(msg.pack_item_list) do
            local tv = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
            tv:fromServer(v);
            tv.packType = msg.pack_type;
            bag:addOneItem(tv);
        end
        if msg.pack_type == Lua_PackData.LW_PACK then
            -- 更新灵纹红点
            DataCenter.runeData:checkRedDotSate();
            -- 更新灵纹界面
            Lua_MsgUtil.callFunc("rOpenRunePanelInfo");
            -- 背包数据更新
            Lua_MsgUtil.callFunc("PACK_RUNE_UPDATE");
        end
    end
end

function Lua_PackProxy:delayOpenNewEquTips()
    if self.newEquPutOnTipsIdxList == nil or self.newEquPutOnTipsIdxList:getSize() == 0 then
        return;
    end
    local len = self.newEquPutOnTipsIdxList:getSize();
    local tvo = nil;
    for i = 1, len do
        tvo = self.newEquPutOnTipsIdxList[i];
        if tvo.useLvl <= DataCenter.roleData.level then
            Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, tvo.index);
        end
    end
    self.newEquPutOnTipsIdxList:clear();

end
function Lua_PackProxy:checkBetterEqu(showNewItem)
    local rd = DataCenter.roleData;
    if rd.baseParam == nil then
        return;
    end

    local betterList = Array();
    local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local arr = bag:getItemsBySubType( { Lua_PackTypeDefine.EQUIP });
    local len = arr:getSize();
    local isBetter = false;
    local isWingBetter = false;
    for i = 1, len do
        local tv = arr[i];
        if (tv.career == 0 or tv.career == DataCenter.roleData.career)
            and tv.useLvl <= DataCenter.roleData.level
            and tv.profession <= DataCenter.roleData.profession 
            and tv.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
            local equData = DataCenter.equData;
            local myEqu = equData:getEquByPart(tv.part);
            if myEqu == nil or (myEqu ~= nil and tv.score > myEqu.score) then
                isBetter = true;
                betterList:add(tv.index);
                if showNewItem ~= true then
                    break;
                end
            end
        end
    end

    if isWingBetter == false then
        local arr = bag:getItemsBySubType( { Lua_PackTypeDefine.WING_ITEM });
        len = arr:getSize();
        for i = 1, len do
            local tv = arr[i];
            local wingForce = DataCenter.GodWingData:getForce();
            if (tv.career == 0 or tv.career == DataCenter.roleData.career)
                and tv.useLvl <= DataCenter.roleData.level
                and tv.profession <= DataCenter.roleData.profession
                and DataCenter.funcOpenData:isOpened(10066, false) == true 
                and tv.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
                if tv.force > wingForce then
                    isWingBetter = true;
                    betterList:add(tv.index);
                    if showNewItem ~= true then
                        break;
                    end
                end
            end
        end
    end
    if showNewItem == true then
        for i = 1, betterList:getSize() do
            Lua_WindowUtil.openWin("Lua_NewItemTipWindow", WinParam.ACTION_OPEN, betterList[i]);
        end
    end
    if isBetter then
        DataCenter.redDotData:updateRedDotVoState(10086, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = 10086, val = 1, bShow = true });
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
    else
        DataCenter.redDotData:updateRedDotVoState(10086, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = 10086, val = 0, bShow = false });
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end

    if isWingBetter then
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = 10090, val = 1, bShow = true });
        if DataCenter.funcOpenData:isOpened(10066) == true then
            DataCenter.redDotData:updateRedDotVoState(10090, true);
            Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
        end
    else
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = 10090, val = 0, bShow = false });
        if DataCenter.funcOpenData:isOpened(10066) == true then
            DataCenter.redDotData:updateRedDotVoState(10090, false);
            Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
        end
    end
end
function Lua_PackProxy:onSoleBack(mp)
    --[[
    if mp.errno == 0 then
        local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
        bagData:reoder();
    end
    ]]
end
function Lua_PackProxy:onBatchSoleBack(mp)
    if mp.errno == 0 then
        OperateAlert.show(LanUtil.getValue(110821));
    end
end
function Lua_PackProxy:delPackItem(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400102();
        msg:ParseFromString(mp.data);
        local bag = DataCenter.packData:getBagType(msg.pack_type);
        for i, v in ipairs(msg.del_item_list) do
            bag:removeItemByServer(v.del_index, v.del_amount);
        end
        Lua_CommonUtil.delayCollectCall("delPackItem_" .. msg.pack_type, self, self.onDelUpdate, msg.pack_type, 0.2);
    end
end
function Lua_PackProxy:onDelUpdate(packType)
    if packType == Lua_PackData.BAG_PACK then
        self:checkBetterEqu();
        if DataCenter.funcOpenData:isOpened(10141) == true then
            DataCenter.mountEquipData:checkMountRedDotSate(); -- 骑装红点更新
            Lua_MsgUtil.callFunc("PACK_MOUNTEQUIP_UPDATE");
        end

        if DataCenter.funcOpenData:isOpened(10184) == true then
            -- 更新 披风红点
            Lua_MsgUtil.callFunc("PACK_CLOAK_UPDATE");
            DataCenter.cloakData:checkCloakRedDotSate();
        end

        if DataCenter.funcOpenData:isOpened(10215) == true then
            Lua_MsgUtil.callFunc("PACK_EIDOLON_UPDATE");--幻灵
        end
    end
    DataCenter.combineUtil:checkCombineRedDot();
    Lua_MsgUtil.callFunc("PACK_UPDATE", packType);
    if packType == Lua_PackData.SACRED_ANIMAL_BAG then
        Lua_MsgUtil.callFunc("PACK_ANIMALINFO_UPDATE");
    end

    if packType == Lua_PackData.CARD_PACK then
        -- 卡牌
        if DataCenter.funcOpenData:isOpened(10149) == true then
            DataCenter.cardData:checkCardRedDotSate();-- 更新卡牌红点
            Lua_MsgUtil.callFunc("PACK_CARD_UPDATE");
        end
    end

    if packType == Lua_PackData.JH_PACK then
        -- 聚魂
        Lua_MsgUtil.callFunc("PACK_GATHERSOUL_UPDATE");
        if DataCenter.funcOpenData:isOpened(10112) == true then
            DataCenter.gatherSoulData:checkSoulRedDotSate()
        end
    end

    if packType == Lua_PackData.STAMP_PACK then
        -- 魂印
        Lua_MsgUtil.callFunc("PACK_STAMP_UPDATE");
        if DataCenter.funcOpenData:isOpened(10161) == true then
            -- 更新 魂印主界面 红点变强
            DataCenter.stampData:checkStampRedDotSate();
        end
    end

    if packType == Lua_PackData.ARMY_PACK then
        -- 军魂
        Lua_MsgUtil.callFunc("PACK_ARMY_UPDATE");
        if DataCenter.funcOpenData:isOpened(10193) == true then
            -- 更新 军魂红点
            DataCenter.armySoulData:checkArmyRedDotSate();
        end
    end
end
function Lua_PackProxy:onMoneyUpdate(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400103();
        msg:ParseFromString(mp.data);
        local omoney = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
        DataCenter.moneyData:setMoney(Lua_MoneyData.GOLD, msg.gold);
        if tonumber(tostring(msg.gold)) > omoney and DataCenter.rechargeData.winOpen == 1 then
            DataCenter.rechargeData:sGetRechargeInfo();
        end
        DataCenter.moneyData:setMoney(Lua_MoneyData.BIND_GOLD, msg.bind_gold);
        DataCenter.moneyData:setMoney(Lua_MoneyData.COPPER, msg.copper);
        DataCenter.moneyData:setMoney(Lua_MoneyData.BIND_COPPER, msg.bind_copper);
        DataCenter.moneyData:setMoney(Lua_MoneyData.SAVVY, msg.savvy);
        DataCenter.moneyData:setMoney(Lua_MoneyData.COPY_JIFEN, msg.st_score);
        DataCenter.moneyData:setMoney(Lua_MoneyData.SHENGWANG, msg.prestige);
        DataCenter.moneyData:setMoney(Lua_MoneyData.RONGYU, msg.glory);

        if getLanType() == 1 then --韩服
            DataCenter.moneyData:setMoney(Lua_MoneyData.JEWEL, msg.diamond);
        end

        Lua_MsgUtil.callFunc("MONEY_UPDATE", DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER));
        DataCenter.skillData:checkSkillUpdate();
    end
end
function Lua_PackProxy:onItemUsed(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto51400106();
        msg:ParseFromString(mp.data);
        local tvo = Lua_ToolVo.createToolVo(msg.item_id, 1, 1)
        local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
        bag:setCool(tvo);
        Lua_MsgUtil.callFunc("ITEM_CD_UPDATE", tvo.subType);
    elseif mp.errno == 1353 then
        --    DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
    end
end

function Lua_PackProxy:useGSBackGift(mp)
    if mp.errno == 0 then
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto51400031();
        msg:ParseFromString(mp.data);
        if msg.state == 1 then
            Lua_WindowUtil.openWin("Lua_SuperVipGiftWindow", WinParam.ACTION_CLOSE);
        end
    end
end

function Lua_PackProxy:useRoleRename(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_RenameTipWindow", WinParam.ACTION_CLOSE);
    end
end

function Lua_PackProxy:useFactionRename(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_RenameTipWindow", WinParam.ACTION_CLOSE);
    end
end