
-- 聚魂配置数据
checkRequire("Lua_SoulGatheringVo");
Lua_GatherSoulUtil = class("Lua_GatherSoulUtil");
function Lua_GatherSoulUtil:ctor()
    self:superCall("ctor");

end


function Lua_GatherSoulUtil.Get:pkg_size()--背包上限
	return getConfig({"soul_gather", "pkg_size", "value"});
end

function Lua_GatherSoulUtil.Get:soul_stone()--魂石id
    return getConfig({"soul_gather", "soul_stone", "value"});
end

function Lua_GatherSoulUtil.Get:soul_stone_name()--魂石名字
    local soul_stone_name = getConfig({"item",self.soul_stone}).name;
    local soul_stone_color = getConfig({"item",self.soul_stone}).color;

    return "[" .. Lua_ColorDefine.getItemColorStr(soul_stone_color,true) .. "]" .. soul_stone_name .. "[-]";
end

function Lua_GatherSoulUtil.Get:soul_dust()--魂之粉尘
    return getConfig({"soul_gather", "soul_dust", "value"});
end

function Lua_GatherSoulUtil.Get:attribute()--历练之魂灵魂属性(用于屏蔽凝聚按钮)
    return getConfig({"soul_gather", "attribute", "value"});
end

function Lua_GatherSoulUtil.Get:single_soul()--单属性灵魂升级
    return getConfig({"soul_upgrade_decomp", "single_soul_upgrade", "values"});
end

function Lua_GatherSoulUtil.Get:double_soul()--多属性灵魂升级
    return getConfig({"soul_upgrade_decomp", "double_soul_upgrade", "values"});
end

function Lua_GatherSoulUtil.Get:normal_decomp()--普通灵魂基础值
    return getConfig({"soul_upgrade_decomp", "normal_decomp", "values"});
end

function Lua_GatherSoulUtil.Get:specail_decomp()--特殊灵魂基础值
    return getConfig({"soul_upgrade_decomp", "specail_decomp", "values"});
end

function Lua_GatherSoulUtil:lvl_unlock(id)--解锁等级
    return getConfig({"soul_unlock_cond"})[id].lvl_unlock;
end

function Lua_GatherSoulUtil:prof_lvl(id)--解锁职业
    return getConfig({"soul_unlock_cond"})[id].prof_lvl;
end

function Lua_GatherSoulUtil:isMsxLvl(color,lvl)--是否满级
    if self.single_soul[color][lvl+1] ~= nil then
        return false;
    else
        return true;
    end
end

function Lua_GatherSoulUtil:soulResolveNum(arr)--分解获得总额
    local resolveNum = 0;
    for i=1,arr:getSize() do
        resolveNum = resolveNum + arr[i].decompose;
    end
    return resolveNum
end

-----------------------------------------------------------------------------------------------------------------------------------------
--下行，灵魂凝聚数据

function Lua_GatherSoulUtil:getArrByClassId(class_id) --通过组ID 获取ID所有数据
    return self.soulGatherConfigInfo[tostring(class_id)]
end

function Lua_GatherSoulUtil:getArrByClassAndGroupInfo(class_id,group_id) --通过组ID 获取vo
    local arr = self:getArrByClassId(class_id);
    if arr:getSize() ~= 0 then
         for i=1,arr:getSize() do
            if arr[i].soul_group_id == group_id then
                return arr[i];
            end
        end
    end
    return nil;
end

function Lua_GatherSoulUtil.Get:soulGatherConfigInfo()-- vo
    if self.gatherDic == nil then
        self.gatherDic = {};
        local config = getConfig({"soul_compress"});
        if config ~= nil then
            for k, v in pairs(config) do
                local vo = Lua_SoulGatheringVo.new(k, v);
                if self.gatherDic[tostring(vo.soul_class_id)] == nil then
                    self.gatherDic[tostring(vo.soul_class_id)] = Array();
                end
                self.gatherDic[tostring(vo.soul_class_id)]:add(vo);
            end
        end
    end
    return self.gatherDic;
end

function Lua_GatherSoulUtil.Get:gatherCalssInfo()-- 凝聚类数据
    if self.gather_info == nil then
        self.gather_info = {};
        local gather_calss = getConfig({"gatherSoul_class"});
        for i,v in pairs(gather_calss) do
            self.gather_info[i]= v;
        end
    end

    return self.gather_info;
end

function Lua_GatherSoulUtil.Get:getGatherCalssInfo()--用于凝聚界面页签显示
    local arr = self.gatherCalssInfo;
    if self.gatherCalssData == nil then
        self.gatherCalssData = Array();
        for k,v in pairs(arr) do
            local soul_group_list = v.soul_group_list;
            local sub1 = Array();
            if soul_group_list ~= nil then
                for i, j in pairs(soul_group_list) do
                    local temp = self:getArrByClassAndGroupInfo(k,j);
                        if temp ~= nil then
                        local soul_id = temp.id;
                        local soul_name = getConfig({"item",soul_id}).name;
                        sub1:add({name=soul_name, data = temp}); 
                    end
                end 
            end 
            self.gatherCalssData:add({name=v.soul_class_name, sub=sub1});           
        end
    end

    return self.gatherCalssData;
end


function Lua_GatherSoulUtil:updateShowRedList(class_id)--聚魂列表红点更新
    local isRedList = {};
    local have_stone = DataCenter.gatherSoulData.soulStone;
    local vo = self:getArrByClassId(class_id);
    
    for i=1,vo:getSize() do
        if vo[i].cost_item == nil then
            if vo[i].level <= DataCenter.roleData.level and have_stone >= vo[i].cost_soul_stone then
                isRedList[vo[i].soul_class_id] = true;
            end
        else
            local arr = vo[i].cost_item;
            local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[1][1]);
            local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[2][1]);
            local needNum1 = arr[1][2];
            local needNum2 = arr[2][2];
            if vo[i].level <= DataCenter.roleData.level
                and have_stone >= vo[i].cost_soul_stone
                and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
                isRedList[vo[i].soul_class_id] = true;
            end
        end
    end
    
    return isRedList;
end

function Lua_GatherSoulUtil:getShowCohesionRedList(class_id)--聚魂列表红点更新
    local isRedList = {};
    local have_stone = DataCenter.gatherSoulData.soulStone;
    local vo = self:getArrByClassId(class_id);

    for i=1,vo:getSize() do
        if vo[i].cost_item == nil then
            if vo[i].level <= DataCenter.roleData.level and have_stone >= vo[i].cost_soul_stone then
                isRedList[vo[i].soul_group_id] = true;
            end
        else
            local arr = vo[i].cost_item;
            local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[1][1]);
            local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.JH_PACK):getItemNum(arr[2][1]);
            local needNum1 = arr[1][2];
            local needNum2 = arr[2][2];
            if vo[i].level <= DataCenter.roleData.level 
                and have_stone >= vo[i].cost_soul_stone
                and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
                isRedList[vo[i].soul_group_id] = true;
            end
        end
    end

    return isRedList;
end

--打开 灵魂凝聚 界面所需要的值

function Lua_GatherSoulUtil:getSoulCostId(soul_id)--通过灵魂ID 获取对应双属性灵魂ID
    local config = getConfig({"soul_compress"})
    for k,v in pairs(config) do
        if v.cost_item ~= nil then
            if soul_id == v.cost_item[1][1] or soul_id == v.cost_item[2][1] then
                return k;
            end
        end
    end
end

function Lua_GatherSoulUtil:getSoulCalssId(costId)
    return getConfig({"soul_compress",costId}).soul_class_id;
end

function Lua_GatherSoulUtil:getSoulGroupIndex(costId,classId)--通过灵魂ID 获取组ID的索引
    local group_id = getConfig({"soul_compress",costId}).soul_group_id;
    local list = self.gatherCalssInfo[classId].soul_group_list;
    for i,v in ipairs(list) do
        if v == group_id then
            return i;
        end
    end
end

--灵魂拆解
function Lua_GatherSoulUtil:getSoulFrontName(soul_id)--灵魂聚集需要的材料单属性灵魂  -前
    local cost_item = getConfig({"soul_compress",soul_id}).cost_item;
    local color = getConfig({"item",cost_item[1][1]}).color;
    local name = getConfig({"item",cost_item[1][1]}).name;

    return  "[" .. Lua_ColorDefine.getItemColorStr(color,true) .. "]" .. name .. "[-]";
end

function Lua_GatherSoulUtil:getSoulLaterName(soul_id)--灵魂聚集需要的材料单属性灵魂  -后
    local cost_item = getConfig({"soul_compress",soul_id}).cost_item
    local color = getConfig({"item",cost_item[2][1]}).color;
    local name = getConfig({"item",cost_item[2][1]}).name;

    return "[" .. Lua_ColorDefine.getItemColorStr(color,true) .. "]" .. name .. "[-]";
end