Lua_PackUtil = {};
function Lua_PackUtil.doActClick(actVal, data)
	if data == nil then
		return;
	end

	if actVal == 1 then -- 装备
		Lua_PackUtil.equItem(data);
	elseif actVal == 2 then -- 卸下
		Lua_PackUtil.tackOffItem(data);
	elseif actVal == 3 then -- 出售
		Lua_PackUtil.soleItem(data);
	elseif actVal == 4 then -- 使用
		Lua_PackUtil.useItem(data);
	elseif actVal == 5 then -- 炫耀
		DataCenter.chatData:setChatShowItem(1, data);
		Lua_MsgUtil.callFunc("CHAT_SHOW_ITEM_UPDATE");
		OperateAlert.show(LanUtil.getValue(120234));
	elseif actVal == 6 then -- 放入
		Lua_PackUtil.toWhare(data);
	elseif actVal == 7 then -- 取出
		Lua_PackUtil.toPack(data);
	elseif actVal == 8 then -- 打开锻造
		if DataCenter.funcOpenData:isOpened(10006, true) == false then
			local tipsStr = getConfig({"func_open", 10006, "advance_message"});
			if tipsStr ~= nil then
				OperateAlert.show(tipsStr);
			end
			return;
		end
		Lua_WindowUtil.openWin("Lua_ForgingWindow");
	elseif actVal == 9 then -- 神翼穿戴
		Lua_PackUtil.putOnWing(data);
	elseif actVal == 10 then -- 帮派仓库取到背包里
		Lua_PackUtil.factionWhareToPack(data);
	elseif actVal == 11 then -- 捐献背包里面的装备到帮派仓库
		Lua_PackUtil.packEquToFactionWhare(data);
	elseif actVal == 12 then -- 市场上架
		if DataCenter.funcOpenData:isOpened(10036, true) == false then
			return;
		end

		if DataCenter.moneyData.mineShelvesArr ~= nil and DataCenter.marketUtil.myMarketShelvesNum <= DataCenter.moneyData.mineShelvesArr:getSize() then
			OperateAlert.show(LanUtil.getValue(121736));
			return;
		end
		Lua_WindowUtil.openWin("Lua_MarketOnShelvesWindow", WinParam.ACTION_OPEN, data);
	elseif actVal == 14 then -- 精灵装备
		Lua_PackUtil.putOnFairy(data);
	elseif actVal == 15 then -- 精灵卸下
		Lua_PackUtil.putOffFairy(data);
	elseif actVal == 16 then -- 精灵续费
		Lua_PackUtil.renewalFairy(data);
	elseif actVal == 17 then -- 帮派仓库销毁装备
		Lua_PackUtil.destroyFactionWhareItems(data);
	elseif actVal == 18 then -- 帮派仓库销毁装备或礼包类型物品的使用
		Lua_PackUtil.useGIFT(data);
	elseif actVal == 19 then -- 合成
		if data ~= nil and data.openWin ~= nil and data.openWin.compound ~= nil then
			Lua_PackUtil.openWinByList(data.openWin.compound, data, nil);
			return;
		end
	elseif actVal == 20 then -- 镶嵌
		if data ~= nil and data.openWin ~= nil and data.openWin.inlay ~= nil then
			local bShowPack = Lua_PackUtil.openWinByList(data.openWin.inlay, data, "Lua_PackWindow");
			if bShowPack == 1 then
				Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE, nil);
			end
			return;
		end
	elseif actVal == 21 then -- 神兽装备
		local master_id = DataCenter.sacredAnimalData.selectedEquId;
		Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sPutOnEquipMsg(master_id, data.index);
	elseif actVal == 22 then -- 神兽卸下
		local pack_index = Array();
		pack_index:add(data.part);
		Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sPutOutEquipMsg(data.master_id, pack_index);
	elseif actVal == 23 then -- 神兽强化
		Lua_WindowUtil.openWin("Lua_SacredBagWindow", WinParam.ACTION_CLOSE)
		Lua_WindowUtil.openWin("Lua_SacredQiangHuaWindow", WinParam.ACTION_OPEN)
	elseif actVal == 24 then -- 灵魂拆解
		DataCenter.gatherSoulData:onDismantleTipsClick(data);
	elseif actVal == 25 then -- 灵魂凝聚
		Lua_WindowUtil.openWin("Lua_SoulCohesionWindow", WinParam.ACTION_AUTO, { vo = data, isTips = false });
	elseif actVal == 26 then -- 灵魂升级
		Lua_WindowUtil.openWin("Lua_SoulUpgradeWindow", WinParam.ACTION_AUTO);
	elseif actVal == 27 then -- 灵魂佩戴
		DataCenter.gatherSoulData:onAdornSoulClick(data)
	elseif actVal == 28 then -- 灵魂卸下
		Lua_ProxyManager.getProxy("Lua_GatherSoulProxy"):sDischargeSoul(data.groove_id);
	elseif actVal == 29 then -- 灵魂分解
		if data.color >= 4 then
			DataCenter.gatherSoulData:onResolveTipsClick(data, true);
		else
			DataCenter.gatherSoulData:onResolveTipsClick(data, false);
		end
	elseif actVal == 30 then -- 骑装穿戴
		if DataCenter.funcOpenData:isOpened(10141) == false then
			local tipsStr = getConfig({"func_open", 10141, "advance_message"});
			if tipsStr ~= nil then
				OperateAlert.show(tipsStr);
			end
		else
			Lua_ProxyManager.getProxy("Lua_MountProxy"):sApparelMountEquip(data.index);
			Lua_WindowUtil.openWin("Lua_FeatureMainWindow", WinParam.ACTION_AUTO);
			Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE);
		end
	elseif actVal == 31 then -- 骑装卸下
		Lua_ProxyManager.getProxy("Lua_MountProxy"):sDischargeMountEquip(data.mountPart);
	elseif actVal == 32 then -- 骑装合成
		if DataCenter.funcOpenData:isOpened(10141) == false then
			local tipsStr = getConfig( { "func_open", 10141, "advance_message" });
			if tipsStr ~= nil then
				OperateAlert.show(tipsStr);
			end
		else
			Lua_WindowUtil.openWin("Lua_MountEquipCompoundWindow", WinParam.ACTION_AUTO, { vo = data });
		end
	elseif actVal == 33 then -- 骑装强化
		Lua_WindowUtil.openWin("Lua_MountEquipIntensifyWindow", WinParam.ACTION_AUTO);
	elseif actVal == 34 then
		Lua_WindowUtil.openWin("Lua_ItemSelectedWindow", nil, { list = DataCenter.mountEquipData:getSamePartEquipData(data.part), isEquip = true, isEquipPart = true });
	elseif actVal == 35 then -- 卡牌升级
		Lua_WindowUtil.openWin("Lua_CardUpdateWindow", WinParam.ACTION_OPEN);
	elseif actVal == 36 then -- 卡牌替换
		Lua_WindowUtil.openWin("Lua_CardPackWindow", WinParam.ACTION_OPEN, { grooveId = data.cardPart, armory_type = data.armory_type });
	elseif actVal == 37 then -- 卡牌卸下
		Lua_ProxyManager.getProxy("Lua_CardProxy"):sDischargeSoul(data.cardPart);
	elseif actVal == 38 then -- 卡牌佩戴
		Lua_ProxyManager.getProxy("Lua_CardProxy"):sInlaySoul(DataCenter.cardData.openGrooveId, data.index);
	elseif actVal == 39 then -- 魂印佩戴
		Lua_ProxyManager.getProxy("Lua_StampProxy"):sInlayStamp(data.id, data.index);
	elseif actVal == 40 then -- 魂印卸下
		Lua_ProxyManager.getProxy("Lua_StampProxy"):sUnloadStamp(data.part, data.stamp_type);
	elseif actVal == 41 then -- 魂印拆解
		DataCenter.stampData:onDismantleTipsClick(data);
	elseif actVal == 42 then -- 魂印分解
		if data.color >= 4 and data.stamp_type ~= 0 then
			DataCenter.stampData:onResolveTipsClick(data, true);
		else
			DataCenter.stampData:onResolveTipsClick(data, false);
		end
	elseif actVal == 43 then -- 魂印替换
		Lua_ProxyManager.getProxy("Lua_StampProxy"):sReplaceStamp(data.id, data.index);
	elseif actVal == 44 then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = nil, des = LanUtil.getValue(120587), type = 1, subFun = Lua_PackUtil.onChaiJieEquip,
			equipData = data, showChaiJie = true, subName = LanUtil.getValue(120588), cancelName = LanUtil.getValue(120589)});
	elseif actVal == 45 then -- 军装佩戴
		Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sSdornArmyEquip(data.army_id, data.id, data.index);
	elseif actVal == 46 then -- 军装替换
		if data.packType == nil then
			DataCenter.armySoulData.isSelectPack = false;
			Lua_WindowUtil.openWin("Lua_ArmyEquipPackWindow", WinParam.ACTION_OPEN, { soulType = data.soul_type })
		else
			Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sReplaceArmyEquip(data.army_id, data.id, data.index);
		end
	elseif actVal == 47 then -- 军装分解
		if data.color >= 4 then
			DataCenter.armySoulData:onResolveTipsClick(data, true);
		else
			DataCenter.armySoulData:onResolveTipsClick(data, false);
		end
	elseif actVal == 48 then -- 军装卸下
		Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sUnloadArmyEquip(data.army_id, data.part);
	elseif actVal == 49 then -- 军装强化
		Lua_WindowUtil.openWin("Lua_ArmyEquipIntensifyWindow", WinParam.ACTION_OPEN, data)
	elseif actVal == 50 then -- 神兽装备合成
		Lua_WindowUtil.openWin("Lua_SacredBagWindow", WinParam.ACTION_CLOSE)
		Lua_WindowUtil.openWin("Lua_SacredWindow", WinParam.ACTION_CLOSE)
		local _ShenShou = 1
		if data.star == 3 then
			_ShenShou = 2
		end
		Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_OPEN, { openIdx = 2, ShenShou = _ShenShou })
	elseif actVal == 51 then -- 生肖装备分解
		Lua_WindowUtil.openWin("Lua_ZodiacPackWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_ZodiacResolveWindow", WinParam.ACTION_OPEN);
	elseif actVal == 52 then -- 生肖装备穿戴
		local zodiacIndex = DataCenter.zodiacData.selectZodiacId;
		Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sWearEquip(zodiacIndex, data.index);
	elseif actVal == 53 then -- 生肖装备卸下
		local zodiacIndex = DataCenter.zodiacData.selectZodiacId;
		Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sDropEquip(zodiacIndex, data.part);
	end
end

function Lua_PackUtil.onChaiJieEquip(value, data)
	local msg = ProtoPublic_pb.Proto11400634();
	msg.pakg_index = data.equipData.index;
	sendMsg(11400634, msg);
end

-- list格式：[{"winName":"Lua_GamePlayWindow", "openIdx":1, "funId":10022, "copyId":1, "opName":"集字送礼"}]
-- itemID：用于打开商店时跳到指定道具
function Lua_PackUtil.openWinByList(list, data, checkWinName, needCheckOpen, itemID)
	if (needCheckOpen == nil or needCheckOpen) and Lua_PackUtil.checkOpenWinFunOpen(list) == false then
		return 0;
	end

	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local bShowWin = 1;
	local len = #list;
	for i = 1, len do
		local winName = list[i].winName;
		if list[i].show_kuafu ~= nil and list[i].show_kuafu ~= 0 then
			if list[i].show_kuafu == 1 and sceneConfig.kuafu_map == 1 then
				OperateAlert.show(LanUtil.getValue(122593));
				return 0;
			end

			if list[i].show_kuafu == 2 and sceneConfig.kuafu_map == 0 then
				OperateAlert.show(LanUtil.getValue(122593));
				return 0;
			end
		end

		if winName ~= nil and winName ~= "" then
			if checkWinName == winName then
				bShowWin = 2;
			end

			if "Lua_YunBiaoWindow" == winName then
				Lua_MsgUtil.callFunc("GO_YUN_BIAO");
			elseif "Lua_SoulCohesionWindow" == winName then
				-- 用于打开灵魂凝聚界面
				Lua_WindowUtil.openWin(winName, WinParam.ACTION_OPEN, {vo = data, isTips = true});
			elseif "Lua_ShopWindow" == winName then
				-- 用于打开商店并跳到指定道具
				Lua_WindowUtil.openWin(winName, WinParam.ACTION_OPEN, {openIdx = list[i].openIdx, data = data, funId = list[i].funId, opName = list[i].opName, nameIndex = list[i].nameIndex, itemID = itemID});
			else
				local avo = nil;
				if list[i].actFirstType ~= nil then
					avo = DataCenter.OperationalActivitiesData:getActivitiesByType(list[i].actFirstType, nil);
				end

				if avo == nil then
					Lua_WindowUtil.openWin(winName, WinParam.ACTION_OPEN, {openIdx = list[i].openIdx, data = data, funId = list[i].funId, opName = list[i].opName, nameIndex = list[i].nameIndex});
				else
					local rtData = DataCenter.allRtData.topRightIconDic[avo.icon_type];
					if rtData ~= nil then
						Lua_WindowUtil.openWin(rtData.param, nil, {iconId = rtData.id, opName = avo.title})
					else
						Lua_WindowUtil.openWin(winName, WinParam.ACTION_OPEN, {openIdx = list[i].openIdx, data = data, funId = list[i].funId, opName = list[i].opName});
					end
				end
			end
		end

		local copyId = list[i].copyId;
		if copyId ~= nil then
			local copyVo = DataCenter.copyData:getCopyById(copyId);
			if copyVo ~= nil and copyVo.win_name ~= nil then
				Lua_WindowUtil.openWin(copyVo.win_name, nil, copyVo);
			end
		end
	end
	return bShowWin;
end

-- list格式：[{"winName":"Lua_GamePlayWindow", "openIdx":1, "funId":10022, "copyId":1, "opName":"集字送礼"}]
function Lua_PackUtil.checkOpenWinFunOpen(list)
	if list == nil or #list < 1 then
		return false;
	end

	for i = 1, #list do
		if list[i].funId ~= nil and DataCenter.funcOpenData:isOpened(list[i].funId, true) == false then
			return false;
		end

		if "Lua_FactionMainWindow" == list[i].winName then
			local leagueId = DataCenter.roleData.leagueId;
			if leagueId == nil or leagueId == 0 then
				OperateAlert.show(LanUtil.getValue(110885));
				return false;
			end
		end

		if list[i].actId ~= nil then
			local adata = DataCenter.xianshiData:getDataById(list[i].actId);
			if adata ~= nil then
				-- if adata.activity_state == 0 or adata.activity_state == 3 then
				-- 	OperateAlert.show(LanUtil.getValue(110646));
				-- 	return false;
				-- end

				if DataCenter.roleData.level < adata.limit_level then
					OperateAlert.show(LanUtil.getValue(110647));
					return false;
				end
			end
		end

		if list[i].copyId ~= nil then
			local copyVo = DataCenter.copyData:getCopyById(list[i].copyId);
			if copyVo == nil or copyVo:isOpened() == false then
				OperateAlert.show(LanUtil.getValue(121115));
				return false;
			end
		end

		if list[i].actFirstType ~= nil then
			local actData = DataCenter.OperationalActivitiesData:getActivitiesByType(list[i].actFirstType, nil);
			if actData == nil then
				OperateAlert.show(LanUtil.getValue(122573));
				return false;
			end
		end
	end
	return true;
end

function Lua_PackUtil.useItem(data, num)
	-- 改名卡的使用
	if data.subType == Lua_PackTypeDefine.ROLE_RENAME_TYPE or data.subType == Lua_PackTypeDefine.FACTION_RENAME_TYPE then
		Lua_WindowUtil.openWin("Lua_RenameTipWindow", WinParam.ACTION_OPEN, {index = data.index, subType = data.subType});
		return;
	end

	-- 使用后台福利礼包特殊处理
	-- if data.type == Lua_PackTypeDefine.GSBACKGIFT_TYPE then
	-- 	Lua_WindowUtil.openWin("Lua_SuperVipGiftWindow", WinParam.ACTION_OPEN, data);
	-- 	return;
	-- end

	if data.subType == Lua_PackTypeDefine.HP_DRUG_ITEM or data.subType == Lua_PackTypeDefine.HP_DRUG_ITEM then
		local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
		if sceneConfig.limit_recover_item == 1 then
			OperateAlert.show(LanUtil.getValue(110881));
			return;
		end
	end

	-- 正常使用
	if data.useLvl > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.getValue(110823));
		return;
	end

	if data.unUse == 1 then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110823), data.colorName));
		return;
	end

	-- 打开对应功能界面
	if data ~= nil and data.openWin ~= nil and data.openWin.use ~= nil then
		local bShowPack = Lua_PackUtil.openWinByList(data.openWin.use, data, "Lua_PackWindow");
		if bShowPack == 1 then
			Lua_WindowUtil.openWin("Lua_PackWindow", WinParam.ACTION_CLOSE, nil);
		end
		return;
	end

	local bag = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bag:isCool(data) then
		OperateAlert.show(LanUtil.getValue(110878));
		return;
	end

	if data.effect_prop.name == "hook_time" then
		Lua_WindowUtil.openWin("Lua_OutLineAddWindow", WinParam.ACTION_OPEN, data);
		return;
	end

	if data.effect_prop.name == "exp_percent" then
		local buffId = Lua_CommonUtil.getCommonConfig("shenyou_buff", 1);
		local bvo = DataCenter.roleData:getBuffById(buffId, true);
		if bvo ~= nil and bvo.value2 ~= data.effect_prop.percent then
			local itemId = 0;
			if bvo.value2 == 50 then
				itemId = 204000004;
			elseif bvo.value2 == 100 then
				itemId = 204000003;
			elseif bvo.value2 == 200 then
				itemId = 204000002;
			end
			local oldStr = Lua_ToolVo.createToolVo(itemId, 1, 1).colorName;
			local leftTime = TimeTransform.getInstance():transSeconds6(bvo.leftTime, true, true);
			local newStr = data.colorName;

			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = nil, des = LanUtil.formateStr(LanUtil.getValue(110038), oldStr, leftTime, newStr),
				type = 1, subFun = Lua_PackUtil.doTipsUse, toolData = data});
			return;
		end
	end

	if num == nil then
		if data.batchUse == 1 and data.count > 1 then
			local useCount = 0
			local isUseTimeLimit = false
			if data.effect_prop.use_limit_num ~= nil and data.use_limit_num ~= 0 then
				isUseTimeLimit = true
				useCount = data.effect_prop.use_limit_num - data.useTimes
			end

			if useCount == 0 and isUseTimeLimit == true then
				local msg = ProtoPublic_pb.Proto11400106();
				msg.index = data.index;
				msg.amount = 1;
				sendMsg(11400106, msg);
				return
			end

			Lua_WindowUtil.openWin("Lua_BatchUseWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data,
				callBack = Lua_PackUtil.useItemCallBack, maxNum = data.count, startMax = true, toolData = data});
		else
			Lua_PackUtil.doUseItem(data, 1);
		end
	else
		Lua_PackUtil.doUseItem(data, num);
	end
end

function Lua_PackUtil.doTipsUse(value, data)
	if data.toolData.batchUse == 1 and data.toolData.count > 1 then
		local useCount = 0
		local isUseTimeLimit = false
		if data.toolData.effect_prop.use_limit_num ~= nil and data.toolData.toolData.use_limit_num ~= 0 then
			isUseTimeLimit = true
			useCount = data.toolData.effect_prop.use_limit_num - data.toolData.useTimes
		end

		if useCount == 0 and isUseTimeLimit == true then
			local msg = ProtoPublic_pb.Proto11400106();
			msg.index = data.toolData.index;
			msg.amount = 1;
			sendMsg(11400106, msg);
			return;
		end

		Lua_WindowUtil.openWin("Lua_BatchUseWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data.toolData,
			callBack = Lua_PackUtil.useItemCallBack, maxNum = data.toolData.count, startMax = true, toolData = data.toolData});
	else
		Lua_PackUtil.doUseItem(data.toolData, 1);
	end
end

function Lua_PackUtil.useItemCallBack(val, data)
	Lua_PackUtil.doUseItem(data, val);
end

function Lua_PackUtil.doUseItem(data, num)
	local msg = ProtoPublic_pb.Proto11400106();
	if data.effect_prop.name == "open_gift" then
		-- 开启攻城宝箱的钥匙使用
		local item = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemByItemId(data.effect_prop.gift_id);
		if item == nil then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110886), tostring(Lua_ToolVo.new(data.effect_prop.gift_id).colorName)));
			return;
		elseif DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(data.effect_prop.gift_id) < num then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110886), tostring(Lua_ToolVo.new(data.effect_prop.gift_id).colorName)));
			return;
		end
		msg.index = item.index;
		msg.amount = num;
	elseif data.effect_prop.name == "hook_time" then
		-- 离线挂机卡
		DataCenter.hangUpSettingsData:useOutTimeItem(data, num);
		return;
	else
		msg.index = data.index;
		msg.amount = num;
	end
	sendMsg(11400106, msg);
end

function Lua_PackUtil.useGIFT(data, num)
	if data.type == Lua_PackTypeDefine.GSBACKGIFT_TYPE then
		-- 使用后台福利礼包特殊处理
		Lua_WindowUtil.openWin("Lua_SuperVipGiftWindow", WinParam.ACTION_OPEN, data);
		return;
	end

	if data.type == Lua_PackTypeDefine.TREASURE_ACT_TYPE then
		Lua_WindowUtil.openWin("Lua_TreasureTipsWindow", WinParam.ACTION_OPEN, {owner = nil,
		subFun = Lua_PackUtil.useTreasureGiftCallBack, boxVo = data, rewardArr = data.treasureItemVo});
		return;
	end

	if data.useLvl > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.getValue(110823));
		return;
	end

	if data.unUse == 1 then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110823), data.colorName));
		return;
	end

	if data.subType == Lua_PackTypeDefine.NORMAL_GiftPack then
		if data.need_money ~= nil then
			Lua_MsgUtil.callFunc("USE_PACK_GIFT", data)
		else
			if num == nil then
				if data.batchUse == 1 and data.count > 1 then
					local useCount = 0
					local isUseTimeLimit = false
					if data.effect_prop.use_limit_num ~= nil and data.use_limit_num ~= 0 then
						isUseTimeLimit = true
						useCount = data.effect_prop.use_limit_num - data.useTimes
					end

					if useCount == 0 and isUseTimeLimit == true then
						local msg = ProtoPublic_pb.Proto11400106();
						msg.index = data.index;
						msg.amount = 1;
						sendMsg(11400106, msg);
						return
					end

					Lua_WindowUtil.openWin("Lua_BatchUseWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data,
						callBack = Lua_PackUtil.useGIFTCallBack, maxNum = data.count, startMax = true, toolData = data});
				else
					local msg = ProtoPublic_pb.Proto11400106();
					msg.index = data.index;
					msg.amount = 1;
					sendMsg(11400106, msg);
				end
			end
		end
	elseif data.subType == Lua_PackTypeDefine.SELECT_GiftPack then
		Lua_WindowUtil.openWin("Lua_SelectedGiftItemWindow", WinParam.ACTION_OPEN, data);
	elseif data.subType == Lua_PackTypeDefine.CONFIG_GiftPack then
		if data.need_money ~= nil then
			Lua_MsgUtil.callFunc("USE_PACK_GIFT", data)
		else
			if num == nil then
				if data.batchUse == 1 and data.count > 1 then
					local useCount = 0
					local isUseTimeLimit = false
					if data.effect_prop.use_limit_num ~= nil and data.use_limit_num ~= 0 then
						isUseTimeLimit = true
						useCount = data.effect_prop.use_limit_num - data.useTimes
					end

					if useCount == 0 and isUseTimeLimit == true then
						local msg = ProtoPublic_pb.Proto11400106();
						msg.index = data.index;
						msg.amount = 1;
						sendMsg(11400106, msg);
						return;
					end

					Lua_WindowUtil.openWin("Lua_BatchUseWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data,
						callBack = Lua_PackUtil.useGIFTCallBack, maxNum = data.count, startMax = true, toolData = data});
				else
					local msg = ProtoPublic_pb.Proto11400106();
					msg.index = data.index;
					msg.amount = 1;
					sendMsg(11400106, msg);
				end
			end
		end
	end
end

function Lua_PackUtil.useTreasureGiftCallBack(val, data, vo)
	local msg = ProtoPublic_pb.Proto11400029();
	msg.item_id = vo.id;
	msg.index = vo.index;
	msg.choose_id = data
	if data == 0 then
		OperateAlert.show(LanUtil.getValue(127106));
	else
		sendMsg(11400029, msg);
	end
end

function Lua_PackUtil.useGIFTCallBack(val, data)
	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = data.index;
	msg.amount = val;
	sendMsg(11400106, msg);
end

function Lua_PackUtil.equItem(data)
	local equip = DataCenter.equData:getEquByPart(data.part)
	if equip ~= nil then
		if equip.refine == 0 then
			local msg = ProtoPublic_pb.Proto11400612();
			msg.pkg_index = data.index;
			sendMsg(11400612, msg);
		else
			local refineCount = DataCenter.equData:getRefineCount(equip, equip.refine);
			if refineCount < 2 then
				local msg = ProtoPublic_pb.Proto11400612();
				msg.pkg_index = data.index;
				sendMsg(11400612, msg);
			else
				Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = nil, des = LanUtil.getValue(120540), type = 1,
					subFun = Lua_PackUtil.onSubEquipCallback, subName = LanUtil.getValue(120542), cancelName = LanUtil.getValue(120541),
				titleName = LanUtil.getValue(120543), equipData = data});
			end
		end
	else
		if data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
			return;
		end
		local msg = ProtoPublic_pb.Proto11400612();
		msg.pkg_index = data.index;
		sendMsg(11400612, msg);
	end
end

function Lua_PackUtil.onSubEquipCallback(value, data)
	if data.equipData.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
		return;
	end
	local msg = ProtoPublic_pb.Proto11400612();
	msg.pkg_index = data.equipData.index;
	sendMsg(11400612, msg);
end

function Lua_PackUtil.putOnWing(data)
	if DataCenter.roleData.level < data.useLvl then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110868), tostring(data.useLvl)));
		return;
	end
	local msg = ProtoPublic_pb.Proto11403814();
	msg.pack_index = data.index;
	sendMsg(11403814, msg);
end

function Lua_PackUtil.tackOffItem(data)
	local msg = ProtoPublic_pb.Proto11400613();
	msg.part = data.part;
	sendMsg(11400613, msg);
end

function Lua_PackUtil:delNewTip(data)
	if data.newTag ~= 1 then
		return;
	end
	local msg = ProtoPublic_pb.Proto11400153();
	msg.index = data.index;
	sendMsg(11400153, msg);
	data.newTag = 0;
	Lua_MsgUtil.callFunc("UPDATE_NEW_TAG", data.index);
end

function Lua_PackUtil.soleItem(data, checkRare, isAuto)
	local showTip = false;
	if checkRare ~= false then
		showTip = data.rare;
	end

	if showTip == false then
		local msg = ProtoPublic_pb.Proto11400110();
		msg.index = data.index;
		msg.amount = data.count;
		if isAuto == true then
			msg.auto = 1;
		else
			msg.auto = 0;
		end
		msg.pack_type = Lua_PackData.BAG_PACK;
		sendMsg(11400110, msg);
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = nil, des = LanUtil.getValue(110892),
			type = 1, subFun = Lua_PackUtil.doSoleItem, data = data, isAuto = isAuto});
	end
end

function Lua_PackUtil.doSoleItem(val, data)
	local msg = ProtoPublic_pb.Proto11400110();
	msg.index = data.data.index;
	msg.amount = data.data.count;
	msg.pack_type = Lua_PackData.BAG_PACK;
	if data.isAuto == true then
		msg.auto = 1;
	else
		msg.auto = 0;
	end
	sendMsg(11400110, msg);
end

function Lua_PackUtil.isBetterThen(evo)
	if evo == nil then
		return false;
	end

	local part = evo.part
	local myEqu = DataCenter.equData:getEquByPart(part);
	if myEqu == nil or evo.force > myEqu.force then
		return true;
	end
	return false;
end

function Lua_PackUtil.soleItems(list)
	local len = list:getSize();
	if len > 0 then
		local cmd = ProtoPublic_pb.Proto11400134();
		for i = 1, len do
			local good = ProtoPublic_pb.ProtoItemSellInfo();
			good.pack_index = list[i].index;
			good.sell_number = list[i].count;
			cmd.goods_list:addToList(good);
		end
		sendMsg(11400134, cmd);
	end
end

function Lua_PackUtil.buyItem(itemid, shopType, num, autoUse)
	local cmd = ProtoPublic_pb.Proto10100023();
	cmd.shop_type = shopType;
	cmd.item_id = itemid;
	cmd.buy_amount = num;
	if autoUse == nil then
		cmd.auto_use = false;
	else
		cmd.auto_use = autoUse;
	end
	sendMsg(10100023, cmd);
end

function Lua_PackUtil.combineItem(data, rateItems, isAll, universalInfo, isUseItem)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bagData.packSize - bagData:getUsedSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(110857));
		return false;
	end

	local arr;
	if universalInfo ~= nil then
		-- 万能道具
		arr = Lua_PackUtil.isUniversalItem(data.materials, universalInfo);
		if arr then
			return
		end
	else
		arr = Lua_PackUtil.getPackIndex(data.materials);
		if arr == nil then
			return false;
		end
	end

	local rateArr = nil;
	if rateItems ~= nil then
		local r = {};
		for i = 1, 4 do
			local itemId = rateItems[i];
			if itemId ~= 0 then
				if r[itemId] == nil then
					r[itemId] = 0;
				end
				r[itemId] = r[itemId] + 1;
			end
		end

		local r2 = Array();
		for k, v in pairs(r) do
			r2:add({id = k, count = v});
		end
		rateArr = Lua_PackUtil.getPackIndex(r2);
	end

	local itemArr = nil;
	if universalInfo ~= nil then
		-- 万能道具
		itemArr = Lua_PackUtil.getPackUniversalIndex(universalInfo.id);
	end

	local cmd = ProtoPublic_pb.Proto11400125();
	cmd.rule_id = data.id;
	if isAll ~= nil and isAll == true then
		cmd.is_all_rule = 1;
		if universalInfo ~= nil then
			-- 万能道具
			if arr ~= nil then
				for i = 1, arr:getSize() do
					cmd.material_index:append(arr[i]);
				end
			end

			if rateArr ~= nil then
				for i = 1, rateArr:getSize() do
					cmd.rate_index:append(rateArr[i]);
				end
			end
		end

		if itemArr ~= nil then
			-- 万能道具 一键合成
			cmd.use_universal_item = isUseItem;
			for i = 1, itemArr:getSize() do
				cmd.universial_item:append(itemArr[i]);
			end
		else
			cmd.use_universal_item = 0;
		end
		sendMsg(11400125, cmd);
		return true;
	end

	if arr ~= nil then
		for i = 1, arr:getSize() do
			cmd.material_index:append(arr[i]);
		end
	end

	if rateArr ~= nil then
		for i = 1, rateArr:getSize() do
			cmd.rate_index:append(rateArr[i]);
		end
	end

	if itemArr ~= nil then
		cmd.use_universal_item = isUseItem;
		for i = 1, itemArr:getSize() do
			cmd.universial_item:append(itemArr[i]);
		end
	else
		cmd.use_universal_item = 0;
	end
	sendMsg(11400125, cmd);
	return true;
end

function Lua_PackUtil.putOnFairy(data)
	if data.fairyType ~= nil and data.fairyType ~= 0 then
		Lua_ProxyManager.getProxy("Lua_FairyProxy"):sPutOnFairy(data);
	end
end

function Lua_PackUtil.putOffFairy(data)
	Lua_ProxyManager.getProxy("Lua_FairyProxy"):sPutOffFairy(data);
end

function Lua_PackUtil.renewalFairy(data)
	-- Lua_WindowUtil.openWin("Lua_FairyTipsWindow", WinParam.ACTION_OPEN, {fairyPackItemData = data, winType = 2});
	Lua_WindowUtil.openWin("Lua_FairyExpireWindow", WinParam.ACTION_OPEN, {fairyPackItemData = data, winType = 2});
end

function Lua_PackUtil.getPackIndex(materials)
	local dic = {};
	for i = 1, materials:getSize() do
		if dic[materials[i].id] == nil then
			dic[materials[i].id] = 0;
		end
		dic[materials[i].id] = dic[materials[i].id] + materials[i].count;
	end

	local arr = Array();
	for k, v in pairs(dic) do
		local num = v;
		local inNum = 0;
		local tempTime = 0
		local fairyIndex = 0;
		local isAllTime = false;
		local bagItems = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemsById(k);
		if bagItems ~= nil then
			for j = 1, bagItems:getSize() do
				if bagItems[j].fairyVo ~= nil and bagItems[j].fairyVo.expireTimes ~= nil and isAllTime == false then
					if bagItems[j].fairyVo.isUsed == 1 then
						local leftTime = bagItems[j].fairyVo.expireTimes - DataCenter.roleData.serverTime;
						if leftTime > 0 and tonumber(bagItems[j].fairyVo.expireTimes) > tempTime then
							tempTime = tonumber(bagItems[j].fairyVo.expireTimes);
							fairyIndex = bagItems[j].index;
						end
					else
						isAllTime = true;
						fairyIndex = bagItems[j].index;
					end
				end
			end
		end

		if fairyIndex ~= nil and fairyIndex ~= 0 then
			arr:add(fairyIndex);
			inNum = inNum + 1;
		else
			local c = 1;
			while true do
				if bagItems == nil or bagItems[c] == nil then
					break;
				end
				local count = bagItems[c].count;
				local overdue = false;
				if bagItems[c].fairyVo ~= nil and bagItems[c].fairyVo.expireTimes ~= nil then
					if bagItems[c].fairyVo.isUsed == 1 then
						local leftTime = bagItems[c].fairyVo.expireTimes - DataCenter.roleData.serverTime;
						if leftTime <= 0 then
							overdue = true;
						end
					end
				end

				if overdue == false then
					for j = 1, count do
						inNum = inNum + 1;
						arr:add(bagItems[c].index);
						if inNum >= num then
							break;
						end
					end
				end

				if inNum >= num then
					break;
				end
				c = c + 1;
			end
		end

		if inNum < num then
			OperateAlert.show(LanUtil.getValue(110828));
			return nil;
		end
	end
	return arr;
end

function Lua_PackUtil.getPackUniversalIndex(id)
	-- 获取道具索引
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local arr = bagData:getBagAllData();
	local _arr = Array();
	for i = 1, arr:getSize() do
		if arr[i].id == id then
			_arr:add(arr[i].index);
		end
	end

	if _arr:getSize() > 0 then
		return _arr;
	else
		return nil;
	end
end

function Lua_PackUtil.isUniversalItem(materials, universalInfo)
	-- 判断万能道具+合成道具 是否够用
	for i = 1, materials:getSize() do
		local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(materials[i].id);
		if (bagNum + universalInfo.bagNum) < materials[i].count then
			OperateAlert.show(LanUtil.getValue(110828));
			return true;
		else
			return Lua_PackUtil.getPackUniversalIndex(materials[i].id)
		end
	end
end

function Lua_PackUtil.toWhare(data)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.WHARE);
	if bagData:getLeftSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(110864));
		return;
	end

	if data.count > 1 then
		Lua_WindowUtil.openWin("Lua_NumberInputWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data,
			callBack = Lua_PackUtil.toWhereCallBack, maxNum = data.count, startMax = true, titleName = LanUtil.getValue(110889)});
	else
		local cmd = ProtoPublic_pb.Proto11402901();
		cmd.pack_index = data.index;
		cmd.item_number = data.count;
		sendMsg(11402901, cmd);
	end
end

function Lua_PackUtil.toWhereCallBack(val, data)
	local cmd = ProtoPublic_pb.Proto11402901();
	cmd.pack_index = data.index;
	cmd.item_number = val;
	sendMsg(11402901, cmd);
end

function Lua_PackUtil.toPack(data)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bagData:getLeftSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(110863));
		return;
	end

	if data.count > 1 then
		Lua_WindowUtil.openWin("Lua_NumberInputWindow", WinParam.ACTION_OPEN, {owner = nil, callBackData = data,
			callBack = Lua_PackUtil.toPackCallBack, maxNum = data.count, startMax = true, titleName = LanUtil.getValue(110888)});
	else
		local cmd = ProtoPublic_pb.Proto11402902();
		cmd.store_index = data.index;
		cmd.item_number = data.count;
		sendMsg(11402902, cmd);
	end
end

function Lua_PackUtil.factionWhareToPack(data)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bagData:getLeftSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(110863));
		return;
	end

	local cmd = ProtoPublic_pb.Proto10100633();
	cmd.index = data.index;
	cmd.amount = data.count;
	sendMsg(10100633, cmd);
end

function Lua_PackUtil.destroyFactionWhareItems(data)
	local msg = getProtoMsg("Proto10100632");
	msg.goods_list:append(data.index);
	sendMsg(10100632, msg);
end

function Lua_PackUtil.resetCountInputData()
	Lua_PackUtil.startNum = true;
	Lua_PackUtil.onNum = 1;
	Lua_PackUtil.fwtpItemVo = nil;
end

-- function Lua_PackUtil.factionWhareToPackCallBack(data)
-- 	if data == nil then
-- 		return;
-- 	end

-- 	if Lua_PackUtil.fwtpItemVo == nil then
-- 		return;
-- 	end

-- 	if Lua_PackUtil.onNum == nil then
-- 		Lua_PackUtil.onNum = 1 ;
-- 	end

-- 	if data.state == 0 then -- 重置
-- 		Lua_PackUtil.startNum = true;
-- 		Lua_PackUtil.onNum = 1;
-- 		Lua_MsgUtil.callFunc("COUNTINPUT_CHANGE_NUM",Lua_PackUtil.onNum);
-- 		-- self:updateOnNum();
-- 		return;
-- 	elseif data.state == 1 then -- 数字
-- 		if Lua_PackUtil.startNum ~= nil and Lua_PackUtil.startNum == true then
-- 			Lua_PackUtil.onNum = data.num;
-- 			Lua_PackUtil.startNum = false;
-- 		else
-- 			local str = Lua_PackUtil.onNum..data.num;
-- 			Lua_PackUtil.onNum = tonumber(str);
-- 			if Lua_PackUtil.onNum > Lua_PackUtil.fwtpItemVo.count then
-- 				Lua_PackUtil.onNum = Lua_PackUtil.fwtpItemVo.count;
-- 			end
-- 		end
-- 		Lua_MsgUtil.callFunc("COUNTINPUT_CHANGE_NUM",Lua_PackUtil.onNum);
-- 	elseif data.state == 2 then -- ok
-- 		local cmd = ProtoPublic_pb.Proto10100633();
-- 		cmd.index = Lua_PackUtil.fwtpItemVo.index;
-- 		cmd.amount= Lua_PackUtil.onNum;
-- 		sendMsg(10100633, cmd);
-- 		Lua_MsgUtil.callFunc("COUNTINPUT_WIN_CLOSE");
-- 		-- self:updateOnNum();
-- 	end
-- end

-- function Lua_PackUtil.factionWhareToPackCallBack(val,data)
-- 	local cmd = ProtoPublic_pb.Proto10100633();
-- 	cmd.index = data.index;
-- 	cmd.amount= val;
-- 	sendMsg(10100633, cmd);
-- end

function Lua_PackUtil.packEquToFactionWhare(data)
	local cmd = getProtoMsg("Proto10100629");
	-- cmd.index = data.index;
	-- cmd.item_id = data.id;

	local obj = ProtoPublic_pb.ProtoPairObj();
	obj.obj_id = data.index;
	obj.obj_value = data.id;
	cmd.index_item_id:addToList(obj);
	
	sendMsg(10100629, cmd);
end

function Lua_PackUtil.toPackCallBack(val, data)
	local cmd = ProtoPublic_pb.Proto11402902();
	cmd.store_index = data.index;
	cmd.item_number = val;
	sendMsg(11402902, cmd);
end

-- 市场上架
function Lua_PackUtil.showMarketSellDetail(data)
	local btnNames = Array();
	local actList = Array();
	if data ~= nil and data.bind ~= 1 then
		btnNames:add(LanUtil.getValue(121715));
		actList:add(12);
	end
	return {btnNames, actList};
end

-- 是否到期
function Lua_PackUtil.isDue(data)
	local isDue = false;
	if data.timeOut > 0 and data.timeOut - DataCenter.roleData.serverTime <= 0 then
		isDue = true;
	end
	return isDue;
end

function Lua_PackUtil.showNormalDetail(data)
	local btnNames = Array();
	local actList = Array();
	-- print("Lua_PackUtil", data.packType, data.subType, data.type, data.unUse);
	if data.packType == Lua_PackData.BAG_PACK and data.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE and
		data.subType ~= Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then
		if data.type == 1 then
			btnNames:add(LanUtil.getValue(110812));
			-- 装备
			actList:add(1);
			if data.star == 4 then
				btnNames:add(LanUtil.getValue(124436));
				-- 拆解装备
				actList:add(44);
			end
		elseif data.unUse == 0 then
			if data.subType == Lua_PackTypeDefine.WING_ITEM then
				btnNames:add(LanUtil.getValue(110835));
				-- 穿戴
				actList:add(9);
			elseif data.subType == Lua_PackTypeDefine.SPRITE then
				local isDue = Lua_PackUtil.isDue(data);
				if isDue and data.fairyVo.isCanRenew then
					btnNames:add(LanUtil.getValue(110874));
					-- 续费
					actList:add(16);
				elseif isDue == false then
					btnNames:add(LanUtil.getValue(110812));
					-- 装备
					actList:add(14);
				end
			elseif data.subType == Lua_PackTypeDefine.NORMAL_GiftPack
				or data.subType == Lua_PackTypeDefine.SELECT_GiftPack
				or data.subType == Lua_PackTypeDefine.CONFIG_GiftPack then

				if data.timeOut ~= nil and data.timeOut ~= 0 then
					if data.timeOut - DataCenter.roleData.serverTime > 0 then
						btnNames:add(LanUtil.getValue(110822));
						-- 使用
						actList:add(18);
					end
				else
					btnNames:add(LanUtil.getValue(110822));
					-- 使用
					actList:add(18);
				end
			else
				btnNames:add(LanUtil.getValue(110822));
				-- 使用
				actList:add(4);
			end
		end

		-- 合成
		if data.compound ~= nil and data.compound == 1 then
			btnNames:add(LanUtil.getValue(110883));
			-- 镶嵌
			actList:add(19);
		end

		-- 镶嵌
		if data.subType == Lua_PackTypeDefine.ATT_JEWL or data.subType == Lua_PackTypeDefine.DEF_JEWL then
			btnNames:add(LanUtil.getValue(110882));
			-- 镶嵌
			actList:add(20);
		end

		-- 上架
		if DataCenter.marketData:checkCanOnSheleves(data) == true then
			btnNames:add(LanUtil.getValue(121715));
			-- 上架
			actList:add(12);
		end

		if data.sys_price ~= 0 then
			if data.subType == Lua_PackTypeDefine.SPRITE then
				-- 精灵特殊判断
				local isDue = Lua_PackUtil.isDue(data);
				if isDue == true then
					btnNames:add(LanUtil.getValue(110819));
					-- 出售
					actList:add(3);
				end
			else
				btnNames:add(LanUtil.getValue(110819));
				-- 出售
				actList:add(3);
			end
		end
	elseif data.packType == Lua_PackData.EQU_PACK then
		if data.type == 1 then
			btnNames:add(LanUtil.getValue(110854));
			-- 锻造
			actList:add(8);

			btnNames:add(LanUtil.getValue(110813));
			-- 卸下
			actList:add(2);
		end

		if data.subType == Lua_PackTypeDefine.SPRITE then
			local isDue = Lua_PackUtil.isDue(data);
			if isDue and data.fairyVo.isCanRenew then
				btnNames:add(LanUtil.getValue(110874));
				-- 续费
				actList:add(16);
			-- else
			end
			btnNames:add(LanUtil.getValue(110813));
			-- 卸下
			actList:add(15);
		end
	elseif data.packType == Lua_PackData.SACRED_ANIMAL_BAG then
		-- 神兽背包
		btnNames:add(LanUtil.getValue(110812));
		actList:add(21);
		if (data.star == 2 or data.star == 3) and data.color == 5 then
			btnNames:add(LanUtil.getValue(110801));
			actList:add(50);
		end
	elseif data.master_id ~= nil and data.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
		-- 装备上神兽
		btnNames:add(LanUtil.getValue(124601));
		actList:add(23);
		btnNames:add(LanUtil.getValue(110813));
		actList:add(22);
	elseif data.type == 8 and data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM then
		-- 灵魂背包
		if (data.packType ~= 999 and data.packType ~= nil) or data.groove_id ~= nil then
			-- data.groove_id 佩戴灵魂标识，
			if data.groove_id ~= nil then
				-- 已佩戴
				if data.prop_type == 2 then
					-- 拆解
					if data.color >= 3 then
						btnNames:add(LanUtil.getValue(124436));
						actList:add(24);
					end
				end
				-- 升级
				btnNames:add(LanUtil.getValue(124438));
				actList:add(26);
				-- 卸下
				btnNames:add(LanUtil.getValue(124439));
				actList:add(28);
			else
				-- 未佩戴
				if data.soul_type ~= 2 then
					btnNames:add(LanUtil.getValue(124440));
					actList:add(27);
				end

				if data.prop_type == 2 then
					-- 拆解
					if data.color >= 3 then
						btnNames:add(LanUtil.getValue(124436));
						actList:add(24);
					end
				elseif data.prop_type == 1 then
					if data.color >= 3 then
						-- 凝聚
						if data.attribute ~= DataCenter.gatherSoulUtil.attribute then
							btnNames:add(LanUtil.getValue(124437));
							actList:add(25);
						end
					end
					-- 分解
					btnNames:add(LanUtil.getValue(124441));
					actList:add(29);
				end
			end
		end
	elseif data.type == 1 and data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
		-- 骑装
		if data.mountPart ~= nil then
			-- 已佩戴
			-- 强化
			btnNames:add(LanUtil.getValue(110550));
			actList:add(33);
			-- 合成
			btnNames:add(LanUtil.getValue(110801));
			actList:add(32);
			-- 替换
			btnNames:add(LanUtil.getValue(110584));
			actList:add(34);
			-- 卸下
			btnNames:add(LanUtil.getValue(124439));
			actList:add(31);
			-- 炫耀
			btnNames:add(LanUtil.getValue(110820));
			actList:add(5);
		else
			-- 未佩戴
			-- 装备
			btnNames:add(LanUtil.getValue(110812));
			actList:add(30);
			-- 合成
			btnNames:add(LanUtil.getValue(110801));
			actList:add(32);
			-- 上架
			if DataCenter.marketData:checkCanOnSheleves(data) == true then
				btnNames:add(LanUtil.getValue(121715));
				-- 上架
				actList:add(12);
			end
			-- 出售
			btnNames:add(LanUtil.getValue(110819));
			actList:add(3);
		end
	elseif data.type == 11 and data.subType == Lua_PackTypeDefine.CARD_ITEM and data.packType ~= 999 and data.packType ~= 200 then
		-- 卡牌
		if data.cardPart ~= nil then
			-- 升级
			btnNames:add(LanUtil.getValue(124438));
			actList:add(35);
			-- 替换
			btnNames:add(LanUtil.getValue(110584));
			actList:add(36);
			-- 卸下
			btnNames:add(LanUtil.getValue(124439));
			actList:add(37);
		elseif data.packType == Lua_PackData.CARD_PACK then
			-- 穿戴
			btnNames:add(LanUtil.getValue(110835));
			actList:add(38);
		end
	elseif data.type == 12 and data.subType == Lua_PackTypeDefine.STAMP_ITEM then
		-- 魂印
		if data.stamp_part ~= nil then
			-- 卸下
			btnNames:add(LanUtil.getValue(124439));
			actList:add(40);
		elseif data.packType == Lua_PackData.STAMP_PACK then
			if data.stamp_type ~= 0 then
				if data.isSameType == true then
					-- 替换
					btnNames:add(LanUtil.getValue(110584));
					actList:add(43);
				else
					-- 穿戴
					btnNames:add(LanUtil.getValue(110835));
					actList:add(39);
				end

				if data.isCanCohesion == true then
					-- 分解
					btnNames:add(LanUtil.getValue(124441));
					actList:add(42);
					-- 拆解
					btnNames:add(LanUtil.getValue(124436));
					actList:add(41);
				else
					-- 分解
					btnNames:add(LanUtil.getValue(124441));
					actList:add(42);
				end
			else
				-- 分解
				btnNames:add(LanUtil.getValue(124441));
				actList:add(42);
			end

			-- 上架
			if DataCenter.marketData:checkCanOnSheleves(data) == true then
				btnNames:add(LanUtil.getValue(121715));
				-- 上架
				actList:add(12);
			end
		end
	elseif data.type == 13 and data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
		-- 军装
		if data.army_part ~= nil then
			-- 替换
			btnNames:add(LanUtil.getValue(110584));
			actList:add(46);
			-- 强化
			btnNames:add(LanUtil.getValue(110550));
			actList:add(49);
			-- 卸下
			btnNames:add(LanUtil.getValue(124439));
			actList:add(48);
		elseif data.packType == Lua_PackData.ARMY_PACK then
			if DataCenter.armySoulData.isSelectPack == true then
				-- 分解
				btnNames:add(LanUtil.getValue(124441));
				actList:add(47);
			else
				if data.isSameType == false then
					-- 替换
					btnNames:add(LanUtil.getValue(110584));
					actList:add(46);
				else
					-- 穿戴
					btnNames:add(LanUtil.getValue(110835));
					actList:add(45);
				end
				-- 分解
				btnNames:add(LanUtil.getValue(124441));
				actList:add(47);
			end
		end
	elseif data.type == 1 and data.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖
		if data.packType == Lua_PackData.ZODIAC_PACK then
			-- 上架
			if DataCenter.marketData:checkCanOnSheleves(data) == true then
				btnNames:add(LanUtil.getValue(121715));
				actList:add(12);
			end
			-- 分解
			btnNames:add(LanUtil.getValue(124441));
			actList:add(51);
			-- 装备
			btnNames:add(LanUtil.getValue(110812));
			actList:add(52);
		else
			if data.isWear == true then
				-- 卸下
				btnNames:add(LanUtil.getValue(124439));
				actList:add(53);
			end
		end
	end

	if data.packType == Lua_PackData.BAG_PACK or data.packType == Lua_PackData.EQU_PACK
		or data.master_id ~= nil or data.packType == Lua_PackData.SACRED_ANIMAL_BAG then
		btnNames:add(LanUtil.getValue(110820));
		-- 炫耀
		actList:add(5);
	end
	return {btnNames, actList};
end

function Lua_PackUtil.showWhareDetail(data)
	local btnNames = Array();
	local actList = Array();
	if data.packType == Lua_PackData.BAG_PACK then
		if DataCenter.packData.showFactionDonateEquPanel == true then
			btnNames:add(LanUtil.getValue(121030));
			actList:add(11);
		else
			btnNames:add(LanUtil.getValue(110830));
			actList:add(6);
		end
	elseif data.packType == Lua_PackData.WHARE then
		btnNames:add(LanUtil.getValue(110831));
		actList:add(7);
	elseif data.packType == Lua_PackData.FACTION_WHARE then
		btnNames:add(LanUtil.getValue(121031));
		actList:add(10);
		
		-- if DataCenter.factionData.myFactionInfo:isFactionLord() == true then
		-- 	btnNames:add(LanUtil.getValue(121050));
		-- 	actList:add(17);
		-- end
	end
	return {btnNames, actList};
end

function Lua_PackUtil.getEquipPart(part)
	if part == Lua_PackTypeDefine.SPRITE_PART then
		return LanUtil.getValue(110870);
	end
	return getConfig({"equipment_polish", "equip_part"})[part];
end

-- isMarketSell 是否是市场上架tips
function Lua_PackUtil.showItemInfo(data, isMarketSell, equLvlMark, isShowBtns)
    isShowBtns = isShowBtns == nil and true or isShowBtns;
    isMarketSell = isMarketSell == nil and false or isMarketSell;
    equLvlMark = equLvlMark == nil and false or equLvlMark;
	
	-- 1 装备
	if data.type == 1 or data.subType == Lua_PackTypeDefine.SPRITE -- 精灵
		or data.subType == Lua_PackTypeDefine.WING_ITEM then
		if data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE and -- 非背包和穿戴栏骑装隐藏按钮
			data.packType ~= Lua_PackData.BAG_PACK and data.mountPart == nil and data.packType ~= Lua_PackData.WHARE then
			isShowBtns = false;
		end

		if Lua_PackTypeDefine.SHENSHOU_EQU == data.subType and WindowMananger.getInstance():isWindowShowing("Lua_PackWindow") and WindowMananger.getInstance():isWindowShowing("Lua_SacredBagWindow") == false then
			isShowBtns = false;
		end
		Lua_WindowUtil.openWin("Lua_ItemEquDetailWindow", WinParam.ACTION_OPEN, {data = data, isShowBtns = isShowBtns, isMarketSell = isMarketSell, equLvlMark = equLvlMark});
	elseif data.type == 3 and data.subType == Lua_PackTypeDefine.LOVE_GIFT and DataCenter.marryData.keepsake_info.keepsake_id ~= 0 then
		Lua_WindowUtil.openWin("Lua_LoveGiftTipsWindow", WinParam.ACTION_OPEN, {data = data, isShowBtn = false});
		return;
	else
		Lua_WindowUtil.openWin("Lua_ItemDetailWindow", WinParam.ACTION_OPEN, {data = data, isShowBtns = isShowBtns, isMarketSell = isMarketSell});
	end
	-- Lua_MsgUtil.callFunc("SHILED_BOSS_UI_AVATAR",true);
end

function Lua_PackUtil.genAttName(att, data)
	local s = getConfig({"attr_name2", att.attr_id});
	local value = att.value;
	local str = LanUtil.formateStr(s, tostring(value));
	str = "[" .. Lua_ColorDefine.getItemColorStr(att.color) .. "]" .. str .. "[-]";

	local addVlaue = 0;
	local attrConfig = getConfig({"attr_common", att.attr_id});
	local percent_valueStr = "";
	if data ~= nil and data.jingcui_level ~= nil and data.jingcui_level ~= 0 then
		local cur_jingCuiConfig = data:getConfigDataByPartAndLvl(data.equPart, data.jingcui_level, 3);
		local addVlaue = math.floor(value * cur_jingCuiConfig[attrConfig.attr_english] / 100);
		if attrConfig.show_percent == 1 then
			addVlaue = string.format("%.3f", value * cur_jingCuiConfig[attrConfig.attr_english] / 100);
			percent_valueStr = "%";
		end
		addVlaue = addVlaue .. percent_valueStr;
		str = str .. "   [00E125](" .. LanUtil.getValue(140200) .. "+" .. addVlaue .. ")[-]";
	end
	return str;
end