-- 泳池派对 数据类型

checkRequire("Lua_PoolSunVo")
Lua_PoolPartyData = class("Lua_PoolPartyData");
function Lua_PoolPartyData:ctor()
	self:superCall("ctor");
    self.selectPlayrId = nil;
end

function Lua_PoolPartyData:dispose()
    if self.roleArr then
        self.roleArr:clear();
        self.roleArr:dispose();
    end

    if self.sunArr then
        self.sunArr:clear();
        self.sunArr:dispose();
    end
    self.selectPlayrId = nil;
end

-- 日光浴
function Lua_PoolPartyData:fromServerSunInfo(msg) -- 道具界面信息
    if not msg then
        return
    end
    self.sunArr = Array();
    self.sunArr:clear();
    local list = msg.item_list;
    for k, v in ipairs(list) do
        local vo = Lua_PoolSunVo.new();
        vo.id = k;
        vo:formServer(v);
        self.sunArr:add(vo);
    end
end

function Lua_PoolPartyData.Get:isShowUnlock() -- 是否拥有道具
    local arr = self.sunArr;
    for i=1,arr:getSize() do
        if arr[i].isUnlock == 1 then
            return true;
        end
    end
    return false;
end

function Lua_PoolPartyData:fromServerSceneInfo(msg) -- 泳池派对场景 信息
    if not msg then
        return
    end

    self.total_exp = msg.total_exp;             -- 获得的总经验值
    self.exp_multi = msg.exp_multi;             -- 日光浴加成倍率
    self.interaction_exp = msg.interaction_exp; -- 互动获得的经验值

    self.partner_id = msg.partner_id;            -- 日光浴伙伴id
    self.partner_name = msg.partner_name;        -- 日光浴伙伴名字
    self.sun_bath_type = msg.sun_bath_type;      -- 日光浴类型 0未使用 1自身的船 2他人的船
    self.sun_bath_state = msg.sun_bath_state;    -- 日光浴状态 0空闲 1单人 2双人
    self.interaction_count = msg.interaction_count; -- 日光浴状态 互动剩余次数 

end

-- 请求信息
function Lua_PoolPartyData:fromServerRequestInfo(msg) 
    if not msg then
        return
    end
    self.roleArr = Array();
    self.roleArr:clear();
    local role_list = msg.role_list;
    for _,v in ipairs(role_list) do
        local list = {};
        list.player_id = v.id;
        list.name = v.name;
        list.value = v.value;
        if v.value == 1 then
            list.tips = LanUtil.getValue(140812);
        elseif v.value == 2 then
            list.tips = LanUtil.getValue(140813);
        end
        self.roleArr:add(list);
    end
end

-- 结算信息
function Lua_PoolPartyData:fromServerResultInfo(msg) 
    if not msg then
        return
    end
    self.result_exp = msg.total_exp;     -- 获得的总经验值
    self.left_time = msg.left_time;      -- 剩余退出时间
    self.packet_count = msg.packet_count;-- 获得的宝箱数量
end

-- 是否在泳池派对场景
function Lua_PoolPartyData.Get:isInPoolPartyScene()
    local sceneID = getConfig({"swimwear_party_const", "pool_scene_id", "value"});
    return DataCenter.roleData.sceneId == sceneID
end

-- 日光浴遮罩时间
function Lua_PoolPartyData.Get:mask_time()
    return getConfig({"swimwear_party_const", "mask_time", "value"});
end

-- 活动大厅ID
function Lua_PoolPartyData.Get:activity_id()
    local list =  getConfig({"swimwear_party_const", "activity_list", "arr"});
    return list[1]
end

-- 活动奖励ID
function Lua_PoolPartyData.Get:rewardId()
    return DataCenter.xianshiData:getDataById(self.activity_id).display_reward;
end

-- 宝箱Id
function Lua_PoolPartyData.Get:pool_box_id()
    return getConfig({"swimwear_party_const", "pool_box_id", "value"});
end

function Lua_PoolPartyData.Get:showActivityTime()
    return DataCenter.xianshiData:getDataById(self.activity_id).openTimeDesc;
end
