-- 泳池派对 消息类
checkRequire("Lua_PoolPartyData");
Lua_PoolPartyProxy = class("Lua_PoolPartyProxy");
function Lua_PoolPartyProxy:ctor()
	DataCenter.poolPartyData = Lua_PoolPartyData.new();

	LuaUtil.addLuaMsg(50402206, self, self.rSunItemInfo);   -- 泳池派对道具界面（返回）
	LuaUtil.addLuaMsg(50402207, self, self.rGoInSceneInfo); -- 进入泳池派对（返回）
	LuaUtil.addLuaMsg(50402203, self, self.rBoardingInfo);  -- 申请/邀请上船（返回）
	LuaUtil.addLuaMsg(50402202, self, self.rLabber);        -- 泼水（返回）

	LuaUtil.addLuaMsg(80402202, self, self.rPoolPartySceneInfo);     -- 通知玩家泳池派对信息
	LuaUtil.addLuaMsg(80402203, self, self.rPoolPartyRequestInfo);   -- 通知请求列表信息
	LuaUtil.addLuaMsg(80402204, self, self.rPoolPartyResultInfo);    -- 通知活动结算信息
	LuaUtil.addLuaMsg(80402206, self, self.rPoolPartyUpdateTimeInfo);-- 泳池派对时间信息通知
	LuaUtil.addLuaMsg(80402201, self, self.rPoolPartyBoatInfo);      -- 泳池外观信息
end

-- 上行消息号
-- 请求进入泳池派对场景
function Lua_PoolPartyProxy:sOnGoInPoolPartyScene()
	sendMsg(10402207);
end

-- 泳池派对 道具界面
function Lua_PoolPartyProxy:sPoolPartyItemInfo()
	sendMsg(10402206);
end

-- 泳池派对道具使用
function Lua_PoolPartyProxy:sUsePoolPartyItem(type,index)
	local cmd = ProtoPublic_pb.Proto10402201();
	cmd.type = tonumber(type); -- 1道具使用 2解锁道具
	cmd.index = tonumber(index);
	sendMsg(10402201, cmd);
end

-- 泳池派对 泼水
function Lua_PoolPartyProxy:sLabber(id)
	local cmd = ProtoPublic_pb.Proto10402202();
	cmd.target_player = tonumber(id); -- 泼水目标id
	sendMsg(10402202, cmd);
end

-- 泳池派对  申请/邀请上船
function Lua_PoolPartyProxy:sBoarding(type,role_id)
	local cmd = ProtoPublic_pb.Proto10402203(); 
	cmd.type = tonumber(type); -- 1申请 2邀请
	cmd.role_id = tonumber(role_id); -- 对方id
	sendMsg(10402203, cmd);
end

-- 泳池派对  下船/请离
function Lua_PoolPartyProxy:sDisembark(_type,role_id)
	local cmd = ProtoPublic_pb.Proto10402204();
	if _type == 1 then
		cmd.type = tonumber(_type);
	else
		cmd.type = tonumber(_type); -- 1自己下船 2请离
		cmd.role_id = tonumber(role_id); -- 请离对象id //自己下船时不需要这个字段
	end
	sendMsg(10402204, cmd);
end

-- 泳池派对  请求
function Lua_PoolPartyProxy:sRequestState(is_all_refuse,reply,role_id)
	local cmd = ProtoPublic_pb.Proto10402205();
	if is_all_refuse == 1 then
		cmd.is_all_refuse = tonumber(is_all_refuse); -- 是否一键拒绝 1是0否
	else
		cmd.reply = tonumber(reply); -- 1接受 2拒绝
		cmd.role_id = tonumber(role_id);-- 申请者/邀请者id
		cmd.is_all_refuse = tonumber(is_all_refuse); -- 是否一键拒绝 1是0否
	end
	sendMsg(10402205, cmd);
end





-- 通知玩家泳池派对信息
function Lua_PoolPartyProxy:rPoolPartySceneInfo(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402202();
		msg:ParseFromString(mp.data);
		DataCenter.poolPartyData:fromServerSceneInfo(msg);
		Lua_MsgUtil.callFunc("UPDARE_POOL_SCENE_INFO");
	end
end

-- 通知其他玩家泳日光浴状态
function Lua_PoolPartyProxy:rResultSunbathingTypeInfo(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402205();
		msg:ParseFromString(mp.data);
		if DataCenter.hook.selectedId ~= 0 and DataCenter.hook.selectedId ~= nil then
			local thingVo = DataCenter.thingData:getThing(DataCenter.hook.selectedId);
			thingVo.sun_bath_type = msg.type; -- 0未使用道具 1自身的 2他人的
			DataCenter.thingData:addThing(thingVo);
		end
	end
end

-- 泳池派对时间信息通知
function Lua_PoolPartyProxy:rPoolPartyUpdateTimeInfo(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402206();
		msg:ParseFromString(mp.data);
		DataCenter.poolPartyData.act_left_time = msg.act_left_time;      -- 活动剩余时间
		DataCenter.poolPartyData.packet_left_time = msg.packet_left_time;-- 礼包刷新剩余时间
		Lua_MsgUtil.callFunc("UPDARE_POOL_TIME_INFO");
	end
end

-- 通知请求列表信息
function Lua_PoolPartyProxy:rPoolPartyRequestInfo(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402203();
		msg:ParseFromString(mp.data);
		DataCenter.poolPartyData:fromServerRequestInfo(msg);
		Lua_MsgUtil.callFunc("UPDARE_POOL_REQUES_INFO");
	end
end

-- 申请/邀请上船（返回
function Lua_PoolPartyProxy:rBoardingInfo(mp) 
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50402203();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
			OperateAlert.show(LanUtil.getValue(140835))
		else
			OperateAlert.show(LanUtil.getValue(140836))
		end
	end
end

-- 通知活动结算信息
function Lua_PoolPartyProxy:rPoolPartyResultInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402204();
		msg:ParseFromString(mp.data);
		DataCenter.poolPartyData:fromServerResultInfo(msg);
		Lua_MsgUtil.callFunc("UPDARE_POOL_RESULT_INFO");
		Lua_MsgUtil.callFunc("UPDATE_BTNS_STATE",true);
		Lua_WindowUtil.openWin("Lua_PoolPartyCopyResultWindow", WinParam.ACTION_OPEN);
		Lua_WindowUtil.openWin("Lua_PoolPartyLeftWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PoolPartyCenterWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PoolPartyRequestWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PoolPlayWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PoolSunbathingWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_PoolPartyProxy:rGoInSceneInfo(mp) --请求进入泳池派对(返回)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("UPDATE_BTNS_STATE",false);
		Lua_WindowUtil.openWin("Lua_PoolPartyWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_PoolPartyLeftWindow", WinParam.ACTION_OPEN);
		Lua_WindowUtil.openWin("Lua_PoolPartyCenterWindow", WinParam.ACTION_OPEN);
		Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_PoolPartyProxy:rSunItemInfo(mp) -- 泳池派对道具界面（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50402206();
		msg:ParseFromString(mp.data);
		DataCenter.poolPartyData:fromServerSunInfo(msg);
		Lua_MsgUtil.callFunc("UPDARE_POOL_SUN_INFO");
	end
end

function Lua_PoolPartyProxy:rLabber(mp) -- 泳池派对泼水（返回）
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50402202();
		msg:ParseFromString(mp.data);
		local str = LanUtil.formateStr(LanUtil.getValue(140839), Lua_CommonUtil.getNumberTrans(msg.exp))
		OperateAlert.show(str);
	end
end 

function Lua_PoolPartyProxy:rPoolPartyBoatInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80402201();
		msg:ParseFromString(mp.data);

		if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
			DataCenter.roleData.sun_bath_type = msg.bath_sun_type;
		else
			local thingVo = DataCenter.thingData:getThing(msg.role_id);
			thingVo.sun_bath_type = msg.bath_sun_type;
			DataCenter.thingData:addThing(thingVo);
		end

		local rp = ThingUtil.instance:getThingById(tonumber(msg.role_id));
		local ownerPlayer = ThingUtil.instance:getThingById(tonumber(msg.owner_id));
		if not ownerPlayer then
			return;
		end
		local comount = nil;
		local mpdata = ownerPlayer.data;
		local comountid = tonumber(tostring(mpdata.comountRoleId));
		if msg.type == 1 then --上船
			if comountid ~= 0 
				and mpdata.comountConfigId ~= msg.shape_id then
				ThingUtil.instance:removeThing(comountid);
				comountid = 0;
			end

			if comountid == 0 then
				local cmd = CooperateMountData();
				cmd.kind = 17;
				cmd.mustShow = true;
				cmd.roleId = CooperateMountData.genId();
				cmd.objId = msg.shape_id;
				cmd.px = rp.data.px;
				cmd.py = rp.data.py;
				cmd.pz = rp.data.pz;

				comountid = tonumber(tostring(cmd.roleId));
				comount = ThingUtil.instance:addCoMount(cmd);
				cmd:setPlayer(comount);
			end
			comount = ThingUtil.instance:getThingById(comountid);

			if comount then
				if tonumber(msg.role_id) == tonumber(msg.owner_id) then
					comount:addRider(1, rp);
					if msg.partner_id ~= 0 then
						local partner = ThingUtil.instance:getThingById(msg.partner_id);
						if partner ~= nil then
							comount:addRider(2, partner);
						end
					end
				else
					comount:addRider(2, rp);
				end
			end
		elseif msg.type == 2 then --下船
			if comountid == 0 then
				return;
			end
			comount = ThingUtil.instance:getThingById(comountid);
			if comount then
				comount:removeRider(tonumber(msg.role_id));
			end
		end
	end
end