checkRequire("Lua_NewFristRechargeVo");
Lua_RechargeData = class("Lua_RechargeData");
function Lua_RechargeData:ctor()
	self:dispose();
end

function Lua_RechargeData:dispose()
	self.selectNum = 0;
	self.curDay = 0;
	self.remainDays = 0;
	self.receiveState = 0;
	self.activateState = 0;
	self.openState = 0;
	self.openMagicState = 0; -- 暴击法宝礼包 开启状态
	self.giftMagicState = 0; -- 暴击法宝礼包 领取状态
	self.winOpen = 0;
end

-- 领取首充奖励
function Lua_RechargeData:sReceiveFirstReward() 
	sendMsg(11401802);
end

-- 获取充值界面信息
function Lua_RechargeData:sGetRechargeInfo()
	local cmd = ProtoPublic_pb.Proto11401812();
	cmd.type = 0;
	sendMsg(11401812, cmd);
end

-- 礼金礼包
function Lua_RechargeData:sRechargeGiftBagMsg()
	sendMsg(11401818);
end

-- 领取礼包奖励
function Lua_RechargeData:sReceiveGiftBagRewardMsg() 
	sendMsg(11401819);
end

-- 暴击法宝礼包
function Lua_RechargeData:sRechargeMagicBagMsg()
	sendMsg(11401820);
end

-- 领取暴击法宝礼包奖励
function Lua_RechargeData:sReceiveMagicBagRewardMsg() 
	sendMsg(11401821);
end

-- 取消红点
-- function Lua_RechargeData:sCloseGiftRedDot()
-- 	sendMsg(11401822);
-- end

function Lua_RechargeData:fromServer51401812(msg)
	if msg == nil then
		return;
	end

	self.left_time = msg.left_time; -- 开服活动剩余秒数
	self.fist_recharge = msg.fist_recharge; -- 已充值过的元宝
	self.type = msg.type; -- 类型：0或空，默认首充，1新首充
	self.area_version = msg.area_version; -- 地区版本：0表示大陆，1表示繁体
	self.recharge_reward = msg.recharge_reward; -- 0不可领取，1已领取首充奖励，2为可领取

	local tvo;
	self.newRechargeDic = {};
	self.newRechargeArr = Array();
	for i,v in ipairs(msg.recharge_rewards) do -- 各天奖励状态：0不可领取，1已领取首充奖励，2为可领取
		tvo = Lua_NewFristRechargeVo.new(i);
		tvo:fromServer(v);
		self.newRechargeDic[i] = tvo;
		self.newRechargeArr:add(tvo);
	end

	self.selectIndex = 0;
	for i,v in ipairs(msg.recharge_rewards) do
		if v == 1 then
			self.selectIndex = i;
		end
	end

	if self.selectIndex == 3 then
		self.selectIndex = 3;
	else
		self.selectIndex = self.selectIndex + 1
	end

	if self.recharge_reward ~= 1  then
		-- Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10001);
		Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10002);
	else
		Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10001);
		Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10002);
	end
end

-- 开启礼金礼包金额
function Lua_RechargeData.Get:activateMoney()
	if getLanType() == 1 then
		return getConfig({"recharge_gift_korea", 1001, "money"});
	elseif getLanType() == 2 then
		if CommonUtil.isApplePlatform then
			return getConfig({"recharge_gift", "activate_ios", "value"});
		else
			return getConfig({"recharge_gift", "activate_android", "value"});
		end
	else
		if CommonUtil.isApplePlatform then
			return getConfig({"recharge_gift", "activate_ios", "value"}) / 10;
		else
			return getConfig({"recharge_gift", "activate_android", "value"}) / 10;
		end
	end
end

-- 礼金充值id
function Lua_RechargeData.Get:activateRechargeId()
	return getConfig({"recharge_gift", "recharge_id", "value"});
end

-- 每天可领礼金
function Lua_RechargeData.Get:activateCurDay()
	if getLanType() == 1 then
		return getConfig({"recharge_gift_korea", 1001, "bind_gold", 1});
	else
		return 100;
	end
end

-- 礼包持续天数
function Lua_RechargeData.Get:amountDayNum()
	if getLanType() == 1 then
		return getConfig({"recharge_gift_korea", 1001, "amount_days"});
	else
		return 7;
	end
end

-- 开启暴击礼包金额
function Lua_RechargeData.Get:openMagicBagMoney()
	if getLanType() == 1 then
		return getConfig({"item_gift_korea", 1002, "money"});
	elseif getLanType() == 2 then
		if CommonUtil.isApplePlatform then
			return getConfig({"item_gift", "activate_ios", "value"});
		else
			return getConfig({"item_gift", "activate_android", "value"});
		end
	else
		if CommonUtil.isApplePlatform then
			return getConfig({"item_gift", "activate_ios", "value"}) / 10;
		else
			return getConfig({"item_gift", "activate_android", "value"}) / 10;
		end
	end
end

-- 礼金充值id
function Lua_RechargeData.Get:magicRechargeId()
	return getConfig({"item_gift", "recharge_id", "value"});
end

-- 开启暴击礼包奖励
function Lua_RechargeData.Get:magicBagGiftData()
	local arr = Array();
	local defaultPart = nil;
	if defaultPart == nil then
		if CommonUtil.isApplePlatform then
			defaultPart = 170;
		else
			defaultPart = 180;
		end
	end

	-- 先写死奖励id
	local rewardId = 30172; -- getConfig({"item_gift", defaultPart, "value"});
	if getLanType() == 1 then
		rewardId = getConfig({"item_gift_korea", 1002, "gift_id"});
	end

	local list = getConfig({"rewards", rewardId, "client_goods_list"});
	for i,v in ipairs(list) do
		arr:add({id = v[1], count = v[2], bind = v[3]});
	end
	return arr;
end

-- 获取配置数组
function Lua_RechargeData:rechargeInfoArr()
    local s = "";
    if getCVersion() > 1248 then
        s = PlayerData.getInstance().phpData:getRechargeItemsStr();
    end

    local showList;
    if s ~= "" then
		local arr = string.split(s, "_");
		showList = {};
		for i = 1, arr:getSize() do
			showList[i] = tonumber(arr[i]);
		end
    else
		local defaultPart;
		local packageName = SDKPlatform.GetPackageName();
		if packageName ~= nil then
			local list = string.split(packageName, "_")
			local cid = tonumber(list[list:getSize()]);
			local sl = getConfig({"recharge_show", cid, "show_moneys"});
			if sl ~= nil then
				defaultPart = cid;
			end
		end

		if defaultPart == nil then
			if CommonUtil.isApplePlatform then
				defaultPart = "default_ios";
			else
				defaultPart = "default_android";
			end
		end
		showList = getConfig({"recharge_show", defaultPart, "show_moneys"});
    end

	local arr = Array();
	if self.openState == 1 then -- 服务端控制开启
		arr:add({isShowGiftBag = true})
	end

	if self.openMagicState == 1 then -- 服务端控制开启
		arr:add({isShowMagicBag = true})
	end

	local mitem;
	for i,v in ipairs(showList) do
		mitem = getConfig({"recharge", v});
		if mitem ~= nil then
			arr:add({id = v,money = tonumber(mitem.money), glodNum = tonumber(mitem.recharge_num),
				glodReward = tonumber(mitem.gold), bindGoldReward = tonumber(mitem.bind_gold),
				atlas = mitem.atlas, sprite = mitem.sprite});
		end
	end
	return arr;
end

--礼金礼包 变强显隐
function Lua_RechargeData:isGiftBeStrongRed(bool)
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22018, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22018, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22018, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22018, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

--法宝暴击礼包 变强显隐
function Lua_RechargeData:isRechargeBeStrongRed(bool)
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22019, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22019, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22019, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22019, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end