checkRequire("Lua_RechargeData");
Lua_RechargeProxy = class("Lua_RechargeProxy");
function Lua_RechargeProxy:ctor()
	DataCenter.rechargeData = Lua_RechargeData.new();

	-- LuaUtil.addLuaMsg(50100205, self, self.rRechargeList);
	LuaUtil.addLuaMsg(51401802, self, self.rReceiveFirstReward); -- 领取充值奖励（返回）
	LuaUtil.addLuaMsg(51401812, self, self.rRechargeInfo); -- 充值界面信息（返回）
	LuaUtil.addLuaMsg(51401818, self, self.rGetRechargeGiftBagInfo); -- 请求充值礼包界面数据（返回）礼金礼包
	LuaUtil.addLuaMsg(51401820, self, self.rGetRechargeMagicBagInfo); -- 请求暴击法宝礼包状态（返回）
	LuaUtil.addLuaMsg(81401808, self, self.rOpenFirstRechargeWindow); -- 通知首充奖励
	LuaUtil.addLuaMsg(81401602, self, self.nRechargeRewardInfo); -- 充值返回客户端充值获得的物品

	Lua_MsgUtil.addEventListener("OPEN_FACTION_FRISTRECHARGE", self, self.onOpenFristrecharge);
end

function Lua_RechargeProxy:rReceiveFirstReward(mp)
	if mp.errno == 0 then
		if DataCenter.rechargeData.type == 1 then
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10001);
			DataCenter.rechargeData.recharge_reward = 1;
		else
			local removIcon = true;
			for i,v in ipairs(DataCenter.rechargeData.recharge_rewards) do
				if v == 0 or v == 2 then
					removIcon = false;
				end
			end

			if removIcon == true then 
				Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10001);
				-- Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10002);
				DataCenter.rechargeData.recharge_reward = 1;
			end
		end
	end
end

function Lua_RechargeProxy:rRechargeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401812();
		msg:ParseFromString(mp.data);
		DataCenter.rechargeData:fromServer51401812(msg);
		DataCenter.rechargeData.type = msg.type;
		DataCenter.rechargeData.recharge_rewards = msg.recharge_rewards;
		if msg.recharge_reward ~= 0 then
			Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10002);
		end

		if msg.type == nil or msg.type == 0 then 
			self.openWinName = "Lua_FristRechargeWindow";
		else
			self.openWinName = "Lua_NewFristRechargeWindow";
		end
		Lua_MsgUtil.callFunc("SET_FRISTRECHARGE_BTN");
		Lua_MsgUtil.callFunc("SET_RECHARGE_DATA");

		local playerLv = DataCenter.roleData.level;
		self.winOpenArr = self:getWinOpenLv();
		self.tipsOpenArr = self:getTipsOpenLv();
		-- if playerLv < self.winOpenArr[#self.winOpenArr] and msg.recharge_reward ~= 1 and self.winOpenKey == nil then
		-- 	self.winOpenKey = MsgUtil.addEventListener("PLAYER_LEVEL_UP", self, self.onWinOpen);
		-- end

		if playerLv < self.tipsOpenArr[#self.tipsOpenArr] and msg.recharge_reward == 0 and self.tipsOpenKey == nil then
			self.tipsOpenKey = MsgUtil.addEventListener("PLAYER_LEVEL_UP", self, self.onTipsOpen);
		end

		if self.chargeEveryDayKey == nil then
			self.everyDayArr = self:getChargeEveryDayData();
			local everyDayLen;
			self.topLevelArr = Array();
			for i = 1, #self.everyDayArr do
				everyDayLen = #self.everyDayArr[i];
				self.topLevelArr:add({num = self.everyDayArr[i][everyDayLen]});

				if playerLv < self.everyDayArr[i][everyDayLen] and self.chargeEveryDayKey == nil then
					self.chargeEveryDayKey = MsgUtil.addEventListener("PLAYER_LEVEL_UP", self, self.onChargeEveryDayOpen);
				end
			end
			self.topLevelArr:sort("num", true);
		end
	end
end

function Lua_RechargeProxy:getWinOpenLv()
	return Lua_CommonUtil.getCommonConfig("sr_appear_open_lv", 3);
end

function Lua_RechargeProxy:getTipsOpenLv()
	return Lua_CommonUtil.getCommonConfig("sr_appear_small_open_lv", 3);
end

function Lua_RechargeProxy:getChargeEveryDayData()
	return Lua_CommonUtil.getCommonConfig("charge_every_day", 3);
end

function Lua_RechargeProxy:onWinOpen()
	local playerLv = DataCenter.roleData.level;
	for i = 1, #self.winOpenArr do
		if playerLv == self.winOpenArr[i] and DataCenter.rechargeData.recharge_reward ~= 1 then
			Lua_WindowUtil.openWin(self.openWinName,WinParam.ACTION_OPEN);
			if playerLv >= self.winOpenArr[#self.winOpenArr] and self.winOpenKey ~= nil then
				MsgUtil.removeEventListener("PLAYER_LEVEL_UP", self.winOpenKey);
				self.winOpenKey = nil;
				return;
			end
		end

		if playerLv >= self.winOpenArr[#self.winOpenArr] and self.winOpenKey ~= nil then
			MsgUtil.removeEventListener("PLAYER_LEVEL_UP", self.winOpenKey);
			self.winOpenKey = nil;
		end
	end
end

function Lua_RechargeProxy:onTipsOpen()
	local playerLv = DataCenter.roleData.level;
	for i = 1, #self.tipsOpenArr do
		if playerLv == self.tipsOpenArr[i] and DataCenter.rechargeData.recharge_reward == 0 then
			Lua_WindowUtil.openWin("Lua_FristRechargeTipsWindow", WinParam.ACTION_OPEN);
			if playerLv >= self.tipsOpenArr[#self.tipsOpenArr] and self.tipsOpenKey ~= nil then
				MsgUtil.removeEventListener("PLAYER_LEVEL_UP", self.tipsOpenKey);
				self.tipsOpenKey = nil;
				return;
			end
		end

		if playerLv >= self.tipsOpenArr[#self.tipsOpenArr] and self.tipsOpenKey ~= nil then
			MsgUtil.removeEventListener("PLAYER_LEVEL_UP", self.tipsOpenKey);
			self.tipsOpenKey = nil;
		end
	end
end

function Lua_RechargeProxy:onChargeEveryDayOpen()
	local playerLv = DataCenter.roleData.level;
	local senceId = DataCenter.roleData.sceneId;
	for i = 1, #self.everyDayArr do
		if senceId == self.everyDayArr[i][1] then
			local everyDayLen = #self.everyDayArr[i];
			for j = 1,everyDayLen - 1 do
				if playerLv == self.everyDayArr[i][j + 1] then
					Lua_WindowUtil.openWin("Lua_ChargeEverydayWindow", WinParam.ACTION_OPEN);
					if self.topLevelArr[1].num <= playerLv and self.chargeEveryDayKey ~= nil then
						MsgUtil.removeEventListener("PLAYER_LEVEL_UP", self.chargeEveryDayKey);
						self.chargeEveryDayKey = nil;
						return;
					end
				end
			end
		end
	end
end

-- 礼金礼包信息返回
function Lua_RechargeProxy:rGetRechargeGiftBagInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401818();
		msg:ParseFromString(mp.data);
		DataCenter.rechargeData.curDay = msg.cur_day;
		DataCenter.rechargeData.remainDays = msg.remain_days;
		DataCenter.rechargeData.receiveState = msg.receive_state;
		DataCenter.rechargeData.activateState = msg.activate_state;
		DataCenter.rechargeData.openState = msg.open_state; -- 0不开放，1开放

		if msg.activate_state == 1 and msg.receive_state == 0 and msg.open_state == 1 then -- 变强
			DataCenter.rechargeData:isGiftBeStrongRed(true)
		else
			DataCenter.rechargeData:isGiftBeStrongRed(false)
		end
		Lua_MsgUtil.callFunc("SET_RECHARGE_DATA");
	end
end

-- 暴击法宝礼包信息返回
function Lua_RechargeProxy:rGetRechargeMagicBagInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401820();
		msg:ParseFromString(mp.data);
		DataCenter.rechargeData.giftMagicState = msg.gift_state; -- 0可购买，1可领取，2已领取
		DataCenter.rechargeData.openMagicState = msg.open_state; -- 0不开放，1开放
		DataCenter.rechargeData:rechargeInfoArr();

		if msg.open_state == 1 and msg.gift_state == 1 then--变强
			DataCenter.rechargeData:isRechargeBeStrongRed(true)
		else
			DataCenter.rechargeData:isRechargeBeStrongRed(false)
		end
		Lua_MsgUtil.callFunc("SET_RECHARGE_DATA");
	end
end

function Lua_RechargeProxy:rOpenFirstRechargeWindow(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401808();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
			Lua_WindowUtil.openWin(self.openWinName, WinParam.ACTION_OPEN);
			DataCenter.rechargeData.recharge_reward = 2;
		else
			local num = msg.timeout - msg.time;
			Lua_MsgUtil.callFunc("UPDATE_RTICON_SHOWTIME", {iconId = 10001, showTime = num});
		end
	end
end

function Lua_RechargeProxy:onOpenFristrecharge()
	Lua_WindowUtil.openWin(self.openWinName, WinParam.ACTION_OPEN);
end

function Lua_RechargeProxy:nRechargeRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401602();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_ChongzhiSucceededWindow", WinParam.ACTION_OPEN, msg);
	end
end