-- 红点数据
checkRequire("Lua_RedDotVo");
Lua_RedDotData = class("Lua_RedDotData");
function Lua_RedDotData:ctor()
end

function Lua_RedDotData.Get:allRedDotList()
	if self._allRedDotList == nil then
		self._allRedDotList = {};
		self._iconRedDotList = {};

		local config = getConfig({"red_tips"});
		if config ~= nil then
			local vo;
			for i, v in pairs(config) do
				vo = Lua_RedDotVo.new(i, v);
				self._allRedDotList[tostring(vo.evenId)] = vo;

				if vo.iconIds ~= nil then
					for i, v in ipairs(vo.iconIds) do
						if self._iconRedDotList[tostring(v)] == nil then
							self._iconRedDotList[tostring(v)] = Array();
						end
						self._iconRedDotList[tostring(v)]:add(vo);
					end
				end
			end
		end
	end
	return self._allRedDotList;
end

function Lua_RedDotData:upDataIconRedDotList()
	if self.newIconRedDotList == nil then
		self.newIconRedDotList = {};
	end

	local newList = {};
	if self._iconRedDotList ~= nil then
		for k, v in pairs(self._iconRedDotList) do
			if newList[tostring(k)] == nil then
				newList[tostring(k)] = Array();
			end

			for i = 1, v:getSize() do
				if v[i].first_type ~= nil then
					local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(tonumber(k));
					for j = 1, actList:getSize() do
						if actList[j].first_type == v[i].first_type then
							newList[tostring(k)]:add(v[i]);
						end
					end
				else
					newList[tostring(k)]:add(v[i]);
				end
			end
		end
		self.newIconRedDotList = newList;
	end
end

function Lua_RedDotData.Get:iconRedDotList()
	if self._iconRedDotList == nil then
		local list = self.allRedDotList;
	end
	if self.newIconRedDotList ~= nil then
		return self.newIconRedDotList;
	end
	return self._iconRedDotList;
end

-- 根据图标id获取界面红点显示状态
function Lua_RedDotData:getIconShowRedDotState(iconId)
	local arr = self:getIconShowRedDotArr(iconId);
	if arr == nil then
		return false;
	end

	local len = arr:getSize();
	for i = 1, len do
		local vo = arr[i];
		if vo.redState == true then
			return true;
		end
	end
	return false;
end

function Lua_RedDotData:getRedDotVoByIconIdAndType(iconId, subType)
	local arr = self:getIconShowRedDotArr(iconId);
	if arr == nil then
		return false;
	end

	local len = arr:getSize();
	for i = 1, len do
		local vo = arr[i];
		if tonumber(vo.subType) == tonumber(subType) then
			return vo;
		end
	end
	return nil;
end

-- 根据图标Id获取对应集合
function Lua_RedDotData:getIconShowRedDotArr(iconId)
	return self.iconRedDotList[tostring(iconId)];
end

-- 更新红点状态
function Lua_RedDotData:updateRedDotVoState(eventId, state)
	local vo = self:getRedDotVoByEventId(eventId);
	if vo ~= nil then
		vo:setRedState(state);
		self:checkIconRedState(vo);
	end
end

-- 根据红点Id获取对应显示状态
function Lua_RedDotData:getRedDotStateByEventId(eventId)
	local vo = self:getRedDotVoByEventId(eventId);
	if vo ~= nil then
		return vo.redState;
	end
	return false;
end

-- 根据红点Id获取对应集合
function Lua_RedDotData:getRedDotVoByEventId(eventId)
	return self.allRedDotList[tostring(eventId)];
end

function Lua_RedDotData:checkIconRedState(vo)
	if vo ~= nil and vo.iconIds ~= nil then
		for i,v in ipairs(vo.iconIds) do
			-- 背包栏的图标
			local iconData = DataCenter.menuIconData.menuIconDic[v];
			if iconData ~= nil then
				Lua_MsgUtil.callFunc("REFRESH_MENUICON_REDDOT", v);
				return;
			end

			-- 右上角图标
			iconData = DataCenter.allRtData.topRightIconDic[v];
			if iconData ~= nil then
				Lua_MsgUtil.callFunc("REFRESH_RIGHTTOP_ICONSREDDOT", v);
				return;
			end
		end
	end
end

function Lua_RedDotData:dispose()
	local list = self._allRedDotList;
	if list == nil then
		return;
	end
	
	for k, v in pairs(list) do
		v:setRedState(false);
	end
end