-- 红点
checkRequire("Lua_RedDotData");
Lua_RedDotProxy = class("Lua_RedDotProxy");
function Lua_RedDotProxy:ctor()
	DataCenter.redDotData = Lua_RedDotData.new();

	LuaUtil.addLuaMsg(51401702, self, self.rUpdateRedDotState); -- 系统提示详细内容(返回)
	LuaUtil.addLuaMsg(81401703, self, self.rAddShowRedDot); -- 主动提示红点
	LuaUtil.addLuaMsg(81401705, self, self.rRemoveShowRedDot); -- 主动提示红点消失
	LuaUtil.addLuaMsg(81401901, self, self.rFunOpenStateUpdate); -- 通知后台功能开关状态(主动)

	-- 客户端红点控制事件
	Lua_MsgUtil.addEventListener("MAINICON_UPDATE_REDDOTSTATE", self, self.onUpdateMainIconRedState);
end

-- 系统提示详细内容(返回)
function Lua_RedDotProxy:rUpdateRedDotState(mp)
	self.bInitState = true;
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401702();
		msg:ParseFromString(mp.data);
		
		local list = msg.event_list;
		local redState;
		if list ~= nil then
			for i = 1, #list do
				redState = list[i].obj_value > 0;
				DataCenter.redDotData:updateRedDotVoState(list[i].obj_id, redState);
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = list[i].obj_id,
					val = list[i].obj_value, bShow = redState});
			end
		end
	end
end

-- 主动提示红点
function Lua_RedDotProxy:rAddShowRedDot(mp)
	if self.bInitState ~= true then
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401703();
		msg:ParseFromString(mp.data);
		
		DataCenter.redDotData:updateRedDotVoState(msg.even_id, true);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = msg.even_id, val = msg.even_value, bShow = true});
	end
end

-- 主动提示红点消失
function Lua_RedDotProxy:rRemoveShowRedDot(mp)
	if self.bInitState ~= true then
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401705();
		msg:ParseFromString(mp.data);

		DataCenter.redDotData:updateRedDotVoState(msg.even_id, false);
		Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = msg.even_id, val = -1, bShow = false});
	end
end

-- 通知后台功能开关状态(主动)
function Lua_RedDotProxy:rFunOpenStateUpdate(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401901();
		msg:ParseFromString(mp.data);
		-- 0表示关闭， 1表开启
	end
end





---------------------------------------------------------------------------------------
-- 额外提供的2种客户端处理主界面图标红点控制方式，不需要在redDot配置表配置
---------------------------------------------------------------------------------------

-- 红点更新显示
-- {iconId = 10001, state = false}
-- Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10003, state = true});
function Lua_RedDotProxy:onUpdateMainIconRedState(obj)
	if obj == nil then
		return;
	end
	self:updateMainIconRedState(obj.iconId, obj.state);
end

-- 刷新主界面图标红点
-- Lua_ProxyManager.getProxy("Lua_RedDotProxy"):updateMainIconRedState(10001, true);
function Lua_RedDotProxy:updateMainIconRedState(iconId, state)
	local iconData = DataCenter.menuIconData.menuIconDic[iconId];
	if iconData ~= nil then -- 背包栏的图标
		iconData:setRedDotShowState(state);
		Lua_MsgUtil.callFunc("REFRESH_MENUICON_REDDOT", iconId);
		return;
	end

	-- 右上角图标
	iconData = DataCenter.allRtData.topRightIconDic[iconId];
	if iconData ~= nil then
		iconData:setRedDotShowState(state);
		Lua_MsgUtil.callFunc("REFRESH_RIGHTTOP_ICONSREDDOT", iconId);
	end
end