checkRequire("Lua_RedEnvelopeVo");
checkRequire("Lua_BulletinConfigVo");
Lua_RedEnvelopeData = class("Lua_RedEnvelopeData");
function Lua_RedEnvelopeData:ctor()
end

function Lua_RedEnvelopeData:rGetPanelInfo(msg)
	if msg == nil then
		return;
	end

	self.redEnvelopeList = msg.red_packet_list;
	self.type = msg.type;
	self.curPage = msg.cur_page;
	self.totalPage = msg.total_page;
	self.packFlag = msg.pack_flag;
	
	if DataCenter.configLoaded == 1 then
		self.brocastInfoList = msg.brocast_info;
	end
end

function Lua_RedEnvelopeData.Get:redEnvelopeList()
	return self._redEnvelopeList;
end

function Lua_RedEnvelopeData.Set:redEnvelopeList(list)
	if self._redEnvelopeList ~= nil then
		self._redEnvelopeList:clear();
	else
		self._redEnvelopeList = Array();
	end

	local vo
	for i,v in ipairs(list) do
		vo = Lua_RedEnvelopeVo.new();
		vo:fromServer(v);
		self._redEnvelopeList:add(vo);
	end
	self._redEnvelopeList:sort("orderIndex", false)
end

function Lua_RedEnvelopeData.Get:brocastInfoList()
	return self._brocastInfoList;
end

function Lua_RedEnvelopeData.Set:brocastInfoList(list)
	if self._brocastInfoList ~= nil then
		self._brocastInfoList:clear();
	else
		self._brocastInfoList = Array();
	end

	local vo;
	for k,v in ipairs(list) do
		vo = Lua_BulletinConfigVo.new(v.shout_id);
		self._brocastInfoList:add({shoutStr = vo:parseContent(v), time = v.time});
	end
end

function Lua_RedEnvelopeData.Get:redEnvelopeConfig()
	if self._redEnvelopeConfig == nil then
		self._redEnvelopeConfig = getConfig({"red_packet_const"});
	end
	return self._redEnvelopeConfig;
end