checkRequire("Lua_RedEnvelopeData")
checkRequire("Lua_RedEnvelopeDetailVo");
Lua_RedEnvelopeProxy = class("Lua_RedEnvelopeProxy")
function Lua_RedEnvelopeProxy:ctor()
	DataCenter.redEnvelopeData = Lua_RedEnvelopeData.new();

	LuaUtil.addLuaMsg(50101101, self, self.rGetPanelInfo); -- 获取红包面板信息
	LuaUtil.addLuaMsg(50101102, self, self.rSendRedEnvelope); -- 发送红包消息返回
	LuaUtil.addLuaMsg(50101103, self, self.rGrabRedEnvelope); -- 抢红包消息返回
	LuaUtil.addLuaMsg(50101104, self, self.rRedEnvelopeDetail); -- 获取红包详细信息
	LuaUtil.addLuaMsg(80101101, self, self.rOpenRedEnvelopeEntrance); -- 主动提示显示红包入口
	LuaUtil.addLuaMsg(80101102, self, self.rCloseRedEnvelopeEntrance); -- 主动提示关闭红包入口
end

function Lua_RedEnvelopeProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101101();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
		elseif msg.type == 2 then
			DataCenter.redEnvelopeData:rGetPanelInfo(msg);
			Lua_MsgUtil.callFunc("UPDATA_FACTION_RED_ENVELOPE_PANEL");
		end
	end
end

function Lua_RedEnvelopeProxy:rSendRedEnvelope(mp)
	self:sGetPanelInfo({type = 2, page = 1});
end

function Lua_RedEnvelopeProxy:rGrabRedEnvelope(mp)
	self:sGetPanelInfo({type = 2, page = 1});
end

function Lua_RedEnvelopeProxy:rRedEnvelopeDetail(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50101104();
		msg:ParseFromString(mp.data);

		local vo = Lua_RedEnvelopeDetailVo.new();
		vo:fromServer(msg.red_packet_detail);
		Lua_MsgUtil.callFunc("UPDATA_RED_ENVELOPE_DETAIL_PANEL", {detailVo = vo});
	end
end

function Lua_RedEnvelopeProxy:rOpenRedEnvelopeEntrance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80101101();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
		elseif msg.type == 2 then
			Lua_MsgUtil.callFunc("SHOW_FACTION_RED_ENVELOPE_ENTRANCE", {isShow = true, serverData = msg});
		end
	end
end

function Lua_RedEnvelopeProxy:rCloseRedEnvelopeEntrance(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("SHOW_FACTION_RED_ENVELOPE_ENTRANCE", {isShow = false});
	end
end





function Lua_RedEnvelopeProxy:sGetPanelInfo(param)
	local cmd = ProtoPublic_pb.Proto10101101();
	cmd.type = param.type;
	cmd.page = param.page;
	sendMsg(10101101, cmd);
end

function Lua_RedEnvelopeProxy:sSendRedEnvelope(param)
	local cmd = ProtoPublic_pb.Proto10101102();
	cmd.type = param.type;
	-- cmd.index = param.index;
	cmd.amount = param.amount;
	cmd.number = param.number;
	cmd.msg = param.msg;
	cmd.red_id = param.redId;
	sendMsg(10101102, cmd);
end

function Lua_RedEnvelopeProxy:sGrabRedEnvelope(param)
	local cmd = ProtoPublic_pb.Proto10101103();
	cmd.type = param.type;
	cmd.id = param.id;
	sendMsg(10101103, cmd);
end

function Lua_RedEnvelopeProxy:sRedEnvelopeDetail(param)
	local cmd = ProtoPublic_pb.Proto10101104();
	cmd.type = param.type;
	cmd.id = param.id;
	sendMsg(10101104, cmd);
end