checkRequire("Lua_RuneHoleVo")
Lua_RuneData = class("Lua_RuneData");
function Lua_RuneData:ctor()
    self:superCall("ctor");

    self.runeHolesInfo = {};
    self.runeTower = 0;     -- 当前通关灵纹塔层数
    self.grooveId = 0;      -- 解锁号
    self.ownEssence = 0;    -- 拥有灵纹
    self.ownEcrystal = 0;   -- 拥有灵晶
    self.afterEssence = 0;
    self.runeChip = 0;
    self.unLockType = nil;
    self.selectIndex = 1;   -- 灵纹页签默认选择
end

function Lua_RuneData:dispose()
    self.runeHolesInfo = {};
    self.runeTower = 0;
    self.grooveId = 0;
    self.ownEssence = 0;
    self.ownEcrystal = 0;
    self.runeChip = 0;
    self.afterEssence = 0;
    self.unLockType = nil;
    self.selectIndex = 1;
end


-- 孔位信息
function Lua_RuneData:fromServerHoldsInfo(msg)
    if msg == nil then
        return;
    end
    self.msg = msg;
    self.attr_prop = msg.attr_prop;--总属性
    local list = msg.groove_list;
    for k, v in ipairs(list) do
        local vo = Lua_RuneHoleVo.new();
        vo:formServer(v);
        vo.ownEssence = msg.essence;
        --vo.ownEcrystal = msg.rune_crystal;
        self.runeHolesInfo[tonumber(vo.id)] = vo;
    end
    self._attributeList = nil;
end

function Lua_RuneData:getArrByGrooveId(groove_id)--通过槽号 获取vo
    if self.runeHolesInfo[tonumber(groove_id)] == nil and self.runeHolesInfo[tonumber(groove_id)].runeId == 0 then
        return nil;
    end

    return self.runeHolesInfo[tonumber(groove_id)];
end

-- 合成 功能开启判断
function Lua_RuneData.Get:isOpenCompound()
    local data = getConfig({"func_open", 10157});
    local cond_level = data.cond_level;
    local prof_level = data.prof_level;
    local runetower_layer = data.runetower_layer;
    --local advance_function = data.advance_function;

    local palyerLvl = DataCenter.roleData.level;
    local palyerProf = DataCenter.roleData.profession;

    if palyerLvl >= cond_level and palyerProf >= prof_level and self.runeTower >= runetower_layer then
        return true;
    end
    return false;
end



function Lua_RuneData.Get:getAllRuneForce()--获得灵纹总战力
    local list = self.attr_prop;
    if list == nil then
        return 0;
    end
    local force = {};
    for i,v in ipairs(list) do
        if v.obj_value ~= 0 then
            force[tonumber(v.obj_id)] = v.obj_value;
        end   
    end
    return Lua_FightUtil.caculateForce(force);
end

-- 升级灵纹
function Lua_RuneData:fromServerUpgradeRune(msg)
    if msg == nil then
        return;
    end
    local vo = self.runeHolesInfo[tonumber(msg.groove_num)];
    if vo ~= nil then
        vo.runeLv = msg.rune_levle;
        vo.upgradeCostEssence = msg.need_essence;
        vo.bFullLv = msg.is_full_level == 1 and true or false;
    end
end

--界面分解红点处理
function Lua_RuneData:isShowResolveRed()
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);--灵纹背包
    local arr = bagData:getBagAllData();
    for i=1,arr:getSize() do
        if arr[i].color == 2 or arr[i].rune_type == 1 then
            return  true;
        end
    end
    return false;
end

--界面替换按钮红点处理
function Lua_RuneData:isShowChangeRed(grooveId)
    local vo = self:getArrByGrooveId(grooveId).runeVo
    local attribute = vo.attribute;
    local color =  vo.color;
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);--灵纹背包
    local arr = bagData:getBagAllData();
    for i=1,arr:getSize() do
        if arr[i].attribute == attribute then
            if arr[i].color > color then
                return  true;
            end
        end
    end
    return false;
end

--界面 Item 镶嵌红点处理   背包是否全部剩余有相同类型的灵纹 或者 剩余特殊灵纹 
function Lua_RuneData:updateIsRuneInlayRed()
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);
    local arr = bagData:getBagAllData();
    local attributeList = {}
    for k,v in pairs(self.runeHolesInfo) do
        if v.runeId ~= 0 and v.runeId ~= nil then
            attributeList[v.runeVo.attribute] = true;
        end
    end
    for i=1,arr:getSize() do
        if arr[i].rune_type ~= 1 then
            if attributeList[arr[i].attribute] ~= true then
                return true;
            end      
        end
    end
    return false;
end

function Lua_RuneData:updateIsKernelRed() -- 更新核心  (绝对防御 )红点
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);
    local arr = bagData:getBagAllData();
    self.ablow = false;
    self.defens = false;
    for i=1,arr:getSize() do
        if arr[i].rune_type ~= 1 then
            if tonumber(arr[i].attribute) == 2145000 then 
                self.ablow = true;
            end
            if tonumber(arr[i].attribute) == 2146000 then 
                self.defens = true;
            end    
        end
    end
    if (self.ablow == true and self.runeHolesInfo[8] ~= nil and self.runeHolesInfo[8].runeId == 0) 
        or (self.defens == true and self.runeHolesInfo[9] ~= nil and self.runeHolesInfo[9].runeId == 0) then
        return true;
    end
    return false;
end

-- 界面 合成按钮 红点处理
function Lua_RuneData:isShowCompoundRed()
    if self.isOpenCompound == true then --合成 活动开启判断
        if self._config  == nil then
            self._config = getConfig({"rune_compose"});
        end
        local level;
        local runeTower;
        
        for k,v in pairs(self._config) do
            if v.cost_item == nil then
                --暂无配置
            else
                if v.level == nil then
                    level = 0;
                else
                    level = v.level;
                end

                if v.runetower_limit == nil then
                    runeTower = 0;
                else
                    runeTower = v.runetower_limit;
                end

                if level <= DataCenter.roleData.level and runeTower <= self.runeTower then
                    local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(v.cost_item[1][1]);
                    local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(v.cost_item[2][1]);
                    local needNum1 = v.cost_item[1][2];
                    local needNum2 = v.cost_item[2][2];
                    if v.cost_rune_crystal[2] <= self.ownEcrystal and bagNum1 >= needNum1 and bagNum2 >= needNum2 then
                        return true;
                    end
                end
            end
        end
    end

    return false;
end


--红点检测
function Lua_RuneData:checkRedDotSate()
    local isShowRed = false;
    local openLvl = getConfig({"func_open", 10002, "cond_level"});
    local palyerLvl = DataCenter.roleData.level;
    if self.runeHolesInfo ~= nil then
        for k,v in pairs(self.runeHolesInfo) do
            if v.unLock then
                if v.runeId == 0 or v.runeId == nil then -- 没有灵纹镶嵌 
                    if self:updateIsRuneInlayRed() == true and v.id < 8 then -- 灵纹背包是否有灵纹
                        isShowRed = true;
                    end 
                else --已灵纹镶嵌
                    local isShowChangeRed = self:isShowChangeRed(v.id); -- 替换红点判断；
                    local ownEssence = tonumber(self.ownEssence);       -- 拥有精华
                    local upCostEssence = tonumber(v.upCostEssence);    -- 升级需要精华
                    if isShowChangeRed == true or (ownEssence >= upCostEssence and v.bFullLv  == false) then
                        isShowRed = true;
                    end
                end
            end
        end
        if palyerLvl >= openLvl then -- 判断 活动是否开启
            if isShowRed == true  or self:updateIsKernelRed() == true then -- 灵纹提升
                self:isShowIconRed(true);
            else
                self:isShowIconRed(false);
            end

            if self:isShowResolveRed() == true then -- 灵纹分解
                self:isShowResolveIconRed(true);
            else
                self:isShowResolveIconRed(false);
            end

            if self:isShowCompoundRed() == true then -- 灵纹合成

                self:isShowCompoundIconRed(true);
            else
                self:isShowCompoundIconRed(false);
            end
        else
            self:isShowIconRed(false);
            self:isShowResolveIconRed(false);
            self:isShowCompoundIconRed(false);
        end
    else
        self:isShowIconRed(false);
        self:isShowResolveIconRed(false);
        self:isShowCompoundIconRed(false);
    end
    -- self:isShowResolveRed()--分解红点
end

-- 主界面红点显隐
function Lua_RuneData:isShowIconRed(bool)
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(11175, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11175, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(11175, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11175, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

-- 分解
function Lua_RuneData:isShowResolveIconRed(bool)
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22033, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22033, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22033, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22033, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

-- 合成
function Lua_RuneData:isShowCompoundIconRed(bool)
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22034, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22034, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22034, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22034, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

-- 灵纹背包 显示已拥有UI 判断
-- function Lua_RuneData:isShowPossessSign(attribute)
--     if attribute == nil then
--         return false;
--     end

--     local attributeList = {}
--     for k,v in pairs(self.runeHolesInfo) do
--         if v.runeId ~= 0 and v.runeId ~= nil then
--             if v.runeVo.rune_type == 0 then
--                 attributeList[tonumber(v.runeVo.attribute)] = true;
--             else
--                 local config_rune = getConfig( { "rune", "prop" })[tonumber(v.runeVo.attribute)];
--                 local list_id1 = tonumber(config_rune["attr_list"][1]["attr_id"]);
--                 local list_id2 = tonumber(config_rune["attr_list"][2]["attr_id"]);

--                 attributeList[tonumber(v.runeVo.attribute)] = true;
--                 attributeList[tonumber(list_id1)] = true;
--                 attributeList[tonumber(list_id2)] = true;
--             end
--         end
--     end


--     local config_rune = getConfig( { "rune", "prop" })[tonumber(attribute)];
--     if config_rune["attr_list"] == nil then
--         if attributeList[tonumber(attribute)] == true then
--             return true;
--         end
--    else
--         local list_id1 = tonumber(config_rune["attr_list"][1]["attr_id"]);
--         local list_id2 = tonumber(config_rune["attr_list"][2]["attr_id"]);
--         if attributeList[tonumber(list_id1)] == true or attributeList[tonumber(list_id2)] or attributeList[tonumber(attribute)] == true  then
--             return true;
--         end
--    end

--    return false;
-- end


--获取属性集合
function Lua_RuneData.Get:attributeList()
    if self._attributeList == nil then
        self._attributeList = {}
        for k,v in pairs(self.runeHolesInfo) do
            if v.runeId ~= 0 and v.runeId ~= nil then
                if v.runeVo.rune_type == 0 then
                    self._attributeList[tonumber(v.runeVo.attribute)] = true;
                else
                    local config_rune = getConfig( { "rune", "prop" })[tonumber(v.runeVo.attribute)];
                    local list_id1 = tonumber(config_rune["attr_list"][1]["attr_id"]);
                    local list_id2 = tonumber(config_rune["attr_list"][2]["attr_id"]);

                    self._attributeList[tonumber(v.runeVo.attribute)] = true;
                    self._attributeList[tonumber(list_id1)] = true;
                    self._attributeList[tonumber(list_id2)] = true;
                end
            end
        end
    end

    return self._attributeList;
end

--灵纹背包 显示已拥有UI 判断
function Lua_RuneData:isShowPossessSign(attribute)
    if attribute == nil then
        return false;
    end

    if self.config_rune == nil then
        self.config_rune = getConfig( { "rune", "prop" });
    end

    local config_rune = self.config_rune[tonumber(attribute)];
    if config_rune["attr_list"] == nil then
        if self.attributeList[tonumber(attribute)] == true then
            return true;
        end
    else
        local list_id1 = tonumber(config_rune["attr_list"][1]["attr_id"]);
        local list_id2 = tonumber(config_rune["attr_list"][2]["attr_id"]);
        if self.attributeList[tonumber(list_id1)] == true or self.attributeList[tonumber(list_id2)] or self.attributeList[tonumber(attribute)] == true  then
            return true;
        end
   end

   return false;
end


function Lua_RuneData:sortFun(a, b)
    if a == nil or b == nil then
        return false;
    end
    local bool_1 = self:isShowPossessSign(a.attribute);
    local bool_2 = self:isShowPossessSign(b.attribute);
    if a.attribute ~= nil and b.attribute == nil then
        return true;
    elseif a.attribute ~= nil and b.attribute ~= nil then
        if bool_1 ~= true and bool_2 == true then
            return true;
        elseif bool_1 == true and bool_2 == true then
            if a.rune_type == 2 and b.rune_type ~= 2 then
                return true
            elseif a.rune_type ~= 2 and b.rune_type ~= 2 then
                if a.color > b.color then
                    return true;
                elseif a.color == b.color then
                    if a.rune_level > b.rune_level then
                        return true;
                    elseif a.rune_level == b.rune_level then
                        if tonumber(a.id) > tonumber(b.id) then
                            return true;
                        end
                    end
                end
            elseif a.rune_type == 2 and b.rune_type == 2 then 
                if a.color > b.color then
                    return true;
                elseif a.color == b.color then
                    if a.rune_level > b.rune_level then
                        return true;
                    elseif a.rune_level == b.rune_level then
                        if tonumber(a.id) > tonumber(b.id) then
                            return true;
                        end
                    end
                end
            end
        elseif bool_1 ~= true and bool_2 ~= true then
            if a.rune_type == 2 and b.rune_type ~= 2 then
                return true
            elseif a.rune_type ~= 2 and b.rune_type ~=2 then
                if a.color > b.color then
                    return true;
                elseif a.color == b.color then
                    if a.rune_level > b.rune_level then
                        return true;
                    elseif a.rune_level == b.rune_level then
                        if tonumber(a.id) > tonumber(b.id) then
                            return true;
                        end
                    end
                end
            elseif a.rune_type == 2 and b.rune_type == 2 then 
                if a.color > b.color then
                    return true;
                elseif a.color == b.color then
                    if a.rune_level > b.rune_level then
                        return true;
                    elseif a.rune_level == b.rune_level then
                        if tonumber(a.id) > tonumber(b.id) then
                            return true;
                        end
                    end
                end
            end
        end
    end







    return false;
end