
checkRequire("Lua_RuneData");
checkRequire("Lua_RuneUtil");
Lua_RuneProxy = class("Lua_RuneProxy");
function Lua_RuneProxy:ctor()
	self:superCall("ctor");
    DataCenter.runeData = Lua_RuneData.new();
    DataCenter.runeUtil = Lua_RuneUtil.new();
	
	LuaUtil.addLuaMsg(51403825, self, self.rOpenRunePanelInfo);--打开灵纹面板
    LuaUtil.addLuaMsg(51403826, self, self.rSelectUnlockedInfo);--选择已解锁镶嵌槽
    LuaUtil.addLuaMsg(51403827, self, self.rUpgradeRune);--升级灵纹
    LuaUtil.addLuaMsg(51403831, self, self.rOpenRuneExchange);--打开灵纹兑换界面
    LuaUtil.addLuaMsg(51403830, self, self.rResolveRune);--分解灵纹
    LuaUtil.addLuaMsg(51403841, self, self.sCompoundRuneState);--合成灵纹

    LuaUtil.addLuaMsg(80400931, self, self.rInformDeblocking);--通知解锁新灵纹类型
    LuaUtil.addLuaMsg(80400932, self, self.rIllusUpdataEssenceInfo);--灵纹精华通知
end

-----------------------------------------------------------------------------------
-- 上行消息号 
-- 打开灵纹面板
function Lua_RuneProxy:sOpenRunePanelInfo()
	sendMsg(11403825);
end

-- 选择已解锁镶嵌槽
function Lua_RuneProxy:sSelectUnlockedNum(groove_num)
    local cmd = ProtoPublic_pb.Proto11403826();
    cmd.groove_num = groove_num;
    sendMsg(11403826, cmd);
end

-- 升级灵纹
function Lua_RuneProxy:sUpgradeRune(holeId)
	local cmd = ProtoPublic_pb.Proto11403827();
    cmd.groove_num = holeId;
    sendMsg(11403827, cmd);
end

-- 替换灵纹
function Lua_RuneProxy:sReplaceRune(holeId, runeId, idx)
	local cmd = ProtoPublic_pb.Proto11403828();
    cmd.groove_num = holeId;
    cmd.item_id = runeId;
    cmd.pkg_type = Lua_PackData.LW_PACK;
    cmd.pkg_index = idx;
    sendMsg(11403828, cmd);
end

-- 镶嵌灵纹
function Lua_RuneProxy:sInlayRune(holeId, runeId, idx)
	local cmd = ProtoPublic_pb.Proto11403829();
    cmd.groove_num = holeId;
    cmd.item_id = runeId;
    cmd.pkg_type = Lua_PackData.LW_PACK;
    cmd.pkg_index = idx;
    sendMsg(11403829, cmd);
end

--灵纹分解
function Lua_RuneProxy:sResolveRune(list)
	local cmd = ProtoPublic_pb.Proto11403830();
    if list == nil then
       	cmd.get_essence = 1
        sendMsg(11403830, cmd);
        return
    end

    local len = list:getSize();
    for i = 1, len do
        local item = ProtoPublic_pb.ProtoDecomposeRune();
        item.pkg_index = list[i].index;
        item.pkg_type = Lua_PackData.LW_PACK;
        item.item_id = list[i].id;
        cmd.item_list:addToList(item);
    end
    cmd.get_essence = 0
    sendMsg(11403830, cmd);
end

-- 打开灵纹兑换界面
function Lua_RuneProxy:sOpenRuneExchangeInfo()
	sendMsg(11403831);
end

-- 兑换灵纹
function Lua_RuneProxy:sExchangeRune(runeId)
	local cmd = ProtoPublic_pb.Proto11403835();
    cmd.item_id = runeId;
    sendMsg(11403835, cmd);
end

-- 合成灵纹
function Lua_RuneProxy:sCompoundRune(item_id,list)
    local cmd = ProtoPublic_pb.Proto11403841();
    cmd.item_id = item_id;          --id
    if list ~= nil then
        local len = list:getSize();
        for i = 1, len do
            local cost_list = ProtoPublic_pb.ProtoPairObj();
            cost_list.obj_id = list[i].id;       -- 道具id
            cost_list.obj_value = list[i].index; -- 背包索引
            cmd.cost_list:addToList(cost_list);
        end
    end
    sendMsg(11403841, cmd);
end


-----------------------------------------------------------------------------------
-- 下行消息
--打开灵纹面板(返回)
function Lua_RuneProxy:rOpenRunePanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403825();
		msg:ParseFromString(mp.data);
        DataCenter.runeData.ownEssence = msg.essence;
        DataCenter.runeData.ownEcrystal = msg.rune_crystal;
        --print("拥有灵精   = =",msg.rune_crystal)
        DataCenter.runeData.runeTower = msg.rune_tower;
		DataCenter.runeData:fromServerHoldsInfo(msg);
        DataCenter.runeData:checkRedDotSate();--检测红点
		Lua_MsgUtil.callFunc("rOpenRunePanelInfo");
	end
end

--选择已解锁镶嵌槽(返回)
function Lua_RuneProxy:rSelectUnlockedInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403826();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("RSELECTUNLOCKEDINFO");
    end
end

--升级灵纹(返回)
function Lua_RuneProxy:rUpgradeRune(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403827();
		msg:ParseFromString(mp.data);
		DataCenter.runeData:fromServerUpgradeRune(msg);
        Lua_MsgUtil.callFunc("rUpgradeRune", msg.groove_num);
	end
end

--打开灵纹兑换界面(返回)
function Lua_RuneProxy:rOpenRuneExchange(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403831();
		msg:ParseFromString(mp.data);
        DataCenter.runeData.runeChip = msg.chip;
        DataCenter.runeData.unLockType = msg.unlock_type;
		Lua_MsgUtil.callFunc("update_runeType_unlock");
	end
end

--灵纹分解(返回)
function Lua_RuneProxy:rResolveRune(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403830();
		msg:ParseFromString(mp.data);
        DataCenter.runeData.ownEssence = msg.essence;
        DataCenter.runeData.afterEssence = msg.after_essence;
        Lua_MsgUtil.callFunc("rResolveRune");
	end
end

--通知解锁新灵纹类型(返回)
function Lua_RuneProxy:rInformDeblocking(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400931();
		msg:ParseFromString(mp.data);
        DataCenter.runeData.unLockType = msg.rune_type;
        DataCenter.runeData:checkRedDotSate();--检测红点
        Lua_MsgUtil.callFunc("update_runeType_unlock");
	end
end

function Lua_RuneProxy:rIllusUpdataEssenceInfo(mp)--刷新灵纹精华
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400932();
        msg:ParseFromString(mp.data);
        DataCenter.runeData.ownEssence = msg.essence;
        DataCenter.runeData:checkRedDotSate();
    end
end

function Lua_RuneProxy:sCompoundRuneState(mp) --获取合成后是否成功（返回）
        if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403841();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("IS_SUCCEED_STATE",msg.state);--是否成功
    end
end