--灵魂凝聚vo

Lua_RuneCompoundVo = class("Lua_RuneCompoundVo");
function Lua_RuneCompoundVo:ctor(id,value)
	self.id = id;
	if value == nil  then
		self.config = getConfig( { "rune_compose", id });
	else
		self.config = value;
	end 
end

function Lua_RuneCompoundVo.Get:crystal_id()--灵晶id
	return self.config.cost_rune_crystal[1];
end

function Lua_RuneCompoundVo.Get:crystal_vo()--灵晶vo
	local vo = Lua_ToolVo.createToolVo(self.crystal_id);
	return vo;
end

function Lua_RuneCompoundVo.Get:cost_soul_stone()--灵晶消耗
	return self.config.cost_rune_crystal[2];
end

function Lua_RuneCompoundVo.Get:item_vo()--合成道具VO
	if self.cost_item ~= nil then
		local vo = Lua_ToolVo.createToolVo(self.id)
		vo.rune_level = self.getRuneLevel;
		--print("中心灵纹等级   = =",self.getRuneLevel);
		return vo;
	end

	return nil;
end

function Lua_RuneCompoundVo.Get:rune_class_id()--灵纹组ID
	return self.config.rune_class_id;
end

function Lua_RuneCompoundVo.Get:rune_group_id()--灵纹组ID
	return self.config.rune_group_id;
end

function Lua_RuneCompoundVo.Get:prop_type()--灵纹属性类型
	return self.config.prop_type;
end

function Lua_RuneCompoundVo.Get:cost_item()--灵纹灵魂道具
	return self.config.cost_item;
end

function Lua_RuneCompoundVo.Get:cost_item_vo()--灵纹灵魂道具 vo
	local arr = self.cost_item;
	local _arr = Array();
	if arr ~= nil then
		local rune_level;
		for i=1,#arr do
			local maxArr = self:getMaxRuneLvlArray(arr[i][1]);
			if maxArr == nil or maxArr:getSize() == 0 then
				rune_level = 1;
			else
				rune_level = maxArr[1].rune_level;
			end 
			local tvo = Lua_ToolVo.createToolVo(arr[i][1]);
			tvo.bagNum = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[i][1]);
			tvo.needNum = arr[i][2];
			tvo.rune_level = rune_level;
			--print("右侧灵纹等级   = =",rune_level);
			_arr:add(tvo);
		end
		return _arr;
	end
	return nil;
end

function Lua_RuneCompoundVo.Get:probability()--合成概率
	return self.config.probability;
end

function Lua_RuneCompoundVo.Get:needLevel()--所需等级
	if self.config.level ~= nil then
		return self.config.level;
	else
		return 0;
	end
end

function Lua_RuneCompoundVo.Get:runetower_limit()--通关灵纹塔多少层开放合成
	if self.config.runetower_limit ~= nil then
		return self.config.runetower_limit;
	else
		return 0;
	end
end

function Lua_RuneCompoundVo.Get:isRuneTower()--判断
	if self.config.runetower_limit ~= nil then
		local num = self.config.runetower_limit;
		local runeTower = DataCenter.runeData.runeTower;
		--print("层级  = = ",runeTower)
		if runeTower < num then
			return true;
		else
			return false;
		end
	else
		return false;
	end
end

---------------------------------------------------------------------------------------------------------------------------------------
--合成数据处理 

function Lua_RuneCompoundVo:getMaxRuneIndex(id) -- 获取等级最高的 灵纹索引
    local runeArr = Array();
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);--灵纹
    local arr = bagData:getBagAllData();
    local len = arr:getSize();

    for i=1,len do
        if arr[i].id == id then          
            runeArr:add(arr[i])
        end
    end
    runeArr:sort("rune_level",true)

    return runeArr[1].index;
end

function Lua_RuneCompoundVo:getMaxRuneLvlArray(id) --获取灵魂最高等级
    local runeArr = Array();
    local bagData = DataCenter.packData:getBagType(Lua_PackData.LW_PACK);--聚魂
    local arr = bagData:getBagAllData();
    local len = arr:getSize();

    for i=1,len do
        if arr[i].id == id then          
            runeArr:add(arr[i])
        end
    end

    runeArr:sort("rune_level",true)

    return runeArr;
end

function Lua_RuneCompoundVo.Get:getRuneDoubleArray() -- 多属性合成 list
    local _arr = Array();
    local arr = self.cost_item;
    for i=1,#arr do   
        local list = {}
        list.id = self:getMaxRuneLvlArray(arr[i][1])[1].id;
        list.index = self:getMaxRuneIndex(arr[i][1]);
        _arr:add(list);
    end

    return _arr;
end

function Lua_RuneCompoundVo.Get:getRuneLevel() --通过 合成材料的灵纹 获取合成预览等级
    local rune_id1 = self.cost_item[1][1];
    local rune_id2 = self.cost_item[2][1];

    local arr1 = self:getMaxRuneLvlArray(rune_id1);
    local arr2 = self:getMaxRuneLvlArray(rune_id2);

    local runeLevel;
    if arr1:getSize() == 0 and arr2:getSize() == 0 then
        runeLevel = 1;
    elseif arr1:getSize() ~= 0 and arr2:getSize() ~= 0 then
        runeLevel = self:getCompoundRuneLevel(arr1,arr2);
    elseif  arr1:getSize() ~= 0 and arr2:getSize() == 0 then
        runeLevel = self:getCompoundRuneLevel(arr1);
    else
        runeLevel = self:getCompoundRuneLevel(arr2);
    end

    return runeLevel;
end

function Lua_RuneCompoundVo:getCompoundRuneLevel(arr1,arr2) -- 获取合成预览灵魂的等级
    local arr;
    local decompose;
    local vo = getConfig( { "item", self.id });
    local color = vo.color - DataCenter.runeUtil.runeStartColor+1;
    local str = 0;
    local lvl = 0;
    local double = getConfig( { "rune", "double_essence" });
    if arr1 ~= nil and arr2 ~= nil then
        local decompose1 = arr1[1].compoundAllResolve;
        local decompose2 = arr2[1].compoundAllResolve;
        decompose = decompose1 + decompose2;
        for i=1,#double[color] do
            local s = double[color][i];
            str = str + s;
            if str <= decompose then
                lvl = i;
            end
        end
    else
        if arr1 ~= nil and arr2 == nil then
            arr = arr1;
        elseif arr1 == nil and arr2 ~= nil then
            arr = arr2;
        end
        decompose = arr[1].compoundAllResolve;
        if decompose > 0 then
            for i=1,#double[color] do
                local s = double[color][i];
                str = str + s;
                if str <= decompose then
                    lvl = i;
                end
            end
        else
            lvl = 0;
        end
    end

    if lvl > 0 then
        return lvl;
    else
        return 1;
    end
end