-- 灵纹配置数据
checkRequire("Lua_ExchangeRuneVo");
checkRequire("Lua_RuneCompoundVo");
Lua_RuneUtil = class("Lua_RuneUtil");
function Lua_RuneUtil:ctor()
    self:superCall("ctor");

end

-- 灵纹兑换数据集
function Lua_RuneUtil.Get:exchangeRunesInfoArr()
	if self._exchangeRunesInfoArr == nil then
		self._exchangeRunesInfoArr = Array();
		local list = getConfig({"rune", "buy_rune"});
		if list ~= nil then
			for i=1, #list do
				local vo = Lua_ExchangeRuneVo.new(list[i]);
				self._exchangeRunesInfoArr:add(vo);
			end
		end
	end

	return self._exchangeRunesInfoArr;
end

-- 符文起始颜色
function Lua_RuneUtil.Get:runeStartColor()
    return getConfig({"rune", "item_base_color"})
end

-- 孔位对应解锁灵纹塔需要层数
function Lua_RuneUtil:getHoleUnlockNeedFloor(holeId)
    if self._unlockCondArr == nil then
    	self._unlockCondArr = Array();
    	local list = getConfig({"rune", "groove_unlock_cond"});
    	for k, v in pairs(list) do
    		self._unlockCondArr:add(tonumber(v));
    	end

    	local len = self._unlockCondArr:getSize();
        for i = 1, len do
            for j = i + 1, len do
                if self._unlockCondArr[i] > self._unlockCondArr[j] then
                    local temp = self._unlockCondArr[i];
                    self._unlockCondArr[i] = self._unlockCondArr[j];
                    self._unlockCondArr[j] = temp;
                end
            end
        end
    end
    
    return self._unlockCondArr[holeId];
end

function Lua_RuneUtil.Get:preview_rune()
	if self._preview_rune == nil then
	    local config = getConfig( { "rune", "preview_rune" });
	    self._preview_rune = Array();
	    local dic = {};
	    for k, v in pairs(config) do
	        local obj={};
	        obj.id = k;
	        obj.name = v.name;
	        obj.unlock_condition = v.unlock_condition;
	        obj.list = v.list;
	        if dic[v.unlock_condition] == nil then
	        	dic[v.unlock_condition] = Array();
	        end
	        dic[v.unlock_condition]:add(obj)
	    end
	    
	    for k, v in pairs(dic) do
	    	v:sort("id", false);
	    	self._preview_rune:add(v);
	    end

	    local len = self._preview_rune:getSize();
	    for i = 1, len do
	    	for j = i + 1, len do
	    		if self._preview_rune[i][1].id > self._preview_rune[j][1].id then
	    			local temp = self._preview_rune[i];
	    			self._preview_rune[i] = self._preview_rune[j];
	    			self._preview_rune[j] = temp;
	    		end
	    	end
	    end
    end

    return self._preview_rune
end

function Lua_RuneUtil:unlock_cond_show(id)--获得解锁灵纹塔层数
    return getConfig( { "rune", "unlock_cond_show" })[id];
end

function Lua_RuneUtil:type_unlock(id)--默认解锁
    return getConfig( { "rune", "type_unlock" })[id];
end

function Lua_RuneUtil:groove_unlock_cond(id) --灵纹塔层数解锁孔
    return getConfig( { "rune", "groove_unlock_cond" })[id];
end

function Lua_RuneUtil:runeResolveNum(arr)
	local resolveNum = 0;
	for i=1,arr:getSize() do
		resolveNum = resolveNum + arr[i].decompose;
	end
    return resolveNum
end

function Lua_RuneUtil:runeCrystalNum(arr)
    local resolveNum = 0;
    for i=1,arr:getSize() do
        resolveNum = resolveNum + arr[i].decomposeCrystal;
    end
    return resolveNum
end
----------------------------------------------------------------------------------------------------------------------------------------
-- 灵纹合成 数据；

function Lua_RuneUtil:getCompoundCalssId(id)
    return getConfig({"rune_compose",id}).rune_class_id;
end

function Lua_RuneUtil:getCompoundGroupIndex(costId,classId)--通过灵魂ID 获取组ID的索引
    local group_id = getConfig({"rune_compose",costId}).rune_group_id;
    local list = self.getCalssConfigInfo[classId].rune_group_list;
    for i,v in ipairs(list) do
        if v == group_id then
            return i;
        end
    end
end

function Lua_RuneUtil:getArrByClassId(class_id)--通过类ID 获取ID所有数据
    return self.getCompoundConfigInfo[tostring(class_id)]
end

function Lua_RuneUtil:getArrByClassAndGroupInfo(class_id,group_id)--通过组ID 获取vo
    local arr = self:getArrByClassId(class_id);
    if arr:getSize() ~= 0 then
    	 for i=1,arr:getSize() do
            if arr[i].rune_group_id == group_id then
                return arr[i];
            end
        end
    end
    return nil;
end

function Lua_RuneUtil.Get:getCompoundConfigInfo()-- 合成 数据
    if self.compoundDic == nil then
        self.compoundDic = {};
        local config = getConfig({"rune_compose"});
        if config ~= nil then
            for k, v in pairs(config) do
                local vo = Lua_RuneCompoundVo.new(k, v);
                if self.compoundDic[tostring(vo.rune_class_id)] == nil then
                    self.compoundDic[tostring(vo.rune_class_id)] = Array();
                end
                self.compoundDic[tostring(vo.rune_class_id)]:add(vo);
            end
        end
    end
    return self.compoundDic;
end

function Lua_RuneUtil.Get:getCalssConfigInfo()-- 合成类数据
    if self.calss_info == nil then
        self.calss_info = {};
        local rune_class = getConfig({"rune_class"});
        for i,v in pairs(rune_class) do
            self.calss_info[i]= v;
        end
    end

    return self.calss_info;
end

function Lua_RuneUtil.Get:getCompoundCalssInfo()--用于 灵纹合成界面页签显示
    local arr = self.getCalssConfigInfo;
    local runeCalssData = Array();
    runeCalssData:clear();
    for k,v in pairs(arr) do
        local rune_group_list = v.rune_group_list;
        local sub1 = Array();
        if rune_group_list ~= nil then
            for i, j in pairs(rune_group_list) do
                local rune_id = self:getArrByClassAndGroupInfo(k,j).id;
                local rune_name = getConfig({"item",rune_id}).name;
                sub1:add({name=rune_name, isShowLock =self:getArrByClassAndGroupInfo(k,j).isRuneTower, data = self:getArrByClassAndGroupInfo(k,j)}); 
            end 
        end 
        runeCalssData:add({name=v.rune_class_name, sub=sub1});           
    end

    return runeCalssData;
end

-- 页签红点处理
function Lua_RuneUtil:updateShowRedList(class_id)-- 合成 class 列表红点更新
    local isRedList = {};
    local have_stone = DataCenter.runeData.ownEcrystal;
    local vo = self:getArrByClassId(class_id);
    for i=1,vo:getSize() do
        if vo[i].cost_item == nil then
            if vo[i].needLevel <= DataCenter.roleData.level and have_stone >= vo[i].cost_soul_stone then
                isRedList[vo[i].rune_class_id] = true;
            end
        else
            local arr = vo[i].cost_item;
            local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[1][1]);
            local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[2][1]);
            local needNum1 = arr[1][2];
            local needNum2 = arr[2][2];
            if vo[i].needLevel <= DataCenter.roleData.level
                and have_stone >= vo[i].cost_soul_stone
                and bagNum1 >= needNum1 and bagNum2 >= needNum2 
                and vo[i].isRuneTower == false then
                isRedList[vo[i].rune_class_id] = true;
            end
        end
    end
    
    return isRedList;
end

function Lua_RuneUtil:getShowCompoundRedList(class_id)-- 合成 group 列表红点更新
    local isRedList = {};
    local have_stone = DataCenter.runeData.ownEcrystal;
    local vo = self:getArrByClassId(class_id);

    for i=1,vo:getSize() do
        if vo[i].cost_item == nil then
            if vo[i].needLevel <= DataCenter.roleData.level and have_stone >= vo[i].cost_soul_stone then
                isRedList[vo[i].rune_group_id] = true;
            end
        else
            local arr = vo[i].cost_item;
            local bagNum1 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[1][1]);
            local bagNum2 = DataCenter.packData:getBagType(Lua_PackData.LW_PACK):getItemNum(arr[2][1]);
            local needNum1 = arr[1][2];
            local needNum2 = arr[2][2];
            if vo[i].needLevel <= DataCenter.roleData.level 
                and have_stone >= vo[i].cost_soul_stone
                and bagNum1 >= needNum1 and bagNum2 >= needNum2 
                and vo[i].isRuneTower == false then
                isRedList[vo[i].rune_group_id] = true;
            end
        end
    end

    return isRedList;
end