﻿checkRequire("Lua_SacredAnimalVo")
Lua_SacredAnimalData = class("Lua_SacredAnimalData");
function Lua_SacredAnimalData:ctor()
end

function Lua_SacredAnimalData:dispose()
	if self.dataArr ~= nil then
		self.dataArr:clear()
		self.dataArr = nil
	end
	self:superCall("dispose");
end

function Lua_SacredAnimalData:fromServer51403201(msg)
	if msg == nil then
		return;
	end

	self.helped_count = msg.helped_count;
	self.helped_total = msg.helped_total;
	self.masters = msg.masters;
	if self.masters ~= nil and #self.masters ~= 0 then
		for k, v in ipairs(self.masters) do
			if v.id ~= nil and v.id ~= 0 then
				self.animalArr[v.id]:setValue(v.id, v.helped, v.equipment)
			end
		end
	end
	Lua_MsgUtil.callFunc("UPDATE_ANIMAL_PANEL", self.animalArr[self.selectedEquId])
end

function Lua_SacredAnimalData.Get:selectedEquId()
	return self._selectedEquId
end

function Lua_SacredAnimalData.Set:selectedEquId(value)
	self._selectedEquId = value;
end

function Lua_SacredAnimalData.Get:btnState()
	if self.selectedEquId == nil then
		return false;
	end
	return self.animalArr[self.selectedEquId].equipNum == 5;
end

function Lua_SacredAnimalData:getAnimalEquipByPart(part)
	if self.selectedEquId == nil then
		return nil
	end
	return self.animalArr[self.selectedEquId].equipParts[part]
end

function Lua_SacredAnimalData:getEquipNumById(id)
	if id == nil then
		return 0
	end
	return self.animalArr[id].equipNum
end

function Lua_SacredAnimalData:getEquipRedDotStateById(id)
	return self.animalArr[id].RedDotState
end

function Lua_SacredAnimalData:getWindowNameByUrl(url)
	return self.mt_openWin[url];
end

function Lua_SacredAnimalData.Get:costItem()
	if self.helped_total ~= nil then
		self.tempIdx = self.helped_total - self.help_init + 1
	end
	return self.help_open[self.tempIdx]
end

function Lua_SacredAnimalData.Get:animalEquipItemArr()
	local arr = Array();
	local len = self.animalArr:getSize();
	for i = 1, len do
		if self.animalArr[i].helped == true then
			local len = #self.animalArr[i].equipParts
			for c = 1, len do
				arr:add(self.animalArr[i].equipParts[c])
			end
		end
	end

	local len = arr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not self:sortFun(arr[i], arr[j]) then
				local temp = arr[i]
				arr[i] = arr[j]
				arr[j] = temp
			end
		end
	end
	return arr;
end

function Lua_SacredAnimalData:sortFun(a, b)
	if a.color > b.color then
		return false;
	elseif a.color == b.color then
		if a.zongheForce > b.zongheForce then
			return false
		elseif a.zongheForce == b.zongheForce then
			return a.part > b.part
		end
		return true;
	end
	return true;
end





function Lua_SacredAnimalData.Get:configData()
	if self._configData == nil then
		self._configData = getConfig({"od_master"})
	end
	return self._configData;
end

function Lua_SacredAnimalData.Get:animalArr()
	if self.dataArr == nil then
		self.dataArr = Array();

		for k, v in ipairs(self.configData) do
			local animalVo = Lua_SacredAnimalVo.new(k);
			animalVo:fromServer(v)
			self.dataArr:add(animalVo);
		end
	end
	return self.dataArr;
end

function Lua_SacredAnimalData:getSkillInfo(id)
	return getConfig({"player_skill", id})
end

function Lua_SacredAnimalData.Get:configColorData()
	if self._colorConfig == nil then
		self._colorConfig = {};

		local colorConfig = getConfig({"color"});
		for k, v in pairs(colorConfig) do
			self._colorConfig[k] = {id = k, price_div = v.price_div, progress = v.progress, high_Lvl = #v.progress,
				attack = v.attack, blood = v.blood, defence = v.defence};
		end
	end
	return self._colorConfig;
end





function Lua_SacredAnimalData.Get:configBaseData()
	if self._baseConfig == nil then
		self._baseConfig = getConfig({"const"}); -- 神兽常量
	end
	return self._baseConfig;
end

function Lua_SacredAnimalData.Get:help_init()
	if self._help_init == nil then
		self._help_init = self.configBaseData.help_init.value;
	end
	return self._help_init;
end

function Lua_SacredAnimalData.Get:help_total()
	if self._help_total == nil then
		self._help_total = self.configBaseData.help_total.value
	end
	return self._help_total;
end

function Lua_SacredAnimalData.Get:help_open()
	if self._help_open == nil then
		self._help_open = self.configBaseData.help_open.arr_val
	end
	return self._help_open;
end

function Lua_SacredAnimalData.Get:itensify()
	if self._itensify == nil then
		self._itensify = self.configBaseData.itensify.arr_val
	end
	return self._itensify;
end

function Lua_SacredAnimalData.Get:part_name()
	if self._part_name == nil then
		self._part_name = self.configBaseData.part_name.arr_val
	end
	return self._part_name;
end

function Lua_SacredAnimalData.Get:part_color()
	if self._part_color == nil then
		self._part_color = self.configBaseData.part_color.arr_val
	end
	return self._part_color;
end

function Lua_SacredAnimalData.Get:item_price_div()
	if self._item_price_div == nil then
		self._item_price_div = self.configBaseData.price_div.value
	end
	return self._item_price_div;
end

function Lua_SacredAnimalData.Get:equip_add_attr()
	if self._equip_add_attr == nil then
		self._equip_add_attr = self.configBaseData.equip_add_attr.arr_val
	end
	return self._equip_add_attr;
end

function Lua_SacredAnimalData.Get:mt_prodfuce()
	if self._mt_prodfuce == nil then
		self._mt_prodfuce = self.configBaseData.mt_prodfuce.arr_val
	end
	return self._mt_prodfuce[1];
end

function Lua_SacredAnimalData.Get:mt_openWin()
	if self._mt_openWin == nil then
		self._mt_openWin = self.configBaseData.mt_openWin.arr_val
	end
	return self._mt_openWin;
end

function Lua_SacredAnimalData.Get:animalEquipColorArr()
	if self._animalEquipColorArr == nil then
		self._animalEquipColorArr = self.configBaseData.equip_color.arr_val
	end
	return self._animalEquipColorArr;
end

function Lua_SacredAnimalData.Get:animalEquipStarArr()
	if self._animalEquipStarArr == nil then
		self._animalEquipStarArr = self.configBaseData.equip_star.arr_val
	end
	return self._animalEquipStarArr;
end

function Lua_SacredAnimalData.Get:animalMaterialColor()
	if self._animalMaterialColor == nil then
		self._animalMaterialColor = self.configBaseData.mt_color.arr_val
	end
	return self._animalMaterialColor;
end