﻿checkRequire("Lua_ToolVo")
checkRequire("Lua_EquipVo")
Lua_SacredAnimalVo = class("Lua_SacredAnimalVo");
function Lua_SacredAnimalVo:ctor(id, helped)
    self.id = id;
    self.headStr = "/images/sacredAnimal/head/animal_" .. self.id .. ".png";
    self.headImgStr = "/images/sacredAnimal/head/animal_Img_" .. self.id .. ".png";
    self.bgName = { "ui_common_prop_2", "ui_common_prop_3", "ui_common_prop_4", "ui_common_prop_5", "ui_common_prop_6", "ui_common_prop_7" }

    if helped ~= nil then
        self.helped = helped;
    else
        self.helped = false;
    end
    self.parts = { };
end

function Lua_SacredAnimalVo:fromServer(v)
    self.name = v.name;
    self.skill_list = v.skill_list;
    self.color = v.color;
    self.attr = v.attr
    self.color_index = v.color_index;
    self.headBgName = self.bgName[self.color_index]
    self:getRedDotState()
end

function Lua_SacredAnimalVo.Set:master_id(value)
    self._master_id = value
end
function Lua_SacredAnimalVo.Get:master_id()
    return self._master_id;
end

function Lua_SacredAnimalVo.Get:RedDotState()
    local redDotArr = self.RedDotArr
    return redDotArr:getSize() > 0
end 

function Lua_SacredAnimalVo.Get:RedDotArr()
    local redDotArr = self:getRedDotState()
    return redDotArr
end 

function Lua_SacredAnimalVo:getRedDotState()
    local _arr = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG):getBagAllData();
    local _len = _arr:getSize()
    local arr = Array()
    local redDotArr = Array()
    for i = 1, _len do
        if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU then
            arr:add(_arr[i])
        end
    end
    local len = arr:getSize()
    for i = 1, #self.color do
        for a = 1, len do
            if self.color[i] <= arr[a].color and i == arr[a].part then
                local tempPart = i;
                if self.equipParts[tempPart] == nil then
                    if redDotArr:indexOf(i) == -1 then
                        redDotArr:add(i)
                    end
                end
            end
        end
    end
    return redDotArr;
end

function Lua_SacredAnimalVo:setValue(id, helped, equipment)
    self.master_id = id
    self.helped = helped;
    self.equipment = equipment
    self:getRedDotState()
end 

function Lua_SacredAnimalVo.Set:equipment(value)
    self._equipment = value;
    self.parts = { };
    if self._equipment ~= nil then
        for k, v in ipairs(self._equipment) do
            if v.id ~= 0 then
                local equipVo = Lua_ToolVo.createToolVo(v.id, v.amount, v.bind);
                if equipVo ~= nil and equipVo.part ~= nil then
                    equipVo:fromServer(v);
                    equipVo.master_id = self.master_id;
                    equipVo.confingKey = tonumber(equipVo.color .. "00" .. equipVo.part);
                    equipVo.bolSelected = tonumber(equipVo.master_id .. equipVo.confingKey)

                    equipVo.star = v.equipment.star
                    equipVo.gm_level = v.equipment.gm_level
                    --      equipVo.gm_maxLvl = self:getMaxLvl(equipVo.confingKey)
                    equipVo.rank_value = 0;
                    if equipVo.gm_level >= equipVo.gm_maxLvl then
                        equipVo.rank_value = 1;
                    end
                    equipVo.gm_progress = v.equipment.gm_progress;
                    equipVo.gm_total_progress = v.equipment.gm_total_progress;
                    equipVo.high_progress = self:getHighProgress(equipVo.confingKey, equipVo.gm_level + 1, equipVo.gm_maxLvl);
                    equipVo.qiangHua_atrr_1 = self:getQiangHuaAttr(equipVo.confingKey, equipVo.gm_level, equipVo.gm_maxLvl)
                    equipVo.qiangHua_atrr_2 = self:getQiangHuaAttr(equipVo.confingKey, equipVo.gm_level + 1, equipVo.gm_maxLvl)
                    self.parts[equipVo.part] = equipVo;
                end
            end
        end
    end
end

function Lua_SacredAnimalVo.Get:equipment()
    return self._equipment;
end

function Lua_SacredAnimalVo:getMaxLvl(key)
    local colorData = DataCenter.sacredAnimalData.configColorData;
    local high_lvl = colorData[key].high_Lvl
    return high_lvl;
end

function Lua_SacredAnimalVo.Get:colorName()
    return "[" .. Lua_ColorDefine.getItemColorStr(self.color_index, false) .. "]" .. self.name .. "[-]";
end

function Lua_SacredAnimalVo.Get:score()
    local _score = 0;
    local txtArr = self.txtArr
    local len = txtArr:getSize()
    local dataList = { };
    local _score1 = 0
    local _score2 = 0

    for i = 1, len do
        dataList[txtArr[i].attr] = txtArr[i].score_Value
    end
    _score1 = Lua_FightUtil.caculateConfigForce(dataList)

    for i = 1, 5 do
        if self.equipParts[i] ~= nil then
            _score2 = _score2 + self.equipParts[i].jipinForce;
        end
    end
    --   if self.helped == false then
    --       _score = _score1
    --   else
    _score = _score1 + _score2
    --   end
    return _score;
end

function Lua_SacredAnimalVo:getHighProgress(key, gm_level, maxLvl)
    local colorData = DataCenter.sacredAnimalData.configColorData;
    local progress = 0;
    local high_lvl = maxLvl;
    if gm_level > high_lvl then
        progress = colorData[key].progress[gm_level - 1];
    else
        progress = colorData[key].progress[gm_level]
    end
    return progress;
end
function Lua_SacredAnimalVo:getQiangHuaAttr(key, gm_level, maxLvl)
    local colorData = DataCenter.sacredAnimalData.configColorData;
    local txtArr = Array();
    local high_lvl = maxLvl;
    for i, v in ipairs(Lua_ThingDefine.params) do
        if colorData[key][v] ~= nil then
            if gm_level == 0 then
                txtArr:add("[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]+" .. 0)
            else
                if gm_level <= maxLvl then
                    txtArr:add("[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]+" .. colorData[key][v][gm_level])
                else
                    txtArr:add(LanUtil.getValue(124619))
                end
            end
        end
    end
    return txtArr;
end

function Lua_SacredAnimalVo.Get:partColorName()
    self._partColorName = Array();
    if self.partName == nil then
        self.partName = DataCenter.sacredAnimalData.part_name;
        self.partColor = DataCenter.sacredAnimalData.part_color;
    end
    for i = 1, #self.color do
        self._partColorName:add(self.partColor[self.color[i]] .. self.partName[i] .. "[-]")
    end
    return self._partColorName;
end

function Lua_SacredAnimalVo.Get:txtArr()
    local txtArr = Array()
    local listAttrName = DataCenter.sacredAnimalData.equip_add_attr;
    local tempLen = #listAttrName;
    local shenshou_Arr = self:calculate_ShenShouAttr()
    local shenshou_Len = shenshou_Arr:getSize();
    local equipBase_Arr = self:calculate_BaseAttr()
    local equipBase_Len = equipBase_Arr:getSize();
    local equipQiangHuaArr = self:calculate_QiangHuaAttr()
    local equipQqiangHua_Len = equipBase_Arr:getSize();

    for i = 1, tempLen do
        local tempAttr = listAttrName[i]
        local list = { }
        local hasAttr = false
        list.attr = tempAttr;
        list.value = 0
        local value1 = 0
        for a = 1, shenshou_Len do
            if shenshou_Arr[a].attr == tempAttr then
                value1 = value1 + shenshou_Arr[a].value;
                list.value = shenshou_Arr[a].value
                hasAttr = true
            end
        end

        for b = 1, equipBase_Len do
            if equipBase_Arr[b].attr == tempAttr then
                value1 = value1 + equipBase_Arr[b].value;
            end
        end

        for c = 1, equipQqiangHua_Len do
            if equipQiangHuaArr[c].attr == tempAttr then
                value1 = value1 + equipQiangHuaArr[c].value;
            end
        end
        if hasAttr == false then
            if value1 ~= 0 then
                list.total_value = value1
                list.score_Value = value1
                list.add_value = value1
                list.str = "[00E125]" .. Lua_ThingDefine.getParamName(list.attr) .. "：   +" .. list.value1
                txtArr:add(list)
            end
        else
            list.total_value = value1
            list.score_Value = value1
            list.add_value = list.total_value - list.value
            if self.helped == false then
                if list.total_value ~= list.value then
                    list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(list.attr) .. "：[-]" .. list.value .. "   [00E125]+" .. list.total_value - list.value
                else
                    list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(list.attr) .. "：[-]" .. list.value
                end
            end
            txtArr:add(list)
        end
    end

    if self.helped == false then
        return txtArr
    end

    local txtArrLen = txtArr:getSize();
    local personal_skillData = self:dataAnalysis(self.PersonalSkillData)
    local personal_skillDataLen = personal_skillData:getSize()
    local others_skillData = self:dataAnalysis(self:getOthersSkillData())
    local others_skillDataLen = others_skillData:getSize()
    personal_skillData = self:skillCompose(personal_skillData, others_skillData)
    personal_skillDataLen = personal_skillData:getSize()

    local shouTxtArr = Array();
    for i = 1, txtArrLen do
        local isHas = -1
        for a = 1, shenshou_Len do
            if shenshou_Arr[a].attr == txtArr[i].attr then
                isHas = a
                break;
            end
        end
        if isHas ~= -1 then
            local list = { }
            list.attr = shenshou_Arr[isHas].attr;
            list.total_value = txtArr[i].total_value
            list.add_value = txtArr[i].add_value
            list.shenshou_value = shenshou_Arr[isHas].value
            list.add_skill_value = 0
            list.Show_Value = txtArr[i].add_value
            -- 计算技能属性
            for b = 1, personal_skillDataLen do
                if personal_skillData[b].attr == list.attr then
                    list.add_skill_value = math.floor(list.total_value * personal_skillData[b].value)
                    list.Show_Value = list.add_skill_value + list.add_value
                end
            end
            list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(list.attr) .. "：[-]" .. list.shenshou_value .. "   [00E125]+" .. list.Show_Value;
            list.score_Value = list.shenshou_value + list.Show_Value
            shouTxtArr:add(list)
        else
            -- 装备加的新属性
            local list = { }
            list.attr = txtArr[isHas].attr;
            list.total_value = txtArr[i].total_value
            list.add_value = txtArr[i].add_value
            list.add_skill_value = 0
            list.Show_Value = txtArr[i].add_value
            for b = 1, personal_skillDataLen do
                if personal_skillData[b].attr == list.attr then
                    list.add_skill_value = math.floor(list.total_value * personal_skillData[b].value)
                    list.Show_Value = list.add_skill_value + list.add_value
                end
            end
            list.str = "[00E125]" .. Lua_ThingDefine.getParamName(list.attr) .. "：   +" .. list.Show_Value
            list.score_Value = list.Show_Value
            shouTxtArr:add(list)
        end
    end
    return shouTxtArr;
end

function Lua_SacredAnimalVo:dataAnalysis(arr)
    local _arr = arr
    local _arrLen = _arr:getSize()
    local tempSkillList = { };
    for i = 1, _arrLen do
        if tempSkillList[_arr[i].attr] == nil then
            tempSkillList[_arr[i].attr] = _arr[i]
        else
            if type(tempSkillList[_arr[i].attr]) == "table" then
                tempSkillList[_arr[i].attr] = tempSkillList[_arr[i].attr].value + _arr[i].value
            else
                tempSkillList[_arr[i].attr] = tempSkillList[_arr[i].attr] + _arr[i].value
            end
        end
    end
    _arr:clear()
    for k, v in pairs(tempSkillList) do
        local list = { }
        list.attr = k;
        if type(tempSkillList[k]) == "table" then
            list.value = tempSkillList[k].value;
        else
            list.value = tempSkillList[k];

        end
        _arr:add(list)
    end
    return arr
end

function Lua_SacredAnimalVo:skillCompose(personalSkillArr, othersSkillArr)
    local _personalSkillArr = personalSkillArr
    local _personalSkillArrLen = _personalSkillArr:getSize()
    local _othersSkillArr = othersSkillArr
    local _othersSkillArrLen = othersSkillArr:getSize()
    for i = 1, _othersSkillArrLen do
        local tempLen = _personalSkillArr:getSize()
        local isHas = -1
        local hasAttr = -1
        for a = 1, tempLen do
            if _personalSkillArr[a].attr == _othersSkillArr[i].attr then
                isHas = a
                hasAttr = _othersSkillArr[i].attr
                break;
            end
        end
        if isHas ~= -1 and hasAttr ~= -1 then
            _personalSkillArr[isHas].value = _personalSkillArr[isHas].value + _othersSkillArr[i].value
        else
            _personalSkillArr:add(_othersSkillArr[i])
        end
    end
    return _personalSkillArr
end


function Lua_SacredAnimalVo.Get:PersonalSkillData()
    local _skillArr = Array()
    local skillArr = self.skillArr
    local skillLen = skillArr:getSize()
    for i = 1, skillLen do
        local detail = skillArr[i].detail
        local len1 = #detail
        for a = 1, len1 do
            local effectArr = detail[a]["effect"]
            local effectLen = #effectArr
            for b = 1, effectLen do
                local list = { }
                list.attr = Lua_ThingDefine.getAttrName(effectArr[b]["name"]);
                if effectArr[b]["percent"] ~= nil then
                    list.value = effectArr[b]["percent"] / 100;
                end
                list.property = skillArr[i].property;
                if list.attr ~= nil then
                    _skillArr:add(list);
                end
            end
        end
    end
    return _skillArr;
end

function Lua_SacredAnimalVo:getOthersSkillData()
    local _skillArr = Array()
    local animalArr = DataCenter.sacredAnimalData.animalArr
    local animalArrLen = animalArr:getSize();

    for i = 1, animalArrLen do
        if animalArr[i].id ~= self.id and animalArr[i].helped == true then
            local skillData = animalArr[i].PersonalSkillData
            local len = skillData:getSize()
            for a = 1, len do
                if skillData[a].property == 2 then
                    local list = { }
                    list.attr = skillData[a].attr
                    list.value = skillData[a].value
                    list.property = skillData[a].property
                    _skillArr:add(list)
                end
            end
        end
    end
    return _skillArr;
end

function Lua_SacredAnimalVo:calculate_ShenShouAttr()
    local configData = DataCenter.sacredAnimalData.configData;
    local txtArr = Array();
    for i, v in ipairs(self.attr) do
        if configData[self.id][v] ~= nil then
            local list = { }
            list.attr = v;
            list.value = configData[self.id][v]
            list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]" .. list.value
            txtArr:add(list);
        end
    end
    return txtArr;
end

function Lua_SacredAnimalVo:calculate_BaseAttr()
    local tempParts = self.equipParts;
    local equip_txtArr = Array();
    for i = 1, 5 do
        if tempParts[i] ~= nil then
            for k, v in ipairs(Lua_ThingDefine.params) do
                if tempParts[i][v] ~= nil and tempParts[i][v] ~= 0 then
                    local list = { }
                    list.attr = v;
                    list.value = tempParts[i][v]
                    list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]" .. list.value
                    equip_txtArr:add(list)
                end
            end
        end
    end
    return equip_txtArr;
end

function Lua_SacredAnimalVo:calculate_QiangHuaAttr()
    local tempParts = self.equipParts;
    local equip_txtArr = Array();
    local colorData = DataCenter.sacredAnimalData.configColorData;
    for i = 1, 5 do
        if tempParts[i] ~= nil then
            local key = tempParts[i].confingKey;
            local gm_level = tempParts[i].gm_level
            for k, v in ipairs(Lua_ThingDefine.params) do
                local list = { };
                if colorData[key][v] ~= nil then
                    list.attr = v
                    if gm_level == 0 then
                        list.value = 0
                    else
                        list.value = colorData[key][v][gm_level]
                    end
                    list.str = "[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]" .. list.value
                    equip_txtArr:add(list);
                end
            end
        end
    end
    return equip_txtArr;
end

function Lua_SacredAnimalVo.Get:skillArr()
    self._skillArr = Array();
    if self.skill_list ~= nil then
        for i = 1, #self.skill_list do
            local skillConfig = DataCenter.sacredAnimalData:getSkillInfo(self.skill_list[i]);
            local list = { };
            list.name = skillConfig.name
            list.atlas = skillConfig.atlas;
            list.skill_icon = skillConfig.skill_icon;
            list.reMark = skillConfig.reMark;
            list.desc_name = skillConfig.desc_name;
            list.skill_lvl = skillConfig.skill_lvl;
            list.detail = skillConfig.detail;
            list.activation_state = self.helped;
            if skillConfig.god_master_propery == nil then
                list.property = 0
            else
                list.property = skillConfig.god_master_propery;
            end
            self._skillArr:add(list);
        end
    end
    return self._skillArr
end

function Lua_SacredAnimalVo.Get:equipParts()
    return self.parts;
end

function Lua_SacredAnimalVo.Get:equipNum()
    local count = 0
    local equipParts = self.equipParts
    local len = #equipParts
    for i = 1, len do
        if equipParts[i] ~= nil and equipParts[i].id ~= 0 then
            count = count + 1
        end
    end
    return count
end

function Lua_SacredAnimalVo.Get:partIdArr()
    local arrId = Array();
    for i = 1, 5 do
        if self.equipParts[i] ~= nil then
            arrId:add(self.equipParts[i].part)
        end
    end
    return arrId;
end