﻿checkRequire("Lua_SacredAnimalData");
Lua_SacredAnimalProxy = class("Lua_SacredAnimalProxy");
function Lua_SacredAnimalProxy:ctor()
	DataCenter.sacredAnimalData = Lua_SacredAnimalData.new();

	LuaUtil.addLuaMsg(51403201, self, self.rSacredAnimalInfo);
	LuaUtil.addLuaMsg(51403202, self, self.r51403202);
	LuaUtil.addLuaMsg(51403205, self, self.r51403205);
	LuaUtil.addLuaMsg(51403206, self, self.r51403206);

	Lua_MsgUtil.addEventListener("PACK_ANIMALINFO_UPDATE", self, self.onSacredPackDataUpdate);
end

function Lua_SacredAnimalProxy:rSacredAnimalInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403201();
		msg:ParseFromString(mp.data);
		DataCenter.sacredAnimalData:fromServer51403201(msg);
	end
end

function Lua_SacredAnimalProxy:r51403202(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("PLAY_EFFECT_SACRED");
	end
end

function Lua_SacredAnimalProxy:r51403205(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403205();
		msg:ParseFromString(mp.data);
		if msg.cur_level > msg.pre_level then
			Lua_MsgUtil.callFunc("PLAY_EFFECT_SACRED");
		end
	end
end

function Lua_SacredAnimalProxy:r51403206(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(124617));
	end
end

function Lua_SacredAnimalProxy:onSacredPackDataUpdate()
	local animalArr = DataCenter.sacredAnimalData.animalArr;
	local hasRedDot = false;
	for i = 1, animalArr:getSize() do
		hasRedDot = DataCenter.sacredAnimalData:getEquipRedDotStateById(i)
		if hasRedDot == true then
			break;
		end
	end

	if DataCenter.funcOpenData:isOpened(10110) == true then
		DataCenter.redDotData:updateRedDotVoState(12001, hasRedDot);
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", { iconId = 10066, state = hasRedDot });
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", hasRedDot);
	end
	Lua_MsgUtil.callFunc("UPDATE_SACRED_REDDOT");
end





function Lua_SacredAnimalProxy:sInitMsg()
	sendMsg(11403201);
end

function Lua_SacredAnimalProxy:sZhuZhanMsg(master_id, help)
	local cmd = ProtoPublic_pb.Proto11403202();
	cmd.master_id = master_id;
	cmd.help = help;
	sendMsg(11403202, cmd);
end

function Lua_SacredAnimalProxy:sPutOnEquipMsg(master_id, pack_index)
	local cmd = ProtoPublic_pb.Proto11403203();
	cmd.master_id = master_id;
	cmd.pack_index = pack_index;
	sendMsg(11403203, cmd);
end

function Lua_SacredAnimalProxy:sPutOutEquipMsg(master_id, part)
	local cmd = ProtoPublic_pb.Proto11403204();
	cmd.master_id = master_id;
	for i = 1, part:getSize() do
		cmd.part:append(part[i])
	end
	sendMsg(11403204, cmd);
end

function Lua_SacredAnimalProxy:sQiangHuaEquipMsg(master_id, part, pack_indexArr, double_intensify)
	local cmd = ProtoPublic_pb.Proto11403205();
	cmd.master_id = master_id;
	cmd.part = part;
	for i = 1, pack_indexArr:getSize() do
		local good = ProtoPublic_pb.ProtoPairObj();
		good.obj_id = pack_indexArr[i].index;
		good.obj_value = pack_indexArr[i].num;
		cmd.pack_index:addToList(good);
	end
	cmd.double_intensify = double_intensify;
	sendMsg(11403205, cmd);
end

function Lua_SacredAnimalProxy:sKuoZhanMsg()
	sendMsg(11403206);
end