-- 秘藏配置
checkRequire("Lua_SecretVo");
Lua_SecretUtil = class("Lua_SecretUtil");
function Lua_SecretUtil:ctor()
    self:superCall("ctor");
end

function Lua_SecretUtil:resetSecretInfo()
    if self._secretInfoDic ~= nil then
		for k, v in pairs(self.secretInfoDic) do
	    	v:resetServerInfo();
	    end
	end
end

function Lua_SecretUtil:updateSecretInfo(serverInfo)
	if serverInfo == nil or serverInfo.hoard_num == nil then
		return;
	end

	local vo = self.secretInfoDic[serverInfo.hoard_num];
	if vo ~= nil then
		vo:updateServerInfo(serverInfo);
	end
end

function Lua_SecretUtil.Get:secretInfoDic()
	if self._secretInfoDic == nil then
		self._secretInfoDic = {};
		self._secretInfoArr = Array();
		local config = getConfig({ "animal_hoard" });
		for k,v in pairs(config) do
			local vo = Lua_SecretVo.new(k, v);
			self._secretInfoDic[k] = vo;
			self._secretInfoArr:add(vo);
		end
	end
	return self._secretInfoDic;
end

function Lua_SecretUtil.Get:secretInfoArr()
	if self._secretInfoArr == nil then
		local dic = self.secretInfoDic;
	end
	return self._secretInfoArr;
end

function Lua_SecretUtil:getSecretVoById(id)
	local dic = self.secretInfoDic;
	if dic ~= nil and dic[id] ~= nil then
		return dic[id];
	end
	return nil;
end

function Lua_SecretUtil:getCommonConfig(name, _type)
	if self.commonDic == nil then
		self.commonDic = {};
	end
	if self.commonDic[name] == nil then
		local config = getConfig({"animal_hoard_info", name});
		if config == nil then
			return nil;
		end
		self.commonDic[name] = config;
	end

	if _type == 1 then
		return self.commonDic[name].value;
	else
		return self.commonDic[name].arr;
	end
end

-- 临时仓库大小
function Lua_SecretUtil.Get:packSize()
    local packSize = self:getCommonConfig("pack_size", 1);
    if packSize ~= nil then
    	return packSize;
    end
    return 0;
end

-- 元宝单抽购买的数量
function Lua_SecretUtil.Get:oneBuyCount()
    local oneDrawCount = self:getCommonConfig("hoard_gold_item1", 1);
    if oneDrawCount ~= nil then
    	return oneDrawCount;
    end
    return 0;
end

-- 元宝十抽购买的数量
function Lua_SecretUtil.Get:tenBuyCount()
    local oneDrawCount = self:getCommonConfig("hoard_gold_item2", 1);
    if oneDrawCount ~= nil then
    	return oneDrawCount;
    end
    return 0;
end

-- 奖励预览
function Lua_SecretUtil.Get:rewardShowArr()
	if self.rewardShow == nil then
		self.rewardShow = Array();
		local showItem = self:getCommonConfig("show_item", 2);
		if showItem ~= nil then
			for k,v in pairs(showItem) do
				self.rewardShow:add(Lua_ToolVo.createToolVo(v));
			end
		end
	end
    return self.rewardShow;
end