Lua_PetSkillVo = class("Lua_PetSkillVo");
function Lua_PetSkillVo:ctor(id,petLvl,servantConfig)
	self.petLvl = petLvl;
	self.id = id;
	self.isActivation = isActivation == nil and true or isActivation;
	self.servantConfig = servantConfig;
	self.config = getConfig({"servant_skill", id});
	if self.config == nil then
		print("no such skill:", id);
	end
end

function Lua_PetSkillVo:fromServer(val)
	self.skillId = val.skill_id;
	self.skillLvl = val.skill_lvl;
	self.skillIndex = val.skill_index+1;
	self.activationState = val.activation_state;
	--self.coolTime = val.cool_time;

	self.coolTime = self:getCoolTime();
	--self.skillType = val.skill_type;
	self.itemId = val.item_id;
end



function Lua_PetSkillVo:updateSkillLvl(lvl)
	self.skillLvl = lvl;
end

function Lua_PetSkillVo:getCoolTime()
	local coolTime = self.config.cool;
	if(coolTime==nil) then
		coolTime = 0;
	end
	return coolTime;
end

function Lua_PetSkillVo.Get:passiveTrigger()
	return self.config.passive_trigger;
end

function Lua_PetSkillVo.Get:skillName()
	return self.config.name;
end

function Lua_PetSkillVo.Get:atlasName()
	return self.config.atlas;
end

function Lua_PetSkillVo.Get:skillType()
	return self.config.skill_type;
end

function Lua_PetSkillVo.Get:iconName()
	return self.config.skill_icon;
end

function Lua_PetSkillVo.Get:desText()
	return self.config.reMark;
end

function Lua_PetSkillVo.Get:showLvl()
	if self.config ~= nil and self.config.showLvl ~= nil then
		return self.config.showLvl;
	end
	return 0;
end

function Lua_PetSkillVo:getDetailEffect(index)
	if(index==0) then index = 1; end
	local detailList = nil;
	if(self.config.other_detail~=nil) then
		detailList = self.config.other_detail;
	else
		detailList = self.config.detail;
	end
	local effect = nil;
	if(index > #detailList) then
		return nil;
	end
	effect = detailList[index].effect[1];
	--print(detail[1])
	return effect.percent;
end

function Lua_PetSkillVo.Get:useLvl()
	local skillList = self.servantConfig.skill_set;
	for k,v in ipairs(skillList) do
		--print("v[1]  "..v[1].." self.id  "..self.id)
		if(v[1] == self.id) then
			return v[2];
		end
	end
	return 0;
end

function Lua_PetSkillVo.Get:isActivated()
	if(self.petLvl>=self.useLvl) then
		return true;
	end
	return false;
end

function Lua_PetSkillVo.Get:isShowSkill()
	if self.petLvl >= self.showLvl then
		return true;
	end
	return false;
end

function Lua_PetSkillVo.Get:skillLvlUpItemInfo()
	local skillList = self.servantConfig.cost_item;
	--local skillList = getConfig({"servant", "skill","cost_item"});

	local itemList = skillList[self.skillIndex];
	local itemInfo;
	if(self.skillLvl==0) then
		itemInfo = itemList[1];
	else
		itemInfo = itemList[self.skillLvl];
	end

	local itemId = itemInfo[2];
	local needNum = itemInfo[3];
	local name = getConfig({"item",itemId ,"name"});
	local itemInfoDic = {};
	itemInfoDic.itemId = itemId;
	itemInfoDic.needNum = needNum;
	itemInfoDic.name = name;
	return itemInfoDic;
end