checkRequire("Lua_PetSkillVo");
Lua_ServantCommonData = class("Lua_ServantCommonData");
function Lua_ServantCommonData:ctor()
end

function Lua_ServantCommonData:calcLvl(totalLvl)
	self.evolutionLvl = totalLvl;
	if self.isMaxLvl == 0 then
		self.stage = math.floor(totalLvl / 10) + 1;
		self.starLvl = totalLvl % 10;
	elseif self.isMaxLvl == 1 then
		self.stage = math.floor(totalLvl / 10);
		self.starLvl = 10;
	end
end

function Lua_ServantCommonData:lvlTrans(totalLvl)
	local tempList = self:getShapConfig();
	local stage = math.floor(totalLvl / 10) + 1;
	local starLvl = totalLvl % 10;
	if stage > #tempList then
		stage = #tempList;
		starLvl = 10;
	end
	return {stage = stage, starLvl = starLvl};
end

function Lua_ServantCommonData.Get:attrId()
	if self._attrId == nil then
		self._attrId = getConfig({"attr_id"});
	end
	return self._attrId;
end

function Lua_ServantCommonData.Get:attrStrConfig()
	if self._attrStrConfig == nil then
		self._attrStrConfig = getConfig({"attr_common"});
	end
	return self._attrStrConfig;
end

function Lua_ServantCommonData:getCurAttrData(dataList)
	local baseAttrDic = self.config.evolution.property;
	local attrName;
	local attackTypeDic;
	self.curAttrArr = Array();
	for k1, v1 in ipairs(dataList) do
		for k2, v2 in pairs(baseAttrDic) do
			attrName = tostring(k2);
			if self.attrId[attrName] == v1.attr_id then
				if attrName == "attack_upper" or attrName == "attack_lower" then
					if attackTypeDic == nil then
						attackTypeDic = {};
					end

					attackTypeDic.attrStr = self.attrStrConfig[self.attrId["attack"]].common;
					attackTypeDic[attrName] = {id = v1.attr_id, attrName = attrName,
						attrStr = self.attrStrConfig[v1.attr_id].common, value = v1.attr_value};
					if attrName == "attack_lower" then
						self.curAttrArr:add(attackTypeDic);
					end
				else
					self.curAttrArr:add({id = v1.attr_id, attrName = attrName,
						attrStr = self.attrStrConfig[v1.attr_id].common, value = v1.attr_value});
				end
			end
		end
	end
end

function Lua_ServantCommonData:getNextAttrData(dataList)
	local baseAttrDic = self.config.evolution.property;
	local curAttr;
	local attackTypeDic;
	self.nextAttrArr = Array();
	for i = 1, self.curAttrArr:getSize() do
		curAttr = self.curAttrArr[i];
		for k, v in pairs(baseAttrDic) do
			local attrName = tostring(k);
			local attr1 = v[self.evolutionLvl + 1];
			local attr2 = v[self.evolutionLvl + 2];
			if attr2 == nil then
				self.nextAttrArr:add(nil);
			else
				if curAttr[attrName] == nil and self.attrId[attrName] == curAttr.id
					or curAttr[attrName] ~= nil and self.attrId[attrName] == curAttr[attrName].id then
					if attrName == "attack_upper" or attrName == "attack_lower" then
						if attackTypeDic == nil then
							attackTypeDic = {};
						end

						attackTypeDic.attrStr = self.attrStrConfig[self.attrId["attack"]].common;
						attackTypeDic[attrName] = {id = self.attrId[attrName], attrName = attrName,
							attrStr = self.attrStrConfig[self.attrId[attrName]].common, value = attr2 - attr1};
						if attrName == "attack_lower" then
							self.nextAttrArr:add(attackTypeDic);
						end
					else
						self.nextAttrArr:add({id = self.attrId[attrName], attrName = attrName,
							attrStr = self.attrStrConfig[self.attrId[attrName]].common, value = attr2 - attr1});
					end
				end
			end
		end
	end
end

function Lua_ServantCommonData:getPanaceaListData(dataList)
	local panaceaConfig = self.config.feeding_item;
	local panaceaDic = {};
	for k1, v1 in ipairs(panaceaConfig) do
		panaceaDic[tostring(v1[1])] = {limit = v1[2], stage = v1[3] / 10 + 1};
	end

	local panaceaVo;
	local addAttrList;
	local addAttrArr = self.config.panacea_prop;
	self.panaceaToolVoList = Array();
	for k2, v2 in ipairs(dataList) do
		panaceaVo = Lua_ToolVo.new(v2.obj_id, v2.obj_value);
		panaceaVo.cond = panaceaDic[tostring(v2.obj_id)];

		addAttrList = Array();
		for k3, v3 in pairs(addAttrArr[k2]) do
			local singleAttrDic = {};
			local attrName = tostring(k3);
			singleAttrDic.id = self.attrId[attrName];
			singleAttrDic.attrName = attrName;
			singleAttrDic.attrStr = self.attrStrConfig[self.attrId[attrName]].common;
			singleAttrDic.value = v3[1];
			singleAttrDic.show_percent = 0
			if self.attrStrConfig[self.attrId[attrName]].show_percent ~= nil and self.attrStrConfig[self.attrId[attrName]].show_percent == 1 then
				singleAttrDic.value = v3[1] .. "%";
				singleAttrDic.show_percent = 1
			end
			addAttrList:add(singleAttrDic);
		end

		local arrLen = addAttrList:getSize();
		for i = 1, arrLen do
			for j = 1, arrLen - i do
				if addAttrList[j].id > addAttrList[j + 1].id then
					local temp = addAttrList[j];
					addAttrList[j] = addAttrList[j + 1];
					addAttrList[j + 1] = temp;
				end
			end
		end
		panaceaVo.addAttrList = addAttrList;
		panaceaVo.servantData = self;
		self.panaceaToolVoList:add(panaceaVo);
	end
end

function Lua_ServantCommonData:getSkillListData(dataList)
	local skillVo;
	self.skillVoList = Array();
	for k, v in ipairs(dataList) do
		skillVo = Lua_PetSkillVo.new(v.skill_id, self.evolutionLvl, self.config.skill);
		skillVo:fromServer(v);
		self.skillVoList:add(skillVo);
	end
end

function Lua_ServantCommonData:getMaxExp(totalLvl)
	local tempList1 = self.config.evolution.cost_process;
	local tempList2 = totalLvl == nil and tempList1[#tempList1] or tempList1[totalLvl + 1];
	return tempList2[3];
end

function Lua_ServantCommonData:getEvoItemId()
	return self.config.evolution.item_id;
end

function Lua_ServantCommonData:getEvoItemList(lvl)
	local itemList = self.config.evolution.cost_item;
	local item = self.isMaxLvl == 0 and itemList[lvl + 1] or itemList[#itemList];
	return item[1];
end

function Lua_ServantCommonData:getServantShapeList()
	local tempList = self:getShapConfig();
	local shapeData;
	local servantShapeList = Array();
	for k, v in pairs(tempList) do
		shapeData = {};
		shapeData.id = v[1];
		shapeData.activationLvl = v[2];
		shapeData.name = v[3];
		if self.evolutionLvl ~= nil then
			shapeData.isActivated = self.evolutionLvl >= v[2];
		end
		servantShapeList:add(shapeData);
	end
	return servantShapeList;
end

function Lua_ServantCommonData:getShapConfig()
	return self.config.servant_shape;
end

function Lua_ServantCommonData:getBaseAttrDic()
	return self.config.servant_base;
end

function Lua_ServantCommonData.Set:selectedServantId(val)
	self._selectedServantId = val;
end

function Lua_ServantCommonData.Get:selectedServantId()
	if self._selectedServantId == nil then
		return self:getServantShapeList()[1].id;
	end
	return self._selectedServantId;
end

function Lua_ServantCommonData.Get:usingIndex()
	local shapeList = self:getServantShapeList();
	local index = 0;
	for i = 1, shapeList:getSize() do
		if shapeList[i].id == self.servantShape then
			index = i;
			break;
		end
	end
	return index;
end

function Lua_ServantCommonData:getModelInfo(id)
	local shapeConfig = getConfig({"playerHanger", id});
	if shapeConfig == nil then
		return nil;
	end

	return {floder = shapeConfig.floder, fileName = shapeConfig.fileName, modelName = shapeConfig.modelName,
		pos = shapeConfig.servant_pos, rot = shapeConfig.servant_rot, sca = shapeConfig.servant_sca,
		rootPos = shapeConfig.servant_root_pos, rootRot = shapeConfig.servant_root_rot, rootSca = shapeConfig.servant_root_sca};
end

function Lua_ServantCommonData:getEffectInfo(id)
	local shapeConfig = getConfig({"effect", id});
	if shapeConfig == nil then
		return nil;
	end
	return {floder = "/" .. shapeConfig.floder, path = shapeConfig.path};
end

function Lua_ServantCommonData.Get:attrOrder()
	if self._attrOrder == nil then
		self._attrOrder = {"blood", "attack", "defence", "crit", "toughness", "hit", "avoid"};
	end
	return self._attrOrder;
end

function Lua_ServantCommonData:getSkillLvl(index)
	return #self.config.skill.cost_item[index];
end

function Lua_ServantCommonData:getDisplayModelInfo(id)
	local shapeConfig = getConfig({"featureHanger", id});
	local data = {};
	data.camView = 15;
	data.root = {pos = {0, 0, 0}, rot = {0, 0, 0}, sca = {1, 1, 1}};
	data.uieffect = {pos = { 0, 0, 0}, rot = {0, 0, 0}, sca = {360, 360, 360}};
	if shapeConfig == nil then
		return data;
	end

	if shapeConfig.camView ~= nil then
		data.camView = shapeConfig.camView;
	end

	if shapeConfig.root ~= nil then
		if shapeConfig.root.pos ~= nil then
			data.root.pos = shapeConfig.root.pos;
		end
		if shapeConfig.root.rot ~= nil then
			data.root.rot = shapeConfig.root.rot;
		end
		if shapeConfig.root.sca ~= nil then
			data.root.sca = shapeConfig.root.sca;
		end
	end

	if (shapeConfig.uieffect ~= nil) then
		if shapeConfig.uieffect.pos ~= nil then
			data.uieffect.pos = shapeConfig.uieffect.pos;
		end
		if shapeConfig.uieffect.rot ~= nil then
			data.uieffect.rot = shapeConfig.uieffect.rot;
		end
		if shapeConfig.uieffect.sca ~= nil then
			data.uieffect.sca = shapeConfig.uieffect.sca;
		end
	end
	return data;
end