checkRequire("Lua_ServantCommonData");
Lua_ServantData = class("Lua_ServantData", Lua_ServantCommonData);
Lua_ServantData.AUTO_UP = 0;
Lua_ServantData.AUTO_CHECK = false;
function Lua_ServantData:ctor()
end

function Lua_ServantData:sServantPanelInfo()
	local cmd = ProtoPublic_pb.Proto11400901();
	cmd.ser_type = 0;
	sendMsg(11400901, cmd);
end

function Lua_ServantData:sServantAnvance()
	local cmd = ProtoPublic_pb.Proto11400902();
	cmd.ser_type = 0;
	cmd.cost_type = Lua_ServantData.AUTO_UP
	sendMsg(11400902, cmd);
end

function Lua_ServantData:sUseItem(index, num)
	local cmd = ProtoPublic_pb.Proto11400913();
	cmd.panacez_index = index;
	cmd.ser_type = 0;
	cmd.use_num = num;
	sendMsg(11400913, cmd);
end

function Lua_ServantData:sUse(param)
	local cmd = ProtoPublic_pb.Proto11400909();
	cmd.servant_id = param;
	cmd.ser_type = 0;
	sendMsg(11400909, cmd);
end

function Lua_ServantData:sNonuse(hide_flag)
	local cmd = ProtoPublic_pb.Proto11400911();
	cmd.ser_type = 0;
	cmd.hide_flag = hide_flag
	sendMsg(11400911, cmd);
end

function Lua_ServantData:sSkillLvlUp(id)
	local cmd = ProtoPublic_pb.Proto11400910();
	cmd.skill_id = id;
	cmd.ser_typr = 0;
	sendMsg(11400910, cmd);
end

function Lua_ServantData:sStopLvlUp()
	sendMsg(10409001);
end

function Lua_ServantData.Get:config()
	if self._config == nil then
		self._config = getConfig({"servant"});
	end
	return self._config;
end

function Lua_ServantData:fromServer51400901(data)
	self.isMaxLvl = data.is_max_lvl;
	self.evolutionExp = data.evolution_exp;
	self.servantShape = data.servant_shape;
	self.name = data.name;
	self.force = data.force;
	self.isUsing = data.is_battle;
	self.ser_type = data.ser_type;

	self:calcLvl(data.evolution_lvl);
	self:getCurAttrData(data.total_prop_list);
	self:getNextAttrData(data.next_prop_list);
	self:getSkillListData(data.skill_list);
	self:getPanaceaListData(data.edible_panacea);
end

function Lua_ServantData:servantAdvance(data)
end

function Lua_ServantData:skillLvlUp(data)
	for i = 1, self.skillVoList:getSize() do
		if self.skillVoList[i].skillId == data.skill_id then
			self.skillVoList[i].skillLvl = data.skill_lvl;
		end
	end
end

function Lua_ServantData:updateState1(data)
	self.isUsing = data.is_battle;
end

function Lua_ServantData:updateState2(data)
	self.isUsing = data.is_battle;
end

function Lua_ServantData:dispose()
	Lua_ServantData.AUTO_UP = 0
	Lua_ServantData.AUTO_CHECK = false
	self:superCall("dispose");
end