checkRequire("Lua_ServantData");
Lua_ServantProxy = class("Lua_ServantProxy");
function Lua_ServantProxy:ctor()
	DataCenter.servantData = Lua_ServantData.new();

	LuaUtil.addLuaMsg(51400901, self, self.rGetServantPanelInfo); -- 侍宠使用灵丹（返回）
	LuaUtil.addLuaMsg(51400902, self, self.rServantAnvance); -- 侍宠进阶（返回）
	LuaUtil.addLuaMsg(51400909, self, self.rFight); -- 化形（返回）
	LuaUtil.addLuaMsg(51400910, self, self.rSkillLvlUp); -- 侍宠技能升级（返回）
	LuaUtil.addLuaMsg(51400911, self, self.rRecall); -- 显示隐藏（返回）
	LuaUtil.addLuaMsg(51400913, self, self.rUseItem); -- 侍宠使用灵丹（返回）
end

function Lua_ServantProxy:rGetServantPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400901();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 0 then
			return;
		end
		DataCenter.servantData:fromServer51400901(msg);
		Lua_MsgUtil.callFunc("PET_PANEL_UPDATE");
		Lua_MsgUtil.callFunc("Servant_LVL_UP_UPDATE");
	end
end

function Lua_ServantProxy:rServantAnvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400902();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 0 then
			return;
		end
		DataCenter.servantData:servantAdvance(msg);
		-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", {state = false});
		-- 	DataCenter.servantData:sServantPanelInfo();
	end
	DataCenter.servantData:sServantPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_ServantProxy:rFight(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400909();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 0 then
			return;
		end
		DataCenter.servantData:updateState1(msg);
		-- Lua_MsgUtil.callFunc("PET_PANEL_UPDATE");
		DataCenter.servantData:sServantPanelInfo();
	end
end

function Lua_ServantProxy:rRecall(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400911();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 0 then
			return;
		end
		DataCenter.servantData:updateState2(msg);
		-- Lua_MsgUtil.callFunc("PET_PANEL_UPDATE");
		-- DataCenter.servantData:sServantPanelInfo();
	end
end

function Lua_ServantProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400910();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 0 then
			return;
		end
		DataCenter.servantData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_ServantProxy:rUseItem(mp)
	-- if mp.errno == 0 then
	-- 	local msg = ProtoPublic_pb.Proto51400910();
	-- 	msg:ParseFromString(mp.data);
	-- 	DataCenter.servantData:skillLvlUp(msg);
	-- 	Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	-- end
end





function Lua_ServantProxy:sFuncOpen()
	local shapeList = DataCenter.servantData:getServantShapeList();
	DataCenter.servantData:sUse(shapeList[1].id);
end