Lua_ServantLvlUpData = class("Lua_ServantLvlUpData");
function Lua_ServantLvlUpData:ctor()
  --  self:rInit();
    LuaUtil.addLuaMsg(80400101, self, self.rInit);
end

function Lua_ServantLvlUpData:rInit()
    self.tempData = { };
    self.tempData.dragListLen = { 4, 17, 5 };
    local ot = os.date("*t", os.time())
    local loginStr = DataCenter.roleData.roleId .. "_SERVANT_LVL_UP_WINDOW";
    local lday = UnityEngine.PlayerPrefs.GetInt(loginStr);
    if lday == 0 or lday ~= ot.yday + 100 then
        UnityEngine.PlayerPrefs.SetInt(loginStr, ot.yday + 100);
        Lua_ServantLvlUpData.IS_FIRST_DAY = true
    else
        Lua_ServantLvlUpData.IS_FIRST_DAY = false;
    end
    local key1 = DataCenter.roleData.roleId .. "_SERVANT_LVL_1"
    local key2 = DataCenter.roleData.roleId .. "_SERVANT_LVL_2"
    local key3 = DataCenter.roleData.roleId .. "_SERVANT_LVL_3"
    if Lua_ServantLvlUpData.IS_FIRST_DAY == true then
        UnityEngine.PlayerPrefs.SetInt(key1, 3);
        UnityEngine.PlayerPrefs.SetInt(key2, 16);
        UnityEngine.PlayerPrefs.SetInt(key3, 4);
    end
    self.tempData.defaultIndex = { UnityEngine.PlayerPrefs.GetInt(key1), UnityEngine.PlayerPrefs.GetInt(key2), UnityEngine.PlayerPrefs.GetInt(key3) }
end

function Lua_ServantLvlUpData:setSelectedIndex(curDragDownIndex, index)
    local key = DataCenter.roleData.roleId .. "_SERVANT_LVL_" .. curDragDownIndex
    UnityEngine.PlayerPrefs.SetInt(key, index);
end

function Lua_ServantLvlUpData:sGetLvlUpPanelInfo()
    sendMsg(11400903);
end

function Lua_ServantLvlUpData:sEatItem(indexList)

    if indexList:getSize() <= 0 then
        return;
    end
    local cmd = ProtoPublic_pb.Proto11400904();
    for i = 1, indexList:getSize() do

        cmd.pack_index:append(indexList[i]);
    end
    sendMsg(11400904, cmd);
end

function Lua_ServantLvlUpData:fromServer(data)
    self.servantLvl = data.servant_lvl;
    self.servantExp = data.servant_exp;
    self.isMaxLvl = data.is_max_lvl;
end

function Lua_ServantLvlUpData:updateWhileEateItem(data)
    self.servantLvl = data.servant_lvl;
    self.servantExp = data.cur_exp;
    if (data.is_grade == 1) then
        self:sGetLvlUpPanelInfo();
    else
        Lua_MsgUtil.callFunc("Servant_LVL_UP_UPDATE");
    end
end

function Lua_ServantLvlUpData:getMaxExp(totalLvl)
    local tempList1 = self.config.cost_exp;
    -- local tempList1=getConfig({"servant", "upgrade","cost_exp"});
    local tempList2;
    if (totalLvl == nil) then
        tempList2 = tempList1[#tempList1];
    else
        tempList2 = tempList1[totalLvl + 1];
    end
    return tempList2;
end

function Lua_ServantLvlUpData:getVipRatio(vipLvl)
    local vipAdd = getConfig({"vip_level", DataCenter.vipData.level, "combine_equip"});
    if vipAdd == nil then
        vipAdd = 0;
    end
    return vipAdd;
end

function Lua_ServantLvlUpData:getItemList()
    local minColor = self.config.min_color;
    local equipAddExpList = self.config.equip_exp;
    local starRatio = self.config.star_ratio;

    local packDataList = DataCenter.packData:getBagType(2):getBagAllData();

    local itemList = Array();
    for i = 1, packDataList:getSize() do
        local item = nil;
        local addExp = 0;
        local isShow = false;
        local itemData = packDataList[i];
        if (itemData.type == 1 and itemData.color >= minColor) and itemData.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then--骑装屏蔽
            if (itemData.career == 0 or itemData.career ~= 0 and itemData.career == DataCenter.roleData.career) then
                local myEqu = DataCenter.equData:getEquByPart(itemData.part);
                if myEqu ~= nil and itemData.force <= myEqu.force then
                    isShow = true;
                end
            else
                isShow = true;
            end
            if (isShow == true) then
                local expList = equipAddExpList[itemData.order];
                addExp = expList[itemData.color - 2];
                if (itemData.star >= 0) then
                    addExp = addExp * starRatio[itemData.star + 1];
                end
            end
        elseif (self.devourItemDic[tostring(itemData.id)] ~= nil) then
            isShow = true;
            addExp = self.devourItemDic[tostring(itemData.id)] * itemData.count;
        end

        if (isShow == true) then
            local vipAdd = getConfig({"vip_level", DataCenter.vipData.level, "combine_equip"});
            if vipAdd == nil then
                vipAdd = 0;
            end
            addExp = addExp + addExp * (vipAdd / 100);
            item = { };
            item.addExp = math.floor(addExp);
            item.voData = itemData;
            itemList:add(item);
        end
    end


    local len = itemList:getSize();
    for i = 1, len - 1 do
        for j = 1, len - i do
            if (itemList[j].voData.force < itemList[j + 1].voData.force) then
                local temp = itemList[j];
                itemList[j] = itemList[j + 1];
                itemList[j + 1] = temp;
            end
        end
    end
    return itemList;
end

function Lua_ServantLvlUpData:getAttr(lvl)
    local attrConfig = self.config.property;
    local curAttr = 0;
    local nextAttr = 0;
    local attrDic = { };
    for k, v in pairs(attrConfig) do
        local attrName = tostring(k);
        if (lvl > 0) then
            curAttr = v[lvl];
        end
        if (v[lvl + 1] ~= nil) then
            nextAttr = v[lvl + 1];
        end
        attrDic[attrName] = { };
        attrDic[attrName].curAttr = curAttr;
        attrDic[attrName].nextAttr = nextAttr;
    end
    return attrDic;
end

function Lua_ServantLvlUpData.Get:devourItemDic()
    if (self._devourItemDic == nil) then
        local devourItem = self.config.devour_item;
        self._devourItemDic = { };
        for k, v in ipairs(devourItem) do
            self._devourItemDic[tostring(v[1])] = v[2];
        end
    end
    return self._devourItemDic;
end

function Lua_ServantLvlUpData.Get:config()
    if (self._config == nil) then
        self._config = getConfig( { "servant", "upgrade" });
    end
    return self._config;
end