checkRequire("Lua_ServantLvlUpData");
Lua_ServantLvlUpProxy = class("Lua_ServantLvlUpProxy", Lua_EventOwner);
function Lua_ServantLvlUpProxy:ctor()
	self:superCall("ctor");

	DataCenter.servantLvlUpData = Lua_ServantLvlUpData.new();

	LuaUtil.addLuaMsg(51400903, self, self.rGetServantLvlUpPanelInfo);
	LuaUtil.addLuaMsg(51400904, self, self.rEatItem);

	Lua_MsgUtil.addEventListener("AUTO_EAT_EQUIPMENT",self,self.onCheckAutoEat);
	Lua_MsgUtil.addEventListener("EQU_UPDATE", self, self.equipUpdate);
	Lua_MsgUtil.addEventListener("PACK_UPDATE", self, self.packUpdate);
	Lua_MsgUtil.addEventListener("BASE_PARAM_COMPLETE", self, self.baseParamComplete);
end

function Lua_ServantLvlUpProxy:rGetServantLvlUpPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400903();
		msg:ParseFromString(mp.data);
		DataCenter.servantLvlUpData:fromServer(msg);
		Lua_MsgUtil.callFunc("Servant_LVL_UP_UPDATE");
	end
end

function Lua_ServantLvlUpProxy:rEatItem(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400904();
		msg:ParseFromString(mp.data);
		DataCenter.servantLvlUpData:updateWhileEateItem(msg);
		DataCenter.servantData:sServantPanelInfo();
		Lua_MsgUtil.callFunc("Servant_LVL_UP_UPDATE");
	end
end

function Lua_ServantLvlUpProxy:equipUpdate()
	-- self:autoEatEquipment();
	-- Lua_CommonUtil.delayCall(0.5, self, self.autoEatEquipment);
	-- self:checkRedDot();
end

function Lua_ServantLvlUpProxy:packUpdate(packType)
	if packType == Lua_PackData.BAG_PACK and self.isEquipUpdated == true then
		self:checkRedDot();
	end
end

function Lua_ServantLvlUpProxy:onCheckAutoEat()
	Lua_CommonUtil.delayCall(0.5, self, self.autoEatEquipment);
end

function Lua_ServantLvlUpProxy:autoEatEquipment()
	if DataCenter.roleData.baseParam == nil then
		return;
	end

	-- if DataCenter.packData:getBagType(2):getLeftSize() > 5 then
	-- 	return;
	-- end

	if DataCenter.funcOpenData:isOpened(10008) == false
		or DataCenter.hangUpSettingsData.auto_eat_equipt ~= 1
		or DataCenter.packData:getBagType(2):getLeftSize()>5 then
		return;
	end

	local itemData;
	local packDataList = DataCenter.packData:getBagType(2):getBagAllData();
	local indexList = Array();
	for i = 1, packDataList:getSize() do
		itemData = packDataList[i];
		if itemData.type == 1 and itemData.color == 3
			and itemData.career ~= DataCenter.roleData.career
			and itemData.stream_id == Lua_PackTypeDefine.PICK_STREAM_TYPE then
			if self:isEatable(itemData) then
				indexList:add(itemData.index);
			end
		end
	end

	if indexList:getSize() > 0 then
		DataCenter.servantLvlUpData:sEatItem(indexList);
	end
end

function Lua_ServantLvlUpProxy:baseParamComplete()
	if self.isEquipUpdated ~= true then
		self.isEquipUpdated = true;
		self:checkRedDot();
	end
end

function Lua_ServantLvlUpProxy:checkRedDot()
	if DataCenter.funcOpenData:isOpened(10008) == false then
		return;
	end

	local itemData;
	local packDataList = DataCenter.packData:getBagType(2):getBagAllData();
	for i = 1, packDataList:getSize() do
		itemData = packDataList[i];
		if (itemData.type == 1 and itemData.color >= 3 or itemData.subType == 0)
			and itemData.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
			if self:isEatable(itemData) and self:isSelected(itemData) then
				DataCenter.redDotData:updateRedDotVoState(11112, true);
				Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11112, val = -1, bShow = true});
				Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
				return;
			end
		end
	end

	DataCenter.redDotData:updateRedDotVoState(11112, false);
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11112, val = -1, bShow = false});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
end

function Lua_ServantLvlUpProxy:isSelected(itemData)
	-- if itemData.subType == 0 then
	-- 	return false;
	-- end

	local selectedIndexDic = DataCenter.servantLvlUpData.tempData.defaultIndex;
	local dragListLenDic = DataCenter.servantLvlUpData.tempData.dragListLen;

	local selectedIndex1 = dragListLenDic[1] - selectedIndexDic[1] + 1;
	local selectedColor = selectedIndex1 == 1 and nil or selectedIndex1 + 1;

	local selectedIndex2 = dragListLenDic[2] - selectedIndexDic[2] + 1;
	local selectedStage = selectedIndex2 == 1 and nil or selectedIndex2 - 2;

	local selectedIndex3 = dragListLenDic[3] - selectedIndexDic[3] + 1;
	local selectedStar = selectedIndex3 == 1 and nil or selectedIndex3 - 2;

	local color = itemData.color;
	local stage = itemData.order;
	local star = itemData.star;
	local isSelected = false;
	if selectedColor == nil then
		if color ~= nil then
			isSelected = false;
		end
	else
		if color ~= nil and color <= selectedColor then
			isSelected = true;
		end
	end

	if selectedStage == nil then
		if stage ~= nil then
			isSelected = false;
		end
	elseif selectedStage ~= 0 then
		if stage == nil or (stage ~= nil and stage > selectedStage) then
			isSelected = false;
		end
	end

	if selectedStar == nil then
		if star ~= nil then
			isSelected = false;
		end
	else
		if star == nil or (star ~= nil and star > selectedStar) then
			isSelected = false;
		end
	end
	return isSelected;
end

function Lua_ServantLvlUpProxy:isEatable(itemData)
	if itemData.type == 3 and itemData.subType == 0 then
		local devourItemDic = DataCenter.servantLvlUpData.devourItemDic;
		if devourItemDic[tostring(itemData.id)] ~= nil then
			return true;
		end
	end

	if itemData.career == 0 or itemData.career ~= 0 and itemData.career == DataCenter.roleData.career then
		local myEqu = DataCenter.equData:getEquByPart(itemData.part);
		if myEqu ~= nil and itemData.force <= myEqu.force then
			return true;
		end
	else
		return true;
	end
	return false;
end