checkRequire("Lua_ServantMountData");
Lua_ServantMountProxy = class("Lua_ServantMountProxy");
function Lua_ServantMountProxy:ctor()
	DataCenter.servantMountData = Lua_ServantMountData.new();
	
	LuaUtil.addLuaMsg(51400901, self, self.rGetServantPanelInfo); -- 打开侍宠界面（返回）
	LuaUtil.addLuaMsg(51400902, self, self.rServantAnvance); -- 侍宠进阶（返回）
	LuaUtil.addLuaMsg(51400909, self, self.rMount); -- 化形（返回）
	LuaUtil.addLuaMsg(51400910, self, self.rSkillLvlUp); -- 侍宠技能升级（返回）
	LuaUtil.addLuaMsg(51400911, self, self.rDismount); -- 显示隐藏（返回）
	LuaUtil.addLuaMsg(51400913, self, self.rUseItem); -- 侍宠使用灵丹（返回）
end

function Lua_ServantMountProxy:rGetServantPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400901();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 2 then
			return;
		end
		DataCenter.servantMountData:fromServer51400901(msg);
		Lua_MsgUtil.callFunc("PET_MOUNT_PANEL_UPDATE");
	end
end

function Lua_ServantMountProxy:rServantAnvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400902();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 2 then
			return;
		end
		DataCenter.servantMountData:servantAdvance(msg);
		--Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.servantData:sServantPanelInfo();
	end
	DataCenter.servantMountData:sServantPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_ServantMountProxy:rMount(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400909();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 2 then
			return;
		end
		DataCenter.servantMountData:updateState1(msg);
		-- Lua_MsgUtil.callFunc("PET_MOUNT_PANEL_UPDATE");
		DataCenter.servantMountData:sServantPanelInfo();
	end
end

function Lua_ServantMountProxy:rDismount(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400911();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 2 then
			return;
		end
		DataCenter.servantMountData:updateState2(msg);
		-- Lua_MsgUtil.callFunc("PET_MOUNT_PANEL_UPDATE");
		DataCenter.servantMountData:sServantPanelInfo();
	end
end

function Lua_ServantMountProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400910();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 2) then return; end
		DataCenter.servantMountData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_ServantMountProxy:rUseItem(mp)
	-- if mp.errno == 0 then
	-- 	local msg = ProtoPublic_pb.Proto51400910();
	-- 	msg:ParseFromString(mp.data);
	-- 	DataCenter.servantData:skillLvlUp(msg);
	-- 	Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	-- end
end





function Lua_ServantMountProxy:sFuncOpen()
	local shapeList = DataCenter.servantMountData:getServantShapeList();
	DataCenter.servantMountData:sUse(shapeList[1].id);
end