checkRequire("Lua_ServantMountTransData");
Lua_ServantMountTransProxy = class("Lua_ServantMountTransProxy");
function Lua_ServantMountTransProxy:ctor()
    self:superCall("ctor");
    DataCenter.servantMountTransData = Lua_ServantMountTransData.new();
    LuaUtil.addLuaMsg(51400905, self, self.rGetPetTransPanelInfo);
    LuaUtil.addLuaMsg(51400906, self, self.rActivation);
    LuaUtil.addLuaMsg(51400907, self, self.rTransmogrify);
    LuaUtil.addLuaMsg(51400908, self, self.rLvlUp);
    LuaUtil.addLuaMsg(51400912, self, self.rRestore);
end

function Lua_ServantMountTransProxy:rGetPetTransPanelInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400905();
        msg:ParseFromString(mp.data);
        if (msg.ser_type ~= 2) then return; end
        DataCenter.servantMountTransData:fromServer(msg);
        Lua_MsgUtil.callFunc("SERVANT_MOUNT_TRANS_PANEL_UPDATE");
    end
end

function Lua_ServantMountTransProxy:rActivation(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400906();
        msg:ParseFromString(mp.data);
        if (msg.ser_type ~= 2) then return; end
        DataCenter.servantMountTransData:getActivationInfo(msg);
        DataCenter.servantMountTransData:sGetPanelInfo(2);
    end
end

function Lua_ServantMountTransProxy:rTransmogrify(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400907();
        msg:ParseFromString(mp.data);
        if (msg.ser_type ~= 2) then return; end
        DataCenter.servantMountTransData:getTransInfo(msg);
        DataCenter.servantMountTransData:sGetPanelInfo(2);
    end
end

function Lua_ServantMountTransProxy:rLvlUp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400908();
        msg:ParseFromString(mp.data);
        if (msg.ser_type ~= 2) then return; end
        DataCenter.servantMountTransData:getLvlUpInfo(msg);
        DataCenter.servantMountTransData:sGetPanelInfo(2);
    end
end

function Lua_ServantMountTransProxy:rRestore(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400912();
        msg:ParseFromString(mp.data);
        if (msg.ser_type ~= 2) then return; end
        DataCenter.servantMountTransData:sGetPanelInfo();
    end
end