Lua_TransCommonData = class("Lua_TransCommonData");
function Lua_TransCommonData:ctor()
    self.isSuccess = false;
end

function Lua_TransCommonData:setDataList(dataList)
	local isCanShow;
	local data;
	local itemInfo;
	local isShow;
	local condItemDic;
	local costItemDic;
	local actedArr = Array();
	local canActArr = Array();
	local unActArr = Array();
	for k, v in ipairs(dataList) do
		isCanShow = self:getShowState(self:getModelId(k));
		if isCanShow then
			data = {};
			data.illLvl = v.ill_lvl;
			data.illId = v.ill_id;
			data.isUnlock = v.is_unlock;
			data.unlockType = v.unlock_type;
			data.illName = v.ill_name;
			data.modelId = self:getModelId(k);
			data.itemId = self.config.illusion_item_id[k];

			itemInfo = Lua_ToolVo.new(data.itemId)
			isShow = false;
			if itemInfo.qudao_xianshi == 0 then
				isShow = true;
			else
				for i = 1, #itemInfo.qudao_xianshi do
					if getAgentName() == tostring(itemInfo.qudao_xianshi[i]) then
						isShow = true;
						break;
					end
				end
			end
			data.huanhua_rank = itemInfo.huanhua_rank
			data.fragmentItemId = self.config.decompose_item[k][2];
			data.maxLvl = self.config.max_lvl;
			data.isTransmogrified = self.illId == data.illId;

			condItemDic = self:getCondItemId(v.ill_id);
			costItemDic = self:getCostItemInfo(v.ill_id, v.ill_lvl);
			if condItemDic ~= nil and costItemDic ~= nil then
				data.condItemDic = condItemDic;
				data.neededFullItemNum = condItemDic.fullItem.num;
				data.neededFragmentItemNum = condItemDic.fragmentItem.num;
				data.ownedFullItemNum = DataCenter.packData:getBagType(2):getItemNum(condItemDic.fullItem.id);
				data.ownedFragmentItemNum = DataCenter.packData:getBagType(2):getItemNum(condItemDic.fragmentItem.id);
				data.lvlUpItemId = costItemDic.id;
				data.lvlUpitemNum = costItemDic.num;
			end
			data.isActivable = data.ownedFullItemNum >= data.neededFullItemNum 
				or data.ownedFragmentItemNum >= data.neededFragmentItemNum;

			-- 分类 排序
			if v.is_unlock == 1 then
				if isShow == true then
					actedArr:add(data);
				end
			else
				if data.isActivable then
					if isShow then
						canActArr:add(data);
					end
				else
					if isShow then
						unActArr:add(data);
					end
				end
			end
		end
	end

	local index = 0;
	self.servantTransList = Array();
	-- 可解锁
	if canActArr:getSize() > 0 then
		canActArr:sort("huanhua_rank", false);
	end
	for i = 1, canActArr:getSize() do
		index = index + 1;
		canActArr[i].index = index;
		self.servantTransList:add(canActArr[i]);
	end
	-- 已解锁
	if actedArr:getSize() > 0 then
		actedArr:sort("huanhua_rank", false);
	end
	for i = 1, actedArr:getSize() do
		index = index + 1;
		actedArr[i].index = index;
		self.servantTransList:add(actedArr[i]);
	end
	-- 未解锁
	if unActArr:getSize() > 0 then
		unActArr:sort("huanhua_rank", false);
	end
	for i = 1, unActArr:getSize() do
		index = index + 1;
		unActArr[i].index = index;
		self.servantTransList:add(unActArr[i]);
	end
end

-- 2022-6-30 由客户端根据 illusion_list 来显示幻化
function Lua_TransCommonData:getShowState(id)
	local isCanShow = false;
	for i = 1, #self.config.illusion_list do
		if id == self.config.illusion_list[i] then
			isCanShow = true;
			break;
		end
	end
	return isCanShow;
end

function Lua_TransCommonData:getCondItemId(id)
	local condItemDic;
	for k, v in ipairs(self.config.illusion_shape) do
		if v.id == id then
			condItemDic = {fullItem = {id = v.illusion_item[1][1], num = v.illusion_item[1][2]},
				fragmentItem = {id = v.illusion_item[2][1], num = v.illusion_item[2][2]}};
		end
	end
	return condItemDic;
end

function Lua_TransCommonData:getCostItemInfo(id, lvl)
	lvl = lvl == 0 and 1 or lvl;
	local itemInfo;
	local costItemDic;
	for k, v in ipairs(self.config.illusion_shape) do
		if v.id == id then
			itemInfo = v.cost_item[lvl];
			if itemInfo == nil then
				itemInfo = v.cost_item[lvl - 1];
			end
			costItemDic = {id = itemInfo[1], num = itemInfo[2]};
		end
	end
	return costItemDic;
end

function Lua_TransCommonData:getAttrData(id, lvl, isUnlock)
	local attrOrderDic;
	if self.config.attr_order ~= nil then
		attrOrderDic = {};
		for k, v in ipairs(self.config.attr_order) do
			attrOrderDic[v] = k;
		end
	end

	lvl = lvl == 0 and 1 or lvl;
	local transList = self.config.illusion_shape;
	local attrDic;
	local attrName;
	local configInfo;
	local attrArr = Array();
	for k, v in ipairs(transList) do
		if v.id == id then
			for k1, v1 in pairs(v.property) do
				attrDic = {};
				attrDic.curValue = v1[lvl];
				attrDic.nextValue = 0;
				if isUnlock == 1 and v1[lvl + 1] ~= nil then
					attrDic.nextValue = v1[lvl + 1] - v1[lvl];
				end

				attrName = tostring(k1);
				configInfo = self.attrStrConfig[self.attrId[attrName]];

				attrDic.id = self.attrId[attrName];
				attrDic.lvl = lvl;
				attrDic.isUnlock = isUnlock;
				attrDic.attrName = attrName;
				attrDic.attrStr = configInfo.common;
				if configInfo.show_percent ~= nil and configInfo.show_percent == 1 then
					attrDic.show_percent = configInfo.show_percent;
					attrDic.curValue = v1[lvl] .. "%"
				else
					attrDic.show_percent = 0
				end

				if attrOrderDic ~= nil then
					attrDic.order = attrOrderDic[attrName];
				end
				attrArr:add(attrDic);
			end
		end
	end

	if attrOrderDic == nil then
		attrArr:sort("id", false);
	else
		attrArr:sort("order", false);
	end
	return attrArr;
end

function Lua_TransCommonData.Get:attrStrConfig()
	if self._attrStrConfig == nil then
		self._attrStrConfig = getConfig({"attr_common"});
	end
	return self._attrStrConfig;
end

function Lua_TransCommonData.Get:attrId()
	if self._attrId == nil then
		self._attrId = getConfig({"attr_id"});
	end
	return self._attrId;
end

function Lua_TransCommonData:getModelId(index)
	return self.config.illusion_shape_id[index];
end

function Lua_TransCommonData:getName(id)
	local list = self.config.illusion_shape;
	local name;
	for k, v in ipairs(list) do
		if v.id == id then
			name = v.name;
		end
	end
	return name;
end