checkRequire("Lua_ServantTransData");
Lua_ServantTransProxy = class("Lua_ServantTransProxy");
function Lua_ServantTransProxy:ctor()
	DataCenter.servantTransData = Lua_ServantTransData.new();
	
	LuaUtil.addLuaMsg(51400905, self, self.rGetPetTransPanelInfo);
	LuaUtil.addLuaMsg(51400906, self, self.rActivation);
	LuaUtil.addLuaMsg(51400907, self, self.rTransmogrify);
	LuaUtil.addLuaMsg(51400908, self, self.rLvlUp);
	LuaUtil.addLuaMsg(51400912, self, self.rRestore);
end

function Lua_ServantTransProxy:rGetPetTransPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400905();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 0) then return; end
		DataCenter.servantTransData:fromServer(msg);
		Lua_MsgUtil.callFunc("SERVANT_TRANS_PANEL_UPDATE");
	end
end

function Lua_ServantTransProxy:rActivation(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400906();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 0) then return; end
		DataCenter.servantTransData:getActivationInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantTransData:sGetPanelInfo(0);
	end
end

function Lua_ServantTransProxy:rTransmogrify(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400907();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 0) then return; end
		DataCenter.servantTransData:getTransInfo(msg);
		DataCenter.servantTransData:sGetPanelInfo(0);
	end
end

function Lua_ServantTransProxy:rLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400908();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 0) then return; end
		DataCenter.servantTransData:getLvlUpInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantTransData:sGetPanelInfo(0);
	end
end

function Lua_ServantTransProxy:rRestore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400912();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 0) then return; end
		DataCenter.servantTransData:sGetPanelInfo(0);
	end
end