checkRequire("Lua_ServantWeaponData");
Lua_ServantWeaponProxy = class("Lua_ServantWeaponProxy");
function Lua_ServantWeaponProxy:ctor()
	DataCenter.servantWeaponData = Lua_ServantWeaponData.new();

	LuaUtil.addLuaMsg(51400901, self, self.rGetServantPanelInfo); -- 打开侍宠界面（返回）
	LuaUtil.addLuaMsg(51400902, self, self.rServantAnvance); -- 侍宠进阶（返回）
	LuaUtil.addLuaMsg(51400909, self, self.rPutOn); -- 化形（返回）
	LuaUtil.addLuaMsg(51400910, self, self.rSkillLvlUp); -- 侍宠技能升级（返回）
	LuaUtil.addLuaMsg(51400911, self, self.rPutOff); -- 显示隐藏（返回）
	LuaUtil.addLuaMsg(51400913, self, self.rUseItem); -- 侍宠使用灵丹（返回）
end

function Lua_ServantWeaponProxy:rGetServantPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400901();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 1 then
			return;
		end
		DataCenter.servantWeaponData:fromServer51400901(msg);
		Lua_MsgUtil.callFunc("PET_WEAPON_PANEL_UPDATE");
	end
end

function Lua_ServantWeaponProxy:rServantAnvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400902();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponData:servantAdvance(msg);
		--Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.servantData:sServantPanelInfo();
	end
	DataCenter.servantWeaponData:sServantPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_ServantWeaponProxy:rPutOn(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400909();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponData:updateState1(msg);
		-- Lua_MsgUtil.callFunc("PET_WEAPON_PANEL_UPDATE");
		DataCenter.servantWeaponData:sServantPanelInfo();
	end
end

function Lua_ServantWeaponProxy:rPutOff(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400911();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponData:updateState2(msg);
		-- Lua_MsgUtil.callFunc("PET_WEAPON_PANEL_UPDATE");
		DataCenter.servantWeaponData:sServantPanelInfo();
	end
end

function Lua_ServantWeaponProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400910();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_ServantWeaponProxy:rUseItem(mp)
	-- if mp.errno == 0 then
	-- 	local msg = ProtoPublic_pb.Proto51400910();
	-- 	msg:ParseFromString(mp.data);
	-- 	DataCenter.servantData:skillLvlUp(msg);
	-- 	Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	-- end
end





function Lua_ServantWeaponProxy:sFuncOpen()
	local shapeList = DataCenter.servantWeaponData:getServantShapeList();
	DataCenter.servantWeaponData:sUse(shapeList[1].id);
end