checkRequire("Lua_ServantWeaponTransData");
Lua_ServantWeaponTransProxy = class("Lua_ServantWeaponTransProxy");
function Lua_ServantWeaponTransProxy:ctor()
	self:superCall("ctor");
	DataCenter.servantWeaponTransData = Lua_ServantWeaponTransData.new();
	LuaUtil.addLuaMsg(51400905, self, self.rGetPetTransPanelInfo);
	LuaUtil.addLuaMsg(51400906, self, self.rActivation);
	LuaUtil.addLuaMsg(51400907, self, self.rTransmogrify);
	LuaUtil.addLuaMsg(51400908, self, self.rLvlUp);
	LuaUtil.addLuaMsg(51400912, self, self.rRestore);
end

function Lua_ServantWeaponTransProxy:rGetPetTransPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400905();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponTransData:fromServer(msg);
		Lua_MsgUtil.callFunc("SERVANT_WEAPON_TRANS_PANEL_UPDATE");
	end
end

function Lua_ServantWeaponTransProxy:rActivation(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400906();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponTransData:getActivationInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantWeaponTransData:sGetPanelInfo(1);
	end
end

function Lua_ServantWeaponTransProxy:rTransmogrify(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400907();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponTransData:getTransInfo(msg);
		DataCenter.servantWeaponTransData:sGetPanelInfo(1);
	end
end

function Lua_ServantWeaponTransProxy:rLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400908();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponTransData:getLvlUpInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantWeaponTransData:sGetPanelInfo(1);
	end
end

function Lua_ServantWeaponTransProxy:rRestore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400912();
		msg:ParseFromString(mp.data);
		if(msg.ser_type ~= 1) then return; end
		DataCenter.servantWeaponTransData:sGetPanelInfo();
	end
end