checkRequire("Lua_ServantWingData");
Lua_ServantWingProxy = class("Lua_ServantWingProxy");
function Lua_ServantWingProxy:ctor()
	DataCenter.servantWingData = Lua_ServantWingData.new();

	LuaUtil.addLuaMsg(51400901, self, self.rGetServantPanelInfo); -- 打开侍宠界面（返回）
	LuaUtil.addLuaMsg(51400902, self, self.rServantAnvance); -- 侍宠进阶（返回）
	LuaUtil.addLuaMsg(51400909, self, self.rUse); -- 化形（返回）
	LuaUtil.addLuaMsg(51400910, self, self.rSkillLvlUp); -- 侍宠技能升级（返回）
	LuaUtil.addLuaMsg(51400911, self, self.rNonuse); -- 显示隐藏（返回）
	LuaUtil.addLuaMsg(51400913, self, self.rUseItem); -- 侍宠使用灵丹（返回）
end

function Lua_ServantWingProxy:rGetServantPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400901();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingData:fromServer51400901(msg);
		Lua_MsgUtil.callFunc("PET_WING_PANEL_UPDATE");
	end
end

function Lua_ServantWingProxy:rServantAnvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400902();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingData:servantAdvance(msg);
		-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.servantData:sServantPanelInfo();
	end
	DataCenter.servantWingData:sServantPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_ServantWingProxy:rUse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400909();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingData:updateState1(msg);
		-- Lua_MsgUtil.callFunc("PET_WING_PANEL_UPDATE");
		DataCenter.servantWingData:sServantPanelInfo();
	end
end

function Lua_ServantWingProxy:rNonuse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400911();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingData:updateState2(msg);
		-- Lua_MsgUtil.callFunc("PET_WING_PANEL_UPDATE");
		DataCenter.servantWingData:sServantPanelInfo();
	end
end

function Lua_ServantWingProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400910();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_ServantWingProxy:rUseItem(mp)
	-- if mp.errno == 0 then
	-- 	local msg = ProtoPublic_pb.Proto51400910();
	-- 	msg:ParseFromString(mp.data);
	-- 	DataCenter.servantData:skillLvlUp(msg);
	-- 	Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	-- end
end

function Lua_ServantWingProxy:sFuncOpen()
	local shapeList = DataCenter.servantWingData:getServantShapeList();
	DataCenter.servantWingData:sUse(shapeList[1].id);
end