checkRequire("Lua_ServantWingTransData");
Lua_ServantWingTransProxy = class("Lua_ServantWingTransProxy");
function Lua_ServantWingTransProxy:ctor()
	DataCenter.servantWingTransData = Lua_ServantWingTransData.new();

	LuaUtil.addLuaMsg(51400905, self, self.rGetPetTransPanelInfo);
	LuaUtil.addLuaMsg(51400906, self, self.rActivation);
	LuaUtil.addLuaMsg(51400907, self, self.rTransmogrify);
	LuaUtil.addLuaMsg(51400908, self, self.rLvlUp);
	LuaUtil.addLuaMsg(51400912, self, self.rRestore);
end

function Lua_ServantWingTransProxy:rGetPetTransPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400905();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		-- print("rGetPetTransPanelInfo", msg.ser_type);
		DataCenter.servantWingTransData:fromServer(msg);
		Lua_MsgUtil.callFunc("SERVANT_WING_TRANS_PANEL_UPDATE");
	end
end

function Lua_ServantWingTransProxy:rActivation(mp)
	-- print("rActivation");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400906();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingTransData:getActivationInfo(msg);
		-- Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantWingTransData:sGetPanelInfo();
	end
end

function Lua_ServantWingTransProxy:rTransmogrify(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400907();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingTransData:getTransInfo(msg);
		DataCenter.servantWingTransData:sGetPanelInfo();
	end
end

function Lua_ServantWingTransProxy:rLvlUp(mp)
	-- print("rLvlUp");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400908();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingTransData:getLvlUpInfo(msg);
		-- Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.servantWingTransData:sGetPanelInfo();
	end
end

function Lua_ServantWingTransProxy:rRestore(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400912();
		msg:ParseFromString(mp.data);
		if msg.ser_type ~= 3 then
			return;
		end
		DataCenter.servantWingTransData:sGetPanelInfo();
	end
end