checkRequire("Lua_ShopItemVo")
Lua_ShopData = class("Lua_ShopData");
Lua_ShopData.weekLimit = 1; -- 每周限购
Lua_ShopData.commonProps = 2; -- 常用道具
Lua_ShopData.growStronger = 3; -- 成长变强
Lua_ShopData.fashionShop = 4; -- 时装外形
Lua_ShopData.bindGoldShop = 5; -- 绑元商城
Lua_ShopData.honorShop = 6; -- 荣誉商城
Lua_ShopData.integralShop = 7; -- 积分商城
Lua_ShopData.prestigeShop = 8; -- 声望商城
function Lua_ShopData:ctor()
	self.activity_active = 0;
	self.left_time = 0;
	self.vip_lvl = 0;
	self._data = 1;
	self.itemList = {};
	self._itemArr = Array();
end

function Lua_ShopData:dispose()
	self.activity_active = 0;
	self.left_time = 0;
	self.vip_lvl = 0;
	self._data = 1;
	self.itemList = {};
	if self.itemArr:getSize() > 0 then
		self.itemArr:clear();
		self.itemArr = nil;
	end
end

function Lua_ShopData:fromServer50100021(msg)
	if msg == nil then
		return;
	end

	self.activity_active = msg.activity_active; -- 是否有商城活动，0：关，1：开
	self.left_time = msg.left_time; -- 剩余时间，单位sec
	self.vip_lvl = msg.vip_lvl; -- 用户当前vip等级(0,1,2,3...)

	if msg.mall_list ~= nil then
		self.itemArr:clear();
		for k, v in ipairs(msg.mall_list) do
			if v.Item_list ~= nil then -- 物品列表
				for key, value in ipairs(v.Item_list) do
					local itemVo = Lua_ShopItemVo.new(value.item_id, value.max_item, value.item_bind);
					itemVo:fromServer(value);
					-- 魅力之王活动特殊处理
					itemVo.isCharmKing = false;
					if DataCenter.charmKingData.isOpen == true and value.item_id == DataCenter.charmKingData.discount_item_id then
						itemVo.curPrice = DataCenter.charmKingData.discount_price;
						itemVo.isCharmKing = true;
					end
					-- 判断等级限制和职业限制，要么0 无职业限制，要么对应职业 1 2 3
					if itemVo.is_show == true and itemVo.shop_career == 0 or itemVo.shop_career == DataCenter.roleData.career then
						self._itemArr:add(itemVo)
					end
				end
				self.itemList[v.shop_type] = self.itemArr;
			end
		end
	end
end

-- 当前商城类型的数据
function Lua_ShopData.Get:itemArr()
	return self._itemArr;
end

function Lua_ShopData.Set:itemArr()
	self._itemArr = Array();
end

function Lua_ShopData.Get:Data()
	return self._data;
end

function Lua_ShopData.Set:Data(val)
	self._data = val;
end

function Lua_ShopData.Set:moneyType(val)
	self._moneyType = val;
end