checkRequire("Lua_SkillDefine");
checkRequire("Lua_SkillVo");
checkRequire("Lua_SkillSuitList");
Lua_SkillData = class("Lua_SkillData");
function Lua_SkillData:ctor()
	self.skillData = {};
	self.suitList = {};
	self.skillToSlotDic = {};
	self.slotToSkillDic = {};
	self.lastCareerTime = 0;
	self._jumpSkill = nil;
	self.initedSkillList = false;
	self.needFloatingSkill = false;
	self.transSkillId = 0;
end

function Lua_SkillData:getSkillSuitList(val)
	local sl = self.suitList[val];
	return sl;
end

function Lua_SkillData:checkSkillUpdate()
	local ssl = self:getSkillSuitList(0);
	if ssl == nil then
		return;
	end

	local canUpdate = false;
	if canUpdate == false then
		local len = ssl.careerSkills:getSize();
		for i=1,len do
			if ssl.careerSkills[i].canUpdate == true then
				canUpdate = true;
				break;
			end
		end
	end

	if canUpdate == false then
		local len = ssl.passiveSkills:getSize();
		for i=1,len do
			if ssl.passiveSkills[i].canUpdate == true then
				canUpdate = true;
				break;
			end
		end
	end

	if canUpdate == false then
		local len = ssl.qiyuanSkills:getSize();
		for i=1,len do
			if ssl.qiyuanSkills[i].canUpdate == true then
				canUpdate = true;
				break;
			end
		end
	end

	if canUpdate then
        DataCenter.redDotData:updateRedDotVoState(11174, true);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11174, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE",true);
    else
        DataCenter.redDotData:updateRedDotVoState(11174, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 11174, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE",false);
    end
end

function Lua_SkillData:findTransSkill()
	return self.skillData[self.transSkillId];
end

function Lua_SkillData:updateSkillData(data)
	self.skillData[data.skillId] = data;
	
	local st = data.defaultSkill;
	if self.suitList[st] == nil then
		self.suitList[st] = Lua_SkillSuitList.new();
	end

	local ssl = self.suitList[st];
	if data.skillType == Lua_SkillDefine.SKILL_TYPE_JUMP then
		ssl.jumpSkill = data;
	elseif data.skillType == Lua_SkillDefine.SKILL_TYPE_CAREER then
		ssl:updateCareerSkill(data);
	elseif data.skillType == Lua_SkillDefine.SKILL_TYPE_ANGRY then
		ssl.angrySkill = data;
	elseif data.skillType == Lua_SkillDefine.SKILL_TYPE_PASSIVE then
		ssl:updatePassiveSkill(data);
	elseif data.skillType == Lua_SkillDefine.SKILL_TYPE_QIYUAN then
		ssl:updateqiyuanSkill(data);
	elseif data.skillType == Lua_SkillDefine.SKILL_TYPE_BASE then
		ssl.baseSkill = data;
	end
end

function Lua_SkillData:initDefaultSlot()
	local suitList = self:getSkillSuitList(0);
	if suitList ~= nil then
		len = suitList.careerSkills:getSize();
		for i=1,len do
			local svo = suitList.careerSkills[i];
			-- svo:hasLearn() == true and
			if self.skillToSlotDic[svo.skillId] == nil then
				for j=1,4 do
					if self.slotToSkillDic[j] == nil then
						self:setSlot(j, svo.skillId);
						break;
					end
				end
			end
		end
	end
end

function Lua_SkillData:clearSlot()
	self.skillToSlotDic = {};
	self.slotToSkillDic = {};
end

function Lua_SkillData:setSlot(slot, skillId)
	self.skillToSlotDic[skillId] = slot;
	self.slotToSkillDic[slot] = skillId;
end

function Lua_SkillData:getSkillSlot(skillId)
	return self.skillToSlotDic[skillId];
end

function Lua_SkillData:getSlotSkill(slot)
	return self.slotToSkillDic[slot];
end

function Lua_SkillData:getSkillData(skillId)
	return self.skillData[skillId];
end

function Lua_SkillData:onSkillUse(val)
	local skillVo = self.skillData[val];
	if skillVo ~= nil then
		if skillVo.skillType == Lua_SkillDefine.SKILL_TYPE_CAREER then
			self.lastCareerTime = UnityEngine.Time.realtimeSinceStartup;
		end
		skillVo:updateUseTime();
		Lua_MsgUtil.callFunc("LUA_SKILL_COOL", val);
	end
end

function Lua_SkillData:findUseSkill()
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local buffVo = DataCenter.roleData:getBuffById(1114);
	if buffVo ~= nil and sceneData.canTransfer == true then
		local skillList = getConfig({"awake","client_Show",buffVo.value1,"skill"});
		local baseSkill = getConfig({"awake","client_Show",buffVo.value1,"base_skill"});
		if skillList ~= nil then
			for i,v in ipairs(skillList) do
				local skillVo = self:getSkillData(v);
				if skillVo ~= nil and skillVo.canUse == true then
					return skillVo;
				end
			end
			local skillVo = self:getSkillData(baseSkill);
			if skillVo ~= nil and skillVo.canUse == true then
				return skillVo;
			end
		end
		return nil;
	end

	if DataCenter.hangUpSettingsData.auto_call_beast == 1 then--自动使用变身技能
		local ts = self:findTransSkill();
		if ts ~= nil and ts.isCool == 0 and sceneData.canTransfer == true then
			return ts;
		end
	end

	local slist = self.suitList[0];
	local len = slist.careerSkills:getSize();
	for i=1,len do
		local skillVo = slist.careerSkills[i];
		if skillVo.canUse == true then
			return skillVo;
		end
	end
	return slist.baseSkill;
end

function Lua_SkillData.Get:jumpSkill()
	if self._jumpSkill == nil then
		self._jumpSkill = Lua_SkillVo.new();
	end
	return self._jumpSkill;
end

function Lua_SkillData:dispose()
	self.skillData = {};
	self.suitList = {};
	self.transSkillId = 0;
end