Lua_SkillSuitList = class("Lua_SkillSuitList");
function Lua_SkillSuitList:ctor()
	self.careerSkills = Array();
	self.passiveSkills = Array();
	self.qiyuanSkills = Array();
end

function Lua_SkillSuitList:reset()
	self.baseSkill = nil;
	self.careerSkills:clear();
	self.passiveSkills:clear();
	self.qiyuanSkills:clear();
	self.angrySkill = nil;
	self.jumpSkill = nil;
end

function Lua_SkillSuitList:updateCareerSkill(val)
	if val.skill_owner ~= 1 then
		return;
	end

	local len = self.careerSkills:getSize();
	for i = 1, len do
		if self.careerSkills[i].skillId == val.skillId then
			local showActiveWin = false;
			if self.careerSkills[i]:hasLearn() == false and val:hasLearn() == true then
				showActiveWin = true;
			end
			
			self.careerSkills[i] = val;
			if getShowTips() and showActiveWin == true and DataCenter.skillData.initedSkillList == true then
				Lua_WindowUtil.openWin("Lua_SkillActiveTipsWindow",WinParam.ACTION_OPEN,val);
				
				DataCenter.hook:stop(true);
				local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
				if rolePlayer ~= nil then
					rolePlayer:stopMove(true,true);
				end
			end
			return;
		end
	end
	self.careerSkills:add(val);
	self.careerSkills:sort("slot", false);
end

function Lua_SkillSuitList:updatePassiveSkill(val)
	if val.skill_owner ~= 1 or val.config.profession == nil then
		return;
	end

	local len = self.passiveSkills:getSize();
	for i = 1, len do
		if self.passiveSkills[i].skillId == val.skillId then
			local showActiveWin = false;
			if self.passiveSkills[i]:hasLearn() == false and val:hasLearn() == true then
				showActiveWin = true;
			end	
			self.passiveSkills[i] = val;
			if getShowTips() and showActiveWin == true and DataCenter.skillData.initedSkillList == true then
				Lua_WindowUtil.openWin("Lua_SkillActiveTipsWindow",WinParam.ACTION_OPEN,val);
			end
			return;
		end
	end
	self.passiveSkills:add(val);
	self.passiveSkills:sort("slot", false);
end

function Lua_SkillSuitList:updateqiyuanSkill(val)
	if val.skill_owner ~= 1 then
		return;
	end

	local len = self.qiyuanSkills:getSize();
	for i = 1, len do
		if self.qiyuanSkills[i].skillId == val.skillId then
			local showActiveWin = false;
			if self.qiyuanSkills[i]:hasLearn() == false and val:hasLearn() == true then
				showActiveWin = true;
			end
			self.qiyuanSkills[i] = val;

			if getShowTips() and showActiveWin == true and DataCenter.skillData.initedSkillList == true then
				Lua_WindowUtil.openWin("Lua_SkillActiveTipsWindow",WinParam.ACTION_OPEN,val);	
			end
			return;
		end
	end
	self.qiyuanSkills:add(val);
	self.qiyuanSkills:sort("slot", false);
end