checkRequire("Lua_SkillData");
checkRequire("Lua_SkillVo");
checkRequire("Lua_SkillDefine");
Lua_SkillProxy = class("Lua_SkillProxy");
function Lua_SkillProxy:ctor()
	DataCenter.skillData = Lua_SkillData.new();

	LuaUtil.addLuaMsg(50400701, self, self.rSkillList);
	LuaUtil.addLuaMsg(80400109, self, self.rAddSkill);
	LuaUtil.addLuaMsg(50400711, self, self.rUpgradeSkill);
	LuaUtil.addLuaMsg(80400502, self, self.rTransferSkill);
end

function Lua_SkillProxy:rSkillList(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400701();
		msg:ParseFromString(mp.data);
		if msg.part ~= 0 then
			return;
		end

		DataCenter.skillData.transSkill = nil;
		local allSkillObj = Lua_SkillDefine.getSkillByCareer(DataCenter.roleData.career);
		if allSkillObj.baseSkill ~= 0 then
			local skillVo = Lua_SkillVo.new(allSkillObj.baseSkill);
			skillVo.skillLevel = 0;
			DataCenter.skillData:updateSkillData(skillVo);
		end

		local len = allSkillObj.actSkills:getSize();
		for i=1,len do
			local skillVo = Lua_SkillVo.new(allSkillObj.actSkills[i]);
			skillVo.skillLevel = 0;
			DataCenter.skillData:updateSkillData(skillVo);
		end

		len = allSkillObj.qiyuanSkills:getSize();
		for i=1,len do
			local skillVo = Lua_SkillVo.new(allSkillObj.qiyuanSkills[i]);
			skillVo.skillLevel = 0;
			DataCenter.skillData:updateSkillData(skillVo);
		end

		len = allSkillObj.passiveSkills:getSize();
		for i=1,len do
			local skillVo = Lua_SkillVo.new(allSkillObj.passiveSkills[i]);
			skillVo.skillLevel = 0;
			DataCenter.skillData:updateSkillData(skillVo);
		end

		for i,v in ipairs(msg.skill_list) do
			local skillVo = DataCenter.skillData:getSkillData(v.skill_id);
			if skillVo == nil then
				skillVo = Lua_SkillVo.new(v.skill_id);
			end
			skillVo:fromServer(v);
			
			if v.use_sec > 0 then
				local clt = v.use_sec - tonumber(tostring(GlobalVar.cur_tick));
				if clt > 0 then
					skillVo:updateCdLeftTime(clt + 2);
				else
					skillVo.lastTime = -9999;
				end
			else
				skillVo.lastTime = -9999;
			end
			DataCenter.skillData:updateSkillData(skillVo);
		end

		DataCenter.skillData:clearSlot();
		for i,v in ipairs(msg.skill_key_map) do
			DataCenter.skillData:setSlot(v.obj_id, v.obj_value);
		end
		DataCenter.skillData:initDefaultSlot();
		DataCenter.skillData.initedSkillList = true;
		DataCenter.skillData:checkSkillUpdate();
		Lua_MsgUtil.callFunc("SKILL_UPDATE");
		Lua_MsgUtil.callFunc("SKILL_SHOW");
		Lua_MsgUtil.callFunc("SKILL_INFO", msg.skill_list);
	end
end

function Lua_SkillProxy:rAddSkill(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400109();
		msg:ParseFromString(mp.data);

		local skillVo = DataCenter.skillData:getSkillData(msg.skill_id);
		if skillVo == nil then
			skillVo = Lua_SkillVo.new(msg.skill.skill_id);
		end

		skillVo:fromServer(msg.skill);
		if msg.skill.use_sec > 0 then
			local pastCdTime = msg.skill.use_sec - tonumber(tostring(GlobalVar.cur_tick));
			skillVo:updateCdLeftTime(pastCdTime);
		end
		DataCenter.skillData:updateSkillData(skillVo);
		
		DataCenter.skillData:initDefaultSlot();
		Lua_MsgUtil.callFunc("SKILL_UPDATE");
		Lua_MsgUtil.callFunc("SKILL_SHOW");
	end
end

function Lua_SkillProxy:rUpgradeSkill(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400711();
		msg:ParseFromString(mp.data);

		local skillVo = DataCenter.skillData:getSkillData(msg.skill_id);
		if skillVo == nil then
			skillVo = Lua_SkillVo.new(msg.skill_id);
		end
		skillVo.skillLevel = msg.skill_level;
		DataCenter.skillData:updateSkillData(skillVo);

		Lua_MsgUtil.callFunc("SKILL_UPDATE_DATA", DataCenter.skillData:getSkillData(msg.skill_id));
		OperateAlert.show(LanUtil.getValue(110630));
	end
end

function Lua_SkillProxy:rTransferSkill(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400502();
		msg:ParseFromString(mp.data);
		DataCenter.skillData.transSkillId = msg.model_skill;
		Lua_MsgUtil.callFunc("TRANS_SKILL_UPDATE_DATA");
	end
end