-- 夺宝大逃杀数据
Lua_SnatchWarData = class("Lua_SnatchWarData");
function Lua_SnatchWarData:ctor()
    self:superCall("ctor");

    self.countDown = 0;
	self.countDownGetTime = 0;
	self.residueTime = 0;
	self.residueTimeGetTime = 0;
end

function Lua_SnatchWarData:dispose()
	self.countDown = 0;
	self.countDownGetTime = 0;
	self.residueTime = 0;
	self.residueTimeGetTime = 0;
end

-- 是否在夺宝大逃杀的场景里
function Lua_SnatchWarData.Get:bInSnatchWarScene()
	if DataCenter.roleData.sceneId == Lua_SnatchWarUtil.snatchWarSceneId
	 or DataCenter.roleData.sceneId == Lua_SnatchWarUtil.kuafu_snatchWarSceneId then
		return true;
	end

	return false;
end

-- 开始倒计时
function Lua_SnatchWarData:fromServerCountDown(num)
	self.countDown = num;
	self.countDownGetTime = getTime();
end

-- 战斗开始倒计时剩余时间
function Lua_SnatchWarData.Get:fightCountDown()
	if self.countDown > 0 then
		return self.countDown - (getTime() - self.countDownGetTime);
	end

	return 0;
end

-- 夺宝大逃杀信息
function Lua_SnatchWarData:fromServerFightingInfo(msg)
	-- msg.wealth_info; -- 宝物信息
    -- msg.left_time; -- 剩余秒数
    self.residueTime = msg.left_time;
    self.residueTimeGetTime = getTime();
    for i, v in ipairs(msg.wealth_info) do
		local vo = self:getSnatchWarGiftVoById(v.id);
		if vo ~= nil then
			vo:updateServerInfo(v);
		end
	end 
end

-- 战斗剩余时间
function Lua_SnatchWarData.Get:fightResidueTime()
	if self.residueTime > 0 then
		return self.residueTime - (getTime() - self.residueTimeGetTime);
	end

	return 0;
end

function Lua_SnatchWarData:getSnatchWarGiftVoById(giftId)
	return DataCenter.snatchWarUtil.snatchWarGiftDic[tonumber(giftId)];
end

function Lua_SnatchWarData.Get:snatchWarGiftArr()
	return DataCenter.snatchWarUtil.snatchWarGiftArr;
end

function Lua_SnatchWarData.Get:curOwnSnatchWarGiftVo()
	local arr = self.snatchWarGiftArr;
	if arr ~= nil then
		local len = arr:getSize();
		for i = 1, len do
			local vo = arr[i];
			local buffVo = DataCenter.roleData:getBuffById(vo.buffId, true);
			if buffVo ~= nil then
				return vo;
			end
		end
	end

	return nil;
end

function Lua_SnatchWarData:checkCanCollectGiftById(monsterId)
	local arr = self.snatchWarGiftArr;
	if arr ~= nil then
		local len = arr:getSize();
		local ap = ThingUtil.instance:getThingById(monsterId);
		if ap == nil then
			return nil;
		end

		local objId = tonumber(ap.data.objId);
		for i = 1, len do
			local vo = arr[i];
			if vo.monster_id == objId then
				if vo.canCollect == false then
					return LanUtil.formateStr(LanUtil.getValue(123109), vo.giftName);
				end
			end
		end
	end

	return nil;
end