-- 夺宝大逃杀
checkRequire("Lua_SnatchWarData")
checkRequire("Lua_SnatchWarUtil")
Lua_SnatchWarProxy = class("Lua_SnatchWarProxy");
function Lua_SnatchWarProxy:ctor()
    DataCenter.snatchWarData = Lua_SnatchWarData.new();
    DataCenter.snatchWarUtil = Lua_SnatchWarUtil.new();

    LuaUtil.addLuaMsg(50407001, self, self.rEnterSnatchWarScene);	    -- 请求进入夺宝大逃杀(返回)
    LuaUtil.addLuaMsg(50407002, self, self.rExchangeGift);	    -- 兑换奖励(返回)

    LuaUtil.addLuaMsg(80407001, self, self.rSnatchWarInfo);	    -- 战斗信息
    LuaUtil.addLuaMsg(80407002, self, self.rSnatchWarLeftSec);	    -- 倒计时通知

    Lua_MsgUtil.addEventListener("SNATCHWAR_TASKNPC_CLICK", self, self.openSnatchWarTaskWin);
end

function Lua_SnatchWarProxy:openSnatchWarTaskWin(obj)
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local npcData = sceneData:findNpcById(tonumber(obj));
	Lua_WindowUtil.openWin("Lua_SnatchWarTaskWindow", WinParam.ACTION_OPEN, {npc = npcData});
end

-----------------------------------------------------
-- 上行协议

-- 请求进入夺宝大逃杀
function Lua_SnatchWarProxy:sEnterSnatchWarScene()
	sendMsg(10407001);
end

-- 兑换奖励
function Lua_SnatchWarProxy:sExchangeGift(giftId)
	local cmd = ProtoPublic_pb.Proto10407002();
    cmd.id = giftId;   -- 请求的页数
    sendMsg(10407002, cmd);
end

-- 退出场景
function Lua_SnatchWarProxy:sExitScene()
	sendMsg(10400902);
end



-----------------------------------------------------
-- 下行协议

-- 请求进入夺宝大逃杀(返回)
function Lua_SnatchWarProxy:rEnterSnatchWarScene(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_SnatchWarWindow", WinParam.ACTION_CLOSE, nil);
        Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
	end
end

-- 兑换奖励(返回)
function Lua_SnatchWarProxy:rExchangeGift(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50407002();
        msg:ParseFromString(mp.data);
        -- msg.ret; -- 0 成功 其他错误号
        -- msg.id; --
        if msg.ret == 0 then
        	OperateAlert.show(LanUtil.getValue(123107));
        end
	end
end

-- 战斗信息
function Lua_SnatchWarProxy:rSnatchWarInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80407001();
        msg:ParseFromString(mp.data);
        -- msg.wealth_info; -- 宝物信息
        -- msg.left_time; -- 剩余秒数
        DataCenter.snatchWarData:fromServerFightingInfo(msg);
        Lua_MsgUtil.callFunc("rSnatchWarInfo");
	end
end

-- 倒计时通知
function Lua_SnatchWarProxy:rSnatchWarLeftSec(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80407002();
        msg:ParseFromString(mp.data);
        -- msg.left_sec; -- 剩余秒数
        DataCenter.snatchWarData:fromServerCountDown(msg.left_sec);
        Lua_MsgUtil.callFunc("rSnatchWarLeftSec");
	end
end