--魂印数据类
checkRequire("Lua_StampHolesVo") -- 槽位vo
checkRequire("Lua_StampHolyVo")  -- 圣印vo
Lua_StampData = class("Lua_StampData");
function Lua_StampData:ctor()
    self:superCall("ctor");

    self.stampHolesInfo = {};
    self.stamp_crystal = 0;-- 晶魄
    self.select_color = 2; -- 默认选择色值
    self.select_order = 2; -- 默认选择品阶
    self.intensifyIndex = 1; --强化索引
    self.isAutoStampResolve = 0; -- 自动分解标识
end

function Lua_StampData:dispose()
    self.stampHolesInfo = {};
    self.stamp_crystal = 0;
    self.select_color = 2;
    self.select_order = 2;
    self.intensifyIndex = 1;
    self.isAutoStampResolve = 0;

    if self.stampHolyInfo ~= nil then
        self.stampHolyInfo:clear();
        self.stampHolyInfo:dispose();
    end
end

-- 孔位信息
function Lua_StampData:fromServerHoldsInfo(msg)
    if msg == nil then
        return;
    end
    self.msg = msg;

    local part = 0;
    local list = msg.soul_imprint_info;
    for k, v in ipairs(list) do
        for i,j in ipairs(v.part_info) do
            part = part+1
            local vo = Lua_StampHolesVo.new();
            vo:formServer(j);
            self.stampHolesInfo[tonumber(vo.stamp_part)] = vo;
        end
    end

    self.stampHolyInfo = Array();
    self.stampHolyInfo:clear();
    local divine_soul = msg.divine_soul; -- 圣魂
    for i,v in ipairs(divine_soul) do
        local vo = Lua_StampHolyVo.new();
        vo:formServer(v);
        self.stampHolyInfo:add(vo);
    end
end

function Lua_StampData.Get:getServerSuitList() -- 获得套装id数组
    local _list = {};
    if self.msg == nil then
        return _list;
    end
    local list = self.msg.suit_key;

    for i,v in ipairs(list) do
        if v ~= 0 then 
            local prop = getConfig({"soul_imprint_suit",v,"suit_prop"});
            _list[prop] = 1;
        end
    end
    
    return _list;
end

function Lua_StampData:getArrByStampInfo(groove_id)--通过槽号 获取vo
    if self.stampHolesInfo[tonumber(groove_id)] == nil then
        return nil;
    end
    if self.stampHolesInfo[tonumber(groove_id)].stamp_id ~= 0 then
        return self.stampHolesInfo[tonumber(groove_id)];
    end

    return nil;
end

function Lua_StampData:isUnlockStamp(groove_id)--通过槽号 是否解锁
    if self.stampHolesInfo[tonumber(groove_id)].stamp_id == 0 and self.stampHolesInfo[tonumber(groove_id)].unlock == 1  then
        return true;
    end

    return false;
end

function Lua_StampData:getStampIntensifyData()--强化数据
    local arr = Array();
    local info = self.stampHolesInfo;
    for k,v in pairs(info) do
        if v.stamp_id ~=nil and v.stamp_id ~= 0 then
            arr:add(v);
        end
    end

    local len = arr:getSize()
    for i = 1, len do
        for j = i + 1, len do
            local a = arr[i];
            local b = arr[j];
            if a.intensifyVo.intensify_lvl == a.intensifyVo.max_intensify_lvl and b.intensifyVo.intensify_lvl ~= b.intensifyVo.max_intensify_lvl then
                local temp = arr[i]
                arr[i] = arr[j]
                arr[j] = temp
            end
        end
    end

    return arr;
end

function Lua_StampData:getIntensifyIndex(part)--魂印在强化列表的索引--用于打开强化列表对应魂印
    local arr = self:getStampIntensifyData();

    for i=1,arr:getSize() do
        if arr[i].stamp_part == part then
            return i;
        end
    end
end

function Lua_StampData.Get:getShowAllAtt()--属性总览
    local str = "";
    if self.msg ~= nil then
        local attr = self.msg.prop_map;
        self.arr = Array();
        for i,v in ipairs(attr) do
            if v.obj_value ~= 0 then
                self.arr:add(i)
                local s = getConfig( { "attr_name2", v.obj_id});
                if str == "" then
                    str = "";
                else
                    str = str.."\n";
                end

                local _s = LanUtil.formateStr(s, tostring("[00E125]"..v.obj_value.."[-]"));
                str = str.."[B1CAF4]".._s.."[-]";
            end
        end
    end
    return str;  
end

function Lua_StampData.Get:getStampAllForce()--获得魂印穿戴总战力
    if self.msg == nil then
        return 0;
    end
    local list = self.msg.prop_map;
    local force = {};
    for i,v in ipairs(list) do
        if v.obj_value ~= 0 then
            -- print("v.obj_id   =-= ",v.obj_id,"    ",v.obj_value)
            force[tonumber(v.obj_id)] = v.obj_value;
        end   
    end

    return Lua_FightUtil.caculateForce(force);
end



function Lua_StampData:onResolveTipsClick(data,bool) -- 背包魂印Tips分解
    self.arr = Array();
    local list = {}
    list.id = data.id;
    list.index = data.index;
    self.arr:add(list)
    if bool == true then
        local tipData = {};
        tipData.des = LanUtil.getValue(128527)
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.onSubCallback;
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    else
        Lua_ProxyManager.getProxy("Lua_StampProxy"):sResolveStamp(self.arr);
    end
end

function Lua_StampData:onSubCallback()
    Lua_ProxyManager.getProxy("Lua_StampProxy"):sResolveStamp(self.arr);
end

function Lua_StampData:onDismantleTipsClick(data)--背包灵魂Tips 拆解
    if data == nil then
        return;
    end
    self._data = data;
    local stamp_name = DataCenter.stampUtil:getStampNmae(data.id); --获得拆解魂印
    local item_name = DataCenter.stampUtil:getItemNmae(data.id); --获得拆解材料
    local tipData = {};
    tipData.des = LanUtil.formateStr(LanUtil.getValue(128543),tostring(data.colorName),tostring(stamp_name),tostring(item_name));
    tipData.owner = self;
    tipData.type = 1;
    tipData.titleName = LanUtil.getValue(124443);
    tipData.showHint = LanUtil.getValue(128544);
    tipData.subFun = self.onDismantleClick;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_StampData:onDismantleClick()
    Lua_ProxyManager.getProxy("Lua_StampProxy"):sDisassemStamp(self._data);
end

----------------------------------------------------------------------------------------------------------------------------------------
-- 红点处理

-- 主界面  变强  红点  检测
function Lua_StampData:checkStampRedDotSate()
    if self:isShowStampHolyRed() == true then -- 圣魂
        self:isShowHolyIconRed(true);
    else
        self:isShowHolyIconRed(false);
    end

    if self:isShowStampResolveRed() == true then -- 分解
        self:isShowResolveIconRed(true);
    else
        self:isShowResolveIconRed(false);
    end

    if self:isShowStampIntensifyRed() == true then -- 强化
        self:isShowIntensifyIconRed(true);
    else
        self:isShowIntensifyIconRed(false);
    end

    if self:isShowStampCompoundRed() == true then -- 合成
        self:isShowCompoundIconRed(true);
    else
        self:isShowCompoundIconRed(false);
    end

    if self:isShowStampDressRed() == true then -- 穿戴
        self:isShowDressIconRed(true);
    else
        self:isShowDressIconRed(false);
    end

    if self:isShowStampReplaceRed() == true then -- 替换
        self:isShowReplaceIconRed(true);
    else
        self:isShowReplaceIconRed(false);
    end
end

function Lua_StampData:isShowStampHolyRed() -- 界面圣魂按钮 红点显隐
    local arr = self.stampHolyInfo;
    if arr == nil then
        return false;
    end
    for i=1,arr:getSize() do
        if arr[i].isShowHolyUpgradeRed == true then
            return true;
        end
    end

    return false;
end

function Lua_StampData:isShowStampResolveRed() -- 界面分解按钮 红点显隐
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK); --魂印 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});
    
    for i=1,arr:getSize() do
        if (arr[i].color <= 2 and arr[i].order <=2) or arr[i].stamp_type == 0 then
            return  true;
        end
    end

    return false;
end

function Lua_StampData:isShowStampIntensifyRed() -- 界面强化按钮 红点显隐
    local arr = self:getStampIntensifyData();

    for i=1,arr:getSize() do
        if arr[i].intensifyVo.isCanIntensify == true then
            return true;
        end
    end

    return false;
end

function Lua_StampData:isShowStampCompoundRed() -- 界面合成按钮 红点显隐
    local info = DataCenter.stampUtil.getCalssConfigInfo;

    for k,v in pairs(info) do
        local vo = DataCenter.stampUtil:getArrByClassId(k);
        for i=1,vo:getSize() do
            if vo[i].isShowCompoundRed == true then
                return true;
            end
        end
    end

    return false;
end



function Lua_StampData:isShowStampDressRed() -- 主界面 是否有可穿戴  红点处理
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK); --魂印 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});

    if arr:getSize() <= 0 then
        return false;
    end

    for i=1,arr:getSize() do
        if arr[i].stamp_type ~= 0 then
            local isUnlockStamp = self:isUnlockStamp(arr[i].part);
            if arr[i].isSameType == false and isUnlockStamp == true and DataCenter.roleData.level >= arr[i].useLvl then
                return true;
            end
        end
    end

    return false;
end

function Lua_StampData:isShowStampReplaceRed() -- 主界面 是否有可替换  红点处理
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK); --魂印 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});

    if arr:getSize() <= 0 then
        return false;
    end

    for i=1,arr:getSize() do
        if arr[i].stamp_type ~= 0 then
            local vo = self:getArrByStampInfo(arr[i].part);
            if vo ~= nil then
                if arr[i].force > vo.stampVo.stampBascForce and DataCenter.roleData.level >= arr[i].useLvl then
                    return true;
                end
            end
        end
    end

    return false;
end


----------------------------------------------------------------------------------------------------------------------------------------
-- 变强处理

function Lua_StampData:isShowHolyIconRed(bool) -- 圣魂 变强事件 
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22024, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22024, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22024, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22024, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", 22024);
    end
end

function Lua_StampData:isShowResolveIconRed(bool) -- 分解 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22025, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22025, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22025, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22025, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_StampData:isShowIntensifyIconRed(bool) -- 强化 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22026, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22026, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22026, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22026, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_StampData:isShowCompoundIconRed(bool) -- 合成 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22027, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22027, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22027, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22027, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_StampData:isShowDressIconRed(bool) -- 可穿戴 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22028, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22028, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22028, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22028, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end

function Lua_StampData:isShowReplaceIconRed(bool) -- 可替换 变强事件
    if bool == true then
        DataCenter.redDotData:updateRedDotVoState(22029, true);--客户端主动添加红点事件
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22029, val = 1, bShow = true});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);--变强事件
    else
        DataCenter.redDotData:updateRedDotVoState(22029, false);
        Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 22022, val = 0, bShow = false});
        Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
    end
end