-- 魂印位置信息
Lua_StampHolesVo = class("Lua_StampHolesVo")
function Lua_StampHolesVo:ctor()
    self:superCall("ctor");
end

function Lua_StampHolesVo:formServer(obj)
	if obj == nil then
		return;
	end

	self.stamp_part = obj.part;      -- 部位 从1开始
    self.stamp_id = obj.id;          -- 魂印ID
    self.intensify_lvl = obj.level;  -- 魂印强化等级
    self.unlock = obj.unlock;        -- 解锁状态1解锁0未
    self.schedule = obj.schedule;    -- 进度
    self.bind = obj.bind;
end

function Lua_StampHolesVo.Get:stampVo()
	if self.stamp_id ~= nil and self.stamp_id ~= 0 then
		local vo = Lua_ToolVo.createToolVo(self.stamp_id,1,self.bind);
		vo.stamp_part = self.stamp_part;
        vo.isStamp = 0
		if self.intensify_lvl > vo.max_intensify_lvl then
			self.intensify_lvl =  vo.max_intensify_lvl;
		end
		vo.intensify_lvl = self.intensify_lvl;
		return vo;
	end
	return nil;
end

function Lua_StampHolesVo.Get:intensifyVo()
	if self.stamp_id ~= nil and self.stamp_id ~= 0 then
		local vo = Lua_ToolVo.createToolVo(self.stamp_id,1,self.bind);
		vo.stamp_part = nil;
		vo.packType = 999;
		if self.intensify_lvl > vo.max_intensify_lvl then
			self.intensify_lvl =  vo.max_intensify_lvl;
		end
		vo.intensify_lvl = self.intensify_lvl;
		return vo;
	end
	return nil;
end

function Lua_StampHolesVo.Get:getOpenLvl() -- 开启等级
	local lvl_unlock = getConfig({"soul_imprint_part", self.stamp_part, "lvl_unlock"});
	if lvl_unlock == nil then
		return "";
	end
	return LanUtil.formateStr(LanUtil.getValue(141022), tostring(lvl_unlock));
end
---------------------------------------------------------------------------------------------------------------------------------------
-- Item 魂印 红点

--魂印界面 穿戴 红点处理
function Lua_StampHolesVo.Get:isShowStampDressRed()

    if self.unlock == 0 then
    	return false;
    end

    if self.unlock == 1 and self.stamp_id == 0 and self.isHaveCommonStamp == true  then
    	return true;
    end

    return false;
end

function Lua_StampHolesVo.Get:isHaveCommonStamp()--背包 是否拥有同部位魂印
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK);
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});

    if arr:getSize() <= 0 then
        return false;
    end

    for i=1,arr:getSize() do
        if arr[i].part == self.stamp_part and DataCenter.roleData.level >= arr[i].useLvl then
            return true;
        end
    end

    return false;
end

function Lua_StampHolesVo.Get:isShowStampReplaceRed() -- 替换  红点处理
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK); --魂印 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});

    if arr:getSize() <= 0 then
        return false;
    end

    if self.stamp_id == 0 then
    	return false;
    end

    for i=1,arr:getSize() do
        if arr[i].stamp_type ~= 0 then
           	if arr[i].part == self.stamp_part then
                if arr[i].force > self.stampVo.stampBascForce and DataCenter.roleData.level >= arr[i].useLvl then
                    return true;
                end
            end
        end
    end

    return false;
end