-- 圣魂信息
Lua_StampHolyVo = class("Lua_StampHolyVo")
function Lua_StampHolyVo:ctor()
    self:superCall("ctor");
end

function Lua_StampHolyVo:formServer(obj)
	if obj == nil then
		return;
	end

    self.holy_id = obj.obj_id;          -- 圣印 ID
    self.holy_lvl = obj.obj_value;      -- 当前 值
end

function Lua_StampHolyVo.Get:itemVo() -- vo
	local vo = Lua_ToolVo.createToolVo(self.item_id);
	return vo;
end

function Lua_StampHolyVo.Get:stampHolyConfig() -- 圣印配置
    local config = getConfig({"divine_soul", self.holy_id});
    if config == nil then
    	return;
    end
    return config;
end

function Lua_StampHolyVo.Get:item_id() -- 使用消耗道具
	local cost = self.stampHolyConfig.cost;
    return tonumber(cost[1]);
end

function Lua_StampHolyVo.Get:pack_item_num() -- 背包拥有道具 数量
    local num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.item_id);
    if num == nil then
    	num = 0;
    end
    return num;
end

function Lua_StampHolyVo.Get:cost_item_num() -- 使用消耗道具 数量
    local cost = self.stampHolyConfig.cost;
    return tonumber(cost[2]);
end

function Lua_StampHolyVo.Get:isCanUpgrade() -- 是否可以升级
    if self.pack_item_num >= self.cost_item_num then
    	return true;
    end

    return false;
end

function Lua_StampHolyVo.Get:getIndex() -- 得到使用区间索引
	local list = self.stampHolyConfig.lvl_limit;
	local lvl = DataCenter.roleData.level;
	for i=1, #list do
		if list[i][1] <= lvl and lvl <= list[i][2] then
			return i;
		end
	end

	return #list;
end

function Lua_StampHolyVo.Get:getOpenLvl() -- 下阶 使用等级
	local list = self.stampHolyConfig.lvl_limit;
	if list[self.getIndex + 1] == nil then
		return nil;
	else
		return list[self.getIndex + 1][1];
	end
end

function Lua_StampHolyVo.Get:getOpenNum() -- 使用数量
	local list =self.stampHolyConfig.lvl_limit;
	if list == nil then
		return;
	end
	return list[self.getIndex][3];
end

function Lua_StampHolyVo.Get:isMaxLvl() -- 是否到达上限
    local list =self.stampHolyConfig.lvl_limit;
    if list[self.getIndex +1] == nil and self.holy_lvl >= self.getOpenNum then
        return true;
    end

    return false;
end

function Lua_StampHolyVo.Get:isMaxNum() -- 使用数量 是否到达上限
    if self.holy_lvl >= self.getOpenNum then
        return true;
    end

    return false;
end


function Lua_StampHolyVo.Get:isShowHolyUpgradeRed() -- 升级 红点处理 
    if self.isCanUpgrade == true and self.isMaxNum == false then
    	return true;
    end

    return false;
end

function Lua_StampHolyVo.Get:prop_id() -- 属性链id
    return self.stampHolyConfig.prop_id;
end

function Lua_StampHolyVo.Get:stampHolyProp() -- 圣印基础属性封装
    local str = "";
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_imprint_prop", self.prop_id, v});
        if val ~= nil and Lua_ThingDefine.isStampParam(v) ~= true then
            if str == "" then
                str = "";
            else
                str = str.."  ";
            end
            local base = val[1]*self.holy_lvl;
            if Lua_ThingDefine.isPercentParam(v) then
                base = base.."%";
            end
            local s = Lua_ThingDefine.getParamName(v).."+"..base;

            str = str..s;
        end
    end
    return str;
end

function Lua_StampHolyVo.Get:stampSpecialProp() -- 圣印特殊属性封装
    local str = "";
    local is_special = true;
    for k,v in ipairs(Lua_ThingDefine.params) do
        local val = getConfig({"soul_imprint_prop", self.prop_id, v});
        if val ~= nil and Lua_ThingDefine.isStampParam(v) == true and is_special == true then
        	is_special = false;
            if str == "" then
                str = "";
            else
                str = str.."  ";
            end
            
            local base;
            local s;
            if self.stampHolyConfig.is_special == 1 then
            	base = LanUtil.formateStr(LanUtil.getValue(128532), tostring(val[1] * self.holy_lvl));
            	s = base;
            else
	            base = val[1] * self.holy_lvl;
	            s = Lua_ThingDefine.getParamName(v).."+"..base.."%";
	        end

            str = str..s;
        end
    end
    return str;
end