--魂印

checkRequire("Lua_StampData");
checkRequire("Lua_StampUtil");
Lua_StampProxy = class("Lua_StampProxy");
function Lua_StampProxy:ctor()
	self:superCall("ctor");
    DataCenter.stampData = Lua_StampData.new();
    DataCenter.stampUtil = Lua_StampUtil.new();
	
	LuaUtil.addLuaMsg(51403401, self, self.rOpenStampPanelInfo); -- 获取魂印界面信息（返回）
    LuaUtil.addLuaMsg(51403403, self, self.rUpgradeStampHoly);   -- 圣魂升级（返回）
    LuaUtil.addLuaMsg(51403407, self, self.rResolveStamp);       -- 魂印分解（返回）
    LuaUtil.addLuaMsg(51403405, self, self.sCompoundStampState);--合成灵纹
    LuaUtil.addLuaMsg(51403404, self, self.sIntensifyStampState);-- 强化特效
end

-----------------------------------------------------------------------------------
-- 上行消息号 
-- 获取魂印界面信息
function Lua_StampProxy:sOpenStampPanelInfo()
    sendMsg(11403401);
end

-- 圣魂升级
function Lua_StampProxy:sUpgradeStampHoly(id)
    local cmd = ProtoPublic_pb.Proto11403403();
    cmd.divine_type = tonumber(id);     --道具ID
    sendMsg(11403403,cmd);
end

-- 圣魂背包自动分解
function Lua_StampProxy:sAutoResolveStamp(status)
    local cmd = ProtoPublic_pb.Proto11403410();
    -- print("  圣魂背包自动分解   = =  ",status)
    cmd.auto_decomp_state = status;-- 0关，1开
    sendMsg(11403410, cmd);
end

-- 魂印镶嵌
function Lua_StampProxy:sInlayStamp(item_id, index)
    local cmd = ProtoPublic_pb.Proto11403402();
    cmd.item_id = tonumber(item_id);     --道具ID
    cmd.index =tonumber(index);          --背包索引
    sendMsg(11403402, cmd);
end

-- 魂印分解
function Lua_StampProxy:sResolveStamp(list)
    local cmd = ProtoPublic_pb.Proto11403407();
    local len = list:getSize();
    for i = 1, len do
        local item = ProtoPublic_pb.ProtoDecomposeSoul();
        item.pkg_index = list[i].index;
        item.item_id = list[i].id;
        cmd.item_list:addToList(item);
    end
    sendMsg(11403407, cmd);
end

-- 魂印强化
function Lua_StampProxy:sIntensifyStamp(part,type)
    local cmd = ProtoPublic_pb.Proto11403404();
    cmd.part = tonumber(part);          --槽号
    cmd.type = tonumber(type);  
    sendMsg(11403404, cmd);
end

-- 魂印合成
function Lua_StampProxy:sCompoundStamp(item_id,list)
    local cmd = ProtoPublic_pb.Proto11403405();
    cmd.item_id = item_id;          --id
    if list ~= nil then
        local len = list:getSize();
        for i = 1, len do
            local cost_item = ProtoPublic_pb.ProtoThreeObj();
            cost_item.id = list[i].id;       -- 道具id
            cost_item.value = list[i].index; -- 背包索引
            cost_item.sub = list[i].packType; -- 背包索引
            
            cmd.cost_item:addToList(cost_item);
        end
    end
    sendMsg(11403405, cmd);
end

-- 魂印卸下
function Lua_StampProxy:sUnloadStamp(part,type)
    local cmd = ProtoPublic_pb.Proto11403406();
    cmd.part_id = tonumber(part);       --槽号
    cmd.type = tonumber(type);          --卸下的类型
    sendMsg(11403406, cmd);
end

-- 魂印拆解
function Lua_StampProxy:sDisassemStamp(data)
    local cmd = ProtoPublic_pb.Proto11403408();
    local item = ProtoPublic_pb.ProtoDecomposeSoul();
    item.pkg_index = data.index;
    item.item_id = data.id;
    cmd.item_list:addToList(item);
    sendMsg(11403408, cmd);
end

-- 魂印替换
function Lua_StampProxy:sReplaceStamp(item_id, index)
    local cmd = ProtoPublic_pb.Proto11403409();
    cmd.item_id = tonumber(item_id);     --道具ID
    cmd.index =tonumber(index);          --背包索引
    sendMsg(11403409, cmd);
end
-----------------------------------------------------------------------------------
-- 下行消息
-- 获取魂印面板信息（返回）
function Lua_StampProxy:rOpenStampPanelInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403401();
        msg:ParseFromString(mp.data);
        -- print("自动分解状态   = =",msg.decomp_type);
        DataCenter.stampData.stamp_crystal = msg.crystal_spirit;   -- 晶魄
        DataCenter.stampData.isAutoStampResolve = msg.auto_decomp_state; -- 自动分解状态 0关 1开
        DataCenter.stampData:fromServerHoldsInfo(msg);

        -- 更新 魂印主界面红点
        DataCenter.stampData:checkStampRedDotSate();
        Lua_MsgUtil.callFunc("UPDATE_STAMP_INFO");
    end
end

-- 魂印分解（返回）
function Lua_StampProxy:rResolveStamp(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403407();
        msg:ParseFromString(mp.data);
        --DataCenter.cardData.fragment = msg.fragment;--器源碎片
        Lua_MsgUtil.callFunc("RESOLVE_STAMP_INFO");
    end
end

-- 圣魂升级（返回）
function Lua_StampProxy:rUpgradeStampHoly(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403403();
        msg:ParseFromString(mp.data);
    end
end

-- 获取合成后是否成功（返回）
function Lua_StampProxy:sCompoundStampState(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403405();
        msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("IS_SUCCEED_STAMP_STATE",msg.state);--是否成功
    end
end

-- 获取 强化后是否成功（返回）
function Lua_StampProxy:sIntensifyStampState(mp) 
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51403404();
        msg:ParseFromString(mp.data);
        --print("获取 强化后是否成功（返回")
        Lua_MsgUtil.callFunc("UPDATE_INTENS_STAMP");--是否成功
    end
end