--魂印合成VO

Lua_StampCompoundVo = class("Lua_StampCompoundVo")
function Lua_StampCompoundVo:ctor(id,value)
	self.id = id;
	if value == nil  then
		self.config = getConfig( { "soul_imprint_compose", id });
	else
		self.config = value;
	end 
end

function Lua_StampCompoundVo.Get:stamp_class_id() -- 合成类 id
    return self.config.stamp_class_id;
end

function Lua_StampCompoundVo.Get:stamp_group_id() -- 合成组 id
    return self.config.stamp_group_id;
end


function Lua_StampCompoundVo.Get:cost_item()--合成 道具 --索引1 为合成材料
    return self.config.cost_item;
end

function Lua_StampCompoundVo.Get:probability() -- 合成概率
    return self.config.probability;
end

function Lua_StampCompoundVo.Get:materials_num() --合成材料 消耗数量
	return self.cost_item[1][2];
end

function Lua_StampCompoundVo.Get:materials_have_num() --合成材料 拥有数量
    return DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.cost_item[1][1]);
end

function Lua_StampCompoundVo.Get:materials_vo() --合成材料 vo
	local vo = Lua_ToolVo.createToolVo(self.cost_item[1][1]);
    vo.packType = 999;
	return vo;
end

function Lua_StampCompoundVo.Get:item_vo()--合成道具VO
	local vo = Lua_ToolVo.createToolVo(self.id);
    vo.packType = 999;
	return vo;
end

function Lua_StampCompoundVo.Get:cost_item_vo()--消耗魂印 vo
    local arr = self.cost_item;
    local _arr = Array();
    if arr ~= nil then
        for i=1,#arr do
            if i > 1 then
                local tvo = Lua_ToolVo.createToolVo(arr[i][1]);
                tvo.packType = 999;
                tvo.bagNum = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK):getItemNum(arr[i][1]);
                tvo.needNum = arr[i][2];
                _arr:add(tvo);
            end
        end

        return _arr;
    end
    return nil;
end

function Lua_StampCompoundVo.Get:getCompoundItemArr() -- 多属性合成 
    local _arr = Array();
    local arr = self.cost_item
    local len = #arr;
    for i=1,len do
        if i == 1 then
            local list = self:getItemIndex(arr[i][1]);
            for k,v in pairs(list) do
                _arr:add({id = arr[i][1], index = v, packType = Lua_PackData.BAG_PACK});
            end
            
        else
            local num = arr[i][2];
            local list = self:getMixForeItem(arr[i][1]);
            for j=1,num do
                _arr:add({id = arr[i][1], index = list[j].index, packType = Lua_PackData.STAMP_PACK});
            end
        end
    end
    return _arr;
end

function Lua_StampCompoundVo:getItemIndex(id) -- 获得材料 道具索引
    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);--聚魂
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_SOUL});
    local len = arr:getSize();
    local list = {}
    for i=1,len do
        if arr[i].id == id  then          
            list[i] = arr[i].index;
        end
    end
    return list;
end

function Lua_StampCompoundVo:getMixForeItem(id) -- 获得最低战力道具
    local stampArr = Array();
    local bagData = DataCenter.packData:getBagType(Lua_PackData.STAMP_PACK);--聚魂
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.STAMP_ITEM});
    local len = arr:getSize();

    for i=1,len do
        if arr[i].id == id then          
            stampArr:add(arr[i])
        end
    end

    stampArr:sort("force",false);

    return stampArr;
end

function Lua_StampCompoundVo.Get:isShowCompoundRed()--合成红点

    local arr = self.cost_item_vo;
    local isRed = true;
    for i=1,arr:getSize() do
        if arr[i].bagNum < arr[i].needNum then
            isRed = false;
        end
    end
    if isRed == true and self.materials_have_num >= self.materials_num then
        return true;
    end

    return false;
end