-- 套装信息
Lua_StampSuitVo = class("Lua_StampSuitVo")
function Lua_StampSuitVo:ctor(id,value)
	self.id = id;
	if value == nil  then
		self.stampSuitConfig = getConfig({"stampSuit", id});
	else
		self.stampSuitConfig = value;
	end
end

-- 属性链id
function Lua_StampSuitVo.Get:suit_prop()
	return self.stampSuitConfig.suit_prop;
end

-- 套装数量
function Lua_StampSuitVo.Get:suit_amount()
	return self.stampSuitConfig.suit_amount;
end

-- 套装名字
function Lua_StampSuitVo.Get:suit_name()
	local other_name = self.stampSuitConfig.other_name;
	local color = self.stampSuitConfig.color;
	local colorStr =Lua_ColorDefine.getItemColorStr(color);
	return "[" .. colorStr .. "]" .. other_name .. "[-]";
end

-- 套装名字
function Lua_StampSuitVo:name(isSuit)
	local other_name = self.stampSuitConfig.other_name;
	local num = self.suit_adorn_num;
	if isSuit ~= nil then --套装总览展示魂印标识
		num = 0;
	end
	return other_name.." ("..num.."/"..self.suit_max_num..")";
end

-- 套装最大数量
function Lua_StampSuitVo.Get:suit_max_num()
	return #self.stampSuitConfig.item_list;
end

-- 激活 套装 索引
function Lua_StampSuitVo.Get:suit_index()
	local num = self.suit_adorn_num;
	local suit_amount = self.suit_amount;
	local index = 0;
	for k,v in pairs(suit_amount) do
		if v <= num then
			index = k;
		end
	end
	return index;
end

-- 是否是套装ID
function Lua_StampSuitVo:isSuitItem(id)
	if self.getSuitList[id] == 1 then
		return true;
	end
	return false;
end

-- 服务端套装索引
function Lua_StampSuitVo.Get:getServerSuitIndex()
	local item_list = self.suit_prop;
	local list = DataCenter.stampData.getServerSuitList;
	local index = 0;
	for k,v in ipairs(item_list) do
		if list[v] == 1 then
			index = k;
		end
	end
	-- print("服务端套装索引：",index);
	return index;
end

-- 服务端套装数量
function Lua_StampSuitVo.Get:getServerSuitNum()
	if self.getServerSuitIndex == 0 then
		return 0;
	end
	return self.suit_amount[self.getServerSuitIndex];
end

-- 套装穿戴数量
function Lua_StampSuitVo.Get:suit_adorn_num()
	local info = DataCenter.stampData.stampHolesInfo;
	local item_list = self.getSuitList;
	local num = 0;
	for k,v in pairs(info) do
		if v.stamp_id ~= 0 then
			if item_list[v.stamp_id] == 1 then
				num = num + 1;
			end
		end
	end

	if self.getServerSuitNum > num then
		return self.getServerSuitNum;
	else
		return num;
	end
end

-- 套装ID标记
function Lua_StampSuitVo.Get:getSuitList()
	local item_list = self.stampSuitConfig.item_list;
	local info = {};
	for k,v in ipairs(item_list) do
		info[v] = 1;
	end
	return info;
end

-- 套装魂印
function Lua_StampSuitVo.Get:stampSuitinfo()
	local item_list = self.stampSuitConfig.item_list;
	local suitinfo = {};
	for k, v in pairs(item_list) do
			local vo = Lua_ToolVo.createToolVo(v);
		vo.isSuit = true;
		vo.packType = 999;
		suitinfo[vo.part] = vo;
	end
	return suitinfo;
end

-- 获得套装总战力
function Lua_StampSuitVo.Get:getSuitAllForce()
	local list = self.suit_prop;
	local num = 0;
	local _force = 0;
	local all_force = 0;
	for k,v in pairs(list) do
		local force = {};
		local stamp_force = 0;
		for i,j in ipairs(Lua_ThingDefine.params) do
			local val = getConfig({"soul_imprint_prop", v, j});
			if val ~= nil then
				force[j] = val[1];
				if Lua_ThingDefine.isStampParam(j) then
					local _num = self:getSuitTypeForce(j,val[1]);
					stamp_force = stamp_force + _num;
				end
			end
		end

		num = num + Lua_FightUtil.caculateConfigForce(force);
		_force = _force + stamp_force
	end

	all_force = num + _force;
	return all_force;
end

function Lua_StampSuitVo.Get:getSuitAllProp() -- 套装属性封装
	local _str = "";
	local list = self.suit_prop;
	for k,v in pairs(list) do
		if _str == "" then
			_str = "";
		else
			_str = _str.."\n";
		end
		_str = _str..self:getSuitProp(v, k)
	end
	return _str;
end

function Lua_StampSuitVo:getSuitProp(prop_id,index) -- 单个套装属性封装
	local str = "";
	local force = {};
	local stamp_force = 0;
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", prop_id, v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end

			local color = "[FFFFFF]";
			if index <= self.suit_index then
				color = "[00E125]";
			end

			local base = val[1];
			force[v] = base;
			if Lua_ThingDefine.isPercentParam(v) then
				base = base.."%";
			end

			if Lua_ThingDefine.isStampParam(v) then
				base = base.."%";
				local _num = self:getSuitTypeForce(v,val[1]);
				stamp_force = stamp_force + _num;
			end

			local s = "[85A8BE]"..Lua_ThingDefine.getParamName(v).."[-]".." +"..color..base;
			str = str..s;
		end
	end

	local color = "[FFFFFF]";
	if index <= self.suit_index then
		color = "[00E125]";
	end
	local _force = color..(Lua_FightUtil.caculateConfigForce(force) + stamp_force);
	local suitforce = LanUtil.formateStr(LanUtil.getValue(128535), tostring(_force));

	local num =  LanUtil.formateStr(LanUtil.getValue(128536), tostring(self.suit_amount[index]));
	return num.."\n"..suitforce.."\n"..str;
end

-- 套装类型战力
function Lua_StampSuitVo:getSuitTypeForce(attr, num)
	local info = DataCenter.stampData.stampHolesInfo;
	local _type = 0;
	if attr == "fiend_multi"  then
		_type = 1;
	elseif attr == "immortal_multi" then
		_type = 2;
	elseif attr == "deity_multi" then
		_type = 3;
	end

	local _force = 0;
	for i,v in pairs(info) do
		if v.stamp_id ~= 0 then 
			if v.stampVo.stamp_type == _type then 
				local force = Lua_FightUtil.caculateConfigForce(v.stampVo.stampAttr);
				local _num = force + force * (num / 100);
				_force = _force + _num;
			end
		end
	end
	return math.ceil(_force);
end

-- 道具Tips 套装 封装
function Lua_StampSuitVo:showItemSuit(isSuit)
	local _str = "";
	local list = self.suit_prop;
	for k,v in pairs(list) do
		if _str == "" then
			_str = "";
		else
			_str = _str.."\n";
		end
		_str = _str..self:getItemSuitProp(v, k, isSuit)
	end
	return _str;
end

-- 单个套装属性封装
function Lua_StampSuitVo:getItemSuitProp(prop_id, index, isSuit)
	local str = "";
	local is = false;
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"soul_imprint_prop", prop_id, v});
		if val ~= nil then
			if str == "" then
				str = "";
			else
				str = str.."\n";
			end

			local base = val[1];
			if Lua_ThingDefine.isPercentParam(v) then
				base = base.."%";
			end

			if Lua_ThingDefine.isStampParam(v) then
				base = base.."%";
			end

			local color = "[C1E7FF]";
			if index <= self.suit_index and isSuit == nil  then
				color = "[00E125]";
			end

			local num;
			if is == false then
				is = true;
				local s = LanUtil.formateStr(LanUtil.getValue(128905), tostring(self.suit_amount[index]));
				num = color.."["..s.."] ";
			else
				num = "        "
			end

			local s = num..color..Lua_ThingDefine.getParamName(v).."[-]".."+"..base;
			str = str..s;
		end
	end
	return str;
end