-- 魂印配置数据
checkRequire("Lua_StampCompoundVo");
checkRequire("Lua_StampSuitVo") -- 套装vo
Lua_StampUtil = class("Lua_StampUtil");
function Lua_StampUtil:ctor()
end

-- 魂印常量，背包上限
function Lua_StampUtil.Get:pack_size()
	return getConfig({"soul_imprint", "pack_size", "value"});
end

-- 开启阶位限制
function Lua_StampUtil.Get:open_order()
	return getConfig({"soul_imprint", "open_order", "arr"});
end

-- 分解获得总额
function Lua_StampUtil:stampResolveNum(arr)
	local resolveNum = 0;
	for i = 1, arr:getSize() do
		resolveNum = resolveNum + arr[i].decompose;
	end
	return resolveNum;
end

-- 魂印合成 界面数据，通过类ID 获取ID所有数据
function Lua_StampUtil:getArrByClassId(class_id)
	return self.getCompoundConfigInfo[tostring(class_id)]
end

--通过 类ID 组ID 获取vo
function Lua_StampUtil:getArrByClassAndGroupInfo(class_id, group_id)
	local arr = self:getArrByClassId(class_id);
	if arr:getSize() ~= 0 then
		for i = 1, arr:getSize() do
			if arr[i].stamp_group_id == group_id then
				return arr[i];
			end
		end
	end
	return nil;
end

-- 合成 数据
function Lua_StampUtil.Get:getCompoundConfigInfo()
	if self.compoundDic == nil then
		self.compoundDic = {};
		local config = getConfig({"soul_imprint_compose"});
		if config ~= nil then
			for k,v in pairs(config) do
				local vo = Lua_StampCompoundVo.new(k, v);
				if self.compoundDic[tostring(vo.stamp_class_id)] == nil then
					self.compoundDic[tostring(vo.stamp_class_id)] = Array();
				end
				self.compoundDic[tostring(vo.stamp_class_id)]:add(vo);
			end
		end
	end
	return self.compoundDic;
end

-- 合成类数据
function Lua_StampUtil.Get:getCalssConfigInfo()
	if self.calss_info == nil then
		self.calss_info = {};
		local list = getConfig({"stampClass"});
		for i,v in pairs(list) do
			self.calss_info[i]= v;
		end
	end
	return self.calss_info;
end

-- 用于魂印合成界面页签显示
function Lua_StampUtil.Get:getCompoundCalssInfo()
	local list = self.getCalssConfigInfo;
	local stampCalssData = Array();
	stampCalssData:clear();
	for k,v in pairs(list) do
		local stamp_group_list = v.stamp_group_list;
		local sub1 = Array();
		if stamp_group_list ~= nil then
			local stamp_id;
			local stamp_name;
			for i, j in pairs(stamp_group_list) do
				stamp_id = self:getArrByClassAndGroupInfo(k,j).id;
				stamp_name = getConfig({"item", stamp_id}).name;
				sub1:add({name = stamp_name, data = self:getArrByClassAndGroupInfo(k,j)});
			end
		end
		stampCalssData:add({name = v.stamp_class_name, sub = sub1});
	end
	return stampCalssData;
end

-- 页签红点处理，合成 class 列表红点更新
function Lua_StampUtil:updateShowRedList(class_id)
	local isRedList = {};
	local vo = self:getArrByClassId(class_id);
	local isRed = false;
	for i = 1, vo:getSize() do
		if vo[i].isShowCompoundRed == true then
			isRed = true;
		end
		isRedList[vo[i].stamp_class_id] = isRed;
	end
	return isRedList;
end

-- 合成 group 列表红点更新
function Lua_StampUtil:getShowCompoundRedList(class_id)
	local isRedList = {};
	local vo = self:getArrByClassId(class_id);
	for i = 1, vo:getSize() do
		isRedList[vo[i].stamp_group_id] = vo[i].isShowCompoundRed;
	end
	return isRedList;
end

-- 获取拆解道具
function Lua_StampUtil:getItemNmae(id)
	local config = getConfig({"soul_imprint_compose",id});
	local _id = config.cost_item[1][1];
	local num = config.cost_item[1][2];
	local name = getConfig({"item",_id}).name;
	local color = getConfig({"item",_id}).color;
	local colorStr = Lua_ColorDefine.getItemColorStr(color);
	return "[" .. colorStr .. "]" .. name .."x".. num .. "[-]";
end

-- 获取拆解魂印
function Lua_StampUtil:getStampNmae(id)
	local config = getConfig({"soul_imprint_compose",id});
	local _id = config.cost_item[2][1];
	local num = config.cost_item[2][2];
	local name = getConfig({"item", _id}).name;
	local color = getConfig({"item", _id}).color;
	local colorStr =Lua_ColorDefine.getItemColorStr(color);
	return "[" .. colorStr .. "]" .. name .."x".. num .. "[-]";
end

-- 魂印 套装数据
function Lua_StampUtil.Get:getSuitConfigInfo()
	local stampSuitInfo = Array();
	local config = getConfig({"stampSuit"});
	if config ~= nil then
		local vo;
		for k,v in pairs(config) do
			vo = Lua_StampSuitVo.new(k, v);
			stampSuitInfo:add(vo);
		end
	end
	return stampSuitInfo;
end

-- 通过穿戴id，获取对应vo
function Lua_StampUtil:getSuitInfo(id)
	local arr = self.getSuitConfigInfo;
	for i = 1, arr:getSize() do
		if arr[i]:isSuitItem(id) == true then
			return arr[i];
		end
	end
	return nil;
end