Lua_SysSettingsData = class("Lua_SysSettingsData");
Lua_SysSettingsData.SHIELD_SKILL = 1;
Lua_SysSettingsData.SHIELD_OUTLOOK = 2;
Lua_SysSettingsData.SHIELD_MYEFFECT = 3;

function Lua_SysSettingsData:ctor()
	self:superCall("ctor");
	self:dispose();
end

function Lua_SysSettingsData:sGetSysPanelInfo()
	sendMsg(11401751);
end

function Lua_SysSettingsData:fromServer(data)
	self.isShock = data.is_shock;
	self.screenType = data.screen_type;
	self.turnoffActNotify=data.turnoff_act_notify;
	self.autoAdjustExpress=data.auto_adjust_express;
	self.fluencyType=data.fluency_type;
	self.getMusicData(data.music);
	self.getSoundData(data.sound_effect);
	self.shieldList = {};
	for i,v in ipairs(data.shield_type) do
		self.shieldList[i] = v;
	end
end
function Lua_SysSettingsData:getMusicData(data)
	self.isPlayMusic = data.obj_id;
	self.musicVolume= data.obj_value;
end
function Lua_SysSettingsData:getSoundData(data)
	self.isPlaySound = data.obj_id;
	self.soundVolume = data.obj_value;
end
function Lua_SysSettingsData:getShieldTypeData(t)
	if self.shieldList[t] == nil then
		return false;
	end
	return self.shieldList[t] == 1;
end
function Lua_SysSettingsData:setShieldTypeData(t,val)
	self.shieldList[t] = val;
end

function Lua_SysSettingsData:dispose()
	self.isPlayMusic = 1;--音乐开启
	self.musicVolume = 50;--音乐声音

	self.isPlaySound = 1;--音效开启
	self.soundVolume = 50;--音效声音

	self.screenType = 1;--1.3D视角 2.2.5D视角
	self.fluencyType = 2;--1.精美，2.智能， 3.流畅

	self.showQuality = 30;--显示品质
	self.showPlayerNum = 10;--显示玩家数量
	self.showMonsterNum = 10;--显示怪物数量

	self.shieldList = {};
end

function Lua_SysSettingsData:saveSetting()
end