Lua_SysSettingsProxy = class("Lua_SysSettingsProxy");
function Lua_SysSettingsProxy:ctor()
	self:superCall("ctor");
	--LuaUtil.addLuaMsg(81401751, self, self.rAutoGetSysPanelInfo);
	--LuaUtil.addLuaMsg(51401751, self, self.rGetSysPanelInfo);
	self.shieldData = {};
	self.shieldData[1] = "SHIELD_OTHER_SKILL";
	self.shieldData[2] = "SHIELD_OTHER_PET";
	self.shieldData[3] = "SHIELD_MYEFFECT";
	self.shieldData[4] = "SHIELD_SCENE_EFFECT";
	self.shieldData[5] = "SHIELD_DROP_NAME";
	self.shieldData[6] = "SHIELD_FRIEND";
	self.shieldData[7] = "IS_SHOCK";
	self.shieldData[8] = "SCREEN_TYPE";
	self.shieldData[9] = "FLUENCY_TYPE";
	self.shieldData[10] = "IS_PLAY_MUSIC";
	self.shieldData[11] = "MUSIC_VOLUME";
	self.shieldData[12] = "IS_PLAY_SOUND";
	self.shieldData[13] = "SOUND_VOLUME";
	self.shieldData[14] = "QUALITY_NUM";
	self.shieldData[15] = "SHOW_PLAYER_NUM";
	self.shieldData[16] = "SHOW_MONSTER_NUM";
end

function Lua_SysSettingsProxy:rAutoGetSysPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401751();
		msg:ParseFromString(mp.data);

		self:initData(msg.system_setting);
		
		Lua_MsgUtil.callFunc("SYS_PANEL_UPDATE");
	end
end

function Lua_SysSettingsProxy:rGetSysPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51401751();
		Lua_MsgUtil.callFunc("SYS_PANEL_UPDATE");
	end
end

function Lua_SysSettingsProxy:saveSetting()
	local pd = PlayerData.getInstance();
	for i,v in ipairs(self.shieldData) do
		UnityEngine.PlayerPrefs.SetInt(v, pd:getSettingValue(v));
    end
    UnityEngine.PlayerPrefs.Save();
end

function Lua_SysSettingsProxy:initData(data)
	local pd = PlayerData.getInstance();
	for i,v in ipairs(self.shieldData) do
		pd:setSettingValue(v, self:getSaveValue(v));
    end
end
function Lua_SysSettingsProxy:getSaveValue(v)
	if UnityEngine.PlayerPrefs.HasKey(v) == true then
		return UnityEngine.PlayerPrefs.GetInt(v);
	end
	if v == self.shieldData[1] then--"SHIELD_OTHER_SKILL"
		return 0;
	elseif v == self.shieldData[2] then--"SHIELD_OTHER_PET"
		return 0;
	elseif v == self.shieldData[3] then--"SHIELD_MYEFFECT"
		return 0;
	elseif v == self.shieldData[4] then--"SHIELD_SCENE_EFFECT"
		return 0;
	elseif v == self.shieldData[5] then--"SHIELD_DROP_NAME"
		return 0;
	elseif v == self.shieldData[6] then--"SHIELD_FRIEND"
		return 0;
	elseif v == self.shieldData[7] then--"IS_SHOCK"
		return 0;
	elseif v == self.shieldData[8] then--"SCREEN_TYPE"
		return 1;
	elseif v == self.shieldData[9] then--"FLUENCY_TYPE"
		return 2;
	elseif v == self.shieldData[10] then--"IS_PLAY_MUSIC"
		return 1;
	elseif v == self.shieldData[11] then--"MUSIC_VOLUME"
		return 80;
	elseif v == self.shieldData[12] then--"IS_PLAY_SOUND"
		return 1;
	elseif v == self.shieldData[13] then--"SOUND_VOLUME"
		return 80;
	elseif v == self.shieldData[14] then--"QUALITY_NUM"
		return 50;
	elseif v == self.shieldData[15] then--"SHOW_PLAYER_NUM"
		return 10;
	elseif v == self.shieldData[16] then--"SHOW_MONSTER_NUM"
		return 10;
	elseif v == self.shieldData[17] then--"SHOW_MONSTER_NUM"
		return 1;
	end
end