﻿Lua_TalePetVo = class("Lua_TalePetVo");
function Lua_TalePetVo:ctor(id, index)
	self.id = id; -- 敕令id
	self.index = index;
end

function Lua_TalePetVo:fromServer(v)
	self.skill_list = v.skill_list;
	self.evolution_lvl = v.evolution_lvl; -- 阶级
	self.isMax = self.max_level == v.evolution_lvl;
	self.states = v.activation_status == 1; -- 激活状态：1 激活，0 未激活
	self.force = v.force; -- 战力
	self.skill_list = v.skill_list; -- 技能表
end

function Lua_TalePetVo.Get:configData()
	return DataCenter.talePetData.talePetConfig[self.index];
end

-- 名字
function Lua_TalePetVo.Get:name()
	return self.configData.name;
end

-- 敕令品质
function Lua_TalePetVo.Get:color_index()
	return self.configData.color_index;
end

-- 敕令激活条件显示
function Lua_TalePetVo.Get:conditions()
	return self.configData.conditions;
end

-- 激活前置条件
function Lua_TalePetVo.Get:activation_cond()
	if self.configData.activation_cond == nil then
		return nil;
	end
	return self.configData.activation_cond[1];
end

-- 激活消耗材料
function Lua_TalePetVo.Get:activation_cost()
	if self.configData.activation_cost == nil then
		return nil;
	end
	return self.configData.activation_cost[1];
end

-- 升级（进阶）材料消耗
function Lua_TalePetVo.Get:cost_item()
	if self.isMax == true then
		return nil;
	end
	return self.configData.cost_item[self.evolution_lvl][1];
end

-- 最高等阶
function Lua_TalePetVo.Get:max_level()
	return self.configData.max_level;
end

-- 敕令属性显示
function Lua_TalePetVo.Get:attr()
	return self.configData.attr;
end

-- 敕令模型大小
function Lua_TalePetVo.Get:pet_size()
	return self.configData.pet_size;
end

-- 敕令偏移位置
function Lua_TalePetVo.Get:offsetPos()
	return self.configData.offsetPos;
end

-- 角度偏移
function Lua_TalePetVo.Get:angle()
	return self.configData.angle;
end

function Lua_TalePetVo.Get:headBgName()
	return "ui_common_prop_" .. (self.color_index + 1);
	-- return DataCenter.talePetData:getHeadIconByColorIdx(self.color_index);
end

function Lua_TalePetVo.Get:headStr()
	return "/images/talePet/head/" .. self.id .. ".png";
end

function Lua_TalePetVo.Get:colorName()
	return "[" .. Lua_ColorDefine.getItemColorStr(self.color_index, false) .. "]" .. self.name .. "[-]";
end

function Lua_TalePetVo.Get:orderStr()
	return DataCenter.talePetData.talePetCommonConfig["order_str"].arr_val[self.evolution_lvl];
end

function Lua_TalePetVo.Get:skillArr()
	self._skillArr = Array();
	if self.skill_list ~= nil then
		local skillConfig;
		local list;
		for k, v in ipairs(self.skill_list) do
			skillConfig = DataCenter.talePetData:getSkillInfo(v.skill_id);
			list = {};
			list.name = skillConfig.name;
			list.atlas = skillConfig.atlas;
			list.skill_icon = skillConfig.skill_icon;
			list.reMark = skillConfig.reMark;
			list.desc_name = skillConfig.desc_name;
			list.skill_lvl = skillConfig.skill_lvl;
			list.detail = skillConfig.detail;

			if skillConfig.god_master_propery == nil then
				list.property = 0;
			else
				list.property = skillConfig.god_master_propery;
			end

			list.activation_state = v.activation_state == 1;
			if list.activation_state == false then
				if skillConfig.skill_open_des ~= nil then
					list.skill_open_des = skillConfig.skill_open_des;
				else
					list.skill_open_des = "";
				end
			else
				list.skill_open_des = "";
			end
			self._skillArr:add(list);
		end
	end
	return self._skillArr;
end

function Lua_TalePetVo.Get:attrArr()
	local txtArr = Array();
	local attrArr = self.attr;
	local value;
	local list;
	for i = 1, #attrArr do
		if self.configData[attrArr[i]] ~= nil then
			value = self.configData[attrArr[i]][self.evolution_lvl];
			if self.isMax then
				list = {wordStr = "[85A8BE]" .. Lua_ThingDefine.getParamName(attrArr[i]) .. "：[-]", valueStr = value};
			else
				if self.states then
					local addValue = self.configData[attrArr[i]][self.evolution_lvl + 1] - value;
					list = {wordStr = "[85A8BE]" .. Lua_ThingDefine.getParamName(attrArr[i]) .. "：[-]", valueStr = value .. "  [00E125]+" .. addValue};
				else
					list = {wordStr = "[85A8BE]" .. Lua_ThingDefine.getParamName(attrArr[i]) .. "：[-]", valueStr = value};
				end
			end
			txtArr:add(list);
		end
	end
	return txtArr;
end 

function Lua_TalePetVo.Get:showRedDot()
	if self.states == false then
		local petArr = DataCenter.talePetData.petArr;
		local redDot = false;
		if self.activation_cond ~= nil then
			local petId = self.activation_cond[1];
			local petLvCondition = self.activation_cond[2];
			for i = 1, petArr:getSize() do
				if petArr[i].id == petId then
					if petArr[i].evolution_lvl >= petLvCondition then
						redDot = true;
						break;
					end
				end
			end

			if redDot == false then
				return redDot;
			end
		end

		if self.activation_cost ~= nil then
			local hadCount = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.activation_cost[1]);
			redDot = hadCount >= self.activation_cost[2];
		end
		return redDot;
	else
		if self.cost_item == nil then
			return false;
		end
		return DataCenter.talePetData.soul_source >= self.cost_item[2];
	end
end