checkRequire("Lua_TalePetData");
Lua_TalePetProxy = class("Lua_TalePetProxy");
function Lua_TalePetProxy:ctor()
	DataCenter.talePetData = Lua_TalePetData.new();

	LuaUtil.addLuaMsg(51400920, self, self.rTalePetPanelInfo);
	LuaUtil.addLuaMsg(51400921, self, self.r51400921);
	LuaUtil.addLuaMsg(51400922, self, self.r51400922);
	LuaUtil.addLuaMsg(51400923, self, self.r51400923);

	Lua_MsgUtil.addEventListener("PACK_UPDATE", self, self.onPackDataUpdate);
end

-- 获取敕令信息（返回）
function Lua_TalePetProxy:rTalePetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400920();
		msg:ParseFromString(mp.data);
		DataCenter.talePetData:fromServer51400920(msg);
		Lua_MsgUtil.callFunc("UPDATE_TALEPET_PANEL")
	end
end

-- 敕令激活（返回）
function Lua_TalePetProxy:r51400921(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400921();
		msg:ParseFromString(mp.data);
		DataCenter.talePetData:fromServer51400921(msg);
	end
end

-- 敕令进阶（返回）
function Lua_TalePetProxy:r51400922(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400922();
		msg:ParseFromString(mp.data);
		DataCenter.talePetData:fromServer51400922(msg);
	end
end

-- 敕令材料分解（返回）
function Lua_TalePetProxy:r51400923(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400923();
		msg:ParseFromString(mp.data);
		DataCenter.talePetData:fromServer51400923(msg);
		Lua_MsgUtil.callFunc("UPDATE_TALEPET_PANEL")
	end
end





-- 获取敕令信息
function Lua_TalePetProxy:sInitMsg()
	sendMsg(11400920);
end

-- 敕令激活
function Lua_TalePetProxy:sJiHuoMsg(id)
	local cmd = ProtoPublic_pb.Proto11400921();
	cmd.id = id;
	sendMsg(11400921, cmd);
end

-- 敕令进阶
function Lua_TalePetProxy:sLevelUpMsg(id)
	local cmd = ProtoPublic_pb.Proto11400922();
	cmd.id = id;
	sendMsg(11400922, cmd);
end

-- 敕令材料分解
function Lua_TalePetProxy:sFenJieMsg(pack_indexArr)
	local cmd = ProtoPublic_pb.Proto11400923();
	local arr = pack_indexArr;
	local len = pack_indexArr:getSize();
	for i = 1, arr:getSize() do
		local good = ProtoPublic_pb.ProtoPairObj();
		good.obj_id = arr[i].index;
		good.obj_value = arr[i].num;
		cmd.item_list:addToList(good);
	end
	sendMsg(11400923, cmd);
end

function Lua_TalePetProxy:onPackDataUpdate()
	if DataCenter.talePetData.decompose_RedDot then
		if DataCenter.funcOpenData:isOpened(10144) then
			DataCenter.redDotData:updateRedDotVoState(14012, true);
			Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10020, state = true});
			Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
		end
	else
		if DataCenter.funcOpenData:isOpened(10144) then
			DataCenter.redDotData:updateRedDotVoState(14012, false);
			Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10020, state = false});
			Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
		end
	end
end