checkRequire("Lua_TalismanData");
Lua_TalismanProxy = class("Lua_TalismanProxy");
function Lua_TalismanProxy:ctor()
	DataCenter.talismanData = Lua_TalismanData.new();

	LuaUtil.addLuaMsg(51403701, self, self.rGetPanelInfo); -- 获取仙器信息（返回）
	LuaUtil.addLuaMsg(51403702, self, self.rAdvance); -- 仙器进阶（返回）
	LuaUtil.addLuaMsg(51403715, self, self.rUse); -- 仙器佩戴/隐藏（返回）
	LuaUtil.addLuaMsg(51403707, self, self.rSkillLvlUp); -- 仙器技能升级（返回）
	LuaUtil.addLuaMsg(51403708, self, self.rUseItem); -- 仙器使用器灵（返回）
	LuaUtil.addLuaMsg(51403709, self, self.rHuaXingMsg); -- 仙器化形（返回）
end

function Lua_TalismanProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403701();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:fromServer51403701(msg);
		Lua_MsgUtil.callFunc("TALISMAN_PANEL_UPDATE");
	end
end

function Lua_TalismanProxy:rAdvance(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403702();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:advance(msg);
		-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
		-- elseif mp.errno == 3301 then
		-- elseif mp.errno == 3302 then
	else
		Lua_MsgUtil.callFunc("SET_AUTO_LVLUP_TIMER", false);
		-- DataCenter.talismanData:sServantPanelInfo();
	end
	DataCenter.talismanData:sGetPanelInfo();
	-- Lua_MsgUtil.callFunc("IS_SHOW_MASK",false);
end

function Lua_TalismanProxy:rUse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403715();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:updateState(msg);
		Lua_MsgUtil.callFunc("UESAGE_STATE_UPDATE");
	end
end

function Lua_TalismanProxy:rSkillLvlUp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403707();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:skillLvlUp(msg);
		Lua_MsgUtil.callFunc("SERVANT_SKILL_PANEL_UPDATE");
	end
end

function Lua_TalismanProxy:rUseItem(mp)
	DataCenter.talismanData:sGetPanelInfo();
		if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403708();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:useItem(msg);
		-- Lua_MsgUtil.callFunc("TALISMAN_PANEL_UPDATE");
	end
end

function Lua_TalismanProxy:rHuaXingMsg(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51402510();
		msg:ParseFromString(mp.data);
		DataCenter.talismanData:setShapeId(msg);
		Lua_MsgUtil.callFunc("TALISMAN_HUANXING_UPDATE", msg);
	end
end





function Lua_TalismanProxy:sFuncOpen(mp)
	local shapeList = DataCenter.talismanData:getServantShapeList();
	DataCenter.talismanData:sUse(shapeList[1].id, 1);
	DataCenter.talismanData:sHuanXingMsg(shapeList[1].id)
end