checkRequire("Lua_TalismanTransData");
Lua_TalismanTransProxy = class("Lua_TalismanTransProxy");
function Lua_TalismanTransProxy:ctor()
	self:superCall("ctor");
	DataCenter.talismanTransData = Lua_TalismanTransData.new();
	LuaUtil.addLuaMsg(51403703, self, self.rGetPanelInfo);
	LuaUtil.addLuaMsg(51403704, self, self.rActivation);
	LuaUtil.addLuaMsg(51403706, self, self.rTransmogrify);
	LuaUtil.addLuaMsg(51403705, self, self.rLvlUp);
end

function Lua_TalismanTransProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403703();
		msg:ParseFromString(mp.data);
		DataCenter.talismanTransData:fromServer(msg);
		Lua_MsgUtil.callFunc("TALISMAN_TRANS_PANEL_UPDATE");
	end
end

function Lua_TalismanTransProxy:rActivation(mp)
	print("rActivation");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403704();
		msg:ParseFromString(mp.data);
		DataCenter.talismanTransData:getActivationInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.talismanTransData:sGetPanelInfo();
	end
end

function Lua_TalismanTransProxy:rTransmogrify(mp)
	print("rTransmogrify");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403706();
		msg:ParseFromString(mp.data);
		DataCenter.talismanTransData:getTransInfo(msg);
		DataCenter.talismanTransData:sGetPanelInfo();
	end
end

function Lua_TalismanTransProxy:rLvlUp(mp)
	print("rLvlUp");
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51403705();
		msg:ParseFromString(mp.data);
		DataCenter.talismanTransData:getLvlUpInfo(msg);
		--Lua_MsgUtil.callFunc("Servant_TRANS_PANEL_UPDATE");
		DataCenter.talismanTransData:sGetPanelInfo();
	end
end