checkRequire("Lua_TaskDefine");
checkRequire("Lua_TaskVo");
Lua_TaskData = class("Lua_TaskData", Lua_EventOwner);
function Lua_TaskData:ctor()
	self:superCall("ctor");

	self.taskFinish = Array();
	self.isFinishGuide = 0;
	self.taskListsDic = {};
	self.routineBoxRewardInfo = {};
	self.routineIsAllComplete = 0;
	self.hasShowCantAcceptEff = false;
	self.zoomOutTaskUI = true; -- 任务栏缩放情况
	self.excutingTaskId = nil;
	self.showingRoutineGuideTaskId = nil;
	self.needCheckRoutineWinClose = false;
	self.taskClickDic = {};
	self.npcCheckTaskTypes = Array(Lua_TaskDefine.TRUCK,
		Lua_TaskDefine.PROFESSION,
		Lua_TaskDefine.LEAGUE,
		Lua_TaskDefine.ROUTINE,
		Lua_TaskDefine.BRANCH,
		Lua_TaskDefine.RELATION,
		Lua_TaskDefine.LOVERS);
end

function Lua_TaskData:dispose()
	self:reset();
	if self.removeProfession ~= nil then -- 切换账号设置为nil
		self.removeProfession = nil;
	end
end

function Lua_TaskData:reset()
	self.taskFinish = Array();
	self.isFinishGuide = 0;
	while #self.taskListsDic > 0 do
		self.taskListsDic[1]:clear();
		table.remove(self.taskListsDic, 1);
	end
	self.taskListsDic = {};
	self.routineBoxRewardInfo = {};
	self.rountRewardRoleLv = nil;
	self.routineIsAllComplete = 0;
	self.hasShowCantAcceptEff = false;
	self.zoomOutTaskUI = true;
	self.excutingTaskId = nil;
	-- self.taskList = Array();
	self.needCheckRoutineWinClose = false;
	self.taskClickDic = {};
end




function Lua_TaskData:fastFinishTask(taskId)
	print("taskId", taskId);
	local cmd = getProtoMsg("Proto11400330");
	cmd.task_id = taskId;
	sendMsg(11400330, cmd);
end

function Lua_TaskData:fromServer51400325(msg)
	if msg == nil then
		return;
	end
	
	self.isFinishGuide = msg.is_finish_guide;
	for i,v in ipairs(msg.task_finish) do
		self.taskFinish:add(v);
	end

	local tvo;
	local isAutoExecute;
	local singleTypeTaskArr;
	local leagueAutoVipLv = getConfig({"vip_level", DataCenter.roleData.vipType, "auto_leahue_task"});
	for i,v in ipairs(msg.task_list) do
		tvo = Lua_TaskVo.new(v.task_id, v.type);
		tvo:fromServer(v);

		isAutoExecute = false;
		if tvo.task_null ~= 1 then
			if tvo.taskType == Lua_TaskDefine.LEAGUE 
				and leagueAutoVipLv == 1
				and tvo.conditionType ~= Lua_TaskDefine.CONDITION_TYPE_SUBMIT then
				isAutoExecute = true;
			elseif tvo.taskType == Lua_TaskDefine.ROUTINE and tvo.status ~= Lua_TaskDefine.ACCEPT then
				isAutoExecute = true;
			end
		end
		tvo.isAutoExecute = isAutoExecute;
		
		singleTypeTaskArr = self:getListByType(v.type);
		singleTypeTaskArr:add(tvo);
	end
end

function Lua_TaskData:getListByType(type)
	if self.taskListsDic[tostring(type)] == nil then
		self.taskListsDic[tostring(type)] = Array();
	end
	return self.taskListsDic[tostring(type)];
end

function Lua_TaskData:fromServer51400351(msg)
	if msg == nil then
		return;
	end

	self.rountRewardRoleLv = msg.role_lvl;
	-- print("msg.role_lvl", msg.role_lvl);
	self.routineIsAllComplete = msg.is_all_complete;
	for k,v in ipairs(msg.box_info) do
		self.routineBoxRewardInfo[k] = v;
	end
	Lua_MsgUtil.callFunc("ROUTINE_BOX_REWARD_INFO");
end

function Lua_TaskData:fromProfessionTask(msg)
	local profession, task_step;
	if msg.profession == #Lua_ChangeJobUtil.getConfig() then
		profession = msg.profession;
	else
		profession = msg.profession +1;
	end
	DataCenter.roleData.joblength = #Lua_ChangeJobUtil.getstepConfig(profession);

	if msg.task_step == #Lua_ChangeJobUtil.getstepConfig(profession) then
		task_step = msg.task_step;
	else
		task_step = msg.task_step +1;
		DataCenter.changeJobData.iscolorProfession = msg.complete_task;
	end
	DataCenter.roleData.taskStep = task_step;

	if #msg.profession_task ~= 0  then
		DataCenter.taskData.taskvalue = msg.profession_task[1].obj_value
	end

	if msg.open_task ~= true then
		if msg.profession == #Lua_ChangeJobUtil.getConfig() then
			self:removeTask(9, self.profession)
		else
			self:removeTask(9, profession-1)
		end
		
		if DataCenter.changeJobData.isShow == false then
			self:removeTask(9, self.profession)
		end
		self.removeProfession = nil;
	else	
		if self.removeProfession == nil then 
			DataCenter.roleData.taskStep = task_step
			DataCenter.roleData.joblength = #Lua_ChangeJobUtil.getstepConfig(profession);

			self.profession = profession;

			local tvo = Lua_TaskVo.new(profession,9);
			tvo.status = 9;
			tvo.condList = Array();
			tvo.routineIndex = task_step;
			-- tvo.isAutoExecute = msg.complete_task;
			tvo.routineTotal = #Lua_ChangeJobUtil.getstepConfig(profession);

			local singleTypeTaskArr = self:getListByType(tvo.taskType);
			singleTypeTaskArr:add(tvo);
			-- self:removeTask(9,msg.profession)
		-- else
			self.removeProfession = true
		end
	end
	Lua_MsgUtil.callFunc("TASK_UPDATE");
end





function Lua_TaskData:canDoCollect(objId)
	local list = self:getListByType(Lua_TaskDefine.TRUCK);
	local len = list:getSize();
	for i = 1, len do
		if list[i].status == Lua_TaskDefine.ACCEPTED
		and list[i].conditionType == Lua_TaskDefine.CONDITION_TYPE_COLLECT then
			if list[i].afterAcceptTarget == objId then
				return true;
			end
		end
	end
	return false;
end

function Lua_TaskData:addTask(tvo)
	self:removeTask(tvo.taskType, tvo.taskId);
	local singleTypeTaskArr = self:getListByType(tvo.taskType);
	singleTypeTaskArr:add(tvo);
end

function Lua_TaskData:removeTask(ttype,taskId)
	if DataCenter.taskData.excutingTaskId  == taskId then
		DataCenter.taskData.excutingTaskId  = nil;
	end

	local singleTypeTaskArr = self:getListByType(ttype);
	local index = self:getTaskIndex(singleTypeTaskArr, taskId);
	if index ~= -1 then
		singleTypeTaskArr:remove(index);
	end
end

function Lua_TaskData:getTaskIndex(taskList, taskId)
	local len = taskList:getSize();
	for i = 1, len do
		if taskList[i].taskId == taskId then
			return i;
		end
	end
	return -1;
end

function Lua_TaskData:getTaskById(taskId)
	for k,v in pairs(self.taskListsDic) do
		local len = v:getSize();
		for i = 1, len do
			if v[i].taskId == taskId then
				return v[i];
			end
		end
	end
	return nil;
end

function Lua_TaskData:getTaskByTypeAndId(taskType,taskId)
	local singleTypeTaskArr = self:getListByType(taskType);
	local len = singleTypeTaskArr:getSize();
	for i = 1, len do
		if singleTypeTaskArr[i].taskId == taskId then
			return singleTypeTaskArr[i];
		end
	end
	return nil;
end

--根据npcid，判断有没有任务与npc有关联
function Lua_TaskData:checkTaskWithNpc(npcId)
	local typsLen = self.npcCheckTaskTypes:getSize();
	local vo = nil;
	for j = 1, typsLen do
		local singleTypeTaskArr = self:getListByType(self.npcCheckTaskTypes[j]);
		local len = singleTypeTaskArr:getSize();
		for i = 1, len do
			if singleTypeTaskArr[i]:checkTaskWithNpc(npcId) == true then
				if vo == nil then
					vo = singleTypeTaskArr[i];
				elseif vo ~= nil and singleTypeTaskArr[i].status == Lua_TaskDefine.DELIVERED then
					vo = singleTypeTaskArr[i];
					break;
				end
			end
		end
		if vo ~= nil and vo.status == Lua_TaskDefine.DELIVERED then
			break;
		end
	end
	return vo;
end

function Lua_TaskData:showNpcTalkWindow(npcData, npcId)
	local showTask = DataCenter.taskData:checkTaskWithNpc(npcId);
	if showTask ~= nil then
		Lua_WindowUtil.openWin("Lua_NpcTaskWindow", WinParam.ACTION_OPEN, {npc = npcData, taskVo = showTask});	
	else
		Lua_WindowUtil.openWin("Lua_NpcTalkWindow", WinParam.ACTION_OPEN, {npc = npcData});
	end
end

function Lua_TaskData.Get:mainTaskVo()
	local singleTypeTaskArr = self:getListByType(Lua_TaskDefine.TRUCK);
	if singleTypeTaskArr ~= nil and singleTypeTaskArr:getSize() > 0 then
		return singleTypeTaskArr[1];
	end
	return nil;
end

function Lua_TaskData:execTruckTask()
	local singleTypeTaskArr = self:getListByType(Lua_TaskDefine.TRUCK);
	if singleTypeTaskArr ~= nil and singleTypeTaskArr:getSize() > 0 then
		local tTask = singleTypeTaskArr[1];
		tTask:exeTask();
	end
end

function Lua_TaskData:handelOpenDailyTask(taskVo)
	local showDailyWin = false;
	if taskVo.status == Lua_TaskDefine.ACCEPT and taskVo.taskType == Lua_TaskDefine.ROUTINE then
		-- 处于可接状态的日常任务要打开日常任务面板
		showDailyWin = true
	elseif  taskVo.status == Lua_TaskDefine.ACCEPTED and taskVo.taskType == Lua_TaskDefine.ROUTINE and taskVo.config.under_task_type == 0 then
		-- 虚拟日常任务（日常任务全部完成时会有一个虚拟任务，提供给玩家去领取宝箱奖励）
		showDailyWin = true
	elseif getLanType() == 2 and taskVo.status == Lua_TaskDefine.DELIVERED and taskVo.taskType == Lua_TaskDefine.ROUTINE then
		showDailyWin = true
	end

	if showDailyWin == true then
		Lua_WindowUtil.openWin("Lua_DailyRoutineWindow", WinParam.ACTION_OPEN, taskVo);
		return false;
	end
	return true;
end

function Lua_TaskData:delayDoMoveBackExcuTask(taskId)
	local tvo = DataCenter.taskData:getTaskById(taskId);
	if tvo ~= nil then
		tvo:exeTask();
	end
end

function Lua_TaskData:getNeedDoList()
	local cfgList = Array();
	local roleLv = DataCenter.roleData.level;
	local cfg = getConfig({"needtodo"});
	for k,v in ipairs(cfg) do
		local canAdd = true;
		if v.func_id ~= nil and DataCenter.funcOpenData:isOpened(v.func_id,false) == false then
			canAdd = false;
		end
		if v.reddot_id ~= nil and DataCenter.redDotData:getRedDotStateByEventId(v.reddot_id) == false then
			canAdd = false;
		end
		if v.lvl_limit ~= nil and v.lvl_limit > roleLv then
			canAdd = false;
		end
		if v.task_type ~= nil then
			local singleTypeTaskArr = self:getListByType(v.task_type);
			if singleTypeTaskArr == nil or singleTypeTaskArr:getSize() ==0 then
				canAdd = false;
			elseif singleTypeTaskArr ~= nil then
				local ttask = singleTypeTaskArr[1];
				if ttask.taskType == Lua_TaskDefine.ROUTINE and ttask.config.under_task_type == 0 and ttask.status == Lua_TaskDefine.ACCEPTED then
					-- 已经完成了所有日常任务，处于可领取宝箱奖励的情况下，也不用显示了
					canAdd = false;
				end
			end
		end

		if canAdd == true then
			cfgList:add(v);
		end
	end
	return cfgList;
end