Lua_TaskDefine = {};
Lua_TaskDefine.TRUCK = 1; -- 主线任务
Lua_TaskDefine.BRANCH = 2; -- 支线任务
Lua_TaskDefine.ROUTINE = 3; -- 日常任务
Lua_TaskDefine.LEAGUE = 4; -- 帮派任务
Lua_TaskDefine.RELATION = 5; -- 结义任务
Lua_TaskDefine.LOVERS = 6; -- 侠侣任务
Lua_TaskDefine.XIANSHI = 7; -- 限时任务
Lua_TaskDefine.CAR = 8; -- 运镖任务
Lua_TaskDefine.PROFESSION =9; -- 转职任务

Lua_TaskDefine.UNACCEPT = 1; -- 可见，不可接取
Lua_TaskDefine.ACCEPT = 2; -- 可接取
Lua_TaskDefine.ACCEPTED = 3; -- 已接取，任务进行中
Lua_TaskDefine.DELIVERED = 4; -- 已完成，未提交任务
Lua_TaskDefine.FINISHED = 5; -- 已提交任务、领取奖励

-- 配置文件用到的任务类型，为string类型
Lua_TaskDefine.CONDITION_TYPE_TALK = "talk"; -- npc对话
Lua_TaskDefine.CONDITION_TYPE_SCENE = "scene"; -- 进入场景
Lua_TaskDefine.CONDITION_TYPE_LEVEL_UP ="lvl_up" -- 等级条件
Lua_TaskDefine.CONDITION_TYPE_COLLECT = "collect"; -- 采集条件
Lua_TaskDefine.CONDITION_TYPE_KILL = "kill"; -- 杀怪条件
Lua_TaskDefine.CONDITION_TYPE_SCRIPT_WAVE = "script_wave"; -- 副本波数条件
Lua_TaskDefine.CONDITION_TYPE_PACKAGE = "package"; -- 背包物品条件
Lua_TaskDefine.CONDITION_TYPE_PATROL = "patrol"; -- 寻路任务
Lua_TaskDefine.CONDITION_TYPE_COLLECT_ANY = "collect_any"; -- 指定场景收集
Lua_TaskDefine.CONDITION_TYPE_MONSTER = "monster"; -- 杀死指定怪物
Lua_TaskDefine.CONDITION_TYPE_BRANCH = "branch"; -- 完成指定支线任务N次
Lua_TaskDefine.CONDITION_TYPE_SUBMIT = "submit"; -- 上缴装备到帮派仓库
Lua_TaskDefine.CONDITION_TYPE_LMAGE_KILL = "lmage_kill"; -- 镜像副本杀怪
-- Lua_TaskDefine.CONDITION_TYPE_OPENWIN = "open"; -- 上缴装备到帮派仓库

-- ProtoTaskCond用到的任务类型，为int类型
Lua_TaskDefine.CONDITION_INT_TYPE_TALK = 3 ; -- npc对话
Lua_TaskDefine.CONDITION_INT_TYPE_SCENE = 10; -- 进入场景
Lua_TaskDefine.CONDITION_INT_TYPE_LEVEL_UP= 4; -- 等级条件
Lua_TaskDefine.CONDITION_INT_TYPE_COLLECT = 2; -- 采集条件
Lua_TaskDefine.CONDITION_INT_TYPE_KILL = 1; -- 杀怪条件
Lua_TaskDefine.CONDITION_INT_TYPE_SCRIPT_WAVE = 6; -- 副本波数条件
Lua_TaskDefine.CONDITION_INT_TYPE_PACKAGE = 8; -- 背包物品条件
Lua_TaskDefine.CONDITION_INT_TYPE_PATROL = 9; -- 寻路任务
Lua_TaskDefine.CONDITION_INT_TYPE_COLLECT_ANY = 11; -- 指定场景收集
Lua_TaskDefine.CONDITION_INT_TYPE_MONSTER = 12; -- 杀死指定怪物
Lua_TaskDefine.CONDITION_INT_TYPE_BRANCH = 14; -- 完成指定支线任务N次
Lua_TaskDefine.CONDITION_INT_TYPE_SUBMIT = 15; -- 上缴装备类型
Lua_TaskDefine.CONDITION_INT_TYPE_LMAGE_KILL = 16; -- 镜像副本杀怪

-- 环式任务 子类型
Lua_TaskDefine.ROUTINE_SUBTYPE_VIRTUAL = 0; -- 虚拟任务
Lua_TaskDefine.ROUTINE_SUBTYPE_TALK = 1; -- 对话任务
Lua_TaskDefine.ROUTINE_SUBTYPE_KILL = 2; -- 杀怪人物
Lua_TaskDefine.ROUTINE_SUBTYPE_MIRROR = 3; -- 镜像任务
Lua_TaskDefine.ROUTINE_SUBTYPE_COLLECT = 4; -- 收集任务

Lua_TaskDefine.ROUNTINE_FINISH_TASK = 399999999; -- 环式任务完成任务id
function Lua_TaskDefine.getTaskNameTitle(type)
	if type == 8 then
		return LanUtil.getValue(122914);
	elseif type == 9 then
		return "";
	elseif type == 7 then
		return LanUtil.getValue(122940);
	else
		return LanUtil.getValue(122902 + type);
	end
end

function Lua_TaskDefine.getTaskStatusLabel(status)
	-- if status == Lua_TaskDefine.UNACCEPT then
	-- 	return LanUtil.getValue(122909);
	-- elseif status == Lua_TaskDefine.ACCEPT then
	-- 	return LanUtil.getValue(122910);
	-- elseif status == Lua_TaskDefine.ACCEPTED then
	-- 	return LanUtil.getValue(122911);
	-- elseif status == Lua_TaskDefine.DELIVERED then
	-- 	return LanUtil.getValue(122912);
	-- elseif status == Lua_TaskDefine.FINISHED then
	-- 	return LanUtil.getValue(122913);
	-- end
	return "";
end

function Lua_TaskDefine.getTaskTitleColor(status,taskType)
	local color = "[00E125]";
	if status == Lua_TaskDefine.DELIVERED then
		color = "[00E125]";
	else
		if taskType == Lua_TaskDefine.LEAGUE then
			color ="[da70d6]";
		elseif taskType == Lua_TaskDefine.XIANSHI then
			color = "[55d2ff]";
		else
			-- color =  "[ffda68]";
			if getShowTips() == true then
				color = "[ffda68]";
			else
				color = "[AE0E7C]";
			end
		end
	end

	if taskType == Lua_TaskDefine.PROFESSION then
		if DataCenter.changeJobData.iscolorProfession == true then
			color = "[00E125]"
			-- DataCenter.changeJobData.isProfession = true;
		else
			-- color =  "[ffda68]";
			if getShowTips() == true then
				color = "[ffda68]";
			else
				color = "[AE0E7C]";
			end
		end
	end
	return color;
end

function Lua_TaskDefine.getTaskContentColor(status)
	local color = "[00E125]";
	if status == Lua_TaskDefine.DELIVERED then
		color =  "[00E125]";
	elseif status == Lua_TaskDefine.UNACCEPT then
		color = "[ff2828]";
	else
		-- color =  "[c7cedf]";
		if getShowTips() == true then
			color = "[c7cedf]";
		else
			color = "[242222]";
		end
	end
	return color;
end