Lua_TaskHookControl = class("Lua_TaskHookControl");
function Lua_TaskHookControl:initHook()
	self._lastRoleActiveTime = getTime();
	self.ACTIVE_INTERVAL = Lua_CommonUtil.getCommonConfig("auto_task_hook_interval",1);
	self.isInTaskHooking = false;
	self._openning = true;
	MsgUtil.addEventListener("SCENE_LOADED", self,self.onSceneLoaded);
	Lua_CommonUtil.addTimer("checkTaskHook", 1, self, self.checkTaskHook);
	self.wildMapIds = Array();
--	local startTaskHookRoleLv = Lua_CommonUtil.getCommonConfig("start_task_hook_rolelv",1);
	local tcfg = Lua_CommonUtil.getCommonConfig("wild_map_ids",3);
	for k,v in ipairs(tcfg) do
		self.wildMapIds:add(v);
	end
	self.exceptUIList = Array();
	local tuiList = Lua_CommonUtil.getCommonConfig("task_hook_except_ui",3);
	for k,v in ipairs(tuiList) do
		self.exceptUIList:add(v);
	end
	
end
function Lua_TaskHookControl:opencloseHook(val)
--	print("val",val);
	self._openning = val;
end
function Lua_TaskHookControl.Get:openning()
	return self._openning;
end
function Lua_TaskHookControl:onSceneLoaded()
	self:refreshLastRoleActive();
end
function Lua_TaskHookControl:refreshLastRoleActive()
--	print("refreshLastRoleActive");
	self._lastRoleActiveTime = getTime();
	self.isInTaskHooking = false;
end
function Lua_TaskHookControl:checkTaskHook()
	if DataCenter.KuaFuData~= nil then
		if DataCenter.KuaFuData.kuafuHookInng == true  then
			return;
		end
	end
	if DataCenter.theSelectionWarData.isStopsHook == true then
		self._lastRoleActiveTime = getTime();--重新计时自动执行任务等待时间
		return;
	end
	if self.openning ~= true then
		return;
	end
	if GlobalVar.isActing then
--		print("GlobalVar.isActing");
        return;
    end
	if GlobalVar.hooking == true then
--		print("GlobalVar.hooking");
		return;
	end
	if self.isInTaskHooking == true then
--		print("self.isInTaskHooking");
		return;
	end
	
	if self.wildMapIds:indexOf(DataCenter.roleData.sceneId) == -1 then
--		print("self.wildMapIds",DataCenter.roleData.sceneId);
		return;
	end

	if getTime() - self._lastRoleActiveTime <self.ACTIVE_INTERVAL then
--		print("self.ACTIVE_INTERVAL");
        return;
    end

--	print("checkTaskHook");
	if DataCenter.yunBiaoData.isOngoing == true  then		
		return;
	end
	
	if Lua_WindowUtil.isWindowShowing("Lua_FuncOpenTipsPanel") 
		or Lua_WindowUtil.isWindowShowing("Lua_FuncOpenModelPanel") 
		or Lua_WindowUtil.isWindowShowing("Lua_GuideWindow")
		or Lua_WindowUtil.isWindowShowing("ReconnectingWindow")
		or Lua_WindowUtil.isWindowShowing("ReconnectWindow") then
		return;
	end
	local rd = DataCenter.roleData;
	--指定區域內不觸發
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneData:isInNoAutoTaskArea(Vector3(rd.px,0,rd.pz)) == true then
		return;
	end
	
	--打开配置指定的界面是，不触发
	local uiLen = self.exceptUIList:getSize();
	for i=1,uiLen do
		if Lua_WindowUtil.isWindowShowing(self.exceptUIList[i]) then
			return;
		end
	end
	
	if sceneData.copy_type == 34 then
		DataCenter.hook:start();
		return;
	end
	local taskData = DataCenter.taskData;
	local hasExcu = false;
	local tlist = taskData:getListByType(Lua_TaskDefine.TRUCK);
	if tlist ~= nil and tlist:getSize()>0  and tlist[1].status ~= Lua_TaskDefine.UNACCEPT then
		local tTask = tlist[1];
		tTask:exeTask();
		hasExcu = true;
	end
	if hasExcu == false then
		tlist = taskData:getListByType(Lua_TaskDefine.ROUTINE);
		if tlist ~= nil and tlist:getSize()>0 then
			local rTask = tlist[1];
			local showDailyWin = false;
			if rTask.status == Lua_TaskDefine.ACCEPT and rTask.taskType == Lua_TaskDefine.ROUTINE then
				--处于可接状态的日常任务要打开日常任务面板
				showDailyWin = true			
			elseif  rTask.status == Lua_TaskDefine.ACCEPTED and rTask.taskType ==  Lua_TaskDefine.ROUTINE and rTask.config.under_task_type == 0  then
				--虚拟日常任务（日常任务全部完成时会有一个虚拟任务，提供给玩家去领取宝箱奖励）
				showDailyWin = true
			end
			if showDailyWin == false then
				rTask:exeTask();
				hasExcu = true;
			else
				--帮他接
				if  rTask.status == Lua_TaskDefine.ACCEPT then
					local cmd = getProtoMsg("Proto11400328");
					cmd.task_id = rTask.taskId;
					sendMsg(11400328,cmd);
				end
			end
		end
	end
	if hasExcu == false then
		Lua_MsgUtil.callFunc("GOTO_HOOK_MAP");
		hasExcu = true
	end
	self.isInTaskHooking = hasExcu;
	
end
function Lua_TaskHookControl:dispose()
	Lua_CommonUtil.removeTimer(self,self.checkTaskHook);
	self.isInTaskHooking = false;
	if self.wildMapIds ~= nil then
		self.wildMapIds:clear();
	end
end