checkRequire("Lua_TaskCond");
checkRequire("Lua_TaskDefine");
checkRequire("Lua_ThingDefine");
checkRequire("Lua_ChangeJobUtil");

Lua_TaskVo = class("Lua_TaskVo");
Lua_TaskVo.regexpStr = "%([^\n]-%)";
function Lua_TaskVo:ctor(taskId, taskType)
	self:superCall("ctor");
	self.taskId = taskId;
	self.taskType = taskType;
	if taskType == Lua_TaskDefine.TRUCK then
		self.config = getConfig({"main", taskId});
		if self.config == nil then
			print("main not config :"..tostring(taskId));
		end
	elseif taskType == Lua_TaskDefine.BRANCH then
		self.config = getConfig({"branch_task", taskId});
		if self.config == nil then
			print("branch_task not config :"..tostring(taskId));
		end
	elseif taskType == Lua_TaskDefine.CAR then
		self.config = getConfig({"task_car", taskId});
		if self.config == nil then
			print("task_car not config :"..tostring(taskId));
		end	
	elseif taskType == Lua_TaskDefine.ROUTINE then
		self.config = getConfig({"routine", taskId});
		if self.config == nil then
			print("routine not config :"..tostring(taskId));
		end	
	elseif taskType == Lua_TaskDefine.LEAGUE then
		self.config = getConfig({"league_routine",taskId});
		if self.config == nil then
			print("league_routine not config :"..tostring(taskId));
		end	
	elseif taskType == Lua_TaskDefine.XIANSHI then
		self.config = getConfig({"limit_time_task",taskId});
		if self.config == nil then
			print("limit_time_task not config :"..tostring(taskId));
		end	
	elseif taskType == Lua_TaskDefine.PROFESSION then
		self.config = getConfig({"profession","growup"});
		if self.config == nil then
			print("profession not config :"..tostring(taskId));
		end	
	end
	self._isAutoExecute = false;
end
function Lua_TaskVo:fromServer(val)
	self.taskId = val.task_id;
	self.taskType = val.type;
	self.status = val.status;
	self.routineIndex = val.routine_index;
	self.routineTotal = val.routine_total;
	self.isRoutine = val.is_routine;
	self.condList = Array();
	if val.cond_list ~= nil then
		for i,v in ipairs(val.cond_list) do
			local c = Lua_TaskCond.new();
			--print("taskCond( task_id:"..tostring(val.task_id).." , cond_type:"..tostring(val.cond_type));
			c:fromServer(v);
			self.condList:add(c);
		end
	end
	self.time = val.time;
	self.task_time = val.task_time;
	self.task_null = val.task_null;
end
function Lua_TaskVo.Get:canDoTask()
	if self.task_null == 1 then
		return false;
	end
	if DataCenter.roleData.level < self.acceptLevel then
		return false;
	end
	return true;
end
function Lua_TaskVo:exeTask()
	--技能激活面板显示时不给执行任务。
	if WindowMananger.getInstance():isWindowShowing("Lua_SkillActiveTipsWindow") == true 
		or WindowMananger.getInstance():isWindowShowing("Lua_WelcomeWindow") == true 
		or WindowMananger.getInstance():isWindowShowing("Lua_TaskVideoWindow") then
		return;
	end
	--print("self.config.exec_stop_hook",self.config.exec_stop_hook);
	if GlobalVar.hooking == true and self.execDontStopHook == false then
		DataCenter.hook:stop(true);
	end
	DataCenter.taskData.excutingTaskId = self.taskId;
--	print("execTask："..tostring(self.taskId));
	if self.status == Lua_TaskDefine.ACCEPT and self.config.before_accept.auto_accept ~= 1 then --去接任务
		WorldMapUtil.moveTo(self.beforeAcceptScene, self.beforeAcceptCoord.x, self.beforeAcceptCoord.y, self.beforeAcceptCoord.z, self.beforeAcceptNpc, Lua_ThingDefine.NPC, WorldMapUtil.genArriveActionVo({type=1,npcId=self.beforeAcceptNpc}), 0);
	elseif self.status == Lua_TaskDefine.ACCEPTED then --执行任务
--		print("self.conditionType:"..tostring(self.conditionType));
		if self:doAction() == true then
			return;
		end
		if self.conditionType == Lua_TaskDefine.CONDITION_TYPE_TALK then
--			print("self.afterAcceptScene "..tostring(self.afterAcceptScene));
			DataCenter.doingTask = true;
			WorldMapUtil.moveTo(self.afterAcceptScene, self.afterAcceptCoord.x, self.afterAcceptCoord.y, self.afterAcceptCoord.z, self.conditionTarget, Lua_ThingDefine.NPC, 
				WorldMapUtil.genArriveActionVo({type=1,npcId=self.conditionTarget}), 0);
		elseif self.conditionType == Lua_TaskDefine.CONDITION_TYPE_KILL 
				or self.conditionType == Lua_TaskDefine.CONDITION_TYPE_MONSTER
				or self.conditionType == Lua_TaskDefine.CONDITION_TYPE_COLLECT then
			DataCenter.doingTask = true;
			WorldMapUtil.moveTo(self.afterAcceptScene, self.afterAcceptCoord.x, self.afterAcceptCoord.y, self.afterAcceptCoord.z, self.afterAcceptTarget, Lua_ThingDefine.MONSTER, nil, 0);		
		elseif self.conditionType == Lua_TaskDefine.CONDITION_TYPE_SCENE or self.conditionType == Lua_TaskDefine.CONDITION_TYPE_LMAGE_KILL then
			--进入镜像副本
			local mirrorExecPos = self.mirrorExecPos;
			if self.afterAcceptScene == DataCenter.roleData.sceneId then
--				print("self.afterAcceptTarget",self.afterAcceptTarget);
				WorldMapUtil.moveTo(self.afterAcceptScene, self.afterAcceptCoord.x, self.afterAcceptCoord.y, self.afterAcceptCoord.z, self.afterAcceptTarget, Lua_ThingDefine.MONSTER, WorldMapUtil.genArriveActionVo({type=8,monsterId=0,dailytask=0}),  0);		
			else
				WorldMapUtil.moveTo(mirrorExecPos[1], mirrorExecPos[2], mirrorExecPos[3], mirrorExecPos[4], 0, 0,WorldMapUtil.genArriveActionVo({type=9,taskId= self.taskId}),0);
			end
		elseif self.conditionType == Lua_TaskDefine.CONDITION_TYPE_SUBMIT then
			if self.condList:getSize()> 0 then
				Lua_MsgUtil.callFunc("OPEN_SUBMIT_EQU_TO_FACTION",self.taskId);
			end		
		end
	elseif self.status == Lua_TaskDefine.DELIVERED then --交任务
		if self:doAction() == true then
			return;
		end
		if self.finishNpc~= nil and self.finishScene~=nil then
            --print("==========self.status=====22222===self.taskId=====",self.taskId)
--			print("Lua_TaskDefine.DELIVERED , finishScene:"..tostring(self.finishScene).." , finishNpc:"..tostring(self.finishNpc))
			WorldMapUtil.moveTo(self.finishScene, self.finishCoord.x, self.finishCoord.y, self.finishCoord.z, self.finishNpc, Lua_ThingDefine.NPC, WorldMapUtil.genArriveActionVo({type=1,npcId=self.finishNpc}), 0);	
		end
	elseif self.status == Lua_TaskDefine.PROFESSION then
		if DataCenter.changeJobData.iscolorProfession == true or DataCenter.changeJobData.isProfession == true then	
		  	Lua_WindowUtil.openWin("Lua_RoleMainWindow", nil, 4); -- 打开转职界面
		  else
		  	if DataCenter.changeJobData.profession == 4 then
		  		Lua_WindowUtil.openWin("Lua_RoleMainWindow", nil, 4);
		  	else
		  		DataCenter.changeJobData:onQianWangClick()
		  	end
		  end
	end
end

--检查是否有特殊的执行处理
function Lua_TaskVo:doAction()	
	local curAction = nil;
	if self.status == Lua_TaskDefine.ACCEPT and self.config.before_accept ~= nil then
		curAction = self.config.before_accept.action;
	elseif self.status == Lua_TaskDefine.ACCEPTED  and self.config.after_accept ~= nil then 
		curAction = self.config.after_accept.action;
	elseif self.status == Lua_TaskDefine.DELIVERED and self.config.finish ~= nil then
		curAction = self.config.finish.action;
	end
	if  curAction == nil  then
		return false;
	end
	local actionStr = curAction;
	local actionArr = string.split(actionStr,"|");
	local type = actionArr[1];
	if type == "openui" then
		local openIdx = nil;
		if actionArr[3] ~= nil then
			openIdx = tonumber(actionArr[3]);
		end
		if "Lua_FactionDepotWindow" == actionArr[2] and DataCenter.roleData.leagueId == 0 then
			OperateAlert.show(LanUtil.getValue(122939));
			Lua_WindowUtil.openWin("Lua_FactionListWindow",WinParam.ACTION_OPEN);
			return;
		end
		if openIdx == -1 then
			Lua_WindowUtil.openWin(actionArr[2],WinParam.ACTION_OPEN,self);
		else
			Lua_WindowUtil.openWin(actionArr[2],WinParam.ACTION_OPEN,openIdx);
		end
		return true;
	elseif type == "event" then
		local tparam = nil ;
		if actionArr[3] ~= nil then
			tparam = actionArr[3] ;
		end
		Lua_MsgUtil.callFunc(actionArr[2],tparam);
		return true;
	elseif type == "guide" then
		Lua_WindowUtil.openWin("Lua_GuideWindow", nil, tonumber(actionArr[2]));
		return true;
	elseif type == "submitTask" then			
		cmd = getProtoMsg("Proto11400328");
		cmd.task_id = self.taskId;
		sendMsg(11400328,cmd);	
--		print("submitTask",cmd.task_id);
		return true;	
	end
	return false;
	
end
function Lua_TaskVo.Get:name()
	if self.config.name == nil and self.taskType == Lua_TaskDefine.PROFESSION then
		if DataCenter.roleData.profession == 4 then
			local taskId = Lua_CommonUtil.transChineseNumber(Lua_ChangeJobUtil.stage())
			return LanUtil.formateStr(LanUtil.getValue(110938),tostring(taskId))..Lua_ChangeJobUtil.stageTaskShow();	
		end
		local taskId = Lua_CommonUtil.transChineseNumber(DataCenter.roleData.profession+1)
		return LanUtil.formateStr(LanUtil.getValue(110933),tostring(taskId),tostring(DataCenter.roleData.taskStep),tostring(DataCenter.roleData.joblength))
		
	end
	return self.config.name;
end
function Lua_TaskVo.Get:afterAcceptScene()
	if self.afterAcceptDataArr == nil then		
--		print("self.config.after_accept.desc "..tostring(self.config.after_accept.desc));
		self.afterAcceptDataArr = string.split(self.config.after_accept.desc,",");
	end
	return tonumber(self.afterAcceptDataArr[2]);
end
function Lua_TaskVo.Get:afterAcceptTarget()
	if self.afterAcceptDataArr == nil and self.config.after_accept.desc ~= nil then
		self.afterAcceptDataArr = string.split(self.config.after_accept.desc,",");
	end
	if self._afterAcceptTarget == nil then
		local _afterAcceptTarget = self.afterAcceptDataArr[6];
		local sidx,eidx = string.find(_afterAcceptTarget,"%)",1);
		self._afterAcceptTarget = string.sub(_afterAcceptTarget,1,eidx-1);
	end
--	print("self._afterAcceptTarget "..tostring(self._afterAcceptTarget));
	return tonumber(self._afterAcceptTarget);
end
	
function Lua_TaskVo.Get:beforeAcceptScene()
	if self.beforeAcceptDataArr == nil and self.config.before_accept.desc ~= nil then
		self.beforeAcceptDataArr = string.split(self.config.before_accept.desc,",");
	end
	return tonumber(self.beforeAcceptDataArr[2]);
end

function Lua_TaskVo.Get:beforeAcceptCoord()
	if self._beforeAcceptCoord == nil and self.config.before_accept.desc ~= nil then
		local beforeAcceptDataArr = string.split(self.config.before_accept.desc,",");
		self._beforeAcceptCoord = Vector3(beforeAcceptDataArr[3],beforeAcceptDataArr[4],beforeAcceptDataArr[5]);
	end
	return self._beforeAcceptCoord ;
end
function Lua_TaskVo.Get:afterAcceptCoord()
	if self._afterAcceptCoord == nil and self.config.after_accept.desc ~= nil then
		local afterAcceptDataArr = string.split(self.config.after_accept.desc,",");
		self._afterAcceptCoord = Vector3(afterAcceptDataArr[3],afterAcceptDataArr[4],afterAcceptDataArr[5]);
	end
	return self._afterAcceptCoord ;
end
function Lua_TaskVo.Get:finishCoord()
	if self._finishCoord == nil and self.config.finish.desc ~= nil  then
		local finishDataArr = string.split(self.config.finish.desc,",");
		self._finishCoord = Vector3(finishDataArr[3],finishDataArr[4],finishDataArr[5]);
	end
	return self._finishCoord ;
end

--根据npcid 、当前任务状态，判断任务是否跟npc有关联
function Lua_TaskVo:checkTaskWithNpc(npcId)	
--	print("220 taskId"..tostring(self.taskId),self.finishNpc,npcId,self.status);
	if self.taskType == Lua_TaskDefine.PROFESSION then
		--转职任务特殊处理，跟npc没有关联，不检查npc
		return false;
	end
	if tostring(self.beforeAcceptNpc) == tostring(npcId) and self.status == Lua_TaskDefine.ACCEPT then
		return true;
	elseif tostring(self.finishNpc) == tostring(npcId) and ( self.status ==  Lua_TaskDefine.DELIVERED or self.status ==  Lua_TaskDefine.ACCEPTED) then
		return true;
	end
	return false;
end
function Lua_TaskVo.Get:beforeAcceptNpc()
	--[[if self.config == nil then
		print("nil taskId "..tostring(self.taskId));
	end--]]
	return self.config.before_accept.npc;
end
function Lua_TaskVo.Get:beforeAcceptDesc()
	if self._beforeAcceptDesc == nil  then 
		if self.config.before_accept.desc~= nil then
			self._beforeAcceptDesc = Lua_TaskVo.convertDataToDesc(self.config.before_accept.desc);
		else
			self._beforeAcceptDesc= "";
		end
	end
	return self._beforeAcceptDesc;
end

function Lua_TaskVo.Get:finishScene()
	if self.finishDataArr == nil and self.config.finish ~= nil and self.config.finish.desc ~= nil then
		self.finishDataArr = string.split(self.config.finish.desc,",");
	end
    if self.finishDataArr == nil then
        return nil;
    end
	return tonumber(self.finishDataArr[2]);
end
function Lua_TaskVo.Get:finishNpc()
	--[[if self.config.finish == nil then
		print("no finish taksId:"..tostring(self.taskId));
	end--]]
	if self.config.finish == nil then
		return 0;
	end
	return self.config.finish.npc;
end
function Lua_TaskVo.Get:afterAcceptDesc()
	if self._afterAcceptDesc == nil  then 
--		print("self.taskId ",self.taskId);
		if self.config.after_accept.desc~= nil then
			self._afterAcceptDesc = Lua_TaskVo.convertDataToDesc(self.config.after_accept.desc);
			local condLen = self.condList:getSize();
			for i=1,condLen do				
				local colorStr = self.condList[i].isFinish == true and "[00ff00]" or "[fd0000]";
				--subType 800  表示变强，需要显示战力进度
				if self.subType == 800 then
					local val = self.condList[i].value;
					val = tonumber(tostring(val));
					val = math.floor(val);
					local curVal  = val;
					if val > 10000 then
						local v = math.floor(val / 100);
						v =  v / 100;
						curVal = string.format("%.2f",v);
					end
					if self.only_show_curVal == 1 then
						self._afterAcceptDesc = LanUtil.formateStr(self._afterAcceptDesc, colorStr..curVal.."[-]");
					else
						self._afterAcceptDesc = LanUtil.formateStr(self._afterAcceptDesc, colorStr..curVal.."/"..Lua_CommonUtil.getNumberTrans(self.condList[i].final_value).."[-]");
					end
				else
					if self.only_show_curVal == 1 then
						self._afterAcceptDesc = LanUtil.formateStr(self._afterAcceptDesc, colorStr..tostring(self.condList[i].value).."[-]");
					else
						self._afterAcceptDesc = LanUtil.formateStr(self._afterAcceptDesc, colorStr..tostring(self.condList[i].value).."/"..tostring(self.condList[i].final_value).."[-]");
					end
				end
			end
		else
			self._afterAcceptDesc = "";
		end
	end
	return self._afterAcceptDesc;
end
function Lua_TaskVo.Get:finishDesc()
	if self._finishDesc == nil  then 		
		if self.config.finish~= nil and self.config.finish.desc~= nil then
			self._finishDesc = Lua_TaskVo.convertDataToDesc(self.config.finish.desc);
		else
            if getLanType() == 2 then
                if self.taskType == Lua_TaskDefine.ROUTINE and self.status ==Lua_TaskDefine.DELIVERED then
                    return "點擊領取獎勵";
                end
            end
			return "";
		end
	end
	return self._finishDesc;
end
function Lua_TaskVo.Get:acceptLevel()
	return self.config.before_accept.level[1];
end
function Lua_TaskVo.Get:conditionType()
	return self.config.exec.condition[1].type;
end
function Lua_TaskVo.Get:conditionTarget()
	return self.config.exec.condition[1].id[1];
end
function Lua_TaskVo.Get:conditionValue()
	return self.config.exec.condition[1].value;
end
function Lua_TaskVo.Get:conditionGrade()
--	print("self.config.exec.condition[1].grade "..tostring(self.config.exec.condition[1].grade));
	return self.config.exec.condition[1].grade;
end
function Lua_TaskVo.Get:conditionStar()
--	print("self.config.exec.condition[1].star "..tostring(self.config.exec.condition[1].star));
	return self.config.exec.condition[1].star;
end
function Lua_TaskVo.Get:conditionQuality()
--	print("self.config.exec.condition[1].quality "..tostring(self.config.exec.condition[1].quality));
	return self.config.exec.condition[1].quality;
end

function Lua_TaskVo.convertDataToDesc(cfgDesc)
	local rs ="";
	local sidx ,send= string.find(cfgDesc,"%(",1);
	if sidx ~= -1 and sidx ~= nil then
		local eidx ,eend= string.find(cfgDesc,"%)",sidx+1);
		rs = string.sub(cfgDesc,0,send-1);
		local ts,te = string.find(cfgDesc,"%,",1);
		if te ~= nil then
			rs = rs..string.sub(cfgDesc,sidx+1,te-1)..string.sub(cfgDesc,eidx+1);
		end
--		rs = rs.."[u]"..string.sub(cfgDesc,sidx+1,te-1).."[/u]"..string.sub(cfgDesc,eidx+1);
	else
		rs = cfgDesc;
	end

	rs = string.gsub(rs, "<", "(");
	rs = string.gsub(rs, ">", ")");
	return rs;
end
function Lua_TaskVo.Get:curDesc()
	if self.task_null == 1 then
		return "";
	end
	if self.status == Lua_TaskDefine.UNACCEPT then		
		--return LanUtil.formateStr(LanUtil.getValue(122929),tostring(self.config.before_accept.level[2]));
		if  self.config.before_accept.unaccept_desc ~= nil then			
			return self.config.before_accept.unaccept_desc;
		else
			return "";
		end
	elseif self.status == Lua_TaskDefine.ACCEPT  then
		return self.beforeAcceptDesc;
	elseif self.status ==  Lua_TaskDefine.ACCEPTED  then
		return self.afterAcceptDesc;
	elseif self.status ==  Lua_TaskDefine.DELIVERED   then
--		print("curDesc ",self.taskId);
		return self.finishDesc;
	elseif self.status ==  Lua_TaskDefine.PROFESSION   then
		if DataCenter.changeJobData.iscolorProfession == true  then
			if DataCenter.changeJobData.isProfession == true   then
				return  "[00E125]"..LanUtil.getValue(122937).."[-]";
			else
				return  "[00E125]"..LanUtil.getValue(122936).."[-]";
			end
		else
			if DataCenter.roleData.profession == #Lua_ChangeJobUtil.getConfig()  then
				return "";
			end
			return  Lua_ChangeJobUtil.tasktips(DataCenter.roleData.profession+1,DataCenter.roleData.taskStep);
		end
	end
	return "";
end

function Lua_TaskVo.Get:curUIDesc()
	if self.status == Lua_TaskDefine.ACCEPT or self.status == Lua_TaskDefine.UNACCEPT then
		return self.beforeAcceptUIDesc;
	elseif self.status ==  Lua_TaskDefine.ACCEPTED  then		
		return self.afterAcceptUIDesc;
	elseif self.status ==  Lua_TaskDefine.DELIVERED   then
		return self.finishUIDesc;
	end
	return "";
end

function Lua_TaskVo.Get:isAutoAccept()
	return  self.config.before_accept.auto_accept == 0 and false or true;
end
function Lua_TaskVo.Get:acceptTimes()
	return  self.config.before_accept.accept_times ;
end
function Lua_TaskVo.Get:acceptTimes()
	return  self.config.before_accept.accept_times ;
end
function Lua_TaskVo.Get:isAutoExecute()
	return self._isAutoExecute;
end
function Lua_TaskVo.Set:isAutoExecute(val)
	self._isAutoExecute = val;
end
	
function Lua_TaskVo.Get:vip_progress()
	if self.config.vip_progress == nil then
		return 0;
	end
	return self.config.vip_progress;
end
	

function Lua_TaskVo.Get:awardId()
	return self.config.award_id;
end
function Lua_TaskVo.Get:chapterData()	
	return self.config.chapter_data;		
end

function Lua_TaskVo.Get:scriptDegree()
	return self.config.script_degree;
end
function Lua_TaskVo.Get:scriptType()
	return self.config.script_type;
end
function Lua_TaskVo.Get:beforeAcceptUIDesc()
	if self._before_accept_ui_desc == nil and self.config.before_accept_ui_desc ~= nil  then 
		self._before_accept_ui_desc = self.config.before_accept_ui_desc;
	end
	return self._before_accept_ui_desc == nil and "" or self._before_accept_ui_desc;
end

function Lua_TaskVo.Get:afterAcceptUIDesc()
	if self._after_accept_ui_desc == nil and self.config.after_accept_ui_desc ~= nil  then 
		self._after_accept_ui_desc = self.config.after_accept_ui_desc;
	end
	return self._after_accept_ui_desc == nil and "" or self._after_accept_ui_desc;
end

function Lua_TaskVo.Get:finishUIDesc()
	if self._finish_ui_desc == nil and self.config.finish_ui_desc ~= nil  then 
		self._finish_ui_desc = self.config.finish_ui_desc;
	end	
	return self._finish_ui_desc == nil and "" or self._finish_ui_desc;
end

function Lua_TaskVo.Get:mirrorExecPos()
	if self._mirror_exec_pos == nil and self.config.exec.condition[1].mirror_exec_pos ~= nil  then 
		self._mirror_exec_pos = self.config.exec.condition[1].mirror_exec_pos ;
	end
	return self._mirror_exec_pos;
end
function Lua_TaskVo.Get:subType()
	if self._subType == nil then 
		if self.config.sub_type ~= nil then
			self._subType = self.config.sub_type;
		end		
	end
	return self._subType;
end
function Lua_TaskVo.Get:isFast()
	if self._isFast == nil then
		if self.config.exec ~= nil and self.config.exec.fast_finish ~= nil then
			self._isFast = self.config.exec.fast_finish.is_fast == 1 and true or false;
		end
	end
	return self._isFast;
end

function Lua_TaskVo.Get:fastFinishCostGold()
	if self._fastFinishCostGold == nil then
		if self.config.exec ~= nil and self.config.exec.fast_finish ~= nil then
			self._fastFinishCostGold  = self.config.exec.fast_finish.client_show_money;
		end
	end
	return self._fastFinishCostGold;
end
	
function Lua_TaskVo.Get:rountineStr()
	if self.taskType ~= Lua_TaskDefine.LEAGUE and self.taskType ~= Lua_TaskDefine.ROUTINE then
		return "";
	end
	return "("..tostring(self.routineIndex ).."/"..tostring(self.routineTotal)..")";
end
function Lua_TaskVo.Get:unacceptTips()
	if self.config.before_accept ~= nil then
		return self.config.before_accept.unaccept_tips;
	end
	return nil;
end
--副本结束时任务触发指引[script_type,script_degree,guide_id]
function Lua_TaskVo.Get:copyResultGuide()
	return self.config.copy_result_guide;
end
--执行任务是是否需要停止挂机
function Lua_TaskVo.Get:execDontStopHook()
	if self.config.exec_dont_stop_hook == nil or self.config.exec_dont_stop_hook == 0 then
		return false;
	end
	return true;
end

--当前状态是否需要显示小飞鞋
function Lua_TaskVo:curStatusShowFlyShoes()	
	if self.status == Lua_TaskDefine.ACCEPT and self.config.before_accept ~= nil then
		return self.config.before_accept.show_fly_shoes == 1 ;
	elseif self.status == Lua_TaskDefine.ACCEPTED and self.config.after_accept ~= nil then
		return self.config.after_accept.show_fly_shoes == 1 ;
	elseif self.status == Lua_TaskDefine.DELIVERED and self.config.finish ~= nil then
		return self.config.finish.show_fly_shoes == 1 ;
	end
	return false;
end
--当前状态是否显示小飞鞋特效
function Lua_TaskVo:curStatusShowFlyShoesEffect()
	if self.status == Lua_TaskDefine.ACCEPT and self.config.before_accept ~= nil then
		return self.config.before_accept.show_fly_shoes_eff == 1 ;
	elseif self.status == Lua_TaskDefine.ACCEPTED and self.config.after_accept ~= nil then
		return self.config.after_accept.show_fly_shoes_eff == 1 ;
	elseif self.status == Lua_TaskDefine.DELIVERED and self.config.finish ~= nil then
		return self.config.finish.show_fly_shoes_eff == 1 ;
	end
	return false;
end
function Lua_TaskVo:doTransfer()
	local targetSceneId =nil ;
	local targetCoord = nil;
	--根据状态判断获取传送的目标地图和坐标
	if self.status == Lua_TaskDefine.ACCEPT then
		targetSceneId = self.beforeAcceptScene;
		targetCoord = self.beforeAcceptCoord;
	elseif self.status == Lua_TaskDefine.ACCEPTED then
		targetSceneId = self.afterAcceptScene;
		targetCoord = self.afterAcceptCoord;
		if self.conditionType ==   Lua_TaskDefine.CONDITION_TYPE_SCENE or self.conditionType == Lua_TaskDefine.CONDITION_TYPE_LMAGE_KILL then
			if self.afterAcceptScene ~= DataCenter.roleData.sceneId then
				local mirrorExecPos = self.mirrorExecPos;
				targetSceneId = mirrorExecPos[1];
				targetCoord = Vector3(mirrorExecPos[2],mirrorExecPos[3],mirrorExecPos[4]);
			end
		end
	elseif self.status == Lua_TaskDefine.DELIVERED then
		targetSceneId = self.finishScene;
		targetCoord = self.finishCoord
	end
	if targetSceneId ~= nil and targetCoord ~= nil then
--		print("DataCenter.roleData.roleId",tonumber(DataCenter.roleData.roleId));
		local roleId = tonumber(DataCenter.roleData.roleId);
		local ac = WorldMapUtil.genArriveActionVo({type = 10,targetId = Lua_CommonUtil.trnsLongNum(roleId); });
		local code = DataCenter.roleData:tranceTo(tonumber(targetSceneId), tonumber(targetCoord.x), tonumber(targetCoord.y), tonumber(targetCoord.z), 0, 0, ac, 0);
		Lua_CommonUtil.removeTimer(self,self.exeTask);
--		print("code",code);
		if code == 2 then
			self.transEventKey = MsgUtil.addEventListener("MoveCompleteCallBack", self, self.moveCompleteCallBack);		
		elseif targetSceneId ~= DataCenter.roleData.sceneId then
			self.sceneLoadedCBKey = MsgUtil.addEventListener("SCENE_LOADED", self, self.onSceneLoaded);
		elseif code == 1 then
			self:moveCompleteCallBack();
		else
			Lua_MsgUtil.addEventListener("SCENEMAP_CANCLE_CLICKFLY",self,self.onTransferComplete);	
		end
		
	end
end

function Lua_TaskVo:onSceneLoaded()
--	print("Lua_TaskVo:onSceneLoaded");
	if self.sceneLoadedCBKey ~= nil then
		MsgUtil.removeEventListener("SCENE_LOADED",self.sceneLoadedCBKey);
		self.sceneLoadedCBKey = nil;
		self:onTransferComplete();
	end
end
--寻路完毕
function Lua_TaskVo:moveCompleteCallBack()
--	print("Lua_TaskVo:moveCompleteCallBack");
	if self.transEventKey ~= nil then
		MsgUtil.removeEventListener("MoveCompleteCallBack",self.transEventKey);
		self.transEventKey = nil;
	end
	Lua_CommonUtil.addTimer("delayExeTask",0.2,self,self.exeTask,nil,1);
	
end
--直接飞鞋传送完毕
function Lua_TaskVo:onTransferComplete()
--	print("Lua_TaskVo:onTransferComplete");
	Lua_MsgUtil.removeEventListener("SCENEMAP_CANCLE_CLICKFLY",self,self.onTransferComplete);		
	Lua_CommonUtil.addTimer("delayExeTask",0.2,self,self.exeTask,nil,1);
	
end

function Lua_TaskVo.Get:gotoPosFirst()
	if self.status == Lua_TaskDefine.UNACCEPT then		
		return self.config.before_accept.goto_pos_first;
	elseif self.status == Lua_TaskDefine.ACCEPT  then
		return self.config.before_accept.goto_pos_first;
	elseif self.status ==  Lua_TaskDefine.ACCEPTED  then		
		return self.config.after_accept.goto_pos_first;
	elseif self.status ==  Lua_TaskDefine.DELIVERED   then
		return self.config.finish.goto_pos_first;
	end
	return nil;
end
function Lua_TaskVo:gotoPosition()
	if self.gotoPosFirst == nil then
		return;
	end
	local posData = string.split(self.gotoPosFirst,",");
	local nextVo = WorldMapUtil.genArriveActionVo({type=12,taskId=self.taskId});
	WorldMapUtil.moveTo(posData[1], posData[2], posData[3], posData[4], 0, 0, nextVo, 0);
	--10103, 18797, -1164, 13334,
	--10103,17760,-302,13073
end
function Lua_TaskVo.Get:playDrama()
	return self.config.playDrama;
end

function Lua_TaskVo.Get:accept_win()
	return self.config.accept_win;
end

function Lua_TaskVo.Get:accept_effect()
	return self.config.accept_effect;
end

function Lua_TaskVo.Get:count_time()
	if self.config.count_time == nil then
		return 10;
	end
	return self.config.count_time;
end

function Lua_TaskVo.Get:limit_time()
	if self.config.limit_time == nil then
		return 1200;
	end
	return self.config.limit_time;
end

function Lua_TaskVo.Get:show_lv()
	if self.config.show_lv == nil then
		return 0;
	end
	return self.config.show_lv;
end

function Lua_TaskVo.Get:task_sort()
	if self:canShowArraow() == true then
		return self.arrow_sort;
	end
	if self.config.task_sort == nil then
		return 0;
	end
	return self.config.task_sort;
end

function Lua_TaskVo:canShowArraow()
	if self.config.arrow_levels == nil then
		return false;
	end
	if DataCenter.todayFirstLoaded == false then
		return false;
	end
	if self.taskType == Lua_TaskDefine.BRANCH 
		and DataCenter.taskData.taskClickDic[self.subType] ~= nil then
		return false;
	end
	local arrowLevels = self.config.arrow_levels;
	local lv = DataCenter.roleData.level;
	for i,v in ipairs(arrowLevels) do
		if v[1] <= lv and v[2] >= lv then
			return true;
		end
	end
	return false;
end

function Lua_TaskVo.Get:arrow_effect()
	if self.config.arrow_effect == nil then
		return nil;
	end
	return self.config.arrow_effect;
end

function Lua_TaskVo.Get:arrow_sort()
	if self.config.arrow_sort == nil then
		return 0;
	end
	return self.config.arrow_sort;
end

function Lua_TaskVo.Get:sound_id()
	return self.config.sound_id;
end

function Lua_TaskVo.Get:video_url()
	return self.config.video_url;
end

function Lua_TaskVo.Get:only_show_curVal()
	if self.config.only_show_curVal == nil then
		return 0;
	end
	return self.config.only_show_curVal;
end
