checkRequire("Lua_TaskData");
checkRequire("Lua_TaskVo");
Lua_TaskProxy = class("Lua_TaskProxy");
function Lua_TaskProxy:ctor()
	DataCenter.taskData = Lua_TaskData.new();

	LuaUtil.addLuaMsg(51400325, self, self.onTaskList); -- 获取任务列表（返回）
	LuaUtil.addLuaMsg(81400104, self, self.onUpdateTruckTask); -- 主线任务信息更新
	LuaUtil.addLuaMsg(81400203, self, self.onUpdatRoutineTask); -- 日常任务信息更新
	LuaUtil.addLuaMsg(51400351, self, self.onRoutineState); -- 请求环式任务状态信息（返回）
	LuaUtil.addLuaMsg(51403901, self, self.onUpdatProfessionTask); -- 转职任务
	LuaUtil.addLuaMsg(81400204, self, self.trackTaskAfterExitMirror); -- 镜像副本出来后继续做任务
	LuaUtil.addLuaMsg(81400206, self, self.onUpdateXianShiTask); -- 限时任务信息更新
	
	self.initTask = false;
	self.initSceneConfig = false;
	self.needExcuTask = false;
	self.tempMsgList = Array();
	self.tempXianShiList = Array();
	self.doingActDrama  = nil ;
	self.finishedDramaAct = true;
	
	MsgUtil.addEventListener("FINISH_ACT", self, self.finishDramaAct);
	MsgUtil.addEventListener("INIT_SCENE_CONFIG_OBJECT", self, self.onInitSceneConfigObject);
	MsgUtil.addEventListener("SCENE_CHANGE_IN_SAMEMAP", self, self.onSceneChangeInSameMap); -- 切换地图（剧情完了之后会下发这个消息）
	
	Lua_MsgUtil.addEventListener("MENU_OUT_CLICK", self, self.checkExitMirror); -- 检查是否退出镜像副本
	Lua_MsgUtil.addEventListener("SCENE_LOADED", self, self.onSceneLoaded); -- 场景切换完毕
end

function Lua_TaskProxy:onTaskList(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end

	if mp.errno == 0 then
		DataCenter.taskData:reset();
		local msg = ProtoPublic_pb.Proto51400325();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer51400325(msg);
		
		if self.tempXianShiList:getSize() > 0 then
			local tvo = DataCenter.taskData:getTaskById(self.tempXianShiList[1]);
			tvo.newTask = 1;
			if tvo.accept_win ~= nil then
				Lua_WindowUtil.openWin(tvo.accept_win,WinParam.ACTION_OPEN, tvo);
			end
			self.tempXianShiList:clear();
		end	
		Lua_MsgUtil.callFunc("TASK_LIST_INIT_COMPLETE");
		DataCenter.yunBiaoData:updateTaskState(false);
		Lua_MsgUtil.callFunc("TASK_UPDATE");
		
		self.initTask = true;
		self:onSceneChange();
	end
end

function Lua_TaskProxy:onSceneChange()
	if self.initTask == false or self.initSceneConfig == false then
		return;
	end
	
	local sceneId = DataCenter.roleData.sceneId;
	local npcs = getConfig({"scene", sceneId}).npc;
	if npcs ~= nil then
		for k,v in ipairs(npcs) do
			self:checkNpcEffect(v.id);
		end
	end
end

function Lua_TaskProxy:checkNpcEffect(npcId)
	if npcId == nil or npcId == 0 then
		return;
	end

	local tvo = DataCenter.taskData:checkTaskWithNpc(npcId);
	local npcPlayer = ThingUtil.instance:getThingById(tonumber(tostring(npcId)));
	if tvo~= nil and tvo.canDoTask == true then
		if npcPlayer ~= nil then
			if tvo.status == Lua_TaskDefine.ACCEPT then
				npcPlayer.taskEffect = 1;
			elseif tvo.status == Lua_TaskDefine.ACCEPTED then
				-- print(tvo.taskId, "npcEffect npdid", tonumber(tostring(npcId)));
				npcPlayer.taskEffect = 2;
			elseif tvo.status == Lua_TaskDefine.DELIVERED then
				npcPlayer.taskEffect = 3;
			else
				npcPlayer.taskEffect = -1;
			end
		end
	elseif tvo == nil then
		if npcPlayer ~= nil then
			npcPlayer.taskEffect = -1;
		end
	end
end

function Lua_TaskProxy:onUpdateTruckTask(mp)
	if self.initTask == false then
		self.tempMsgList:add(mp);
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81400104();
		msg:ParseFromString(mp.data);
		-- print("msg.task_info.type", msg.task_info.type, "taskId："..msg.task_info.task_id);
		-- print("Proto81400104 task_info.task_id", msg.task_info.task_id, "cmd：", msg.cmd, "type：", msg.task_info.type);
		DataCenter.taskData.isFinishGuide = msg.is_finish_guide;
		if msg.cmd == 1 or msg.cmd == 3 then -- 增加，更新
			local tvo = Lua_TaskVo.new(msg.task_info.task_id,msg.task_info.type);
			tvo:fromServer(msg.task_info);
			-- print("Proto81400104 "..msg.task_info.cond_list[1].value);
			local isChangeStatus = false;
			local curTask = DataCenter.taskData:getTaskByTypeAndId(msg.task_info.type,msg.task_info.task_id);
			if curTask~= nil and curTask.status ~= msg.task_info.status then
				isChangeStatus = true;
			end
			DataCenter.taskData:addTask(tvo);

			if tvo.status == Lua_TaskDefine.ACCEPT then
				self:checkNpcEffect(tvo.beforeAcceptNpc);
			elseif tvo.status == Lua_TaskDefine.ACCEPTED or tvo.status == Lua_TaskDefine.DELIVERED then
				self:checkNpcEffect(tvo.finishNpc);
			end

			if tvo.taskType == Lua_TaskDefine.TRUCK then
				-- 增加，或者任务状态变更时才进行自动执行任务操作
				-- print(tvo.taskId, "isChangeStatus", isChangeStatus, "msg.status："..msg.task_info.status);

				-- 出现功能开启弹窗时、指引需要停止移动时，都先不跑
				if self:isShowingUI() == false  and DataCenter.guideData.stopMoveToGuide == false then
					if (msg.cmd == 1 or isChangeStatus == true) and Lua_FuncOpenData.isInLimitScene() == false then
						if tvo.execDontStopHook == false then
							DataCenter.hook:stop(true);
							local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
							if rolePlayer ~= nil then
								rolePlayer.fightControl:cancelFight();
								rolePlayer:stopMove(true, true);
							end
						end
						self.needExcuTask = true;

						if tvo.gotoPosFirst ~= nil then
							tvo:gotoPosition();
						else
							Lua_CommonUtil.addTimer("delayExcuTask", 0.01, self, self.delayExcuTask, tvo, -1);
						end
					end
				end
			end
			if msg.task_info.status == Lua_TaskDefine.UNACCEPT then
				self:checkShowNeedtodoTips(msg.task_info.task_id);
			end
		elseif msg.cmd == 2 then -- 删除
			local removeTask = DataCenter.taskData:getTaskById(msg.task_info.task_id);
			if removeTask ~= nil and removeTask.playDrama ~= nil then
				self.doingActDrama = removeTask.playDrama;
				DataCenter.hook:stop(true);
				local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
				if rolePlayer ~= nil then
					rolePlayer.fightControl:cancelFight();
					rolePlayer:stopMove(true,true);
				end
				self.finishedDramaAct = false;
				ActingManager.getInstance():startAct(self.doingActDrama);
			end
			DataCenter.taskData:removeTask(msg.task_info.type, msg.task_info.task_id);

			if removeTask ~= nil then
				self:checkNpcEffect(removeTask.finishNpc);
			end
			if DataCenter.taskData.taskFinish:indexOf(msg.task_info.task_id) == -1 then
				DataCenter.taskData.taskFinish:add(msg.task_info.task_id);
				Lua_MsgUtil.callFunc("FINISH_TASK", msg.task_info.task_id);
			end

			--2018.6.19 需求：完成任务时触发配置的指引
			if removeTask ~= nil and removeTask.config.done_guide ~= nil then
				Lua_WindowUtil.openWin("Lua_GuideWindow", WinParam.ACTION_OPEN, removeTask.config.done_guide);
			end
		end
		Lua_MsgUtil.callFunc("TASK_UPDATE");
	end
end

function Lua_TaskProxy:isShowingUI()
	return Lua_WindowUtil.isWindowShowing("Lua_FuncOpenTipsPanel") or Lua_WindowUtil.isWindowShowing("Lua_FuncOpenModelPanel");
end

function Lua_TaskProxy:checkShowNeedtodoTips(taskId)
	local cfgIds = Lua_CommonUtil.getCommonConfig("show_needdo_task", 3);
	if cfgIds == nil then
		return;
	end

	local menu = getConfig({"scene", DataCenter.roleData.sceneId, "menu_item"});
	local forbbin = true;
	for i, v in ipairs(menu) do
		if v == Lua_MainMenuWindow.TASKANDTEAM_INDEX then
			forbbin = false;
			break;
		end
	end

	if forbbin == true then
		return;
	end

	local needShow = false;
	if taskId == -1 then
		needShow = true;
	else
		for k,v in ipairs(cfgIds) do
			if tonumber(v) == tonumber(taskId) then
				needShow = true;
				-- Lua_WindowUtil.openWin("Lua_NeedDoNowWindow", WinParam.ACTION_OPEN);
				break;
			end
		end
	end

	if needShow == true then
		local needDoList = DataCenter.taskData:getNeedDoList();
		-- 2018.6.21需求：只显示“环式任务”选项时，不显示Lua_NeedDoNowWindow, 显示独立的环式任务指引框
		if needDoList:getSize() == 1 and needDoList[1].func_id == 10026 then
			Lua_MsgUtil.callFunc("SHOW_ROUTINE_TASK_GUIDE_TIPS");
		else
			Lua_WindowUtil.openWin("Lua_NeedDoNowWindow", WinParam.ACTION_OPEN);
		end
	end
end

function Lua_TaskProxy:onUpdatRoutineTask(mp)
	if self.initTask == false then
		return;
	end

	if mp.errno == 0 then
		local showRoutineWinTask = nil;
		local msg = ProtoPublic_pb.Proto81400203();
		msg:ParseFromString(mp.data);
		if msg.cmd == 1 or msg.cmd == 3 then --增加，更新
			local taskCond = Lua_TaskCond.new();
			taskCond.index = msg.cond_index;
			taskCond.value= msg.cur_value;
			taskCond.final_value = msg.final_value;
			taskCond.cond_id = msg.cond_id;
			taskCond.cond_type = msg.cond_type;
			taskCond.kill_type = msg.kill_type;

			local tvo = Lua_TaskVo.new(msg.task_id,msg.type);
			tvo.status = msg.status;
			tvo.routineIndex = msg.routine_task_index;
			tvo.routineTotal = msg.total_routine_size;
			tvo.task_null = msg.task_null;
			tvo.isRoutine = 1;
			tvo.condList = Array();
			tvo.condList:add(taskCond);
			DataCenter.taskData:addTask(tvo);

			if msg.type == Lua_TaskDefine.ROUTINE then
				if tonumber(tvo.taskId) == Lua_TaskDefine.ROUNTINE_FINISH_TASK then
					showRoutineWinTask = tvo;
				elseif getLanType()==2 and msg.status==Lua_TaskDefine.DELIVERED then
					showRoutineWinTask = tvo;
				end
			end

			-- 超过配置vip 等级时，接到任务后就自动执行 -- or (msg.cmd == 3 and msg.type == Lua_TaskDefine.ROUTINE)
			if msg.cmd == 1 and (msg.type == Lua_TaskDefine.LEAGUE or msg.type == Lua_TaskDefine.ROUTINE)
				and Lua_FuncOpenData.isInLimitScene() == false and tvo.execDontStopHook == false then
				-- print("tvo.id", tvo.taskId);
				if GlobalVar.hooking == true then
					DataCenter.hook:stop(true);
				end

				local  isAutoExecute = self:chechAutoExec(tvo);
				local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
				if isAutoExecute == true and rolePlayer ~= nil then
					rolePlayer.fightControl:cancelFight();
					rolePlayer:stopMove(true, true);
				end

				if isAutoExecute == true then
					tvo.isAutoExecute = true;
					self.needExcuTask = true;
					Lua_CommonUtil.removeTimer(self,self.delayExcuTask);
					Lua_CommonUtil.addTimer("delayExcuTask", 0.01, self, self.delayExcuTask, tvo, -1);
				end
			end
		-- end
		elseif msg.cmd == 2 then -- 删除
			DataCenter.taskData:removeTask(msg.type, msg.task_id);
		end
		
		Lua_MsgUtil.callFunc("TASK_UPDATE");
		if showRoutineWinTask ~= nil then
			local tlist = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
			if tlist ~= nil and tlist:getSize() > 0 and tlist[1].status == Lua_TaskDefine.UNACCEPT then
				self:checkShowNeedtodoTips(-1);
			end
			Lua_WindowUtil.openWin("Lua_DailyRoutineWindow", WinParam.ACTION_OPEN, showRoutineWinTask);
		end
	end
end

function Lua_TaskProxy:chechAutoExec(taskVo)
	local isAutoExecute = false;
	local leagueAutoVipLv = getConfig({"vip_level", DataCenter.roleData.vipType, "auto_leahue_task"});
	-- print("leagueAutoVipLv", leagueAutoVipLv);
	if taskVo.taskType == Lua_TaskDefine.LEAGUE and leagueAutoVipLv == 1 and DataCenter.vipData.isExpired == false then
		isAutoExecute = true;
	elseif taskVo.taskType == Lua_TaskDefine.ROUTINE  and taskVo.status ~= Lua_TaskDefine.ACCEPT then 
		local roleLv = DataCenter.roleData.level;
		-- 人物等级没有超过这个配置等级的话，会做完每一环任务后自动检查主线任务是否可以做，可以做的话，就不自动跑下一环日常任务了
		local checkLv = Lua_CommonUtil.getCommonConfig("routine_finish_excu_truck_lv",1);
		if roleLv <= checkLv then
			local tlist = DataCenter.taskData:getListByType(Lua_TaskDefine.TRUCK);
			if tlist:getSize() > 0 then
				isAutoExecute = tlist[1].status == Lua_TaskDefine.UNACCEPT;
			else
				isAutoExecute = true;
			end
		else
			isAutoExecute = true;
		end
	end
	return isAutoExecute;
end

function Lua_TaskProxy:onRoutineState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400351();
		msg:ParseFromString(mp.data);
		DataCenter.taskData:fromServer51400351(msg);
	end
end

function Lua_TaskProxy:onUpdatProfessionTask(mp)
	if DataCenter.changeJobData.professionShow == false or DataCenter.changeJobData.isShow == true then
		return;
	end
	if mp.errno == 0 then
	end
end

function Lua_TaskProxy:trackTaskAfterExitMirror(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81400204();
		msg:ParseFromString(mp.data);

		local tlist = DataCenter.taskData:getListByType(msg.task_type);
		if tlist ~= nil and tlist:getSize() > 0 then
			-- 提交装备任务不需要延时弹出了，不然menu菜单按钮有可能点不了
			if tlist[1].conditionType ~= Lua_TaskDefine.CONDITION_TYPE_SUBMIT then
				Lua_CommonUtil.addTimer("trackTaskAfterExitMirror", 1, self, self.delayExcuTaskAfterExitMirror, tlist[1], 1);
			end
		end
	end
end

function Lua_TaskProxy:delayExcuTaskAfterExitMirror(taskVo)
	if taskVo ~= nil then
		taskVo:exeTask();
	end
end

function Lua_TaskProxy:onUpdateXianShiTask(mp)
	if DataCenter.configLoaded ~= 1 then
		local msg = ProtoPublic_pb.Proto81400206();
		msg:ParseFromString(mp.data);
		if msg.cmd == 1 and msg.status == Lua_TaskDefine.ACCEPT then
			self.tempXianShiList:add(msg.task_id);
		end
		return;
	end

	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81400206();
		msg:ParseFromString(mp.data);
		if msg.cmd == 1 or msg.cmd == 3 then -- 增加，更新
			local taskCond = Lua_TaskCond.new();
			taskCond.index = msg.cond_index;
			taskCond.value= msg.cur_value;
			taskCond.final_value = msg.final_value;
			taskCond.cond_id = msg.cond_id;
			taskCond.cond_type = msg.cond_type;
			taskCond.kill_type = msg.kill_type;

			local tvo = Lua_TaskVo.new(msg.task_id,msg.type);
			tvo.status = msg.status;
			tvo.time = msg.time;
			tvo.task_time = msg.timeout;
			tvo.condList = Array();
			tvo.condList:add(taskCond);
			if msg.cmd == 1 then
				tvo.newTask = 1;
			end

			DataCenter.taskData:addTask(tvo);
			if msg.cmd == 1 and (msg.status == Lua_TaskDefine.ACCEPT) and tvo.accept_win ~= nil then
				Lua_WindowUtil.openWin(tvo.accept_win,WinParam.ACTION_OPEN, tvo);
			end
		elseif msg.cmd == 2 then -- 删除
			DataCenter.taskData:removeTask(msg.type, msg.task_id);
		end
		Lua_MsgUtil.callFunc("TASK_UPDATE");
	end
end





function Lua_TaskProxy:finishDramaAct(actId)
	if tonumber(self.doingActDrama) == tonumber(actId) then
		self.finishedDramaAct = true;
	end
end

function Lua_TaskProxy:onInitSceneConfigObject()
	self.initSceneConfig = true;
	self:onSceneChange();
end

function Lua_TaskProxy:onSceneChangeInSameMap()
	-- 正在执行的剧情不为空 并且 剧情动作结束
	if self.doingActDrama ~= nil and self.finishedDramaAct == true then
		DataCenter.taskData:execTruckTask();
		self.doingActDrama = nil;
	end
end

function Lua_TaskProxy:checkExitMirror()
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneCfg == nil then
		return;
	end

	if sceneCfg.isMirrorMap == true then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122932), type = 1, subFun = self.onOutClick});
	end
end

function Lua_TaskProxy:onOutClick()
	sendMsg(10400902);
	DataCenter.hook:stop();
end

function Lua_TaskProxy:onSceneLoaded()
	local sceneId = DataCenter.roleData.sceneId;
	local menuItem = getConfig({"scene", sceneId, "menu_item"});
	local forbbin = true;
	for i, v in ipairs(menuItem) do
		if v == Lua_MainMenuWindow.TASKANDTEAM_INDEX then
			forbbin = false;
			break;
		end
	end
	if forbbin == true and Lua_WindowUtil.isWindowShowing("Lua_NeedDoNowWindow") == true then
		Lua_WindowUtil.openWin("Lua_NeedDoNowWindow", WinParam.ACTION_CLOSE);
	end
end





function Lua_TaskProxy:clearDelayExcuTask()
	Lua_CommonUtil.removeTimer(self, self.delayExcuTask);
end

function Lua_TaskProxy:delayExcuTask(taskVo)
	if self.needExcuTask == false then
		return;
	end

	local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	if rolePlayer == nil or rolePlayer:roleCanMove() == false then
		return;
	end
	rolePlayer:stopMove(true,true);
	rolePlayer.fightControl:forceClearNextSkill();
	rolePlayer.fightControl:cancelFight();

	self.needExcuTask = false;
	Lua_CommonUtil.removeTimer(self, self.delayExcuTask);
	if taskVo ~= nil then
		taskVo:exeTask();
	end
end