
checkRequire("Lua_TeamMemberVo");
Lua_TeamData = class("Lua_TeamData");
function Lua_TeamData:ctor()
    self:dispose();
end
function Lua_TeamData:dispose()
    self.teamerArr = Array();
    self.shenQingArr = Array();
    self.yaoQingArr = Array();
    self.auto_refuse = 0;
    self.auto_accept = 0;
    self.isMatch = false;
    self.no_team = nil;
    self.saveLevel = { };
end
function Lua_TeamData:setSaveData(tid, minLv, maxLv)
    self.saveLevel[tid] = { minLv = minLv, maxLv = maxLv };
end
function Lua_TeamData.Get:isTeamFull()
    if self.hasTeam == false then
        return false;
    end
    return self.teamerArr:getSize() >= 3;
end
function Lua_TeamData.Get:hasTeam()
    if self.no_team == nil or self.no_team == 1 then
        return false;
    else
        return true;
    end
end
function Lua_TeamData:enterCopy(copyId, copyDif)
    local cmd = ProtoPublic_pb.Proto10100325();
    cmd.script_type = copyId;
    cmd.script_degree = copyDif;
    sendMsg(10100325, cmd);
    DataCenter.copyInfoData:clear();
end
function Lua_TeamData.Get:amILeader()
    if self.hasTeam and self.leader_id == DataCenter.roleData.roleId then
        return true;
    else
        return false;
    end
end
--[[是否可以匹配玩家化身]]
function Lua_TeamData:canMathPlayerCopy()
    if self.targetVo == nil or self.targetVo.team_type ~= 3 then
        return false;
    end
    local copyVo = DataCenter.copyData:getCopyById(self.targetVo.script_type);
    if copyVo:getMateType(self.targetVo.script_degree) ~= 1 then
        return false;
    end
    local maxLv = getConfig({"team", "mate_level"});
    if self.hasTeam == false then
        if DataCenter.roleData.level > maxLv then
            return false;
        end
    else
        if self.leaderLv > maxLv then
            return false;
        end
    end
    
    return true;
end
function Lua_TeamData:from80400306(msg)
    self.leader_id = tonumber(msg.leader_id);
    local memberList = { };

    for i, v in ipairs(msg.teamer_set) do
        local fid = tonumber(v.role_id);
        memberList[fid] = 1;
        local vo = self:getTeamMember(fid);
        if vo == nil then
            vo = Lua_TeamMemberVo.new();
            self.teamerArr:add(vo);
        end
        vo:fromServer(v);
        vo.isLeader = fid == self.leader_id;
        if vo.isLeader == true then
            self.leaderLv = vo.role_level;
        end
    end
    local index = 1;
    while true do
        if index > self.teamerArr:getSize() then
            break;
        end
        local vo = self.teamerArr[index];
        if memberList[vo.role_id] == nil then
            self.teamerArr:remove(index);
        end
        index = index + 1;
    end

    self.team_state = msg.team_state;
    self.no_team = msg.no_team;
    self.team_info = msg.team_info;
    
    -- 1普通组队，2野外组队，3副本组队
    -- print("Lua_TeamData", self.team_info.team_type);
    if self.no_team ~= 1 then
        if self.team_info.team_type == 1 then
            self:setTeamTargetByTeamType(self.team_info.team_type, false);
        elseif self.team_info.team_type == 2 then
            self:setTeamTargetByTeamType(self.team_info.team_type, false);
        else
            self:setTeamTargetByCopy(self.team_info.script_type, self.team_info.script_degree, false);
        end
    end

    self.minLv = msg.team_info.level_low;
    self.maxLv = msg.team_info.level_upper;
end
function Lua_TeamData:setTeamTargetByTeamType(t, changeLv)
    self.targetVo = self:getTargetByTeamType(t);
    if changeLv == true then
        if self.saveLevel[self.targetVo.id] == nil then
            self.minLv = 1;
            self.maxLv = Lua_ThingDefine.getMaxLevel();
        else
            local svo = self.saveLevel[self.targetVo.id];
            self.minLv = svo.minLv;
            self.maxLv = svo.maxLv;
        end
    end
end
function Lua_TeamData:setTeamTargetByCopy(copy_script, copy_degree, changeLv)
    self.targetVo = self:getTargetByCopy(copy_script, copy_degree);
    if changeLv == true then
        if self.saveLevel[self.targetVo.id] == nil then
            local cvo = DataCenter.copyData:getCopyById(copy_script);
            self.minLv = cvo:getCopyMinLv(copy_degree);
            self.maxLv = Lua_ThingDefine.getMaxLevel();
        else
            local svo = self.saveLevel[self.targetVo.id];
            self.minLv = svo.minLv;
            self.maxLv = svo.maxLv;
        end
    end
end
function Lua_TeamData:getTeamMember(id)
    local len = self.teamerArr:getSize();
    for i = 1, len do
        if self.teamerArr[i].role_id == id then
            return self.teamerArr[i];
        end
    end
    return nil;
end
function Lua_TeamData:from80400401(msg)
    local fid = tonumber(msg.fighter_id);
    local vo = self:getTeamMember(fid);
    if vo ~= nil then
        vo.blood = tonumber(msg.blood);
        vo.max_blood = tonumber(msg.max_blood);
    end
end
function Lua_TeamData:fromTeamerState(msg)
    local fid = tonumber(msg.role_id);
    local vo = self:getTeamMember(fid);
    if vo ~= nil then
        vo.nearby = msg.scene == DataCenter.roleData.sceneId;
        vo.alive = msg.alive;
        vo.online_flag = msg.online;
    end
end
function Lua_TeamData.Get:isNear()
    local len = self.teamerArr:getSize();
    for i = 1, len do
        if self.teamerArr[i].nearby == false then
            return false;
        end
    end
    return true;
end

function Lua_TeamData:getTargetList(win, showAll)
    if self.targetList == nil then
        local arr = Array();
        local t = getConfig( { "teamTarget" });
        for k, v in pairs(t) do
            v.id = tonumber(k);
            arr:add(v);
        end
        arr:sort("priority");
        self.targetList = arr;
    end
    local outList = Array();
    local len = self.targetList:getSize();
    for i = 1, len do
        if win ~= true or self.targetList[i].show_in_win == 1 then
            if self.targetList[i].team_type == 3 then
                local cvo = DataCenter.copyData:getCopyById(self.targetList[i].script_type);
                local l = cvo:getCopyMinLv(self.targetList[i].script_degree);
                if l <= DataCenter.roleData.level or showAll == true then
                    outList:add(self.targetList[i]);
                end
            else
                outList:add(self.targetList[i]);
            end
        end
    end
    return outList;
end
function Lua_TeamData:getTargetById(id)
    local list = self:getTargetList(false, true);
    for i = 1, list:getSize() do
        if list[i].id == id then
            return list[i];
        end
    end
    return nil;
end
function Lua_TeamData:getTargetByTeamType(t)
    local list = self:getTargetList(false, true);
    for i = 1, list:getSize() do
        if list[i].team_type == t then
            return list[i];
        end
    end
    return nil;
end
function Lua_TeamData:getTargetByCopy(cid, degree)
    local list = self:getTargetList(false, true);
    for i = 1, list:getSize() do
        if list[i].script_type == cid and list[i].script_degree == degree then
            return list[i];
        end
    end
    return nil;
end

function Lua_TeamData:quitTeam()
    if self.hasTeam == false then
        return;
    end
    sendMsg(10100306);
end

function Lua_TeamData:createTeam()
    if self.hasTeam == true then
        OperateAlert.show(LanUtil.getValue(122230));
        return;
    end
    local cmd = ProtoPublic_pb.Proto10100302();
    cmd.team_type = self.targetVo.team_type;
    cmd.level_low = self.minLv;
    cmd.lelev_upper = self.maxLv;
    cmd.script_type = self.targetVo.script_type;
    cmd.script_degree = self.targetVo.script_degree;
    sendMsg(10100302, cmd);
end
function Lua_TeamData:addYaoQing(v)
    for i = 1, self.yaoQingArr:getSize() do
        if self.yaoQingArr[i].role_id == v.role_id then
            return false;
        end
    end
    self.yaoQingArr:add(v);
    while true do
        if self.yaoQingArr:getSize() < 20 then
            break;
        end
        self.yaoQingArr:remove(0);
    end
    return true;
end
function Lua_TeamData:removeYaoQing(v)
    for i = 1, self.yaoQingArr:getSize() do
        if self.yaoQingArr[i].role_id == v.role_id then
            self.yaoQingArr:remove(i);
            return;
        end
    end
end
function Lua_TeamData:addShenQing(v)
    for i = 1, self.shenQingArr:getSize() do
        if self.shenQingArr[i].role_id == v.role_id then
            return false;
        end
    end
    self.shenQingArr:add(v);
    while true do
        if self.shenQingArr:getSize() < 20 then
            break;
        end
        self.shenQingArr:remove(0);
    end
    return true;
end
function Lua_TeamData:removeShenQing(v)
    for i = 1, self.shenQingArr:getSize() do
        if self.shenQingArr[i].role_id == v.role_id then
            self.shenQingArr:remove(i);
            return;
        end
    end
end
function Lua_TeamData:onOutTeam()
    self.shenQingArr:clear();
    self.no_team = 1;
    self.teamerArr:clear();
    self.leader_id = 0;
end
function Lua_TeamData:getAddExp()
    if self.hasTeam == false then
        return getConfig( { "team", "exp_addition", 1 });
    else
        local num = 0;
        local len = self.teamerArr:getSize();
        for i = 1, len do
            if tonumber(self.teamerArr[i].role_id) == DataCenter.roleData.roleId then
                num = num + 1;
            else
                if self.teamerArr[i].nearby == true then
                    num = num + 1;
                end
            end
        end
        return getConfig( { "team", "exp_addition", num + 1 });
    end
end