checkRequire("Lua_TeamData");
Lua_TeamProxy = class("Lua_TeamProxy");
function Lua_TeamProxy:ctor()
	self:superCall("ctor");
	DataCenter.teamData = Lua_TeamData.new();

	LuaUtil.addLuaMsg(80400306, self, self.onTeamInfo);
	LuaUtil.addLuaMsg(80400310, self, self.onTeamActBack);
	LuaUtil.addLuaMsg(80400401, self, self.onTeamMemberInfo);
	LuaUtil.addLuaMsg(80400402, self, self.onTeamMemberStatue);
	LuaUtil.addLuaMsg(80400308, self, self.onTeamKick);
	LuaUtil.addLuaMsg(80400309, self, self.onTeamAct);--收到申请或者邀请
	LuaUtil.addLuaMsg(80100312, self, self.onTeamPress);--队员催促
	LuaUtil.addLuaMsg(80100313, self, self.onTeamAutoState);
	LuaUtil.addLuaMsg(80100302, self, self.onTeamReconfig);--队员进入副本确认
	LuaUtil.addLuaMsg(80100303, self, self.onTeamRefuse);--队员拒绝进入副本
	LuaUtil.addLuaMsg(80100304, self, self.onTeamCopyError);--副本进入错误
	LuaUtil.addLuaMsg(80100310, self, self.onTeamMatch);--匹配状态更新

	LuaUtil.addLuaMsg(80100305, self, self.onTeamMatchNumber);--匹配人数

	LuaUtil.addLuaMsg(50100322, self, self.onTeamAutoYaoQing);
	LuaUtil.addLuaMsg(50100323, self, self.onTeamAutoShenQing);
	LuaUtil.addLuaMsg(50100324, self, self.onTeamInviteList);
	LuaUtil.addLuaMsg(50100313, self, self.onTeamList);
	LuaUtil.addLuaMsg(50100307, self, self.onTeamActResult);
	LuaUtil.addLuaMsg(50100302, self, self.onTeamCreateResult);

	Lua_MsgUtil.addEventListener("UPDATE_TEAM_TIP_STATE", self, self.checkShowTeamTip);
end
function Lua_TeamProxy:onTeamInfo(mp)
	if DataCenter.configLoaded ~= 1 then
		return;
	end
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400306();
		msg:ParseFromString(mp.data);
		DataCenter.teamData:from80400306(msg);
		Lua_MsgUtil.callFunc("TEAM_INFO_UPDATE");
	end
end
function Lua_TeamProxy:onTeamCreateResult(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(122244));
	end
end
function Lua_TeamProxy:onTeamActBack(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400310();
		msg:ParseFromString(mp.data);
		local s = 0;
		if msg.oper_type == 0 then--表示邀请对方进入队伍
			if msg.oper_result == 0 then
				s = 122201;
			elseif msg.oper_result == 1 then
				s = 122202;
			end
		elseif msg.oper_type == 1 or msg.oper_type == 2 then--表示申请加入对方组队 --表示副本申请加入对方队
			if msg.oper_result == 0 then
				s = 122203;
			elseif msg.oper_result == 1 then
				s = 122204;
			end
		end
		if s ~= 0 then

			local str = LanUtil.formateStr(LanUtil.getValue(s),msg.oper_name);
			OperateAlert.show(str);
		end
	end
end
function Lua_TeamProxy:onTeamMemberInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400401();
		msg:ParseFromString(mp.data);
		DataCenter.teamData:from80400401(msg);
		local fid = tonumber(msg.fighter_id);
		Lua_MsgUtil.callFunc("TEAMMEMBER_INFO_UPDATE", fid);
	end
end
function Lua_TeamProxy:onTeamMemberStatue(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400402();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.states) do
			DataCenter.teamData:fromTeamerState(v);
		end
		Lua_MsgUtil.callFunc("TEAM_INFO_UPDATE");
	end
end
function Lua_TeamProxy:onTeamInviteList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100324();
		msg:ParseFromString(mp.data);
		DataCenter.KuaFuData.isKuaFuTeam = false;
		Lua_WindowUtil.openWin("Lua_TeamInviteWindow", WinParam.ACTION_OPEN, msg);
	end
end
function Lua_TeamProxy:onTeamList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100313();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("TEAM_LIST_UPDATE", msg);
	end
end
function Lua_TeamProxy:onTeamAct(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400309();
		msg:ParseFromString(mp.data);
		local v = {};
		v.role_id = tonumber(msg.role_id);
		v.role_name = msg.role_name;
		v.role_level = msg.role_level;
		v.fight_force = msg.fight_force;
		v.league_name = msg.league_name;
		v.career = msg.career;
		v.team_goal = msg.team_goal;
		v.profession = msg.profession;
		v.head_frame = msg.head_frame;
		v.role_head_name = msg.role_head_name;
		v.start_time = getTime();
		if msg.oper_type == 0 then
			local rs = DataCenter.teamData:addYaoQing(v);
			if rs == true then
				Lua_MsgUtil.callFunc("TEAM_YAOQING_UPDATE", msg);
			end
		else
			local rs = DataCenter.teamData:addShenQing(v);
			if rs == true then
				Lua_MsgUtil.callFunc("TEAM_SHENQING_UPDATE", msg);
			end
		end
		self:checkShowTeamTip();
		if self.isRunning ~= true then
			self.isRunning = true;
			Lua_CommonUtil.addTimer("ct", 0.8, self, self.onCheckTeamTip);
		end
	end
end

function Lua_TeamProxy:onCheckTeamTip()
	local td = DataCenter.teamData;
	if td == nil then
		self.isRunning = false;
		Lua_CommonUtil.removeTimer(self, self.onCheckTeamTip);
		return;
	end
	local nt = getTime();
	local c = 1;
	local ot = Lua_CommonUtil.getCommonConfig("team_out_time", 1);
	while true do
		if c <= td.shenQingArr:getSize() then
			if nt - td.shenQingArr[c].start_time > ot then
				td.shenQingArr:remove(c);
				c = c - 1;
			end
			c = c + 1;
		else
			break;
		end
	end
	c = 1;
	while true do
		if c <= td.yaoQingArr:getSize() then
			if nt - td.yaoQingArr[c].start_time > ot then
				td.yaoQingArr:remove(c);
				c = c - 1;
			end
			c = c + 1;
		else
			break;
		end
	end
	if td.shenQingArr:getSize() == 0 and td.yaoQingArr:getSize() == 0 then
		self.isRunning = false;
		Lua_CommonUtil.removeTimer(self, self.onCheckTeamTip);
	end
	self:checkShowTeamTip();
end

function Lua_TeamProxy:checkShowTeamTip(go)
	if DataCenter.teamData.hasTeam == false then
		if DataCenter.teamData.yaoQingArr:getSize() > 0 then
			local msg = {};
			msg.type = Lua_MenuTipData.TEAM_INVITE;
			msg.altas = "icon_atlas_5";
			msg.spriteName = "activity_small_tips_zd";
			msg.state = 1;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		else
			local msg = {};
			msg.type = Lua_MenuTipData.TEAM_INVITE;
			msg.state = 0;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		end
	else
		if DataCenter.teamData.shenQingArr:getSize() > 0 and DataCenter.teamData.amILeader then
			local msg = {};
			msg.type = Lua_MenuTipData.TEAM_INVITE;
			msg.altas = "icon_atlas_5";
			msg.spriteName = "activity_small_tips_zd";
			msg.state = 1;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		else
			local msg = {};
			msg.type = Lua_MenuTipData.TEAM_INVITE;
			msg.state = 0;
			Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
		end
	end
end
function Lua_TeamProxy:onTeamPress(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(122234));
	end
end
function Lua_TeamProxy:onTeamActResult(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(122236));
	end
end
function Lua_TeamProxy:onTeamKick(mp)
	if mp.errno == 0 then
		DataCenter.teamData:onOutTeam();
		Lua_MsgUtil.callFunc("TEAM_INFO_UPDATE");
	end
end
function Lua_TeamProxy:onTeamAutoYaoQing(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100322();
		msg:ParseFromString(mp.data);
		DataCenter.teamData.auto_refuse = msg.status;
	end
	
end
function Lua_TeamProxy:onTeamAutoShenQing(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100323();
		msg:ParseFromString(mp.data);
		DataCenter.teamData.auto_accept = msg.status;
	end
end
function Lua_TeamProxy:onTeamAutoState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100313();
		msg:ParseFromString(mp.data);
		local td = DataCenter.teamData;
		td.auto_refuse = msg.auto_refuse;
		td.auto_accept = msg.auto_accept;
	end
end
function Lua_TeamProxy:onTeamReconfig(mp)
	if mp.errno == 0 then
		local td = DataCenter.teamData;
		if td.hasTeam == false or td.amILeader == true then
			return;
		end

		local msg = ProtoPublic_pb.Proto80100302();
		msg:ParseFromString(mp.data);
		local copyVo = DataCenter.copyData:getCopyById(msg.script_type);
		if copyVo:getCopyMinLv(msg.script_degree) > DataCenter.roleData.level then
			return;
		end
		
		for i,v in ipairs(msg.agree_list) do
			if DataCenter.roleData.roleId == tonumber(v.role_id) then
				return;
			end
		end
		Lua_WindowUtil.openWin("Lua_TeamCommiteWindow", WinParam.ACTION_OPEN, msg.left_tick);
	end
end
function Lua_TeamProxy:onTeamRefuse(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100303();
		msg:ParseFromString(mp.data);

		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122246), msg.name));
	end
end
function Lua_TeamProxy:onTeamCopyError(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100304();
		msg:ParseFromString(mp.data);
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121144), msg.name));
	end
end
function Lua_TeamProxy:onTeamMatch(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100310();
		msg:ParseFromString(mp.data);
		-- if msg == true then
		-- 	DataCenter.teamData.isMatch = msg.mate;
		-- else
			DataCenter.teamData.isMatch = msg.mate;
			DataCenter.teamData.matchTime = msg.tick;
			DataCenter.teamData.matchStartTime = getTime();
		-- end
		Lua_MsgUtil.callFunc("TEAM_INFO_UPDATE");
	end
end

function Lua_TeamProxy:onTeamMatchNumber(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100305();
		msg:ParseFromString(mp.data);
		local td = DataCenter.teamData;
		td.mate_amount = msg.mate_amount;
		Lua_MsgUtil.callFunc("TEAM_MATCH_NUMBER");
	end
end

--组队目标
function Lua_TeamProxy:sSetTeamTarget(teamType, minLv, maxLv, copyType, degree)
	local cmd = ProtoPublic_pb.Proto10100311();
    cmd.team_type = teamType;
    cmd.level_low = minLv;
    cmd.level_upper = maxLv;
    cmd.script_type = copyType;
    cmd.script_degree = degree;
    sendMsg(10100311, cmd);
end

-- 邀请&申请
function Lua_TeamProxy:sInviteAndApplyTeam(role_id, teamType)
    local cmd = ProtoPublic_pb.Proto10100307();
    cmd.role_id = role_id;
    cmd.type = teamType;
    sendMsg(10100307, cmd);
end