-- 天选之战配置
Lua_TheSelectionWarUtil = class("Lua_TheSelectionWarUtil");
function Lua_TheSelectionWarUtil:ctor()
end

-- 常量配置，赛季奖励参战次数
function Lua_TheSelectionWarUtil.Get:sports_rank_num()
	return getConfig({"theaven_const", "sports_rank_num", "value"});
end

-- 购买次数对应元宝
function Lua_TheSelectionWarUtil.Get:gold_times()
	return getConfig({"theaven_const", "gold_times", "arr"});
end

-- 场次奖励
function Lua_TheSelectionWarUtil.Get:box_index()  
    return getConfig({"theaven_const", "box_index", "arr"});
end

-- 免费次数
function Lua_TheSelectionWarUtil.Get:max_free_times()  
	return getConfig({"theaven_const", "free_times", "value"});
end

-- 自动关闭Tips界面时间
function Lua_TheSelectionWarUtil.Get:getCloseSenceTime()
	return getConfig({"theaven_const", "countdown_time", "value"});
end 

-- 最大场次
function Lua_TheSelectionWarUtil.Get:max_box_index()
    return self.box_index[tonumber(#self.box_index)];
end

-- 购买次数价格
function Lua_TheSelectionWarUtil:gold_times()
	if self.goldArr == nil then
		self.goldArr = Array();

		local list = getConfig({"theaven_const", "gold_times", "arr"});
		if list ~= nil then
			for i = 1, #list do
				self.goldArr:add(list[i]);
			end
		end
	end
	return self.goldArr;
end

-- 获取段位
function Lua_TheSelectionWarUtil:getPalyDan(id)
	return getConfig({"theaven_grade", id, "name"});
end

-- 获取段位每日荣誉奖励
function Lua_TheSelectionWarUtil:getHonorReward(id)
	if id == 0 or id == nil then
		return;
	end

	local num = DataCenter.theSelectionWarData.reward_amount;
	local name = getConfig({"item", id, "name"});
	return "[FFB319]"..num..name.."[-]";
end

-- 排行榜页签
function Lua_TheSelectionWarUtil.Get:getRankListInfo()
	local list = getConfig({"theaven_const", "rank_list_info", "arr"});
	local arr = Array();
	for i = 1, #list do
		arr:add({name=list[i][1], class_id = list[i][2]});
	end
	return arr;
end

-- 赛季目标界面信息
function Lua_TheSelectionWarUtil.Get:sportsRewardConfigInfo()
	local arr = Array();
	local config = getConfig({"theaven_rank_reward"});
	if config ~= nil then
		for k, v in pairs(config) do
			arr:add({season = v.season, name = v.name, reward_id = v.reward_id,
				atlas = v.atlas, atlas_name = v.atlas_name, eff = v.eff});
		end
	end
	arr:sort("season", true);

	local max_sectionm;
	if DataCenter.theSelectionWarData.season == nil or DataCenter.theSelectionWarData.season > arr[1].season then
		max_sectionm = arr[1].season;
	else
		max_sectionm = DataCenter.theSelectionWarData.season;
	end

	local _arr = Array();
	for i = 1, arr:getSize() do
		if arr[i].season == max_sectionm then
			_arr:add(arr[i]);
		end
	end
	return _arr;
end

-- 段位奖励界面信息
function Lua_TheSelectionWarUtil.Get:danRewardConfigInfo()
	local arr = Array();
	local config = getConfig({"theaven_grade_reward"});
	if config ~= nil then
		for k, v in pairs(config) do
			arr:add({season = v.season, name = v.name, reward_id = v.grade_reward,
				atlas = v.atlas, atlas_name = v.atlas_name, eff = v.eff});
		end
	end
	arr:sort("season", true);

	local max_sectionm;
	if DataCenter.theSelectionWarData.season == nil or DataCenter.theSelectionWarData.season > arr[1].season then
		max_sectionm = arr[1].season;
	else
		max_sectionm = DataCenter.theSelectionWarData.season;
	end

	local _arr = Array();
	for i = 1, arr:getSize() do
		if arr[i].season == max_sectionm then
			_arr:add(arr[i]);
		end
	end
	return _arr;
end

-- 玩法规则数据信息
function Lua_TheSelectionWarUtil.Get:gameRulesConfigInfo()
	local dic = {};
	local config = getConfig({"theSelectionPlayRule"});
	if config ~= nil then
		for k, v in pairs(config) do
			if dic[v.class_id] == nil then
				dic[v.class_id] = Array();
			end
			dic[v.class_id]:add(v);
		end
	end
	return dic;
end

-- 玩法规则
function Lua_TheSelectionWarUtil:getArrByClassId(class_id)
	return self.gameRulesConfigInfo[class_id];
end

-- 玩法规则
function Lua_TheSelectionWarUtil:getGameRulesinfo(class_id, num)
	local str = "";
	local arr = self.gameRulesConfigInfo[class_id];
	for i = 1, arr:getSize() do
		if str == "" then
			str = "";
		else
			str = str.."\n";
		end

		local _s;
		if num == 1 then
			_s = arr[i].sports;
		else
			_s = arr[i].account;
		end
		str = str.._s;
	end
	return str;
end

-- 玩法规则页签
function Lua_TheSelectionWarUtil.Get:getGameRulesCalssList()
	local config = getConfig({"theSelectionPlayRuleClass"});
	local arr = Array();
	for k,v in ipairs(config) do
		arr:add({name = v.class_name, class_id = tonumber(k)});           
	end
	return arr;
end

function Lua_TheSelectionWarUtil:getFightRewardId(season, times)
	if self._timeRewardList == nil then
		self._rewardSeason = 0;
		self._timeRewardList = {};
		local config = getConfig({"theaven_fight_reward"});
		for k, v in pairs(config) do
			if self._timeRewardList[v.season] == nil then
				self._timeRewardList[v.season] = {};

				if self._rewardSeason < v.season then
					self._rewardSeason = v.season;
				end
			end
			self._timeRewardList[v.season][v.fight_times] = v;
		end
	end
	
	if self._timeRewardList[season] ~= nil then
		return self._timeRewardList[season][times];
	else
		if season ~= nil and season > self._rewardSeason then
			return Lua_TheSelectionWarUtil:getFightRewardId(self._rewardSeason, times);
		end
	end
	return nil;
end