Lua_BuffVo = class("Lua_BuffVo");
function Lua_BuffVo:ctor(id)
	self.id = id;
	self.s_time = -1;
	self.lask_tick = -1;
	self.config = getConfig({"buff", self.id});
end

function Lua_BuffVo:fromServer(ps)
	self.value1 = ps.value1;
	self.value2 = ps.value2;
	self.value3 = ps.value3;
	self.lask_tick = ps.last_tick;
	self.cool_tick = ps.cool_tick;
	self.s_time = getTime();
end

function Lua_BuffVo.Get:leftTime()
	if self.lask_tick == -1 then
		return -1;
	end
	local pt = getTime() - self.s_time;
	local lt = self.lask_tick - pt;
	return lt < 0 and 0 or lt;
end

function Lua_BuffVo.Get:hunluan()
	if self.config.hunluan == nil then
		return 0;
	end
	return self.config.hunluan;
end

function Lua_BuffVo.Get:buff_type()
	if self.config.buff_type == nil then
		return 0;
	end
	return self.config.buff_type;
end

function Lua_BuffVo.Get:kongju()
	if self.config.kongju == nil then
		return 0;
	end
	return self.config.kongju;
end

function Lua_BuffVo.Get:bianxing()
	if self.config.bianxing == nil then
		return 0;
	end 
	return self.config.bianxing;
end

function Lua_BuffVo.Get:name()
	if self.config.name == nil then
		return tostring(self.id);
	end
	return self.config.name; 
end

function Lua_BuffVo.Get:atlas()
	if self.config.altas == nil then
		return "skillIcon_atlas_1";
	end
	return self.config.altas;
end

function Lua_BuffVo.Get:sprite()
	if self.config.sid == nil then
		return "411110002";
	end
	return self.config.sid; 
end

function Lua_BuffVo.Get:show_icon()
	if self.config.show_icon == nil then
		return 0;
	end
	return self.config.show_icon; 
end

function Lua_BuffVo.Get:des()
	if self.config.des == nil then
		return "";
	end
	local str = string.formateDic(self.config.des, self)
	return str;
end

function Lua_BuffVo.Get:show_time()
	if self.config.show_time == nil then
		return 0;
	end
	return tonumber(self.config.show_time);
end

function Lua_BuffVo.Get:effect()
	if self.config.head_effect == nil then
		return nil;
	end
	return self.config.head_effect;
end

function Lua_BuffVo.Get:atlasAndSprite()
	if self.config.atlasAndSprite == nil then
		return nil;
	end
	return self.config.atlasAndSprite;
end

function Lua_BuffVo.Get:warn_effect()
	if self.config.warn_effect == nil then
		return 0;
	end
	return tonumber(self.config.warn_effect);
end

function Lua_BuffVo.Get:warn_speed()
	if self.config.warn_speed == nil then
		return 0;
	end
	return tonumber(self.config.warn_speed);
end

function Lua_BuffVo.Get:warn_outside_radius()
	if self.config.warn_outside_radius == nil then
		return 0;
	end
	return tonumber(self.config.warn_outside_radius);
end

function Lua_BuffVo.Get:warn_inside_radius()
	if self.config.warn_inside_radius == nil then
		return 0;
	end
	return tonumber(self.config.warn_inside_radius);
end

function Lua_BuffVo.Get:warn_atlas()
	if self.config.warn_atlas == nil then
		return nil;
	end
	return self.config.warn_atlas;
end 

function Lua_BuffVo.Get:warn_sprite()
	if self.config.warn_sprite == nil then
		return nil;
	end
	return self.config.warn_sprite;
end 

function Lua_BuffVo.Get:mapIconUrl()
	return self.config.mapIconUrl;
end

function Lua_BuffVo.Get:mapIconSize()
	return self.config.mapIconSize;
end

function Lua_BuffVo.Get:mapNoShowName()
	if self.config.mapNoShowName == nil then
		return 0;
	end
	return self.config.mapNoShowName;
end