Lua_MonsterConfigData = class("Lua_MonsterConfigData");
function Lua_MonsterConfigData:ctor(objId)
	self:superCall("ctor");
	self.objId = tonumber(objId);
	self.config = getConfig({"monster", self.objId});
end
function Lua_MonsterConfigData.Get:name()
	return self.config.name;
end
function Lua_MonsterConfigData.Get:boss()
	if self.config.boss == nil then
		return 0;
	end
	return self.config.boss;
end
function Lua_MonsterConfigData.Get:isCollect()
	if self.config.monster_type == nil then
		return false;
	end
	return self.config.monster_type >= 1 and self.config.monster_type <= 9;
end
function Lua_MonsterConfigData.Get:isShowHpBar()
	if self.config.show_blood == nil then
		return false;
	end
	return self.config.show_blood == 1;
end
function Lua_MonsterConfigData.Get:level()
	if self.config.lvl == nil then
		return 1;
	end
	return self.config.lvl;
end
function Lua_MonsterConfigData.Get:effect_tip()
	if self.config.effect_tip == nil then
		return nil;
	end
	return self.config.effect_tip;
end
function Lua_MonsterConfigData.Get:noSelect()
	if self.config.noSelect == nil then
		return 0;
	end
	return self.config.noSelect;
end
function Lua_MonsterConfigData.Get:scale()
	if self.config.scale == nil then
		return 1;
	end
	return self.config.scale;
end
function Lua_MonsterConfigData.Get:headSrc()
	if self.config.head_src == nil then
		return 0;
	end
	return self.config.head_src;
end
function Lua_MonsterConfigData.Get:hide_lv()
	if self.config.hide_lv == nil then
		return 0;
	end
	return self.config.hide_lv;
end

function Lua_MonsterConfigData.Get:lifeNum()
	if self.config.life_num == nil then
		return 1;
	end
	return self.config.life_num;
end

function Lua_MonsterConfigData.Get:eachBloodVal()
	if self.config.eachBloodVal == nil then
		return 0;
	end
	return self.config.eachBloodVal;
end

function Lua_MonsterConfigData.Get:nameOffsetY()
	return self.config.name_Offset_Y;
end