checkRequire("Lua_BuffVo");
Lua_RoleData = class("Lua_RoleData");
function Lua_RoleData:ctor()
    self.buffList = Array();
    self.allLines = Array();

    self.fightChange = { };
    self.baseParamChange = { };
    self.showEffectList = Array();

    self.cutImage = nil;
    self.uploadHead = nil;
    self.role_head_list = nil;

    self:dispose();
end
function Lua_RoleData:dispose()
    self.roleId = 0;
    self.sceneId = nil;
    self.buffList:clear();
    self.allLines:clear();
    self.kill_value = 0;
    self.nameColor = 0;
    self.worldLevel = 0;
    self.expAddition = 0;
    self.serverSetTime = 0;
    self.setTime = 0;
    self.camp_id = 0;
    self.transferId = 0;
    self.curLuaSceneId = 0;
    self.unUseShoesTranTo = true;
    self.fightState = false;
    self.curLine = 1;
    self.preNameEffect = nil;
    self.profession = 0;
    self.taskStep = 0;
    self.permission = 0;
    self.lastScene = nil;--退出游戏或者切换账号，记录场景id字段设置为空
    self.switchDic = {};
    self.petChatScene = -1;
    self.petChatCountDown = -1;
    self.petLastIndex = -1;
    self.role_head_list = nil;
    self.career = 0;

    self.baseParam = nil;
    self.showEffectList:clear();

    self.cutImage = nil;
    self.uploadHead = nil;
    self.role_head_list = nil;

    self.cloak = 0;

    self:resetChangeParam();
    self:resetBaseChangeParam();
end
function Lua_RoleData:showBaQuan()
    local list = Lua_CommonUtil.getCommonConfig("bafu_pid_gid",3);
    if list == nil then
        return false;
    end
    for i,v in ipairs(list) do
        if getPid() == v[1] and getGid() == v[2] then
            return true;
        end
    end
    return false;
end
function Lua_RoleData:checkGameSwich(val)
    if self.switchDic[val] == nil then
        return 1;
    end
    return self.switchDic[val];
end
function Lua_RoleData:updateLockState(id, state)
    local saveVal = DataCenter.roleData:getLockEffectState(id);
    if saveVal == state then
        return;
    end

    local cmd = ProtoPublic_pb.Proto10100206();
    cmd.event_status.id = id;
    cmd.event_status.value = state;
    sendMsg(10100206,cmd);
end
function Lua_RoleData:addLockEffectList(val)
    self.showEffectList:add(val);
end
function Lua_RoleData:getLockEffectState(id)
    local len = self.showEffectList:getSize();
    for i=1,len do
        if tonumber(self.showEffectList[i].id) == id then
            return self.showEffectList[i].value;
        end
    end
    return -1;
end
function Lua_RoleData:clearLockEffectList()
    self.showEffectList:celar();
end
function Lua_RoleData:resetBaseChangeParam()
    for i, v in ipairs(Lua_ThingDefine.changeParams) do
        self.baseParamChange[v] = 0;
    end
end
function Lua_RoleData:resetChangeParam()
    self.fightChange.oldLv = 0;
    self.fightChange.curLv = 0;

    self.fightChange.oldFight = 0;
    self.fightChange.curFight = 0;
end
function Lua_RoleData:fromServer(msg)
    self.roleId = tonumber(tostring(msg.role_id));
    self.name = msg.name;
    self.militaryRank = msg.military_rank;
    self.level = msg.level;
    self.sex = msg.sex;
    self.career = msg.career;
    self.leagueId = tonumber(tostring(msg.league_id));
    self.leagueName = msg.league_name;
    self.pkState = msg.pk_state;
    self.exp = tonumber(tostring(msg.experience));
    self.vipType = msg.vip_type;
    self.force = tonumber(tostring(msg.force));
    self.sceneId = msg.scene_id;
    self.hp = tonumber(tostring(msg.blood));
    self.maxHp = tonumber(tostring(msg.max_blood));
    self.mp = tonumber(tostring(msg.magic));
    self.maxMp = tonumber(tostring(msg.max_magic));
    self.profession = msg.profession;
    self.permission = msg.permission;
    self.server_name = msg.server_name;

    self.market_code = msg.market_code;
    self.agent = msg.agent;

    self.partnerId = tonumber(tostring(msg.partner_id));
    self.wedding_id = tonumber(tostring(msg.wedding_id));
    self.wedding_type = msg.wedding_type;
    self.partnerName = msg.partner_name;

    self.cur_tick = tonumber(tostring(msg.cur_tick));
    self.mount_id = msg.shape_info.mount_shape;
    self.weapon_id = msg.shape_info.weapon;
    self.clothes_id = msg.shape_info.clothes;
    self.camp_id = msg.camp_id;
    self.wingId = msg.shape_info.wing;
    self.fairyId = msg.shape_info.fairy_shape;
    self.mount_id = msg.shape_info.mount_shape;
    self.faqiId = msg.shape_info.mw_shape;
    self.spoorId = msg.shape_info.spoor_shape;
    self.fashion_weapon_id = msg.shape_info.fashion_weapon_id;
    self.fashion_clothes_id = msg.shape_info.fashion_clothes_id;
    self.fashionHeadId = msg.shape_info.fashion_headdress_id;
    self.cloak = msg.cloak;
    self.labelId = msg.shape_info.label;

    self.headFrame = msg.shape_info.fashion_head_frame;
    self.airBubble = msg.shape_info.fashion_air_bubble;
    self.fashionBgId = msg.fashion_background_id;

    self.transferId = tonumber(tostring(msg.model_id));
    self.px = msg.coord.pixel_x;
    self.py = msg.coord.pixel_y;
    self.pz = msg.coord.pixel_z;
    self.dir = 0;
end
function Lua_RoleData:fromCData()
    local croleData = PlayerData.getInstance().data;
    self.roleId = tonumber(tostring(croleData.roleId));
    self.name = croleData.nickname;
    self.level = croleData.lvl;
    self.sex = croleData.gender;
    self.career = croleData.career;
    self.leagueId = tonumber(tostring(croleData.league_id));
    self.pkState = croleData.pk_state;
    self.exp = tonumber(tostring(croleData.exp));
    self.force = tonumber(tostring(croleData.fighting));
    self.sceneId = croleData.scene_id;
    self.hp = tonumber(tostring(croleData.hp));
    self.maxHp = tonumber(tostring(croleData.maxHp));
    self.mp = tonumber(tostring(croleData.mp));
    self.maxMp = tonumber(tostring(croleData.maxMp));
    self.vipType = croleData.vipType;
    self.profession = croleData.profession;
    self.mount_id = croleData.mount_id;
    self.weapon_id = croleData.weapon_id;
    self.clothes_id = croleData.clothes_id;
    self.camp_id = croleData.camp_id;
    self.wingId = croleData.wingId;
    self.fairyId = croleData.fairyId;
    self.mount_id = croleData.mount_id;
    self.faqiId = croleData.faqiId;
    self.spoorId = croleData.spoorId;
    self.fashion_weapon_id = croleData.fashion_weapon_id;
    self.fashion_clothes_id = croleData.fashion_clothes_id;
    self.fashionHeadId = croleData.fashionHeadId;
    self.px = croleData.px;
    self.py = croleData.py;
    self.pz = croleData.pz;
    self.dir = croleData.dir;
end
function Lua_RoleData:hasHunLuan()
    local len = self.buffList:getSize();
    for i = 1, len do
        if self.buffList[i].hunluan == 1 then
            return true;
        end
    end
    return false;
end

function Lua_RoleData.Set:ascription_state(val)
    self._ascription_state = val;
end
function Lua_RoleData.Get:ascription_state()
    if self._ascription_state == 1 then
        return 1;
    end
    local buffVo = self:getBuffById(70005);
    if buffVo ~= nil then
        self.ascriptionEffect = buffVo.effect;
        self.atlasAndSprite = buffVo.atlasAndSprite;
        return 3;
    end
    buffVo = self:getBuffById(80001);
    if buffVo ~= nil then
        self.ascriptionEffect = buffVo.effect;
        self.atlasAndSprite = buffVo.atlasAndSprite;
        return 2;
    end
    return 0;
end

function Lua_RoleData:getBuffById(val, onlyId)
    local len = self.buffList:getSize();
    for i = 1, len do
        if onlyId == true then
            if self.buffList[i].id == val then
                return self.buffList[i];
            end
        else
            if self.buffList[i].id == val or self.buffList[i].buff_type == val then
                return self.buffList[i];
            end
        end
        
    end
    return nil;
end
function Lua_RoleData:updateBuff(val)
    if val == nil then
        return;
    end
    local t = getTime();
    local len = self.buffList:getSize();
    for i = 1, len do
        if self.buffList[i].id == val.id then
            self.buffList[i] = val;
            return;
        end
    end
    self.buffList:add(val);
end
function Lua_RoleData:removeBuff(id)
    local len = self.buffList:getSize();
    for i = 1, len do
        if self.buffList[i].id == id then
            self.buffList:remove(i);
            return;
        end
    end
end
function Lua_RoleData:setServerTime(val)
    self.serverSetTime = tonumber(val);
    self.setTime = getTime();
end
function Lua_RoleData.Get:serverTime()
    return math.floor(self.serverSetTime + getTime() - self.setTime);
end
function Lua_RoleData:isScenceOpen(scenceId, showTips)
    -- 判断场景是否开启
    local scenceData = Lua_SceneConfigData.getSceneConfig(scenceId);
    if self.level < scenceData.minLv then
        if showTips == true then
            OperateAlert.show(LanUtil.getValue(110018));
        end
        return false;
    end
    return true;
end
function Lua_RoleData.Get:hookRange()
    local scenceData = Lua_SceneConfigData.getSceneConfig(self.sceneId);
    if scenceData.hook_range == 0 then
        if self.norRange == nil then
            self.norRange = Lua_CommonUtil.getCommonConfig("find_enemy_range", 1)
        end
        return self.norRange;
    else
        return scenceData.hook_range;
    end
end
function Lua_RoleData.Get:pointHookRange()
    local scenceData = Lua_SceneConfigData.getSceneConfig(self.sceneId);
    if scenceData.hook_range == 0 then
        if self._pointHookRange == nil then
            self._pointHookRange = Lua_CommonUtil.getCommonConfig("hook_fix_pos_dis", 1)
        end
        return self._pointHookRange;
    else
        return scenceData.hook_range;
    end
end

-- 是否在副本
function Lua_RoleData:isInCopy(needTip)
    if self.sceneId ~= nil then
        local cData = Lua_SceneConfigData.getSceneConfig(self.sceneId);
        if cData.config ~= nil and cData.config.copy_type ~= nil and tonumber(cData.config.copy_type) > 0 then
            if needTip ~= nil and needTip == true then
                OperateAlert.show(LanUtil.getValue(123313));
            end
            return true;
        end
    end

    return false;
end

function Lua_RoleData:checkPathDistance(posx, posy, posz)
    -- 判断是否需要传送
    local num = Lua_CommonUtil.getCommonConfig("transfer_minDistance", 1);
    if num ~= nil then
        local rd = DataCenter.roleData;
        local arr = WorldMapUtil.genPath(rd.px, rd.py, rd.pz, posx, posy, posz);
        if arr ~= nil then
            local wayLen = 0;
            local len = arr.Count;
            for i = 0, len - 2 do
                wayLen = Vector3.Distance(arr[i], arr[i + 1]) + wayLen;
            end

            if wayLen < num then
                return true;
            else
                return false;
            end
        end
    end

    return false;
end

-- 玩家直接传送到目的地
-- 0 失败
-- 1 直接传送
-- 2 寻路
function Lua_RoleData:tranceTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask)
    -- 运镖状态下
    if DataCenter.yunBiaoData.isOngoing == true then
        OperateAlert.show(LanUtil.getValue(123314));
        return 0;
    end

    -- 战斗状态下不能传送
    local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
    if rolePlayer ~= nil then
        local canFighting = Lua_CommonUtil.getCommonConfig("transfer_fight_state", 1);
        if canFighting ~= nil and canFighting == 1 then
            if rolePlayer.data.isFightAct == true then
                OperateAlert.show(LanUtil.getValue(123310));
                return 0;
            end
        else
            if rolePlayer.data:getBuffCanDo(1) == false or rolePlayer.data.kongjuState == 1 then
                OperateAlert.show(LanUtil.getValue(123317));
                return 0;
            end
        end
    end
    -- if DataCenter.roleData.pkState ~= Lua_ThingDefine.PK_STATE_PEASE then-- 正常寻路
    --     OperateAlert.show(LanUtil.getValue(123310));
    --     DataCenter.hook:stop(true);
    --     WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
    --     return 2;
    -- end

    -- 判断地图是否能够传送
    local cData = Lua_SceneConfigData.getSceneConfig(sceneId);
    if cData.config == nil then
        OperateAlert.show(LanUtil.getValue(123308));
        return 0;
    end

    -- 地图不能传送
    if cData.config.unableTransfer ~= nil and cData.config.unableTransfer == 1 then
        -- 正常寻路
        OperateAlert.show(LanUtil.getValue(123307));
        DataCenter.hook:stop(true);
        WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
        return 2;
    end

    DataCenter.hook:resetControlTime(0);
    local num = getConfig( { "vip_level", DataCenter.vipData.level, "free_transfer" });
    if num ~= nil and num == 1 then
        -- 免费传送
        Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(sceneId, posx, posy, posz, 0);
        return 1;
    end

    ----------------------- 需要消耗小飞鞋 -------------------------------------------------
    -- 同场景，距离短正常寻路
    if DataCenter.roleData.sceneId == tonumber(sceneId) and self:checkPathDistance(posx, posy, posz) == true then
        OperateAlert.show(LanUtil.getValue(123309));
        DataCenter.hook:stop(true);
        WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
        return 2;
    end

    -- 判断小飞鞋是否足够
    num = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(DataCenter.mapWindowUtil.flyShoesItemId);
    if num <= 0 then
        local vo = Lua_ToolVo.new(DataCenter.mapWindowUtil.flyShoesItemId);
        if vo.goldPrice == nil or vo.goldPrice == 0 then
            OperateAlert.show(LanUtil.getValue(123306));
            DataCenter.hook:stop(true);
            WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
            return 2;
        end

        -- print("TranceTo_CostShoes_Tip = ", DataCenter.neverTip:getNeverValue("TranceTo_CostShoes_Tip"));
        if DataCenter.neverTip:getNeverValue("TranceTo_CostShoes_Tip") == false then
            OperateAlert.show(LanUtil.getValue(123306));
            local str = "";
            if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, vo.goldPrice, false, false) == false then
                str = "[" .. Lua_ColorDefine.RED_STR .. "]" .. tostring(vo.goldPrice) .. "[-]";
            else
                str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. tostring(vo.goldPrice) .. "[-]";
            end
            local tipData = { };
            tipData.des = LanUtil.formateStr(LanUtil.getValue(123315), str);
            tipData.neverTip = "TranceTo_CostShoes_Tip";
            tipData.owner = self;
            tipData.type = 1;
            tipData.subFun = self.onSureFun;
            -- 确定
            tipData.cancelFun = self.onCancelFun;
            -- 取消
            tipData.sceneId = sceneId;
            tipData.posx = posx;
            tipData.posy = posy;
            tipData.posz = posz;
            tipData.targetId = targetId;
            tipData.targetType = targetType;
            tipData.act = act;
            tipData.dailytask = dailytask;
            Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
            return 0;
        else
            if self.unUseShoesTranTo == false then
                -- 直接消耗
                if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, vo.goldPrice, true, true) == true then
                    Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(sceneId, posx, posy, posz, 1);
                    return 1;
                else
                    -- 正常寻路
                    OperateAlert.show(LanUtil.getValue(123306));
                    DataCenter.hook:stop(true);
                    WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
                    return 2;
                end
            else
                -- 正常寻路
                OperateAlert.show(LanUtil.getValue(123306));
                DataCenter.hook:stop(true);
                WorldMapUtil.moveTo(sceneId, posx, posy, posz, targetId, targetType, act, dailytask);
                return 2;
            end
        end
    else
        -- 小飞鞋足够，消耗飞鞋传送
        Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(sceneId, posx, posy, posz, 1);
        return 1;
    end

    return 0;
end

function Lua_RoleData:onSureFun(data)
    if DataCenter.neverTip:getNeverValue("TranceTo_CostShoes_Tip") == true then
        self.unUseShoesTranTo = false;
    end

    local vo = Lua_ToolVo.new(DataCenter.mapWindowUtil.flyShoesItemId);
    if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, vo.goldPrice, true, true) == false then
        -- 元宝不足寻路过去
        DataCenter.hook:stop(true);
        WorldMapUtil.moveTo(data.sceneId, data.posx, data.posy, data.posz, data.targetId, data.targetType, data.act, data.dailytask);
        Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", { x = data.posx, y = data.posy, z = data.posz });
        return 2;
    else
        -- 直接飞
        Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(data.sceneId, data.posx, data.posy, data.posz, 1);
        Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", nil);
        return 1;
    end
end

function Lua_RoleData:onCancelFun(data)
    if DataCenter.neverTip:getNeverValue("TranceTo_CostShoes_Tip") == true then
        self.unUseShoesTranTo = true;
    end

    -- 正常寻路
    DataCenter.hook:stop(true);
    WorldMapUtil.moveTo(data.sceneId, data.posx, data.posy, data.posz, data.targetId, data.targetType, data.act, data.dailytask);
    Lua_MsgUtil.callFunc("SCENEMAP_CANCLE_CLICKFLY", { x = data.posx, y = data.posy, z = data.posz });
    return 2;
end

function Lua_RoleData:isTransing()
    if self.transferId == nil or self.transferId == 0 then
        return false;
    end
    return true;
end



-- 头像更换
function Lua_RoleData:init50110011(msg)
    self.role_head_list = msg.role_head_list;
end

function Lua_RoleData:init50100041(msg)
    self.role_head_list = msg.role_head_list;
end

function Lua_RoleData:getHeadFrame(id)
    local list = nil;
    if id ~= nil then
        list = {};
        list.atlas = getConfig({"chat_attire", id, "right_atlas"});
        list.sprite = tostring(id);
        list.bg = getConfig({"chat_attire", id, "frame_bg"});
    end
    return list;
end

function Lua_RoleData:getChatBubble(id, isLeft)
    local list = {};
    if id ~= nil then
        list.atlas = getConfig({"chat_attire", id, "right_atlas"});
        if isLeft == 1 then 
            list.sprite = id.."_left";
        else
            list.sprite = id.."_right";
        end
    end
    return list;
end

function Lua_RoleData:defaultHead()
    local arr = Array();
    local get_head = getConfig({"role_head", self.career, "get_head"});
    local val = getConfig({"role_head", self.career, "value"});
    for i,v in ipairs(val) do
        local list = {};
        list.value = v;
        list.get_head = get_head[i];
        list.profession = i - 1;
        arr:add(list);
    end
    return arr;
end

function Lua_RoleData:isDefaultHead(career, role_head) -- 判断是否是本职业默认头像
    local val = getConfig({"role_head", career, "value"});
    for i,v in ipairs(val) do
        if tostring(v) == tostring(role_head) then
            return true;
        end 
    end
    return false;
end

function Lua_RoleData.Get:getHeadIconData()
    local arr = Array();
    local _arr = self:defaultHead();
    if self.role_head_list ~= nil then
        for i,v in ipairs(self.role_head_list) do
            local list = {};
            local isDefault = self:isDefaultHead(self.career, v.role_head);
            list.role_head = v.role_head;
            list.is_dress = v.is_dress;
            list.head_time = v.head_time;
            list.isDefault = isDefault;
            if isDefault == true then -- 默认头像
                for j=1,_arr:getSize() do
                    local isGray = false;
                    if tostring(_arr[j].value) == tostring(v.role_head) then
                        list.get_head = _arr[j].get_head;
                        list.sortNum = j;
                        if _arr[j].profession > self.profession then -- 该头像对应的转职大于当前转职置灰显示
                            isGray = true;
                        end
                        list.isGray = isGray;
                    end
                end
            else
                list.get_head = LanUtil.getValue(129204);
                list.sortNum = 0;
                list.isGray = false;
            end
            
            arr:add(list);
        end
    end
    arr:sort("sortNum", false);
    return arr;
end

function Lua_RoleData.Get:getDressHead() -- 获得已穿戴头像名
    if self.role_head_list ~= nil then
        for i,v in ipairs(self.role_head_list) do
            if v.is_dress == 1 then
                return v.role_head;
            end
        end
    end
    return nil;
end

function Lua_RoleData.Get:getDressHeadIndex() -- 获得已穿戴头像索引
    local arr = self.getHeadIconData;
    for i=1,arr:getSize() do
        if arr[i].is_dress == 1 then
            return i;
        end
    end
    return nil;
end

-- 是否需要杀人提示
function Lua_RoleData.Get:bShowKillRoleTips()
    if self.killTipsSceneDic == nil then
        self.killTipsSceneDic = {};
        local list = getConfig({"tiny", "kill_tips_scene"});
        if list ~= nil and #list > 0 then
            for i = 1, #list do
                local sId = tonumber(list[i]);
                self.killTipsSceneDic[sId] = sId;
            end
        end
    end

    if self.killTipsSceneDic[tonumber(self.sceneId)] ~= nil then
        return true;
    end

    return false;
end