Lua_ThingData = class("Lua_ThingData");
function Lua_ThingData:ctor()
	self:superCall("ctor");
	self.thingDic = {};
	self.thingObjDic = {};
	self.lastSelectedDic = {};
	self.dropDic = {};
	self.lastSelectedTime = 0;
end
function Lua_ThingData:dispose(val)
	self.thingDic = {};
	self.cloakTemp = nil;
	self.dropDic = {};
	if val == nil or val == true then
		self.thingObjDic = {};
	else
		local myPlayer = self:getThingObj(DataCenter.roleData.roleId);
		self.thingObjDic = {};
		self.thingObjDic[tonumber(DataCenter.roleData.roleId)] = myPlayer;
	end
end
function Lua_ThingData:getMonsterListByType(monsterConfigId)
	local arr = Array();
	for k,v in pairs(self.thingDic) do
		if v.kind == Lua_ThingDefine.MONSTER then
			if v.configId == monsterConfigId then
				arr:add(v);
			end
		end
	end
	return arr;
end
function Lua_ThingData:getNearMonsterByType(cp, monsterConfigId)
	local rs = nil;
	local dis = 9999999;
	for k,v in pairs(self.thingDic) do
		if v.kind == Lua_ThingDefine.MONSTER then
			local dx = cp.x - v.px;
			local dy = cp.y - v.py;
			local dz = cp.z - v.pz;
			local curDis = math.abs(dx) + math.abs(dy) + math.abs(dz);
			if curDis < dis then
				rs = v;
			end
		end
	end
	return rs;
end
function Lua_ThingData:showNum()
	local num = 0;
	for k,v in pairs(self.thingDic) do
		num = num + 1;
	end
	print("thingDic:", num);
	num = 0;
	for k,v in pairs(self.thingObjDic) do
		num = num + 1;
	end
	print("thingObjDic:", num);
	num = 0;
	for k,v in pairs(self.lastSelectedDic) do
		num = num + 1;
	end
	print("lastSelectedDic:", num);
	num = 0;
	for k,v in pairs(self.dropDic) do
		num = num + 1;
	end
	print("dropDic:", num);
end
function Lua_ThingData:addDrop(thingVo)
	self.dropDic[tonumber(thingVo.objId)] = thingVo;
end
function Lua_ThingData:removeDrop(objId)
	self.dropDic[tonumber(objId)] = nil;
end

function Lua_ThingData:addThing(thingVo)
	self.thingDic[tonumber(thingVo.objId)] = thingVo;
end
function Lua_ThingData:getThing(objId)
	local r = tonumber(objId);
	if r == tonumber(DataCenter.roleData.roleId) then
		return DataCenter.roleData;
	else
		return self.thingDic[r];
	end
end
function Lua_ThingData:removeThing(objId)
	self.thingDic[tonumber(objId)] = nil;
end
function Lua_ThingData:addThingObj(objId, thing)
	self.thingObjDic[tonumber(objId)] = thing;
end
function Lua_ThingData:getThingObj(objId)
	return self.thingObjDic[tonumber(objId)];
end
function Lua_ThingData:removeThingObj(objId)
	self.thingObjDic[tonumber(objId)] = nil;
end
function Lua_ThingData.Get:maxDisSq()
	return DataCenter.roleData.hookRange;
end
function Lua_ThingData.Get:pointHookRange()
	return DataCenter.roleData.pointHookRange;
end
function Lua_ThingData:addLastSlectedTarget(id)
	if id == nil or id == 0 then
		return;
	end
	self.lastSelectedDic[id] = getTime();
end
function Lua_ThingData:clearLastSelectedList()
	local delList = Array();
	local nt = getTime();
	for k,v in pairs(self.lastSelectedDic) do
		if nt - v > 2 then
			delList:add(k);
		end
	end
	local len = delList:getSize();
	for i=1,len do
		self.lastSelectedDic[delList[i]] = nil;
	end
end
function Lua_ThingData:findNearestDrop(mypos, isAuto)
	local rs = nil;
	local ndis = 99999999999999;
	local findRange = Lua_CommonUtil.getCommonConfig("find_drop_rang",1);
	for k,v in pairs(self.dropDic) do
		local cp = ThingUtil.instance:getThingById(v.objId);
		if cp ~= nil 
			and v:canPick(isAuto) then
			local dx = mypos.x - v.px;
			local dy = mypos.y - v.py;
			local dz = mypos.z - v.pz;
			local curDis = math.abs(dx) + math.abs(dy) + math.abs(dz);
			if curDis < findRange and curDis < ndis then
				rs = v;
				ndis = curDis;
			end
		end
	end
	return rs;
end
function Lua_ThingData:checkSameCS()
	for k,v in pairs(self.thingDic) do
		if v.objId ~= DataCenter.roleData.roleId then
			local cp = ThingUtil.instance:getThingById(v.objId);
			if cp == nil then
				print("checkSameCS:", v.objId);
				return;
			end
		end
	end
	print("all same");
end
function Lua_ThingData:findNearestThing(mypos, isAuto, dis, monsterId)--todo
	local rs = nil;
	local ndis = 99999999999999;
	local hunluan = DataCenter.roleData:hasHunLuan(); 
	local arr = Array();
	local hd = DataCenter.hangUpSettingsData;
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	for k,v in pairs(self.thingDic) do
		if v.objId ~= DataCenter.roleData.roleId and v.kind ~= Lua_ThingDefine.PET then
			local cp = ThingUtil.instance:getThingById(v.objId);
			if cp ~= nil 
				and v.isDead == false 
				and self:checkTargetCanAttactk(v, isAuto) == true then
				local addDis = 0;
				if isAuto == true and hd.auto_avoid_boss == 1 and v.boss == 1 and sceneData.single_map == 0 then
					addDis = 100000;
				end
				--local isCollect = false;
				--[[
				if isAuto == true and v.kind == Lua_ThingDefine.MONSTER and v.monsterData.isCollect == true then
					isCollect = true;
				end
				]]
				local isInRange = true;
				if isAuto == true and hd.hook_monster_sort == 1 then
					local st = DataCenter.hook:getStartPos();
					local dx = st.x - v.px;
					local dy = st.y - v.py;
					local dz = st.z - v.pz;
					local curDis = math.abs(dx) + math.abs(dy) + math.abs(dz);
					
					if curDis > self.pointHookRange then
						isInRange = false;
					end
				end
				if isInRange == true then
					local dx = mypos.x - v.px;
					local dy = mypos.y - v.py;
					local dz = mypos.z - v.pz;
					local curDis = math.abs(dx) + math.abs(dy) + math.abs(dz);
					if (curDis < self.maxDisSq) or (v.configId ~= nil and monsterId ~= 0 and monsterId ~= nil and monsterId == v.configId) then
						curDis = curDis + addDis;
						if isAuto == true
							and v.kind == Lua_ThingDefine.MONSTER 
							and v.isCollect == true
							and DataCenter.copyInfoData.script_type == Lua_CopyData.JUEXING_COPY then --觉醒副本采集物处理
							local buffVo = DataCenter.roleData:getBuffById(Lua_CopyData.JUEXING_COPY_BUFF, true);
							if buffVo == nil then--没有采集
								local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUEXING_COPY);
								local p = copyVo:getCollectionPriority(DataCenter.copyInfoData.script_degree, v.configId);
								curDis = curDis - 10000 * p;
							end
						end
						if self.lastSelectedDic[v.objId] ~= nil then
							curDis = curDis + 1000000;
						end
						curDis = curDis;
						if v.configId ~= nil and monsterId ~= 0 and monsterId ~= nil and monsterId == v.configId then
							curDis = curDis - 500000;
						end
						if curDis <= ndis then
				            ndis = curDis;
				            rs = v;
				        end
				        if hunluan == true then
				        	arr:add({data=v, dis=curDis});
				        end
					end
				end
			end
		end
	end
	if hunluan == false then
		return rs;
	else
		arr:sort("dis", false);
		local arrLen = arr:getSize();
		if arrLen == 0 then
			return nil;
		end
		local len = arrLen < 8 and arrLen or 8;
		local n = math.random(len);
		return arr[n].data;
	end
end
function Lua_ThingData:findAttackTarget(mypos, isAuto, dis, monsterId, refind)
	local sid = DataCenter.hook.selectedId;
	local hunluan = DataCenter.roleData:hasHunLuan(); 
	if (refind == nil or refind == false) and (hunluan == false or getTime() - self.lastSelectedTime < 2) and sid ~= 0 then
		local tvo = self:getThing(sid);
		local n = tonumber(Lua_CommonUtil.trnsLongNum(DataCenter.hook.selectedId));
		local cp = ThingUtil.instance:getThingById(n);
		if tvo ~= nil and cp ~= nil then
			local dx = mypos.x - tvo.px;
			local dy = mypos.y - tvo.py;
			local dz = mypos.z - tvo.pz;
			local curDis = dx * dx + dy * dy + dz * dz;
			if curDis < 1000000 and self:checkTargetCanAttactk(tvo, isAuto) == true then
				return tvo;
			end
		end
	end
	self.lastSelectedTime = getTime();
	return self:findNearestThing(mypos, isAuto, dis, monsterId);
end
function Lua_ThingData:checkTargetCanAttactk(thingVo, isAuto)
	if thingVo.kind == Lua_ThingDefine.PET then
		return false;
	end
	if thingVo.isDead == true then
		return false;
	end

	if thingVo.noSelect == 1 then
		return false;
	end
	if isAuto == true
		and thingVo.kind == Lua_ThingDefine.MONSTER 
		and thingVo.isCollect == true
		and DataCenter.copyInfoData.script_type == Lua_CopyData.JUEXING_COPY then --觉醒副本采集物处理
		local buffVo = DataCenter.roleData:getBuffById(Lua_CopyData.JUEXING_COPY_BUFF, true);
		if buffVo ~= nil or DataCenter.roleData:isTransing() == false then--已经采集
			return false;
		end
	end
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneData.no_select_safe_area == 1 then
		local areaType = sceneData:isInSafeArea(Vector3(thingVo.px,0,thingVo.pz));
		if areaType ~= 0 then
			if areaType == 1 then
				return false;
			elseif areaType == 2 then
				if thingVo.kind == Lua_ThingDefine.USER then
					return false;
				end
			end
		end
	end
	--混沌战场
	if isAuto == true and thingVo.kind == Lua_ThingDefine.MONSTER and thingVo.isCollect == true then
		if thingVo.collect_occupy_state == 1 then
			return false;
		end
	end
	-- 己方阵营采集物不能采集
    if DataCenter.campWarData.bInCampWarScene == true or DataCenter.factionLeagueActData.bInFactionLeagueActScene == true then
		local campId = thingVo.camp_id;
	    if campId == nil or campId == 0 then
	        campId = thingVo.sub_id;
	    end
	    if campId ~= nil and campId ~= 0 then
	        if campId == DataCenter.roleData.camp_id then -- 己方阵营
	            return false;
	        end
	    end
	else
		if isAuto == true then
			if thingVo.kind == Lua_ThingDefine.MONSTER and thingVo.isCollect == true then
				if sceneData.noAutoCollect == true then
					return DataCenter.taskData:canDoCollect(thingVo.configId);
				end
			end
		end
	end

	if DataCenter.roleData.pkState == Lua_ThingDefine.PK_STATE_PEASE then
		return self:checkPeaseState(thingVo);
	elseif DataCenter.roleData.pkState == Lua_ThingDefine.PK_STATE_ALL then
		return self:checkAllState(thingVo);
	elseif DataCenter.roleData.pkState == Lua_ThingDefine.PK_STATE_TEAM then
		return self:checkTeamState(thingVo);
	elseif DataCenter.roleData.pkState == Lua_ThingDefine.PK_STATE_CAMP then
		return self:checkCampState(thingVo);
	end
	return false;
end
function Lua_ThingData:checkPeaseState(thingVo)
	if thingVo.kind == Lua_ThingDefine.MONSTER then
		if thingVo.isCollect == true then
			return true;
		else
			return true;
		end
	end
	return false;
end
function Lua_ThingData:checkAllState(thingVo)
	if thingVo.kind == Lua_ThingDefine.MONSTER and thingVo.isCollect == true then
		return true;
	end
	return true;
end
function Lua_ThingData:checkTeamState(thingVo)
	return true;
	--[[
	if thingVo.kind == Lua_ThingDefine.MONSTER then
		return true;
	else--队伍判断和帮派判断
		if DataCenter.roleData.leagueId ~= 0 then
			if thingVo.leagueId == DataCenter.roleData.leagueId then
				return false;
			end
		end
		if DataCenter.teamData.hasTeam == true then
			local td = DataCenter.teamData:getTeamMember(thingVo.objId);
			if td ~= nil then
				return false;
			end
		end
	end
	return true;
	]]
end
function Lua_ThingData:checkCampState(thingVo)
	local campId = thingVo.camp_id;
    if campId == nil or campId == 0 then
        campId = thingVo.sub_id;
    end
    if campId ~= nil and campId ~= 0 then
        if campId ~= DataCenter.roleData.camp_id then -- 敌人
            return true;
        else -- 己方阵营
            return false;
        end
    end
    return true;
end
function Lua_ThingData:updateThingPlayerShieldState()
	for k,v in pairs(self.thingObjDic) do
		v:updateShieldState();
	end
end
function Lua_ThingData:updateTransfer(rid, transferId, force, isStart)
	local thingVo = DataCenter.thingData:getThing(rid);
	if thingVo == nil then
		return;
	end
	if force ~= true and thingVo.transferId == transferId then
		return;
	end
	if thingVo ~= nil then
		thingVo.transferId = transferId;
	end
	local rp = ThingUtil.instance:getThingById(rid);
	if rp ~= nil then
		if transferId ~= 0 then
			rp.data.weapon_id = 0;
            rp.data.clothes_id = 0;
            rp.data.fashion_clothes_id = transferId;
            rp.data.fashion_weapon_id = 0;
            rp.data.fashionHeadId = 0;
            rp.data.faqiId = 0;
            rp.data.spoorId = 0;
            rp.data.wingId = 0;
            rp.data.fairyId = 0;
            rp.data.mount_id = 0;
            rp.data.noDelay = rid == DataCenter.roleData.roleId;
            rp.data.curState:setState(4, false);
            rp:setState(rp.data.curState, true);
            --rp:resetBodyUrl();
            rp:loadBody();
            rp:initPutOn(1);
            rp:initPutOn(2);
            rp:initPutOn(3);
            rp:initPutOn(4);
            rp:initPutOn(5);
            rp:initPutOn(6);
            if isStart == true then
            	rp:forceUpdate(10003, true, 1, 0, false, -1,0);
            end
		else
			if thingVo.weapon_id ~= nil then
				rp.data.weapon_id = thingVo.weapon_id;
			end
			if thingVo.fairyId ~= nil then
				rp.data.fairyId = thingVo.fairyId;
			end
			if thingVo.clothes_id ~= nil then
				rp.data.clothes_id = thingVo.clothes_id;
			end
			if thingVo.fashion_clothes_id ~= nil then
				rp.data.fashion_clothes_id = thingVo.fashion_clothes_id;
			end
			if thingVo.fashion_weapon_id ~= nil then
				rp.data.fashion_weapon_id = thingVo.fashion_weapon_id;
			end
			if thingVo.fashionHeadId ~= nil then
				rp.data.fashionHeadId = thingVo.fashionHeadId;
			end
			if thingVo.faqiId ~= nil then
				rp.data.faqiId = thingVo.faqiId;
			end
			if thingVo.spoorId ~= nil then
				rp.data.spoorId = thingVo.spoorId;
			end
			if thingVo.wingId ~= nil then
				rp.data.wingId = thingVo.wingId;
			end
			if thingVo.mount_id ~= nil then
				rp.data.mount_id = thingVo.mount_id;
			end
            if thingVo.mount_id ~= 0 then
            	rp.data.curState:setState(4, true);
            	rp:setState(rp.data.curState, true);
            end
            rp:forceUpdate(0, true, 1, 0, false, -1,0);
            --rp:resetBodyUrl();
            rp:loadBody();
            rp:initPutOn(1);
            rp:initPutOn(2);
            rp:initPutOn(3);
            rp:initPutOn(4);
            rp:initPutOn(5);
            rp:initPutOn(6);
		end
	end
	self:updateCloak(rid);
end
function Lua_ThingData:updateCloak(rid)
	local thingVo = self:getThing(rid);
	if thingVo == nil then
		return;
	end
	if DataCenter.roleData.sceneId ~= nil then
        local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
        if sceneConfig ~= nil and sceneConfig.isSwimScene == true then
            return;
        end
    end
	local rp = self:getThingObj(rid);
	if rp == nil then
		return;
	end
	if thingVo.transferId ~= 0 or (thingVo.cloak == nil or thingVo.cloak == 0) then
		rp:addEffect(10741, nil);
	else
		local eff = getConfig({"cloak_info", thingVo.cloak, "illusion"});
		rp:addEffect(10741, tostring(eff));
	end
end
function Lua_ThingData:getCloakTemp(rid)
	if self.cloakTemp == nil then
		return nil;
	end
	return self.cloakTemp[tonumber(rid)];
end
function Lua_ThingData:clearCloakTemp()
	self.cloakTemp = nil;
end
function Lua_ThingData:setCloakTemp(rid, cloak)
	if self.cloakTemp == nil then
		self.cloakTemp = {};
	end
	self.cloakTemp[tonumber(rid)] = cloak;
end