checkRequire("Lua_ChangeJobUtil");

Lua_ThingDefine = { };
Lua_ThingDefine.MALE = 1;
Lua_ThingDefine.FEMALE = 2;

Lua_ThingDefine.PK_STATE_PEASE = 0;
Lua_ThingDefine.PK_STATE_ALL = 1;
Lua_ThingDefine.PK_STATE_TEAM = 2;
Lua_ThingDefine.PK_STATE_CAMP = 3;

Lua_ThingDefine.NPC = 7;
Lua_ThingDefine.SCENE_EFFECT = 6;
Lua_ThingDefine.EXIT = 5;
Lua_ThingDefine.USER = 1;
Lua_ThingDefine.MOUNTS = 4;
Lua_ThingDefine.MONSTER = 3;
Lua_ThingDefine.PLAYER = 2;
Lua_ThingDefine.PET = 8;
Lua_ThingDefine.ACTIVITY_THING = 9;
Lua_ThingDefine.DROP_ITEM = 10;

-- 基本属性字段
Lua_ThingDefine.params = { "guardian_power", -- 特殊字段 属性显示首位
    "attack","blood","blood_max","magic_max","health","defence","crit","dodge","avoid","toughness", "hit","reduce_defence",--两个字属性字段
    "exp_multi","reduction_multi","felement_attack","felement_defence","damage","defence_multi","blood_multi",
    "damage_multi","reverse","attack_multi","skill_hurt_multi","crit_hurt_multi","block","extra_toughness_rate",
    "reverse_hurt_per","base_attack","base_defence","base_blood","skill_reduction_multi","reduce_contral",
    "crit_value_multi","toughness_multi","real_hurt_per","reduce_defence_multi","extra_crit_per","beast_hurt","ignore_defence",--四个字属性字段
    "double_hit","extra_avoid_rate","extra_hit_rate","real_hurt",
    "pvp_damage","pvp_reduce",--五个字属性字段
    "fiend_multi","immortal_multi","deity_multi","cloak_base_multi","beast_hurt_val","pvp_damage_val","pvp_reduce_val"--多个字属性字段
};

Lua_ThingDefine.changeParams = {
    "attack","attack_upper","attack_lower","defence","maxHp","maxMp","hit",
    "dodge","crit","toughness","damage","reduction","reduce_defence","felement_attack","felement_defence"
};

-- 特殊属性字段
Lua_ThingDefine.specialParams = {"metal_power","wood_power","water_power","fire_power","earth_power"};

-- 生肖之力字段
Lua_ThingDefine.zodiacParams = {"rat","cattle","tiger","rabbit","dragon","snake","horse","sheep","monkey","rooster","dog","pig"};

-- 百分比值字段
Lua_ThingDefine.percentage_params = {
    "base_attack","base_defence","base_blood","damage_multi","reduction_multi",
    "exp_multi","attack_multi","blood_multi","defence_multi","cloak_base_multi"
};

function Lua_ThingDefine.isPercentParam(t) -- 是否为百分比字段判断
    if t == "exp_multi" or t == "reduction_multi" or t == "damage" or t == "damage_multi" or t == "reverse" or t == "blood_multi"
        or t == "attack_multi" or t == "skill_hurt_multi" or t == "extra_crit_per" or t == "crit_hurt_multi" or t == "pvp_reduce" or t == "pvp_damage"
        or t == "defence_multi" or t == "block" or t == "reverse_hurt_per" or t == "base_attack" or t == "base_defence" or t == "base_blood" 
        or t == "skill_reduction_multi" or t == "reduce_contral" or t == "crit_value_multi" or t == "toughness_multi" or t == "real_hurt_per" 
        or t == "reduce_defence_multi" or t == "extra_toughness_rate" or t == "cloak_base_multi" or t == "beast_hurt" or t == "ignore_defence" 
        or t == "double_hit" or t == "extra_avoid_rate" or t == "extra_hit_rate" or t == "felement_attack_multi" or t == "felement_defence_multi" then
        return true;
    end
    return false;
end

function Lua_ThingDefine.isStampParam(t) -- 是否为圣印属性判断
    if t == "fiend_multi" or t == "immortal_multi" or t == "deity_multi"  then
        return true;
    end
    return false;
end

function Lua_ThingDefine.getJobName(val, profession)
    profession = profession == nil and 0 or profession;
    profession = profession + 1;
    local name = "";
    if val == 1 then
        name = Lua_ChangeJobUtil.getprofession(profession, val);
        -- LanUtil.getValue(110009);
        return name;
    elseif val == 2 then
        name = Lua_ChangeJobUtil.getprofession(profession, val);
        -- LanUtil.getValue(110009);
        return name;
    elseif val == 3 then
        name = Lua_ChangeJobUtil.getprofession(profession, val);
        -- LanUtil.getValue(110009);
        return name;
    else
        return "no job";
    end
end
function Lua_ThingDefine.getParamName(t)
    local s = getConfig( { "attr_name2", t });
    if s == nil then
        return t
    end
    return s;
end

function Lua_ThingDefine.getParaRankByParams(t)
    for k, v in ipairs(Lua_ThingDefine.params) do
        if t == v then
            return tonumber(k)
        end
    end
    return 99;
end

function Lua_ThingDefine.getParamId(t)
    local s = getConfig( { "attr_id", t });
    return s;
end

function Lua_ThingDefine.getLevelExp(val)
    local mexp = getConfig( { "level", "role_level", val });
    if mexp == nil or mexp == 0 then
        mexp = 100;
    end
    return mexp;
    -- local lvData = Lua_LevelData.new(val);
    -- return lvData.exp;
end
function Lua_ThingDefine.getMaxLevel()
    local mexp = getConfig( { "level", "top_level" });
    return mexp;
end

-- 根据玩家职业获取玩家头像
function Lua_ThingDefine.getHeadIconUrlByCareer(career, profession)
    local url = "";
    if profession == nil then
        url = "/images/head/role/role_" .. career .. "_0.png";
    else
        url = "/images/head/role/role_" .. career .. "_" .. profession .. ".png";
    end
    return url;
end
-- 根据玩家职业获取玩家装扮头像
function Lua_ThingDefine.getFashionHeadIconUrlByCareer(career, profession)
    local url = "";
    if profession == nil then
        url = "/images/head/fashionRole/role_" .. career .. "_0.png";
    else
        url = "/images/head/fashionRole/role_" .. career .. "_" .. profession .. ".png";
    end
    return url;
end
-- 获取玩家自定义头像路径(头像名,是否穿戴头像框(1:圆形头像,0:菱形头像))
function Lua_ThingDefine.getHeadIconUrlByCustom(head_name, isFashion)
    local url = "";
    if isFashion == 1 then
        url = "/images/head/fashionRole/" .. head_name .. ".png";
    elseif isFashion == 0 then
        url = "/images/head/role/" .. head_name .. ".png";
    end
    return url;
end
-- 根据玩家职业获取玩家名字图片
function Lua_ThingDefine.getNameIconUrlByCareer(career, profession)
    local url = "";
    if profession == nil then
        url = "/images/role/career/u" .. career .. "_name0.png";
    else
        url = "/images/role/career/u" .. career .. "_name" .. profession .. ".png";
    end
    return url;
end

function Lua_ThingDefine.getCollectTipsId()
    if Lua_ThingDefine.collectTipsId == nil then
        Lua_ThingDefine.collectTipsId = Lua_CommonUtil.getCommonConfig("show_collect_tips", 1);
    end
    return Lua_ThingDefine.collectTipsId;
end
-- 带颜色的军衔名字
function Lua_ThingDefine.getJunXianName(rank)
    local junxianName = getConfig( { "military_rank", "junxian", rank });
    local junxianColor = getConfig( { "military_rank", "junxian_color", rank });
    return junxianColor .. "[" .. junxianName .. "][-]";
end

-- 根据传入的技能name，返回对应的属性字段名
Lua_ThingDefine.AttrParams = { ["blood_multi"] = "blood", ["defence_multi"] = "defence", ["attack_multi"] = "attack" }
function Lua_ThingDefine.getAttrName(name)
    if Lua_ThingDefine.AttrParams[name] ~= nil then
        return Lua_ThingDefine.AttrParams[name]
    else
        --   print("暂时没有对应的配置，请自行添加");
    end
end