checkRequire("Lua_ThingDefine");
checkRequire("Lua_AttackedData");
Lua_PlayerProxy = class("Lua_PlayerProxy");
function Lua_PlayerProxy:ctor()
	DataCenter.roleData = Lua_RoleData.new();
	DataCenter.attackedData = Lua_AttackedData.new();

	LuaUtil.addLuaMsg(80400101, self, self.onMyDataEnter);
	LuaUtil.addLuaMsg(50400110, self, self.onSceneChange);
	LuaUtil.addLuaMsg(50400205, self, self.onPropertyDetail);
	LuaUtil.addLuaMsg(80400206, self, self.onPlayerInfo);
	LuaUtil.addLuaMsg(80100112, self, self.onPlayerKill);
	LuaUtil.addLuaMsg(80400411, self, self.onPlayerKillValue); -- 罪恶值
	LuaUtil.addLuaMsg(80400413, self, self.onPlayerAttacked); -- 玩家被攻击

	-- 迁移到了Lua_ThingProxy
	-- LuaUtil.addLuaMsg(80400203, self, self.onFightBuff");
	-- LuaUtil.addLuaMsg(80400205, self, self.onRemoveFightBuff");
	-- LuaUtil.addLuaMsg(80400207, self, self.onAddFightBuff");

	LuaUtil.addLuaMsg(80404305, self, self.onHookExp);
	LuaUtil.addLuaMsg(80400110, self, self.onLineInfo);
	LuaUtil.addLuaMsg(50400120, self, self.onLineChange);
	LuaUtil.addLuaMsg(50400007, self, self.onNameColor);
	LuaUtil.addLuaMsg(50400204, self, self.onPkStateChange);

	LuaUtil.addLuaMsg(50600106, self, self.onServerTime);

	LuaUtil.addLuaMsg(80400121, self, self.onBaseParam);
	LuaUtil.addLuaMsg(80400412, self, self.onOutSceneCountDown);
	LuaUtil.addLuaMsg(80401034, self, self.onOutMonsterComeDown);

	LuaUtil.addLuaMsg(81401706, self, self.onEffectShowList);
	LuaUtil.addLuaMsg(80100105, self, self.onGameSwitch);
	LuaUtil.addLuaMsg(80100106, self, self.onRoleLimit);
	LuaUtil.addLuaMsg(81400105, self, self.updateRoleNewName);

	LuaUtil.addLuaMsg(50600107, self, self.onRoleList);
	LuaUtil.addLuaMsg(50600101, self, self.onAddress);

	LuaUtil.addLuaMsg(50110011, self, self.getRoleHead); -- 头像
	LuaUtil.addLuaMsg(50100041, self, self.updateRoleHead); -- 头像
end

function Lua_PlayerProxy:onRoleList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50600107();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.role_data) do
			DataCenter.thingData:setCloakTemp(v.role_id, v.cloak);
		end
	end
end

function Lua_PlayerProxy:onAddress(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50600101();
		msg:ParseFromString(mp.data);
	end
end

-- 游戏功能开关
function Lua_PlayerProxy:onGameSwitch(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100105();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.game_switch_list) do
			DataCenter.roleData.switchDic[v.name] = v.obj_value;
		end
	end
end

function Lua_PlayerProxy:onRoleLimit(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100106();
		msg:ParseFromString(mp.data);
		DataCenter.roleData.limit = msg.limit;
	end
end

function Lua_PlayerProxy:onEffectShowList(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401706();
		msg:ParseFromString(mp.data);
		for i,v in ipairs(msg.event_status) do
			DataCenter.roleData:addLockEffectList(v);
		end
		Lua_MsgUtil.callFunc("LOCK_EFFECT_LIST");
	end
end

function Lua_PlayerProxy:onNameColor(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400007();
		msg:ParseFromString(mp.data);

		DataCenter.roleData.kill_value = msg.kill_value;
		DataCenter.roleData.nameColor = msg.color;
		DataCenter.roleData.worldLevel = msg.world_level;
		DataCenter.roleData.expAddition = msg.exp_addition;

		local obj = DataCenter.thingData:getThingObj(DataCenter.roleData.roleId);
		if obj ~= nil then
			obj:showName();
		end
		Lua_MsgUtil.callFunc("PLAYER_KILL_VALUE");
	end
end

function Lua_PlayerProxy:onHookExp(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80404305();
		msg:ParseFromString(mp.data);
		DataCenter.hangUpSettingsData:setExpRate(tonumber(tostring(msg.exp)), msg.show);
	end
end

function Lua_PlayerProxy:onLineInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400110();
		msg:ParseFromString(mp.data);
		DataCenter.roleData.curLine = msg.cur_line;
		DataCenter.roleData.allLines:clear();
		for i,v in ipairs(msg.lines) do
			DataCenter.roleData.allLines:add(v);
		end
		Lua_MsgUtil.callFunc("ON_LINE_INFO");
	end
end

function Lua_PlayerProxy:onLineChange(mp)
	if mp.errno == 0 then
		OperateAlert.show(LanUtil.getValue(110645));
	end
end

function Lua_PlayerProxy:onPkStateChange(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400204();
		msg:ParseFromString(mp.data);
		DataCenter.roleData.pkState = msg.pk_state;
		Lua_MsgUtil.callFunc("PK_STATE_UPDATE");

		local langNum = msg.pk_state;
		if langNum == Lua_ThingDefine.PK_STATE_PEASE then
			langNum = 110012;
		elseif langNum == Lua_ThingDefine.PK_STATE_ALL then
			langNum = 110014;
		else
			langNum = 110013;
		end
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110640), LanUtil.getValue(langNum)));
	end
end

function Lua_PlayerProxy:onMyDataEnter(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400101();
		msg:ParseFromString(mp.data);
		DataCenter.roleData:fromServer(msg);
		Lua_MsgUtil.callFunc("SCENE_CHANGE");
		Lua_MsgUtil.callFunc("ROLE_HP_UPDATE");
	end
end

function Lua_PlayerProxy:onPlayerKill(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80100112();
		msg:ParseFromString(mp.data);
		DataCenter.killData = msg;
	end
end

function Lua_PlayerProxy:onPlayerKillValue(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400411();
		msg:ParseFromString(mp.data);
		DataCenter.roleData.kill_value = msg.kill_value;
		Lua_MsgUtil.callFunc("PLAYER_KILL_VALUE");
	end
end

function Lua_PlayerProxy:onPlayerAttacked(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400413();
		msg:ParseFromString(mp.data);
		DataCenter.attackedData:fromServer(msg);
	end
end

function Lua_PlayerProxy:onPlayerInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400206();
		msg:ParseFromString(mp.data);
		local roleData = DataCenter.roleData;
		if roleData.fightChange.oldLv == 0 then
			roleData.fightChange.oldLv = roleData.level;
		end
		if roleData.fightChange.oldFight == 0 then
			roleData.fightChange.oldFight = roleData.force;
		end
		roleData.force = tonumber(tostring(msg.force));
		roleData.attack = tonumber(tostring(msg.attack));
		roleData.defence = tonumber(tostring(msg.defence));
		roleData.maxHp = tonumber(tostring(msg.max_blood));
		roleData.hit = tonumber(tostring(msg.hit));
		roleData.dodge = tonumber(tostring(msg.avoid));
		roleData.crit = tonumber(tostring(msg.crit));
		roleData.toughness = tonumber(tostring(msg.toughness));
		roleData.attack_lower = tonumber(tostring(msg.attack_lower));
		roleData.attack_upper = tonumber(tostring(msg.attack_upper));
		roleData.maxMp = tonumber(tostring(msg.max_magic));
		roleData.damage = tonumber(tostring(msg.damage_per));
		roleData.reduction = tonumber(tostring(msg.reduction_per));
		roleData.fightChange.curLv = roleData.level;
		roleData.fightChange.curFight = tonumber(tostring(roleData.force));

		if msg.level > roleData.level then
			Lua_MsgUtil.callFunc("EACH_LV_UP");
			self:checkSceneLevelOpene(msg.level);
			if msg.level == Lua_CommonUtil.getCommonConfig("switch_auto_sole", 1) then
				DataCenter.hangUpSettingsData.auto_sell = 1;
				Lua_MsgUtil.callFunc("HANGUP_PANEL_UPDATE");
				DataCenter.hangUpSettingsData:saveHangUp();
			end
		end
		roleData.level = msg.level;

		local open_lvl = getConfig({"func_open", 10184, "cond_level"});
		if msg.level == open_lvl and DataCenter.roleData.isOpenCloak == nil then
			DataCenter.roleData.isOpenCloak = true;
			Lua_MsgUtil.callFunc("OPEN_CLOAK_UPDATE"); -- 披风功能开启刷新 合成界面
		end
		Lua_CommonUtil.delayCall(0.5, self, self.onDelayUpdateState);
	end
end

-- BUG #11879 在指定场景到达某个等级弹出活动面板
function Lua_PlayerProxy:checkSceneLevelOpene(lv)
	local cvalue = Lua_CommonUtil.getCommonConfig("open_panels", 3);
	if cvalue == nil then
		return;
	end

	if cvalue[2] == DataCenter.roleData.sceneId then
	local isLv = false;
	for i,v in ipairs(cvalue[1]) do
		if lv == v then
			isLv = true;
		end
	end

		if isLv then
			local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(Lua_OperationalActivitiesData.MYSTERIOUS_FIRST, 0); -- 神秘限购
			if avo ~= nil then
				Lua_WindowUtil.openWin("Lua_MysteriousBuyWindow", WinParam.ACTION_OPEN);
				return;
			end

			local rtData = DataCenter.allRtData.topRightIconDic[10078];
			if rtData ~= nil and rtData.canShow then
				Lua_WindowUtil.openWin("Lua_NewServerActivityWindow", WinParam.ACTION_OPEN); -- 开服冲榜
				return;
			end
		end
	end
end

function Lua_PlayerProxy:onDelayUpdateState()
	local data = DataCenter.roleData;
	if data.fightChange.curLv > data.fightChange.oldLv then
		MsgUtil.callFunc("PLAYER_LEVEL_UP");
		Lua_CommonUtil.checkPreloadScene(data.fightChange.curLv);

		local dic = {};
		dic.roleLevel = data.level;
		dic.fighting = data.force;
		DataCenter.sdkInterface:callSDKInterfaceTab(Lua_SDKMessageType.UpdateLevel, dic);
	end

	local changeFight = data.fightChange.curFight - data.fightChange.oldFight;
	if changeFight ~= 0 then
		MsgUtil.callFunc(EventsDefine.WIN_SHOW_HIDE, WinParam.getWinParam("FightChangeWindow", WinParam.ACTION_OPEN,
		{oldFight = data.fightChange.oldFight, curFight = data.fightChange.curFight}));
	end
	Lua_MsgUtil.callFunc("ROLE_DATA_CHANGE", data.force);
	data:resetChangeParam();
end

function Lua_PlayerProxy:onSceneChange(mp)
	if mp.errno == 0 then
		local bChangeScene = false;
		local msg = ProtoPublic_pb.Proto50400110();
		msg:ParseFromString(mp.data);
		if msg.scene_id ~= DataCenter.roleData.sceneId then
			bChangeScene = true;
		end
		DataCenter.roleData.lastScene = DataCenter.roleData.sceneId;
		DataCenter.roleData.sceneId = msg.scene_id;
		DataCenter.roleData.px = msg.pixel_x;
		DataCenter.roleData.py = msg.pixel_y;
		DataCenter.roleData.pz = msg.pixel_z;

		if bChangeScene then
			if Lua_WindowUtil.isWindowShowing("Lua_ChallengeTimeWindow") then
				Lua_WindowUtil.openWin("Lua_ChallengeTimeWindow", WinParam.ACTION_CLOSE);
			end

			Lua_MsgUtil.callFunc("SCENE_CHANGE");
		else
			Lua_MsgUtil.callFunc("PLAYER_POS_UPDATE");
			if DataCenter.campWarData.bInCampWarScene then -- 策划要求夺旗场景传送弹提示
				OperateAlert.show(LanUtil.getValue(122723));
			end
		end
	end
end

function Lua_PlayerProxy:onServerTime(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50600106();
		msg:ParseFromString(mp.data);
		DataCenter.roleData:setServerTime(msg.time);
	end
end

function Lua_PlayerProxy:onPropertyDetail(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400205();
		msg:ParseFromString(mp.data);

		local roleData = DataCenter.roleData;
		roleData.heart_rate = msg.heart_rate; -- 会心率
		roleData.reduce_defence = msg.reduce_defence; -- 破甲
		roleData.crit_hurt = msg.crit_hurt; -- 暴击伤害
		roleData.damage = msg.damage; -- 伤害加深
		roleData.reduction = msg.reduction; -- 伤害减免
		roleData.felement_attack = msg.felement_attack; -- 元素攻击
		roleData.felement_defence = msg.felement_defence; -- 元素防御
		roleData.pvp_damage = msg.pvp_damage; -- PVP伤害增加
		roleData.pvp_reduction = msg.pvp_reduction; -- PVP伤害减少
		roleData.reduce_contral = msg.reduce_contral; -- 控制抵抗
		roleData.attack_blood = msg.attack_blood; -- 饮血
		roleData.beast_damage = msg.beast_damage; -- 宠物伤害
		roleData.reverse = msg.reverse; -- 伤害反射
		roleData.skill_hurt_val = msg.skill_hurt_val; -- 技能伤害
		roleData.ignore_defence = msg.ignore_defence; -- 无视防御
		roleData.real_hurt = msg.real_hurt; -- 真伤
		roleData.block_hurt_rate = msg.block_hurt_rate; -- 格挡几率
		roleData.thump_rate = msg.thump_rate; -- 重击几率
		roleData.double_hit_rate = msg.double_hit_rate; -- 连击几率
		roleData.speed_multi = msg.speed_multi; -- 移速加成
		roleData.extra_crit_rate = msg.extra_crit_rate; -- 额外暴击率
		roleData.extra_toughness_rate = msg.extra_toughness_rate; -- 额外韧性率
		roleData.extra_avoid_rate = msg.extra_avoid_rate; -- 额外闪避率
	end
end

function Lua_PlayerProxy:onFightBuff(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end

		local msg = ProtoPublic_pb.Proto80400203();
		msg:ParseFromString(mp.data);
		if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
			DataCenter.roleData.buffList = Array();

			local buffVo;
			for i,v in ipairs(msg.status_list) do
				buffVo = Lua_BuffVo.new(v.status);
				buffVo:fromServer(v);
				DataCenter.roleData:updateBuff(buffVo);
				if buffVo.hunluan == 1 then
					DataCenter.thingData.lastSelectedTime = 0;
				end
			end
			Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
		end
	end
end

function Lua_PlayerProxy:onRemoveFightBuff(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end

		local msg = ProtoPublic_pb.Proto80400205();
		msg:ParseFromString(mp.data);
		if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
			DataCenter.roleData:removeBuff(msg.status);
			Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
		end
	end
end

function Lua_PlayerProxy:onAddFightBuff(mp)
	if mp.errno == 0 then
		if DataCenter.configLoaded ~= 1 then
			return;
		end

		local msg = ProtoPublic_pb.Proto80400207();
		msg:ParseFromString(mp.data);
		if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
			local buffVo = Lua_BuffVo.new(msg.status_detial.status);
			buffVo:fromServer(msg.status_detial);
			DataCenter.roleData:updateBuff(buffVo);
			if buffVo.hunluan == 1 then
				DataCenter.thingData.lastSelectedTime = 0;
			end
			Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
		end

		local b2 = Lua_BuffVo.new(msg.status_detial.status);
		if b2.warn_effect ~= 0 then
			b2:fromServer(msg.status_detial);

			ThingUtil.instance:addWarnEffect({px = msg.status_detial.coord.pixel_x, py = msg.status_detial.coord.pixel_y, pz = msg.status_detial.coord.pixel_z,
				outsideR = b2.warn_outside_radius, insideR = b2.warn_inside_radius, lt = b2.leftTime, speed = b2.warn_speed,
				outAtlas = "warningEffect", outSprite = "out_ring", insideAtlas = "warningEffect", insideSprite = "inside_ring"});

			Lua_WindowUtil.openWin("Lua_WarningTipsWindow", nil, {lt = b2.leftTime, spname = "warn_tips1"});
		end
	end
end

function Lua_PlayerProxy:onBaseParam(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400121();
		msg:ParseFromString(mp.data);
		local roleData = DataCenter.roleData;
		local isFirst = false;
		if roleData.baseParam == nil then
			isFirst = true;
			roleData.baseParam = {};
		end

		for i,v in ipairs(Lua_ThingDefine.changeParams) do
			if roleData.baseParamChange[v] == 0 and roleData.baseParam[v] ~= nil then
				roleData.baseParamChange[v] = roleData.baseParam[v];
			end
		end
		roleData.baseParam.blood_max = tonumber(tostring(msg.blood_max));
		roleData.baseParam.maxHp = tonumber(tostring(msg.blood_max));
		roleData.baseParam.magic_max = tonumber(tostring(msg.magic_max));
		roleData.baseParam.maxMp = tonumber(tostring(msg.magic_max));
		roleData.baseParam.attack_sum = tonumber(tostring(msg.attack_lower)) + tonumber(tostring(msg.attack_upper));
		roleData.baseParam.defence = tonumber(tostring(msg.defence));
		roleData.baseParam.crit = tonumber(tostring(msg.crit));
		roleData.baseParam.toughness = tonumber(tostring(msg.toughness));
		roleData.baseParam.hit = tonumber(tostring(msg.hit));
		roleData.baseParam.avoid = tonumber(tostring(msg.avoid));
		roleData.baseParam.dodge = tonumber(tostring(msg.avoid));
		roleData.baseParam.beast_attack = tonumber(tostring(msg.beast_attack));
		roleData.baseParam.attack_lower = tonumber(tostring(msg.attack_lower));
		roleData.baseParam.attack_upper = tonumber(tostring(msg.attack_upper));
		roleData.baseParam.damage = msg.damage_per;
		roleData.baseParam.reduction = msg.reduction_per;
		roleData.baseParam.heart_rate = msg.heart_rate;
		roleData.baseParam.reduce_defence = msg.reduce_defence;
		roleData.baseParam.crit_hurt = msg.crit_hurt;
		roleData.baseParam.felement_attack = msg.felement_attack;
		roleData.baseParam.felement_defence = msg.felement_defence;
		roleData.baseParam.pvp_damage = msg.pvp_damage;
		roleData.baseParam.pvp_reduction = msg.pvp_reduction;
		roleData.baseParam.reduce_contral = msg.reduce_contral;
		roleData.baseParam.attack_blood = msg.attack_blood;
		roleData.baseParam.beast_damage = msg.beast_damage;
		roleData.baseParam.reverse = msg.reverse;
		roleData.baseParam.skill_hurt_val = msg.skill_hurt_val;
		roleData.baseParam.ignore_defence = msg.ignore_defence;
		roleData.baseParam.real_hurt = msg.real_hurt;
		roleData.baseParam.block_hurt_rate = msg.block_hurt_rate;
		roleData.baseParam.thump_rate = msg.thump_rate;
		roleData.baseParam.double_hit_rate = msg.double_hit_rate;
		roleData.baseParam.speed_multi = msg.speed_multi;
		roleData.baseParam.extra_crit_rate = msg.extra_crit_rate;
		roleData.baseParam.extra_toughness_rate = msg.extra_toughness_rate;

		roleData.baseParam.blood_max_base = tonumber(tostring(msg.blood_max_base));
		roleData.baseParam.attack_lower_base = tonumber(tostring(msg.attack_lower_base));
		roleData.baseParam.attack_upper_base = tonumber(tostring(msg.attack_upper_base));
		roleData.baseParam.attack_sum_base = tonumber(tostring(msg.attack_lower_base)) + tonumber(tostring(msg.attack_upper_base));
		roleData.baseParam.defence_base = tonumber(tostring(msg.defence_base));
		roleData.baseParam.crit_base = tonumber(tostring(msg.crit_base));
		roleData.baseParam.toughness_base = tonumber(tostring(msg.toughness_base));
		roleData.baseParam.hit_base = tonumber(tostring(msg.hit_base));
		roleData.baseParam.avoid_base = tonumber(tostring(msg.avoid_base));
		roleData.baseParam.felement_attack_base = tonumber(tostring(msg.felement_attack_base));
		roleData.baseParam.felement_defence_base = tonumber(tostring(msg.felement_defence_base));
		roleData.baseParam.absolutely_attack = tonumber(tostring(msg.absolutely_attack));
		roleData.baseParam.absolutely_defence = tonumber(tostring(msg.absolutely_defence));

		roleData.absolutely_attack = tonumber(tostring(msg.absolutely_attack));
		roleData.absolutely_defence = tonumber(tostring(msg.absolutely_defence));
		roleData.skill_reduction_multi = msg.skill_reduction_multi;
		roleData.extra_hit_rate = msg.extra_hit_rate;

		roleData.baseParam.equip_blood = tonumber(tostring(msg.equip_blood));
		roleData.baseParam.equip_attack = tonumber(tostring(msg.equip_attack_upper)) + tonumber(tostring(msg.equip_attack_lower));
		roleData.baseParam.equip_defence = tonumber(tostring(msg.equip_defence));
		roleData.baseParam.extra_avoid_rate = msg.extra_avoid_rate;

		roleData.baseParam.metal_power = tonumber(tostring(msg.metal_power));
		roleData.baseParam.wood_power = tonumber(tostring(msg.wood_power));
		roleData.baseParam.water_power = tonumber(tostring(msg.water_power));
		roleData.baseParam.fire_power = tonumber(tostring(msg.fire_power));
		roleData.baseParam.earth_power = tonumber(tostring(msg.earth_power));
		roleData.baseParam.guardian_power = tonumber(tostring(msg.guardian_power)); -- 守护力

		roleData.baseParam.attack = 0;
		Lua_ProxyManager.getProxy("Lua_PackProxy"):checkBetterEqu();
		Lua_MsgUtil.callFunc("BASE_PARAM_COMPLETE");

		--进入游戏时使用v+卡的特殊处理
		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK); 
		local curData = bagData:getItemByItemId(202000059);
		if curData ~= nil and  DataCenter.vipData.level == 0 then
			Lua_MsgUtil.callFunc("USE_VIP_CARD")
		end

		if DataCenter.funcOpenData:isOpened(10141) then
			DataCenter.mountEquipData:checkMountRedDotSate(); -- 骑装红点更新
		end

		if isFirst == false then
			Lua_CommonUtil.delayCall(0.5, self, self.onDelayUpdateBaseParam);
		end
	end
end

function Lua_PlayerProxy:onDelayUpdateBaseParam()
	local roleData = DataCenter.roleData;
	if roleData.baseParam == nil or roleData.baseParamChange == nil then
		return;
	end

	local param = {};
	for i,v in ipairs(Lua_ThingDefine.changeParams) do
		if roleData.baseParam[v] ~= nil and roleData.baseParamChange[v] ~= nil then
			local c = roleData.baseParam[v] - roleData.baseParamChange[v];
			if math.abs(c) > 0.0001 then
				param[v] = c;
			end
		end
	end
	Lua_WindowUtil.openWin("Lua_ParamChangeWindow", WinParam.ACTION_OPEN, param);
	roleData:resetBaseChangeParam();
end

function Lua_PlayerProxy:onOutSceneCountDown(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400412();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("OUTSCENE_COUNTDOWN_TIME", msg);
	end
end

-- 怪物攻城
function Lua_PlayerProxy:onOutMonsterComeDown(mp)
	if mp.errno == 0 then
	local msg = ProtoPublic_pb.Proto80401034();
	msg:ParseFromString(mp.data);
		if msg.scene_id == DataCenter.roleData.sceneId then
			Lua_MsgUtil.callFunc("OUTMONSTRE_COMEDOWN_TIME", msg);
		end
	end
end

-- 更新角色改名后新名字
function Lua_PlayerProxy:updateRoleNewName(mp)
	if mp.errno == 0 then
	local msg = ProtoPublic_pb.Proto81400105();
	msg:ParseFromString(mp.data);
		if DataCenter.roleData.roleId == tonumber(msg.role_id) then
			DataCenter.roleData.name = msg.role_name;
			Lua_MsgUtil.callFunc("ROLE_HP_UPDATE", 0);
		end
	end
end

-- 获取头像
function Lua_PlayerProxy:getRoleHead(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50110011();
		msg:ParseFromString(mp.data);
		DataCenter.roleData:init50110011(msg);
	end
end

-- 新增更新头像
function Lua_PlayerProxy:updateRoleHead(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50100041();
		msg:ParseFromString(mp.data);
		DataCenter.roleData:init50100041(msg);
		Lua_MsgUtil.callFunc("ROLE_HEAD_UPDATE");
	end
end

function Lua_PlayerProxy:sSaveHeadIcon(role_head)
	local cmd = ProtoPublic_pb.Proto10100011();
	cmd.role_head.head_time = 0;
	cmd.role_head.is_dress = 1;
	cmd.role_head.role_head = role_head;
	sendMsg(10100011, cmd);
end