checkRequire("Lua_ThingData");
checkRequire("Lua_ThingVo");
checkRequire("Lua_RoleData");
checkRequire("Lua_MonsterConfigData");
Lua_ThingProxy = class("Lua_ThingProxy");
function Lua_ThingProxy:ctor()
	if DataCenter.roleData == nil then
        DataCenter.roleData = Lua_RoleData.new();
    end
	DataCenter.thingData = Lua_ThingData.new();
	LuaUtil.addLuaMsg(80400102, self, self.onOtherPlayerEnterWorld);
	LuaUtil.addLuaMsg(80400202, self, self.onUpdateFightInfo);
	LuaUtil.addLuaMsg(80400208, self, self.onUpdatePlayerState);
	LuaUtil.addLuaMsg(80400104, self, self.onThingDisappear);
	LuaUtil.addLuaMsg(80400111, self, self.onMonsterEnter);
	LuaUtil.addLuaMsg(80400103, self, self.onPetEnter);
	LuaUtil.addLuaMsg(80400105, self, self.onThingMoveHandler);
	LuaUtil.addLuaMsg(80400112, self, self.onDropItem);
	LuaUtil.addLuaMsg(80400119, self, self.onChangeRewardBelong);

	LuaUtil.addLuaMsg(80400203, self, self.onFightBuff);
    LuaUtil.addLuaMsg(80400205, self, self.onRemoveFightBuff);
    LuaUtil.addLuaMsg(80400207, self, self.onAddFightBuff);

    LuaUtil.addLuaMsg(80405101, self, self.onTransfer);
    LuaUtil.addLuaMsg(81400105, self, self.onChangeName);
    self.delayResetTrans = Array();
    self.delayCloakTrans = Array();

    self.buffEvent = {};
    self.buffEvent[1114] = {owner=self, inCallBack=self.onAddTransferModelBuff, outCallBack=self.onRemoveTransferModelBuff};--变身模型
    self.buffEvent[1112] = {owner=self, inCallBack=self.onAddTransferSkillBuff};--变身技能
    self.buffEvent[10069] = {owner=self, inCallBack=self.onAddJueXingCopyBuff, outCallBack=self.onRemoveJueXingCopyBuff};--觉醒副本技能
end

function Lua_ThingProxy:onChangeRewardBelong(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400119();
--		print("Proto80400119");
		msg:ParseFromString(mp.data);
		local thingVo = DataCenter.thingData:getThing(msg.ai_id);
		if thingVo == nil then
			return;
		end
		thingVo.reward_belong = msg.reward_belong;
		Lua_MsgUtil.callFunc("BOSS_REWARD_BELONG_CHANGE",msg);
	end
end

function Lua_ThingProxy:onUpdateFightInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400202();
		msg:ParseFromString(mp.data);
		local thingVo = DataCenter.thingData:getThing(msg.fighter_id);
		if thingVo == nil then
			return;
		end
		local tid = tonumber(msg.fighter_id);
		local updateEvent = tid == DataCenter.roleData.roleId;
		
		if msg.fight_info.type == 1 then
			local hp = tonumber(tostring(msg.fight_info.tips1));
			thingVo.hp = hp;

			if tonumber(tostring(msg.fight_info.tips2)) == 5 then -- 更新最大血量
				if thingVo.maxHp < hp then
					thingVo.maxHp = hp;
				end
			end
			-- 杀人提示改成服务端处理
			-- if hp <= 0 and DataCenter.roleData.bShowKillRoleTips == true then -- 杀人提示
			-- 	local attackId = tonumber(msg.fight_info.attackor_id);
			-- 	if updateEvent then -- 玩家是受害者
			-- 		local attackVo = DataCenter.thingData:getThing(attackId);
			-- 		if attackVo ~= nil and (attackVo.kind == Lua_ThingDefine.USER or attackVo.kind == Lua_ThingDefine.PLAYER) then -- 双方都是玩家
			-- 			if attackVo.leagueName ~= nil and attackVo.leagueName ~= "" then
			-- 				local str = attackVo.leagueName;
			-- 				str = string.gsub(str, "%z", "");
			-- 				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110340), str, attackVo.name));
			-- 			else
			-- 				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110341), attackVo.name));
			-- 			end
			-- 		end
			-- 	elseif (thingVo.kind == Lua_ThingDefine.PLAYER or thingVo.kind == Lua_ThingDefine.USER) and attackId == DataCenter.roleData.roleId then -- 玩家是攻击者
			-- 		if thingVo.leagueName ~= nil and thingVo.leagueName ~= "" then
			-- 			local str = thingVo.leagueName;
			-- 			str = string.gsub(str, "%z", "");
			-- 			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110338), str, thingVo.name));
			-- 		else
			-- 			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(110339), thingVo.name));
			-- 		end
			-- 	end
			-- end

			if thingVo.kind == Lua_ThingDefine.MONSTER and thingVo.monsterData.isCollect == true then
				local rp = ThingUtil.instance:getThingById(tonumber(msg.fighter_id));
				if rp ~= nil then
					local bc = rp.root:GetComponent("BoxCollider");
					if bc ~= nil then
						if thingVo.hp > 0 then
							bc.enabled = true;
						else
							bc.enabled = false;
						end
					end
				end
			end
		elseif msg.fight_info.type == 2 then
			thingVo.mp = tonumber(msg.fight_info.tips1);
		elseif msg.fight_info.type == 3 then
			if updateEvent then
				local v = math.floor(msg.fight_info.value);
				if v > 0 then
					local per = math.floor(tonumber(msg.fight_info.tips2));
					if per <= 0 then
						OperateAlert.show("+EXP "..Lua_CommonUtil.getNumberTrans(v), nil, 1);
					else
						OperateAlert.show("+EXP "..Lua_CommonUtil.getNumberTrans(v).."(+"..per.."%)", nil, 1);
					end
				elseif v <0 then
					OperateAlert.show("-EXP "..Lua_CommonUtil.getNumberTrans(math.abs(v)), nil, 1);
				end
			end
			thingVo.exp = tonumber(tostring(msg.fight_info.experience));
		elseif msg.fight_info.type == 7 then
			thingVo.pkState = msg.fight_info.value;
		elseif msg.fight_info.type == 4 then
			thingVo.fightState = msg.fight_info.value ~= 0;
		elseif msg.fight_info.type == 10 then -- 阵营
			if updateEvent == true and DataCenter.roleData.camp_id ~= msg.fight_info.value then -- 自己
                DataCenter.roleData.camp_id = msg.fight_info.value;
	        end
            thingVo.camp_id = msg.fight_info.value;
        elseif msg.fight_info.type == 12 then -- 等級
        	thingVo.lvl = msg.fight_info.value;
        elseif msg.fight_info.type == 13 then -- 变身
        	if thingVo.kind == Lua_ThingDefine.MONSTER then
	        	thingVo.monsterData = Lua_MonsterConfigData.new(msg.fight_info.value);
	        	thingVo.name = thingVo.monsterData.name;
	        end
	        -- 如果是选中的，则刷新名字
	        if DataCenter.hook.selectedId == thingVo.objId then
	        	Lua_MsgUtil.callFunc("SELECTED_TARGET_INFOCHANGE");
	        end
	    elseif msg.fight_info.type == 14 then -- 占领状态
	    	thingVo.collect_occupy_state = msg.fight_info.value;
		end
		if updateEvent then
			if msg.fight_info.type == 1 or msg.fight_info.type == 2 or msg.fight_info.type == 3 then
				Lua_CommonUtil.delayCollectCall("ROLE_HP_UPDATE", self, self.onRoleHpUpdate, msg.fight_info.type, 0.5);
			end
			if msg.fight_info.type == 7 then
				Lua_MsgUtil.callFunc("PK_STATE_UPDATE");
			end
		end
		if DataCenter.hook ~= nil and tid == DataCenter.hook.selectedId and (msg.fight_info.type == 1 or msg.fight_info.type == 12) then
			Lua_CommonUtil.delayCollectCall("SELECTED_TARGET_CHANGE", self, self.onTargetHpUpdate, msg.fight_info.type, 0.3);
		end
	end
end
function Lua_ThingProxy:onTargetHpUpdate(param)
	Lua_MsgUtil.callFunc("SELECTED_TARGET_CHANGE");
end
function Lua_ThingProxy:onRoleHpUpdate(param)
	Lua_MsgUtil.callFunc("ROLE_HP_UPDATE", param);
end
function Lua_ThingProxy:onUpdatePlayerState(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400208();
		msg:ParseFromString(mp.data);

		local lData = DataCenter.thingData:getThing(tonumber(msg.role_id));
		local thingObj = DataCenter.thingData:getThingObj(tonumber(msg.role_id));	
--		print("Proto80400208 role_id"..tostring(msg.role_id).." , update_type "..tostring(msg.update_type));
		if thingObj == nil or lData == nil then
			return;
		end
		--print("Proto80400208 msg.league_name:"..tostring(msg.league_name).." , msg.league_id:"..tostring(msg.league_id));    
		if msg.update_type == 4 then--称号
			lData.labelId = msg.cur_label;
			thingObj:updateTitle();
			thingObj:updateHeadThingPosition();
		elseif msg.update_type == 2 then--VIP
			lData.vipType = msg.vip_type;
		elseif msg.update_type == 22 then--军衔
			lData.militaryRank = msg.military_rank;
			thingObj:showName();
		elseif msg.update_type == 5 then --帮派
--			print("Proto80400208 msg.update_type5 msg.league_name"..tostring(msg.league_name));
			lData.leagueId = tonumber(msg.league_id);
			lData.leagueName = msg.league_name;
			thingObj:showLeagueName();
			thingObj:updateHeadThingPosition();
			if tonumber(msg.role_id) == DataCenter.roleData.roleId then
				Lua_MsgUtil.callFunc("FACTION_NAME_UPDATE");
			end
		elseif msg.update_type == 11 then --名字颜色
			lData.nameColor = msg.value;
			thingObj:showName();
		elseif msg.update_type == 1 then --坐骑状态
			lData.mount_id = msg.value;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("UPFATE_MOUNT_STATE");
			end
			if lData.transferId ~= 0 then
				self.delayResetTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
			end
		elseif msg.update_type == 3 then --装备外形
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				DataCenter.roleData.weapon_id = msg.weapon_id;
				DataCenter.roleData.clothes_id = msg.clothes_id;
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
		elseif msg.update_type == 30 then --掉落标识
			lData.ascription_state = msg.ascription_state;
			thingObj:updateAscription();	
			thingObj:updateHeadThingPosition();
        elseif msg.update_type == 32 then --占领归属
            lData.occupy_state = msg.occupy_state;
            thingObj:updateOccupation();
            thingObj:updateHeadThingPosition();
		elseif msg.update_type == 15 then --神翼
			lData.wingId = msg.wing_id;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
			if lData.transferId ~= 0 then
				self.delayResetTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
			end
		elseif msg.update_type == 27 then --仙器
			lData.fairyId = msg.fairy_shape;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
			if lData.transferId ~= 0 then
				self.delayResetTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
			end
		elseif msg.update_type == 33 then --披风
			lData.cloak = msg.cloak;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
			if lData.transferId == 0 then
				self.delayCloakTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onCloakTransAct);
			end
		elseif msg.update_type == 13 then --法器
			lData.faqiId = msg.mw_id;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
			if lData.transferId ~= 0 then
				self.delayResetTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
			end
		elseif msg.update_type == 28 then --足迹
			lData.spoorId = msg.spoor_shape;
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
		elseif msg.update_type == 19 then --時裝
			lData.fashion_weapon_id = msg.fashion_weapon;
			lData.fashion_clothes_id = msg.fashion_clothes;
			lData.fashionHeadId = msg.fashion_hat;
			if lData.transferId ~= 0 then
				self.delayResetTrans:add(tonumber(msg.role_id));
				Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
			end
			if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
				Lua_MsgUtil.callFunc("PLAYER_MODEL_UPDATE");
			end
			lData.headFrame = tonumber(msg.fashion_head_frame);
			lData.fashionBgId = tonumber(msg.fashion_background_id);
		elseif msg.update_type == 20 then --伴侶
			lData.partnerId = tonumber(msg.partner_id);
			lData.partnerName = tostring(msg.partner_name);
		end
	end
end
function Lua_ThingProxy:onDelayTransAct()
	local len = self.delayResetTrans:getSize();
	for i=1,len do
		local thingVo = DataCenter.thingData:getThing(self.delayResetTrans[i]);
		if thingVo ~= nil and thingVo.transferId ~= 0 and thingVo.transferId ~= nil then
			DataCenter.thingData:updateTransfer(self.delayResetTrans[i], thingVo.transferId, true);
		end
	end
	self.delayResetTrans:clear();
end
function Lua_ThingProxy:onOtherPlayerEnterWorld(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400102();
		msg:ParseFromString(mp.data);
		if tonumber(msg.role_id) == tonumber(DataCenter.roleData.roleId) then
			DataCenter.roleData.militaryRank = msg.military_rank;
			DataCenter.roleData.labelId = msg.shape_info.label;
			DataCenter.roleData.nameColor = msg.name_color;
			DataCenter.roleData.ascription_state = msg.ascription_state;
			--[[local myThingObj = DataCenter.thingData:getThingObj(msg.role_id);
			if myThingObj ~= nil then
				myThingObj:updateAscription();
			end--]]
		else
			local thingVo = Lua_ThingVo.new(msg.role_id, Lua_ThingDefine.USER);
			thingVo:fromUserServer(msg);
			DataCenter.thingData:addThing(thingVo);
			local mid = tonumber(msg.model_id);
			DataCenter.thingData:updateTransfer(tonumber(msg.role_id), mid, mid ~= 0);
			self.delayResetTrans:add(tonumber(msg.role_id));
			Lua_CommonUtil.delayCall(0.05, self, self.onDelayTransAct);
		end
	end
end
function Lua_ThingProxy:onMonsterEnter(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400111();
		msg:ParseFromString(mp.data);
		local thingVo = Lua_ThingVo.new(msg.ai_id, Lua_ThingDefine.MONSTER);
--		print("msg.ai_sort",msg.ai_sort);
		thingVo.configId = msg.ai_sort;
		thingVo:fromMonsterServer(msg);
		DataCenter.thingData:addThing(thingVo);
	end
end
function Lua_ThingProxy:onPetEnter(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400103();
		msg:ParseFromString(mp.data);
		local thingVo = Lua_ThingVo.new(msg.beast_id, Lua_ThingDefine.PET);
		thingVo:fromPetServer(msg);
		DataCenter.thingData:addThing(thingVo);
	end
end
function Lua_ThingProxy:onDropItem(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400112();
		msg:ParseFromString(mp.data);

		if msg.drop_type == 0 or msg.drop_type == 1 or msg.drop_type == 10 then
			local isIn = false;
			for i,v in ipairs(msg.viewer_set) do
				if tonumber(v) == DataCenter.roleData.roleId then
					isIn = true;
					break;
				end
			end
            if isIn == false then
            	return;
            end
        end
		local thingVo = Lua_ThingVo.new(msg.drop_id, Lua_ThingDefine.DROP_ITEM);
		thingVo:fromDropServer(msg);
		DataCenter.thingData:addDrop(thingVo);
	end
end
function Lua_ThingProxy:onThingMoveHandler(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400105();
		msg:ParseFromString(mp.data);

		local thingVo = DataCenter.thingData:getThing(msg.mover_id);
		if tonumber(msg.mover_id) == DataCenter.roleData.roleId then
			local px = PlayerData.getInstance().data.px;
			local py = PlayerData.getInstance().data.py;
			local pz = PlayerData.getInstance().data.pz;
			DataCenter.MoveTestData = "myPos x：".. px .."，y：".. py .."，z：".. pz .."\n\n";
			
			local step;
			local text;
			local pos = Vector3(px,py,pz);
			for j,k in ipairs(msg.step_list) do
				local step = Vector3(k.pixel_x,k.pixel_y,k.pixel_z);
				local text = "Proto80400105 x：".. k.pixel_x .."，y：".. k.pixel_y .."，z："..
					 k.pixel_z .."，dis："..Vector3.Distance(pos,step).."\n";
				DataCenter.MoveTestData = DataCenter.MoveTestData .. text;
			end

			if WindowMananger.getInstance():isWindowShowing("Lua_MoveTestWindow") ==  true then
				Lua_MsgUtil.callFunc("MOVE_TEST_UPDATE_INFO");
			end
			DataCenter.taskHook:refreshLastRoleActive();
			return;
		end

		if thingVo ~= nil then
			for i,v in ipairs(msg.step_list) do
				thingVo:setCurPosition(v.pixel_x, v.pixel_y, v.pixel_z);
			end
		end
	end
end

function Lua_ThingProxy:onTransfer(mp)
	if mp.errno == 0 then		
		local msg = ProtoPublic_pb.Proto80405101();
		msg:ParseFromString(mp.data);
		local rnum = tonumber(msg.fighter_id);
		DataCenter.thingData:updateTransfer(rnum, msg.model, true, true);
		if rnum == DataCenter.roleData.roleId then
			Lua_MsgUtil.callFunc("TRANSFER_BUFF_CHANGE");
		end
	end
end

function Lua_ThingProxy:onChangeName(mp)
	if mp.errno == 0 then		
		local msg = ProtoPublic_pb.Proto81400105();
		msg:ParseFromString(mp.data);
		local rnum = tonumber(msg.role_id);
		local luaData = DataCenter.thingData:getThing(rnum);
		if luaData ~= nil then
			luaData.name = msg.role_name;
			local rp = DataCenter.thingData:getThingObj(rnum);
			local cp = ThingUtil.instance:getThingById(rnum);
		    if rp ~= nil and cp ~= nil then
		    	cp.data.nickname = msg.role_name;
		        rp:loadBodyComplete();
		        local pid = tonumber(cp.data.pet_id);
		        local petObj = DataCenter.thingData:getThingObj(pid);
		        if petObj ~= nil then
			        petObj:loadBodyComplete();
			    end
		    end
		end
	end
end

function Lua_ThingProxy:onThingDisappear(mp)
	if mp.errno == 0 then		
		local msg = ProtoPublic_pb.Proto80400104();
		msg:ParseFromString(mp.data);
		DataCenter.thingData:removeThing(msg.mover_id);
		DataCenter.thingData:removeDrop(msg.mover_id);
	end
end

function Lua_ThingProxy:onFightBuff(mp)
	if DataCenter.configLoaded ~= 1 then
        return;
    end

    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400203();
        msg:ParseFromString(mp.data);
        local thingVo = DataCenter.thingData:getThing(msg.fighter_id);
        local oldBuffList = {};
		local isSelf = false;
		if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
			isSelf = true;
			local len = DataCenter.roleData.buffList:getSize();
			for i=1,len do
				oldBuffList[DataCenter.roleData.buffList[i].id] = 1;
			end
			DataCenter.roleData.buffList = Array();
		else
			if thingVo ~= nil then
				if thingVo.buffList ~= nil then
					local len = thingVo.buffList:getSize();
					for i=1,len do
						oldBuffList[thingVo.buffList[i].id] = 1;
					end
				end
				thingVo.buffList = Array();
			end
		end

        for i, v in ipairs(msg.status_list) do
            local buffVo = Lua_BuffVo.new(v.status);
            buffVo:fromServer(v);
           	if isSelf == true then
                DataCenter.roleData:updateBuff(buffVo);
                if buffVo.hunluan == 1 then
                    DataCenter.thingData.lastSelectedTime = 0;
                end
            end
            if thingVo ~= nil then
            	thingVo:updateBuff(buffVo);
            end
            oldBuffList[buffVo.id] = 0;
            self:doAddBuffAction(tonumber(msg.fighter_id), buffVo);
        end
        if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
	        for k,v in pairs(oldBuffList) do
	        	if v == 1 then
	        		self:doRemoveBuffAction(tonumber(msg.fighter_id), k);
	        	end
	        end
	    end
	    if thingVo.transferId == 0 and (thingVo.cloak ~= nil and thingVo.cloak ~= 0) then
	    	self.delayCloakTrans:add(tonumber(msg.fighter_id));
			Lua_CommonUtil.delayCall(0.05, self, self.onCloakTransAct);
	    end
	    
	    local thingObj = DataCenter.thingData:getThingObj(msg.fighter_id);
	    if thingObj ~= nil then
	    	thingObj:updateAscription();
	    	thingObj:updateHeadThingPosition();
	    end
        if isSelf == true then
            Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
        end
    end
end

function Lua_ThingProxy:onCloakTransAct()
	local len = self.delayCloakTrans:getSize();
	for i=1,len do
		DataCenter.thingData:updateCloak(self.delayCloakTrans[i]);
	end
	self.delayCloakTrans:clear();
end

function Lua_ThingProxy:onRemoveFightBuff(mp)
	if DataCenter.configLoaded ~= 1 then
        return;
    end

    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400205();
        msg:ParseFromString(mp.data);

        local thingVo = DataCenter.thingData:getThing(msg.fighter_id);
		if thingVo ~= nil then
			thingVo:removeBuff(msg.status);
		end
		self:doRemoveBuffAction(tonumber(msg.fighter_id), msg.status);
        if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
            DataCenter.roleData:removeBuff(msg.status);
            Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
        end
        local thingObj = DataCenter.thingData:getThingObj(msg.fighter_id);
	    if thingObj ~= nil then
	    	thingObj:updateAscription();
	    	thingObj:updateHeadThingPosition();
	    end
    end
end

function Lua_ThingProxy:onAddFightBuff(mp)
	if DataCenter.configLoaded ~= 1 then
        return;
    end

    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400207();
        msg:ParseFromString(mp.data);
        local buffVo = Lua_BuffVo.new(msg.status_detial.status);
        buffVo:fromServer(msg.status_detial);

        local thingVo = DataCenter.thingData:getThing(msg.fighter_id);
		if thingVo ~= nil then
			thingVo:updateBuff(buffVo);
		end
        self:doAddBuffAction(tonumber(msg.fighter_id), buffVo);
        if tonumber(msg.fighter_id) == DataCenter.roleData.roleId then
            DataCenter.roleData:updateBuff(buffVo);
            if buffVo.hunluan == 1 then
                DataCenter.thingData.lastSelectedTime = 0;
            end
            Lua_MsgUtil.callFunc("ROLE_BUFF_UPDATE");
        end
        local b2 = Lua_BuffVo.new(msg.status_detial.status);
        b2:fromServer(msg.status_detial);
        if b2.warn_effect ~= 0 then
            local tb = {};
            tb.px = msg.status_detial.coord.pixel_x;
            tb.py = msg.status_detial.coord.pixel_y;
            tb.pz = msg.status_detial.coord.pixel_z;
            tb.outsideR = b2.warn_outside_radius;
            tb.insideR = b2.warn_inside_radius;
            tb.lt = b2.leftTime;
            tb.speed = b2.warn_speed;
            tb.outAtlas = "warningEffect";
            tb.outSprite = "out_ring";
            tb.insideAtlas = "warningEffect";
            tb.insideSprite = "inside_ring";
            ThingUtil.instance:addWarnEffect(tb);
        end
        if b2.warn_atlas ~= nil and b2.warn_atlas ~= nil then
        	Lua_WindowUtil.openWin("Lua_WarningTipsWindow", nil, {lt=b2.leftTime, atlas=b2.warn_atlas, spname=b2.warn_sprite});
        end
        local thingObj = DataCenter.thingData:getThingObj(msg.fighter_id);
	    if thingObj ~= nil then
	    	thingObj:updateAscription();
	    	thingObj:updateHeadThingPosition();
	    end
    end
end
function Lua_ThingProxy:doAddBuffAction(rid, buffVo)
	local cid = buffVo.buff_type;
	if buffVo.id == Lua_CopyData.JUEXING_COPY_BUFF then
		cid = Lua_CopyData.JUEXING_COPY_BUFF;
	end
	if self.buffEvent[cid] ~= nil and self.buffEvent[cid].inCallBack ~= nil then
		self.buffEvent[cid].inCallBack(self.buffEvent[cid].owner, rid, buffVo);
	end
end
function Lua_ThingProxy:doRemoveBuffAction(rid, buffId)
	local cid = 0;
	if buffId == Lua_CopyData.JUEXING_COPY_BUFF then
		cid = Lua_CopyData.JUEXING_COPY_BUFF;
	else
		local buffVo = Lua_BuffVo.new(buffId);
		cid = buffVo.buff_type;
	end
	
	if self.buffEvent[cid] ~= nil and self.buffEvent[cid].outCallBack ~= nil then
		self.buffEvent[cid].outCallBack(self.buffEvent[cid].owner, rid);
	end
end
function Lua_ThingProxy:onAddTransferModelBuff(rid, buffVo)
	DataCenter.thingData:updateTransfer(rid, buffVo.value1);
	if rid == DataCenter.roleData.roleId then
		Lua_MsgUtil.callFunc("TRANSFER_BUFF_CHANGE");
	end
end
function Lua_ThingProxy:onRemoveTransferModelBuff(rid)
	DataCenter.thingData:updateTransfer(rid, 0, true);
	local ap = ThingUtil.instance:getThingById(rid);
	EffectManager.getInstance():playActionEffect(ap, "transfer_end", 0, -1, 0, ap);
	if rid == DataCenter.roleData.roleId then
		Lua_MsgUtil.callFunc("TRANSFER_BUFF_CHANGE");
		if ap.ac:isDoingAction(0) == false and ap.ac:isDoingAction(1) == false  then
			ap:forceUpdate(0, true, 1, 0, false, -1,0);
			ap.ac:setActionState(11, false, false, false, false, false, false, false, 1);
		end
	end
end
function Lua_ThingProxy:onAddTransferSkillBuff(rid, buffVo)
	if rid == DataCenter.roleData.roleId then
    	Lua_MsgUtil.callFunc("UPDATE_TRANS_SKILL_BUFF");
    end
end
function Lua_ThingProxy:onAddJueXingCopyBuff(rid, buffVo)
	if rid == DataCenter.roleData.roleId then
    	Lua_MsgUtil.callFunc("UPDATE_JUEXINGCOPY_SKILL_BUFF");
    end
    local thingVo = DataCenter.thingData:getThingObj(rid);
    local luaData = DataCenter.thingData:getThing(rid);

    if thingVo ~= nil then
    	local skillVo = Lua_SkillVo.new(buffVo.value1);
    	if skillVo.preEffect ~= nil and thingVo.showNamePreEffect ~= nil then
    		luaData.preName = skillVo.preEffect;
    		thingVo:showNamePreEffect(skillVo.preEffect);
    	end
    end
end
function Lua_ThingProxy:onRemoveJueXingCopyBuff(rid)
	if rid == DataCenter.roleData.roleId then
    	Lua_MsgUtil.callFunc("UPDATE_JUEXINGCOPY_SKILL_BUFF");
    end
    local thingVo = DataCenter.thingData:getThingObj(rid);
    local luaData = DataCenter.thingData:getThing(rid);
    if thingVo ~= nil and thingVo.removeNamePreEffect ~= nil then
    	luaData.preName = nil;
    	thingVo:removeNamePreEffect();
    end
end