Lua_TitleAllData = class("Lua_TitleAllData");
checkRequire("Lua_TitleData");
function Lua_TitleAllData:ctor()
	self.removeid = 1000056;
end

-- print("获取称号面板")
function Lua_TitleAllData:sInitMsg()
	sendMsg(11400701);
end

-- print("选择使用称号")
function Lua_TitleAllData:sSelectMsg(label_id)
	local cmd = ProtoPublic_pb.Proto11400702();
	cmd.label_id = label_id;
	sendMsg(11400702,cmd);
end

-- print("放弃使用称号")
function Lua_TitleAllData:sAbandonMsg(label_id)
	local cmd = ProtoPublic_pb.Proto11400703();
	cmd.label_id = label_id;
	sendMsg(11400703,cmd);
end

-- print("获取单个称号信息")
function Lua_TitleAllData:sGainMsg(label_id)
	local cmd = ProtoPublic_pb.Proto11400704();
	cmd.label_id = label_id;
	sendMsg(11400704,cmd);
end

-- "查看新的称号"
function Lua_TitleAllData:sNewMsg(label_id)
	local cmd = ProtoPublic_pb.Proto11400705();
	cmd.label_id = label_id;
	sendMsg(11400705,cmd);
end

-- 获取所有称号，是否包括不显示称号
function Lua_TitleAllData:gettitleDic(isAll)
	if isAll == true then
		return self.titleDic;
	else
		self.arr = Array();
		local len = self.titleDic:getSize();
		for i=1,len do
			if self.titleDic[i].isShow == true then
				self.arr:add(self.titleDic[i]);
			end
		end
		return self.arr;
	end
end

-- 51400701
function Lua_TitleAllData:fromServer(msg)
	self.cur_label_id = msg.cur_label_id;
	self.prop_list = msg.prop_list;
	self.titleDic = {};

	local config = checkRequire("label");
	for i,v in pairs(config) do
		if i ~= DataCenter.titleData.removeid and self.cur_label_id ~= DataCenter.titleData.removeid then
			self.titleDic[i] = Lua_TitleData.new(i);
		end
	end
	
	for i,v in ipairs(msg.permant_label_list) do     --永久
		local tid = msg.permant_label_list[i];
		self.titleDic[tid].isActive = true;
		self.titleDic[tid].timeLimit = -1;
		self.titleDic[tid].isShow = table.indexOf(msg.unshown_list, tid) ~= -1;
	end

	for i,v in ipairs(msg.limit_time_label_list) do     --限时称号
	
		local tid = msg.limit_time_label_list[i].label_id;
		self.titleDic[tid].isActive = true;
		self.titleDic[tid].timeLimit = msg.limit_time_label_list[i].left_time;
		self.titleDic[tid].isShow = table.indexOf(msg.unshown_list, tid) ~= -1;
	end

	for i,v in ipairs(msg.func_label_list) do       --随系统
		local tid = msg.func_label_list[i];
		self.titleDic[tid].isActive = true;
		self.titleDic[tid].timeLimit = -2;
		self.titleDic[tid].isShow = table.indexOf(msg.unshown_list, tid) ~= -1;
	end

	self.alltitleList = Array();
	for k,v in pairs(self.titleDic) do
		local data = Lua_TitleData.new(k)
		local titleVo = {};
		titleVo.isActive = self.titleDic[k].isActive;
		titleVo.rank = data.rank;
		if titleVo.isActive == true then
			titleVo.sortIdx = 100000 - data.rank;
		else
			titleVo.sortIdx = 5000 - data.rank;
		end
		titleVo.id = k;
		titleVo.timeLimit = data.time;
		titleVo.name = data.name;
		titleVo.limittype = data.limit_type;
		titleVo.referenceId = data.referenceId;
		self.alltitleList:add(titleVo);
	end
	self.alltitleList:sort("sortIdx",true);
end

-- 51400702 
function Lua_TitleAllData:useTitle(msg)
	self.cur_label_id = msg.label_id;
	--self.titleDic:sort("priority", true);
end

--51400703
function Lua_TitleAllData:abandonTitle(msg)
	self.cur_label_id = 0;
end

--51400704
function Lua_TitleAllData:updateOneTitle(msg)
	local len = self.alltitleList:getSize();
	for i=1,len do
		if self.alltitleList[i].id == msg.label_id then
			self.alltitleList[i].timeLimit = msg.left_time;
			--self.alltitleList[i].isActive = nil
			return;
		end
	end
end

-- 81400701
-- function Lua_TitleAllData:updateTitle(msg)
-- 	print("msg")
-- end

function Lua_TitleAllData:dispose()
	if self.cur_label_id ~= nil then
		self.cur_label_id = nil;
	end

	if self.alltitleList ~= nil then
		self.alltitleList:clear()
		self.alltitleList:dispose()
	end
end