Lua_TitleData = class("Lua_TitleData");
function Lua_TitleData:ctor(id)
	self.id = tonumber(id);
	self.config = getConfig({"label", self.id});
end

-- 名字
function Lua_TitleData.Get:name()
	return self.config.name;
end

-- 获取途径
function Lua_TitleData.Get:outputs()
	return self.config.outputs;
end

-- 防御
function Lua_TitleData.Get:defence()
	return self.config.defence;
end

-- 攻击
function Lua_TitleData.Get:attack()
	return self.config.attack;
end

-- 生命
function Lua_TitleData.Get:blood()
	return self.config.blood;
end

-- 暴击
function Lua_TitleData.Get:crit()
	return self.config.crit;
end

-- 任性
function Lua_TitleData.Get:toughness()
	return self.config.toughness;
end

function Lua_TitleData.Get:sortIdx()
	if self.isActive == true then
		return 1000000 + self.rank;
	else
		return self.rank;
	end
end

function Lua_TitleData.Get:desc()
	local desArr = Array();
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"label", self.id, v});
		if val ~= nil and val ~= 0 then
			if Lua_ThingDefine.isPercentParam(v) == false then -- 是否为百分比字段判断
				local s = "[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]" .. val;
				desArr:add({wordsStr = Lua_ThingDefine.getParamName(v), numStr = val});
			else
				local s = "[85A8BE]" .. Lua_ThingDefine.getParamName(v) .. "：[-]" .. val .. "%";
				desArr:add({wordsStr = Lua_ThingDefine.getParamName(v), numStr = val.."%"});
			end
		end
	end
	return desArr;
end

function Lua_TitleData.Get:descNoColor()
	local str = nil;
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"label", self.id, v});
		if val ~= nil and val ~= 0 then
			if str == nil then
				str = "";
			else
				str = str.."\n";
			end
			local s = Lua_ThingDefine.getParamName(v).."+"..val;
			str = str..s;
		end
	end
	return str;
end

function Lua_TitleData.Get:titleForce()
	local str = {};
	for k,v in ipairs(Lua_ThingDefine.params) do
		local val = getConfig({"label", self.id, v});
		if val ~= nil and val ~= 0 then
			str[v] = val;
		end
	end
	return Lua_FightUtil.caculateConfigForce(str);
end

function Lua_TitleData.Get:compareTitle()
	if self.config.limit_type == nil then
		return LanUtil.getValue(110451);
	end

	if #DataCenter.titleData.func_label_list == 0 then
		return LanUtil.getValue(110451);
	end

	local config;
	for i = 1, #DataCenter.titleData.func_label_list do
		config = getConfig({"label", DataCenter.titleData.func_label_list[i]})
		if self.config.compareTitle == config.compareTitle then
			if self.config.rank < config.rank then 
				return LanUtil.getValue(110465);
			else
				return LanUtil.getValue(110451);
			end
		else
			return LanUtil.getValue(110451);
		end
	end
end

function Lua_TitleData.Get:use()
	if self.config.use == nil then
		return 2;
	end
	return self.config.use;
end

-- 称号图片ID
function Lua_TitleData.Get:referenceId()
	return self.config.referenceId;
end

-- 是否永久  0 为永久 1为限时
function Lua_TitleData.Get:limit_type()
	return self.config.limit_type;
end

function Lua_TitleData.Get:limit_str()
	if self.config.limit_str == nil then
		return "";
	end
	return self.config.limit_str;
end

-- 时间
function Lua_TitleData.Get:time()
	return self.config.time;
end

-- 时效攻击
function Lua_TitleData.Get:attack1()
	return self.config.attack1;
end

-- 时效攻击
function Lua_TitleData.Get:effect()
	return self.config.effect;
end

function Lua_TitleData.Get:list_effect_size()
	return self.config.list_effect_size;
end

-- 排行
function Lua_TitleData.Get:rank()
	return self.config.rank;
end

function Lua_TitleData.Get:priority()
	if DataCenter.titleData.cur_label_id == self.id then
		return 50;
	end
	return 20;
end

function Lua_TitleData.Get:iswear()
	return self.id == DataCenter.titleData.cur_label_id;
end

function Lua_TitleData.Get:specialTitle() 
	if self.config.specialTitle == nil then
		return 0;
	end
	return self.config.specialTitle;
end

function Lua_TitleData.Get:atlas()
	if self.config.atlas == nil then
		return "item7";
	end
	return self.config.atlas;
end