checkRequire("Lua_TitleAllData");
checkRequire("Lua_TitleData");
Lua_TitleProxy = class("Lua_TitleProxy");
function Lua_TitleProxy:ctor()
    DataCenter.titleData = Lua_TitleAllData.new();
    
    LuaUtil.addLuaMsg(51400701, self, self.rUpdateTitleInfo);
    LuaUtil.addLuaMsg(51400702, self, self.rSelectTitleInfo);
    LuaUtil.addLuaMsg(51400703, self, self.rAbandonTitleInfo);
    LuaUtil.addLuaMsg(51400704, self, self.rGainTitleInfo);
    LuaUtil.addLuaMsg(51400705, self, self.rNewTitleInfo);
    LuaUtil.addLuaMsg(81400701, self, self.rConversionTitleInfo);
	LuaUtil.addLuaMsg(81400702, self, self.rUnLookTitleInfo);
end

function Lua_TitleProxy:rUpdateTitleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400701();
        msg:ParseFromString(mp.data);
        DataCenter.titleData.cur_label_id = msg.cur_label_id;
        DataCenter.titleData.func_label_list = msg.func_label_list;
        DataCenter.titleData:fromServer(msg);
        Lua_MsgUtil.callFunc("SHOW_TITLEINFO");
    end
end

function Lua_TitleProxy:rSelectTitleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400702();
        msg:ParseFromString(mp.data);
        DataCenter.titleData:useTitle(msg);
        Lua_MsgUtil.callFunc("SELECT_TITLEINFO");
    end
end

function Lua_TitleProxy:rAbandonTitleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400703();
        msg:ParseFromString(mp.data);
        DataCenter.titleData:abandonTitle(msg);
        Lua_MsgUtil.callFunc("ABANDON_TITLEINFO");
    end
end

function Lua_TitleProxy:rGainTitleInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51400704();
        msg:ParseFromString(mp.data);
        DataCenter.titleData:updateOneTitle(msg);
        Lua_MsgUtil.callFunc("UPDATEONE_TITLEINFO");
    end
end

function Lua_TitleProxy:rNewTitleInfo(mp)
    if mp.errno == 0 then
    end
end

function Lua_TitleProxy:rConversionTitleInfo(mp)
    if mp.errno == 0 then   
        if DataCenter.configLoaded ~= 1 then
            return;
        end
        local msg = ProtoPublic_pb.Proto81400701();
        msg:ParseFromString(mp.data);
        if msg.label_id == 1000056 and msg.operate == 1 then
            DataCenter.titleData.removeid = 0 
        elseif msg.label_id == 1000056 and msg.operate == 2 then 
            DataCenter.titleData.removeid = 1000056; 
        end
        local data = Lua_TitleData.new(msg.label_id)
        if msg.operate == 1 then
            if data.use == 2 then
                if msg.operate == 1 then
                    if DataCenter.configLoaded ~= 1 then
                        return;
                    end
                    --DataCenter.titleData:updateTitle(msg);
                    Lua_WindowUtil.openWin("Lua_GetTitleWindow", WinParam.ACTION_OPEN, msg)
                end
            else
                if DataCenter.titleData.cur_label_id ~= nil then
                   DataCenter.titleData:sAbandonMsg(DataCenter.titleData.cur_label_id)
                end
                DataCenter.titleData:sSelectMsg(msg.label_id)
            end
        end
    end
end

function Lua_TitleProxy:rUnLookTitleInfo(mp)
  
end