﻿checkRequire("Lua_TransData");

Lua_TransProxy = class("Lua_TransProxy");

function Lua_TransProxy:ctor()
    DataCenter.transData = Lua_TransData.new();
    LuaUtil.addLuaMsg(51402401, self, self.rTransMsg);
    LuaUtil.addLuaMsg(51402402, self, self.rTransReplyMsg);
    LuaUtil.addLuaMsg(51402403, self, self.rPutIntoTransMsg);
    LuaUtil.addLuaMsg(51402404, self, self.rTakeOutTransMsg);
    LuaUtil.addLuaMsg(51402405, self, self.rLockTransMsg);
    LuaUtil.addLuaMsg(51402406, self, self.rBeginTransMsg);
    LuaUtil.addLuaMsg(51402407, self, self.rCloseTransMsg);

    LuaUtil.addLuaMsg(80400241, self, self.noticeOthers);
    LuaUtil.addLuaMsg(80400242, self, self.noticeSelf);
    LuaUtil.addLuaMsg(80400243, self, self.noticeSelf2);
    LuaUtil.addLuaMsg(80400244, self, self.noticeIconsChange);
    LuaUtil.addLuaMsg(80400245, self, self.noticeCloseTrans);
   -- LuaUtil.addLuaMsg(80400246, self, self.noticeOthersTrans);
    LuaUtil.addLuaMsg(80400247, self, self.noticeOthersTrans2);
    LuaUtil.addLuaMsg(80400249, self, self.noticeSubChange);
    LuaUtil.addLuaMsg(80400250, self, self.noticeTransSucceed);
    LuaUtil.addLuaMsg(80400251, self, self.noticeLocked);
end

function Lua_TransProxy:rTransMsg(mp)
    if mp.errno == 0 then
        -- Lua_WindowUtil.openWin("Lua_TransactionWindow", WinParam.ACTION_OPEN, self._data.userName)
    end
end
function Lua_TransProxy:rTransReplyMsg(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51402402();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer51402402(msg);
    end
end
function Lua_TransProxy:rPutIntoTransMsg(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51402403();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer51402403(msg);
    end
end
function Lua_TransProxy:rTakeOutTransMsg(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51402404();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer51402404(msg);
    end
end
function Lua_TransProxy:rLockTransMsg(mp)
    if mp.errno == 0 then
        --        Lua_MsgUtil.callFunc("TRANS_LOCK_STATE", true);
        --    else
        --        Lua_MsgUtil.callFunc("TRANS_LOCK_STATE", false);
    end
end
function Lua_TransProxy:rBeginTransMsg(mp)
    if mp.errno == 0 then
        --  Lua_WindowUtil.openWin("Lua_TransactionWindow", WinParam.ACTION_CLOSE);
        --  OperateAlert.show("交易成功");
        Lua_MsgUtil.callFunc("TRANS_REQUEST", false);
    end
end
function Lua_TransProxy:rCloseTransMsg(mp)
    Lua_MsgUtil.callFunc("TRANS_REQUEST", false);
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_TransactionWindow", WinParam.ACTION_CLOSE);
    end
end

function Lua_TransProxy:noticeOthers(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400241();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer80400241(msg);
    end
end  

function Lua_TransProxy:noticeSelf(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400242();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer80400242(msg);
    end
end  

function Lua_TransProxy:noticeSelf2(mp)
    if mp.errno == 0 then
        -- 通知交易被忽略
        Lua_MsgUtil.callFunc("TRANS_REQUEST", false);
    end
end

function Lua_TransProxy:noticeIconsChange(mp)
    if mp.errno == 0 then
        Lua_MsgUtil.callFunc("TRANS_REQUEST", false);
    end
end

function Lua_TransProxy:noticeCloseTrans(mp)
    if mp.errno == 0 then
        Lua_MsgUtil.callFunc("TRANS_REQUEST", false);
        Lua_WindowUtil.openWin("Lua_TransactionWindow", WinParam.ACTION_CLOSE);
    end
end  

-- function Lua_TransProxy:noticeOthersTrans(mp)
--    if mp.errno == 0 then
--        local msg = ProtoPublic_pb.Proto80400246();
--        msg:ParseFromString(mp.data);
--        DataCenter.transData:fromServer80400246(msg);
--    end
-- end

function Lua_TransProxy:noticeOthersTrans2(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto80400247();
        msg:ParseFromString(mp.data);
        DataCenter.transData:fromServer80400247(msg);
    end
end
function Lua_TransProxy:noticeSubChange(mp)
    if mp.errno == 0 then
        Lua_MsgUtil.callFunc("TRANS_SUB_STATE", true);
    end
end
function Lua_TransProxy:noticeTransSucceed(mp)
    if mp.errno == 0 then
        Lua_WindowUtil.openWin("Lua_TransactionWindow", WinParam.ACTION_CLOSE);
    end
end  

function Lua_TransProxy:noticeLocked(mp)
    if mp.errno == 0 then
        --    Lua_MsgUtil.callFunc("TRANS_SUO_STATE", true);
    end
end 




function Lua_TransProxy:sTransMsg(role_id)
    local cmd = ProtoPublic_pb.Proto11402401();
    cmd.role_id = role_id;
    sendMsg(11402401, cmd);
end
function Lua_TransProxy:sTransReplyMsg(respone_type, role_id)
    local cmd = ProtoPublic_pb.Proto11402402();
    cmd.respone_type = respone_type;
    cmd.role_id = role_id;
    sendMsg(11402402, cmd);
end
function Lua_TransProxy:sPutIntoTransMsg(item_id, pack_index, item_amount)
    local cmd = ProtoPublic_pb.Proto11402403();
    cmd.item_id = item_id;
    cmd.pack_index = pack_index;
    cmd.item_amount = item_amount;
    sendMsg(11402403, cmd);
end
function Lua_TransProxy:sTakeOutTransMsg(item_id, pack_index, item_amount)
    local cmd = ProtoPublic_pb.Proto11402404();
    cmd.item_id = item_id;
    cmd.pack_index = pack_index;
    cmd.item_amount = item_amount;
    sendMsg(11402404, cmd);
end
function Lua_TransProxy:sLockTransMsg()
    sendMsg(11402405);
end
function Lua_TransProxy:sBeginTransMsg()
    sendMsg(11402406);
end
function Lua_TransProxy:sCloseTransMsg()
    sendMsg(11402407);
end