-- 藏宝阁数据
Lua_TreasureData = class("Lua_TreasureData");
function Lua_TreasureData:ctor()
    self:superCall("ctor");
    self.jifenNum = 0;	-- 装备抽奖积分
    self.runeChipsNum = 0;	-- 符文碎片
    self.runeFreeTickTime = 0; -- 免费倒计时剩余
    self.freeTickGetTime = 0;
    self.runeDrawTimes = 0; -- 灵纹抽奖累计次数

    self.bEnableEquipmentDraw = true;
    self.bEnableRunesDraw = true;

    self.bEnablePeakDraw = true;
    self.equipmentDrawType = 0;
    self.peakDrawType = 2;
    self.supremacyDrawType = 3;
    self.apotheosizeDrawType = 4;
end

function Lua_TreasureData:dispose()
	self.jifenNum = 0;	-- 积分
    self.runeChipsNum = 0;	-- 符文碎片
    self.runeFreeTickTime = 0; -- 免费倒计时剩余
    self.freeTickGetTime = 0;
    self.runeDrawTimes = 0; -- 灵纹抽奖累计次数

    self.bEnableEquipmentDraw = true;
    self.bEnableRunesDraw = true;

    self.bEnablePeakDraw = true;
    self.equipmentDrawType = 0;
    self.peakDrawType = 2;
    self.supremacyDrawType = 3;
    self.apotheosizeDrawType = 4;
end

function Lua_TreasureData.Get:runeFreeReduiseTime()
	local num = self.runeFreeTickTime - (getTime() - self.freeTickGetTime);
	if num < 0 then
		return 0;
	end
	return num;
end

-- 必得剩余次数
function Lua_TreasureData.Get:runeBestTimes()
	return DataCenter.treasureUtil.runeDrawBestEndNum - self.runeDrawTimes;
end

function Lua_TreasureData:getRuneOpenTypeShow()
	local result = Array();
	local arr = DataCenter.runeData.unLockType;
	if arr ~= nil then
		local len = #arr;
		for i = 1, len do
			local list = getConfig({"treasure_runeshow", arr[i], "showArr"});
			if list ~= nil then
				for i = 1, #list do
                    result:add(Lua_ToolVo.new(list[i]));
	            end
			end
		end
	end

	return result;
end

function Lua_TreasureData:treasureRuneInfo(msg)
    self.item_list = msg.item_list;
end

function Lua_TreasureData.Get:getRuneCrystalNum()--获得 灵晶数量
    local list = self.item_list;
    local num = 0;
    local len = #list;
    for i = 1, len do
        if tonumber(list[i].id) == 201060101 then
            num = num + list[i].amount;
        end
    end

    return num;
end
function Lua_TreasureData.Get:treasureSortId(msg)
    local list = getConfig({"hi_treasure_info", "open_sort_id","arr"});
    local sortId = 1;
    for i = 1, #list do
       if DataCenter.funcOpenData:isOpened(list[i]) == true and list[i] ~= 10079 then
            sortId =  i;
        end
    end
    return sortId;
end