-- 藏宝阁proxy
checkRequire("Lua_TreasureData")
checkRequire("Lua_TreasureUtil")
Lua_TreasureProxy = class("Lua_TreasureProxy");
function Lua_TreasureProxy:ctor()
    DataCenter.treasureData = Lua_TreasureData.new();
    DataCenter.treasureUtil = Lua_TreasureUtil.new();

    LuaUtil.addLuaMsg(51401501, self, self.rTreasurePanelInfo);	-- 获取藏宝阁信息(返回)
    LuaUtil.addLuaMsg(51401502, self, self.rTreasureStorePickUp);	-- 取出/一键取出(返回)
    LuaUtil.addLuaMsg(51401503, self, self.rTreasureEquipmentDraw);	-- 宝物抽奖(返回)
    LuaUtil.addLuaMsg(51401504, self, self.rTreasureRunesDraw);	-- 灵纹抽奖(返回)
    LuaUtil.addLuaMsg(51401505, self, self.rTreasureStoreSort);	-- 整理(返回)
    LuaUtil.addLuaMsg(51401506, self, self.rTreasureMallExchange);	-- 积分商城兑换(返回)
    LuaUtil.addLuaMsg(51401507, self, self.rTreasureDrawRecords);	-- 藏宝阁抽奖记录(返回)
    LuaUtil.addLuaMsg(81401501, self, self.rTreasureDrawRecordsUpdate);	-- 藏宝阁获奖记录更新（主动）

    LuaUtil.addLuaMsg(51401509, self, self.rTreasurePeakDraw); -- 巅峰抽奖(返回)
    LuaUtil.addLuaMsg(51401510, self, self.rSupremacyDraw);    -- 至尊寻宝抽奖（返回)
    LuaUtil.addLuaMsg(51401511, self, self.rApotheosizeDraw);  -- 封神寻宝抽奖（返回)
end


-----------------------------------------------------
-- 上行协议

-- 获取藏宝阁信息
function Lua_TreasureProxy:sTreasurePanelInfo()
    sendMsg(11401501);
end

-- 关闭界面
function Lua_TreasureProxy:sCloseTreasureWin()
    sendMsg(11401508);
end

-- 取出/一键取出
function Lua_TreasureProxy:sTreasureStorePickUp(pickUpType, idx)
    local cmd = ProtoPublic_pb.Proto11401502();
    cmd.take_type = pickUpType;	-- 0取出，1一键取出
    cmd.pack_index = idx;	-- 物品索引（一键取出时无效）
    sendMsg(11401502, cmd);
end

-- 宝物抽奖
function Lua_TreasureProxy:sTreasureEquipmentDraw(drawType)
    local cmd = ProtoPublic_pb.Proto11401503();
    cmd.draw_type = drawType;	-- 抽奖类型 0一次 1十次
    sendMsg(11401503, cmd);
    DataCenter.treasureData.bEnableEquipmentDraw = false;
end

-- 灵纹抽奖
function Lua_TreasureProxy:sTreasureRunesDraw(drawType)
    local cmd = ProtoPublic_pb.Proto11401504();
    cmd.draw_type = drawType;	-- 抽奖类型 0一次 1十次 2免费
    sendMsg(11401504, cmd);
    DataCenter.treasureData.bEnableRunesDraw = false;
end

-- 整理
function Lua_TreasureProxy:sTreasureStoreSort()
    sendMsg(11401505);
end

-- 积分商城兑换
function Lua_TreasureProxy:sTreasureMallExchange(idx, drawType)
    local cmd = ProtoPublic_pb.Proto11401506();
    cmd.item_index = tonumber(idx); -- 兑换的道具索引
    cmd.type = tonumber(drawType); -- 0装备抽奖 2巅峰寻宝
    sendMsg(11401506, cmd);
end

-- 藏宝阁抽奖记录
function Lua_TreasureProxy:sTreasureDrawRecords(drawType)
    local cmd = ProtoPublic_pb.Proto11401507();
    cmd.type = tonumber(drawType);
    sendMsg(11401507, cmd);
end

-- 巅峰抽奖
function Lua_TreasureProxy:sTreasurePeakDraw(drawType)
    local cmd = ProtoPublic_pb.Proto11401509();
    cmd.draw_type = drawType;   -- 抽奖类型 0一次 1十次
    sendMsg(11401509, cmd);
    DataCenter.treasureData.bEnablePeakDraw = false;
end

-- 至尊抽奖
function Lua_TreasureProxy:sSupremacyDraw(drawType)
    local cmd = ProtoPublic_pb.Proto11401510();
    cmd.draw_type = drawType;   -- 抽奖类型 0一次 1十次
    sendMsg(11401510, cmd);
    DataCenter.treasureData.bEnableSupremacyDraw = false;
end

-- 封神抽奖
function Lua_TreasureProxy:sApotheosizeDraw(drawType)
    local cmd = ProtoPublic_pb.Proto11401511();
    -- print("抽奖类型  = =",drawType)
    cmd.draw_type = drawType;   -- 抽奖类型 0一次 1十次
    sendMsg(11401511, cmd);
    DataCenter.treasureData.bEnableApotheosizeDraw = false;
end

-----------------------------------------------------
-- 下行协议

-- 获取藏宝阁信息(返回)
function Lua_TreasureProxy:rTreasurePanelInfo(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401501();
        msg:ParseFromString(mp.data);
        DataCenter.treasureData.jifenNum = msg.integral_num;	-- 积分
        DataCenter.treasureData.runeChipsNum = msg.frag_count;	-- 符文碎片
        DataCenter.treasureData.runeDrawTimes = tonumber(msg.rune_times); -- 灵纹抽奖累计次数
        DataCenter.treasureData.runeFreeTickTime = tonumber(msg.refresh_tick);	-- 距离下一次免费的刷新时间
        DataCenter.treasureData.freeTickGetTime = getTime();
        -- msg.record_list;	-- 获奖记录列表
        Lua_MsgUtil.callFunc("rTreasurePanelInfo", msg.record_list);
    end
end

-- 取出/一键取出(返回)
function Lua_TreasureProxy:rTreasureStorePickUp(mp)
    if mp.errno == 0 then
        -- local msg = ProtoPublic_pb.Proto51401502();
        -- msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("rTreasureStorePickUp");
        OperateAlert.show(LanUtil.getValue(121422));
    end
end

-- 宝物抽奖(返回)
function Lua_TreasureProxy:rTreasureEquipmentDraw(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401503();
        msg:ParseFromString(mp.data);
        DataCenter.treasureData.jifenNum = msg.integral_num;	-- 当前的积分
        -- msg.draw_type; -- 抽奖类型 0一次 1十次
        -- msg.item_list;	-- 获得的道具列表
        if Lua_WindowUtil.isWindowShowing("Lua_EquipmentTreasureResultWindow") == false then
            Lua_WindowUtil.openWin("Lua_EquipmentTreasureResultWindow");
        end
        Lua_MsgUtil.callFunc("rTreasureEquipmentDraw", msg);
        DataCenter.treasureData.bEnableEquipmentDraw = true;
        self:sTreasureStoreSort();
    end
end

-- 灵纹抽奖(返回)
function Lua_TreasureProxy:rTreasureRunesDraw(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401504();
        msg:ParseFromString(mp.data);
        -- msg.draw_type; -- 抽奖类型 0一次 1十次
        -- msg.item_list;	-- 获得的道具列表
        DataCenter.treasureData.runeDrawTimes = msg.rune_times; -- 抽奖次数累计
        DataCenter.treasureData.runeFreeTickTime = tonumber(msg.refresh_tick);  -- 距离下一次免费的刷新时间
        DataCenter.treasureData.freeTickGetTime = getTime();
        if Lua_WindowUtil.isWindowShowing("Lua_RunesTreasureResultWindow") == false then
            Lua_WindowUtil.openWin("Lua_RunesTreasureResultWindow");
        end
        DataCenter.treasureData:treasureRuneInfo(msg);
        Lua_MsgUtil.callFunc("rTreasureRunesDraw", msg);

        DataCenter.treasureData.runeChipsNum = msg.frag_count;	-- 灵纹碎片
	    DataCenter.treasureData.bEnableRunesDraw = true;
        self:sTreasureStoreSort();
    end
end

-- 整理(返回)
function Lua_TreasureProxy:rTreasureStoreSort(mp)
    if mp.errno == 0 then
        -- local msg = ProtoPublic_pb.Proto51401505();
        -- msg:ParseFromString(mp.data);
        Lua_MsgUtil.callFunc("rTreasureStoreSort");
        --OperateAlert.show(LanUtil.getValue(121423));
    end
end

-- 积分商城兑换(返回)
function Lua_TreasureProxy:rTreasureMallExchange(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401506();
        msg:ParseFromString(mp.data);
        DataCenter.treasureData.jifenNum = msg.integral_num;	-- 当前积分
        Lua_MsgUtil.callFunc("rTreasureJifenUpdate");
        OperateAlert.show(LanUtil.getValue(121424));
    end
end

-- 藏宝阁抽奖记录(返回)
function Lua_TreasureProxy:rTreasureDrawRecords(mp)
    if mp.errno == 0 then
        -- print("藏宝阁抽奖记录(返回)")
        local msg = ProtoPublic_pb.Proto51401507();
        msg:ParseFromString(mp.data);
        -- msg.record_list; -- 抽奖记录列表
        if msg.type == DataCenter.treasureData.equipmentDrawType then -- 0装备抽奖 2巅峰寻宝 3至尊抽奖 4封神抽奖
            Lua_MsgUtil.callFunc("rTreasureDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.peakDrawType then
            Lua_MsgUtil.callFunc("rPeakTreasureDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.supremacyDrawType then
            Lua_MsgUtil.callFunc("rSupremacyDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.apotheosizeDrawType then
            Lua_MsgUtil.callFunc("rApotheosizeDrawRecords", msg.record_list);
        end
    end
end

-- 藏宝阁获奖记录更新（主动）
function Lua_TreasureProxy:rTreasureDrawRecordsUpdate(mp)
    if mp.errno == 0 then
        -- print("藏宝阁获奖记录更新（主动")
        local msg = ProtoPublic_pb.Proto81401501();
        msg:ParseFromString(mp.data);
        -- msg.record_list; -- 抽奖记录列表
        if msg.type == DataCenter.treasureData.equipmentDrawType then -- 0装备抽奖 2巅峰寻宝 3至尊抽奖 4封神抽奖
            Lua_MsgUtil.callFunc("rTreasureDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.peakDrawType then
            Lua_MsgUtil.callFunc("rPeakTreasureDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.supremacyDrawType then
            Lua_MsgUtil.callFunc("rSupremacyDrawRecords", msg.record_list);
        elseif msg.type == DataCenter.treasureData.apotheosizeDrawType then
            Lua_MsgUtil.callFunc("rApotheosizeDrawRecords", msg.record_list);
        end
    end
end

-- 巅峰抽奖(返回)
function Lua_TreasureProxy:rTreasurePeakDraw(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401509();
        msg:ParseFromString(mp.data);
        DataCenter.treasureData.jifenNum = msg.peak_integral;    -- 当前的积分
        -- msg.draw_type; -- 抽奖类型 0一次 1十次
        -- msg.item_list;   -- 获得的道具列表
        if Lua_WindowUtil.isWindowShowing("Lua_PeakTreasureResultWindow") == false then
            Lua_WindowUtil.openWin("Lua_PeakTreasureResultWindow");
        end
        Lua_MsgUtil.callFunc("rTreasurePeakDraw", msg);
        DataCenter.treasureData.bEnablePeakDraw = true;
        self:sTreasureStoreSort();
    end
end

-- 至尊抽奖(返回)
function Lua_TreasureProxy:rSupremacyDraw(mp)
    if mp.errno == 0 then
        local msg = ProtoPublic_pb.Proto51401510();
        msg:ParseFromString(mp.data);
        DataCenter.treasureData.jifenNum = msg.cur_integral;    -- 当前的积分
        -- msg.draw_type; -- 抽奖类型 0一次 1十次
        -- msg.item_list;   -- 获得的道具列表
        if Lua_WindowUtil.isWindowShowing("Lua_SupremacyResultWindow") == false then
            Lua_WindowUtil.openWin("Lua_SupremacyResultWindow");
        end
        Lua_MsgUtil.callFunc("rSupremacyDraw", msg);
        DataCenter.treasureData.bEnableSupremacyDraw = true;
        self:sTreasureStoreSort();
    end
end

-- 至尊抽奖(返回)
function Lua_TreasureProxy:rApotheosizeDraw(mp)
    if mp.errno == 0 then
        
        local msg = ProtoPublic_pb.Proto51401511();
        msg:ParseFromString(mp.data);
        -- print("当前的积分   = =",msg.cur_integral)
        DataCenter.treasureData.jifenNum = msg.cur_integral;    -- 当前的积分
        -- msg.draw_type; -- 抽奖类型 0一次 1十次
        -- msg.item_list;   -- 获得的道具列表
        if Lua_WindowUtil.isWindowShowing("Lua_ApotheosizeResultWindow") == false then
            Lua_WindowUtil.openWin("Lua_ApotheosizeResultWindow");
        end
        Lua_MsgUtil.callFunc("rApotheosizeDraw", msg);
        DataCenter.treasureData.bEnableApotheosizeDraw = true;
        self:sTreasureStoreSort();
    end
end