-- 藏宝阁配置数据
Lua_TreasureUtil = class("Lua_TreasureUtil");
function Lua_TreasureUtil:ctor()
    self:superCall("ctor");
    
end

-- 宝物抽奖展示
function Lua_TreasureUtil:getEquipmentTreasureShow(num)
    local showList = Array();
    local info = getConfig({"equip_treasure_reward"});
    local rewardId=0;
    for i = 1, #info do
        if info[i].type == num then
            if DataCenter.roleData.worldLevel >= info[i].world_lvl[1] 
                and DataCenter.roleData.worldLevel <= info[i].world_lvl[2] 
                and DataCenter.roleData.level >= info[i].role_level[1] 
                and DataCenter.roleData.level <= info[i].role_level[2] then
                rewardId=info[i].showreward_id[1]
            end
        end
    end
    local list = getConfig({"rewards",rewardId,"client_goods_list"})
    if list ~= nil then
        for i = 1, #list do
            local obj = list[i];
            if obj ~= nil then
                local vo = Lua_ToolVo.createToolVo(obj[2]);
                vo.index = obj[1];
                vo.count = obj[3];
                vo.star = obj[4];
                vo.packType = 999;
                showList:add(vo);
            end
        end
    end

    local len = showList:getSize();
    for i = 1, len do
        for j = i + 1, len do
            local a = showList[i];
            local b = showList[j];
            if a.index > b.index then
                local temp = showList[i];
                showList[i] = showList[j];
                showList[j] = temp;
            end
        end
    end

    return showList;
end

-- 装备抽奖左上角标识
function Lua_TreasureUtil.Get:equipmentShowSignInfo()
    if self._equipmentShowSignInfo == nil then
        self._equipmentShowSignInfo = {};
        local info = getConfig({"hi_treasure_info", "equipment_iconSign_show", "arr"});
        if info ~= nil then
            for i = 1, #info do
                local obj = info[i];
                if obj ~= nil and obj[3] ~= nil and obj[3] ~= "" then
                    self._equipmentShowSignInfo[tonumber(obj[1])] = obj;
                end
            end
        end
    end

    return self._equipmentShowSignInfo;
end

-- 临时仓库大小
function Lua_TreasureUtil:getStoreSize()
    return getConfig({"hi_treasure_info", "pack_size", "value"});
end

-- 兑换数据
function Lua_TreasureUtil:getExchangeData(num)
    self.exchangeData = Array();
    local config = getConfig({"hi_treasure_exchange"});
    if config ~= nil then
        for i, v in pairs(config) do
            
            local drawType = nil; --抽奖类型
            if num == 1 then
                drawType = DataCenter.treasureData.equipmentDrawType;
            elseif num == 2 then
                drawType = DataCenter.treasureData.peakDrawType;
            elseif num == 3 then
                drawType = DataCenter.treasureData.supremacyDrawType;
            elseif num == 4 then
                drawType = DataCenter.treasureData.apotheosizeDrawType;
            end

            local id = tostring(tonumber(i));
            if tonumber(string.sub(id, 1, -4)) == num then
                v.id = i;
                v.drawType = drawType;
                self.exchangeData:add(v);
            end
        end
    end

    self.exchangeData:sort("oder", true);

    return self.exchangeData;
end

-- 装备抽奖消耗的道具id
function Lua_TreasureUtil.Get:equipDrawCostId()
    return getConfig({"hidden_treasure", "equip_luck_draw", "item_id"});
end

-- 装备抽奖一次消耗的数量
function Lua_TreasureUtil.Get:equipDrawOneCostNum()
    if self.equipOneCostNum == nil then
        self.equipOneCostNum = getConfig({"hidden_treasure", "equip_luck_draw", "draw_type"})[1][2];
    end

    return self.equipOneCostNum;
end

-- 装备抽奖十次消耗的数量
function Lua_TreasureUtil.Get:equipDrawTenCostNum()
    if self.equipTenCostNum == nil then
        self.equipTenCostNum = getConfig({"hidden_treasure", "equip_luck_draw", "draw_type"})[2][2];
    end

    return self.equipTenCostNum;
end

-- 装备抽奖五十次消耗的数量
function Lua_TreasureUtil.Get:equipDrawFiftyCostNum()
    if self.equipFiftyCostNum == nil then
        self.equipFiftyCostNum = getConfig({"hidden_treasure", "equip_luck_draw", "draw_type"})[3][2];
    end

    return self.equipFiftyCostNum;
end

-- 灵纹抽奖消耗的道具id
function Lua_TreasureUtil.Get:runeDrawCostId()
    return getConfig({"hidden_treasure", "rune_luck_draw", "item_id"});
end

-- 灵纹抽奖一次消耗的数量
function Lua_TreasureUtil.Get:runeDrawOneCostNum()
    if self.runeOneCostNum == nil then
        self.runeOneCostNum = getConfig({"hidden_treasure", "rune_luck_draw", "draw_type"})[1][2];
    end

    return self.runeOneCostNum;
end

-- 灵纹抽奖十次消耗的数量
function Lua_TreasureUtil.Get:runeDrawTenCostNum()
    if self.runeTenCostNum == nil then
        self.runeTenCostNum = getConfig({"hidden_treasure", "rune_luck_draw", "draw_type"})[2][2];
    end

    return self.runeTenCostNum;
end


-- 灵纹抽奖抽保底需累计的次数
function Lua_TreasureUtil.Get:runeDrawBestEndNum()
    return getConfig({"hi_treasure_info", "rune_draw_count", "value"});
end

function Lua_TreasureUtil:getPreciseDecimal(nNum, n)
    if type(nNum) ~= "number" then
        return nNum;
    end
    n = n or 0;
    n = math.floor(n);
    if n < 0 then
        n = 0;
    end

    local nDecimal = 10 ^ n;
    local nTemp = math.floor(nNum * nDecimal);
    local nRet = nTemp / nDecimal;

    if nRet == 0 and nNum > 0 then -- 特殊处理，防止血量很低显示0
        return 0.01;
    end

    return nRet;
end

-- 灵纹抽奖抽奖品展示
function Lua_TreasureUtil.Get:runeRewadrShow()
    return getConfig({"hi_treasure_info", "rune_iconSign_show", "arr"});
end





-- 巅峰抽奖左上角标识
function Lua_TreasureUtil.Get:peakShowSignInfo()
    if self._peakShowSignInfo == nil then
        self._peakShowSignInfo = {};
        local info = getConfig({"hi_treasure_info", "peak_iconSign_show", "arr"});
        if info ~= nil then
            for i = 1, #info do
                local obj = info[i];
                if obj ~= nil and obj[3] ~= nil and obj[3] ~= "" then
                    self._peakShowSignInfo[tonumber(obj[1])] = obj;
                end
            end
        end
    end

    return self._peakShowSignInfo;
end

-- 巅峰抽奖消耗的道具id
function Lua_TreasureUtil.Get:peakDrawCostId()
    return getConfig({"hidden_treasure", "peak_luck_draw", "item_id"});
end

-- 巅峰抽奖一次消耗的数量
function Lua_TreasureUtil.Get:peakDrawOneCostNum()
    if self.peakOneCostNum == nil then
        self.peakOneCostNum = getConfig({"hidden_treasure", "peak_luck_draw", "draw_type"})[1][2];
    end

    return self.peakOneCostNum;
end

-- 巅峰抽奖十次消耗的数量
function Lua_TreasureUtil.Get:peakDrawTenCostNum()
    if self.peakTenCostNum == nil then
        self.peakTenCostNum = getConfig({"hidden_treasure", "peak_luck_draw", "draw_type"})[2][2];
    end

    return self.peakTenCostNum;
end

-- 巅峰抽奖五十次消耗的数量
function Lua_TreasureUtil.Get:peakDrawFiftyCostNum()
    if self.peakFiftyCostNum == nil then
        self.peakFiftyCostNum = getConfig({"hidden_treasure", "peak_luck_draw", "draw_type"})[3][2];
    end

    return self.peakFiftyCostNum;
end





-- 至尊抽奖左上角标识
function Lua_TreasureUtil.Get:supremacyShowSignInfo()
    if self._peakShowSignInfo == nil then
        self._peakShowSignInfo = {};
        local info = getConfig({"hi_treasure_info", "supreme_iconSign_show", "arr"});
        if info ~= nil then
            for i = 1, #info do
                local obj = info[i];
                if obj ~= nil and obj[3] ~= nil and obj[3] ~= "" then
                    self._peakShowSignInfo[tonumber(obj[1])] = obj;
                end
            end
        end
    end
    return self._peakShowSignInfo;
end

-- 至尊抽奖消耗的道具id
function Lua_TreasureUtil.Get:supremacyDrawCostId()
    return getConfig({"hidden_treasure", "supreme_luck_draw", "item_id"});
end

-- 至尊抽奖一次消耗的数量
function Lua_TreasureUtil.Get:supremacyDrawOneCostNum()
    if self.peakOneCostNum == nil then
        self.peakOneCostNum = getConfig({"hidden_treasure", "supreme_luck_draw", "draw_type"})[1][2];
    end

    return self.peakOneCostNum;
end

-- 至尊抽奖十次消耗的数量
function Lua_TreasureUtil.Get:supremacyDrawTenCostNum()
    if self.peakTenCostNum == nil then
        self.peakTenCostNum = getConfig({"hidden_treasure", "supreme_luck_draw", "draw_type"})[2][2];
    end

    return self.peakTenCostNum;
end

-- 至尊抽奖五十次消耗的数量
function Lua_TreasureUtil.Get:supremacyDrawFiftyCostNum()
    if self.peakFiftyCostNum == nil then
        self.peakFiftyCostNum = getConfig({"hidden_treasure", "supreme_luck_draw", "draw_type"})[3][2];
    end

    return self.peakFiftyCostNum;
end



-- 封神抽奖左上角标识
function Lua_TreasureUtil.Get:apotheosizeShowSignInfo()
    if self._showSignInfo == nil then
        self._showSignInfo = {};
        local info = getConfig({"hi_treasure_info", "seal_iconSign_show", "arr"});
        if info ~= nil then
            for i = 1, #info do
                local obj = info[i];
                if obj ~= nil and obj[3] ~= nil and obj[3] ~= "" then
                    self._showSignInfo[tonumber(obj[1])] = obj;
                end
            end
        end
    end

    return self._showSignInfo;
end

-- 封神抽奖消耗的道具id
function Lua_TreasureUtil.Get:apotheosizeCostId()
    return getConfig({"hidden_treasure", "seal_luck_draw", "item_id"});
end

-- 封神抽奖一次消耗的数量
function Lua_TreasureUtil.Get:apotheosizeOneCostNum()
    if self.oneCostNum == nil then
        self.oneCostNum = getConfig({"hidden_treasure", "seal_luck_draw", "draw_type"})[1][2];
    end

    return self.oneCostNum;
end

-- 封神抽奖十次消耗的数量
function Lua_TreasureUtil.Get:apotheosizeTenCostNum()
    if self.tenCostNum == nil then
        self.tenCostNum = getConfig({"hidden_treasure", "seal_luck_draw", "draw_type"})[2][2];
    end

    return self.tenCostNum;
end

-- 封神抽奖五十次消耗的数量
function Lua_TreasureUtil.Get:apotheosizeFiftyCostNum()
    if self.fiftyCostNum == nil then
        self.fiftyCostNum = getConfig({"hidden_treasure", "seal_luck_draw", "draw_type"})[3][2];
    end

    return self.fiftyCostNum;
end











-- Lua_TreasureUtil = class("Lua_TreasureUtil");
-- function Lua_TreasureUtil:ctor()
-- end

-- function Lua_TreasureUtil:getShowReward(val)
--     self.rewardList = Array();
--     local list = getConfig("{equip_treasure_reward}");
--     for i = 1, #list do
--         if list[i].type == val and DataCenter.roleData.worldLevel >= list[i].world_lvl[1] and DataCenter.roleData.worldLevel <= list[i].world_lvl[2] 
--             and DataCenter.roleData.level >= list[i].role_level[1] and DataCenter.roleData.level <=list[i].role_level[2] then
--             local showreward_id = list[i].showreward_id[1];
--             local rewards = getConfig("{rewards, showreward_id, client_goods_list}");
--             for i = 1, #rewards do
--                 local obj = rewards[i];
--                 local vo = Lua_ToolVo.createToolVo(obj[2]);
--                 vo.index = obj[1];
--                 vo.count = obj[3];
--                 vo.star = obj[4];
--                 self.rewardList:add(vo);
--             end
--         end
--     end
--     for i = 1, self.rewardList:getSize() - 1 do
--         for j = i + 1, self.rewardList:getSize() do
--             if self.rewardList[i] > self.rewardList[j] then
--                 self.rewardList[i], self.rewardList[j] = self.rewardList[j], self.rewardList[i];
--             end
--         end
--     end
--     return self.rewardList;
-- end

-- function Lua_TreasureUtil:getSupremacySign()
--     local signList = Array();
--     local info = getConfig("{hi_treasure_info, supreme_iconSign_show, arr}");
--     for i = 1, #info do
--         local obj = info[i];
--         if obj[3] ~= nil and obj[3] ~= "" then
--             signList[tonumber(obj[1])] = obj;
--         end
--     end
--     return signList;
-- end


