﻿checkRequire("Lua_TreasureBoxVo")
checkRequire("Lua_TreasureEventVo")
Lua_TreasureActivityData = class("Lua_TreasureActivityData");
function Lua_TreasureActivityData:ctor()
	self:dispose();
end

function Lua_TreasureActivityData:dispose()
	self.total_treasure_roll = nil;
	self.event_tiems = nil;
	self.eventList = {};
end

function Lua_TreasureActivityData:fromServer51400025(msg)
	if msg == nil then
		return;
	end

	self.stage_reward_info = msg.act_item.stage_reward_info;
	self.event_tiems = msg.event_tiems;
	self.hide_treasure_event = msg.act_item.hide_treasure_event;
	self.total_treasure_roll = msg.act_item.sub_value;
	self.stage_index = msg.act_item.stage_index + 1;
	self.tipsContent = msg.act_item.content;
	self.stop_tick = tonumber(tostring(msg.act_item.stop_tick));

	self:setTreasureHideEventList();
	self:setTreasureEventList();
	Lua_MsgUtil.callFunc("UPDATE_TREASUREACTIVITY_DATA")
end

function Lua_TreasureActivityData:changeStage(curindex)
	self.stage_index = curindex;

	-- self:setTreasureHideEventList();
	-- self:setTreasureEventList();
	self.Get:curTreasureBoxArr();
	Lua_MsgUtil.callFunc("UPDATE_TREASUREACTIVITY_DATA");
end

function Lua_TreasureActivityData:setTreasureHideEventList()
	if self.hide_treasure_event ~= nil then
		self.eventList = {};

		local eventVo;
		local index = 0;
		for k, v in ipairs(self.hide_treasure_event) do
			index = index + 1;

			eventVo = Lua_TreasureEventVo.new(v.event_id);
			eventVo.point = v.point;
			eventVo.content = v.content;
			eventVo.limit_amount = v.limit_amount;
			eventVo.stage_index = self.stage_index;
			eventVo.index = index;
			self.eventList[eventVo.eventId] = eventVo;
		end
	end
end

function Lua_TreasureActivityData:setTreasureEventList()
	if self.event_tiems ~= nil then
		for k, v in ipairs(self.event_tiems) do
			if self.eventList[v.obj_id] ~= nil then
				self.eventList[v.obj_id].eventNum = v.obj_value;
			end
		end
	end
end

function Lua_TreasureActivityData.Get:ticketCount()
	if self.total_treasure_roll == nil then
		return 0;
	end
	return self.total_treasure_roll;
end

function Lua_TreasureActivityData.Get:treasureFloors()
	if self.stage_reward_info == nil then
		return nil;
	end
	return #self.stage_reward_info;
end

function Lua_TreasureActivityData.Get:subPos()
	return self._subPos;
end

function Lua_TreasureActivityData.Set:subPos(subpos)
	self._subPos = subpos;
end

function Lua_TreasureActivityData.Get:isLastFinish()
	local isFinish = true;
	if self.stage_index ~= nil and self.stage_index > 1 then
		for k, v in ipairs(self.stage_reward_info) do
			if self.stage_index == v.stage_index + 2 then
				for key,value in ipairs(v.reward_info) do
					local boxVo = Lua_TreasureBoxVo.new(self.stage_index - 1, key);
					boxVo:fromServer(value);
					if boxVo.draw_flag ~= 1 then
						isFinish = false;
					end

					local boxVo1 = Lua_TreasureBoxVo.new(self.stage_index, key);
					boxVo1:fromServer(value);
				end
			end
		end
	end
	return isFinish;
end

function Lua_TreasureActivityData.Get:curTreasureBoxArr()
	if self.stage_index == nil then
		return;
	else
		return self:getTreasureBoxByIndex(self.stage_index);
	end
end

function Lua_TreasureActivityData.Get:treasureBoxArr()
	local list;
	local arr = Array();
	if self.stage_reward_info ~= nil then
		for k, v in ipairs(self.stage_reward_info) do
			list = {};
			list.boxCount = #v.reward_info;
			list.stage_index = v.stage_index + 1;
			list.boxArr = Array();
			for key, value in ipairs(v.reward_info) do
				local boxVo = Lua_TreasureBoxVo.new(list.stage_index, value.index);
				boxVo:fromServer(value);
				list.boxArr:add(boxVo);
			end
			arr:add(list);
		end
	end
	return arr;
end

function Lua_TreasureActivityData:getTreasureBoxByIndex(stage_index)
	if stage_index == nil then
		return;
	end

	local len = self.treasureBoxArr:getSize();
	for i = 1, len do
		if self.treasureBoxArr[i].stage_index == stage_index then
			return self.treasureBoxArr[i];
		end
	end
	return;
end

function Lua_TreasureActivityData.Get:configData()
	if self._configData == nil then
		self._configData = getConfig({"treasureActivity"})
	end
	return self._configData;
end

function Lua_TreasureActivityData.Get:treasureEventArr()
	local arr = Array();
	for k, v in pairs(self.eventList) do
		if self.eventList[k].eventLimitNum ~= nil and tonumber(self.eventList[k].eventLimitNum) > 0 then
			arr:add(self.eventList[k]);
		end
	end
	arr:sort("index", false);
	return arr;
end