Lua_TujianData = class("Lua_TujianData");
function Lua_TujianData:ctor()
	self.illus_list = {};
end

function Lua_TujianData:dispose()
	if self.props_List ~= nil then
		self.props_List = nil;
	end
	if self.illus_list ~= nil then
		self.illus_list = {};
	end
	if self.msg ~= nil then
		self.msg = nil;
	end
	if self.illusArry ~= nil then
		self.illusArry:clear();
		self.illusArry = nil;
	end
	if self.arr ~= nil then
		self.arr:clear();
		self.arr = nil;
	end
	DataCenter.TuJianUtil:resetTuJianInfo();
end

-- 获取图鉴列表信息
function Lua_TujianData:sIllusMsg()
	sendMsg(11404001);
end

-- 升级图鉴
function Lua_TujianData:sIllusUppgradeMsg(illus_id)
	local cmd = ProtoPublic_pb.Proto11404005();
	cmd.illus_id = illus_id;
	sendMsg(11404005, cmd);
end

-- 激活图鉴
function Lua_TujianData:sIllusActivateMsg(illus_id)
	local cmd = ProtoPublic_pb.Proto11404008();
	cmd.illus_id = illus_id;
	sendMsg(11404008, cmd);
end

function Lua_TujianData:fromServer51404001(msg)
	if msg == nil then
		return;
	end

	self.msg = msg;
	self.prop_list = msg.prop_list; -- 玩家获得总属性

	local vo;
	self.illusArry = Array();
	for k, v in ipairs(msg.illus_list) do -- 玩家图鉴集合
		self.illusArry:add({classId = v.illus_class_id});
		vo = DataCenter.TuJianUtil:getVoByClassIdAndConfigId(v.illus_class_id, v.illus_id);
		vo:fromServer(v);
	end

	for i,v in ipairs(msg.active_list) do -- 玩家可激活图鉴集合
		self.illus_list[v] = true;
	end
end

function Lua_TujianData:fromServer81404007(msg)
	if msg == nil then
		return;
	end

	self.msg = msg;
	self.prop_list = msg.prop_list; -- 玩家获得总属性

	local vo;
	for k, v in ipairs(msg.illus_list) do
		vo = DataCenter.TuJianUtil:getVoByClassIdAndConfigId(v.illus_class_id, v.illus_id);
		vo:fromServer(v);
	end

	for i,v in ipairs(msg.active_list) do
		self.illus_list[v] = true;
	end
end





function Lua_TujianData:getClassList(class_id)
	self.arr = Array();
	if self.msg ~= nil then
		for i,v in ipairs(self.msg.illus_list) do
			if v.illus_class_id == class_id then
				self.arr:add({i = v.illus_class_id});
			end
		end
	end
	return self.arr:getSize();
end





-- 可升级类图鉴排序，可激活>可升级>已激活>未激活
function Lua_TujianData:canUpLvSortFun(a, b)
	if a == nil then
		return false;
	end

	local _aRedState, _aDrawState = self:getCanUpLvRedState(a);
	local _bRedState, _bDrawState = self:getCanUpLvRedState(b);
	if _aRedState ~= _bRedState then
		if _aRedState then
			return true; -- a有红点
		else
			return false; -- b有红点
		end
		
	else
		if _aRedState == true then -- 都有红点
			return _aDrawState > _bDrawState; -- 0满级 1可升级 2可激活
		else -- 都没红点
			local _aMaxOrActiveState = a.illusClassId == nil;
			local _bMaxOrActiveState = b.illusClassId == nil;
			if _aMaxOrActiveState ~= _bMaxOrActiveState then
				return not _aMaxOrActiveState;
			else
				return a.sort < b.sort;
			end
		end
	end
end

function Lua_TujianData:getCanUpLvRedState(a)
	local itemId;
	if self.illus_class_id == 1 then
		itemId = Lua_CommonUtil.getCommonConfig("illus_universal_monster", 1); -- 万能野外怪物图鉴道具
	else
		itemId = Lua_CommonUtil.getCommonConfig("illus_universal_boss", 1); -- 万能boss图鉴道具
	end

	local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if a.illusClassId == nil then -- 未激活可激活
		return packData:getItemNum(a.upgrade_goods_id) >= a.goods_amount_list[1], 2;
	else -- 已激活
		if a.illusLevel < a.illus_level then -- 当前等级，最大等级
			local getAllItemNum = packData:getItemNum(itemId); -- 身上的万能道具
			return (a.hasTujianCount + getAllItemNum) >= a.goods_amount_list[1], 1;
		else
			return false, 0;
		end
	end
end





-- 不可升级类图鉴排序，可激活>已激活>未激活
function Lua_TujianData:noLvSortFun(a, b)
	if a == nil then
		return false;
	end

	local _aRedState = self:getNoLvRedState(a);
	local _bRedState = self:getNoLvRedState(b);
	if _aRedState ~= _bRedState then
		return _aRedState;
	else
		if _aRedState == true then -- 都有红点
			return a.sort < b.sort;
		else -- 都没红点
			local _aActiveState = self:getNoLvActiveState(a);
			local _bActiveState = self:getNoLvActiveState(b);
			if _aActiveState ~= _bActiveState then
				return _aActiveState < _bActiveState;
			else
				return a.sort < b.sort;
			end
		end
	end
	return true;
end

function Lua_TujianData:getNoLvRedState(a)
	if a.illusClassId == nil and self.illus_list[a.id] == true then -- 可激活的
		return true;
	end
	return false;
end

function Lua_TujianData:getNoLvActiveState(a)
	return a.illusClassId ~= nil and 1 or 2; -- 1已激活 2未激活
end