checkRequire("Lua_TuJianVo");
Lua_TuJianUtil = class("Lua_TuJianUtil");
function Lua_TuJianUtil:ctor()
end

-- 清除VO数据
function Lua_TuJianUtil:resetTuJianInfo()
	if self.tujianDic ~= nil then
		for k, list in pairs(self.tujianDic) do
			for i = 1, list:getSize() do
				list[i]:clearServerInfo();
			end
		end
	end
end

-- 通过图鉴类获取VO
function Lua_TuJianUtil:getArrByClassId(class_id)
	return self.tujianConfigInfo[tostring(class_id)];
end

-- 通过图鉴ID获取VO，用于图鉴非升级类
function Lua_TuJianUtil:getVoByConfigId(configId)
	local tujianDic = self.tujianConfigInfo;
	for k,v in pairs(tujianDic) do
		for i = 1, v:getSize() do
			if v[i].id == configId then
				return v[i];
			end
		end
	end
	return nil;
end

-- 通过图鉴类和图鉴ID获取VO，服务端传值
function Lua_TuJianUtil:getVoByClassIdAndConfigId(class_id, configId)
	local arr = self:getArrByClassId(class_id)
	for i = 1, arr:getSize() do
		if arr[i].id == configId then
			return arr[i];
		end
	end
	return nil;
end 

-- 通过图鉴类和图鉴组ID获取VO，用于图鉴升级类
function Lua_TuJianUtil:getArrByClassIdAndGroupId(class_id, groupId)
	local result = Array();
	local arr = self:getArrByClassId(class_id)
	for i = 1, arr:getSize() do
		if arr[i].illus_group_id == groupId then
			result:add(arr[i]);
		end
	end
	return result;
end

-- 通过图鉴类和职业ID获取VO，用于图鉴非升级类
function Lua_TuJianUtil:getArrByClassIdAndCareer(class_id, career)
	local illus_fashion_id = Lua_CommonUtil.getCommonConfig("illus_fashion_id", 1); -- 时装类常量值
	local illus_decorate_id = Lua_CommonUtil.getCommonConfig("illus_decorate_id", 1); -- 装饰类常量值
	if class_id ~= illus_fashion_id and class_id ~= illus_decorate_id then
		return self:getArrByClassId(class_id);
	else
		local result = Array();
		local arr = self:getArrByClassId(class_id)
		for i = 1, arr:getSize() do
			if arr[i].play_career == career or arr[i].play_career == 0 then
				result:add(arr[i]);
			end
		end
		return result;
	end
end

-- VO
function Lua_TuJianUtil.Get:tujianConfigInfo()
	if self.tujianDic == nil then
		self.tujianDic = {};

		local vo;
		local config = getConfig({"illus_non_upgrade"}); -- 非升级类图鉴
		for k, v in pairs(config) do
			vo = Lua_TuJianVo.new(k, v);
			if self.tujianDic[tostring(vo.illus_class_id)] == nil then
				self.tujianDic[tostring(vo.illus_class_id)] = Array();
			end
			self.tujianDic[tostring(vo.illus_class_id)]:add(vo);
		end

		config = getConfig({"illus_upgrade"}); -- 升级类图鉴
		for k, v in pairs(config) do
			vo = Lua_TuJianVo.new(k, v);
			if self.tujianDic[tostring(vo.illus_class_id)] == nil then
				self.tujianDic[tostring(vo.illus_class_id)] = Array();
			end
			self.tujianDic[tostring(vo.illus_class_id)]:add(vo);
		end

		local sort;
		for k,v in pairs(self.tujianDic) do
			sort = getConfig({"tujian_calss", tonumber(k), "sort"}); -- 图鉴类
			if sort ~= nil and sort == 5 then
				v:sort("sort", false);
			else
				v:sort("id", false) 
			end
		end
	end
	return self.tujianDic;
end

-- 激活个数获取表数据，用于图鉴非升级类
function Lua_TuJianUtil:getArrByClassIdAndActiveNum(class_id, active_num)
	local arr = self.tujianAddproInfo[tostring(class_id)];
	if arr == nil then
		return nil;
	end

	local len = arr:getSize();
	for i = 1, len do
		if i < len then
			if active_num >= arr[i].active and active_num < arr[i + 1].active then
				return {curInfo = arr[i], nextInfo = arr[i + 1]};
			elseif  i == 1 and  active_num < arr[i].active then
				return {nextInfo = arr[1]};
			end
		else
			return {curInfo = arr[len]};
		end
	end
	return nil;
end

-- 图鉴非升级类额外属性数据处理，用于图鉴非升级类
function Lua_TuJianUtil.Get:tujianAddproInfo()
	if self.addprolist == nil then
		self.addprolist = {};

		local attrConfig = getConfig({"illus_non_upgrade_add"}); -- 图鉴额外属性加成
		for k,v in pairs(attrConfig) do 
			if self.addprolist[tostring(v.illus_class_id)] == nil then
				self.addprolist[tostring(v.illus_class_id)] = Array();
			end
			self.addprolist[tostring(v.illus_class_id)]:add(v);
		end

		for k,v in pairs(self.addprolist) do
			v:sort("active", false)
		end
	end
	return self.addprolist;
end

-- 图鉴分类数据
function Lua_TuJianUtil:tuJianCalssInfo()
	if self.tujian_info == nil then
		self.tujian_info = {};

		local config = getConfig({"tujian_calss"});
		for i,v in pairs(config) do
			self.tujian_info[i] = v;
		end
	end
	return self.tujian_info;
end

-- 用于图鉴界面页签显示
function Lua_TuJianUtil:getIllusCalssList()
	local arr = self:tuJianCalssInfo();
	if self.arrList == nil then
		self.arrList = Array();

		local subArr;
		local config = getConfig({"illus_upgrade_group"});
		for k,v in pairs(arr) do
			subArr = Array();
			if v.illus_group_list ~= nil then
				for i, j in pairs(v.illus_group_list) do
					subArr:add({
						name = config[j]["illus_group_name"],
						illus_class_id = k,
						illus_group_id = j
					});
				end
			end
			self.arrList:add({name = v.illus_class_name, illus_class_id = k, sub = subArr});
		end
	end
	return self.arrList;
end

function Lua_TuJianUtil:getIllusIsClassId(class_id)
	self.isrodList = {};
	local vo = self:getArrByClassId(class_id);
	if self.tujian_info[class_id].illus_group_list ~= nil then
		local itemId;
		if class_id == 1 then
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_monster", 1); -- 万能野外怪物图鉴道具
		else
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_boss", 1); -- 万能boss图鉴道具
		end

		local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		for i = 1, vo:getSize() do
			if vo[i].illusClassId ~= nil then -- 已激活
				local illusLevel = vo[i].illusLevel; -- 图鉴当前等级
				local needCount = vo[i].needTujianCount;
				local hasCount = vo[i].hasTujianCount + packData:getItemNum(itemId); -- 专属图鉴 + 万能图鉴
				if hasCount >= needCount and vo[i].goods_amount_list[illusLevel + 1] ~= nil then
					self.isrodList[vo[i].illus_class_id] = true;
					self.isrodList[vo[i].illus_group_id] = true;
				end
			else -- 未激活的
				local curCount = packData:getItemNum(vo[i].upgrade_goods_id);
				if curCount >= vo[i].goods_amount_list[1] then
					self.isrodList[vo[i].illus_class_id] = true;
					self.isrodList[vo[i].illus_group_id] = true;
				end
			end
		end
	else
		for i = 1, vo:getSize() do
			if vo[i].illusClassId == nil then -- 未激活
				if DataCenter.TujianData.illus_list[vo[i].id] == true then
					self.isrodList[vo[i].illus_class_id] = true;
				end
			end
		end
	end
	return self.isrodList;
end

function Lua_TuJianUtil:getIllusIsGroupId(class_id)
	local isrodList = {};
	local vo = self:getArrByClassId(class_id);
	if self.tujian_info[class_id].illus_group_list ~= nil then
		local itemId;
		if class_id == 1 then
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_monster", 1); -- 万能野外怪物图鉴道具
		else
			itemId = Lua_CommonUtil.getCommonConfig("illus_universal_boss", 1); -- 万能boss图鉴道具
		end

		local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		for i = 1, vo:getSize() do
			if vo[i].illusClassId ~= nil then -- 已激活
				local illusLevel = vo[i].illusLevel; -- 图鉴当前等级
				local needCount = vo[i].needTujianCount;
				local hasCount = vo[i].hasTujianCount + packData:getItemNum(itemId); -- 图鉴 + 万能图鉴  
				if hasCount >= needCount and vo[i].goods_amount_list[illusLevel + 1] ~= nil then
					isrodList[vo[i].illus_group_id] = true;
				end
			else -- 未激活的
				local curCount = packData:getItemNum(vo[i].upgrade_goods_id);
				if curCount >= vo[i].goods_amount_list[1] then
					isrodList[vo[i].illus_group_id] = true;
				end
			end
		end
	end
	return isrodList;
end