﻿checkRequire("Lua_VipTypeVo");
checkRequire("Lua_VipLevelInfoVo");
Lua_VipData = class("Lua_VipData");
function Lua_VipData:ctor()
	self.isExpired = false;
end

function Lua_VipData:dispose()
	self._level = nil;
end

-- 获取会员卡配置信息
function Lua_VipData:initVipType()
	self.vipTypeDic = {};

	local vipConfing = getConfig({"vip_type"});
	for k,v in pairs(vipConfing) do
		self.vipTypeDic[k] = Lua_VipTypeVo.new(k);
	end
end

function Lua_VipData:getVoById(id)
	if self.vipTypeDic == nil then
		self:initVipType();
	end
	return self.vipTypeDic[id];
end

function Lua_VipData:getAllVipTypeList()
	if self.vipTypeDic == nil then
		self:initVipType();
	end

	local arr = Array();
	for k,v in pairs(self.vipTypeDic) do
		if k > 1 then
			arr:add(v);
		end
	end
	arr:sort("order" ,true)
	return arr;
end

-- 获取会员各个级别特权内容的配置信息
function Lua_VipData:initViplevelInfo()
	self.vipLevelInfoDic = {};

	local vo;
	local vipConfing = getConfig({"vip_level"});
	for k,v in pairs(vipConfing) do
		vo = Lua_VipLevelInfoVo.new(k);
		if k == 100 then
			k = 10;
		end
		self.vipLevelInfoDic[k] = vo;
	end
end

function Lua_VipData:getTheWholeVipLevelList()
	if self.vipLevelInfoDic == nil then
		self:initViplevelInfo();
	end

	local arr = Array();
	for k,v in pairs(self.vipLevelInfoDic) do
		arr:add(v);
	end
	return arr;
end

function Lua_VipData.Get:level()
	if self._level == nil then
		self._level = 0;
	end
	return self._level;
end

function Lua_VipData.Set:level(value)
	if self._level ~= nil and value > self._level then
		MsgUtil.callFunc("VIP_LEVEL_UP", value);
	end
	self._level = value;
end

-- 买VIP
function Lua_VipData:sBuyVip(vip_variety)
	local cmd = ProtoPublic_pb.Proto11400801();
	cmd.vip_variety = vip_variety;
	sendMsg(11400801, cmd);
end

-- 领取vip专属礼物
function Lua_VipData:sGetVipPresent(vip_type)
	local cmd = ProtoPublic_pb.Proto11400803();
	cmd.vip_type = vip_type;
	sendMsg(11400803, cmd);
end

-- 领取vip每日礼包
function Lua_VipData:sGetVipDailyPresent()
	sendMsg(11400807);
end

-- 获取角色的vip信息
function Lua_VipData:sGetRoleVipInfo()
	sendMsg(11400804);
end

-- 获取角色的svip信息
function Lua_VipData:sGetRoleRoleSvipInfo()
	sendMsg(11400805);
end

-- 是否体验VIP
function Lua_VipData.Get:isTiYan()
	local surplusTime = tonumber(self.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
	if surplusTime > 0 and self.vip_type ==  1 and self.level == 1 then
		return true;
	end
	return false;
end

 -- vip每日礼包奖励
function Lua_VipData.rewardList(val)
	local itemList = Array();
	local itemDic = {};
	local dtidx = 1;
	local step = 1;
	for i = 1, val:getSize() do
		local tr = Lua_RewardsUtil.getRewardList(val[i]);
		local rewards = tr.rewards;
		local dropMarks = tr.dropMarks;
		for k,v in ipairs(rewards) do
			dtidx = dtidx + 1;
			local str = v.id..v.bind..v.star;
			local inObj = itemDic[str];
			if inObj == nil then
				inObj = {};
				inObj.id = v.id;
				inObj.amount = v.amount;
				inObj.bind = v.bind;
				inObj.star = v.star;
				inObj.attr = v.attr;
				inObj.step = step;
				inObj.bShowItemBg = bShowItemBg;
				if roundEffect ~= nil  then
					inObj.roundEffect = roundEffect;
				else
					inObj.roundEffect = v.roundEffect;
				end
				step = step + 1;

				if dropMarks ~= nil and table.indexOf(dropMarks, k - 1) ~= -1 then
					inObj.mustDrop = true;
				end
				itemDic[str] = inObj;
			else
				inObj.amount = inObj.amount + v.amount;
			end
		end
	end

	for k,v in pairs(itemDic) do
		itemList:add(v);
	end
	itemList:sort("step", false);
	return itemList
end

function Lua_VipData.Set:ChongzhiWindowData(data)
	self._windowData = data;
end

function Lua_VipData.Get:ChongzhiWindowData()
	if self._windowData == nil then
		return nil;
	end
	return self._windowData;
end