﻿checkRequire("Lua_VipData")
Lua_VipProxy = class("Lua_VipProxy")

function Lua_VipProxy:ctor()
	self:superCall("ctor")

	DataCenter.vipData = Lua_VipData.new()

	LuaUtil.addLuaMsg(51400801, self, self.rBuyVip)
	LuaUtil.addLuaMsg(51400803, self, self.rGetVipPresent)
	LuaUtil.addLuaMsg(51400804, self, self.rGetRoleVipInfo)
	LuaUtil.addLuaMsg(51400805, self, self.rGetRoleSvipInfo)
    LuaUtil.addLuaMsg(51400807, self, self.rGetRoleSvipInfo)
	
	self.tipData = {}
end

--购买vip返回
function Lua_VipProxy:rBuyVip(mp)
	if mp.errno == 0 then
		DataCenter.vipData:sGetRoleVipInfo()
		OperateAlert.show(LanUtil.getValue(121307));
	end
end

--返回领取vip礼物
function Lua_VipProxy:rGetVipPresent(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("VIP_GET_PRESENT", msg);
	end
end

--获取角色的vip信息
function Lua_VipProxy:rGetRoleVipInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400804();
		msg:ParseFromString(mp.data)
		local vipData = DataCenter.vipData
		vipData.vip_type = msg.vip_type;
		vipData.level = msg.level;
		vipData.cur_exp = msg.cur_exp;
		vipData.expired_time = msg.expired_time;
		vipData.vip_reward = msg.vip_reward
        vipData.gift_state = msg.gift_state
		if tonumber(vipData.expired_time) >tonumber(tostring(GlobalVar.cur_tick)) then
			Lua_CommonUtil.removeTimer(self,self.onVipExpiredTick);
			Lua_CommonUtil.addTimer("VIP_EXPIRED_COUNTDOWN",1,self,self.onVipExpiredTick,nil,-1);
			vipData.isExpired = false;
			vipData.surplusTime = tonumber(vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick))
			if vipData.vip_type ~= 1 and vipData.level~= 1 and tonumber(vipData.surplusTime) <= tonumber(60 * 60 * 24 * 3) then
				if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.RELIVE) == false and msg.tips_state == 0 then
					self.tipData.owner = self;
					self.tipData.neverTip = Lua_NeverTipData.RELIVE;
                    self.tipData.expired_time = vipData.expired_time;
					Lua_WindowUtil.openWin("Lua_ExpireWarningWindow", nil, self.tipData);
				end
			end
		else
			vipData.isExpired = true;
		end
		Lua_MsgUtil.callFunc("VIP_UPGRADE_EVENT", msg.level);
		-- print("Lua_VipProxy中数据持久化之后的人物vip级别是：  "..vipData.level)
		Lua_MsgUtil.callFunc("VIP_GET_ROLE_VIPINFORMATION", msg)
	end
end


function Lua_VipProxy:onVipExpiredTick()
	if DataCenter.vipData ~= nil then
		if(DataCenter.vipData.vip_type ~=  0) then
			self.tempVipType = DataCenter.vipData.vip_type;
		end
		local leftTime =tonumber(DataCenter.vipData.expired_time) - tonumber(tostring(GlobalVar.cur_tick));
--		print("vip expire time left:"..tostring(leftTime));
		if leftTime<=0  then
			Lua_CommonUtil.removeTimer(self,self.onVipExpiredTick);
			DataCenter.vipData.isExpired = true;
			Lua_MsgUtil.callFunc("VIP_EXPIRED");
--			print("DataCenter.vipData.vip_type ",DataCenter.vipData.vip_type,DataCenter.vipData.level);
			if DataCenter.vipData.vip_type ==  0 and DataCenter.vipData.level == 0 then
				if(self.tempVipType == 1) then
					Lua_WindowUtil.openWin("Lua_VipExperienceExpiredWindow", WinParam.ACTION_OPEN,self.tempVipType);
				else
					local tipData = {};
					tipData.des = LanUtil.getValue(121321);  
					tipData.owner = self;
					tipData.type = 2;
					tipData.txtSpacingY = 16
					tipData.txtPos = { x = 0, y = 38};
					tipData.titleName = LanUtil.getValue(121334);
					tipData.subName = LanUtil.getValue(121313);
					tipData.subFun = self.onGotoRechargeClick;   --确定
					Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
				end
				self.tempVipType = 0;
			end
			
		end
	end
end
function Lua_VipProxy:onGotoRechargeClick()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 10097);
end
function Lua_VipProxy:rGetRoleSvipInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51400805();
		msg:ParseFromString(mp.data)

		local rd = DataCenter.vipData

		rd.des_content = msg.des_content
		rd.qq_num = msg.qq_num
		rd.is_open = msg.is_open; 
	end
end

function Lua_VipProxy:rGetVipDailyPresent(mp)
	if mp.errno == 0 then
		Lua_MsgUtil.callFunc("VIP_GET_Daily_Present")
	end
end
