-- 武林大会数据
Lua_WulindahuiData = class("Lua_WulindahuiData");
Lua_WulindahuiData.wulindahuiSceneId = 40201;
function Lua_WulindahuiData:ctor()
	self:dispose();
end

function Lua_WulindahuiData:dispose()
	self:resetWulinInfo();
	self:resetChallengeInfo();
end

function Lua_WulindahuiData:fromServerWulinInfo(msg)
	self.curWinRate = msg.win_per > 100 and 100 or msg.win_per; -- 当前胜率
	self.curPointNum = msg.point; -- 当前积分
	self.curChallengeTimes = msg.enter_number; -- 当前场次
	self.boxRewards = msg.box_reward; -- 0 不可领取，1 可领取，2 已领取
end

function Lua_WulindahuiData:resetWulinInfo()
	self.curWinRate = 0;
	self.curPointNum = 0;
	self.curChallengeTimes = 0;
	self.boxRewards = nil;
end

function Lua_WulindahuiData.Get:bInWulindahuiScene()
	if DataCenter.roleData.sceneId == Lua_WulindahuiData.wulindahuiSceneId then
		return true;
	end
	return false;
end

function Lua_WulindahuiData:fromServerChallengeInfo(msg)
	self.getLeftTime = getTime();
	self.leftTime = msg.left_time;
	self.countDown = msg.count_down;
	self.martialState = msg.martial_state;
	self.totalTime = msg.total_time;
	self.firstRoleInfo = msg.first_role;
	self.firstMaxBlood = tonumber(tostring(msg.first_max_blood));
	self.firstCurBlood = tonumber(tostring(msg.first_cur_blood));
	self.firstMaxMagic = msg.first_max_magic;
	self.firstCurMagic = msg.first_cur_magic;
	self.secRoleInfo = msg.second_role;
	self.secMaxBlood = tonumber(tostring(msg.second_max_blood));
	self.secCurBlood = tonumber(tostring(msg.second_cur_blood));
	self.secMaxMagic = msg.second_max_magic;
	self.secCurMagic = msg.second_cur_magic;
	self.reloginSign = msg.is_relogin;
end

function Lua_WulindahuiData:resetChallengeInfo()
	self.getLeftTime = 0;
	self.leftTime = 0;
	self.countDown = nil;
	self.martialState = 0;
	self.totalTime = 0;
	self.firstRoleInfo = nil;
	self.firstMaxBlood = 0;
	self.firstCurBlood = 0;
	self.firstMaxMagic = 0;
	self.firstCurMagic = 0;
	self.secRoleInfo = nil;
	self.secMaxBlood = 0;
	self.secCurBlood = 0;
	self.secMaxMagic = 0;
	self.secCurMagic = 0;
	self.reloginSign = 0;
end

function Lua_WulindahuiData.Get:reduiseTime()
	local num = self.leftTime - (getTime() - self.getLeftTime);
	if num <= 0 then
		return 0;
	end
	return num;
end

function Lua_WulindahuiData.Get:countDownTime()
	if self.countDown == nil then
		return nil;
	end
	
	local num = self.countDown - (getTime() - self.getLeftTime);
	if num <= 0 then
		return 0;
	end
	return math.ceil(num);
end

function Lua_WulindahuiData:updateChallengeInfo(msg)
	self.firstMaxBlood = msg.first_total_blood;
	self.firstCurBlood = msg.first_cur_blood;
	self.firstMaxMagic = msg.first_total_magic;
	self.firstCurMagic = msg.first_cur_magic;
	
	self.secMaxBlood = msg.second_total_blood;
	self.secCurBlood = msg.second_cur_blood;
	self.secMaxMagic = msg.second_total_magic;
	self.secCurMagic = msg.second_cur_magic;
end