checkRequire("Lua_WulindahuiData");
checkRequire("Lua_WulindahuiUtil");
Lua_WulindahuiProxy = class("Lua_WulindahuiProxy");
function Lua_WulindahuiProxy:ctor()
	DataCenter.WulindahuiData = Lua_WulindahuiData.new();
	DataCenter.WulindahuiUtil = Lua_WulindahuiUtil.new();

	LuaUtil.addLuaMsg(50400301, self, self.rChallengMatchOrCancle); -- 武林大会开始/取消匹配（返回）
	LuaUtil.addLuaMsg(50400302, self, self.rGetWulinReward); -- 领取武林大会场次奖励
	LuaUtil.addLuaMsg(50400303, self, self.rWulinInfoUpdate); -- 打开武林大会界面返回
	LuaUtil.addLuaMsg(50400304, self, self.rWulinRankInfo); -- 获取武林大会排行榜数据（返回）

	LuaUtil.addLuaMsg(80400337, self, self.rWulinChallengeInfo); -- 进入武林大会信息（主动）
	LuaUtil.addLuaMsg(80400338, self, self.rWulinChallengeEnd); -- 武林大会战斗结果提示(主动)
	LuaUtil.addLuaMsg(80400339, self, self.rMatchSuccess); -- 通知客户端玩家匹配成功
	LuaUtil.addLuaMsg(80400340, self, self.rUpdateChallengeInfo); -- 武林大会双方血量
end

function Lua_WulindahuiProxy:rChallengMatchOrCancle(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400301();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rChallengMatchOrCancle", msg.type);
	end
end

function Lua_WulindahuiProxy:rGetWulinReward(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400302();
		msg:ParseFromString(mp.data);
		DataCenter.WulindahuiData.boxRewards = msg.box_index;
		Lua_MsgUtil.callFunc("rGetWulinReward");
	end
end

function Lua_WulindahuiProxy:rWulinInfoUpdate(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400303();
		msg:ParseFromString(mp.data);
		DataCenter.WulindahuiData:fromServerWulinInfo(msg);
		Lua_MsgUtil.callFunc("rWulinInfoUpdate");
	else
		DataCenter.WulindahuiData:resetWulinInfo();
		Lua_MsgUtil.callFunc("rWulinInfoUpdate");
	end
end

function Lua_WulindahuiProxy:rWulinRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50400304();
		msg:ParseFromString(mp.data);
		Lua_MsgUtil.callFunc("rWulinRankInfo", msg);
	end
end





function Lua_WulindahuiProxy:rWulinChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400337();
		msg:ParseFromString(mp.data);
		DataCenter.WulindahuiData:fromServerChallengeInfo(msg);
		Lua_MsgUtil.callFunc("rWulinChallengeInfo");
	end
end

function Lua_WulindahuiProxy:rWulinChallengeEnd(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400338();
		msg:ParseFromString(mp.data);
		Lua_WindowUtil.openWin("Lua_WulinFightingEndWindow");
		Lua_MsgUtil.callFunc("rWulinChallengeEnd", msg);
	end
end

function Lua_WulindahuiProxy:rMatchSuccess(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400339();
		msg:ParseFromString(mp.data);
		if msg.left_time > 0 then
			Lua_WindowUtil.openWin("Lua_WulinMatchCompleteCDWindow", WinParam.ACTION_OPEN, msg.left_time);
		end
		Lua_MsgUtil.callFunc("rMatchSuccess");
	end
end

function Lua_WulindahuiProxy:rUpdateChallengeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400340();
		msg:ParseFromString(mp.data);
		DataCenter.WulindahuiData:updateChallengeInfo(msg);
		Lua_MsgUtil.callFunc("rUpdateChallengeInfo");
	end
end