checkRequire("Lua_XianShiVo");
Lua_XianShiData = class("Lua_XianShiData");
function Lua_XianShiData:ctor()
	self.actListInfo = {};
	self.actState = {};
	self.hasOpenAct = false;
end

function Lua_XianShiData.Get:actsDic()
	if self._actsDic == nil then
		self._actsDic = {};
		local huodongList = getConfig({"common_activity"});
		for k, v in pairs(huodongList) do
			local vo = Lua_XianShiVo.new(k, v);
			self._actsDic[vo.id] = vo;
		end
	end

	return self._actsDic;
end

function Lua_XianShiData:dispose()
	self.actListInfo = {};
	self.actState = {};
	self.hasOpenAct = false;
	if self._actsDic ~= nil then
		for k, v in pairs(self._actsDic) do
			v.activity_state = nil;
			v.icon_bling = nil;
			v.left_time = nil;
	 		v.sub_value = nil;
			v.startTime = nil;
			v.attend = nil;
		end
	end

end

function Lua_XianShiData:getDataById(vid)
	if self.actsDic[vid] == nil then
		return nil;
	end
	return self.actsDic[vid];
end

function Lua_XianShiData:sOnSceneMsg(msgNum)--用于限时活动弹框
    sendMsg(tonumber(msgNum));
end

function Lua_XianShiData:isSteRemove(v)
	self.actListInfo = {};
end

-- 判断是否有开启的活动
function Lua_XianShiData:checkOpenActState()
	local rs = false;
	local openList = Array();
	local closeList = Array();
	if self.actsDic ~= nil then
		for k, v in pairs(self.actsDic) do 
			if v ~= nil then
				if v ~= nil 
					and v.activity_state == 2 
					and DataCenter.roleData.level >=  v.limit_level
					and tonumber(v.show) >= 0 then
					rs = true;

					local obj = {};
					obj.type = v.id + 100000;
					obj.altas = v.altas;
					obj.spriteName = v.sprite_name;
					obj.state = 1;
					obj.openAct = v.id;
					openList:add(obj);
				else
					local obj = {};
					obj.type = v.id + 100000;
					obj.state = 0;
					closeList:add(obj);
				end
			end
		end
	end

	if rs ~= self.hasOpenAct then
		self.hasOpenAct = rs;
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10008, state = rs});
	end
	Lua_MsgUtil.callFunc("MENU_TIP_UPDATE_LIST", {openList=openList, closeList=closeList});
end

function Lua_XianShiData:getActList(num)-- 1 活动大厅 0 帮派活动
	if self.actListInfo == nil then
		self.actListInfo = {};
	end

	num = tonumber(num);
	if self.actListInfo[num] ~= nil then
		return self.actListInfo[num];
	end

	self.actListInfo[num] = Array();
	local dic = self.actsDic;
	local nameDic = {};
	for k, v in pairs(dic) do
		if tonumber(v.show) >= 0 and (num == 1 or tonumber(v.show) == num) then
			if nameDic[v.name] == nil then
				nameDic[v.name] = Array();
			end
			nameDic[v.name]:add(v);
		end
	end

	local len = 0;
	for k, arr in pairs(nameDic) do
		arr:sort("id", false);
		len = arr:getSize();
		if len > 0 then
			if len > 1 then
				local str = arr[1].pShowTimeStr;
				local str1 = arr[2].pShowTimeStr;
				local state = arr[1].activity_state;
				if str ~= str1 then
					for i = 2, len do
						str = str..","..arr[i].pShowTimeStr;
					end
				else
					str = LanUtil.formateStr(LanUtil.getValue(120329),tostring(str));
				end
				if arr[1].activity_state ~= arr[2].activity_state then
					if arr[1].activity_state == 2 or arr[2].activity_state == 2 then
						state = 2;
					else
						state = 0;
					end
				end
				arr[1].pShowTime = str;
				arr[1].activity_state = state;
			end
			self.actListInfo[num]:add(arr[1]);
		end
	end

	local arr = self.actListInfo[num];
	len = arr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not self:sortFun(arr[i], arr[j]) then
                local temp = arr[i]
                arr[i] = arr[j]
                arr[j] = temp
            end
		end
	end
	return arr;
end

function Lua_XianShiData:sortFun(a, b)
	if a == nil or b == nil then
		return false;
	end

	local openA = 1; -- 0今天开 1今天不开 2等级未到
	if a.limit_level > DataCenter.roleData.level then
		openA = 2;
	elseif a.bOpenToday == true then
		openA = 0;
	end

	local openB = 1;
	if b.limit_level > DataCenter.roleData.level then
		openB = 2;
	elseif b.bOpenToday == true then
		openB = 0;
	end

	if openA > openB then
		return false;
	elseif openA == openB then
		local aState = a.activity_state; -- 0未开始1预告2活动进行3结束
		if aState == nil then
			aState = 0;
		elseif aState == 3 then
			aState = -1;
		end

		local bState = b.activity_state;
		if bState == nil then
			bState = 0;
		elseif bState == 3 then
			bState = -1;
		end

		if aState < bState then
			return false;
		elseif aState == bState then
			if a.start > b.start then
				return false;
			elseif a.start == b.start then
				if a.limit_level > b.limit_level then
					return false;
				elseif a.limit_level == b.limit_level then
					if a.id > b.id then
						return false;
					end
				end
			end
		end
	end

	return true;
end