Lua_XianShiVo = class("Lua_XianShiVo");
function Lua_XianShiVo:ctor(id, config)
	self.id = tonumber(id);
	self.config = config;
end

function Lua_XianShiVo.Get:priority()
	local a = 0;
	if DataCenter.roleData.level >= self.limit_level then
		a = 10000;
	end
	if self.config.priority == nil then
		return 0 + a;
	end
	return self.config.priority + a;
end

function Lua_XianShiVo.Get:top_right_id()
	if self.config.top_right_id == nil then
		return 0;
	end
	return self.config.top_right_id;
end

function Lua_XianShiVo.Get:show()
	if self.config.show == nil then
		return 1;
	end
	return self.config.show;
end

function Lua_XianShiVo.Get:activity_state()
	return self._activity_state;
end

function Lua_XianShiVo.Set:activity_state(val)
	self._activity_state = val;
end

function Lua_XianShiVo.Get:startDayTime()
	if self._startDayTime == nil then
		local st = self.config.start;
		local h = math.floor(st / 100);
		local m = st - h * 100;
		self._startDayTime = (h * 60 + m) * 60;
	end
	return self._startDayTime;
end

function Lua_XianShiVo.Get:endDayTime()
	if self._endDayTime == nil then
		local st = self.config.end_time;
		local h = math.floor(st / 100);
		local m = st - h * 100;
		self._endDayTime = (h * 60 + m) * 60;
	end
	return self._endDayTime;
end

function Lua_XianShiVo.Get:timeStr()
	if self._timeStr == nil then
		local st = self.config.start;
		local h = math.floor(st / 100);
		local m = st - h * 100;
		local s_str = h..":"..Lua_CommonUtil.fixNumerLen(m, 2);

		st = self.config.end_time;
		h = math.floor(st / 100);
		m = st - h * 100;
		local e_str = h..":"..Lua_CommonUtil.fixNumerLen(m, 2);

		self._timeStr = s_str.." - "..e_str;
	end
	return self._timeStr;
end

function Lua_XianShiVo.Get:startTimeStr()
	local st = self.config.start;
	local h = math.floor(st / 100);
	local m = st - h * 100;
	local s_str = h..":"..Lua_CommonUtil.fixNumerLen(m, 2);
	return s_str;
end

function Lua_XianShiVo.Get:limit_level()
	if self.config.limit_level == nil then
		return "";
	end
	return self.config.limit_level;
end

-- 说明（暂时产出）
function Lua_XianShiVo.Get:remark()
	if self.config.remark == nil then
		return "";
	end
	return self.config.remark;
end

function Lua_XianShiVo:getLeftTime()
	if self.left_time == nil or self.startTime == nil then
		return 0;
	end
	local dt = getTime() - self.startTime;
	return self.left_time - dt;
end

function Lua_XianShiVo.Get:atlas()
	if self.config.atlas == nil then
		return "";
	end
	return self.config.atlas;
end

function Lua_XianShiVo.Get:icon()
	if self.config.icon == nil then
		return "";
	end
	return self.config.icon;
end

function Lua_XianShiVo.Get:start()
	if self.config.start == nil then
		return 0;
	end
	return self.config.start;
end

function Lua_XianShiVo.Get:end_time()
	if self.config.end_time == nil then
		return 0;
	end
	return self.config.end_time;
end

function Lua_XianShiVo.Get:week()
	if self.config.week == nil then
		return {};
	end
	return self.config.week;
end

function Lua_XianShiVo.Get:redDot()--红点标识
	if self.config.redDot == nil then
		return nil;
	end
	return self.config.redDot;
end

function Lua_XianShiVo.Get:weekArr()
	if self._weekArr == nil then
		self._weekArr = Array();
		local list = self.week;
		if list ~= nil and #list > 0 then
			local len = #list;
			for i = 1, len do
				local num = tonumber(list[i]);
				if num == 0 then
					num = 7;
				end
				self._weekArr:add(num);
			end

			for i = 1, len do
	            for j = i + 1, len do
	                local a = self._weekArr[i];
	                local b = self._weekArr[j];
	                if a > b then
	                    local temp = self._weekArr[i];
	                    self._weekArr[i] = self._weekArr[j];
	                    self._weekArr[j] = temp;
	                end
	            end
	        end 
		end
	end
	return self._weekArr;
end

-- 获取开启天数描述
function Lua_XianShiVo.Get:openTimeDesc()
	if self._openTimeDesc == nil then
		local dayList = self.week;
		if dayList ~= nil and #dayList < 7 then
			self._openTimeDesc = LanUtil.getValue(42);
			local arr = Array();
			for i = 1, #dayList do
				arr:add(dayList[i]);
			end

			local len = arr:getSize();
			for i = 1, len do
	            for j = i + 1, len do
	                local a = arr[i];
	                local b = arr[j];
	                if a > b or a == 0 then
	                    local temp = arr[i];
	                    arr[i] = arr[j];
	                    arr[j] = temp;
	                end
	            end
	        end 

	        for i = 1, len do
	        	self._openTimeDesc = self._openTimeDesc..LanUtil.getValue(200 + arr[i]);
	        	if i < len then
	        		self._openTimeDesc = self._openTimeDesc.."、";
		        end
	        end
		else
			self._openTimeDesc = LanUtil.getValue(41);
		end

		local str1 = TimeTransform.getInstance():transSeconds6(self.startDayTime, true, false);
		local str2 = TimeTransform.getInstance():transSeconds6(self.endDayTime, true, false);
		self._openTimeDesc = self._openTimeDesc..str1.."-"..str2;
	end

	return self._openTimeDesc;
end

function Lua_XianShiVo.Set:pShowTime(val)
	self.showTime = val;
end

function Lua_XianShiVo.Get:pShowTime()
	if self.showTime == nil then
		return self.pShowTimeStr;
	end
	return self.showTime;
end

--开启时间描述 例如 当日开显示12:00-12:00 当日不开显示 一，二
function Lua_XianShiVo.Get:pShowTimeStr()

	if self._pShowTimeStr == nil then

		local dayList = self.week;
		if dayList == nil then
			return;
		end

		local day = os.date("%w");
		for k,v in pairs(dayList) do
			if tostring(v) == day then
				--if self.showTime == nil then 
					local str1 = TimeTransform.getInstance():transSeconds6(self.startDayTime, true, false);
					local str2 = TimeTransform.getInstance():transSeconds6(self.endDayTime, true, false);
					self._pShowTimeStr = str1.."-"..str2;
					--end
			else		
				if self._pShowTimeStr == nil then
					self._pShowTimeStr = "";
					local arr = Array();
					for i = 1, #dayList do
						arr:add(dayList[i]);
					end

					local len = arr:getSize();
					for i = 1, len do
			            for j = i + 1, len do
			                local a = arr[i];
			                local b = arr[j];
			                if a > b or a == 0 then
			                    local temp = arr[i];
			                    arr[i] = arr[j];
			                    arr[j] = temp;
			                end
			            end
			        end 

			        for i = 1, len do
			        	self._pShowTimeStr = self._pShowTimeStr..LanUtil.getValue(200 + arr[i]);
			        	if i < len then
			        		self._pShowTimeStr = self._pShowTimeStr.."、";
				    	end
				   	end
				end
		    end
		end
	end
	return self._pShowTimeStr;
end

function Lua_XianShiVo.Get:bOpenToday()
	local dayList = self.week;
	if dayList == nil or #dayList <= 0 then
		return true;
	end
	--print(os.date("%X"))
	local day = os.date("%w");
	for k,v in pairs(dayList) do
		if tostring(v) == day then
			return true;
		end
	end
	
	return false;

end

function Lua_XianShiVo.Get:limit_level()
	if self.config.limit_level == nil then
		return 0;
	end
	return self.config.limit_level;
end

function Lua_XianShiVo.Get:fun_str()
	if self.config.fun_str == nil then
		return "";
	end
	return self.config.fun_str;
end

function Lua_XianShiVo.Get:name()
	if self.config.name == nil then
		return "";
	end
	return self.config.name;
end

function Lua_XianShiVo.Get:altas()
	if self.config.altas == nil then
		return "righttop";
	end
	return self.config.altas;
end

function Lua_XianShiVo.Get:sprite_name()
	if self.config.sprite_name == nil then
		return "activity_small_tips_hddt";
	end
	return self.config.sprite_name;
end

function Lua_XianShiVo.Get:display_reward()
	if self.config.display_reward == nil then
		return {};
	end
	return self.config.display_reward;
end

function Lua_XianShiVo.Get:open_day()
	if self.config.open_day == nil then
		return 0;
	end
	return self.config.open_day;
end

function Lua_XianShiVo.Get:tips_desc()
	if self.config.tips_desc == nil then
		return "";
	end
	return self.config.tips_desc;
end

function Lua_XianShiVo.Get:scene_Msg()
	if self.config.scene_Msg == nil then
		return 0;
	end
	return self.config.scene_Msg;
end

function Lua_XianShiVo.Get:dic() --未开启活动特殊描述
	if self.config.dic == nil then
		return nil;
	end
	return self.config.dic;
end