checkRequire("Lua_XianShiData");
checkRequire("Lua_XianShiUtil");
checkRequire("Lua_AllRightTopData");
checkRequire("Lua_AllMenuIconData");
Lua_XianShiProxy = class("Lua_XianShiProxy");
function Lua_XianShiProxy:ctor()
	self:superCall("ctor");
	DataCenter.xianshiData = Lua_XianShiData.new();
	DataCenter.xianshiUtil = Lua_XianShiUtil.new();
	DataCenter.allRtData = Lua_AllRightTopData.new();
	DataCenter.menuIconData = Lua_AllMenuIconData.new();
	LuaUtil.addLuaMsg(81401201, self, self.rActStateInfo);  -- 主动通知活动状态

	Lua_MsgUtil.addEventListener("ADD_RIGHTTOP_ICON", self, self.onAddRightTopIcon);
	Lua_MsgUtil.addEventListener("REMOVE_RIGHTTOP_ICON", self, self.onRemoveRightTopIcon);
	Lua_MsgUtil.addEventListener("UPDATE_RTICON_SHOWTIME", self, self.onUpdateRTIconShowTime);
end
function Lua_XianShiProxy:checkShowCurActivity(oldActId, newActId)
	if oldActId == newActId then
		return true;
	end
	
	local oldVo = DataCenter.xianshiData:getDataById(oldActId);
	local newVo = DataCenter.xianshiData:getDataById(newActId);
	if newVo == nil then
		return false;
	end

	if oldVo == nil or oldVo.top_right_id ~= newVo.top_right_id then
		return true;
	end

	if oldVo.activity_state ~= newVo.activity_state then
		if oldVo.activity_state == 1 then
			if newVo.activity_state == 2 and newVo.attend ~= 1 then
				return true;
			else
				return false;
			end
		elseif oldVo.activity_state == 2 then
			if oldVo.attend == 1 then
				if newVo.activity_state == 1 then
					return true;
				else
					return false;
				end
			else
				return false;
			end
		else
			return true;
		end
	else
		if newVo.activity_state == 2 and newVo.attend == 1 then -- 已开始已参加
			return false;
		else
			return true;
		end
	end
end

-- 主动通知活动状态
function Lua_XianShiProxy:rActStateInfo(mp)
	--print("主动通知活动状态")
	if DataCenter.configLoaded ~= 1 then
		return;
	end
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto81401201();
		msg:ParseFromString(mp.data);
		local xianshiData = DataCenter.xianshiData;
		xianshiData:isSteRemove(false);
		local newActList = Array();
		if msg.activity_info ~= nil then
			for i,v in ipairs(msg.activity_info) do
				local vo = xianshiData:getDataById(v.activity_id);
				if vo ~= nil then	
					vo.activity_state = v.activity_state;
					vo.icon_bling = v.icon_bling;
					vo.left_time = v.left_time;
			 		vo.sub_value = v.sub_value;
					vo.startTime = getTime();
					vo.attend = v.attend; -- 是否参加过该次活动，0未参加，1已参加

					if v.activity_state == 2 and (xianshiData.actState[v.activity_id] ~= nil and xianshiData.actState[v.activity_id] ~= 2) then
						newActList:add(v.activity_id);
					end
					xianshiData.actState[v.activity_id] = v.activity_state;
					if vo.top_right_id ~= 0 then
						local rt = DataCenter.allRtData.topRightIconDic[vo.top_right_id];
						if rt ~= nil then
							if rt.act_id == nil or self:checkShowCurActivity(rt.act_id, v.activity_id) == true then
								rt.act_id = v.activity_id;
							end
						end
					end
				end

				if v.activity_id == DataCenter.poolPartyData.activity_id then
			        DataCenter.redDotData:updateRedDotVoState(22055, v.activity_state == 2); -- 泳池派对登录红点
			    end
			end
		end
		
		xianshiData:checkOpenActState();
		Lua_MsgUtil.callFunc("ACT_STATE_CHANGE");
		Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS");
		local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId)

		if newActList:getSize() > 0 and sceneConfig.no_act_tip == 0 then
			if (newActList[1] == 10002 or newActList[1] == 10003) and DataCenter.yunBiaoData.escortTimes == 0 then
				return;--运镖弹出前判断次数
			end
			Lua_WindowUtil.openWin("Lua_ActiveTipWindow", nil, newActList[1]);
		end
	end
end

function Lua_XianShiProxy:onAddRightTopIcon(iconId)
	local rt = DataCenter.allRtData.topRightIconDic[iconId];
	if rt ~= nil then
		if rt.act_id == nil or rt.act_id == -1 then
			rt.act_id = 0;
		end 
		rt:setState(true);
		Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS", false);
	end
end

function Lua_XianShiProxy:onRemoveRightTopIcon(iconId)
	local rt = DataCenter.allRtData.topRightIconDic[iconId];
	if rt ~= nil then
		rt:setState(false);
		Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS", false);
	end
end

-- {iconId = 10010, showTime = 100}
function Lua_XianShiProxy:onUpdateRTIconShowTime(obj)
	if DataCenter.configLoaded ~= 1 then
		return;
	end
	local rt = DataCenter.allRtData.topRightIconDic[obj.iconId];
	if rt ~= nil then
		if obj.showStr ~= nil then
			rt.showOpenStr = obj.showStr;
		end
		if obj.isShoWBule ~= nil then
			rt.isShoWBule = obj.isShoWBule;--是否时间显示绿色色值
		else
			rt.isShoWBule = nil;
		end
		rt.showCountTime = obj.showTime;
		Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS", false);
	end
end