Lua_YunBiaoData = class("Lua_YunBiaoData");
function Lua_YunBiaoData:ctor()
	self._config = nil;
	self.carId = 0;
	self.stage = 0;

	Lua_MsgUtil.addEventListener("SCENE_CHANGE", self, function() self.carId = 0; end);
end

function Lua_YunBiaoData:dispose()
	self.carId = 0;
	self.stage = 0;
	self.escortTimes = nil;
end

function Lua_YunBiaoData:sGetPanelInfo()
	sendMsg(10401523);
end

function Lua_YunBiaoData:sUseToken()
	sendMsg(10401524);
end

function Lua_YunBiaoData:sStartYunBiao(type)
	local cmd = ProtoPublic_pb.Proto10401522();
	cmd.type = type;
	sendMsg(10401522,cmd);
end

function Lua_YunBiaoData:sStopYunBiao(stage)
	local cmd = ProtoPublic_pb.Proto10401525();
	cmd.stage = stage;
	sendMsg(10401525,cmd);
end

function Lua_YunBiaoData:fromServer50401523(data)
	self.escortTimes = data.escort_times;
	self.curLevel = data.cur_level;
	self.freeRefresh = data.free_refresh;
end

function Lua_YunBiaoData:useToken(data)
	self.status = data.status;
	-- self.curLevel = data.cur_level;
end

function Lua_YunBiaoData:startYunBiao(data)
	-- self.isOngoing = true;
end

function Lua_YunBiaoData:stopYunBiao(data)
	self.settlementData = {};
	self.settlementData.leftTimes = data.left_times;
	self.escortTimes = data.left_times;
	self.settlementData.stage = data.stage;
	self.settlementData.percent = data.percent;
	self.settlementData.reward = Array();
	self.settlementData.reward:add(Lua_ToolVo.new(209000006, data.exp));
	self.settlementData.reward:add(Lua_ToolVo.new(209000001, data.money));

	-- if(data.stage==0) then
	-- 	self.carId = 0;
	-- end
end

function Lua_YunBiaoData:openStopYunBiaoWin(data)
	self.stage = data;
	if self.isOngoing then
		Lua_WindowUtil.openWin("Lua_StopYunBiaoWindow", WinParam.ACTION_OPEN, self.stage);
		-- Lua_WindowUtil.openWin("Lua_SettlementWindow", WinParam.ACTION_OPEN);
	end
end

-- function Lua_YunBiaoData:openFinishYunBiaoWin(obj)
-- 	if self.isOngoing then
-- 		Lua_WindowUtil.openWin("Lua_FinishYunBiaoWindow", WinParam.ACTION_OPEN);
-- 		-- Lua_WindowUtil.openWin("Lua_SettlementWindow", WinParam.ACTION_OPEN);
-- 	else
-- 		DataCenter.taskData:showNpcTalkWindow(tonumber(obj));
-- 	end
-- end

function Lua_YunBiaoData:rYunBiaoInfo(msg)
	-- print("rYunBiaoInfo", msg.beast_id);
	self.carId = msg.beast_id;
	self.curLevel = tonumber(string.sub(tostring(msg.beast_sort), 9));
	self:updateTaskState();
end

function Lua_YunBiaoData:rCarDisappear(msg)
	-- print("rCarDisappear:", self.carId);
	if self.carId == 0 then
		return;
	end

	if self.carId == msg.mover_id then
		self.carId = 0;
		self:updateTaskState();
	end
end

function Lua_YunBiaoData:updateTaskState(val)
	if self.taskArr == nil then
		return;
	end

	-- print("updateTaskState:", self.carId);
	if self.carId == 0 then
		if self.curLevel ~= 0 and self.curLevel ~= nil then
			DataCenter.taskData:removeTask(8, self.taskArr[self.curLevel].id);
			if val ~= false then
				Lua_MsgUtil.callFunc("TASK_UPDATE");
			end
		end
		PlayerData.getInstance().data.escort_id = 0;
		self.taskVo = nil;
	else
		local tvo = Lua_TaskVo.new(self.taskArr[self.curLevel].id, 8);
		tvo.status = 3;
		tvo.condList = Array();
		DataCenter.taskData:addTask(tvo);

		self.taskVo = tvo;
		if val ~= false then
			Lua_MsgUtil.callFunc("TASK_UPDATE");
		end
	end
	self:updateChatMiniCarIcon();
end

function Lua_YunBiaoData.Get:config()
	if self._config == nil then
		self._config = getConfig({"convoy_const"});
	end
	return self._config;
end

function Lua_YunBiaoData:getYunBiaoLvlInfo(data)
	local rewardExp = getConfig({"lvl_reward", DataCenter.roleData.level, "escort_exp"});
	local rewardMoney = self.config.reward_money.arr;
	local rewardCount = self.config.cost_count.arr;
	local data;
	local modelInfo;
	local modelIdList = self.config.car_list.arr;
	local dataList = Array();
	local titleList = string.split(LanUtil.getValue(122101), ",");
	for i = 1, #rewardExp do
		data = {};
		data.lvl = i;
		data.title = titleList[i];
		data.rewardExp = rewardExp[i];
		data.rewardMoney = rewardMoney[i];
		data.needCount = rewardCount[i]
		data.costId = self.config.item.value;
		data.costInfo = getConfig({"item", data.costId});
		data.modelInfo = getConfig({"playerHanger", modelIdList[i]});
		dataList:add(data);
	end
	return dataList;
end

function Lua_YunBiaoData.Get:tokenNum()
	return DataCenter.packData:getBagType(2):getItemNum(self.config.item.value);
end

function Lua_YunBiaoData.Get:effectInfo()
	return self.config.select_effect.arr;
end

function Lua_YunBiaoData.Get:doubleExpTime()
	local eventHallConfig1 = getConfig({"common_activity", 10002});
	local time1 = Array();
	time1:add(self:getTimeStr(eventHallConfig1.start));
	time1:add(self:getTimeStr(eventHallConfig1.end_time));

	local eventHallConfig2 = getConfig({"common_activity", 10003});
	local time2 = Array();
	time2:add(self:getTimeStr(eventHallConfig2.start));
	time2:add(self:getTimeStr(eventHallConfig2.end_time));

	local time = Array();
	time:add(time1);
	time:add(time2);
	return time;
end

function Lua_YunBiaoData:getTimeStr(time)
	local str = tostring(time);
	local h = string.sub(str, 1, 2);
	local m = string.sub(str, 3, 4);
	return h .. ":" .. m;
end

function Lua_YunBiaoData:getNpcInfo(index)
	local info = {};
	if index == 0 then
		info.npcId = self.config.npc.value;
		info.sceneId = self.config.scene.value;
	elseif index == 1 then
		info.npcId = self.config.first_npc.value;
		info.sceneId = self.config.scene.value;
	elseif index == 2 then
		info.npcId = self.config.second_npc.value;
		info.sceneId = self.config.second_scene.value;
	else
		return nil;
	end

	local pos;
	local npcList = getConfig({"scene", info.sceneId, "npc"});
	for k,v in ipairs(npcList) do
		if v.id == info.npcId then
			pos = Array();
			pos:add(v.posX);
			pos:add(v.posY);
			pos:add(v.posZ);
			info.pos = pos;
		end
	end
	return info;
end

function Lua_YunBiaoData:getRewardRatio(index)
	local ratio = 0;
	-- if(index==1) then
	-- 	ratio = self.config.first_npc.arr;
	-- elseif(index==2) then
	-- 	ratio = self.config.second_npc.arr;
	-- end
	-- ratio = ratio / 100;
	ratio = 100;
	return ratio;
end

function Lua_YunBiaoData.Get:countDown()
	return self.config.count_down.value;
end

function Lua_YunBiaoData.Get:taskConfig()
	if self._taskConfig == nil then
		self._taskConfig = getConfig({"task_car"});
	end
	return self._taskConfig;
end

function Lua_YunBiaoData.Get:taskArr()
	if self._taskArr == nil then
		self._taskArr = Array();

		for k,v in pairs(self.taskConfig) do
			self._taskArr:add({id = k});
		end
		self._taskArr:sort("id", false);
	end
	return self._taskArr;
end

function Lua_YunBiaoData.Get:isOngoing()
	return self.carId ~= 0 and true or false;
end

function Lua_YunBiaoData:updateChatMiniCarIcon()
	if self.isOngoing then
		local msg = {};
		msg.type = Lua_MenuTipData.CAR_ICON;
		msg.altas = "icon_atlas_5";
		msg.spriteName = "activity_small_tips_qg";
		msg.state = 1;
		-- msg.fairyInfo = {fairyVo = DataCenter.fairyData.fairyList[equipedfairyItem.fairyVo.index]};
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", msg);
	else
		Lua_MsgUtil.callFunc("MENU_TIP_UPDATE", {type = Lua_MenuTipData.CAR_ICON, state = 0});
	end
end