checkRequire("Lua_YunBiaoData");
Lua_YunBiaoProxy = class("Lua_YunBiaoProxy", Lua_EventOwner);
function Lua_YunBiaoProxy:ctor()
	self:superCall("ctor");
	DataCenter.yunBiaoData = Lua_YunBiaoData.new();

	LuaUtil.addLuaMsg(80400103, self, self.rYunBiaoInfo); -- 宠物出现
	LuaUtil.addLuaMsg(80400104, self, self.rThingDisappear); -- 移动物体退出场景通知
	LuaUtil.addLuaMsg(50400110, self, self.yunBiaoTransferFinishedType2); -- 切换场景请求（返回）
	LuaUtil.addLuaMsg(50400203, self, self.rPlayerRevive); -- 请求复活（返回）
	LuaUtil.addLuaMsg(80400321, self, self.onYunBiaoEnd); -- 退出运镖状态
	LuaUtil.addLuaMsg(50401522, self, self.rStartYunBiao); -- 开启运镖（返回）
	LuaUtil.addLuaMsg(50401523, self, self.rGetPanelInfo); -- 打开运镖界面（返回）
	LuaUtil.addLuaMsg(50401524, self, self.rUseToken); -- 升级运镖品质（返回）
	LuaUtil.addLuaMsg(50401525, self, self.rStopYunBiao); -- 运镖结束（返回）

	Lua_MsgUtil.addEventListener("YUN_BIAO_STAGE_ONE", self, self.yunBiaoStageOne);
	Lua_MsgUtil.addEventListener("YUN_BIAO_STAGE_TWO", self, self.yunBiaoStageTwo);
	Lua_MsgUtil.addEventListener("GO_YUN_BIAO", self, self.goYunBiao);
	Lua_MsgUtil.addEventListener("START_YUN_BIAO", self, self.openYunBiaoWin);
	self:addCSharpEvent("INIT_SCENE_CONFIG_OBJECT", self, self.yunBiaoTransferFinishedType1);
end

function Lua_YunBiaoProxy:rYunBiaoInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400103();
		msg:ParseFromString(mp.data);
		if msg.type == 1 and tonumber(msg.master_id) == tonumber(DataCenter.roleData.roleId) then
			DataCenter.yunBiaoData:rYunBiaoInfo(msg);
		end
	end
end

function Lua_YunBiaoProxy:rThingDisappear(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400104();
		msg:ParseFromString(mp.data);
		DataCenter.yunBiaoData:rCarDisappear(msg);
	end
end

function Lua_YunBiaoProxy:yunBiaoTransferFinishedType2()
	if self.transferType ~= 2 then
		return;
	end
	self.transferType = 0;
	Lua_CommonUtil.delayCall(0.2, self, self.moveToNpc, 0);
end

function Lua_YunBiaoProxy:rPlayerRevive(mp)
	if mp.errno == 0 then
		if DataCenter.yunBiaoData.isOngoing then
			Lua_CommonUtil.delayCall(1, self, self.moveToNpc, 2);
		end
	end
end

function Lua_YunBiaoProxy:onYunBiaoEnd(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80400321();
		msg:ParseFromString(mp.data);
		if msg.type == 1 then
			DataCenter.yunBiaoData.carId = 0;
			DataCenter.yunBiaoData:updateTaskState();
		end
	end
end

function Lua_YunBiaoProxy:rStartYunBiao(mp)
	if mp.errno == 0 then
		Lua_WindowUtil.openWin("Lua_YunBiaoWindow", WinParam.ACTION_CLOSE);
		self:moveToNpc(2);
	end
end

function Lua_YunBiaoProxy:rGetPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50401523();
		msg:ParseFromString(mp.data);
		DataCenter.yunBiaoData:fromServer50401523(msg);
		Lua_MsgUtil.callFunc("YUN_BIAO_PANEL_UPDATE");
	end
end

function Lua_YunBiaoProxy:rUseToken(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50401524();
		msg:ParseFromString(mp.data);
		DataCenter.yunBiaoData:useToken(msg);
	end
end

function Lua_YunBiaoProxy:rStopYunBiao(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto50401525();
		msg:ParseFromString(mp.data);
		DataCenter.yunBiaoData:stopYunBiao(msg);
		Lua_MsgUtil.callFunc("FINISH_YUNBIAO_PANEL_UPDATE");
		-- if msg.stage == 1 then
		-- 	Lua_MsgUtil.callFunc("FINISH_YUNBIAO_PANEL_UPDATE");
		-- elseif msg.stage == 2 then
		-- 	Lua_MsgUtil.callFunc("SETTLEMENT_PANEL_UPDATE");
		-- end
		-- Lua_WindowUtil.openWin("Lua_FinishYunBiaoWindow", WinParam.ACTION_CLOSE);
		-- Lua_WindowUtil.openWin("Lua_SettlementWindow", WinParam.ACTION_OPEN);
	end
end





function Lua_YunBiaoProxy:yunBiaoStageOne()
	DataCenter.yunBiaoData:openStopYunBiaoWin(1);
end

function Lua_YunBiaoProxy:yunBiaoStageTwo(obj)
	-- DataCenter.yunBiaoData:openFinishYunBiaoWin(obj);
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local npcData = sceneData:findNpcById(tonumber(obj));
	if DataCenter.yunBiaoData.isOngoing then
		Lua_WindowUtil.openWin("Lua_FinishYunBiaoWindow", WinParam.ACTION_OPEN, {npc = npcData, taskVo = DataCenter.yunBiaoData.taskVo});
		-- Lua_WindowUtil.openWin("Lua_NpcTaskWindow", WinParam.ACTION_OPEN, {npc = npcData, taskVo = self.taskVo});
		-- Lua_WindowUtil.openWin("Lua_SettlementWindow", WinParam.ACTION_OPEN);
	else
		DataCenter.taskData:showNpcTalkWindow(npcData, tonumber(obj));
	end
end

function Lua_YunBiaoProxy:goYunBiao()
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneData.copy_type == 34 then
		OperateAlert.show(LanUtil.getValue(122258));
		return;
	end

	local npc =  DataCenter.yunBiaoData:getNpcInfo(0);
	local transPos = npc.pos; -- getConfig({"scene", npc.sceneId, "fixed_pos"});
	if DataCenter.roleData.sceneId ~= npc.sceneId and transPos~=nil then
		self.transferType = 1;
		Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(npc.sceneId, transPos[1]-100,transPos[2], transPos[3], 0);
	else
		-- self:moveToNpc(0);
		self.transferType = 2;
		Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(npc.sceneId, transPos[1]-100,transPos[2], transPos[3], 0);
		-- Lua_CommonUtil.delayCall(0.2, self, self.moveToNpc, 0);
	end
end

function Lua_YunBiaoProxy:openYunBiaoWin(obj)
	local sceneData = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local npcData = sceneData:findNpcById(tonumber(obj));
	local isFuncOpened = DataCenter.funcOpenData:isOpened(10058);
	if isFuncOpened then
		Lua_WindowUtil.openWin("Lua_YunBiaoWindow", WinParam.ACTION_OPEN);
	else
		DataCenter.taskData:showNpcTalkWindow(npcData, tonumber(obj));
	end
end

function Lua_YunBiaoProxy:yunBiaoTransferFinishedType1()
	if self.transferType ~= 1 then
		return;
	end
	self.transferType = 0;
	Lua_CommonUtil.delayCall(0.2, self, self.moveToNpc, 0);
end

function Lua_YunBiaoProxy:moveToNpc(index)
	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end
	local npc =  DataCenter.yunBiaoData:getNpcInfo(index);
	WorldMapUtil.moveTo(npc.sceneId, npc.pos[1], npc.pos[2], npc.pos[3], npc.npcId, 7, nil, 0);
end