Lua_ZodiacData = class("Lua_ZodiacData");
function Lua_ZodiacData:ctor()
    self:superCall("ctor");

    self:dispose();
end

function Lua_ZodiacData:dispose()
	self.selectMainIndex = 1; -- 主标签索引
	self.selectZodiacId = 1; -- 选择的生肖ID
	self.selectHolePart = 1; -- 强化选择的孔位
	self.packSelectColor = 1; -- 分解选择的品质
	self.packSelectOrder = 1; -- 分解选择的星级
	self.skillCount = 0; -- 已使用技能数
	self.skillTotal = 0; -- 可使用技能总数
	self.extendSkillLevel = 0; -- 技能扩展等级
	self.intensifyCostCount = 0; -- 强化需要的材料总数
	self._zodiacPowerArr = nil;

	DataCenter.zodiacUtil:resetZodiacInfo();
	DataCenter.zodiacUtil:resetZodiacSkill();
end

-- 所有生肖数据
function Lua_ZodiacData:fromServer51404601(msg)
	if msg == nil then
		return;
	end

	local arr = self.zodiacPowerArr;
	for i,v in ipairs(msg.zodiacs) do
		DataCenter.zodiacUtil:updateZodiacInfo(v);

		if arr[v.index] ~= nil then
			arr[v.index].value = v.power;
		end
	end

	self.skillCount = msg.skill_count;
    self.skillTotal = msg.skill_total;
    self.intensifyCostCount = msg.material_amount;
   	self.extendSkillLevel = msg.expand_level;
end

-- 装备升阶数据
function Lua_ZodiacData:fromServer51404608(msg)
	if msg == nil then
		return;
	end

	self.beforeItem = msg.before_item; -- 升阶前装备
	self.afterItem = msg.after_item; -- 升阶后装备
end

-- 所有生肖之力
function Lua_ZodiacData.Get:zodiacPowerArr()
	if self._zodiacPowerArr == nil then
		self._zodiacPowerArr = Array()
		for i,v in ipairs(Lua_ThingDefine.zodiacParams) do
			self._zodiacPowerArr:add({ name = Lua_ThingDefine.getParamName(v), value = 0 });
		end
	end
	return self._zodiacPowerArr;
end

-- 升阶前
function Lua_ZodiacData.Get:beforeVo()
	if self.beforeItem == nil or self.beforeItem.id == 0 then
		return nil;
	end
	local item = self.beforeItem;
	local vo = Lua_ToolVo.createToolVo(item.id, item.amount, item.bind);
	vo:fromServer(item);
	return vo;
end

-- 升阶后
function Lua_ZodiacData.Get:afterVo()
	if self.afterItem == nil or self.afterItem.id == 0 then
		return nil;
	end
	local item = self.afterItem;
	local vo = Lua_ToolVo.createToolVo(item.id, item.amount, item.bind);
	vo:fromServer(item);
	return vo;
end

-- 子标签索引
function Lua_ZodiacData.Get:selectSubIndex()
	if self.selectZodiacId == nil then
		return 1;
	end
	local dic = DataCenter.zodiacUtil.zodiacDic;
	for k, arr in pairs(dic) do
		if k == self.selectMainIndex then
			for i = 1, arr:getSize() do
				if arr[i].id == self.selectZodiacId then
					return i;
				end
			end
		end
	end
	return 1;
end

-- 技能使用是否未达上限
function Lua_ZodiacData.Get:skillHaveUse()
	if self.skillCount < self.skillTotal then
		return true;
	end
	return false;
end