checkRequire("Lua_ZodiacUtil");
checkRequire("Lua_ZodiacData");
Lua_ZodiacProxy = class("Lua_ZodiacProxy");
function Lua_ZodiacProxy:ctor()
	self:superCall("ctor");
	DataCenter.zodiacUtil = Lua_ZodiacUtil.new();
    DataCenter.zodiacData = Lua_ZodiacData.new();

    LuaUtil.addLuaMsg(51404601, self, self.rZodiacInfo); -- 生肖数据（返回）
    LuaUtil.addLuaMsg(51404606, self, self.rResolveEquip); -- 装备分解（返回）
    LuaUtil.addLuaMsg(51404608, self, self.rUpgradeEquip); -- 装备升阶（返回）
end

-- 生肖数据
function Lua_ZodiacProxy:sZodiacInfo()
    sendMsg(11404601);
end

-- 使用技能
function Lua_ZodiacProxy:sUseZodiacSkill(zodiacIndex, isUse)
    local cmd = ProtoPublic_pb.Proto11404602();
    cmd.zodiac_index = zodiacIndex; -- 生肖索引
    cmd.is_active = isUse; -- 是否使用技能
    sendMsg(11404602, cmd);
end

-- 穿装备
function Lua_ZodiacProxy:sWearEquip(zodiacIndex, packIndex)
    local cmd = ProtoPublic_pb.Proto11404603();
    cmd.zodiac_index = zodiacIndex; -- 生肖索引
    cmd.pack_index = packIndex; -- 背包索引
    sendMsg(11404603, cmd);
end

-- 卸装备
function Lua_ZodiacProxy:sDropEquip(zodiacIndex, partIndex)
    local cmd = ProtoPublic_pb.Proto11404604();
    cmd.zodiac_index = zodiacIndex; -- 生肖索引
    cmd.part_index = partIndex; -- 装备部位索引
    sendMsg(11404604, cmd);
end

-- 装备强化
function Lua_ZodiacProxy:sIntensifyEquip(zodiacIndex, partIndex)
    local cmd = ProtoPublic_pb.Proto11404605();
    cmd.zodiac_index = zodiacIndex; -- 生肖索引
    cmd.part_index = partIndex; -- 装备部位索引
    sendMsg(11404605, cmd);
end

-- 装备分解
function Lua_ZodiacProxy:sResolveEquip(arr)
    local cmd = ProtoPublic_pb.Proto11404606();
    for i = 1, arr:getSize() do
        cmd.item_list:append(arr[i].index);
    end
    sendMsg(11404606, cmd);
end

-- 扩展技能
function Lua_ZodiacProxy:sSkillExtend()
    sendMsg(11404607);
end

-- 装备升阶
function Lua_ZodiacProxy:sUpgradeEquip(zodiacIndex, partIndex, infoType)
    local cmd = ProtoPublic_pb.Proto11404608();
    cmd.zodiac_index = zodiacIndex; -- 生肖索引
    cmd.part_index = partIndex; -- 装备部位索引
    cmd.info_type = infoType; -- 0获取界面 1升阶
    sendMsg(11404608, cmd);
end

-- 生肖面板（返回）
function Lua_ZodiacProxy:rZodiacInfo(mp)
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto51404601();
        msg:ParseFromString(mp.data);
        DataCenter.zodiacData:fromServer51404601(msg);
        Lua_MsgUtil.callFunc("UPDATE_ALL_ZODIAC");
    end
end

-- 装备分解（返回）
function Lua_ZodiacProxy:rResolveEquip(mp)
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto51404606();
        msg:ParseFromString(mp.data);
        DataCenter.zodiacData.intensifyCostCount = msg.material_amount; -- 分解后获得的强化材料数量
        Lua_MsgUtil.callFunc("UPDATE_ALL_ZODIAC");
    end
end

-- 装备升阶（返回）
function Lua_ZodiacProxy:rUpgradeEquip(mp)
    if mp.errno == 0 then
    	local msg = ProtoPublic_pb.Proto51404608();
        msg:ParseFromString(mp.data);
        DataCenter.zodiacData:fromServer51404608(msg);
        Lua_MsgUtil.callFunc("ZODIAC_EQUIP_UPGRADE");
    end
end