Lua_FightUtil = {};
Lua_FightUtil.BLOOD_MAX					= 2001; -- 血量上限
Lua_FightUtil.MAGIC_MAX					= 2002; -- 魔法上限
Lua_FightUtil.HIT						= 2003; -- 命中
Lua_FightUtil.AVOID						= 2004; -- 闪避
Lua_FightUtil.CRIT						= 2005; -- 暴击
Lua_FightUtil.TOUGHNESS					= 2006; -- 韧性
Lua_FightUtil.ATTACK					= 2008; -- 攻击
Lua_FightUtil.DEFENCE					= 2009; -- 防御
Lua_FightUtil.DAMAGE					= 2010; -- 伤害加成数值
Lua_FightUtil.REDUCTION					= 2011; -- 伤害减免数值
Lua_FightUtil.ATTACK_UPPER				= 2012; -- 攻击上限
Lua_FightUtil.ATTACK_LOWER				= 2013; -- 攻击下限
Lua_FightUtil.DEFENCE_UPPER				= 2014; -- 防御上限
Lua_FightUtil.DEFENCE_LOWER				= 2015; -- 防御下限

Lua_FightUtil.HEART_RATE  				= 2016; -- 回心率
Lua_FightUtil.REDUCE_DEFENCE			= 2017; -- 减甲
Lua_FightUtil.FELEMENT_DEFENCE			= 2018; -- 五行伤害
Lua_FightUtil.FELEMENT_ATTACK			= 2019; -- 五行防御
Lua_FightUtil.IGNORE_DEFENCE_PER		= 2020; -- 无视护甲
Lua_FightUtil.REDUCE_CONTRAL_RATE		= 2021; -- 控制抵抗
Lua_FightUtil.ATTACK_BLOOD_RATE			= 2022; -- 攻击回血
Lua_FightUtil.REVERSE_RATE				= 2023; -- 反伤概率
Lua_FightUtil.SKILL_HURT_VAL			= 2024; -- 技能伤害
Lua_FightUtil.REAL_HURT_VAL				= 2025; -- 真实伤害
Lua_FightUtil.BLOCK_HURT_RATE			= 2026; -- 格挡概率
Lua_FightUtil.THUMP_RATE				= 2027; -- 重击概率
Lua_FightUtil.DOUBLE_HIT_RATE			= 2028; -- 连击几率
Lua_FightUtil.PVP_DAMAGE_PER			= 2029; -- 玩家加成
Lua_FightUtil.PVP_REDUCE_PER			= 2030; -- 玩家减免
Lua_FightUtil.BEAST_HURT_PER			= 2031; -- 宠物加成
Lua_FightUtil.BEAST_HURT				= 2032; -- 宠物攻击
Lua_FightUtil.SKILL_ADD					= 2129; -- 技能加成
Lua_FightUtil.REDUCE_DEFENCE_MULTI		= 2144;

Lua_FightUtil.EQUIP_BLOOD				= 2122; -- 装备生命百分比
Lua_FightUtil.EQUIP_ATTACK				= 2123; -- 装备攻击百分比
Lua_FightUtil.EQUIP_DEFENCE				= 2124; -- 装备防御百分比
Lua_FightUtil.BASE_BLOOD				= 2125; -- 基础生命百分比
Lua_FightUtil.BASE_ATTACK				= 2126; -- 基础攻击百分比
Lua_FightUtil.BASE_DEFENCE				= 2127; -- 基础防御百分比

Lua_FightUtil.LEVEL_WITH_ATTACK			= 12008; -- 每{1}级攻击增加1
Lua_FightUtil.LEVEL_WITH_DEF			= 12009; -- 每{1}级防御增加1
Lua_FightUtil.LEVEL_WITH_HIT			= 12003; -- 每{1}级命中增加1
Lua_FightUtil.LEVEL_WITH_AVOID			= 12004; -- 每{1}级闪避增加1
Lua_FightUtil.LEVEL_WITH_BLOOD			= 22001; -- 每1级生命增加

Lua_FightUtil.BLOOD						= 2101; -- 增加血量
Lua_FightUtil.MAGIC						= 2102; -- 增加魔法
Lua_FightUtil.HIT_MULTI					= 2103; -- 命中倍数
Lua_FightUtil.AVOID_MULTI				= 2104; -- 闪避倍数
Lua_FightUtil.CRIT_HURT_MULTI			= 2105; -- 暴击伤害倍数
Lua_FightUtil.TOUGHNESS_MULTI			= 2106; -- 韧性倍数
Lua_FightUtil.BLOOD_MULTI				= 2108; -- 血倍数
Lua_FightUtil.MAGIC_MULTI				= 2109; -- 魔法倍数
Lua_FightUtil.ATTACK_MULTI				= 2110; -- 攻击倍数
Lua_FightUtil.DEFENCE_MULTI				= 2111; -- 防御倍数
Lua_FightUtil.DAMAGE_MULTI				= 2112; -- 伤害加成万分比
Lua_FightUtil.REDUCTION_MULTI			= 2113; -- 伤害减免万分比
Lua_FightUtil.ATTACK_UPPER_MULTI		= 2114; -- 攻击上限倍数
Lua_FightUtil.ATTACK_LOWER_MULTI		= 2115; -- 攻击下限倍数
Lua_FightUtil.DEFENCE_UPPER_MULTI		= 2116; -- 防御上限倍数
Lua_FightUtil.DEFENCE_LOWER_MULTI		= 2117; -- 防御下限倍数
Lua_FightUtil.CRIT_VALUE_MULTI			= 2118; -- 暴击值倍数
Lua_FightUtil.EXTRA_CRIT_PER			= 2134; -- 额外暴击率
Lua_FightUtil.CRIT_HURT_REDUCE_MULTI	= 2120; -- 暴击伤害减免倍数
Lua_FightUtil.EXP_MULTI					= 2121; -- 经验加成万分比
Lua_FightUtil.EXTRA_TOUGHNESS_RATE		= 2141; -- 额外韧性率
Lua_FightUtil.ABSOLUTELY_ATTACK			= 2145;
Lua_FightUtil.ABSOLUTELY_DEFENCE		= 2146;

Lua_FightUtil.FELEMENT_ATTACK_MULTI		= 2142; -- 五行伤害加成百分比
Lua_FightUtil.FELEMENT_DEFENCE_MULTI	= 2143; -- 五行防御加成百分比
Lua_FightUtil.SKILL_REDUCTION_MULTI		= 2154; -- 技能减伤百分比

Lua_FightUtil.BLOOD_MAX_STR               = "blood"; -- 血量上限
Lua_FightUtil.BLOOD_MAX_STR2              = "health"; -- 血量上限
Lua_FightUtil.MAGIC_MAX_STR               = "magic"; -- 魔法上限
Lua_FightUtil.HIT_STR                     = "hit"; -- 命中
Lua_FightUtil.AVOID_STR                   = "dodge"; -- 闪避
Lua_FightUtil.AVOID_STR2                  = "avoid"; -- 闪避
Lua_FightUtil.CRIT_STR                    = "crit"; -- 暴击
Lua_FightUtil.TOUGHNESS_STR	              = "toughness"; -- 韧性
Lua_FightUtil.ATTACK_STR                  = "attack"; -- 攻击
Lua_FightUtil.DEFENCE_STR                 = "defence"; -- 防御
Lua_FightUtil.ATTACK_UPPER_STR            = "attack_min"; -- 攻击上限
Lua_FightUtil.ATTACK_LOWER_STR            = "attack_max"; -- 攻击下限
Lua_FightUtil.DEFENCE_UPPER_STR           = "defence_min"; -- 防御上限
Lua_FightUtil.DEFENCE_LOWER_STR           = "defence_max"; -- 防御下限
Lua_FightUtil.DAMAGE_STR                  = "damage";
Lua_FightUtil.REDUCTION_STR               = "reduction";
Lua_FightUtil.EXTRA_TOUGHNESS_RATE_STR    = "extra_toughness_rate"; -- 额外韧性率
Lua_FightUtil.FELEMENT_DEFENCE_STR        = "felement_defence"; -- 五行伤害
Lua_FightUtil.FELEMENT_ATTACK_STR         = "felement_attack"; -- 五行防御
Lua_FightUtil.FELEMENT_ATTACK_MULTI_STR   = "felement_defence_multi"; -- 五行伤害加成百分比
Lua_FightUtil.FELEMENT_DEFENCE_MULTI_STR  = "felement_attack_multi"; -- 五行防御加成百分比
Lua_FightUtil.EQUIP_BLOOD_STR             = "equip_blood"; -- 装备生命百分比
Lua_FightUtil.EQUIP_ATTACK_STR            = "equip_attack"; -- 装备攻击百分比
Lua_FightUtil.EQUIP_DEFENCE_STR           = "equip_defence"; -- 装备防御百分比
Lua_FightUtil.BASE_BLOOD_STR              = "base_blood"; -- 基础生命百分比
Lua_FightUtil.BASE_ATTACK_STR             = "base_attack"; -- 基础攻击百分比
Lua_FightUtil.BASE_DEFENCE_STR            = "base_defence"; -- 基础防御百分比
Lua_FightUtil.ABSOLUTELY_ATTACK_STR       = "absolutely_attack";
Lua_FightUtil.ABSOLUTELY_DEFENCE_STR      = "absolutely_defence";
Lua_FightUtil.HIT_MULTI_STR               = "hit_multi";
Lua_FightUtil.AVOID_MULTI_STR             = "avoid_multi";
Lua_FightUtil.SKILL_HURT_MULTI            = "skill_hurt_multi"; -- 技能伤害
Lua_FightUtil.SKILL_MULTI_STR             = "damage_multi"; -- 伤害加成
Lua_FightUtil.BLOCK                       = "block"; -- 格挡概率
Lua_FightUtil.REDUCE_CONTRAL              = "reduce_contral"; -- 控制抵抗
Lua_FightUtil.REVERSE_HURT_PER            = "reverse_hurt_per"; -- 伤害反射
Lua_FightUtil.SKILL_REDUCTION_MULTI_STR   = "skill_reduction_multi";
Lua_FightUtil.REDUCE_DEFENCE_STR          = "reduce_defence";
Lua_FightUtil.EXTRA_CRIT_PER_STR          = "extra_crit_per";
Lua_FightUtil.CRIT_VALUE_MULTI_STR        = "crit_value_multi";
Lua_FightUtil.REDUCE_DEFENCE_MULTI_STR    = "reduce_defence_multi";
Lua_FightUtil.TOUGHNESS_MULTI_STR         = "toughness_multi"; -- 韧性加成
Lua_FightUtil.CRIT_HURT_MULTI_STR         = "crit_hurt_multi"; -- 暴击伤害倍数
Lua_FightUtil.REAL_HURT_PER               = "real_hurt_per"; -- 真实伤害
Lua_FightUtil.ATTACK_MULTI_STR            = "attack_multi"; -- 攻击加成
Lua_FightUtil.DEFENCE_MULTI_STR           = "defence_multi"; -- 防御加成
Lua_FightUtil.BLOOD_MULTI_STR             = "blood_multi"; -- 防御加成
Lua_FightUtil.PVP_DAMAGE_PER_STR          = "pvp_damage"; -- pvp_damage
Lua_FightUtil.PVP_REDUCE_PER_STR          = "pvp_reduce"; -- PVP伤害减免
Lua_FightUtil.DOUBLE_HIT_RATE_STR         = "double_hit_rate"; -- 连击几率

function Lua_FightUtil.caculateServerForce(randAttrList, a) -- 根据服务端发下来的属性计算战力
	local dic = Lua_FightUtil.transServerDic(nil, randAttrList);
	return Lua_FightUtil.caculateForce(dic, a);
end

function Lua_FightUtil.transServerDic(dic, randAttrList)
	if dic == nil then
		dic = {};
	end

	for i,v in ipairs(randAttrList) do
		if dic[v.attr_id] == nil then
			dic[v.attr_id] = 0;
		end
		dic[v.attr_id] = dic[v.attr_id] + v.value;
	end
	return dic;
end

function Lua_FightUtil.caculateServerForceArray(arr, a) -- 根据服务端发下来的属性计算战力
	local dic = {};
	local len = arr:getSize();
	for i=1,len do
		local v = arr[i];
		if dic[v.attr_id] == nil then
			dic[v.attr_id] = 0;
		end
		dic[v.attr_id] = dic[v.attr_id] + v.value;
	end
	return Lua_FightUtil.caculateForce(dic, a);
end

function Lua_FightUtil.caculateConfigForce(param, a)
	local dic = Lua_FightUtil.transConfigDic(nil, param);
	return Lua_FightUtil.caculateForce(dic,a);
end

function Lua_FightUtil.transConfigDic(dic, param)
	if dic == nil then
		dic = {};
	end
	if param[Lua_FightUtil.BLOOD_MAX_STR] ~= nil then
		dic[Lua_FightUtil.BLOOD_MAX] = param[Lua_FightUtil.BLOOD_MAX_STR];
	end
	if param[Lua_FightUtil.BLOOD_MAX_STR2] ~= nil then
		dic[Lua_FightUtil.BLOOD_MAX] = param[Lua_FightUtil.BLOOD_MAX_STR2];
	end
	if param[Lua_FightUtil.MAGIC_MAX_STR] ~= nil then
		dic[Lua_FightUtil.MAGIC_MAX] = param[Lua_FightUtil.MAGIC_MAX_STR];
	end
	if param[Lua_FightUtil.HIT_STR] ~= nil then
		dic[Lua_FightUtil.HIT] = param[Lua_FightUtil.HIT_STR];
	end
	if param[Lua_FightUtil.EXTRA_TOUGHNESS_RATE_STR] ~= nil then
		dic[Lua_FightUtil.EXTRA_TOUGHNESS_RATE] = param[Lua_FightUtil.EXTRA_TOUGHNESS_RATE_STR];
	end
	if param[Lua_FightUtil.AVOID_STR] ~= nil then
		dic[Lua_FightUtil.AVOID] = param[Lua_FightUtil.AVOID_STR];
	end
	if param[Lua_FightUtil.AVOID_STR2] ~= nil then
		dic[Lua_FightUtil.AVOID] = param[Lua_FightUtil.AVOID_STR2];
	end
	if param[Lua_FightUtil.REDUCTION_STR] ~= nil then
		dic[Lua_FightUtil.REDUCTION] = param[Lua_FightUtil.REDUCTION_STR];
	end
	if param[Lua_FightUtil.CRIT_STR] ~= nil then
		dic[Lua_FightUtil.CRIT] = param[Lua_FightUtil.CRIT_STR];
	end
	if param[Lua_FightUtil.TOUGHNESS_STR] ~= nil then
		dic[Lua_FightUtil.TOUGHNESS] = param[Lua_FightUtil.TOUGHNESS_STR];
	end
	if param[Lua_FightUtil.ATTACK_STR] ~= nil then
		dic[Lua_FightUtil.ATTACK] = param[Lua_FightUtil.ATTACK_STR];
	end
	if param[Lua_FightUtil.DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.DEFENCE] = param[Lua_FightUtil.DEFENCE_STR];
	end
	if param[Lua_FightUtil.ATTACK_UPPER_STR] ~= nil then
		dic[Lua_FightUtil.ATTACK_UPPER] = param[Lua_FightUtil.ATTACK_UPPER_STR];
	end
	if param[Lua_FightUtil.ATTACK_LOWER_STR] ~= nil then
		dic[Lua_FightUtil.ATTACK_LOWER] = param[Lua_FightUtil.ATTACK_LOWER_STR];
	end
	if param[Lua_FightUtil.DEFENCE_UPPER_STR] ~= nil then
		dic[Lua_FightUtil.DEFENCE_UPPER] = param[Lua_FightUtil.DEFENCE_UPPER_STR];
	end
	if param[Lua_FightUtil.DEFENCE_LOWER_STR] ~= nil then
		dic[Lua_FightUtil.DEFENCE_LOWER] = param[Lua_FightUtil.DEFENCE_LOWER_STR];
	end
	if param[Lua_FightUtil.FELEMENT_DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.FELEMENT_DEFENCE] = param[Lua_FightUtil.FELEMENT_DEFENCE_STR];
	end
	if param[Lua_FightUtil.FELEMENT_ATTACK_STR] ~= nil then
		dic[Lua_FightUtil.FELEMENT_ATTACK] = param[Lua_FightUtil.FELEMENT_ATTACK_STR];
	end
	if param[Lua_FightUtil.EQUIP_BLOOD] ~= nil then
		dic[Lua_FightUtil.EQUIP_BLOOD] = param[Lua_FightUtil.EQUIP_BLOOD_STR];
	end
	if param[Lua_FightUtil.EQUIP_ATTACK_STR] ~= nil then
		dic[Lua_FightUtil.EQUIP_ATTACK] = param[Lua_FightUtil.EQUIP_ATTACK_STR];
	end
	if param[Lua_FightUtil.EQUIP_DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.EQUIP_DEFENCE] = param[Lua_FightUtil.EQUIP_DEFENCE_STR];
	end
	if param[Lua_FightUtil.BASE_BLOOD_STR] ~= nil then
		dic[Lua_FightUtil.BASE_BLOOD] = param[Lua_FightUtil.BASE_BLOOD_STR];
	end
	if param[Lua_FightUtil.BASE_ATTACK_STR] ~= nil then
		dic[Lua_FightUtil.BASE_ATTACK] = param[Lua_FightUtil.BASE_ATTACK_STR];
	end
	if param[Lua_FightUtil.BASE_DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.BASE_DEFENCE] = param[Lua_FightUtil.BASE_DEFENCE_STR];
	end
	if param[Lua_FightUtil.ABSOLUTELY_ATTACK_STR] ~= nil then
		dic[Lua_FightUtil.ABSOLUTELY_ATTACK] = param[Lua_FightUtil.ABSOLUTELY_ATTACK_STR];
	end
	if param[Lua_FightUtil.ABSOLUTELY_DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.ABSOLUTELY_DEFENCE] = param[Lua_FightUtil.ABSOLUTELY_DEFENCE_STR];
	end
	if param[Lua_FightUtil.FELEMENT_ATTACK_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.FELEMENT_ATTACK_MULTI] = param[Lua_FightUtil.FELEMENT_ATTACK_MULTI_STR];
	end
	if param[Lua_FightUtil.FELEMENT_DEFENCE_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.FELEMENT_DEFENCE_MULTI] = param[Lua_FightUtil.FELEMENT_DEFENCE_MULTI_STR];
	end
	if param[Lua_FightUtil.HIT_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.HIT_MULTI] = param[Lua_FightUtil.HIT_MULTI_STR];
	end
	if param[Lua_FightUtil.skill_hurt_multi] ~= nil then
		dic[Lua_FightUtil.AVOID_MULTI] = param[Lua_FightUtil.skill_hurt_multi];
	end
	if param[Lua_FightUtil.SKILL_HURT_MULTI] ~= nil then -- 技能伤害
		dic[Lua_FightUtil.SKILL_HURT_VAL] = param[Lua_FightUtil.SKILL_HURT_MULTI];
	end
	if param[Lua_FightUtil.SKILL_MULTI_STR] ~= nil then -- 伤害加成
		dic[Lua_FightUtil.DAMAGE_MULTI] = param[Lua_FightUtil.SKILL_MULTI_STR];
	end
	if param[Lua_FightUtil.BLOCK] ~= nil then -- 格挡概率
		dic[Lua_FightUtil.BLOCK_HURT_RATE] = param[Lua_FightUtil.BLOCK];
	end
	if param[Lua_FightUtil.REDUCE_CONTRAL] ~= nil then -- 控制抵抗
		dic[Lua_FightUtil.REDUCE_CONTRAL_RATE] = param[Lua_FightUtil.REDUCE_CONTRAL];
	end
	if param[Lua_FightUtil.REVERSE_HURT_PER] ~= nil then -- 伤害反射
		dic[Lua_FightUtil.REVERSE_RATE] = param[Lua_FightUtil.REVERSE_HURT_PER];
	end
	if param[Lua_FightUtil.SKILL_REDUCTION_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.SKILL_REDUCTION_MULTI] = param[Lua_FightUtil.SKILL_REDUCTION_MULTI_STR];
	end
	if param[Lua_FightUtil.REDUCE_DEFENCE_STR] ~= nil then
		dic[Lua_FightUtil.REDUCE_DEFENCE] = param[Lua_FightUtil.REDUCE_DEFENCE_STR];
	end
	if param[Lua_FightUtil.REDUCE_DEFENCE_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.REDUCE_DEFENCE_MULTI] = param[Lua_FightUtil.REDUCE_DEFENCE_MULTI_STR];
	end
	if param[Lua_FightUtil.EXTRA_CRIT_PER_STR] ~= nil then
		dic[Lua_FightUtil.EXTRA_CRIT_PER] = param[Lua_FightUtil.EXTRA_CRIT_PER_STR];
	end
	if param[Lua_FightUtil.CRIT_VALUE_MULTI_STR] ~= nil then
		dic[Lua_FightUtil.CRIT_VALUE_MULTI] = param[Lua_FightUtil.CRIT_VALUE_MULTI_STR];
	end
	if param[Lua_FightUtil.TOUGHNESS_MULTI_STR] ~= nil then -- 韧性加成
		dic[Lua_FightUtil.TOUGHNESS_MULTI] = param[Lua_FightUtil.TOUGHNESS_MULTI_STR];
	end
	if param[Lua_FightUtil.CRIT_HURT_MULTI_STR] ~= nil then -- 暴击伤害数
		dic[Lua_FightUtil.CRIT_HURT_MULTI] = param[Lua_FightUtil.CRIT_HURT_MULTI_STR];
	end
	if param[Lua_FightUtil.REAL_HURT_PER] ~= nil then -- 真实伤害
		dic[Lua_FightUtil.REAL_HURT_VAL] = param[Lua_FightUtil.REAL_HURT_PER];
	end
	if param[Lua_FightUtil.ATTACK_MULTI_STR] ~= nil then -- 攻击加成
		dic[Lua_FightUtil.ATTACK_MULTI] = param[Lua_FightUtil.ATTACK_MULTI_STR];
	end
	if param[Lua_FightUtil.DEFENCE_MULTI_STR] ~= nil then -- 防御加成
		dic[Lua_FightUtil.DEFENCE_MULTI] = param[Lua_FightUtil.DEFENCE_MULTI_STR];
	end
	if param[Lua_FightUtil.BLOOD_MULTI_STR] ~= nil then -- 生命加成
		dic[Lua_FightUtil.BLOOD_MULTI] = param[Lua_FightUtil.BLOOD_MULTI_STR];
	end
	if param[Lua_FightUtil.PVP_DAMAGE_PER_STR] ~= nil then -- PVP伤害加成
		dic[Lua_FightUtil.PVP_DAMAGE_PER] = param[Lua_FightUtil.PVP_DAMAGE_PER_STR];
	end
	if param[Lua_FightUtil.PVP_REDUCE_PER_STR] ~= nil then -- PVP伤害减免
		dic[Lua_FightUtil.PVP_REDUCE_PER] = param[Lua_FightUtil.PVP_REDUCE_PER_STR];
	end
	if param[Lua_FightUtil.DOUBLE_HIT_RATE_STR] ~= nil then
		dic[Lua_FightUtil.DOUBLE_HIT_RATE] = param[Lua_FightUtil.DOUBLE_HIT_RATE_STR];
	end
	return dic;
end

function Lua_FightUtil.caculateConfigAndServer(configDic, serverDic, showPrint)
	local dic = Lua_FightUtil.transConfigDic(nil, configDic);
	dic = Lua_FightUtil.transServerDic(dic, serverDic);
	return Lua_FightUtil.caculateForce(dic, showPrint);
end

function Lua_FightUtil.caculateForce(dic, showPrint)
	local rd = DataCenter.roleData.baseParam;
	if rd == nil then
		return 0;
	end
	
	local attack = dic[Lua_FightUtil.ATTACK] ~= nil and dic[Lua_FightUtil.ATTACK] or 0;
	local attack_lower = dic[Lua_FightUtil.ATTACK_LOWER] ~= nil and dic[Lua_FightUtil.ATTACK_LOWER] + attack or attack;
	local attack_upper = dic[Lua_FightUtil.ATTACK_UPPER] ~= nil and dic[Lua_FightUtil.ATTACK_UPPER] + attack or attack;
	local defence = dic[Lua_FightUtil.DEFENCE] ~= nil and dic[Lua_FightUtil.DEFENCE] or 0;
	local hit = dic[Lua_FightUtil.HIT] ~= nil and dic[Lua_FightUtil.HIT] or 0;
	local avoid = dic[Lua_FightUtil.AVOID] ~= nil and dic[Lua_FightUtil.AVOID] or 0;
	local crit = dic[Lua_FightUtil.CRIT] ~= nil and dic[Lua_FightUtil.CRIT] or 0;
	local crit_value_multi = dic[Lua_FightUtil.CRIT_VALUE_MULTI] ~= nil and dic[Lua_FightUtil.CRIT_VALUE_MULTI] or 0;
	local toughness = dic[Lua_FightUtil.TOUGHNESS] ~= nil and dic[Lua_FightUtil.TOUGHNESS] or 0;
	local blood_max = dic[Lua_FightUtil.BLOOD_MAX] ~= nil and dic[Lua_FightUtil.BLOOD_MAX] or 0;
	local felement_attack = dic[Lua_FightUtil.FELEMENT_ATTACK] ~= nil and dic[Lua_FightUtil.FELEMENT_ATTACK] or 0;
	local felement_defence = dic[Lua_FightUtil.FELEMENT_DEFENCE] ~= nil and dic[Lua_FightUtil.FELEMENT_DEFENCE] or 0;
	local beast_hurt = dic[Lua_FightUtil.BEAST_HURT] ~= nil and dic[Lua_FightUtil.BEAST_HURT] or 0;
	local skill_hurt = dic[Lua_FightUtil.SKILL_HURT_VAL] ~= nil and dic[Lua_FightUtil.SKILL_HURT_VAL] or 0;
	local damage = dic[Lua_FightUtil.DAMAGE] ~= nil and dic[Lua_FightUtil.DAMAGE] or 0;
	local reduce = dic[Lua_FightUtil.REDUCTION] ~= nil and dic[Lua_FightUtil.REDUCTION] or 0;
	local block_hurt = dic[Lua_FightUtil.BLOCK_HURT_RATE] ~= nil and dic[Lua_FightUtil.BLOCK_HURT_RATE] or 0;
	local reverse = dic[Lua_FightUtil.REVERSE_RATE] ~= nil and dic[Lua_FightUtil.REVERSE_RATE] or 0;
	local ignore_defence = dic[Lua_FightUtil.IGNORE_DEFENCE_PER] ~= nil and dic[Lua_FightUtil.IGNORE_DEFENCE_PER] or 0;
	local thump = dic[Lua_FightUtil.THUMP_RATE] ~= nil and dic[Lua_FightUtil.THUMP_RATE] or 0;
	local reduce_contral = dic[Lua_FightUtil.REDUCE_CONTRAL_RATE] ~= nil and dic[Lua_FightUtil.REDUCE_CONTRAL_RATE] or 0;
	local pvp_damage = dic[Lua_FightUtil.PVP_DAMAGE_PER] ~= nil and dic[Lua_FightUtil.PVP_DAMAGE_PER] or 0;
	local pvp_reduce = dic[Lua_FightUtil.PVP_REDUCE_PER] ~= nil and dic[Lua_FightUtil.PVP_REDUCE_PER] or 0;
	local beast_hurt_per = dic[Lua_FightUtil.BEAST_HURT_PER] ~= nil and dic[Lua_FightUtil.BEAST_HURT_PER] or 0;
	local crit_hurt = dic[Lua_FightUtil.CRIT_HURT_MULTI] ~= nil and dic[Lua_FightUtil.CRIT_HURT_MULTI] or 0;
	local extra_toughness_rate = dic[Lua_FightUtil.EXTRA_TOUGHNESS_RATE] ~= nil and dic[Lua_FightUtil.EXTRA_TOUGHNESS_RATE] or 0;
	local double_hit_rate = dic[Lua_FightUtil.DOUBLE_HIT_RATE] ~= nil and dic[Lua_FightUtil.DOUBLE_HIT_RATE] or 0;

	local equip_blood = dic[Lua_FightUtil.EQUIP_BLOOD] ~= nil and dic[Lua_FightUtil.EQUIP_BLOOD] or 0;
	local equip_attack = dic[Lua_FightUtil.EQUIP_ATTACK] ~= nil and dic[Lua_FightUtil.EQUIP_ATTACK] or 0;
	local equip_defence = dic[Lua_FightUtil.EQUIP_DEFENCE] ~= nil and dic[Lua_FightUtil.EQUIP_DEFENCE] or 0;
	local base_blood = dic[Lua_FightUtil.BASE_BLOOD] ~= nil and dic[Lua_FightUtil.BASE_BLOOD] or 0;
	local base_attack = dic[Lua_FightUtil.BASE_ATTACK] ~= nil and dic[Lua_FightUtil.BASE_ATTACK] or 0;
	local base_defence = dic[Lua_FightUtil.BASE_DEFENCE] ~= nil and dic[Lua_FightUtil.BASE_DEFENCE] or 0;
	local absolutely_attack = dic[Lua_FightUtil.ABSOLUTELY_ATTACK] ~= nil and dic[Lua_FightUtil.ABSOLUTELY_ATTACK] or 0;
	local absolutely_defence = dic[Lua_FightUtil.ABSOLUTELY_DEFENCE] ~= nil and dic[Lua_FightUtil.ABSOLUTELY_DEFENCE] or 0;
	local reduce_defence = dic[Lua_FightUtil.REDUCE_DEFENCE] ~= nil and dic[Lua_FightUtil.REDUCE_DEFENCE] or 0;
	local reduce_defence_multi = dic[Lua_FightUtil.REDUCE_DEFENCE_MULTI] ~= nil and dic[Lua_FightUtil.REDUCE_DEFENCE_MULTI] or 0;

	local felement_attack_multi = dic[Lua_FightUtil.FELEMENT_ATTACK_MULTI] ~= nil and dic[Lua_FightUtil.FELEMENT_ATTACK_MULTI] or 0;
	local felement_defence_multi = dic[Lua_FightUtil.FELEMENT_DEFENCE_MULTI] ~= nil and dic[Lua_FightUtil.FELEMENT_DEFENCE_MULTI] or 0;
	local hit_multi = dic[Lua_FightUtil.HIT_MULTI] ~= nil and dic[Lua_FightUtil.HIT_MULTI] or 0;
	local avoid_multi = dic[Lua_FightUtil.AVOID_MULTI] ~= nil and dic[Lua_FightUtil.AVOID_MULTI] or 0;
	local skill_reduction_multi = dic[Lua_FightUtil.SKILL_REDUCTION_MULTI] ~= nil and dic[Lua_FightUtil.SKILL_REDUCTION_MULTI] or 0;

	local attack_sum = attack_lower + attack_upper;
	local perLvlAttack = dic[Lua_FightUtil.LEVEL_WITH_ATTACK] ~= nil and dic[Lua_FightUtil.LEVEL_WITH_ATTACK] or 0;
	if perLvlAttack ~= 0 then
		attack_sum = attack_sum + DataCenter.roleData.level / perLvlAttack * 2;
	end
	local mulAttack = dic[Lua_FightUtil.ATTACK_MULTI] ~= nil and dic[Lua_FightUtil.ATTACK_MULTI] or 0;
	if mulAttack ~= 0 then
		attack_sum = attack_sum + rd.attack_sum_base * mulAttack / 100;
	end
	if base_attack ~= 0 then
		attack_sum = attack_sum + rd.attack_sum_base * base_attack / 100;
	end
	if equip_attack ~= 0 then
		attack_sum = attack_sum + rd.equip_attack * equip_attack / 100;
	end
	local def_mul = dic[Lua_FightUtil.DEFENCE_MULTI] ~= nil and dic[Lua_FightUtil.DEFENCE_MULTI] or 0;
	if def_mul ~= 0 then
		defence = defence + rd.defence_base * def_mul / 100;
	end
	if base_defence ~= 0 then
		defence = defence + rd.defence_base * base_defence / 100;
	end
	if equip_defence ~= 0 then
		defence = defence + rd.equip_defence * equip_defence / 100;
	end
	local perLvlDef = dic[Lua_FightUtil.LEVEL_WITH_DEF] ~= nil and dic[Lua_FightUtil.LEVEL_WITH_DEF] or 0;
	if perLvlDef ~= 0 then
		defence = defence + DataCenter.roleData.level / perLvlDef;
	end

	local force = attack_sum + defence * 2 + hit * 20 + avoid * 20 + crit * 10 + toughness * 10 + blood_max / 25
		+ felement_attack * 2 + felement_defence * 2 + beast_hurt + beast_hurt / 5 * beast_hurt_per / 100
		+ reduce_defence * 2;
	
	force = force + absolutely_attack;
	force = force + absolutely_defence;
	force = force + rd.felement_attack * felement_attack_multi * 2 / 100;
	force = force + rd.felement_defence * felement_defence_multi * 2 / 100;
	force = force + rd.hit * hit_multi * 20 / 100;
	force = force + rd.avoid * avoid_multi * 20 / 100;
	force = force + rd.damage * attack_sum / 200;
	force = force + rd.ignore_defence * attack_sum / 200;
	force = force + rd.thump_rate * attack_sum / 400;
	force = force + rd.skill_hurt_val * attack_sum / 400;
	force = force + rd.pvp_damage * attack_sum / 400;
	force = force + rd.reduce_defence * reduce_defence_multi * 2 / 100;
	force = force + rd.reverse * 0.4 * defence / 100;
	force = force + rd.block_hurt_rate * 0.4 * defence / 100;
	force = force + rd.reduce_contral * 0.4 * defence / 100;
	force = force + rd.pvp_reduction * defence / 100;
	force = force + rd.crit * 10 * crit_value_multi / 100;

	force = force + rd.attack_sum / 4 * double_hit_rate / 100;
	force = force + rd.attack_sum / 4 * skill_hurt / 100;
	force = force + rd.attack_sum / 2 * damage / 100;
	force = force + rd.attack_sum * ignore_defence / 200;
	force = force + rd.attack_sum * pvp_damage / 800;

	force = force + rd.defence * reduce_contral * 0.4 / 100;
	force = force + rd.defence * pvp_reduce / 100;
	force = force + rd.defence * skill_reduction_multi / 100;
	force = force + rd.defence * extra_toughness_rate / 100;

	local perLvlHit = dic[Lua_FightUtil.LEVEL_WITH_HIT] ~= nil and dic[Lua_FightUtil.LEVEL_WITH_HIT] or 0;
	if perLvlHit ~= 0 then
		force = force + 20 * DataCenter.roleData.level / perLvlHit;
	end
	local perLvlBlood = dic[Lua_FightUtil.LEVEL_WITH_BLOOD] ~= nil and dic[Lua_FightUtil.LEVEL_WITH_BLOOD] or 0;
	if perLvlBlood ~= 0 then
		force = force + DataCenter.roleData.level * perLvlBlood / 25;
	end
	local blood_mul = dic[Lua_FightUtil.BLOOD_MULTI] ~= nil and dic[Lua_FightUtil.BLOOD_MULTI] or 0;
	if blood_mul ~= 0 then
		force = force + rd.blood_max_base * blood_mul / 100 / 25;
	end
	if base_blood ~= 0 then
		force = force + rd.blood_max_base * base_blood / 100 / 25;
	end

	if equip_blood ~= 0 then
		force = force + rd.equip_blood * equip_blood / 100 / 25;
	end
	local perLvlAvoid = dic[Lua_FightUtil.LEVEL_WITH_AVOID] ~= nil and dic[Lua_FightUtil.LEVEL_WITH_AVOID] or 0;
	if perLvlAvoid ~= 0 then
		force = force + 30 * DataCenter.roleData.level / perLvlAvoid;
	end
	if crit_hurt ~= 0 then
		force = force + rd.attack_sum * crit_hurt * 0.075 / 100;
	end
	if thump ~= 0 then
		force = force + rd.attack_sum * thump / 4 / 100;
	end
	if reverse ~= 0 then
		force = force + rd.defence * 0.4 * reverse / 100;
	end
	if block_hurt ~= 0 then
		force = force + rd.defence * 0.4 * block_hurt / 100;
	end

	if beast_hurt_per ~= 0 then
		force = force + rd.beast_attack / 5 * beast_hurt_per / 100;
	end

	local damageMult = dic[Lua_FightUtil.DAMAGE_MULTI] ~= nil and dic[Lua_FightUtil.DAMAGE_MULTI] or 0;
	if damageMult ~= 0 then
		force = force + rd.attack_sum / 2 * damageMult / 100;
	end

	local reduceMult = dic[Lua_FightUtil.REDUCTION_MULTI] ~= nil and dic[Lua_FightUtil.REDUCTION_MULTI] or 0;
	if reduceMult ~= 0 then
		force = force + rd.defence * 2 * reduceMult / 100;
	end
	local skillAdd = dic[Lua_FightUtil.SKILL_ADD] ~= nil and dic[Lua_FightUtil.SKILL_ADD] or 0;
	if skillAdd ~= 0 then
		force = force + rd.attack_sum / 4 * skillAdd / 100;
	end
	local crit_nul = dic[Lua_FightUtil.EXTRA_CRIT_PER] ~= nil and dic[Lua_FightUtil.EXTRA_CRIT_PER] or 0;
	if crit_nul ~= 0 then
		force = force + (rd.attack_sum / 4 * crit_nul) / 100;
	end
	force = force * 5;
	return math.floor(force);
end

function Lua_FightUtil.caculateEquipScore(vo, serverAttrList)
	local blueAttrNum = 0;
	local purpleAttrNum = 0;
	local yellowAttrNum = 0;

	if serverAttrList ~= nil then
		for i, v in ipairs(serverAttrList) do
			if v.color == 2 then
				blueAttrNum = blueAttrNum + 1;
			elseif v.color == 3 then
				purpleAttrNum = purpleAttrNum + 1;
			elseif v.color == 4 then
				yellowAttrNum = yellowAttrNum + 1;
			end
		end
	else
		if vo.star == 0 then
			if vo.color == 3 then
				blueAttrNum = 1;
			end
		elseif vo.star == 1 then
			if vo.color == 3 then
				purpleAttrNum = 1;
			elseif vo.color == 4 then
				blueAttrNum = 1;
				purpleAttrNum = 1;
			elseif vo.color == 5 then
				blueAttrNum = 2;
				purpleAttrNum = 1;
			end
		elseif vo.star == 2 then
			if vo.color == 4 then
				purpleAttrNum = 2;
			elseif vo.color == 5 then
				blueAttrNum = 1;
				purpleAttrNum = 2;
			end
		elseif vo.star == 3 then
			if vo.color == 5 then
				purpleAttrNum = 3;
			end
		elseif vo.star == 4 then
			if vo.color == 6 then
				purpleAttrNum = 3;
				yellowAttrNum = 1;
			end
		end
	end

	local order = vo.order ~= nil and vo.order or 0;
	local star = vo.star ~= nil and vo.star or 0;
	local score = (1 + order / 20) * (star * 3000 
	+ blueAttrNum * 5000 + purpleAttrNum * 15670 + yellowAttrNum * 18350)
	+ vo.attack_min * 10 + vo.defence * 10 + vo.hit * 100 + vo.crit * 50 + vo.toughness * 50 + vo.blood * 0.2;
	return math.floor(score);
end