Lua_WindowUtil = {};
Lua_WindowUtil.UI_CONTAINER = 1;
Lua_WindowUtil.UI_SPRITE = 2;
Lua_WindowUtil.UI_LABEL = 3;
Lua_WindowUtil.UI_CHECKBOX = 4;
Lua_WindowUtil.UI_BUTTON = 5;
Lua_WindowUtil.UI_COSTOM = 6;
Lua_WindowUtil.UI_TEXTINPUT = 7;
Lua_WindowUtil.UI_IMAGE = 8;
Lua_WindowUtil.UI_PB = 9;
Lua_WindowUtil.UI_EDIT_AUX = 999; -- UI编辑辅助组件，不进行UI皮肤导出
function Lua_WindowUtil.openWin(winName, act, data)
	if act == WinParam.ACTION_CLOSE then
		if WindowMananger.getInstance():isWindowShowing(winName) == false then
			return;
		end
	end

	if winName == "Lua_ChongzhiWindow" then
		if getRechargeStyle() == 1 or getRechargeStyle() == 2 or getRechargeStyle() == 3 then
			winName = "Lua_ChongzhiWindow2";
		elseif getRechargeStyle() == 4 then -- ios 提申包做特殊处理
			if act ~= WinParam.ACTION_CLOSE then
				if type(data) ~= "table" then
					if data ~= nil then
						if tonumber(data) == 10097 or tonumber(data) == 10084 or tonumber(data) > 1 then
							winName = "Lua_ChongzhiWindow";
						elseif tonumber(data) == 1 then
							winName = "Lua_ChongzhiIosWindow";
						end
					else
						winName = "Lua_ChongzhiIosWindow";
					end
				else
					if data.openIdx ~= nil then
						if tonumber(data.openIdx) == 10097 or tonumber(data.openIdx) == 10084 or tonumber(data.openIdx) > 1 then
							winName = "Lua_ChongzhiWindow";
						elseif tonumber(data) == 1 then
							winName = "Lua_ChongzhiIosWindow";
						end
					else
						winName = "Lua_ChongzhiIosWindow";
					end
				end
			end
		end
	end

	Lua_WindowUtil.addWinData(winName, data);
	act = act == nil and WinParam.ACTION_AUTO or act;
	MsgUtil.callFunc(EventsDefine.WIN_SHOW_HIDE, WinParam.getWinParam(winName, act, nil));
end

function Lua_WindowUtil.addWinData(winName, data)
	if data == nil then
		return;
	end

	if Lua_WindowUtil.winData == nil then
		Lua_WindowUtil.winData = {};
	end
	Lua_WindowUtil.winData[winName] = data;

	if Lua_WindowUtil.winListData == nil then
		Lua_WindowUtil.winListData = {};
	end
	if Lua_WindowUtil.winListData[winName] == nil then
		Lua_WindowUtil.winListData[winName] = Array();
	end
	Lua_WindowUtil.winListData[winName]:add(data);
end

function Lua_WindowUtil.getWinData(winName, doRemove)
	if Lua_WindowUtil.winData == nil then
		return nil;
	end

	local showWinData = Lua_WindowUtil.winData[winName];
	if doRemove == true then
		Lua_WindowUtil.winData[winName] = nil;
	end
	return showWinData;
end

function Lua_WindowUtil.getWinListData(winName, doRemove)
	if Lua_WindowUtil.winListData == nil then
		return nil;
	end

	local showWinDataArr = Lua_WindowUtil.winListData[winName];
	if doRemove == true then
		Lua_WindowUtil.winListData[winName] = nil;
	end
	return showWinDataArr;
end

function Lua_WindowUtil.isWindowShowing(winName)
	return WindowMananger.getInstance():isWindowShowing(winName);
end

function Lua_WindowUtil.buildFromSkin(showTable, skinStr, rootObj)
	local conTable = {};
	conTable["content"] = showTable["content"];

	skinTable = checkRequire(skinStr);
	for i,v in ipairs(skinTable) do
		Lua_WindowUtil:buildOneSkin(showTable, conTable, v);
	end
end

function Lua_WindowUtil.buildFromSkinEachFrame(showTable, skinTable, conTable, index)
	if index > #skinTable then
		return true;
	else
		Lua_WindowUtil:buildOneSkin(showTable, conTable, skinTable[index]);
		return false;
	end
end

function Lua_WindowUtil:buildOneSkin(showTable, conTable, v)
	if v.type == Lua_WindowUtil.UI_CONTAINER then
		showTable[v.name] = Lua_WindowUtil.createContaner(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name];
	elseif v.type == Lua_WindowUtil.UI_SPRITE then
		showTable[v.name] = Lua_WindowUtil.createUIAtlasImage(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_CHECKBOX then
		showTable[v.name] = Lua_WindowUtil.createCheckBox(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_LABEL then
		showTable[v.name] = Lua_WindowUtil.createLabel(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_BUTTON then
		showTable[v.name] = Lua_WindowUtil.createButton(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_TEXTINPUT then
		showTable[v.name] = Lua_WindowUtil.createInput(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_IMAGE then
		showTable[v.name] = Lua_WindowUtil.createImage(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	elseif v.type == Lua_WindowUtil.UI_PB then
		showTable[v.name] = Lua_WindowUtil.createProgressBar(conTable[v.parent], v);
		conTable[v.name] = showTable[v.name].mainContent;
	end
	if showTable[v.name] ~= nil then
		showTable[v.name].name = v.name;
	end
end

function Lua_WindowUtil.createContaner(p, v)
	return UICreate.createGameObject(p, v.x, v.y, v.z);
end

function Lua_WindowUtil.createUIAtlasImage(p, v)
	local img = UICreate.createUIAtlasImage(p, v.atlas, v.spriteName, v.x, v.y, v.width, v.height);
	img.depth = v.depth;
	img.pivot = Lua_WindowUtil.getPivot(v.pivot);
	img:setLocation(v.x, v.y, v.z);
	img:setSacle(v.sx, v.sy);
	img:setRot(v.rx, v.ry, v.rz, v.rw);
	return img;
end

function Lua_WindowUtil.initTextFieldStyle(label, v)
	if v.effectStyle ~= nil then
		label.effectStyle = v.effectStyle;
	end
	if v.color ~= nil then
		label.colorStr = v.color;
	end
	if v.effectColor ~= nil then
		label.effectColorStr = v.effectColor;
	end
	if v.effectDistanceX ~= nil and v.effectDistanceY ~= nil then
		label:setEffectDistance(v.effectDistanceX, v.effectDistanceY);
	end
	if v.fontName ~= nil then
		label.fontName = v.fontName;
	end
	if v.fontsize ~= nil then
		label.fontSize = tonumber(v.fontsize);
	end
	if v.labelWidth ~= nil and v.labelHeight then
		label:SetDimensions(v.labelWidth, v.labelHeight);
	end
	if v.overflow == 0 then
		label.overflowMethod = UILabel.Overflow.ShrinkContent;
	elseif v.overflow == nil or v.overflow == 1 then
		label.overflowMethod = UILabel.Overflow.ClampContent;
	elseif v.overflow == 2 then
		label.overflowMethod = UILabel.Overflow.ResizeFreely;
	elseif v.overflow == 3 then
		label.overflowMethod = UILabel.Overflow.ResizeHeight;
	end
	if v.spaceX ~= nil then
		label.spacingX = v.spaceX;
	end
	if v.spaceY ~= nil then
		label.spacingY = v.spaceY;
	end
	if v.applyGradient == 1 then
		label.applyGradient = v.applyGradient;
		label.gradientTop = v.gradientTop;
		label.gradientBottom = v.gradientBottom;
	end
end

function Lua_WindowUtil.getUILan(v)
	if v.resetTxt == 1 then
		return uilang[v.txt];
	else
		return v.txt;
	end
end

function Lua_WindowUtil.createLabel(p, v)
	local label = UICreate.createLabel(p, Lua_WindowUtil.getUILan(v), v.x, v.y, v.width, v.height, tonumber(v.fontsize));
	label.depth = v.depth;
	label.pivot = Lua_WindowUtil.getPivot(v.pivot);
	Lua_WindowUtil.initTextFieldStyle(label, v);
	label:setLocation(v.x, v.y, v.z);
	label:setSacle(v.sx, v.sy);
	label:setRot(v.rx, v.ry, v.rz, v.rw);
	return label;
end

function Lua_WindowUtil.createInput(p, v)
	local label = UICreate.createInput(p, Lua_WindowUtil.getUILan(v), v.x, v.y, v.width, v.height, tonumber(v.fontsize));
	label.pivot = Lua_WindowUtil.getPivot(v.pivot);
	label.depth = v.depth;	
	Lua_WindowUtil.initTextFieldStyle(label, v);
	label:setLocation(v.x, v.y, v.z);
	label:setSacle(v.sx, v.sy);
	label:setRot(v.rx, v.ry, v.rz, v.rw);
	return label;
end

function Lua_WindowUtil.createButton(p, v)
	local btn = UICreate.createButton(p, Lua_WindowUtil.getUILan(v), v.x, v.y, v.width, v.height);
	Lua_WindowUtil.initTextFieldStyle(btn.txt, v);
	if v.labelPosX ~= nil and v.labelPosY ~= nil then
		btn.txt:setLocation(v.labelPosX, v.labelPosY);
	end
	btn.depth = v.depth;
	btn:setStyle(v.style);
	btn:setSacle(v.sx, v.sy);
	btn:setRot(v.rx, v.ry, v.rz, v.rw);
	return btn;
end

function Lua_WindowUtil.createCheckBox(p, v)
	local cbox = UICreate.createCheckBox(p, Lua_WindowUtil.getUILan(v), v.x, v.y, v.width, v.height);
	Lua_WindowUtil.initTextFieldStyle(cbox.txt, v);
	if v.labelPosX ~= nil and v.labelPosY ~= nil then
		cbox.txt:setLocation(v.labelPosX, v.labelPosY);
	end
	cbox.depth = v.depth;
	cbox:setStyle(v.style);
	cbox:SetDimensions(v.width, v.height);
	cbox:setSacle(v.sx, v.sy);
	cbox:setRot(v.rx, v.ry, v.rz, v.rw);
	return cbox;
end

function Lua_WindowUtil.createImage(p, v)
	local img = UICreate.createImage(p, v.url, v.x, v.y, v.width, v.height);
	img.pivot = Lua_WindowUtil.getPivot(v.pivot);
	img.depth = v.depth;
	img:setSacle(v.sx, v.sy);
	img:setRot(v.rx, v.ry, v.rz, v.rw);
	return img;
end

function Lua_WindowUtil.createProgressBar(p, v)
	local pb = UICreate.createProgressBar(p, v.bgAtals, v.bgSpriteName, v.barAtals, v.barSpriteName, v.x, v.y, v.width, v.height);
	Lua_WindowUtil.initTextFieldStyle(pb.txt, v);
	if v.labelPosX ~= nil and v.labelPosY ~= nil then
		pb.txt:setLocation(v.labelPosX, v.labelPosY);
	end
	pb.depth = v.depth;
	pb:setBarOffset(v.offsetWidth, v.offsetHeight);
	pb:setSacle(v.sx, v.sy);
	pb:setRot(v.rx, v.ry, v.rz, v.rw);
	return pb;
end

function Lua_WindowUtil.getPivot(v)
	if v == 1 then
		return UIWidget.Pivot.TopLeft;
	elseif v == 2 then
		return UIWidget.Pivot.Top;
	elseif v == 3 then
		return UIWidget.Pivot.TopRight;
	elseif v == 4 then
		return UIWidget.Pivot.Left;
	elseif v == 5 then
		return UIWidget.Pivot.Center;
	elseif v == 6 then
		return UIWidget.Pivot.Right;
	elseif v == 7 then
		return UIWidget.Pivot.BottomLeft;
	elseif v == 8 then
		return UIWidget.Pivot.Bottom;
	elseif v == 9 then
		return UIWidget.Pivot.BottomRight;
	end
	return UIWidget.Pivot.Left;
end

function Lua_WindowUtil.getPreLoadList(skinStr)
	local skinTable = checkRequire(skinStr);
	local arr = {};
	local index = 1;
	for i,v in ipairs(skinTable) do
		if v.type == Lua_WindowUtil.UI_SPRITE then
			arr[index] = {resName = v.atlas, type = Lua_WindowUtil.UI_SPRITE};
			index = index + 1;
		end
	end
	return arr;
end

function Lua_WindowUtil.hideOtherWindow()
	local tlist = {
		"Lua_MainMenuWindow",
		"Lua_GuideWindow",
		"OperateAlertWindow",
		"Lua_DebugWindow",
		"Lua_NewItemTipWindow",
		"Lua_BossCopyInfoWindow",
		"Lua_LimitTimeBossRageWindow",
		"Lua_LaoYuLeftInfoWindow",
		"Lua_AnswerLeftInfoPanel",
		"LiuHaiMaskWindow",
		"Lua_ChaoticLeftInfoWindow"};
	WindowMananger.getInstance():hideOtherWindow(tlist);
end