Lua_TheSelectionWarData = class("Lua_TheSelectionWarData");
Lua_TheSelectionWarData.theSelectionWarSceneId = 71601;
function Lua_TheSelectionWarData:ctor()
	self:dispose();
end

function Lua_TheSelectionWarData:dispose()
	if self.rank_list ~= nil then
		self.rank_list:dispose();
		self.rank_list:clear()
		self.rank_list = nil;
	end
	if self.exploit_list ~= nil then
		self.exploit_list:dispose();
		self.exploit_list:clear()
		self.exploit_list = nil;
	end
	self.leftTime = 0; -- 匹配成功倒计时
	self.startTime = 0; -- 战斗开始倒计时
	self.isStopsHook = false;
	self.daily_fight = 0; 
	self:resetChallengeInfo()
end

function Lua_TheSelectionWarData:resetChallengeInfo()
	self.left_sec = 0;
	self.total_sec = 0;
	self.state = 0;
	self.getLeftTime = 0;

	self.left_player = nil;
	self.right_player = nil;

	self.self_player = nil;
	self.match_player = nil;
	self.fight_drawed = nil;
end

-- 界面信息
function Lua_TheSelectionWarData:fromServer51405301(msg)
	if msg == nil then
		return;
	end

	-- print("id", msg.self_grade_reward.id, "数量", msg.self_grade_reward.amount);
	self.is_reward = msg.grade_daily_draw;                    -- 是否有每日段位奖励，0 没有，1有
	self.reward_id = msg.self_grade_reward.id;                -- 每日段位奖励id
	self.reward_amount = msg.self_grade_reward.amount;        -- 每日段位奖励数量

	self.fight_drawed = msg.self_fight_drawed;                -- 0不可领取，1可领取，2已领取

	self.fight_sec = msg.left_fight_sec;                      -- 未匹配成功则为0，否则就是离开战还有多少秒
	self.is_match = msg.is_match;                             -- 是否匹配中，0 没有在匹配，1 匹配中，2 匹配成功
	self.fight_times = msg.left_fight_times;                  -- 剩余挑战次数
	self.max_times = msg.total_fight_times;                   -- 剩余最大挑战次数

	self.season_end_tick = msg.season_end_tick;               -- 赛季结束时间
	self.left_buy_times = msg.left_buy_times;
	self.self_player = msg.self_player;
	self.match_player = msg.match_player;
	self.season = msg.season;                                 --第几赛季
	self.daily_fight = msg.daily_fight;                       --当天挑战次数
	-- 自己信息
	self.own_role_id = msg.self_player.role_id;               --角色ID
	self.own_role_name = msg.self_player.role_name;           --角色名
	self.own_server_name = msg.self_player.server_name;       --服务器名字
	self.own_career = msg.self_player.career;                 --职业
	self.own_sex = msg.self_player.sex;                       --性别
	self.own_profession = msg.self_player.profession;         --专职次数
	self.own_level = msg.self_player.level;                   --等级
	self.own_fight_times = msg.self_player.total_fight_times; --参战场次
	self.own_win_rate = msg.self_player.win_rate;             --胜率
	self.own_win_streak = msg.self_player.win_streak;         --连胜场次
	self.own_score = msg.self_player.score;                   --积分
	self.own_grade_id = msg.self_player.grade_id;             --段位ID
	self.own_role_head_name = msg.self_player.role_head_name; --头像名

	-- 对方信息
	self.match_role_id = msg.match_player.role_id;               --角色ID
	self.match_role_name = msg.match_player.role_name;           --角色名
	self.match_server_name = msg.match_player.server_name;       --服务器名字
	self.match_career = msg.match_player.career;                 --职业
	self.match_sex = msg.match_player.sex;                       --性别
	self.match_profession = msg.match_player.profession;         --专职次数
	self.match_level = msg.match_player.level;                   --等级
	self.match_fight_times = msg.match_player.total_fight_times; --参战场次
	self.match_win_rate = msg.match_player.win_rate;             --胜率
	self.match_win_streak = msg.match_player.win_streak;         --连胜场次
	self.match_score = msg.match_player.score;                   --积分
	self.match_grade_id = msg.match_player.grade_id;             --段位ID
	self.match_role_head_name = msg.match_player.role_head_name; --头像名
end

function Lua_TheSelectionWarData:fromServerRankInfo(msg) -- 排行榜
	if msg == nil then
		return;
	end

	self.type = msg.type; -- 0百强，1青铜、2白银、3黄金、4白金、5钻石、6王者

	--自己战绩
	self.rank = msg.self_rank.rank; -- 排名
	self.total_rank = msg.total_rank; -- 总排名
	self.role_id = msg.self_rank.role_id; -- 角色ID
	self.role_name = msg.self_rank.role_name; -- 角色名
	self.server_name = msg.self_rank.server_name; -- 角色名
	self.fight_force = msg.self_rank.fight_force; -- 战力
	self.score = msg.self_rank.score; -- 积分
	self.grade_id = msg.self_rank.grade_id; -- 段位ID

	-- 排行信息
	self.rank_list = Array();
	for i,v in ipairs(msg.rank_list) do
		self.rank_list:add({rank = v.rank, role_id = v.role_id, role_name = v.role_name, server_name = v.server_name,
			fight_force = v.fight_force, score = v.score, grade_id = v.grade_id});
	end
end

function Lua_TheSelectionWarData:fromServerExploitInfo(msg)--功勋
	if msg == nil then
		return;
	end

	self.exploit = msg.exploit;

	local arr;
	self.exploit_list = Array();
	for i,v in ipairs(msg.expoit_reward_list) do
		arr = Array();
		for i,v in ipairs(v.item_list) do
			arr:add({id = v.id, count = v.amount, bind = v.bind});
		end
		-- exploit 奖励需要的功勋，reward_flag 0 未达成，1 可领奖，2 已领奖
		self.exploit_list:add({exploit = v.exploit, is_reward = v.reward_flag, data = arr});
	end
end

function Lua_TheSelectionWarData.Get:isShowExploiRewardRod() -- 功勋红点
	for i = 1, self.exploit_list:getSize() do
		if self.exploit_list[i].is_reward == 1 then
			return true;
		end
	end
	return false;
end

-- 界面信息
function Lua_TheSelectionWarData:fromServer80405308(msg) -- 战斗场景
	if msg == nil then
		return;
	end

	self.getLeftTime = getTime();
	self.left_sec = msg.left_sec;                -- 剩余秒数
	self.total_sec = msg.total_sec;              -- 总时间
	self.state = msg.state;                      -- 1 战斗前准备，2 战斗中

	self.left_player = msg.left_player;
	self.right_player = msg.right_player;

	--左侧信息
	self.left_role_id = msg.left_player.role_id;               --角色ID
	self.left_role_name = msg.left_player.role_name;           --角色名
	self.left_server_name = msg.left_player.server_name;       --服务器名字
	self.left_career = msg.left_player.career;                 --职业
	self.left_sex = msg.left_player.sex;                       --性别
	self.left_level = msg.left_player.level;                   --等级
	self.left_fight_times = msg.left_player.total_fight_times; --参战场次
	self.left_win_rate = msg.left_player.win_rate;             --胜率
	self.left_win_streak = msg.left_player.win_streak;         --连胜场次
	self.left_score = msg.left_player.score;                   --积分
	self.left_grade_id = msg.left_player.grade_id;             --段位ID
	self.left_fight_force = tonumber(msg.left_player.fight_force);       --战力
	self.left_role_head_name = msg.left_player.role_head_name; --头像名

	self.left_left_blood = msg.left_player.left_blood;         --剩余血量
	self.left_total_blood = msg.left_player.total_blood;       --总血量
	self.left_left_magic = msg.left_player.left_magic;         --剩余蓝
	self.left_total_magic = msg.left_player.total_magic;       --总蓝

	self.left_profession = msg.left_player.profession;         --专职次数
	self.left_cur_server = msg.left_player.cur_server_flag;    --区组

	--右侧信息
	self.right_role_id = msg.right_player.role_id;               --角色ID
	self.right_role_name = msg.right_player.role_name;           --角色名
	self.right_server_name = msg.right_player.server_name;       --服务器名字
	self.right_career = msg.right_player.career;                 --职业
	self.right_sex = msg.right_player.sex;                       --性别
	self.right_level = msg.right_player.level;                   --等级
	self.right_fight_times = msg.right_player.total_fight_times; --参战场次
	self.right_win_rate = msg.right_player.win_rate;             --胜率
	self.right_win_streak = msg.right_player.win_streak;         --连胜场次
	self.right_score = msg.right_player.score;                   --积分
	self.right_grade_id = msg.right_player.grade_id;             --段位ID
	self.right_fight_force = tonumber(msg.right_player.fight_force);       --战力
	self.right_role_head_name = msg.right_player.role_head_name; --头像名

	self.right_left_blood = msg.right_player.left_blood;         --剩余血量
	self.right_total_blood = msg.right_player.total_blood;       --总血量
	self.right_left_magic = msg.right_player.left_magic;         --剩余蓝
	self.right_total_magic = msg.right_player.total_magic;       --总蓝

	self.right_profession = msg.right_player.profession;         --专职次数
	self.right_cur_server = msg.right_player.cur_server_flag;    --区组
end

function Lua_TheSelectionWarData.Get:reduiseTime()
	local num = self.left_sec - (getTime() - self.getLeftTime);
	if num <= 0 then
		return 0;
	end
	return num; 
end

-- 战斗结果通知
function Lua_TheSelectionWarData:fromServer80405310(msg)
	if msg == nil then
		return;
	end

	self.end_type = msg.type; -- 类型：1 战胜，2 战败
	self.end_fighter_id = msg.fighter_id; -- 对手ID
	self.end_fighter_name = msg.fighter_name; -- 对手名字
	self.end_trvl_exploit = msg.trvl_exploit; -- 功勋
	self.end_trvl_honor = msg.trvl_honor; -- 荣誉
	self.end_trvl_score = msg.trvl_score; -- 积分
	self.end_exp = msg.exp; -- 经验
end