-- 天选之战
checkRequire("Lua_TheSelectionWarData");
checkRequire("Lua_TheSelectionWarUtil");
Lua_TheSelectionWarProxy = class("Lua_TheSelectionWarProxy");
function Lua_TheSelectionWarProxy:ctor()
	DataCenter.theSelectionWarData = Lua_TheSelectionWarData.new();
	DataCenter.theSelectionWarUtil = Lua_TheSelectionWarUtil.new();

	LuaUtil.addLuaMsg(51405301, self, self.rOpenPanelInfo); -- 打开天选之战界面信息（返回）
	LuaUtil.addLuaMsg(51405302, self, self.rGetRankInfo); -- 获取天选之战排行信息（返回）
	LuaUtil.addLuaMsg(51405307, self, self.rExploitRewardInfo); -- 获取天选的功勋奖励列表（返回）

	LuaUtil.addLuaMsg(80405307, self, self.rSuccessfulMatchesInfo); -- 匹配成功倒计时（返回）
	LuaUtil.addLuaMsg(80405308, self, self.rFightScenesInfo); -- 天选之战战斗场景头像信息（返回）
	LuaUtil.addLuaMsg(80405309, self, self.rFightStartTimeInfo); -- 天选之战战斗开始倒计时（返回）
	LuaUtil.addLuaMsg(80405310, self, self.rFightEndTimeInfo); -- 战斗结果通知（返回）
end

-- 天选之战界面信息
function Lua_TheSelectionWarProxy:sOpenTheSelectionWarPanel()
	sendMsg(11405301);
end

-- 获取天选的功勋奖励列表
function Lua_TheSelectionWarProxy:sExploitRewardList()
	sendMsg(11405307);
end

-- 开始匹配天选之战 
function Lua_TheSelectionWarProxy:sBeginToMatch()
	sendMsg(11405305);
end

-- 取消匹配天选之战
function Lua_TheSelectionWarProxy:sGetEveryDayReward()
	sendMsg(11405310);
end

-- 取消匹配天选之战
function Lua_TheSelectionWarProxy:sCancelToMatch()
	sendMsg(11405306);
end

-- 领取宝箱奖励
function Lua_TheSelectionWarProxy:sgetBoxReward(times)
	local cmd = ProtoPublic_pb.Proto11405309();
	cmd.fight_times = tonumber(times)
	sendMsg(11405309, cmd);
end

-- 领取天选的功勋奖励
function Lua_TheSelectionWarProxy:sgetExploitReward(exploit)
	local cmd = ProtoPublic_pb.Proto11405308();
	cmd.exploit = tonumber(exploit); -- 奖励的功勋值下限，500，1000等
	sendMsg(11405308, cmd);
end

--  获取天选之战排行信息
function Lua_TheSelectionWarProxy:sGetRankInfo(type,page)
	local cmd = ProtoPublic_pb.Proto11405302();
	cmd.type = type; -- 0 百强，1 青铜，2 白银，3 黄金，4 白金，5 钻石，6 王者
	cmd.page = page; -- 0 重新获取，1 继续下一页
	sendMsg(11405302, cmd);
end

-- 购买天选之战价格
function Lua_TheSelectionWarProxy:sGetBuyPrice(times)
	local cmd = ProtoPublic_pb.Proto11405303();
	cmd.times = times;
	sendMsg(11405303, cmd);
end

-- 购买天选之战次数
function Lua_TheSelectionWarProxy:sGetBuyTimes(times)
	local cmd = ProtoPublic_pb.Proto11405304();
	cmd.times = times;
	sendMsg(11405304, cmd);
end





-- 打开天选之战界面信息（返回）
function Lua_TheSelectionWarProxy:rOpenPanelInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405301();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData:fromServer51405301(msg);
		Lua_MsgUtil.callFunc("UPDATA_PANEL_INFO"); -- 更新界面信息
	end
end

-- 获取天选之战排行信息（返回）
function Lua_TheSelectionWarProxy:rGetRankInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405302();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData:fromServerRankInfo(msg);
		Lua_MsgUtil.callFunc("UPDATA_RANK_INFO"); -- 更新排行榜信息
	end
end

-- 获取天选的功勋奖励列表（返回）
function Lua_TheSelectionWarProxy:rExploitRewardInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto51405307();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData:fromServerExploitInfo(msg);
		Lua_MsgUtil.callFunc("UPDATA_EXPLOIT_REWARD_INFO");
	end
end

-- 匹配成功倒计时（返回）
function Lua_TheSelectionWarProxy:rSuccessfulMatchesInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405307();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData.leftTime = msg.left_sec;
		self:sOpenTheSelectionWarPanel();
		Lua_MsgUtil.callFunc("UPDATA_PANEL_INFO"); -- 更新界面信息
	end
end

-- 天选之战，战斗场景信息（返回）
function Lua_TheSelectionWarProxy:rFightScenesInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405308();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData:fromServer80405308(msg);
		Lua_MsgUtil.callFunc("UPDATA_FIGHT_SCENCES_INFO"); -- 更新战斗场景信息
	end
end

-- 天选之战，战斗开始倒计时（返回）
function Lua_TheSelectionWarProxy:rFightStartTimeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405309();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData.startTime = msg.left_sec;
		Lua_MsgUtil.callFunc("UPDATA_STATE_TIME_INFO"); -- 更新战斗场景信息
	end
end

-- 天选之战，战斗结果通知（返回）
function Lua_TheSelectionWarProxy:rFightEndTimeInfo(mp)
	if mp.errno == 0 then
		local msg = ProtoPublic_pb.Proto80405310();
		msg:ParseFromString(mp.data);
		DataCenter.theSelectionWarData:fromServer80405310(msg);
		Lua_WindowUtil.openWin("Lua_TheSelectionWarCopyResultPanel", WinParam.ACTION_OPEN);
		-- Lua_MsgUtil.callFunc("UPDATA_FIGHT_END_INFO"); -- 更新战斗结果通知
	end
end